#include "emu.h"

#include "aci_cmh.h"

T_HANDLE aci_handle;
//
//typedef enum              /* ACI functional return codes */
//{
//  AT_FAIL = -1,           /* execution of command failed */
//  AT_CMPL,                /* execution of command completed */
//  AT_EXCT,                /* execution of command is in progress */
//  AT_BUSY                 /* execution of command is rejected due
//                             to a busy command handler */
//} T_ACI_RETURN;
//

T_ACI_RETURN sAT_PercentBAND(T_ACI_CMD_SRC   srcId,
                                    T_ACI_BAND_MODE bandMode,
                                    UBYTE           bandType)
{
	return AT_CMPL;
}

T_ACI_RETURN tAT_PercentBAND(T_ACI_CMD_SRC   srcId,
                                    T_ACI_BAND_MODE *MaxBandMode,
                                    UBYTE           *AllowedBands)
{
	return AT_CMPL;
}
T_ACI_RETURN qAT_PercentBAND(T_ACI_CMD_SRC   srcId,
                                    T_ACI_BAND_MODE *bandMode,
                                    UBYTE           *bandType)
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PercentCAL( T_ACI_CMD_SRC    srcId,
                                    T_ACI_CAL_ENTR  *callTable )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PercentNRG( T_ACI_CMD_SRC   srcId,
                                    T_ACI_NRG_RGMD  regMode,
                                    T_ACI_NRG_SVMD  srvMode,
                                    T_ACI_NRG_FRMT  oprFrmt,
                                    CHAR           *opr )
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PercentNRG( T_ACI_CMD_SRC   srcId,
                                    T_ACI_NRG_RGMD *regMode,
                                    T_ACI_NRG_SVMD *srvMode,
                                    T_ACI_NRG_FRMT *oprFrmt,
                                    T_ACI_NRG_SVMD *srvStat,
                                    CHAR           *oper)
{
	return AT_CMPL;
}



T_ACI_RETURN qAT_PercentCTV ( T_ACI_CMD_SRC    srcId,
                                     LONG            *ctv)
{
	return AT_CMPL;

}
T_ACI_RETURN qAT_PercentCAOC( T_ACI_CMD_SRC    srcId,
                                     CHAR            *cur,
                                     CHAR            *val)
{
	return AT_CMPL;

}
T_ACI_RETURN qAT_PercentCACM( T_ACI_CMD_SRC    srcId,
                                     CHAR            *cur,
                                     CHAR            *val)
{
	return AT_CMPL;

}
T_ACI_RETURN qAT_PercentRPCT( T_ACI_CMD_SRC    srcId,
                                     T_ACI_RPCT_VAL  *rpuct)
{
	return AT_CMPL;

}

T_ACI_RETURN sAT_PercentCCBS( T_ACI_CMD_SRC    srcId,
                                     SHORT            idx  )
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PercentCCBS( T_ACI_CMD_SRC    srcId)
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PercentALS( T_ACI_CMD_SRC srcId,
                             T_ACI_ALS_MOD mode   )
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PercentALS( T_ACI_CMD_SRC srcId,
                             T_ACI_ALS_MOD *mode  )
{
	return AT_CMPL;
}
T_ACI_RETURN tAT_PercentALS( T_ACI_CMD_SRC srcId,
                             T_ACI_ALS_MOD *ALSmode)
{
	return AT_CMPL;
}



T_ACI_RETURN sAT_PercentPBCF( T_ACI_CMD_SRC srcId,
                                     T_ACI_PBCF_LDN ldn,
                                     T_ACI_PBCF_LRN lrn,
                                     T_ACI_PBCF_LMN lmn )
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PercentPBCF( T_ACI_CMD_SRC srcId,
                                     T_ACI_PBCF_LDN *ldn,
                                     T_ACI_PBCF_LRN *lrn,
                                     T_ACI_PBCF_LMN *lmn )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PercentPVRF( T_ACI_CMD_SRC   srcId,
                                     T_ACI_PVRF_TYPE type,
                                     CHAR * pin,
                                     CHAR * newpin )
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PercentPVRF( T_ACI_CMD_SRC srcId,
                                     SHORT        *pn1Cnt,
                                     SHORT        *pn2Cnt,
                                     SHORT        *pk1Cnt,
                                     SHORT        *pk2Cnt,
                                     T_ACI_PVRF_STAT *ps1,
                                     T_ACI_PVRF_STAT *ps2 )
{
	return AT_CMPL;
}


T_ACI_RETURN sAT_PercentSATC( T_ACI_CMD_SRC  srcId,
                                     SHORT          len,
                                     UBYTE        * satCnfg )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PercentSATR( T_ACI_CMD_SRC  srcId,
                                     SHORT          len,
                                     UBYTE        * satCmd )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PercentSATE( T_ACI_CMD_SRC  srcId,
                                     SHORT          len,
                                     UBYTE        * satCmd )
{
	return AT_CMPL;

}

T_ACI_RETURN sAT_PercentCPRI( T_ACI_CMD_SRC srcId,
                                     UBYTE mode )
{
	return AT_CMPL;
}

/////////////////////////////////////////////////////////////////
// AT_Plus


T_ACI_RETURN sAT_PlusCMOD  ( T_ACI_CMD_SRC srcId,
                                    T_ACI_CMOD_MOD mode )
{
	return AT_CMPL;
}




T_ACI_RETURN sAT_PlusCHLD  ( T_ACI_CMD_SRC    srcId,
                                    T_ACI_CHLD_MOD   mode,
                                    CHAR            *call)
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCEER  ( T_ACI_CMD_SRC    srcId,
                                    USHORT           *cause)
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusVTS   ( T_ACI_CMD_SRC    srcId,
                                    CHAR             dtmf,
                                    T_ACI_VTS_MOD    mode)
{
	return AT_CMPL;

}

T_ACI_RETURN sAT_PlusCBST  ( T_ACI_CMD_SRC srcId,
                                    T_ACI_BS_SPEED speed,
                                    T_ACI_CBST_NAM name,
                                    T_ACI_CBST_CE ce)
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCAOC  ( T_ACI_CMD_SRC    srcId,
                                    LONG            *ccm)
{
	return AT_CMPL;

}

T_ACI_RETURN sAT_PlusCACM  ( T_ACI_CMD_SRC    srcId,
                             CHAR            *passwd)
{
		return AT_CMPL;

}
T_ACI_RETURN qAT_PlusCACM  ( T_ACI_CMD_SRC    srcId,
                             LONG            *acm)
							 {
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCAMM  ( T_ACI_CMD_SRC    srcId,
                             LONG             acmmax,
                             CHAR            *passwd)
							 {
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCAMM  ( T_ACI_CMD_SRC    srcId,
                             LONG            *acmmax)
							 {
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCPUC  ( T_ACI_CMD_SRC    srcId,
                             CHAR            *cur,
                             CHAR            *ppu,
                             CHAR            *passwd)
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCPUC  ( T_ACI_CMD_SRC    srcId,
                             CHAR            *cur,
                             CHAR            *ppu)
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCTFR  ( T_ACI_CMD_SRC    srcId,
                                    CHAR            *number,
                                    T_ACI_TOA       *type,
                                    CHAR            *subaddr,
                                    T_ACI_TOS       *satype)
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCPOL  ( T_ACI_CMD_SRC srcId,
                                    SHORT              startIdx,
                                    SHORT             *lastIdx,
                                    T_ACI_CPOL_OPDESC *operLst,
                                    T_ACI_CPOL_MOD     mode )
{

	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCPOL  ( T_ACI_CMD_SRC srcId,
                                    SHORT index,
                                    T_ACI_CPOL_FRMT format,
                                    CHAR * oper,
                                    SHORT index2,
                                    T_ACI_CPOL_MOD mode )
{
	return AT_CMPL;
}


T_ACI_RETURN tAT_PlusCPOL  ( T_ACI_CMD_SRC srcId,
                                    SHORT * lastIdx,
                                    SHORT * usdNtry )
{
		return AT_CMPL;

}

T_ACI_RETURN tAT_PlusCOPS  ( T_ACI_CMD_SRC srcId,
                                    SHORT startIdx,
                                    SHORT * lastIdx,
                                    T_ACI_COPS_OPDESC * operLst)
{
	return AT_CMPL;

}

T_ACI_RETURN sAT_PlusCFUN  ( T_ACI_CMD_SRC  srcId,
                                    T_ACI_CFUN_FUN fun,
                                    T_ACI_CFUN_RST rst )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCPBS ( T_ACI_CMD_SRC srcId,
                                   T_ACI_PB_STOR mem )
{
	return AT_CMPL;
}


T_ACI_RETURN qAT_PlusCFUN  ( T_ACI_CMD_SRC  srcId,
                                    T_ACI_CFUN_FUN *fun )
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCPIN   (T_ACI_CMD_SRC srcId,
                                    T_ACI_CPIN_RSLT *code)
{	
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCPWD  ( T_ACI_CMD_SRC  srcId,
                                    T_ACI_CPWD_FAC fac,
                                    CHAR  *        oldpwd,
                                    CHAR  *        newpwd)
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCLAN ( T_ACI_CMD_SRC  srcId,
                                   T_ACI_LAN_SUP* lngCode )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCMGF  ( T_ACI_CMD_SRC     srcId,
                                    T_ACI_CMGF_MOD    mode)
{

	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCMGL  ( T_ACI_CMD_SRC     srcId,
                                    T_ACI_SMS_STAT    state,
                                    SHORT             startIdx,
                                    T_ACI_SMS_READ    rdMode )
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCNMI  ( T_ACI_CMD_SRC     srcId,
                                    T_ACI_CNMI_MT   * mt,
                                    T_ACI_CNMI_BM   * bm,
                                    T_ACI_CNMI_DS   * ds)
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCMGR      ( T_ACI_CMD_SRC   srcId,
                                        UBYTE           index,
                                        T_ACI_SMS_READ  rdMode )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCMGS      ( T_ACI_CMD_SRC   srcId,
                                        CHAR*           da,
                                        T_ACI_TOA*      toda,
                                        T_SM_DATA_EXT*  src_data,
                                        CHAR*           sca,
                                        T_ACI_TOA*      tosca,
                                        SHORT           isReply )
{
	return  AT_CMPL;
}

T_ACI_RETURN sAT_PlusCMSS      ( T_ACI_CMD_SRC   srcId,
                                        UBYTE           index,
                                        CHAR*           da,
                                        T_ACI_TOA*      toda )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCPMS  ( T_ACI_CMD_SRC    srcId,
                                    T_ACI_SMS_STOR   mem1,
                                    T_ACI_SMS_STOR   mem2,
                                    T_ACI_SMS_STOR   mem3)
{
	return AT_CMPL;


}

T_ACI_RETURN sAT_PlusCMGW      ( T_ACI_CMD_SRC   srcId,
                                        SHORT           index,
                                        CHAR*           address,
                                        T_ACI_TOA*      toa,
                                        T_ACI_SMS_STAT  stat,
                                        UBYTE           msg_ref,
                                        T_SM_DATA_EXT*  src_data,
                                        CHAR*           sca,
                                        T_ACI_TOA*      tosca,
                                        SHORT           isReply )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCMGD      ( T_ACI_CMD_SRC   srcId,
                                        UBYTE           index )
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCPMS  ( T_ACI_CMD_SRC    srcId)
{
	return AT_CMPL;

}

T_ACI_RETURN sAT_PlusCMGC      ( T_ACI_CMD_SRC   srcId,
                                        SHORT           fo,
                                        SHORT           ct,
                                        SHORT           pid,
                                        SHORT           mn,
                                        CHAR*           da,
                                        T_ACI_TOA*      toda,
                                        T_ACI_CMD_DATA* data )
{
	return AT_CMPL;

}

T_ACI_RETURN sAT_PlusCSAS  ( T_ACI_CMD_SRC  srcId,
                                    SHORT          profile )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCSMP  ( T_ACI_CMD_SRC    srcId,
                                    SHORT            fo,
                                    SHORT            vprel,
                                    T_ACI_VP_ABS    *vpabs,
                                    T_ACI_VP_ENH    *vpenh,
                                    SHORT            pid,
                                    SHORT            dcs )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCSCA  ( T_ACI_CMD_SRC    srcId,
                                    CHAR            *sca,
                                    T_ACI_TOA       *tosca )
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCSMP  ( T_ACI_CMD_SRC    srcId,
                                    SHORT           *fo,
                                    SHORT           *vprel,
                                    T_ACI_VP_ABS    *vpabs,
                                    T_ACI_VP_ENH    *vpenh,
                                    SHORT           *pid,
                                    SHORT           *dcs )
{

	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCSCA  ( T_ACI_CMD_SRC    srcId,
                                    CHAR            *sca,
                                    T_ACI_TOA       *tosca )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCSCB  ( T_ACI_CMD_SRC     srcId,
                                    T_ACI_CSCB_MOD    mode,
                                    USHORT          * mids,
                                    UBYTE           * dcss)
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCSCB  ( T_ACI_CMD_SRC     srcId,
                                    T_ACI_CSCB_MOD  * mode,
                                    USHORT          * mids,
                                    UBYTE           * dcss)
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCLCK  ( T_ACI_CMD_SRC  srcId,
                                    T_ACI_CLCK_FAC fac,
                                    T_ACI_CLCK_MOD mode,
                                    CHAR  *        passwd,
                                    T_ACI_CLASS    class_type)
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCLCK  ( T_ACI_CMD_SRC  srcId,
                                    T_ACI_CLCK_FAC fac,
                                    T_ACI_CLASS    class_type,
                                    T_ACI_CLSSTAT *clsStat)
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCUSD  ( T_ACI_CMD_SRC    srcId,
                                    T_ACI_USSD_DATA *str,
                                    SHORT            dcs)
{
	return AT_CMPL;

}
 T_ACI_RETURN sAT_PlusCCUG  ( T_ACI_CMD_SRC   srcId,
                                    T_ACI_CCUG_MOD  mode,
                                    T_ACI_CCUG_IDX  index,
                                    T_ACI_CCUG_INFO info)
 {
	return AT_CMPL;
 }

T_ACI_RETURN qAT_PlusCCUG  ( T_ACI_CMD_SRC   srcId,
                                    T_ACI_CCUG_MOD  *mode,
                                    T_ACI_CCUG_IDX  *index,
                                    T_ACI_CCUG_INFO *info)
{
	return AT_CMPL;
}

T_ACI_RETURN qAT_PlusCIMI  ( T_ACI_CMD_SRC    srcId,
                                    CHAR            *imsi)
{
	return AT_CMPL;
}


T_ACI_RETURN sAT_PlusCPBW ( T_ACI_CMD_SRC  srcId,
                                   SHORT          index,
                                   CHAR          * number,
                                   T_ACI_TOA     * type,
                                   T_ACI_PB_TEXT * text,
                                   T_ACI_VP_ABS  * dateTime )
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCCWA  ( T_ACI_CMD_SRC    srcId,
                                    T_ACI_CCWA_MOD   mode,
                                    T_ACI_CLASS      class_type)
{
	return AT_CMPL;
}

T_ACI_RETURN sAT_PlusCNMI  ( T_ACI_CMD_SRC     srcId,
                                    T_ACI_CNMI_MT     mt,
                                    T_ACI_CNMI_BM     bm,
                                    T_ACI_CNMI_DS     ds)
{
	return AT_CMPL;
}
/////////////////////////////////////////////////

T_ACI_RETURN sAT_Dm        ( T_ACI_CMD_SRC       srcId,
                                    CHAR                *str,
                                    T_ACI_PB_STOR       mem,
                                    SHORT               index,
                                    T_ACI_D_CLIR_OVRD   clirOvrd,
                                    T_ACI_D_CUG_CTRL    cugCtrl,
                                    T_ACI_D_TOC         callType )
{
	return AT_CMPL;
}


T_ACI_RETURN sAT_Dn        ( T_ACI_CMD_SRC srcId,
                                    CHAR * number,
                                    T_ACI_D_CLIR_OVRD clirOvrd,
                                    T_ACI_D_CUG_CTRL  cugCtrl,
                                    T_ACI_D_TOC       callType )
{
	return AT_CMPL;
}


T_ACI_RETURN sAT_A         ( T_ACI_CMD_SRC srcId )
{
	return AT_CMPL;
}
T_ACI_RETURN sAT_H         ( T_ACI_CMD_SRC srcId )
{
	return AT_CMPL;

}

T_ACI_RETURN sAT_Abort     ( T_ACI_CMD_SRC  srcId,
                                    T_ACI_AT_CMD   cmd)
{
	return AT_CMPL;

}


T_ACI_ERR_DESC qAT_ErrDesc ( void )
{
	return 0;
}
