#
#	Setting Directory for AUS Objects
#
include $(AUSYSTEM_DIR)/GLE/gle_env.mak
COPTAUS  = -me -mt -o -pw2 -x -mw 

ifndef NO_SYMBOL
COPTAUS += -g -mn
endif 



$(GLE_LIB) : $(AOBJ) $(GLE_OBJ) $(GLE_LIB_DIR)
	$(AR) r $(GLE_LIB) $(GLE_OBJ) 
	
$(AOBJ):	
	mkdir $(subst /,$(SLASH),$(AOBJ))

$(GLE_LIB_DIR):
	mkdir $(subst /,$(SLASH),$(GLE_LIB_DIR))

clean: 
	$(REMOVE) $(subst /,$(SLASH),$(AOBJ))


$(GLE_OBJ) : $(AOBJ)/%.$(OBJ_TAIL) : $(GLE_SRC_DIR)/%.c
	echo -DTRGT_G23 > cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo -I$(IGLE) >> cmd
	echo -I$(IAUS) >> cmd
	echo -I$(IAUSC) >> cmd
	echo $(COPTAUS) >> cmd
	echo -I$(ICOM) >> cmd
	echo -fr$(AOBJ) >> cmd
	$(CC) $^ -@cmd


