//6.19 chenjun add a function DrawCpointLine()
//Game_display.h
//author:chenjun
//date:2002.06.12
//purpose:define the struct used in game mode
#ifndef _GAME_DISPLAY
#define _GAME_DISPLAY
#include "typedefs.h"

#define scrX 119
#define scrY 159

typedef struct
{ 
  USHORT  x;
  USHORT  y;
} CPoint;

typedef struct
{ 
  int x;
  int y;
  int color;
} game_Point;//struct of point in game mode

typedef struct
{
  int x;
  int y;
  int radius;
  int fillcolor;
  int color;
} game_Circle;//struct of circle in game mode

typedef struct
{
  int x1;
  int y1;
  int x2;
  int y2;
  int fillcolor;
  int color;
} game_Rectangle;//struct of rect in game mode

typedef struct
{
  int x1;
  int y1;
  int x2;
  int y2;
  int color;
} game_Line;//struct of line in game mode

#if 1
typedef enum         
{               
 WHITE,//ɫ  ffffff 
 RED,// ɫ  ff0000 
GREEN,// ɫ  00ff00 
BLUE,// ɫ  0000ff 
MAGENTA,// Һɫ  ff00ff 
CYAN,// ǳɫ  00ffff 
YELLOW,// ɫ  ffff00 
BLACK,// ɫ  000000 
AQUAMARINE,// ɫ  70db93 
BRONZE,// ͭɫ  8c7853 
COPPER,// ͭɫ  b87333 
FELDSPAR,// ʯɫ  d19275 
GOLD,// ɫ  cd7f32 
GRAY,// ɫ  c0c0c0 
KHAKI,// ɫ  9f9f9f 
MAROON,// ɫ  8e236b 
ORANGE,// ɫ  ff7f00 
ORCHID,// ɫ  db70db 
PINK,// ۺɫ  bc8f8f 
PLUM,// ÷ɫ  eaadea
QUARTZ,// ʯӢɫ  d9d9f3 
SALMON,// qɫ  6f4242 
SCARLET,// rɫ  8c1717 
SILVER,// yɫ  e6e8fa 
THISTLE,// ɫ  d8bfd8 
TURQUOISE,// ɫ  adeaea 
VIOLET,// ɫ  4f2f4f 
WHEAT,// Сɫ  d8d8bf 
ALICEBLUE,// ˿f0f8ff 
ANTIQUEWHITE,// ͹Ű antiquewhite faebd7 
AZURE,// ɫ azure f0ffff 
BEIGE,// ɫ beige f5f5dc 
BISQUE,// ɫ bisque ffe4c4 
BLANCHEDALMOND,//  blanchedalmond ffebcd 
BLUEVIOLET,// ɫ blueviolet 8a2be2 
BROWN,// ɫ brown a52a2a 
BURLYWOOD,// Ӳľ^ burlywood deb887 
CADETBLUE,//  cadetblue 5f9ea0 
CHARTREUSE,// ɫ chartreuse 7ff000 
CHOCOLATE,// Һɫ chocolate d2691e 
CORAL,// ɺɫ coral ff7f50 
CORNFLOWERBLUE,//  cornflowerblue 6495ed 
CORNSILK,//  cornsilk fff8dc 
CRIMSON,// rɫ crimson dc143c 
DARKBLUE,// ɫ darkblue 00008b 
DARKCYAN,// ɫ darkcyan 008b8b 
DARKGOLDENROD,//  darkgoldenrod b8860b 
DARKGRAY,// ɫ darkgray a9a9a9 
DARKGREEN,// īɫ darkgreen 006400 
DARKKHAKI,// ɫ darkkhaki bdb76b 
DARKMAGENTA,// Ϻɫ darkmagenta 8b008b 
DARKOLIVEGREEN,//  darkolivegreen 556b2f 
DARKORANGE,// ɫ darkorange ff8c00 
DARKORCHID,//  darkorchid 9932cc 
DARKRED,// ɫ darkred 8b0000 
DARKSALMON,// Ⱥɫ darksalmon e9967a 
DARKSEAGREEN,// ɫ darkseagreen 8fbc8f 
DARKSLATEBLUE,// ɫ darkslateblue 483d8b 
DARKSLATEGRAY,// ɫ darkslategray 2f4f4f 
DARKTURQUOISE,//  darkturquoise 00ced1 
DARKVIOLET,// ɫ darkviolet 9400d3 
DEEPPINK,// طۺɫ deeppink ff1493 
DEEPSKYBLUE,//  deepskyblue 00bfff 
DIMGRAY,// ɫ dimgray 696969 
DODGERBLUE,//  dodgerblue 1e90ff 
FIREBRICK,// ͻשɫ firebrick b22222 
   
 MaxGameColor             
} game_color ;   //struct of color index in game mode
#endif

//following os the prototype of draw function in game mode
 int  GetGameColor(game_color g_color);
 void DrawPoint(game_Point   param);
 void DrawCircle(game_Circle  param);
 void DrawRectagle(game_Rectangle  param);
void DrawLine(game_Line  param);
void  DrawCpointLine(CPoint point_start, CPoint point_end, USHORT ulinewidth, ULONG  ucolor);




#endif
