/* 2003-12-14, Robert.Chen, Add api to support subLCD */
//08/09/2002,zhonghz,display multi-font
//08/02/2002,zhonghz,0x80 for unicode,set in_Attrib to dspl_txtattr_unimode,else
//           set in_Attrib to dspl_txtattr_asciimode
/*********************************************************************
Date        Modification                                                 
  ------------------------                                                 
  04/08/2002   zy add dspl_DrawRect() and change some color setting    
*********************************************************************/

//08/01/2000 zy add dspl_colorTextOut() this function could display color text
//6.19 chenjun add a function dspl_set_pen_size(),
//but, cause ZYM has changed the function dspl_draw_point(),
//which delete the module draw point with gc's pensize bigger than 1 pixel,
//this function didn't work in drawing.All draw use the pen_size of 1 pixel now.
//maybe we should consider a new method to support coarse line and point. 
/*
+-------------------------------------------------------------------+
| PROJECT: GSM-PS                     $Workfile:: display.c        $|
| $Author: zhq $ CONDAT AG            $Revision: 1.6 $|
| CREATED: 18.03.1999                 $Modtime:: 21.02.00 11:33    $|
+-------------------------------------------------------------------+

   MODULE  : DRV_DSPL

   PURPOSE : This Module defines the G23 display driver.

   The driver has three parts:

   1. The interface according the display driver specification
      (dspl_....)
   2. A workaround for the original graphic driver of TI.
      (src_...)
      This was necessary, because the original TI driver leads
      to unexspected lines in the display.
   3. A simulation of the TI driver functions for Windows.
      (LCD_...)

   Additional the support of an external display is integrated
   (dspl_SendDisplayReq).

04/12/2001 GW - Updated to use TI driver V5.3.1

   $Log: display.c,v $
   Revision 1.6  2004/08/05 09:31:16  zhq
   zhq, 2004/08/05, add this for use use block fresh in r2d_refresh.

   Revision 1.5  2004/07/29 09:10:06  jhxu
   no message

   Revision 1.4  2004/07/27 06:42:06  zhenggl
   no message

   Revision 1.3  2004/07/27 05:43:39  zhenggl
   no message

   Revision 1.2  2004/07/26 10:57:15  jhxu
   no message

   Revision 1.1.1.1  2004/06/19 06:00:46  root
   The baseline of M288 project

   Revision 1.4  2004/06/04 08:03:01  sunsj
   Fix some bug

   Revision 1.3  2004/05/24 08:38:00  sunsj
   get rid of the redefined macro

   Revision 1.2  2004/05/11 10:01:42  sunsj
   Modify font type

   Revision 1.1.1.1  2004/05/10 02:33:45  root
   zhq, 2004/05/10, import base on M188A_102X80 project
   tag "M188B_128X160_20040509_BASE".

   Revision 1.1.1.1  2004/04/19 08:33:10  root
   This is the base release version for M188A

   Revision 1.7  2004/04/08 03:13:06  sunsj
   Change chinese char width from 12 to 13

   Revision 1.6  2004/03/25 06:02:53  sunsj
   Add some font char

   Revision 1.5  2004/03/19 09:04:54  huyl
   no message

   Revision 1.4  2004/03/10 08:52:09  sunsj
   Add 0~9 small font

   Revision 1.3  2004/02/03 02:58:33  huyl
   talcon modify 2004/02/03

   Revision 1.2  2004/01/13 07:33:18  sunsj
   modify unicode text display

   Revision 1.1.1.1  2004/01/06 03:15:58  root
   this is the baseline for M188_102X80A project

   Revision 1.2  2004/01/04 09:34:40  sunsj
   Add font switch

   Revision 1.1.1.1  2004/01/03 07:44:50  root
   this is the baseline of M188_102X80A project

   Revision 1.3  2003/12/27 02:32:38  huyl
   add function dspl_SetScreenType,dspl_GetScreenType()
       add function pointer
            pdspl_BitBlt ,  pset_font_type,  pdspl_Enable,  pdspl_TextOut_Cmode_Center,
         pdspl_colorTextOut  ,
         pdspl_ClearAll   ,  pdspl_Clear
       ʹ֮Ӧ

   Revision 1.2  2003/12/26 01:57:47  zhenggl
   no message

* 24   28/10/2003  sunsj **************************************
       modify the auto width char display.
  *************************************************************

* 23   07.03.2002  13:00 zhangzg
* One argument, UBYTE in_Attrib has been added to the functions of displaying text, including
      scrText_Invert, scrText_Invert_Unicode, scrText, scrText_Unicode. These function will call
      scrTxtPoint, instead of scrPoint! scrTxtPoint is a new added function.
* The purpose of these modifications is to support transparent displaying of text and future extending   
  
      
* 22   06.12.2002  14:55 gan chunhui
* Function all function on display has been modified. The old display[][] array is 
*     not used again, scrpoint is modified to call the R2D_DrawPoint();
   
 *
 * 21    22.02.00 14:55 Fk
 * Function 'scrMobUpdate()' considers size of variable 'display[][]'
 * correctly
|
| 20    21.02.00 9:24 Le
| MMI_DISPLAY_REQ size corrected for PALLOC_SDU
 *
 * 19    14.02.00 12:37 Kk
 * adaption for tap test on pc. needed scrInit in dspl_init for
 * initialization of glob vars
|
| 18    11.02.00 14:24 Le
 *
 * 16    10.02.00 14:21 Slo
|
| 15    26.01.00 12:13 Le
| scrclear not available under windows
 *
 * 14    25.01.00 18:20 Be
|
| 13    6.01.00 9:20 Le
| Improvements for MMI tests
 *
 * 12    24.11.99 17:52 Be
|
| 11    18.11.99 14:45 Le
 *
 * 10    13.10.99 16:09 Pz
 * Adapted to new frame
 *
 * 9     2.08.99 19:03 Be
 * added ADC support
 *
 * 8     6.07.99 12:54 Es
 *
 * 7     18.05.99 9:47 Kk
 *
 * 6     4.05.99 13:42 Kk
 *
 * 4     14.04.99 17:33 Es
 *
 * 3     14.04.99 15:48 Sab
|
| 2     14.04.99 9:52 Le
|
| 1     1.04.99 11:26 Le

*/
#ifndef _INNOVATION_EMULATOR_

    #ifndef DRV_DSPL_C
        #define DRV_DSPL_C
    #endif
/*==== INCLUDES ===================================================*/
    #define ENTITY_CST

    #include <string.h>
    #if defined (WIN32)
        #include <stdio.h>
    #endif

    #if defined (NEW_FRAME)
        #include "typedefs.h"
        #include "gdi.h"
//        #include "dspl.h"
        #include "font_bitmaps.h"
        #include "vsi.h"
        #include "custom.h"
        #include "gsm.h"
        #include "prim.h"
        #include "p_mmi.h"
        #include "tok.h"
        #include "cst.h"
        #include "os.h"

    #else

        #include "stddefs.h"
        #include "gdi.h"
  //      #include "dspl.h"
        #include "font_bitmaps.h"
        #include "custom.h"
        #include "gsm.h"
        #include "prim.h"
        #include "p_mmi.h"
        #include "vsi.h"
        #include "tok.h"
        #include "cst.h"
    #endif

#else // _INNOVATION_EMULATOR_


    #ifndef DRV_DSPL_C
        #define DRV_DSPL_C
    #endif

    #define ENTITY_MFW

    #include <stdio.h>
    #include <string.h>
    #include <stdlib.h>

    #if defined (NEW_FRAME)

        #include "typedefs.h"
        #include "vsi.h"
        #include "pei.h"
        #include "custom.h"
        #include "gsm.h"

    #else

        #include "stddefs.h"
        #include "custom.h"
        #include "gsm.h"
        #include "vsi.h"

    #endif

extern T_HANDLE mmi_handle;

    #include <string.h>
    #if defined (MY_WIN32)
        #include <stdio.h>
    #endif

    #if defined (NEW_FRAME)
        #include "typedefs.h"
        #include "gdi.h"        
        #include "font_bitmaps.h"
    //    #include "dspl.h"
        #include "vsi.h"
        #include "custom.h"
        #include "gsm.h"
        #include "p_mmi.h"
        #include "tok.h"
        #include "os.h"

    #else

        #include "stddefs.h"
        #include "gdi.h"        
        #include "font_bitmaps.h"
      //  #include "dspl.h"
        #include "custom.h"
        #include "gsm.h"
        #include "prim.h"
        #include "p_mmi.h"
        #include "vsi.h"
        #include "tok.h"
        #include "cst.h"
    #endif

#endif // _INNOVATION_EMULATOR_


#include "rvf_api.h"
#include "r2d.h"
#include "dspl.h"

//#include "rvf_api.h"
//#include "r2d.h"

#include "uni16x16.h"
#include "wstring.h"  //xsf add for wstrlen() 2003.03.10

//#define TDTRACE 1
//#include "../bmi/mmiutilapi.h"

/*==== EXPORT =====================================================*/
#define ENCODE_OFFSET 24

//#define EASY_TEXT_ENABLED

#ifndef _SIMULATION_

//#if (defined(_TARGET_) && (BOARD!=41))
    #if (defined(_TARGET_) )
        #define R2D_ENABLED
    #endif

#endif

#if (defined(_INNOVATION_EMULATOR_))
    #ifndef R2D_ENABLED
        #define R2D_ENABLED
    #endif
#endif

/*==== VARIABLES ==================================================*/
static int 	 	scrX, scrY;			/* display size */
GLOBAL UBYTE	extDisplay = 0;     /* external display ? */
GLOBAL UBYTE	dspl_char_type;
GLOBAL UBYTE	dspl_font_type;
/* Robert.Chen add, for sub LCD, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
static int 		sub_scrX, sub_scrY;
GLOBAL UBYTE	dspl_sub_char_type;
GLOBAL UBYTE	dspl_sub_font_type;
#endif


int bitmap_num = 0;

GLOBAL dspl_DevCaps displayData;
/* Robert.Chen add, for sub LCD, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL dspl_DevCaps sub_displayData;
#endif

#if defined (NEW_FRAME)
EXTERN T_HANDLE       hCommL1;
#else
EXTERN T_VSI_CHANDLE  hCommL1;
#endif

int scrEnabled = 0;              /* screen update enable */
static int txtInvert = 0;        /* Text invert */
/* Robert.Chen add, for sub LCD, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
int sub_scrEnabled = 0;              /* sub screen update enable */
#endif

/* Definiton for multi-font infomation */
typedef struct UNIFONTTYPEtag
{
    int font_w;     /* font width */
    int font_h;     /* font height */ 	
    int font_s;     /* font size */
    int font_e;     /* the max char for a font lib table */
    char *ascfont;  /* ascii char font lib */
    char *uni0_256; /* uni 0~256 char font lib */
    char *uni_cjk;  /* uni cjk font lib */
    _UniSym_   *uni_sym;  /* uni sym font lib */
    _Uni12X12_ *uni_12x12;/* uni12x12 font lib */
    char * charwidth;     /* char width, sunsj031013 */
    char * elementmap;
} FONTINFO;

static FONTINFO *fontinfo;
/* Robert.Chen add, for sub LCD, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
#define R2D_MAINLCD		1
#define R2D_SUBLCD		0
static FONTINFO *sub_fontinfo;
#endif

/*==== FUNCTIONS ==================================================*/
/*
 * send to external Display
 */
//extern int wstrlen(char * txt);
//extern void wstrcpy(char * intxt, char * outtxt);
LOCAL void dspl_SendDisplayReq (USHORT x, USHORT y, char *text);
GLOBAL void kbd_test (UBYTE key);

/*
 * TI driver functions
 */
extern void LCD_SetPower        (void);
extern void LCD_Reset           (void);
extern void LCD_Enable          (int);
extern void LCD_Clear           (void);
extern void LCD_WriteString     (int y, int x, char *s);
extern void LCD_PixBlt          (int x, int y, int w, int h, char *bmp);
extern void LCD_DrawIcon        (int x, int y, char id);
extern void LCD_TranslateBitmap (int w, int h, char *bo, char *bt);
extern void LCD_Cursor          (int row, int col);

extern void           r2d_draw_rectangle(T_R2D_GC_PTR gc,
                                         INT16 ul_x,INT16 ul_y,INT16 bl_x, INT16 bl_y);


GLOBAL void rt_ExtPrimitive ( USHORT TaskHandle, USHORT DestComHandle, USHORT DestTaskHandle,
                              char *ExtDest, OS_QDATA *Msg );
/*
 * Internal Functions for Graphic Driver (Workaround)
 */
LOCAL  void scrInit      (void);
LOCAL  void scrExit      (void);
LOCAL  void scrSize      (int *x, int *y);
#if (!CUST)//JVJE #if (CUST==1)

LOCAL  void scrClear     (void);
#endif
LOCAL  void scrClearRect (int px, int py, int sx, int sy);
extern  void scrText      (int x, int y, UBYTE in_Attrib, char *txt);  //zgz,2002.8.19 change it to global function
extern  void scrText_Unicode      (int x, int y, UBYTE in_Attrib, char *txt); //zgz,2002.8.19 change it to global function
#if R2D_SUBLCD_SUPPORT
void sub_scrText_Unicode (int x, int y, UBYTE in_Attrib, char * intxt);
void sub_scrText(int x, int y, UBYTE in_Attrib, char *txt);
#endif
LOCAL  void scrLine      (int px, int py, int sx, int sy);
LOCAL  void scrRect      (int px, int py, int sx, int sy);
LOCAL  int  scrFntSelect (int font);
LOCAL  int  scrFntHeight (void);
LOCAL  int  scrFntGetFit (char *tp, int lineWidth);
#if R2D_SUBLCD_SUPPORT
LOCAL  int  scrFntGetLen (char *tp, int nChars, int sub_main);
#else
LOCAL  int  scrFntGetLen (char *tp, int nChars);
#endif
LOCAL  int  scrBmpDraw   (int px, int py, int sx, int sy,
                          int ix, char *bm, int mode);
LOCAL  void scrCurType   (int type);
LOCAL  void scrCursor    (int x, int y);
LOCAL  void scrPoint     (int px, int py, int col);
#if R2D_SUBLCD_SUPPORT
LOCAL  void scrTxtPoint (int px, int py, UBYTE in_Attr, int col, UBYTE sub_main);
#else
LOCAL  void scrTxtPoint (int px, int py, UBYTE in_Attr, int col);
#endif

LOCAL  int  scrUpdate    (int onOff);

#if R2D_SUBLCD_SUPPORT
void dspl_show_bitmap	(int x, 
						 int y,
						 UBYTE txtAttrib,
						 t_font_bitmap *current_bitmap,
						 UBYTE attr,
						 UBYTE sub_main );
#else
void dspl_show_bitmap	(int x, 
						 int y,
						 UBYTE txtAttrib,
						 t_font_bitmap *current_bitmap,
						 UBYTE attr);

#endif


/* Robert.Chen add, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
#define	SUBLCD_COL	96
#define SUBLCD_ROW	64
#endif


/*2003/12/25,talcon add*/
GLOBAL UBYTE dspl_TextOut_Cmode_Center(USHORT in_Y, USHORT len_x, UBYTE in_Attrib,
									   char * in_Text, UBYTE Newline);
static U8 dsplScreenType = 0;
PDSPL_BITBLT				pdspl_BitBlt = (PDSPL_BITBLT)dspl_BitBlt;
PSET_FONT_TYPE				pset_font_type = (PSET_FONT_TYPE)set_font_type;
PDSPL_ENABLE				pdspl_Enable = (PDSPL_ENABLE)dspl_Enable;
PDSPL_TEXTOUT_CMODE_CENTER	pdspl_TextOut_Cmode_Center = (PDSPL_TEXTOUT_CMODE_CENTER)dspl_TextOut_Cmode_Center;
PDSPL_COLORTEXTOUT			pdspl_colorTextOut = (PDSPL_COLORTEXTOUT)dspl_colorTextOut;
PDSPL_CLEARALL				pdspl_ClearAll =(PDSPL_CLEARALL)dspl_ClearAll;
PDSPL_CLEAR					pdspl_Clear = (PDSPL_CLEAR)dspl_Clear; 
/*END TALCON ADD*/
/*==== CONSTANTS ==================================================*/

/*******************************************************************
 *                                                                 *
 * PART I: Driver Interface                                        *
 *                                                                 *
 *******************************************************************/

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_Init                  |
+--------------------------------------------------------------------+

  PURPOSE : The function initializes the drivers internal data. The
            function returns DRV_INITIALIZED if the driver has already
            been initialized and is ready to be used or already in use.
            In case of an initialization failure, which means that the
            driver cannot be used, the function returns DRV_INITFAILURE.

*/

GLOBAL UBYTE dspl_Init (void)
{
    /*
     * Default is character Display
     */
    fontinfo = (FONTINFO *)malloc(sizeof (FONTINFO));/* must allot place to save fontinfo */
    displayData.DisplayType = DSPL_TYPE_CHARACTER;
    set_font_type(NORMAL_FONT);/* set the initial font type is NORMAL_FONT */

	/* Robert.Chen add, for sub LCD, 2003-12-14 */
    #if R2D_SUBLCD_SUPPORT
    sub_fontinfo = (FONTINFO *)malloc(sizeof (FONTINFO));
    sub_displayData.DisplayType = DSPL_TYPE_GRAPHIC;
    sub_displayData.Height		= SUBLCD_ROW;
    sub_displayData.Width		= SUBLCD_COL;
    sub_scrX					= SUBLCD_COL;
    sub_scrY					= SUBLCD_ROW;
    set_sub_font_type(NORMAL_FONT);
   r2d_erase(r2d_g_sublcd_gc);    
    sub_scrEnabled = 1;
    #endif
    /* end */

    if(!extDisplay)                /* use internal display */
    {
#if defined (SIMULATE_LCD)
        LCD_Reset  ();                /* use character oriented display */
        LCD_Enable (1);
        LCD_Clear  ();
        scrInit();          /* we need this also for glob vars, kk 14.02.2000*/
#else
        scrInit();                    /* use graphic display */
#endif
    }
    else
#if defined (SIMULATE_LCD)
        LCD_Enable (0);
#else
        scrExit();
#endif

    return DRV_OK;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_Exit                  |
+--------------------------------------------------------------------+

  PURPOSE : The function is called when the driver functionality is
            not longer needed. The function "de-allocates" all
            allocated resources and finalizes the driver.

*/

GLOBAL void dspl_Exit (void)
{
    scrExit();
}

/*
+--------------------------------------------------------------------+

  PURPOSE : This function is used to clear a specific region of the
            display using the current background colour. The region
            is specified by the upper left corner (X1, Y1) and the
            lower right corner (X2, Y2) inclusive. The background
            color can be set using dspl_SetBkgColor () function.

*/
GLOBAL UBYTE dspl_Clear (USHORT   in_X1,
                         	USHORT   in_Y1,
                         	USHORT   in_X2,
                         	USHORT   in_Y2)
{

    r2d_fill_rectangle( r2d_g_lcd_gc, in_X1-1, in_Y1-1, in_X2, in_Y2);//attention:need to clear buffer also later
    return DRV_OK;
}

/* Robert.Chen add, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL UBYTE dspl_sub_Clear (USHORT   in_X1,
                         		  USHORT   in_Y1,
                         		  USHORT   in_X2,
                         		  USHORT   in_Y2)
{

    r2d_fill_rectangle( r2d_g_sublcd_gc, in_X1-1, in_Y1-1, in_X2, in_Y2);
    return DRV_OK;
}
#endif
/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_Clear                 |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to clear a specific region of the
            display using the current background colour. The region
            is specified by the upper left corner (X1, Y1) and the
            lower right corner (X2, Y2) inclusive. The background
            color can be set using dspl_SetBkgColor () function.

*/

GLOBAL UBYTE dspl_ClearAll (void)
{
    scrClear ();
    return DRV_OK;
}

/* Robert.Chen add, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL UBYTE dspl_sub_ClearAll(void)
{
	U8 uMode;
	
	uMode = dspl_sub_Enable(0);
    r2d_erase(r2d_g_sublcd_gc);
    dspl_sub_Enable(uMode);
}
#endif

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_Enable                |
+--------------------------------------------------------------------+

  PURPOSE : The function is used to turn the display on or off. While
            a display is switched off, it is possible to perform any
            drawing function.

*/

GLOBAL UBYTE dspl_Enable (UBYTE   in_Enable)
{
    return scrUpdate (in_Enable);
}

/* Robert.Chen add, for enable/disable sub LCD, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL UBYTE dspl_sub_Enable(UBYTE in_Enable)
{
	int ena = sub_scrEnabled;
    
    sub_scrEnabled = in_Enable;
    if(sub_scrEnabled)
    {
        LcdUpdateRequire(r2d_g_sublcd_gc);        
    }
    
    return ena;
}
#endif

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_GetDeviceCaps         |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to retrieve the capabilities of the
            display device including the dimensions of the display and
            the logical unit in which the dimensions is measured.

*/

GLOBAL void dspl_GetDeviceCaps (dspl_DevCaps * out_DeviceCapsPtr)
{
    int x,y;

    scrSize (&x, &y);

    out_DeviceCapsPtr->Height = (USHORT)y;
    out_DeviceCapsPtr->Width  = (USHORT)x;
}

/* Robert.Chen add, for sub LCD capability, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL void dspl_sub_GetDeviceCaps(dspl_DevCaps * out_DeviceCapsPtr)
{
	out_DeviceCapsPtr->Height = (USHORT)SUBLCD_ROW;
    out_DeviceCapsPtr->Width  = (USHORT)SUBLCD_COL;
}
#endif

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_SetDeviceCaps         |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to set the capabilities of the
            display device including the dimensions of the display and
            the logical unit in which the dimensions is measured.

*/

GLOBAL void dspl_SetDeviceCaps (dspl_DevCaps * in_DeviceCapsPtr)
{
    displayData.DisplayType = in_DeviceCapsPtr->DisplayType;
}

/* Robert.Chen add, for sub LCD capability, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL void dspl_sub_SetDeviceCaps (dspl_DevCaps * in_DeviceCapsPtr)
{
    sub_displayData.DisplayType = in_DeviceCapsPtr->DisplayType;
}
#endif

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_GetIconImage          |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to copy the image of a driver
            internal icon into an application specific icon buffer.
            The icon may modify the icon. In case of a successful
            completion the function returns DRV_OK. In case the
            size of the buffer where the icon image shall be copied
            is too small the driver returns DRV_INVALID_PARAMS. In
            case a specific driver implementation does not support
            this functionality the driver returns DSPL_FCT_NOTSUPPORTED.

*/

GLOBAL UBYTE dspl_GetIconImage (UBYTE     in_Icon,
                                USHORT    in_Size,
                                UBYTE   * out_IconImagePtr)
{
    return DSPL_FCT_NOTSUPPORTED;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_SetCursor             |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to change the current cursor settings.
            These settings include the type of cursor and the mode
            (e.g. static cursor, not flashing). A set of standard
            types and modes is defined.

*/

GLOBAL UBYTE dspl_SetCursor (UBYTE in_CursorType,
                             UBYTE in_CursorMode)
{
    return DRV_OK;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_SetCursorPos          |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to set the current cursor position.
            If the function succeeds, the cursor is set to the new
            position. If one of the values is out of range, the function
            returns DRV_INVALID_PARAMS. The number of rows and columns
            the display supports can be retrieved using the function
            dspl_GetDevCaps(). The upper left corner has the coordinates
            0,0. The values in_X and in_Y are measured in logical units
            depending on the capabilities of the device. The means a
            graphical display will use pixels.

GW 05/09/01 Added size x and size y parameters to allow for chinese chars.
*/

GLOBAL UBYTE dspl_SetCursorPos (USHORT   in_X,
                                USHORT   in_Y,
                                USHORT   in_SizeX,
                                USHORT   in_SizeY
                               )
{
/*GW Removed windows test code
#if defined (WIN32)
  char bmp[5];
  int warn99;
  int ofsY;
  {
    bmp[2] = 0x00;
    bmp[3] = 0x00;
    if (in_SizeX == 6)
    {
      if (in_SizeY==8)
        ofsY = 0;
      else
        ofsY = 4;
      bmp[0] = 0x00;
      bmp[1] = '-';
      dspl_TextOut ( in_X, (USHORT)(in_Y+ofsY), 0x80, bmp);
    }
    else
    {
      bmp[0] = 0x4E;
      bmp[1] = 0x00;
      dspl_TextOut ( in_X, in_Y, 0x80, bmp);
    }
    return (DRV_OK);
  }
#endif
*/
    if(displayData.DisplayType EQ DSPL_TYPE_CHARACTER)
    {
        LCD_Cursor (in_Y, in_X);               /* set cursor position */
        if(extDisplay)                        /* if external display */
            dspl_SendDisplayReq (in_X, in_Y, NULL);
    }
    else
	{
		/* 2003/12/29 sunsj modify */
		//scrLine(in_X,in_Y+in_SizeY,in_X+in_SizeX-1,in_Y+in_SizeY);
        scrLine(in_X,in_Y+in_SizeY-1,in_X+in_SizeX-1,in_Y+in_SizeY-1);
	}
    return DRV_OK;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_ShowCursor            |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to change the status of the cursor.
            The cursor can be visible or invisible. The function returns
            the previous status of the cursor.

*/

GLOBAL UBYTE dspl_ShowCursor (UBYTE in_Show)
{
    return DSPL_CURSOR_VISIBLE;
}


/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_SetBkgColor           |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to change the color used for
            background painting. If the color is out of range, the
            driver returns DRV_INVALID_PARAMS and leaves the color
            unchanged.

*/
GLOBAL UINT32 dspl_SetBkgColor (UINT32 in_Color)
{
    UINT32 Cur_BkgColor;
    Cur_BkgColor=dspl_GetBkgColor();
    r2d_set_background_color(r2d_g_lcd_gc,in_Color);
    return Cur_BkgColor;
}

/* Robert.Chen add, for setting sub LCD background color, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL UINT32 dspl_sub_SetBkgColor (UINT32 new_bkgc)
{
    UINT32 cur_bkgc;
    cur_bkgc = dspl_sub_GetBkgColor();
    r2d_set_background_color(r2d_g_sublcd_gc, new_bkgc);
    return cur_bkgc;
}
#endif


/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_SetFrgColor           |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to change the color used for
            foreground painting, e.g. text color. If the color is
            out of range, the driver returns DRV_INVALID_PARAMS and
            leaves the color unchanged.
            set a call-back function which

*/
GLOBAL UINT32 dspl_SetFrgColor (UINT32 in_Color)
{
    UINT32 Cur_FrgColor;
    Cur_FrgColor = dspl_GetFrgColor();  
    r2d_set_foreground_color(r2d_g_lcd_gc,in_Color);
    return(Cur_FrgColor);
}

/* Robert.Chen add, for setting sub LCD fgd color, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL UINT32 dspl_sub_SetFrgColor (UINT32 new_frgc)
{
    UINT32 cur_frgc;
    cur_frgc = dspl_sub_GetFrgColor();  
    r2d_set_foreground_color(r2d_g_sublcd_gc, new_frgc);
    return(cur_frgc);
}
#endif

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_GetFrgColor                |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to get the foreground color of the r2d_g_lcd_gc,chenjun add
            this in the demand of shitong,0603

*/
GLOBAL UINT32   dspl_GetFrgColor(void)
{
    return(UINT32)r2d_get_foreground_color(r2d_g_lcd_gc);
}

/* Robert.Chen add, for getting sub LCD fgd color, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL UINT32   dspl_sub_GetFrgColor(void)
{
    return(UINT32)r2d_get_foreground_color(r2d_g_sublcd_gc);
}
#endif
/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_GetFrgColor                |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to get the background color of the r2d_g_lcd_gc, chenjun add
            this  in the demand of shitong,0603

*/
GLOBAL UINT32 dspl_GetBkgColor(void)
{
    return(UINT32)r2d_get_background_color(r2d_g_lcd_gc);
} 

/* Robert.Chen add, for getting sub LCD bkg color, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL UINT32 dspl_sub_GetBkgColor(void)
{
    return(UINT32)r2d_get_background_color(r2d_g_sublcd_gc);
}
#endif
/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_DrawIcon              |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to draw a driver internal icon.
            The origin of the icon is the upper left corner, defined
            by the parameters in_X/in_Y.

*/

GLOBAL UBYTE dspl_DrawIcon (UBYTE  in_IconID,
                            USHORT in_X,
                            USHORT in_Y)
{
    return DSPL_FCT_NOTSUPPORTED;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_DrawLine              |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to draw a line from a specific
            location defined by the parameters in_X1/in_Y1, to a
            specific location defined by the parameters in_X2/in_Y2.
            The displays origin is the upper left corner with the
            co-ordinates (0,0). The function uses the current
            foreground color, which can be set using the
            dspl_SetFrgColor (), to draw the line.

*/

GLOBAL UBYTE dspl_DrawLine (USHORT in_X1,
                            USHORT in_Y1,
                            USHORT in_X2,
                            USHORT in_Y2)
{
    scrLine(in_X1,in_Y1,in_X2,in_Y2);

    return DRV_OK;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_DrawRect              |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to draw a rectangle. The upper left
            corner of the rectangle is defined by the parameters
            in_X1/in_Y1. The lower right corner of the rectangle is
            defined by the parameters in_X2/in_Y2.
            The displays origin is the upper left corner with the
            co-ordinates (0,0). The function uses the current
            foreground color, which can be set using the
            dspl_SetFrgColor (), to draw the rectangle.

*/

GLOBAL UBYTE dspl_DrawRect (USHORT in_X1,
                            USHORT in_Y1,
                            USHORT in_X2,
                            USHORT in_Y2)
{
    scrRect(in_X1,in_Y1,in_X2-in_X1,in_Y2-in_Y1);

    return DRV_OK;
}

/******************************************************/
/*                                                    */
/*Function Name:  dspl_DrawFillRect                            */
/*Purpose:        DrawFillRect    */
/*Parameter:     USHORT in_X1  in_Y1  in_X2,   in_Y2        */
/*return   :     UBYTE                      */
/*                                                    */
/*Author   :    zhou yue                     */
/*Date     :     Aug.4st,2002                           */
/******************************************************/


GLOBAL UBYTE dspl_DrawFillRect (USHORT in_X1,
                                USHORT in_Y1,
                                USHORT in_X2,
                                USHORT in_Y2)
{
    USHORT i,py,DX1=in_X1,DX2=in_X2,DY1=in_Y1,DY2=in_Y2;
    if(in_X1>in_X2)
    {
        DX1=in_X2;
        DX2=in_X1;
    }

    if(in_Y1>in_Y2)
    {
        DY1=in_Y2;
        DY2=in_Y1;
    }
    for(i=0,py=DY1;i<(DY2-DY1);i++,py++)
    {
        scrLine(DX1,py,DX2,py);
    }
    return DRV_OK;
}
/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_DrawEllipse           |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to draw an ellipse. The center of
            the ellipse is the center of the bounding rectangle
            specified by the parameters.
            The displays origin is the upper left corner with the
            co-ordinates (0,0). The function uses the current
            foreground color, which can be set using the
            dspl_SetFrgColor (), to draw the ellipse.

*/

GLOBAL UBYTE dspl_DrawEllipse (USHORT in_X1,
                               USHORT in_Y1,
                               USHORT in_X2,
                               USHORT in_Y2)
{
    return DSPL_FCT_NOTSUPPORTED;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_BitBlt                |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to display a bitmap at the
            specified location using the raster operation provided.
            The bitmap format is customer specific but must include
            the size of the bitmap.


*///2003 02.28 zhaowm add for displaying browser's image 

GLOBAL UBYTE DSPL_BitBlt (USHORT in_X,
                          USHORT in_Y,
                          USHORT in_Width,
                          USHORT in_Height,
                          USHORT in_Index,
                          void * in_BmpPtr,
                          USHORT in_Rop)
{
    scrBmpDraw ((int)in_X, (int) in_Y, (int) in_Width,
                (int)in_Height, (int)in_Index,
                (char *)in_BmpPtr, (int)in_Rop);

    return DRV_OK;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_SelectFontbyID        |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to select a font used for
            displaying text. Text can be displayed using the
            functions dspl_TextOut_Cmode.
            Driver specific fonts are identified be a font ID
            (parameter in_Font). The definition of fonts and font
            identifiers is not in scope of G23. Fonts and font
            identifiers have to be defined by the customer. The
            specific implementation of the display driver and the MMI
            using the driver have the knowledge about the available
            fonts, their identification and how to use them.

*/

GLOBAL UBYTE dspl_SelectFontbyID (UBYTE in_Font)
{
    return DSPL_FCT_NOTSUPPORTED;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_SelectFontbyImage     |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to select a font used for
            displaying text. Text can be displayed using the
            functions dspl_TextOut_Cmode.
            Application specific fonts are identified by the parameter
            in_FontPtr, the address of the buffer containing the
            application specific font. The structure of the font image
            in not in the scope of G23. The structure of the font images
            have to be defined by the customer implementing the driver.

*/

GLOBAL UBYTE dspl_SelectFontbyImage (UBYTE * in_FontPtr)
{
    return DSPL_FCT_NOTSUPPORTED;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_GetFontImage          |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to copy the image of a font into an
            application specific font buffer. The application may modify
            the font. In case of a successful completion the function
            returns DRV_OK. In case the size of the buffer where the
            font image shall be copied to is too small the driver returns
            DRV_INVALID_PARAMS. In case a specific driver implementation
            does not support this functionality the driver returns
            DSPL_FCT_NOTSUPPORTED.

*/

GLOBAL UBYTE dspl_GetFontImage (UBYTE    in_Font,
                                USHORT   in_Size,
                                UBYTE *  out_FontPtr)
{
    return DSPL_FCT_NOTSUPPORTED;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_GetFontHeight         |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to retrieve the vertical size of
            the currently selected font. The function returns the
            height measured in logical units depending on the device
            capabilities (e.g. pixels or multiple of characters). Call
            the function dspl_SelectFont() to select a font.

*/

GLOBAL UBYTE dspl_GetFontHeight (void)
{
    return scrFntHeight();
}

/* Robert.Chen add, for getting sub LCD font height, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL UBYTE dspl_sub_GetFontHeight (void)
{
    return sub_fontinfo->font_h;
}
#endif

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_GetTextExtent         |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to calculate the size of a 0-terminated
            string, to which the parameter in_Text points. The function
            returns the size needed to display the text. The value of
            the size is measured in units depending on the device
            capabilities (e.g. pixels or multiple of characters). Call
            the function dspl_SelectFont() to select a font.

*/
/* Robert.Chen changed, for sub LCD, 2003-102-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL USHORT dspl_GetTextExtent (char * in_Text, USHORT in_Length)
{
    if(displayData.DisplayType EQ DSPL_TYPE_CHARACTER)
        return in_Length;
    else
        return scrFntGetLen ( in_Text, ( int ) in_Length, 1 );
}
GLOBAL USHORT dspl_sub_GetTextExtent (char *in_Text, USHORT in_Length)
{
    if(sub_displayData.DisplayType EQ DSPL_TYPE_CHARACTER)
        return in_Length;
    else
        return scrFntGetLen ( in_Text, ( int ) in_Length, 0 );
}
#else
GLOBAL USHORT dspl_GetTextExtent (char * in_Text, USHORT in_Length)
{
    if(displayData.DisplayType EQ DSPL_TYPE_CHARACTER)
        return in_Length;
    else
        return scrFntGetLen ( in_Text, ( int ) in_Length );
}
#endif

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_GetMaxTextLen         |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to calculate the sub-string
            (number of characters) of a 0-terminated string (in_Text)
            that can be displayed in the region given by the parameter
            in_HSize. The value of in_HSize is measured in logical
            units (e.g. pixels or multiple of characters). Call
            the function dspl_SelectFont() to select a font.

*/

GLOBAL USHORT dspl_GetMaxTextLen (char  * in_Text,
                                  USHORT   in_HSize)
{
    if(displayData.DisplayType EQ DSPL_TYPE_CHARACTER)
        return strlen (in_Text);
    else
        return scrFntGetFit ( in_Text, ( int ) in_HSize );
}




GLOBAL void dspl_set_char_type(UBYTE char_type)
{
    dspl_char_type = char_type;
}

GLOBAL UBYTE dspl_get_char_type(void)
{
    return dspl_char_type;
}
/* Robert.Chen add, for sub LCD, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
GLOBAL void dspl_sub_set_char_type(UBYTE char_type)
{
    dspl_sub_char_type = char_type;
}

GLOBAL UBYTE dspl_sub_get_char_type(void)
{
    return dspl_sub_char_type;
}
#endif

#if R2D_SUBLCD_SUPPORT
/* font type setting internal function */
static void set_font_type_i(UBYTE font_type, UBYTE lcd)
{
	FONTINFO *finfo;
	
	if(lcd == 1) /* set main LCD font type */
	{
		dspl_font_type = font_type;
		finfo = fontinfo;
	}	
	else
	{
		dspl_sub_font_type = font_type;	
		finfo = sub_fontinfo;
	}
		
    switch(font_type)
    {
        case NORMAL_FONT:
			/* 2003/12/29 sunsj add font switch */
		#if defined FONT_12X12
            finfo->font_w	= 6;			/* we should set font_w as 1/2 of width of unicode */
            finfo->font_h	= 12;			/* font height */
            finfo->font_s	= 12;			/* we should set font_s as 1/2 of size of unicode */
            finfo->font_e	= MAXCODESYM;	/* how many char in uni_sym font lib table */
            finfo->ascfont	= (char *)Asc0_127_6x12Ex;	/* ascii font lib	  */
            finfo->uni0_256	= (char *)Asc0_127_6x12Ex;	/* uni 0~256 font lib */
            finfo->uni_cjk	= (char *)UniCJKNormal12x12;		/* uni cjk font lib   */
            finfo->uni_sym	= (_UniSym_ *)UniSym12x12;	/* uni sym font lib   */
            finfo->uni_12x12= 0; /* uni12x12 font lib, if you needn't it,you can set it to 0 */
		#elif defined FONT_16X16
            finfo->font_w	= 8;			/* we should set font_w as 1/2 of width of unicode */
            finfo->font_h	= 16;			/* font height */
            finfo->font_s	= 16;			/* we should set font_s as 1/2 of size of unicode */
            finfo->font_e	= MAXCODESYM;	/* how many char in uni_sym font lib table */
            finfo->ascfont	= (char *)Uni0_256_8x16Ex;	/* ascii font lib	  */
            finfo->uni0_256	= (char *)Uni0_256_8x16Ex;	/* uni 0~256 font lib */
            finfo->uni_cjk	= (char *)UniCJKNormal16x16;		/* uni cjk font lib   */
            finfo->uni_sym	= (_UniSym_ *)UniSym16x16;	/* uni sym font lib   */
            finfo->uni_12x12= 0; /* uni12x12 font lib, if you needn't it,you can set it to 0 */
		#endif
			/* 2003/10/13 sunsj charwidth if we display auto width ascii */	
			finfo->charwidth = (char *)asccharwidth;
			/* 2003/10/26 sunsj add for stroke element and pinyin element */
			finfo->elementmap = (char *)ElementMap;
			break;
        case UNI12X12_FONT: /* for gudy's calendar */
            finfo->font_w	= 6;
            finfo->font_h	= 12;
            finfo->font_s	= 12;
            finfo->font_e	= MAXCODE12X12;
            finfo->ascfont	= (char *)Asc0_127_6x12Ex;
            finfo->uni0_256	= (char *)Asc0_127_6x12Ex;
            finfo->uni_cjk	= 0;//we needn't it,so set it to 0
            finfo->uni_12x12= (_Uni12X12_ *)UniCJK12x12;
            finfo->uni_sym	= 0; /* we needn't it,so set it to 0 */
            break;
        case CHNINPUT_FONT:/* for chinese input */
            finfo->font_w	= 8;
            finfo->font_h	= 16;
            finfo->font_s	= 16;
            finfo->font_e	= MAXCODESYM;
            finfo->ascfont	= 0;
            finfo->uni0_256	= (char *)Asc0_127_6x12Ex;
            finfo->uni_cjk	= 0;//(char *)UniCJKNormal;//we needn't it,so set it to 0
            finfo->uni_12x12= 0;
            finfo->uni_sym	= 0;//we needn't it,so set it to 0
            break;
        case YB8X16_FONT:
            finfo->font_w	= 8;
            finfo->font_h	= 16;
            finfo->font_s	= 16;
            finfo->font_e	= 0;
            finfo->ascfont	= (char *)YB0_127_8x16Ex;
            finfo->uni0_256	= 0;
            finfo->uni_cjk	= 0;
            finfo->uni_12x12= 0;
            finfo->uni_sym	= 0;
            break;
			/* 2004/05/11 sunsj modify */
#ifdef _feature_mainLCD_w102_h80
			/* 2004/03/08 sunsj add small font */
		case SMALL_FONT:
			finfo->font_w   = 4;
			finfo->font_h   = 7;
			finfo->font_s   = 7;
			finfo->font_e   = 0;
			finfo->ascfont  = (char *)ASCII_number_4x7;
			finfo->uni0_256	= 0;
            finfo->uni_cjk	= (char *)UniCJKNormal12x12;
            finfo->uni_sym	= (_UniSym_ *)UniSym12x12;
            finfo->uni_12x12= 0; 
			break;
#endif
        default:
            break;
    }
}

/*
 * If you want display specific font, you must call the following function at first
 * and new font type can be defined in dspl.h
 */
GLOBAL void set_font_type(UBYTE font_type)
{
	/* set main LCD font type */
	set_font_type_i(font_type, 1);
}

GLOBAL void set_sub_font_type(UBYTE font_type)
{
	/* set sub LCD font type */
	set_font_type_i(font_type, 0);
}
#else	/* R2D_SUBLCD_SUPPORT */
/*
 * If you want display specific font, you must call the following function at first
 * and new font type can be defined in dspl.h
 */
static void set_font_type(UBYTE font_type)
{
    dspl_font_type = font_type;
    switch(dspl_font_type)
    {
        case NORMAL_FONT:
//#if(MAIN_LCD_SIZE==3)
	#if defined FONT_12X12
			fontinfo->font_w=6;//we should set font_w as 1/2 of width of unicode
            fontinfo->font_h=12;//font height
            fontinfo->font_s=12;//we should set font_s as 1/2 of size of unicode
            fontinfo->font_e=MAXCODESYM;//how many char in uni_sym font lib table 
            fontinfo->ascfont=(char *)Asc0_127_6x12Ex;//ascii font lib
            fontinfo->uni0_256=(char *)Asc0_127_6x12Ex;//uni 0~256 font lib
            fontinfo->uni_cjk=(char *)UniCJKNormal12x12;//uni cjk font lib
            fontinfo->uni_sym=(_UniSym_ *)UniSym12x12;//uni sym font lib
            fontinfo->uni_12x12=0;//uni12x12 font lib, if you needn't it,you can set it to 0
#elif defined FONT_16X16
            fontinfo->font_w=8;//we should set font_w as 1/2 of width of unicode
            fontinfo->font_h=16;//font height
            fontinfo->font_s=16;//we should set font_s as 1/2 of size of unicode
            fontinfo->font_e=MAXCODESYM;//how many char in uni_sym font lib table 
            fontinfo->ascfont=(char *)Uni0_256_8x16Ex;//ascii font lib
            fontinfo->uni0_256=(char *)Uni0_256_8x16Ex;//uni 0~256 font lib
            fontinfo->uni_cjk=(char *)UniCJKNormal16x16;//uni cjk font lib
            fontinfo->uni_sym=(_UniSym_ *)UniSym16x16;//uni sym font lib
            fontinfo->uni_12x12=0;//uni12x12 font lib, if you needn't it,you can set it to 0
#endif
			/* 2003/10/13 sunsj charwidth if we display auto width ascii */	
			fontinfo->charwidth = (char *)asccharwidth;
			/* 2003/10/26 sunsj add for stroke element and pinyin element */
			fontinfo->elementmap = (char *)ElementMap;
			break;
        case UNI12X12_FONT://zhonghz,2002/8/2, for gudy's calendar
            fontinfo->font_w=6;
            fontinfo->font_h=12;
            fontinfo->font_s=12;
            fontinfo->font_e=MAXCODE12X12;
            fontinfo->ascfont=(char *)Asc0_127_6x12Ex;
            fontinfo->uni0_256=(char *)Asc0_127_6x12Ex;
            fontinfo->uni_cjk=0;//we needn't it,so set it to 0
            fontinfo->uni_12x12=(_Uni12X12_ *)UniCJK12x12;
            fontinfo->uni_sym=0;//we needn't it,so set it to 0
            break;
        case CHNINPUT_FONT://zhonghz,2002/9/3, for zhangxp's chinese input
            fontinfo->font_w=8;
            fontinfo->font_h=16;
            fontinfo->font_s=16;
            fontinfo->font_e=MAXCODESYM;
            fontinfo->ascfont=0;
            fontinfo->uni0_256=(char *)Asc0_127_6x12Ex;
            fontinfo->uni_cjk=(char *)UniCJK16x16;;//we needn't it,so set it to 0
            fontinfo->uni_12x12=0;
            fontinfo->uni_sym=0;//we needn't it,so set it to 0
            break;
        case YB8X16_FONT:
            fontinfo->font_w=8;
            fontinfo->font_h=16;
            fontinfo->font_s=16;
            fontinfo->font_e=0;
            fontinfo->ascfont=(char *)YB0_127_8x16Ex;
            fontinfo->uni0_256=0;
            fontinfo->uni_cjk=0;
            fontinfo->uni_12x12=0;
            fontinfo->uni_sym=0;
            break;
        default:
            break;
    }
}
#endif	/* R2D_SUBLCD_SUPPORT */

/* get font type */ 
GLOBAL UBYTE get_font_type(void)
{
    return dspl_font_type;
}

/* get font height */
GLOBAL int get_font_height(void)
{
    return fontinfo->font_h;
}

/* get font width,half of width of unicode */
GLOBAL int get_font_width(void)
{
    return fontinfo->font_w;
}

/* get font width,half of size of unicode */
GLOBAL int get_font_size(void)
{
    return fontinfo->font_s;
}

/* Robert.Chen add, for sub LCD, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
/* get font type */ 
GLOBAL UBYTE get_sub_font_type(void)
{
    return dspl_sub_font_type;
}

/* get font height */
GLOBAL int get_sub_font_height(void)
{
    return sub_fontinfo->font_h;
}

/* get font width,half of width of unicode */
GLOBAL int get_sub_font_width(void)
{
    return sub_fontinfo->font_w;
}

/* get font width,half of size of unicode */
GLOBAL int get_sub_font_size(void)
{
    return sub_fontinfo->font_s;
}
#endif
/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_TextOut_Cmode               |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to display a text at the given
            location in_X/in_Y uding the defined attributes (in_Attrib)
            and the currently selected color (foreground and background).
            The cursor position is left unchanged. The driver will not
            take the displays bounding rectangle into consideration and
            therefore text may be cut off.
            Linefeeds and carriage returns are not supported and there-
            fore must be handled by upper layers.


*/

#if R2D_SUBLCD_SUPPORT
/* Robert.Chen add, 2003-12-14 */
/* sub_main: 1 for main LCD, 0 for sub LCD */
static dspl_TextOut_Cmode_Center_i(USHORT in_Y, USHORT len_x, UBYTE in_Attrib,
                                             char * in_Text, UBYTE Newline, UBYTE sub_main)
{
    int in_X_signed;
    int in_Y_signed;
    unsigned char * p=(unsigned char *)in_Text;
    int charnum=0,row=0,i=0,j=0,n=0;
    USHORT unichar;
    UBYTE  displayType;
    int font_h, font_w, font_s;
    char mult_line_txt_asc[MAXROW][24];//maxrow X maxchar
    char mult_line_txt_uni[MAXROW][42];//char * type;you should allot 42;
	/* 2003/10/28 sunsj */
	unsigned char ascii_char;
	int total_pixel;
	int current_char_width;
	int scrX_i;


	/* 2003/10/28 sunsj */
    //charnum=(len_x-in_X)/font_w;
	charnum=(len_x)/6;

	if(sub_main == R2D_MAINLCD) /* main LCD */
	{
		font_h		= fontinfo->font_h;
	    font_w		= fontinfo->font_w;
    	font_s		= fontinfo->font_s;
    	displayType = displayData.DisplayType;
    	scrX_i		= scrX;
	}
	else	/* sub LCD */
	{
		font_h		= sub_fontinfo->font_h;
	    font_w		= sub_fontinfo->font_w;
    	font_s		= sub_fontinfo->font_s;
    	displayType = sub_displayData.DisplayType;
    	scrX_i		= sub_scrX;
	}	

    if(Newline)
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)//if ascii
        {
			/* 2003/10/28 sunsj some ascii code will convert a big number through type convert */
			ascii_char = *p;
            for(i=0;i<MAXROW&&(*p!=0);i++)
            {
				/* 2003/10/28 sunsj add for auto width char display */
				total_pixel = 0;
                while((*p!=NEWLINE)&&(j<charnum)&&(*p!=0))
                {
					/* 2003/10/28 sunsj add for auto width char */
					if(sub_main == R2D_MAINLCD)
						current_char_width = get_CharWidth((USHORT)ascii_char);
					else
						current_char_width = sub_get_CharWidth((USHORT)ascii_char);
						
					total_pixel += current_char_width;
					if( total_pixel > len_x )
					{
						break;
					}

                    mult_line_txt_asc[i][j++]=(char)*p++;
					/* 2003/10/28 sunsj get the new char */
					ascii_char = *p;
                }
                row++;
                mult_line_txt_asc[i][j]=0x00;//set the end char to 0x00;
                if(*p==NEWLINE&&*(p+1)!=0x00)//if newline and next char isn't 0x00, get next char;
                    p++;
                j=0;            
            }
        }
        else/* if(in_Attrib&DSPL_TXTATTR_UNIMODE)*/
        {
            //if unicode
            unichar=(*p<<8)+*(p+1);
            for(i=0;i<MAXROW&&(unichar!=0x0000);i++)
            {
                n=0;
				/* 2003/10/28 sunsj add for auto width char display */
				total_pixel = 0;
                while((unichar!=NEWLINE)&&((n<(charnum-1))||((n==charnum-1)&&(unichar<=0xff)))&&(unichar!=0x0000))
                {
					/* 2003/10/28 sunsj add for auto width char */
					if(sub_main == R2D_MAINLCD)
						current_char_width = get_CharWidth(unichar);
					else
						current_char_width = sub_get_CharWidth(unichar);
						
					total_pixel += current_char_width;
					if( total_pixel > (len_x) )
					{
						break;
					}

                    mult_line_txt_uni[i][j++]=(char)*p;
                    mult_line_txt_uni[i][j++]=(char)*(p+1);
                    if(unichar<=0xff)
                        n++;
					/* 2003/10/13 sunsj pinyin code display number */
					else if(unichar >= 0xf461 && unichar <= 0xf490)
						n++;
                    else
                        n+=2;
                    p+=2;
                    unichar=(USHORT)((*p<<8)+*(p+1));
                }
                row++;
                mult_line_txt_uni[i][j]=0x00;//set the end byte to 0x00,0x00;
                mult_line_txt_uni[i][j+1]=0x00;
                if(unichar==NEWLINE&&(((*(p+2)<<8)+*(p+3))!=0x0000))
                {//if newline and next byte isn't 0x0000, get next byte;
                    p+=2;
                    unichar=(USHORT)((*p<<8)+*(p+1));
                }
                j=0;        
                n=0;
            }
        }
    }
    else
    {
        row=1;
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        { // if ascii
            memcpy(mult_line_txt_asc,p,24);
            mult_line_txt_asc[0][charnum]=0;
        }
        else
        { // if unicode
            charnum=wstrlen(in_Text)-1;  //xsf add for real length of str 2003.03.10 minus 0x80
            memcpy(mult_line_txt_uni[0],&in_Text[1],charnum);
            mult_line_txt_uni[0][charnum+1]=0;
            mult_line_txt_uni[0][charnum]=0;
        }
    }
    // SH - If we want signed coordinates (i.e. if x and y can have negative numbers)
    // we need to convert the unsigned values into two's complement.

    if(in_Attrib & DSPL_TXTATTR_SIGNED_COORDS)
    {
        in_X_signed = (SHORT)(scrX_i-len_x)/2;
        in_Y_signed = (SHORT)in_Y;
    }
    else
    {
        in_X_signed =50;/*jhxu720 (SHORT)(scrX_i-len_x)/2;*/
        in_Y_signed = in_Y;
    }

#if defined (WIN32_FORREST)
    if(scrEnabled)
    {
        scrText(in_X, in_Y, in_Attrib, in_Text); // zhangzg Eastcom 0703/2002
    }
    else
        LCD_WriteString (in_Y, in_X, (UBYTE *) in_Text);
#else
    if(displayType EQ DSPL_TYPE_CHARACTER)
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        {
            for(i=0;i<row;i++)
            {
            	if(sub_main == R2D_MAINLCD)
                	scrText(font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib,(char *)mult_line_txt_asc[i]);
                else
                	sub_scrText(font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib,(char *)mult_line_txt_asc[i]);
            }
        }
        else if(in_Attrib&DSPL_TXTATTR_UNIMODE)
        {
            char *ss;
            for(i=0;i<row;i++)
            {
                ss=*(mult_line_txt_uni+i);
                if(sub_main == R2D_MAINLCD)
	                scrText_Unicode(2*font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib, ss);
				else
					sub_scrText_Unicode(2*font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib, ss);
            }
        }
    }
    else
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        {
            //2004-05-10 Sunny removed
            for(i=0;i<row - 1;i++)//old:for(i=0;i<row;i++)
            {
            	if(sub_main == R2D_MAINLCD)
	                scrText(in_X_signed,in_Y_signed+i*font_h, in_Attrib, (char *)mult_line_txt_asc[i]);
	            else
	            	sub_scrText(in_X_signed,in_Y_signed+i*font_h, in_Attrib, (char *)mult_line_txt_asc[i]);
            }

            /* 2004/05/26 sunsj modify */
            if( (i==(row-1))&&(row-1)==0 )
            {
				in_X_signed=56;/*jhxu720(scrX_i-total_pixel)/2;*/
				
            	if(sub_main == R2D_MAINLCD)
	                scrText(in_X_signed,in_Y_signed+i*font_h, in_Attrib, (char *)mult_line_txt_asc[i]);
	            else
	            	sub_scrText(in_X_signed,in_Y_signed+i*font_h, in_Attrib, (char *)mult_line_txt_asc[i]);
            }
			//2004-05-10 Sunny add end
        }
        else
        {
            char *ss;
            for(i=0;i<row-1;i++)
            {
            		
                ss=*(mult_line_txt_uni+i);
                if(sub_main == R2D_MAINLCD)
	                scrText_Unicode(in_X_signed,in_Y_signed+i*font_h, in_Attrib, ss);
	            else
	            	sub_scrText_Unicode(in_X_signed,in_Y_signed+i*font_h, in_Attrib, ss);
            }
		
			if((i==(row-1))&&(row-1)!=0)
			{
				in_X_signed=56;/*(scrX_i-total_pixel)/2;jhxu720*/
				ss=*(mult_line_txt_uni+i);
				if(sub_main == R2D_MAINLCD)
					scrText_Unicode(in_X_signed,in_Y_signed+i*font_h, in_Attrib, ss);
				else
					sub_scrText_Unicode(in_X_signed,in_Y_signed+i*font_h, in_Attrib, ss);
			}

			
        }
    }
#endif
     return DRV_OK;
}

/* Compatiable with old version, 2003-12-16, Robert.Chen */
GLOBAL UBYTE dspl_TextOut_Cmode_Center(USHORT in_Y, USHORT len_x, UBYTE in_Attrib,
                                             char * in_Text, UBYTE Newline)
{
	return dspl_TextOut_Cmode_Center_i(in_Y, len_x, in_Attrib, in_Text, Newline, R2D_MAINLCD);
}

GLOBAL UBYTE dspl_sub_TextOut_Cmode_Center(USHORT in_Y, USHORT len_x, UBYTE in_Attrib,
                                             char * in_Text, UBYTE Newline)
{
	return dspl_TextOut_Cmode_Center_i(in_Y, len_x, in_Attrib, in_Text, Newline, R2D_SUBLCD);
}

#else
/*2003/11/25, wangyan add for multi-line text show in center mode*/
GLOBAL UBYTE dspl_TextOut_Cmode_Center(USHORT  in_Y, USHORT  len_x,UBYTE   in_Attrib,char * in_Text,
                                 UBYTE Newline)
{
    int in_X_signed;
    int in_Y_signed;
    unsigned char * p=(unsigned char *)in_Text;
    int charnum=0,row=0,i=0,j=0,n=0;
    USHORT unichar;
    int font_h=fontinfo->font_h;
    int font_w=fontinfo->font_w;
    int font_s=fontinfo->font_s;
    char mult_line_txt_asc[MAXROW][24];//maxrow X maxchar
    char mult_line_txt_uni[MAXROW][42];//char * type;you should allot 42;
	/* 2003/10/28 sunsj */
	unsigned char ascii_char;
	int total_pixel;
	int current_char_width;


	/* 2003/10/28 sunsj */
    //charnum=(len_x-in_X)/font_w;
	charnum=(len_x)/6;

    if(Newline)
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)//if ascii
        {
			/* 2003/10/28 sunsj some ascii code will convert a big number through type convert */
			ascii_char = *p;
            for(i=0;i<MAXROW&&(*p!=0);i++)
            {
				/* 2003/10/28 sunsj add for auto width char display */
				total_pixel = 0;
                while((*p!=NEWLINE)&&(j<charnum)&&(*p!=0))
                {
					/* 2003/10/28 sunsj add for auto width char */
					current_char_width = get_CharWidth((USHORT)ascii_char);
					total_pixel += current_char_width;
					if( total_pixel > len_x )
					{
						break;
					}

                    mult_line_txt_asc[i][j++]=(char)*p++;
					/* 2003/10/28 sunsj get the new char */
					ascii_char = *p;
                }
                row++;
                mult_line_txt_asc[i][j]=0x00;//set the end char to 0x00;
                if(*p==NEWLINE&&*(p+1)!=0x00)//if newline and next char isn't 0x00, get next char;
                    p++;
                j=0;            
            }
        }
        else/* if(in_Attrib&DSPL_TXTATTR_UNIMODE)*/
        {
            //if unicode
            unichar=(*p<<8)+*(p+1);
            for(i=0;i<MAXROW&&(unichar!=0x0000);i++)
            {
                n=0;
				/* 2003/10/28 sunsj add for auto width char display */
				total_pixel = 0;
                while((unichar!=NEWLINE)&&((n<(charnum-1))||((n==charnum-1)&&(unichar<=0xff)))&&(unichar!=0x0000))
                {
					/* 2003/10/28 sunsj add for auto width char */
					current_char_width = get_CharWidth(unichar);
					total_pixel += current_char_width;
					if( total_pixel > (len_x) )
					{
						break;
					}

                    mult_line_txt_uni[i][j++]=(char)*p;
                    mult_line_txt_uni[i][j++]=(char)*(p+1);
                    if(unichar<=0xff)
                        n++;
					/* 2003/10/13 sunsj pinyin code display number */
					else if(unichar >= 0xf461 && unichar <= 0xf490)
						n++;
                    else
                        n+=2;
                    p+=2;
                    unichar=(USHORT)((*p<<8)+*(p+1));
                }
                row++;
                mult_line_txt_uni[i][j]=0x00;//set the end byte to 0x00,0x00;
                mult_line_txt_uni[i][j+1]=0x00;
                if(unichar==NEWLINE&&(((*(p+2)<<8)+*(p+3))!=0x0000))
                {//if newline and next byte isn't 0x0000, get next byte;
                    p+=2;
                    unichar=(USHORT)((*p<<8)+*(p+1));
                }
                j=0;        
                n=0;
            }
        }
    }
    else
    {
        row=1;
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        { // if ascii
            memcpy(mult_line_txt_asc,p,24);
            mult_line_txt_asc[0][charnum]=0;
        }
        else
        { // if unicode
            charnum=wstrlen(in_Text)-1;  //xsf add for real length of str 2003.03.10 minus 0x80
            memcpy(mult_line_txt_uni[0],&in_Text[1],charnum);
            mult_line_txt_uni[0][charnum+1]=0;
            mult_line_txt_uni[0][charnum]=0;
        }
    }
    // SH - If we want signed coordinates (i.e. if x and y can have negative numbers)
    // we need to convert the unsigned values into two's complement.

    if(in_Attrib & DSPL_TXTATTR_SIGNED_COORDS)
    {
        in_X_signed = (SHORT)(scrX-len_x)/2;
        in_Y_signed = (SHORT)in_Y;
    }
    else
    {
        in_X_signed = (SHORT)(scrX-len_x)/2;;
        in_Y_signed = in_Y;
    }

#if defined (WIN32)
    if(scrEnabled)
    {
        scrText(in_X, in_Y, in_Attrib, in_Text); // zhangzg Eastcom 0703/2002
    }
    else
        LCD_WriteString (in_Y, in_X, (UBYTE *) in_Text);
#else
    if(displayData.DisplayType EQ DSPL_TYPE_CHARACTER)
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        {
            for(i=0;i<row;i++)
            {
                scrText(font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib,(char *)mult_line_txt_asc[i]);
            }
        }
        else if(in_Attrib&DSPL_TXTATTR_UNIMODE)
        {
            char *ss;
            for(i=0;i<row;i++)
            {
                ss=*(mult_line_txt_uni+i);
                scrText_Unicode(2*font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib, ss);
            }
        }
    }
    else
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        {
            for(i=0;i<row;i++)
            {
                scrText(in_X_signed,in_Y_signed+i*font_h, in_Attrib, (char *)mult_line_txt_asc[i]);
            }
        }
        else
        {
            char *ss;
            for(i=0;i<row-1;i++)
            {
            		
                ss=*(mult_line_txt_uni+i);
                scrText_Unicode(in_X_signed,in_Y_signed+i*font_h, in_Attrib, ss);
            }
		
		if((i==(row-1))&&(row-1)!=0){
			in_X_signed=(scrX-total_pixel)/2;
					               ss=*(mult_line_txt_uni+i);
		 scrText_Unicode(in_X_signed,in_Y_signed+i*font_h, in_Attrib, ss);
		}

			
        }
    }
#endif
     return DRV_OK;
}
#endif	/* R2D_SUBLCD_SUPPORT */


#if 0//R2D_SUBLCD_SUPPORT
GLOBAL UBYTE dspl_TextOut_Cmode (USHORT  in_X,
                                 USHORT  in_Y,
                                 USHORT  len_x,
                                 UBYTE   in_Attrib,
                                 char * in_Text,
                                 UBYTE Newline,
                                 UBYTE sub_main)
{
    int in_X_signed;
    int in_Y_signed;
    unsigned char * p=(unsigned char *)in_Text;
    int charnum=0,row=0,i=0,j=0,n=0;
    USHORT unichar;
    int font_h, font_w, font_s;
    char mult_line_txt_asc[MAXROW][24];//maxrow X maxchar
    char mult_line_txt_uni[MAXROW][42];//char * type;you should allot 42;
	/* 2003/10/28 sunsj */
	unsigned char ascii_char;
	int total_pixel;
	int current_char_width;
	UBYTE dispType;
	

	/* zhq, 2004/08/05, add this for use use block fresh in r2d_refresh. */
	r2d_update_region(in_X,in_Y, R2D_WIDTH, ((in_Y+16)>R2D_HEIGHT ? R2D_HEIGHT : (in_Y+16)));

	
	if(sub_main == R2D_MAINLCD)
	{
		dispType = displayData.DisplayType;
		font_h	 = fontinfo->font_h;
	    font_w	 = fontinfo->font_w;
    	font_s	 = fontinfo->font_s;
	}
	else
	{
		dispType = sub_displayData.DisplayType;
		font_h	 = sub_fontinfo->font_h;
	    font_w	 = sub_fontinfo->font_w;
    	font_s	 = sub_fontinfo->font_s;
	}	

    if(len_x<in_X)
        in_X=0;

	/* 2003/12/01 sunsj */
    //charnum=(len_x-in_X)/font_w;
	charnum=len_x/6;

    if(Newline)
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)//if ascii
        {
			/* 2003/10/28 sunsj some ascii code will convert a big number through type convert */
			ascii_char = *p;
            for(i=0;i<MAXROW&&(*p!=0);i++)
            {
				/* 2003/10/28 sunsj add for auto width char display */
				total_pixel = 0;
                while((*p!=NEWLINE)&&(j<charnum)&&(*p!=0))
                {
					/* 2003/10/28 sunsj add for auto width char */
					if(sub_main == R2D_MAINLCD)
					{
						current_char_width = get_CharWidth((USHORT)ascii_char);
					}	
					else
					{
						current_char_width = sub_get_CharWidth((USHORT)ascii_char);
					}
					
					total_pixel += current_char_width;
					if( total_pixel > len_x )
					{
						break;
					}

                    mult_line_txt_asc[i][j++]=(char)*p++;
					/* 2003/10/28 sunsj get the new char */
					ascii_char = *p;
                }
                row++;
                mult_line_txt_asc[i][j]=0x00;//set the end char to 0x00;
                if(*p==NEWLINE&&*(p+1)!=0x00)//if newline and next char isn't 0x00, get next char;
                    p++;
                j=0;            
            }
        }
        else/* if(in_Attrib&DSPL_TXTATTR_UNIMODE)*/
        {
            //if unicode
            unichar=(*p<<8)+*(p+1);
            for(i=0;i<MAXROW&&(unichar!=0x0000);i++)
            {
                n=0;
				/* 2003/10/28 sunsj add for auto width char display */
				total_pixel = 0;
                while((unichar!=NEWLINE)&&((n<(charnum-1))||((n==charnum-1)&&(unichar<=0xff)))&&(unichar!=0x0000))
                {
					/* 2003/10/28 sunsj add for auto width char */
					if(sub_main == R2D_MAINLCD)
					{
						current_char_width = get_CharWidth(unichar);
					}
					else
					{
						current_char_width = sub_get_CharWidth(unichar);
					}
					
					total_pixel += current_char_width;
					/* 2003/12/01 sunsj modify */
					if( total_pixel > len_x )
					{
						break;
					}

                    mult_line_txt_uni[i][j++]=(char)*p;
                    mult_line_txt_uni[i][j++]=(char)*(p+1);
                    if(unichar<=0xff)
                        n++;
					/* 2003/10/13 sunsj pinyin code display number */
					else if(unichar >= 0xf461 && unichar <= 0xf490)
						n++;
                    else
                        n+=2;
                    p+=2;
                    unichar=(USHORT)((*p<<8)+*(p+1));
                }
                row++;
                mult_line_txt_uni[i][j]=0x00;//set the end byte to 0x00,0x00;
                mult_line_txt_uni[i][j+1]=0x00;
                if(unichar==NEWLINE&&(((*(p+2)<<8)+*(p+3))!=0x0000))
                {//if newline and next byte isn't 0x0000, get next byte;
                    p+=2;
                    unichar=(USHORT)((*p<<8)+*(p+1));
                }
                j=0;        
                n=0;
            }
        }
    }
    else
    {
        row=1;
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        { // if ascii
            memcpy(mult_line_txt_asc,p,24);
            mult_line_txt_asc[0][charnum]=0;
        }
        else
        { // if unicode
            charnum=wstrlen(in_Text)-1;  //xsf add for real length of str 2003.03.10 minus 0x80
            memcpy(mult_line_txt_uni[0],&in_Text[1],charnum);
            mult_line_txt_uni[0][charnum+1]=0;
            mult_line_txt_uni[0][charnum]=0;
        }
    }
    // SH - If we want signed coordinates (i.e. if x and y can have negative numbers)
    // we need to convert the unsigned values into two's complement.

    if(in_Attrib & DSPL_TXTATTR_SIGNED_COORDS)
    {
        in_X_signed = (SHORT)in_X;
        in_Y_signed = (SHORT)in_Y;
    }
    else
    {
        in_X_signed = in_X;
        in_Y_signed = in_Y;
    }

#if defined (WIN32)
    if(scrEnabled)
    {
        scrText(in_X, in_Y, in_Attrib, in_Text); // zhangzg Eastcom 0703/2002
    }
    else
        LCD_WriteString (in_Y, in_X, (UBYTE *) in_Text);
#else
    if(dispType EQ DSPL_TYPE_CHARACTER)
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        {
        	if(sub_main == R2D_MAINLCD)
        	{
	            for(i=0;i<row;i++)
	            {
	                scrText(font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib,(char *)mult_line_txt_asc[i]);
	            }
            }
            else
            {
            	for(i=0;i<row;i++)
	            {
	                sub_scrText(font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib,(char *)mult_line_txt_asc[i]);
	            }
            }
        }
        else if(in_Attrib&DSPL_TXTATTR_UNIMODE)
        {
            char *ss;
            if(sub_main == R2D_MAINLCD)
            {
	            for(i=0;i<row;i++)
	            {
	                ss=*(mult_line_txt_uni+i);
	                scrText_Unicode(2*font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib, ss);
	            }
            }
            else
            {
            	for(i=0;i<row;i++)
	            {
	                ss=*(mult_line_txt_uni+i);
	                sub_scrText_Unicode(2*font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib, ss);
	            }
            }
        }
    }
    else
    {    	
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        {
        	if(sub_main == R2D_MAINLCD)
    		{
	            for(i=0;i<row;i++)
	            {
	                scrText(in_X_signed,in_Y_signed+i*font_h, in_Attrib, (char *)mult_line_txt_asc[i]);
	            }
            }
            else
            {
            	for(i=0;i<row;i++)
	            {
	                sub_scrText(in_X_signed,in_Y_signed+i*font_h, in_Attrib, (char *)mult_line_txt_asc[i]);
	            }
            }
        }
        else
        {
            char *ss;
            if(sub_main == R2D_MAINLCD)
            {
	            for(i=0;i<row;i++)
	            {
	                ss=*(mult_line_txt_uni+i);
	                scrText_Unicode(in_X_signed,in_Y_signed+i*font_h, in_Attrib, ss);
	            }
            }
            else
            {
            	for(i=0;i<row;i++)
	            {
	                ss=*(mult_line_txt_uni+i);
	                sub_scrText_Unicode(in_X_signed,in_Y_signed+i*font_h, in_Attrib, ss);
	            }
            }
        }
    }
#endif
    /*
     * if an external display simulation is used and switched on with the
     * EXT_DISPLAY config primitive - send a MMI_DISPLAY_REQ primitive.
     */
    if(extDisplay)
        for(i=0;i<row;i++)
            dspl_SendDisplayReq (in_X, in_Y, (char *)mult_line_txt_asc[i]);

    return DRV_OK;
}

#else	/* R2D_SUBLCD_SUPPORT */
GLOBAL UBYTE dspl_TextOut_Cmode (USHORT  in_X,
                                 USHORT  in_Y,
                                 USHORT  len_x,
                                 UBYTE   in_Attrib,
                                 char * in_Text,
                                 UBYTE Newline)
{
    int in_X_signed;
    int in_Y_signed;
    unsigned char * p=(unsigned char *)in_Text;
    int charnum=0,row=0,i=0,j=0,n=0;
    USHORT unichar;
    int font_h=fontinfo->font_h;
    int font_w=fontinfo->font_w;
    int font_s=fontinfo->font_s;
    char mult_line_txt_asc[MAXROW][24];//maxrow X maxchar
    char mult_line_txt_uni[MAXROW][42];//char * type;you should allot 42;
	/* 2003/10/28 sunsj */
	unsigned char ascii_char;
	int total_pixel;
	int current_char_width;

    if(len_x<in_X)
        in_X=0;

	/* 2003/12/01 sunsj */
    //charnum=(len_x-in_X)/font_w;
	charnum=len_x/6;

    if(Newline)
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)//if ascii
        {
			/* 2003/10/28 sunsj some ascii code will convert a big number through type convert */
			ascii_char = *p;
            for(i=0;i<MAXROW&&(*p!=0);i++)
            {
				/* 2003/10/28 sunsj add for auto width char display */
				total_pixel = 0;
                while((*p!=NEWLINE)&&(j<charnum)&&(*p!=0))
                {
					/* 2003/10/28 sunsj add for auto width char */
					current_char_width = get_CharWidth((USHORT)ascii_char);
					total_pixel += current_char_width;
					if( total_pixel > len_x )
					{
						break;
					}

                    mult_line_txt_asc[i][j++]=(char)*p++;
					/* 2003/10/28 sunsj get the new char */
					ascii_char = *p;
                }
                row++;
                mult_line_txt_asc[i][j]=0x00;//set the end char to 0x00;
                if(*p==NEWLINE&&*(p+1)!=0x00)//if newline and next char isn't 0x00, get next char;
                    p++;
                j=0;            
            }
        }
        else/* if(in_Attrib&DSPL_TXTATTR_UNIMODE)*/
        {
            //if unicode
            unichar=(*p<<8)+*(p+1);
            for(i=0;i<MAXROW&&(unichar!=0x0000);i++)
            {
                n=0;
				/* 2003/10/28 sunsj add for auto width char display */
				total_pixel = 0;
                while((unichar!=NEWLINE)&&((n<(charnum-1))||((n==charnum-1)&&(unichar<=0xff)))&&(unichar!=0x0000))
                {
					/* 2003/10/28 sunsj add for auto width char */
					current_char_width = get_CharWidth(unichar);
					total_pixel += current_char_width;
					/* 2003/12/01 sunsj modify */
					if( total_pixel > len_x )
					{
						break;
					}

                    mult_line_txt_uni[i][j++]=(char)*p;
                    mult_line_txt_uni[i][j++]=(char)*(p+1);
                    if(unichar<=0xff)
                        n++;
					/* 2003/10/13 sunsj pinyin code display number */
					else if(unichar >= 0xf461 && unichar <= 0xf490)
						n++;
                    else
                        n+=2;
                    p+=2;
                    unichar=(USHORT)((*p<<8)+*(p+1));
                }
                row++;
                mult_line_txt_uni[i][j]=0x00;//set the end byte to 0x00,0x00;
                mult_line_txt_uni[i][j+1]=0x00;
                if(unichar==NEWLINE&&(((*(p+2)<<8)+*(p+3))!=0x0000))
                {//if newline and next byte isn't 0x0000, get next byte;
                    p+=2;
                    unichar=(USHORT)((*p<<8)+*(p+1));
                }
                j=0;        
                n=0;
            }
        }
    }
    else
    {
        row=1;
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        { // if ascii
            memcpy(mult_line_txt_asc,p,24);
            mult_line_txt_asc[0][charnum]=0;
        }
        else
        { // if unicode
            charnum=wstrlen(in_Text)-1;  //xsf add for real length of str 2003.03.10 minus 0x80
            memcpy(mult_line_txt_uni[0],&in_Text[1],charnum);
            mult_line_txt_uni[0][charnum+1]=0;
            mult_line_txt_uni[0][charnum]=0;
        }
    }
    // SH - If we want signed coordinates (i.e. if x and y can have negative numbers)
    // we need to convert the unsigned values into two's complement.

    if(in_Attrib & DSPL_TXTATTR_SIGNED_COORDS)
    {
        in_X_signed = (SHORT)in_X;
        in_Y_signed = (SHORT)in_Y;
    }
    else
    {
        in_X_signed = in_X;
        in_Y_signed = in_Y;
    }

#if defined (WIN32)
    if(scrEnabled)
    {
        scrText(in_X, in_Y, in_Attrib, in_Text); // zhangzg Eastcom 0703/2002
    }
    else
        LCD_WriteString (in_Y, in_X, (UBYTE *) in_Text);
#else
    if(displayData.DisplayType EQ DSPL_TYPE_CHARACTER)
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        {
            for(i=0;i<row;i++)
            {
                scrText(font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib,(char *)mult_line_txt_asc[i]);
            }
        }
        else if(in_Attrib&DSPL_TXTATTR_UNIMODE)
        {
            char *ss;
            for(i=0;i<row;i++)
            {
                ss=*(mult_line_txt_uni+i);
                scrText_Unicode(2*font_w * in_X_signed + 2, font_h * (in_Y_signed+i), in_Attrib, ss);
            }
        }
    }
    else
    {
        if(in_Attrib&DSPL_TXTATTR_ASCIIMODE)
        {
            for(i=0;i<row;i++)
            {
                scrText(in_X_signed,in_Y_signed+i*font_h, in_Attrib, (char *)mult_line_txt_asc[i]);
            }
        }
        else
        {
            char *ss;
            for(i=0;i<row;i++)
            {
                ss=*(mult_line_txt_uni+i);
                scrText_Unicode(in_X_signed,in_Y_signed+i*font_h, in_Attrib, ss);
            }
        }
    }
#endif
    /*
     * if an external display simulation is used and switched on with the
     * EXT_DISPLAY config primitive - send a MMI_DISPLAY_REQ primitive.
     */
    if(extDisplay)
        for(i=0;i<row;i++)
            dspl_SendDisplayReq (in_X, in_Y, (char *)mult_line_txt_asc[i]);

    return DRV_OK;
}
#endif	/* R2D_SUBLCD_SUPPORT */

void newdspl_TextOut ( int x, int y, unsigned char* bitmap, int attr);
#if R2D_SUBLCD_SUPPORT
static UBYTE dspl_TextOut_Blk_i(USHORT  in_X,
                              USHORT  in_Y,
                              USHORT  len_x,
                              UBYTE   in_Attrib,
                              char * in_Text,
                              UBYTE	  sub_main)
{
    U8    	uMode;    

    if(sub_main == R2D_MAINLCD)
    {
    	uMode = dspl_Enable(0);    	
    }
    else
    {
    	uMode = dspl_sub_Enable(0);
    }

	/* 2003/12/29 sunsj modify */
	if( in_Attrib&DSPL_TXTATTR_UNICODE )
	{
		dspl_TextOut_Cmode(in_X,in_Y,len_x,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,1, sub_main);
	}
	else if(in_Text[0] == (char)0x80)
	{
		dspl_TextOut_Cmode(in_X,in_Y,len_x,in_Attrib|DSPL_TXTATTR_UNIMODE,&in_Text[1],1, sub_main);
	}
	/*
    if(in_Attrib&DSPL_TXTATTR_UNICODE || in_Text[0] == (char)0x80)
    {
        if(in_Text[0] == (char)0x80)
        {
            dspl_TextOut_Cmode(in_X,in_Y,len_x,in_Attrib|DSPL_TXTATTR_UNIMODE,&in_Text[1],1, sub_main);
        }
        else
        {
        	dspl_TextOut_Cmode(in_X,in_Y,len_x,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,1, sub_main);
        }	
    }
	*/
    else
    {
        dspl_TextOut_Cmode(in_X,in_Y,len_x,in_Attrib|DSPL_TXTATTR_ASCIIMODE,in_Text,1, sub_main);
    }
     

    /* if not NORMAL_FONT, we always set font to NORMAL_FONT */
    if(sub_main == R2D_MAINLCD)
    {
    	dspl_Enable(uMode);
        set_font_type(NORMAL_FONT);
    }
    else
    {
    	dspl_sub_Enable(uMode);
    	set_sub_font_type(NORMAL_FONT);
    }

    return DRV_OK;
}

GLOBAL UBYTE dspl_TextOut_Blk(USHORT  in_X,
                              USHORT  in_Y,
                              USHORT  len_x,
                              UBYTE   in_Attrib,
                              char * in_Text)
{
	return dspl_TextOut_Blk_i(in_X, in_Y, len_x, in_Attrib, in_Text, R2D_MAINLCD);
}        

GLOBAL UBYTE dspl_sub_TextOut_Blk(USHORT  in_X,
                              USHORT  in_Y,
                              USHORT  len_x,
                              UBYTE   in_Attrib,
                              char * in_Text)
{
	return dspl_TextOut_Blk_i(in_X, in_Y, len_x, in_Attrib, in_Text, R2D_SUBLCD);
} 
#else
GLOBAL UBYTE dspl_TextOut_Blk(USHORT  in_X,
                              USHORT  in_Y,
                              USHORT  len_x,
                              UBYTE   in_Attrib,
                              char * in_Text)
{
    U8    uMode;
    uMode = dspl_Enable(0);//ganchh 2002/6/12

    if(in_Attrib&DSPL_TXTATTR_UNICODE || in_Text[0] == (char)0x80)
    {
        if(in_Text[0] == (char)0x80)
            dspl_TextOut_Cmode(in_X,in_Y,len_x,in_Attrib|DSPL_TXTATTR_UNIMODE,&in_Text[1],1);//don't display first byte of string,zhonghz
        else
            dspl_TextOut_Cmode(in_X,in_Y,len_x,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,1);
    }
    else
    {
        dspl_TextOut_Cmode(in_X,in_Y,len_x,in_Attrib|DSPL_TXTATTR_ASCIIMODE,in_Text,1);
    }
    dspl_Enable(uMode); //ganchh 2002/6/12

    if(get_font_type()!=NORMAL_FONT)//zhonghz, if not NORMAL_FONT, we always set font to NORMAL_FONT,2002/8/9
        set_font_type(NORMAL_FONT);

    return DRV_OK;
}
#endif

#if R2D_SUBLCD_SUPPORT
static UBYTE dspl_TextOut_NoNewline_i(USHORT  in_X,
                                    USHORT  in_Y,
                                    UBYTE   in_Attrib,
                                    char * in_Text,
                                    UBYTE   sub_main)
{
    U8    uMode;
    int   scrX_i;

    if(sub_main == R2D_MAINLCD)
    {
    	uMode  = dspl_Enable(0);
    	scrX_i = scrX;
    }
    else
    {
    	uMode  = dspl_sub_Enable(0);
    	scrX_i = sub_scrX;
    }

	/* 2003/12/29 sunsj modify */
	if( in_Attrib&DSPL_TXTATTR_UNICODE )
	{
		dspl_TextOut_Cmode(in_X,in_Y,scrX_i,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,0,sub_main);
	}
	else if(in_Text[0] == (char)0x80)
	{
		dspl_TextOut_Cmode(in_X,in_Y,scrX_i,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,0,sub_main);
	}
	/*
    if(in_Attrib&DSPL_TXTATTR_UNICODE || in_Text[0] == (char)0x80)
    {
        if(in_Text[0] == (char)0x80)
            dspl_TextOut_Cmode(in_X,in_Y,scrX_i,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,0,sub_main);
        else
            dspl_TextOut_Cmode(in_X,in_Y,scrX_i,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,0,sub_main);
    }
	*/
    else
    {
        dspl_TextOut_Cmode(in_X,in_Y,scrX_i,in_Attrib|DSPL_TXTATTR_ASCIIMODE,in_Text,0,sub_main);
    }
    
	/* if not NORMAL_FONT, we always set font to NORMAL_FONT */
    if(sub_main == R2D_MAINLCD)
    {
    	dspl_Enable(uMode);
        set_font_type(NORMAL_FONT);
    }
    else
    {
    	dspl_sub_Enable(uMode);
    	set_sub_font_type(NORMAL_FONT);
    }

    return DRV_OK;
}

GLOBAL UBYTE dspl_TextOut_NoNewline(USHORT  in_X,
                                    USHORT  in_Y,
                                    UBYTE   in_Attrib,
                                    char * in_Text)
{
	return dspl_TextOut_NoNewline_i(in_X, in_Y, in_Attrib, in_Text, R2D_MAINLCD);
}

GLOBAL UBYTE dspl_sub_TextOut_NoNewline(USHORT  in_X,
                                    USHORT  in_Y,
                                    UBYTE   in_Attrib,
                                    char * in_Text)
{
	return dspl_TextOut_NoNewline_i(in_X, in_Y, in_Attrib, in_Text, R2D_SUBLCD);
}
#else
GLOBAL UBYTE dspl_TextOut_NoNewline(USHORT  in_X,
                                    USHORT  in_Y,
                                    UBYTE   in_Attrib,
                                    char * in_Text)
{
    U8    uMode;
    uMode = dspl_Enable(0);//ganchh 2002/6/12

    if(in_Attrib&DSPL_TXTATTR_UNICODE || in_Text[0] == (char)0x80)
    {
        if(in_Text[0] == (char)0x80)
            dspl_TextOut_Cmode(in_X,in_Y,scrX,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,0);
        else
            dspl_TextOut_Cmode(in_X,in_Y,scrX,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,0);
    }
    else
    {
        dspl_TextOut_Cmode(in_X,in_Y,scrX,in_Attrib|DSPL_TXTATTR_ASCIIMODE,in_Text,0);
    }
    dspl_Enable(uMode); 

    if(get_font_type()!=NORMAL_FONT)
        set_font_type(NORMAL_FONT);

    return DRV_OK;
}
#endif

#if R2D_SUBLCD_SUPPORT
static UBYTE dspl_TextOut_i(USHORT  in_X,
                          USHORT  in_Y,
                          UBYTE   in_Attrib,
                          char * in_Text,
                          UBYTE   sub_main)
{
    U8    uMode;
    int   scrX_i;

    if(sub_main == R2D_MAINLCD)
    {
    	uMode  = dspl_Enable(0);
    	scrX_i = scrX;
    }
    else
    {
    	uMode  = dspl_sub_Enable(0);
    	scrX_i = sub_scrX;
    }

	/* 2003/10/28 sunsj if attrib is DSPL_TXTATTR_UNICODE so don't increase the buffer point */
	if(in_Attrib&DSPL_TXTATTR_UNICODE)
    {
		dspl_TextOut_Cmode(in_X,in_Y,scrX_i,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,1, sub_main);
    }
	else if (in_Text[0] == (char)0x80)
    {
		dspl_TextOut_Cmode(in_X,in_Y,scrX_i,in_Attrib|DSPL_TXTATTR_UNIMODE,&in_Text[1],1, sub_main);//don't display first byte of string,zhonghz
    }
	/*
    if((in_Attrib&DSPL_TXTATTR_UNICODE) || (in_Text[0] == (char)0x80))
    {
        if(in_Text[0] == (char)0x80)
            dspl_TextOut_Cmode(in_X,in_Y,scrX_i,in_Attrib|DSPL_TXTATTR_UNIMODE,&in_Text[1],1);//don't display first byte of string,zhonghz
        else
            dspl_TextOut_Cmode(in_X,in_Y,scrX_i,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,1);
    }
	*/
    else
    {
        dspl_TextOut_Cmode(in_X,in_Y,scrX_i,in_Attrib|DSPL_TXTATTR_ASCIIMODE,in_Text,1, sub_main);
    }
    
	if(sub_main == R2D_MAINLCD)
	{
		dspl_Enable(uMode);
		set_font_type(NORMAL_FONT);
	}
	else
	{
		dspl_sub_Enable(uMode);
		set_sub_font_type(NORMAL_FONT);
	}
    return DRV_OK;
}

GLOBAL UBYTE dspl_TextOut(USHORT  in_X,
                          USHORT  in_Y,
                          UBYTE   in_Attrib,
                          char * in_Text)
{
	dspl_TextOut_i(in_X, in_Y, in_Attrib, in_Text, R2D_MAINLCD);
}

GLOBAL UBYTE dspl_sub_TextOut(USHORT  in_X,
                          USHORT  in_Y,
                          UBYTE   in_Attrib,
                          char * in_Text)
{
	dspl_TextOut_i(in_X, in_Y, in_Attrib, in_Text, R2D_SUBLCD);
}

#else
GLOBAL UBYTE dspl_TextOut(USHORT  in_X,
                          USHORT  in_Y,
                          UBYTE   in_Attrib,
                          char * in_Text)
{
    U8    uMode;
    uMode = dspl_Enable(0);//ganchh 2002/6/12

	/* 2003/10/28 sunsj if attrib is DSPL_TXTATTR_UNICODE so don't increase the buffer point */
	if(in_Attrib&DSPL_TXTATTR_UNICODE)
    {
		dspl_TextOut_Cmode(in_X,in_Y,scrX,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,1);
    }
	else if (in_Text[0] == (char)0x80)
    {
		dspl_TextOut_Cmode(in_X,in_Y,scrX,in_Attrib|DSPL_TXTATTR_UNIMODE,&in_Text[1],1);//don't display first byte of string,zhonghz
    }
	/*
    if((in_Attrib&DSPL_TXTATTR_UNICODE) || (in_Text[0] == (char)0x80))
    {
        if(in_Text[0] == (char)0x80)
            dspl_TextOut_Cmode(in_X,in_Y,scrX,in_Attrib|DSPL_TXTATTR_UNIMODE,&in_Text[1],1);//don't display first byte of string,zhonghz
        else
            dspl_TextOut_Cmode(in_X,in_Y,scrX,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,1);
    }
	*/
    else
    {
        dspl_TextOut_Cmode(in_X,in_Y,scrX,in_Attrib|DSPL_TXTATTR_ASCIIMODE,in_Text,1);
    }
    dspl_Enable(uMode); //ganchh 2002/6/12

    if(get_font_type()!=NORMAL_FONT)//zhonghz, if not NORMAL_FONT, we always set font to NORMAL_FONT,2002/8/9
        set_font_type(NORMAL_FONT);

    return DRV_OK;
}
#endif

/*2003/11/25, wangyan add for multi-line text show in center mode*/
GLOBAL UBYTE dspl_TextOut_Center(USHORT  in_Y,
                              USHORT  len_x,
                              UBYTE   in_Attrib,
                              char * in_Text)
{
    U8    uMode;
    uMode = dspl_Enable(0);//ganchh 2002/6/12

	/* 2003/10/28 sunsj if attrib is DSPL_TXTATTR_UNICODE so don't increase the buffer point */
	if(in_Attrib&DSPL_TXTATTR_UNICODE)
    {
		dspl_TextOut_Cmode_Center(in_Y, len_x, in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,1);
    }
	else if (in_Text[0] == (char)0x80)
    {
		dspl_TextOut_Cmode_Center(in_Y, len_x, in_Attrib|DSPL_TXTATTR_UNIMODE,&in_Text[1],1);//don't display first byte of string,zhonghz
    }
	/*
    if((in_Attrib&DSPL_TXTATTR_UNICODE) || (in_Text[0] == (char)0x80))
    {
        if(in_Text[0] == (char)0x80)
            dspl_TextOut_Cmode(in_X,in_Y,scrX,in_Attrib|DSPL_TXTATTR_UNIMODE,&in_Text[1],1);//don't display first byte of string,zhonghz
        else
            dspl_TextOut_Cmode(in_X,in_Y,scrX,in_Attrib|DSPL_TXTATTR_UNIMODE,in_Text,1);
    }
	*/
    else
    {
        dspl_TextOut_Cmode_Center(in_Y, len_x, in_Attrib|DSPL_TXTATTR_ASCIIMODE,in_Text,1);
    }
    dspl_Enable(uMode); //ganchh 2002/6/12

    if(get_font_type()!=NORMAL_FONT)//zhonghz, if not NORMAL_FONT, we always set font to NORMAL_FONT,2002/8/9
        set_font_type(NORMAL_FONT);

    return DRV_OK;
}

/**************zy add this fuciton could display specfic color text***************/
/**zhonghz modify this fuction, delete some useless code,2002/8/9**/
GLOBAL UBYTE dspl_colorTextOut_Blk(USHORT  in_X,
                                   USHORT  in_Y,
                                   USHORT  len_x,
                                   UBYTE   in_Attrib,
                                   char * in_Text,UINT32 TxtColor)
{
    int oldcolor;
    oldcolor=dspl_SetFrgColor(TxtColor);
    dspl_TextOut_Blk(in_X, in_Y, len_x,in_Attrib, in_Text);
    dspl_SetFrgColor(oldcolor); 

    return DRV_OK;
}


/**************zy add this fuciton could display specfic color text***************/
/**zhonghz modify this fuction, delete some useless code,2002/8/9**/
GLOBAL UBYTE dspl_colorTextOut(USHORT  in_X,
                               USHORT  in_Y,
                               UBYTE   in_Attrib,
                               char * in_Text,UINT32 menuTxtColor)
{
    int oldcolor;
    oldcolor=dspl_GetFrgColor();//zym set the color of text to red,6.13
    dspl_SetFrgColor(menuTxtColor);
    dspl_TextOut(in_X, in_Y, in_Attrib, in_Text);
    dspl_SetFrgColor(oldcolor);//zym,reset the frg color 

    return DRV_OK;
}

#if R2D_SUBLCD_SUPPORT
GLOBAL UBYTE dspl_sub_colorTextOut(USHORT  in_X,
                               USHORT  in_Y,
                               UBYTE   in_Attrib,
                               char * in_Text,UINT32 menuTxtColor)
{
    int oldcolor;
    oldcolor=dspl_sub_GetFrgColor();//zym set the color of text to red,6.13
    dspl_sub_SetFrgColor(menuTxtColor);
    dspl_sub_TextOut(in_X, in_Y, in_Attrib, in_Text);
    dspl_sub_SetFrgColor(oldcolor);//zym,reset the frg color 

    return DRV_OK;
}

#endif
/**************************end of zy change******************************/

/**/
#ifdef CHINESE_MMI
#if R2D_SUBLCD_SUPPORT
t_font_bitmap* getChineseBitmap(USHORT selected_code, UBYTE sub_main)
{
    int begin,end,cur;
    unsigned long n,i;
    static t_font_bitmap chn_bmp;    
	int font_w;
    int font_h;
    int font_s;
    int font_e;
    UBYTE	 ftype; /* font type */
    FONTINFO *finfo;
    USHORT	selcode_tmp;

    if(sub_main == R2D_MAINLCD)
    {
    	finfo = fontinfo;
    	ftype = dspl_font_type;
    }
    else
    {
    	finfo = sub_fontinfo;
    	ftype = dspl_sub_font_type;
    }

	font_w = finfo->font_w;
	font_h = finfo->font_h;
    font_s = finfo->font_s;
    font_e = finfo->font_e;

    chn_bmp.code	= selected_code;

    chn_bmp.height	= font_h;
    chn_bmp.format	= 1;

	if(bitmap_num != 0)
	{
		free(chn_bmp.bitmap);//free place before allocation, if free place after alloc,will lost some data
	}

	bitmap_num++;
    chn_bmp.bitmap = (char *)malloc(2 * font_s + 1);

    if(ftype == UNI12X12_FONT)
    {
		//if 12x12 font, should search bitmap in font-lib table
        if(selected_code <= 0x7f)
        {
            chn_bmp.width		= font_w;
            chn_bmp.bitmap_size	= font_s;
            
            n = font_s * selected_code;
            for(i = 0; i < font_s; i++)
                chn_bmp.bitmap[i] = finfo->uni0_256[n+i];
        }
        else if(selected_code >= UNI12X12FIRSTCODE && selected_code <= UNI12X12ENDCODE)
        {
            begin = 0;
            end   = font_e;
            cur   = (end + begin)/2;
            
            while(begin+1 < end)
            {
                if(finfo->uni_12x12[cur].code == selected_code)
                {
                    memcpy(chn_bmp.bitmap, finfo->uni_12x12[cur].bmp, 2 * font_s);
                    break;
                }
                else if(finfo->uni_12x12[cur].code < selected_code)
                {
                    begin = cur;
                }
                else if(finfo->uni_12x12[cur].code > selected_code)
                {
                    end = cur;
                }
                
                cur = (end + begin)/2;
            }
            
            chn_bmp.width		= 2 * font_w;
            chn_bmp.bitmap_size	= 2 * font_s;
            
            if(finfo->uni_12x12[begin].code == selected_code)
            {
                memcpy(chn_bmp.bitmap, finfo->uni_12x12[begin].bmp, 2 * font_s);
            }
            else if(finfo->uni_12x12[end].code == selected_code)
            {
                memcpy(chn_bmp.bitmap, finfo->uni_12x12[end].bmp, 2 * font_s);
            }
            else if(finfo->uni_12x12[cur].code != selected_code)
            {
            	/* if not fond, set bitmap to 0 */
                memset(chn_bmp.bitmap, '\0', 2 * font_s);
            }
        }
        else
        {
        	/* if out of range, set bitmap to 0 */
            memset(chn_bmp.bitmap, '\0', 2 * font_s);
        }
    }
    else
    {
		//if not 12x12 font
        if(selected_code <= 0xff)
        {
            if(ftype == CHNINPUT_FONT)
            {
                chn_bmp.width		= 8;
                chn_bmp.height		= 12;
                chn_bmp.bitmap_size	= 12;
                font_s				= 12;
            }
            else
            {
				/* 2003/10/13 sunsj modify ascii char display in unicode char */
                //chn_bmp.width=font_w;
                
                chn_bmp.bitmap_size = font_s;          
				
				/* get the ascii char width */
				#if 0
				if(selected_code <= 0x5a && selected_code >= 0x41)
				{
					/* 2003/12/01 sunsj */
					//chn_bmp.width = finfo->charwidth[selected_code - 0x41]+1;
					chn_bmp.width = get_CharWidth(selected_code);
				}
				else if(selected_code <= 0x7a && selected_code >= 0x61)
				{
					/* 2003/12/01 sunsj */
					//chn_bmp.width = finfo->charwidth[selected_code - 0x41]+1;
					chn_bmp.width = get_CharWidth(selected_code);
				}
				else
				{
					chn_bmp.width = finfo->font_w;
				}
				#endif
				
				if((selected_code < 0x41) || (selected_code > 0x7a) || 
				   (selected_code > 0x5a && selected_code < 0x61))
				{
					chn_bmp.width = finfo->font_w;
				}
				else
				{
					if(sub_main == R2D_MAINLCD)
						chn_bmp.width = get_CharWidth(selected_code);
					else
						chn_bmp.width = sub_get_CharWidth(selected_code);
				}
			}
			
            n = font_s * selected_code;
            
            for(i = 0; i < font_s; i++)
            {
                chn_bmp.bitmap[i]=finfo->uni0_256[n+i];
            }    
        }
        else if(selected_code >= UNI_CJK_FIRST_CHAR && selected_code <= UNI_CJK_LAST_CHAR)
        {
	    /* 2004/05/11 sunsj modify */
#if( MAIN_LCD_SIZE == 4 )		
            chn_bmp.width		= 2 * font_w;
#elif(  MAIN_LCD_SIZE == 3 )		
			chn_bmp.width		= 2 * font_w ;
#elif(  MAIN_LCD_SIZE == 2 )		
			chn_bmp.width		= 2 * font_w + 1;
#endif
			chn_bmp.bitmap_size	= 2 * font_s;
            //chn_bmp.bitmap=(char *)malloc(2*font_s+1);
			n = 2 * font_s * (selected_code - UNI_CJK_FIRST_CHAR);
			
            for(i = 0; i < 2 * font_s; i++)
                chn_bmp.bitmap[i] = finfo->uni_cjk[n+i];
        }
		/* 2003/10/13 sunsj add for pinyin display */
		else if(selected_code>=0xf461 && selected_code<=0xf47B)
		{
			selcode_tmp = selected_code - 0xf400;

		#if 0
			if((selected_code - 0xf400) <= 0x5a && (selected_code - 0xf400) >= 0x41)
			{
				/* 2003/12/01 sunsj */
				//chn_bmp.width = finfo->charwidth[(selected_code - 0xf400) - 0x41]+1;
				if(sub_main == R2D_MAINLCD)
					chn_bmp.width = get_CharWidth(selected_code);
				else
					chn_bmp.width = sub_get_CharWidth(selected_code);
			}
			else if((selected_code - 0xf400) <= 0x7a && (selected_code - 0xf400) >= 0x61)
			{
				/* 2003/12/01 sunsj */
				//chn_bmp.width = finfo->charwidth[(selected_code - 0xf400) - 0x41]+1;
				chn_bmp.width = get_CharWidth(selected_code);
			}
			else
			{
				chn_bmp.width = finfo->font_w;
			}
		#else
			if((selcode_tmp < 0x41) || (selcode_tmp > 0x7a) || 
			   (selcode_tmp > 0x5a && selcode_tmp < 0x61))
			{
				chn_bmp.width = finfo->font_w;
			}
			else
			{
				if(sub_main == R2D_MAINLCD)
					chn_bmp.width = get_CharWidth(selected_code);
				else
					chn_bmp.width = sub_get_CharWidth(selected_code);
			}
		#endif
			
			//chn_bmp.width=2*font_w;
            chn_bmp.bitmap_size = 2*8;

            //n=2*font_s*(selected_code - 0xf461 + UNI_CJK_LAST_CHAR - UNI_CJK_FIRST_CHAR + 1);
            //for(i=0; i < 2*font_s; i++)
            //    chn_bmp.bitmap[i]=finfo->uni_cjk[n+i];
            
			n= font_s * selcode_tmp;
			
            for(i = 0; i < font_s; i++)
                chn_bmp.bitmap[i] = finfo->uni0_256[n+i];
		}
		/* 2003/12/22 sunsj add for zhuyin element display */
		else if( selected_code >= 0xf000 && selected_code <= 0xf429 )
		{
			chn_bmp.width = 2 * font_w;
			chn_bmp.bitmap_size = 2 * font_s;
			n = 2 * font_s * (ElementMapIndex[(selected_code-0xf000)]-1);
			for(i=0; i<2*font_s; i++)
				chn_bmp.bitmap[i] = finfo->elementmap[n+i];
		}
        else if((selected_code>=0xa4&&selected_code<=0x451)||
                (selected_code>=0x2015&&selected_code<=0x2642)||
                (selected_code>=0x3001&&selected_code<=0x3229)||
                (selected_code>=0xff01&&selected_code<=0xffe5))
        {
            begin = 0;
            end = font_e;
            cur = (end + begin)/2;
            //chn_bmp.bitmap=(char *)malloc(2*font_s+1);
            while(begin+1 < end)
            {
                if(finfo->uni_sym[cur].code == selected_code)
                {
                    memcpy(chn_bmp.bitmap,finfo->uni_sym[cur].bmp,2*font_s);
                    break;
                }
                else if(finfo->uni_sym[cur].code < selected_code)
                {
                    begin = cur;
                }
                else if(finfo->uni_sym[cur].code > selected_code)
                {
                    end = cur;
                }
                cur = (end + begin)/2;
            }
            chn_bmp.width=2*font_w;
            chn_bmp.bitmap_size=2*font_s;
            if(finfo->uni_sym[begin].code == selected_code)
            {
                memcpy(chn_bmp.bitmap,finfo->uni_sym[begin].bmp,2*font_s);
            }
            else if(finfo->uni_sym[end].code == selected_code)
            {
                memcpy(chn_bmp.bitmap,finfo->uni_sym[end].bmp,2*font_s);
            }
            else if(finfo->uni_sym[cur].code != selected_code)
            {
                memset(chn_bmp.bitmap,'\0',2*font_s);
            }
        }
        else
        {//zhonghz,return NULL;
            chn_bmp.width=font_w;
            chn_bmp.bitmap_size=font_s;
            //chn_bmp.bitmap=(char *)malloc(font_s+2);
            memset(chn_bmp.bitmap,'\0',font_s);
        }
    }
    return(&chn_bmp);
}

#else
t_font_bitmap* getChineseBitmap(USHORT selected_code)
{
    int begin,end,cur;
    unsigned long n,i;
    static t_font_bitmap chn_bmp;
	int font_w=fontinfo->font_w;
    int font_h=fontinfo->font_h;
    int font_s=fontinfo->font_s;
    int font_e=fontinfo->font_e;
    //if(bitmap_num!=0)
	//{
	//	bitmap_num++;
	//}
    chn_bmp.code = selected_code;
    chn_bmp.height=font_h;
    chn_bmp.format=1;
	if(bitmap_num!=0)
	{
		free(chn_bmp.bitmap);//free place before allot, if free place after allot,will lost some data,zhonghz,200/8/9
	}
	bitmap_num++;

    chn_bmp.bitmap=(char *)malloc(2*font_s+1);
    if(get_font_type()==UNI12X12_FONT)
    {//if 12x12 font,we should search bitmap in font-lib table,zhonghz,2002/9/8
        if(selected_code<=0x7f)
        {
            chn_bmp.width=font_w;
            chn_bmp.bitmap_size=font_s;
            //chn_bmp.bitmap=(char *)malloc(font_s+1);
            n=font_s*selected_code;
            for(i=0;i<font_s;i++)
                chn_bmp.bitmap[i]=fontinfo->uni0_256[n+i];
        }
        else if(selected_code>=UNI12X12FIRSTCODE&&selected_code<=UNI12X12ENDCODE)
        {
            begin = 0;
            end = font_e;
            cur = (end + begin)/2;
            //chn_bmp.bitmap=(char *)malloc(2*font_s+1);
            while(begin+1 < end)
            {
                if(fontinfo->uni_12x12[cur].code == selected_code)
                {
                    memcpy(chn_bmp.bitmap,fontinfo->uni_12x12[cur].bmp,2*font_s);
                    break;
                }
                else if(fontinfo->uni_12x12[cur].code < selected_code)
                {
                    begin = cur;
                }
                else if(fontinfo->uni_12x12[cur].code > selected_code)
                {
                    end = cur;
                }
                cur = (end + begin)/2;
            }
            chn_bmp.width=2*font_w;
            chn_bmp.bitmap_size=2*font_s;
            if(fontinfo->uni_12x12[begin].code == selected_code)
            {
                memcpy(chn_bmp.bitmap,fontinfo->uni_12x12[begin].bmp,2*font_s);
            }
            else if(fontinfo->uni_12x12[end].code == selected_code)
            {
                memcpy(chn_bmp.bitmap,fontinfo->uni_12x12[end].bmp,2*font_s);
            }
            else if(fontinfo->uni_12x12[cur].code != selected_code)
            {//if not fond, set bitmap to 0
                memset(chn_bmp.bitmap,'\0',2*font_s);
            }
        }
        else
        {//if out of range, set bitmap to 0
            memset(chn_bmp.bitmap,'\0',2*font_s);
        }
    }
    else
    {
		//if not 12x12 font
        if(selected_code<=0xff)
        {//0x80,zhonghz
            if(get_font_type()==CHNINPUT_FONT)
            {
                chn_bmp.width=8;
                chn_bmp.height=12;
                chn_bmp.bitmap_size=12;
                font_s=12;
            }
            else
            {
				/* 2003/10/13 sunsj modify ascii char display in unicode char */
                //chn_bmp.width=font_w;
                chn_bmp.bitmap_size=font_s;
				
				/* get the ascii char width */
				if(selected_code <= 0x5a && selected_code >= 0x41)
				{
					/* 2003/12/01 sunsj */
					//chn_bmp.width = fontinfo->charwidth[selected_code - 0x41]+1;
					chn_bmp.width = get_CharWidth(selected_code);
				}
				else if(selected_code <= 0x7a && selected_code >= 0x61)
				{
					/* 2003/12/01 sunsj */
					//chn_bmp.width = fontinfo->charwidth[selected_code - 0x41]+1;
					chn_bmp.width = get_CharWidth(selected_code);
				}
				else
				{
					chn_bmp.width = fontinfo->font_w;
				}
			}
            n=font_s*selected_code;
            for(i=0;i<font_s;i++)
                chn_bmp.bitmap[i]=fontinfo->uni0_256[n+i];
        }
        else if(selected_code>=UNI_CJK_FIRST_CHAR&& selected_code<=UNI_CJK_LAST_CHAR)
        {
            chn_bmp.width=2*font_w;
            chn_bmp.bitmap_size=2*font_s;
            //chn_bmp.bitmap=(char *)malloc(2*font_s+1);
			n=2*font_s*(selected_code-UNI_CJK_FIRST_CHAR);
            for(i=0;i<2*font_s;i++)
                chn_bmp.bitmap[i]=fontinfo->uni_cjk[n+i];
        }
		/* 2003/10/13 sunsj add for pinyin display */
		else if(selected_code>=0xf461&&selected_code<=0xf47B)
		{
			if((selected_code - 0xf400) <= 0x5a && (selected_code - 0xf400) >= 0x41)
			{
				/* 2003/12/01 sunsj */
				//chn_bmp.width = fontinfo->charwidth[(selected_code - 0xf400) - 0x41]+1;
				chn_bmp.width = get_CharWidth(selected_code);
			}
			else if((selected_code - 0xf400) <= 0x7a && (selected_code - 0xf400) >= 0x61)
			{
				/* 2003/12/01 sunsj */
				//chn_bmp.width = fontinfo->charwidth[(selected_code - 0xf400) - 0x41]+1;
				chn_bmp.width = get_CharWidth(selected_code);
			}
			else
			{
				chn_bmp.width = fontinfo->font_w;
			}
			//chn_bmp.width=2*font_w;
            chn_bmp.bitmap_size=2*8;

            //n=2*font_s*(selected_code - 0xf461 + UNI_CJK_LAST_CHAR - UNI_CJK_FIRST_CHAR + 1);
            //for(i=0; i < 2*font_s; i++)
            //    chn_bmp.bitmap[i]=fontinfo->uni_cjk[n+i];
            
			n=font_s*(selected_code - 0xf400);
            for(i=0;i<font_s;i++)
                chn_bmp.bitmap[i]=fontinfo->uni0_256[n+i];
		}
		/* 2003/10/26 sunsj add for stroke element display */
		else if( selected_code >= 0xf000 && selected_code <= 0xf400 )
		{
			chn_bmp.width = 2 * font_w;
			chn_bmp.bitmap_size = 2 * font_s;
			n = 2 * font_s * (ElementMapIndex[(selected_code-0xf000)]-1);
			for(i=0; i<2*font_s; i++)
				chn_bmp.bitmap[i] = fontinfo->elementmap[n+i];
		}
        else if((selected_code>=0xa4&&selected_code<=0x451)||
                (selected_code>=0x2015&&selected_code<=0x2642)||
                (selected_code>=0x3001&&selected_code<=0x3229)||
                (selected_code>=0xff01&&selected_code<=0xffe5))
        {
            begin = 0;
            end = font_e;
            cur = (end + begin)/2;
            //chn_bmp.bitmap=(char *)malloc(2*font_s+1);
            while(begin+1 < end)
            {
                if(fontinfo->uni_sym[cur].code == selected_code)
                {
                    memcpy(chn_bmp.bitmap,fontinfo->uni_sym[cur].bmp,2*font_s);
                    break;
                }
                else if(fontinfo->uni_sym[cur].code < selected_code)
                {
                    begin = cur;
                }
                else if(fontinfo->uni_sym[cur].code > selected_code)
                {
                    end = cur;
                }
                cur = (end + begin)/2;
            }
            chn_bmp.width=2*font_w;
            chn_bmp.bitmap_size=2*font_s;
            if(fontinfo->uni_sym[begin].code == selected_code)
            {
                memcpy(chn_bmp.bitmap,fontinfo->uni_sym[begin].bmp,2*font_s);
            }
            else if(fontinfo->uni_sym[end].code == selected_code)
            {
                memcpy(chn_bmp.bitmap,fontinfo->uni_sym[end].bmp,2*font_s);
            }
            else if(fontinfo->uni_sym[cur].code != selected_code)
            {
                memset(chn_bmp.bitmap,'\0',2*font_s);
            }
        }
        else
        {//zhonghz,return NULL;
            chn_bmp.width=font_w;
            chn_bmp.bitmap_size=font_s;
            //chn_bmp.bitmap=(char *)malloc(font_s+2);
            memset(chn_bmp.bitmap,'\0',font_s);
        }
    }
    return(&chn_bmp);
}
#endif	/* R2D_SUBLCD_SUPPORT */
#endif	/* CHINESE_MMI */

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_SetWorkShadow         |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to define the address of the
            shadow RAM for drawing operations.

*/

GLOBAL UBYTE dspl_SetWorkShadow (UBYTE * in_ShadowPtr)
{
    return DSPL_FCT_NOTSUPPORTED;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6103)       MODULE  : DRV_DSPL                   |
| STATE   : code                ROUTINE : dspl_SetDisplayShadow      |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to define the address of the
            shadow RAM for displaying operations.

*/

GLOBAL UBYTE dspl_SetDisplayShadow (UBYTE * in_ShadowPtr)
{
    return DSPL_FCT_NOTSUPPORTED;
}


/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6147)         MODULE  : SMI_WM                   |
| STATE   : code                  ROUTINE : dspl_SendDisplayReq      |
+--------------------------------------------------------------------+

  PURPOSE : sends an MMI_DISPLAY_REQ primitive to write
            the text at position X,Y to PL. If the parameter
            text is NULL only the cursor position
            should change. If in this case the X and Y value
            is 0xffff the cursor will be hide.

*/
#ifndef _INNOVATION_EMULATOR_
LOCAL void dspl_SendDisplayReq (USHORT x, USHORT y, char *text)
{
#ifdef NEW_FRAME
    OS_QDATA QData;
    USHORT TaskHandle, TSTHandle;
#endif
    USHORT sdu_len = (text NEQ NULL) ? strlen (text) : 0;
    PALLOC_SDU (mmi_display_req, MMI_DISPLAY_REQ, sdu_len<<3);
    {
        mmi_display_req->c_x = x;
        mmi_display_req->c_y = y;

        if(text NEQ NULL)
        {
            /*
             * text output
             */
            mmi_display_req->attrib.content = CON_TEXT;
            mmi_display_req->attrib.control = CTL_NORMAL;
            mmi_display_req->sdu.o_buf = 0;
            mmi_display_req->sdu.l_buf = (sdu_len<<3);
            memcpy (mmi_display_req->sdu.buf, text, sdu_len);
        }
        else
        {
            /*
             * change the cursor position
             */
            mmi_display_req->attrib.content = CON_CURSOR;
            mmi_display_req->attrib.control = ((x EQ 0xffff) ? CTL_HIDDEN : CTL_NORMAL);
            mmi_display_req->sdu.o_buf = 0;
            mmi_display_req->sdu.l_buf = 0;
        }

#if defined NEW_FRAME
        TaskHandle = vsi_gettaskhandle ( 0, "CST" );
        if((TSTHandle = vsi_gettaskhandle ( TaskHandle, "TST" )) != VSI_ERROR)
        {
            QData.len = sdu_len  + sizeof(T_MMI_DISPLAY_REQ);
            QData.data16 = MSG_PRIMITIVE;
            QData.ptr = (unsigned long*)D2P(mmi_display_req);
            rt_ExtPrimitive ( TaskHandle, TSTHandle, TSTHandle, "PAN", &QData );
        }
#else
        ext_primitive (D2P(mmi_display_req), "CST", "PAN",
                       sizeof (T_PRIM_HEADER) +
                       sizeof (T_MMI_DISPLAY_REQ) +
                       sdu_len);
#endif
        PFREE (mmi_display_req);
    }
}
#else
LOCAL void dspl_SendDisplayReq (USHORT x, USHORT y, char *text)
{
}
#endif

/*******************************************************************
 *                                                                 *
 * PART II: Workaround for Graphical Displays                      *
 *                                                                 *
 *******************************************************************/
#if 0
#if (!CUST)//JVJE #if (CUST==1)
    #if ((ModeType ==1) ||(ModeType ==2) ||(ModeType ==3))
        #define LCD_COL 128                      /* display size             *///ljq change it from 120 to 128 2003/4/10 
        #define LCD_COL_B ((LCD_COL+7)/8)       /* row size in byte         */
        #define LCD_ROW 160
    #else
      #ifdef _feature_mainLCD_w102_h80
 	  	#define LCD_COL 102                      /* display size             */
        #define LCD_COL_B ((LCD_COL+7)/8)       /* row size in byte         */
        #define LCD_ROW 80
      #endif      
      
      #ifdef _feature_mainLCD_w128_h160
        #define LCD_COL 128                      /* display size             *///ljq change it from 120 to 128 2003/4/10 
        #define LCD_COL_B ((LCD_COL+7)/8)       /* row size in byte         */
        #define LCD_ROW 160
      #endif
    #endif
    #define DISPL_DIV 4
static int mobEnabled = 1;              /* mobile simulation enabled      */
#else
    #if ((ModeType ==1) ||(ModeType ==2) ||(ModeType ==3))
        #define LCD_COL 128                     /* display size             *///ljq change it from 120 to 128 2003/4/10 
        #define LCD_COL_B ((LCD_COL+7)/8)       /* row size in byte         */
        #define LCD_ROW 160
    #else
        #define LCD_COL 120                     /* display size             *///ljq change it from 120 to 128 2003/4/10 
        #define LCD_COL_B ((LCD_COL+7)/8)       /* row size in byte         */
        #define LCD_ROW 160
    #endif
    #define DISPL_DIV 4
static int mobEnabled = 1;              /* mobile simulation disabled      */
#endif
#endif

#if (MAIN_LCD_SIZE==4)
        #define LCD_COL 128                      /* display size             *///ljq change it from 120 to 128 2003/4/10 
        #define LCD_COL_B ((LCD_COL+7)/8)       /* row size in byte         */
        #define LCD_ROW 160
#elif( MAIN_LCD_SIZE == 3 )
 	  	#define LCD_COL 128                      /* display size             */
        #define LCD_COL_B ((LCD_COL+7)/8)       /* row size in byte         */
        #define LCD_ROW 128
#elif( MAIN_LCD_SIZE == 2 )      
        #define LCD_COL 102                      /* display size             *///ljq change it from 120 to 128 2003/4/10 
        #define LCD_COL_B ((LCD_COL+7)/8)       /* row size in byte         */
        #define LCD_ROW 80
#endif
#define DISPL_DIV 4
static int mobEnabled = 1;              /* mobile simulation enabled      */


extern int mfwExtOut (char *cmd);       /* forward to ext. display  */
UBYTE lcd_output_ready  = TRUE;
UBYTE lcd_output_needed = FALSE;

#define scrHlen 18
static const char *scrHeader = "CONFIG MFWMOB SCR ";

#if defined (WIN32)
static int mtkEnabled = 0;              /* MMI Toolkit */
#endif


static int internal = 0;                /* internal use only */
//static char scratch [LCD_ROW*LCD_COL_B*2+100];      /* command buffer */
//static UBYTE display [LCD_ROW][LCD_COL_B];   /* display buffer */
static int xIndex;                      /* data transfer index */

static void scrPoint (int px, int py, int col);






/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrMobUpdate       |
+--------------------------------------------------------------------+

  PURPOSE : Shadow display to mobile simulation

*/

void scrMobUpdate (void)
{
//Glowing,2004-07-27, disable the code for the WIN32
//#if defined (WIN32)
#if 0
    USHORT x,y;
    USHORT i;
    USHORT z;

    if(mtkEnabled)
    {
        USHORT   sdu_len;

        switch(mtkEnabled)
        {
            case 1: // ASAMPLE
                z= LCD_ROW;
                sdu_len = (USHORT)(13 * z); // (100 * z Pixels);
                {
                    PALLOC_SDU (mmi_display_req, MMI_DISPLAY_REQ, sdu_len<<3);
                    {
                        mmi_display_req->c_x = LCD_COL;
                        mmi_display_req->c_y = z;
                        i=0;
                        for(y=0;y<z;y++)
                            for(x=0; x < 13; x++)
                                mmi_display_req->sdu.buf[i++] = display[y][x];
                    }

                    TRACE_EVENT ("Send Display Content");
#if defined NEW_FRAME
                    {
                        {
                            T_QMSG Message;

                            Message.MsgType = MSG_PRIMITIVE;
                            Message.Msg.Primitive.Prim = D2P(mmi_display_req);
                            Message.Msg.Primitive.PrimLen = sizeof (T_MMI_DISPLAY_REQ) + LCD_COL_B*z;
#ifdef MEMORY_SUPERVISION
                            vsi_c_send (VSI_CALLER hCommL1 ,&Message, __FILE__, __LINE__);
#else
                            vsi_c_send (VSI_CALLER hCommL1 ,&Message);
#endif
                        }
                    }
#else
//        vsi_c_send (VSI_CALLER hCommL1, D2P(mmi_display_req), sizeof (T_MMI_DISPLAY_REQ) + LCD_COL_B*z);
#endif
                }
                break;

            case 2: // another target with other dimensions
                {
                    char buf[40];
                    sprintf (buf, "LCD NEEDED %d READY %d", lcd_output_needed, lcd_output_ready);
                    TRACE_EVENT (buf);
                }
                lcd_output_needed = TRUE;
                if(lcd_output_ready)
                {
                    lcd_output_needed = FALSE;
                    lcd_output_ready = FALSE;

                    sdu_len = 14 * 16 + 20;
#if (LCD_ROW >= 64)
                    {
                        PALLOC_SDU (mmi_display_req, MMI_DISPLAY_REQ, sdu_len<<3);

                        mmi_display_req->c_x = LCD_COL;
                        mmi_display_req->c_y = 16;
                        mmi_display_req->attrib.content = 3;
                        i=0;
                        for(y=48;y<64;y++)
                            for(x=0; x < 13; x++)
                                mmi_display_req->sdu.buf[i++] = display[y][x];
#if defined NEW_FRAME
                        {
                            T_QMSG Message;

                            Message.MsgType = MSG_PRIMITIVE;
                            Message.Msg.Primitive.Prim = D2P(mmi_display_req);
                            Message.Msg.Primitive.PrimLen = sizeof (T_MMI_DISPLAY_REQ) + 14*16+20;
#ifdef MEMORY_SUPERVISION
                            vsi_c_send (VSI_CALLER hCommL1 ,&Message, __FILE__, __LINE__);
#else
                            vsi_c_send (VSI_CALLER hCommL1 ,&Message);
#endif
                        }
#else
                        vsi_c_send (VSI_CALLER hCommL1, D2P(mmi_display_req), sizeof (T_MMI_DISPLAY_REQ) + 14*16+20);
#endif
                    }
#endif
#if (LCD_ROW >= 48)
                    {
                        PALLOC_SDU (mmi_display_req, MMI_DISPLAY_REQ, sdu_len<<3);

                        mmi_display_req->c_x = LCD_COL;
                        mmi_display_req->c_y = 16;
                        mmi_display_req->attrib.content = 2;
                        i=0;
                        for(y=32;y<48;y++)
                            for(x=0; x < 13; x++)
                                mmi_display_req->sdu.buf[i++] = display[y][x];
#if defined NEW_FRAME
                        {
                            T_QMSG Message;

                            Message.MsgType = MSG_PRIMITIVE;
                            Message.Msg.Primitive.Prim = D2P(mmi_display_req);
                            Message.Msg.Primitive.PrimLen = sizeof (T_MMI_DISPLAY_REQ) + 14*16+20;
#ifdef MEMORY_SUPERVISION
                            vsi_c_send (VSI_CALLER hCommL1 ,&Message, __FILE__, __LINE__);
#else
                            vsi_c_send (VSI_CALLER hCommL1 ,&Message);
#endif
                        }
#else
                        vsi_c_send (VSI_CALLER hCommL1, D2P(mmi_display_req), sizeof (T_MMI_DISPLAY_REQ) + 14*16+20);
#endif
                    }
#endif
                    {
                        PALLOC_SDU (mmi_display_req, MMI_DISPLAY_REQ, sdu_len<<3);

                        mmi_display_req->c_x = LCD_COL;
                        mmi_display_req->c_y = 16;
                        mmi_display_req->attrib.content = 1;
                        i=0;
                        for(y=16;y<32;y++)
                            for(x=0; x < 13; x++)
                                mmi_display_req->sdu.buf[i++] = display[y][x];
#if defined NEW_FRAME
                        {
                            T_QMSG Message;

                            Message.MsgType = MSG_PRIMITIVE;
                            Message.Msg.Primitive.Prim = D2P(mmi_display_req);
                            Message.Msg.Primitive.PrimLen = sizeof (T_MMI_DISPLAY_REQ) + 14*16+20;
#ifdef MEMORY_SUPERVISION
                            vsi_c_send (VSI_CALLER hCommL1 ,&Message, __FILE__, __LINE__);
#else
                            vsi_c_send (VSI_CALLER hCommL1 ,&Message);
#endif
                        }
#else
                        vsi_c_send (VSI_CALLER hCommL1, D2P(mmi_display_req), sizeof (T_MMI_DISPLAY_REQ) + 14*16+20);
#endif
                    }
                    {
                        PALLOC_SDU (mmi_display_req, MMI_DISPLAY_REQ, sdu_len<<3);

                        mmi_display_req->c_x = LCD_COL;
                        mmi_display_req->c_y = 16;
                        mmi_display_req->attrib.content = 0;
                        i=0;
                        for(y=0;y<16;y++)
                            for(x=0; x < 13; x++)
                                mmi_display_req->sdu.buf[i++] = display[y][x];
#if defined NEW_FRAME
                        {
                            T_QMSG Message;

                            Message.MsgType = MSG_PRIMITIVE;
                            Message.Msg.Primitive.Prim = D2P(mmi_display_req);
                            Message.Msg.Primitive.PrimLen = sizeof (T_MMI_DISPLAY_REQ) + 14*16+20;
#ifdef MEMORY_SUPERVISION
                            vsi_c_send (VSI_CALLER hCommL1 ,&Message, __FILE__, __LINE__);
#else
                            vsi_c_send (VSI_CALLER hCommL1 ,&Message);
#endif
                        }
#else
                        vsi_c_send (VSI_CALLER hCommL1, D2P(mmi_display_req), sizeof (T_MMI_DISPLAY_REQ) + 14*16+20);
#endif
                    }
                    TRACE_EVENT ("Send Display Content");
                }
                break;
        }
    }
#endif

    if(mobEnabled)
    {
        //Glowing,2004-07-27, disable the code for the WIN32
        xIndex = 0;
        //sprintf(scratch,"%s%s %d",scrHeader,"disp",LCD_COL_B);
        //mfwExtOut(scratch);
        
    }
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrLCDUpdate       |
+--------------------------------------------------------------------+

  PURPOSE : Shadow display to LCD

*/

//GW Procedure/data supplied by new TI Driver V5.3.1
#ifdef R2D_ENABLED
void r2d_refresh(void);
extern T_R2D_GC_PTR r2d_g_lcd_gc;
extern T_R2D_GC_PTR r2d_g_sublcd_gc;
#endif

void scrLCDUpdate (void)
{    
    if(!scrEnabled)
        return;

#if defined (WIN32)
    return;
#endif

    if(scrEnabled)
        LcdUpdateRequire(r2d_g_lcd_gc);
    return;
}


/* Robert.Chen add, for subLCD, 2003-12-16 */
#if R2D_SUBLCD_SUPPORT
void sub_scrLCDUpdate (void)
{
    if(sub_scrEnabled)
    {
        LcdUpdateRequire(r2d_g_sublcd_gc);
    }
    
    return;
}
#endif

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrMobCommand      |
+--------------------------------------------------------------------+

  PURPOSE : Command string from mobile simulation

*/

void scrMobCommand (char *s)
{
#if 0  //Glowing,2004-07-28, comment the following block
    char *p;
    unsigned char *q;
    int i;

    if(strstr(s,"ena") == s)
    {
        mobEnabled = 1;
        return;
    }
    if(strstr(s,"dis") == s)
    {
        mobEnabled = 0;
        return;
    }
    if(strstr(s,"ok") == s)
    {
        if(xIndex < 0)
            return;
        strcpy(scratch,scrHeader);
        if(xIndex >= sizeof(display))
        {
            strcat(scratch,"done");
            mfwExtOut(scratch);
            return;
        }
        strcat(scratch,"data ");
        p = scratch + strlen(scratch);
        sprintf(p,"%04d %04d ",xIndex,LCD_COL_B*LCD_ROW/DISPL_DIV);
        p = scratch + strlen(scratch);
        q = (UBYTE *) display;
        for(i = 0; i < LCD_COL_B * LCD_ROW / DISPL_DIV; i++)
        {
            sprintf(p,"%02x",q[xIndex++]);
            p += 2;
        }
        *p = '\0';
        mfwExtOut(scratch);
        return;
    }
#endif	
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrInit            |
+--------------------------------------------------------------------+

  PURPOSE : initialize screen driver

*/

void scrInit (void)
{
    LCD_SetPower(); /* ES!! */
    LCD_Reset();
    LCD_Enable(1);

//Glowing,2004-07-27, comment the following statement
//    memset(display,0,sizeof(display));
    
#ifdef R2D_ENABLED
    r2d_erase( r2d_g_lcd_gc );
#endif
    mobEnabled = 0;
    scrEnabled = 1;
    internal = 0;
    scrX = LCD_COL;
    scrY = LCD_ROW;
    xIndex = -1;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrExit            |
+--------------------------------------------------------------------+

  PURPOSE : finalize screen driver

*/

void scrExit (void)
{
    LCD_Enable(0);
    mobEnabled = 0;
    scrEnabled = 0;
    xIndex = -1;
    
    #if R2D_SUBLCD_SUPPORT
    sub_scrEnabled = 0;	/* Robert.chen add, 2003-12-14 */
    #endif
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrUpdate          |
+--------------------------------------------------------------------+

  PURPOSE : set screen update mode

GW 18/09/01 clear text invert flag whenever display is enabled/disabled.
*/

int scrUpdate (int onOff)
{
    int ena = scrEnabled;
    txtInvert = 0;  //clear text invert flag whenever display is enabled/disabled.
    scrEnabled = onOff;
    if(scrEnabled)
    {
        scrLCDUpdate();
        scrMobUpdate();
    }

    return ena;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrSize            |
+--------------------------------------------------------------------+

  PURPOSE : retrieve display size

*/

void scrSize (int *x, int *y)
{
    *x = scrX;
    *y = scrY;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrOnOff           |
+--------------------------------------------------------------------+

  PURPOSE : switch display On/Off

*/

void scrOnOff (int on)
{
//Glowing,2004-07-27, comment the following block
//    sprintf(scratch,"%sscrOnOff:%d",scrHeader,on);
//    mfwExtOut(scratch);
}

#if (!CUST)//JVJE #if (CUST==1)
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrLight           |
+--------------------------------------------------------------------+

  PURPOSE : switch display backlight On/Off

*/

void scrLight (int on)
{
//Glowing,2004-07-27,comment the following block
//    sprintf(scratch,"%sscrLight:%d",scrHeader,on);
//    mfwExtOut(scratch);
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrClear           |
+--------------------------------------------------------------------+

  PURPOSE : clear display

*/

void scrClear (void)
{
    U8 uMode;
#ifdef R2D_ENABLED

    uMode=dspl_Enable(0);

    r2d_erase( r2d_g_lcd_gc );
    dspl_Enable(uMode);

#endif//CUST==1
#if 0
    {
        memset(display,0,sizeof(display));  /* clear shadow display     */
        memset(displayCopy,0,sizeof(displayCopy));  /* clear shadow display     */
        if(scrEnabled)
        {
            LCD_Clear();                    /* TI driver function       */
            scrMobUpdate();                 /* update mobile simulation */
        }
    }
#endif 
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrClearRect       |
+--------------------------------------------------------------------+

  PURPOSE : clear display area

*/

void scrClearRect(int px, int py, int sx, int sy)
{
    int x1, x2, i, j;
    UBYTE m1, m2;

    if(px < 0 || py < 0 || px >= scrX || py >= scrY || sx < 0 || sy < 0)
        return;
    if(px + sx > scrX)
        sx = scrX - px;
    if(py + sy > scrY)
        sy = scrY - py;
/*    for (i=px;i<px+sx;i++)
    {
      for (j=py;j<py+sy;j++)
      {
#ifdef R2D_ENABLED
      r2d_erase_point(r2d_g_lcd_gc,i,j);
#endif
      }
    }*/

    x1 = px / 8;                        /* first x offset           */
    x2 = (px + sx) / 8;                 /* last x offset            */
    m1 = m2 = 0xff;
    m1 = (UBYTE) ~(m1 >> (px & 7));        /* left mask                */
    m2 = (UBYTE) (m2 >> ((px + sx) & 7));  /* right mask               */
    if(x1 == x2)
        m1 = m2 = m1 | m2;              /* combined masks           */
#if 0 //Glowing,2004-07-27,comment the following Block	
    for(j = py; j < py + sy; j++)
    {
        display[j][x1] &= m1;
        for(i = x1 + 1; i < x2; i++)
            display[j][i] = '\0';
        display[j][x2] &= m2;
    }
#endif	


    scrLCDUpdate();                     /* update LCD               */
    scrMobUpdate();                     /* update mobile simulation */
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr              |
| STATE   : code                        ROUTINE : scrText_Unicode      |
+--------------------------------------------------------------------+

  PURPOSE : draw text

*/
#if R2D_SUBLCD_SUPPORT
static void scrText_Unicode_i(int x, int y, UBYTE in_Attrib, char *intxt, UBYTE sub_main)
{
    int				invert_flag = 1;
    int				font_w, font_h;
    int				lcd_col;
    UBYTE			*p = (UBYTE*)intxt;
    USHORT			current_code;
    t_font_bitmap	*current_bitmap;
    int				scrX_i;
    
	if(sub_main == R2D_MAINLCD)
	{
		font_w 	= fontinfo->font_w;
		font_h 	= fontinfo->font_h;
		lcd_col = LCD_COL;
		scrX_i	= scrX;
	}
	else
	{
		font_w  = sub_fontinfo->font_w;
		font_h  = sub_fontinfo->font_h;
		lcd_col = SUBLCD_COL;
		scrX_i	= sub_scrX;
	}
	
    if(x < 0 || y < 0 || y + font_h > scrY)
        return;

    if( in_Attrib & DSPL_TXTATTR_INVERS )
        invert_flag = 0;
        
    current_code = (USHORT) ((*p<<8)+*(p+1));

	/* 2003/12/22 sunsj if the text length is large than screen size */
    while((current_code) /* && (x + font_w <= scrX_i)*/)
    {
        current_bitmap = getChineseBitmap(current_code, sub_main);
		
        /* 2004/05/26 sunsj modify */
        if( x + current_bitmap->width > scrX_i )
	{
		break;
	}
        dspl_show_bitmap(x,y, in_Attrib, current_bitmap,invert_flag, sub_main);
        
        x += current_bitmap->width;
        p += 2;
        current_code = (USHORT) ((*p<<8)+*(p+1));
        
		if(x >= lcd_col)
		{
			/* 2004/01/04 sunsj modify for font height */
			y += font_h;
			x  = 0;
		}
    }
	/* update LCD */
	if(sub_main == R2D_MAINLCD)
	{
	    scrLCDUpdate();
	}
	else
	{
		sub_scrLCDUpdate();
	}	
}

void scrText_Unicode(int x, int y, UBYTE in_Attrib, char * intxt)
{
	scrText_Unicode_i(x, y, in_Attrib, intxt, R2D_MAINLCD);
}

void sub_scrText_Unicode (int x, int y, UBYTE in_Attrib, char * intxt)
{
	scrText_Unicode_i(x, y, in_Attrib, intxt, R2D_SUBLCD);	
}

#else
void scrText_Unicode (int x, int y, UBYTE in_Attrib, char *intxt)  //zhangzg Eastcom 0703/2002
{
    int invert_flag=1;
	int	font_w, font_h;	/* 2004/01/04 sunsj */
    UBYTE  *p=(UBYTE*)intxt;
    USHORT current_code;
    t_font_bitmap* current_bitmap;

	/* 2004/01/04 sunsj */
	font_w 	= fontinfo->font_w;
	font_h 	= fontinfo->font_h;

    if(x < 0 || y < 0 || y + fontinfo->font_h > scrY)
        return;

    if( in_Attrib & DSPL_TXTATTR_INVERS )
        invert_flag = 0;
    current_code = (USHORT) ((*p<<8)+*(p+1));

    while((current_code) && (x + fontinfo->font_w <= scrX))
    {
        current_bitmap = getChineseBitmap(current_code);
        dspl_show_bitmap(x,y, in_Attrib, current_bitmap,invert_flag);  //zhangzg Eastcom 0703/2002
        x += current_bitmap->width;
        p+=2;
        current_code = (USHORT) ((*p<<8)+*(p+1));
		if(x>=LCD_COL)
		{
			/* 2004/01/04 sunsj modify for font height */
			y+=font_h;
			x=0;
		}
    }

    scrLCDUpdate();                     /* update LCD               */
}
#endif

#if R2D_SUBLCD_SUPPORT
void dspl_show_bitmap(int x,int y, UBYTE txtAttrib, t_font_bitmap* current_bitmap,UBYTE attr, UBYTE sub_main )
{
    USHORT i, j,a,b;
    UINT32 oldfgcolor;
    t_font_bitmap * whiteedge_bitmap;


    if(txtAttrib&DSPL_TXTATTR_WHITE_EDGE)
    {//display white edge
        txtAttrib|=DSPL_TXTATTR_TRANSPARENT;
        whiteedge_bitmap=(t_font_bitmap*)malloc(sizeof(t_font_bitmap));
        whiteedge_bitmap->bitmap=(char*)malloc(2*current_bitmap->bitmap_size);
        j=(current_bitmap->width+7)/8;
        whiteedge_bitmap->height=current_bitmap->height+2;
        whiteedge_bitmap->width=current_bitmap->width;
        whiteedge_bitmap->bitmap_size=current_bitmap->bitmap_size+2*j;
        memset(whiteedge_bitmap->bitmap,0,whiteedge_bitmap->bitmap_size);
        i=0;
        while(i<current_bitmap->bitmap_size)
        {
            if(current_bitmap->bitmap[i]&0x80)
            {
                whiteedge_bitmap->bitmap[i]|=0x80;// 1000 0000
                whiteedge_bitmap->bitmap[i+j]|=0xc0;// 1100 0000
                whiteedge_bitmap->bitmap[i+2*j]|=0x80;// 1000 0000
            }
            for(a=1;a<8;a++)
            {
                if(current_bitmap->bitmap[i]&(0x80>>a))
                {
                    whiteedge_bitmap->bitmap[i]|=(0x80>>a);
                    whiteedge_bitmap->bitmap[i+j]|=(0xe0>>(a-1));// 1110 0000
                    whiteedge_bitmap->bitmap[i+2*j]|=(0x80>>a);
                }
            }
            i++;
        }

        if(sub_main == R2D_MAINLCD)
	        oldfgcolor = dspl_SetFrgColor(CWHITE);
	    else
	    	oldfgcolor = dspl_sub_SetFrgColor(CWHITE);
	    	
        for(i = 0; i < whiteedge_bitmap->height; i++)
            for(j = 0; j < whiteedge_bitmap->width; j++)
            {
                a = (j&(0x07));
                b = i*((whiteedge_bitmap->bitmap_size)/(whiteedge_bitmap->height))+((j&0xf8)>>3);
                scrTxtPoint(x+j,y+i-1,txtAttrib, whiteedge_bitmap->bitmap[b]&(0x80>>a), sub_main);    //zhangzg Eastcom 0703/2002;
            }
        
        if(sub_main == R2D_MAINLCD)
	        oldfgcolor = dspl_SetFrgColor(oldfgcolor);
	    else
	    	oldfgcolor = dspl_sub_SetFrgColor(oldfgcolor);
	    	
        free(whiteedge_bitmap->bitmap);
        free(whiteedge_bitmap);
    }


    for(i = 0; i < current_bitmap->height; i++)
	{
        for(j = 0; j < current_bitmap->width; j++)
        {
            a = (j&(0x07));
            b = i*((current_bitmap->bitmap_size)/(current_bitmap->height))+((j&0xF8)>>3);
            if(attr||txtAttrib&DSPL_TXTATTR_WHITE_EDGE)//because if have white edge,we needn't invert display,zhonghz,2002/9/10
                scrTxtPoint(x+j,y+i,txtAttrib, current_bitmap->bitmap[b]&(0x80>>a), sub_main);    //zhangzg Eastcom 0703/2002;
            else
                scrTxtPoint(x+j,y+i,txtAttrib, ((UBYTE)~(current_bitmap->bitmap[b]))&(0x80>>a), sub_main);  //zhangzg Eastcom 0703/2002
        }
	}

}
/*
void dspl_show_bitmap(int x,int y, UBYTE txtAttrib, t_font_bitmap* current_bitmap,UBYTE attr )
{
	dspl_show_bitmap_i(x, y, txtAttrib, current_bitmap, attr, R2D_MAINLCD);
}

void dspl_sub_show_bitmap(int x,int y, UBYTE txtAttrib, t_font_bitmap* current_bitmap,UBYTE attr )
{
	dspl_show_bitmap_i(x, y, txtAttrib, current_bitmap, attr, R2D_SUBLCD);
}
*/
#else
void dspl_show_bitmap(int x,int y, UBYTE txtAttrib, t_font_bitmap* current_bitmap,UBYTE attr )  //zhangzg Eastcom 0703/2002
{
    USHORT i, j,a,b;
    UINT32 oldfgcolor;
    t_font_bitmap * whiteedge_bitmap;
    if(txtAttrib&DSPL_TXTATTR_WHITE_EDGE)
    {//display white edge
        txtAttrib|=DSPL_TXTATTR_TRANSPARENT;
        whiteedge_bitmap=(t_font_bitmap*)malloc(sizeof(t_font_bitmap));
        whiteedge_bitmap->bitmap=(char*)malloc(2*current_bitmap->bitmap_size);
        j=(current_bitmap->width+7)/8;
        whiteedge_bitmap->height=current_bitmap->height+2;
        whiteedge_bitmap->width=current_bitmap->width;
        whiteedge_bitmap->bitmap_size=current_bitmap->bitmap_size+2*j;
        memset(whiteedge_bitmap->bitmap,0,whiteedge_bitmap->bitmap_size);
        i=0;
        while(i<current_bitmap->bitmap_size)
        {
            if(current_bitmap->bitmap[i]&0x80)
            {
                whiteedge_bitmap->bitmap[i]|=0x80;// 1000 0000
                whiteedge_bitmap->bitmap[i+j]|=0xc0;// 1100 0000
                whiteedge_bitmap->bitmap[i+2*j]|=0x80;// 1000 0000
            }
            for(a=1;a<8;a++)
            {
                if(current_bitmap->bitmap[i]&(0x80>>a))
                {
                    whiteedge_bitmap->bitmap[i]|=(0x80>>a);
                    whiteedge_bitmap->bitmap[i+j]|=(0xe0>>(a-1));// 1110 0000
                    whiteedge_bitmap->bitmap[i+2*j]|=(0x80>>a);
                }
            }
            i++;
        }
        oldfgcolor= dspl_SetFrgColor(CWHITE);//we can change the frg color
        for(i = 0; i < whiteedge_bitmap->height; i++)
            for(j = 0; j < whiteedge_bitmap->width; j++)
            {
                a = (j&(0x07));
                b = i*((whiteedge_bitmap->bitmap_size)/(whiteedge_bitmap->height))+((j&0xf8)>>3);
                scrTxtPoint(x+j,y+i-1,txtAttrib, whiteedge_bitmap->bitmap[b]&(0x80>>a));    //zhangzg Eastcom 0703/2002;
            }
        dspl_SetFrgColor(oldfgcolor);
        free(whiteedge_bitmap->bitmap);
        free(whiteedge_bitmap);
    }
    for(i = 0; i < current_bitmap->height; i++)
	{
        for(j = 0; j < current_bitmap->width; j++)
        {
            a = (j&(0x07));
            b = i*((current_bitmap->bitmap_size)/(current_bitmap->height))+((j&0xF8)>>3);
            if(attr||txtAttrib&DSPL_TXTATTR_WHITE_EDGE)//because if have white edge,we needn't invert display,zhonghz,2002/9/10
                scrTxtPoint(x+j,y+i,txtAttrib, current_bitmap->bitmap[b]&(0x80>>a));    //zhangzg Eastcom 0703/2002;
            else
                scrTxtPoint(x+j,y+i,txtAttrib, ((UBYTE)~(current_bitmap->bitmap[b]))&(0x80>>a));  //zhangzg Eastcom 0703/2002
        }
	}
}
#endif

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrText            |
+--------------------------------------------------------------------+

  PURPOSE : draw text
GW 18/09/01 - Made invert flag local to file not procedure
*/
#if R2D_SUBLCD_SUPPORT
static void scrText_i(int x, int y, UBYTE in_Attrib, char *txt, UBYTE sub_main)
{
    int 	n, i, invert_flag = 1;
    UBYTE	*p = (UBYTE*)txt;
    UBYTE	current_width = 0;
    UBYTE	current_code;
    t_font_bitmap current_bitmap;
    FONTINFO *finfo;
    int		scrX_i;

	if(sub_main == R2D_MAINLCD)
	{
		finfo  = fontinfo;
		scrX_i = scrX; 
	}	
	else
	{
		finfo  = sub_fontinfo;
		scrX_i = sub_scrX;
	}	
		
	if(x < 0 || y < 0 || (y + finfo->font_h ) > scrY)
        return;
	
	if(get_font_type() == SMALL_FONT)
	{
		current_bitmap.bitmap		= (char *)malloc(finfo->font_s + 1);
		current_bitmap.width		= finfo->font_w;
		current_bitmap.bitmap_size	= finfo->font_s;
		current_bitmap.height		= finfo->font_h;

		current_code = *p;
		
		if(in_Attrib & DSPL_TXTATTR_INVERS)
			invert_flag = 0;

		while((current_code != 0x00) && (x + current_bitmap.width <= scrX_i))
		{
			/* 2004/03/24 sunsj modify for 0x20 */
			if( current_code == 0x20 )
			{
				for(i = 0; i < finfo->font_s; i++ )
				{
					current_bitmap.bitmap[i] = 0x00;
				}
			}
			else
			{
				n = finfo->font_s * (current_code-0x30);
				current_bitmap.width = finfo->font_w;
				
				for(i=0;i<finfo->font_s;i++)
				{
					current_bitmap.bitmap[i]=finfo->ascfont[n+i];
				}
			}
			dspl_show_bitmap(x, y, in_Attrib, &current_bitmap, invert_flag, sub_main);	    
			
			x += current_bitmap.width;
			p++;
			current_code = *p;
		}
	}
	else
	{
    current_bitmap.bitmap		= (char *)malloc(finfo->font_s + 1);
    current_bitmap.width		= finfo->font_w;
    current_bitmap.bitmap_size	= finfo->font_s;
    current_bitmap.height		= finfo->font_h;

    current_code = *p;

    if(in_Attrib & DSPL_TXTATTR_INVERS)
        invert_flag = 0;

    while((current_code != 0x00) && (x + current_bitmap.width <= scrX_i))
    {
        n = finfo->font_s * current_code;
		
		/* 2003/10/28 sunsj modify for display auto width char */
		/* 2003/10/13 sunsj get the ascii char width */
		if(current_code <= 0x5a && current_code >= 0x41)
		{
			current_bitmap.width = finfo->charwidth[current_code - 0x41]+1;
		}
		else if(current_code <= 0x7a && current_code >= 0x61)
		{
			current_bitmap.width = finfo->charwidth[current_code - 0x41]+1;
		}
		else
		{
			current_bitmap.width = finfo->font_w;
		}

        for(i=0;i<finfo->font_s;i++)
        {
            current_bitmap.bitmap[i]=finfo->ascfont[n+i];
        }
        
        dspl_show_bitmap(x, y, in_Attrib, &current_bitmap, invert_flag, sub_main);	    

        x += current_bitmap.width;
        p++;
        current_code = *p;
    }
	}
	/* update LCD */
    if(sub_main == R2D_MAINLCD)
    {
		scrLCDUpdate(); 
	}	
	else
	{
		sub_scrLCDUpdate();
	}	
		
    free(current_bitmap.bitmap);
}

void scrText(int x, int y, UBYTE in_Attrib, char *txt)
{
	scrText_i(x, y, in_Attrib, txt, R2D_MAINLCD);
}

void sub_scrText(int x, int y, UBYTE in_Attrib, char *txt)
{
	scrText_i(x, y, in_Attrib, txt, R2D_SUBLCD);
}

#else

void scrText(int x, int y, UBYTE in_Attrib, char * txt)
{
    int n,i,invert_flag=1;
    UBYTE *p=(UBYTE*)txt;
    UBYTE current_width=0;
    UBYTE current_code;
    t_font_bitmap current_bitmap;

    current_bitmap.bitmap=(char *)malloc(fontinfo->font_s+1);
    current_bitmap.width=fontinfo->font_w;
    current_bitmap.bitmap_size=fontinfo->font_s;
    current_bitmap.height=fontinfo->font_h;
    if(x < 0 || y < 0 || (y + fontinfo->font_h )> scrY)
        return;

    current_code =*p;
    if(in_Attrib&DSPL_TXTATTR_INVERS)
        invert_flag=0;
    while((current_code!=0x00) && (x + current_bitmap.width <= scrX))
    {
        n=fontinfo->font_s*current_code;
		
		/* 2003/10/28 sunsj modify for display auto width char */
		/* 2003/10/13 sunsj get the ascii char width */
		if(current_code <= 0x5a && current_code >= 0x41)
		{
			current_bitmap.width = fontinfo->charwidth[current_code - 0x41]+1;
		}
		else if(current_code <= 0x7a && current_code >= 0x61)
		{
			current_bitmap.width = fontinfo->charwidth[current_code - 0x41]+1;
		}
		else
		{
			current_bitmap.width = fontinfo->font_w;
		}

        for(i=0;i<fontinfo->font_s;i++)
            current_bitmap.bitmap[i]=fontinfo->ascfont[n+i];
            
        dspl_show_bitmap(x,y,in_Attrib,&current_bitmap,invert_flag);

        x += current_bitmap.width;
        p++;
        current_code =*p;
    }
    scrLCDUpdate();                     /* update LCD               */
    free(current_bitmap.bitmap);
}
#endif  /* R2D_SUBLCD_SUPPORT */

EXTERN UBYTE   dspl_str_length(char * str)
{
    return(wstrlen(str));
}



/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrLine            |
+--------------------------------------------------------------------+

  PURPOSE : draw line

*/

void scrLine (int x1, int y1, int x2, int y2)
{
    int x, y, dx, dy, c1, c2, err, swap = 0;

    if(x1 < 0 || x1 >= scrX || x2 < 0 || x2 >= scrX ||
       y1 < 0 || y1 >= scrY || y2 < 0 || y2 >= scrY)
        return;

    dx = x2 - x1; dy = y2 - y1;
    if(((dx < 0) ? -dx : dx) < ((dy < 0) ? -dy : dy))
    {
        swap = 1;                       /* take the long way        */
        x = x1; x1 = y1; y1 = x;
        x = x2; x2 = y2; y2 = x;
    }
    if(x1 > x2)
    {
        x = x1; x1 = x2; x2 = x;        /* always move to the right */
        y = y1; y1 = y2; y2 = y;
    }

    dx = x2 - x1; dy = y2 - y1;
    c1 = dy * 2; dy = 1;
    if(c1 < 0)
    {
        c1 = -c1;
        dy = -1;
    }
    err = c1 - dx; c2 = err - dx;
    x = x1; y = y1;
    while(x <= x2)
    {
        scrPoint(swap?y:x,swap?x:y,1);
        x++;
        if(err < 0)
            err += c1;
        else
        {
            y += dy;
            err += c2;
        }
    }

    if(internal)
        return;
//nm
    scrLCDUpdate();                     /* update LCD               */
    scrMobUpdate();                     /* update mobile simulation */
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrRect            |
+--------------------------------------------------------------------+

  PURPOSE : draw rectangle

*/

void scrRect (int px, int py, int sx, int sy)
{
    internal = 1;
    scrLine(px,py,px+sx,py);
    scrLine(px,py+sy,px+sx,py+sy);
    scrLine(px,py,px,py+sy);
    internal = 0;
    scrLine(px+sx,py,px+sx,py+sy);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrFntSelect       |
+--------------------------------------------------------------------+

  PURPOSE : select the current font

*/

int scrFntSelect (int font)
{
    return 1;                           /* always OK                */
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrFntHeight       |
+--------------------------------------------------------------------+

  PURPOSE : get height of current font

*/

int scrFntHeight (void)
{
    return fontinfo->font_h;//zhonghz,16
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrFntGetFit       |
+--------------------------------------------------------------------+

  PURPOSE : number of string chars that fit into the line

*/

int scrFntGetFit (char *tp, int lineWidth)
{
    if((unsigned char)*tp != (unsigned char)0x80)
        return(lineWidth /fontinfo->font_w);
    else
        return(lineWidth / (2*fontinfo->font_w));
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrFntGetLen       |
+--------------------------------------------------------------------+

  PURPOSE : number of pixel used by first n string chars

*/

/* Robert.Chen changed, to support sub LCD, 2003-12-14 */
#if R2D_SUBLCD_SUPPORT
int scrFntGetLen(char *tp, int nChars , int sub_main)
{	
    int lenth = wstrlen(tp);
    int font_width;
    
    if((UBYTE)(*tp) == (UBYTE)0x80)
        lenth--;
    if(lenth > nChars)
        lenth = nChars;

	if(sub_main == 1) /* 1 for main LCD */
    	font_width = fontinfo->font_w;	
    else	/* 0 for sub LCD */
    	font_width = sub_fontinfo->font_w;

    return(lenth * font_width);
}
#else
int scrFntGetLen(char *tp, int nChars)
{
    int lenth=wstrlen(tp);
    if((UBYTE)(*tp)== (UBYTE)0x80)
        lenth--;
    if(lenth>nChars)
        lenth=nChars;

    return(lenth*fontinfo->font_w);
}
#endif

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrBmpDraw         |
+--------------------------------------------------------------------+

  PURPOSE : draw bitmap

*/

int scrBmpDraw (int px, int py, int sx, int sy,
                int ix, char *bm, int mode)
{
    int i, j;
    unsigned char m;

    if(px < 0 || px >= scrX || py < 0 || py >= scrY
       || sx < 0 || sy < 0)
        return 0;
    if(px + sx > scrX)
        sx = scrX - px;
    if(py + sy > scrY)
        sy = scrY - py;

    m = 0x80;
    bm += (sx * sy * ix) / 8;
    for(j = 0; j < sy; j++)
    {
        for(i = 0; i < sx; i++)
        {
            scrPoint(px+i,py+j,*bm & m);
            m >>= 1;
            if(!m)
            {
                m = 0x80;
                bm++;
            }
        }
        if(m != 0x80)
        {
            m = 0x80;
            bm++;
        }
    }
//nm
    scrLCDUpdate();                     /* update LCD               */
    scrMobUpdate();                     /* update mobile simulation */

    return 0;
}



/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : dspl_ColorBmpDraw         |
+--------------------------------------------------------------------+

  PURPOSE : draw bitmap

*/

GLOBAL UBYTE dspl_BitBlt       (USHORT              in_X,
                                USHORT              in_Y,
                                USHORT              in_Width,
                                USHORT              in_Height,
                                USHORT              in_Index,
                                void              * in_BmpPtr,
                                USHORT              in_Rop)
{

    r2d_new_draw_bmp(r2d_g_lcd_gc, in_X,   //zym modified 10/25
                     in_Y,
                     in_Width,
                     in_Height,
                     in_Index,
                     in_BmpPtr,
                     in_Rop);

    return 0;
}

/* Robert.Chen add, for sub LCD, 2003-12-20 */
#if R2D_SUBLCD_SUPPORT
GLOBAL UBYTE dspl_sub_BitBlt		(USHORT              in_X,
	                                USHORT              in_Y,
	                                USHORT              in_Width,
	                                USHORT              in_Height,
	                                USHORT              in_Index,
	                                void              * in_BmpPtr,
	                                USHORT              in_Rop)
{

    r2d_new_draw_bmp(r2d_g_sublcd_gc,
    				 in_X,
                     in_Y,
                     in_Width,
                     in_Height,
                     in_Index,
                     in_BmpPtr,
                     in_Rop);

    return 0;
}
#endif

/********************************tangyan add it 9.6**********************************
 *fuction : dspl_getscreen
 *author : tangyan
 *description : ȫֱr2d_g_lcd_gcжָrect
 *********************************************************************************/
void  dspl_getscreen(USHORT px, USHORT py, USHORT width, USHORT height,char *pscreenbuffer)
{

    r2d_readimage(r2d_g_lcd_gc,px, py,width, height,pscreenbuffer);

}

void  dspl_move_lcdbuffer(U8 speed)
{

    int i,memsize,lcdy,cyclenum;

    cyclenum=160/speed;
    for(i=0;i<cyclenum;i++)
    {
        lcdy=i*speed;
        dspl_cpy_lcdbuffer(r2d_g_lcd_gc,lcdy,speed);
//TRACE_EVENT_P1("dspl_move_lcdbuffer",memcpyz);
    }
}
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : dspl_fill_rectangle         |
+--------------------------------------------------------------------+

  PURPOSE : draw bitmap

*/
// will use the rgb taken from the  color palette  with the given bgcolor value in the future
GLOBAL UBYTE dspl_fill_rectangle(int px, int py, int bx, int by)
{
    //oldBgColor=r2d_get_background_color(r2d_g_lcd_gc);
    //r2d_set_background_color_with_argb(r2d_g_lcd_gc,0,255,0,0);//just for a test,will get rgb from the color palette
    r2d_fill_rectangle(r2d_g_lcd_gc,px,py,bx,by);
    return DRV_OK;
    //r2d_set_background_color_with_argb(r2d_g_lcd_gc,r2d_alpha(oldcolor),r2d_red(oldcolor),r2d_green(oldcolor),r2d_blue(oldcolor));

    //chenjun change this function to make all the dspl_draw,and dspl_fill has the same interface to user
}
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrCurType         |
+--------------------------------------------------------------------+

  PURPOSE : set cursor type (0 = no cursor)

*/

void scrCurType (int type)
{
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrCursor          |
+--------------------------------------------------------------------+

  PURPOSE : set cursor at specified position

*/

void scrCursor (int x, int y)
{
    scrLine(x,y+7,x+5,y+7);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : ti1_scr            |
| STATE   : code                        ROUTINE : scrPoint           |
+--------------------------------------------------------------------+

  PURPOSE : draw point

*/

static void scrPoint (int px, int py, int col)
{
    unsigned char m = 0x80;

    if(px < 0 || py < 0 || px >= scrX || py >= scrY)
        return;
#ifdef R2D_ENABLED
    if(col)
        r2d_draw_point(r2d_g_lcd_gc,px,py);
    else
        r2d_erase_point(r2d_g_lcd_gc,px,py);
#endif

#if 0
    m >>= px & 7;                       // mask
    px >>= 3;                           // x offset

    //m>>=px;


    if(col)
        display[py][px] |= m;
    else
        display[py][px] &= (UBYTE) ~m;
#endif     

}

/*
/***************************************************************************************/
/*Function Name: scrTxtPoint
/*Purpose:  to support transparent text and future possible extending (supporting other attributions)
/*Parameter: x, y, in_Attr, col
/*Return:  void
/*
/*Author: zhangzg
/*Date:  07/03/2002
/***************************************************************************************/

// to display transparent text, OR the const DSPL_TXTATTR_TRANPARENT with your current in_Attrbi
// before calling dspl_textout.  

#if R2D_SUBLCD_SUPPORT
LOCAL  void scrTxtPoint (int px, int py, UBYTE in_Attr, int col, UBYTE sub_main)
{
    unsigned char m = 0x80;
    T_R2D_GC_PTR *gc;	

    if(px < 0 || py < 0)
    	return;

	

	if(sub_main == R2D_MAINLCD)
	{
		if(px >= scrX || py >= scrY)
			return;
			
		gc = r2d_g_lcd_gc;
	}	
	else
	{
		if(px >= sub_scrX || py >= sub_scrY)
			return;
		gc = r2d_g_sublcd_gc;
	}	
		
	#ifdef R2D_ENABLED
    if(col)
        r2d_draw_point(gc, px, py);
    else
    {
        if((!(in_Attr & DSPL_TXTATTR_TRANSPARENT)) | (in_Attr & DSPL_TXTATTR_INVERS))
            r2d_erase_point(gc, px, py);
    }
	#endif
}
#else
LOCAL  void scrTxtPoint (int px, int py, UBYTE in_Attr, int col)
{
    unsigned char m = 0x80;

    if(px < 0 || py < 0 || px >= scrX || py >= scrY)
        return;

	#ifdef R2D_ENABLED
    if(col)
        r2d_draw_point(r2d_g_lcd_gc,px,py);
    else
    {
        if((!(in_Attr & DSPL_TXTATTR_TRANSPARENT)) | (in_Attr & DSPL_TXTATTR_INVERS))
            r2d_erase_point(r2d_g_lcd_gc,px,py);
    }
	#endif
}
#endif

/*******************************************************************
 *                                                                 *
 * PART III: LCD Simulation for Windows                            *
 *                                                                 *
 *******************************************************************/

#if defined (WIN32)

#define LCDE_COL 20
#define LCDE_ROW 4
static int screensize_x = 16;
static int screensize_y = 4;

#define NULL_TERM   '\0'  /* string termination                   */

static CHAR lcd_screen [LCDE_ROW+2][LCDE_COL+3];
static CHAR cursor_line[LCDE_COL+3];

static int lcd_cursX, lcd_cursY, lcd_enabled = FALSE;

LOCAL void LCD_Refresh (void)
{
    int i;
    CHAR buf[100];

    for(i=0; i<screensize_y+2; i++)
    {
        sprintf (buf, "~LCD~%s", &lcd_screen[i][0]);
#if defined NEW_FRAME
        vsi_o_ttrace (0, 0xffff, buf);
#else
//    vsi_o_trace ("", 0xffff, buf);
#endif
        printf ("%s\n", &lcd_screen[i][0]);
        if(lcd_cursY+1 EQ i)
        {
            cursor_line[lcd_cursX+1] = '^';
            sprintf (buf, "~LCD~%s", cursor_line);
#if defined NEW_FRAME
            vsi_o_ttrace (0, 0xffff, buf);
#else
//      vsi_o_trace ("", 0xffff, buf);
#endif
            printf ("%s\n", cursor_line);
            cursor_line[lcd_cursX+1] = ' ';
        }
        else
        {
            if(i < screensize_y+1)
            {
                sprintf (buf, "~LCD~%s", cursor_line);
#if defined NEW_FRAME
                vsi_o_ttrace (0, 0xffff, buf);
#else
//        vsi_o_trace ("", 0xffff, buf);
#endif
                printf ("%s\n", cursor_line);
            }
        }
    }
}

GLOBAL void LCD_Enable (int on)
{
    lcd_enabled = (on EQ 1);
}

GLOBAL void LCD_Clear (void)
{
    int r, c;

    if(lcd_enabled)
    {
        lcd_cursX = lcd_cursY = 0;

        for(r=1; r<screensize_y+1; r++)
            for(c=1; c<screensize_x+1; c++)
                lcd_screen[r][c] = ' ';

        LCD_Refresh ();
    }
}

GLOBAL void LCD_Reset (void)
{
    int r, c, i;

    memset (cursor_line, ' ', screensize_x+3);
    cursor_line[0] = cursor_line[screensize_x+1] = '|';
    cursor_line[screensize_x+2] = NULL_TERM;

    for(r=1; r < screensize_y+1; r++)
    {
        lcd_screen[r][0] = '|';
        lcd_screen[r][screensize_x+1] = '|';
    }
    for(c=1; c < screensize_x+1; c++)
    {
        lcd_screen[0][c] = '-';
        lcd_screen[screensize_y+1][c] = '-';
    }

    lcd_screen[0][0]                 = '+';
    lcd_screen[screensize_y+1][0]         = '+';
    lcd_screen[0][screensize_x+1]         = '+';
    lcd_screen[screensize_y+1][screensize_x+1] = '+';

    for(i=0; i<screensize_y+2; i++)
        lcd_screen [i][screensize_x+2] = NULL_TERM;

    lcd_enabled = TRUE;

    LCD_Clear ();

    lcd_enabled = FALSE;
}

GLOBAL void LCD_WriteString (int row, int col, CHAR *s)
{
    if(s == NULL)
    {
        TRACE_EVENT("LCD_WriteString got NULL Pointer as Text");
        return;
    }
    if(lcd_enabled)
    {
        int len = strlen (s);

        if(row < screensize_y)
        {
            if((col + len) > screensize_x)
            {
                /* clip the string */
                s[(len = screensize_x-col)] = NULL_TERM;
            }
            memcpy (&lcd_screen[row+1][col+1], s, len);
            LCD_Refresh ();
        }
    }
}

GLOBAL void LCD_Cursor (int row, int col)
{
    if(lcd_enabled)
    {
        if(row < screensize_y AND col < screensize_x)
        {
            lcd_cursY = row;
            lcd_cursX = col;
            LCD_Refresh ();
        }
    }
}

GLOBAL void LCD_SetPower (void)
{
}

GLOBAL void LCD_PixBlt (int x, int y, int w, int h, char *bmp)
{
}

/*
 * Stimulation of the lcd driver
 */
GLOBAL void lcd_test (UBYTE mode)
{
    TRACE_EVENT ("Display Redirection activated");
    mtkEnabled = mode;
    scrInit();
    if(mtkEnabled EQ 2)
    {
        scrY = 64;
    }
}
#endif


GLOBAL UBYTE    dspl_DrawCircle (USHORT x,USHORT y,USHORT r)
{
    r2d_draw_circle(r2d_g_lcd_gc,x, y, r);
    return DRV_OK;

}
GLOBAL UBYTE    dspl_DrawPoint          (int px, int py)
{
    scrPoint (px, py, 1);
    return DRV_OK;
}
GLOBAL UBYTE    dspl_fill_Circle    (USHORT x,USHORT y,USHORT r)
{
    r2d_fill_circle(r2d_g_lcd_gc, x, y, r);
    return DRV_OK;

}

GLOBAL UINT16 dspl_set_pen_size(UINT16 the_size)
{
    UINT16 cursize;
    cursize=r2d_get_pen_size(r2d_g_lcd_gc);
    r2d_set_pen_size(r2d_g_lcd_gc,the_size);
    return cursize;

}

GLOBAL UBYTE dspl_SetTextMode(void)
{
    dspl_SetBkgColor(0xFFFFFF);
    dspl_SetFrgColor(0x000000);
    return DRV_OK;
}

/* Robert.Chen changed, for sub LCD, 2003-12-18 */
#if R2D_SUBLCD_SUPPORT
static int get_CharWidth_i(USHORT string, UBYTE sub_main)
{
	USHORT	stringchar	= 0x0000;
	int 	charwidth	= 0;
	BOOL	asciichar	= FALSE;
	BOOL	unicodechar	= FALSE;
	FONTINFO *finfo;

	if(sub_main == R2D_MAINLCD)
	{
		finfo = fontinfo;
	}
	else
	{
		finfo = sub_fontinfo;
	}

	stringchar = string;
	
	if( stringchar >= 0x0041 && stringchar <= 0x005a )
	{
		charwidth = finfo->charwidth[stringchar - 0x41]+1;
	}
	else if(stringchar >= 0x0061 && stringchar <= 0x007a )
	{
		charwidth = finfo->charwidth[stringchar - 0x41]+1;
	}
	else if(stringchar <= 0x00ff )
	{
		charwidth = finfo->font_w;
	}
	/* 2003/11/1 sunsj count the pinyin element char width */
	else if(stringchar >= 0xf461 && stringchar <= 0xf47a )
	{
		charwidth = finfo->charwidth[stringchar - 0xf461]+1;
	}
	else
	{
		/* 2004/05/11 sunsj modify */
#if(MAIN_LCD_SIZE==4)
		charwidth = finfo->font_w*2;
#elif(MAIN_LCD_SIZE==2)
		charwidth = finfo->font_w*2 + 1;
#elif(MAIN_LCD_SIZE==3)
		charwidth = finfo->font_w*2 + 1;
#endif
	}
	return charwidth;
}

GLOBAL int get_CharWidth(USHORT string)
{
	return get_CharWidth_i(string, R2D_MAINLCD);
}

GLOBAL int sub_get_CharWidth(USHORT string)
{
	return get_CharWidth_i(string, R2D_SUBLCD);
}

#else
/* 2003/10/13 sunsj get char width */
GLOBAL int get_CharWidth(USHORT string)
{
	USHORT stringchar=0x0000;
	int charwidth=0;
	BOOL asciichar = FALSE;
	BOOL unicodechar = FALSE;

	stringchar = string;
	if( stringchar >= 0x0041 && stringchar <= 0x005a )
	{
		charwidth = fontinfo->charwidth[stringchar - 0x41]+1;
	}
	else if(stringchar >= 0x0061 && stringchar <= 0x007a )
	{
		charwidth = fontinfo->charwidth[stringchar - 0x41]+1;
	}
	else if(stringchar <= 0x00ff )
	{
		charwidth = fontinfo->font_w;
	}
	/* 2003/11/1 sunsj count the pinyin element char width */
	else if(stringchar >= 0xf461 && stringchar <= 0xf47a )
	{
		charwidth = fontinfo->charwidth[stringchar - 0xf461]+1;
	}
	else
	{
		/* 2004/04/06 sunsj modify */
		charwidth = fontinfo->font_w*2 + 1;
	}
	return charwidth;
}
#endif

/*******************************************************************************

 $Function:		get_StringWidth

 $Description:	get the text width
 
 $Returns:		none

 $Arguments:	none

 $Author Name:  Sunsj

 $Date:			2003/11/1

 $History:		2003/11/10 sunsj

*******************************************************************************/
GLOBAL int get_StringWidth(char *string)
{
	char *TextString;
	int  StepSize = 0;
	int  TextWidth = 0;
	U16 Temp_Char;
	U16 HighByte;
	U16 LowByte;

	if( string == NULL )
		return 0;

	TextString = string;
	if( *TextString == (char)0x80 )
	{
		TextString++;
		StepSize = 2;
	}
	else
	{
		StepSize = 1;
	}

	if( StepSize == 1 )  /* ascii string */
	{
		while( *TextString )
		{
			TextWidth += get_CharWidth( *TextString );
			TextString += StepSize;
		}
	}
	else if( StepSize == 2 )  /* unicode string */
	{
		HighByte = (*TextString & 0x00ff) << 8;
		LowByte = (*(TextString+1) & 0x00ff);

		Temp_Char = HighByte | LowByte;
		
		while( Temp_Char )
		{
			TextWidth += get_CharWidth( Temp_Char );
    		TextString += StepSize;
			HighByte = (*TextString & 0x00ff) << 8;
			LowByte = (*(TextString+1) & 0x00ff);

			Temp_Char = HighByte | LowByte;
		}
	}
    return TextWidth;
}

#endif // CUST



/*************talcon add *********************************/
int dspl_SetScreenType(U8 type)
{
	if(dsplScreenType == type)
		return dsplScreenType;
	if(type == 0)
	{
		dsplScreenType = 0;
		pdspl_BitBlt				= (PDSPL_BITBLT)dspl_BitBlt;
		pset_font_type				= (PSET_FONT_TYPE)set_font_type;
		pdspl_Enable				= (PDSPL_ENABLE)dspl_Enable;
		pdspl_TextOut_Cmode_Center	= (PDSPL_TEXTOUT_CMODE_CENTER)dspl_TextOut_Cmode_Center;
		pdspl_colorTextOut			= (PDSPL_COLORTEXTOUT)dspl_colorTextOut;
		pdspl_ClearAll				=(PDSPL_CLEARALL)dspl_ClearAll;
		pdspl_Clear					= (PDSPL_CLEAR)dspl_Clear; 
		return 1;
	}
	else
	{
		dsplScreenType = 1;
#if R2D_SUBLCD_SUPPORT
		pdspl_BitBlt				= (PDSPL_BITBLT)dspl_sub_BitBlt;
		pset_font_type				= (PSET_FONT_TYPE)set_sub_font_type;
		pdspl_Enable				= (PDSPL_ENABLE)dspl_sub_Enable;
		pdspl_TextOut_Cmode_Center	= (PDSPL_TEXTOUT_CMODE_CENTER)dspl_sub_TextOut_Cmode_Center;
		pdspl_colorTextOut			= (PDSPL_COLORTEXTOUT)dspl_sub_colorTextOut;
		pdspl_ClearAll				=(PDSPL_CLEARALL)dspl_sub_ClearAll;
		pdspl_Clear					= (PDSPL_CLEAR)dspl_sub_Clear; 
#endif
		return 0;
	}
}

int dspl_GetScreenType()
{
	return dsplScreenType;
}
/********end talcon add******************/
/* glowing,2004-06-08, add the following code that used in TI bmi and mfw */

int dspl_getDisplayType( void )
{


#ifdef R2D_ENABLED
	if (R2D_LCD_DISPLAY == R2D_COLOR)
		return (DSPL_COLOUR);
	else
#endif
		return (DSPL_BW);
}



GLOBAL UBYTE dspl_BitBlt2(short in_X,
                          short in_Y,
                          USHORT in_Width,
                          USHORT in_Height,
                          void * in_BmpPtr,
                          USHORT in_index,
                          int bmpFormat)

{

    r2d_new_draw_bmp(r2d_g_lcd_gc, in_X,   //zym modified 10/25
                     in_Y,
                     in_Width,
                     in_Height,
                     in_index,
                     in_BmpPtr,
                     bmpFormat);

    return 0;
}


enum
{
	COL_TYPE_FGD =0,
	COL_TYPE_BGD,
	COL_TYPE_HIGHLIGHT,
	COL_TYPE_BORDER,
	COL_TYPE_SHADOW,
	MAX_COL_TYPE
};
enum
{
	COL_CMD_INIT,
	COL_CMD_GET,
	COL_CMD_SET,
	COL_CMD_SETSHADOW,
	COL_CMD_RESTORECOL,
	MAX_COL_CMD
};

//This definition allows us to have a transparent colour in 256 colour bitmaps.
//We lose the colour nearly-black gray but I don't think it will be missed!
//Better to lose white than gray but will require all icons to be updated!
#define TRANSPARENT_256_COL 0x25

//This definition allows us to have a transparent colour in 16bit LCD colour bitmaps.
//We lose almost white R=0xF8 G=0xFC B=0xF8. NB word is inverted
#define TRANSPARENT_16BIT_COL 0x0020

//using ARGB format, transparent = 0xFFxxxxxx
#define TRANSPARENT_32BIT_COLOUR 0xFF000000

//Hide colours
LOCAL U32 colour_class (int cmd, int colId, U32 inColour)
{
static U32 g_col[MAX_COL_TYPE];
static U32 g_colOld[MAX_COL_TYPE];
	switch (cmd)
	{
		case COL_CMD_INIT:
			colour_class(COL_CMD_SET,	COL_TYPE_FGD,			0x00404040	);
			colour_class(COL_CMD_SET,	COL_TYPE_BGD,			0x00FFFFFF	); //white
			colour_class(COL_CMD_SET,	COL_TYPE_HIGHLIGHT,		0x00FF00FF	);
			colour_class(COL_CMD_SET,	COL_TYPE_BORDER,		0x00FFFFFF	);
			colour_class(COL_CMD_SET,	COL_TYPE_SHADOW,		0x40010101	); //50% translucency
			return (0);
			break;
		case COL_CMD_SET:
			if (inColour != 0)
			{
				g_colOld[colId]	=	g_col[colId];
				g_col[colId]	=	inColour;
			}
			return(g_colOld[colId]);
			break;
		case COL_CMD_GET:
#ifdef COLOURDISPLAY
#ifdef DSAMPLE_COLOUR
			return(g_col[colId]);
#endif
#else
			switch (colId)
			{
				case COL_TYPE_FGD:			return (0x00FFFFFF);
				case COL_TYPE_BGD:			return (0x00000000);
				case COL_TYPE_HIGHLIGHT:	return (0x00000000);
				case COL_TYPE_BORDER:		return (0x00000000);
				case COL_TYPE_SHADOW:		return (0x00000000);
				default:					return (0);
			}
#endif
			break;
		case COL_CMD_SETSHADOW:
			g_colOld[colId]	=	g_col[colId];//currently we dont really need to save the old value
			// set shadow to 50% black
			g_col[colId] = 0x40010101;// | ((inColour >> 2) & 0x003F3F3F);
			return(0x40010101);
			break;
		case COL_CMD_RESTORECOL:
			g_col[colId] = g_colOld[colId];
			return (0);
			break;
		default:
			break;
	}
	return (0);
}

GLOBAL U32 dspl_SetFgdColour (U32 inColour)			{	return (colour_class(COL_CMD_SET,		COL_TYPE_FGD,		inColour));	}
GLOBAL U32 dspl_SetBgdColour (U32 inColour)			{	return (colour_class(COL_CMD_SET,		COL_TYPE_BGD,		inColour));	}
GLOBAL U32 dspl_SetHighlightColour (U32 inColour)	{	return (colour_class(COL_CMD_SET,		COL_TYPE_HIGHLIGHT,	inColour));	}
GLOBAL U32 dspl_SetBorderColour (U32 inColour)		{	return (colour_class(COL_CMD_SET,		COL_TYPE_BORDER,  	inColour));	}
GLOBAL U32 dspl_SetShadowColour (U32 inColour)		{	return (colour_class(COL_CMD_SETSHADOW,	COL_TYPE_SHADOW,  	inColour));	}

GLOBAL U32 dspl_GetFgdColour ( void )				{	return (colour_class(COL_CMD_GET,		COL_TYPE_FGD,		0));	}
GLOBAL U32 dspl_GetBgdColour ( void )				{	return (colour_class(COL_CMD_GET,		COL_TYPE_BGD,		0));	}
GLOBAL U32 dspl_GetHighlightColour ( void )			{	return (colour_class(COL_CMD_GET,		COL_TYPE_HIGHLIGHT,	0));	}
GLOBAL U32 dspl_GetBorderColour ( void )			{	return (colour_class(COL_CMD_GET,		COL_TYPE_BORDER,	0));	}
GLOBAL U32 dspl_GetShadowColour (void)				{	return (colour_class(COL_CMD_GET,		COL_TYPE_SHADOW,  	0));	}

static int txtBorder=0;
int dspl_setBorderWidth(int borderSize)
{
	int oldBorder;
	oldBorder = txtBorder;
	if ((borderSize >=0) && (borderSize <=4))
		txtBorder = borderSize;
	return (oldBorder);
}

/* end of add, glowing,2004-06-08 */

