/* 
+------------------------------------------------------------------------------
|  File:       frm_defs.h
+------------------------------------------------------------------------------
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  Definitions for the fixed dimensions of frame.
+----------------------------------------------------------------------------- 
*/ 

#ifndef FRM_DEFS_H
#define FRM_DEFS_H

#include "glob_defs.h"

#define NUM_OF_COMPONENT_TABLES      2
#define MAX_TST_DRV                  5  /* maximal number of cascaded TST drivers */
#define MAX_TST_DRV_CONF             3  /* maximal number of cascaded TST driver configurations */

#define RANGES_PER_POOL              5
#define ASSIGNED_BY_CONDAT           0

#endif
