/************* Revision Controle System Header *************
 *                  GSM Layer 1 software
 * L1TM_CUST_ADD.C
 *
 *        Filename %M%
 *        Version  %I%
 *        Date     %G%
 *
  * $History: Mmidict.c

 	01/08/02 			huangxl creat.	
 * $end

 ************* Revision Controle System Header *************/
//#include "l1_types.h"
#ifndef TYPE_DEF
	#define TYPE_DEF
	//typedef          char  CHAR;
	typedef unsigned char UWORD8;
	typedef unsigned short UWORD16;
	
#endif

#define BUGS 0

#define ENTITY_MFW
/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif



#include "ffs.h"
#include "pcm.h"
#include "header.h"
#include "mfw_mfw.h"
#include "mfw_tim.h"
#include "mfw_ffs.h"
#include "mfw_smsi.h"
//typedef long           LONG;
#define GLOBAL  
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "Mfw_cnvt.h"

#include "L1tm_cust_add.h"


#define WRITE 6


static MfwHnd       tim;
static MfwHnd 		win;
UBYTE		command=0;
PhbData Sim_PhbData;
PCCMDSTATUS	PcCmdStatus={0,0,0,0,0,0,0,0,0,0};
	static const PhbData SimPhbDefaultData=
	{
		{
		{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},
		{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"},{"\0","\0"}
		}
	};
	
static char 	i=0;//ÿSim绰ļ20¼(0 19)MAXSIMPHBNUM-1
				//smsļ¼
static UBYTE	k=0;//kSim绰/sms ļ
static T_MFW_SMS_IDX 	*psmsidx=NULL;//smsĴ洢index T_MFW_SMS_MSG
static UBYTE	*pWriteSmsdata=NULL;//smsдļݵַ1k
static char	*pReadSmsdata=NULL;//smsļݵַ1k
static SHORT	unreadsms=0;//smsδĸ
static	int	totallen=0;//sms file total len
static T_MFW_SMS_MO	*psenddata=NULL;//smsָ

static int OldNum=0;//chenjun add 0331

static int read_sim_phb_cb(void);
static int excute_tim_cb( MfwEvt e, MfwTim *tc );
static void InitPcCmdStatus(void);
static int	return_info(int ret, void *p1,int p1len,void *p2,int p2len);
static int read_sim_sms_cb(void);
static void	write_sms_file(void);
static int get_data_and_send(void);
static int write_nvm_phb_cb(void);

static void Sleep_wait(unsigned short  times) ;//waiting....

int hstrcpy( char *d,const char *r);
int hstrlen(const char * txt);

void save_send_sms(T_MFW_SMS_MO_TYPE type);
extern BOOL smsidle_get_ready_state(void);
extern T_MFW_MEM_INFO     memory;

/*******************************************************************************

 $Function:    	write_imei

 $Description:	This function invokes the operation for writtting the IMEI.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
int write_imei(UWORD8 *imei)
{
	UWORD8 retVal;                     /* holds return value */
	UWORD8 buf[SIZE_EF_IMEI];


	retVal = pcm_WriteFile ((UWORD8 *)EF_IMEI_ID, SIZE_EF_IMEI, imei);
	if( retVal EQ PCM_INVALID_SIZE OR retVal EQ PCM_INVALID_FILE )
		return( FALSE );

	return( TRUE );
}

/*******************************************************************************

 $Function:    	write_SerialNumber

 $Description:	This function invokes the operation for writting the SerialNumber.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
int write_SerialNumber(UWORD8 *value)
{
    if(strlen((char *)value)<=8)
        memcpy(Ffs_const_data.serialnumber,value,strlen((char*)value));
    else
        memcpy(Ffs_const_data.serialnumber,value,8);

    flash_constdata_write();
    
	return( TRUE );
}

/*******************************************************************************

 $Function:    	read_SerialNumber

 $Description:	This function invokes the operation  for getting the SerialNumber.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
int read_SerialNumber(char *table)
{
    flash_constdata_read();
    memcpy(table,Ffs_const_data.serialnumber,8);
    table[8]=0;                 // Null teminator for the end of the string
	return( TRUE );
}

// Jeffrey, for production test, 04/06/04
short write_TestNumber(UWORD16 value)
{
	effs_t ret;
	
	ret = ffs_fwrite("/pcm/TestNum", (void*)&value, 2);
	return ret;
}

int read_TestNumber(short* value)
{
	int ret;
	
	ret = ffs_fread("/pcm/TestNum", value, 2);
	return ret;
}

/*******************************************************************************

 $Function:    	checksim

 $Description:	This function invokes the operation  for check the sim card.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
UWORD16 checksim()
{
	UWORD16 nret;
	nret=get_sim_status();
	
	return nret;
}

/*******************************************************************************

 $Function:    	checknetavail

 $Description:	This function invokes the operation  for check the net
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
UWORD16 checknetavail()
{
	UWORD8 nret;
	nret=get_net_status();

	return nret;

}

/*******************************************************************************

 $Function:    	ctrlcd

 $Description:	This function invokes the operation  for lcd
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
UWORD8 ctrlcd(UWORD16 value)
{
	/* Jeffrey modified this to use our own LCD backlight control API, 04/01/04 */
	switch(value)
	{
		case OFF://lcd off
			LedLightnessAdjust(0); 
			break;
		case ON://lcd on
			LedLightnessAdjust(255); 
			break;
		default:
			break;
	}
	return 1;

}

/*******************************************************************************

 $Function:    	ctrled

 $Description:	This function invokes the operation  for led
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
UWORD8 ctrled(UWORD16 value)
{

	switch(value)
	{
		case OFF://led off
			LED_OFF();
			break;
			
		case ON://led on
			LED_ON();
			break;
			
		default:
			break;
	}
	return 1;

}

/*******************************************************************************

 $Function:    	ctrbacklight

 $Description:	This function invokes the operation  for backlight
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
UWORD8 ctrbacklight(UWORD16 value)
{

	switch(value)
	{
		case OFF://backlight off
		Backlight_OFF();
			break;
		case ON://backlight on
		Backlight_ON();
			break;
		default:
			break;
	}
	return 1;

}

/*******************************************************************************

 $Function:    	ctrvibrator

 $Description:	This function invokes the operation  for vibrator
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
UWORD8 ctrvibrator(UWORD16 value)
{
	switch(value)
	{
		case OFF://vibrator off
			StopVibrator();
			break;
			
		case ON://vibrator on
			StartVibrator();
			break;
			
		default:
			break;
	}

	return 1;

}

/*******************************************************************************

 $Function:    	ctrbuzzer

 $Description:	This function invokes the operation  for buzzer
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
UWORD8 ctrbuzzer(UWORD16 value)
{

	switch(value)
	{
		case OFF://buzzer off
			StopTone();
			break;
		case ON://buzzer on
			StartTone();
			break;
		default:
			break;
	}
		

	return 1;

}


/*******************************************************************************

 $Function:    	key_simulation

 $Description:	This function invokes the operation  for key_simulation 
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
int key_simulation(UWORD8 size,UWORD8 *keycode)
{
	int i;
	for(i=0;i<size;i++){
//		drvKeyUpDown(0,keycode[i]);
		kbd_test(keycode[i]);
	}
	
	return( TRUE );

}

/*******************************************************************************

 $Function:    	read_rtc

 $Description:	This function invokes the operation  for getting the rtc.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
int read_rtc(char *table)
{



	return( TRUE );
}



/*******************************************************************************

 $Function:     excute_tim_cb

 $Description:  The  time out has occured 

 $Returns:    MFW_EVENT_CONSUMED always

 $Arguments:  e, event, tc timer context

*******************************************************************************/
static int excute_tim_cb( MfwEvt e, MfwTim *tc )
{
	char test[20];

  	int excuteret=0;
  	
  // stop running timer.
  if (tim != NULL ) {
    timStop(tim);
  }

	switch(command){
		case READ_SIM_PHB_CMD:
			excuteret=read_sim_phb_cb();
			break;

		case WRITE_SIM_PHB_CMD:
			excuteret=write_sim_phb_cb();
			break;
		case WRITE_NVM_PHB_CMD:
			excuteret=write_nvm_phb_cb();
			break;
		
		case READ_NEW_SMS_CMD:
		case READ_SIM_SMS_CMD:
			excuteret=read_sim_sms_cb();
			break;
		case SEND_SMS_CMD:
			excuteret=send_sms_cb();
			break;
			
		default:
			break;
	}
			//sprintf(test,"ret:%d",excuteret);
			//dspl_TextOut(8, 48, 0, test);
			
	timDelete(tim);
	
  return MFW_EVENT_CONSUMED;
  
}

/*******************************************************************************

 $Function:    	read_sim_phb

 $Description:	This function creat the timer and start to  excute.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/

int read_sim_phb(void)
{
	T_MFW_PHB_STATUS status;

	PcCmdStatus.isPcConect=1;
	//check if the sim cark ok
	if((phb_get_mode()==PHB_LOADING)||(phb_get_mode()==MFW_PHB_FAIL))
		return SIM_NOT_REDAY;
	
	tim		= timCreate(win,   100,         (MfwCb)excute_tim_cb);
	command	=READ_SIM_PHB_CMD;
	timStart(tim);
	PcCmdStatus.SimPhbNum=0;
	PcCmdStatus.NvmPhbNum=0;
	i=0;//sim phb data index in one file[0,19]
	InitPcCmdStatus();

	status.book=PHB_ADN;   
	if (phb_get_status(&status)==MFW_PHB_OK)
		PcCmdStatus.nsimphbmax=status.max_entries;
	
	return CMD_RET_OK;
}


/*******************************************************************************

 $Function:    	read_sim_phb_cb

 $Description:	This function invokes the operation  for creat the simphb file.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
static int read_sim_phb_cb(void)
{
	char	simpath[20];
	int 	j=0;//all phb data index
	int		unreadnum=0;
	T_MFW_PHB_ENTRY  l_phb_Shortentry;
char test[20];

MmiTrace("read_sim_phb_cb");
	Sim_PhbData=SimPhbDefaultData;
	
	memset(&l_phb_Shortentry,0,sizeof(T_MFW_PHB_ENTRY));

	//ֹsimæʱ
	if(PcCmdStatus.isPcCmdRun)
		return CMD_BUSY;
	
	PcCmdStatus.isPcCmdRun=1;
	
	//check if the sim cark ok
	if((phb_get_mode()==PHB_LOADING)||(phb_get_mode()==MFW_PHB_FAIL))
		return return_info(SIM_NOT_REDAY,NULL,0,NULL,0);
	
	if(SIMLoadingPhbk==FALSE){
		GetSIMData();
		SIMLoadingPhbk=TRUE;
	}
	MmiTrace("simTotal");
	MmiTraceInt(SIMTotal);
	
	PcCmdStatus.NvmPhbNum=NVMTotal;
	PcCmdStatus.SimPhbNum=SIMTotal;
	if (SIMTotal==0)
   		return return_info(NO_SIM_PHB,NULL,0,NULL,0);
	
	
	unreadnum=SIMTotal;
	for (j=0;j<PHBKTotal;j++)
	{
		if (l_phb_index[l_phb_sort_index[j].index].phonebook!=SIM_BOOK_SEL)
			continue;
		if (ReadSIMRecord(l_phb_sort_index[j].index,&l_phb_Shortentry)!=TRUE)
			continue;
		
		memcpy(Sim_PhbData.phbdata[i].Name,l_phb_Shortentry.name.data,21);
		memcpy(Sim_PhbData.phbdata[i].Number,l_phb_Shortentry.number,21); 
		unreadnum--;
		if((i==(MAXSIMPHBNUM-1))||(unreadnum==0)){
			i=-1;//for it will be add to 0 hxl changed 2002-12-12
			k++;
			//creat simphb file in the phone	
			sprintf(simpath,"/mmi/PhSimBf%d",k);
			if(ffs_fwrite(simpath,&Sim_PhbData,sizeof(Sim_PhbData) )<0)
				return return_info(FWRITE_FAIL,NULL,0,NULL,0);
			if(unreadnum==0){
				PcCmdStatus.NvmPhbNum=NVMTotal;
				PcCmdStatus.SimPhbNum=SIMTotal;
				return return_info(CMD_COMPLETE_OK,NULL,0,NULL,0);
			}else
				Sim_PhbData=SimPhbDefaultData;

		}
		i++;	

	}
	

	return return_info(CMD_RET_OK,NULL,0,NULL,0);
}

/*******************************************************************************

 $Function:    	write_nvm_phb_cb

 $Description:	This function creat the timer and start to  excute.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/

int write_nvm_phb_cb(void)
{
	int	noldfile=0;
	effs_t	effret=1;
	int	loop=3;
	int	nfile=0;
	MmiTrace("write_nvm_phb_cb");
	
	PcCmdStatus.isPcCmdRun=1;

	//ԭȵĺдĶ࣬Ҫļд0
    	noldfile= (NVMTotal%72)? ((NVMTotal/72)+1): NVMTotal/72;
	MmiTraceInt(noldfile);
	MmiTraceInt(PcCmdStatus.NvmPhbNum);
	
	while(noldfile-PcCmdStatus.NvmPhbNum>0){
		nfile=PcCmdStatus.NvmPhbNum++;
	MmiTrace("in");
		while((effret!=EFFS_OK)&&(loop>0)){
			effret=ffs_remove(PBTable[nfile]);
			if(effret!=EFFS_OK){
				Sleep_wait(100);
				loop--;
			}
		}
		ConfigPhbkReset();  
              flash_PBwrite(PBTable[nfile]);
              noldfile--;
	}
	
	NVMLoadingPhbk=FALSE;
	
	InitPcCmdStatus();

	return 1;
}

/*******************************************************************************

 $Function:    	write_sim_phb

 $Description:	This function creat the timer and start to  excute.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/

int write_sim_phb(void)
{
	//check if the sim cark ok
	if((phb_get_mode()==PHB_LOADING)||(phb_get_mode()==MFW_PHB_FAIL))
		return SIM_NOT_REDAY;
	
	SIMLoadingPhbk=FALSE; //ʹʱʾsimº
	
	tim		= timCreate(win,   100,         (MfwCb)excute_tim_cb);
	command	=WRITE_SIM_PHB_CMD;
	timStart(tim);

//	i=MAXSIMPHBNUM-1;//phb index in simphb file(0 19)
       i=MAXSIMPHBNUM;//chenjun changed ,0401,because we use Sim_PhbData.phbdata[i-1]
	
	InitPcCmdStatus();

	return 1;
}


/*******************************************************************************

 $Function:    	write_sim_phb_cb

 $Description:	This function invokes the operation  for update the simphb file.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
int write_sim_phb_cb(void)
{
	UWORD16 nret;
	effs_t ffsret;
	T_MFW mfwret;
	T_MFW_PHB_STATUS status;
	UBYTE	simphbnum;
	fd_t	fdret,fdi;
	char	simpath[20];
	static UBYTE	unwritenum=0;
	T_MFW_PHB_ENTRY entries;
	UBYTE	bookType=0;
	char test[10];
	UBYTE	j=0;
	

//	char buf[50];//chenjun for debug ,0331

	MmiTrace("in write_sim_phb_cb");

		
	//ֹsimæʱ
	if(PcCmdStatus.isPcCmdRun)
		return CMD_BUSY;
	
	PcCmdStatus.isPcCmdRun=1;

	//һִʱȽsim绰
	if(k==0){
		//delete the sim phb all,simԭΪʱָ
	  	status.book=PHB_ADN;   
	 	if (phb_get_status(&status)==MFW_PHB_OK)
	  	{
			OldNum=status.used_entries;//chenjun add 0331
	   		if (status.used_entries>0){
    				bookType= bookActiveBook(WRITE);
        			phb_delete_book(bookType);//chenjun add 0408				
	   		}
	 	}else
			return return_info(READ_SIM_PHB_FAIL,NULL,0,NULL,0);
		
		MmiTrace("PcCmdStatus.SimPhbNum");
		MmiTraceInt(PcCmdStatus.SimPhbNum);
        	
		if(PcCmdStatus.SimPhbNum==0)//chenjun del 0331
			{
			if (status.used_entries>0)                   //chenjun 0331 add this conditions
				{
				bookType= bookActiveBook(WRITE);//chenjun 0409
				if(phb_delete_book(bookType)==MFW_PHB_OK)
					{
//					  dspl_TextOut(8, 80, 0, "clear");
				         return CMD_RET_OK;
					}
				else return WRITE_SIM_PHB_FAIL; 
				}
			    //phb_delete_book(bookType);//chenjun 0331 del
			//return return_info(NO_SIM_PHB,NULL,0,NULL,0);//chenjun 0331 del
			}
		
		unwritenum=PcCmdStatus.SimPhbNum;//chenjun 0331,does this right when set it By tell_simphb_num()?

	//	memset(buf,0,50);
	//	sprintf(buf,"num %d",PcCmdStatus.SimPhbNum);
	//	dspl_TextOut(8, 64, 0, buf);
	}
	

#if 0	 //chenjun add 0408
	//ȫִ꣬˳
	if(unwritenum==0){
//		dspl_TextOut(8, 64, 0, "uwn=0");
		//ɾļ
	/*	if(k>0){
			MmiTrace("chenjun ffs_rm");
			sprintf(simpath,"/mmi/PhSimBf%d",k);
			ffs_remove(simpath);
		}
	*/  //chenjun 0331 move these code to the coming lines 		
		//ɾļ¼
	  	status.book=PHB_ADN;   
	 	if (phb_get_status(&status)==MFW_PHB_OK)
	  	{
		//	if(j=(status.max_entries-20*(k-1)-i-1)){//this is wrong, because i++ lead to j--, but j must ++ here ,chenjun 0331
	   	//	for (j=20*(k-1)+i+1;j<status.max_entries;j++){
	   	       j=(20*(k-1)+i+1);//chenjnu 0331 add
		       if(j<=OldNum/*status.max_entries*/){//chenjun 0331 add
//		              memset(buf,0,50);
//		              sprintf(buf,"j m %d,%d",j,OldNum/*status.max_entries*/);
//		              dspl_TextOut(8, 64, 0, buf);
        			if(phb_delete_entry(status.book, j, &status)!=MFW_PHB_OK)
						return WRITE_SIM_PHB_FAIL;				
				i++; 
				return CMD_RET_OK;//chenjun 0331,after this call, must call SetDelFlag()?    	      
			}
			else
			{
				k=0;
				i=MAXSIMPHBNUM;
//				dspl_TextOut(8, 64, 0, "end");
				MmiTrace("end");
			
				return return_info(CMD_COMPLETE_OK,NULL,0,NULL,0);
			}
	 	}
		else return return_info(READ_SIM_PHB_FAIL,NULL,0,NULL,0);	
//		return return_info(CMD_RET_OK,NULL,0,NULL,0);
		
	}
#endif    //chenjun add 0408

	


	//Ҫ򿪲ȡļ
//	if(i==(MAXSIMPHBNUM-1))//chenjun 0401 changed
      if(i==(MAXSIMPHBNUM ))     //chenjun ,i=0,save 1 i=1;...;i=18, save 19 i=19;but there is 20 entries
	{
		//ɾѶļ
/*		if(k>0)
		{
			sprintf(simpath,"/mmi/PhSimBf%d",k);
			ffs_remove(simpath);
		}
*///chenjun 0331 move these code to the coming lines 		
		//ļ
		k++;
		i=0;
		//read file 	
		Sim_PhbData=SimPhbDefaultData;		
		sprintf(simpath,"/mmi/PhSimBf%d",k);
 		if(ffs_fread(simpath,&Sim_PhbData, sizeof(Sim_PhbData))<0)
 			{
 			MmiTrace("Into ffs_fread failed");
			
			//ɾѶļ
		      if(k>0)
			        {
				     sprintf(simpath,"/mmi/PhSimBf%d",k);
				     ffs_remove(simpath);
			       }
			        return return_info(FREAD_FAIL,NULL,0,NULL,0);//chenjun add
 			}
		      if(k>0)
			        {
//			            sprintf(buf,"into k>0,rmf %d",k);
//			            MmiTrace(buf);
				     sprintf(simpath,"/mmi/PhSimBf%d",k);
				     ffs_remove(simpath);
			       }			        
	}

	
	//ļеļ¼һдsim20*(k-1)+i 
	i++;
	memset(&entries, 0, sizeof(entries));
	entries.book=PHB_ADN;
	entries.index=20*(k-1)+i;//does the index begin from 1?not 0?   
	memcpy(entries.name.data, Sim_PhbData.phbdata[i-1].Name, MAXNAMELEN);
	entries.name.len =wstrlen((char*)entries.name.data);
	memcpy(entries.number, Sim_PhbData.phbdata[i-1].Number, MAXNUMLEN);
	
	MmiTrace(entries.name.data);
	MmiTrace(entries.number);
	MmiTraceInt(entries.index);
	
	
	if(phb_store_entry(PHB_ADN,&entries,&status)!=MFW_PHB_OK)
		return return_info(WRITE_SIM_PHB_FAIL,NULL,0,NULL,0);
	unwritenum--;
//	dspl_TextOut(8, 100, 0, "uwn --");
	
	return CMD_RET_OK;
	
}


/*******************************************************************************

 $Function:    	tell_simphb_num

 $Description:	This function is pc tell phone,how many phb num need to write into sim card
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/

void tell_simphb_num(UWORD16 value)
{
MmiTrace("tell_simphb_num");
	PcCmdStatus.SimPhbNum=(UWORD8)value;
	MmiTraceInt(PcCmdStatus.SimPhbNum);

}

void tell_nvmphb_num(UWORD16 value)
{
MmiTrace("tell_nvmphb_num");
	PcCmdStatus.NvmPhbNum=(UWORD8)value;
	MmiTraceInt(PcCmdStatus.NvmPhbNum);
	
	InitPcCmdStatus();
	
	tim		= timCreate(win,   100,         (MfwCb)excute_tim_cb);
	command	=WRITE_NVM_PHB_CMD;
	timStart(tim);
}

int read_new_sms(void)
{
       
	MmiTrace("read_new_sms");
	i=0;  //smsҪ
	PcCmdStatus.nSimSmsFile=0;

	InitPcCmdStatus();
	
	//check if the sim cark ok
	if (!smsidle_get_ready_state())
		return return_info(SIM_NOT_REDAY,NULL,0,NULL,0);
	//ռ䣬ֵ
	if ( ( psmsidx = (T_MFW_SMS_IDX *) ALLOC_MEMORY(  memory.total*sizeof(T_MFW_SMS_IDX)) ) == NULL )
		return return_info( ALLOC_MEM_FAIL,NULL,0,NULL,0);
	if ( ( pWriteSmsdata = (UBYTE *) ALLOC_MEMORY( 1024) ) == NULL )
		return return_info( ALLOC_MEM_FAIL,psmsidx,  memory.total*sizeof(T_MFW_SMS_IDX),NULL,0);
	memset(psmsidx,0, memory.total*sizeof(T_MFW_SMS_IDX));
	memset(pWriteSmsdata,0,1024);
	
	//smsindex
	unreadsms=sms_index_list(MFW_SMS_UNREAD,psmsidx,MAX_MESSAGES);
	if(unreadsms==0){
		return return_info( NO_SIM_SMS,psmsidx,  memory.total*sizeof(T_MFW_SMS_IDX),pWriteSmsdata,1024);
	}
	//
	//SortSms(unreadsms,psmsidx);//T_MFW_SMS_MSGռ벻
		
	tim		= timCreate(win,   100,         (MfwCb)excute_tim_cb);
	command	=READ_NEW_SMS_CMD;
	timStart(tim);


	return CMD_RET_OK;
}

int read_sim_sms(void)
{
       
	MmiTrace("read_sim_sms");
	i=0;  //smsҪ
	PcCmdStatus.nSimSmsFile=0;

	PcCmdStatus.isPcConect=1;
	InitPcCmdStatus();
	
	//check if the sim cark ok
	if (!smsidle_get_ready_state())
		return return_info(SIM_NOT_REDAY,NULL,0,NULL,0);
	
MmiTraceInt(memory.total);
	if(memory.total==0)
		return return_info(NO_SIM_SMS,NULL,0,NULL,0);
	
	//ռ䣬ֵ
	if ( ( psmsidx = (T_MFW_SMS_IDX *) ALLOC_MEMORY( memory.total*sizeof(T_MFW_SMS_IDX)) ) == NULL )
		return return_info( ALLOC_MEM_FAIL,NULL,0,NULL,0);
	if ( ( pWriteSmsdata = (UBYTE *) ALLOC_MEMORY( 1024) ) == NULL )
		return return_info( ALLOC_MEM_FAIL,psmsidx,memory.total*sizeof(T_MFW_SMS_IDX),NULL,0);
	memset(psmsidx,0,memory.total*sizeof(T_MFW_SMS_IDX));
	memset(pWriteSmsdata,0,1024);
	
	//smsindex
	unreadsms=sms_index_list(MFW_SMS_ALL,psmsidx,memory.total);
	if(unreadsms==0){
		return return_info( NO_SIM_SMS,psmsidx,memory.total*sizeof(T_MFW_SMS_IDX),pWriteSmsdata,1024);
	}
	//
	//SortSms(unreadsms,psmsidx);//T_MFW_SMS_MSGռ벻

	PcCmdStatus.nsimsmsmax=memory.total;
	tim		= timCreate(win,   100,         (MfwCb)excute_tim_cb);
	command	=READ_SIM_SMS_CMD;
	timStart(tim);


	return CMD_RET_OK;
}



/*******************************************************************************

 $Function:    	read_sim_sms_cb

 $Description:	This function invokes the operation  for creat the simphb file.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
static int read_sim_sms_cb(void)
{
	char	simpath[20];
	int 	j=0;//all phb data index
	T_MFW	mfwret=MFW_SMS_FAIL;
	UBYTE	idx=0;
char test[20];

MmiTrace("read_sim_sms_cb");
	//ֹsimæʱ
	if(PcCmdStatus.isPcCmdRun)
		return  CMD_BUSY;
	
	PcCmdStatus.isPcCmdRun=1;
	
	//check if the sim cark ok
	if (!smsidle_get_ready_state())
		return return_info(SIM_NOT_REDAY,psmsidx,memory.total*sizeof(T_MFW_SMS_IDX),pWriteSmsdata,1024);

	//ʱдļ
	if(unreadsms==0){
		write_sms_file();
//		dspl_TextOut(6, 6, 0, "pos 1");//chenjun 0409
		totallen=0;
	//	if(command	==READ_NEW_SMS_CMD)
	//		PcCmdStatus.nNewsms=0;//hxl&chj  0409 del for PCSync
		return return_info(CMD_COMPLETE_OK,psmsidx,memory.total*sizeof(T_MFW_SMS_IDX),pWriteSmsdata,1024);
	}

	while(mfwret==MFW_SMS_FAIL)
	{
		//psmsidx++;
		idx=(&psmsidx[i])->index;//psmsidx->index;
		mfwret=sms_read(MFW_SMS_MESSAGE,idx);
		
		MmiTrace("readsms");
		MmiTraceInt( i);
		MmiTraceInt(idx);

		MmiTraceInt(mfwret);

		unreadsms--;
		i++;
		if((unreadsms==0)&&(mfwret==MFW_SMS_FAIL)){
			write_sms_file();
			
			totallen=0;
	//		if(command	==READ_NEW_SMS_CMD)
	//			PcCmdStatus.nNewsms=0;//chenjun 0409 del for PCSync
			return return_info(CMD_COMPLETE_OK,psmsidx,memory.total*sizeof(T_MFW_SMS_IDX),pWriteSmsdata,1024);
		}
	}
	

	return CMD_RET_OK;
}


void Get_sms_info(const char *info,void *adr, void * t,void *scaddr,int errStatus) 
{
       UINT16 year,month,day,hour,minute,second;
       char		date[18];
       char		other[5];
	int		len=0;
	char		readdata[600];
	char 	*preaddata=&readdata[0];
	int		m=0;
	T_MFW_SMS_ADDR	*addr=(T_MFW_SMS_ADDR *)adr;
	T_MFW_SMS_SCTP *time=(T_MFW_SMS_SCTP *)t;
char test[80];
	MmiTrace("Get_sms_info");
	if(errStatus){
		read_sim_sms_cb();
		return;
	}

	//ֵתΪASII
	year=time->year[0]%13*10+time->year[1]%13;
	month=time->month[0]*10+time->month[1]%13;
	day=time->day[0]*10+time->day[1]%32;
	hour=time->hour[0]*10+time->hour[1]%24;
	minute=time->minute[0]%60*10+time->minute[1]%60;
	second=time->second[0]%60*10+time->second[1]%60;
       memset(date,0,18);
	sprintf(date,"%2d-%2d-%2d %2d:%2d:%2d",
		year,month,day,hour,minute,second);
	sprintf(other,"%d%d%d%d"
		,(&psmsidx[i-1])->stat
		,addr->ton
		,addr->npi
		,(&psmsidx[i-1])->index);
	MmiTrace("index");
	MmiTraceInt((&psmsidx[i-1])->index);

	//readdataУΪlen
	memset(readdata,0,600);
	len+=hstrcpy(preaddata+len,date);
	len+=hstrcpy(preaddata+len,addr->number);
	len+=hstrcpy(preaddata+len,info);
	len+=hstrcpy(preaddata+len,scaddr);
	len+=hstrcpy(preaddata+len,other);
	
	
	//ԭȵѹһļȣдļ
	if((totallen+len)>1024){
		write_sms_file();
		memset(pWriteSmsdata,0,1024);
		totallen=0;
	}

	memcpy(pWriteSmsdata+totallen,readdata,len);
	totallen+=len;

	if((&psmsidx[i-1])->stat ==MFW_SMS_UNREAD)
		sms_change_read_status( (&psmsidx[i-1])->index);

	
	read_sim_sms_cb();//һ
	
}


static void	write_sms_file(void)
{
	
	char	path[20];
	
	MmiTrace("write_sms_file");
	
	k++;
	//creat simphb file in the phone	
	sprintf(path,"/mmi/PhonMf%d",k);
	if(ffs_fwrite(path,pWriteSmsdata,1024 )>=0)
		PcCmdStatus.nSimSmsFile+=1;

	k=PcCmdStatus.nSimSmsFile;
	
	MmiTraceInt(k);
}

/*******************************************************************************

 $Function:    del_sim_sms

 $Description:	This function creat the timer and start to  excute.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/

int del_sim_sms(UWORD16 value)
{
	//check if the sim cark ok
	if (!smsidle_get_ready_state())
		return SIM_NOT_REDAY;
	InitPcCmdStatus();
	
	PcCmdStatus.isPcCmdRun=1;
	sms_msg_delete((UWORD8)value);

	return return_info(CMD_RET_OK,NULL,0,NULL,0);
}

/*******************************************************************************

 $Function:    change_sim_sms

 $Description:	This function creat the timer and start to  excute.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/

int change_sim_sms(UWORD16 value)
{
	//check if the sim cark ok
	if (!smsidle_get_ready_state())
		return SIM_NOT_REDAY;
	InitPcCmdStatus();
	
	PcCmdStatus.isPcCmdRun=1;
	sms_change_read_status((UWORD8)value);

	return return_info(CMD_RET_OK,NULL,0,NULL,0);
}

void tell_smsFile_num(UWORD16 value)
{
MmiTrace("tell_smsFile_num");
	
	PcCmdStatus.nSimSmsFile=(UWORD8)value;
	MmiTraceInt(PcCmdStatus.nSimSmsFile);

}




/*******************************************************************************

 $Function:    send_sms

 $Description:	This function creat the timer and start to  excute.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/

int send_sms(void)
{
	//check if the sim cark ok
	if (!smsidle_get_ready_state())
		return SIM_NOT_REDAY;
	
	if ( ( pReadSmsdata = (char *) ALLOC_MEMORY( 1024) ) == NULL )
		return return_info( ALLOC_MEM_FAIL,NULL,0,NULL,0);
	if((psenddata=(T_MFW_SMS_MO *)ALLOC_MEMORY(	sizeof(T_MFW_SMS_MO)))==NULL)
		return return_info( ALLOC_MEM_FAIL,pReadSmsdata,1024,NULL,0);
	
	InitPcCmdStatus();
	totallen=0;
	
	tim		= timCreate(win,   100,         (MfwCb)excute_tim_cb);
	command	=SEND_SMS_CMD;
	timStart(tim);


	return CMD_RET_OK;
}


/*******************************************************************************

 $Function:    	send_sms_cb

 $Description:	This function invokes the operation  for creat the simphb file.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
int send_sms_cb(void)
{
	char	simpath[20];
char test[80];

MmiTrace("send_sms_cb");
	//ֹsimæʱ
	if(PcCmdStatus.isPcCmdRun)
		return CMD_BUSY;
	
	PcCmdStatus.isPcCmdRun=1;
	
	//check if the sim cark ok
	if (!smsidle_get_ready_state())
		return return_info(SIM_NOT_REDAY,pReadSmsdata,1024,psenddata,sizeof(T_MFW_SMS_MO));
	
	//Ϊһζļ׼
	if(k==0)
		memset(pReadSmsdata,0,1024);

	if(get_data_and_send()<0){
		MmiTrace("getdata<0");
		if(k==PcCmdStatus.nSimSmsFile){
			MmiTrace("k=nsimsmsfile");
			if(k>0){
				sprintf(simpath,"/mmi/PhonMf%d",k);
				ffs_remove(simpath);
			}
			return return_info(CMD_COMPLETE_OK,pReadSmsdata,1024,psenddata,sizeof(T_MFW_SMS_MO));
		}
		
		//ļ
		if(totallen==0){
			memset(pReadSmsdata,0,1024);
			//ɾϵļ
			if(k>0){
				sprintf(simpath,"/mmi/PhonMf%d",k);
				ffs_remove(simpath);
			}
			k++;
			sprintf(simpath,"/mmi/PhonMf%d",k);
 			if(ffs_fread(simpath,pReadSmsdata, 1024)<0)
				return return_info(FREAD_FAIL,pReadSmsdata,1024,psenddata,sizeof(T_MFW_SMS_MO));
 			MmiTrace("freadfile");
 			MmiTraceInt(k);
		}

		if(get_data_and_send()<0){
			MmiTrace("getda<0");
			if(k>0){
				sprintf(simpath,"/mmi/PhonMf%d",k);
				ffs_remove(simpath);
			}
			return return_info(NO_SIM_SMS,pReadSmsdata,1024,psenddata,sizeof(T_MFW_SMS_MO));
		}
	}
	else{
		MmiTrace("getdata>=0");
	}

	return CMD_RET_OK;
}

static int get_data_and_send(void)
{
	TPhoneSmsItem	readdata;
	T_MFW_SMS_INFO	sms_parameter;
	USHORT outLen;
	char other[5] ;
	UBYTE*	pstrinfo;

	MmiTrace("get_data_and_send");
	
	memset(&readdata,0,sizeof(TPhoneSmsItem));
	//ȡһ¼
	totallen+=hstrcpy(readdata.date,pReadSmsdata+totallen);
	MmiTraceInt(totallen);
	totallen+=hstrcpy(readdata.Number,pReadSmsdata+totallen);
	totallen+=hstrcpy(readdata.info,pReadSmsdata+totallen);
	totallen+=hstrcpy(readdata.sc_addr,pReadSmsdata+totallen);
	totallen+=hstrcpy(other,pReadSmsdata+totallen);
	readdata.type=other[0];
	readdata.ton=other[1];
	readdata.npi=other[2];
	readdata.index=other[3];
	//жǷ
       if((readdata.info[0]=='\0')&&(readdata.Number[0]=='\0')){
		totallen=0;
		return -1;
       }

	pstrinfo = mmi_Sys_Sim((char *)readdata.info, &outLen,&(sms_parameter.dcs));
	SmsSend_set_dcs_number (&sms_parameter);
			
	//дṹ
	memset(psenddata,0,sizeof(T_MFW_SMS_MO));

	psenddata->msg_len=outLen;
	wstrcpy(psenddata->sms_msg,(char *)readdata.info );
	strcpy(psenddata->dest_addr.number,readdata.Number );
	strcpy(psenddata->sc_addr,readdata.sc_addr);
               	
			
	sms_submit(MFW_SMS_SUBMIT,psenddata->dest_addr.number,(UBYTE *)pstrinfo,psenddata->msg_len,psenddata->sc_addr);			

	return 0;	
}

void save_send_sms(T_MFW_SMS_MO_TYPE type)
{
	T_MFW_SMS_INFO	sms_parameter;
	USHORT outLen;
	UBYTE*	pstrinfo;
	MmiTrace("save_send_sms");
	MmiTraceInt(type);
	
	pstrinfo = mmi_Sys_Sim((char *)psenddata->sms_msg, &outLen,&(sms_parameter.dcs));
	SmsSend_set_dcs_number (&sms_parameter);
	
	sms_store( type, psenddata->dest_addr.number, (UBYTE *)pstrinfo, psenddata->msg_len, NULL);
	command=SAVE_SEND_SMS;
	
	PcCmdStatus.isPcCmdRun=1;
	
}

int hstrcpy( char *d,const char *r)
{
	int size;

	size=hstrlen(r);
	memcpy(d,r,size);

	return size;
}

int hstrlen(const char * txt)
{
	int lenth=0;
	unsigned char * ss=(unsigned char*)txt;

	if(*ss==0x80)//if unicode
	{
		ss++;
		lenth++;
		while((*ss<<8)+*(ss+1)!=0)
		{
			lenth+=2;
			ss+=2;
		}
		lenth+=2;//add two zero
	}
	else//if ascii
	{
		while(*ss++!=0)
			lenth++;
		lenth+=1;//add one zero

	}

	return lenth;
}

/*******************************************************************************

 $Function:    	IsExcutefileEnd

 $Description:	This function check the operation  for excute file before.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
UWORD8 IsPcCmdExcuteEnd(char *value)
{
	T_MFW_SMS_IDX 	smsidx[MAX_MESSAGES];//smsĴ洢index T_MFW_SMS_MSG
	MmiTrace("IsPcCmdExcuteEnd()");

	PcCmdStatus.nNewsms=(UWORD8)(sms_index_list(MFW_SMS_UNREAD,smsidx,1));
	memcpy(value,(char *)&PcCmdStatus,sizeof(PCCMDSTATUS));
	
	return sizeof(PCCMDSTATUS);
}

static void InitPcCmdStatus(void)
{
	PcCmdStatus.isPcCmdRun=0;
	PcCmdStatus.isdelsmsok=0;
	PcCmdStatus.iscmdreterr=0;
	k=0;
}

static int	return_info(int ret,void *p1,int p1len,void *p2,int p2len)
{	
	PcCmdStatus.isPcCmdRun=0;//ִнʱñ־
	k=0;
	i=0;

	if(p1!=NULL)
		FREE_MEMORY( p1,  p1len);
	if(p2!=NULL)
		FREE_MEMORY(p2,p2len);
	
	return ret;
}

void Sleep_wait(unsigned short times) //waiting....
{
    unsigned short i=0;
    unsigned short endtimes = times*10;
    
    for(i=0; i<=endtimes; i++)
    	{
    	}
}


