#ifndef _DEF_BMI_DICTFUNC_H_
#define _DEF_BMI_DICTFUNC_H_
/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Supplementary services
 $File:		    Mmidictfunc.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		hxl(Mobile Innovation)                                                         
 $Date:		    28/06/02                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This module provides the supplementary services functionality

  
********************************************************************************
 $History: Mmidictfunc.h

	01/08/02 			huangxl creat.	
	   
 $End

*******************************************************************************/
extern int dict_english_find(char*w);
extern int dict_chinese_find_first(char* w);
extern int dict_chinese_find_next(char* w);
extern int dict_chinese_find_back(char* w);
extern  char dict_book(int index);
extern  char* dict_eng(int index);
extern  char* dict_yb(int index);
extern  char* dict_chn(int index);
extern int dict_getTotalByBook(char book);
extern int dict_getWordByBook(int index,char book);
extern int dict_chinese_find_total(const char* w,signed short  *idx);

#define BOOK_SCHOOL 0x01
#define BOOK_CET4    0x02
#define BOOK_CET6	 0x04
#define	BOOK_GRADUATE  0x08
#define BOOK_TOEFL    0x10 //0x08
#define BOOK_GRE		0x20//0x10 
#define	BOOK_BUSINESS	  0x40
#define	BOOK_MBA		0x80

#endif


