/********************************************************************************  
					CONDAT (UK)

/********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Schedule
 $File:		    Mmischedule.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the start code for the MMI
                        
********************************************************************************
 $History: MmiStart.h

	25/10/00			Original Condat(UK) BMI version.
	14/08/02            gdy add
	27/08/02            gdy add
	   
 $End

*******************************************************************************/
//#include "td.h"
#ifndef _MMISCHEDULE_H
#define _MMISCHEDULE_H 1

typedef enum
{
ONCE=0,
EVERYDAY,
WEEKLY,
EVERYMONTH,
ANNUALLY
}frequency_mode;

typedef enum
{
  MEETING=0,
  BIRTHDAY,
  APPOINTMENT,
  PHONE,
  REMIND
}type_list;


T_MFW_HND calin_start(T_MFW_HND parent_win);
int type_once(MfwMnu* m, MfwMnuItem* i);
int type_day(MfwMnu* m, MfwMnuItem* i);
int type_week(MfwMnu* m, MfwMnuItem* i);
int type_month(MfwMnu* m, MfwMnuItem* i);
int type_year(MfwMnu* m, MfwMnuItem* i);
extern int calinder(MfwMnu* m, MfwMnuItem* i);
extern int NewSche(MfwMnu* m, MfwMnuItem* i);
extern int TodaySche(MfwMnu* m, MfwMnuItem* i);
extern int AllSche(MfwMnu* m, MfwMnuItem* i);
extern int DeleteOld(MfwMnu* m, MfwMnuItem* i);
extern int DeleteAll(MfwMnu* m, MfwMnuItem* i);
extern int meeting(MfwMnu* m, MfwMnuItem* i);
extern int birthday(MfwMnu* m, MfwMnuItem* i);
extern int appointment(MfwMnu* m, MfwMnuItem* i);
extern int remind(MfwMnu* m, MfwMnuItem* i);
extern int phone(MfwMnu* m, MfwMnuItem* i);
int ScheChange(MfwMnu* m, MfwMnuItem* i);
int ScheSMS(MfwMnu* m, MfwMnuItem* i);
int ScheDelete(MfwMnu* m, MfwMnuItem* i);
extern void ScheInit();
extern void ScheMemoRead();
void scheDataDisplay(FlashSchedule * data);
//game_Line setLine(int x1,int y1,int x2,int y2,int color);

#endif
