/************************************************************************
 *                                                                      *
 *  ļ:   cam_api.h                                                   *
 *                                                                      *
 *  :   camera ײӿ                                         *    
 *                                                                      *
 *  ʷ:   2004.7.23       WYJ         ʼ汾                    *
 *                                                                      *
 *                                                                      *
 ************************************************************************/
#ifndef _CAM_API_H
#define _CAM_API_H

/*talcon modified*/
    #include "topc.h"
    #include "halAPI.h"
    #include "camera.h"

//typedef unsigned char   CAMU8;
//typedef unsigned short  CAMU16;
//typedef unsigned int    CAMU32;


#define LCDWIDTH 128
#define LCDHEIGHT 128

#define CAMERAWIDTH 640
#define CAMERAHEIGHT 480

#define USINGSCALERATE 3

enum
{
    R2D_REFRESH_ENABLE,
    R2D_REFRESH_DISABLE,
};

typedef enum tagImageQuality
{
    IQ_HIGH = 0,
    IQ_MIDIUM,
    IQ_LOW,      
}ImageQuality;


typedef enum tagCLC346_PreviewSize
{
    S128120=0,
    QQVGA,
    QVGA,
    VGA,
    ANYSIZE_MODE
}CLC346_PREVIEWSIZE;

typedef enum tagImgEffecType
{
IF_NORMAL,
IF_MIRROR
}IMAGE_EFFECT_MODE;

typedef enum tagImgRotationType
{
RT_NORMAL,
RT_90,
RT_180,
RT_270
}IMAGE_ROTATION_TYPE;

typedef enum tagCLC346_ShotType
{
    SINGLE_SHOT=0,
    MULTI_SHOT,
    OSD_SHOT,
    MOVIE_SHOT,
    MOVIE_DECODE
}CLC346_SHOTTYPE;

//==============================================================
//  CAMEXT Structure
//==============================================================
typedef struct tagCAMEXT
{   
    CAMU16       m_nCurMode;    
    CAMU16       m_nCurSize;
    CAMU16       m_nCurEffect;
    CAMU16       m_nCurRotationType;
    CAMU16       m_nJPEGQFactor; 

   // 2004.7.8 WYJ ADD 
    int  refresh;
    int  contrast;
    int  bright;
    int  color;
    int  zoom;
    CAMU16 *pOSD_Mask;
}CAMEXT,*pCAMEXT;





#endif
