
//	2004.6.1 WYJ add for encrypt  _ENCRYPT


#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#if defined (NEW_FRAME)

	#include "typedefs.h"
	#include "vsi.h"
	#include "pei.h"
	#include "custom.h"
	#include "gsm.h"

#else  /* NEW_FRAME */

	#include "stddefs.h"
	#include "custom.h"
	#include "gsm.h"
	#include "vsi.h"

#endif /* NEW_FRAME */

#include "Mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "Mfw_cm.h"
#include "dspl.h"
#include "MmiMmi.h"
#include "MmiMain.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiCall.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiResources.h"
#include "MmiBlkLangDB.h"
#include "MmiBookUtils.h"
#include "MmiEditor.h"
#include "MmiEditor_i.h"
#include "MmiBookshared.h"
#include "mmiSmsMenu.h"
#include "Mmismssend.h"
#include "mmiutilapi.h"

#include "mmidialogs.h"
#include "mmitextinput.h"


#include "encrypt.h"


/* ¼ */
#define	ENCRYPT_INIT			1			// ½
#define	ENCRYPT_DESTROY		2			// 


// 
typedef struct
{
	T_MMI_CONTROL   mmi_control;
	T_MFW_HND       	parent_win;
	T_MFW_HND       	win;
	T_MFW_HND       	kbd;
	T_MFW_HND       	edit_win;				
    	T_EDITOR_DATA   edit_data;				// ༭ 
    	char				name[11];
} T_ENCRYPT_DATA;//wyj


extern T_idle idle_data;                       


static  	T_MFW_HND 	Encrypt_Create (T_MFW_HND parent_win);
static 	void 		Encrypt_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static 	int 			Encrypt_win_cb(T_MFW_EVENT event, T_MFW_WIN * win);
static 	int 			Encrypt_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
static 	int 			Encrypt_Destroy (T_MFW_HND win);


static	void 		Set_New_Editor(T_MFW_HND win);
static 	void			New_EditorCB( T_MFW_HND win,USHORT Identifier,UBYTE reason);


T_ENCRYPT	Encrypt_ffs;		//ffs 
char key_input[10];
char key_flash[10];
char imei_temp[15];
char imei_front[8];
char imei_back[9];
char encrypt_result[20];
char encrypt[20];

long int key_input_long;
long int key_flash_long;
long int imei_front_long;
long int imei_back_long;

/* 2004/06/08, zhq, add for production test purpose. */
extern unsigned short gl_mainboardtype;


/* 2004/06/08, zhq, add for production test purpose. */
unsigned short Set_Encrypt_Key_MMI(unsigned short encrypt_key)
{
	
	T_FFS_STAT 	s;	
	int			status;	
	/* ݵEncrypt_ffs */
	status = ffs_stat("/mmi/mi", &s);
	if(status != EFFS_NOTFOUND)			// 
	{
	status = ffs_fread("/mmi/mi", &Encrypt_ffs, sizeof(T_ENCRYPT));
	Encrypt_ffs.a = encrypt_key;	/* zhq, max 65536. */
	status = ffs_fwrite("/mmi/mi", &Encrypt_ffs, sizeof(T_ENCRYPT));
	}
	else								// һʼļ
	{
	memset(&Encrypt_ffs, 0, sizeof(T_ENCRYPT));
	Encrypt_ffs.a = encrypt_key;	/* zhq, max 65536. */
	status = ffs_fwrite("/mmi/mi", &Encrypt_ffs, sizeof(T_ENCRYPT));
	}
	return status;
}

unsigned short Get_Encrypt_Key_MMI(unsigned short* encrypt_key)
{
	
	T_FFS_STAT 	s;	
	int			status;	
	/* ݵEncrypt_ffs */
	status = ffs_stat("/mmi/mi", &s);
	if(status != EFFS_NOTFOUND)			// 
	{
	status = ffs_fread("/mmi/mi", &Encrypt_ffs, sizeof(T_ENCRYPT));
	*encrypt_key = (unsigned short)Encrypt_ffs.a;	/* zhq, max 65536. */
	}
	else								// һʼļ
	{
	memset(&Encrypt_ffs, 0, sizeof(T_ENCRYPT));
	*encrypt_key = (unsigned short)Encrypt_ffs.a ;	/* zhq, max 65536. */
	status = ffs_fwrite("/mmi/mi", &Encrypt_ffs, sizeof(T_ENCRYPT));
	}
	return status;
}

/* 2004/06/08, zhq, add for production test purpose. */
unsigned short Set_MainboardType_MMI(unsigned short MainboardType)
{
	
	T_FFS_STAT 	s;	
	int			status;	
	/* ݵgl_mainboardtype */
	status = ffs_stat("/mmi/MainboardType", &s);
	if(status != EFFS_NOTFOUND)			// 
	{
	status = ffs_fread("/mmi/MainboardType", &gl_mainboardtype, sizeof(gl_mainboardtype));
	gl_mainboardtype = MainboardType;	/* zhq, max 65536. */
	status = ffs_fwrite("/mmi/MainboardType", &gl_mainboardtype, sizeof(gl_mainboardtype));
	}
	else								// һʼļ
	{
	gl_mainboardtype = MainboardType;	/* zhq, max 65536. */
	status = ffs_fwrite("/mmi/MainboardType", &gl_mainboardtype, sizeof(gl_mainboardtype));
	}
	return status;
}

/* 2004/06/08, zhq, add for production test purpose. */
unsigned short Get_MainboardType_MMI(unsigned short* MainboardType)
{
	
	T_FFS_STAT 	s;	
	int			status;	
	/* ݵgl_mainboardtype */
	status = ffs_stat("/mmi/MainboardType", &s);
	if(status != EFFS_NOTFOUND)			// 
	{
	status = ffs_fread("/mmi/MainboardType", &gl_mainboardtype, sizeof(gl_mainboardtype));
	*MainboardType = gl_mainboardtype;	/* zhq, max 65536. */
	}
	else								// һʼļ
	{
	gl_mainboardtype = 0;  //MAINBOARD_188	/* zhq, default to M188. */
	*MainboardType = gl_mainboardtype;	/* zhq, max 65536. */
	status = ffs_fwrite("/mmi/MainboardType", &gl_mainboardtype, sizeof(gl_mainboardtype));
	}
	return status;
}

int Encrypt_Main()
{
T_MFW_HND 	parent 	= mfwParent( mfw_header());
T_MFW_HND 	win 	= Encrypt_Create(parent);
T_FFS_STAT 	s;	
int			status;		


	/* ݵEncrypt_ffs */
	status = ffs_stat("/mmi/mi", &s);
	if(status != EFFS_NOTFOUND)			// 
	{
		status = ffs_fread("/mmi/mi", &Encrypt_ffs, sizeof(T_ENCRYPT));
	}
	else								// һʼļ
	{
		memset(&Encrypt_ffs, 0, sizeof(T_ENCRYPT));
		status = ffs_fwrite("/mmi/mi", &Encrypt_ffs, sizeof(T_ENCRYPT));
	}

   	if(win NEQ NULL)
   	{
   	  	SEND_EVENT(win, ENCRYPT_INIT, 0, 0);
   	}
   	return 1;
}


T_MFW_HND 		Encrypt_Create (T_MFW_HND parent_win)
{
T_MFW_WIN	*win;
T_ENCRYPT_DATA	*data = (T_ENCRYPT_DATA *)ALLOC_MEMORY (sizeof (T_ENCRYPT_DATA));

	data->win = win_create(parent_win, 0, MfwWinVisible, (T_MFW_CB)Encrypt_win_cb);
	
	if (data->win EQ 0)
		return 0;

	data->kbd = kbd_create (data->win, KEY_ALL, (T_MFW_CB)Encrypt_kbd_cb);
	data->edit_win = NULL;
	
	/* Create window handler */
	data->mmi_control.dialog    = (T_DIALOG_FUNC)Encrypt_DialogCB;/* dialog main function    */
	data->mmi_control.data      = data;
	data->parent_win 			= parent_win;
	win                         = ((T_MFW_HDR *)data->win)->data;
	win->user                   = (void *) data;
	
	/* return window handle	*/
	return data->win;
}


/* ¼ */
static void Encrypt_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
T_ENCRYPT_DATA      *data           = (T_ENCRYPT_DATA *)win_data->user;


	switch(event)
	{
	case  	ENCRYPT_INIT:
		/* ༭ */
		Set_New_Editor(win);
        	data->edit_data.Callback          = (T_EDIT_CB)New_EditorCB;

        	if( data->edit_data.mode == TEXTINPUT_MODE )
            		data->edit_win = text_input(win, &(data->edit_data));
        	else
            		data->edit_win = editor_start(win, &(data->edit_data));

		break;	

	case	ENCRYPT_DESTROY:
		// Ԥ
		Encrypt_Destroy(win);
		break;
	}
}


/* ʾص */
static int Encrypt_win_cb(T_MFW_EVENT event, T_MFW_WIN * win)
{
T_ENCRYPT_DATA	   *data = (T_ENCRYPT_DATA *)win->user;  

	switch(event)
	{
	case  MfwWinVisible:
		dspl_ClearAll();
		dspl_TextOut(0, 0, 0, (char *)encrypt);
		return MFW_EVENT_REJECTED;

	default:
		return MFW_EVENT_REJECTED;
	}

	return MFW_EVENT_CONSUMED;
}


/* ڰص */
static int Encrypt_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
T_MFW_HND		win			= mfw_parent(mfw_header());
T_MFW_WIN		*win_data	= ((T_MFW_HDR *)win)->data;
T_ENCRYPT_DATA		*data		= (T_ENCRYPT_DATA*)win_data->user; 

	switch (keyboard->code)
	{
	default:
		Encrypt_Destroy(win);
		break;
	}

	return MFW_EVENT_CONSUMED;
}

static int Encrypt_Destroy (T_MFW_HND win)
{
T_MFW_WIN        *win_data   = ((T_MFW_HDR *)win)->data;
T_ENCRYPT_DATA       *data       = (T_ENCRYPT_DATA *)win_data->user;			

	kbd_delete(data->kbd);				// Delete keyboard handlers
	win_delete(win);					// Delete window

	FREE_MEMORY((UBYTE *)data, sizeof(T_ENCRYPT_DATA));		// Destroy data structure

	return 1;
}


/* ֱ༭ */
static	void Set_New_Editor(T_MFW_HND win)
{
T_MFW_WIN       *win_data   = ((T_MFW_HDR *)win)->data;
T_ENCRYPT_DATA		*data 		= (T_ENCRYPT_DATA *)win_data->user;   
	
    memset((char*)data->name, 0, 11);
    editor_attr_init_fullscr(&((data->edit_data).editor_attr), 1,TxtSmsEnterNumber, (char*)data->name, 11, edtCurBar1);   
    data->edit_data.hide              = FALSE;
    data->edit_data.min_enter         = 1;  // Avoid returning empty strings
	
    data->edit_data.Identifier        = 0xFFFF ; 
    data->edit_data.TextString        = NULL;  
    data->edit_data.timeout           = FOREVER;  // Avoid returning empty strings
    data->edit_data.destroyEditor     = TRUE;
	
    data->edit_data.TextId            = '\0';                                                
    data->edit_data.LeftSoftKey       = TxtSoftConfirm;//comfirm
	
    data->edit_data.AlternateLeftSoftKey  = TxtNull;
    data->edit_data.RightSoftKey      = TxtDelete;
    data->edit_data.mode              = SHUZI_MODE;       
    data->edit_data.InputMode         = SHUZI_INPUT_MODE;    
	
}
void encrypt_main();
/* ༭ص */
static 	void New_EditorCB( T_MFW_HND win,USHORT Identifier,UBYTE reason)
{
T_MFW_WIN       *win_data   = ((T_MFW_HDR *)win)->data;
T_ENCRYPT_DATA   	*data       = (T_ENCRYPT_DATA *)win_data->user;  
char			test[100];
int			status;		


    switch( reason )
    {
    case INFO_KCD_LEFT: 

	     	memset(encrypt_result,0,sizeof(encrypt_result));
          	memset(encrypt,0,sizeof(encrypt));
	  	memset(key_input,0,sizeof(key_input));
	  	memcpy(key_input,data->name, sizeof(key_input));

		if(Encrypt_ffs.counter >= 100 || Encrypt_ffs.during_time > 1*3600)//shiheng 0605 modify
		{
			memset(encrypt,  '0',  sizeof(encrypt));
			encrypt[16] = 0;
			winShow(win);
			return;
		}
        /*
		if(Encrypt_ffs.counter == 0)
			key_flash_long = Encrypt_ffs.a;
		else if(Encrypt_ffs.counter == 1)
			key_flash_long = Encrypt_ffs.b;
		else if(Encrypt_ffs.counter == 2)
			key_flash_long = Encrypt_ffs.c;
		*///shiheng 0605 delete
        key_flash_long = Encrypt_ffs.a;//shiheng 0605 add
		
	 	
		
        memset(imei_temp,0,sizeof(imei_temp));
	  	get_imei((char*)idle_data.imei);
	  	
		memcpy(imei_temp,(char*)idle_data.imei,15);
		
	  	memset(imei_front,0,sizeof(imei_front));
	  	memset(imei_back,0,sizeof(imei_back));
	  	encrypt_main();
		
		Encrypt_ffs.counter++;

		status = ffs_fwrite("/mmi/mi", &Encrypt_ffs, sizeof(T_ENCRYPT));
			
		winShow(win);
		//Encrypt_Destroy (win);
		break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
		Encrypt_Destroy (win);
		break;
    }
}







//extern void encrypt_main();

long int key_input_long;
long int key_flash_long;
long int imei_front_long;
long int imei_back_long;


long int StringToNum(char *string1)
{
   int i;
   int stringLen;
   long int temp_result=0;
  
   stringLen=strlen(string1);
   
   for(i=0;i<stringLen;i++)
   {
     temp_result=temp_result*10+(string1[i]-0x30);
   }
   
   return temp_result;
  
}
void NumToStr(unsigned int num)
{
    
	long int num_1;
	int num_2;
	char char1;
	char char2[15]={0};
	int i=0;
	while (num!=0)
	{
		num_1=num/10;
		num_2=num%10;
		char1=num_2+0x30;
		char2[i]=char1;
		i++;
		num=num_1;
	}
	strcat(encrypt_result,char2);
	
 
}


void encrypt_main()
{
    int i,j;
	int key_input_len,key_input_total=0;
	int imei_lenth,imei_total=0;
	char temp_result[30];
	char char_result[10];
	

			
	key_input_len=strlen(key_input);
	for(i=0;i<key_input_len;i++)
	  key_input_total=key_input_total+key_input[i]-0x30;

	imei_lenth=strlen(imei_temp);
    for(i=0;i<imei_lenth;i++)
	  imei_total=imei_total+imei_temp[i]-0x30;

 

	key_input_long=StringToNum(key_input);
//	key_flash_long=StringToNum(key_flash);
    
    key_flash_long=key_input_long+key_flash_long;

	for(i=0;i<7;i++)
		imei_front[i]=imei_temp[i];
	imei_front[7]='\0';

	j=0;
	for(i=7;i<15;i++)
	{
		imei_back[j]=imei_temp[i];
		j++;
    }
    imei_back[8]='\0';
	
	imei_front_long=StringToNum(imei_front);
	imei_back_long=	StringToNum(imei_back);
  
    imei_front_long^=4323356;
    imei_back_long^=98789032;

	
    
    switch(key_input_total%9)
	{
	   case 0 :
		  
		  imei_front_long= imei_front_long>>0;
		  imei_back_long= imei_back_long<<4;
		  imei_front_long^=imei_back_long;
		   break;
	   case 1 :
		   
		  imei_front_long= imei_front_long>>1;
		  imei_back_long= imei_back_long<<3;
		  imei_front_long^=imei_back_long;
		   break;
	   case 2 :
		   
		   imei_front_long= imei_front_long>>2;
		   imei_back_long=imei_back_long<<2;
		   imei_front_long^=imei_back_long;
		   break;
	   case 3 :
		   
		  imei_front_long=  imei_front_long>>3;
		   imei_back_long=imei_back_long<<1;
		   imei_front_long^=imei_back_long;
           break;
	   case 4 :
		   
		   imei_front_long=  imei_front_long<<4;
		   imei_back_long=imei_back_long>>0;
		   key_input_long=key_input_long>>1;
		   imei_front_long^=imei_back_long;

           break;
       case 5 :
		   
		   imei_front_long=  imei_front_long<<3;
		   imei_back_long=imei_back_long>>1;
		   key_input_long=key_input_long>>2;
		   imei_front_long^=imei_back_long;
           break;
	   case 6 :
		   
		   imei_front_long=  imei_front_long<<2;
		   imei_back_long=imei_back_long>>2;
		   key_input_long=key_input_long>>3;
		   imei_front_long^=imei_back_long;
           break;
	   case 7 :
		   
		   imei_front_long=  imei_front_long<<1;
		   imei_back_long=imei_back_long>>3;
           key_flash_long=key_flash_long<<1;
		   imei_front_long^=imei_back_long;
           break;
	   case 8 :
		   
		   imei_front_long=  imei_front_long<<0;
		   imei_back_long=imei_back_long>>4;
		   key_flash_long=key_flash_long<<2;
		   imei_front_long^=imei_back_long;
           break;
		   


	   default:
		  
		   break;


	}
	
	
	imei_front_long=imei_front_long+key_flash_long;//shiheng 0601
    
	if(key_input_long>key_flash_long)
	{
		key_input_long=key_input_long-key_flash_long+12345;
	    key_flash_long=key_flash_long+key_input_long+67890;
	}
	else if(key_input_long=key_flash_long)
	{
	    key_input_long=key_input_long+12345;
		key_flash_long=key_flash_long+67890;
	}
	else
	{
	    key_input_long=key_input_long+key_flash_long+12345;
        key_flash_long=key_flash_long-key_input_long+67890;
	}
	
    key_input_long^=key_flash_long;
    key_flash_long&=key_input_long;
	
	imei_front_long &=key_input_long;
	imei_back_long |=key_flash_long;

    if(key_input_long>key_flash_long)
	{
	  key_input_long=key_input_long-(~key_flash_long);
	  key_flash_long=key_flash_long+key_input_long;
	}
	else
	{
	  key_flash_long=key_flash_long-(~key_input_long);
      key_input_long=key_input_long+key_flash_long;
	}
	
    imei_front_long^=key_input_long;
    imei_back_long^=key_flash_long;
	
    imei_front_long^=imei_back_long;
	
	
	key_flash_long^=imei_back_long;
	imei_front_long^=key_input_long;
	
	switch(imei_total%4)
	{
	   case 0 :
		   
		   imei_front_long= imei_front_long<<0;
		   imei_back_long= imei_back_long>>4;
		   break;
	   case 1 :
		   
		   imei_front_long= imei_front_long<<1;
		   imei_back_long= imei_back_long>>3;
		   break;
	   case 2 :
		   
		   imei_front_long= imei_front_long<<2;
		   imei_back_long=imei_back_long>>2;
		   break;
	   case 3 :
		   
		   imei_front_long=  imei_front_long<<3;
		   imei_back_long=imei_back_long>>1;
           break;
	   default:
		   
		   break;
		   
		   
	}

	NumToStr((unsigned int)imei_front_long);
    NumToStr((unsigned int)imei_back_long);

	strncat(encrypt,encrypt_result,15);

   
}
