/**********************************************************************************
* 
* file name : mmi3dframe.c
*
* description : ļϷʹϷõ
*             button,messagebox,menu, clarity text
*
***********************************************************************************/

/******************************ļʷ¼********************************
*
* creator : tangyan
*
* create : 2002/9/16
* 
* file version                            modified
*
**************************************************************************************/

/*********************************include headfiles***************************************/
#include "mfw_sys.h"
//#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
//#include "vsi.h"
#include "ffs.h"
#include "p_sim.h"
#include "cus_aci.h"
#include "Rtc_Api.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_sat.h"
#include "mfw_mnu.h"
#include "mfw_ffs.h"
#include "dspl.h"
//#include "bmieastapi.h"
#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiBookShared.h"

#include "MmiBlkLangDB.h"
#include "GameDisplay.h"
//#include "mmigameicons.h"
#include "mmi3dframe.h"
#include "wstring.h"

#define textheight  16

#define abs(a)  ((a)>0? (a):-(a))
#define GAMEMNUSHOW  0
#define GAMEMNUDOWN  1
#define GAMEMNUUP     2
#define GAMEMNUANIMI  3

#define GMNUTEXTHIGH  19
#define GMNUTEXTYPOS  83
#define GMNUFOCUSWD  16
#define GMNUFOCUSHG   16

U8 winfocusout;

void draw3drect(MfwRect rect, U32 tlcolor, U32 brcolor);
/*********************************display clarity word************************************/

/*************************************************************************************
  : drawcolrclaritytext
   :  ʾɫ͸,Ѿ0x80
  *************************************************************************************/
void drawcolorclarity(U16 left, U16 top , char * text, U32 color)
{

U16 oldcolor;

oldcolor=dspl_GetFrgColor();
dspl_SetFrgColor(color);
dspl_TextOut(left, top,DSPL_TXTATTR_TRANSPARENT, (char *)text);
dspl_SetFrgColor(oldcolor);
}


/***************************************************************************************
	$Function:		DrawColorNumber
	$Description:	only for number with new line.
	$Author:		Sunny
	$Date:			2004-04-28
***************************************************************************************/
void DrawColorNumber(U16 left, U16 top, char * text, U32 color)
{
	int i = 0;
	int nTextLen = 0;
	int rows = 0, nCharsLastLine = 0;
	int nCharWidth = 0;
	int nCharsPerLine = 0;
	U16 oldcolor;
	char subText[25];	

	if(!text)
	{
		return;
	}

	nCharWidth = 6;//?
	
	nCharsPerLine = (SCREEN_SIZE_X - left) / nCharWidth;

	nTextLen = strlen(text);
	
	oldcolor=dspl_GetFrgColor();
	dspl_SetFrgColor(color);

	rows = nTextLen / nCharsPerLine;
	nCharsLastLine = nTextLen % nCharsPerLine;

	if(nCharsLastLine != 0)
	{
		rows++;
	}

	for(i = 0; i < rows - 1; i++)
	{
		memcpy(subText,text + i * nCharsPerLine, nCharsPerLine);
		subText[nCharsPerLine] = 0;
		dspl_TextOut(left, top + i * 13,DSPL_TXTATTR_TRANSPARENT, (char *)subText); //13?
	}	

	if(nCharsLastLine > 0)
	{
		memcpy(subText,text + (rows - 1) * nCharsPerLine, nCharsLastLine);
		subText[nCharsLastLine] = 0;
		dspl_TextOut(left, top + (rows - 1) * 13,DSPL_TXTATTR_TRANSPARENT, (char *)subText); //13?
	}
	else
	{
		memcpy(subText,text + (rows - 1) * nCharsPerLine, nCharsPerLine);
		subText[nCharsPerLine] = 0;
		dspl_TextOut(left, top + (rows - 1) * 13,DSPL_TXTATTR_TRANSPARENT, (char *)subText);
	}

	dspl_SetFrgColor(oldcolor);
}


/*************************************************************************************
  : drawcolorclarity_NoNewline
   :  ʾɫ͸,Ѿ0x80
  xsf  add 2003.03.06
  *************************************************************************************/
void drawcolorclarity_NoNewline(U16 left, U16 top , char * text, U32 color)
{
 U16 oldcolor;

 oldcolor=dspl_GetFrgColor();
 dspl_SetFrgColor(color);
 dspl_TextOut_NoNewline(left, top,DSPL_TXTATTR_TRANSPARENT, (char *)text);
 dspl_SetFrgColor(oldcolor);
}

/*************************************************************************************
  : drawmidtext
   :   ָľεмʾɫ͸
  *************************************************************************************/
void drawmiddle(U16 left, U16 top, U16 width,U16 height, char * text, U32 color)
{
U16 ileft,itop,length;


 MmiTrace("drawmiddle");
length=wstrlen(text)*8;

if(height<14)
	return;
if(length>=width)
	return;

ileft=left+ (width-length)/2;
itop=top + (height- textheight)/2;
drawcolorclarity( ileft , itop , text, color);

}

/*********************************draw 3dbutton*****************************************/

/*************************************************************************************
  : draw3dbutton
   :  3dЧbutton
  *************************************************************************************/
void draw3dbutton(U16 left,U16 top,U16 right,U16 bottom ,char *pcaption ,U32 color,U8 select)
{
MfwRect  rect;
U32 oldcolor,width,height;

rect.px=left;
rect.py=top;
rect.sx=abs(right-left);
rect.sy=abs(bottom-top);

    //MmiTrace("draw3dbutton");
	//zgzTraceDataFunc("draw3dbuttoncolor", (U16)color);
    oldcolor = dspl_SetBkgColor(color); 
    dspl_fill_rectangle(left, top, right, bottom);
    dspl_SetBkgColor(oldcolor);

    
	if(select)
		draw3drect(rect, color|0x3c3c3c, color&0x3c3c3c);
	else
    	draw3drect(rect, color&0x3c3c3c, color|0x3c3c3c);

	width=abs(right-left);
	height=abs(bottom-top);
	oldcolor=(~color)&0xffffff;
	drawmiddle(left, top, width, height, pcaption, oldcolor );
}

/*********************************draw messagebox*****************************************/

/*************************************************************************************
  : messagebox
   :  3dЧbutton
  *************************************************************************************/
//extern const unsigned char backgroundBit[];
//extern const unsigned char iconRequire[];

//void Draw_Dialog(char * sztext)
//{
//U16 xPosition_i,txtSize_i;
/*
oldcolor = dspl_SetBkgColor(color); 
dspl_fill_rectangle(, , , );
dspl_SetBkgColor(oldcolor);  
*/
//draw_popup_background();
/*
dspl_BitBlt(9,41, 102, 72, 0, (void *)&backgroundBit, 0);  
dspl_BitBlt(49, 61, 22, 19, 0, (void *)&iconRequire, 0);  
txtSize_i=wstrlen(sztext)*8;
xPosition_i=9+(102-txtSize_i)/2;

dspl_TextOut(xPosition_i, 49+38,DSPL_TXTATTR_TRANSPARENT, (char *)sztext);*//*2003/12/16, wangyan modify*/
//dspl_TextOut(37, 30,DSPL_TXTATTR_TRANSPARENT, (char *)sztext);
//}


/*************************************************************************************
  : Bmp_Copy
   :  bmp copy
  *************************************************************************************/
void Bmp_Copy(U16* destbmp , U16* scrbmp,
                                   U16 destheight,U16 destwidth,
                                   U16 scrheight, U16 scrwidth,
                                   U16 destxpos, U16 destypos )
{
	UINT16 *p ,*ptr ,*ptrbmp,lcdy ;

	p= (UINT16 *)(scrbmp+destypos*scrwidth);
    
    for(lcdy=0;(lcdy<destheight)&&((lcdy+destypos)<scrheight);lcdy++){ 
	       ptr = p + (destypos + lcdy) * scrwidth+destxpos;
	       ptrbmp = destbmp + destwidth*lcdy;
	
	if((destxpos+destwidth)<scrwidth)
		memcpy(ptr ,ptrbmp ,destwidth*2);
	else
		if(destxpos<scrwidth)
			memcpy(ptr,ptrbmp,(scrwidth-destxpos)*2);
     }
     
}
/*************************************************************************************
  : messagebox
   :  3dЧbutton
  *************************************************************************************/
/*void drawmessagebbox(char * szcaption,char * sztext ,U8 type ,U32 color,U8 focus)
{
MfwRect  rect;
U32 oldcolor,width,height,tempcolor;

MmiTrace("drawmessagebbox");
rect.px=10;
rect.py=30;
rect.sx=MESSAGEBOX_WIDTH;
rect.sy=MESSAGEBOX_HEIGHT;

if(messageboxtype & MESSAGEBOX_CREATE)
{
    oldcolor = dspl_SetBkgColor(color); 
    dspl_fill_rectangle(rect.px, rect.py+20, rect.px+rect.sx, rect.py+rect.sy);
    dspl_SetBkgColor(oldcolor);   
    
    oldcolor = dspl_SetBkgColor(color&0x3c3c3c); 
    dspl_fill_rectangle(rect.px, rect.py, rect.px+rect.sx, rect.py+21);
    dspl_SetBkgColor(oldcolor);   
    
	draw3drect(rect, color|0x3c3c3c, color&0x3c3c3c);

	tempcolor=(~color)&0xffffff;
	
	if(messageboxtype & MESSAGEBOX_NOBUTTON)
		{
		    drawcolorclarity( rect.px+1 , rect.py+1 , szcaption, tempcolor);
			drawmiddle(rect.px, rect.py+5, rect.sx, rect.sy, sztext, tempcolor );
			return;
		}
	
	if(messageboxtype & MESSAGEBOX_OKBUTTON)
		{
		    drawcolorclarity( rect.px+1 , rect.py+1 , szcaption, tempcolor);
		    drawmiddle(rect.px, rect.py, rect.sx, rect.sy-15, sztext, tempcolor );
		    draw3dbutton(rect.px+30,rect.py+53,rect.px+70,rect.py+71,"ise",tempcolor,1);
		    return;
		}
	
    if(messageboxtype & MESSAGEBOX_YESNOBUTTON)
		{
		  drawcolorclarity( rect.px+1 , rect.py+1 , szcaption, tempcolor);
		  drawmiddle(rect.px, rect.py, rect.sx, rect.sy-15, sztext, tempcolor );
		  draw3dbutton(rect.px+10,rect.py+53,rect.px+46,rect.py+70,"xxx",tempcolor,1);
		  draw3dbutton(rect.px+54,rect.py+53,rect.px+90,rect.py+70,"xxx",tempcolor,1);
		  return;
		}
    
}   

}*/

/*************************************************************************************
  : messagebox
   :  3dЧbutton
  *************************************************************************************/
void draw3drect(MfwRect rect, U32 tlcolor, U32 brcolor)
{
  game_Line  threedrect;
//һ
  threedrect.x1=rect.px;
  threedrect.x2=rect.px;
  threedrect.y1=rect.py;
  threedrect.y2=rect.py+rect.sy;
  threedrect.color=tlcolor;
  DrawLine(threedrect);
 // zgzTraceDataFunc("draw3drect1", (U16)tlcolor);
  // zgzTraceDataFunc("draw3drectbrcolr", (U16)brcolor);
//һ
  threedrect.x1=rect.px;
  threedrect.x2=rect.px+rect.sx;
  threedrect.y1=rect.py;
  threedrect.y2=rect.py;
  threedrect.color=tlcolor;
  DrawLine(threedrect);
//һ
  threedrect.x1=rect.px+rect.sx;
  threedrect.x2=rect.px+rect.sx;
  threedrect.y1=rect.py;
  threedrect.y2=rect.py+rect.sy;
  threedrect.color=brcolor;
  DrawLine(threedrect);

//һ
  threedrect.x1=rect.px;
  threedrect.x2=rect.px+rect.sx;
  threedrect.y1=rect.py+rect.sy;
  threedrect.y2=rect.py+rect.sy;
  threedrect.color=brcolor;
  DrawLine(threedrect);
	
}

/****************************************************************************
*  function name : dsplsoftkey
*  describe : display softkey
*
*****************************************************************************/
void dsplsoftkey(U32 leftSoftKey,U32 rightSoftKey)
{
displaySoftKeys( leftSoftKey, rightSoftKey);
}

/*******************************Mnu Setting*****************************************/
#define KEYICONHEIGHT   8
#define KEYICONWIDTH   17
#define KEYICONHEIGHT2 14
#define ARROWHEIGHT    12
#define ARROWWIDTH    11
#define KEYSETHEIGHT    16
#define KEYSETSTATUS1  1     /* key setting show */
#define KEYSETSTATUS2  2     /* key setting error */

Key_Setting keysetting;
extern ffsgamedata ffs_gamedata;
extern T_MFW_HND gtVibator;
T_MFW_HND g_game_win;

/*2003/12/30,talcon add*/
const char gameKeySetting_Russia[]=
{
	0x01,0x01,0x01,0x01,0x00,0x01,0x01,0x01,0x01
};
const char gameKeySetting_Boxman[]=
{
	0x01,0x01,0x01,0x01,0x01,0x00,0x00,0x01,0x01
};
const char gameKeySetting_Snake[]=
{
	0x01,0x01,0x01,0x01,0x00,0x01,0x00,0x01,0x01
};
/*************end talcon add*/
//2004/06/25 yhf mod
/*
Correspond_Chart Ctrl_IconsIndex[]=
{
//	{(char *)difficlty_Ybmp ,    11,23},                            
	//{ (char *)volume_Ybmp   , 11,35},                               
	{ (char *)arrow_leftYbmp, ARROWHEIGHT,ARROWWIDTH},              
	{ (char *)arrow_rightYbmp,ARROWHEIGHT,ARROWWIDTH},              
	{ (char *)arrow_downYbmp, ARROWWIDTH,ARROWHEIGHT},              
	{ (char *)arrow_upYbmp,	  ARROWWIDTH,ARROWHEIGHT},   

	{ (char *)arrow_regretYbmp,  ARROWWIDTH,ARROWHEIGHT},           
	{ (char *)pause_Ybmp,      KEYICONHEIGHT2,KEYICONHEIGHT2},     
	{ (char *)arrow_changeYbmp,13,16},                              
	{ (char *)start_Ybmp,     KEYICONHEIGHT2,KEYICONHEIGHT2},       
//	{ (char *)fire_Ybmp,      KEYICONHEIGHT2,KEYICONHEIGHT2},       
	{ (char *)exit_Ybmp,	11,22},                                 
	//{ (char *)default_Ybmp, 11,47}  	                        
};                                                                      

Correspond_Chart Key_IconsIndex[]=
{
	//{(char *)key_starBbmp,	KEYICONHEIGHT,KEYICONWIDTH},                    
	//{(char *)key_hashBbmp,	KEYICONHEIGHT,KEYICONWIDTH},                    
	{(char *)key_mnuleftBbmp,	KEYICONHEIGHT,KEYICONWIDTH},                    
	{(char *)key_mnurightBbmp,KEYICONHEIGHT,KEYICONWIDTH},   
	{(char *)key_mnudownBbmp,KEYICONHEIGHT2,KEYICONHEIGHT2-2},
	{(char *)key_mnuupBbmp,KEYICONHEIGHT2,KEYICONHEIGHT2-2},
	{(char *)key_rightBbmp,KEYICONHEIGHT,KEYICONWIDTH},    
	{(char *)key_callBbmp,	KEYICONHEIGHT,KEYICONWIDTH},
	{(char *)key_okBbmp,	KEYICONHEIGHT2,KEYICONHEIGHT2}, 

    {(char *)key_callBbmp,	KEYICONHEIGHT,KEYICONWIDTH},                                            

//	{(char *)key_leftBbmp,	KEYICONHEIGHT,KEYICONWIDTH},  
	{(char *)key_hupBbmp,	KEYICONHEIGHT,KEYICONWIDTH},   
//	{(char *)key_mnurightBbmp,KEYICONHEIGHT,KEYICONWIDTH},                 
//	{(char *)open_Bbmp,    11,11},                                         
//	{(char *)close_Bbmp,   11,11}                                          
}; 
*/                                                                     
U8 Key_Setshow(U8 nType)
{
	char *pgameKeySetting  = 0;
	int nloop = GET_ICONATTR_NUM(ICON_GAME_CTRL);//sizeof(ctrl_iconsindex)/sizeof(ctrl_iconsindex[0]);
	int nKeyMap = 0;
	U8 i = 0,width,height,tempheight,tempxposition;
	char * iconaddr,difficult[4];
	U32 oldcolor;  
	switch(nType)
		   {
	case 0:
		pgameKeySetting  = (char *)gameKeySetting_Russia ;
   					break;
	case 1:
		pgameKeySetting  = (char *)gameKeySetting_Boxman ;
   				    break;
	case 2:
		pgameKeySetting  = (char *)gameKeySetting_Snake ;
   			break;
   		default:
   return 0;   
}

oldcolor = dspl_SetBkgColor(0xFEFED8); 
    dspl_fill_rectangle(0, 0, 59, 160);
    dspl_SetBkgColor(oldcolor);
oldcolor = dspl_SetBkgColor(0xDBFFFF); 
	//2004/06/08 yhf modify
	dspl_fill_rectangle(60, 0, 128, 160);
    //dspl_fill_rectangle(60, 0, 119, 160);
    dspl_SetBkgColor(oldcolor);
	DRAW_ICON(ICON_GAME_SETTITLE);
//dspl_BitBlt(0, 0, 120, 15, 0, (void *)keysettitle, 0); 

	tempheight=17;
	for(;i<nloop;i++)
 		 	{
		if(pgameKeySetting[i] != (char)0x01)
			continue;
		/*iconaddr = Ctrl_IconsIndex[i].iconAddr;
		width    = Ctrl_IconsIndex[i].iconWidth;
		height   = Ctrl_IconsIndex[i].iconHeight;*/
		//iconaddr = GET_ICONATTR(ICON_GAME_CTRL,i)->icons;//ctrl_iconsindex[i].icons;
		width    = GET_ICONATTR(ICON_GAME_CTRL,i)->area.sx;//ctrl_iconsindex[i].area.sy;
		//height   = GET_ICONATTR(ICON_GAME_CTRL,i)->area.sx;//ctrl_iconsindex[i].area.sx;		
        	    tempxposition = (49-width)/2+11;

		/*dspl_BitBlt(tempxposition, tempheight,
			width, height, 0, (void *)iconaddr, 0);*/
		DRAW_ICON_ATTRIBUTE(ICON_GAME_CTRL,tempxposition,tempheight,i,ICON_LOCATION);
                
		/*iconaddr =Key_IconsIndex[i].iconAddr;
		width    = Key_IconsIndex[i].iconWidth;
		height   = Key_IconsIndex[i].iconHeight;*/
		//iconaddr = GET_ICONATTR(ICON_GAME_KEYSETTING,i)->icons;//key_iconsindex[i].icons;
		width    = GET_ICONATTR(ICON_GAME_KEYSETTING,i)->area.sx;//key_iconsindex[i].area.sy;
		//height   = GET_ICONATTR(ICON_GAME_KEYSETTING,i)->area.sx;//key_iconsindex[i].area.sx;		
                    tempxposition = (49-width)/2+60;
		/*dspl_BitBlt(tempxposition, tempheight,
			width, height, 0, (void *)iconaddr, 0); */
		DRAW_ICON_ATTRIBUTE(ICON_GAME_KEYSETTING,tempxposition,tempheight,i,ICON_LOCATION);
					
		tempheight += KEYSETHEIGHT;
}
return 0;
}
void Print_Number(char * numtemp,U8 size,U32 number)
{
U8 i,temp;

memset(numtemp,0,size*sizeof(char));

//if(number>=100000) //talcn delete
//	return;//talcn delete
if(number>=100000)//talcon add
	number = number%100000;//talcon add
if(number>=10000)
{
    for(i=5;i>0;i--)
    	{
    	numtemp[i-1]=number%10+48;
    	number=number/10;
    	}
    return;
}
if(number>=1000)
{
for(i=4;i>0;i--)
    	{
    	numtemp[i-1]=number%10+48;
    	number=number/10;
    	}
return;
}
if(number>=100)
{
for(i=3;i>0;i--)
    	{
    	numtemp[i-1]=number%10+48;
    	number=number/10;
    	}
return;
}	
if(number>=10)
{
for(i=2;i>0;i--)
    	{
    	numtemp[i-1]=number%10+48;
    	number=number/10;
    	}
return;
}	
if(number>=0)
{
for(i=1;i>0;i--)
    	{
    	numtemp[i-1]=number%10+48;
    	number=number/10;
    	}
return;
}	
}

void set_backlight_off(void)
{
  g_lcd_game_flag=1;
  timStop(gtVibator);
  Backlight_OFF();
  LedLightnessAdjust(11);//zy //12/02
}


int game_win_focussed(void)
{
	if (winIsFocussed(g_game_win))
	   {
	     return 1;
		}
	else
		{
		g_lcd_game_flag=0;
		return 0;
		}
}

void set_backlight_on(void)
{
   g_lcd_game_flag=0;
    Backlight_ON();
    LedLightnessAdjust(16);
    timStart(gtVibator);
}

