/**********************************************************************************
* 
* file name : mmi3dframe.h
*
* description : ļϷʹϷõ
*            button,messagebox,menu, clarity word
*
***********************************************************************************/

/******************************ļʷ¼********************************
*
* creator : tangyan
*
* create : 2002/9/16
* 
* file version                            modified
*
**************************************************************************************/
/************************ϢͺʹС****************************/
#ifndef _MMI_MMI3DGAME_H_
#define _MMI_MMI3DGAME_H_

#include "mfw_kbd.h"


#define MESSAGEBOX_NOBUTTON         1
#define MESSAGEBOX_OKBUTTON         2
#define MESSAGEBOX_YESNOBUTTON      4
#define MESSAGEBOX_KEYMAKE           8
#define MESSAGEBOX_CREATE            16       

#define MESSAGEBOX_HEIGHT            80
#define MESSAGEBOX_WIDTH             100
#define BUTTON_HEIGHT              20
#define BUTTON_WIDTH              40

/*********************************ݽṹ*********************************/
typedef struct{
MfwRect rect;
U32 color;
char * buttontext;
}Button_Property; 
//ť

typedef struct {
MfwRect  rect;
U32 colorl;
U8  type;
char *szcaption;
char *sztext;
}Messagebox_Property;
//messagebox


/**************************ýṹ************************************/
typedef struct{
	    U8 ctrlIconid;
	    U8 keyCode;
}Ctrlkey_Map;

typedef struct{
       // U8   id;
        char * iconAddr;
      //  char * iconAddrFocus;
        U8 iconHeight;
        U8 iconWidth;
}Correspond_Chart;

typedef struct{
	    U8 gamedifficult;
	    U8 keycode;
	    U8 keySetstatus;
	    U8 difficulty;        
	    U8 focus;                //ǰ۽һ
        U8 ctrlKeynum;          //жٸҪõĶ   
        Ctrlkey_Map * ctrlKeylist; 
}Key_Setting;

typedef enum{
	  IconDifficult,
      IconAudio,
      IconLeft,
      IconRight,
      IconDown,
      IconUp,
      IconRegret,
      IconPause,
      IconChange,
      IconRestart,
      IconFire,
      IconExit,
      IconDefault,
      IconOn,
      IconOff,
      Icon_End
}Game_Iconlists;

#define GAMESETTING_ICONS (Icon_End+1)

//extern Correspond_Chart Ctrl_IconsIndex[GAMESETTING_ICONS+1];
//extern Correspond_Chart Key_IconsIndex[21];
extern Key_Setting keysetting;
//extern Ctrlkey_Map *Balloon_Ffskey;
//extern Ctrlkey_Map *Bm_Ffskey;
//extern Ctrlkey_Map *Russia_Ffskey;
extern BOOL g_lcd_game_flag;  
extern U8 winfocusout;
extern T_MFW_HND g_game_win;
//end ýṹ

typedef struct   
{
			U8    savemap[16][12];  //2004/05/28 yhf modify
            //U8    savemap[12][16];  
            //һûнĵͼϢ
            U16    mapselect;        
            //洢ѡһصĵͼ
            U8       load;            
            //жǷеͼĴ浵
} SaveMap; //Ϸ

typedef struct
{
U32 score[5];
} GameScore;   //Ϸ


typedef struct
{
	unsigned long opp1_money;
	unsigned long opp2_money;
	unsigned long opp3_money;
	unsigned long player_money;	
}MONEY_SAVED;

typedef struct
{
//MONEY_SAVED  p_c_ffsmoney;
//Ctrlkey_Map Balloon_Ffskeyload[9];
	//Ctrlkey_Map Russia_Ffskeyload[8];
	//Ctrlkey_Map Bm_Ffskeyload[9];
//GameScore  Blloon_ffsScore;
GameScore  Russia_ffsScore;
SaveMap    bmsavemap;
/*2003/12/19,talcon add*/
GameScore	Snake_ffsScore;
}ffsgamedata;


/*********************************fucntion declare***************************************/

//void drawmiddle(U16 left , U16 top, U16 width,U16 height, char * text, U32 color);

//void drawcolorclarity(U16 left , U16 top , char* text, U32 color );

void draw3dbutton(U16 left , U16 top,U16 right,U16 bottom ,char * pcaption ,U32 color,U8 select);
void draw3drect(MfwRect rect, U32 tlcolor, U32 brcolor);
#if 0
void Bmp_Cpoy(U16* destbmp , U16* scrbmp,
                                   U16 destheight,U16 destwidth,
                                   U16 scrheight, U16 scrwidth,
                                   U16 destxpos, U16 destypos );
#endif
//
//
//
//void Load_Keyset(U8 gameid);
//U8  Key_Setshow(Key_Setting * ctrlkeyset);
U8  Key_Setshow(U8 nType);
//U8  Key_Setting_func(U8 gameid, Key_Setting * ctrlkeyset, MfwKbd * key);
void dsplsoftkey(U32 leftSoftKey,U32 rightSoftKey);
void Print_Number(char * numtemp,U8 size,U32 number);
void set_backlight_off(void);
void set_backlight_on(void);
int game_win_focussed(void);
#endif
