#ifndef _DEF_MMI_CHARGING_H_
#define _DEF_MMI_CHARGING_H_

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Charging
 $File:		    Mmicharging.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		      26/08/02
                                                    
                                                                               
********************************************************************************
                                                                              
 Description:
 
                        
********************************************************************************



/*******************************************************************************
                                                                              
                                Required Include Files
                                                                              
*******************************************************************************/

							          
/* PROTOTYPES               */

typedef enum
{
 	CHARGER,   
 	HEADSET,
 	DATALINE,
 	NOTHING
}CARKITSTATE;

//hxl moved here from pwr.h 09/01-------------------------------
typedef struct bat_voltage  ///zym revised  0819
{
	UBYTE	batchanged;
   UBYTE    remain_capacity;
   UBYTE	shutdown;
} bat_voltage;
//end of hxl moved 09/01----------------------------------------

extern bat_voltage	bat_voltage_info;
extern UBYTE   ChargeOffset;
/*2003/11/14,talcon add*/
extern UINT8 oldChargeIcon;

void ChargeWin(void);
void  ALPollingTick( void );


#endif

