/*******************************************************************************

					CONDAT (UK)
 
********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Start
 $File:		    MmiDummy.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

   
                        
********************************************************************************




/*******************************************************************************
                                                                              
                                Include files
                                                                              
*******************************************************************************/


#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif
#include "mon_aci.h"
#include "tok.h"
#include "pcm.h"


#include "p_sim.h"
//NM

#include "mfw_sys.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_icn.h"
#include "mfw_edt.h"
#include "mfw_mnu.h"
#include "mfw_sat.h"
#include "mfw_nm.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h" 

//NM
#include "gdi.h"
#include "audio.h"

//NM

#include "MmiVersion.h"
#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

#include "MmiMain.h"

//#define TDTRACE 1
#include "mmiutilapi.h"

/*
#include "pcm.h"
#include "ccdapi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "vsi.h"
#include "pei.h"
#include "tok.h"
#include "em.h"
#include "aci_cmh.h"
*/

/*******************************************************************************************
 *
 * Global definition of message function plus some dummies
 *
 *******************************************************************************************/

void mmi_send_event (T_MFW_HND win, USHORT event, USHORT value, void * parameter)
{
	MMI_TRACE_EVENT(("<<<<<<<<talcon,mmi_send_event--win:%p,event:%d,value:%d,parameter:%p",win,event,value,parameter));
	if (win )
	{
	#define MMISENDEVENT_CHECK
#ifdef MMISENDEVENT_CHECK
		T_MFW_WIN     * win_data =0 ;
		 T_MMI_CONTROL * control  =0;

	
	if( ((T_MFW_HDR *)win)->type != MfwTypWin)
	{
		MMI_TRACE_EVENT(("-------------------------------------------------------------------------------------------------------------------------"));
		MMI_TRACE_EVENT(("<<<<<<<<talcon,mmi_send_event--win:0x%p,type:%d,data:0x%p",win,((T_MFW_HDR *)win)->type,((T_MFW_HDR *)win)->data));
  		MMI_TRACE_EVENT(("<<<talcon,end mmi_send_event--0"));
		MMI_TRACE_EVENT(("-------------------------------------------------------------------------------------------------------------------------"));
		return;
	}
		  win_data  = (T_MFW_WIN     *) ((T_MFW_HDR *)win)->data;
		  if(win_data   == 0)
	  	{
	  		MMI_TRACE_EVENT(("-------------------------------------------------------------------------------------------------------------------------"));
	  		MMI_TRACE_EVENT(("<<<talcon,end mmi_send_event--1"));
			MMI_TRACE_EVENT(("-------------------------------------------------------------------------------------------------------------------------"));
			return;
	  	}

		  control  = (T_MMI_CONTROL *)win_data->user;

		   if(control   == 0)
	  	{
	  		MMI_TRACE_EVENT(("-------------------------------------------------------------------------------------------------------------------------"));
			
	  		MMI_TRACE_EVENT(("<<<talcon,end mmi_send_event--2"));
			MMI_TRACE_EVENT(("-------------------------------------------------------------------------------------------------------------------------"));
			return;
	  	}
#else
		T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;;
		T_MMI_CONTROL * control  = (T_MMI_CONTROL *)win_data->user;
#endif


		if (control->dialog NEQ 0)
		    (control->dialog) (win, event, value, parameter);
	}
	
	MMI_TRACE_EVENT(("<<<talcon,end mmi_send_event--4"));
}

UBYTE idle_screen_has_focus()
{
  return TRUE;
}



/*******************************************************************************

 $Function:    	get_imei

 $Description:	This function invokes the operation for key sequence
				command for getting the IMEI.
 
 $Returns:		

 $Arguments:	 
*******************************************************************************/
int get_imei(char *imei)
{
	UBYTE retVal;                     /* holds return value */
	UBYTE version;                        /* holds version */
	UBYTE buf[SIZE_EF_IMEI];

	TRACE_FUNCTION ("get_imei()");


	retVal = pcm_ReadFile ((UBYTE *)EF_IMEI_ID, SIZE_EF_IMEI, buf, &version);
	if( retVal EQ PCM_INVALID_SIZE OR retVal EQ PCM_INVALID_FILE )
		return( FALSE );

	imei[0]  = ( buf [0] & 0x0F) +0x30;
	imei[1]  = ((buf [0] >> 4) & 0x0F)+0x30;
	imei[2]  = ( buf [1] & 0x0F)+0x30;
	imei[3]  = ((buf [1] >> 4) & 0x0F)+0x30;
	imei[4]  = ( buf [2] & 0x0F)+0x30;
	imei[5]  = ((buf [2] >> 4) & 0x0F)+0x30;
	imei[6]  = ( buf [3] & 0x0F)+0x30;
	imei[7]  = ((buf [3] >> 4) & 0x0F)+0x30;
	imei[8]  = ( buf [4] & 0x0F)+0x30;
	imei[9]  = ((buf [4] >> 4) & 0x0F)+0x30;
	imei[10] = ( buf [5] & 0x0F)+0x30;
	imei[11] = ((buf [5] >> 4) & 0x0F)+0x30;
	imei[12] = ( buf [6] & 0x0F)+0x30;
	imei[13] = ((buf [6] >> 4) & 0x0F)+0x30;
	imei[14] = ( buf [7] & 0x0F)+0x30;
	imei[15] = 0;
	return( TRUE );
}


char* get_build_user()
{
	return BUILD_USER;
}

char* get_build_date()
{
	return BUILD_DATE;
}

char* get_build_time()
{
	return BUILD_TIME;
}

void temptest()//jhxu720 add
{
}

/************************ End of functions *************************************************/

#ifndef MMI_WAP_ENABLED
void rAT_WAP_start_gprs_login(void)
{
	//Dummy function - WAP disabled/not compiled
}

void rAT_WAP_start_login(void)
{
	//Dummy function
}

void rAT_WAP_PPP_connected(SHORT cId,ULONG IPAddress)
{
	
}

void wapffsfile_init(void)
{

}

void FlashWapInitialise(void)
{

}

signed char flash_wap_write()
{  //write_flag = DATA;
 
}

int  AUI_homepageStart(T_MFW_HND parent_win)
{


}

void mmi_decoder(UBYTE  event_id, void *parameter)
{
}
#endif
/* END OF DUMMY FUNCTIONS */
