/*******************************************************************************

                    Mobile Innovation

********************************************************************************                                                                              

 This software product is the property of Mobile Innovation and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MMI
 $File:		    MmiEcTimeDate.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		zhu guangzhao                                                      
 $Date:		2002.8.26                                       
                                                                               
********************************************************************************
                                                                              
 Description:

  

********************************************************************************

ver 1.0
*******************************************************************************/


#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"
#include "p_sim.h"

//#include <stdio.h>
//#include <string.h>
//#include <stdlib.h>

//#include "mfw_sys.h"

//#include "stddefs.h"
//#include "custom.h"
//#include "gsm.h"
//#include "vsi.h"

#include "mfw_mfw.h"
#include "mfw_win.h"

#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_cm.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_sat.h"

#include "dspl.h"

#include "gdi.h" //ES!!

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

//#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiIdle.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiecTimeDate.h"
#include "MmiSounds.h"
#include "audio.h"
#include "cus_aci.h"
#include "p_sim.h"

#include "rtc_api.h"  // zgz add,2002.8.15 Mobile Innovation
#include "mmisettings.h"
//#include "bmieastapi.h"
#include "mmibookshared.h"
#include "Gamedisplay.h"
#include "mmiouterIdle.h" //2004-04-05 Sunny add

//wyj
#include "TdDisplay.h"
//#include "mmiicnother.h"  //2004/05/17 yhf add


#define CLEAR_BOTTOM_ZONE dspl_Clear( KEY_AREA );

extern const unsigned char alarmBit[];
extern const unsigned char alarmBitMask;
//extern const unsigned char icnMnuListBkg[];// 2004/05/20 yhf remove

extern              Draw_Line;
static T_MFW_HND    tida_win  = NULL;
static uint8        tmpSwitch = 0;//gdy add

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       win;
    T_MFW_HND       kbd_win;
    T_MFW_HND       tim_win;
    CLOCK           temp_time;
    char            date_string[12];
    char            time_string[10];  
    int             index;
    int             id;  
    BOOL            AMPM_index;
    int             position_flag;// 1-ʱ	2Сʱ 3AM/PM
    int             tmode_flag;   // 1-12Сʱ 224Сʱ
} tidaData;//wyj

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        parent_win;
    T_MFW_HND        win;
    T_MFW_HND        kbd_win;
}browseAlarmData;

/* ʱ */
static T_MFW_HND    timedate_create(T_MFW_HND parent_window);//gdy add
static void         tida_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter);//gdy add
static int          timeDate_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);//gdy add
static T_MFW_CB     timedate_tim_cb(MfwEvt e, MfwTim *tc);//gdy add
static int          timedate_kbd_cb(MfwEvt e, MfwKbd *kc);//gdy add
static void         timedate_destroy (T_MFW_HND own_window);//gdy add
static void         tida_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);//gdy add infodialog cb

/*  */
static int          check_time(T_MFW_HND win, tidaData * edt_data); //ʱ
static int          check_date(T_MFW_HND win, tidaData * edt_data); //ʱ
static int          check_time1(T_MFW_HND win, void* edt_dat);      //Ӽ
static int          check_date1(T_MFW_HND win, void * edt_dat);     //Ӽ

/*  */
static void         date_time_edt_destroy  (T_MFW_HND own_window);
static T_MFW_HND    date_time_edt_create(T_MFW_HND parent_window);
static int          tida_edt_kbd_cb (MfwEvt e, MfwKbd *kc);
static void         tida_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int          tida_edt_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win);
static int          tida_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void         tida_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static void         date_time_destroy  (T_MFW_HND own_window);
static T_MFW_HND    date_time_create (T_MFW_HND parent_window);


static void         reset_edt_attr_sett(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
                                        U8 *controls, char *text,U16 size,MfwEdtAttr* attr);

static int          updateRtcDate(Date newDate);  // zgz,2002.8.15 Mobile Innovation
static int          updateRtcClock(CLOCK newClock);  // zgz,2002.8.15 Mobile Innovation



//zgz,2002.8.23  functions define for the world time
static T_MFW_HND    worldTime_create (T_MFW_HND parent_window);
static int          worldTime_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static T_MFW_CB     worldTime_tim_cb(T_MFW_EVENT event, T_MFW_TIM *tc);
static void         worldTime_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static void         worldTime_destroy(T_MFW_HND own_window);
static int          wt_kbd_cb(MfwEvt e, MfwKbd *kc);
static int          getLastDate(Date *d); // set d to it's last date
static int          getNextDate(Date *d); // set d to it's next date
static void         drawTimeZoneLine(int timezone); //timezone from 0 to 24
static int          adjustTimeDate(int curTimeZone);


static T_MFW_HND    weeklyAlarmStart(T_MFW_HND parent);
static T_MFW_HND    weeklyAlarmCreate(T_MFW_HND parent_window);
static void         weeklyAlarmCb(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int          weeklyAlarmWinCb(T_MFW_EVENT event, T_MFW_WIN * win);
static void         weeklyAlarmMenuCb(T_MFW_HND * Parent, ListMenuData * ListData);
static void         weeklyAlarmDestroy(T_MFW_HND own_window);

static T_MFW_HND    browseAlarm_create(T_MFW_HND parent_window);
static void         browseAlarm_DialogCb(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int          browseAlarm_kbd_cb (MfwEvt e, MfwKbd *kc);
static void         browseAlarm_destroy(T_MFW_HND own_window);




/*bmpWidth:120,bmpHigh:80*/

/*After convert 24-bit bmp to 16-bit(565) bmp,
    the datas of 16-bit bmp as follows:*/
/*Note:	RG is combined to make Data[1],GB is combined to make Data[0]. 
    This file is arranged by Data[0],Data[1],...,and so on */

/* 2004/05/20 yhf remove */
/*extern const unsigned char world_bmp[];
extern const unsigned char gImage_bar[];
extern const unsigned char left_key[];
extern const unsigned char left_key_mask[];
extern const unsigned char right_key[];
extern const unsigned char right_key_mask[];*/




const  char *weekdays[] =
{
    "\x80\x65\xe5\x00\x00", //
    "\x80\x4e\x00\x00\x00", //һ
    "\x80\x4e\x8c\x00\x00", //
    "\x80\x4e\x09\x00\x00", //
    "\x80\x56\xdb\x00\x00", //
    "\x80\x4e\x94\x00\x00", //
    "\x80\x51\x6d\x00\x00", //
};

const char *weekdayes[] =
{
    "Sun","Mon","Tue","Wed","Thu","Fri","Sat"
};

static      MfwHnd  win;                      /* our window               */
static      DisplayData DisplayInfo;
T_MFW_HND   weeklyAlarm_win;

#define MAX_DIG_TIDA		20	        /* size of buffer (??)  */
#define MAX_LEN_DATE		11	        /* maximum number of digits date*/
#define MAX_LEN_TIME		6	        /* maximum number of digits time*/
#define DATE_TEXT_X         28
#define DATE_TEXT_Y         16

typedef enum
{
    DAILY_ALARM,
    WEEKLY_ALARM,
    SETTING
} timeDateMode;

typedef struct
{
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         parent_win;
    T_MFW_HND         tida_win;
    T_MFW_HND         weAl_win;  // weekly alarm win.
    USHORT            display_id1;
    USHORT            display_id2;
    DAT_TIME_CASE_EC  state;               /* setting state            */
    //UBYTE				mode;				//whether we're setting the current time/date or alarm.
} T_tida;

typedef struct
{
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         parent_win;
    T_MFW_HND         tida_edt_win;
    T_MFW_HND         kbd_handle;
    T_MFW_HND         kbd_long_handle;
    T_MFW_HND         editor_handle;
    T_MFW_HND         tim_out_handle;
    DAT_TIME_CASE_EC  state;               /* setting state            */
    char              edtbuf1[MAX_DIG_TIDA];
    BOOL              position;
    BOOL              AMANDPM;
    MfwEdtAttr        edit1Attr;
    UBYTE             index;
}T_tida_edt;


typedef struct
{
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         parent_win;
    T_MFW_HND         wt_win;
    T_MFW_HND         tim_win;
    USHORT            display_id;
    int               curTZ;          // current time zone. from 0 to 24
    int               curCity;  //current city indication at curTZ. from 1 to Total Nums.
} T_worldtime;

/* REASONS */
typedef enum
{
    WT_INITIAL,
    WT_UPDATE,
    WT_SETTED,
    WT_DESTROY
}WORLD_TIME_EVENT;

const int w12TxtId[] = {1, TxtKwajalein};  //The text ID of cities in west 12 zone.  the first element indicate the City Nums.
const int w11TxtId[] = {2, TxtMidwayIs, TxtSamoa};
const int w10TxtId[] = {2, TxtHawaii, TxtHonolulu};
const int w09TxtId[] = {1, TxtAlaska};
const int w08TxtId[] = {2, TxtLosAngeles, TxtSanFrancisco};
const int w07TxtId[] = {1, TxtDenver};
const int w06TxtId[] = {2, TxtChicago, TxtMexicoCity};
const int w05TxtId[] = {3, TxtNewYork, TxtLima, TxtMontreal};
const int w04TxtId[] = {2, TxtSantiago, TxtLaPaz};
const int w03TxtId[] = {2, TxtBrasilia, TxtRioDeJaneiro};
const int w02TxtId[] = {1, TxtMidAtlantic};
const int w01TxtId[] = {1, TxtCapeVerdeIs};
const int w00TxtId[] = {3, TxtLondon, TxtCasablanca, TxtLisbon};
const int e01TxtId[] = {4, TxtRome, TxtBerlin, TxtParis, TxtMadrid};
const int e02TxtId[] = {3, TxtAthens, TxtEasternEurope, TxtHelsinki};
const int e03TxtId[] = {3, TxtBaghdad, TxtKoweit, TxtMoscow};
const int e04TxtId[] = {1, TxtTbilisi};
const int e05TxtId[] = {1, TxtIslamabad};
const int e06TxtId[] = {2, TxtAlmaty, TxtDhaKa};
const int e07TxtId[] = {2, TxtBangkok, TxtJaKarta};
const int e08TxtId[] = {3, TxtBeiJing, TxtHongkong, TxtSingapore};
const int e09TxtId[] = {2, TxtSeoul, TxtTokyo};
const int e10TxtId[] = {3, TxtGuam, TxtSydney, TxtVladivostok};
const int e11TxtId[] = {1, TxtSolomonIs};
const int e12TxtId[] = {3, TxtFiji, TxtMarshallIs, TxtWellington};

const int *cityTxtid[] = {
    w12TxtId,
    w11TxtId,
    w10TxtId,
    w09TxtId,
    w08TxtId,
    w07TxtId,
    w06TxtId,
    w05TxtId,
    w04TxtId,
    w03TxtId,
    w02TxtId,
    w01TxtId,
    w00TxtId,
    e01TxtId,
    e02TxtId,
    e03TxtId,
    e04TxtId,
    e05TxtId,
    e06TxtId,
    e07TxtId,
    e08TxtId,
    e09TxtId,
    e10TxtId,
    e11TxtId,
    e12TxtId
};

static const uint8 weekMask[] ={
    SUNDAY_M,
    MONDAY_M,
    TUESDAY_M,
    WEDNESDAY_M,
    THURSDAY_M,
    FRIDAY_M,
    SATURDAY_M
};

static MfwMnuAttr weeklyAlarm_menuAttrib =
{
    0,
    &menuWeeklyArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                  /* number of items			*/
};

static const int weekdayId[] ={
    TxtSunday,
    TxtMonday,
    TxtTuesday,
    TxtWednesday,
    TxtThursday,
    TxtFriday,
    TxtSaturday
};

/*
 Settings menu subs:
 */

/* #define TIMERESULT      1000           time for results         */
#define TIMERCLEAR		2500

//Flag to indicate whether we're setting the current or alarm date/time.
static UBYTE DateTimeEntryMode;
static UBYTE dailyAlarmed =0;  //xsf add for check if the alarm is alerted 09.24
static UBYTE weeklyAlarmed=0;

extern UBYTE            getcurrentAlarmTone(void);  //mmisounds
extern T_RTC_DATE_TIME  timedate;//zhonghz,globel var,define in mmimain.c
extern MfwHnd           gtVibator; //XSF 08.14 static MfwHnd gtVibator;


/* 2003.10.14 wyj ʱļ */
static void checkTimeSetNumInput(tidaData *data, U8 keynum);
static void checkTimeSetLeftInput(tidaData *data);
static void checkTimeSetRightInput(tidaData *data);

/* 2003.10.15 wyj ļ */
static void checkDateSetNumInput(tidaData *data, U8 keynum);
static void checkDateSetLeftInput(tidaData *data);
static void checkDateSetRightInput(tidaData *data);

/* 2003.10.15 wyj ļ */
static void checkAlarmNumInput(T_tida_edt *data, U8 keynum);
static void checkAlarmLeftInput(T_tida_edt *data);
static void checkAlarmRightInput(T_tida_edt *data);

/* 2003.12.1 wyj ʱתʱʾת */
static void timeset_12_to_24(tidaData *data);
static void timeset_24_to_12(tidaData *data);

/* 2003.12.8 wyj ÿӲ鿴ʾ */
static void weekc(void);
static void weeken(void);

/* ʱ */
extern const TD_Rect    TS_input_rect; 
extern const TD_Attri   TS_input_attr1;
extern const TD_Attri   TS_input_attr2;
extern const TD_Line    TS_index_l;
extern const Color      TS_index_c;
extern const TD_Rect    TS_tm_rect;
extern const TD_Attri   TS_tm_attr;
extern const TD_Rect    TS_AP_rect;
extern const TD_Attri   TS_AP_attr;

/*  */
extern const TD_Rect    DS_input_rect; 
extern const TD_Attri   DS_input_attr;
extern const TD_Rect    DS_hint_rect;
extern const TD_Attri   DS_hint_attr;
extern const TD_Attri   TS_tm_attr1;
extern const TD_Line    DS_index_l;
extern const Color      DS_index_c;

/*  */
extern const TD_Rect    AL_input_rect; 
extern const TD_Attri   AL_input_attr1;
extern const TD_Attri   AL_input_attr2;
extern const TD_Line    AL_index_l;
extern const Color      AL_index_c;
extern const TD_Rect    AL_hint_rect;
extern const TD_Attri   AL_hint_attr;
extern const TD_Rect    AL_AP_rect;
extern const TD_Attri   AL_AP_attr;

/* icon */
extern const MfwIcnAttr idl_AttrMask[];

/*******************************************************************************

 $Function:  date_time_create  

 $Description:	create main dialog for time and date (SINGLE_DYNAMIC)

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
/* "ÿ" "ÿ" ڴ */
static T_MFW_HND date_time_create (T_MFW_HND parent_window)
{
    T_MFW_WIN     * win;

    T_tida * data = (T_tida *)ALLOC_MEMORY (sizeof (T_tida));
    data->tida_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)tida_win_cb);

    TRACE_FUNCTION("MmiTimeDate:date_time_create");

    if( data->tida_win EQ 0 )
        return 0;

    /* Create window handler */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)tida_main;/* dialog main function    */
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->tida_win)->data;
    win->user                   = (void *) data;

    /* return window handle	*/
    mfwSetSignallingMethod(1);
    winShow(data->tida_win);

    return data->tida_win;
}
/*******************************************************************************

 $Function:  date_time_destroy  

 $Description:	 destroy main dialog for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static void date_time_destroy  (T_MFW_HND own_window)
{
    T_tida * data;
    T_MFW_WIN * win;

    if( own_window )
    {
        TRACE_EVENT("MmiTimeDate:date_time_destroy");
        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_tida *)win->user;

        if( data )
        {
            win_delete (data->tida_win);
            FREE_MEMORY((void *)data,(sizeof(T_tida)));
        }
    }
}
/*******************************************************************************

 $Function:  date_time_edt_create  

 $Description:	 create editor dialog for time and date(SINGLE_DYNAMIC)

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
/* "ÿ" "ÿ"ڳʼ */
static T_MFW_HND date_time_edt_create(T_MFW_HND parent_window)
{
    T_tida_edt * data = (T_tida_edt *)ALLOC_MEMORY (sizeof (T_tida_edt));
    T_MFW_WIN * win;
    T_MFW_WIN * win_data = ((T_MFW_HDR *)parent_window)->data;  //zgz,2002.8.30
    T_tida * tida_data = (T_tida *)win_data->user;//tida main data

    data->tida_edt_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)tida_edt_win_cb);

    TRACE_FUNCTION("MmiTimeDate:date_time_edt_create");

    if( data->tida_edt_win EQ 0 )
        return 0;

    /* Create window handler*/
    data->mmi_control.dialog    = (T_DIALOG_FUNC)tida_editor;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->tida_edt_win)->data;
    win->user                   = (void *) data;

    /* Create any other handler	*/
    //reset_edt_attr_sett(0,10,70,10,0,0,edtCurBar1 | edtModOverWr,0,(char*)data->edtbuf1,MAX_DIG_TIDA,&data->edit1Attr);
    if( tida_data->state == DATE_ENTRY_EC )
        reset_edt_attr_sett(20,55,90,20,0,0,edtCurBar1 | edtModOverWr,0,(char*)data->edtbuf1,MAX_DIG_TIDA,&data->edit1Attr);
    //else
    //	reset_edt_attr_sett(36,55,90,20,0,0,edtCurBar1 | edtModOverWr,0,(char*)data->edtbuf1,MAX_DIG_TIDA,&data->edit1Attr);
    //zgz,data->tim_out_handle = tim_create(data->tida_edt_win,TIMERCLEAR,(T_MFW_CB)tida_edt_tim_out_cb);
    // data->editor_handle = edt_create(data->tida_edt_win,&data->edit1Attr,0,0);
    data->kbd_handle = kbd_create(data->tida_edt_win,KEY_ALL,(T_MFW_CB)tida_edt_kbd_cb);
    //zgz,data->kbd_long_handle = kbd_create(data->tida_edt_win,KEY_ALL | KEY_LONG,(T_MFW_CB)tida_edt_kbd_long_cb);

    /* return window handle	*/
    return data->tida_edt_win;
}
/*******************************************************************************

 $Function:  date_time_edt_destroy  

 $Description:	destroy editor dialog for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static void date_time_edt_destroy  (T_MFW_HND own_window)
{
    T_tida_edt * data ;
    T_MFW_WIN * win;

    if( own_window )
    {
        TRACE_FUNCTION ("MmiTimeDate:date_time_edt_destroy");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_tida_edt *)win->user;

        if( data )
        {
            win_delete (data->tida_edt_win);
            FREE_MEMORY((void *)data,(sizeof(T_tida_edt)));
        }
    }
}
/*******************************************************************************

 $Function:  tida_main  

 $Description:	 main dialog function for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
/* "ÿ" "ÿ"¼ */
static void tida_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
    T_tida          *tida_data      = (T_tida *)win_data->user;//tida main data
    T_tida_edt      *tida_edt_data  = (T_tida_edt *) parameter;//tida editor data
    T_MFW_HND       tida_edt_win;
    T_DISPLAY_DATA  display_info;

    TRACE_FUNCTION("MmiTimeDate:tida_main");

    switch( event )
    {
    case DATE_SHOW_EC:
        tida_data->state = DATE_SHOW_EC;
        tida_data->display_id1 = TxtEnterDate;
        tida_edt_win = date_time_edt_create(tida_data->tida_win);
        if( tida_edt_win )
        {
            SEND_EVENT(tida_edt_win,event,0,tida_data);
        }
        break;
    case DATE_ENTRY_EC:
        tida_data->state = DATE_ENTRY_EC;
        tida_data->display_id1 = TxtEnterDate;
        tida_edt_win = date_time_edt_create(tida_data->tida_win);
        {
            SEND_EVENT(tida_edt_win,event,0,tida_data);
        }
        break;
    case TIME_ENTRY_EC:
        tida_data->state = TIME_ENTRY_EC;
        tida_data->display_id1 = TxtEnterTime;
        tida_edt_win = date_time_edt_create(tida_data->tida_win);
        if( tida_edt_win )
        {
            SEND_EVENT(tida_edt_win,event,0,tida_data);
        }
        break;
    case TIME_SHOW_EC:
        tida_data->state = TIME_SHOW_EC;
        tida_data->display_id1 = TxtEnterTime;
        tida_edt_win = date_time_edt_create(tida_data->tida_win);
        if( tida_edt_win )
        {
            SEND_EVENT(tida_edt_win,event,0,tida_data);
        }
        break;
    case ENTRY_OK_EC:
        dialog_info_init(&display_info);            
        display_info.TextId2 = TxtSaved;            
        display_info.RightSoftKey = TxtSoftBack;
        display_info.Time = FOREVER;
        display_info.KeyEvents = KEY_OK | KEY_RIGHT | KEY_LEFT;             
        display_info.iconindex = REMIND_COMPLETE;
        display_info.Callback = (T_VOID_FUNC)ECtida_info_cb;
        info_dialog(tida_data->tida_win,&display_info); /* information screen "Saved" */
        break;
    case SAVED_EC:
    case TIDA_ABORT_EC:
    case TIDA_CLEAR_EC:
    case TIDA_TO_IDLE_EC:
        date_time_destroy(tida_data->tida_win);
        break;
    default:
        break;
    }
}
/*******************************************************************************

 $Function:  ECtida_info_cb  

 $Description:	 callback function from info dialog for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
void ECtida_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reasons)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;
    //int i,uIndex=0;	

    TRACE_FUNCTION ("MmiTimeDate: ECtida_info_cb");
    date_time_destroy(tida_data->tida_win);

    /*switch(identifier)
    {
        case SAVED_EC:
            SEND_EVENT(tida_data->tida_win,identifier,0,NULL);
            break;
        default:
            break;
    }*/
}

/*******************************************************************************

 $Function:  tida_win_cb  

 $Description:	 windows main callback function for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static int tida_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    TRACE_FUNCTION ("MmiTimeDate: tida_win_cb");
    if( event EQ MfwWinVisible )
    {
        /* Top Window has no output	*/
        dspl_ClearAll();
        return 1;
    }
    return 0;
}
/*******************************************************************************

 $Function:  tida_edt_win_cb  

 $Description:	 windows callback function for editor for time and date

 $Returns:		none.

 $Arguments:	7
 
*******************************************************************************/
/* "ÿ" "ÿ" ʾص */
static int tida_edt_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win)
{
    T_tida_edt      *edt_data   = (T_tida_edt *)win->user;//tida edt data
    T_MFW_WIN       *win_tida   = ((T_MFW_HDR *)edt_data->parent_win)->data;
    T_tida          *tida_data  = (T_tida *)win_tida->user; // tida main data
    char            lin1[MAX_LEN_DATE];
    char            lin2[MAX_LEN_TIME];
    char            string[4];
    int             old_color;
    game_Line       line;
    game_Rectangle  rectangle;
    TD_Line         l;

    memset(lin1, '\0', sizeof(lin1));
    memset(lin2, '\0', sizeof(lin2));

    TRACE_FUNCTION ("MmiTimeDate:tida_edt_win_cb");

    if( event EQ MfwWinVisible )
    {
        U8 uMode = 0;
        uMode = dspl_Enable(0);

        dspl_ClearAll();

        if( tida_data->state EQ TIME_ENTRY_EC )
        {
            TRACE_EVENT("dspl_title");

            /* background display */
            TD_drawBkg(BG_rect, BG_attr);

            /* title display */
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_MENUUP);
            /*dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
            */
            /* 2004/05/20 yhf modify */
#if(MAIN_LCD_SIZE==3)
			if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)//ʾ
				dspl_colorTextOut(32,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtEnterTime),0x0);
			else			
				dspl_colorTextOut((102-wstrlen(MmiRsrcGetText(TxtEnterTime))*6)/2,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtEnterTime),0x0);
#elif(MAIN_LCD_SIZE==4)
            if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                dspl_colorTextOut(32,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtEnterTime),0x0);
            else
                dspl_colorTextOut((102-wstrlen(MmiRsrcGetText(TxtEnterTime))*6)/2,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtEnterTime),0x0);
#endif
            /* input rect display */
            if( !edt_data->position )         //focus on input rect
            {
                TD_drawSolidRectangle(AL_input_rect, AL_input_attr1);
                l       = AL_index_l;
#if(MAIN_LCD_SIZE==3)
				l.x1	= AL_index_l.x1 + edt_data->index*8;
				l.x2	= AL_index_l.x2 + edt_data->index*8;
#elif(MAIN_LCD_SIZE==4)
                l.x1    = AL_index_l.x1 + edt_data->index*8;
                l.x2    = AL_index_l.x2 + edt_data->index*8;
#endif
                TD_drawLine(l, AL_index_c);
            }
            else
            {
                TD_drawSolidRectangle(AL_input_rect, AL_input_attr2);
            }    
            /* hint rect dispaly */
#if(MAIN_LCD_SIZE==3)
			dspl_colorTextOut(30+EX, 20, DSPL_TXTATTR_TRANSPARENT, edt_data->edtbuf1,0 );
#elif(MAIN_LCD_SIZE==4)
			dspl_colorTextOut(40+EX, 57, DSPL_TXTATTR_TRANSPARENT, edt_data->edtbuf1,0 );
#endif			
            TD_drawSolidRectangle(AL_hint_rect, AL_hint_attr);
            set_font_type(UNI12X12_FONT);
#if(MAIN_LCD_SIZE==4)
            if( FFS_flashData.time_format==TWENTYFOUR_HOUR )
            {
                if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                    dspl_colorTextOut(37+EX, 103, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),0);
                else
                    dspl_colorTextOut(36+EX, 103, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),0);
            }
            else
            {
                if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                    dspl_colorTextOut(37+EX, 103, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),0);
                else
                    dspl_colorTextOut(36+EX, 103, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),0);
            }
#elif(MAIN_LCD_SIZE==3)
			if(FFS_flashData.time_format==TWENTYFOUR_HOUR)
			{       
				if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
					dspl_colorTextOut(28+EX, 50, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),0);
				else
					dspl_colorTextOut(28+EX, 50, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),0);
			}
			else
			{		
				if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
					dspl_colorTextOut(28+EX, 50, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),0);
				else
					dspl_colorTextOut(28+EX, 50, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),0);
			}
#endif
            /* AM/PM rect display */
            if( FFS_flashData.time_format==TWELVE_HOUR )
            {
                memset(string,0,4);

                if( edt_data->AMANDPM )
                    strcpy(string,"PM");
                else
                    strcpy(string,"AM");    

                if( edt_data->position )      //focus on AM/PM rect
                {
                    TD_drawSolidRectangle(AL_AP_rect, AL_AP_attr);

                    /*dspl_BitBlt(35+EX, 38, 4, 8, 0, (void *)left_key, DSPL_BMPXOR);
                    dspl_BitBlt(35+EX, 38, 4, 8, 0, (void *)left_key_mask, DSPL_BMPAND);
                    dspl_BitBlt(35+EX, 38, 4, 8, 0, (void *)left_key, DSPL_BMPXOR);

                    dspl_BitBlt(64+EX, 38, 4, 8, 0, (void *)right_key, DSPL_BMPXOR);
                    dspl_BitBlt(64+EX, 38, 4, 8, 0, (void *)right_key_mask, DSPL_BMPAND);
                    dspl_BitBlt(64+EX, 38, 4, 8, 0, (void *)right_key, DSPL_BMPXOR);*/

                    dspl_colorTextOut(52+EX, 81, DSPL_TXTATTR_TRANSPARENT, string, 0xffffff);   
                }
                else
                {
                    dspl_colorTextOut(52+EX, 81, DSPL_TXTATTR_TRANSPARENT, string, 0x000000);   
                }
            }

            /*  icon display */
            /* 2004/06 sunsj modify for picture manage */
            //dspl_BitBlt(13+EX, 59, idl_Attr[iconIdAlarm].area.sx, idl_Attr[iconIdAlarm].area.sy, 0, idl_Attr[iconIdAlarm].icons, DSPL_BMPXOR);
            //dspl_BitBlt(13+EX, 59, idl_AttrMask[iconIdAlarm].area.sx, idl_AttrMask[iconIdAlarm].area.sy, 0, idl_AttrMask[iconIdAlarm].icons, DSPL_BMPAND);
            //dspl_BitBlt(13+EX, 59, idl_Attr[iconIdAlarm].area.sx, idl_Attr[iconIdAlarm].area.sy, 0, idl_Attr[iconIdAlarm].icons, DSPL_BMPXOR);
#if(MAIN_LCD_SIZE==3)
			DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, 3+EX,20, iconIdAlarm, ICON_MASK|ICON_LOCATION);
#elif(MAIN_LCD_SIZE==4)
            DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, 13+EX, 59, iconIdAlarm, ICON_MASK|ICON_LOCATION);
#endif
            /***end yhf modify***/

            displaySoftKeys(TxtSoftOK,TxtSoftBack);
        }
        else if( tida_data->state EQ TIME_SHOW_EC )
        {
            if( (DateTimeEntryMode == SETTING) || (FFS_flashData.alarm_day == 0) )
                sprintf(lin2,"%02d:%02d",currclock.hour, currclock.min);
            else
                sprintf(lin2,"%02d:%02d",FFS_flashData.alarm_hour, FFS_flashData.alarm_minute);

            strncpy(edt_data->edtbuf1,lin2,MAX_LEN_TIME);
            edtShow(edt_data->editor_handle);
            edtChar(edt_data->editor_handle, ecTop);
        }

        dspl_Enable(uMode );
        return 1;
    }
    return 0;
}
/*******************************************************************************

 $Function:  tida_editor  

 $Description:	 dialog function for editor for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
/* "ÿ" "ÿ"¼ 
 * 2003.10.28 wyj AM/PM */
static void tida_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida_edt * edt_data = (T_tida_edt *)win_data->user;

    T_tida * tida_data = (T_tida *)parameter;//tida main data
    char lin2[MAX_DIG_TIDA];
    int hour;

    edt_data->state = tida_data->state;

    TRACE_FUNCTION("MmiTimeDate:tida_editor");

    /* depending on event */
    switch( event )
    {
    case DATE_SHOW_EC:
    case TIME_SHOW_EC:
        memset(edt_data->edtbuf1, '\0', sizeof(edt_data->edtbuf1));/* initial buffer  */
        edt_data->index = 0;
        winShow(edt_data->tida_edt_win);
        break;
    case DATE_ENTRY_EC:
    case TIME_ENTRY_EC:
        memset(lin2,0,sizeof(lin2));
        memset(edt_data->edtbuf1,0,sizeof(edt_data->edtbuf1));
        if( DateTimeEntryMode == SETTING )
            sprintf(lin2,"%02d:%02d",currclock.hour, currclock.min);
        else if( DateTimeEntryMode == DAILY_ALARM )
        {
            hour=FFS_flashData.dailyAlarm_hour;
            /* 2003.10.28 wyj AM/PM */
            if( FFS_flashData.time_format == TWELVE_HOUR )
            {
                if( hour > 11 )               //PM
                {
                    edt_data->AMANDPM = 1;
                    if( hour != 12 )
                        hour %= 12;
                }
                else                        //AM
                {
                    edt_data->AMANDPM = 0;
                }
            }
            sprintf(lin2,"%02d:%02d",hour, FFS_flashData.dailyAlarm_min);
        }
        else if( DateTimeEntryMode == WEEKLY_ALARM )
        {
            hour=FFS_flashData.weeklyAlarm_hour;    //2003.10.28 wyj 
            /* 2003.10.28 wyj AM/PM */
            if( FFS_flashData.time_format == TWELVE_HOUR )
            {
                if( hour > 11 )               //PM
                {
                    edt_data->AMANDPM = 1;
                    if( hour != 12 )
                        hour %= 12;
                }
                else                        //AM
                {
                    edt_data->AMANDPM=0;
                }
            }
            sprintf(lin2,"%02d:%02d",hour, FFS_flashData.weeklyAlarm_min);
        }
        edt_data->position=0;
        strcpy(edt_data->edtbuf1,lin2);
        TRACE_EVENT(edt_data->edtbuf1);
        winShow(edt_data->tida_edt_win);
        break;
    default:
        break;
    }
}
/*******************************************************************************

 $Function:  tida_edt_kbd_cb  

 $Description:	 keyboard event handler for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
/* "ÿ" "ÿ"
 * 2003.10.28 wyj 12/24Сʱ */
static int tida_edt_kbd_cb (MfwEvt e, MfwKbd *kc)
{
    T_MFW_HND win = mfw_parent(mfw_header());  

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida_edt * edt_data = (T_tida_edt *)win_data->user;//tida edt data

    T_MFW_WIN * win_tida =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_tida * tida_data = (T_tida *)win_tida->user; // tida main data

    //nm T_DateTime currentTime;
    char lin1[MAX_LEN_DATE];
    char lin2[MAX_LEN_TIME];
    T_DISPLAY_DATA display_info;
    int return_value=1;
    int hour;
    int minute;
    char temp_hour[3];
    char temp_minute[3];
    //nm   memset(lin1, '\0', sizeof(lin1));/* initial string  */
    //nm   memset(lin2, '\0', sizeof(lin2));

    TRACE_FUNCTION ("MmiTimeDate: tida_edt_kbd_cb");

    switch( kc->code )
    {
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
        if( edt_data->state EQ DATE_ENTRY_EC )                  /* date entering            */
        {
            if( edt_data->index < (MAX_LEN_DATE - 1) )
            {
                if( (edt_data->index NEQ 2) && (edt_data->index NEQ 5) )
                {
                    edt_data->edtbuf1[edt_data->index] = '0' + kc->code;
                    edtChar(edt_data->editor_handle,edt_data->edtbuf1[edt_data->index]);
                    edt_data->index++;
                }
                if( (edt_data->index EQ 2) || (edt_data->index EQ 5) )
                {
                    edtChar(edt_data->editor_handle,'/');
                    edt_data->edtbuf1[edt_data->index] = '/';
                    edt_data->index++;
                }
                if( edt_data->index == 10 )  //zgz,2002.8.16 added
                {
                    edt_data->index = 0;
                    edtChar(edt_data->editor_handle,ecTop);
                }
            }
        }
        else if( edt_data->state EQ TIME_ENTRY_EC )             /* time entering            */
        {
            /* 2003.10.15 wyj  */   
            checkAlarmNumInput(edt_data,  kc->code);
        }
        winShow(win);
        break;

    case KCD_LEFT:                                 /* select and ok button */
    case KCD_OK:
        if( edt_data->state EQ DATE_ENTRY_EC )
        {
            if( check_date1(win,edt_data)>0 )
            {
                TRACE_EVENT("datecheck ok");
                edtClear(edt_data->editor_handle);
                edtHide(edt_data->editor_handle);   /* verification date successfull */
                date_time_edt_destroy(edt_data->tida_edt_win);
                SEND_EVENT(tida_data->tida_win,ENTRY_OK_EC,0,tida_data); //SEND_EVENT(tida_data->tida_win,TIME_ENTRY_EC,0,tida_data);
            }
            else
            {
                memset(edt_data->edtbuf1, '\0', sizeof(edt_data->edtbuf1));/* initial buffer  */
                edt_data->index = 0;
                sprintf(lin1,"%02d/%02d/%04d",currdate.day,currdate.month,currdate.year);
                //sprintf(lin1,"%d/%d/%d",currdate.day,currdate.month,currdate.year);
                strncpy(edt_data->edtbuf1,lin1,MAX_LEN_DATE);
                edtReset(edt_data->editor_handle);
                edtShow(edt_data->editor_handle);
                edtChar(edt_data->editor_handle, ecTop);

                dialog_info_init(&display_info);//gdy add 						
                display_info.TextId2     =TxtFailed;                       
                display_info.Time       = FOREVER;
                display_info.iconindex = REMIND_FAILURE;
                display_info.Callback     = (T_VOID_FUNC)NULL;//auto_dialog_cb;

                /* Call Info Screen	*/
                info_dialog (edt_data->parent_win, &display_info);
            }
        }
        else if( edt_data->state EQ TIME_ENTRY_EC )
        {
            memset(temp_hour,0,3);
            memset(temp_minute,0,3);
            temp_hour[0]=edt_data->edtbuf1[0];
            temp_hour[1]=edt_data->edtbuf1[1];
            temp_minute[0]=edt_data->edtbuf1[3];
            temp_minute[1]=edt_data->edtbuf1[4];
            hour=atoi(temp_hour);
            minute=atoi(temp_minute);
            /* 2003.10.28 wyj 12/24Сʱ */
            if( FFS_flashData.time_format == TWELVE_HOUR )
            {
                if( edt_data->AMANDPM )
                {
                    if( hour<12 && hour>0 )
                    {
                        hour += 12;
                    }
                }

                memset(edt_data->edtbuf1,0,sizeof(edt_data->edtbuf1));
                sprintf(edt_data->edtbuf1,"%02d:%02d",hour,minute);
            }

            if( check_time1(win,edt_data)>0 )
            {
                TRACE_EVENT("timecheck ok");
                edtClear(edt_data->editor_handle);
                edtHide(edt_data->editor_handle);   /* verification date successfull */
                date_time_edt_destroy(edt_data->tida_edt_win);
                SEND_EVENT(tida_data->tida_win,ENTRY_OK_EC,0,tida_data);
            }
            else
            {
                memset(edt_data->edtbuf1, '\0', sizeof(edt_data->edtbuf1));/* initial buffer  */
                edt_data->index = 0;

                sprintf(lin2,"%02d:%02d",currclock.hour, currclock.min);
                strncpy(edt_data->edtbuf1,lin2,MAX_LEN_TIME);
                edtReset(edt_data->editor_handle);
                edtShow(edt_data->editor_handle);
                edtChar(edt_data->editor_handle, ecTop);

                dialog_info_init(&display_info);//gdy add 						
                display_info.TextId2     =TxtFailed;                        
                display_info.Time       = FOREVER;
                display_info.iconindex = REMIND_FAILURE;

                display_info.Callback     = (T_VOID_FUNC)NULL;//auto_dialog_cb;

                /* Call Info Screen */
                info_dialog (edt_data->parent_win, &display_info);                  
            }
        }
        else if( edt_data->state EQ DATE_SHOW_EC )
        {
            date_time_edt_destroy(edt_data->tida_edt_win);
            SEND_EVENT(tida_data->tida_win,DATE_ENTRY_EC,0,tida_data);
        }                                   /* start date entering      */

        else if( edt_data->state EQ TIME_SHOW_EC )
        {
            date_time_edt_destroy(edt_data->tida_edt_win);
            SEND_EVENT(tida_data->tida_win,TIME_ENTRY_EC,0,tida_data);      /* start time entering      */
        }
        break;
    case KCD_HUP:
    case KCD_RIGHT:                                /* back to previous menu */
        //FFS_flashData.weeklyAlarm_switch=0;//gdy add
        date_time_edt_destroy(edt_data->tida_edt_win);
        SEND_EVENT(tida_data->tida_win,TIDA_ABORT_EC,0,tida_data);
        break;
    case KCD_MNURIGHT:                                /* cursor to right  */
        if( (edt_data->state EQ DATE_ENTRY_EC) || (edt_data->state EQ TIME_ENTRY_EC) )    /* cursor to rigt           */
        {
            if( !edt_data->position ) //겻AM/PM
            {
                /* 2003.10.15 wyj ޸ */
                if( edt_data->state EQ TIME_ENTRY_EC )
                    checkAlarmRightInput(edt_data);

                if( ((edt_data->state EQ DATE_ENTRY_EC) && (edt_data->index EQ 10)) )
                {
                    edt_data->index = 0;
                    //edtChar(edt_data->editor_handle,ecTop);
                }

                if( ((edt_data->state EQ DATE_ENTRY_EC) && ((edt_data->index EQ 2)||(edt_data->index EQ 5))) )
                {
                    edt_data->index++;
                    //edtChar(edt_data->editor_handle,ecRight);
                }
            }
            else
            {
                edt_data->AMANDPM =! edt_data->AMANDPM;
            }
        }
        winShow(win);
        break;
    case KCD_MNULEFT:                            /* cursor to left   */
        if( (!(edt_data->state EQ DATE_SHOW_EC)) && (!(edt_data->state EQ TIME_SHOW_EC)) )
        {
            if( edt_data->state EQ DATE_ENTRY_EC )
            {
                if( edt_data->index EQ 0 )
                {
                    edt_data->index = 9;
                    //	edtChar(edt_data->editor_handle,ecLeft);
                    //	edtChar(edt_data->editor_handle,ecLeft);
                    return MFW_EVENT_CONSUMED;
                }
                else
                    edt_data->index--;

                if( (edt_data->index EQ 2)||(edt_data->index EQ 5) )
                {
                    if( edt_data->index EQ 0 )
                        ;
                    else
                        edt_data->index--;
                    //edtChar(edt_data->editor_handle,ecLeft);
                    //edtChar(edt_data->editor_handle,ecLeft);
                }
            }
            if( edt_data->state EQ TIME_ENTRY_EC )
            {
                if( !edt_data->position )
                    /* 2003.10.15 wyj ޸ */
                    checkAlarmLeftInput(edt_data);
                else
                    edt_data->AMANDPM=!edt_data->AMANDPM;
            }
        }
        winShow(win);
        break;
    case KCD_MNUDOWN:
    case KCD_MNUUP:
        if( FFS_flashData.time_format==TWELVE_HOUR )
        {
            edt_data->position=!edt_data->position;
            edt_data->index=0;
            winShow(win);
        }
        break;
    default:
        return MFW_EVENT_CONSUMED;
    }       

    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:  check_date  

 $Description:	 check date after date entering

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static int check_date(T_MFW_HND win, tidaData* edt_data)
{
    U8 i;
    //T_tida_edt * edt_data = (T_tida_edt *)edt_dat;
    //T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    //T_tida * tida_data = (T_tida *)win_data->user;
    Date tempdate;

    char internday[3];
    char internmonth[3];
    char internyear[5];
    int value;

    char debug[20];

    TRACE_FUNCTION ("MmiTimeDate:check_date");
    TRACE_EVENT(edt_data->date_string);
    TRACE_EVENT("edt_data->date_string");

    memset(internday, '\0', sizeof(internday));/* initial string  */
    memset(internmonth, '\0', sizeof(internmonth));
    memset(internyear, '\0', sizeof(internyear));

    internday[0] = edt_data->date_string[8];
    internday[1] = edt_data->date_string[9];
    internmonth[0] = edt_data->date_string[5];
    internmonth[1] = edt_data->date_string[6];
    for( i = 0;i<4;i++ )
    {
        internyear[i] = edt_data->date_string[i];
    }

    tempdate.month = atoi(internmonth);
    TRACE_EVENT("month:");
    TraceInt(tempdate.month);
    if( (tempdate.month > 12) || (tempdate.month < 1) )
        return FALSE;

    tempdate.day = atoi(internday);
    TRACE_EVENT("day:");
    TraceInt(tempdate.day);
    if( (tempdate.day > 30) || (tempdate.day < 1) )
    {
        if( tempdate.day EQ 31 )
        {
            switch( tempdate.month )
            {
            case 1:
            case 3:
            case 5:
            case 7:
            case 8:
            case 10:
            case 12:
                break;
            default:
                return FALSE;
            }
        }
        else
            return FALSE;
    }

    tempdate.year = atoi(internyear);

    TRACE_EVENT("year:");
    TraceInt(tempdate.year);

    if( (tempdate.year) < 2000 || (tempdate.year > 2099) )  //zgz,2002.8.16 revise it
        return FALSE;

    if( (tempdate.month EQ 2) && (tempdate.day EQ 29) )
    {
        if( !(tempdate.year%4)&&(tempdate.year%100)||!(tempdate.year%400) )  // zgz,if the year is runnian.
        {
            if( DateTimeEntryMode == DAILY_ALARM )
            {
                FFS_flashData.alarm_day = tempdate.day;
                FFS_flashData.alarm_month = tempdate.month;
                FFS_flashData.alarm_year = tempdate.year;
                if( flash_write() )  // zgz, 2002.8.15 just only write alarm setting to flash
                    return FALSE;
            }
            else
            {
                FFS_flashData.current_day = tempdate.day;
                FFS_flashData.current_month = tempdate.month;
                FFS_flashData.current_year = tempdate.year;
                currdate.day = tempdate.day;
                currdate.month = tempdate.month;
                currdate.year = tempdate.year;
            }
            //flash_write();
            value=updateRtcDate(tempdate);
            TraceInt(value);
            if( value<0 )
                return -1;
            set_latest_alarm();
            return TRUE;
        }
        else
            return FALSE;
    }
    else if( !((tempdate.month EQ 2) && (tempdate.day EQ 30)) )
    {
        if( DateTimeEntryMode == DAILY_ALARM )
        {


            FFS_flashData.alarm_day = tempdate.day;
            FFS_flashData.alarm_month = tempdate.month;
            FFS_flashData.alarm_year = tempdate.year;
            if( flash_write() )  // zgz, 2002.8.15 just only write alarm setting to flash
                return FALSE;
        }
        else
        {
            FFS_flashData.current_day = tempdate.day;
            FFS_flashData.current_month = tempdate.month;
            FFS_flashData.current_year = tempdate.year;             
            currdate.day = tempdate.day;
            currdate.month = tempdate.month;
            currdate.year = tempdate.year;
        }
        //flash_write();
        value=updateRtcDate(tempdate);
        TraceInt(value);
        if( value<0 )
            return -1;
        set_latest_alarm();     

        return TRUE;
    }
    else
    {
        return FALSE;
    }
}
/*******************************************************************************

 $Function:  check_time  

 $Description:	check time after time entering

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
/* 2003.10.28 wyj AM/PM */
static int check_time (T_MFW_HND win, tidaData* edt_data)
{
    //T_tida_edt * edt_data = (T_tida_edt *)edt_dat;
    //T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    //T_tida * tida_data = (T_tida *)win_data->user;
    CLOCK tempclock;
    char debug[50];
    char internmin[3];
    char internhour[3];
    char internsec[3];

    memset(internmin, '\0', sizeof(internmin));/* initial string  */
    memset(internhour, '\0', sizeof(internhour));

    internhour[0] = edt_data->time_string[0];
    internhour[1] = edt_data->time_string[1];
    internmin[0] = edt_data->time_string[3];
    internmin[1] = edt_data->time_string[4];
    internsec[0] = edt_data->time_string[6];
    internsec[1] = edt_data->time_string[7];

    tempclock.hour = atoi(internhour);
    if( tempclock.hour > 23 )
        return FALSE;

    tempclock.min = atoi(internmin);
    if( tempclock.min >59 )
        return FALSE;

    tempclock.sec = atoi(internsec);
    if( tempclock.sec >59 )
        return FALSE;
    /*	if (DateTimeEntryMode == DAILY_ALARM)
    {	
    FFS_flashData.dailyAlarm_hour = tempclock.hour;		
    FFS_flashData.dailyAlarm_min = tempclock.min;
    FFS_flashData.dailyAlarm_switch = 1;
    flash_write();
    iconsSetState(iconIdAlarm);
    set_latest_alarm();
}*/
    //else if(DateTimeEntryMode == SETTING)
    //{	
    if( edt_data->tmode_flag == 1 )
    {
        FFS_flashData.time_format = TWELVE_HOUR;
    }
    else
    {
        FFS_flashData.time_format = TWENTYFOUR_HOUR;
    }
    flash_write();

    /* 2003.10.28 wyj AM/PM */
    if( FFS_flashData.time_format == TWELVE_HOUR )
    {
        if( edt_data->AMPM_index )            //PM
        {
            if( tempclock.hour<12 && tempclock.hour>0 )
                tempclock.hour += 12;
        }
    }
    FFS_flashData.current_hour  = tempclock.hour;       
    FFS_flashData.current_minute = tempclock.min;

    currclock.hour = tempclock.hour;
    currclock.min = tempclock.min;
    currclock.sec = tempclock.sec;
    //zgz,2002.8.15 ClockSet(&currclock);
    if( updateRtcClock(tempclock)<0 )
        return -1;
    /*}
    //else if(DateTimeEntryMode == WEEKLY_ALARM)
    {
        FFS_flashData.weeklyAlarm_hour= tempclock.hour;		
        FFS_flashData.weeklyAlarm_min= tempclock.min;
        flash_write();		
        iconsSetState(iconIdAlarm);
    }*/
    set_latest_alarm();

    return TRUE;
}


static int check_time1(T_MFW_HND win, void * edt_dat)
{
    T_tida_edt * edt_data = (T_tida_edt *)edt_dat;
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;
    CLOCK tempclock;
    char debug[50];
    char internmin[3];
    char internhour[3];

    memset(internmin, '\0', sizeof(internmin));/* initial string  */
    memset(internhour, '\0', sizeof(internhour));

    internhour[0] = edt_data->edtbuf1[0];
    internhour[1] = edt_data->edtbuf1[1];
    internmin[0] = edt_data->edtbuf1[3];
    internmin[1] = edt_data->edtbuf1[4];

    tempclock.hour = atoi(internhour);
    if( tempclock.hour > 23 )
        return FALSE;

    tempclock.min = atoi(internmin);
    if( tempclock.min >59 )
        return FALSE;
    if( DateTimeEntryMode == DAILY_ALARM )
    {
        FFS_flashData.dailyAlarm_hour = tempclock.hour;     
        FFS_flashData.dailyAlarm_min = tempclock.min;
        FFS_flashData.dailyAlarm_switch = 1;
        flash_write();
        iconsSetState(iconIdAlarm);
        //set_latest_alarm();
    }
    else if( DateTimeEntryMode == SETTING )
    {
        FFS_flashData.current_hour = tempclock.hour;        
        FFS_flashData.current_minute = tempclock.min;

        currclock.hour = tempclock.hour;
        currclock.min = tempclock.min;
        //zgz,2002.8.15 ClockSet(&currclock);
        if( updateRtcClock(tempclock)<0 )
            return -1;
    }
    else if( DateTimeEntryMode == WEEKLY_ALARM )
    {
        if( tmpSwitch != FFS_flashData.weeklyAlarm_switch )
            FFS_flashData.weeklyAlarm_switch = tmpSwitch;

        FFS_flashData.weeklyAlarm_hour= tempclock.hour;     
        FFS_flashData.weeklyAlarm_min= tempclock.min;
        flash_write();  
        iconsSetState(iconIdAlarm);
    }
    set_latest_alarm();

    return TRUE;
}


static int check_date1(T_MFW_HND win, void * edt_dat)
{
    U8 i;
    T_tida_edt * edt_data = (T_tida_edt *)edt_dat;
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;
    Date tempdate;

    char internday[3];
    char internmonth[3];
    char internyear[5];

    char debug[20];

    TRACE_FUNCTION ("MmiTimeDate:check_date1");
    TRACE_EVENT(edt_data->edtbuf1);

    memset(internday, '\0', sizeof(internday));/* initial string  */
    memset(internmonth, '\0', sizeof(internmonth));
    memset(internyear, '\0', sizeof(internyear));

    internday[0] = edt_data->edtbuf1[0];
    internday[1] = edt_data->edtbuf1[1];
    internmonth[0] = edt_data->edtbuf1[3];
    internmonth[1] = edt_data->edtbuf1[4];
    for( i = 0;i<4;i++ )
    {
        internyear[i] = edt_data->edtbuf1[6+i];
    }

    tempdate.month = atoi(internmonth);
    if( (tempdate.month > 12) || (tempdate.month < 1) )
        return FALSE;

    tempdate.day = atoi(internday);
    if( (tempdate.day > 30) || (tempdate.day < 1) )
    {
        if( tempdate.day EQ 31 )
        {
            switch( tempdate.month )
            {
            case 1:
            case 3:
            case 5:
            case 7:
            case 8:
            case 10:
            case 12:
                break;
            default:
                return FALSE;
            }
        }
        else
            return FALSE;
    }

    tempdate.year = atoi(internyear);

    if( (tempdate.year) < 2000 || (tempdate.year > 2099) )  //zgz,2002.8.16 revise it
        return FALSE;

    if( (tempdate.month EQ 2) && (tempdate.day EQ 29) )
    {
        if( !(tempdate.year%4)&&(tempdate.year%100)||!(tempdate.year%400) )  // zgz,if the year is runnian.
        {
            if( DateTimeEntryMode == DAILY_ALARM )
            {
                FFS_flashData.alarm_day = tempdate.day;
                FFS_flashData.alarm_month = tempdate.month;
                FFS_flashData.alarm_year = tempdate.year;
                flash_write();  // zgz, 2002.8.15 just only write alarm setting to flash
            }
            else
            {
                FFS_flashData.current_day = tempdate.day;
                FFS_flashData.current_month = tempdate.month;
                FFS_flashData.current_year = tempdate.year;
                currdate.day = tempdate.day;
                currdate.month = tempdate.month;
                currdate.year = tempdate.year;
            }
            //flash_write();
            if( updateRtcDate(tempdate)<0 )
                return -1;
            set_latest_alarm();
            return TRUE;
        }
        else
            return FALSE;
    }
    else if( !((tempdate.month EQ 2) && (tempdate.day EQ 30)) )
    {
        if( DateTimeEntryMode == DAILY_ALARM )
        {
            FFS_flashData.alarm_day = tempdate.day;
            FFS_flashData.alarm_month = tempdate.month;
            FFS_flashData.alarm_year = tempdate.year;
            if( flash_write() )  // zgz, 2002.8.15 just only write alarm setting to flash
                return FALSE;
        }
        else
        {
            FFS_flashData.current_day = tempdate.day;
            FFS_flashData.current_month = tempdate.month;
            FFS_flashData.current_year = tempdate.year;             
            currdate.day = tempdate.day;
            currdate.month = tempdate.month;
            currdate.year = tempdate.year;
        }
        //flash_write();
        updateRtcDate(tempdate);
        set_latest_alarm();     

        return TRUE;
    }
    else
    {
        return FALSE;
    }
}
/*******************************************************************************

 $Function:  reset_edt_attr_sett  

 $Description:	 initialize editor buffer for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static void reset_edt_attr_sett(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
                                U8 *controls, char *text,U16 size,MfwEdtAttr* attr)
{

    attr->win.px = winPx;
    attr->win.py = winPy;
    attr->win.sx = winSx;
    attr->win.sy = winSy;
    attr->fgColor = fgColor;
    attr->font = font;
    attr->mode = mode;
    attr->controls = controls;
    attr->text = text;
    attr->size = size;
}

static int updateRtcDate(Date newDate)  // zgz,2002.8.15 Mobile Innovation
{
    T_RTC_DATE_TIME rtcTime;

    RTC_GetDateTime(&rtcTime);
    if( rtcTime.hour>23 )
        rtcTime.hour=23;
    if( rtcTime.hour<0 )
        rtcTime.hour=0;
    if( rtcTime.minute>59 )
        rtcTime.minute=59;
    if( rtcTime.minute<0 )
        rtcTime.minute=0;
    if( rtcTime.second>59 )
        rtcTime.second=59;
    if( rtcTime.second<0 )
        rtcTime.second=0;
    rtcTime.mode_12_hour=FALSE;
    rtcTime.day = newDate.day;
    rtcTime.month = newDate.month;
    rtcTime.year = newDate.year - 2000; 

    return RTC_SetDateTime(rtcTime);
}

static int updateRtcClock(CLOCK newClock)  // zgz,2002.8.15 Mobile Innovation
{
    T_RTC_DATE_TIME rtcTime;

    TRACE_EVENT("updateRtcClock");
    RTC_GetDateTime(&rtcTime);

    if( rtcTime.year>99 )
        rtcTime.year=99;
    if( rtcTime.year<0 )
        rtcTime.year=0;
    if( rtcTime.month>12 )
        rtcTime.month=12;
    if( rtcTime.month<1 )
        rtcTime.month=1;
    switch( rtcTime.month )
    {
    case 1:
    case 3:
    case 5:
    case 7:
    case 8:
    case 10:
    case 12:
        if( rtcTime.day>31 )
            rtcTime.day=31;
        if( rtcTime.day<1 )
            rtcTime.day=1;
        break;
    case 2:
        /*talcon 2004.05.26,talcon modify*/
        //if(!((rtcTime.year+2000)%4)&&((rtcTime.year+2000)%100)&&!((rtcTime.year+2000)%400))
        if( ( (rtcTime.year+2000)%4 ==0 && (rtcTime.year+2000)%100 !=0 )
            ||( (rtcTime.year+2000)%400 == 0) )
        {
            if( rtcTime.day>29 )
                rtcTime.day=29;
            if( rtcTime.day<1 )
                rtcTime.day=1;
        }
        else
        {
            if( rtcTime.day>28 )
                rtcTime.day=28;
            if( rtcTime.day<1 )
                rtcTime.day=1;
        }
        break;      
    case 4:
    case 6:
    case 9:
    case 11:
        if( rtcTime.day>30 )
            rtcTime.day=30;
        if( rtcTime.day<1 )
            rtcTime.day=1;
        break;
    }   
    rtcTime.mode_12_hour=FALSE;
    rtcTime.hour= newClock.hour;
    rtcTime.minute= newClock.min;
    rtcTime.second= newClock.sec;   

    return RTC_SetDateTime(rtcTime);    
}

int setSystemDate(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND parent = mfwParent( mfw_header());
    T_MFW_HND win = timedate_create(parent);

    DateTimeEntryMode =SETTING;

    if( win NEQ NULL )
    {
        SEND_EVENT(win, DATE_ENTRY_EC, 0, 0);
    }

    return 1;
}

int setSystemTime(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND parent = mfwParent( mfw_header());
    T_MFW_HND win = timedate_create(parent);

    DateTimeEntryMode =SETTING;

    if( win NEQ NULL )
    {
        SEND_EVENT(win, TIME_ENTRY_EC, 0, 0);
    }

    return 1;
}


static T_MFW_HND timedate_create(T_MFW_HND parent_window)
{
    T_MFW_WIN     * win;

    tidaData * data = (tidaData *)ALLOC_MEMORY (sizeof (tidaData));
    data->win = win_create(parent_window, 0, MfwWinVisible, (T_MFW_CB)timeDate_win_cb);

    TRACE_FUNCTION("MmiTimeDate:timedate_create");

    if( data->win EQ 0 )
        return 0;

    /*
    * Create window handler
*/
    data->mmi_control.dialog    = (T_DIALOG_FUNC)tida_DialogCB;/* dialog main function    */
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;

    /*
    * return window handle
    */

    //mfwSetSignallingMethod(1);
    //winShow(data->win);
    tida_win=data->win;

    return data->win;
}
/* 2003.10.28 wyj AM/PM */
static void tida_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tidaData* data = (tidaData *) win_data->user; 
    T_RTC_DATE_TIME rtcTime;

    RTC_GetDateTime(&rtcTime);

    TRACE_EVENT("tida_DialogCB");

    if( FFS_flashData.time_format==TWELVE_HOUR )
    {
        data->AMPM_index    = 0;//'0' indicates AM,'1' indecates PM
        data->tmode_flag    = 1;    
    }
    else
    {
        data->tmode_flag     = 2;   
    }
    data->position_flag = 1;
    data->index=0;
    data->id=event;
    data->kbd_win=kbd_create(win,KEY_ALL,(T_MFW_CB)timedate_kbd_cb);
    switch( event )
    {
    case DATE_ENTRY_EC:
        memset(data->date_string,0,sizeof(data->date_string));
        sprintf(data->date_string,"%d/%02d/%02d",rtcTime.year+2000,rtcTime.month,rtcTime.day);
        winShow(win);
        break;
    case TIME_ENTRY_EC:
        //data->tim_win=timCreate(data->win,1000,(T_MFW_CB)timedate_tim_cb);
        data->temp_time.hour=rtcTime.hour;
        data->temp_time.min=rtcTime.minute;
        data->temp_time.sec=rtcTime.second;
        memset(data->time_string,0,sizeof(data->time_string));
        /* 2003.10.28 wyj AM/PM */
        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            if( data->temp_time.hour > 11 )   //PM
            {
                data->AMPM_index = 1;
                if( data->temp_time.hour != 12 )
                    data->temp_time.hour %= 12;
            }
            else                            //AM
                data->AMPM_index=0;

            sprintf(data->time_string,"%02d:%02d:%02d",data->temp_time.hour,data->temp_time.min,data->temp_time.sec);
        }
        else
        {
            sprintf(data->time_string,"%02d:%02d:%02d",data->temp_time.hour,data->temp_time.min,data->temp_time.sec);
        }
        //timStart(data->tim_win);
        winShow(win);
        break;
    default:
        break;
    }
}

/* ʱʾص */
static int timeDate_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    tidaData       *data = (tidaData *)win->user;  
    int             old_color;
    UINT32          oldColor,oldFontColor;
    game_Line       line;
    TD_Line         l;  
    game_Rectangle  rectangle;
    char            string[4];
    Color           color;

    if( event EQ MfwWinVisible )
    {
        U8 uMode = 0;
        uMode = dspl_Enable(0);

        /* Top Window has no output	*/
        dspl_ClearAll();

        if( data->id==DATE_ENTRY_EC )         //ʾ
        {

            /* background display */
            TD_drawBkg(BG_rect, BG_attr);

            /* title display*/
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_MENUUP);
            /*dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
            */
            if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
#if(MAIN_LCD_SIZE==4)
                dspl_colorTextOut(28+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSetDate), 0x0 );
#elif(MAIN_LCD_SIZE==3)
			dspl_colorTextOut(32+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSetDate), 0x0 );
#endif
            else
                dspl_colorTextOut((102-wstrlen(MmiRsrcGetText(TxtSetDate))*6)/2, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSetDate), 0x0 );/* 2004/05/20 yhf modify */

            /* input rect display */
            TD_drawSolidRectangle(DS_input_rect, DS_input_attr);
#if(MAIN_LCD_SIZE==4)
            dspl_colorTextOut(20+EX, 57, DSPL_TXTATTR_TRANSPARENT, data->date_string,0);
#elif(MAIN_LCD_SIZE==3)
			dspl_colorTextOut(27+EX, 19, DSPL_TXTATTR_TRANSPARENT, data->date_string,0);
#endif
            /* input rect index display */
            l       = DS_index_l;
#if(MAIN_LCD_SIZE==4)
            l.x1    = DS_index_l.x1 + (data->index)*8;
            l.x2    = DS_index_l.x2 + (data->index)*8;
#elif(MAIN_LCD_SIZE==3)
			l.x1	= DS_index_l.x1 + (data->index)*8;
			l.x2	= DS_index_l.x2 + (data->index)*8;
#endif
            
            TD_drawLine(l, DS_index_c);

            /* hint rect display */
            if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
            {
                set_font_type(UNI12X12_FONT);
                TD_drawSolidRectangle(DS_hint_rect, DS_hint_attr);
            }
            if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
 
#if(MAIN_LCD_SIZE==4)
            dspl_colorTextOut(36+EX, 93, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtYMD), 0x004c98);
#elif(MAIN_LCD_SIZE==3)
      		dspl_colorTextOut(32+EX, 50, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtYMD), 0x004c98);
#endif
        }
        else if( data->id==TIME_ENTRY_EC )
        {
            /* background display */
            TD_drawBkg(BG_rect, BG_attr);

            /* title display*/
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_MENUUP);
            /*dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
            */
            if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
#if(MAIN_LCD_SIZE==4)
            dspl_colorTextOut(28+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSetTime), 0x0 );
#elif(MAIN_LCD_SIZE==3)
			dspl_colorTextOut(32+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSetTime), 0x0 );
#endif
            else
                dspl_colorTextOut((102-wstrlen(MmiRsrcGetText(TxtSetTime))*6)/2, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSetTime), 0x0);       

            /* input rect display */
            memset(data->time_string,0,sizeof(data->time_string));
            sprintf(data->time_string,"%02d:%02d:%02d",data->temp_time.hour,data->temp_time.min,data->temp_time.sec);

            if( data->position_flag==1 )      //focus input rect
            {
                TD_drawSolidRectangle(TS_input_rect, TS_input_attr1);
#if(MAIN_LCD_SIZE==3)
			    dspl_colorTextOut(32+EX, 19, DSPL_TXTATTR_TRANSPARENT, data->time_string,0);
				l       = TS_index_l;
                l.x1    = TS_index_l.x1 + (data->index)*8;
                l.x2    = TS_index_l.x2 + (data->index)*8;
#elif(MAIN_LCD_SIZE==4)
                dspl_colorTextOut(28+EX, 57, DSPL_TXTATTR_TRANSPARENT, data->time_string,0);
				l       = TS_index_l;
                l.x1    = TS_index_l.x1 + (data->index)*8;
                l.x2    = TS_index_l.x2 + (data->index)*8;
#endif

                TD_drawLine(l, TS_index_c);
            }
            else
            {
                TD_drawSolidRectangle(TS_input_rect, TS_input_attr2);
 
#if(MAIN_LCD_SIZE==3)
				dspl_TextOut(32+EX, 17, 0, data->time_string);
#elif(MAIN_LCD_SIZE==4)
               dspl_TextOut(28+EX, 57, 0, data->time_string);
#endif
            }

            /* 12/24 rect display */
            if( data->position_flag == 2 )    //focus 12/24 rect
            {
#if(MAIN_LCD_SIZE==4)
				DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 25+EX, 84, 0, ICON_LOCATION);
                DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 92+EX, 84, 1, ICON_LOCATION);
#elif(MAIN_LCD_SIZE==3)
				DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 21+EX, 50, 0, ICON_LOCATION|ICON_MASK);
				DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 94+EX, 50, 1, ICON_LOCATION|ICON_MASK);
#endif
                TD_drawSolidRectangle(TS_tm_rect, TS_tm_attr1);
                set_font_type(UNI12X12_FONT);
                color = 0x0;

            }
            else
            {
                TD_drawSolidRectangle(TS_tm_rect, TS_tm_attr);
                set_font_type(UNI12X12_FONT);
                color = 0x0;

            }
#if(MAIN_LCD_SIZE==4)
            if( data->tmode_flag == 2 )       //24
            {
                if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                    dspl_colorTextOut(37+EX, 93-10, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),color);
                else
                    dspl_colorTextOut(39+EX, 93-10, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),color);
            }
            else                            //12
            {
                if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                    dspl_colorTextOut(37+EX, 93-10, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),color);
                else
                    dspl_colorTextOut(39+EX, 93-10, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),color);
            }           
#elif(MAIN_LCD_SIZE==3)
			if(data->tmode_flag == 2)		//24
			{
				if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
					dspl_colorTextOut(34+EX, 49, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),color);
				else
					dspl_colorTextOut(34+EX, 49, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),color);
			}
			else							//12
			{
				if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
					dspl_colorTextOut(34+EX, 49, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),color);
				else
					dspl_colorTextOut(34+EX, 49, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),color);
			}			
#endif
            /* am/pm rect display */
            if( data->tmode_flag == 1 )       //12
            {
                memset(string,0,4);     
                if( data->AMPM_index==0 )
                    strcpy(string,"AM");
                else
                    strcpy(string,"PM");

                if( data->position_flag == 3 )    //focus on am/pm rect
                {
                    /*dspl_BitBlt(35+EX, 53, 4, 8, 0, (void *)left_key, DSPL_BMPXOR);
                    dspl_BitBlt(35+EX, 53, 4, 8, 0, (void *)left_key_mask, DSPL_BMPAND);
                    dspl_BitBlt(35+EX, 53, 4, 8, 0, (void *)left_key, DSPL_BMPXOR);
                    
                    dspl_BitBlt(64+EX, 53, 4, 8, 0, (void *)right_key, DSPL_BMPXOR);
                    dspl_BitBlt(64+EX, 53, 4, 8, 0, (void *)right_key_mask, DSPL_BMPAND);
                    dspl_BitBlt(64+EX, 53, 4, 8, 0, (void *)right_key, DSPL_BMPXOR);*/
#if(MAIN_LCD_SIZE==4)
                    DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 44+EX, 105, 0, ICON_LOCATION);
                    DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 73+EX, 105, 1, ICON_LOCATION);
					TD_drawSolidRectangle(TS_AP_rect, TS_AP_attr);
                    dspl_colorTextOut(52+EX,112-10,DSPL_TXTATTR_TRANSPARENT,string,0xffffff);
#elif(MAIN_LCD_SIZE==3)
                    DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 37+EX, 65, 0, ICON_LOCATION|ICON_MASK);
                    DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 66+EX, 65, 1, ICON_LOCATION|ICON_MASK);
					TD_drawSolidRectangle(TS_AP_rect, TS_AP_attr);
					dspl_colorTextOut(46+EX,65,DSPL_TXTATTR_TRANSPARENT,string,0xffffff);
#endif
 
                }
                else
                {
#if(MAIN_LCD_SIZE==4)
                    dspl_colorTextOut(52+EX,112-10,DSPL_TXTATTR_TRANSPARENT,string,0x000000);               
#elif(MAIN_LCD_SIZE==3)
					dspl_colorTextOut(46+EX,65,DSPL_TXTATTR_TRANSPARENT,string,0x000000);
#endif
                }
                /***end yhf modify***/
            }
        }
        displaySoftKeys(TxtSoftOK,TxtSoftBack);

        dspl_Enable(uMode );

        return 0;
    }
    return 1;
}

#if 0

static T_MFW_CB  timedate_tim_cb(MfwEvt e, MfwTim *tc) 
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    tidaData* data = (tidaData*)win_data->user;
    T_RTC_DATE_TIME rtcTime;

    RTC_GetDateTime(&rtcTime);
    data->temp_time.hour=rtcTime.hour;
    data->temp_time.min=rtcTime.minute;
    data->temp_time.sec=rtcTime.second;
    /* if(data->temp_time.sec==59)
    {
    data->temp_time.sec=0;
    data->temp_time.min++;
    }
    else
    data->temp_time.sec++;
    if(data->temp_time.min==60)
    {
    data->temp_time.min=0;
    data->temp_time.hour++;
    }
    if(FFS_flashData.time_format == TWELVE_HOUR)
    {
    //if(data->temp_time.hour==12)
        //   data->temp_time.hour=0;  lxj delete for can input 12:xx and so on 
        if(data->temp_time.hour==12)  //lxj
        data->temp_time.hour=0;//lxj
        }
        else
        {
        if(data->temp_time.hour==24)
        data->temp_time.hour=0;
    }*/
    timStart(data->tim_win);
    winShow(win);
}
#endif

/* 2003.10.14 wyj ޸ ʹܴ֮*/
static int timedate_kbd_cb(MfwEvt e, MfwKbd *kc)
{
    T_MFW_HND       win         = mfw_parent(mfw_header());
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *)win)->data;
    tidaData        *data       = (tidaData*)win_data->user; // tida main data
    T_DISPLAY_DATA  display_info;
    int             flag        = 1;
    int             return_value;
    int             t;

    TRACE_EVENT("timedate_kbd_cb");

    // tim_stop(data->tim_win);
    switch( kc->code )
    {
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
        if( data->id==DATE_ENTRY_EC )
        {
            /* 2003.10.15 wyj ޸ ʹܴ֮*/
            checkDateSetNumInput(data, kc->code);
        }
        else if( data->id==TIME_ENTRY_EC )
        {
            /* 2003.10.14 wyj ޸ ʹܴ֮*/
            checkTimeSetNumInput(data, kc->code);
        }

        winShow(win);
        break;
    case KCD_LEFT:                               /* select and ok button */
    case KCD_OK:
        if( data->id == DATE_ENTRY_EC )       //趨
        {
            return_value = check_date(win,data);
            TraceInt(return_value);
            if( return_value == 0 )           //
            {
                data->index=0;
                memset(data->date_string,0,sizeof(data->date_string));
                sprintf(data->date_string,"%d/%02d/%02d",currdate.year,currdate.month,currdate.day);

                dialog_info_init(&display_info);
                display_info.TextId2    = TxtInputError;                          
                display_info.Time       = FOREVER;
                display_info.iconindex  = REMIND_NORECORD;
                display_info.Callback   = (T_VOID_FUNC)NULL;//tida_memo_dialog_cb;
                /*
                 * Call Info Screen
                */              

                info_dialog(data->win, &display_info);
            }
            else if( return_value>0 )         //
            {
                dialog_info_init(&display_info);
                display_info.KeyEvents      = KEY_OK | KEY_RIGHT | KEY_LEFT;                          
                display_info.RightSoftKey   = TxtSoftBack;                          
                display_info.TextId2        = TxtSaved;                          
                display_info.Time           = FOREVER;
                display_info.iconindex      = REMIND_COMPLETE;
                display_info.Callback       = (T_VOID_FUNC)tida_dialog_cb;
                /*
                * Call Info Screen
                */

                //2004-04-05 Sunny add 
                setOuterState(OUTERIDLESTATE_REFRESH, 1, 0);

                info_dialog(data->win, &display_info);
            }
            else                            //rtcʧ
            {
                data->index=0;
                memset(data->date_string,0,sizeof(data->date_string));
                sprintf(data->date_string,"%d/%02d/%02d",currdate.year,currdate.month,currdate.day);

                dialog_info_init(&display_info);
                display_info.TextId2    = TxtFailed;                          
                display_info.Time       = FOREVER;
                display_info.iconindex  = REMIND_NORECORD;
                display_info.Callback   = (T_VOID_FUNC)NULL;//tida_memo_dialog_cb;
                /*
                 * Call Info Screen
                 */
                info_dialog(data->win, &display_info);
            }
        }
        else if( data->id == TIME_ENTRY_EC )  //ʱ
        {
            if( check_time(win,data) == 0 )   //
            {
                data->index = 0;
                memset(data->date_string,0,sizeof(data->time_string));
                sprintf(data->time_string,"%02d:%02d:%02d",currclock.hour,currclock.min,currclock.sec);
                data->temp_time.hour    = currclock.hour;
                data->temp_time.min     = currclock.min;
                data->temp_time.sec     = currclock.sec;

                dialog_info_init(&display_info);
                display_info.KeyEvents      = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey    = '\0';
                display_info.RightSoftKey   = '\0';
                display_info.TextString     = '\0';
                display_info.TextString2    = '\0';
                display_info.TextId2        = TxtInputError;
                display_info.TextId         = '\0';
                display_info.Time           = FOREVER;
                display_info.iconindex      = REMIND_NORECORD;

                display_info.Callback       = (T_VOID_FUNC)NULL;//timer_memo_dialog_cb;
                /*
                 * Call Info Screen
                */
                info_dialog(data->win, &display_info);
            }
            else if( check_time(win,data)>0 ) //ȷȷ
            {
                timStop(data->tim_win);     //!?û

                dialog_info_init(&display_info);
                display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = TxtSoftBack;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2      = TxtSaved;
                display_info.TextId       = '\0';
                display_info.Time         = FOREVER;
                display_info.iconindex    = REMIND_COMPLETE;
                display_info.Callback     = (T_VOID_FUNC)tida_dialog_cb;
                /*
                * Call Info Screen
                */

                //2004-04-05 Sunny add 
                setOuterState(OUTERIDLESTATE_REFRESH, 1, 0);

                info_dialog(data->win, &display_info);
            }
            else                                //ʧ
            {
                data->index=0;
                memset(data->date_string,0,sizeof(data->time_string));
                sprintf(data->time_string,"%02d:%02d:%02d",currclock.hour,currclock.min,currclock.sec);
                data->temp_time.hour=currclock.hour;
                data->temp_time.min=currclock.min;
                data->temp_time.sec=currclock.sec;

                dialog_info_init(&display_info);
                display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = '\0';
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2     =TxtFailed;
                display_info.TextId      = '\0';
                display_info.Time       = FOREVER;
                display_info.iconindex = REMIND_NORECORD;
                display_info.Callback     = (T_VOID_FUNC)NULL;//timer_memo_dialog_cb;

                /* Call Info Screen */
                info_dialog(data->win, &display_info);
            }
        }
        break;
    case KCD_MNULEFT:
        if( data->id == TIME_ENTRY_EC )
        {
            if( data->position_flag == 3 )        //AM/PM
            {
                TRACE_EVENT("KCD_MNULEFT");
                TraceInt(data->AMPM_index);
                data->AMPM_index =! data->AMPM_index;
                TraceInt(data->AMPM_index);
                winShow(win);
                break;
            }
            else if( data->position_flag == 2 )   //12/24
            {
                if( data->tmode_flag == 1 )       //12Сʱ
                {
                    data->tmode_flag = 2;
                    timeset_12_to_24(data);
                }
                else                            //24Сʱ
                {
                    data->tmode_flag = 1;
                    timeset_24_to_12(data);
                }
                flash_write();

            }
            else                               //time input
                /* 2003.10.14 wyj ޸ ʹܴ֮*/
                checkTimeSetLeftInput(data);
        }
        else if( data->id == DATE_ENTRY_EC )
        {
            /* 2003.10.15 wyj ޸ ʹܴ֮*/
            checkDateSetLeftInput(data);
        }
        winShow(win);
        break;
    case KCD_MNURIGHT:  
        if( data->id == TIME_ENTRY_EC )           //AM/PM
        {
            if( data->position_flag == 3 )
            {
                data->AMPM_index =! data->AMPM_index;
                winShow(win);
                break;
            }
            else if( data->position_flag == 2 )   //12/24
            {
                if( data->tmode_flag == 1 )       //12Сʱ
                {
                    data->tmode_flag = 2;
                    timeset_12_to_24(data);
                }
                else                            //24Сʱ
                {
                    data->tmode_flag = 1;
                    timeset_24_to_12(data);
                }
            }
            else                                //time input
                /* 2003.10.14 wyj ޸ ʹܴ֮*/
                checkTimeSetRightInput(data);
        }
        else if( data->id == DATE_ENTRY_EC )
            /* 2003.10.15 wyj ޸ ʹܴ֮*/
            checkDateSetRightInput(data);

        winShow(win);
        break;
    case KCD_MNUDOWN:
        if( data->position_flag == 1 )        //ʱ
        {
            data->position_flag = 2;
        }
        else if( data->position_flag == 2 )   //Сʱ
        {
            if( data->tmode_flag == 1 )       //12Сʱ
            {
                data->position_flag = 3;
            }
            else                            //24Сʱ
            {
                data->position_flag = 1;
                data->index=0;
            }
        }
        else                                //AM/PM
        {
            data->position_flag = 1;
            data->index=0;
        }
        winShow(win);
        break;

    case KCD_MNUUP:
        if( data->position_flag == 1 )        //ʱ
        {
            if( data->tmode_flag == 1 )       //12Сʱ
            {
                data->position_flag = 3;
            }
            else                            //24Сʱ
            {
                data->position_flag = 2;
            }
        }
        else if( data->position_flag == 2 )   //Сʱ
        {
            data->position_flag = 1;
            data->index=0;
        }
        else                                //AM/PM
        {
            data->position_flag = 2;
        }
        winShow(win);
        break;

    case KCD_RIGHT:
    case KCD_HUP:
        timedate_destroy(win);
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}

void tida_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    T_MFW_WIN     * win_data= ((T_MFW_HDR *) tida_win )->data;     
    tidaData*    data=(tidaData* )win_data->user;

    timedate_destroy(tida_win);
}

static void timedate_destroy (T_MFW_HND own_window)
{
    tidaData* data ;
    T_MFW_WIN * win;

    if( own_window )
    {
        TRACE_FUNCTION ("MmiTimeDate:date_time_edt_destroy");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (tidaData *)win->user;

        if( data )
        {
            timDelete(data->tim_win);
            win_delete (data->win);
            FREE_MEMORY((void *)data,(sizeof(tidaData)));
        }
    }
}

int setSysDate(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = date_time_create(idle_win);//  parent_window is idle

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;

    TRACE_FUNCTION ("MmiTimeDate:settingsTimeDate()");

    tida_data->state = DATE_ENTRY_EC;
    DateTimeEntryMode = SETTING;

    if( tida_data->tida_win )
    {
        SEND_EVENT(tida_data->tida_win,DATE_ENTRY_EC,0,tida_data);
    }
    return 1;
}

int setSysTime(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = date_time_create(idle_win);//  parent_window is idle

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;

    TRACE_FUNCTION ("MmiTimeDate:settingsTimeDate()");

    tida_data->state = TIME_ENTRY_EC;
    DateTimeEntryMode = SETTING;

    if( tida_data->tida_win )
    {
        SEND_EVENT(tida_data->tida_win,TIME_ENTRY_EC,0,tida_data);
    }
    return 1;
}

int setWTime(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = worldTime_create(idle_win);//  parent_window is idle

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_worldtime * wt_data = (T_worldtime *)win_data->user;

    TRACE_FUNCTION ("MmiTimeDate:setWTime()");

    //wt_data->state = TIME_ENTRY_EC;

    if( wt_data->wt_win )
    {
        SEND_EVENT(wt_data->wt_win,WT_INITIAL,0,0);

    }
    return 1;
}

static T_MFW_HND worldTime_create (T_MFW_HND parent_window)
{
    T_MFW_WIN     * win;

    T_worldtime * data = (T_worldtime *)ALLOC_MEMORY (sizeof (T_worldtime));
    data->wt_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)worldTime_win_cb);

    TRACE_FUNCTION("MmiTimeDate:worldTime_create");

    if( data->wt_win EQ 0 )
        return 0;

    /* Create window handler */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)worldTime_main;/* dialog main function    */
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->wt_win)->data;
    win->user                   = (void *) data;

    // winShow(data->wt_win);
    data->tim_win=tim_create(data->wt_win,30000,(T_MFW_CB)worldTime_tim_cb);

    return data->wt_win;
}

static T_MFW_CB worldTime_tim_cb(T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_worldtime   * data = (T_worldtime *)win_data->user;
    TRACE_EVENT("worldTime_tim_cb");

    tim_start(data->tim_win);
    winShow(win);
}

static int worldTime_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_worldtime * wt_data = (T_worldtime *)win->user;//worldtime main data
    char *cityName;
    char cityNumer[5];
    /* 2004/05/17 yhf modify */
#if (MAIN_LCD_SIZE==3)
	char strTime[6];
#elif ( MAIN_LCD_SIZE==2 )
    char strTime[6];
#elif ( MAIN_LCD_SIZE==4 )
    char strTime[16];
#endif
    char strDate[11];

    CLOCK dspClock;
    Date dspDate;
    T_RTC_DATE_TIME curtimedate;

    UINT32 oldColor,oldFontColor;

    memset(cityNumer, 0, sizeof(cityNumer));
    memset(strTime, 0, sizeof(strTime));
    memset(strTime, 0, sizeof(strTime));

    //get current phone's time:
    RTC_GetDateTime(&curtimedate);
    dspClock.hour = curtimedate.hour;
    dspClock.min= curtimedate.minute;

    dspDate.year = curtimedate.year + 2000;
    dspDate.month= curtimedate.month;
    dspDate.day= curtimedate.day;

    dspClock.hour = dspClock.hour + (wt_data->curTZ - FFS_flashData.timeZone);

    if( dspClock.hour >= 24 )
    {
        dspClock.hour %= 24;
        getNextDate(&dspDate);   // days++
    }
    else if( dspClock.hour < 0 )
    {
        dspClock.hour = (dspClock.hour + 24)%24;
        getLastDate(&dspDate);   // days--
    }

    //time
    if( wt_data->curTZ-12>=0 )
        sprintf(strTime, "+%02d", wt_data->curTZ - 12);
    else
        sprintf(strTime, "-%02d", 12 - wt_data->curTZ);

    /* 2004/05/17 yhf modify */
#if ( MAIN_LCD_SIZE==4 )
    if( dspClock.hour < 13 )                  //AM
        sprintf(strTime, "AM %02d:%02d", dspClock.hour, dspClock.min);
    else
        sprintf(strTime, "PM %02d:%02d", dspClock.hour-12, dspClock.min);
    sprintf(strDate, "%02d/%02d/%02d",dspDate.year-2000,dspDate.month,dspDate.day);
#endif
    cityName = (char*)MmiRsrcGetText(cityTxtid[wt_data->curTZ][wt_data->curCity]);
    sprintf(cityNumer, "%1d/%1d", wt_data->curCity, *cityTxtid[wt_data->curTZ]);

    TRACE_EVENT("MmiTimeDate: worldTime_win_cb");
    if( event EQ MfwWinVisible )
    {
        U8 uMode;
        uMode = dspl_Enable(0);
		dspl_ClearAll();
        /* 2004/05/17 yhf modify */
#if (MAIN_LCD_SIZE==3)//jhxu720
		DRAW_ICON(ICON_TIMEZONE_WORLDMAP);
		DRAW_ICON(ICON_MENUUP);
		DRAW_ICON(ICON_TIMEZONE_BMP);
		
		if(Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
			dspl_colorTextOut(64+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtWorldTime), 0xf);//jhxu 288 modify
		else
			dspl_colorTextOut(50+EX, 2, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtWorldTime), 0xf);//jhxu 288 modify
		
		//bar display
		
		//dspl_BitBlt(0, 100, 128, 14, 0, (void *)gImage_bar, 0);//jhxu 288 deleted it
		
		//display cityname	
		dspl_colorTextOut(2, 93, DSPL_TXTATTR_TRANSPARENT, (char *)cityName, 0xffffff);   //jhxu 288 modify 
		
		//time
		if(Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
			dspl_colorTextOut(98, 95, DSPL_TXTATTR_TRANSPARENT, (char *)strTime, 0xffffff);    //jhxu 288 modify
		else
			dspl_colorTextOut(108, 95, DSPL_TXTATTR_TRANSPARENT, (char *)strTime, 0xffffff); //jhxu 288 modify   
		
		
		//line
		drawTimeZoneLine(wt_data->curTZ);
		displaySoftKeys(TxtSoftConfirm,TxtSoftBack);
		draw_softkeybar_leftright_arrow();//jhxu720
		dspl_Enable(uMode);
#elif ( MAIN_LCD_SIZE==2 )
        dspl_BitBlt(0, 13, 102, 65, 0, (void *)icnMnuListBkg, 0);

        dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                     menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                     menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);

        if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
            dspl_colorTextOut(28+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtWorldTime), 0x0);
        else
            dspl_colorTextOut(16+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtWorldTime), 0x0);

        dspl_BitBlt(8, 13, 88, 38, 0, (void *)world_bmp, 0);

        //bar display
        dspl_BitBlt(0, 51, 102, 14, 0, (void *)gImage_bar, 0);

        //display cityname	
        dspl_colorTextOut(2, 52, DSPL_TXTATTR_TRANSPARENT, (char *)cityName, 0x0);    

        //time
        if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
            dspl_colorTextOut(70, 52, DSPL_TXTATTR_TRANSPARENT, (char *)strTime, 0x0);
        else
            dspl_colorTextOut(81, 52, DSPL_TXTATTR_TRANSPARENT, (char *)strTime, 0x0);    


        //line
        drawTimeZoneLine(wt_data->curTZ);
        displaySoftKeys(TxtSoftConfirm,TxtSoftBack);   

        dspl_Enable(uMode);

#elif ( MAIN_LCD_SIZE==4 )
        /* background */
        draw_special_background();
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON(ICON_TIMEZONE_WORLDMAP);
        //dspl_BitBlt(0, 74, 128, 68, 0, (void *)gImage_world_bmp, 0);

        /* title */
        dspl_colorTextOut(31, 3, DSPL_TXTATTR_WHITE_EDGE, MmiRsrcGetText(wt_data->display_id),0x0); //display title

        /* softkey */       
        displaySoftKeys(TxtSoftConfirm,TxtSoftBack);   

        /* city name */
        dspl_colorTextOut(8, 20, DSPL_TXTATTR_TRANSPARENT, cityName, 0xffffff);            
        dspl_colorTextOut(100, 20, DSPL_TXTATTR_TRANSPARENT, cityNumer, 0xffffff);            

        /* time */
        dspl_colorTextOut(9, 40, DSPL_TXTATTR_TRANSPARENT, strTime, 0xffffff);  

        /* data */
        dspl_colorTextOut(7, 57, DSPL_TXTATTR_TRANSPARENT, strDate, 0xffffff);  

        /* line */
        drawTimeZoneLine(wt_data->curTZ);

        dspl_Enable(uMode);
#endif
        return 1;
    }
    return 0;
}

/*******************************************************************************

 $Function:  worldTime_main  

 $Description:	 main dialog function for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static void worldTime_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_worldtime * wt_data = (T_worldtime *)win_data->user;//worldtime main data
    T_DISPLAY_DATA display_info;

    TRACE_FUNCTION("MmiTimeDate:worldTime_main");

    switch( event )
    {
    case WT_INITIAL:
        tim_start(wt_data->tim_win);
        wt_data->curTZ = FFS_flashData.timeZone;
        wt_data->display_id = TxtWorldTime;
        wt_data->curCity = FFS_flashData.cityNumber;
        kbd_create(wt_data->wt_win,KEY_ALL|KEY_MAKE,(T_MFW_CB)wt_kbd_cb);
        winShow(win);
        break;
    case WT_SETTED:
        dialog_info_init(&display_info);
        display_info.TextId = 0;
        display_info.TextId2 = TxtSaved;
        display_info.TextString = 0;
        display_info.TextString2 = 0;
        display_info.LeftSoftKey = 0;
        display_info.RightSoftKey = TxtSoftBack;
        display_info.Time = FOREVER;
        display_info.KeyEvents = KEY_OK | KEY_RIGHT | KEY_LEFT;
        display_info.Identifier = 0;
        display_info.iconindex = REMIND_COMPLETE;
        display_info.Callback = (T_VOID_FUNC)WT_info_cb;
        info_dialog(win, &display_info); /* information screen "Saved" */
        break;
    case WT_DESTROY:
        worldTime_destroy(wt_data->wt_win);
        break;
    default:
        break;
    }
}

static void worldTime_destroy(T_MFW_HND own_window)
{
    T_worldtime * data ;
    T_MFW_WIN * win;


    if( own_window )
    {
        TRACE_FUNCTION ("MmiTimeDate:worldTime_destroy");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_worldtime *)win->user;

        if( data )
        {
            win_delete (data->wt_win);
            FREE_MEMORY((void *)data,(sizeof(T_worldtime)));
        }
    }
}

static int wt_kbd_cb(MfwEvt e, MfwKbd *kc)
{
    T_MFW_HND win = mfw_parent(mfw_header());  

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_worldtime * wt_data = (T_worldtime *)win_data->user;//world time main data

    int cityNumMax = *cityTxtid[wt_data->curTZ];
    T_DISPLAY_DATA display_info;
    //	zgzTraceData("cityNumMax", (U16) cityNumMax);

    TRACE_FUNCTION ("MmiTimeDate: wt_kbd_cb");
    if( e & KEY_MAKE )
    {

        switch( kc->code )
        {
        
        case KCD_LEFT:
        case KCD_OK:
            //adjust timezone and save the setting. then start a 2s info dialog
            FFS_flashData.cityNumber=wt_data->curCity;
            if( !adjustTimeDate(wt_data->curTZ) )
            {
                dialog_info_init(&display_info);
                display_info.TextId = 0;
                display_info.TextId2 = TxtFailed;
                display_info.TextString = 0;
                display_info.TextString2 = 0;
                display_info.LeftSoftKey = 0;
                display_info.RightSoftKey = TxtSoftBack;
                display_info.Time = FOREVER;
                display_info.KeyEvents = KEY_ALL;
                display_info.Identifier = 0;
                display_info.iconindex = REMIND_COMPLETE;
                display_info.Callback = (T_VOID_FUNC)NULL;//WT_info_cb;
                info_dialog(win, &display_info); 
                break;
            }
            SEND_EVENT(win, WT_SETTED, 0, 0);
            break;
        case KCD_RIGHT:
        case KCD_HUP:
            SEND_EVENT(win, WT_DESTROY, 0, 0);
            break;      
        case KCD_MNULEFT:
            wt_data->curTZ--;

            if( wt_data->curTZ < 0 )
                wt_data->curTZ = 24;

            wt_data->curCity = 1;
            winShow(win);

            break;
        case KCD_MNURIGHT:
            wt_data->curTZ++;
            if( wt_data->curTZ > 24 )
                wt_data->curTZ = 0;
            wt_data->curCity = 1;
            winShow(win);           
            break;
        case KCD_MNUUP:
            wt_data->curCity--;
            if( wt_data->curCity < 1 )
                wt_data->curCity = cityNumMax;
            winShow(win);

            break;
        case KCD_MNUDOWN:
            wt_data->curCity++;
            if( wt_data->curCity > cityNumMax )
                wt_data->curCity = 1;
            winShow(win);
            break;
        default:
            break;
        }
    }

    return MFW_EVENT_CONSUMED;

}

void WT_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reasons)
{

    TRACE_FUNCTION ("MmiTimeDate: WT_info_cb");

    SEND_EVENT(win, WT_DESTROY, 0, 0);
}
static int getLastDate(Date *d) // set d to it's last date
{
    Date curDate = *d;
    Date lastDate = curDate;

    if( curDate.day > 1 )
        lastDate.day--;
    else if( curDate.day == 1 )
    {
        switch( curDate.month )
        {
        case 2:
        case 4:
        case 6:
        case 8:
        case 9:
        case 11:
            lastDate.month--;
            lastDate.day = 31;
            break;

        case 5:
        case 7:
        case 10:
        case 12:
            lastDate.month--;
            lastDate.day = 30;
            break;

        case 1:
            lastDate.year--;
            lastDate.month = 12;
            lastDate.day = 31;
            break;

        case 3:
            if( (curDate.year % 400 == 0) || ((curDate.year % 4 == 0) && (curDate.year % 100)) )  // current year is leap year
                lastDate.day = 29;
            else
                lastDate.day = 28;
            lastDate.month --;
            break;

        default:
            return 0;  //error
        }

    }

    *d = lastDate;
    return 1; //success
}

static int getNextDate(Date *d) // set d to it's next date
{
    Date curDate = *d;
    Date nextDate = curDate;

    if( curDate.day < 28 )
        nextDate.day++;
    else
    {
        switch( curDate.month )
        {
        case 1:
        case 3:
        case 5:
        case 7:
        case 8:
        case 10:
        case 12:
            if( curDate.day < 31 )
                nextDate.day++;
            else
                nextDate.day = 1;

            nextDate.month++; 

            if( nextDate.month > 12 )
            {
                nextDate.month = 1;
                nextDate.year++;
            }

            break;
        case 4:
        case 6:
        case 9:
        case 11:
            if( curDate.day < 30 )
                nextDate.day++;
            else
                nextDate.day = 1;

            nextDate.month++; 

            break;
        case 2:
            nextDate.month++;
            nextDate.day++;

            if( (curDate.year % 400 == 0) || ((curDate.year % 4 == 0) && (curDate.year % 100)) )
            {
                // current year is leap year
                if( nextDate.day > 29 )
                    nextDate.day = 1;
            }
            else
            {
                if( nextDate.day > 28 )
                    nextDate.day = 1;
            }

            break;
        default:
            return 0; //error
        }
    }

    *d = nextDate;
    return 1; //success
}

static void drawTimeZoneLine(int timezone) //timezone from 0 to 24
{
#if (MAIN_LCD_SIZE==3)//jhxu720
	int xPos;
	
	if(timezone <= 8)
		xPos = (timezone) * 4-25;//10 ŦԼ
	else if(timezone <= 12)
		xPos = (timezone) * 4 -20;//11 
	else if(timezone <= 16)
		xPos = (timezone) * 4 -10;//13 
	else if(timezone <= 20)
		xPos = (timezone) * 3 +15;//15 
	else
		xPos = (timezone) * 3 +16;//16 
	
	dspl_DrawLine(xPos+25, 18, xPos+25, 90);//jhxu 288 modify
#elif ( MAIN_LCD_SIZE==2 )
    int xPos;

    if( timezone <= 8 )
        xPos = (timezone) * 3 + 10;
    else if( timezone <= 12 )
        xPos = (timezone) * 3 + 11;
    else if( timezone <= 16 )
        xPos = (timezone) * 3 + 13;
    else if( timezone <= 20 )
        xPos = (timezone) * 3 + 15;
    else
        xPos = (timezone) * 3 + 16;

    dspl_DrawLine(xPos, 13, xPos, 51);

#elif ( MAIN_LCD_SIZE==4 )
    int xPos;
    xPos = (timezone-11+24)%24 * 5 + 10;

    if( xPos )
        xPos--;
    else
        xPos++;

    if( timezone == 24 )
        xPos--;
    dspl_DrawLine(xPos, 74, xPos, 142);
#endif
}

static int adjustTimeDate(int curTimeZone)
{

    CLOCK dspClock;
    Date dspDate;
    T_RTC_DATE_TIME curtimedate;


    //get current phone's time:
    RTC_GetDateTime(&curtimedate);
    dspClock.hour = curtimedate.hour;
    dspClock.min = curtimedate.minute;
    dspClock.sec = curtimedate.second;

    dspDate.year = curtimedate.year + 2000;
    dspDate.month= curtimedate.month;
    dspDate.day= curtimedate.day;

    dspClock.hour = dspClock.hour + (curTimeZone - FFS_flashData.timeZone);

    if( dspClock.hour >= 24 )
    {
        dspClock.hour %= 24;
        getNextDate(&dspDate);   // days++
    }
    else if( dspClock.hour < 0 )
    {
        dspClock.hour = (dspClock.hour + 24)%24;
        getLastDate(&dspDate);   // days--
    }

    curtimedate.hour = dspClock.hour;
    curtimedate.year = dspDate.year - 2000;
    curtimedate.month = dspDate.month;
    curtimedate.day = dspDate.day;

    currdate = dspDate;  // update the data for display
    currclock = dspClock;
    //!!!! if day changed, count  the week day.
    RTC_SetDateTime(curtimedate);

    FFS_flashData.timeZone = curTimeZone;
    if( flash_write() )
        return FALSE;
    return TRUE;
}
int setFullHrAlertOn(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND parent_win = mfwParent( mfw_header());
    T_DISPLAY_DATA display_info;

    if( FFS_flashData.fullhralert != 1 )
    {
        FFS_flashData.fullhralert  = 1;
        flash_write();
        mnuUpdate(m);
    }
    dialog_info_init(&display_info);    
    display_info.TextId2 = TxtActivated;
    display_info.Time = FOREVER;
    display_info.iconindex = REMIND_COMPLETE;
    info_dialog(parent_win, &display_info);

    return MFW_EVENT_CONSUMED;

}

int setFullHrAlertOff(MfwMnu* m, MfwMnuItem* i)
{ 
    T_MFW_HND parent_win = mfwParent( mfw_header());
    T_DISPLAY_DATA display_info;

    if( FFS_flashData.fullhralert != 0 )
    {
        FFS_flashData.fullhralert  = 0;
        if( !flash_write() )
            mnuUpdate(m);
    }
    dialog_info_init(&display_info);    
    display_info.TextId2 = TxtDeActivated;
    display_info.Time = FOREVER;
    display_info.iconindex = REMIND_COMPLETE;
    info_dialog(parent_win, &display_info);

    return MFW_EVENT_CONSUMED;
}

USHORT fullHrAlertCheck(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{   

    if( ((FFS_flashData.fullhralert == 0)&&(((int)mi->str) == TxtOff))||
        ((FFS_flashData.fullhralert == 1)&&(((int)mi->str) == TxtOn)) )
    {
        return FLAGFUNC_TRUE_ICON;
    }
    else
    {
        return FLAGFUNC_FALSE_ICON;
    }
}
/* Ϊ12Сʱ */
int setTo12hrMode(MfwMnu* m, MfwMnuItem* i)
{   
    T_MFW_HND parent_win = mfwParent( mfw_header());
    T_DISPLAY_DATA display_info;

    if( FFS_flashData.time_format != TWELVE_HOUR )
    {
        FFS_flashData.time_format = TWELVE_HOUR;
        if( !flash_write() )
            mnuUpdate(m);
    }
    dialog_info_init(&display_info);  
    display_info.TextId2 = TxtSaved;
    display_info.Time = FOREVER;
    display_info.iconindex = REMIND_COMPLETE;
    info_dialog(parent_win, &display_info);

    return MFW_EVENT_CONSUMED;

}
/* Ϊ24Сʱ */
int setTo24hrMode(MfwMnu* m, MfwMnuItem* i)
{   
    T_MFW_HND parent_win = mfwParent( mfw_header());
    T_DISPLAY_DATA display_info;
    TRACE_EVENT("setTo24hrMode");

    TraceInt(FFS_flashData.time_format);
    if( FFS_flashData.time_format != TWENTYFOUR_HOUR )
    {
        FFS_flashData.time_format = TWENTYFOUR_HOUR;
        if( !flash_write() )
            mnuUpdate(m);
    }
    TraceInt(FFS_flashData.time_format);
    dialog_info_init(&display_info);  
    display_info.TextId2 = TxtSaved;
    display_info.Time = FOREVER;
    display_info.iconindex = REMIND_COMPLETE;
    info_dialog(parent_win, &display_info);
    return MFW_EVENT_CONSUMED;
}

USHORT hourModeCheck(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{


    TRACE_EVENT("hourModeCheck");

    if( ((FFS_flashData.time_format == TWELVE_HOUR)&&(((int)mi->str) == TxtTwelveHour))||
        ((FFS_flashData.time_format == TWENTYFOUR_HOUR)&&(((int)mi->str) == TxtTwentyfourHour)) )

        return FLAGFUNC_TRUE_ICON;

    else

        return FLAGFUNC_FALSE_ICON;


}

static void setWeekdayOn(int weekday)  //  set the given weekday's alarm switch On.  weekday from 0 to 6 instead of sunday, ..., saturday
{
    //uint8 tmpSwitch;
    //tmpSwitch = FFS_flashData.weeklyAlarm_switch;

    tmpSwitch |= weekMask[weekday];

    //if(tmpSwitch != FFS_flashData.weeklyAlarm_switch){
    //	FFS_flashData.weeklyAlarm_switch = tmpSwitch;
    //	flash_write();
    //	}
}

static void setWeekdayOff(int weekday)   //  set the given weekday's alarm switch Off.
{
    //uint8 tmpSwitch;
    //tmpSwitch = FFS_flashData.weeklyAlarm_switch;

    tmpSwitch &= (~weekMask[weekday]);

    //if(tmpSwitch != FFS_flashData.weeklyAlarm_switch){
    //	FFS_flashData.weeklyAlarm_switch = tmpSwitch;
    //	flash_write();
    //	}
}

int weeklyAlarmIsOn(int curWeek)  //by current weekday, check if weekly alarm switch is on. 
{
    if( tmpSwitch & weekMask[curWeek] )//gdy add FFS_flashData.weeklyAlarm_switch
        return 1;   // switch is on 
    else
        return 0;   // switch is off
}

int setDailyAlarmOff(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win =  mfwParent( mfw_header() );
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard   *data = (tBookStandard *)win_data->user;

    T_DISPLAY_DATA display_info;

    mnuHide(data->menu);
    mnuEscape(data->menu);
    mnuUnhide(data->menu);


    if( FFS_flashData.dailyAlarm_switch )
    {
        FFS_flashData.dailyAlarm_switch = 0;
        flash_write();
        set_latest_alarm();
    }
    showAlarmIcon();
    dialog_info_init(&display_info);
    display_info.KeyEvents      = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId         = TxtAlarm;
    display_info.TextId2        = TxtCancelled;
    display_info.TextString     = '\0';
    display_info.TextString2    = '\0';
    display_info.LeftSoftKey    = TxtNull;
    display_info.RightSoftKey   = TxtSoftBack;
    display_info.Time           = FOREVER;
    display_info.iconindex  = REMIND_COMPLETE;
    display_info.Callback       = (T_VOID_FUNC) NULL;

    /* Call Info Screen
    */
    info_dialog( win, &display_info );


    return MFW_EVENT_CONSUMED;

}
/* "ÿ" */
int setDailyAlarmOn(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND mnu_win =  mfwParent( mfw_header() );
    T_MFW_WIN * mnuwin_Data = ((T_MFW_HDR *)mnu_win)->data;
    tBookStandard   *mnuDialog_data = (tBookStandard *)mnuwin_Data->user;

    T_MFW_HND idle_win      = idle_get_window();
    T_MFW_HND win           = date_time_create(idle_win);//  parent_window is idle
    T_MFW_WIN * win_data    = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data      = (T_tida *)win_data->user;

    TRACE_FUNCTION ("MmiTimeDate:setDailyAlarmOn()");

    mnuHide(mnuDialog_data->menu);
    mnuEscape(mnuDialog_data->menu);
    mnuUnhide(mnuDialog_data->menu);

    tida_data->state = TIME_ENTRY_EC;
    DateTimeEntryMode = DAILY_ALARM;

    if( tida_data->tida_win )
    {
        SEND_EVENT(tida_data->tida_win,TIME_ENTRY_EC,0,tida_data);
    }
    return 1;
}

int setWeeklyAlarmOff(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win =  mfwParent( mfw_header() );
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard   *data = (tBookStandard *)win_data->user;

    T_DISPLAY_DATA display_info;

    mnuHide(data->menu);
    mnuEscape(data->menu);
    mnuUnhide(data->menu);


    if( FFS_flashData.weeklyAlarm_switch )
    {
        FFS_flashData.weeklyAlarm_switch = 0;
        flash_write();
        set_latest_alarm();
    }
    showAlarmIcon();

    dialog_info_init(&display_info);
    display_info.KeyEvents      = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId         = TxtAlarm;
    display_info.TextId2        = TxtCancelled;    
    display_info.LeftSoftKey    = TxtNull;
    display_info.RightSoftKey   = TxtSoftBack;
    display_info.Time           = FOREVER;
    display_info.iconindex  = REMIND_COMPLETE;
    display_info.Callback       = (T_VOID_FUNC) NULL;

    /* Call Info Screen */
    info_dialog( win, &display_info );

    return MFW_EVENT_CONSUMED;
}
/* "ÿ"ڳʼ */
int setWeeklyAlarmTime()
{
    /*
    T_MFW_HND mnu_win =  mfwParent( mfw_header() );
    T_MFW_WIN * mnuwin_Data = ((T_MFW_HDR *)mnu_win)->data;
    tBookStandard	*mnuDialog_data = (tBookStandard *)mnuwin_Data->user;
    */
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = date_time_create(idle_win);//  parent_window is idle????  zgz, IT'S WRONG,it should be menu win.
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;

    TRACE_FUNCTION ("MmiTimeDate:setWeeklyAlarmTime()");

    tida_data->state = TIME_ENTRY_EC;
    DateTimeEntryMode = WEEKLY_ALARM;

    if( tida_data->tida_win )
    {
        SEND_EVENT(tida_data->tida_win,TIME_ENTRY_EC,0,tida_data);

    }
    return 1;
}
/* "鿴" */
int browseAlarm(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND parent_win    = mfwParent(mfw_header());
    T_MFW_HND  win          =  browseAlarm_create(parent_win);

    if( win NEQ NULL )
    {
        SEND_EVENT(win, 0, 0, 0);
    }
    return MFW_EVENT_CONSUMED;  
}


static int browseAlarm_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    browseAlarmData * wt_data = (browseAlarmData *)win_data->user;

    char str1[46],str2[6];  
    int old_color;   
    game_Line line;
    game_Rectangle rectangle;

    TRACE_EVENT("browseAlarm_DialogCb()");
    //flash_read();
    if( event EQ MfwWinVisible )
    {
        // flash_read();
        dspl_ClearAll();
        /* background display */
        /* 2004/05/20 yhf remove */
        //TD_drawBkg(BG_rect, BG_attr);

        memset(str1, 0, sizeof(str1));
        memset(str2, 0, sizeof(str2));

        /* ʾ */
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON(ICON_MENUUP);
        /*
        dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
            menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
            menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
        */
        if( Mmi_getCurrentLanguage() == ENGLISH_LANGUAGE )
        {   /* 2004/05/20 yhf modify */
            dspl_colorTextOut(8+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtBrowseAlarm),0x0);
            dspl_colorTextOut(6+EX, 23, 0, MmiRsrcGetText(TxtDailyAlarm), 0);
            dspl_colorTextOut(6+EX, 77, 0, MmiRsrcGetText(TxtWeeklyAlarm), 0);
        }
        else
        {
            dspl_colorTextOut(28+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtBrowseAlarm),0x0);
#if(MAIN_LCD_SIZE==4)
            dspl_colorTextOut(13+EX, 23, 0, MmiRsrcGetText(TxtDailyAlarm), 0);
            dspl_colorTextOut(13+EX, 77, 0, MmiRsrcGetText(TxtWeeklyAlarm), 0);
#elif(MAIN_LCD_SIZE==3)
            dspl_colorTextOut(11+EX, 18, 0, MmiRsrcGetText(TxtDailyAlarm), 0);
            dspl_colorTextOut(11+EX, 72, 0, MmiRsrcGetText(TxtWeeklyAlarm), 0);
#endif
            /***end yhf modify***/
        }
#if(MAIN_LCD_SIZE==4)
        /* 2004/05/20 yhf modify */
        line.x1=7+EX;
        line.y1=69;
        line.x2=113+EX;
        line.y2=69;
        line.color=0xB9D9EA;
        DrawLine(line);
        line.x1=6+EX;
        line.y1=70;
        line.x2=114+EX;
        line.y2=70;
        line.color=0x5474A7;
        DrawLine(line);
        line.x1=7+EX;
        line.y1=71;
        line.x2=113+EX;
        line.y2=71;
        line.color=0xB9D9EA;
        DrawLine(line);  

        /* dailyAlarm display */
        if( FFS_flashData.dailyAlarm_switch )
        {
            drawSolidRectangle(57+EX, 43, 106+EX, 62, 3,0xDBFFFF,0xDBFFFF);
            sprintf(str1,"%02d:%02d",FFS_flashData.dailyAlarm_hour, FFS_flashData.dailyAlarm_min);      
            dspl_TextOut(62+EX, 45, DSPL_TXTATTR_TRANSPARENT, str1);        
        }
        else
        {
            drawSolidRectangle(58+EX, 42, 99+EX, 61, 3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(66+EX, 44, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtClose),0x0);
        }   

        /* weeklyAlarm display */
        if( FFS_flashData.weeklyAlarm_switch )
        {
            sprintf(str2,"%02d:%02d",FFS_flashData.weeklyAlarm_hour, FFS_flashData.weeklyAlarm_min);
            if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
            {
                drawSolidRectangle(57+EX, 118, 106+EX, 138, 3,0xDBFFFF,0xDBFFFF);             
                dspl_colorTextOut(62+EX, 120, DSPL_TXTATTR_TRANSPARENT, str2,0);
                set_font_type(UNI12X12_FONT);
                weekc();
            }
            else
            {
                drawSolidRectangle(57+EX, 121, 106+EX, 139, 3,0xDBFFFF,0xDBFFFF);             
                dspl_colorTextOut(62+EX, 122, DSPL_TXTATTR_TRANSPARENT, str2,0);
                set_font_type(UNI12X12_FONT);
                weeken();
            }
        }
        else
        {
            drawSolidRectangle(58+EX, 96, 99+EX, 115, 3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(65+EX, 98, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtClose),0x0);
            /***end yhf modify***/
        }   
#elif (MAIN_LCD_SIZE==3)
        /* 2004/05/20 yhf modify */
        line.x1=7+EX;
        line.y1=66;
        line.x2=113+EX;
        line.y2=66;
        line.color=0xB9D9EA;
        DrawLine(line);
        line.x1=6+EX;
        line.y1=67;
        line.x2=114+EX;
        line.y2=67;
        line.color=0x5474A7;
        DrawLine(line);
        line.x1=7+EX;
        line.y1=68;
        line.x2=113+EX;
        line.y2=68;
        line.color=0xB9D9EA;
        DrawLine(line);  

        /* dailyAlarm display */
        if( FFS_flashData.dailyAlarm_switch )
        {
            drawSolidRectangle(57+EX, 38, 106+EX, 57, 3,0xDBFFFF,0xDBFFFF);
            sprintf(str1,"%02d:%02d",FFS_flashData.dailyAlarm_hour, FFS_flashData.dailyAlarm_min);      
            dspl_TextOut(62+EX, 40, DSPL_TXTATTR_TRANSPARENT, str1);        
        }
        else
        {
            drawSolidRectangle(58+EX, 38, 99+EX, 57, 3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(66+EX, 39, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtClose),0x0);
        }   

        /* weeklyAlarm display */
        if( FFS_flashData.weeklyAlarm_switch )
        {
            sprintf(str2,"%02d:%02d",FFS_flashData.weeklyAlarm_hour, FFS_flashData.weeklyAlarm_min);
            if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
            {
                drawSolidRectangle(57+EX, 113, 106+EX, 133, 3,0xDBFFFF,0xDBFFFF);             
                dspl_colorTextOut(62+EX, 115, DSPL_TXTATTR_TRANSPARENT, str2,0);
                set_font_type(UNI12X12_FONT);
                weekc();
            }
            else
            {
                drawSolidRectangle(57+EX, 116, 106+EX, 134, 3,0xDBFFFF,0xDBFFFF);             
                dspl_colorTextOut(62+EX, 117, DSPL_TXTATTR_TRANSPARENT, str2,0);
                set_font_type(UNI12X12_FONT);
                weeken();
            }
        }
        else
        {
            drawSolidRectangle(58+EX, 91, 99+EX, 110, 3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(65+EX, 93, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtClose),0x0);
            /***end yhf modify***/
        }   
#endif
        displaySoftKeys(0, TxtSoftBack);
    }
}



/* "鿴"ڴ */
static T_MFW_HND browseAlarm_create(T_MFW_HND parent_window)
{
    T_MFW_WIN     * win;

    browseAlarmData* data = (browseAlarmData *)ALLOC_MEMORY (sizeof (browseAlarmData));
    data->win = win_create(parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)browseAlarm_win_cb);  

    TRACE_FUNCTION("MmiTimeDate:browseAlarm_create");

    if( data->win EQ 0 )
        return 0;

    /* Create window handler */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)browseAlarm_DialogCb;/* dialog main function    */
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;
    data->kbd_win = kbdCreate(data->win, KEY_ALL, (T_MFW_CB)browseAlarm_kbd_cb);

    return data->win;
}
/* "鿴"ͼ */
static void browseAlarm_DialogCb(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    browseAlarmData * wt_data = (browseAlarmData *)win_data->user;

    switch( event )
    {
    case 0:     
        winShow(win);
        break;
    }
}

/* "鿴"İ */
static int browseAlarm_kbd_cb (MfwEvt e, MfwKbd *kc)
{
    T_MFW_HND win = mfw_parent(mfw_header());  

    switch( kc->code )
    {
    case KCD_RIGHT:
    case KCD_HUP:
        browseAlarm_destroy(win);
        break;
    default:
        break;
    }
    return 1;
}
/* "鿴"Ĵٺ */
static void browseAlarm_destroy(T_MFW_HND own_window)
{
    browseAlarmData * data ;
    T_MFW_WIN * win;

    if( own_window )
    {
        TRACE_FUNCTION ("MmiTimeDate:worldTime_destroy");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (browseAlarmData *)win->user;

        if( data )
        {
            win_delete (data->win);
            FREE_MEMORY((void *)data,(sizeof(browseAlarmData)));
        }
    }
}

USHORT weekly_flag_check(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    TRACE_EVENT("weekly_flag_check"); 

    if( ((FFS_flashData.weeklyAlarm_switch!=0)&&(((int)mi->str)==TxtOn))||
        ((FFS_flashData.weeklyAlarm_switch==0)&&(((int)mi->str)==TxtOff)) )
        return FLAGFUNC_TRUE_ICON;
    else
        return FLAGFUNC_FALSE_ICON;
}

USHORT daily_flag_check(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    TRACE_EVENT("daily_flag_check");
    /*if( ((FFS_flashData.language==CHINESE_LANGUAGE)&&(mi->str==MmiRsrcGetText(TxtChinese)))||
    ((FFS_flashData.language==ENGLISH_LANGUAGE)&&(mi->str==MmiRsrcGetText(TxtEnglish)))
    )*/
    if( ((FFS_flashData.dailyAlarm_switch==1)&&(((int)mi->str)==TxtOn))||
        ((FFS_flashData.dailyAlarm_switch==0)&&(((int)mi->str)==TxtOff)) )

        return FLAGFUNC_TRUE_ICON;
    else
        return FLAGFUNC_FALSE_ICON;
}



USHORT alarmStateDspl(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    char str1[46],str2[6];
    USHORT xPos, yPos;
    int i;
    //U8 uIndex;
    // U8    uMode;
    // uMode = dspl_Enable(0);

    TRACE_EVENT("alarmStateDspl()");
    dspl_Clear(0,96,120,136);
    memset(str1, 0, sizeof(str1));
    memset(str2, 0, sizeof(str2));
    if( m->lCursor[m->level] )
    {  //  current item is weekly alarm
        if( FFS_flashData.weeklyAlarm_switch )
        {
            sprintf(str2,"%02d:%02d",FFS_flashData.weeklyAlarm_hour, FFS_flashData.weeklyAlarm_min);
            if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
            {
                wstrcpy(str1,(char *)FFS_flashData.weeklyChineseString);
                wstrcat(str1,str2);
                wstrcat(str1,(char*)MmiRsrcGetText(TxtOn));
                dspl_TextOut(0, 104, 0, str1);            
            }
            else if( Mmi_getCurrentLanguage() == ENGLISH_LANGUAGE )
            {
                set_font_type(UNI12X12_FONT);
                dspl_TextOut(72, 120, 0, str1);
                set_font_type(UNI12X12_FONT);
                dspl_TextOut(108, 120, 0, MmiRsrcGetText(TxtOn));
                set_font_type(UNI12X12_FONT);
                dspl_TextOut(0, 104 , 0 , (char*)FFS_flashData.weeklyEnglishString);
            }
        }
        else
        {
            if( Mmi_getCurrentLanguage() == ENGLISH_LANGUAGE )
                set_font_type(UNI12X12_FONT);
            dspl_TextOut(74, 120, 0, MmiRsrcGetText(TxtOff));
        }
    }
    else
    {
        // current item is Daily alarm
        if( FFS_flashData.dailyAlarm_switch )
        {

            sprintf(str1,"%02d:%02d",FFS_flashData.dailyAlarm_hour, FFS_flashData.dailyAlarm_min);
            if( Mmi_getCurrentLanguage() == ENGLISH_LANGUAGE )
            {
                set_font_type(UNI12X12_FONT);
                dspl_TextOut(36, 120, 0, str1);
            }
            else
                dspl_TextOut(18, 120, 0, str1);
            if( Mmi_getCurrentLanguage() == ENGLISH_LANGUAGE )
                set_font_type(UNI12X12_FONT);
            dspl_TextOut(74, 120, 0, MmiRsrcGetText(TxtOn));
        }
        else
        {
            if( Mmi_getCurrentLanguage() == ENGLISH_LANGUAGE )
                set_font_type(UNI12X12_FONT);
            dspl_TextOut(74, 120, 0, MmiRsrcGetText(TxtOff));
        }
    }
    //dspl_Enable(uMode); 
    return 0;
}

typedef struct _tWAStandard_  //zgz, weekly alarm standard data struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent_win;
    ListMenuData      *menu_list_data;
} tWAStandard;

typedef enum
{
    E_WEEKLYALARM_INIT,
    E_WEEKLYALARM_DESTROY
}e_weeklyalarm_events;

/* "ÿ" */    
int setWeeklyAlarm(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND mnu_win =  mfwParent( mfw_header() );
    T_MFW_WIN * mnuwin_Data = ((T_MFW_HDR *)mnu_win)->data;
    tBookStandard   *mnuDialog_data = (tBookStandard *)mnuwin_Data->user;

    mnuHide(mnuDialog_data->menu);  // menu back to upper level
    mnuEscape(mnuDialog_data->menu);
    mnuUnhide(mnuDialog_data->menu);

    weeklyAlarmStart(mnu_win);

    return MFW_EVENT_CONSUMED;
}
/* "ÿ"ڳʼ */  
static T_MFW_HND weeklyAlarmStart(T_MFW_HND parent)
{
    T_MFW_HND win;

    TRACE_EVENT ("weeklyAlarmStart()");
    DateTimeEntryMode = WEEKLY_ALARM;

    win = weeklyAlarmCreate(parent);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_WEEKLYALARM_INIT, 0, 0);
    }
    return win;

}
/* "ÿ"ڴ */
static T_MFW_HND weeklyAlarmCreate(T_MFW_HND parent_window)
{
    tWAStandard *  data = (tWAStandard *)ALLOC_MEMORY (sizeof (tWAStandard));
    T_MFW_WIN     *  win;

    TRACE_EVENT ("weeklyAlarmCreate()");

    /* Create window handler */
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)weeklyAlarmWinCb);

    if( data->win EQ NULL )
    {
        return NULL;
    }

    /* connect the dialog data to the MFW-window */
    data->mmi_control.dialog = (T_DIALOG_FUNC)weeklyAlarmCb;
    data->mmi_control.data   = data;
    data->parent_win             = parent_window;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    weeklyAlarm_win=data->win;

    winShow(win);

    /* return window handle */
    return data->win;
}
/* "ÿ"¼ */
static void weeklyAlarmCb(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    tWAStandard * data = (tWAStandard *)win_data->user;//weekly alarm main data
    int i;
    TRACE_FUNCTION("MmiTimeDate:weeklyAlarmCb()");

    switch( event )
    {
    case E_WEEKLYALARM_INIT:
        data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));
        tmpSwitch=FFS_flashData.weeklyAlarm_switch;

        if( !data->menu_list_data )
        {
            weeklyAlarmDestroy(win);
            return;  //ڴ˴ϳʾ
        }

        data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( 7 * sizeof(T_MFW_MNU_ITEM) );

        if( !data->menu_list_data->List )
        {
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
            weeklyAlarmDestroy(win);
            return;   //ڴ˴ϳʾ
        }

        for( i = 0; i < 7; i++ )
        {
            /* 2004/06 sunsj modify for picture manage */
            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_SITUATION3, 0);//&situation3Icon;						
            data->menu_list_data->List[i].exta = 0;
            data->menu_list_data->List[i].edit = 0;
            data->menu_list_data->List[i].menu = 0;
            data->menu_list_data->List[i].func = NULL;
            data->menu_list_data->List[i].str=(char *)weekdayId[i];
            data->menu_list_data->List[i].flagFunc = weeklyAlarmItemCheck; 
        }
        data->menu_list_data->ListLength      = 7;
        data->menu_list_data->ListPosition    = 1;
        data->menu_list_data->CursorPosition  = 1;
        data->menu_list_data->SnapshotSize    = 7;
        data->menu_list_data->Font            = 0;
        data->menu_list_data->LeftSoftKey     = TxtSoftConfirm;
        data->menu_list_data->RightSoftKey    = TxtSoftBack;
        data->menu_list_data->KeyEvents       = KEY_ALL;
        data->menu_list_data->Reason          = 0;
        data->menu_list_data->Strings         = 0;
        data->menu_list_data->Attr            = &weeklyAlarm_menuAttrib; 
        data->menu_list_data->autoDestroy     = FALSE;
        data->menu_list_data->ListMenuFlag    = 1;
        data->menu_list_data->ListMenuHeadStr = (char *) MmiRsrcGetText(TxtWeeklyAlarm);
        listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)weeklyAlarmMenuCb,0);
        break;
    case E_WEEKLYALARM_DESTROY:
        weeklyAlarmDestroy(win);
        break;
    }
}

USHORT weeklyAlarmItemCheck(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    TRACE_EVENT("weeklyAlarmItemCheck");

    if( (weeklyAlarmIsOn(0) && (((int)mi->str) == TxtSunday))
        ||(weeklyAlarmIsOn(1) && (((int)mi->str) == TxtMonday))
        ||(weeklyAlarmIsOn(2) && (((int)mi->str) == TxtTuesday))
        ||(weeklyAlarmIsOn(3) && (((int)mi->str) == TxtWednesday))
        ||(weeklyAlarmIsOn(4) && (((int)mi->str) == TxtThursday))
        ||(weeklyAlarmIsOn(5) && (((int)mi->str) == TxtFriday))
        ||(weeklyAlarmIsOn(6) && (((int)mi->str) == TxtSaturday)) )

        return FLAGFUNC_TRUE_ICON;
    else
        return FLAGFUNC_FALSE_ICON; 
}


static int weeklyAlarmWinCb(T_MFW_EVENT event, T_MFW_WIN * win)
{
    TRACE_FUNCTION ("weeklyAlarmWinCb()");
    if( event EQ MfwWinVisible )
    {
        dspl_ClearAll();
        return 1;
    }
    return 0;   
}
/* "ÿ"ѡбص */
static void weeklyAlarmMenuCb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    tWAStandard     * data     = (tWAStandard  *)win_data->user;
    int             curWeekday,i,uIndex;
    T_DISPLAY_DATA  display_info;
    T_MFW_WIN       * win_data1 = ((T_MFW_HDR *)weeklyAlarm_win)->data;
    tWAStandard     * data1     = (tWAStandard  *)win_data1->user;

    switch( ListData->Reason )
    {
    case LISTS_REASON_OK:
        {
            TRACE_EVENT("LISTS_REASON_OK");
            curWeekday = ListData->CursorPosition;

            if( weeklyAlarmIsOn(curWeekday) )
                setWeekdayOff(curWeekday);
            else
                setWeekdayOn(curWeekday);

            winShow(ListData->win);
        }
        break;
    case LISTS_REASON_BACK:  // KCD_POWER
        {
            TRACE_EVENT("LISTS_REASON_BACK");
            //FFS_flashData.weeklyAlarm_switch=0;
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List, 7*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));             
            weeklyAlarmDestroy(data->win);
            //listsDestroy(data1->menu_list_data->win);//ListData->win);
            //  FREE_MEMORY((void *)data->menu_list_data->List, 7*sizeof(T_MFW_MNU_ITEM));
            // FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));		     	
            // weeklyAlarmDestroy(weeklyAlarm_win);	  
        }
        break;
    case LISTS_REASON_SELECT:     //KCD_RIGHTѡ
        {
            TRACE_EVENT("weeklyAlarmMenuCb:LISTS_REASON_LEFT");
            if( !tmpSwitch )//gdy add
            {
                dialog_info_init(&display_info);
                display_info.iconindex=REMIND_NORECORD;
                display_info.TextId2=TxtSelectDate;
                display_info.Time=FOREVER;
                display_info.RightSoftKey = TxtSoftBack;            
                display_info.Callback = (T_VOID_FUNC)NULL;

                info_dialog(0, &display_info);
                break;
            }
            //TraceInt(FFS_flashData.weeklyAlarm_switch);
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List, 7*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));             
            weeklyAlarmDestroy(data->win);        
            if( DateTimeEntryMode == WEEKLY_ALARM )
            {
                TRACE_EVENT("Set Weekly_Alarm");
                memset(FFS_flashData.weeklyChineseString,0,50);
                memset(FFS_flashData.weeklyEnglishString,0,50);
                wstrcpy((char*)FFS_flashData.weeklyChineseString, "\x80\x6b\xcf\x54\x68\x00\x00");  //			

                for( i = 0; i < 7; i++ )
                {
                    if( weeklyAlarmIsOn(i) )
                    {

                        switch( i )
                        {
                        case 0:
                            wstrcat((char*)FFS_flashData.weeklyChineseString, "\x80\x65\xe5\x00\x00" ); //chinese sunday
                            break;
                        case 1:
                            wstrcat((char*)FFS_flashData.weeklyChineseString, "\x80\x4e\x00\x00\x00");
                            break;
                        case 2:
                            wstrcat((char*)FFS_flashData.weeklyChineseString, "\x80\x4e\x8c\x00\x00" );
                            break;
                        case 3:
                            wstrcat((char*)FFS_flashData.weeklyChineseString, "\x80\x4e\x09\x00\x00" );
                            break;
                        case 4:
                            wstrcat((char*)FFS_flashData.weeklyChineseString, "\x80\x56\xdb\x00\x00" );
                            break;
                        case 5:
                            wstrcat((char*)FFS_flashData.weeklyChineseString, "\x80\x4e\x94\x00\x00" );
                            break;
                        case 6:
                            wstrcat((char*)FFS_flashData.weeklyChineseString, "\x80\x51\x6d\x00\x00" );
                            break;                          
                        default:
                            break;
                        }                   
                    }
                }
                wstrcat((char*)FFS_flashData.weeklyChineseString,"\x00");
                TraceInt(wstrlen(FFS_flashData.weeklyChineseString));
                TRACE_EVENT((char*)FFS_flashData.weeklyChineseString);
            }
            //TRACE_EVENT((char*)FFS_flashData.weeklyChineseString);

            for( i=0,uIndex=0;i<7;i++ )
            {
                if( weeklyAlarmIsOn(i) )
                    uIndex++;
            }
            if( uIndex<=5 )
            {
                strcpy((char*)FFS_flashData.weeklyEnglishString,"               Every ");
            }
            else
            {
                strcpy((char*)FFS_flashData.weeklyEnglishString,"Every                   ");
            }

            for( i = 0; i < 7; i++ )
            {
                if( weeklyAlarmIsOn(i) )
                {
                    switch( i )
                    {
                    case 0:
                        strcat((char*)FFS_flashData.weeklyEnglishString,"Sun " ); 
                        break;
                    case 1:
                        strcat((char*)FFS_flashData.weeklyEnglishString, "Mon ");
                        break;
                    case 2:
                        strcat((char*)FFS_flashData.weeklyEnglishString, "Tue " );
                        break;
                    case 3:
                        strcat((char*)FFS_flashData.weeklyEnglishString, "Wed " );
                        break;
                    case 4:
                        strcat((char*)FFS_flashData.weeklyEnglishString, "Thu " );
                        break;
                    case 5:
                        strcat((char*)FFS_flashData.weeklyEnglishString, "Fri " );
                        break;
                    case 6:
                        strcat((char*)FFS_flashData.weeklyEnglishString, "Sat " );
                        break;                          
                    default:
                        break;
                    }                   
                }
            }         
            setWeeklyAlarmTime();
        }
        break;
    default:
        break;
    }
}

static void weeklyAlarmDestroy(T_MFW_HND own_window)
{
    tWAStandard * data;
    T_MFW_WIN * win;

    if( own_window )
    {
        TRACE_EVENT("MmiTimeDate:weeklyAlarmDestroy");
        win = ((T_MFW_HDR *)own_window)->data;
        data = (tWAStandard *)win->user;
        weeklyAlarm_win=NULL;

        if( data )
        {
            win_delete (data->win);
            FREE_MEMORY((void *)data,(sizeof(tWAStandard)));
        }
    }
}

/*******************************************************************************

 $Function:  alarm_check  

 $Description:	 Called by MmiMain.c to check current time/date against that set for Daily alarm
                If they match the alarm screen comes up and the buzzer sounds

 $Returns:		none.

 $Arguments:	none
 
*******************************************************************************/

void dailyAlarm_check()
{
    TRACE_FUNCTION("dailyAlarm_check"); 
    if( FFS_flashData.dailyAlarm_switch == 0 )   //if no alarm set
    {
        return;
    }
    //if date and time match
    if( (FFS_flashData.dailyAlarm_hour == currclock.hour) && (FFS_flashData.dailyAlarm_min ==  currclock.min) )
    {
        audio_PlaySoundID(AUDIO_BUZZER, getcurrentAlarmTone(), 200, 0 );
        alarm_screen();
    }

}

/*******************************************************************************

 $Function:  alarm_check  

 $Description:	 Called by MmiMain.c to check current time/date against that set for weekly alarm
                If they match the alarm screen comes up and the buzzer sounds

 $Returns:		none.

 $Arguments:	none
 
*******************************************************************************/

void weeklyAlarm_check()
{
    T_RTC_DATE_TIME curtimedate;
    TRACE_FUNCTION("weeklyAlarm_check");    

    if( FFS_flashData.weeklyAlarm_switch == 0 )  //if no alarm set
    {
        return;
    }

    //get current phone's time:
    RTC_GetDateTime(&curtimedate);

    if( !weeklyAlarmIsOn(curtimedate.wday) )
        return;

    //if date and time match
    if( (FFS_flashData.weeklyAlarm_hour== currclock.hour) && (FFS_flashData.weeklyAlarm_min==  currclock.min) )
    {
        //audio_PlaySoundID(AUDIO_BUZZER, getcurrentAlarmTone(), 200, 0 );
        StartPlayByReason(ALARMPLAY,0);  //xsf add 2002.09.20
        alarm_screen();
    }
}

/**********************************************************************************
* Function Name         : checkTimeSetNumInput
* Function Description  : дʱõּʹܴ֮
*
* Parameters		    : tidaData *data        	     I/O
*						: U8 keynum						 I
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.12.1
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/

static void checkTimeSetNumInput(tidaData *data, U8 keynum)
{
    char hour[3]   = {0,0,0};
    char minute[3] = {0,0,0};
    char second[3] = {0,0,0};

    /* ӣ֤СʱûԽ */
    switch( data->index )
    {
    case 0:                                 // Сʱʮλ
        if( data->tmode_flag == 1 )           //12Сʱ
        {
            if( keynum > 1 )
                return;
        }
        else
        {
            if( keynum > 2 )
                return;
        }

        //data->time_stringʽhh:mm:ss
        data->time_string[data->index++] = '0' + keynum;
        break;

    case 1:                                 //Сʱλ
        if( data->tmode_flag == 1 )           //12Сʱ
        {
            if( (data->time_string[data->index-1]=='1') && (keynum>2) )
                return;
        }
        else
        {
            if( (data->time_string[data->index-1]=='2') && (keynum>3) )
                return;
        }
        data->time_string[data->index++] = '0' + keynum;
        data->index++;
        break;

    case 3:                                 //ʮλ
    case 6:                                 //ʮλ
        if( keynum > 5 )
            return;
        data->time_string[data->index++] = '0' + keynum;
        break;

    case 4:                                 //Ӹλ
        data->time_string[data->index++] = '0' + keynum;
        data->index++;
        break;                              

    case 7:                                 //Ӹλ
        data->time_string[data->index++] = '0' + keynum;
        data->index = 0;
        break;

    default:
        break;
    }

    /* data->temp_time޸Ļʾ */
    hour[0]     = data->time_string[0];
    hour[1]     = data->time_string[1];
    minute[0]   = data->time_string[3];
    minute[1]   = data->time_string[4];
    second[0]   = data->time_string[6];
    second[1]   = data->time_string[7];

    data->temp_time.hour = atoi(hour);
    data->temp_time.min  = atoi(minute);
    data->temp_time.sec  = atoi(second);
}

/**********************************************************************************
* Function Name         : checkTimeSetLeftInput
* Function Description  : дʱõĲ˵ʹܴ֮
*
* Parameters		    : tidaData *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.12.1
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/

static void checkTimeSetLeftInput(tidaData *data)
{
    /* Ҫ, */
    switch( data->index )
    {
    case 1:
    case 4:
    case 7:
        data->index--;
        return;
    }

    /* Сʱ */
    if( data->tmode_flag == 1 )               //12Сʱ
    {
        //ʮСʱСʱ12
        if( data->temp_time.hour > 12 )
            return;
    }
    else
    {
        //ʮСʱСʱ23
        if( data->temp_time.hour > 23 )
            return;
    }

    /* Ӻ */
    if( data->temp_time.min>59 || data->temp_time.sec>59 )
        return;

    /* ȷ޸index */
    switch( data->index )
    {
    case 3:
    case 6:
        data->index -= 2;
        break;

    case 0:
        data->index = 7;
        break;

    default:
        break;
    }
}



/**********************************************************************************
* Function Name         : checkTimeSetRightInput
* Function Description  : дʱõĲ˵Ҽʹܴ֮
*
* Parameters		    : tidaData *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.12.1
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/

static void checkTimeSetRightInput(tidaData *data)
{
    /* Ҫ, */
    switch( data->index )
    {
    case 0:
    case 3:
    case 6:
        data->index++;
        return;
    }

    /* Сʱ */
    if( data->tmode_flag == 1 )               //12Сʱ
    {
        //ʮСʱСʱ12
        if( data->temp_time.hour > 12 )
            return;
    }
    else
    {
        //ʮСʱСʱ23
        if( data->temp_time.hour > 23 )
            return;
    }

    /* Ӻ */
    if( data->temp_time.min>59 || data->temp_time.sec>59 )
        return;

    /* ȷ޸index */
    switch( data->index )
    {
    case 1:
    case 4:
        data->index += 2;
        break;

    case 7:
        data->index = 0;
        break;

    default:
        break;
    }
}
/**********************************************************************************
* Function Name         : checkDateSetNumInput
* Function Description  : дõּʹܴ֮
*
* Parameters		    : tidaData *data        	     I/O
*						: U8 keynum						 I
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.15
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/

static void checkDateSetNumInput(tidaData *data, U8 keynum)
{
    char    *pYear;
    int     YearValue;


    switch( data->index )
    {
    case 0:                                 //ǧλ
        if( keynum != 2 )
            return;

        //data->date_stringʽ yyyy/mm/dd
        data->date_string[data->index++] = '0' + keynum;
        break;

    case 1:                                 //ʮλͰλ
    case 2:
        data->date_string[data->index++] = '0' + keynum;
        break;

    case 3:                                 //ĸλ
        pYear = data->date_string;
        YearValue = (pYear[0]-48)*1000 + (pYear[1]-48)*100 + (pYear[2]-48)*10 + (pYear[3]-48);

        if( YearValue>2099 || YearValue<2000 )
            return;

        data->date_string[data->index++] = '0' + keynum;
        data->index++;
        break;

    case 5:                                 //µʮλ
        if( keynum > 1 )
            return;

        data->date_string[data->index++] = '0' + keynum;
        break;

    case 6:                                 //µĸλ
        if( data->date_string[5]=='1' && keynum>2 )
            return;
        if( data->date_string[5]!='1' && keynum<1 )
            return;

        data->date_string[data->index++] = '0' + keynum;
        data->index++;
        break;

    case 8:                                 //յʮλ
        if( keynum > 3 )
            return;

        data->date_string[data->index++] = '0' + keynum;
        break;

    case 9:                                 //յĸλ
        if( data->date_string[8]=='3' && keynum>1 )
            return;

        if( data->date_string[8]=='0' && keynum<1 )
            return;

        data->date_string[data->index++] = '0' + keynum;
        data->index = 0;
        break;

    default:
        break;

    }                       

}
/**********************************************************************************
* Function Name         : checkDateSetLeftInput
* Function Description  : дõĲ˵ʹܴ֮
*
* Parameters		    : tidaData *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.15
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkDateSetLeftInput(tidaData *data)
{
    char    *pYear;
    int     YearValue;

    switch( data->index )
    {
    case 1:                                 //Ҫ
    case 2:
    case 3:
    case 6:
    case 9:
        data->index--;
        break;

    case 0:                                 //
        pYear = data->date_string;
        YearValue = (pYear[0]-48)*1000 + (pYear[1]-48)*100 + (pYear[2]-48)*10 + (pYear[3]-48);

        if( YearValue>2099 || YearValue<2000 )
            return;
        data->index = 9;
        break;

    case 5:                                 //
        pYear = &data->date_string[5];
        YearValue = (pYear[0]-48)*10 + (pYear[1]-48);

        if( YearValue>12 || YearValue<1 )
            return;

        data->index -= 2;
        break;

    case 8:                                 //
        pYear = &data->date_string[8];
        YearValue = (pYear[0]-48)*10 + (pYear[1]-48);

        if( YearValue>31 || YearValue<1 )
            return;

        data->index -= 2;
        break;

    }

}
/**********************************************************************************
* Function Name         : checkDateSetRightInput
* Function Description  : дʱõĲ˵Ҽʹܴ֮
*
* Parameters		    : tidaData *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.15
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkDateSetRightInput(tidaData *data)
{
    char    *pYear;
    int     YearValue;

    switch( data->index )
    {
    case 0:                                 //Ҫ
    case 1:
    case 2:
    case 5:
    case 8:
        data->index++;
        break;

    case 3:                                 //
        pYear = data->date_string;
        YearValue = (pYear[0]-48)*1000 + (pYear[1]-48)*100 + (pYear[2]-48)*10 + (pYear[3]-48);

        if( YearValue>2099 || YearValue<2000 )
            return;
        data->index += 2;
        break;

    case 6:                                 //
        pYear = &data->date_string[5];
        YearValue = (pYear[0]-48)*10 + (pYear[1]-48);

        if( YearValue>12 || YearValue<1 )
            return;

        data->index += 2;
        break;

    case 9:                                 //
        pYear = &data->date_string[8];
        YearValue = (pYear[0]-48)*10 + (pYear[1]-48);

        if( YearValue>31 || YearValue<1 )
            return;

        data->index = 0;
        break;

    }
}
/**********************************************************************************
* Function Name         : checkAlarmNumInput
* Function Description  : дʱõּʹܴ֮
*
* Parameters		    : T_tida_edt *data        	     I/O
*						: U8 keynum						 I
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.15
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkAlarmNumInput(T_tida_edt *data, U8 keynum)
{
    char hour[3]   = {0,0,0};
    char minute[3] = {0,0,0};

    /* ӣ֤СʱûԽ */
    switch( data->index )
    {
    case 0:                                 // Сʱʮλ
        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            if( keynum > 1 )
                return;
        }
        else
        {
            if( keynum > 2 )
                return;
        }

        //data->edtbuf1ʽhh:mm
        data->edtbuf1[data->index++] = '0' + keynum;
        break;

    case 1:                                 //Сʱλ
        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            if( (data->edtbuf1[data->index-1]=='1') && (keynum>2) )
                return;
        }
        else
        {
            if( (data->edtbuf1[data->index-1]=='2') && (keynum>3) )
                return;
        }
        data->edtbuf1[data->index++] = '0' + keynum;
        data->index++;
        break;

    case 3:                                 //ʮλ
        if( keynum > 5 )
            return;
        data->edtbuf1[data->index++] = '0' + keynum;
        break;

    case 4:                                 //Ӹλ
        data->edtbuf1[data->index++] = '0' + keynum;
        data->index = 0;
        break;                              

    default:
        break;
    }
}

/**********************************************************************************
* Function Name         : checkAlarmLeftInput
* Function Description  : дʱõĲ˵ʹܴ֮
*
* Parameters		    : T_tida_edt *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.15
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkAlarmLeftInput(T_tida_edt *data)
{
    char *p;
    int  value;

    //ʱʽhh:mm
    switch( data->index )
    {
    case 1:                                 //Ҫ
    case 4:
        data->index--;
        break;

    case 0:                                 //Сʱ
        p = &data->edtbuf1[0];
        value = (p[0]-48)*10 + (p[1]-48);

        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            //ʮСʱСʱ12
            if( value > 12 )
                return;
        }
        else
        {
            //ʮСʱСʱ23
            if( value > 23 )
                return;
        }
        data->index = 4;
        break;

    case 3:                                 //
        if( data->edtbuf1[3] > '5' )
            return;

        data->index = 1;
        break;

    default:
        break;
    }
}

/**********************************************************************************
* Function Name         : checkAlarmRightInput
* Function Description  : дʱõĲ˵Ҽʹܴ֮
*
* Parameters		    : T_tida_edt *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.15
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkAlarmRightInput(T_tida_edt *data)
{
    char *p;
    int  value;

    //ʱʽhh:mm
    switch( data->index )
    {
    case 0:                                 //Ҫ
    case 3:
        data->index++;
        break;

    case 1:                                 //Сʱ
        p = &data->edtbuf1[0];
        value = (p[0]-48)*10 + (p[1]-48);

        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            //ʮСʱСʱ12
            if( value > 12 )
                return;
        }
        else
        {
            //ʮСʱСʱ23
            if( value > 23 )
                return;
        }
        data->index = 3;
        break;

    case 4:                                 //
        if( data->edtbuf1[3] > '5' )
            return;

        data->index = 0;
        break;

    default:
        break;
    }
}
/**********************************************************************************
* Function Name         : timeset_12_to_24
* Function Description  : ʱתʱʾת
*
* Parameters		    : tidaData *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.12.1
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void timeset_12_to_24(tidaData *data)
{
    int     hour;

    hour = (data->time_string[0]-48)*10 + (data->time_string[1]-48) + data->AMPM_index*12; 
    if( hour == 24 )
    {
        hour = 12;
    }

    data->temp_time.hour = hour;
}

/**********************************************************************************
* Function Name         : timeset_24_to_12
* Function Description  : ʱתʱʾת
*
* Parameters		    : tidaData *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.12.1
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void timeset_24_to_12(tidaData *data)
{
    int     hour;

    hour = (data->time_string[0]-48)*10 + (data->time_string[1]-48);

    if( hour < 12 )                           //AM
    {
        data->AMPM_index = 0;
    }
    else if( hour == 12 )                     //PM
    {
        data->AMPM_index = 1;
    }
    else if( hour > 12 )                      //PM
    {
        hour %= 12;

        data->temp_time.hour =  hour;
        data->AMPM_index = 1;
    }
}
/**********************************************************************************
* Function Name         : weekc
* Function Description  : Ӳ鿴ʱʾӢ
*
* Parameters		    : tidaData *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.12.8
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void weekc(void)
{
    int     i;

    for( i=0; i<7; i++ )
    {
        set_font_type(UNI12X12_FONT);
        if( FFS_flashData.weeklyAlarm_switch & weekMask[i] )
            dspl_colorTextOut(EX+10+i*15, 98, DSPL_TXTATTR_TRANSPARENT, (char *)weekdays[i], 0xff0000);//2004/06/07 yhf
        else
            dspl_colorTextOut(EX+10+i*15, 98, DSPL_TXTATTR_TRANSPARENT, (char *)weekdays[i], 0xbdbdbd); 
    }
}
/**********************************************************************************
* Function Name         : weeken
* Function Description  : Ӳ鿴ʱʾӢ
*
* Parameters		    : none
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.12.8
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void weeken(void)
{
    int     i;

    for( i=0; i<4; i++ )
    {
        set_font_type(UNI12X12_FONT);
        if( FFS_flashData.weeklyAlarm_switch & weekMask[i] )
            dspl_colorTextOut(EX+5+i*30, 93, DSPL_TXTATTR_TRANSPARENT, (char *)weekdayes[i], 0x000000);//2004/06/07 yhf
        else
            dspl_colorTextOut(EX+5+i*30, 93, DSPL_TXTATTR_TRANSPARENT, (char *)weekdayes[i], 0xbdbdbd); 
    }

    for( i=4; i<7; i++ )
    {
        set_font_type(UNI12X12_FONT);
        if( FFS_flashData.weeklyAlarm_switch & weekMask[i] )
            dspl_colorTextOut(EX+5+(i-4)*30, 105, DSPL_TXTATTR_TRANSPARENT, (char *)weekdayes[i], 0x004c98);
        else
            dspl_colorTextOut(EX+5+(i-4)*30, 105, DSPL_TXTATTR_TRANSPARENT, (char *)weekdayes[i], 0xbdbdbd);    
    }
}
