#ifndef _DEF_MMI_ECTIMEDATE_H_
#define _DEF_MMI_ECTIMEDATE_H_

/*******************************************************************************

					Mobile Innovation

********************************************************************************

 This software product is the property of Mobile Innovation and may not be
 disclosed to any third party without the express permission of the owner.
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MMI
 $File:		    MmiEcTimeDate.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		zhu guangzhao                                         
 $Date:		 2002.8.26                                         
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the root mofule for the basic MMI
                        
********************************************************************************
 $History: MmiEcTimeDate.h

  ver 1.0	   
 $End

*******************************************************************************/
#include "mfw_ffs.h"


#define ALLOC_MEMORY mfwAlloc
#define FREE_MEMORY  mfwFree


								          
/* REASONS                  */
typedef enum
{
	DATE_SHOW_EC = ECTimeDateDummy,
	TIME_SHOW_EC,
	DATE_ENTRY_EC,
	TIME_ENTRY_EC,
	ENTRY_OK_EC,
	SAVED_EC,
	TIDA_ABORT_EC,
	TIDA_CLEAR_EC,
	TIDA_TO_IDLE_EC
}
DAT_TIME_CASE_EC;

#define SUNDAY_M 		0x01		//zgz, sunday mask
#define MONDAY_M  		0x02
#define TUESDAY_M  		0x04
#define WEDNESDAY_M  	0x08
#define THURSDAY_M  	0x10
#define FRIDAY_M 		0x20
#define SATURDAY_M		0x40
//#define IDENTIFIER_CLOCK    998   /*2003/12/4, wangyan delete*/
                                        /* PROTOTYPES               */
//menu handler functions                                        

/*
int alarmTimeDate(MfwMnu* m, MfwMnuItem* i);
int settingsTimeDate(MfwMnu* m, MfwMnuItem* i);
int clear_alarm(MfwMnu* m, MfwMnuItem* i);
int twelve_hour_clock(MfwMnu* m, MfwMnuItem* i);
int twentyfour_hour_clock(MfwMnu* m, MfwMnuItem* i);
void alarm_check();
*/

void ECtida_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reasons);
void WT_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reasons);                                        
/*
void date_time_edt_destroy  (T_MFW_HND own_window);
T_MFW_HND date_time_edt_create(T_MFW_HND parent_window);
void date_time_destroy  (T_MFW_HND own_window);
T_MFW_HND date_time_create (T_MFW_HND parent_window);
*/
//zgz, add the follows 2002.8.15
int setSystemDate(MfwMnu* m, MfwMnuItem* i);//gdy add
int setSystemTime(MfwMnu* m, MfwMnuItem* i);//gdy add
int setSysDate(MfwMnu* m, MfwMnuItem* i);
int setSysTime(MfwMnu* m, MfwMnuItem* i);
int setWTime(MfwMnu* m, MfwMnuItem* i);
int setFullHrAlertOn(MfwMnu* m, MfwMnuItem* i);
int setFullHrAlertOff(MfwMnu* m, MfwMnuItem* i);
USHORT fullHrAlertCheck(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
int setTo12hrMode(MfwMnu* m, MfwMnuItem* i);
int setTo24hrMode(MfwMnu* m, MfwMnuItem* i);
USHORT hourModeCheck(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
int setDailyAlarmOff(MfwMnu* m, MfwMnuItem* i);
int setDailyAlarmOn(MfwMnu* m, MfwMnuItem* i);
int setWeeklyAlarmOff(MfwMnu* m, MfwMnuItem* i);
int setWeeklyAlarmTime();
int browseAlarm(MfwMnu* m, MfwMnuItem* i);
USHORT alarmStateDspl(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
USHORT daily_flag_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
USHORT weekly_flag_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);

int setWeeklyAlarm(MfwMnu* m, MfwMnuItem* i);
USHORT weeklyAlarmItemCheck(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
int weeklyAlarmIsOn(int curWeek) ;


#endif


