
/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MMI
 $File:		    MmiEditor_i.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
    This module provides utility functions for the phone book.

                        
********************************************************************************

 $History: MmiEditor_i.h
 
   * *****************  Version 01 *****************
 * zgz,2002.7.11
 *Add the eastcom input method mode "E_MOBILEINNOVATION_MODE"
 * 


	25/10/00			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/


#ifndef _DEF_MMIEDITOR_I_H_
#define _DEF_MMIEDITOR_I_H_

//???GW Removed T9 reference

/* KGT:
 *		internal modes
 */ 
typedef enum
{
    E_NORMAL_MODE = 0,
//???GW Removed T9 reference
    E_PIN_SECURITY,
    
    E_MOBILEINNOVATION_MODE		//zgz, 2002.7.4  this mode for our symbol input 
} T_E_EDIT_MODE;

//???GW Removed T9 reference

/* 
 * Internal struct
 */
typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent;
    T_MFW_HND       edt_win;
    T_MFW_HND       edt_edt;
    T_MFW_HND       edt_kbd;
    T_MFW_HND       edt_kbd_long;
    T_MFW_HND       edt_tim; // c015 rsa
	T_MFW_HND		edit_input;		/* 2003/11/1 sunsj modify */
	T_MFW_HND		symbol_input; //zhangxp2003-04-01

    T_EDITOR_DATA   editor_data;
    char            LabelText[PROMPT_LENGTH];
	char			*tmpBuf; /* KGT 06-09: used for hide mode. the normal editor buffer will be used
								to display '*' instead of the typed letters and numbers.
								the real typed string will be stored in tmpBuf */

	T_E_EDIT_MODE	edt_mode;//KGT 27-08
//???GW Removed T9 reference
	UBYTE			destroyEditor;
	UBYTE			emergency_call;	
	UBYTE			ss_string;
	char			imei[16];
	T_MFW_HND       edt_anim_win;
	
}
T_EDITOR_INFO;


#endif

