/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         $Workfile::   Mmihost.h     $|
| $Author: root $Revision: 1.1.1.1 $|
| CREATED: 21/06/02                     $Modtime::                  $|
| STATE  : code                                                      |
+--------------------------------------------------------------------+

   MODULE  : security

   PURPOSE : header file for hostkey
   
   EXPORT  :

   TO DO   :

/********************************************************************************
 $History: Mmihost.c
    Date .................. Modification ......................................
	19/08/02      version 0.101 xusufang modified 
	29/08/02      version 0.102 xsf modified
 $End

*******************************************************************************/

#ifndef _DEF_BMI_HOST_H_
#define _DEF_BMI_HOST_H_

/* typedefs */
typedef enum {
    HOSTKEY_INIT = HostkeyDummy,
    HOSTKEY_NULL,   //xsf for distingguish from MMI_OUTGOING_CALL_DIALOG_NORMAL in mmidialogs.c 2002.09.18
	HOSTKEY_ASK,
	HOSTKEY_ASK_OK,
	HOSTKEY_ASK_FAIL,
    
    HOSTKEY_ASK_MENU,
	HOSTKEY_MENU_OK,
	HOSTKEY_MENU_FAIL,
	HOSTKEY_MENU_END,
	
	HOSTKEY_ASK_ONOFF,     //XSF ADD FOR SWITCH ON/OFF FOR HOSTKEY 2002.08.22   
	HOSTKEY_ONOFF_OK,     //XSF ADD FOR SWITCH ON/OFF FOR HOSTKEY 2002.08.22   
	HOSTKEY_ONOFF_FAIL,     //XSF ADD FOR SWITCH ON/OFF FOR HOSTKEY 2002.08.22  
	HOSTKEY_ONOFF_END,     //XSF ADD FOR SWITCH ON/OFF FOR HOSTKEY 2002.08.22 	

    HOSTKEY_SWITCHON,
	
    HOSTKEY_FAIL,
    HOSTKEY_OK,
    HOSTKEY_OK_END,
    HOSTKEY_CHANGE_FAIL,
    HOSTKEY_CHANGE_OK,
    HOSTKEY_CHANGE_END,
    //HOSTKEY_CHANGE,
    INPUT_OLD_HOSTKEY,
    INPUT_NEW_HOSTKEY,
    INPUT_NEW_HOSTKEY_AGAIN,   
    
    SETT_HOSTKEY_ABORT,
    MAX_HOST_MODE
	} HOST_CASE;

typedef enum
{
 PRO_ON=0,
 PRO_SIMLOCK,
 PRO_DELALLPHB,
 PRO_RESETALL,
 PRO_MSGBOX,
 PRO_DELALLPHBSUCC,    //xsf add 2002.09.17
 PRO_NOTICE,  //xsf add 2003.04.16
 PRO_CONFIRM
}ProtectItem;


/* function declaration */
//void hostkey_init(T_MFW_HND parent_window);
int hostkey_change (struct MfwMnuTag * m, struct MfwMnuItemTag * i);
int settingHostKeyOff(MfwMnu* m, MfwMnuItem* i);
int settingHostKeyOn(MfwMnu* m, MfwMnuItem* i);
//USHORT hostkey_menu_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
int hostkey_menu_check(struct MfwMnuTag * m, struct MfwMnuItemTag * i);
int CheckPassWord(ProtectItem Items);
int JudgeHostKey(char* L_Key) ;
void JudgeSim(void);
void ReadSimIMSI(void);
int SetModeSwitchOn(MfwMnu* m, MfwMnuItem* i);
int SetModeSimLock(MfwMnu* m, MfwMnuItem* i);
int SetModeDelAllPhb(MfwMnu* m, MfwMnuItem* i);
int SetModeReset(MfwMnu* m, MfwMnuItem* i);
int SetModeMsgBox(MfwMnu* m, MfwMnuItem* i);
USHORT HostkeyOptions_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
//USHORT settingHostKeyOnOff (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi); //xsf add 2002.08.22
int settingHostKeyOnOff(struct MfwMnuTag * m, struct MfwMnuItemTag * i); //xsf add 2002.08.23
int CheckHostkey(ProtectItem Items);  //xsf add 2002.08.25
void CheckHostkey2(T_MFW_HND     win, ProtectItem Items); //xsf 11.08
void hostkey_exit (void);  //xsf add 2 lines 2002.09.12
int hostkeyASKIsFocussed(void);
void HostkeyProtectOpts_confirm(void); //xsf add 2003.03.06
void HostkeyProtectOpts_notice(void);   //xsf add 2003.4.16 
#endif

