/*******************************************************************************

          Mobile Innovation (Shanghai)

********************************************************************************

 This software product is the property of Mobile Innovation (Shanghai) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: 
 $Module:   MMI
 $File:      mmihz.c
 $Revision:   1.0

 $Author:  Mobile Innovation (Shanghai)
 $Date:       2002/7/15

********************************************************************************

 Description:
 This file contains the Gloable variables defined by Engineer of Mobile Innovation. These variables are
 included in the mmihz.h


********************************************************************************

 $History: mmihz.c

  Date             Modification                             Author                                           
  ------------------------------------------------------------- 
  05/09/2002       1.3                                    zhangxiuping
  01/08/2002       1.2                                    zhangxiuping
  15/07/2002       1.1                                    zhangxiuping
  03/08/2000       1.0                                    zhaogang
  
 $End

*******************************************************************************/
/*
$Log: mmihz.c,v $
Revision 1.3  2004/07/19 09:16:25  zhenggl
no message

Revision 1.1.1.1  2004/05/10 02:33:58  root
zhq, 2004/05/10, import base on M188A_102X80 project
tag "M188B_128X160_20040509_BASE".

Revision 1.1.1.1  2004/04/19 08:33:13  root
This is the base release version for M188A

Revision 1.1.1.1  2004/01/06 03:15:54  root
this is the baseline for M188_102X80A project

Revision 1.1.1.1  2004/01/03 07:44:30  root
this is the baseline of M188_102X80A project

Revision 1.1.1.1  2003/12/25 11:15:35  root
this is the baseline for m188 project

 *    Rev 1.3 August 03 2000 14:35:54   ZhaoGang
 *    Rev 1.2   July 24 2000 15:35:54   ZhaoGang
 *    Rev 1.1   July 18 2000 16:35:54   ZhaoGang
 *    Rev 1.0   June 30 2000 16:25:04   ZhaoGang
 * Initial revision.
---------------------------------------------------------------------------
*/

#define ENTITY_MFW

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif

#include "dspl.h"
#include "mfw_mfw.h"
#include "mfw_lng.h"
#include "cus_aci.h"
#include "p_sim.h"

#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_edt.h"
#include "mfw_mnu.h"
#include "mfw_sat.h"
#include "mfw_ffs.h"

#include "drv_key.h"
#include "drv_tmr.h"


#include "uniparad.h"
#include "Uniassociate.h"
#include "Mmimmi.h"
#include "Mmidummy.h"
#include "Mmidialogs.h"
#include "MmiSoftKeys.h"
#include "Mmieditor.h"
#include "Mmieditor_i.h"
#include "mmihz.h"
#include "mmisettings.h"
#include "mmiblklangdb.h"
#include "mmihzapi.h"

U8 editForChineseInput=0;
extern void TraceMMI(char *s);
T_MFW_HND hz_start (T_MFW_HND parent,T_MFW_KBD *kc);
static T_MFW_HND hz_create (T_MFW_HND  parent);
static void hz_exec_cb(T_MFW_HND win, USHORT event, SHORT value, T_MFW_KBD *kc);
static int  hzEventWin (MfwEvt e,MfwWin *w);
static int  hzEventKbd (MfwEvt e,MfwKbd *kc);
static int TimerEH(MfwEvt e, MfwTim *tc) ;

////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
#define   KCD_CURSORDISP 60         // this is a simulate key_code
//#define   MAX_Satisfy 10
#define   MaxPinYin 402
#define   MaxHanZi  7334*4
#define   MaxAssHanZi  11833*2

#define	  TIM_TAKE_OVER		1000	// one second as shorttimer
#define	  TIM_TAKE_OVERLONG	1500	// six second as longtimer

static const char  * InputMethodFirstChar[8] = {"abc","def","gh","jkl","mno","pqrs","t" ,"wxyz" };
static const char  * InputMethodOtherChar[8] = {"a"  ,"e"  ,"ghi",""  ,"no" ,"r"   ,"uv",""     }; 
static const char  * Table[MaxPinYin] = {
    "a","ai","an","ang","ao","ba","bai","ban","bang","bao",
    "bei","ben","beng","bi","bian","biao","bie","bin","bing","bo",
    "bu","ca","cai","can","cang","cao","ce","cen","ceng","cha",
    "chai","chan","chang","chao","che","chen","cheng","chi","chong","chou",
    "chu","chuai","chuan","chuang","chui","chun","chuo","ci","cong","cou",
    "cu","cuan","cui","cun","cuo","da","dai","dan","dang","dao",
    "de","deng","di","dia","dian","diao","die","ding","diu","dong",
    "dou","du","duan","dui","dun","duo","e","ei","en","er",
    "fa","fan","fang","fei","fen","feng","fo","fou","fu","ga",
    "gai","gan","gang","gao","ge","gei","gen","geng","gong","gou",
    "gu","gua","guai","guan","guang","gui","gun","guo","ha","hai",
    "han","hang","hao","he","hei","hen","heng","hong","hou","hu",
    "hua","huai","huan","huang","hui","hun","huo","ji","jia","jian",
    "jiang","jiao","jie","jin","jing","jiong","jiu","ju","juan","jue",
    "jun","ka","kai","kan","kang","kao","ke","ken","keng","kong",
    "kou","ku","kua","kuai","kuan","kuang","kui","kun","kuo","la",
    "lai","lan","lang","lao","le","lei","leng","li","lia","lian",
    "liang","liao","lie","lin","ling","liu","long","lou","lu","luan",
    "lue","lun","luo","lv","ma","mai","man","mang","mao","me",
    "mei","men","meng","mi","mian","miao","mie","min","ming","miu",
    "mo","mou","mu","na","nai","nan","nang","nao","ne","nei",
    "nen","neng","ni","nian","niang","niao","nie","nin","ning","niu",
    "nong","nou","nu","nuan","nue","nuo","nv","o","ou","pa",
    "pai","pan","pang","pao","pei","pen","peng","pi","pian","piao",
    "pie","pin","ping","po","pou","pu","qi","qia","qian","qiang",
    "qiao","qie","qin","qing","qiong","qiu","qu","quan","que","qun",
    "ran","rang","rao","re","ren","reng","ri","rong","rou","ru",
    "ruan","rui","run","ruo","sa","sai","san","sang","sao","se",
    "sen","seng","sha","shai","shan","shang","shao","she","shen","sheng",
    "shi","shou","shu","shua","shuai","shuan","shuang","shui","shun","shuo",
    "si","song","sou","su","suan","sui","sun","suo","ta","tai",
    "tan","tang","tao","te","teng","ti","tian","tiao","tie","ting",
    "tong","tou","tu","tuan","tui","tun","tuo","wa","wai","wan",
    "wang","wei","wen","weng","wo","wu","xi","xia","xian","xiang",
    "xiao","xie","xin","xing","xiong","xiu","xu","xuan","xue","xun",
    "ya","yan","yang","yao","ye","yi","yin","ying","yo","yong",
    "you","yu","yuan","yue","yun","za","zai","zan","zang","zao",
    "ze","zei","zen","zeng","zha","zhai","zhan","zhang","zhao","zhe",
    "zhen","zheng","zhi","zhi","zhong","zhou","zhu","zhua","zhuai","zhuan",
    "zhuang","zhui","zhun","zhuo","zi","zong","zou","zu","zuan","zui","zun","zuo"};


static char flagForNewWin=0;
extern INT8 g_norejectkeyflag;


static void InitializeForChineseInput(chinese_Data * pChineseData)
    	{    	    	
    	memset(pChineseData->ConditionStr, 0, sizeof(pChineseData->ConditionStr));
    	memset(pChineseData->ConditionHz, 0, sizeof(pChineseData->ConditionHz));
    	memset(pChineseData->PromptBuf, 0, sizeof(pChineseData->PromptBuf));
    	pChineseData->InTheTime=1;
    	pChineseData->SatisfyNum=0;
    	pChineseData->PageNum=0;
    	pChineseData->MAX_Satisfy=10;
    	pChineseData->Index=0;
    	pChineseData->CurCode=0;
    	memset(pChineseData->OtherMightChar,0,sizeof(pChineseData->OtherMightChar));
    	}
/*    	
static unsigned int wordstrlen(const unsigned short *ws)
{
   const unsigned short *wr = ws - 1;

   while (*++wr);
   return wr - ws;
}
*/
int wordstrcmp(const unsigned short *ws1, const unsigned short *ws2)
{
   unsigned short *st1 = (unsigned short *)ws1;
   unsigned short *st2 = (unsigned short *)ws2;
   unsigned int   ch1, diff;

   while (!(diff = (ch1 = *st1++) - *st2++) && ch1 != 0) ;
   return diff;
}
/*
 static unsigned short *wordstrcat(unsigned short *ws1, const unsigned short *ws2)
{
   unsigned short *result = ws1;

   while (*ws1++);			     // FIND END OF STRING   
   --ws1;				     // BACK UP OVER NULL    
   while (*ws1++ = *ws2++);	             // APPEND SECOND STRING 
   return result;
}*/
static char  *Wbuf2Cbuf(char *s, unsigned short *ws)/*ߵֽڽλ*/
{   char *p=(char*)ws;
    char msg[100];
    *s++=0x80;
    while(*ws)
    {   *s++=*(p+1);
      
        *s++=(*p);	
      
        ws++;
        p+=2;
      }
    
    
    
     return s;
     
}
static int  Input_one_key(T_MFW_HND win,int KeyCode);
static void DispPromptBuf(T_MFW_HND win);


/*******************************************************************************

 $Function:     hz_start

 $Description:  input chinese.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
T_MFW_HND hz_start (T_MFW_HND parent,T_MFW_KBD *kc)
{
    T_MFW_HND win;

    TRACE_EVENT ("hz_start()");
    editForChineseInput=0;
    g_norejectkeyflag=1;

    win = hz_create (parent);

    if (win NEQ NULL)
    	{
            SEND_EVENT (win, HZINIT, 0, kc);
        }
    return win;
}

/*******************************************************************************

 $Function:     hz_create

 $Description:  Creation of a win.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static T_MFW_HND hz_create (T_MFW_HND  parent)
{
    T_HZ_INFO*  data = (T_HZ_INFO *)ALLOC_MEMORY (sizeof (T_HZ_INFO));
    
    T_MFW_WIN     *  win;

    TRACE_EVENT ("hz_create()");

    /*
     * Create window handler
     */
    
    data->hz_win =winCreate( parent, 0, MfwWinVisible, (MfwCb) hzEventWin); 

    if (data->hz_win EQ NULL)
    {
        return NULL;
    }

    /*
     * connect the dialog data to the MFW-window
     */


    data->mmi_control.dialog = (T_DIALOG_FUNC)hz_exec_cb;
    data->mmi_control.data   = data;
    data->parent             = parent;
    win                      = ((T_MFW_HDR *)data->hz_win)->data;
    win->user                = (void *)data;
    winShow(data->hz_win);

    /*
     * return window handle
     */

    return data->hz_win;
}

/*******************************************************************************

 $Function:     hz_exec_cb

 $Description:  Dialog function for  chinese win.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static void hz_exec_cb(T_MFW_HND win, USHORT event, SHORT value, T_MFW_KBD *kc)
{
    T_MFW_WIN      * win_data  = ((T_MFW_HDR *)win)->data;
    T_HZ_INFO  * data      = (T_HZ_INFO *)win_data->user;
    
    T_MFW_HND       parent_win = data->parent;
    T_MFW_WIN     *parentwin_data =((T_MFW_HDR *)parent_win)->data;
    T_EDITOR_INFO  *parentdata   =(T_EDITOR_INFO *)parentwin_data->user;
    MfwHdr *edit_hdr=(MfwHdr *)parentdata->edt_edt;
    MfwEdt *edit_controll=(MfwEdt *)edit_hdr->data;
   // MfwEdtAttr  * edtattr=&parentdata->editor_data.editor_attr;
    T_MFW_HND      * l_parent;
    char msg[100];

    TRACE_EVENT("hz_exec_cb()");
    sprintf(msg,"win:%d",(int *)win);
    TRACE_EVENT(msg);
    switch(event)
    	{    
    	case HZINIT:
    		
    		data->InitPx=56;    		
    		data->InitPy=98;
    		data->CurPx=data->InitPx;
            data->CurPy=data->InitPy;
            data->memoryPx=0;
            data->memoryPy=0;
            memset(data->memoryBuf,0,sizeof(data->memoryBuf));
           
            InitializeForChineseInput(&data->chineseData);            
            if((int)kc->code==KCD_0||(int)kc->code==KCD_OK||(int)kc->code==KCD_ABC
            	||getSymbolNumSpare(edit_controll)<1)
            	{ 
            	  hz_destroy(data->hz_win);
                  return;
            	}

        
    		data->l_intimelong = timCreate(data->hz_win, TIM_TAKE_OVERLONG, (MfwCb)TimerEH);
    		timStart(data->l_intimelong);
            data->l_intime = timCreate(data->hz_win, TIM_TAKE_OVER, (MfwCb)TimerEH); 
            timStart(data->l_intime);
            
    		Input_one_key(win,(int) kc->code);    		
    		
            data->hz_kbd = kbdCreate(data->hz_win, KEY_ALL, (MfwCb) hzEventKbd);
    		sprintf(msg,"zxp beforeinput:%s",(char *)data->chineseData.ConditionStr);
    		TRACE_EVENT(msg);
            //Input_one_key(win,(int) kc->code);
           
    	    break;
        case HZEXIT:          	
    		hz_destroy(data->hz_win);
    		break;
    	}
}

/*******************************************************************************

 $Function:     hz_destroy

 $Description:  Destroy the hz_win.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
void hz_destroy (T_MFW_HND window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)window)->data;
    T_HZ_INFO * data = (T_HZ_INFO *)win->user;
    T_MFW_HND  parent_win   =data->parent;
    T_MFW_WIN     *parentwin_data =((T_MFW_HDR *)parent_win)->data;
    T_EDITOR_INFO  *parentdata   =(T_EDITOR_INFO *)parentwin_data->user;
 //   MfwHdr *edit_hdr=(MfwHdr *)parentdata->edt_edt;
 //   MfwEdt *edit_controll=(MfwEdt *)edit_hdr->data;
    TRACE_EVENT ("hz_destroy()");

    if (data)
        {
            g_norejectkeyflag=0;
            if((!editForChineseInput)&&(!(parentdata->editor_data.edtInPbk)))
               editForChineseInput=1;
            parentdata->hz_input=NULL;
           // kbd_delete (data->hz_kbd);
            win_delete (data->hz_win);
        //    edit_controll->cp_curr_x=0;//reset the flag.we set it in editorkeycb before hz_start.
            /*
             * Free Memory
             */
            FREE_MEMORY ((void *)data, sizeof (T_HZ_INFO));
            
        } 
    else
        {
            return ;
        }
}


static void DispPromptBuf(T_MFW_HND win) 
{   
    T_MFW_WIN     * win_data   = ((T_MFW_HDR *)win)->data;
    T_HZ_INFO *  data       = (T_HZ_INFO *)win_data->user;
    char* ConditionStr =(char*)data->chineseData.ConditionStr;
    unsigned short* ConditionHz=(unsigned short*)data->chineseData.ConditionHz;
    
    unsigned short Word,memoryWord,TempBuf[20];
    char Ch[5],memoryCh[5],HzTempbuf[8],CharTempBuf[20],CharPromptBuf[200];
    char msg[100];    
    USHORT px;
    UINT32 oldColor,oldFontColor;
    U8 mode;
    
    TRACE_EVENT("DispPromptBuf");

    mode=dspl_Enable(0);
   
    if(wordstrcmp(data->chineseData.PromptBuf, data->memoryBuf)!=0/*||dsplflag==0*/||flagForNewWin==1)/*&&InTheTime==0*/    	 
       dspl_Clear(0, 82, 120, 131); 
         
    memset(TempBuf,0,sizeof(TempBuf));
    memset(HzTempbuf,0,sizeof(HzTempbuf));
    memset(CharTempBuf,0,sizeof(CharTempBuf));
    memset(CharPromptBuf,0,sizeof(CharPromptBuf));
    
			
    if(wordstrlen(ConditionHz))   
    
      strcpy(CharTempBuf,"");      
    	
	else if(strlen(ConditionStr)&&(ConditionStr[5]!=':')){
		if(data->chineseData.InTheTime)
			sprintf(CharTempBuf," %s          ",ConditionStr);
		else sprintf(CharTempBuf," %s_         ",ConditionStr);	
		}
	else if(strlen(ConditionStr)&&(ConditionStr[5]==':')){
		sprintf(CharTempBuf," %s          ",ConditionStr);
	
		}		
	
    if(data->chineseData.PageNum)
	{	CharTempBuf[11]='<';
	    CharTempBuf[12]='-';
	    CharTempBuf[13]=' ';
	}
	if(data->chineseData.SatisfyNum>data->chineseData.MAX_Satisfy)    
	{	
		CharTempBuf[12]='-';
		CharTempBuf[13]='>';
	}
	else {
	     	CharTempBuf[13]=' ';
		}
    CharTempBuf[14]='\0';
    
        //oldColor=dspl_GetBkgColor();
        //dspl_SetBkgColor(0xe6ffff);
    	dspl_TextOut(0 , 82, 0,CharTempBuf);
    	//dspl_SetBkgColor(oldColor);
   
	//else dspl_TextOut(0 , 78,0,CharTempBuf);
	while(data->chineseData.SatisfyNum<=(data->CurPy-data->InitPy)/16*5&&data->CurPy>data->InitPy)
		data->CurPy-=16;
	while(data->chineseData.SatisfyNum<((data->CurPy-data->InitPy)/16*5+data->CurPx/24+1)&&data->CurPx>8)
     	data->CurPx-=24;

	if((ConditionStr[5] != ':')/*&&(InTheTime==0)*/){//Chinese 

        if(wordstrcmp(data->chineseData.PromptBuf, data->memoryBuf)==0/*&&dsplflag==1&&(memoryBuf!=NULL)*/&&(!flagForNewWin))  
        	{
        	  TRACE_EVENT("buf not changed");
        	  memoryWord=data->memoryBuf[((data->memoryPy-data->InitPy)/16*5+data->memoryPx/24)*2+1];
              memoryCh[0]=0x80;
              memoryCh[1]=(char)(memoryWord>>8);
              memoryCh[2]=(char)memoryWord;
              memoryCh[3]='\0';
              memoryCh[4]='\0';
              dspl_TextOut(data->memoryPx, data->memoryPy, DSPL_TXTATTR_UNICODE, memoryCh);
        	}
        else {  
        	  TRACE_EVENT("buf  changed");
              Wbuf2Cbuf(CharPromptBuf,data->chineseData.PromptBuf);        
              
              CharPromptBuf[41] ='\0';
              CharPromptBuf[42] ='\0';     
      
              set_font_type(CHNINPUT_FONT);       
        	
              dspl_TextOut(0 , data->InitPy, DSPL_TXTATTR_UNICODE,CharPromptBuf);
            //  dsplflag=1;
        	}        	
                      
        Word=(unsigned short)data->chineseData.PromptBuf[((data->CurPy-data->InitPy)/16*5+data->CurPx/24)*2+1];
        Ch[0]=0x80;
        Ch[1]=(char)(Word>>8);
        Ch[2]=(char)Word;
        Ch[3]='\0';
        Ch[4]='\0';
       
        	
        dspl_colorTextOut(data->CurPx, data->CurPy, DSPL_TXTATTR_INVERS|DSPL_TXTATTR_UNICODE, Ch,0x008080);
        
            
     
    }
else /*if(InTheTime==0)*/{ //Label
       if(wordstrcmp(data->chineseData.PromptBuf, data->memoryBuf)==0/*&&dsplflag==1&&(memoryBuf!=NULL)*/&&(!flagForNewWin))  
       	{
       	  TRACE_EVENT("buf not changed");
       	  if(data->chineseData.PageNum==0)
        	{ if(data->memoryPy==data->InitPy&&data->memoryPx<=data->InitPx)
        	    memoryWord=data->memoryBuf[(data->memoryPx/24)*2+1];
              else if(data->memoryPy==data->InitPy&&data->memoryPx>=80)
              	memoryWord=data->memoryBuf[7+(data->memoryPx-80)/24*2+1];
              else memoryWord=data->memoryBuf[11+(data->memoryPx/24)*3+1];
        	}
        else memoryWord=data->memoryBuf[(data->memoryPy-data->InitPy)/16*15+(data->memoryPx/24)*3+1];
        Sprintf(msg,"memoryword:%d",memoryWord);
        TRACE_EVENT(msg);
        memoryCh[0]=0x80;
        memoryCh[1]=(char)(memoryWord>>8);
        memoryCh[2]=(char)memoryWord;
        memoryCh[3]='\0';
        memoryCh[4]='\0';       
        	
            dspl_TextOut(data->memoryPx, data->memoryPy, DSPL_TXTATTR_UNICODE, memoryCh);
            
       	}
       else{
       	TRACE_EVENT("buf changed");
        Wbuf2Cbuf(CharPromptBuf,data->chineseData.PromptBuf);        
        
      
     //   TraceMMI(CharPromptBuf);
     
        if(data->chineseData.PageNum==0)
        	{ CharPromptBuf[52]='\0';
              CharPromptBuf[53]='\0';
        	}
        else {CharPromptBuf[60]='\0';
              CharPromptBuf[61]='\0';
        	}
     
        //	oldColor=dspl_GetBkgColor();
            //dspl_SetBkgColor(0xffe1e1);
            dspl_TextOut(0 , data->InitPy, DSPL_TXTATTR_UNICODE,CharPromptBuf);
         //   dspl_SetBkgColor(oldColor);
       //  dsplflag=1;
       	}   
        if(data->chineseData.PageNum==0)
        	{ if(data->CurPy==data->InitPy&&data->CurPx<=data->InitPx)
        	    Word=data->chineseData.PromptBuf[(data->CurPx/24)*2+1];
              else if(data->CurPy==data->InitPy&&data->CurPx>=80)
              	Word=data->chineseData.PromptBuf[7+(data->CurPx-80)/24*2+1];
              else Word=data->chineseData.PromptBuf[11+(data->CurPx/24)*3+1];
        	}
        else Word=data->chineseData.PromptBuf[(data->CurPy-data->InitPy)/16*15+(data->CurPx/24)*3+1];
        
        Ch[0]=0x80;
        Ch[1]=(char)(Word>>8);
        Ch[2]=(char)Word;
        Ch[3]='\0';
        Ch[4]='\0';
       
        	//oldColor=dspl_GetBkgColor();
            //dspl_SetBkgColor(0xffe1e1);
            dspl_colorTextOut(data->CurPx, data->CurPy, DSPL_TXTATTR_INVERS|DSPL_TXTATTR_UNICODE, Ch,0x008080);
            //dspl_SetBkgColor(oldColor);
        
     
     //   displaySoftKeys(TxtSoftSelect, TxtSoftBack); 
     
        
    }
    data->memoryPx=data->CurPx;
    data->memoryPy=data->CurPy;
    memset(data->memoryBuf, 0, sizeof(data->memoryBuf));
    wordstrcat(data->memoryBuf, data->chineseData.PromptBuf);
    /*
    oldColor=dspl_GetBkgColor();
	dspl_SetBkgColor(GetPreDefinedColor(ColorSoftKeyBG));
	oldFontColor=dspl_GetFrgColor();
	dspl_SetFrgColor(GetPreDefinedColor(ColorSoftKeyFont));
	*/
    if(wordstrlen(ConditionHz)||(strlen(ConditionStr)&&(ConditionStr[5]==':')))
     	displaySoftKeys(TxtSoftSelect, TxtSoftBack);
    else if(strlen(ConditionStr)&&(ConditionStr[5]!=':'))
     	displaySoftKeys(TxtSoftOK, TxtDelete);
    /*
     dspl_SetBkgColor(oldColor);
	 dspl_SetFrgColor(oldFontColor); 
	 */
	 	
	 	//dspl_SetFrgColor(0x0000ff);
	    dspl_DrawRect(0, 82, 119, 131);
	    //dspl_SetFrgColor(oldFontColor);
	    
	 dspl_Enable(mode);
	 
     
} 

#if 0
static int    PinYinCode(char * ConditionStr,char CheckChar)
{   int Loop;
   // char g_str[10];
    
    for(Loop=0;Loop<MaxPinYin;Loop++)
    {   if ( strncmp(Table[Loop],ConditionStr,strlen(ConditionStr))==0 &&
             Table[Loop][strlen(ConditionStr)]==CheckChar )
            return 1;
    }
    return 0;
}

static void SetOtherMightChar(chinese_Data* pchinese_Data,int KeyCode)
{   unsigned int Position;
    Position=0;
    memset(pchinese_Data->OtherMightChar,0,sizeof(pchinese_Data->OtherMightChar));
    while(KeyCode>1 && strlen(InputMethodOtherChar[KeyCode-2])!=Position)
    {   if(PinYinCode(pchinese_Data->ConditionStr,InputMethodOtherChar[KeyCode-2][Position]))
            pchinese_Data->OtherMightChar[strlen(pchinese_Data->OtherMightChar)]=InputMethodOtherChar[KeyCode-2][Position];
        Position++;
    }
}

static int FindBiShun(char *ConditionStr)
{   unsigned int Num;
    char c;
    for(Num=1; Num<strlen(ConditionStr); Num++)
    {   c = ConditionStr[Num];
        if ( c!='5' && c!='8' && c!='9' && c!='7' && c!='0' 
             && c!='-' && c!='|' && c!='/' && c!='\\' && c!='>'
          	 && c!='r' && c!='u' && c!='v')
          return 0;
    }
    return 1;
}

static void ChangCharToBs(char * ConditionStr)
{   unsigned int Num;
    char msg[100];
    TRACE_EVENT("change to bishun");
    for(Num=1; Num<strlen(ConditionStr); Num++)
        switch(ConditionStr[Num])
        {   case '5':   ConditionStr[Num]='-';
                        break;
            case 'u':
            case 'v':
            case '8':   ConditionStr[Num]='|';
                        break;
            case 'r':
            case '7':   ConditionStr[Num]='/';
                        break;
            case '9':   ConditionStr[Num]='\\';
                        break;
            case '0':   ConditionStr[Num]='>';
                        break;
            case '-':
            case '|':
            case '/':
            case '\\':
            case '>':   break;
            default :   ConditionStr[Num]='?';
                        break;
        }
        sprintf(msg,"zxp bishun:%s",ConditionStr);
        TRACE_EVENT(msg);
}

static void    PinYinProgramCode(chinese_Data* pchinese_Data)
{   unsigned int Num;

    char* ConditionStr =(char*)pchinese_Data->ConditionStr;
    char* ProgramCode=(char*)pchinese_Data->ProgramCode;
    
    ProgramCode[0] = ConditionStr[0];
    for(Num=1; Num<strlen(ConditionStr); Num++)
        switch(ConditionStr[Num])
        {  	case 'a':    ProgramCode[Num]=2;    break;
   	        case 'e':    ProgramCode[Num]=3;    break;
   	        case 'i':    ProgramCode[Num]=4;    break;
   	        case 'n':    ProgramCode[Num]=5;    break;
   	        case 'o':    ProgramCode[Num]=6;    break;
   	        case 'r':    ProgramCode[Num]=7;    break;
   	        case 'u':    ProgramCode[Num]=8;    break;
		    case 'g':    ProgramCode[Num]=9;    break;
   	        case 'h':    ProgramCode[Num]=12;   break;
   	        case 'v':    ProgramCode[Num]=11;   break;
            default :    ProgramCode[Num]=0;    break;
        }
    for(;Num<8;Num++) ProgramCode[Num]=0;
}

static void SearchSomeHanZi_ByPinYin(chinese_Data* pchinese_Data)
{   unsigned int  Smart, OffSetPositoin,OffSetEnd,IsNotPinyinCode;
    unsigned int PCode;
    unsigned short TempString[10],ch1[3];    
    char msg[100];

    char* ProgramCode=(char*)pchinese_Data->ProgramCode;

    OffSetPositoin = 0;
    OffSetEnd = MaxHanZi;
    
    if(ProgramCode[4])      Smart=0xffff;
    else if(ProgramCode[3]) Smart=0xfff0;
    else if(ProgramCode[2]) Smart=0xff00;
    else if(ProgramCode[1]) Smart=0xf000;
    else                    Smart=0x0000;
    PCode= ((int)ProgramCode[1]<<12)+((int)ProgramCode[2]<<8)+
    		((int)ProgramCode[3]<<4 )+(int)ProgramCode[4];

    IsNotPinyinCode = 1 - PinYinCode(pchinese_Data->ConditionStr,0);
    if(ProgramCode[5]) IsNotPinyinCode =1;

    if(pchinese_Data->PageNum)
    //if(LineNum>1)
    {   memset(TempString,0,sizeof(TempString));
        while( OffSetPositoin<OffSetEnd && pchinese_Data->SatisfyNum<pchinese_Data->MAX_Satisfy)        // page 0
        {   if( (( *(HLCode+OffSetPositoin+1))& Smart) == PCode && ((*(HLCode+OffSetPositoin))>>8) ==ProgramCode[0] &&
                ((*(HLCode+OffSetPositoin)&0x000f)==(int)ProgramCode[5] || ProgramCode[5]==0) )
                pchinese_Data->SatisfyNum++;
            OffSetPositoin += 4;
        }

        while( OffSetPositoin<OffSetEnd && pchinese_Data->SatisfyNum<pchinese_Data->MAX_Satisfy*pchinese_Data->PageNum )// page 1 to n-1 (n=1....Max)
        {   if( (( *(HLCode+OffSetPositoin+1))& Smart) == PCode && ((*(HLCode+OffSetPositoin))>>8) ==ProgramCode[0] &&
                ((*(HLCode+OffSetPositoin)&0x000f)==(int)ProgramCode[5] || ProgramCode[5]==0) &&
                (IsNotPinyinCode || ((*(HLCode+OffSetPositoin)&0x000f)==0 && *(HLCode+OffSetPositoin+1) == PCode))  )
                pchinese_Data->SatisfyNum++;
            OffSetPositoin += 4;
        }

        pchinese_Data->SatisfyNum = 0; 
        /*
        if(LineNum==2){        	
        while( OffSetPositoin<OffSetEnd && SatisfyNum<MAX_Satisfy/2)        // page 0
        {   if( (( *(HLCode+OffSetPositoin+1))& Smart) == PCode && ((*(HLCode+OffSetPositoin))>>8) ==ProgramCode[0] &&
                ((*(HLCode+OffSetPositoin)&0x000f)==(int)ProgramCode[5] || ProgramCode[5]==0) )
              {// ch1[0] =  (*(HLCode+OffSetPositoin+3));
                //ch1[1] =  ' ';
                //ch1[2] = 0;
                SatisfyNum++;
                ch1[0]=SatisfyNum+0x30;
                ch1[1]=(*(HLCode+OffSetPositoin+3));
                ch1[2]=0;
              //  wsprintf(TempString,"%s",ch1);                 
              //  wordstrcat(PromptBuf,TempString);
                wordstrcat(PromptBuf,ch1);
                
        	}
            OffSetPositoin += 4;
        }
        	}
        	*/
        while( OffSetPositoin<OffSetEnd && pchinese_Data->SatisfyNum<=pchinese_Data->MAX_Satisfy )
        {   if( (( *(HLCode+OffSetPositoin+1))& Smart) == PCode && ((*(HLCode+OffSetPositoin))>>8) ==ProgramCode[0] &&
                ((*(HLCode+OffSetPositoin)&0x000f)==(int)ProgramCode[5] || ProgramCode[5]==0) &&
                (IsNotPinyinCode || ((*(HLCode+OffSetPositoin)&0x000f)==0 && *(HLCode+OffSetPositoin+1) == PCode))  )
            {  // ch1[0] =  (char)(*(HLCode+OffSetPositoin+3)>>8);
              //  ch1[0] =  (*(HLCode+OffSetPositoin+3));
              //  ch1[1] =  ' ';
              //  ch1[2] = 0;
                
                pchinese_Data->SatisfyNum++;
                if(pchinese_Data->SatisfyNum%10==0)
                	ch1[0]=0x30;
                else  ch1[0]=pchinese_Data->SatisfyNum+0x30;
                ch1[1]=(*(HLCode+OffSetPositoin+3));
                ch1[2]=0;
                //wsprintf(TempString,"%d%c%c  ",SatisfyNum,ch1,ch2);
              //  wsprintf(TempString,"%s",ch1);                
             //   wordstrcat(PromptBuf,TempString);
                wordstrcat(pchinese_Data->PromptBuf,ch1);
                
            }
            OffSetPositoin += 4;
        }
    }
    else
    {   memset(TempString,0,sizeof(TempString));
        while( OffSetPositoin<OffSetEnd && pchinese_Data->SatisfyNum<pchinese_Data->MAX_Satisfy ) // 0 to Max_Satisfy-1 HanZi
        {   if( (( *(HLCode+OffSetPositoin+1))& Smart) == PCode && ((*(HLCode+OffSetPositoin))>>8) ==ProgramCode[0] &&
            ((*(HLCode+OffSetPositoin)&0x000f)==(int)ProgramCode[5] || ProgramCode[5]==0) )
            {  /* ch1[0] =  (*(HLCode+OffSetPositoin+3));
                ch1[1] =  ' ';
                ch1[2] = 0;
                */
                //ch1 =  (char)(*(HLCode+OffSetPositoin+3)>>8);
                pchinese_Data->SatisfyNum++;
                if(pchinese_Data->SatisfyNum%10==0)
                	ch1[0]=0x30;
                else  ch1[0]=pchinese_Data->SatisfyNum+0x30;
                ch1[1]=(*(HLCode+OffSetPositoin+3));
                ch1[2]=0;
              //  wsprintf(TempString,"%d%c%c  ",SatisfyNum,ch1,ch2);                
              //  wsprintf(TempString,"%s",ch1);                
              //  wordstrcat(PromptBuf,TempString);
                wordstrcat(pchinese_Data->PromptBuf,ch1);
                
                
            }
            OffSetPositoin += 4;
        }
        while( OffSetPositoin<OffSetEnd && pchinese_Data->SatisfyNum==pchinese_Data->MAX_Satisfy) // Is (MAX_Satisfy HanZi) Exist?
        {   if( (( *(HLCode+OffSetPositoin+1))& Smart) == PCode && ((*(HLCode+OffSetPositoin))>>8) ==ProgramCode[0] &&
                ((*(HLCode+OffSetPositoin)&0x000f)==(int)ProgramCode[5] || ProgramCode[5]==0) &&
                (IsNotPinyinCode || ((*(HLCode+OffSetPositoin)&0x000f)==0 && *(HLCode+OffSetPositoin+1) == PCode))  )
            { /*  ch1[0] =  (*(HLCode+OffSetPositoin+3));
                ch1[1] =  ' ';
                ch1[2] = 0;
                */
                //ch1 =  (char)(*(HLCode+OffSetPositoin+3)>>8);                
                pchinese_Data->SatisfyNum++;
                if(pchinese_Data->SatisfyNum%10==0)
                	ch1[0]=0x30;
                else  ch1[0]=pchinese_Data->SatisfyNum+0x30;
                ch1[1]=(*(HLCode+OffSetPositoin+3));
                ch1[2]=0;
                //wsprintf(TempString,"%d%c%c  ",SatisfyNum,ch1,ch2);
               // wsprintf(TempString,"%s",ch1);                
               // wordstrcat(PromptBuf,TempString);
                wordstrcat(pchinese_Data->PromptBuf,ch1);
                
            }
            OffSetPositoin += 4;
        }

    }
}

static void SearchSomeHanZi_ByBiShun(chinese_Data* pchinese_Data)
{   unsigned int  Smart, OffSetPositoin,OffSetEnd,PCode;
    unsigned short TempString[10],ch1[3];

    char* ProgramCode=(char*)pchinese_Data->ProgramCode;

    OffSetPositoin = 0;
    OffSetEnd = MaxHanZi;

    if(ProgramCode[4])      Smart=0xffff;
    else if(ProgramCode[3]) Smart=0xfff0;
    else if(ProgramCode[2]) Smart=0xff00;
    else if(ProgramCode[1]) Smart=0xf000;
    else                    Smart=0x0000;
    PCode= ((int)ProgramCode[1]<<12)+((int)ProgramCode[2]<<8)+
    		((int)ProgramCode[3]<<4 )+(int)ProgramCode[4];

    while( OffSetPositoin<OffSetEnd && pchinese_Data->SatisfyNum<pchinese_Data->MAX_Satisfy*pchinese_Data->PageNum )
    {   if( (( *(HLCode+OffSetPositoin+2))& Smart) == PCode && ((ProgramCode[0]=='*') || ((*(HLCode+OffSetPositoin)))>>8 ==ProgramCode[0])
            && (((*(HLCode+OffSetPositoin)>>4)&0x000f)==(int)ProgramCode[5] || ProgramCode[5]==0) )
            pchinese_Data->SatisfyNum++;
        OffSetPositoin += 4;
    }

    pchinese_Data->SatisfyNum = 0;
    memset(TempString,0,sizeof(TempString));
    while( OffSetPositoin<OffSetEnd && pchinese_Data->SatisfyNum<=pchinese_Data->MAX_Satisfy )
    {   if( (( *(HLCode+OffSetPositoin+2))& Smart) == PCode && ((ProgramCode[0]=='*') || ((*(HLCode+OffSetPositoin))>>8) ==ProgramCode[0])
            && (((*(HLCode+OffSetPositoin)>>4)& 0x000f)==(int)ProgramCode[5] || ProgramCode[5]==0) )
        {  /* ch1[0] =  (*(HLCode+OffSetPositoin+3));
            ch1[1] =  ' '; //(char)(*(HLCode+OffSetPositoin+3)>>8);
            ch1[2] = 0;
            */
            ch1[0]=0;
            ch1[1]=(*(HLCode+OffSetPositoin+3));
            ch1[2]=0;
            if( (ch1[1]!=pchinese_Data->PromptBuf[0]) && (ch1[1]!=pchinese_Data->PromptBuf[2]) &&
                (ch1[1]!=pchinese_Data->PromptBuf[4]) && (ch1[1]!=pchinese_Data->PromptBuf[6]) &&
                (ch1[1]!=pchinese_Data->PromptBuf[8]) && (ch1[1]!=pchinese_Data->PromptBuf[10]) &&
                (ch1[1]!=pchinese_Data->PromptBuf[12]) && (ch1[1]!=pchinese_Data->PromptBuf[14])&&
                (ch1[1]!=pchinese_Data->PromptBuf[16]) && (ch1[1]!=pchinese_Data->PromptBuf[18]))
            {   pchinese_Data->SatisfyNum++;
                if(pchinese_Data->SatisfyNum%10==0)
                	ch1[0]=0x30;
                else  ch1[0]=pchinese_Data->SatisfyNum+0x30;
                
              //  wsprintf(TempString,"%s",ch1);
              //  wordstrcat(PromptBuf,TempString);
                wordstrcat(pchinese_Data->PromptBuf,ch1);
            }
        }
        OffSetPositoin += 4;
    }
}

static void    SearchSomeHanZi_ByBiaoDian(chinese_Data* pchinese_Data)
{   unsigned int   OffSetPositoin,OffSetEnd;
    unsigned short TempString[10],ch1[6];
    char msg[100];

    OffSetPositoin =MaxHanZi-41*4;
    OffSetEnd = MaxHanZi;
    
   while( OffSetPositoin<OffSetEnd && pchinese_Data->SatisfyNum<pchinese_Data->MAX_Satisfy*pchinese_Data->PageNum )
    {   if( (*(HLCode+OffSetPositoin+2)& 0xf000) == 0xe000 )
            pchinese_Data->SatisfyNum++;
        OffSetPositoin += 4;
    }

    pchinese_Data->SatisfyNum = 0;
    memset(TempString,0,sizeof(TempString));
    while( OffSetPositoin<OffSetEnd && pchinese_Data->SatisfyNum<=pchinese_Data->MAX_Satisfy )
    {   if( (*(HLCode+OffSetPositoin+2)& 0xf000) == 0xe000 )
        {       pchinese_Data->SatisfyNum++;
                if(pchinese_Data->SatisfyNum%10==0)
                	ch1[0]=0x30;
                else  ch1[0]=pchinese_Data->SatisfyNum+0x30;
                ch1[1]=(*(HLCode+OffSetPositoin+3));
                if((ch1[1]>>8&0xff)==0)
                	{ch1[2]=' ';
                     ch1[3]=0;
                	}
                else ch1[2]=0;
                wordstrcat(pchinese_Data->PromptBuf,ch1);
           /*
             if(SatisfyNum%7==0){
              ch1[0]=' ';
              ch1[1]=0;
            //  wsprintf(TempString,"%s",ch1);
            //  wordstrcat(PromptBuf,TempString);
              sprintf(msg,"ch1:0x%x",ch1[0]);
              TRACE_EVENT(msg);
              wordstrcat(PromptBuf,ch1);
              sprintf(msg,"PromptBuf[]:0x%x",PromptBuf[SatisfyNum]);
              TRACE_EVENT(msg);
    	}
            if(SatisfyNum>=0&&SatisfyNum<=5){
            	ch1[0] = *(HLCode+OffSetPositoin+3);
            	ch1[1] =  0;
            	SatisfyNum++;
            	}
            else{
            ch1[0] = *(HLCode+OffSetPositoin+3);
            ch1[1] =  ' '; // (char)(*(HLCode+OffSetPositoin+3)>>8);
            ch1[2] = 0;
            SatisfyNum++;
            	}
          //  wsprintf(TempString,"%s",ch1);           
          //  wordstrcat(PromptBuf,TempString);
            sprintf(msg,"ch1:0x%x",ch1[0]);
            TRACE_EVENT(msg);
            wordstrcat(PromptBuf,ch1);
            sprintf(msg,"PromptBuf[SatisfyNum]:0x%x",PromptBuf[SatisfyNum]);
            TRACE_EVENT(msg);
          */  
        }
        OffSetPositoin += 4;
    }
}

static void    SearchSomeAssociateHanZi(chinese_Data* pchinese_Data) /*۰ҷ*/
{   
    unsigned short* ConditionHz=pchinese_Data->ConditionHz;
    unsigned int  mid,low,hig;
    unsigned short TempString[10],ch1[3];
    char msg[100];
    low=0;
    hig=MaxAssHanZi-1;
    while(low<=hig&&ASSCode[mid]!=ConditionHz[0])
    {    mid=(low+hig)/2;
         if((mid%2)!=0)         	
         	mid--;         	
         	
         if(ASSCode[mid]==ConditionHz[0])
           {    
                while(ASSCode[mid-2]==ASSCode[mid])
         	    mid=mid-2;
                
                while(mid<=MaxAssHanZi&&pchinese_Data->SatisfyNum<pchinese_Data->MAX_Satisfy*pchinese_Data->PageNum)
                	{   
                	    if(ASSCode[mid+2]==ASSCode[mid])
                	    {	pchinese_Data->SatisfyNum++;
                	        mid=mid+2;                	        
                	     }
                	    else if(ASSCode[mid+2]!=ASSCode[mid])//&&ASSCode[mid-2]==ASSCode[mid])
                	    	{  pchinese_Data->SatisfyNum++;
                	           break;
                	    	}
                	 }
                pchinese_Data->SatisfyNum = 0;
                memset(TempString,0,sizeof(TempString));
                while(mid<=MaxAssHanZi&&pchinese_Data->SatisfyNum<=pchinese_Data->MAX_Satisfy)
                
                	{   if(ASSCode[mid+2]==ASSCode[mid])
                	    {
                	      /*  ch1[0] =  (*(ASSCode+mid+1));
                            ch1[1] =  ' ';
                            ch1[2] = 0; 
                            */
                            pchinese_Data->SatisfyNum++;
                            if(pchinese_Data->SatisfyNum%10==0)
                            	ch1[0]=0x30;
                            else ch1[0]=pchinese_Data->SatisfyNum+0x30;
                            ch1[1]=(*(ASSCode+mid+1));
                            ch1[2] = 0; 
                            mid=mid+2;
                          //  wsprintf(TempString,"%s",ch1);
                	      //  wordstrcat(PromptBuf,TempString);
                	        wordstrcat(pchinese_Data->PromptBuf,ch1);
                	      }
                        else if(ASSCode[mid+2]!=ASSCode[mid])//&&ASSCode[mid-2]==ASSCode[mid])
                        	  { /* ch1[0] =  (*(ASSCode+mid+1));
                                 ch1[1] =  ' ';
                                 ch1[2] = 0; 
                                 */
                                 
                                 pchinese_Data->SatisfyNum++;
                                 if(pchinese_Data->SatisfyNum%10==0)
                            	    ch1[0]=0x30;
                                 else ch1[0]=pchinese_Data->SatisfyNum+0x30;
                                 ch1[1]=(*(ASSCode+mid+1));
                                 ch1[2] = 0;                                 
                              //   wsprintf(TempString,"%s",ch1);
                	          //   wordstrcat(PromptBuf,TempString);
                	             wordstrcat(pchinese_Data->PromptBuf,ch1);
                	             break;
                        	    }                        
                	  }  
         	}
         else if(ASSCode[mid]<ConditionHz[0])
                low=mid+2;
         else   hig=mid-2;
         
    }
  
}
                	

static void    BiShunProgramCode(chinese_Data* pchinese_Data)
{   unsigned int Num;

    char* ConditionStr =(char*)pchinese_Data->ConditionStr;
    char* ProgramCode=(char*)pchinese_Data->ProgramCode;
    
    ProgramCode[0] = ConditionStr[0];
    for(Num=1; Num<strlen(ConditionStr); Num++)
        switch(ConditionStr[Num])
        {   case '-':   ProgramCode[Num]=1; break;
            case '|':   ProgramCode[Num]=2; break;
            case '/':   ProgramCode[Num]=3; break;
            case '\\':  ProgramCode[Num]=4; break;
            case '>':   ProgramCode[Num]=5; break;
            default :   ProgramCode[Num]=0; break;
        }
    for(;Num<7;Num++) ProgramCode[Num]=0;
}

void SetTheConditionStr(chinese_Data * pChineseData,int keyCode)
    	{
    	 char *str;
    	 int  Index;
    	 char msg[100];
    	 
    	 str = pChineseData->ConditionStr;        	    	 
    	
    	 if(strlen(str)==0 && keyCode)
          {   pChineseData->Index = 0;
              pChineseData->CurCode= keyCode;
              str[0]=InputMethodFirstChar[keyCode-2][pChineseData->Index];
            }
          else if(strlen(str)==1 && (pChineseData->InTheTime) && (pChineseData->CurCode==keyCode) && keyCode)
          {   pChineseData->Index = (pChineseData->Index + 1) % strlen(InputMethodFirstChar[pChineseData->CurCode-2]);
              str[0]=InputMethodFirstChar[pChineseData->CurCode-2][pChineseData->Index];
           }
           else if((strlen(str) || keyCode) && (strlen(str)<6))
           {   if( (pChineseData->CurCode)!=keyCode || !(pChineseData->InTheTime) ) pChineseData->Index=0;  // Next KCD,then New the Index;
               else str[strlen(str)-1]= 0;  // in the same KCD loop,Del The Last Key;
               pChineseData->CurCode= keyCode;

               SetOtherMightChar(pChineseData,keyCode);
               if(strlen(pChineseData->OtherMightChar))
               {   str[strlen(str)]= pChineseData->OtherMightChar[pChineseData->Index];
                   pChineseData->Index = (pChineseData->Index + 1) % strlen(pChineseData->OtherMightChar);
                 }
                else str[strlen(str)]= (char)(0x30 + keyCode);
                }           
           
    	}

int OtherCharIsOnlyOne(chinese_Data *pChineseData)
    	{            
    	  if((strlen(pChineseData->ConditionStr)==1 && strlen(InputMethodFirstChar[pChineseData->CurCode-2])<2 ) 
            ||( strlen(pChineseData->ConditionStr) >1 && strlen(pChineseData->OtherMightChar)<2 ) )
            return 1;
    	  else return 0;
    	}

static void SetThePromptBuf(chinese_Data *pChineseData)
{    int Loop,CurRule;
     char* ConditionStr =pChineseData->ConditionStr;
     unsigned short* ConditionHz=pChineseData->ConditionHz;

     pChineseData->SatisfyNum = 0;
     Loop=strlen(ConditionStr)-1;
     memset(pChineseData->PromptBuf,0,sizeof(pChineseData->PromptBuf));

     if(wordstrlen(ConditionHz))
     	SearchSomeAssociateHanZi(pChineseData);
     else if(ConditionStr[0]=='*')		CurRule = FindBiShun(ConditionStr);
          else 
           {	CurRule = 10;
     	      for(;Loop;Loop--)
        	     if(ConditionStr[Loop]>'z' || ConditionStr[Loop]<'a')
        	     {   CurRule = FindBiShun(ConditionStr);
            	        break;
        	      }
   	        }
   	 
          if(CurRule == 10)                 // PinYin
              {  PinYinProgramCode(pChineseData);
                 SearchSomeHanZi_ByPinYin(pChineseData);
              }
          else if(CurRule == 1)              // BiShun
          {  ChangCharToBs(pChineseData->ConditionStr);
             BiShunProgramCode(pChineseData);
             SearchSomeHanZi_ByBiShun(pChineseData);
          }
          else if( ConditionStr[5] == ':' )   // BiaoDian
     	     SearchSomeHanZi_ByBiaoDian(pChineseData);
     
       /*   if(PromptBuf[0]==0)	Input_one_key(KCD_RIGHT); */// ûҵ֣ɾǰַ
} 
#endif
static void SelectHanZi(int KeyCode)
{   T_MFW_HND       win        = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data   = ((T_MFW_HDR *)win)->data;
    T_HZ_INFO * hzdata       = (T_HZ_INFO *)win_data->user;
    T_MFW_HND  parent_win   =hzdata->parent;
    T_MFW_WIN     *parentwin_data =((T_MFW_HDR *)parent_win)->data;
    T_EDITOR_INFO  *parentdata   =(T_EDITOR_INFO *)parentwin_data->user;
    char* ConditionStr=hzdata->chineseData.ConditionStr;
    unsigned short* ConditionHz=hzdata->chineseData.ConditionHz;
    char msg[100];     
    
    static unsigned short code;//codeB[3];
	hzdata->StartNextTime=0;
	if( (hzdata->chineseData.SatisfyNum >= KeyCode && KeyCode>0)||(hzdata->chineseData.SatisfyNum>=10&&KeyCode==0))
    {          	
        if(ConditionStr[5] != ':' )
        	{  if(KeyCode==0)
        	     code=hzdata->chineseData.PromptBuf[10*2-1];
               else  code=hzdata->chineseData.PromptBuf[KeyCode*2-1];
        	}
        else {
        	   if(hzdata->chineseData.PageNum==0)
        	     { if(KeyCode==0)
        	         code=hzdata->chineseData.PromptBuf[24];
        	       else if(KeyCode<=3)
        	         code=hzdata->chineseData.PromptBuf[KeyCode*2-1];
                   else if(KeyCode>=4&&KeyCode<=5)
              	     code=hzdata->chineseData.PromptBuf[8+(KeyCode-4)*2];
                   else code=hzdata->chineseData.PromptBuf[12+(KeyCode-6)*3];
        	      }
        	   else if(KeyCode==0)
        	   	   code=hzdata->chineseData.PromptBuf[28];
        	   else code=hzdata->chineseData.PromptBuf[KeyCode*3-2];
        	   /*
        else Word=PromptBuf[(CurPy-96)/16*15+CurPx/24];
        	if(KeyCode<=7)
        		code=PromptBuf[KeyCode];
        	else code=PromptBuf[8+(KeyCode-7)*2-1+(KeyCode-1)/7];
        	*/
        	} 
        	
		//codeB[1]=PromptBuf[KeyCode*5-4];
		//codeB[1]=0;
    
        memset(ConditionStr,0,sizeof(ConditionStr));
		hzdata->CurPx=hzdata->InitPx;
        hzdata->CurPy=hzdata->InitPy;
        
        hzdata->chineseData.PageNum = 0;
        //LineNum=1;
        hzdata->chineseData.SatisfyNum = 0;
        
     //   edtHide(parentdata->edt_edt); 
     //   sprintf(msg,"selectsymbol:0x%x",code);
     //   TRACE_EVENT(msg);
        edtSymbol(parentdata->edt_edt,(int)code);//codeB[0]);   
        //edtSymbol(parentdata->edt_edt,ecRight);
    //    edtUnhide(parentdata->edt_edt); 
      //  bmpflag=0;
        if(wstrlen(parentdata->editor_data.editor_attr.text)>=(parentdata->editor_data.editor_attr.size-3))
        {	memset(ConditionStr,0,10);//sizeof(ConditionStr));
            memset(ConditionHz,0,sizeof(ConditionHz));
            hz_destroy(hzdata->hz_win);
            return;
        	}
        
        if (wordstrlen(ConditionHz)==0&&code>=0x4e00){
           ConditionHz[0]=code;
           ConditionHz[1]='\0';
           hzdata->CurPx=hzdata->InitPx;
           hzdata->CurPy=hzdata->InitPy;
        	}
        else hz_destroy(hzdata->hz_win);
        	
        
    }
}

static int Input_one_key(T_MFW_HND win,int KeyCode)
{	//T_MFW_HND       win        = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data   = ((T_MFW_HDR *)win)->data;
    T_HZ_INFO *  data       = (T_HZ_INFO *)win_data->user;
    char* ConditionStr =(char*)data->chineseData.ConditionStr;
    unsigned short* ConditionHz=(unsigned short*)data->chineseData.ConditionHz;
    char msg[100];

    
       
    TRACE_EVENT("Input_one_key()");
    sprintf(msg,"win:%d",(int *)win);
    TRACE_EVENT(msg);
    sprintf(msg,"zxp0 string:%s",ConditionStr);
    TRACE_EVENT(msg);
    sprintf(msg,"zxp1 string:%s",(char*)data->chineseData.ConditionStr);
    TRACE_EVENT(msg);
    data->StartNextTime=1;
	timStop(data->l_intime);
	timStop(data->l_intimelong);	
    
    switch(KeyCode)
    {    case KCD_HUP:                
                hz_destroy(data->hz_win);
        		break;
		 case KCD_STAR:
		 	    data->StartNextTime=0;
		 	    if(wordstrlen(ConditionHz)&&ConditionHz[wordstrlen(ConditionHz)-1]!='#'){
                	memset(ConditionStr,0,10);//sizeof(ConditionStr));
                	memset(ConditionHz,0,sizeof(ConditionHz));
                	}
				if(wordstrlen(ConditionHz)==0&&strlen(ConditionStr)==0)
                     {   data->chineseData.InTheTime = 0;
                         strcpy(ConditionStr,"Label:");
                       //  expand2wstr(ConditionStr,"Label:");
                         data->CurPx=data->InitPx;
                         data->CurPy=data->InitPy;
                         SetThePromptBuf(&data->chineseData);
                         DispPromptBuf(data->hz_win);
                         return 1;
                     }
                else   return 0;
                break;
         case KCD_1:
         	    data->StartNextTime=0;
         	    if(wordstrlen(ConditionHz)&&ConditionHz[wordstrlen(ConditionHz)-1]!='#'){
                	memset(ConditionStr,0,sizeof(ConditionStr));
                	memset(ConditionHz,0,sizeof(ConditionHz));
                	data->CurPx=data->InitPx;
                	data->CurPy=data->InitPy;
                	}
         	    if((wordstrlen(ConditionHz)&&ConditionHz[wordstrlen(ConditionHz)-1]=='#')
                	||(strlen(ConditionStr) && ((ConditionStr[strlen(ConditionStr)-1]=='#')||ConditionStr[strlen(ConditionStr)-1]==':'))){
                	SelectHanZi(KCD_1);
                	data->chineseData.PageNum=0;
         	    	}
                else if(ConditionStr[0]=='\0')  ConditionStr[0]='*';
                else   return 0;
                break;
         case KCD_HASH:
         		data->StartNextTime=0;         	
         		if(wordstrlen(ConditionHz))
         		{   if(ConditionHz[wordstrlen(ConditionHz)-1]!='#')
         		      ConditionHz[wordstrlen(ConditionHz)]='#';
         		    else   SelectHanZi(KCD_1);
         		}
               /* else if(strlen(ConditionStr)==0)
                     {   InTheTime = 0;
                         strcpy(ConditionStr,"Label:");
                       //  expand2wstr(ConditionStr,"Label:");
                         SetThePromptBuf();
                         DispPromptBuf();
                         return 1;
                     }*/
                 else  if(strlen(ConditionStr)&&ConditionStr[strlen(ConditionStr)-1]!='#')
                    	     ConditionStr[strlen(ConditionStr)] = '#';
                       else    SelectHanZi(KCD_1);              
                	
                break;
         case KCD_MNUUP:
         	/*
         	    if(ConditionStr[5]==':')
         	    	{if(CurPy>1*16)
         	    	   CurPy=CurPy-16;
         	         else CurPy=6*16;
         	    	}
         	 */   	
                if((data->CurPy==data->InitPy&&(data->chineseData.PageNum) && ConditionStr[strlen(ConditionStr)-1]!='#')
                	  ||(data->CurPy==data->InitPy&&(data->chineseData.PageNum) &&ConditionHz[wordstrlen(ConditionHz)-1]!='#'))
                    	{
                           data->chineseData.PageNum--;
                           data->CurPx=data->InitPx;
                           data->CurPy=data->InitPy+16;
                    	}
                      else if((data->CurPy==data->InitPy+16 && ConditionStr[strlen(ConditionStr)-1]!='#')
                	        ||(data->CurPy==data->InitPy+16 &&ConditionHz[wordstrlen(ConditionHz)-1]!='#'))
                	        data->CurPy-=16; 
                	
				data->StartNextTime=0;                                   
                break;
         case KCD_MNUDOWN:
         	/*
         	    if(ConditionStr[5]==':'){
         	    	if(CurPy<6*16)
         	    		CurPy=CurPy+16;
         	    	  else CurPy=1*16;
         	    	}
         	 */
         	    if((data->CurPy==data->InitPy+16&&data->chineseData.SatisfyNum>data->chineseData.MAX_Satisfy &&strlen(ConditionStr)&&ConditionStr[strlen(ConditionStr)-1]!='#')
                	   ||(data->CurPy==data->InitPy+16&&data->chineseData.SatisfyNum>data->chineseData.MAX_Satisfy&&wordstrlen(ConditionHz)&&ConditionHz[wordstrlen(ConditionHz)-1]!='#'))
         	        	{
                        data->chineseData.PageNum++;
                          data->CurPx=data->InitPx;
                          data->CurPy=data->InitPy;
         	        	}
                      else if((data->CurPy==data->InitPy&&data->chineseData.SatisfyNum>5&&strlen(ConditionStr)&& ConditionStr[strlen(ConditionStr)-1]!='#')
                	         ||(data->CurPy==data->InitPy&&data->chineseData.SatisfyNum>5&&wordstrlen(ConditionHz)&&ConditionHz[wordstrlen(ConditionHz)-1]!='#'))
                	         data->CurPy+=16;
         	    	
				data->StartNextTime=0;                            
                break;
         case KCD_MNURIGHT:
         	/*
         	    if(ConditionStr[5]==':'){
         	    	if((CurPx<104)&&(SatisfyNum>(CurPy-16)/16*7+CurPx/16+1))
         	    	  CurPx=CurPx+16;
         	    	else if((CurPx==104)&&(SatisfyNum>(CurPy-16)/16*7+CurPx/16+1))
         	          	{ Input_one_key(KCD_MNUDOWN);
         	                CurPx=8;
         	          	}
         	    	}
         	 */
         	 if(data->chineseData.SatisfyNum>(data->CurPy-data->InitPy)/16*5+data->CurPx/24+1)
         	 	{
         	       if(data->CurPx<104)   	 	
                      data->CurPx=data->CurPx+24;
         	       else if((data->CurPx==104)&&(data->CurPy==data->InitPy))
         	       	{ data->CurPx=8;
                      data->CurPy+=16;
         	       	}
         	       else if((data->CurPx==104)&&(data->CurPy==data->InitPy+16))
         	       	{ data->CurPx=8;
         	          data->CurPy=data->InitPy;
         	       	}
         	 	}
         	 else { data->CurPx=8;
         	        data->CurPy=data->InitPy;
         	 	}
             
         	 /*
         	    if((CurPx<104)&&(SatisfyNum>(CurPy-InitPy)/16*5+CurPx/24))
                      CurPx=CurPx+24;
         	          else if((CurPx==104)&&(SatisfyNum>(CurPy-InitPy)/16*5+CurPx/24))
         	          	{ if((CurPy==InitPy+16&&SatisfyNum>MAX_Satisfy &&strlen(ConditionStr)&&ConditionStr[strlen(ConditionStr)-1]!='#')
                	         ||(CurPy==InitPy+16&&SatisfyNum>MAX_Satisfy&&wordstrlen(ConditionHz)&&ConditionHz[wordstrlen(ConditionHz)-1]!='#'))
                            LineNum++;
                          else if((CurPy==InitPy&&LineNum&&SatisfyNum>5&&strlen(ConditionStr)&& ConditionStr[strlen(ConditionStr)-1]!='#')
                	          ||(CurPy==InitPy&&LineNum &&SatisfyNum>5&&wordstrlen(ConditionHz)&&ConditionHz[wordstrlen(ConditionHz)-1]!='#'))
                	         CurPy=CurPy+16;
         	              CurPx=8;
         	          	}
         	   */
         	    	
         	    data->StartNextTime=0;
                break;
         case KCD_MNULEFT:
         	/*
         	    if(ConditionStr[5]==':'){
         	    	if(CurPx>8)
         	    	  CurPx=CurPx-16;
         	    	else{if(CurPy==16&&CurPx==8) break;
         	    	     else{Input_one_key(KCD_MNUUP);
         	    	          CurPx=104;
         	    	     	}
         	    		}
         	    	}
         	 */
         	     if(data->CurPx>=32)
                       data->CurPx=data->CurPx-24;
         	     else if(data->CurPy==data->InitPy&&data->CurPx==8)
         	         {          	          
         	          if((data->chineseData.SatisfyNum%5==0)||(data->chineseData.SatisfyNum>=data->chineseData.MAX_Satisfy))
         	          	 data->CurPx=104;
         	          else data->CurPx=data->chineseData.SatisfyNum%5*24-16;
         	          if(data->chineseData.SatisfyNum>=data->chineseData.MAX_Satisfy)
         	          	 data->CurPy=16+data->InitPy;
         	          else data->CurPy=data->chineseData.SatisfyNum/5*16+data->InitPy;
         	          }
         	     else if(data->CurPy==data->InitPy+16&&data->CurPx==8)
         	     	{ data->CurPx=104;
         	          data->CurPy=data->InitPy;
         	     	}
         	          	    
         	    data->StartNextTime=0;
                break;
         case KCD_RIGHT:
         	    if(wordstrlen(ConditionHz))
                {	  ConditionHz[wordstrlen(ConditionHz)-1]='\0';
         	          memset(ConditionStr,0,sizeof(ConditionStr));
         	    	}
                else if( strlen(ConditionStr))
                     {  memset(ConditionHz,0,sizeof(ConditionHz));
                        if(ConditionStr[strlen(ConditionStr)-1]==':')
                                memset(ConditionStr,0,sizeof(ConditionStr));
                        else ConditionStr[strlen(ConditionStr)-1] ='\0';
                     }
                
                data->chineseData.CurCode = -1;
                data->CurPx=data->InitPx;
                data->CurPy=data->InitPy;
                
                //PageNum = 0;
                data->chineseData.PageNum =0;
                data->chineseData.SatisfyNum = 0;
				data->StartNextTime=0;
				
                if(ConditionHz[0]=='\0'&&ConditionStr[0]=='\0')
                
        			hz_destroy(data->hz_win);
                
                break;
         case KCD_LEFT:
         case KCD_OK:
         	    data->StartNextTime=0;
         	    /*
         	    if(ConditionStr[5]==':')
         	    	SelectHanZi((CurPy-96)/16*5+CurPx/24+1);
         	    */
         	     if(strlen(ConditionStr)||wordstrlen(ConditionHz))
         	    	  {
         	            if(data->CurPx==104&&data->CurPy==data->InitPy+16)
         	    	       SelectHanZi(KCD_0);
         	            else SelectHanZi((data->CurPy-data->InitPy)/16*5+data->CurPx/24+1);
         	          
         	    	  }
         	    	 
         	    break;
                
         case KCD_2:
         case KCD_3:
         case KCD_4:
         case KCD_5:
         case KCD_6:
         case KCD_7:
         case KCD_8:
         case KCD_9:
         case KCD_0:
                if(wordstrlen(ConditionHz)&&ConditionHz[wordstrlen(ConditionHz)-1]!='#'){
                	memset(ConditionStr,0,10);//sizeof(ConditionStr));
                	memset(ConditionHz,0,sizeof(ConditionHz));
                	data->CurPx=data->InitPx;
                	data->CurPy=data->InitPy;
                	}
                if((wordstrlen(ConditionHz)&&ConditionHz[wordstrlen(ConditionHz)-1]=='#')
                	||(strlen(ConditionStr) && (ConditionStr[strlen(ConditionStr)-1]=='#'||ConditionStr[strlen(ConditionStr)-1]==':')))                 
                {   
                   // if(KeyCode)
                        SelectHanZi(KeyCode);
                }
                else SetTheConditionStr(&data->chineseData, KeyCode);
                #if 0
                else if(strlen(ConditionStr)==0 && KeyCode)
                {   data->chineseData.Index = 0;
                    data->chineseData.CurCode = KeyCode;
                    ConditionStr[0]=InputMethodFirstChar[data->chineseData.CurCode-2][data->chineseData.Index];
                }
                else if(strlen(ConditionStr)==1 && (data->chineseData.InTheTime) && data->chineseData.CurCode==KeyCode && KeyCode)
                {   data->chineseData.Index = (data->chineseData.Index + 1) % strlen(InputMethodFirstChar[data->chineseData.CurCode-2]);
                    ConditionStr[0]=InputMethodFirstChar[data->chineseData.CurCode-2][data->chineseData.Index];
                }
                else if((strlen(ConditionStr) || KeyCode) && (strlen(ConditionStr)<6))
                {   if( data->chineseData.CurCode!=KeyCode || !(data->chineseData.InTheTime) ) data->chineseData.Index=0;  // Next KCD,then New the Index;
                    else ConditionStr[strlen(ConditionStr)-1]= 0;  // in the same KCD loop,Del The Last Key;
                    data->chineseData.CurCode = KeyCode;

                    SetOtherMightChar(&data->chineseData,KeyCode);
                    if(strlen(data->chineseData.OtherMightChar))
                    {   ConditionStr[strlen(ConditionStr)]= data->chineseData.OtherMightChar[data->chineseData.Index];
                        data->chineseData.Index = (data->chineseData.Index + 1) % strlen(data->chineseData.OtherMightChar);
                    }
                    else ConditionStr[strlen(ConditionStr)]= (char)(0x30 + KeyCode);
                
                }
                #endif

			/*	if(strlen(ConditionStr)==0 && KeyCode==KCD_0)
				{	StartNextTime=0;
    	    		winHide(data->hz_win);
        			winFocus(data->l_oldFocus);
                    return 0;
				}*/
				if(strlen(ConditionStr)){
                data->CurPx=data->InitPx;
                data->CurPy=data->InitPy;
					}
                //PageNum = 0;
                data->chineseData.PageNum=0;
                if(strlen(ConditionStr)>7)  ConditionStr[strlen(ConditionStr)-1] = 0;
                
                break;
         default:
                break;
    } 
   
    data->chineseData.InTheTime = data->StartNextTime;
    if( KeyCode==KCD_RIGHT || /*KeyCode==KCD_CURSORDISP ||*/KeyCode==KCD_MNULEFT||KeyCode==KCD_MNURIGHT||
        KeyCode==KCD_MNUDOWN || KeyCode==KCD_MNUUP || KeyCode==KCD_STAR)    	    data->chineseData.InTheTime = 0;
  /*  else if(strlen(ConditionStr)==1 && strlen(InputMethodFirstChar[data->chineseData.CurCode-2])<2 ) data->chineseData.InTheTime = 0;
         else if( strlen(ConditionStr) >1 && strlen(data->chineseData.OtherMightChar)<2 ) 	        data->chineseData.InTheTime = 0;*/
    else if(OtherCharIsOnlyOne(&data->chineseData))  data->chineseData.InTheTime = 0;
         
    if((data->chineseData.InTheTime) && strlen(ConditionStr))	
    {	if(strlen(ConditionStr)==1) timStart(data->l_intime);
    	else if( strlen(ConditionStr)==2 && (KeyCode==KCD_4||KeyCode==KCD_8)) timStart(data->l_intime);
    		 else timStart(data->l_intimelong);
    }
    
    if((wordstrlen(ConditionHz)&&ConditionHz[wordstrlen(ConditionHz)-1]!='#'&&KeyCode!=KCD_CURSORDISP&&KeyCode!=KCD_MNULEFT&&KeyCode!=KCD_MNURIGHT)
    	||(strlen(ConditionStr) && ConditionStr[strlen(ConditionStr)-1]!='#' && KeyCode!=KCD_CURSORDISP&&KeyCode!=KCD_MNULEFT&&KeyCode!=KCD_MNURIGHT))
    	{
    	TRACE_EVENT("setthebuf");
        SetThePromptBuf(&data->chineseData);
        if(data->chineseData.PromptBuf[0]==0)  Input_one_key(win,KCD_RIGHT);
        	
        	
    	}
    sprintf(msg,"zxp2 string:%s",ConditionStr);
    TRACE_EVENT(msg);
    if(strlen(ConditionStr)||wordstrlen(ConditionHz))	DispPromptBuf(data->hz_win);

    return 1;
} 


////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
static int TimerEH(MfwEvt e, MfwTim *tc) 
{  
    //TRACE_EVENT("TimerEH");
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_HZ_INFO * data       = (T_HZ_INFO *)win_data->user;

    TRACE_EVENT("TimerEH");

    if( tc == ((MfwTim*)mfwControl(data->l_intime)) ) 
    {
    	data->chineseData.InTheTime = 0;
    //	dsplflag=0;
    	if(winIsFocussed(win))
    	   DispPromptBuf(data->hz_win);
    }

    if( tc == ((MfwTim*)mfwControl(data->l_intimelong)) ) 
    {
    	data->chineseData.InTheTime = 0;
    //	dsplflag=0;
    	if(winIsFocussed(win))
    	   DispPromptBuf(data->hz_win);
    }

    return 1;
}

/*******************************************************************************

 $Function:    hzEventWin 

 $Description: window event handler.

 $Returns:    MFW_EVENT_CONSUMED.

 $Arguments:  None.

*******************************************************************************/
static int hzEventWin (MfwEvt e, MfwWin *w) 
{   
    T_HZ_INFO  * data      = (T_HZ_INFO *)w->user;    
    T_MFW_HND       parent_win = data->parent;
    U8 mode;
    TRACE_EVENT("hzEventWin");

    mode=dspl_Enable(0);
    switch (e)
	{   case MfwWinVisible: 
	         if(wstrlen(data->chineseData.PromptBuf))
	         	{
	         	 SEND_EVENT(parent_win, E_EDITOR_UPDATE, 1, 0);
	         	 flagForNewWin=1;
	         	 dspl_Clear(0, 82, 120, 131 );
	         	 DispPromptBuf(data->hz_win);
	         	 flagForNewWin=0;
	         	}
	          
             break;
        default:           
        	break;
    } 
    dspl_Enable(mode);
    return MFW_EVENT_CONSUMED;
} 

/*******************************************************************************

 $Function:     hzEventKbd

 $Description:  keyboard event handler

 $Returns:    MFW_EVENT_CONSUMED.

 $Arguments:  None.

*******************************************************************************/
static int hzEventKbd (MfwEvt e, MfwKbd *kc) 
{    
   //  TRACE_EVENT("hzEventKbd");
     T_MFW_HND       win        = mfw_parent (mfw_header());
    // MfwEvt     fKeyPressed = e & KEY_MAKE  ;
     
	 if (e & KEY_MAKE)  
	   Input_one_key(win, (int)kc->code );
	
	 return MFW_EVENT_CONSUMED;
}
/*
void hzInit (void) 
{   U32 events;
  
    fontH=12;   
    l_wa.win.px = (U16)(0);
    l_wa.win.py = (U16)(0);
    l_wa.win.sx = (U16)(SCREENWIDTH);
    l_wa.win.sy = (U16)(SCREENHEIGHT);

    events =  KEY_RIGHT | KEY_MNUUP | KEY_STAR|           // ZhaoGang  00-06-30
              KEY_MNUDOWN | KEY_HASH| KEY_HUP|            // KEY_HUP:EXIT, KEY_RIGHT:CLEAR
              KEY_0 |KEY_1 | KEY_2  | KEY_3 | KEY_4 |
              KEY_5 | KEY_6 | KEY_7 | KEY_8 | KEY_9;

    memset(ConditionStr,0,sizeof(ConditionStr));
    hzWin = winCreate( 0, &l_wa, MfwWinVisible, (MfwCb) hzEventWin);
    hzKbd = kbdCreate(hzWin, events, (MfwCb) hzEventKbd);
    l_intimelong = timCreate(0, TIM_TAKE_OVERLONG, (MfwCb)TimerEH);
    l_intime = timCreate(0, TIM_TAKE_OVER, (MfwCb)TimerEH);
    
 } 
 
void hzExit (void) 
{
    kbdDelete(hzKbd);
    winDelete(hzWin);
    timDelete(l_intime);
    timDelete(l_intimelong);
} 

void hzEntry(char  keyCode, MfwHnd e)  
{    
    if(keyCode==KCD_VOLUP || keyCode==KCD_VOLDOWN)
        return; //do not focus this window when get these keys xh 2k/08/30
  //  p_idx    = Index;
    PageNum  = 0;
    memset(ConditionStr,0,sizeof(ConditionStr));
    memset(ConditionHz,0,sizeof(ConditionHz));
    
    l_oldFocus = winFocus(hzWin);
    Input_one_key((int)keyCode);
} 
*/
