


#include "MmiEditor.h"
#include "mmihzapi.h"

#ifndef _DEF_BMI_HZ_H_
#define _DEF_BMI_HZ_H_


typedef enum
{
    HZINIT,
    HZEXIT
}T_hz_event;



typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent;
    T_MFW_HND       hz_win;
    T_MFW_HND       hz_kbd;
    T_MFW_HND       l_intime;// Shorttimer to switch
    T_MFW_HND       l_intimelong;// longtimer to switch 
    chinese_Data      chineseData;
    int               StartNextTime;
    int               InitPx;
    int               InitPy;
    int               CurPx;//cursor position
    int               CurPy;
    int               memoryPx;
    int               memoryPy;
    unsigned short     memoryBuf[40];
    
   
}T_HZ_INFO;

extern T_MFW_HND hz_start(T_MFW_HND parent,T_MFW_KBD *kc);  
extern void hz_destroy(T_MFW_HND window);                                     

#endif

