/*************************************************
$FILE:mmiicnOther.h
$Description:icon
$remark: Don't modify this file
***************************************************/
#ifndef _MMIICNOTHER_H
#define _MMIICNOTHER_H

#define animGoodbye 10
#define animwelcome 14
#define screenparts 5
#define animcall 8//zy Mobile Innovation 08/01/02 call animation bitmap's number
#define animCF 5 //WUFEI APPEND, zhouyue 2002-12-23 change 8 from 5
#define volumebmp 6 //xsf add 2002.08.27 adjust melody volume bmp's num
#define ThemeNums 5

typedef enum							/* AVAILABLE ICONS IDLE MODE*/
{
    iconIdSMS = 0,						/* icon New SMS message     */
    iconIdVoice,                        /* icon New Voice mail      */
    iconIdCallFor,                      /* icon Call forward uncond */
    iconIdSilRin,                       /* icon silent ringer       */
    iconIdKeyplock,                     /* icon Keypad locked       */
    iconIdCipheringActiv,               /* icon Ciphering           */        
    iconIdCipheringDeActiv,             /* icon Ciphering           */            
	iconIdRinger,                       /* icon ringer              */
	iconIdVibrator,                     /* icon vibrator            */
	iconIdRingVibr,                     /* icon ringer + vibrator   */
	iconIdAlarm,                        /* icon alarm on            */
    iconSIMTool,                        /* icon SIM Toolkit         */
    iconMessages,                       /* icon Messages            */
    iconOrganiser,                      /* icon Organiser           */
    iconSounds,                         /* icon Sounds              */
    iconSettings,                       /* icon Settings            */
    iconServices2,                      /* icon Services line2 16   */
    iconServices1,                      /* icon Services line1 17   */
    iconRoam,							/* icon Roam                */
    iconWAP,							/* icon WAP					*/
    iconIdGPRSOn,						/* icon GPRS ON  (sbh 18/01/02) */
    iconIdHomezone,						/* icon Homezone  (SH 29/11/01)  old is iconGPRSAttached*/
    iconIdGPRSAttached,					/* icon GPRS Attached (sbh 18/01/02) */
    iconIdTimer,
	iconIdMissedCall,						/* icon Missed Call Sunny add at 2004/03/11 */
    idlIdMax                            /* number of icons          */
} IconId;

typedef enum                            /* AVAILABLE ICONS INPUT MODE*/
{
    iconAMBLOW = 0,                     /* icon ambigous mode low   */
    iconAMBUPP,                         /* icon ambigous mode upper */
    iconAMBNUM,                         /* icon ambigous mode numeric */
    iconMTLOW,                          /* icon multitap mode low   */
    iconMTUPP,                          /* icon multitap mode upper */
    iconMTNUM,                          /* icon multitap mode numeric */
    inputIdMax                          /* number of icons          */
} IconInputId;

typedef enum                            /* AVAILABLE ICONS BATTERY  */
{
	iconBattery4 = 0,                   /* icon Battery 0-4%        */
	iconBattery14,                      /* icon Battery 5-14%       */
	iconBattery24,                      /* icon Battery 15-24%      */
	iconBattery49,                      /* icon Battery 25-49%      */
	iconBattery100,                     /* icon Battery 50-100%     */
	iconBattMax                         /* number of batterie icon  */
}IconBattId;

typedef enum                            /* AVAILABLE ICONS SIGNAL */
{
	iconSigStat49 = 0,                  /* icon Signal 0-49         */
	iconSigStat99,                      /* icon Signal 50-99        */
	iconSigStat149,                     /* icon Signal 100-149      */
	iconSigStat199,                     /* icon Signal 150-199      */
	iconSigStat255,                     /* icon Signal 200-255      */
	iconSigStat300,                    //xsf add for value 5 12.05	/* 2004/03/11 sunsj remove */
	iconSignalMax                       /* number of signal icon    */
}IconSignId;


/*************************************************

$Description:	ʱزͼƬ

***************************************************/


#ifndef MMIICNTD_H
#define MMIICNTD_H

/* ʱӱͼ 128*68 */
extern	const unsigned char gImage_world_bmp[];

/* ʱҼͷ 4*8 */
extern	const unsigned char left_key[];
extern	const unsigned char right_key[];

/* ճ̱ */
// еʾͼƬ 128*16
extern const unsigned char gImage_week[];

// ũͼƬ128*17
extern const unsigned char gImage_nl[];

// ⱳͼƬ 128*18
extern const unsigned char gImage_pic[]; 

// ճ̽ͼƬ 17*4
extern const unsigned char gImage_focus[]; 

/* ring select pictures */
// first frame of ring select 52*63
extern const unsigned char gImage_ring1[];

// second frame of ring select 22*26
extern const unsigned char gImage_ring2l[];

// second frame of ring select 23*31
extern const unsigned char gImage_ring2r[];


#endif
/***********¼******************************/
extern const unsigned char iconVoicePlay[];//(46, 55, 27, 30);
extern const unsigned char iconRecord[];//(46, 59, 28, 20);

/**************************************ʱ********************************/
extern const MfwIcnAttr batt_Attr [];
extern const MfwIcnAttr battMask_Attr [];

/**************************************ػʱͼƬ********************************/
extern const MfwIcnAttr Bigbatt_Attr [] ;
extern const MfwIcnAttr Bigbatt_Attr_mask [] ; //2004-04-13 Sunny add

extern const unsigned char newSMS[];

extern MfwIcnAttr colist;
//#define COLIST_HASMASK
#ifdef COLIST_HASMASK
extern const MfwIcnAttr colistMask;
#endif
extern const MfwIcnAttr situation4Icon[];

/*******************************************************************************
                                                                              
                                Externally declared data elements
                                                                              
*******************************************************************************/

extern const MfwIcnAttr idl_AttrMask[ idlIdMax ];
extern const MfwIcnAttr idl_Attr[ idlIdMax ];
//2004/03/11 Sunny add
extern const MfwIcnAttr idl_AttrMask_Outer[ idlIdMax ];
extern const MfwIcnAttr idl_Attr_Outer[ idlIdMax ];

extern		 MfwIcnAttr scene_Attr_Outer[5];
extern       MfwIcnAttr sceneMask_Attr_Outer[5];
//2004/03/11 Sunny add end
extern MfwIcnAttr  cb_chanel_icon[]; //2004-04-20 Sunny add
extern const MfwIcnAttr batt_Attr[];
/*2003/11/13,talcon add */
extern const MfwIcnAttr battMask_Attr[];
extern const MfwIcnAttr Bigbatt_Attr[ iconBattMax ];

extern const MfwIcnAttr sign_Attr[ iconSignalMax ];
extern const MfwIcnAttr signMask_Attr [iconSignalMax];

/* 2004/05/21 yhf add for outeridle */
extern const MfwIcnAttr outersign_Attr[ iconSignalMax ];
extern const MfwIcnAttr outersignMask_Attr [iconSignalMax];
/*end yhf add*/

extern  MfwIcnAttr mainIconSimToolkit;
extern  MfwIcnAttr mainIconCalculator;
extern  MfwIcnAttr mainIconSettings;
extern  MfwIcnAttr mainIconRecentCalls;
extern  MfwIcnAttr mainIconCallDivert;
extern  MfwIcnAttr mainIconSecurity;
extern  MfwIcnAttr mainIconMessages;
extern  MfwIcnAttr mainIconPhonebook;
extern  MfwIcnAttr mainIconWAP;
extern  MfwIcnAttr IconTexteZiText;
extern  MfwIcnAttr IconTexteZiTextSmall;
extern const MfwIcnAttr menuup[ThemeNums];
//extern const  MfwIcnAttr menumid[ThemeNums];
extern const  MfwIcnAttr menumid[ThemeNums];//yhf add  2004/05/14
extern const  MfwIcnAttr menudown[ThemeNums];
extern const MfwIcnAttr menuup_little[ThemeNums ];  //xsf add for display index of menu 12.26


/**********begin zy add for menutitleicon***********************/
/* talcon : modify */
//extern const MfwIcnAttr titleicons[9][2];
extern const MfwIcnAttr titleicons[ ];

/**********end of zy titleicon*********************************/
/*..........zy add for setting menu 04/08/02..........................*/
/*..........end of zy add for setting menu 04/08/02..........................*/


extern  MfwIcnAttr CallIconBk;
extern  MfwIcnAttr UserBusy;
extern  MfwIcnAttr NetNotAvail;
extern  MfwIcnAttr NetBusy;
/*................................zy add for confirm active dialog...........................................*/
extern  MfwIcnAttr Confirm;
extern MfwIcnAttr situationIcon;
extern MfwIcnAttr situation3Icon;  //xsf add 2002.08.16 for list icons
extern MfwIcnAttr simbookicon;
extern MfwIcnAttr nvmbookicon;
extern MfwIcnAttr situationTrueIcon; //xsf add 2002.09.06 for melody list icons
extern MfwIcnAttr situation3IconMask;
/* 2004/05/18 sunsj remove */
//extern MfwIcnAttr situationIconMask;
extern MfwIcnAttr textlistIcon;//added  by windy 0905
extern MfwIcnAttr newsmslist;//added  by windy 1228
extern MfwIcnAttr mtlist;//added  by windy 1228
extern MfwIcnAttr molist;//added  by windy1228
extern MfwIcnAttr unmolist;//added  by windy 1228

extern const unsigned char Mtsmstime[];//added by windy 0127
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
extern const unsigned char newQQ[];//added by hxl 0807
extern const unsigned char newQQmask[];//added by hxl 0807
extern MfwIcnAttr QQlist;//added  by windy 0905
extern MfwIcnAttr QQlistmask;//added  by windy 0905
#endif
/*...................................end of zy for confirm active dialog....................................*/
//gb icons for game(four in a row)
extern const unsigned char white_stone[];
extern const unsigned char black_stone[];
extern const unsigned char game_name[];
extern const unsigned char game_cursor[];
extern const unsigned char game_field[];
extern const unsigned char player_win[];
extern const unsigned char player_lost[];
extern const unsigned char board_full[];
extern const unsigned char iconConnect[];

//gb icons for melodygenerator
extern MfwIcnAttr melodygenerator_Attr[ screenparts];
//active frame
extern const unsigned char akt_frame[];
//begin of noteline
extern const unsigned char noteline_begin[];
//notelines
extern const unsigned char noteline_background[];
//end of noteline
extern const unsigned char noteline_end[];
//all the possible musical notes
//all notes with flag up
extern const unsigned char n1[];
extern const unsigned char n1_16[];
extern const unsigned char n1_32[];
extern const unsigned char n1_8[];
extern const unsigned char n1_f[];
extern const unsigned char n1_h[];
//all notes with flag down
extern const unsigned char n5[];
extern const unsigned char n5_16[];
extern const unsigned char n5_32[];
extern const unsigned char n5_8[];
extern const unsigned char n5_h[];
//all musical pauses
extern const unsigned char n4_b[];
extern const unsigned char n8_b[];
extern const unsigned char n16_b[];
extern const unsigned char n32_b[];
extern const unsigned char nf_b[];
extern const unsigned char nh_b[];
//musical sign
extern const unsigned char n_point[];
extern const unsigned char n_hash[];
extern unsigned char screenpart0[];
extern unsigned char screenpart1[];
extern unsigned char screenpart2[];
extern unsigned char screenpart3[];
extern unsigned char screenpart4[];

//start of xsf add 2002.08.13 for scene mode list icons
extern MfwIcnAttr normalIcon;
extern MfwIcnAttr incarIcon;
extern MfwIcnAttr outIcon;
extern MfwIcnAttr meetingIcon;
extern MfwIcnAttr muteIcon;
//end of xsf add 2002.08.13 for scene mode list icons
/*2004/05/18 yhf modify
/***************************calculator icons*******************************************************/
extern const MfwIcnAttr icnCalcOptOffAttr[];
extern const unsigned int nCalcOptOffAttr;
/***********************end calculator icons*******************************************************/
/* end yhf */
//gdy for calculator
//extern const unsigned char calculatorbmp[];//2004/05/18 yhf remove
//gdy for stopwatch
extern const unsigned char sepa[];
extern const unsigned char sepa_mask[];
extern MfwIcnAttr  sepa_bmp;
extern const unsigned char circle[];
extern const unsigned char circle_mask[];
extern MfwIcnAttr  circle_bmp;
extern const unsigned char downtriangle[];
extern const unsigned char uptriangle[];
extern const unsigned char Hash[];
extern MfwIcnAttr Goodbyeanim[3];
//xzy add for grouping
extern MfwIcnAttr BookGroupingIcon[16];
//end of xzy add 2002.10.23

//hu binhao add for recent calls 
extern MfwIcnAttr Dcallsicon ;
extern MfwIcnAttr M_Read_callsicon ;
extern MfwIcnAttr M_NotRead_callsicon ;
extern MfwIcnAttr Rcallsicon ;
extern MfwIcnAttr Jcallsicon ;
extern MfwIcnAttr Unumbersicon; //hu binhao 2002-12-30 for 5221

//hu binhao add end 2002-12-2
extern MfwIcnAttr scene_Attr[5];
extern const char uparrow[];  //xsf add 2003.04.11
extern const char downarrow[];
//2004-03-31 Sunny add
extern MfwIcnAttr network_search_icon[];
//2004-03-31 Sunny add end

/*2003/10/17.talcon,add bmp of menu scroll bar*/
//extern const unsigned char iconScrollBar[];
//extern const unsigned char iconScrollBlock[];

/*2003/10.20,talcon,ܲ˵-->Ϣ*/

/***********************˵****************/
extern    const MfwIcnAttr mnulistbkgicons[];
extern	const unsigned char icnTitleSM[] ;
/************************************************/

/*2003/11/05,talcon add */
extern const MfwIcnAttr situation4Icon[];
/*end talcon add */
/*2003/11/08,talcon add */
extern const MfwIcnAttr situation5Icon[];
/*end talcon add */
/*2003/12/03,talcon add*/
extern const MfwIcnAttr sceneBarAttr[];
extern MfwIcnAttr sceneMask_Attr[5];

/* 2004/01/12 sunsj add */
extern const char nameicon[];
extern const char namefficon[];
extern const char mobileicon[];
extern const char mobilefficon[];
extern const char officeicon[];
extern const char officefficon[];
extern const char memoicon[];
extern const char memofficon[];

extern const unsigned char TimerBit[] ;
extern const unsigned char TimerBitMask[];

/* 2004/05/18 sunsj remove */
//extern const MfwIcnAttr volume_Attr [volumebmp];	
//extern const unsigned char currentbar[];

// 2004.3.16 WYJ add for record
extern const MfwIcnAttr recordIcons[];

/* 2004/05/18 sunsj modify s */
/* ************************************************
ͼ꣬
ͼСΪ58*57
************************************************ */
extern const unsigned char volume_icon[];

/* ************************************************
ڽͼƬ
ͼƬСΪ99*12
************************************************ */
extern const unsigned char volume_process[];

/* ************************************************
ڽͼƬ
ͼƬСΪ13*13
************************************************ */
extern const unsigned char volume_play[];
/* ring select pictures */
// first frame of ring select 52*63
extern const unsigned char gImage_ring1[];

// second frame of ring select 22*26
extern const unsigned char gImage_ring2l[];

// second frame of ring select 23*31
extern const unsigned char gImage_ring2r[];
/* 2004/05/18 sunsj modify e */

/* 2004/06/01 sunsj add */
extern const unsigned char call_scratchpad_bgicon[];

#endif