/*******************************************************************************

$Project name:	Basic MMI                                                      
$Project code:	BMI                                                      
$Module:		Mmiiconresource
$File:		    Mmiiconresource.h
$Revision:		1.0                                                       
				
$Author:		sunsj
$Date:		    2004/06/10
				
********************************************************************************
				
Description:Manage picture resource.
			
********************************************************************************
			
$History: 
    1.1 Create object
		  
$End
		  
*******************************************************************************/
#ifndef _MMI_MMIICONRESOURCE_H_
#define _MMI_MMIICONRESOURCE_H_
/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
//#include <stdio.h>
//#include <string.h>

#include "mfw_mfw.h"
#include "mfw_icn.h"

/************************************************************************/
/* iconidĶ                                                         */
/************************************************************************/
typedef enum
{
	ICON_BASE,

	ICON_TEXTINPUT_PINYIN,
	ICON_TEXTINPUT_BIHUA,
	ICON_TEXTINPUT_ABC,
	ICON_TEXTINPUT_abc,
	ICON_TEXTINPUT_SHUZI,
#if (MAIN_LCD_SIZE==3)
	ICON_TEXTINPUT_EDITBAR,
	ICON_IDLEDYNAMICWALLPAPER_ONE,
#elif ( MAIN_LCD_SIZE==4 )
	ICON_IDLEDYNAMICWALLPAPER_ONE,
	ICON_IDLEDYNAMICWALLPAPER_TWO,
#endif
#if(MAIN_LCD_SIZE==3)
	ICON_IDLESTATICWALLPAPER, 
#elif ( MAIN_LCD_SIZE==4 )
	ICON_IDLESTATICWALLPAPER_1,
	ICON_IDLESTATICWALLPAPER_2,
	ICON_IDLESTATICWALLPAPER_3,
	ICON_IDLESTATICWALLPAPER_4,
	ICON_IDLESTATICWALLPAPER_5,
	ICON_IDLESTATICWALLPAPER_6,
#endif
	ICON_MAINMENU_1, 
	ICON_MAINMENU_2, 
	ICON_MAINMENU_3, 
	ICON_MAINMENU_4, 
	ICON_MAINMENU_5,
	ICON_MAINMENU_6,
	ICON_MAINMENU_7,
	ICON_MAINMENU_8,
#if (MAIN_LCD_SIZE==3)
	ICON_MAINMENU_9,
#endif
    ICON_MENUTITLE,

    ICON_LISTCOMMON,
#ifdef COLIST_HASMASK
	ICON_LISTCOMMON_MASK,
#endif
	
	ICON_IDLEBATTERY,
	ICON_IDLEBATTERY_MASK,
	ICON_OUTIDLEBATTERY,
	ICON_OUTIDLEBATTERY_MASK,
	ICON_OFFCHARGING,

#if (MAIN_LCD_SIZE==3)
    ICON_OFFBATTERYBKG,
#endif

	ICON_SMSCOMMON_LIST,
	ICON_SMSNEW_LIST,
	ICON_SMSMT_LIST,
	ICON_SMSMO_LIST,
	ICON_SMSUNMO_LIST,
	ICON_SMSMTTIME,

	ICON_SMSSENDING,
	ICON_SMSSENDSUCCESS,

	ICON_IDLESTATE,
	ICON_IDLESTATE_MASK,
	ICON_OUTERIDLESTATE,
	ICON_OUTERIDLESTATE_MASK,
	ICON_OUTERNUMBER,
	ICON_OUTERBKG,

	ICON_IDLESIGNAL,
    ICON_IDLESIGNAL_MASK, 

	ICON_OUTERSIGNAL,
    ICON_OUTERSIGNAL_MASK,
	
    ICON_SITUATION,
	ICON_SITUATION3,
	ICON_SITUATION4,
	ICON_SITUATION5,
#if ( MAIN_LCD_SIZE==4 )
	ICON_SITUATION5_MASK,
#endif
	ICON_CB_CHANEL,

	ICON_SCENE, 
	ICON_SCENE_MASK,
	ICON_SCENEOUTER,
	ICON_SCENEOUTER_MASK,
#if ( MAIN_LCD_SIZE==4 )
	ICON_VOLUME_BK,
	ICON_VOLUME_BAR,
	ICON_VOLUME_RATE,
	ICON_RING_IMAGE,
    ICON_CALCULATE_ON,
	ICON_CALCULATE_OFF,
#endif
#if (MAIN_LCD_SIZE==3)//jhxu720
	ICON_VOLUME_ADJUST,
	ICON_VOLUME_BKG,
	ICON_VOLUME, 
	ICON_MUSIC_PLAY,
	ICON_CALCULATOR,
#endif
	ICON_STOPWATCH_SEPA,
	ICON_STOPWATCH_CIRCLE,
	ICON_ALARM_ANIM,
	ICON_TIMEZONE_WORLDMAP,//ʱӱ
    ICON_TIMEARROW_KEY,
#if (MAIN_LCD_SIZE==3)
    ICON_TIMEARROW_KEY_MASK,
	ICON_TIMEZONE_BMP,
	ICON_CALENDARBKG,
	ICON_IMAGEFOCUS,
	ICON_CALENDARICON,

#elif ( MAIN_LCD_SIZE==4 )
	ICON_SCHEDULE_WEEK,
	ICON_SCHEDULE_NL,
	ICON_SCHEDULE_PIC,
	ICON_SCHEDULE_FOCUS,
#endif	
	ICON_SIMBOOK,
	ICON_NVMBOOK,
	ICON_PHONEBOOK_GROUP,
	ICON_PHONEBOOK_NAME,
	ICON_PHONEBOOK_MOBILE,
	ICON_PHONEBOOK_HOME,
	ICON_PHONEBOOK_OFFICE,
	ICON_PHONEBOOK_MEMO,

	ICON_CALLRECORD_NOREAD,
	ICON_CALLRECORD_READ,
	ICON_CALLRECORD_LDN,
	ICON_CALLRECORD_LRN,
	ICON_CALLRECORD_UNUMBER,
	ICON_CALLRECORD_LJN,
#if ( MAIN_LCD_SIZE==4 )
	ICON_CALLING_TEXTPAD,
#endif
	ICON_CALLACTIVE,
	ICON_CALLHOLD,
	ICON_CALLINCOMING,
	ICON_CALLOUTGOING,
#if(MAIN_LCD_SIZE==3)//jhxu720	
	ICON_CALLACTIVE_ANI,
	ICON_CALLREDIAL_ANI,
#endif
	ICON_MENUUP,
#if ( MAIN_LCD_SIZE==4 )
	ICON_MENUMID,
#endif

	ICON_SOFTKEYBAR,
#if (MAIN_LCD_SIZE==3)
	 ICON_LEFTRIGHT_ARROW,
	 ICON_UPDOWN_ARROW,
	 ICON_FOURDIRECTION_ARROW,
	 ICON_MENULISTBKGICONS,
	 ICON_CURRENTBAR,
#endif
	 ICON_SPECIAL_BG, 
	 ICON_VOICERECORD_PLAY, 
	 ICON_VOICERECORD_RECORD, 
	 ICON_VOICEMEMO_WIN,

#if (MAIN_LCD_SIZE==3)
	ICON_IMAGEBAR,
	ICON_RECORDICON, 
#endif
	ICON_VOICEMEMO_ANIM,
	ICON_POPUPBACKGROUND,
#if (MAIN_LCD_SIZE==3)
	ICON_POPBACKMASK,
#endif

#if (MAIN_LCD_SIZE==3)
	ICON_POPUPICON,
	ICON_CONTRAST_ICONS,
	ICON_CONTRAST,
	ICON_POPCALLICON,
#elif ( MAIN_LCD_SIZE==4 )
    ICON_POPUP_ACTIONBG,
	ICON_POPUPACTION,
	ICON_POPSMSSEND,
	ICON_POPCALLICON,
	ICON_POPWAITING,
	ICON_POPDELETE,
	ICON_POPCOPY,
	ICON_POPSAVE,
	ICON_POPCOMPLETE,
	ICON_CONTRAST,
	ICON_SWITCHON_DEFAULT,
#endif
	
	ICON_SWITCHON,
	ICON_SWITCHOFF,

#if (MAIN_LCD_SIZE==3)
    ICON_SWITCHON_BKG,
	ICON_SWITCHOFF_BKG,
#endif	
	ICON_NETWORKSEARCH,
	ICON_NOSIMCARD,
	ICON_CONNECT_WAP,
	ICON_DIALINGNUMBER,

#if ( MAIN_LCD_SIZE==4 )
    ICON_IDLEDIALING,
	ICON_IDLEDIALING_MASK,
#endif	
	ICON_GAME_KEYSETTING,
	ICON_GAME_CTRL,
	ICON_GAME_SETTITLE,	
	ICON_GAME_NUMBER,
	ICON_SNAKE_BODY,
	ICON_SNAKE_BODYMASK,
	ICON_SNAKE_FOOD,
	ICON_SNAKE_FOODMASK,
	ICON_SNAKE_WALL,
	ICON_SNAKE_BKG,
	ICON_BOXMAN_BMP,
#if(MAIN_LCD_SIZE==3)//jhxu720
	ICON_BOXMAN_BKG,
#endif

	ICON_RUSSIA_DIAMONDS,
	ICON_RUSSIA_BKG,

//2004.08.12 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
	//2004-7-26 yangx Add
	ICON_PREVIEW_BAR,
	ICON_OPTION_BAR,
	ICON_OPTION_NUM,
    ICON_OPTION_NUM_MASK,
	ICON_QUALITY,
	ICON_QUALITY_MASK,
	ICON_SIZE,
    ICON_SIZE_MASK,
	ICON_BRIGHT,
	ICON_BRIGHT_MASK,
	ICON_MODE,
	ICON_MODE_MASK,
	ICON_OSD_MASK,
	//end 2004-7-26 yangx
#endif	
	
	ICON_MAX_NUMBER
};

//ffsͼƬiconid
#define ICON_FFS_PICTURE	0xE000
//ramͼƬݵiconid
#define ICON_BUFFER_PICTURE	0xF000

/************************************************************************/
/* iconid                                                       */
/************************************************************************/

#define ICON_LOCATION		0x00000001
#define ICON_MASK			0x00000002
#define ICON_MASK_OWN		0x00000004
#if (MAIN_LCD_SIZE==3)
//ֽ̬
#define DYNAMICWALLPAPER_NUM	1
//ֽ̬
#define STATICWALLPAPER_NUM		4
#elif ( MAIN_LCD_SIZE==4 )
//ֽ̬
#define DYNAMICWALLPAPER_NUM	2
//ֽ̬
#define STATICWALLPAPER_NUM		6
#endif
typedef struct _ICONRESOURCE_
{
    unsigned int Id;
    const MfwIcnAttr * icon;
	unsigned int iconNum;
} IconResource;

typedef struct _FFSICONRESOURCE_
{
	int icon_index;
	char file_name[22];
} FfsIcon;

typedef enum                            /* AVAILABLE ICONS BATTERY  */
{
	iconBattery4 = 0,                   /* icon Battery 0-4%        */
	iconBattery14,                      /* icon Battery 5-14%       */
	iconBattery24,                      /* icon Battery 15-24%      */
	iconBattery49,                      /* icon Battery 25-49%      */
	iconBattery100,                     /* icon Battery 50-100%     */
	iconBattMax                         /* number of batterie icon  */
}IconBattId;
#if(MAIN_LCD_SIZE==4)
typedef enum                            /* AVAILABLE ICONS SIGNAL */
{
	iconSigStat49 = 0,                  /* icon Signal 0-49         */
	iconSigStat99,                      /* icon Signal 50-99        */
	iconSigStat149,                     /* icon Signal 100-149      */
	iconSigStat199,                     /* icon Signal 150-199      */
	//iconSigStat255,                     /* icon Signal 200-255      */
	iconSigStat300,                     //xsf add for value 5 12.05	/* 2004/03/11 sunsj remove */
	iconSignalMax                       /* number of signal icon    */
}IconSignId;
#elif(MAIN_LCD_SIZE==3)
typedef enum                            /* AVAILABLE ICONS SIGNAL */
{
	iconSigStat49 = 0,                  /* icon Signal 0-49         */
	iconSigStat99,                      /* icon Signal 50-99        */
	iconSigStat149,                     /* icon Signal 100-149      */
	iconSigStat199,                     /* icon Signal 150-199      */
	iconSigStat255,                     /* icon Signal 200-255      */                   //xsf add for value 5 12.05	/* 2004/03/11 sunsj remove */
	iconSignalMax                       /* number of signal icon    */
}IconSignId;
#endif
typedef enum							/* AVAILABLE ICONS IDLE MODE*/
{
    iconIdSMS = 0,						/* icon New SMS message     */
	iconIdVoice,                        /* icon New Voice mail      */
	iconIdCallFor,                      /* icon Call forward uncond */
	iconIdSilRin,                       /* icon silent ringer       */
	iconIdKeyplock,                     /* icon Keypad locked       */
	iconIdCipheringActiv,               /* icon Ciphering           */        
	iconIdCipheringDeActiv,             /* icon Ciphering           */            
	iconIdRinger,                       /* icon ringer              */
	iconIdVibrator,                     /* icon vibrator            */
	iconIdRingVibr,                     /* icon ringer + vibrator   */
	iconIdAlarm,                        /* icon alarm on            */
	iconSIMTool,                        /* icon SIM Toolkit         */
	iconMessages,                       /* icon Messages            */
	iconOrganiser,                      /* icon Organiser           */
	iconSounds,                         /* icon Sounds              */
	iconSettings,                       /* icon Settings            */
	iconServices2,                      /* icon Services line2 16   */
	iconServices1,                      /* icon Services line1 17   */
	iconRoam,							/* icon Roam                */
	iconWAP,							/* icon WAP					*/
	iconIdGPRSOn,						/* icon GPRS ON  (sbh 18/01/02) */
	iconIdHomezone,						/* icon Homezone  (SH 29/11/01)  old is iconGPRSAttached*/
	iconIdGPRSAttached,					/* icon GPRS Attached (sbh 18/01/02) */
	iconIdTimer,
	iconIdMissedCall,					/* icon Missed Call Sunny add at 2004/03/11 */
	idlIdMax                            /* number of icons          */
} IconId;

#define DRAW_ICON(iconid)					Draw_Picture(0, 0, 0, iconid, 0, 0)
#define DRAW_ICON_SEL(iconid, in_index)		Draw_Picture(0, 0, in_index, iconid, 0, 0)

#define DRAW_ICON_MASK(iconid)					Draw_Picture(0, 0, 0, iconid, 0, ICON_MASK)
#define DRAW_ICON_SEL_MASK(iconid, in_index)	Draw_Picture(0, 0, in_index, iconid, 0, ICON_MASK)
#define DRAW_ICON_MASK_OWN(iconid)					Draw_Picture(0, 0, 0, iconid, 0, ICON_MASK_OWN)
#define DRAW_ICON_SEL_MASK_OWN(iconid, in_index)	Draw_Picture(0, 0, in_index, iconid, 0, ICON_MASK_OWN)

#define DRAW_ICON_LOCATION(iconid, in_x, in_y)		Draw_Picture(in_x, in_y, 0, iconid, 0, ICON_LOCATION)
#define DRAW_ICON_ATTRIBUTE(iconid, in_x, in_y, in_index, in_attr)	Draw_Picture(in_x, in_y, in_index, iconid, 0, in_attr)

#define GET_ICONATTR(iconid, in_index)	GetIconAttr(iconid, in_index)
#define GET_ICONATTR_NUM(iconid)		GetIconAttrNumber(iconid)

extern IconResource icontable[];

MfwIcnAttr * GetIconAttr(unsigned short in_IconId, unsigned short in_Index);
int GetIconAttrNumber(unsigned short in_IconId);

#endif