/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   MMI
 $File:       MmiMain.c
 $Revision:   1.0

 $Author:   Condat(UK)
 $Date:       22/02/01

********************************************************************************

 Description:



********************************************************************************

 $History: MmiMain.c

  * *****************  Version 02 *****************
 * zgz,2002.06.24
 * editEventKey() changed. if not nessary, Screen don't be updated.
 * 


  25/10/00      Original Condat(UK) BMI version.
  04/08/02      zy Mobile Innovation change the maininit()
  12/08/02      zym changed get language before in charging win
  14/08/02      zym modify mainInit() function
  15/08/02      gdy modified mainInit()
  15/08/02       xsf modified for "extern gtVibrator"
  15/08/02      zy add  control backlight and lcd
  26/08/02		hxl add for charger
  27/08/02		hxl changed for charger and ffs file
 //zym added
  * zgz,2002.08.26 change the code for timedate.
  2003/11/10    sunsj modify the method of get string length in displayAlignedPrompt function
/********************************************************************************

 $History: mmimain.c

  Date                  Modification        Author                   Describtion                                           
  -------------------------------------------------------------                                                 
  04/08/2002       1.1                    zym                       add two times 
                                                                                function MMiKeyactionpressed
                                                                                revised:showgoodbye,globalflashbattery

 $End

*******************************************************************************/
//zym added


/*******************************************************************************/

#include <stdio.h>
#define ENTITY_MFW
#undef _ResetProtectionEnabled_    //enable  auto reset function

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>


#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
//#include "Uart.h"
#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_kbd.h"
#include "mfw_tim.h"
#include "mfw_lng.h"
#include "mfw_win.h"
#include "mfw_icn.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_edt.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_ffs.h"
#ifdef SIM_TOOLKIT
    #include "mfw_sat.h"
#endif
#include "dspl.h"

#include "fieldtest.h"

#include "p_mmi.h"
#include "aci_cmh.h"
#include "gaci_cmh.h" /* include types declared in GACI  zy 2003-03-19           */
#include "mfw_mme.h"
//#include "Sys_types.h"

#ifndef _SIMULATION_
    #include "Sys_types.h"
#endif

#include "MmiMmi.h"

#include "MmiIcons.h"
#include "MmiPins.h"
#include "MmiMain.h"
#include "MmiDialogs.h"
#include "MmiIdle.h"
#include "MmiStart.h"
#include "MmiCall.h"
#include "MmiSimToolkit.h"
#include "gdi.h"
#include "Audio.h"
#include "MmiLists.h"
#include "MmiSounds.h"
#include "MmiResources.h"
#include "MmiTimeDate.h"
#include "Mmicharging.h"//hxl add for charging win

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "rtc_api.h"
//#include "spi_drv.h"
#include "pwr.h"
//#include "BmiEastApi.h"
#include "td.h"
#include "Mmibookshared.h"
#include "mmiQQSwitch.h" //hxl add for check qq func

/*2003/12/24,talcon add*/
#include "mmiouteridle.h"

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
#include "mmicamera.h"
#endif


//#define TDTRACE 1
#include "mmiutilapi.h"

extern short singleCall;/*2004/4/14, wangyan add*/
extern int   g_kpdnum  ;   ///zym added 10/18
extern int   g_kpdtim ;  ///zym added 10/18
extern UINT32 driverFlag;//wms added 02/12/29
extern UINT8 g_HandsetPcsycMode ;   ///zy 2003-03-19 judge if modem is plug in
extern int g_switchon;
extern T_call call_data;//zy 2003-02-14 add for if lowvoltage is on and the before win is call scratched win We must destroy it
extern MfwHnd call_get_window(void);
extern void CheckNetWork();

static MfwHnd times;          /* clock via software timer */
MfwHnd timer_Hnd=NULL;//gdy add 03/04/03
//joker
MfwHnd gtVibator; //XSF 08.14 static MfwHnd gtVibator;
//int g_tmp;
//zym added
static MfwHnd times_switchoff;          /* timer switch off (GB)*/

// 2004.4.1 WYJ call no win
MfwHnd    hRingVibStartTimer;   /* timeout for vibrator then start of melody */
extern int stopvib2playmelody( MfwEvt e, MfwTim *tc );

int g_lcd_game_flag =0;    /* backlight on/off switch tangyan0418 add */
extern int game_win_focussed(void);/* adjust the game win is focused tangyan0418 add */
//Will have to be stored in PCN eventually
static uint8    ffsNeedWrite=1;//hxl add for write ffs file,when power lower,2003-5-6

/* GLOBAL CONTROL DATA      */
LngInfo mainLngInfo;                    /* language control block   */
MfwHnd mainMmiLng;                      /* global language handler  */

MMI_NM_SERVICE    g_nmService=NM_UNDEFINED;  /* actual registered nm service */
MMI_SIM_STATUS    g_simStatus;      /* actual sim status        */
T_MFW_NETWORK_STRUCT        g_plmnIdent;    /* registered plmn */

#ifndef _SIMULATION_
extern void AI_Power(SYS_UWORD8 power);
#endif

static int keyAction (MfwEvt e, MfwKbd *res);
static int key (MfwEvt e, MfwKbd *kc);
static int timer (MfwEvt e, MfwTim *t);
static void backlight (void);
static int timesEvent (MfwEvt e, MfwTim *t);
static int smsphkchecktimeEvent (MfwEvt e, MfwTim *t);
static void setWriteflag(uint8  iswrite);
static uint8 getWriteflag(void);
///joker
static int  vibratorEvent(MfwEvt e, MfwTim * t);
///zym added
void showGoodBye (T_MFW_HND win);
void goodbye_cb (void);

// this needs a additional keypress for switch on
//static MfwHnd kbd;                      /* the main keyboard        */

// nm15.02.01
// this timer is used for backlight
// the B-Sample dont support backlight
//static MfwHnd tim;                      /* the main Timer           */

//nm 15.02.01
//the power off timer is not specified
//nm static MfwHnd timdown;                /* our timer manager power down */

static MfwHnd mme;                              /* our MME manager           */

U32 GlobalIconStatus;
UBYTE globalMobileMode;
int MmiModule;

extern UBYTE  IsShowGoodbye; //2004-04-23 Sunny add

/* batterie and signal    start  */
int globalBatteryUpdate(U8 value);
int globalSignalUpdate(U8 value);

void globalFlashBattery (void);

UBYTE globalSignalPicNumber;
/* 2004/07/09 sunsj add for forbidden hall off */
int HallOffForbid = FALSE;

UBYTE globalBatteryMode; /*  */
//USHORT settingsStatus=0;
int globalMme(MfwEvt e, void *para);
/* batterie and signal     end  */

CLOCK currclock;
Date currdate;
T_RTC_DATE_TIME timedate;//zhonghz,globel var

static LONG second;

//char stringTrace[50];//2004/04/05,talcon delete */
static U8 deregis = FALSE;            /* status deregistration       */
static int lcdOffControl;//zy 08/12
extern T_idle idle_data;//zy add for gprs attach in period 11/29
extern unsigned char no_wait;            //yq added for set the phbkwiatflag
extern USHORT IsPcsyncRemove(void);//hxl add for check if pcsync line is taken out,2003-2-13
extern UINT8 g_pcsyncstatus ;//hxl add ,if  pcsync run ,return,2003-2-13

int LineControl=0;

// sbh 6/03/02 - HUPKeyOrigin is 1 if POWER_KEY is pressed in idle screen, 0 otherwise
// Means that long press of HUP key will go to idle screen, not just shut down
UBYTE HUPKeyOrigin;
/* SPR877 - SH - set to TRUE if welcome animation has finished */
extern UBYTE animation_complete;
T_MFW_CFLAG_STATUS DivertStatus = MFW_CFLAG_NOTSet;
#define TIME_MINUTE     30000//every 30seconds read rtc,zhonghz

/* 2004/06/02 sunsj modify */
#define TIME_VIBRATOR     5000
///zym added
#define TIMEDOWN        120000L         /* time for powerdown 2min  */
#define TIME_SWITCH_OFF 3000         /* switch off time delay */
#define UPLINKPGAVALUE     0x06   ///-12db--12db 0x10  0x17-0x1b  0x0-0xc  0x11- 0x16 
#define VOLUMECONTROLVALUE   6
///zym added

extern FlashData FFS_flashData;
extern *RAMValue;
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
extern int  QQReadNewSms;//hxl add for qq check sms,2003-3-14
#endif
/* Amounts to: 128 (format mode) + 8 (overwrite mode) */

/*******************************************************************************

 $Function:

 $Description:  general editor control

 $Returns:    none.

 $Arguments:

*******************************************************************************/

static MfwHnd myHandle = 0;             /* editors handle           */
static MfwHnd editTim = 0;              /* the editor timer         */
static char *formatHandle;        // SH - pointer to format string, so that editEventKey can see it
static int *formatIndex;        // SH - pointer to format index
static int *fieldIndex;         // SH - pointer to field position
static char *tmpBuf;          // SH - pointer to temporary buffer for hidden alphanumeric entry

#define KEY_PAD_MAX 5

UBYTE editControls [KCD_MAX] =      /* edit control keys:       */
{
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '*', '#', ecNone, ecNone, ecUp, ecDown, ecLeft, ecRight,
    ecNone, ecNone, ecEnter, ecNone, ecNone, ecNone,
    ecNone, ecNone, ecEnter
};


static UBYTE editAlphaMode;                /* alpha mode flag          */
static UBYTE editCalcMode;                /* calculator mode flag          */
static UBYTE editFormatMode;      /* format mode flag */
static UBYTE editHiddenMode;      /* hidden alphanumeric mode */
static UBYTE editAlphaLevel;               /* alpha level selected     */
static UBYTE editAlphaKey;                 /* alpha mode current key   */



static UBYTE editAlpha [12][KEY_PAD_MAX] =           /* alpha mode characters    */
{
    {'.','+','-','=','0'},              //0 key
    {' ','?','!','1',':'}, {'a','b','c','2',')'}, {'d','e','f','3','('},     // 1 2 3
    {'g','h','i','4','$'}, {'j','k','l','5',' '}, {'m','n','o','6',','},     // 4 5 6
    {'p','q','r','s','7'}, {'t','u','v','8',';'}, {'w','x','y','z','9'},    // 7 8 9
    {'*','#','%','&',' '}, {' ','\'','\"','@','/'}  // star and hash keys
};

static UBYTE editAlphaU [12][KEY_PAD_MAX] =       /* upCase alpha mode characters*/
{
    {'.','+','-','=','0'},              //0 key
    {' ','?','!','1',':'}, {'A','B','C','2',')'}, {'D','E','F','3','('},    // 1 2 3
    {'G','H','I','4','$'}, {'J','K','L','5',' '}, {'M','N','O','6',','},   // 4 5 6
    {'P','Q','R','S','7'}, {'T','U','V','8',';'}, {'W','X','Y','Z','9'}, // 7 8 9
    {'*','#','%','&',' '}, {' ','\'','\"','@','/'}                // star and hash keys
};


int upCase= TRUE;
extern UINT8    Gu8_Envio_num;//enter which enviroment flag 
static int editEventTim (MfwEvt e, MfwTim *t);
static void editShowHeader (void);

extern void  JavaTaskSetup( void );   //zym added
extern void GetTimeDate(int year,short month,short day,TIMEDATE *today);  //xsf add 12.06

//hxl add 09/02,for low voltage warning--------------------------
MfwHnd timlowvoltage=0;          
int MMIStart_completed = 0;

void LowVol_Warning(void);
void LowVol_Poweroff(void);
void bat_info_init(void);
static int tim_LowVoltage_cb (MfwEvt e, MfwTim *t);
extern TffsfileCmd  ffsfileCmd;//ffs file cmd storage
extern T_MFW_CB timer_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc);

/*2003/12/23,talcon add*/
extern U8 isLcdOff();

#ifdef SEVEN_COLORS_LED
MfwHnd ColorLedBlinkTimer;
extern void ColorLedBlinkEvent( MfwEvt e, MfwTim *tc );
/* 2004/06/10 sunsj modify */
MfwHnd ServiceLedTimer;
extern void ServiceLedEvent( MfwEvt e, MfwTim *tc );
MfwHnd ServiceLedDelay;
extern void ServiceLedDelayEvent( MfwEvt e, MfwTim *tc );
#ifdef SEVEN_COLORS_LED_YAMAHA
UINT8 led_switch_on = 1;
#else
UINT8 led_switch_on = 0;
#endif

#else
UINT8 led_switch_on = 0;
#endif



//end of hxl add 09/02---------------------------------------------
/*******************************************************************************

 $Function:  mainInit

 $Description:   init MMI main module

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void mainInit (UBYTE InitCause)
{
    effs_t ffs_ret=0;//hxl add for trace flash error,2003-1-13
    uint8   nloop=0;//hxl add for check flash error,2003-2-13
    char err[50];
    //    TraceMMI("maininit");

/**the initialize must be front of all malloc dynamic memory,for example,MMS_Net_Init**/
	MI_mmimem_Init();
	
    /*clrobert */
    memset(&timedate,0,sizeof(timedate));//zhonghz,set the timedate mem
    RTC_GetDateTime(&timedate);//zhonghz,maininit read rtc
    mfwSetSignallingMethod(1);
    winAutoFocus(TRUE);
    mfwFocus = 0;                       /* reset focus              */

    memset(&ffsfileCmd,0,sizeof(TffsfileCmd));//initialise the ffs file cmd storage


    // this is called to use:
    // power driver;fieldstrength driver; audio driver
    //mmeInit();	// sbh - moved this to mmistart, as rxInit crashes mobile on startup

    //nm  mmeRtcInit(0, 0);

    HUPKeyOrigin = 0;  // sbh
    animation_complete = FALSE;    
    kbdAlways((MfwCb)keyAction);        /* global ke yboard access   */
	/* 2004/04/16 sunsj change long time from 2000 to 1500 */
    kbdTime(1200,1000,400);             /* long / repeat timeouts   */

    // nm15.02.01
    // this timer is used for backlight
    // the B-Sample dont support backlight
    //    tim = timCreate(0,1000,(MfwCb)timer); /* backlight timer        */


    mainMmiLng = lngCreate(0,0,&mainLngInfo,0); /* language handler */

    // times clock event
    times = timCreate(0,TIME_MINUTE,(MfwCb)timesEvent);
    timer_Hnd = timCreate(0, 1000, (T_MFW_CB)timer_tim_cb);//gdy add 03/04/03

    //joker
    gtVibator= timCreate(0,TIME_VIBRATOR,(MfwCb)vibratorEvent);
	/* 2004/07/19 sunsj Fix MI18800000465 */
	timStart(gtVibator);
	
    ///zym added
    mme = mmeCreate(0, MfwMmeSignal|MfwMmeBattery|MfwMmeBaState, (MfwCb)globalMme);       //xzy change this "MfwMmeSignal|" for get signal by another way

    // mmeSetVolume(100, 100);                 /* set audio in/out to 100 percent */
    timlowvoltage=timCreate(0, 1000, (MfwCb)tim_LowVoltage_cb);

	// 2004.4.1 wyj call no win
	 hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);
	
#ifdef SEVEN_COLORS_LED
/* zhq, 2004/07/08, we use MA5 to drive led. */
#ifndef SEVEN_COLORS_LED_YAMAHA
   ColorLedBlinkTimer = timCreate( 0, 1200, (MfwCb)ColorLedBlinkEvent );
#endif //SEVEN_COLORS_LED_YAMAHA
   /* 2004/06/10 sunsj modify */
   ServiceLedTimer = timCreate( 0, 10000, (MfwCb)ServiceLedEvent );
   ServiceLedDelay = timCreate( 0, 1000, (MfwCb)ServiceLedDelayEvent );
   timStart(ServiceLedTimer);
#endif
	
    /* Special case:  The charger is connected, battery inside and    */
    /* the user is switching the mobile off. In this case the display */
    /* has to keep on                                                 */
    //zym
    /*
    MmiTraceInt(globalMobileMode);
    if(globalMobileMode == (GlobalCharging|GlobalDisplayFlag))
    {
      TRACE_FUNCTION(" ! clear GlobalDisplayFlag !");
      globalMobileMode = globalMobileMode & (~GlobalDisplayFlag);

      iconsChargeDisplayOnOff(1); //* switch the display on 
      iconsStateOfCharge();  //* display the text "charging.."  

      globalFlashBattery ();
    }*/


    //RM test 14-07 second = 0;
    memset(&currclock,0,sizeof(currclock));
    memset(&currdate,0,sizeof(currdate));
    currclock.sec = timedate.second;
    currclock.min = timedate.minute;
    currclock.hour = timedate.hour;

    currdate.day = timedate.day;
    currdate.month = timedate.month;
    currdate.year= timedate.year + 2000;  //zgz

#ifdef CAMERA_ENABLED
Cam_Ffs_Init();
#endif

	
    /*.......zy Mobile Innovation if flash read is ok read the timedate 04/08/02........*/
    /*.............end of zy change........................*/
    if( flash_CheckStat("/gsm/com/rfcap")<0 )
    {//no file
        if( flash_CheckStat("/gsm/com")<0 )
        {//no com dir
            if( flash_CheckStat("/gsm")<0 )
            {//no gsm dir
                ffs_ret=flash_PBmkdir("/gsm");
                if( ffs_ret<0 )
                {//make dir gsm failer
                    dspl_TextOut(1, 48, 0,"mkdir gsm error");
                    sprintf(err,"errid:%d",ffs_ret);
                    dspl_TextOut(1, 64, 0,err);
                    OverleapRegist=1;//show the flash error info
                }
            }
            //when gsm dir exist we build the com dir
            if( !OverleapRegist )
            {
                ffs_ret=flash_PBmkdir("/gsm/com");
                if( ffs_ret<0 )
                {//make dir com failer
                    dspl_TextOut(1, 48, 0,"mkdir com error");
                    sprintf(err,"errid:%d",ffs_ret);
                    dspl_TextOut(1, 64, 0,err);
                    OverleapRegist=1;//show the flash error info
                }
            }
        }
        //when gsm/com dir exist we build file
        if( !OverleapRegist )
        {
            ffs_ret=FlashRFCAPInitialise();
            if( ffs_ret<0 )
            {
                dspl_TextOut(1, 48, 0,"fwr rfcap err");
                sprintf(err,"errid:%d",ffs_ret);
                dspl_TextOut(1, 64, 0,err);
                OverleapRegist=1;//show the flash error info and overleap regist
            }
        }
    }

    deregis = FALSE;
    timStart(times);                 /*      start clock          */


    /* power-on key handler  */
    //    is not necessary anymore, this needs a additional keypress
    //    kbd = kbdCreate(0,KEY_HUP,(MfwCb)key);



    /*........................end of zy change ..............................................*/


    Gpio_hisr_initialize();
    Melody_Dev_Init( );

    // SetASpk_UpLinkPGA(UPLINKPGAVALUE);
    // SetASpk_V(VOLUMECONTROLVALUE);  
    SetEarMode();//zy 09/03
    ///zym added
    lcdOffControl=0;//zy 08/15
    //For DAR Bob added 03/03/06
    if( flash_CheckStat("/var/dbg")<0 )
    {
        ffs_ret=flash_PBmkdir("/var");
        ffs_ret=flash_PBmkdir("/var/dbg");
    }

#ifdef _MMS_ENABLE_
    //PowerInfoCbInit();
	MMS_Initialize();
#endif

    bat_info_init();
    MmiRsrcSetChinese();

	Backlight_ON( );

    if( OverleapRegist )//hxl add ,when flash error ,we overleap the regist,20021029
        dspl_TextOut(10, 32, 0,MmiRsrcGetText(TxtFlashErr));
    else
        startExec(PhoneInit,0);     // now the mobile is switched on        
    //end of hxl add 0903--------------------------------------------------------
    // LineControl=1;

	/*talcon add for pcsyn,2004.07.06*/
#ifdef MMI_PCSYN_ENABLED
	{
	extern int pcsynmfw_init (void);
		pcsynmfw_init();
    	}
#endif
		/*talcon add for pcsyn,2004.07.19*/
#ifdef MMI_MMSTASK_ENABLED
	{
	extern int mmsmfw_init (void);
		mmsmfw_init();
    	}
#endif

    MMIStart_completed = 1;
	
}

///zym added for kpd handle
void StartSecTime(void)
{
    timStart(timlowvoltage);
}
/*******************************************************************************

 $Function:  mainExit

 $Description:   exit MMI main module

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void mainExit (UBYTE InitCause)
{
    TRACE_FUNCTION("mainExit");

    startExit();
    sim_exit();                         /* finit SIM handler        */
    lngDelete(mainMmiLng); mainMmiLng = 0;

    // nm + 15.02.01
    // this timer is used for backlight
    // the B-Sample dont support backlight
    //    timDelete(tim); tim = 0;
    // nm -

    timDelete(times);
    timDelete(timer_Hnd);//gdy add 03/04/03
    //   nm 15.02.01
    //   the power off timer is not specified
    //   timDelete(timdown);timdown = 0;

    mmeDelete(mme); mme = 0;

    kbdAlways(0);
    dspl_ClearAll();


}

/*******************************************************************************

 $Function:  keyAction

 $Description:   handler called on every keyboard action

 $Returns:

 $Arguments:

*******************************************************************************/
static int keyAction (MfwEvt e, MfwKbd *res)
{
    T_RTC_DATE_TIME time_date;
    T_RV_RETURN path;
    char temp[100];
    int i;  /*2004/4/14, wangyan add*/

    //this function "keyAction" is called 4*times from MFW per each keypress
    // twice for keypress and twice for keyrelease
    // the variable "toggle" is using to avoid to play the keypadtone twice !
    static UBYTE toggle = TRUE;

    // this mask is use to filter the keyevent "e"
    // want to use KEY_0, KEY_1,......  KEY_HASH
    USHORT  mask = 0x0FFF;

    //TRACE_EVENT("zgz,keyAction");  // zgz , for trace
    //terminate the ringing in all situation (it doesnt matter where the user is
    //TraceMMIValueFunction("Key",e);
    //TraceMMIValueFunction("animation",animation_complete);

    /*zy 2003-04-04 if in callwin halloff return to idle */
		MMI_TRACE_EVENT(("wangyan keyAction e=%d; res->code=%d",e,res->code));
    if( (e & KEY_F4) )
    {

        if( !HallStatus() )
        {

//            if( (call_data.win)&&(!IsHandsetPlugin()) ) 
            if( (call_data.win)&&(!IsHandsetPlugin()) &&(!call_data.win_incoming)) /*2004/4/2, wangyan modify*/
            {

		/*if( call_data.win_incoming )
                {

                    saveRejNuminhalloff();
                    stopIncallLed();
                    SEND_EVENT(call_data.win_incoming,DIALOG_DESTROY,0,0);
                    call_data.win_incoming = 0;
                }*/
                /*begin of zy 2003-04-24 change if dial an switched off number then dial 
                a new number. hall off it willnot disconnect anyway*/
                /*2004/4/14, wangyan modify*/
                /*if( call_data.win_calling )
                {
                    cm_disconnect(call_data.outCall);
                }*/
                /*2004/4/14, wangyan modify*/
                i = 0;
		while (i<call_data.calls.numCalls)
		{
			if (call_data.calls.status[i].call_number!=singleCall)
			{
				if (!removeCall(call_data.calls.status[i].call_number))
					i++;

			}
			else
				i++;
		}
		/*2004/4/14, wangyan add*/
		/*2004/4/22, wangyan modify*/
                if( call_data.win_calling )
                {
                    cm_disconnect(call_data.outCall);
                }
                /*2004/4/22, wangyan modify*/

                /*end of zy change 2003-04-24*/
                TRACE_EVENT("key_hall will hangup all calls");
                RELEASEAllCALL();
   //             returntoidle();
                return 1;
            }
        }
    }
    /*end of zy change 2003-04-03*/

/*2004/4/2, wangyan add*/
	if( e & KEY_LONG )
	{
		if(!HallStatus() )
    		{
    			if( e & KEY_F3)
			{/*2004/04/08,talcon add for long KEY_F3 handle*/ 
				if(FlashSettingData.hallonconnect)
					incoming_call_kbd_long_KeyAction();
				else
				{
					MC_StopVibra();						// 2004.4.16 WYJ add
					StopPlayByReasonId(INCALL);
				}
					
				return MFW_EVENT_CONSUMED;
			}
			/*
			else if( e & KEY_VOLUP)
			{
				MMI_TRACE_EVENT(("sunsj---------------key volup"));
				LedLightnessAdjust(200);
				timStart(gtVibator);
				return MFW_EVENT_CONSUMED;
			}
			*/
		}
	}
 /*2004/4/2, wangyan add*/	

    if( (e & KEY_HUP) && (e & KEY_MAKE) )
    {

        UBYTE currentRinger = getCurrentRingerSettings();

        // terminate the ringing
        //Stopplayingdevice(); //xsf add 2002.08.12 MI18800000126
        //audio_StopSoundbyID( AUDIO_BUZZER, currentRinger );

    }

    //the power-off-key !
    if( (e & KEY_POWER) && (e & KEY_MAKE) && animation_complete )
    {
        TRACE_EVENT("KEY_POWER pressed !!!!");
        set_latest_alarm();

        AutoPowerOn();
        if( (pinsIsFocussed() EQ FOCUSSED_PINS) || idleIsFocussed() )
        {

            pin_exit();
			dspl_ClearAll();	//wyj MI18800000375
            //  if(pinsIsFocussed() EQ FOCUSSED_PINS)
            HUPKeyOrigin=1;
        }
        if( (hostkeyASKIsFocussed() EQ FOCUSSED_PINS) || idleIsFocussed() )
        {
            hostkey_exit();
            HUPKeyOrigin=1;
        }

        /* SH - check to make sure we're in idle screen before starting shutdown
        SPR877 - SH - also check that welcome animation is complete */

        if( HUPKeyOrigin==1 )
        {
            {
                /* 2004/07/09 sunsj add for forbidden hall off */
                HallOffForbid = TRUE;
#ifdef MMS_WAP_ENABLED
{
extern void mms_pushfile_exit();
	mms_pushfile_exit();
}
#endif

#ifdef _MMS_ENABLE_
	MMS_Exit();
#endif
                FfsWriteAllEvent();//hxl add for save file completely 20021125
                FieldTestExit();
                showGoodBye ( idle_get_window () ); //gb
				//2004-04-26 Synny remove
                //times_switchoff = timCreate(0,THREE_SECS,(MfwCb)goodbye_cb);
                //timStart(times_switchoff);
            }
        }
        deregis = FALSE;
    }
    HUPKeyOrigin = 0;

    //every other calls
    if( toggle )
    {
#ifdef SIM_TOOLKIT
        satEvtDownload(SatEvtUserAction);
#endif
        //"KEY_MAKE"  makes sure to call it only by keypress
        //xsf 2002.07.04 if ((FFS_flashData.settings_status & SettingsKeypadClick) && (e & KEY_MAKE))
        if( (FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadTone) && (e & KEY_MAKE) )
        {
            TRACE_EVENT ("Keypad Click activ");
            //play KeypadClick
            //xsf 2002.08.05
            // StartKeyBeep();    //ganchh 2002/8/27
            //audio_PlaySoundID(0, TONES_KEYBEEP, 200, 0 );
        }
        //"KEY_MAKE"  makes sure to call it only by keypress
        else if( (FFS_flashData.settings_status & SettingsKeypadDTMF) && (e & KEY_MAKE) )
        {
            TRACE_EVENT ("Keypad DTMF activ");
            switch( e &= mask )
            {
            case KEY_0:
                audio_PlaySoundID(0, (TONES_DTMF_0), 0, 0 );
                break;
            case KEY_1:
                audio_PlaySoundID(0, TONES_DTMF_1, 0, 0 );
                break;
            case KEY_2:
                audio_PlaySoundID(0, TONES_DTMF_2, 0, 0 );
                break;
            case KEY_3:
                audio_PlaySoundID(0, TONES_DTMF_3, 0, 0 );
                break;
            case KEY_4:
                audio_PlaySoundID(0, TONES_DTMF_4, 0, 0 );
                break;
            case KEY_5:
                audio_PlaySoundID(0, TONES_DTMF_5, 0, 0 );
                break;
            case KEY_6:
                audio_PlaySoundID(0, TONES_DTMF_6, 0, 0 );
                break;
            case KEY_7:
                audio_PlaySoundID(0, TONES_DTMF_7, 0, 0 );
                break;
            case KEY_8:
                audio_PlaySoundID(0, TONES_DTMF_8, 0, 0 );
                break;
            case KEY_9:
                audio_PlaySoundID(0, TONES_DTMF_9, 0, 0 );
                break;
            case KEY_STAR:
                audio_PlaySoundID(0, TONES_DTMF_STAR, 0, 0 );
                break;
            case KEY_HASH:
                audio_PlaySoundID(0, TONES_DTMF_HASH, 0, 0 );
                break;
            default:
                break;

            }
        }

    }

    // toggle the variable
    if( toggle )
    {
        toggle = FALSE;
    }
    else
    {
        toggle = TRUE;
    }


    return 0;
}

/*******************************************************************************

 $Function:  key

 $Description:   keyboard event handler

 $Returns:    none.

 $Arguments:

*******************************************************************************/
// switching the mobile on
static int key (MfwEvt e, MfwKbd *kc)
{

    TRACE_FUNCTION("Initial key");
    //---------------start : Mobile On-------------------
    TRACE_EVENT("	      Mobile ON");
    /* set the state of mobile on   */
    globalMobileMode = (globalMobileMode | GlobalMobileOn);


    //startExec(PhoneInit,0);             /* get it rolling           */

    return 1;
}
/*******************************************************************************

 $Function:  globalMme

 $Description:  MME event handler

 $Returns:    none.

 $Arguments:

*******************************************************************************/
int globalMme(MfwEvt e, MfwHnd para)   ///zym revised
{
    MfwMme* mc = (MfwMme*)para;

    U8  value;
    // char buf[40]; //nm test only

    //TRACE_EVENT("globalMme");

    switch( e )
    {
    case MfwMmeSignal :

        value = (U8)mc->value;//JVJE
        globalSignalUpdate(value); /*Update the value of the fieldstrength  */
        //2003/12/24,talcon add fout outerIdle
        outeridleExec(OUTERIDLEEVENT_SIGNAL,0);
        break;

    case MfwMmeBattery://no charger
        value = (U8)mc->value;


        globalBatteryUpdate(value); /* this update the BatPicNum */
        /* only if Mobile on, Battery inside and Charger Disconnect */
        //2003/12/24,talcon add fout outerIdle
        outeridleExec(OUTERIDLEEVENT_BATTERY,0);
        break;


    case MfwMmeBaState://charger in it,hxl add
        value = (U8)mc->value;
        switch( value )
        {
        /* External Power Plugged Off */
        case 0:

            globalMobileMode = globalMobileMode & (~GlobalCharging);
            globalMobileMode = globalMobileMode & (~GlobalBatteryPower);
            ///zym
            //            power_battery_information();   ///zym 030109  no use 

            break;

            /* Mme Event: External Power Connected or End of Charge */
        case 1:

            globalMobileMode = globalMobileMode & (~GlobalCharging);
            globalMobileMode = (globalMobileMode | GlobalBatteryPower);

            /* indicate that the battery is full*/
            globalBatteryMode = GlobalBatteryFull;
            idleEvent(IdleUpdate);
            break;
            /* Mme Event: Start of Charge */
        case 2:

            globalMobileMode = globalMobileMode & (~GlobalBatteryPower);
            globalMobileMode = (globalMobileMode | GlobalCharging);

            //            globalFlashBattery ();  //hxl delete,for deal the charger in phone

            break;

        default:
            break;
        }


        break;

    default:
        return 1;
    }
    return 1;
}

/*******************************************************************************

 $Function:  backlight

 $Description:  switch on backlight for certain time

 $Returns:    none.

 $Arguments:

*******************************************************************************/
static void backlight (void)
{

    //JVJE    scrLight(1);


    // nm15.02.01
    // this timer is used for backlight
    // the B-Sample dont support backlight
    //nm    timStart(tim);

}

/*******************************************************************************

 $Function:  timesEvent

 $Description:   times event  clock

 $Returns:    none.

 $Arguments:

*******************************************************************************/

extern UINT32 status_reg_value1;
extern UINT32 status_reg_value2;
extern UINT32 status_reg_value3;
static int timesEvent (MfwEvt e, MfwTim *t)
{
    int minold,GprsStatusResult,GPRSAutoAttachResult,gprsStatus;/*zy add 2003-03-19 gprsStatus*/
    static int ffsWaitWrite=20;
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
    static int QQreadtim=0;//hxl for qq read sms check,if don't have this element,check malloc will don't be free,2003-3-14
#endif
    static int GPRSTryControl=2;  
    static int UartInit=1;
    //zhonghz,get time from rtc every 30 second
    //DO NOT via soft-timer


    ////below zym added for check Modem/Pcsync line status

    QueryPcsyncHandsetStatus();
    GetBatPicnum();///zym added for low voltage warning 0319

    RTC_GetDateTime(&timedate);
    currclock.hour=timedate.hour;
    currclock.min=timedate.minute;
    currclock.sec=timedate.second;
    //RM only for PC testing
    //sms_check_memset();//added by windy 1213

    //zgz,2002.8.15 also get date from rtc.
    currdate.day = timedate.day;
    currdate.month = timedate.month;
    currdate.year = timedate.year+2000;
    alarm_check();//gdy add

    //yq added for set phbwaitflag
    if( no_wait>0 )
        no_wait--;
    /*begin of zy 2003-04-23 if modem is not plug in init it*/
    if( g_HandsetPcsycMode!=1&&UartInit==1 )
    {
        SER_ImmediateSwitch ();//zy 2003-05-14 init ser avoid crash
        UartInit=0;
    }
    if( g_HandsetPcsycMode==1 )
    {
        UartInit=1;
    }
    /*end of zy 2003-04-23*/
    if( g_HandsetPcsycMode!=1&&winIsFocussed(idle_data.win)&&(!FlashSettingData.gprsattachmode)&&(iconsGetState(iconIdGPRSAttached)==ICON_VISIBLE) )
    /*
      zy 2003-04-16 judge if need detach gprs
    */
    {
	#ifdef MMS_WAP_ENABLED
		extern int mms_check_status();
		if(mms_check_status() == 0)
	#endif
		{
        TRACE_EVENT("zy:it should do gprsdetach");
        gprsStatus = mmiGprsStatus();
        if( !FlashSettingData.gprsattachmode&&(gprsStatus==2||gprsStatus==1) )
        {

            gprs_attach(CGATT_STATE_DETACHED);
        }
    }
    }
    GPRSTryControl--;
    if( GPRSTryControl<0||GPRSTryControl>2 )
        GPRSTryControl=2;
    if( (GPRSTryControl==0)&&winIsFocussed(idle_data.win)&&FlashSettingData.gprsattachmode )
    {
        GPRSTryControl=2;
        GprsStatusResult=mmiGprsStatus();
        if( (GprsStatusResult!=2)&&FlashSettingData.gprsattachmode )
        {
            GPRSAutoAttachResult=GPRSAutoAttach();
        }
    }
    // flash_settingwrite();///zym added 11/13 tempor

    // flash_environmentwrite();//hxl delete for this all will be done later,2002-11-26
    /*begin of zy change 2003-02-28*/
    if( LineControl )
    {
        if( (FlashDCTbData.lineselectflag==1||FlashDCTbData.lineselectflag==0) )
        {
            if( !ALSPresent(NULL, NULL, NULL) )
            {
                TRACE_EVENT("zy:tim30atline1");
                LineControl=sAT_PercentALS(CMD_SRC_LCL, ALS_MOD_SPEECH);
                als_status_checkicon();
            }
            else
            {
                LineControl=0;
                FlashDCTbData.lineselectflag=0;
                als_status_checkicon();
                flash_DCTbwrite();
            }
        }
        else if( FlashDCTbData.lineselectflag==2 )
        {
            if( !ALSPresent(NULL, NULL, NULL) )
            {
                LineControl=sAT_PercentALS(CMD_SRC_LCL, ALS_MOD_AUX_SPEECH);
                TRACE_EVENT("zy:tim30atline2");
                als_status_checkicon();
            }
            else
            {
                LineControl=0;
                FlashDCTbData.lineselectflag=0;
                als_status_checkicon();
                flash_DCTbwrite();
            }
        }
    }
    /*end of zy change 2003-02-28*/
#if 0
    second += 60;                           /* increase seconds         */

    minold = currclock.min;

    currclock.hour = second/3600;

    if( currclock.hour EQ 24 )
    {
        second = 0;
        currclock.hour = currclock.min = currclock.sec = 0;
        minold = 0;
        DateSet(&currdate);
    }
    else
    {
        currclock.min = (second-currclock.hour*3600)/60;
        currclock.sec = (second-currclock.hour*3600-currclock.min*60);
    }


    RTC_GetDateTime(&timedate);
    currclock.hour=timedate.hour;
    currclock.min=timedate.minute;
    currclock.sec=timedate.second;
#endif
    //hxl add for qq read sms free memory,2003-3-14
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
    if( (QQReadNewSms) )
        QQreadtim+=30;
    else
        QQreadtim=0;
    if( QQreadtim>30 )
    {
        MmiTrace("main check");
        QQreadtim=0;
        check_new_sms(0,0);
    }
#endif
    //end of hxl add,2003-3-14--------
    ffsWaitWrite--;
    if( ffsWaitWrite==0 )
    {
        FfsWriteOneEvent();   //hxl add for write ffs file
        ffsWaitWrite=20;
    }

    if( !isLcdOff() )//inner Idle
    {
        idleEvent(IdleUpdate);    
    }
    //	else//outer Idle
    {
        outeridleExec(OUTERIDLEEVENT_TIME,0);//add
    }

    /*MC CONQUEST 5999->6007,21/05/02 if CPHS reading didn't work on switch-on, try again*/
    if( CphsPresent() == CPHS_ERR )
        cphs_support_check();
    //}

    if( g_pcsyncstatus )
    {//hxl add for check if the line have been take out,2003-2-13
        if( IsPcsyncRemove() )
            g_pcsyncstatus=0;
    }

    timStart(times);
#ifdef _ResetProtectionEnabled_
    if( !call_get_window() ) //no call connected
    {
        CheckNetWork();
        if( ShouldBeReseted() )
        {
            FfsWriteAllEvent();//hxl add for save file completely 20021125
            //unsigned char x=1/0;  //reset it
            while( 1 );    //resetted
        }
    }
#endif
    return 1;
}
/*******************************************************************************

 $Function:  showCLOCK

 $Description:  display clock

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void showCLOCK(void)
{
    extern GLOBAL int get_StringWidth(char *string);
    char line[MAX_LINE];/* RM only for PC testing */
    char *AmPm; //zgz, 2002.8.23
    int hour;
    TIMEDATE today;   
    UINT8 weekpositionX;
    UINT8 weekpositionY;
    GetTimeDate(currdate.year, currdate.month, currdate.day, &today);  //xsf add for get weekday 12.06

    if( FFS_flashData.time_format == TWELVE_HOUR )
    {
        if( currclock.hour / 12 )
        {
            if( FFS_flashData.language==0 )
                AmPm = "PM";
            else
                AmPm = "PM";	/* 2004/04/10 sunsj modify */
        }
        else
        {
            if( FFS_flashData.language==0 )
                AmPm = "AM";
            else
                AmPm = "AM";	/* 2004/04/10 sunsj modify */
        }
        if( currclock.hour>12 )
        {
            hour=currclock.hour-12;
        }
        else if( currclock.hour==0 )
        {
            hour=12;
        }
        else
        {
            hour=currclock.hour;
        }   
        sprintf(line,"%02d:%02d%s",hour,currclock.min, AmPm); //zgz, 2002.8.23  	   
    }
    else
        sprintf(line,"%02d:%02d",currclock.hour,currclock.min);
#if (MAIN_LCD_SIZE==4)									// WYJ MI18800000425
    if( FFS_flashData.language==0 )
    {
        weekpositionX = 71;
        /*2003/10/30,talcon change 125 t0 110 */
        //weekpositionY = 125;
        weekpositionY = 110;
    }
    else
    {
        weekpositionX = 3;
        weekpositionY = 113;
    }

    switch( today.week ) //xsf add for get weekday 12.06
    {
    case 0:
        dspl_TextOut(weekpositionX,weekpositionY,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtSunday));
        break;
    case 1:
        dspl_TextOut(weekpositionX,weekpositionY,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtMonday));
        break;
    case 2:
        dspl_TextOut(weekpositionX,weekpositionY,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtTuesday));
        break;
    case 3:
        dspl_TextOut(weekpositionX,weekpositionY,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtWednesday));
        break;
    case 4:
        dspl_TextOut(weekpositionX,weekpositionY,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtThursday));
        break;
    case 5:
        dspl_TextOut(weekpositionX,weekpositionY,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtFriday));
        break;
    case 6:
        dspl_TextOut(weekpositionX,weekpositionY,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtSaturday));
        break;
    default:
        break;

    }

	/* 2004/05/11 sunsj modify */
    dspl_TextOut( SCREEN_SIZE_X - 2 - get_StringWidth(line), SCREEN_SIZE_Y - Mmi_layout_line_height()*2, 
		DSPL_TXTATTR_WHITE_EDGE, (char *)line);  
#elif (MAIN_LCD_SIZE==3)
	dspl_TextOut((126 - get_StringWidth(line))/2,66,DSPL_TXTATTR_WHITE_EDGE,(char *)line);//jhxu720
#endif
	
}
/*******************************************************************************

 $Function:  setClockFormat

 $Description:  used to switch between 24 hour and 12 hour display format

 $Returns:    none.

 $Arguments:  format enum

*******************************************************************************/
void setClockFormat(UBYTE format)
{
    if( FFS_flashData.time_format == format )  //zgz,2002.8.23
        return;
    /*
    if (format == TWELVE_HOUR)
      FFS_flashData.time_format = TWELVE_HOUR;
    else
      FFS_flashData.time_format = TWENTYFOUR_HOUR;
    */
    FFS_flashData.time_format = format;

    flash_write(); //store format in flash
}

/*******************************************************************************

 $Function:  ClockSet

 $Description:   exit MMI main module

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void ClockSet(CLOCK *currclock)
{

    timStop(times);                     /* clock stop   only for PC testing  */

    second = currclock->hour*3600 + currclock->min*60 + currclock->sec;
    timStart(times);                    /* clock new starts         */
}
/*******************************************************************************

 $Function:  DateSet

 $Description:   date set -

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void DateSet(Date *currdate)
{

    currdate->day++;

    if( (currdate->day >= 29) && (currdate->month EQ 2) )
    {
        if( currdate->day EQ 29 )
        {
            if( ((currdate->year%4) NEQ 0) && (currdate->year NEQ 2000) )
            {
                currdate->day = 1;
                currdate->month = 3;
            }
        }
        else
        {
            currdate->day = 1;
            currdate->month = 3;
        }
    }

    if( currdate->day >= 31 )
    {
        if( currdate->day EQ 31 )
        {
            switch( currdate->month )
            {
            case 1:
            case 3:
            case 5:
            case 7:
            case 8:
            case 10:
            case 12:
                break;
            default:
                currdate->day = 1;
                currdate->month++;
                break;
            }
        }
        else
        {
            currdate->day = 1;
            if( currdate->month != 12 )
                currdate->month++;
            else
            {
                currdate->month = 1;
                currdate->year++;
            }
        }
    }
}
/*******************************************************************************

 $Function:  showDATE

 $Description:   display date

 $Returns:

 $Arguments:

*******************************************************************************/
void showDATE(void)
{
    char line[MAX_LINE];/* only for PC testing  */
    char s[5];
    int c;
    sprintf(s,"%04d",currdate.year);
    //itoa(currdate.year,s,10);
    c=atoi(&s[2]);

    sprintf(line,"%02d.%02d.%02d",c,currdate.month, currdate.day);
    if( FFS_flashData.language==0 )
        dspl_TextOut(3,128,DSPL_TXTATTR_WHITE_EDGE,(char *)line);// zy add 0918 DSPL_TXTATTR_WHITE_EDGE
    else
    {

        /*...................zy change the date display place 04/08/02.......................  */
        //sprintf(line,"%02d/%02d/%04d",currdate.month, currdate.day, currdate.year);
        dspl_TextOut(2,128,DSPL_TXTATTR_WHITE_EDGE,(char *)line);
        sprintf(line,"%04d/%02d/%02d",currdate.year,currdate.month, currdate.day);

    }
    /* ...................end of zy change..................................................................*/
}

/*******************************************************************************

 $Function:  truncateString

 $Description:

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void truncateString(char* strDest,char* strOrig,unsigned int truncLength,int pos,char* trunChar)
{
    unsigned int real_lenth=0,dspl_lenth=0;  //xsf add 03.03.11
    unsigned char * ss=(unsigned char*)strOrig;
    char *s;

    if( wstrBitlen(strOrig)>truncLength )//zy 12/23 for eng with chn menu
    {
        if( wstrlen(trunChar)<truncLength )
        {

            if( pos == POS_END )
            {
                if( *(unsigned char*)strOrig==0x80 )
                {
                    //begin of xsf add 2003.03.11
                    ss++;
                    while( ((*ss<<8)+*(ss+1)!=0) && ((dspl_lenth<truncLength-1) || ((dspl_lenth==truncLength-1) && (*ss==0x00))) )
                    {
                        if( *ss==0x00 )//if not chinese
                            dspl_lenth++;
                        else
                            dspl_lenth+=2;
                        real_lenth+=2;
                        ss+=2;
                    }
                    truncLength=real_lenth;
                    //end of xsf add 2003.03.11
                    wstrncpy(strDest,strOrig,truncLength-2);
                }
                else
                    wstrncpy(strDest,strOrig,truncLength-wstrBitlen(trunChar));
                // s=strDest;
                // s+=truncLength-wstrBitlen(trunChar);
                // wstrcpy(s,trunChar);
                wstrcat(strDest, trunChar);
            }
            else
            {
                s = strOrig;
                s = s+wstrlen(strOrig)-truncLength;
                wstrncpy(strDest,s,truncLength+1);
                wstrncpy(strDest,trunChar,wstrlen(trunChar));
            }
        }
        else
        {
            wstrncpy(strDest,trunChar,truncLength);
            s = strDest;//zy add 09/27
            s++;
            *s='\0'; /* RSA/JVJ-SPR#1204. The wrong address was being overwritten */
        }
    }
    else
        wstrncpy(strDest,strOrig,wstrlen(strOrig));

}

/*******************************************************************************

 $Function:  displayAlignedText

 $Description:  Display text horizontally aligned [left|right|center] in specified row.


 $Returns:    none.

 $Arguments:

*******************************************************************************/
void displayAlignedText( T_MMI_ALIGN x_alignment, USHORT y_lineNum, UBYTE attrib, char* string )
{
    int stringLength = 0;
    USHORT startXPos = 0;      // starting X pos for display

    dspl_DevCaps deviceCaps;

    dspl_GetDeviceCaps(&deviceCaps);

    /* 2003/11/27 sunsj get string length */
    //stringLength=wstrBitlen(string)*8;  //xsf changed to wstrBitlen 2003.01.23
    stringLength = get_StringWidth(string);

    switch( x_alignment )
    {
    case LEFT:

        break;

    case RIGHT:
        startXPos = (USHORT) deviceCaps.Width - stringLength /*- OneCharLen*/ ;
        break;

    case CENTER:
        if( (deviceCaps.Width - stringLength)>=0 )
            startXPos = (USHORT) (deviceCaps.Width - stringLength) / 2;
        else
            startXPos =0;   
        break;
#if(MAIN_LCD_SIZE==3)//jhxu720
	case CENTER_RIGHT://jhxu720 add
        if( (deviceCaps.Width - stringLength)>=0 )
            startXPos = (USHORT) (deviceCaps.Width - stringLength) / 2+22;
        else
            startXPos =0;   
        break;
#endif		

    }

    dspl_TextOut(startXPos, y_lineNum, attrib, (char*)string );
}

/*******************************************************************************
	$Function:		TruncateStringAddDot
	$Description:
	$Author:		Sunny
	$Date:			2004-05-09
*******************************************************************************/
void TruncateStringAddDot(char *strDest, char *strOrig, unsigned int Length)
{
	unsigned int real_lenth = 0, dspl_lenth = 0, strLength = 0;  
    unsigned char *ss = (unsigned char*)strOrig;
	U16 Temp_Char, HighByte, LowByte;
	
	strLength = get_StringWidth(strOrig);

	if(strLength > Length)
	{
		if(*(unsigned char*)strOrig == 0x80)//UNICODE
		{
			ss++;

			HighByte = (*ss & 0x00ff) << 8;
			LowByte = (*(ss+1) & 0x00ff);
			
			Temp_Char = HighByte | LowByte;
			
			while((Temp_Char) && (dspl_lenth < Length))
			{
				dspl_lenth += get_CharWidth( Temp_Char );
				ss += 2;
				HighByte = (*ss & 0x00ff) << 8;
				LowByte = (*(ss+1) & 0x00ff);
				
				Temp_Char = HighByte | LowByte;
				real_lenth += 2;
			}

			real_lenth -= 3;
			memcpy(strDest, strOrig, real_lenth);
			strDest[real_lenth] = 0x00;
			strDest[real_lenth + 1] = 0x2e;
			strDest[real_lenth + 2] = 0x00;
			strDest[real_lenth + 3] = 0x00;
		}
		else
		{
			while((*ss) && (dspl_lenth < Length))
			{
				dspl_lenth += get_CharWidth(*ss);
				ss += 1;
				real_lenth += 1;
			}

			real_lenth -= 2;
			memcpy(strDest, strOrig, real_lenth);
			strDest[real_lenth] = '.';
			strDest[real_lenth + 1] = 0x00;
		}
	}
	else
	{
		wstrncpy(strDest, strOrig, wstrlen(strOrig));
	}

}

/*******************************************************************************
	$Function:		DisplayAlignedAndTruncate
	$Description:
	$Author:		Sunny
	$Date:			2004-05-09
	$History		sunsj
					2004-05-19
*******************************************************************************/
void DisplayAlignedAndTruncate(T_MMI_ALIGN x_alignment, USHORT y_lineNum, USHORT length, UBYTE attrib, char* strtext)
{
	char text[50];
	int nLen = 0;

	if(*(unsigned char*)strtext == 0x80) //chinese don't truncate
	{
		if(get_StringWidth((char *)strtext) < length)
		{
			displayAlignedText(x_alignment, y_lineNum, attrib, strtext);
		}
		else
		{
			dspl_TextOut_Center(y_lineNum, length, attrib, strtext);
		}		
		return;
	}

	if(get_StringWidth((char *)strtext) < length)
	{
		displayAlignedText(x_alignment, y_lineNum, attrib, strtext);
	}
	else
	{
		TruncateStringAddDot(text, strtext, length);
		dspl_TextOut_Center(y_lineNum, length, attrib, text);
	}	
}

/*******************************************************************************

 $Function:  displayAlignedPrompt

 $Description:  Display prompt horizontally aligned [left|right|center] in specified row.

 $Returns:

 $Arguments:

*******************************************************************************/
void displayAlignedPrompt( T_MMI_ALIGN x_alignment, USHORT y_lineNum, UBYTE attrib, int string_id )
{
    int stringLength = 0;
    USHORT startXPos = 0;      // starting X pos for display
    dspl_DevCaps deviceCaps;
    char *Idtext;  //hxl add for get the stringlength

    dspl_GetDeviceCaps(&deviceCaps);

    //hxl start changed to wstrlen for unicode--------------------------
    Idtext=(char*)MmiRsrcGetText( string_id );

    /*talcon added*/
   if(Idtext == 0)
   	return;
   
    /* 2003/11/27 sunsj */
    //stringLength=wstrBitlen(Idtext);  //xsf changed wstrlen to wstrBitlen 2003.01.23
    stringLength = get_StringWidth(Idtext);

    //if(*Idtext==0x80)
    //	stringLength-=1; //delete the 0x80
    //end of hxl changed-----------------------------------------

    switch( x_alignment )
    {
    case LEFT:

        break;

    case RIGHT:
        /* 2003/11/10 sunsj */
        if( (deviceCaps.Width - stringLength) >= 0 )
        //if ( (deviceCaps.Width - (stringLength*8))>=0 )
        {
            /* 2003/11/10 sunsj */
            startXPos = (USHORT) deviceCaps.Width - stringLength;
            //startXPos = (USHORT) deviceCaps.Width - stringLength*8; //hxl changed to Char Length
        }
        else
            startXPos=0;    
        break;

    case CENTER:
        /* 2003/11/10 sunsj */
        if( deviceCaps.Width > stringLength )
        //if ( deviceCaps.Width>(stringLength*8) )
        {
            /* 2003/11/10 sunsj */
            startXPos = (USHORT) (deviceCaps.Width - stringLength) / 2;
            //startXPos = (USHORT) (deviceCaps.Width - stringLength*8) / 2;
        }
        else
            startXPos=0;
        break;
#if(MAIN_LCD_SIZE==3)//jhxu720
	case CENTER_RIGHT://jhxu720
        if( deviceCaps.Width > stringLength )
        {
			startXPos = (USHORT) (deviceCaps.Width - stringLength) / 2+22;
		}
        else
            startXPos=0;
        break;
#endif
    }

    PROMPT(startXPos, y_lineNum, attrib, string_id );
}
/*******************************************************************************

 $Function:  mainShutdown

 $Description:

 $Returns:    none.

 $Arguments:

*******************************************************************************/
/* added by clrobert */
#ifdef _INNOVATION_EMULATOR_
extern int g_bIsPowerOn;
extern int ModuleKey;
#endif


void mainShutdown(void)    ///zym revised
{

    TRACE_EVENT("mainShutdown ()");
    MmiTrace("mainShutdown");

    /* add by clrobert */
#ifdef _INNOVATION_EMULATOR_
    ModuleKey = -1;
    g_bIsPowerOn = 0;   
#endif
    /* add end */

	#if 1	/* Robert.Chen removed, 2004-05-05 */
	if( deregis ) 
	#endif 	/* Robert.Chen removed */
    {
        //---------------start: Mobile OFF-------------------
        TRACE_FUNCTION("                Mobile OFF");
        /* delete the state of mobile on   */
        globalMobileMode = globalMobileMode & (~GlobalMobileOn);

        deregis = FALSE;

        timStop(timlowvoltage);//hxl add 0905 for delete the timer-------------
        timDelete(timlowvoltage);

        //FfsWriteAllEvent();//hxl del for don't write when lowvoltage shutdown, 2003-6-8
        FieldTestExit();
        BaseWinExit();//hxl add for chargerwin entry 20020905

        /*    mmiExit();// RM 20-07 
            SIM_PowerOff();
        #ifndef _SIMULATION_
            AI_Power(0);
        #endif
        *///hxl moved it to switchoffmobile() 20020905-------

    }
}
/*******************************************************************************

 $Function:  globalBatteryUpdate

 $Description:  Update the value of the battery after the MME event

 $Returns:

 $Arguments:

*******************************************************************************/
int globalBatteryUpdate (U8 value)
{

    MmiModuleDel (ModuleBattLow);  /* delete the state */

    globalBatteryMode = GlobalBatteryGreater5;



    switch( value )
    {
    case 0:           /* battery low */
        globalBatteryMode = GlobalBatteryLesser5;

        /* is just a global status */
        MmiModuleSet (ModuleBattLow);  /* set the state */

        /* reject the SAT command if Battery low */
        //          if(MmiModule EQ ModuleSAT )
        //nm              satExec (SatRejectEvent,0); /*  */
        break;

    default:
        break;
    }

    return 0;
}


/*******************************************************************************

 $Function:  globalSignalUpdate

 $Description:Update the value of the fieldstrength after the MME event

 $Returns:

 $Arguments:

*******************************************************************************/
int globalSignalUpdate (U8 value)
{

    UBYTE   lastvalue;

    // sbh - it looks like the value we receive is the "no. of bars",
    // rather than the wider-ranging value expected here

    //begin xzy add for signal change 03/03/26

    if( globalSignalPicNumber==0 )
    {
        globalSignalPicNumber = value;
    }
    else
    {
        /*2003/12/29,talcon comment for outerIdle*/
        //if(idleIsFocussed())
        {
            GetSignalPicNumber();
        }

    }


    idleEvent(IdleUpdate);//hxl delete for show icon at idle_dialing window
    return 0;
}



/*******************************************************************************

 $Function:  globalFlashBattery

 $Description:   exit MMI main module

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void globalFlashBattery (void)   ///zym revised
{
    TRACE_FUNCTION(" globalFlashBattery ");
    idleEvent(IdleUpdate);


}

/*******************************************************************************

 $Function:  editShowHeader

 $Description:   displays the new character over the cursor

 $Returns:    none.

 $Arguments:

*******************************************************************************/
static void editShowHeader (void)
{
    char    alphachar;
    MfwEdt *edit = ((MfwHdr *) myHandle)->data;

    TRACE_EVENT("editShowHeader");

    //zgz,2002.7.3 edtCharf(myHandle,ecDel,0);  //zgz, del the char at cursor position, cp not be changed.
    edtSymbol(myHandle,ecDel);
    if( upCase )
        alphachar = editAlphaU[editAlphaKey][editAlphaLevel];
    else
        alphachar = editAlpha[editAlphaKey][editAlphaLevel];

    if( !(editAlphaMode && editAlphaKey != KCD_MAX) )
        alphachar= ' ';
    else if( editHiddenMode )                          // SH - in hidden mode...
        *(tmpBuf+edit->cp) = alphachar;                     // store character in buffer

#ifdef NO_ASCIIZ
    //zgz, if (Mmi_getCurrentLanguage() == CHINESE_LANGUAGE)
    //alphachar = alphachar << 8;
#endif
    // zgz, 2002.0627 debug for edtSymbol()
    //edtCharf(myHandle,alphachar,0);
    //edtChar(myHandle,ecLeft);
    edtSymbol(myHandle, alphachar);
    edtSymbol(myHandle, ecLeft);

}

/*******************************************************************************

 $Function:  editEventTim

 $Description:   executes the timer event from the edit component

 $Returns:    none.

 $Arguments:

*******************************************************************************/
static int editEventTim (MfwEvt e, MfwTim *t)
{
    char  *format = formatHandle;                       // SH - temporary format template

    TRACE_EVENT("editEventTim");

    if( !(editAlphaMode || editFormatMode) )
        return 1;

    // SH - modifications for format mode & hidden mode
    if( editFormatMode )                                                         // SH - advance format pointer when
    {
        if( editHiddenMode )
        {
            editCharFindNext('*');
            TRACE_EVENT("Password entered (format):");
            TRACE_EVENT(tmpBuf);
        }
        else
            //editCharFindNext(ecRight);
            edtSymbol(myHandle,ecRight);
    }
    else if( editHiddenMode )
    {
        edtChar(myHandle,'*');
        TRACE_EVENT("Password entered:");
        TRACE_EVENT(tmpBuf);
    }
    // end of modifications

    else
        //zgz,2002.7.3 edtChar(myHandle,ecRight);
        edtSymbol(myHandle,ecRight);

    editAlphaLevel = KEY_PAD_MAX-1;  //zgz, commented out this line
    editAlphaKey = KCD_MAX;

    return 1;
}


/*******************************************************************************

 $Function:  editEventKey  

 $Description:	 executes the timer event form the edit component

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
int editEventKey (MfwEvt e, MfwKbd *k)
{

    // over the editor handle "e" we have now the access to
    // the editor buffer "tb". We need it e.g "editCalcMode"
    // to check the buffer
    MfwEdt *edit = ((MfwHdr *) myHandle)->data;
    char *tb = edit->attr->text;

    UBYTE  ch = '.';

    char        *format = formatHandle;                                         // SH - temporary format template
    char        formatchar;                                                     // SH - Current format character
    char        alphachar;                                                      // SH - Current multi-tap character
    int         safetycounter;                                                  // SH - Stops searching forever to find compatible character
    char        test_string[40];
    BOOL        validCharacter;                                                 // SH - flag to indicate whether character is accepted

    TRACE_EVENT("editEventKey");

    // SH - formatted input mode (for WAP)

    if( editFormatMode )
    {
        sprintf(test_string,"cp: %d, size: %d, formatindex: %d", edit->cp, edit->attr->size, *formatIndex);
        TRACE_EVENT(test_string);

        if( k->code==KCD_HUP )                                                   // Escape from edit screen
            return 0;

        if( edit->cp >= (edit->attr->size) )                                 // If at last character of editor, don't
        {
            TRACE_EVENT("Last character.");
            return 1;                                                           // print character
        }

        formatchar = *(format+*formatIndex);

        sprintf(test_string, "formatchar: %c, editAlphaKey: %d, k->code: %d", formatchar, editAlphaKey, k->code);
        TRACE_EVENT(test_string);
        sprintf(test_string, "editAlphaLevel: %d", editAlphaLevel);
        TRACE_EVENT(test_string);

        if( formatchar == NULL )                                                 // If we've reached the end of the format string, don't allow input 
            return 1;

        if( (formatchar>'0' && formatchar<='9') || formatchar=='*' )             // Delimiter for format field
        {
            (*formatIndex)++;
            *fieldIndex     = 0;
            formatchar      = *(format+*formatIndex);                           // Next character is the format for the field
        }

        // Multi-tap input

        // The user presses a different key, meaning the previous character must be entered

        if( editAlphaKey != KCD_MAX && editAlphaKey != k->code )
        {
            timStop(editTim);

            alphachar = NULL;

            switch( formatchar )
            {
            case 'X':                                                       // Uppercase alphabetic only
            case 'A':                                                       // Uppercase alphabetic or punctuation
                alphachar = editAlphaU[editAlphaKey][editAlphaLevel];
                break;

            case 'x':                                                       // Lowercase alphabetic only
            case 'a':                                                       // Lowercase alphabetic or punctuation
                alphachar = editAlpha[editAlphaKey][editAlphaLevel];
                break;

            case 'M':
            case 'm':
                if( upCase )
                    alphachar = editAlphaU[editAlphaKey][editAlphaLevel];
                else
                    alphachar = editAlpha[editAlphaKey][editAlphaLevel];
                break;
            }

            if( alphachar!=NULL )
            {
                if( editHiddenMode )                                 // SH - in hidden mode...
                {
                    *(tmpBuf+edit->cp) = alphachar;                         // store character in buffer
                    TRACE_EVENT("Password entered (format):");
                    TRACE_EVENT(tmpBuf);
                    alphachar = '*';                                // ...and show star
                }
                editCharFindNext(alphachar);                                    // Add number to buffer & advance cursor
                editAlphaLevel = KEY_PAD_MAX-1;
                editAlphaKey = KCD_MAX;
                if( edit->cp >= (edit->attr->size) )                         // If at last character of editor, don't
                    return 1;                                                   // allow another character

            }
        }

        formatchar = *(format+*formatIndex);

        if( k->code <= KCD_9 )                                                   // Key pressed is 0 - 9.
        {

            // Numeric

            if( formatchar == 'N' )                                              // A numeric digit is expected
            {
                if( editHiddenMode )
                {
                    *(tmpBuf+edit->cp) = editControls[k->code];
                    editCharFindNext('*');
                }
                else
                    editCharFindNext(editControls[k->code]);                        // Add number to buffer & advance cursor
                editAlphaLevel = KEY_PAD_MAX-1;                                 // Reset multi-tap settings
                editAlphaKey = KCD_MAX;
                return 1;
            }

            // Multi-tap alphanumeric

            alphachar = NULL;

            if( !strchr("XxAaMm",formatchar) )                                   // If not a valid format code, exit
                return 1;

            if( strchr("Xx",formatchar) && k->code<KCD_2 )                       // 0 and 1 keys not valid in these modes
                return 1;

            editAlphaKey = k->code;                                             // Store the key pressed
            editAlphaLevel++;                                                   // Increment through list of symbols
            if( editAlphaLevel > (KEY_PAD_MAX-1) )                               // List wraps round
                editAlphaLevel = 0;

            safetycounter = 0;
            while( alphachar==NULL && safetycounter<KEY_PAD_MAX )
            {
                validCharacter = FALSE;

                switch( formatchar )
                {
                case 'X':
                    alphachar = editAlphaU[editAlphaKey][editAlphaLevel];   // Uppercase...
                    validCharacter = (alphachar>='A' && alphachar<='Z');    // ...alphabetic only
                    break;

                case 'x':
                    alphachar = editAlpha[editAlphaKey][editAlphaLevel];    // Lowercase
                    validCharacter = (alphachar>='a' && alphachar<='z');    // ...alphabetic only
                    break;

                case 'A':
                    alphachar = editAlphaU[editAlphaKey][editAlphaLevel];   // Uppercase...
                    validCharacter = (alphachar<'0' || alphachar>'9');      // ..non-numeric
                    break;

                case 'a':
                    alphachar = editAlpha[editAlphaKey][editAlphaLevel];    // Lowercase...
                    validCharacter = (alphachar<'0' || alphachar>'9');      // ..non-numeric
                    break;

                case 'M':
                case 'm':
                    if( upCase )                                             // User-selected case...
                        alphachar = editAlphaU[editAlphaKey][editAlphaLevel];
                    else
                        alphachar = editAlpha[editAlphaKey][editAlphaLevel];
                    validCharacter = TRUE;                                  // ...any character accepted
                    break;
                }

                if( !validCharacter )                                            // If character isn't uppercase alphabetic,
                {
                    // find the next one that is,
                    alphachar = NULL;
                    safetycounter++;                                            // (but don't search forever)
                    editAlphaLevel++;
                    if( editAlphaLevel > (KEY_PAD_MAX-1) )
                        editAlphaLevel = 0;
                }
            }

            if( alphachar!=NULL )                // If we've found a character, and string isn't max size
            {
                if( editHiddenMode )
                {
                    *(tmpBuf+edit->cp) = alphachar;
                }
                edtChar(myHandle,alphachar);
                edtChar(myHandle,ecLeft);
                timStart(editTim);
            }
            else
                editAlphaKey = KEY_MAX;
            return 1;
        }

        if( k->code==KCD_HASH )                                                  // Hash key
        {
            if( strchr("AaMm",formatchar) )
            {
                if( editHiddenMode )
                {
                    *(tmpBuf+edit->cp) = ' ';
                    editCharFindNext('*');
                }
                else
                    editCharFindNext(' ');                                      // Prints a space in this mode
            }
            return 1;
        }

        if( k->code==KCD_STAR )                                                  // Star key
        {
            if( strchr("AaMm",formatchar) )
            {
                if( editHiddenMode )
                {
                    *(tmpBuf+edit->cp) = '*';
                }
                editCharFindNext('*');
            }
            return 1;
        }

        return 1;
    }

    // SH - End of formatted input mode

    if( editAlphaMode )
    {
        TRACE_EVENT("alphaMode");
        if( editAlphaKey != KCD_MAX && editAlphaKey != k->code ) //zgz, when the cursor is still not right, we press other key
        {
            timStop(editTim);

            //editShowHeader();  // zgz, change it.
            edtCharf(myHandle,ecRight,0);

            editAlphaLevel = KEY_PAD_MAX-1;
            editAlphaKey = KCD_MAX;
        }

        if( k->code <= KCD_HASH )
        {
            editAlphaLevel++;
            if( editAlphaLevel > (KEY_PAD_MAX-1) )
                editAlphaLevel = 0;
            if( editAlphaKey == KCD_MAX )                        // Inserting a new character
            {

                TRACE_EVENT("zgz, editAlphaKey is KCD_MAX");
                alphachar = (int)' ';
#ifdef NO_ASCIIZ
                //zgz, if (Mmi_getCurrentLanguage() == CHINESE_LANGUAGE)
                //zgz, alphachar = alphachar << 8;
#endif
                //zgz,2002.7.3 edtCharf(myHandle,alphachar,0);
                //zgz,2002.7.3 edtCharf(myHandle,ecLeft,0);						// Move cursor back for further multi-tap            
                edtSymbol(myHandle,alphachar);
                edtSymbol(myHandle,ecLeft);
#if 0                //following is patch from 1331 ganchh 2002/8/26
                /* NM p01306
                   the patch p027 to reduce calling the edtChar as less as possible 
                   was not working for inserting characters.
                   This additional change should work now:
                */
                if( edit->attr->text[0] & 0x80 )
                {
                    moveRight(edit->attr->text + edit->cp,strlen(edit->attr->text + edit->cp),2);                   
                }
                else
                {
                    moveRight(edit->attr->text + edit->cp,strlen(edit->attr->text + edit->cp),1);
                }
                /* NM p01306 END */
#endif
            }
            editAlphaKey = k->code;
            editShowHeader();
            timStart(editTim);
            return 1;
        }
    }
    switch( k->code )
    {
    case KCD_HUP:
        return 0;
    case KCD_HASH:
        /* KGT: If not in an alpha mode insert blanc. 
                    But in numeric mode insert '#'. */
        if( editAlphaMode )
        {
            alphachar = ' ';
            editShowHeader();
        }
        else
        {
            if( editCalcMode )
            {
                if( !(strchr(tb, ch )) ) /* set '.' only once ! */
                    alphachar = '.';
            }
            else
                alphachar = '#';
        }
        /* end KGT */

        // SH - hidden mode
        if( editHiddenMode )
        {
            *(tmpBuf+edit->cp) = alphachar;
            alphachar = '*';
        }
        // end of hidden mode
#ifdef NO_ASCIIZ
        if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
            alphachar = alphachar << 8;
#endif
        edtChar(myHandle,alphachar);
        return 1;

    case KCD_STAR:

        if( editCalcMode )
        {
            if( !(strchr(tb, ch )) ) /* set '.' only once ! */
                edtChar(myHandle,'.');
        }
        else
        {
            if( !editAlphaMode )
                edtChar(myHandle,'*');
            else
            {
                editShowHeader();
                alphachar = '*';
                // SH - hidden mode
                if( editHiddenMode )
                {
                    *(tmpBuf+edit->cp) = alphachar;
                }
                // end of hidden mode

#ifdef NO_ASCIIZ
                if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
                    alphachar = alphachar << 8;
#endif
                edtChar(myHandle,alphachar);
            }
        }

        return 2;                                   // SH -  2 indicates that character WAS printed
        /*
        case KCD_ABC:
            editAlphaMode = (UBYTE) !editAlphaMode;
            if (editAlphaMode)
            {
                editAlphaLevel = KEY_PAD_MAX-1;
                editAlphaKey = KCD_MAX;
            }
            editShowHeader();
            return 1;
            */
    default:
        if( editAlphaMode )
        {
            timStop(editTim);
            edtChar(myHandle,ecRight);
            return 1;
        }
        break;
    }

    // SH - hidden mode
    if( editHiddenMode )
    {
        *(tmpBuf+edit->cp) = editControls[k->code];
        edtChar(myHandle,'*');
    }
    // end of hidden mode
    else
        edtChar(myHandle,editControls[k->code]);

    return 1;
}


/*******************************************************************************

 $Function:  editClear

 $Description:  SH - For formatted input, clears everything except fixed characters

 $Returns:

 $Arguments:

*******************************************************************************/

void editClear()
{
    int editIndex = 0;
    MfwEdt *edit = ((MfwHdr *) myHandle)->data;
    char *tb = edit->attr->text;

    *formatIndex = -1;                              // Find first non-fixed character,
    edtChar(myHandle,ecTop);                          // starting from the top.
    editCharFindNext(NULL);

    while( edit->cp <strlen(tb) )
    {
        editCharFindNext(' ');                            // Overwrite everything with spaces
    }
    edtChar(myHandle,ecTop);
    *formatIndex = -1;
    editCharFindNext(NULL);                             // Return to the first non-fixed character

    return;
}


/*******************************************************************************

 $Function:  editCharFindNext

 $Description:  SH - For formatted input, adds a character to the input buffer then finds
        the next non-fixed character space for the cursor to occupy

 $Returns:

 $Arguments:  character - the character (or code) to print

*******************************************************************************/

void editCharFindNext(char character)
{
    char  *format = formatHandle;                       // SH - temporary format template
    char  formatchar;
    MfwEdt  *edit = ((MfwHdr *) myHandle)->data;
    char  test_string[40];
    UBYTE inField = 0;                // =1 if entering field, =2 if in field

    TRACE_EVENT("editCharFindNext");

    // Check for delimited field

    if( *formatIndex>0 )
    {
        formatchar = *(format+*formatIndex-1);
        if( (formatchar>'0' && formatchar<='9') || formatchar=='*' )
            inField = 2;
    }

    formatchar = *(format+*formatIndex);
    if( (formatchar>'0' && formatchar<='9') || formatchar=='*' )
        inField = 1;

    // Check for cursor right at end of string - don't allow

    if( character == ecRight && edit->cp >= strlen(edit->attr->text) && *formatIndex>-1 && inField==0 )
    {
        return;
    }

    if( character!=NULL )                            // First add the required character
    {
        edtChar(myHandle, character);                     // to the buffer
    }
    // Check for start of fixed input field

    if( inField==1 )
    {
        (*formatIndex)++;                           // Get us into the field...
        *fieldIndex = 0;                            // ...and reset the field index
        formatchar = *(format+*formatIndex);
        if( formatchar=='M' )
            upCase = TRUE;
        if( formatchar=='m' )
            upCase = FALSE;
        inField = 2;
    }

    // Check whether we're in a fixed input field, e.g. "4N" or "8X"

    if( inField==2 )                             // So we don't look back beyond start of string
    {
        (*fieldIndex)++;                          // Increment the position in the field
        if( *fieldIndex==(int)(formatchar-'0') )               // If we've entered the number of characters specified (note- will never happen for the '*' !)
        {
            (*formatIndex)++;                       // point to NULL at end of string (no more input)
        }
        return;
    }

    // If not, just look at next format character as usual

    (*formatIndex)++;                             // Point to next character

    while( *formatIndex<strlen(format) && *(format+*formatIndex) == '\\' )   // Fixed characters encountered
    {
        edtChar(myHandle,ecRight);                        // Skip over them
        (*formatIndex)+=2;
    }

    if( *formatIndex>(strlen(format)) )                      // Don't look beyond end of string
        *formatIndex = strlen(format);

    return;
}


/*******************************************************************************

 $Function:  editFindPrev 

 $Description:	SH - For formatted input, finds the previous non-fixed character and
                moves the cursor there if possible

 $Returns:		0 if the cursor position is not changed (nowhere to go)
                1 if the previous character has been found
                2 if the cursor was over the first non-fixed character

 $Arguments:	
 
*******************************************************************************/

int editFindPrev()
{
    char    *format     = formatHandle;                                         // SH - temporary format template
    int     editIndex;
    char    formatchar;
    MfwEdt  *edit = ((MfwHdr *) myHandle)->data;

    TRACE_EVENT("editFindPrev");

    if( edit->cp == 0 )                                                          // If cursor is at start of string, return 2
    {
        TRACE_EVENT("Exit - start of string found");
        //sprintf(stringTrace, "formatIndex, fieldIndex: %d, %d", *formatIndex, *fieldIndex);
        //TRACE_EVENT(stringTrace);
        return 2;
    }
    // First check whether we're in a fixed input field, e.g. "4N" or "8X"

    if( *formatIndex>0 )                                                         // So we don't look back beyond start of string
    {
        formatchar = *(format+*formatIndex-1);
        if( (formatchar>'0' && formatchar<='9') || formatchar=='*' )             // If it's a number between 1 and 9, or a *
        {
            TRACE_EVENT("In delimited field.");
            edtChar(myHandle,ecLeft);
            if( edit->cp < edit->attr->size-1 )                                  // (Don't decrement if at last char in string)
                (*fieldIndex)--;                                                // Decrement the position in the field

            if( *fieldIndex==0 )                                                 // If we've reached the beginning of the field
            {
                TRACE_EVENT("Getting out of field.");
                (*formatIndex)--;                                               // Get out of the field
            }

        //    sprintf(stringTrace, "formatIndex, fieldIndex: %d, %d", *formatIndex, *fieldIndex);
           // TRACE_EVENT(stringTrace);

            if( edit->cp==(strlen(edit->attr->text)-1) )     // Special case if last character - tell editor to shorten the string
            {
                TRACE_EVENT("Shorten string");
                return 3;
            }

            return 1;                                                           // then we're done
        }
    }

    // If not (or if we've just come out of one) just look at next format character as usual

    editIndex   = *formatIndex-1;                                               // Make copy of format position, starting off to left

    while( editIndex>0 )
    {
        if( *(format+editIndex-1)=='\\' )                                        // If there's a fixed char
            editIndex -=2;                                                      // Look back a further 2 characters
        else                                                                    // If there's a non-fixed character
            break;                                                              // then exit loop
    }

    if( editIndex==-1 )                                                          // Go back from 1st character in editor
    {
        TRACE_EVENT("Exit - skipped over fixed character");
        //sprintf(stringTrace, "formatIndex, fieldIndex: %d, %d", *formatIndex, *fieldIndex);
        //TRACE_EVENT(stringTrace);
        return 2;
    }

    formatchar = *(format+editIndex-1);                                         
    if( (formatchar>'0' && formatchar<='9') || formatchar=='*' )
        (*fieldIndex)--;

    if( editIndex>-1 )                                                           // Provided there is somewhere to go....
    {
        while( *formatIndex>editIndex )
        {
            if( edtChar(myHandle,ecLeft)==MfwResOk )                             // move cursor there
                (*formatIndex)--;
            if( *(format+*formatIndex)=='\\' )
                (*formatIndex)--;
        }
        TRACE_EVENT("Found new position.");
        //sprintf(stringTrace, "formatIndex, fieldIndex: %d, %d", *formatIndex, *fieldIndex);
        //TRACE_EVENT(stringTrace);
        return 1;                                                               // Found new position
    }
    TRACE_EVENT("Position unchanged.");
    //sprintf(stringTrace, "formatIndex, fieldIndex: %d, %d", *formatIndex, *fieldIndex);
    //TRACE_EVENT(stringTrace);
    return 0;                                                                   // Position unchanged
}


/*******************************************************************************

 $Function:  editActivate  

 $Description:	 Activates the edit component

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
void editActivate (MfwHnd e, int AlphaMode)
{
    TRACE_EVENT("editActivate");

    myHandle = e;
    if( !editTim )
        TIMCREATE_SETFLLAG(editTim = timCreate(0,1000,(MfwCb) editEventTim);)
    editAlphaMode = ((AlphaMode != 0) && (AlphaMode != 4) && (AlphaMode != 5));
    editCalcMode  = (AlphaMode == 4);
    editFormatMode = (AlphaMode == 6);
    editHiddenMode = FALSE;
    editAlphaLevel = KEY_PAD_MAX-1;
    editAlphaKey = KCD_MAX;
}


/*******************************************************************************

 $Function:  editHiddenActivate

 $Description:   SH - Activates the edit component for hidden alphanumeric entry

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void editHiddenActivate (char *buffer)
{
    TRACE_EVENT("editHiddenActivate");
    tmpBuf = buffer;
    editHiddenMode = 1;
    return;
}

/*******************************************************************************

 $Function:  editDeactivate

 $Description:   deactivates the edit component

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void editDeactivate (void)
{
    myHandle = 0;

    if( editTim )
    {
        timStop(editTim);
        timDelete(editTim);
    }
    editTim = 0;
}
/*******************************************************************************

 $Function:  activeEditor

 $Description:   deactivates the edit component

 $Returns:    none.

 $Arguments:

*******************************************************************************/
MfwHnd activeEditor (void)
{
    return myHandle;
}

/*******************************************************************************

 $Function:  MmiModuleSet

 $Description:   Set the status

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void MmiModuleSet (int module)
{
    switch( module )
    {
    case ModuleIdle:
        MmiModule = MmiModule & ModuleBattLow;
        MmiModule = MmiModule | ModuleIdle;
        break;
    case ModuleInCall:
        MmiModuleDel(ModuleIdle);
        MmiModule=MmiModule | ModuleInCall;
        break;
    case ModuleCall:
        MmiModuleDel(ModuleIdle);
        MmiModule=MmiModule | ModuleCall;
        break;
    case ModuleMenu:
        MmiModuleDel(ModuleIdle);
        MmiModule=MmiModule | ModuleMenu;
        break;
    case ModulePhon:
        MmiModuleDel(ModuleIdle);
        MmiModule=MmiModule | ModulePhon;
        break;
    case ModuleSms:
        MmiModuleDel(ModuleIdle);
        MmiModule=MmiModule | ModuleSms;
        break;
    case ModuleBattLow:
        MmiModule=MmiModule | ModuleBattLow;
        break;
    case ModuleSAT:
        MmiModuleDel(ModuleIdle);
        MmiModule=MmiModule | ModuleSAT;
        break;
    case ModuleAlarm:
        MmiModuleDel(ModuleIdle);
        MmiModule=MmiModule | ModuleAlarm;
        break;
    case ModuleFax:
        MmiModule=MmiModule | ModuleFax;
        break;
    case ModuleDialling:
        MmiModuleDel(ModuleIdle);
        MmiModule=MmiModule | ModuleDialling;
        break;
    default:
        break;
    }

    return;

}

/*******************************************************************************

 $Function:  MmiModuleDel

 $Description:  Delete the status

 $Returns:    none.

 $Arguments:

*******************************************************************************/
void MmiModuleDel (int module)
{
    switch( module )
    {
    case ModuleIdle:

        MmiModule = MmiModule & (~ModuleIdle);
        break;
    case ModuleInCall:
        MmiModule=MmiModule & (~ModuleInCall);
        break;
    case ModuleCall:
        MmiModule=MmiModule & (~ModuleCall);
        break;
    case ModuleMenu:
        MmiModule=MmiModule & (~ModuleMenu);
        break;
    case ModulePhon:
        MmiModule=MmiModule & (~ModulePhon);
        break;
    case ModuleSms:
        MmiModule=MmiModule & (~ModuleSms);
        break;
    case ModuleBattLow:
        MmiModule=MmiModule & (~ModuleBattLow);
        break;
    case ModuleSAT:
        MmiModule=MmiModule & (~ModuleSAT);
        break;
    case ModuleAlarm:
        MmiModule=MmiModule & (~ModuleAlarm);
        break;
    case ModuleFax:
        MmiModule=MmiModule & (~ModuleFax);
        break;
    case ModuleDialling:
        MmiModule=MmiModule & (~ModuleDialling);
    default:
        break;
    }

    return;

}

/*******************************************************************************

 $Function:     showGoodBye

 $Description:   shows a goodbye Message when swiching off the mobile

 $Returns:    none

 $Arguments:

*******************************************************************************/


void showGoodBye (T_MFW_HND win)   ///zym revised
{
    T_DISPLAY_DATA   display_info;
    T_MFW_HND dialogwin;

	MMI_TRACE_EVENT(("Sunny----Show Goodbye Function: showGoodBye"));

	/*2004/04/23,talcon add*/
	//2004-04-26 Sunny remove
	//nm_deregistration();        /* start deregistration procedure   */
	
    //2004.4.4 WYJ modify
    StartPlayByReason(POWEROFFPLAY, 0);

	/* Robert.Chen added, 2004-05-08, fixed detach problem */
	nm_deregistration();
	/* end */
	
    dialog_info_init(&display_info);    
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = '\0';
    display_info.TextId       = '\0';
    display_info.TextId2      = '\0';
    display_info.TextString   = "\0";
    display_info.TextString2   = '\0';
    display_info.Time         = 3000;	/* Robert.Chen, 2004-05-08, this timer can't less than 3s to avoid uncomplete detach procedure */
    display_info.Callback     = (T_VOID_FUNC)goodbye_cb;
    display_info.KeyEvents    = 0;
    display_info.Identifier=    StartSwitchoffDialog;

    /*
     * Call Icon
     */
    dialogwin=info_dialog (win, &display_info);
    dspl_ClearAll();/*2003/12/1, wangyan modify*/
	if(dialogwin == NULL)return;
	
	//2004-04-21 Sunny add 
	IsShowGoodbye = TRUE; 
	switch(FFS_flashData.onoffanimation) 
	{
	case 0://default
		mmi_dialogs_insert_fixmov_animation(dialogwin, 500 ,GOODBYEANIM);
		break;
	case 1://Mobileinnovation			
		break;
	case 2://flower
		mmi_dialogs_insert_fixmov_animation(dialogwin, 500 ,GOODBYEANIM);
		break;
	case 3://Skyrocket
		break;
	}	
	//2004-04-21 Sunny add end
}

/*******************************************************************************

 $Function:     goodbye_cb

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/


void goodbye_cb (void)
{
	MMI_TRACE_EVENT(("Sunny----Switch Off. Function: goodbye_cb"));

	#if 0	/* Robert.Chen removed, 2004-05-08, replace detach procedure before showing goodbye animation */
    nm_deregistration();        /* start deregistration procedure   */
	#endif
	
    BaseWinExit();
	
    /* add by clrobert */
#ifdef _INNOVATION_EMULATOR_
    ModuleKey = -1;
    g_bIsPowerOn = 0;   
#endif
    /* add end */
}

/*******************************************************************************

 $Function:    	setformatpointers

 $Description:	SH - Sets static variables formatHandle and formatIndex, so thet editEventKey
                can access the format string
 
 $Returns:		

 $Arguments:	Pointer to format string, pointer to format index
                
*******************************************************************************/


void setFormatPointers (char *format, int *index, int *index2)
{
    //char test_string[40];

    TRACE_EVENT("setFormatPointers");
    formatHandle = format;
    formatIndex = index;
    fieldIndex = index2;
    //sprintf(test_string, "index %d, offset %d", (int) *index, (int) *index2);
    //TRACE_EVENT(test_string);
    return;
}


/*************************zym added****************************************/


/* 2004/03/31 sunsj modify */
static int vibratorEvent (MfwEvt e, MfwTim *t)
{
    int i;
    uint16  old_batvoltage=0;

    if( lcdOffControl == 0 )
    {
		/* 2004/04/06 sunsj modify */
		if( GetHallStatus() == 1 )
		{
			/* 2004/06/02 sunsj modify */
			timStop(gtVibator);
			timStart(gtVibator);
			lcdOffControl = 1;
		}
        else
        {
			timStop(gtVibator);
            LedLightnessAdjust( 0 );
            lcdOffControl = 0;            
        }       
    }
	else if( lcdOffControl == 1 )
	{
		/* 2004/06/02 sunsj modify */
		timStop(gtVibator);
		timStart(gtVibator);
		LedLightnessAdjust(100);	/* Robert.Chen add, 2004-04-20 */
		lcdOffControl = 2;
    }
	else
    {
		timStop(gtVibator);
        LedLightnessAdjust(10);	/* Robert.Chen changed lightness setting, 2004-04-20 */
        lcdOffControl = 0;            
    }

    if( lcdOffControl == 2 )
        Backlight_OFF();
   
    return 1;
}

/* 2004/06/10 sunsj modify */
void   MMIActionKeyPress(void)
{
    if( g_lcd_game_flag && game_win_focussed() )
    {
        timStop(gtVibator);
        Backlight_OFF();
        LedLightnessAdjust(0);//zy //12/02
    }
    else
    {
        if( !timFindOut (gtVibator) )
        {
            Backlight_ON();
            //LCD_ON();//glowing, 2004-2-26, comment it
            LedLightnessAdjust(200);//zy 08/14
            MMI_TRACE_EVENT(("glowing:MMIActionKeyPress-before timStart"));
            timStart(gtVibator);//zy 08/15for if tim is runing needn't run again
        }
		/* 2004/03/31 sunsj modify */
        if( lcdOffControl == 2 )
        {
            Backlight_ON();
            LedLightnessAdjust( 200 );//zy //12/02
            timStart(gtVibator);
        }
        else
        {
            Backlight_ON();
        }
    }
    lcdOffControl = 0;
} //MMIActionKeyPress     

/*2004/05/15,talcon add*/
void set_lcdOffControl(int status)
{
	lcdOffControl = status;
}
//------------------------------
void   MMIActionKeyPress_flip(void)
{
    //glowing,2004-02-11, add the following block
    lcdOffControl = 0;
    //LCD_ON();//glowing, 2004-2-26, comment it
    LedLightnessAdjust(200);//zy 08/14
    timStart(gtVibator);//zy 08/15for if tim is runing needn't run again
} //MMIActionKeyPress 






/*************************zym added****************************************/
//start, hxl add for charger 29/08/02---------------------------------------------

static int tim_LowVoltage_cb (MfwEvt e, MfwTim *t)
{
    MmiTrace("tim_LowVoltage_cb");
    /* 2004/06/10 sunsj remove */
    if( g_kpdtim )
    {
        g_kpdtim = 0;
        g_kpdnum = 0;
    }
    else
    {
        if( g_switchon != 1 )
        {
            if( bat_voltage_info.shutdown )
            {
                deregis=TRUE;
                mainShutdown();
            }
            else
            {
#ifdef MMS_WAP_ENABLED
{
extern void mms_pushfile_exit();
	mms_pushfile_exit();
}
#endif

#ifdef _MMS_ENABLE_
	MMS_Exit();
#endif
                if( getWriteflag()==1 )
                {
                    FfsWriteAllEvent();//hxl add for save ffs file when bat low warning,2003-4-11
                    setWriteflag(0);//hxl add for write ffs all,2003-5-6  
                }
                /*
                begin of//zy 2003-02-14 add for 
                if lowvoltage is on and the before win is call scratched win We must destroy it
                */
                if( call_data.win_scratch )
                {
                    SEND_EVENT(call_data.win_scratch, CALL_SCRATCHPAD_DESTROY, 0, 0);
                }
                /*
                end of//zy 2003-02-14 add for 
                if lowvoltage is on and the before win is call scratched win We must destroy it
                */
                LowVoltageWarningDialog();
                //PROMPT(24,48,DSPL_TXTATTR_WHITE_EDGE,TxtNeedCharging);
                //StartTonebypara(1);  xsf changed 2002.12.31
                //StartPlayByReason(NEEDCHARGE,0);
            }
        }
    }
}

void LowVol_Warning(void)
{
    MmiTrace("LowVol_Warning");

    bat_voltage_info.shutdown=0;
    if( (timlowvoltage)&&(!ChargerPlugIn()) )
        timStart(timlowvoltage);
    else
        setWriteflag(1);//hxl add for write ffs all,2003-5-6  

}

void LowVol_Poweroff(void)
{
    MmiTrace("LowVol_Poweroff()");

    if( !ChargerPlugIn() )
    {
        pwr_Status.switchoffflag =1;
        bat_voltage_info.shutdown=1;

        //power down
        deregis=TRUE;
        nm_deregistration();
		
		//2004-04-01 Sunny add for Switch off dialog
		LowVoltageSwitchOffDialog();        
        if( timlowvoltage )
		{
			timSetTime(timlowvoltage,5000);
            timStart(timlowvoltage);
		}
		//2004-04-01 Sunny add for Switch off dialog end 
    }

}

void bat_info_init(void)
{
    bat_voltage_info.batchanged=0;
    bat_voltage_info.remain_capacity=0;
    bat_voltage_info.shutdown=0;

    //	Get_bat_voltage(&(pwr_Status.bat_voltage),&(pwr_Status.remain_capacity)); 
    bat_voltage_info.remain_capacity=pwr_Status.remain_capacity;

    GetBatPicnum();

}

static void setWriteflag(uint8  iswrite)
{
    ffsNeedWrite=iswrite;
}
static uint8 getWriteflag(void)
{
    return ffsNeedWrite;
}

//end of hxl add for charger 29/08/02--------------------------------------------
