/******************************************************************************

 $Project name:	Basic MMI                                                      
 $File:		    tdouterIdle.c
 $Author:		talcon  hu                                                        
 $Date:		    2003-12-12                                                      
 $Description:ʵimplement file
                
 $History: 

*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_cm.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"




#include "dspl.h"
#include "MmiMmi.h"

#include "ksd.h"
#include "psa.h"


#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

#include "MmiMain.h"
#include "MmiStart.h"

#include "MmiMenu.h"

#include "MmiBookController.h"
#include "MmiBookUtils.h"

#include "MmiCall.h"
#include "MmiNetwork.h"
#include "MmiIcons.h"
#include "MmiEditor.h"


#include "MmiSounds.h"
#include "MmiUserData.h"
#include "MmiSoftKeys.h"
#include "MmiPins.h"

#include "MmiDialogs.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSettings.h"
#include "MmiSmsIdle.h"
#include "mfw_ffs.h"
#include "MmiSmsBroadcast.h"
#include "MmiCPHS.h"
#ifdef MMI_HOMEZONE_ENABLED
    #include "MmiHomezone.h"	/* SPR759 - SH*/
#endif
#include "gdi.h"
#include "audio.h"
#include "GameDisplay.h"//zy add 09/18

#include "cus_aci.h"
#include "p_sim.h"
//GW-Remove? #include "pcm.h"
#include "pwr.h" //hxl add for charger
#include "mmicharging.h"
#include "mmiservices.h" //wufei add 
#include "fieldtest.h"
#include "L1tm_cust_add.h"	//hxl add for pcsync 2003-1-5

#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
    #include "mmiqq.h" 
#endif
#include "td.h"
/*2003/11/20,talcon add */
//#define TDTRACE 1
#include "mmiutilapi.h"

#include "mmiouterIdle.h"
#include "mmiiconresource.h"
#include "..\bmi\icons\OuterScreenIcn.h"//shiheng 0810 add
#ifndef OUTERIDLE_FOR_FTA

    #define TIME_OUTERIDLEANIM	700
T_outerIdle outerIdledata;
static U32 GlobalIconStatus_Outer; //2004/03/11 Sunny add
static U32 GlobalStatusNeedAnimation;//2004-04-22 Sunny add
static char *GlobalPar_Outer;

static UBYTE    IsMissedCallAndSms = 0;//2004-04-02 Sunny add
extern UBYTE OlderCurrentBatPicNum; //2004-04-01 Sunny add
extern int NotCharingMode;	/* 2004/07/05 sunsj modify */
extern T_idle idle_data; // 2004/07/12 yhf add
//private
int outerIdle_tim (MfwEvt e, MfwTim *t);
int outerIdleRefresh_tim(MfwEvt e, MfwTim *t);//2004/03/11 Sunny add
void drawOuterIdleZone1();
void drawOuterIdleZone2();
void drawOuterIdle();
void drawOuterIdleMissedCallAndSms();//2004-04-02 Sunny add

//2004/03/11 Sunny add
void DrawOuterNotifyIcon(); 
void DrawOuterSeceneMode(U8 scenestatus);
void InitialIconState();
void DisplayIncomingCall(char *par);//2004/03/23 Sunny add
//2004/03/11 Sunny add end 

//extern declareation 
extern const MfwIcnAttr OTsmsicns[];
extern pwr_Status_Type pwr_Status;
extern  UBYTE CurrentBatPicNum;
extern  UBYTE   BlinkBatPicnum;//2004-03-20 Sunny add

/* zhq, 2004/07/08, add for we use pin_outer_wait to init sub screen
and we do not refresh untile main screen drawIdle. */
extern UBYTE main_sreen_init_complete;


extern void GetTimeDate(int year,short month,short day,TIMEDATE *today);
extern int iconsShowSignal_Sub (U8 signalstatus);
extern void  SetChargingIcon_Sub( U8 BatteryCount);
extern void GetBatPicnum(void);
extern void draw_popup_background_sub(void);//2004-04-01 Sunny add

/* 2004/04/16 sunsj add */
int DisplayOuterNumber(int coor_x, int coor_y, int iconwidth, int iconheight, void * BmpPtr);
int DisplayOuterDate(char *date);
int DisplayOuterTime(char *time, int time_type_flag);
void InitNeedAnimID();
void DrawAnimation(U8 index);
void GetTimeString(char * line);

void outerIdleInit()
{
    GlobalIconStatus_Outer = 0; //2004/03/11 Sunny add
    InitialIconState();//2004/03/11 Sunny add
    memset(&outerIdledata,0,sizeof(outerIdledata) );
    outerIdledata.outeridletimer = timCreate(0,TIME_OUTERIDLEANIM,(MfwCb)outerIdle_tim);
    //2004-03-20 Sunny remove
    //outerIdledata.chargetimer = timCreate(0,1000,(MfwCb)outerIdleCharge_tim);
    outerIdledata.refreshtimer = timCreate(0,1000,(MfwCb)outerIdleRefresh_tim);
    /* 2004/07/08 sunsj remove. Outer lcd initialize before ffs, so the wallpaper of outer idle is always 0. */
    //setOuterState(OUTERIDLESTATE_REFRESH,1,0);

    InitNeedAnimID(); //2004-04-22 Sunny add
}//

void outerIdleExit()
{
    timDelete(outerIdledata.outeridletimer);
    //timDelete(outerIdledata.chargetimer);//2004-03-20 Sunny remove
}
/****************************************
$Descriptio:timer
******************************************/
int outerIdle_tim (MfwEvt e, MfwTim *t) 
{
    U8 uScreenType;
    timStop(outerIdledata.outeridletimer);

    if( outerIdledata.nAnimTimes != -1 ) //-1:forever
    {
        if( outerIdledata.nAnimTimes==0 )
        {
            setOuterState(outerIdledata.nIdleCurState,0,0);//2004-03-23 Sunny modify
            return 1;
        }
        else if( outerIdledata.nAnimTimes >0 )
        {
            outerIdledata.nAnimTimes --;
        }
    }

    //2004-04-22 Sunny add
    if( !(outerIdledata.nIdleCurState & outerIdledata.nIdleState) )
    {
        return 1;//stop
    }

    DrawAnimation(outerIdledata.nIdxAnim);
    outerIdledata.nIdxAnim++;
    outerIdledata.nIdxAnim = outerIdledata.nIdxAnim % outerIdledata.nTotalAnim;
    //2004-04-22 Sunny add end	

#if 0 //2004-04-22 Sunny remove
    uScreenType = dspl_SetScreenType(1);
    outerIdledata.nIdxAnim = drawAnimIcons(outerIdledata.curIcnAttr,outerIdledata.nIdxAnim);
    dspl_SetScreenType(uScreenType);
#endif

    if( outerIdledata.nIdxAnim != 0xff )
        timStart(outerIdledata.outeridletimer);
    else
        outerIdledata.nIdxAnim = 0;

    return MFW_EVENT_CONSUMED;
}

    #if 0 //2004-03-18 Sunny remove
/****************************************
$Description: charge  timer
******************************************/
int outerIdleCharge_tim (MfwEvt e, MfwTim *t) 
{
    U8 uScreenType = dspl_SetScreenType(1);

    timStop(outerIdledata.chargetimer);
    if( outerIdledata.nChargeCurIcn==4 )
        outerIdledata.nChargeCurIcn-=1;
    outerIdledata.nOldChargePicNum = outerIdledata.nChargeCurIcn + outerIdledata.nChargeOffset;
    if( outerIdledata.nChargeState == OUTERIDLECHARGE_NORMAL )
        SetChargingIcon_Sub(outerIdledata.nOldChargePicNum );
    else
        SetChargingIcon_Sub(outerIdledata.nOldChargePicNum );

    //2004-03-18 Sunny modify
    if( outerIdledata.nOldChargePicNum==4 )
    {
        //2004-03-10 Sunny add
        outerIdledata.nChargeOffset=(outerIdledata.nChargeOffset+1)%(5-outerIdledata.nChargeCurIcn);
        GetBatPicnum();
        outerIdledata.nChargeCurIcn=CurrentBatPicNum;
        //2004-03-10 Sunny add end
    }
    else
    {
        outerIdledata.nChargeOffset=(outerIdledata.nChargeOffset+1)%(5-outerIdledata.nChargeCurIcn);        
    }
    //2004-03-18 Sunny modify end

    if( pwr_Status.charger_plugged == 1 && pwr_Status.charging_state!=0 )
    {
        timStart(outerIdledata.chargetimer);
    }
    //2004-03-10 Sunny add for displaying the actual value.
    else if( (pwr_Status.charger_plugged == 0) || (pwr_Status.charging_state == 0) )//no charging and full
    {
        pdspl_colorTextOut(10,15,DSPL_TXTATTR_WHITE_EDGE,"UnPlug",0);
        GetBatPicnum();
        SetChargingIcon_Sub(CurrentBatPicNum);  
        outerIdledata.nChargeState = OUTERIDLECHARGE_NONE;
        timStop(outerIdledata.chargetimer);     
    }
    //2004-03-10 Sunny add end

    dspl_SetScreenType(uScreenType);
    return MFW_EVENT_CONSUMED;
}
    #endif

/****************************************
$Description: charge  timer
********2004/03/11,Sunny create
******************************************/
void DisplayOuterIdleCharge(U8 curBatNum)
{
    U8 uScreenType = dspl_SetScreenType(1);

    SetChargingIcon_Sub(curBatNum);

    dspl_SetScreenType(uScreenType);
}

/*********************************************************
$Function:outerIdleRefresh_tim
$Description:refresh the outer screen
$History:
********2004/03/11,Sunny create
**********************************************************/

int outerIdleRefresh_tim(MfwEvt e, MfwTim *t)
{
    timStop(outerIdledata.refreshtimer);
    drawOuterIdle();
    timStart(outerIdledata.refreshtimer);
    return MFW_EVENT_CONSUMED;
}

    #if 0 //2004-03-21 Sunny remove
/****************************************
$Arguments:
    flags:OUTERIDLECHARGE_XXX

    
$History:
**********2003/12/23,talcon create
*************************************************/
void setChargeState(U8 flags,void *para)
{
    //2004-03-18 Sunny add
    U8 uScreenType = dspl_SetScreenType(1);

    if( flags && pwr_Status.charger_plugged==0 )
    {
        flags = OUTERIDLECHARGE_NONE;
    }
    switch( flags )
    {
    case OUTERIDLECHARGE_NONE:
        if( outerIdledata.nChargeState )
        {
            //2004-03-10 Sunny add for displaying the actual value.
            GetBatPicnum();
            SetChargingIcon_Sub(CurrentBatPicNum);          
            //2004-03-10 Sunny add end

            outerIdledata.nChargeState = OUTERIDLECHARGE_NONE;
            //timStop(outerIdledata.chargetimer);//2004-03-20 Sunny remove
        }
        break;
    case OUTERIDLECHARGE_NORMAL:
    case OUTERIDLECHARGE_OFF:
        if( outerIdledata.nChargeState == OUTERIDLECHARGE_NONE )
        {
            outerIdledata.nChargeState = OUTERIDLECHARGE_NORMAL;

            //2004-03-10 Sunny add
            GetBatPicnum();
            outerIdledata.nChargeCurIcn = CurrentBatPicNum;
            outerIdledata.nChargeOffset = 0;
            //2004-03-10 Sunny add end

            //timStart(outerIdledata.chargetimer);//2004-03-20 Sunny remove
        }
        break;
    }

    //2004-03-18 Sunny add
    dspl_SetScreenType(uScreenType);
}//end setChargeState

    #endif 
/****************************************
$Arguments:
    reason:OUTERIDLEEVENT_XXX

    
$History:
**********2003/12/22,talcon create
*************************************************/
void outeridleExec (int reason,void* para)
{
    U8 uScreenType ;
    if( reason & OUTERIDLEEVENT_TIME )
    {
        //drawOuterIdleZone2();
        drawOuterIdle();
        return;
    }
    uScreenType = dspl_SetScreenType(1);
    if( reason & OUTERIDLEEVENT_SIGNAL )
    {
        iconsShowSignal_Sub(globalSignalPicNumber); 
    }
    if( reason & OUTERIDLEEVENT_BATTERY )
    {
        //2004-03-26 Sunny add
        if( (pwr_Status.charger_plugged==0) ||(pwr_Status.charging_state == 0) )
        {
            GetBatPicnum();
            SetChargingIcon_Sub(CurrentBatPicNum);
        }
        //2004-03-26 Sunny add end
    }
    //2004/03/11 Sunny add for refresh the outer screen.
    if( reason & OUTERIDLEEVENT_REFRESH )
    {
        drawOuterIdle();
    }
    //2004/03/11 Sunny add for refresh the outer screen end
    dspl_SetScreenType(uScreenType);
}
/****************************************
$Arguments:
    @flags:OUTERIDLESTATE_XXX
    @mask:  1 ֪ͨ¼
            0 ֪ͨ¼
    
$History:
**********2003/12/13,talcon create
**********2003-03-23 Sunny add a parameter par
*************************************************/
void setOuterState(U32 flags,UBYTE mask,char *par)
{   
    char strDebug[100];
    U32 oldflags = outerIdledata.nIdleCurState;

    //2004-04-07 Sunny add. Only refresh the outer screen.
    if( flags == OUTERIDLESTATE_REFRESH )
    {
        drawOuterIdle();
        return;
    }
    //2004-04-07 Sunny add end 

    if( mask == 0 )
    {
	/* 2004/07/12 sunsj modify for outer event priority */
	if( flags > outerIdledata.nIdleCurState )
	{
            timStop(outerIdledata.outeridletimer);
	}
        outerIdledata.nIdleState &= ~flags;

        //2004-04-07 Sunny add
        if( flags == OUTERIDLESTATE_INCOMING )
        {
            GlobalPar_Outer = 0;
        }
        //2004-04-07 Sunny add end
    }
    else
    {
	/* 2004/07/09 sunsj Judge the state priority if the new state is the highter so
	   Clear the state because there is only one state can be exist at the same time */
	if( flags == OUTERIDLESTATE_INCOMING )
	{
	    outerIdledata.nIdleState &= ~( OUTERIDLESTATE_ALERT|OUTERIDLESTATE_SMS );
	    outerIdledata.nIdleState |= flags;
	}
	else if( flags == OUTERIDLESTATE_SMS )
	{
	    outerIdledata.nIdleState &= ~OUTERIDLESTATE_ALERT;
	    outerIdledata.nIdleState |= flags;
	}

        outerIdledata.nIdleState |= flags;

        //2004-04-07 Sunny add
        if( flags == OUTERIDLESTATE_INCOMING )
        {
            GlobalPar_Outer = par;
        }
        //2004-04-07 Sunny add end
    }       

    drawOuterIdle();// refresh zone1

    //get state of highest priority
    outerIdledata.nIdleCurState = 0x80000000;
    while( outerIdledata.nIdleCurState )
    {
        if( outerIdledata.nIdleCurState & outerIdledata.nIdleState )
        {
            break;
        }
        outerIdledata.nIdleCurState  >>= 1;
    }

    drawOuterIdle();// refresh zone2

    if( flags < outerIdledata.nIdleCurState )
    {
        return;
    }

    //2004/06/04 yhf modify
    /*switch(outerIdledata.nIdleCurState)
    {
        case OUTERIDLESTATE_INCOMING:		
            outerIdledata.nAnimTimes = -1;
            outerIdledata.nIdxAnim = 0;
            outerIdledata.nTotalAnim = sizeof(CallIcns) / sizeof(MfwIcnAttr);
            outerIdledata.curIcnAttr = (MfwIcnAttr*)CallIcns;
            outerIdledata.curIcnAttr_mask = (MfwIcnAttr*)CallIcns_mask;
            timStart(outerIdledata.outeridletimer); 		
            break;
        case OUTERIDLESTATE_ALERT:		
            outerIdledata.nAnimTimes = -1;
            outerIdledata.nIdxAnim = 0;
            outerIdledata.nTotalAnim = sizeof(AlarmIcns) / sizeof(MfwIcnAttr);
            outerIdledata.curIcnAttr = (MfwIcnAttr*)AlarmIcns;
            outerIdledata.curIcnAttr_mask = (MfwIcnAttr*)AlarmIcns_mask;
            timStart(outerIdledata.outeridletimer); 
            break;
        case OUTERIDLESTATE_SMS:		
            outerIdledata.nAnimTimes = 9;
            outerIdledata.nIdxAnim = 0;
            outerIdledata.nTotalAnim = sizeof(SmsIcns) / sizeof(MfwIcnAttr);
            outerIdledata.curIcnAttr = (MfwIcnAttr*)SmsIcns;
            outerIdledata.curIcnAttr_mask = (MfwIcnAttr*)SmsIcns_mask;
            timStart(outerIdledata.outeridletimer); 
            break;		
    }*/
    //2004-04-07 Sunny remove
#if 0	
    //get state of highest prior level 
    outerIdledata.nIdleCurState = 0x80000000;
    while( outerIdledata.nIdleCurState )
    {
        if( outerIdledata.nIdleCurState & outerIdledata.nIdleState )
        {
            break;
        }
        outerIdledata.nIdleCurState  >>= 1;
    }

    //MMI_TRACE_EVENT( ("<<<<<<<<<<<talcon,setOuterState:outerIdledata.nIdleCurState:%d",outerIdledata.nIdleCurState) );



    if( flags < outerIdledata.nIdleCurState )//λڵǰȼά״
    {
        MMI_TRACE_EVENT( ("<<<<<<<<<<<talcon,setOuterState:flags:%d",flags) );
        return;
    }

    switch( outerIdledata.nIdleCurState )
    {
    case OUTERIDLESTATE_LCDOFF://lcd off
        outerIdledata.nIdleState |= OUTERIDLESTATE_NORMAL;
        outerIdledata.nAnimTimes = 10;
        outerIdledata.nIdxAnim = 0;
        outerIdledata.curIcnAttr = (MfwIcnAttr*)OTLcdOfficns;
        //timStart(outerIdledata.outeridletimer); //2004/03/11 Sunny removed
        break;
        //2004-03-23 Sunny add
    case OUTERIDLESTATE_INCOMING:       
        outerIdledata.nAnimTimes = 10;
        outerIdledata.nIdxAnim = 0;
        outerIdledata.curIcnAttr = (MfwIcnAttr*)OTLcdOfficns;
        //timStart(outerIdledata.outeridletimer); 		
        break;
        //2004-03-23 Sunny add end

        //2004-04-01 Sunny add
    case OUTERIDLESTATE_LOWVOLTAGE:
        outerIdledata.nAnimTimes = 10;
        outerIdledata.nIdxAnim = 0;
        outerIdledata.curIcnAttr = (MfwIcnAttr*)OTLcdOfficns;
        //timStart(outerIdledata.outeridletimer); 		
        break;
    case OUTERIDLESTATE_LOWVOLTAGESWITCHOFF:
        outerIdledata.nAnimTimes = 10;
        outerIdledata.nIdxAnim = 0;
        outerIdledata.curIcnAttr = (MfwIcnAttr*)OTLcdOfficns;
        //timStart(outerIdledata.outeridletimer); 		
        break;      
        //2004-04-01 Sunny add end
    case OUTERIDLESTATE_CALL:       
        outerIdledata.nAnimTimes = -1;
        outerIdledata.nIdxAnim = 0;
        outerIdledata.curIcnAttr = (MfwIcnAttr*)OTCallicns;
        //timStart(outerIdledata.outeridletimer); //2004/03/11 Sunny removed
        break;
    case OUTERIDLESTATE_MISSCALL:       
        outerIdledata.nAnimTimes = 20;
        outerIdledata.nIdxAnim = 0;
        outerIdledata.curIcnAttr = (MfwIcnAttr*)OTMissCallicns;
        //timStart(outerIdledata.outeridletimer); //2004/03/11 Sunny removed
        break;
    case OUTERIDLESTATE_SMS:        
        outerIdledata.nAnimTimes = 20;
        outerIdledata.nIdxAnim = 0;
        outerIdledata.curIcnAttr = (MfwIcnAttr*)OTsmsicns;
        //timStart(outerIdledata.outeridletimer); //2004/03/11 Sunny removed
        break;
    case OUTERIDLESTATE_ALERT:      
        outerIdledata.nAnimTimes = -1;
        outerIdledata.nIdxAnim = 0;
        outerIdledata.curIcnAttr = (MfwIcnAttr*)OTcolckicns;
        //timStart(outerIdledata.outeridletimer); //2004/03/11 Sunny removed
        break;
    case OUTERIDLESTATE_NONE:
        timStop(outerIdledata.outeridletimer);
        break;
    case OUTERIDLESTATE_NORMAL:
        drawOuterIdle();
        break;  
    case OUTERIDLESTATE_LCDON:
        //2004-04-06 Sunny removed.
        //outerIdledata.nIdleState  = OUTERIDLESTATE_NONE;
        //outerIdledata.nIdleCurState = OUTERIDLESTATE_NONE;

        timStop(outerIdledata.outeridletimer);
        break;
    default:
        timStop(outerIdledata.outeridletimer);
        break;
    } 

    drawOuterIdle();//2004/03/11 Sunny add.
    MMI_TRACE_EVENT( ("<<<<<<<<<<<talcon,setOuterState:outerIdledata.nIdleCurState:%d",outerIdledata.nIdleCurState) );
#endif
}

/*********************************************************
$Function:drawOuterIdleZone1
$Description:icon
$History:
********2003/12/20,talcon add
**********************************************************/
void drawOuterIdleZone1()
{
    int nNewSms=0;

    /* 2004/07/15 sunsj modify */
    if( NotCharingMode == FALSE )
    {
        return;
    }
    //draw signal icon
    iconsShowSignal_Sub(globalSignalPicNumber); 

    //2004-03-10 Sunny add

    //draw missed call icon
    if( FlashDCTbData.MissedCallNum )
    {
        iconsSetState(iconIdMissedCall);    
    }
    else
    {
        iconsDeleteState(iconIdMissedCall); 
    }

    //draw new sms
    smsidle_display_sms_status(&nNewSms); //2004-04-22 Sunny modify	

    //draw other notify icon
    DrawOuterNotifyIcon();

    //draw scene mode
    DrawOuterSeceneMode( FlashEnvironmentData.CurrentEnv );

    //draw charge
    if( (pwr_Status.charger_plugged==0) ||(pwr_Status.charging_state == 0) )
    {
        GetBatPicnum();
        SetChargingIcon_Sub(CurrentBatPicNum);
    }
    else
    {
        SetChargingIcon_Sub( OlderCurrentBatPicNum );
    }

    //2004-03-10 Sunny add end.
}//end drawOuterIdleZone1

/*********************************************************
$Function:drawOuterIdleZone2
$Description:draw text
$History:
********2003/12/23,talcon add
**********************************************************/
void drawOuterIdleZone2()
{
	extern getStringWidth();
    char strDebug[100];
    int startX = 0;
    int hour;
    int week;
    char line[15];  
    char *AmPm; //2004-04-06 Sunny add
	TIMEDATE today;   
	UINT8 weekpositionX;
	UINT8 weekpositionY;
	T_CURRENT_NETWORK current_network;
	int txtStrId;



	/* 2004/06/30 sunsj  remove */
#if 1 //shiheng 0809 modify
    if( outerIdledata.nIdleCurState & OUTERIDLESTATE_INCOMING )
    {
        if( GlobalStatusNeedAnimation & OUTERIDLESTATE_INCOMING )
        {
#if (SUB_LCD_SIZE==5)
			pdspl_colorTextOut((96-get_StringWidth(GlobalPar_Outer))/2,18,DSPL_TXTATTR_WHITE_EDGE,(char *)GlobalPar_Outer,0);
#elif ((SUB_LCD_SIZE==1) || (SUB_LCD_SIZE==6))
			pdspl_colorTextOut((96-get_StringWidth(GlobalPar_Outer))/2,SECOND_LINE,DSPL_TXTATTR_WHITE_EDGE,(char *)GlobalPar_Outer,0);
#endif
		}
        else
        {
            DisplayIncomingCall(GlobalPar_Outer);
        }

        return;
    }

    if( outerIdledata.nIdleCurState & OUTERIDLESTATE_ALERT )
    {
        if( GlobalStatusNeedAnimation & OUTERIDLESTATE_ALERT )
        {
            GetTimeString(line);
            MMI_TRACE_EVENT((line));
            pdspl_colorTextOut((96-get_StringWidth(line))/2,45,DSPL_TXTATTR_WHITE_EDGE,(char *)line,0);         
        }
        else
        {
        }
        return;
    }

    if( outerIdledata.nIdleCurState & OUTERIDLESTATE_SMS )
    {
		 
	//shiheng 0813 remove for outer display	
	//	return;     
    }

    if( outerIdledata.nIdleCurState & OUTERIDLESTATE_LOWVOLTAGESWITCHOFF )
    {
        if( GlobalStatusNeedAnimation & OUTERIDLESTATE_LOWVOLTAGESWITCHOFF )
        {
        }
        else
        {
            draw_popup_background_sub();
            startX = (96-get_StringWidth(MmiRsrcGetText(TxtNoPower)))/2;
            dspl_sub_TextOut(startX,32 +2,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtNoPower));
            startX = (96-get_StringWidth(MmiRsrcGetText(TxtSwitchOff)))/2;
            dspl_sub_TextOut(startX,47 +2,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtSwitchOff));
            //dialog_drawPopIcon_sub(POP_ICONINDICATE);
        }
        return;
    }

    if( outerIdledata.nIdleCurState & OUTERIDLESTATE_LOWVOLTAGE )
    {
        if( GlobalStatusNeedAnimation & OUTERIDLESTATE_LOWVOLTAGE )
        {
        }
        else
        {
            draw_popup_background_sub();
            startX = (96-get_StringWidth(MmiRsrcGetText(TxtNeedCharging)))/2;
            dspl_sub_TextOut(startX,30 +2,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtNeedCharging));        
            //dialog_drawPopIcon_sub(POP_ICONINDICATE);
        }
        return;
    }

    drawOuterIdleMissedCallAndSms(); 

#endif
    /*memset(line,0,sizeof(line) );
    sprintf(line,"%02d/%02d/%04d", currdate.day,currdate.month,currdate.year);
    DisplayOuterDate(line);

    memset(line,0,sizeof(line) );
    GetTimeString(line);
    if( FFS_flashData.time_format == TWELVE_HOUR )
    {
        DisplayOuterTime(line, 0);
    }
    else
    {
        DisplayOuterTime(line, 1);
    }*/

    /* 2004/07/14 sunsj modify */
    if( NotCharingMode == FALSE )
    {
        if( pwr_Status.charger_plugged == 1 )
        {
            if( pwr_Status.charging_state == 0 )
            {
#if (SUB_LCD_SIZE==6)
				
				dspl_sub_TextOut((96-get_StringWidth(MmiRsrcGetText(TxtChargComplete)))/2,30,DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtChargComplete),0);
#endif 
#if (SUB_LCD_SIZE==1)
				
				dspl_sub_TextOut((96-get_StringWidth(MmiRsrcGetText(TxtChargComplete)))/2,30,DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtChargComplete),0);
#endif 
#if (SUB_LCD_SIZE==5)
                dspl_sub_TextOut((96-get_StringWidth(MmiRsrcGetText(TxtChargComplete)))/2,15,DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtChargComplete),0);
#endif            
			}
            else
            {
#if (SUB_LCD_SIZE==6)
                dspl_sub_TextOut((96-get_StringWidth(MmiRsrcGetText(TxtCharging)))/2,30,DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtCharging),0);
#endif 
#if (SUB_LCD_SIZE==1)
                dspl_sub_TextOut((96-get_StringWidth(MmiRsrcGetText(TxtCharging)))/2,30,DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtCharging),0);
#endif
#if (SUB_LCD_SIZE==5)   
				dspl_sub_TextOut((96-get_StringWidth(MmiRsrcGetText(TxtCharging)))/2,15,DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtCharging),0);
#endif	            
			}
            return;
        }
    }
	if(IsMissedCallAndSms == 0)//shiheng 0810 add
	{		
/* 2004/07/12 yhf modify*/
#ifndef _INNOVATION_EMULATOR_
    switch( idle_data.nm_status )
    {
    case NETWORK_FULL_SERVICE : 
        /*NM p032
         set the flag when the TEST SIM is inserted*/
        network_get_name (&current_network);
        if( ( !strcmp((char *)current_network.network_name,"46000") )
            || ( !strcmp((char *)current_network.network_name,"46001") )
            || ( !strcmp((char *)current_network.plmn_name,"CHINA  MOBILE")) 
            || ( !strcmp((char *)current_network.plmn_name,"CHN-CUGSM") )
            || ( !strcmp((char*)current_network.plmn_name, "CMCC"))
            || ( !strcmp((char*)current_network.plmn_name, "CU-GSM")) )
        {
            if( (!strcmp((char *)current_network.network_name,"46000"))||(!strcmp((char *)current_network.plmn_name,"CHINA  MOBILE"))||(!strcmp((char*)current_network.plmn_name, "CMCC")) )
            {
                txtStrId   = T_China_Telecomm;
            }
            else if( (!strcmp((char *)current_network.network_name,"46001"))||(!strcmp((char *)current_network.plmn_name,"CHN-CUGSM"))||(!strcmp((char*)current_network.plmn_name, "CU-GSM")) )
            {
                txtStrId   = T_China_Unicomm;
            }
#if (SUB_LCD_SIZE==6)
			
			dspl_sub_TextOut((100-get_StringWidth((char*)MmiRsrcGetText(txtStrId)))/2,16,DSPL_TXTATTR_WHITE_EDGE,(char*)MmiRsrcGetText(txtStrId));
#endif
#if (SUB_LCD_SIZE==1)
			
			dspl_sub_TextOut((100-get_StringWidth((char*)MmiRsrcGetText(txtStrId)))/2,16,DSPL_TXTATTR_WHITE_EDGE,(char*)MmiRsrcGetText(txtStrId));
#endif
#if (SUB_LCD_SIZE==5)
#endif        
		}
        else
        {
            if( current_network.plmn_name[0]!= NULL )   //xsf add for avoid display plmn_name "0000" 12.18
            {
#if (SUB_LCD_SIZE==6)
				dspl_sub_TextOut((100-get_StringWidth((char*)current_network.plmn_name))/2,16,DSPL_TXTATTR_WHITE_EDGE,(char*)current_network.plmn_name);
#endif  
#if (SUB_LCD_SIZE==1)
				dspl_sub_TextOut((100-get_StringWidth((char*)current_network.plmn_name))/2,16,DSPL_TXTATTR_WHITE_EDGE,(char*)current_network.plmn_name);
#endif 
#if (SUB_LCD_SIZE==5)
#endif           
			}
            else
            {
#if (SUB_LCD_SIZE==6)
				dspl_sub_TextOut((100-get_StringWidth(MmiRsrcGetText(TxtNoNetwork)))/2,16,DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtNoNetwork));		
#endif  
#if (SUB_LCD_SIZE==1)
				dspl_sub_TextOut((100-get_StringWidth(MmiRsrcGetText(TxtNoNetwork)))/2,16,DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtNoNetwork));		
#endif 
#if (SUB_LCD_SIZE==5)
#endif            
			}
	}
        break;
    case NETWORK_LIMITED_SERVICE :
    case NETWORK_SEARCH_NETWORK :
    case NETWORK_NO_SERVICE :
    case NETWORK_NO_PLMN_XXX_AVAIL:
	case 0:
        break;		
    default:
        break;	/* 2004/07/15 sunsj modify */
    }
#endif 
/* end of yhf modify */     

	GetTimeDate(currdate.year, currdate.month, currdate.day, &today);  //xsf add for get weekday 12.06
	sprintf(line,"%02d/%02d",today.day,today.month);//,(today.year%100)/10,today.year%1000); //zgz, 2002.8.23 
	set_sub_font_type(UNI12X12_FONT);//yhf	add
#if (SUB_LCD_SIZE==6)
	
	dspl_sub_TextOut(0,50,DSPL_TXTATTR_WHITE_EDGE,(char *)line);
#endif
#if (SUB_LCD_SIZE==1)
	
	dspl_sub_TextOut(0,50,DSPL_TXTATTR_WHITE_EDGE,(char *)line);
#endif
	set_sub_font_type(UNI12X12_FONT);//yhf	

	if( FFS_flashData.time_format == TWELVE_HOUR )
	{
		if( currclock.hour / 12 )
		{
			if( FFS_flashData.language==0 )
				AmPm = "PM";
			else
				AmPm = "PM";	/* 2004/04/10 sunsj modify */
		}
		else
		{
			if( FFS_flashData.language==0 )
				AmPm = "AM";
			else
				AmPm = "AM";	/* 2004/04/10 sunsj modify */
		}
		if( currclock.hour>12 )
		{
			hour=currclock.hour-12;
		}
		else if( currclock.hour==0 )
		{
			hour=12;
		}
		else
		{
			hour=currclock.hour;
		}   
		sprintf(line,"%02d:%02d%s",hour,currclock.min, AmPm); //zgz, 2002.8.23  	   
	}
	else
		sprintf(line,"%02d:%02d",currclock.hour,currclock.min);

	if(FFS_flashData.time_format == TWELVE_HOUR)
	{
		DisplayOuterTime(line, 0);
	}
	else
	{
		DisplayOuterTime(line, 1);
	}
	//dspl_sub_TextOut(30,25,DSPL_TXTATTR_WHITE_EDGE,(char *)line);
	set_sub_font_type(UNI12X12_FONT);//yhf	
	if( FFS_flashData.language==0 )
	{
		switch( today.week ) //xsf add for get weekday 12.06
		{
#if ((SUB_LCD_SIZE==6) || (SUB_LCD_SIZE==1) )
			
		case 0:
			dspl_sub_TextOut(57,50,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtSunday));
			break;
		case 1:
			dspl_sub_TextOut(57,50,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtMonday));
			break;
		case 2:
			dspl_sub_TextOut(57,50,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtTuesday));
			break;
		case 3:
			dspl_sub_TextOut(57,50,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtWednesday));
			break;
		case 4:
			dspl_sub_TextOut(57,50,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtThursday));
			break;
		case 5:
			dspl_sub_TextOut(57,50,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtFriday));
			break;
		case 6:
			dspl_sub_TextOut(57,50,DSPL_TXTATTR_WHITE_EDGE,(char*)GET_TEXT(TxtSaturday));
			break;

#endif
#if (SUB_LCD_SIZE==5)
#endif
		default:
			break;
		}	
	}
	else
	{
		switch( today.week ) //xsf add for get weekday 12.06
		{
		case 0:
			sprintf(line,"%s","Sunday");
			break;
		case 1:
			sprintf(line,"%s","Monday");
			break;
		case 2:
			sprintf(line,"%s","Tuesday");
			break;
		case 3:
			sprintf(line,"%s","Wednesday");
			break;
		case 4:
			sprintf(line,"%s","Thursday");
			break;
		case 5:
			sprintf(line,"%s","Friday");
			break;
		case 6:
			sprintf(line,"%s","Saturday");
			break;
		default:
			break;
		}
#if (SUB_LCD_SIZE==6)
		dspl_sub_TextOut(96 - get_StringWidth(line),50,DSPL_TXTATTR_WHITE_EDGE,(char *)line);
#endif
#if (SUB_LCD_SIZE==1)
		dspl_sub_TextOut(96 - get_StringWidth(line),50,DSPL_TXTATTR_WHITE_EDGE,(char *)line);
#endif		
#if (SUB_LCD_SIZE==5)
#endif
	}
	}//shiheng 0810 add
}//end drawOuterIdleZone2

/*****************************************************************************************
    $Name:			drawOuterIdleMissedCallAndSms
    $Author:		Sunny
    $Date:			2004-04-02
    $Description:	Display the missed call and SMS.
    $History:		Sunny modify at 2004-04-13
*****************************************************************************************/

void drawOuterIdleMissedCallAndSms()
{
    char text[20];
    int txtNo;      
    int xOfs = 0;       
    int txtStrId = TxtNull;    
    int len1 = 0, len2 = 0;

    IsMissedCallAndSms = 0; 

    if( FlashDCTbData.MissedCallNum )
    {
        txtNo = FlashDCTbData.MissedCallNum;
        if( txtNo <= 1 )
        {
            txtStrId = TxtMissedCall;

        }
        else
        {
            txtStrId = TxtMissedCalls;
        }

    }
    else
    {
        txtStrId = (smsidle_display_sms_status(&txtNo ));
    }
    if( txtStrId != TxtNull )
    {
        len1 = get_StringWidth(GET_TEXT(txtStrId));

        if( txtNo != 0 )
        {
            memset(text,0,sizeof(text));
            sprintf((char*)text,"%d",txtNo);
            len2 = get_StringWidth(text);

            xOfs = (OUTERSCREEN_SIZE_X - len1 - len2) /2;
#if (SUB_LCD_SIZE==5)
			dspl_sub_TextOut(xOfs, 13, DSPL_TXTATTR_WHITE_EDGE,text);
            dspl_sub_TextOut(xOfs + len2, 13, DSPL_TXTATTR_WHITE_EDGE,GET_TEXT(txtStrId));
			
#endif
            dspl_sub_TextOut(xOfs, SECOND_LINE, DSPL_TXTATTR_WHITE_EDGE,text);
            dspl_sub_TextOut(xOfs + len2, SECOND_LINE, DSPL_TXTATTR_WHITE_EDGE,GET_TEXT(txtStrId));
        }
        else
        {
            xOfs = (OUTERSCREEN_SIZE_X - len1) /2;
#if (SUB_LCD_SIZE==5)
			dspl_sub_TextOut(xOfs, 13, DSPL_TXTATTR_WHITE_EDGE,GET_TEXT(txtStrId));
			
#endif
			dspl_sub_TextOut(xOfs, SECOND_LINE, DSPL_TXTATTR_WHITE_EDGE,GET_TEXT(txtStrId));
        }

        IsMissedCallAndSms = 1; 
    }
}

/****************************************
$Description:draw normal
***********************************************/
void drawOuterIdle()
{
    U8 uScreenType;
    U8 uMode;
/* zhq, 2004/07/08, add for we use pin_outer_wait to init sub screen
and we do not refresh untile main screen drawIdle. */
    if(main_sreen_init_complete == FALSE)
    {
        if( NotCharingMode == TRUE )
        {
            return;
        }
    }
	
    uScreenType = dspl_SetScreenType(1);
    uMode = pdspl_Enable(0);

    /* 2004/07/15 sunsj modify */
	/*
    if( NotCharingMode == TRUE )
    {
        drawIconByIcnAttr((MfwIcnAttr* )OTBkgIcns+FlashSettingData.OutBGI,NULL);
    }
    else
    {
        pdspl_BitBlt(0, 0, 96, 64, 0, (char *)pin_outer_wait, 0);
    }
	*/
#if (SUB_LCD_SIZE==1)	
	if( NotCharingMode == TRUE )
    {
        //drawIconByIcnAttr((MfwIcnAttr* )OTBkgIcns+FlashSettingData.OutBGI,NULL);
		DRAW_ICON_SEL(ICON_OUTERBKG,FlashSettingData.OutBGI);
    }
#endif
#if (SUB_LCD_SIZE==6)
	DRAW_ICON(ICON_OUTERBKG);
#endif
#if (SUB_LCD_SIZE==5)
	DRAW_ICON(ICON_OUTERBKG);
#endif
	
    drawOuterIdleZone1();
    drawOuterIdleZone2();
    //else
    /*
    {
        if( pwr_Status.charger_plugged == 1 )
        {
            if( pwr_Status.charging_state == 0 )
            {
                dspl_sub_TextOut((96-get_StringWidth(MmiRsrcGetText(TxtChargComplete)))/2,30,DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtChargComplete),0);
            }
            else
            {
                dspl_sub_TextOut((96-get_StringWidth(MmiRsrcGetText(TxtCharging)))/2,30,DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtCharging),0);
            }
        }
    }
    */
    pdspl_Enable(uMode);
    dspl_SetScreenType(uScreenType);
}    

/*********************************************************
$Function:DrawOuterNotifyIcon
$Description:draw notify icon
$History: 2004/06 sunsj modify for picture manage
**********************************************************/
void DrawOuterNotifyIcon()
{


    GlobalIconStatus_Outer =    GlobalSMSIconFlag | GlobalAlarmIconFlag |
                                GlobalIconMissedCallFlag;

    if( GlobalIconStatus_Outer & GlobalSMSIconFlag )
    {
        if( state_Outer[iconIdSMS].state == ICON_VISIBLE )
        {
            DRAW_ICON_SEL_MASK(ICON_OUTERIDLESTATE, iconIdSMS);
        }
    }

    if( GlobalIconStatus_Outer & GlobalAlarmIconFlag )
    {
        if( state_Outer[iconIdAlarm].state == ICON_VISIBLE )
        {
            DRAW_ICON_SEL_MASK(ICON_OUTERIDLESTATE, iconIdAlarm);
        }
    }

    if( GlobalIconStatus_Outer & GlobalIconMissedCallFlag )
    {
        if( state_Outer[iconIdMissedCall].state == ICON_VISIBLE )
        {
            DRAW_ICON_SEL_MASK(ICON_OUTERIDLESTATE, iconIdMissedCall);
        }
    }

    //Note: Other flags you need can append.
}

/*********************************************************
$Function:DrawOuterSeceneMode
$Description:draw secene mode
$History:
********2004/03/11,Sunny create
**********************************************************/
void DrawOuterSeceneMode(U8 scenestatus)
{   
    if( ( scenestatus < 0 ) || ( scenestatus >= iconSceneMax ) )
        return;

    /* 2004/06 sunsj modify for picture manage */
#if (SUB_LCD_SIZE==6)
	DRAW_ICON_SEL_MASK(ICON_SCENEOUTER, scenestatus);
#elif (SUB_LCD_SIZE==1)
	DRAW_ICON_SEL_MASK(ICON_SCENEOUTER, scenestatus);
#endif
}

/*********************************************************
$Function:InitialIconState
$Description:Initial notify icon
$History:
********2004/03/11,Sunny create
**********************************************************/
void InitialIconState()
{
    int i = iconIdSMS;

    for( i; i < idlIdMax; i++ )
    {
        iconsDeleteState(i);
    }   
}

/*********************************************************
$Function:InitialIconState
$Description:Initial notify icon
$History:
********2004/03/23,Sunny create
**********************************************************/
void DisplayIncomingCall(char *par)
{   
    int stringLength = 0;
    USHORT startXPos = 0;      
    dspl_DevCaps deviceCaps;
    char *Idtext; 
    
    U8 uScreenType = dspl_SetScreenType(1);
    dspl_GetDeviceCaps(&deviceCaps);    
    Idtext=(char*)MmiRsrcGetText( TxtIncomingCall );
    stringLength = get_StringWidth(Idtext);

    startXPos = (deviceCaps.Width - stringLength) / 2;

#if (SUB_LCD_SIZE==1)
    pdspl_colorTextOut(startXPos,25,DSPL_TXTATTR_WHITE_EDGE,Idtext,0);
    pdspl_colorTextOut((96-get_StringWidth(par))/2,40,DSPL_TXTATTR_WHITE_EDGE,(char *)par,0);  
#endif
#if (SUB_LCD_SIZE==6)
    pdspl_colorTextOut(startXPos,25,DSPL_TXTATTR_WHITE_EDGE,Idtext,0);
    pdspl_colorTextOut((96-get_StringWidth(par))/2,40,DSPL_TXTATTR_WHITE_EDGE,(char *)par,0);  
#endif
#if (SUB_LCD_SIZE==5)
	pdspl_colorTextOut(startXPos,14,DSPL_TXTATTR_WHITE_EDGE,Idtext,0);
    pdspl_colorTextOut((96-get_StringWidth(par))/2,26,DSPL_TXTATTR_WHITE_EDGE,(char *)par,0);  
	
#endif    
	dspl_SetScreenType(uScreenType);
}

/* 2004/4/16 sunsj add for outer idle font */
int DisplayOuterNumber(int coor_x, int coor_y, int iconwidth, int iconheight, void * BmpPtr)
{
    if( BmpPtr == NULL )
    {
        MMI_TRACE_EVENT(("icon is null"));
        return;
    }
    pdspl_BitBlt(coor_x, coor_y, iconwidth, iconheight, 0, BmpPtr, DSPL_BMPXOR);
    pdspl_BitBlt(coor_x, coor_y, iconwidth, iconheight, 0, BmpPtr, DSPL_BMPAND);
    pdspl_BitBlt(coor_x, coor_y, iconwidth, iconheight, 0, BmpPtr, DSPL_BMPXOR);
}

#define DATE_START_X	8
#define DATE_START_Y	20
#if (SUB_LCD_SIZE==6)       
#define OUTERIDLE_NUM_WIDTH		10
#define OUTERIDLE_NUM_HEIGHT	14
#endif

#if (SUB_LCD_SIZE==5)       
#define OUTERIDLE_NUM_WIDTH		12
#define OUTERIDLE_NUM_HEIGHT	17
#endif
#if (SUB_LCD_SIZE==1)       
#define OUTERIDLE_NUM_WIDTH		10
#define OUTERIDLE_NUM_HEIGHT	14

#endif

int DisplayOuterDate(char *date)
{
    int i = 0;
    int date_sort[10] = {1, 2, 0, 3, 4, 0, 15, 15, 9, 10};
    int date_pixel_x = DATE_START_X;
    int date_pixel_y = DATE_START_Y;

    if( date == NULL )
    {
        return 0;
    }

    for( i = 0; i < 10; i++ )
    {
        if( date_sort[i] != 0 )
        {
            if( date_sort[i] != 15 )
            {
                DRAW_ICON_ATTRIBUTE(ICON_OUTERNUMBER, date_pixel_x, date_pixel_y, date[i]-0x30, ICON_LOCATION);
            }
            else
            {
                continue;
            }
        }
        else
        {
            DRAW_ICON_ATTRIBUTE(ICON_OUTERNUMBER, date_pixel_x, date_pixel_y, 10, ICON_LOCATION);
        }
        date_pixel_x+=OUTERIDLE_NUM_WIDTH;
    }
    return 1;
}

int DisplayOuterTime(char *time, int time_type_flag)
{
    int i = 0;
    int time_sort[5] = {1, 2, 0, 3, 4};
    int time_pixel_x = 0;
    int time_pixel_y = 0;
	
    if( time == NULL )
    {
        return 0;
    }

    if( time_type_flag == 0 )
    {
#if (SUB_LCD_SIZE==6)       
        time_pixel_x = 13;
		time_pixel_y = 32;
#endif
#if (SUB_LCD_SIZE==1)       
        time_pixel_x = 13;
		time_pixel_y = 32;
#endif		
#if (SUB_LCD_SIZE==5)
		time_pixel_x = 7;
		time_pixel_y = 16;
		
#endif
        for( i = 0; i < 5; i++ )
        {
            if( time_sort[i] != 0 )
            {
                DRAW_ICON_ATTRIBUTE(ICON_OUTERNUMBER, time_pixel_x, time_pixel_y, time[i]-0x30, ICON_LOCATION);
            }
            else
            {
                DRAW_ICON_ATTRIBUTE(ICON_OUTERNUMBER, time_pixel_x, time_pixel_y, 11, ICON_LOCATION);
            }
            time_pixel_x += OUTERIDLE_NUM_WIDTH;
        }
        if( time[5] == 80 )
        {
            DRAW_ICON_ATTRIBUTE(ICON_OUTERNUMBER, time_pixel_x, time_pixel_y, 12, ICON_LOCATION);
        }
        else if( time[5] == 65 )
        {
            DRAW_ICON_ATTRIBUTE(ICON_OUTERNUMBER, time_pixel_x, time_pixel_y, 13, ICON_LOCATION);
        }
        time_pixel_x += OUTERIDLE_NUM_WIDTH;
        DRAW_ICON_ATTRIBUTE(ICON_OUTERNUMBER, time_pixel_x, time_pixel_y, 14, ICON_LOCATION);
    }
    else
    {
#if (SUB_LCD_SIZE==6)       
        time_pixel_x = 23;
		time_pixel_y = 32;
#endif
#if (SUB_LCD_SIZE==1)       
        time_pixel_x = 23;
		time_pixel_y = 32;
#endif		
#if (SUB_LCD_SIZE==5)
		time_pixel_x = 19;
		time_pixel_y = 16;
		
#endif        
        for( i = 0; i < 5; i++ )
        {
            if( time_sort[i] != 0 )
            {
                DRAW_ICON_ATTRIBUTE(ICON_OUTERNUMBER, time_pixel_x, time_pixel_y, time[i]-0x30, ICON_LOCATION);
            }
            else
            {
                DRAW_ICON_ATTRIBUTE(ICON_OUTERNUMBER, time_pixel_x, time_pixel_y, 11, ICON_LOCATION);
            }
            time_pixel_x += OUTERIDLE_NUM_WIDTH;
        }
    }

    return 1;
}

/********************************************************************************************
    $Function:		GetTimeString
    $Description:
    $Author:		Sunny
    $Date:			2004-04-22
********************************************************************************************/
void GetTimeString(char * line)
{
    int hour = 0;
    char *AmPm;

    if( FFS_flashData.time_format == TWELVE_HOUR )
    {
        if( currclock.hour / 12 )
        {
            AmPm = "PM";                                    
        }
        else
        {
            AmPm = "AM";                            
        }

        if( currclock.hour>12 )
        {
            hour=currclock.hour-12;
        }
        else if( currclock.hour==0 )
        {
            hour=12;
        }
        else
        {
            hour=currclock.hour;
        }           

        sprintf(line,"%02d:%02d%s",hour,currclock.min,AmPm);
    }
    else
    {
        hour  = currclock.hour;     

        sprintf(line,"%02d:%02d",hour,currclock.min);       
    }
}

/********************************************************************************************
    $Function:		DrawAnimation	
    $Description:
    $Author:		Sunny
    $Date:			2004-04-22
********************************************************************************************/
static void DrawAnimation(U8 index)
{
    char strDebug[100];
    U8 uScreenType = 0;
    MfwIcnAttr *icon = 0;
    MfwIcnAttr *icon_mask = 0;

    drawOuterIdle();

    uScreenType = dspl_SetScreenType(1);

    icon = (MfwIcnAttr *)(outerIdledata.curIcnAttr + index);
    icon_mask = (MfwIcnAttr *)(outerIdledata.curIcnAttr_mask + index);

    drawIconByIcnAttr(icon, icon_mask); 

    dspl_SetScreenType(uScreenType);
}

/********************************************************************************************
    $Function:		SetNeedAnimID
    $Description:
    $Author:		Sunny
    $Date:			2004-04-22
********************************************************************************************/
void SetNeedAnimID(U32 flags,UBYTE mask)
{
    if( mask == 1 )
    {
        GlobalStatusNeedAnimation |= flags;
    }

    if( mask == 0 )
    {
        GlobalStatusNeedAnimation &= ~flags;
    }
}

/********************************************************************************************
    $Function:		InitNeedAnimID
    $Description:
    $Author:		Sunny
    $Date:			2004-04-22
********************************************************************************************/

void InitNeedAnimID()
{
    GlobalStatusNeedAnimation = 0;
    SetNeedAnimID(OUTERIDLESTATE_INCOMING, 1);
    SetNeedAnimID(OUTERIDLESTATE_SMS, 1);
    SetNeedAnimID(OUTERIDLESTATE_ALERT, 1); 
	SetNeedAnimID(OUTERIDLESTATE_LCDOFF, 1); //shiheng 0810 add
	

}

#endif 