/*******************************************************************************

					CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MMI
 $File:		    MmiSimToolkit.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the root mofule for the basic MMI
                        
********************************************************************************
 $History: MmiSimToolkit.h

	25/10/00			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/

#ifndef _DEF_MMI_SAT_H_
#define _DEF_MMI_SAT_H_

#include "mfw_mfw.h"

/*
 * External Interfaces
 */

USHORT sim_toolkit_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
extern void simToolkitInit(T_MFW_HND parentWindow);
extern void simToolkitExit(void);
//glowing,2004-05-18,import from TCS2112GPRS
void sat_add_unicode_tag_if_needed(char* string); /*SPR 1257, added new function for unicode handling*/
void set_sat_redial_flag(UBYTE flag);  /* SPR#1779 - DS - Added prototype */
UBYTE get_sat_redial_flag(void); /* SPR#1779 - DS - Added prototype */
extern void sat_destroy();    /* 2004/07/09 sunsj add for forbidden hall off */

#endif  /* _DEF_MMI_SAT_H_   */

