#ifndef _MMIVOICEMEMO_H_
#define _MMIVOICEMEMO_H_ 1

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		VoiceMemo
 $File:		    MmiVoiceMemo.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the start code for the MMI
                        
********************************************************************************
 $History: MmiStart.h

	25/10/00			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/

EXTERN void voice_memo_init			(void);
EXTERN int	voice_memo_record		(MfwMnu* m, MfwMnuItem* i);
EXTERN int  voice_memo_DeleteAll (MfwMnu* m, MfwMnuItem* i);
EXTERN int  voice_memo_browser (MfwMnu* m, MfwMnuItem* i);
EXTERN int  voice_memo_Delete();
EXTERN int  voice_memo_play();
EXTERN int  voice_memo_Memory();
void StopVoiceMemo();
void SaveVoiceMemo();
/*******************************************************************************
                                                                              
                                Include files
                                                                              
*******************************************************************************/

extern USHORT record_position;




/*******************************************************************************
                                                                              
                                Interface constants
                                                                              
*******************************************************************************/


/* glowing: add the following event define for fix the bug that
   it can't record if disconnected
 */
#define VM_SAVERECORDCALL	508

 typedef struct
{
  T_MMI_CONTROL		mmi_control;
  T_MFW_HND			recentvoice_win;
  T_MFW_HND			parent;
}T_VOICEMEMO_INFO; /* 2003/10/29, wangyan, modify dialog delete style*/


/*******************************************************************************
                                                                              
                                Public methods
                                                                              
*******************************************************************************/

/* pretty standard initialise, execute and exit methods
*/



/*******************************************************************************
                                                                              
                                End of File
                                                                              
*******************************************************************************/

#endif

