#----------------------------------------------------------------------------- 
#  Project :  
#  Modul   :  J:\g23m-gsm\l1\l1.mak
#----------------------------------------------------------------------------- 
#  Copyright 2002 Texas Instruments Berlin, AG 
#                 All rights reserved. 
# 
#                 This file is confidential and a trade secret of Texas 
#                 Instruments Berlin, AG 
#                 The receipt of or possession of this file does not convey 
#                 any rights to reproduce or disclose its contents or to 
#                 manufacture, use, or sell anything it may describe, in 
#                 whole, or in part, without the specific written consent of 
#                 Texas Instruments Berlin, AG. 
#----------------------------------------------------------------------------- 
#|  Purpose :  
#----------------------------------------------------------------------------- 
#
# Makefile used to build the Layer1 customizable library 
#
#
OBJ := $(L23_OBJ_DIR)/l1

SRCL1 = $(CONDAT_DIR)/ms/src/l1

ifeq ($(PMODE),1)
L1CONFIG = -DALR=1
L1OBJ   = $(OBJ)/l1_pei.$(OBJ_TAIL)
endif

ifeq ($(PMODE),2)
L1CONFIG = -DALR=1 -DGPRS
L1OBJ   = $(OBJ)/l1_pei.$(OBJ_TAIL)
endif

$(TOP_DIR)/$(L1_LIB): $(OBJ) $(L1OBJ)
	-$(PERL) $(CONDAT_DIR)/int/bin/make_ver.pl
	$(AR) r $(TOP_DIR)/$(L1_LIB) $(L1OBJ) ver.$(OBJ_TAIL)
$(OBJ):
	mkdir $(subst /,$(SLASH),$(OBJ))

clean:
	-$(REMOVE) $(subst /,$(SLASH),$(OBJ))

#
# Sources files
#
$(L1OBJ): $(OBJ)/%.$(OBJ_TAIL) : $(SRCL1)/%.c
	echo -dNCONFIG >  cmd
	echo -dNTRACE >> cmd
	echo -d$(NWARN) >> cmd
	echo -DNEW_ENTITY >> cmd
	echo $(L1CONFIG) >> cmd
	echo $(COPT) >> cmd
	echo $(COPT1) >> cmd
	echo $(COTAR) >> cmd
	echo -i$(TOP_DIR)/../GPF/FRAME/cust_os >> cmd
	echo -i$(ICOM) >> cmd
	echo -i$(ICDG) >> cmd
	echo -fr$(OBJ) >> cmd
	$(CC_PRE) $^ -@cmd
	$(CC_INT) $(addsuffix .pp,$(basename $^))
	$(CC_COM) $(addsuffix .pp_,$(basename $^)) -@cmd
