#define ENTITY_MFW



#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif


#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#include "mfw_sys.h"
#include "p_sim.h"

#include "vsi.h"

#include "mfw_mfw.h"
#include "mfw_win.h"

#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_cm.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_sat.h"

#include "mfw_ffs.h"

#include "dspl.h"

#include "gdi.h" //ES!!

#ifdef WIN32
    #include "MmiMain.h"
#endif
#include "Audio.h"  
#include "pcm.h"
#include "Mfw_cphs.h"  // line select

#include "../bmi/Mmiblklangdb.h"
#include "../bmi/mmiicons.h"
#include "../bmi/mmi3dframe.h"

//#include "mfw_porting.h"


#define hCommACI _ENTITY_PREFIXED(hCommACI)

#if defined (NEW_FRAME)
EXTERN T_HANDLE hCommACI;
#else
EXTERN T_VSI_CHANDLE hCommACI;
#endif
#define hCommMMI  hCommACI




char CurrentScheFileName[20];

void Common_ffsfile_init(void);
void phonebook_ffsfile_init(void);
void Get_NVM_data(void);
void flash_ConfigDataChecksum_init(void);   
void ConfigFLASHSMSReset(void);
void ffs_Check_stop(void);



TffsfileCmd ffsfileCmd;//ffs file cmd storage ,hxl add 2002-11-26

typedef enum
{
    DATA,
    NO_DATA
} WriteFlag;


FlashData FFS_flashData;
//-------------------------hxl added------------------------------
static const FlashData FlashDefaultData=
{
    /*current time*/
    0,  //uint8 current_hour;
    0,   //	uint8 current_minute;
    /*current date*/
    0, //	uint8 current_day;
    0, //	uint8 current_month;
    0, //	uint16 current_year;
    /*alarm data*/
    0, //	uint8 alarm_hour;
    0, //	uint8 alarm_minute;
    0, //	uint8 alarm_day;
    0, //	uint8 alarm_month;
    0, //	uint16 alarm_year;
    20, //    uint8 timeZone;  BeiJing time
    1, //  unit8 cityNumber;
    0,  // full hour alert flag
    12, //everyday alarm hour
    30, //everyday alarm min
    0,  //everyday alarm switch
    12, //weekly alarm hour
    30, //weekly alarm min
    0,  //weekly alarm switch, it should be decode
    "",    //uint8  weeklyChineseString[50];
    "",    //uint8  weeklyEnglishString[50];
    /*Call timers*/
    0, //	uint32 last_call_duration;
    0, //	uint32 incoming_calls_duration;
    0, //	uint32 outgoing_calls_duration;

    /*MSSET data*/

    0, //	uint8 output_volume;
    0, //	uint8 voice_memo_position;
    0, //	uint8 PLMN_selection_mode;
    0,     //uint8 Band_restriction; //xsf 2002.07.31 for band set
    0, //	uint8 redial_mode;
    1, //   uint8 time_format;
    0,// uint8 call_minute_flag WUFEI ADD

    /* Network Log              */
    0, //   uint8 net_log_status;                 /* status                   */
    {0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0}, //   uint8 plmn_name[20];                /* plmn name                */
    {0,0,0,0, 0,0},    //   uint8 network_name [6];             /* plmn name numeric        */

    /*Setting status*/

    0, //	uint8 settings_status;

    {0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,},   //	uint8 voice_mail[22];

    /*mailbox number*/
    {0,0,0,0, 0,0,0,0, 0,0},   //	uint8 mbn_AlphId[10];
    0, //	uint8 mbn_len;
    0, //	uint8 mbn_numTp;
    {0,0,0,0, 0,0,0,0, 0,0},   //	uint8 mbn_Num[10];

    //Predictive text Flags
    0, //	uint8 PredTextAvailable;
    0, //	uint8 PredTextSelected;

    //CPHS ALS info
    0, //	uint8 als_selLine;
    0, // 	uint8 als_statLine;
    0,0,{0,0},{0,0}, //gdy add autopower
    {0,0,0,0,0,0,0,0,0,0,0,0,0},//gdy add for latest alarm time
    AllLanguage,//CB language
    0xFF,
    {0, 0xFE, 0xFF, 0xFF, 0xFF,
        0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
        0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
        0xFF, 0xFF, 0xFF, 0xFF, 0xFF},//CB DCS 
    {0x0000, 0x0001, 0x0002, 0x0003, 0x0004,0x0005,0x0006,0x0007,0x0008,0x0009,0xFFFF,0xFFFF,
        0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF},//CB MID 
    0,
    0,
    {TxtSendSms,TxtReadSms,TxtAlarm,TxtScene,TxtMissedCalls,TxtIncomingCalls,0,0,0,0,0,0,0,0,0}, //zhangxp add for shortcut menu
    2,//		/* 2004/06/01 sunsj modify */
    0,//uint language 
    7,//Աȶǿ
    0,10,0  //hxl add for dict 2002-12-24
};
FieldTest   FFS_FieldTest;

static const FieldTest FieldTestDefault=
{
    0xA5,
    0xA5,
    0xA5,
    0xA5,
    0xA5,
    0xA5,
    0xA5,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    '\0'
};


FlashConstData  Ffs_const_data;
static const FlashConstData FlashConstDefaultData=
{
    {0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38}   // 	uint8 serialnumber[8];

};

void flash_constdata_init(void)
{
    Ffs_const_data = FlashConstDefaultData;
}

effs_t flash_constdata_write()
{ 
    MmiTrace("flash_constdata_write");
    return ffs_fwrite(FFSFILE_CONSTCONFIG_PATH,  &Ffs_const_data, sizeof(Ffs_const_data));

}

effs_t flash_constdata_read()
{
    flash_constdata_init();//hxl add for avoid fread fail error 2002-11-25
    return ffs_fread(FFSFILE_CONSTCONFIG_PATH,  &Ffs_const_data, sizeof(Ffs_const_data));
}

//----------------------------end of hxl add------------------------------

//------------------------------WUFEI ADD 02/08/06--------------------------------
//Divert usual used number and cug number table:
FlashDCTb FlashDCTbData; //WUFEI
static const FlashDCTb FlashDCTbDefaultData=
{
    0,
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},//wufei add 1008
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},//hu binhao add 11-21
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},//wufei add 1008
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},//wufei add 1008
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},//wufei add 1008
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},//hu binhao add 11-21
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},//wufei add 1008
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},//wufei add 1008
    0,
    0, //hu binhao add 11-21 
    0,
    0,
    0,  //wufei add 0827
    0,//wufei add 0827
    0,//wufei add 0827
    1,//wufei add 0827  hu binhao change from 0 to 1 ,because the default select line is 1
    0,//wufei add 0918
    0,//hu binhao add 2002-11-28
    {0,0,0,0,0,0,0,0,0,0}, //hu binhao add 2002-11-28
    0,      //hu binhao 2002-12-23
    {0,0,0,0,0,0,0,0,0,0}, //hu binhao 2002-12-27 for 3120
    {0,0,0,0,0,0,0,0,0,0}, //hu binhao 2002-12-27 for 3120
    {0,0,0,0,0,0,0,0,0,0}, //hu binhao 2002-12-27 for 3120
    {0,0,0,0,0,0,0,0,0,0}, //hu binhao 2002-12-27 for 3120
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}}, //hu binhao 2002-12-28 for 3120
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}}, //hu binhao 2002-12-28 for 3120
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}}, //hu binhao 2002-12-28 for 3120
    {{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},//hu binhao 2002-12-28 for 3120
    0,
    0


};
//------added by ganchh-----------2002/8/27
const EF_RFCAP FlashRFCAPDataDefault=
{
    0x00,0x0B,0x41,0x00,0x00,0x00,0x00,0x00,0x50,0x00,0x00,0xA5,0X05,0x00,0xC0,0x00
};
//-----------ganchh

void FlashDCTbInitialise(void)
{
    FlashDCTbData = FlashDCTbDefaultData;
}

//----------added by ganchh 2002/8/27------------
effs_t FlashRFCAPInitialise()
{
    EF_RFCAP  FlashRFCAPData;
    FlashRFCAPData=FlashRFCAPDataDefault;
    return ffs_fwrite("/gsm/com/rfcap",&FlashRFCAPData, sizeof(EF_RFCAP));

}
//---------------ganchh
effs_t flash_DCTbwrite()
{
    MmiTrace("flash_DCTbwrite");

    //return ffs_fwrite("/mmi/DCTbData",&FlashDCTbData, sizeof(FlashDCTbData));//hxl delete for managing write flash
    ffsfileCmd.ffsfile[DCTFileIdx].pdir=FFSFILE_DCTB_PATH;
    ffsfileCmd.ffsfile[DCTFileIdx].pdata=&FlashDCTbData;
    ffsfileCmd.ffsfile[DCTFileIdx].size=sizeof(FlashDCTbData);
    ffsfileCmd.ffsfile[DCTFileIdx].writeStatus=1;
    //if time is stop
    return 0;

}

effs_t flash_DCTbread()
{
    uint8   readErrFlag;    //hu binhao 2002-11-28
    uint8   i,n;               //hu binhao 2002-11-28

    FlashDCTbInitialise();//hxl add for avoid fread fail error 2002-11-25
    /* 2004/04/22 sunsj modify */
    return ffs_fread(FFSFILE_DCTB_PATH,&FlashDCTbData, sizeof(FlashDCTbData));

    //----------------hu binhao 2002-11-28 begin---------------------------------
    //case : call number large than 10 
    readErrFlag=0;
    /*
    if((FlashDCTbData.LMNID>10)||(FlashDCTbData.LJNID>10)||(FlashDCTbData.LRNID>10)||(FlashDCTbData.LDNID>10)||(FlashDCTbData.MissedCallNum>10))
        {
            readErrFlag=1;
            FlashDCTbInitialise();
        }*/
    if( FlashDCTbData.LMNID>10 )
    {
        FlashDCTbData.LMNID=10;
        readErrFlag=1;
    }
    if( FlashDCTbData.LJNID>10 )
    {
        FlashDCTbData.LJNID=10;
        readErrFlag=1;
    }
    if( FlashDCTbData.LRNID>10 )
    {
        FlashDCTbData.LRNID=10;
        readErrFlag=1;
    }
    if( FlashDCTbData.LDNID>10 )
    {
        FlashDCTbData.LDNID=10;
        readErrFlag=1;
    }
    if( FlashDCTbData.MissedCallNum>10 )
    {
        FlashDCTbData.MissedCallNum=10;
        readErrFlag=1;
    }
    //case : flags beyond range
    if( (FlashDCTbData.nextcall!=0)&&(FlashDCTbData.nextcall!=1)&&(FlashDCTbData.nextcall!=2) )
    {
        readErrFlag=1;
        FlashDCTbData.nextcall=0;
    }
    if( FlashDCTbData.hideIDflag>1 )
    {
        readErrFlag=1;
        FlashDCTbData.hideIDflag&=1;
    }
    if( FlashDCTbData.callwaitflag>1 )
    {
        readErrFlag=1;
        FlashDCTbData.callwaitflag&=1;
    }

    if( FlashDCTbData.AutoAnswerFlag>1 )
    {
        readErrFlag=1;
        FlashDCTbData.AutoAnswerFlag&=1;
    }

    //case missedcalls is no equal the "1" num in Lmnfalg[10]
    n=0;
    for( i = 0; i < 10; i++ )
    {
        if( FlashDCTbData.LMNflag[i]==1 )
            n++;
    }
    if( n>FlashDCTbData.MissedCallNum )
    {
        readErrFlag=1;
        for( i = 0; i < 10; i++ )
            FlashDCTbData.LMNflag[i]=0; 
        FlashDCTbData.MissedCallNum=0;

    }

    if( readErrFlag==1 )
    {
        flash_DCTbwrite();
    }

    //----------------hu binhao 2002-11-28 end----------------------------------
}

//-----------------------------END OF WUFEI ADD-------------------------------

static WriteFlag write_flag;
int flash_formatted(void); /* SPR#2487 - DS - Function to check if FFS is formatted */

FlashSetting FlashSettingData;//zy Mobile Innovation
static const FlashSetting FlashSettingDefaultData=
{
    "Welcome",
    0,//zy 2003-02-14 we set greetingword needn't initial
    {"A","B","C","D","E"},
    3,//background
    0, //Outer idle wallpaper /* 2004/04/10 sunsj mdoify */
    0,//0,1ʡģʽ
    0,//
    0,//
    2,//ǿ
    18,
    0,
    7,//ʡ米رʱ
    0,
    0,//zy 10/22 hall on connect call
    0,//zy 02/14/2003 GPRS AUTOATTACH mode
    1,//zy 02/12/2003 led control on
 1	//LED switch	/* 2004/04/10 sunsj modify */
};//zy Mobile Innovation add "factory setting"
//--------------------------toolkit module added by gdy-----------------------------------------------------
T_MFW_DetailSche_index ScheDetailIndex[200];//gdy
T_MFW_SCHE_INDEX ScheIndex[200];//gdy
//FlashSchedule sche_data[78];//gdy
Flash_Sche  FFS_ScheData;//gdy

/* 2004/04/22 sunsj modify */
char ScheTable[3][20]={"DateSchedule1","DateSchedule2","DateSchedule3"};

static const Flash_Sche FlashScheduleDefaultData=
{
    {
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},
        {{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""},{{0,0},0,0,0,0,0,""}
    }
};

Flash_MData FFS_MemoData;

static const Flash_MData FlashMemoDefaultData=
{
    {
        {"",0},{"",0},{"",0},{"",0},{"",0},{"",0},{"",0},{"",0},{"",0},{"",0}
    }
};

Flash_Stopw   FFS_StopwData;//gdy
T_MFW_Stopw_INDEX  StopwIndex[5];

static const Flash_Stopw  FlashStopwatchDefaultData=
{
    {
        {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},"",0,0},
        {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},"",0,0},
        {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},"",0,0},
        {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},"",0,0},
        {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},"",0,0}
    }
};


void FlashSettingInitialise(void)
{
    FlashSettingData = FlashSettingDefaultData;
}//zy Mobile Innovation


//start of xsf add 2002.08.05
//hostkey
FlashHostkey FlashHostkeyData;
FlashEnvironment FlashEnvironmentData;
static const FlashHostkey FlashHostkeyDefaultData=
{
    0,
    {0x31,0x31,0x31,0x31,0,0,0,0},
    {0,0,0,0,0},0,
    {0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff}
};

static const FlashEnvironment FlashEnvDefaultData =
{ // default settings.
    NORMAL_ENV, //current environment
    {{
            RING,          //alert type
    3,           //index of ring type  	 
            3,          //ring volume
            0,          //uint8  Autoanswerflag
            0,           //uint8  Anykeyanswerflag
            1,          //uint8  connecttone
            RING,      //PromptEnum      alarmprompt;   //xsf add 2002.08.14
   	6,         // index of uint8  alarmtype
            3,         //alarm volume
            5,         //uint8       speakervolume;   //xsf add 2002.08.30 
            RING,   //SmsAlertType   SMSTone
            3,         //smsvolume
            1,         //uint8         KeypadTone
            0,        //uint8         MissedcallTone
            0,        //uint8         UnreadSMSTone
            3,        //uint8		KeypadVolume	//2003/12/08 sunsj
            0,              //WYJ 04.1.13 uint8	OnRingtype;	//λΪ 1 
            3,              //WYJ 04.1.13  uint8 OnVolume;
            1,              //WYJ 04.1.13  uint8 OffRingtype;
            3,              //WYJ 04.1.13  uint8 OffVolume;
            2,              //WYJ 04.2.12 uint8	HallOnRingtype;	//λΪ 1 
            3,              //WYJ 04.2.12 uint8 HallOnVolume;
            3,              //WYJ 04.2.12 uint8 HallOffRingtype;
            3,              //WYJ 04.2.12 uint8 HallOffVolume;
        }, //normal
        {
            RING,          //alert type
    3,           //index of ring type  	 
            6,   //ring volume
            0,          //uint8  Autoanswerflag
            0,           //uint8  Anykeyanswerflag
            1,          //uint8  connecttone
            RING,      //PromptEnum      alarmprompt;   //xsf add 2002.08.14
   	6,         // index of uint8  alarmtype
            6,         //alarm volume
            6,         //uint8       speakervolume;   //xsf add 2002.08.30 
            SMSRING,   //SmsAlertType   SMSTone
            6,         //smsvolume
            1,         //uint8         KeypadTone
            0,        //uint8         MissedcallTone
            0,        //uint8         UnreadSMSTone
            4,        //uint8		KeypadVolume	//2003/12/08 sunsj
            0,              //WYJ 04.1.13 uint8	OnRingtype;	//λΪ 1 
            4,              //WYJ 04.1.13 uint8 uint8 OnVolume;
            1,              //WYJ 04.1.13 uint8 uint8 OffRingtype;
            4,              //WYJ 04.1.13 uint8 uint8 OffVolume;
            2,              //WYJ 04.2.12 uint8	HallOnRingtype;	//λΪ 1 
            4,              //WYJ 04.2.12 uint8 HallOnVolume;
            3,              //WYJ 04.2.12 uint8 HallOffRingtype;
            4,              //WYJ 04.2.12 uint8 HallOffVolume;
        }, //outdoor
        {
            VIBRA,          //alert type
    3,           //index of ring type  	 
            0,         //ring volume
            0,          //uint8  Autoanswerflag
            0,           //uint8  Anykeyanswerflag
            0,          //uint8  connecttone
            VIBRA,      //PromptEnum      alarmprompt;   //xsf add 2002.08.14
   	6,         // index of uint8  alarmtype
            0,         //alarm volume
            3,         //uint8       speakervolume;   //xsf add 2002.08.30 
            SMSVIBRA,   //SmsAlertType   SMSTone
            0,         //smsvolume
            0,         //uint8         KeypadTone
            0,        //uint8         MissedcallTone
            0,        //uint8         UnreadSMSTone
            0,         //uint8		KeypadVolume	//2003/12/08 sunsj
            0x80,   //WYJ 04.1.13 uint8	OnRingtype;	//λΪ 1 
            0,      //WYJ 04.1.13 uint8 uint8 OnVolume;
            0x81,   //WYJ 04.1.13 uint8 uint8 OffRingtype;
            0,      //WYJ 04.1.13 uint8 uint8 OffVolume;
            0x82,   //WYJ 04.2.12 uint8	HallOnRingtype;	//λΪ 1 
            0,      //WYJ 04.2.12 uint8 HallOnVolume;
            0x83,   //WYJ 04.2.12 uint8 HallOffRingtype;
            0,      //WYJ 04.2.12 uint8 HallOffVolume;
        }, //meeting env  
        {
            VIBRA,          //alert type
    3,           //index of ring type  	 
            4,   //ring volume
            0,          //uint8  Autoanswerflag
            0,           //uint8  Anykeyanswerflag
            1,          //uint8  connecttone
            VIBRA,      //PromptEnum      alarmprompt;   //xsf add 2002.08.14
   	6,         // index of uint8  alarmtype
            4,         //alarm volume
            6,         //uint8       speakervolume;   //xsf add 2002.08.30 
            SMSRING,   //SmsAlertType   SMSTone
            4,         //smsvolume
            1,         //uint8         KeypadTone
            0,        //uint8         MissedcallTone
            0,        //uint8         UnreadSMSTone
            3,         //uint8		KeypadVolume	//2003/12/08 sunsj
            0,              //WYJ 04.1.13 uint8	OnRingtype;	//λΪ 1 
            3,              //WYJ 04.1.13 uint8 uint8 OnVolume;
            1,              //WYJ 04.1.13 uint8 uint8 OffRingtype;
            3,              //WYJ 04.1.13 uint8 uint8 OffVolume;
            2,              //WYJ 04.2.12 uint8	HallOnRingtype;	//λΪ 1 
            3,              //WYJ 04.2.12 uint8 HallOnVolume;
            3,              //WYJ 04.2.12 uint8 HallOffRingtype;
            3,              //WYJ 04.2.12 uint8 HallOffVolume;
        }, //incar env  
        {
            ALERTMUTE,          //alert type
    3,           //index of ring type  	 
            0,   //ring volume
            0,          //uint8  Autoanswerflag
            0,           //uint8  Anykeyanswerflag
            0,          //uint8  connecttone
            ALERTMUTE,      //PromptEnum      alarmprompt;   //xsf add 2002.08.14
            0,         // index of uint8  alarmtype
            0,         //alarm volume
            5,         //uint8       speakervolume;   //xsf add 2002.08.30 
            0,         //SmsAlertType   SMSTone
            0,         //smsvolume
            0,         //uint8         KeypadTone
            0,        //uint8         MissedcallTone
            0,        //uint8         UnreadSMSTone
            0,          //uint8		KeypadVolume	//2003/12/08 sunsj
            0x80,   //WYJ 04.1.13 uint8	OnRingtype;	//λΪ 1 
            0,      //WYJ 04.1.13 uint8 uint8 OnVolume;
            0x81,   //WYJ 04.1.13 uint8 uint8 OffRingtype;
            0,      //WYJ 04.1.13 uint8 uint8 OffVolume;
            0x82,   //WYJ 04.2.12 uint8	HallOnRingtype;	//λΪ 1 
            0,      //WYJ 04.2.12 uint8 HallOnVolume;
            0x83,   //WYJ 04.2.12 uint8 HallOffRingtype;
            0,      //WYJ 04.2.12 uint8 HallOffVolume;
        } //mute env 
    }
};
void FlashHostkeyInitialise(void)
{
    FlashHostkeyData = FlashHostkeyDefaultData;
}

void FlashEnviroInitialise(void)
{
    FlashEnvironmentData = FlashEnvDefaultData;
}
//end of xsf add 2002.08.05

/*---------------------windy added followed struct for common sms-----------------------------*/
CoMessage FFS_CoMsg[CommonMsgNum];
/*2004/04/13,talcon modify*/
static const CoMessage ALDefaultCommonSMS[CommonMsgNum]=
{  
    {"\x80\x8b\xf7\x56\xde\x75\x35\x00"}/*ص*/,
    {"\x80\x66\x0e\x59\x29\x89\xc1\x30\x02\x00"}/**/,
    //{"\x80\x62\x11\x57\x28\x5f\x00\x4f\x1a\xff\x0c\x7b\x49\x4f\x1a\x51\x8d\x80\x54\x7c\xfb\x30\x02\x00"}/*ڿᣬȻϵ*/, 
    {"\x80\x58\x35\x8f\x66\xff\x0c\x66\x5a\x4e\x9b\x52\x30\x30\x02\x00"}/*³Щ*/,
    {"\x80\x80\x01\x57\x30\x65\xb9\x89\xc1\x00"}/*ϵط*/,
    {"\x80\x4e\xca\x59\x29\x52\xa0\x73\xed\x00"}/*Ӱ*/,
    {"\x80\x8b\xf7\x7e\xd9\x62\x11\x52\x9e\x51\x6c\x5b\xa4\x62\x53\x75\x35\x8b\xdd\x00"}/*ҰҴ绰*/,
    {"\x80\x75\x1f\x65\xe5\x5f\xeb\x4e\x50\x00"},/*տ*/
    // {"\x80\x8b\xf7\x7e\xd9\x62\x11\x5b\xb6\x91\xcc\x62\x53\x75\x35\x8b\xdd\x00"}/*Ҽ绰*/,
    {"\x80\x59\x7d\x76\x84\x30\x02\x00"}/*õġ*/,
    {"\x80\x4e\xca\x66\x5a\x67\x09\x7a\x7a\x54\x17\xff\x1f\x00"}/*п*/,
    {"\x80\x62\x11\x73\xb0\x57\x28\x5f\xd9\xff\x0c\x66\x5a\x4e\x9b\x62\x53\x75\x35\x8b\xdd\x7e\xd9\x4f\x60\x00"},/*æЩ绰*/
    { "\x80\x65\xb0\x58\x9e\x67\x61\x76\xee\x00"},/*Ŀ*/
    { "\x80\x65\xb0\x58\x9e\x67\x61\x76\xee\x00"},/*Ŀ*/
    { "\x80\x65\xb0\x58\x9e\x67\x61\x76\xee\x00"},/*Ŀ*/
    { "\x80\x65\xb0\x58\x9e\x67\x61\x76\xee\x00"},/*Ŀ*/
    { "\x80\x65\xb0\x58\x9e\x67\x61\x76\xee\x00"},/*Ŀ*/
};
void CommonSmsInitialise(void)
{
    memcpy(FFS_CoMsg,ALDefaultCommonSMS,CommonMsgNum*sizeof(CoMessage)); 
    //FFS_CoMsg = ALDefaultCommonSMS;
}
effs_t Common_Smswrite()
{ //write_flag = DATA;
    //return ffs_fwrite("/mmi/FlashSmsData",  &FFS_SMSData, sizeof(FFS_SMSData));
    ffsfileCmd.ffsfile[CommonSmsFileIdx].pdir=FFSFILE_COM_SMS_PATH;
    ffsfileCmd.ffsfile[CommonSmsFileIdx].pdata=(CoMessage*)FFS_CoMsg;
    ffsfileCmd.ffsfile[CommonSmsFileIdx].size=CommonMsgNum*sizeof(CoMessage);
    ffsfileCmd.ffsfile[CommonSmsFileIdx].writeStatus=1;
    return 0;

}
effs_t Common_Smsread()
{
    CommonSmsInitialise();  //hxl add for avoid fread fail error 2002-11-25
    /* 2004/04/22 sunsj modify */
    return ffs_fread(FFSFILE_COM_SMS_PATH, (CoMessage*) FFS_CoMsg, CommonMsgNum*sizeof(CoMessage));
}

/*---------------------end windy added for common sms-----------------------------*/

/*---------------------windy added followed struct for flash sms-----------------------------*/
FlashSMSdata             FFS_SMSData;
T_MMI_FLASH_SMS_INDEX Flash_sms_messages[FLSAH_SMS_NUM]; /* store info about the SMS: index... */
UBYTE    FlashSMStotal;
T_MFW_FS_TABLE       CurrentFlashSmsTable;
char FlashSMSTable[FlashSMS_Table][15]={"MobileSMS1","MobileSMS2","MobileSMS3","MobileSMS4","MobileSMS5"};

static const FlashSMSdata ALDefaultFlashSMS=
{  
    { 
        {-1,"",{"","","","","","",0},"",0,0,0xff,FALSE},{-1,"",{"","","","","","",0},"",0,0,0xff,FALSE},
        {-1,"",{"","","","","","",0},"",0,0,0xff,FALSE},{-1,"",{"","","","","","",0},"",0,0,0xff,FALSE},{-1,"",{"","","","","","",0},"",0,0,0xff,FALSE},//05
        {-1,"",{"","","","","","",0},"",0,0,0xff,FALSE},{-1,"",{"","","","","","",0},"",0,0,0xff,FALSE},
        {-1,"",{"","","","","","",0},"",0,0,0xff,FALSE},{-1,"",{"","","","","","",0},"",0,0,0xff,FALSE},{-1,"",{"","","","","","",0},"",0,0,0xff,FALSE},//10
    },
    //  0,
};
void Get_FlashSms_data(void)
{
    int i,j;

    FlashSMStotal=0; 
    memset(Flash_sms_messages,0,sizeof(T_MMI_FLASH_SMS_INDEX)*FLSAH_SMS_NUM);
    for( i=0;i<FlashSMS_Table;i++ )
    {
        if( flash_Smsread(FlashSMSTable[i])!=0 )
        {
            for( j=0;j<FlashSMS_table_len;j++ )
            {
                if( (FFS_SMSData.NVMSMS[j].flag)!=FALSE )
                {
                    Flash_sms_messages[j+i*FlashSMS_table_len].index = j+i*FlashSMS_table_len;
                    Flash_sms_messages[j+i*FlashSMS_table_len].id= FFS_SMSData.NVMSMS[j].id;
                    Flash_sms_messages[j+i*FlashSMS_table_len].state = FFS_SMSData.NVMSMS[j].state;
                    Flash_sms_messages[j+i*FlashSMS_table_len].flag= FFS_SMSData.NVMSMS[j].flag;
                    strcpy(Flash_sms_messages[j+i*FlashSMS_table_len].addr, FFS_SMSData.NVMSMS[j].addr);
                    memcpy(&Flash_sms_messages[j+i*FlashSMS_table_len].time, &FFS_SMSData.NVMSMS[j].time, sizeof(T_MFW_SMS_SCTP));
                    FlashSMStotal++;
                }
                else
                {
                    Flash_sms_messages[j+i*FlashSMS_table_len].index = j+i*FlashSMS_table_len;
                    Flash_sms_messages[j+i*FlashSMS_table_len].flag= FFS_SMSData.NVMSMS[j].flag;              
                }                          
            }
            CurrentFlashSmsTable=i;
        }
    }

}

void FlashSmsInitialise(void) 
{
    int i;

    CurrentFlashSmsTable=FlashSmsNULL;
    /* 2004/04/22 sunsj modify */
    if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
    {
        flash_PBmkdir(FFSFILE_DIRECTORY);
        ConfigFLASHSMSReset();            
        flash_Smswrite(FlashSMSTable[0]);
    }
    else
    {
        //if flashSms file is not exist, read default data
        for( i=0;i<FlashSMS_Table;i++ )
        {
            if( flash_Smsread(FlashSMSTable[i])==0 )
            {
                ConfigFLASHSMSReset();
                flash_Smswrite(FlashSMSTable[i]);                                      
                CurrentFlashSmsTable=i;
            }
        }
        //if flashSms file exist, read file data
        Get_FlashSms_data();
    }
}

effs_t flash_Smswrite(const char *filename) 
{ 
    char str[20]="/bmi/"; /* 2004/04/22 sunsj modify */
    int       idx=0;
    char *path=0;
    TRACE_FUNCTION("flash_Smswrite");
    strcat(str,filename);  
    //MmiTrace("flash_Smswrite");
    return ffs_fwrite(str,&FFS_SMSData,sizeof(FFS_SMSData)); 
}

void ConfigFLASHSMSReset(void)
{
    FFS_SMSData=ALDefaultFlashSMS;
}

int  flash_Smsread(const char *filename)
{
    char str[20]="/bmi/";  
    TRACE_FUNCTION ("flash_Smsread()");
    strcat(str,filename);
    if( flash_CheckStat(str)<0 )
        return 0;
    else
    {
        ConfigFLASHSMSReset();          //hxl add for avoid fread fail error 2002-11-25
        return ffs_fread(str,&FFS_SMSData,sizeof(FFS_SMSData));
    }
}
#if 0
void FlashSmsInitialise(void)
{
    FFS_SMSData = ALDefaultFlashSMS;
}
effs_t flash_Smswrite()
{ //write_flag = DATA;
    //return ffs_fwrite("/mmi/FlashSmsData",  &FFS_SMSData, sizeof(FFS_SMSData));
    ffsfileCmd.ffsfile[SmsFileIdx].pdir=FFSFILE_SMS_PATH;
    ffsfileCmd.ffsfile[SmsFileIdx].pdata=&FFS_SMSData;
    ffsfileCmd.ffsfile[SmsFileIdx].size=sizeof(FFS_SMSData);
    ffsfileCmd.ffsfile[SmsFileIdx].writeStatus=1;
    return 0;

}
effs_t flash_Smsread()
{
    FlashSmsInitialise();   //hxl add for avoid fread fail error 2002-11-25
    return ffs_fread(FFSFILE_SMS_PATH,  &FFS_SMSData, sizeof(FFS_SMSData));
}
#endif


/*---------------------end windy added for flash sms-----------------------------*/

/*------------------------------phonebook default data struct and function------------------*/
static const FlashPBotherdata ALDefaultOtherConfigPhbk=
{  
    {{"",""},{"",""},{"",""},{"",""},{"",""},{"",""},{"",""},{"",""},{"",""}},
    {{"",0,0},{"",0,0},{"",0,0},{"",0,0},{"",0,0},{"",0,0},{"",0,0},{"",0,0},{"",0,0},{"",0,0}}
};

static const FlashPBdata ALDefaultConfigPhbk=
{
    {{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//05
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//10
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//15
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//20
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//25
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//30
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//35
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//40
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//45
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//50
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//55
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//60
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//65
        {"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},{"","","","","",0x0F},//70
        {"","","","","",0x0F},{"","","","","",0x0F},//72
    }  
};

/* glowing: add the record time from 20 seconds to 30 seconds, cut down
   VM_file from 10 to 6 */

/*
static const FlashVMdata ALDefaultConfigVM=
{
  {{"",0,0,0,0,0,0},{"",0,0,0,0,0,0},{"",0,0,0,0,0,0},{"",0,0,0,0,0,0},{"",0,0,0,0,0,0},//05   
   {"",0,0,0,0,0,0},{"",0,0,0,0,0,0},{"",0,0,0,0,0,0},{"",0,0,0,0,0,0},{"",0,0,0,0,0,0}}//10  
};

char vm_name[VM_file][5]={"vm01","vm02","vm03","vm04","vm05",
                          "vm06","vm07","vm08","vm09","vm10"};
*/


static const FlashVMdata ALDefaultConfigVM=
{
    {{"",0,0,0,0,0,0},{"",0,0,0,0,0,0},{"",0,0,0,0,0,0},{"",0,0,0,0,0,0},{"",0,0,0,0,0,0},//05   
        {"",0,0,0,0,0,0}}//6  
};

char vm_name[VM_file][5]={"vm01","vm02","vm03","vm04","vm05",
    "vm06"};

/* 2004/04/22 sunsj modify */
char PBTable[PHB_PBTable][15]={"PhoneRecord1","PhoneRecord2","PhoneRecord3"};

FlashVMdata            FFS_VMData;
FlashPBdata             FFS_PBData;
FlashPBotherdata         FFS_PBOtherData;
T_MFW_PHB_INDEX       l_phb_index[ALL_NUMBER_LIST];
UINT8 SimNumber[ALL_SIM_LIST][PHB_number_len/2+1];
int                     NVMTotal,SIMTotal,PHBKTotal;
U8                     SIMLoadingPhbk;
U8              NVMLoadingPhbk=TRUE;//hxl add for update nvm list data 2002-10-21
T_MFW_PHB_SORT_INDEX l_phb_sort_index[ALL_NUMBER_LIST];
T_MFW_PHB_TABLE       CurrentTable;
T_EntryEvent            phonebookstatus;
int                     Copyidx;

static MfwHnd ffscheck=0;       //Bob added 02/17
int ffs_status=0;       //Bob added 02/17	
void FfsCheckEvent();
void ConfigVMReset(void)
{
    FFS_VMData=ALDefaultConfigVM;
}

int flash_VMwrite(const char *filename) 
{ 
    char str[20]="/voicememory/";
    strcat(str,filename);  
    MmiTrace("flash_VMwrite");

    //return ffs_fwrite(str,&FFS_VMData,sizeof(FFS_VMData));
    ffsfileCmd.ffsfile[VMFileIdx].pdir=FFSFILE_VM_PATH;
    ffsfileCmd.ffsfile[VMFileIdx].pdata=&FFS_VMData;
    ffsfileCmd.ffsfile[VMFileIdx].size=sizeof(FFS_VMData);
    ffsfileCmd.ffsfile[VMFileIdx].writeStatus=1;
    //if time is stop
    return 0;

}

int  flash_VMread(const char *filename)
{
    char str[20]="/voicememory/";  
    strcat(str,filename);
    if( flash_CheckStat(str)<0 ) return 0;
    else
    {
        ConfigVMReset();        //hxl add for avoid fread fail error 2002-11-25
        return ffs_fread(str,&FFS_VMData,sizeof(FFS_VMData));
    }
}

static const ffsgamedata defaulffs_gamedata=
{
    /*
{20000, 20000, 20000, 15000},
{
    {IconDifficult,   0             },
    {IconAudio  ,  40             },
    {IconLeft   ,  KCD_MNULEFT   },
    {IconRight  ,  KCD_MNURIGHT },
    {IconDown  ,  KCD_MNUDOWN },
    {IconUp    ,  KCD_MNUUP    },
    {IconFire   ,  KCD_OK        },
    {IconExit   ,  KCD_HUP       },
    {IconDefault ,  0xff          },
},
*/
#if 0
    {
        {IconAudio  , 40},
        {IconLeft   ,  KCD_MNULEFT},
        {IconRight  ,  KCD_MNURIGHT},
        {IconDown  ,  KCD_MNUDOWN},
        {IconChange,  KCD_OK},
        {IconPause,   KCD_CALL},
        {IconExit   ,  KCD_HUP},
        {IconDefault ,  0xff},
    },
    {
        {IconAudio  ,  40},
        {IconLeft   ,  KCD_MNULEFT},
        {IconRight  ,  KCD_MNURIGHT},
        {IconDown  ,  KCD_MNUDOWN},
        {IconUp    ,  KCD_MNUUP},
        {IconRestart ,  KCD_CALL},
        {IconRegret ,  KCD_RIGHT},
        {IconExit   ,  KCD_HUP},
        {IconDefault ,  0xff},
    },
#endif
    //{1880,1000,1000,100,0,},
    {500,400,300,0,0,},//russia score
    {//bocmap save
        {1,1,1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,4,1,1,1,1,1,1,
            1,1,1,1,1,2,1,1,1,1,1,1,
            1,1,1,1,1,3,2,3,4,1,1,1,
            1,1,1,4,2,3,5,1,1,1,1,1,
            1,1,1,1,1,1,3,1,1,1,1,1,
            1,1,1,1,1,1,4,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,1,1},
        2,
        0
    },
 /*2004/0515,talcon modify*/
 {0,0,0,0,0,},//snake score
};

ffsgamedata ffs_gamedata;

void ConfigGameInit(void)
{
    memcpy(&ffs_gamedata,&defaulffs_gamedata,sizeof(ffsgamedata));
}

int flash_Gamewrite(void)   
{ 
    MmiTrace("flash_Gamewrite");

    ffsfileCmd.ffsfile[GameFileIdx].pdir=FFSFILE_GAME_PATH;
    ffsfileCmd.ffsfile[GameFileIdx].pdata=&ffs_gamedata;
    ffsfileCmd.ffsfile[GameFileIdx].size=sizeof(ffsgamedata);
    ffsfileCmd.ffsfile[GameFileIdx].writeStatus=1;
    return 0;

}

int  flash_Gameread(void)
{
	if(ffsfileCmd.ffsfile[GameFileIdx].writeStatus==1)
		return 0;
    ConfigGameInit();       //hxl add for avoid fread fail error 2002-11-25
    return ffs_fread(FFSFILE_GAME_PATH,&ffs_gamedata,sizeof(ffsgamedata));
}

void ConfigPhbkReset(void)
{
    FFS_PBData=ALDefaultConfigPhbk;
}

void ConfigPhbkOtherReset(void)
{
    FFS_PBOtherData=ALDefaultOtherConfigPhbk;
}

effs_t flash_PBwrite(const char *filename)  
{ 
    char str[20]="/bmi/"; /* 2004/04/22 sunsj modify */
    int       idx=0;
    char *path=0;
    strcat(str,filename);  
    MmiTrace("flash_PBwrite");

    return ffs_fwrite(str,&FFS_PBData,sizeof(FFS_PBData)); 
#if 0
    switch( filename[9] )   //"PhoneBook7"
    {
    case 0x31:
        idx=PHB1FileIdx;
        path=FFSFILE_PHB1_PATH;
        break;
    case 0x32:
        idx=PHB2FileIdx;
        path=FFSFILE_PHB2_PATH;
        break;
    case 0x33:
        idx=PHB3FileIdx;
        path=FFSFILE_PHB3_PATH;
        break;
    case 0x34:
        idx=PHB4FileIdx;
        path=FFSFILE_PHB4_PATH;
        break;
    case 0x35:
        idx=PHB5FileIdx;
        path=FFSFILE_PHB5_PATH;
        break;
    case 0x36:
        idx=PHB6FileIdx;
        path=FFSFILE_PHB6_PATH;
        break;
    case 0x37:
        idx=PHB7FileIdx;
        path=FFSFILE_PHB7_PATH;
        break;
    default:
        break;
    }

    ffsfileCmd.ffsfile[idx].pdir=path;
    ffsfileCmd.ffsfile[idx].pdata=&FFS_PBData;
    ffsfileCmd.ffsfile[idx].size=sizeof(FFS_PBData);
    ffsfileCmd.ffsfile[idx].writeStatus=1;
    //if time is stop
    return 0;

#endif
}

int  flash_PBread(const char *filename)
{
    char str[20]="/bmi/";     /* 2004/04/22 sunsj modify */
    strcat(str,filename);
    if( flash_CheckStat(str)<0 )
        return 0;
    else
    {
        ConfigPhbkReset();          //hxl add for avoid fread fail error 2002-11-25
        return ffs_fread(str,&FFS_PBData,sizeof(FFS_PBData));
    }
}

effs_t flash_PBOtherWrite(const char *filename) 
{ 
    char str[20]="/bmi/"; /* 2004/04/22 sunsj modify */
    strcat(str,filename);  
    MmiTrace("flash_PBOtherWrite");

    //return ffs_fwrite(str,&FFS_PBOtherData,sizeof(FFS_PBOtherData));  
    ffsfileCmd.ffsfile[PBOFileIdx].pdir=FFSFILE_PBO_PATH;
    ffsfileCmd.ffsfile[PBOFileIdx].pdata=&FFS_PBOtherData;
    ffsfileCmd.ffsfile[PBOFileIdx].size=sizeof(FFS_PBOtherData);
    ffsfileCmd.ffsfile[PBOFileIdx].writeStatus=1;
    //if time is stop
    return 0;

}

effs_t flash_PBOtherRead(const char *filename)
{
    char str[20]="/bmi/";     /* 2004/04/22 sunsj modify */
    strcat(str,filename);
    if( flash_CheckStat(str)<0 )
        return 0;
    else
    {
        ConfigPhbkOtherReset(); //hxl add for avoid fread fail error 2002-11-25
        return ffs_fread(str,&FFS_PBOtherData,sizeof(FFS_PBOtherData));
    }
}

#if 0
effs_t flash_PBupdate(const char *filename)
{ 
    char str[20]="/bmi/";     /* 2004/04/22 sunsj modify */
    strcat(str,filename);

    if( write_flag==DATA )
    {
        write_flag=NO_DATA;
        return ffs_fwrite(str,&FFS_PBData,sizeof(FFS_PBData));
    }
    else return EFFS_OK;
}
#endif

effs_t flash_PBmkdir(const char *pathname)
{
    return ffs_mkdir(pathname);
}

effs_t flash_Opendir(const char *pathname)
{
    struct dir_s dir;

    return ffs_opendir(pathname,&dir);
}

effs_t flash_CheckStat(const char *name)
{
    struct stat_s stat;

    return ffs_stat(name,&stat);
}

USHORT GetShortNumber(const char * numstr)
{
    USHORT ShortNum;
    char    Result[22];  /* 2003/12/22 sunsj modify */
    int      i,len;
    char tempstr[22]="";    /* 2003/12/22 sunsj modify */
    ShortNum=0x0000;
    /* 2003/12/22 sunsj initialize temp buffer */
    memset(tempstr, 0x00, sizeof(char)*22);
    if( numstr[0]=='+' )
        memcpy(tempstr,&numstr[3],18);
    else if( numstr[0]=='0'&&numstr[1]=='0' )
        memcpy(tempstr,&numstr[4],17);
    else memcpy(tempstr,numstr,21);
    len=strlen(tempstr)-1;
    for( i=len;i>=0;i-- )
        Result[len-i]=tempstr[i];
    Result[len-i]='\0';

    for( i=0;i<7;i=i+2 )
    {
        switch( i )
        {
        case 0: if( strlen(Result)-1>=i ) ShortNum=ShortNum+(Result[i]-48);
            else ShortNum=ShortNum+0x0F;       
            break;
        case 2: if( strlen(Result)-1>=i ) ShortNum=(ShortNum<<4)+(Result[i]-48);
            else ShortNum=(ShortNum<<4)+0x0F;      
            break;
        case 4: if( strlen(Result)-1>=i ) ShortNum=(ShortNum<<4)+(Result[i]-48);
            else ShortNum=(ShortNum<<4)+0x0F;      
            break;
        case 6: if( strlen(Result)-1>=i ) ShortNum=(ShortNum<<4)+(Result[i]-48);
            else ShortNum=(ShortNum<<4)+0x0F;      
            break;
        default:break;
        }
    }
    return ShortNum;
}

void CompressNum(const char * Num,unsigned char CompNum[])
{
    int  len,i;

    len=strlen(Num);
    for( i=0;i<len;i++ )
    {
        if( i%2==0 )
        {
            if( Num[i]==35 )
                CompNum[i/2]=2;
            else if( Num[i]==42 )
                CompNum[i/2]=3;
            else if( Num[i]==112 )
                CompNum[i/2]=4;
            else
                CompNum[i/2]=Num[i]-42;
        }
        else if( i%2==1 )
        {
            if( Num[i]==35 )
                CompNum[i/2]=(CompNum[i/2]<<4)+2;
            else if( Num[i]==42 )
                CompNum[i/2]=(CompNum[i/2]<<4)+3;
            else if( Num[i]==112 )
                CompNum[i/2]=(CompNum[i/2]<<4)+4;
            else
                CompNum[i/2]=(CompNum[i/2]<<4)+(Num[i]-42);
        }
    }

    if( i%2==1 ) CompNum[i/2]=(CompNum[i/2]<<4)+0x00;
    else if( i%2==0 ) CompNum[i/2]=0x00;
}

void UnCompressNum(const char * CompNum,unsigned char Num[])
{
    int  i,j,ExitFlag;
    unsigned char GetByte;

    i=0;
    j=0;
    ExitFlag=0;
    do
    {
        GetByte=(CompNum[i]>>4) & 0x0F;
        if( GetByte!=0x00 )
        {
            if( GetByte==2 )
                Num[j]=35;
            else if( GetByte==3 )
                Num[j]=42;
            else if( GetByte==4 )
                Num[j]=112;
            else
                Num[j]=GetByte+42;
            j=j+1;
        }
        else
        {
            Num[j]='\0';
            ExitFlag=1;
        }

        if( ExitFlag!=1 )
        {
            GetByte=CompNum[i] & 0x0F;
            if( GetByte!=0x00 )
            {
                if( GetByte==2 )
                    Num[j]=35;
                else if( GetByte==3 )
                    Num[j]=42;
                else if( GetByte==4 )
                    Num[j]=112;
                else
                    Num[j]=GetByte+42;
                j=j+1;
            }
            else
            {
                Num[j]='\0';
                ExitFlag=1;
            }
            i=i+1;
        }
    }
    while( ExitFlag==0 );
}
//------------------------------------------------------------------------------------------
//begin xzy add for fieldtest 0124
effs_t flash_FTwrite()
{
    MmiTrace("flash_FTwrite");

    //return ffs_fwrite("/mmi/MmiData",  &FFS_flashData, sizeof(FFS_flashData));
    //ffsfileCmd.ffsfile[MMIFileIdx].pdir=FFSFILE_FIELDTEST_PATH;
    //ffsfileCmd.ffsfile[MMIFileIdx].pdata=&FFS_FieldTest;
    //ffsfileCmd.ffsfile[MMIFileIdx].size=sizeof(FFS_FieldTest);
    //ffsfileCmd.ffsfile[MMIFileIdx].writeStatus=1;
    //if time is stop
    ffs_fwrite(FFSFILE_FIELDTEST_PATH, &FFS_FieldTest, sizeof(FFS_FieldTest));

    return 0;

}

effs_t flash_FTread()
{
    FFS_FieldTest= FieldTestDefault;
    /* 2004/04/22 sunsj modify */
    return ffs_fread(FFSFILE_FIELDTEST_PATH,  &FFS_FieldTest, sizeof(FFS_FieldTest));

}
//end xzy add for fieldtest 0124
effs_t flash_write()
{ //write_flag = DATA;
    MmiTrace("flash_write");

    //return ffs_fwrite("/mmi/MmiData",  &FFS_flashData, sizeof(FFS_flashData));
    ffsfileCmd.ffsfile[MMIFileIdx].pdir=FFSFILE_CONFIG_PATH;
    ffsfileCmd.ffsfile[MMIFileIdx].pdata=&FFS_flashData;
    ffsfileCmd.ffsfile[MMIFileIdx].size=sizeof(FFS_flashData);
    ffsfileCmd.ffsfile[MMIFileIdx].writeStatus=1;
    //if time is stop

    return 0;
}

#if 0
effs_t flash_update()
{
    if( write_flag == DATA )
    {
        write_flag = NO_DATA;
        return ffs_fwrite(FFSFILE_CONFIG_PATH, &FFS_flashData, sizeof(FFS_flashData));
    }
    else
        return EFFS_OK;
}
#endif
#ifndef WIN32
// EF 22/10/02	for WIN32 simulation, set anykeyanswer on, and keylock off
int flash_read()
{ 
    FlashDataInitialise();      //hxl add for avoid fread fail error 2002-11-25
    /* 2004/04/22 sunsj modify */
    return ffs_fread(FFSFILE_CONFIG_PATH, &FFS_flashData, sizeof(FFS_flashData));
}
#else
int flash_read()
{FFS_flashData.settings_status|= SettingsAnyKeyAnswerOn;
    FFS_flashData.settings_status &= ~SettingsKeyPadLockOn;
}
#endif


effs_t flash_data_write(const char* dir_name, const char* file_name, void* data_pointer, int data_size)
{ 
    T_FFS_DIR dir;
    int val;
    char file[200];

    /* SPR#2487 - DS - If FFS is not formatted, return from function */
    if (flash_formatted() == FALSE)
    {
        TRACE_EVENT("ERROR flash_data_write(): NOT FORMATTED!");
        return EFFS_NOFORMAT;
    }

    val = FFS_opendir(dir_name, &dir);

    if(val < 0)
    {
        val = FFS_mkdir(dir_name);
        
        switch(val)
        {
        case EFFS_OK:
        case EFFS_EXISTS:
            break;
        default:
                TRACE_ERROR("The FFS directory could not be created!");
              	TRACE_EVENT_P2("val = %d dir name = %s", val, dir_name);
            return (effs_t)val; 	
        }
    }

    sprintf(file, "%s/%s", dir_name, file_name);
    val = FFS_fwrite( file, data_pointer, data_size);

    if(val NEQ EFFS_OK)
    {  
        TRACE_ERROR("The FFS file could not be created");
      	TRACE_EVENT_P2("val = %d file name = %s", val, file);
    }  
    return (effs_t)val;
}

/* glowing,2004-06-10, import from TCS2112 */
/* Marcus: Issue 1719: 11/02/2003: Changed return value from effs_t to int */
int flash_data_read(const char* dir_name, const char* file_name, void* data_pointer, int data_size)
{ 
    int val;
    char file[200];
      
    sprintf(file, "%s/%s", dir_name, file_name);

    val = FFS_fread( file, data_pointer, data_size);
    if (val NEQ data_size)
    {
        TRACE_ERROR("The FFS data could not be read!");
        TRACE_EVENT_P1("val = %d", val);
        /* Error, presumably -ve as in FFS_ERRORS, or the actual number of bytes read */
    }
    return val;
}

/* SPR#2487 - DS - Function to check if FFS is formatted */
int flash_formatted(void)
{
    T_FFS_DIR dir;
    int val;

    /* Attempt to open "/mmi" directory */
    val = FFS_opendir("/mmi", &dir);

    /* If return val is not EFFS_NOFORMAT then 
     * assume that FFS is formatted.
     */
    if (val == EFFS_NOFORMAT)
        return FALSE;
    else
        return TRUE;
}
    
/* glowing,2004-06-10, end of import */

/*.................... zy changed 04/08/02...................................................*/
effs_t flash_settingwrite()
{ //write_flag = DATA;
    MmiTrace("flash_settingwrite");

    //return ffs_fwrite("/mmi/SettingData",  &FlashSettingData, sizeof(FlashSettingData));
    ffsfileCmd.ffsfile[SetFileIdx].pdir=FFSFILE_SETTING_PATH;
    ffsfileCmd.ffsfile[SetFileIdx].pdata=&FlashSettingData;
    ffsfileCmd.ffsfile[SetFileIdx].size=sizeof(FlashSettingData);
    ffsfileCmd.ffsfile[SetFileIdx].writeStatus=1;
    //if time is stop
    return 0;

}//zy Mobile Innovation 


effs_t flash_settingread()
{
    FlashSettingInitialise();   //hxl add for avoid fread fail error 2002-11-25
    /* 2004/04/22 sunsj modify */
    return ffs_fread(FFSFILE_SETTING_PATH, &FlashSettingData, sizeof(FlashSettingData));
}//zy Mobile Innovation
//start of xsf add 2002.08.05
effs_t flash_hostwrite()
{ 
    MmiTrace("flash_hostwrite");

    //return ffs_fwrite("/mmi/HostkeyData",  &FlashHostkeyData, sizeof(FlashHostkeyData));
    /*ffsfileCmd.ffsfile[HstKeyFileIdx].pdir=FFSFILE_HOSTKEY_PATH;
    ffsfileCmd.ffsfile[HstKeyFileIdx].pdata=&FlashHostkeyData;
    ffsfileCmd.ffsfile[HstKeyFileIdx].size=sizeof(FlashHostkeyData);
    ffsfileCmd.ffsfile[HstKeyFileIdx].writeStatus=1;*/
    //xsf changed 2003.03.06 for "hostkey protect options" menu with KCD_OK/select .KCD_RIGHT/cancel.KCD_LEFT/confirm&save
    /* 2004/04/22 sunsj modify */
    ffs_fwrite(FFSFILE_HOSTKEY_PATH,  &FlashHostkeyData, sizeof(FlashHostkeyData));  
    return 0;

}

effs_t flash_hostread()
{
    FlashHostkeyInitialise();   //hxl add for avoid fread fail error 2002-11-25
    /* 2004/04/22 sunsj modify */
    return ffs_fread(FFSFILE_HOSTKEY_PATH, &FlashHostkeyData, sizeof(FlashHostkeyData));
}

effs_t flash_environmentwrite()
{ //write_flag = DATA;

    // return ffs_fwrite("/mmi/EnvironmentData",  &FlashEnvironmentData, sizeof(FlashEnvironmentData));
    ffsfileCmd.ffsfile[EnvirFileIdx].pdir=FFSFILE_ENVIR_PATH;
    ffsfileCmd.ffsfile[EnvirFileIdx].pdata=&FlashEnvironmentData;
    ffsfileCmd.ffsfile[EnvirFileIdx].size=sizeof(FlashEnvironmentData);
    ffsfileCmd.ffsfile[EnvirFileIdx].writeStatus=1;
    //if time is stop
    //	timStart(gtimFfsWrite);
    return 0;


}
effs_t flash_environmentread()
{
    FlashEnviroInitialise();    //hxl add for avoid fread fail error 2002-11-25
    return ffs_fread(FFSFILE_ENVIR_PATH,  &FlashEnvironmentData, sizeof(FlashEnvironmentData));
}
//end of xsf add 2002.08.05
/*
effs_t flash_PBmkdir(const char *pathname)
{
  return ffs_mkdir(pathname);
}

effs_t flash_CheckStat(const char *name)
{
  struct stat_s stat;

  return ffs_stat(name,&stat);
}
*/
/*....................end of zy changed 04/08/02...................................................*/
//---------------------------hxl add--------------------------------
void FlashDataInitialise(void)
{
    FFS_flashData = FlashDefaultData;
}

//--------------------------gdy add---------------------------------

effs_t Flash_ScheInitWrite(char * filename)
{
    int idx=0;
    char *path=0;
    char str[20]="/bmi/";   /* 2004/04/22 sunsj modify */
    strcat(str,filename);
    strcpy((char*)CurrentScheFileName,filename);
    MmiTrace("Flash_ScheInitWrite");

    //return ffs_fwrite( str, &FFS_ScheData,sizeof(FFS_ScheData));
    /* 2004/04/22 sunsj modify */
    switch( filename[12] )   //"DateSchedule1"
    {
    case 0x31:
        idx=Sche1FileIdx;
        path=FFSFILE_SCHEDUE1_PATH;
        break;
    case 0x32:
        idx=Sche2FileIdx;
        path=FFSFILE_SCHEDUE2_PATH;
        break;
    case 0x33:
        idx=Sche3FileIdx;
        path=FFSFILE_SCHEDUE3_PATH;
        break;
    default:
        break;
    }

    ffsfileCmd.ffsfile[idx].pdir=path;
    ffsfileCmd.ffsfile[idx].pdata=&FFS_ScheData;
    ffsfileCmd.ffsfile[idx].size=sizeof(FFS_ScheData);
    ffsfileCmd.ffsfile[idx].writeStatus=1;
    //if time is stop
    return 0;
}

int  Flash_ScheRead(char * filename)
{
    char str[20]="/bmi/";   /* 2004/04/22 sunsj modify */
    int iCount;
    strcat(str,filename);
    strcpy((char*)CurrentScheFileName,filename);
    memset(&FFS_ScheData,0,sizeof(FFS_ScheData));
    FlashScheDataInitialise();  //hxl add for avoid fread fail error 2002-11-25
    iCount=ffs_fread(str, &FFS_ScheData,sizeof(FFS_ScheData));
    //TraceInt(iCount);
    iCount/=sizeof(FlashSchedule);
    //TraceInt(iCount);
    return iCount;
}

void FlashScheDataInitialise(void)
{
    FFS_ScheData=FlashScheduleDefaultData;
    //memset(&FFS_ScheData,0,sizeof(Flash_Sche));
}

effs_t flash_Stopwrite()
{ //write_flag = DATA;
    MmiTrace("flash_Stopwrite");

    // return ffs_fwrite("/mmi/stopwatch",  &FFS_StopwData, sizeof(FFS_StopwData));
    ffsfileCmd.ffsfile[StpWatFileIdx].pdir=FFSFILE_STOPWATCH_PATH;
    ffsfileCmd.ffsfile[StpWatFileIdx].pdata=&FFS_StopwData;
    ffsfileCmd.ffsfile[StpWatFileIdx].size=sizeof(FFS_StopwData);
    ffsfileCmd.ffsfile[StpWatFileIdx].writeStatus=1;
    //if time is stop
    return 0;
}

effs_t flash_Stopwread()
{
    FlashStopwDataInitialise(); //hxl add for avoid fread fail error 2002-11-25
    /* 2004/04/22 sunsj modify */
    return ffs_fread(FFSFILE_STOPWATCH_PATH, &FFS_StopwData, sizeof(FFS_StopwData));
}

void FlashStopwDataInitialise(void)
{
    FFS_StopwData=FlashStopwatchDefaultData;
    //memset(&FFS_ScheData,0,sizeof(Flash_Sche));
}

effs_t flash_Memowrite()//gdy add for memo
{
    //write_flag = DATA;
    MmiTrace("flash_Memowrite");
    ffsfileCmd.ffsfile[MemoFileIdx].pdir=FFSFILE_MEMO_PATH;
    ffsfileCmd.ffsfile[MemoFileIdx].pdata=&FFS_MemoData;
    ffsfileCmd.ffsfile[MemoFileIdx].size=sizeof(FFS_MemoData);
    ffsfileCmd.ffsfile[MemoFileIdx].writeStatus=1;
    //if time is stop
    return 0;  
}

effs_t flash_Memoread()//gdy add for memo
{
    FlashMemoDataInitialise();
    /* 2004/04/22 sunsj modify */
    return ffs_fread(FFSFILE_MEMO_PATH, &FFS_MemoData, sizeof(FFS_MemoData));
}

void FlashMemoDataInitialise(void)
{
    FFS_MemoData=FlashMemoDefaultData;  
}

int Iswritefileend(char * filename, int filesize)
{
    struct stat_s stat;
    effs_t ret;

    char str[20]="/bmi/";   /* 2004/04/22 sunsj modify */
    strcat(str,filename);

    ret=ffs_stat(str, &stat); // /mmi/
    if( stat.size==filesize )
        return 1;
    else
        return 0;
}

//hxl add 30/08/02---------------------------------------------------------
ConfigDataCheck ConfigDataCheckSum;
uint16 getConfigData_checksum(char *filepath)
{
    uint16  checksumdata;
    uint16  size=0;
    uint8   *ptr;
    checksumdata=0;

    if( strcmp(filepath,FFSFILE_CONFIG_PATH)==0 )
    {
        ptr=( uint8 * )&FlashDefaultData;
        size= sizeof(FlashDefaultData);
    }
    else if( strcmp(filepath,FFSFILE_ENVIR_PATH)==0 )
    {
        ptr=( uint8 * )&FlashEnvDefaultData;
        size= sizeof(FlashEnvDefaultData);
    }
    else if( strcmp(filepath,FFSFILE_DCTB_PATH)==0 )
    {   //2002.09.02  
        ptr=( uint8 * )&FlashDCTbDefaultData;
        size= sizeof(FlashDCTbDefaultData);
    }
    else if( strcmp(filepath,FFSFILE_SETTING_PATH)==0 )
    {
        ptr=( uint8 * )&FlashSettingDefaultData;
        size= sizeof(FlashSettingDefaultData);
    }
    else if( strcmp(filepath,FFSFILE_HOSTKEY_PATH)==0 )
    {
        ptr=( uint8 * )&FlashHostkeyDefaultData;
        size= sizeof(FlashHostkeyDefaultData);
    }

    if( size )
        for( checksumdata = 0; size--; checksumdata += *ptr++ );

    return checksumdata;
}

uint16 getConfigData_size(char *filepath)
{
    uint16  size=0;

    if( strcmp(filepath,FFSFILE_CONFIG_PATH)==0 )
    {
        size= sizeof(FlashDefaultData);
    }
    else if( strcmp(filepath,FFSFILE_ENVIR_PATH)==0 )
    {
        size= sizeof(FlashEnvDefaultData);
    }
    else if( strcmp(filepath,FFSFILE_DCTB_PATH)==0 )
    {
        size= sizeof(FlashDCTbDefaultData);
    }
    else if( strcmp(filepath,FFSFILE_SETTING_PATH)==0 )
    {
        size= sizeof(FlashSettingDefaultData);
    }
    else if( strcmp(filepath,FFSFILE_HOSTKEY_PATH)==0 )
    {
        size= sizeof(FlashHostkeyDefaultData);
    }

    return size;
}


void flash_ConfigDataChecksum_init(void)
{
    ConfigDataCheckSum.Mmidata_sum=getConfigData_checksum(FFSFILE_CONFIG_PATH);
    ConfigDataCheckSum.Mmidata_size=sizeof(FlashDefaultData);
    ConfigDataCheckSum.Environment_sum=getConfigData_checksum(FFSFILE_ENVIR_PATH);
    ConfigDataCheckSum.Environment_size=sizeof(FlashEnvDefaultData);

    ConfigDataCheckSum.DCTbdata_sum=getConfigData_checksum(FFSFILE_DCTB_PATH);
    ConfigDataCheckSum.DCTbdata_size=sizeof(FlashDCTbDefaultData);
    ConfigDataCheckSum.Settingdata_sum=getConfigData_checksum(FFSFILE_SETTING_PATH);
    ConfigDataCheckSum.Settingdata_size=sizeof(FlashSettingDefaultData);
    ConfigDataCheckSum.Hostkeydata_sum=getConfigData_checksum(FFSFILE_HOSTKEY_PATH);
    ConfigDataCheckSum.Hostkeydata_size=sizeof(FlashHostkeyDefaultData);

}

effs_t flash_ConfigDataChecksum_write(void)
{
    ConfigDataCheckSum.Mmidata_sum=getConfigData_checksum(FFSFILE_CONFIG_PATH);
    ConfigDataCheckSum.Mmidata_size=sizeof(FlashDefaultData);
    ConfigDataCheckSum.Environment_sum=getConfigData_checksum(FFSFILE_ENVIR_PATH);
    ConfigDataCheckSum.Environment_size=sizeof(FlashEnvDefaultData);

    ConfigDataCheckSum.DCTbdata_sum=getConfigData_checksum(FFSFILE_DCTB_PATH);
    ConfigDataCheckSum.DCTbdata_size=sizeof(FlashDCTbDefaultData);
    ConfigDataCheckSum.Settingdata_sum=getConfigData_checksum(FFSFILE_SETTING_PATH);
    ConfigDataCheckSum.Settingdata_size=sizeof(FlashSettingDefaultData);
    ConfigDataCheckSum.Hostkeydata_sum=getConfigData_checksum(FFSFILE_HOSTKEY_PATH);
    ConfigDataCheckSum.Hostkeydata_size=sizeof(FlashHostkeyDefaultData);
    MmiTrace("flash_ConfigDataChecksum_write");

    //	return ffs_fwrite(FFSFILE_CONFIG_CHECK_PATH,&ConfigDataCheckSum, sizeof(ConfigDataCheckSum));
    ffsfileCmd.ffsfile[CheckFileIdx].pdir=FFSFILE_CONFIG_CHECK_PATH;
    ffsfileCmd.ffsfile[CheckFileIdx].pdata=&ConfigDataCheckSum;
    ffsfileCmd.ffsfile[CheckFileIdx].size=sizeof(ConfigDataCheckSum);
    ffsfileCmd.ffsfile[CheckFileIdx].writeStatus=1;
    return 0;
}

effs_t flash_ConfigDataChecksum_read(void)
{
    flash_ConfigDataChecksum_init();    //hxl add for avoid fread fail error 2002-11-25
    return ffs_fread(FFSFILE_CONFIG_CHECK_PATH,&ConfigDataCheckSum, sizeof(ConfigDataCheckSum));
}

//hxl add for QQ 2002-12-17-------------------------------------------------
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
TQQSET  ffs_qqset;
effs_t flash_QQSetWrite()
{ 
    MmiTrace("flash_QQSetWrite");

    ffsfileCmd.ffsfile[QQSetFileIdx].pdir=FFSFILE_QQSET_PATH;
    ffsfileCmd.ffsfile[QQSetFileIdx].pdata=&ffs_qqset;
    ffsfileCmd.ffsfile[QQSetFileIdx].size=sizeof(ffs_qqset);
    ffsfileCmd.ffsfile[QQSetFileIdx].writeStatus=1;
    return 0;
}

effs_t flash_QQSetread()
{
    MmiTrace("flash_QQSetread");
    Flash_QQSetInit();  //hxl add for avoid fread fail error 2002-11-25
    return ffs_fread(FFSFILE_QQSET_PATH,  &ffs_qqset, sizeof(ffs_qqset));
}

void Flash_QQSetInit(void)
{
    MmiTrace("Flash_QQSetInit");
    memset(&ffs_qqset,0,sizeof(TQQSET));
}

effs_t flash_QQDataWrite(int nfile)
{ 
    MmiTrace("flash_QQDataWrite");
    if( nfile>=1 )
    {
        ffsfileCmd.ffsfile[QQDataFile1Idx].pdir=FFSFILE_QQData1_PATH;
        ffsfileCmd.ffsfile[QQDataFile1Idx].pdata=pQQSmsfile1;
        ffsfileCmd.ffsfile[QQDataFile1Idx].size=1024;
        ffsfileCmd.ffsfile[QQDataFile1Idx].writeStatus=1;
    }
    if( nfile>=2 )
    {
        ffsfileCmd.ffsfile[QQDataFile2Idx].pdir=FFSFILE_QQData2_PATH;
        ffsfileCmd.ffsfile[QQDataFile2Idx].pdata=pQQSmsfile2;
        ffsfileCmd.ffsfile[QQDataFile2Idx].size=1024;
        ffsfileCmd.ffsfile[QQDataFile2Idx].writeStatus=1;
    }
    if( nfile>=3 )
    {
        ffsfileCmd.ffsfile[QQDataFile3Idx].pdir=FFSFILE_QQData3_PATH;
        ffsfileCmd.ffsfile[QQDataFile3Idx].pdata=pQQSmsfile3;
        ffsfileCmd.ffsfile[QQDataFile3Idx].size=1024;
        ffsfileCmd.ffsfile[QQDataFile3Idx].writeStatus=1;
    }
    if( nfile>=4 )
    {
        ffsfileCmd.ffsfile[QQDataFile4Idx].pdir=FFSFILE_QQData4_PATH;
        ffsfileCmd.ffsfile[QQDataFile4Idx].pdata=pQQSmsfile4;
        ffsfileCmd.ffsfile[QQDataFile4Idx].size=1024;
        ffsfileCmd.ffsfile[QQDataFile4Idx].writeStatus=1;
    }
    return 0;
}

effs_t flash_QQDataread(int havefile)
{
    MmiTrace("flash_QQDataread");

    readQQfile(havefile);
    return	1;

}
#endif
//end of hxl add for QQ 2002-12-17-------------------------------------------

void ffsfile_init(void)
{
    MmiTrace("ffsfile_init");

    Common_ffsfile_init();
    phonebook_ffsfile_init();
    FlashSmsInitialise();//added by windy 030325
}

void Common_ffsfile_init(void)
{
    // hxl changed, for should check the file 0827-----------------------------
    // flash file check, creat , write, read-----------
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
    if( flash_CheckStat(FFSFILE_QQSET_PATH)<0 )
    {
        /* 2004/04/22 sunsj modify */
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        Flash_QQSetInit();
        flash_QQSetWrite();
    }
    else
    {
        flash_QQSetread();
    }

    if( flash_CheckStat(FFSFILE_QQData1_PATH)>=0 )
    {
        flash_QQDataread(1);
    }
    else
        flash_QQDataread(0);
#endif
    if( flash_CheckStat("/voicememory/VM")<0 )
    {
        if( flash_CheckStat("/voicememory")<0 )
            flash_PBmkdir("/voicememory");
        ConfigVMReset();            
        flash_VMwrite("VM");    
    }
    else
    {
        flash_VMread("VM");    
    }

    /* 2004/04/22 sunsj modify */
    if( flash_CheckStat(FFSFILE_GAME_PATH)<0 )
    {
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        ConfigGameInit();
        flash_Gamewrite();
    }
    else
    {
        flash_Gameread();
    }

    if( (getConfigData_checksum(FFSFILE_DCTB_PATH)!=ConfigDataCheckSum.DCTbdata_sum)//user update the default data
        ||(getConfigData_size(FFSFILE_DCTB_PATH)!=ConfigDataCheckSum.DCTbdata_size) )
    {//user update the default data
        FlashDCTbInitialise();
        flash_DCTbwrite();
    }
    else
        if( flash_CheckStat(FFSFILE_DCTB_PATH)<0 )
    {
        /* 2004/04/22 sunsj modify */
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        FlashDCTbInitialise();
        flash_DCTbwrite();
    }
    else
    {
        flash_DCTbread();
    }

    if( (getConfigData_checksum(FFSFILE_SETTING_PATH)!=ConfigDataCheckSum.Settingdata_sum)//user update the default data
        ||(getConfigData_size(FFSFILE_SETTING_PATH)!=ConfigDataCheckSum.Settingdata_size) )
    {//user update the default data
        FlashSettingInitialise();
        flash_settingwrite();
    }
    else
        if( flash_CheckStat(FFSFILE_SETTING_PATH)<0 )
    {
        /* 2004/04/22 sunsj modify */
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        FlashSettingInitialise();
        flash_settingwrite();
    }
    else
    {
        flash_settingread();
    }

    /*---------------------windy added followed code for common sms 0223---------------------*/
    if( flash_CheckStat(FFSFILE_COM_SMS_PATH)<0 )
    {
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        CommonSmsInitialise();
        Common_Smswrite();  //end of windy add
    }
    else
    {
        Common_Smsread();  //windy add
    }
    /*---------------------end windy added for common sms 0223-----------------------------*/
    if( flash_CheckStat(FFSFILE_SCHEDUE1_PATH)<0 )//||(flash_CheckStat(FFSFILE_SCHEDUE2_PATH)<0)||(flash_CheckStat(FFSFILE_SCHEDUE3_PATH)<0))
    {
        /* 2004/04/22 sunsj modify */
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        ScheInit();
        /* 2004/04/22 sunsj modify */
        Flash_ScheInitWrite("DateSchedule1");//hxl add for write dafault data
    }
    else
    {
        ScheMemoRead();
    }

    if( flash_CheckStat(FFSFILE_STOPWATCH_PATH)<0 )
    {
        /* 2004/04/22 sunsj modify */
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        FlashStopwDataInitialise();//gdy add 27/08/02
        flash_Stopwrite();//gdy add 27/08/02
    }
    else
    {
        flash_Stopwread();
    }
    if( flash_CheckStat(FFSFILE_MEMO_PATH)<0 )
    {
        /* 2004/04/22 sunsj modify */
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        FlashMemoDataInitialise();//gdy add 27/08/02
        flash_Memowrite();//gdy add 27/08/02
    }
    else
    {
        flash_Memoread();//gdy add
    }

    if( flash_CheckStat(FFSFILE_CONSTCONFIG_PATH)<0 )
    {
        /* 2004/04/22 sunsj modify */
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        flash_constdata_init();  
        flash_constdata_write();
    }
    else
    {
        flash_constdata_read();
    }

    //we write the update default check data
    flash_ConfigDataChecksum_write();

    showAlarmIcon();
}

//end of hxl changed, for should check the file 0827-----------------------------}
void Forward_Ffsfile_init()
{
    //check the config data , if it is updated,we use the update default data
    if( flash_CheckStat(FFSFILE_CONFIG_CHECK_PATH)<0 )
    {
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        flash_ConfigDataChecksum_write();
    }
    else
        flash_ConfigDataChecksum_read();

    //check the current default data
    if( (getConfigData_checksum(FFSFILE_HOSTKEY_PATH)!=ConfigDataCheckSum.Hostkeydata_sum)//user update the default data
        ||(getConfigData_size(FFSFILE_HOSTKEY_PATH)!=ConfigDataCheckSum.Hostkeydata_size) )
    {//user update the default data
        FlashHostkeyInitialise();  //  xsf add 2002.06.06
        flash_hostwrite();  
    }
    else if( flash_CheckStat(FFSFILE_HOSTKEY_PATH)<0 )
    {
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        FlashHostkeyInitialise();  //begin of xsf add 2002.06.06
        flash_hostwrite();   
    }
    else
    {
        flash_hostread();    //xsf add
    }

    if( (getConfigData_checksum(FFSFILE_CONFIG_PATH)!=ConfigDataCheckSum.Mmidata_sum)
        ||(getConfigData_size(FFSFILE_CONFIG_PATH)!=ConfigDataCheckSum.Mmidata_size) )
    {//user update the default data
        FlashDataInitialise();  //use update data
        flash_write();
    }
    else if( flash_CheckStat(FFSFILE_CONFIG_PATH)<0 )
    {
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        FlashDataInitialise();  
        flash_write();
    }
    else
    {
        flash_read();
        if( FFS_flashData.dailyAlarm_switch||FFS_flashData.weeklyAlarm_switch )
            iconsSetState(iconIdAlarm);
    }

    if( (getConfigData_checksum(FFSFILE_ENVIR_PATH)!=ConfigDataCheckSum.Environment_sum)//user update the default data
        ||(getConfigData_size(FFSFILE_ENVIR_PATH)!=ConfigDataCheckSum.Environment_size) )
    {//user update the default data
        FlashEnviroInitialise();  //use update data
        flash_environmentwrite();  //end of xsf add
    }
    else if( flash_CheckStat(FFSFILE_ENVIR_PATH)<0 )  //xsf moved from Common_ffsfile_init() for alarm with pin1 01.14
    {
        /* 2004/04/22 sunsj modify */
        if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
            flash_PBmkdir(FFSFILE_DIRECTORY);
        FlashEnviroInitialise();
        flash_environmentwrite();  //end of xsf add
    }
    else
    {
        flash_environmentread();  //xsf add
    }


}

void phonebook_ffsfile_init(void)
{
    int i;

    /*..........................................fzq add for PhoneBook 08/08....................................*/
    SIMLoadingPhbk=FALSE;
    phonebookstatus=COPYNONE;
    CurrentTable=PhoneBookNULL;
    /* 2004/04/22 sunsj modify */
    if( flash_CheckStat(FFSFILE_DIRECTORY)<0 )
    {

        flash_PBmkdir(FFSFILE_DIRECTORY);

        ConfigPhbkReset();            
        flash_PBwrite(PBTable[0]);

        ConfigPhbkOtherReset();
        /* 2004/04/22 sunsj modify */
        flash_PBOtherWrite("PBOData");
    }
    else
    {

        //if phk file is not exist, read default data
        for( i=0;i<PHB_PBTable;i++ )
        {
            if( flash_PBread(PBTable[i])==0 )
            {
                ConfigPhbkReset();
                flash_PBwrite(PBTable[i]);                                      
                CurrentTable=i;
            }
        }

        //if phk file exist, read file data
        Get_NVM_data();


        if( flash_PBOtherRead("PBOption")==0 )
        {
            ConfigPhbkOtherReset();
            flash_PBOtherWrite("PBOption"); 
        }
    }
    /*.........................................end of fzq add for PhoneBook 08/08....................................*/
}

void Get_NVM_data(void)
{
    int i,j;
    unsigned char backstr[21];

    NVMTotal=0;  
    memset(l_phb_index,0,sizeof(T_MFW_PHB_INDEX)*ALL_NVM_LIST);
    for( i=0;i<PHB_PBTable;i++ )
    {
        if( flash_PBread(PBTable[i])!=0 )
        {
            if( i<PHB_PBTable-1 )
            {
                for( j=0;j<PHB_table_len;j++ )
                {
                    if( (FFS_PBData.NVMBook[j].info & 0xC0)!=0x00 )
                    {
                        FFS_PBData.NVMBook[j].name[PHB_name_len]=0x00;
                        FFS_PBData.NVMBook[j].name[PHB_name_len+1]=0x00;
                        FFS_PBData.NVMBook[j].name[PHB_name_len+2]=0x00;
                        memcpy(l_phb_index[j+i*PHB_table_len].name,FFS_PBData.NVMBook[j].name,PHB_name_len);
                        l_phb_index[j+i*PHB_table_len].phonebook=NVM_BOOK_SEL;
                        l_phb_index[j+i*PHB_table_len].index=j+i*PHB_table_len;                            
                        UnCompressNum((char *)FFS_PBData.NVMBook[j].number,backstr);
                        l_phb_index[j+i*PHB_table_len].number[0]=GetShortNumber((char *)backstr);
                        /* 2003/12/01 sunsj modify office and home turn */
                        //UnCompressNum((char *)FFS_PBData.NVMBook[j].office,backstr);
                        UnCompressNum((char *)FFS_PBData.NVMBook[j].home,backstr);
                        l_phb_index[j+i*PHB_table_len].number[1]=GetShortNumber((char *)backstr);
                        //UnCompressNum((char *)FFS_PBData.NVMBook[j].home,backstr);
                        UnCompressNum((char *)FFS_PBData.NVMBook[j].office,backstr);
                        l_phb_index[j+i*PHB_table_len].number[2]=GetShortNumber((char *)backstr);                                                         
                        l_phb_index[j+i*PHB_table_len].flag=FFS_PBData.NVMBook[j].info;
                        if( (FFS_PBData.NVMBook[j].info & 0x40)==0x40 ) NVMTotal=NVMTotal+1;
                    }
                    else
                    {

                        l_phb_index[j+i*PHB_table_len].name[0]='\0';
                        l_phb_index[j+i*PHB_table_len].phonebook=NVM_BOOK_SEL;
                        l_phb_index[j+i*PHB_table_len].index=j+i*PHB_table_len;
                        l_phb_index[j+i*PHB_table_len].number[0]=0X0000;
                        l_phb_index[j+i*PHB_table_len].number[1]=0X0000;
                        l_phb_index[j+i*PHB_table_len].number[2]=0X0000;                            
                        l_phb_index[j+i*PHB_table_len].flag=FFS_PBData.NVMBook[j].info;     
                    }                          
                }
                CurrentTable=i;
            }
            else
            {
                for( j=0;j<68;j++ )
                {
                    if( (FFS_PBData.NVMBook[j].info & 0xC0)!=0x00 )
                    {
                        memcpy(l_phb_index[j+i*PHB_table_len].name,FFS_PBData.NVMBook[j].name,PHB_name_len);
                        l_phb_index[j+i*PHB_table_len].phonebook=NVM_BOOK_SEL;
                        l_phb_index[j+i*PHB_table_len].index=j+i*PHB_table_len;

                        UnCompressNum((char *)FFS_PBData.NVMBook[j].number,backstr);
                        l_phb_index[j+i*PHB_table_len].number[0]=GetShortNumber((char *)backstr);
                        /* 2003/12/01 sunsj modify office and home turn */
                        //UnCompressNum((char *)FFS_PBData.NVMBook[j].office,backstr);
                        UnCompressNum((char *)FFS_PBData.NVMBook[j].home,backstr);
                        l_phb_index[j+i*PHB_table_len].number[1]=GetShortNumber((char *)backstr);
                        //UnCompressNum((char *)FFS_PBData.NVMBook[j].home,backstr);
                        UnCompressNum((char *)FFS_PBData.NVMBook[j].office,backstr);
                        l_phb_index[j+i*PHB_table_len].number[2]=GetShortNumber((char *)backstr);
                        l_phb_index[j+i*PHB_table_len].flag=FFS_PBData.NVMBook[j].info;
                        if( (FFS_PBData.NVMBook[j].info & 0x40)==0x40 ) NVMTotal=NVMTotal+1;
                    }
                    else
                    {
                        l_phb_index[j+i*PHB_table_len].name[0]='\0';
                        l_phb_index[j+i*PHB_table_len].phonebook=NVM_BOOK_SEL;
                        l_phb_index[j+i*PHB_table_len].index=j+i*PHB_table_len;
                        l_phb_index[j+i*PHB_table_len].number[0]=0X0000;
                        l_phb_index[j+i*PHB_table_len].number[1]=0X0000;
                        l_phb_index[j+i*PHB_table_len].number[2]=0X0000;                            
                        l_phb_index[j+i*PHB_table_len].flag=FFS_PBData.NVMBook[j].info;     
                    }                          
                }
                CurrentTable=i;
            }                   
        }
    }

}

void FfsWriteOneEvent ()
{
    int idx=0;
    static int startidx=0;
    effs_t effsret=0;
    MmiTrace("FfsWriteOneEvent");

    for( idx=startidx;idx<MAX_FILE_NUM;idx++ )
    {

        if( ffsfileCmd.ffsfile[idx].writeStatus==1 )
            break;
    }

    //if have waitting cmd,write it
    if( idx!=MAX_FILE_NUM )
    {
        MmiTrace("write idx");
        MmiTrace(ffsfileCmd.ffsfile[idx].pdir);

        effsret=ffs_fwrite(ffsfileCmd.ffsfile[idx].pdir, ffsfileCmd.ffsfile[idx].pdata, ffsfileCmd.ffsfile[idx].size);
        if( effsret==EFFS_OK )
        {
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
            if( idx==QQDataFile1Idx )
            {
                if( pQQSmsfile1!=NULL )
                    FREE_MEMORY((void *)pQQSmsfile1,1024);
                pQQSmsfile1=NULL;
            }
            else
                if( idx==QQDataFile2Idx )
            {
                if( pQQSmsfile2!=NULL )
                    FREE_MEMORY((void *)pQQSmsfile2,1024);
                pQQSmsfile2=NULL;
            }
            else
                if( idx==QQDataFile3Idx )
            {
                if( pQQSmsfile3!=NULL )
                    FREE_MEMORY((void *)pQQSmsfile3,1024);
                pQQSmsfile3=NULL;
            }
            else
                if( idx==QQDataFile4Idx )
            {
                if( pQQSmsfile4!=NULL )
                    FREE_MEMORY((void *)pQQSmsfile4,1024);
                pQQSmsfile4=NULL;
            }
#endif
            ffsfileCmd.ffsfile[idx].writeStatus=0;
        }
/* glowing,2004-06-12, remove it */		
//        else
//            MmiTraceInt(effsret);
/* glowing,2004-06-12, end of remove */

        startidx=idx+1;

    }
    else
        startidx=0;

}


void FfsWriteAllEvent ()
{
    int idx=0;
    effs_t effsret=0;
	
    SaveGprsCounter();//write gprsdatacounter at swith off handset
    for( idx=0;idx<MAX_FILE_NUM;idx++ )
    {
        if( ffsfileCmd.ffsfile[idx].writeStatus==1 )
        {
            //if have waitting cmd,write it
            effsret=ffs_fwrite(ffsfileCmd.ffsfile[idx].pdir, ffsfileCmd.ffsfile[idx].pdata, ffsfileCmd.ffsfile[idx].size);
            if( effsret==EFFS_OK )
            {
                ffsfileCmd.ffsfile[idx].writeStatus=0;
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
                if( idx==QQDataFile1Idx )
                {
                    if( pQQSmsfile1!=NULL )
                        FREE_MEMORY((void *)pQQSmsfile1,1024);
                    pQQSmsfile1=NULL;
                    freeQQsmsMem();
                }
                else
                    if( idx==QQDataFile2Idx )
                {
                    if( pQQSmsfile2!=NULL )
                        FREE_MEMORY((void *)pQQSmsfile2,1024);
                    pQQSmsfile2=NULL;
                }
                else
                    if( idx==QQDataFile3Idx )
                {
                    if( pQQSmsfile3!=NULL )
                        FREE_MEMORY((void *)pQQSmsfile3,1024);
                    pQQSmsfile3=NULL;
                }
                else
                    if( idx==QQDataFile4Idx )
                {
                    if( pQQSmsfile4!=NULL )
                        FREE_MEMORY((void *)pQQSmsfile4,1024);
                    pQQSmsfile4=NULL;
                }
#endif
            }

        }
    }

}



//end of hxl add 30/08/02---------------------------------------------------------------------

//chenjun add begin 2003-01-23---------------------------------------------------------------
/*
void SetEnvironRing(UBYTE id, short value)
{
   if(id>3)
    return;
   else 
    {
      FlashEnvironmentData.EnviroProfile[id].ringtype=(uint8)(value&0x00ff);
      FlashEnvironmentData.EnviroProfile[id].alarmtype=(uint8)((value&0xff00)>>8); 
    }
}

void GetEnvironRing(UBYTE id, short * value)
{
  if(id>3)
    return;
  else
    { 
       *value=(((short)FlashEnvironmentData.EnviroProfile[id].alarmtype)<<8)&0xff00;
       *value|=((short)FlashEnvironmentData.EnviroProfile[id].ringtype)&0x00ff;
            
    }
}

*/
void GetRingAlarmGroupRing(char* data )
{
    unsigned char i;
    for( i=0;i<4;i++ )
    {
        data[i]=FlashEnvironmentData.EnviroProfile[i].ringtype;
        data[i+4]=FlashEnvironmentData.EnviroProfile[i].alarmtype;
    }
    for( i=0;i<10;i++ )
        data[i+8]=FFS_PBOtherData.GroupingItem[i].GroupingRing;
}

void SetRingAlarmGroupRing( unsigned char data[])
{
    unsigned char i;
    for( i=0;i<4;i++ )
    {
        FlashEnvironmentData.EnviroProfile[i].ringtype=data[i];
        FlashEnvironmentData.EnviroProfile[i].alarmtype=data[i+4];
    }
    for( i=0;i<10;i++ )
        FFS_PBOtherData.GroupingItem[i].GroupingRing =data[i+8];  
}

void GetUserBackGround(short* value)
{
    *value=(short)FlashSettingData.BGI;
}

void SetUserBackGround(short value)
{
    FlashSettingData.BGI=(int) value;
}

//chenjun add over 2003-01-23----------------------------------------------------------------
//Bob added 02/17
//get the error code and printf in the LCD


void FfsCheckEvent()
{   
    //there are five routines to check
    ffs_status=flash_CheckStat(FFSFILE_DIRECTORY);
    //flash_settingread();
    //flash_settingwrite();
    //flash_Smsread();
    //flash_constdata_read();
    //if FFS error occur, it return and stop the test
    if( ffs_status<0 )
    {
        ffs_Check_stop();
        return;
    }
    //continue to check
    timStart(ffscheck);
}
void ffs_Check()
{
    //create a check timer for ffs check
    ffscheck=timCreate(0,1000,(MfwCb)FfsCheckEvent);
    //start the timer
    timStart(ffscheck);
}
void ffs_Check_stop()
{
    //stop the timer
    timStop(ffscheck);
    //delete the timer
    timDelete(ffscheck);
}

//Bob added 02/18
uint32 FFS_Get_Free_Bytes()
{
    uint32 p;
    //get free bytes
    ffs_query(1,&p);
    return p;
}
uint32 FFS_Get_Lost_Bytes()
{
    uint32 p;
    //get lost bytes
    ffs_query(3,&p);
    return p;
}
uint32 FFS_Get_Used_Bytes()
{
    uint32 p;
    //get used bytes
    ffs_query(2,&p);
    return p;
}
//End of Bob added 02/18
