#ifndef MFW_FFS_H_
#define MFW_FFS_H_

#include "ffs.h"
#include "ffs_coat.h"

//#include "Ffs.h"
#include "mfw_mfw.h"
#include "mfw_sms.h"

#define MAXCB     20  //It should be equal MAX_IDENTS
/*2004/04/13,talcon modify*/
#define CommonMsgNum     15 /*10*/  //It should be equal MAX_IDENTS


#define FFSFILE_DIRECTORY			"/bmi"
#define	FFSFILE_CONSTCONFIG_PATH	"/bmi/ConConfigData"		//
#define	FFSFILE_DCTB_PATH			"/bmi/MobileDctbData"		//index=0
#define	FFSFILE_VM_PATH				"/voicememory/VM"			//index=1
#define	FFSFILE_PHB1_PATH			"/bmi/PhoneRecord1"	//index=2
#define	FFSFILE_PHB2_PATH			"/bmi/PhoneRecord2"	//index=3
#define	FFSFILE_PHB3_PATH			"/bmi/PhoneRecord3"	//index=4
#define	FFSFILE_PBO_PATH			"/bmi/PBOData"		//index=5
#define	FFSFILE_CONFIG_PATH			"/bmi/BmiConfigData"		//index=6
#define	FFSFILE_SETTING_PATH    	"/bmi/MobileSettingData"	//index=7
#define	FFSFILE_HOSTKEY_PATH		"/bmi/MobileHostkeyData"	//index=8
#define	FFSFILE_ENVIR_PATH			"/bmi/MobileProfiles"	//index=9					/* 2003/12/08 sunsj */
#define FFSFILE_STOPWATCH_PATH		"/bmi/MobileSW"			//index=a
#define FFSFILE_WAP_PATH			"/bmi/MobileWapData"			//index=b
#define	FFSFILE_SCHEDUE1_PATH		"/bmi/DateSchedule1"			//index=c
#define	FFSFILE_SCHEDUE2_PATH		"/bmi/DateSchedule2"			//index=d
#define	FFSFILE_SCHEDUE3_PATH		"/bmi/DateSchedule3"			//index=e
#define	FFSFILE_CONFIG_CHECK_PATH	"/bmi/BmiConfigCheckData"	//index=f
#define	FFSFILE_SMS_PATH			"/bmi/MobileSmsData"	//index=10
#define FFSFILE_MEMO_PATH			"/bmi/PersonMemory"		///index=11
#define	FFSFILE_GAME_PATH			"/bmi/SmallGameData"			//index=12

#define	FFSFILE_COM_SMS_PATH		"/bmi/MobileCSmsData"	//index=22
#define FFSFILE_FIELDTEST_PATH		"/bmi/MobileFieldTestData"			//field test add by xzy 0124

typedef struct
{
    uint16     Mmidata_sum;
    uint16     Mmidata_size;
    uint16     Environment_sum;
    uint16     Environment_size;
    uint16     DCTbdata_sum;
    uint16     DCTbdata_size;
    uint16     Settingdata_sum;
    uint16     Settingdata_size;
    uint16     Hostkeydata_sum;
    uint16     Hostkeydata_size;
}ConfigDataCheck;
typedef struct
{
    char greeting_word[15];	/* 2004/07/01 sunsj modify */
    int  GreetingWordIsOn;//0,1ʺ￪ر0/1
    char BackgroundTable[5][21];// 
    int  BGI;//background
    int  OutBGI;   //Out idle wallpaper	/* 2004/04/10 sunsj modify */
    int  saving_mode;//0,1ʡģʽ
    int  switch_animation;//ػ
    int  theme;//
    int  backlight_intensity;//ǿ
    uint8 backlight_on_time_hour;
    uint8 backlight_on_time_minute;
    uint8 backlight_off_time_hour;//ʡ米رʱ
    uint8 backlight_off_time_minute;
    uint8 hallonconnect;//0,1Ǵ򿪽0:ok;1:no
    uint8 gprsattachmode;//0:manual;1:Automatic
    uint8 ledon;//0,1led control on off
    uint8 LedSwitch;       //ظǷҪ˸LED /* 2004/04/10 sunsj add */
}FlashSetting;
typedef struct
{
    uint8 UsedTbIdx; //record the next  index of UsedNumberTable
    uint8   UsedNumberTable[10][21]; //Usual used forwarding number
    uint8   GroupedNumber[10][9]; 
    uint8   SettedCUGIndex[10][2]; 
    //Call Record
    uint8   LMNTable[10][24];//missed number
    uint8   LJNTable[10][24];//reject number  missed number
    uint8   LRNTable[10][24];//missed number
    uint8   LDNTable[10][24];//missed number
    uint8   LMNTime[10][21]; 
    uint8   LJNTime[10][21];//reject number
    uint8   LRNTime[10][21];
    uint8   LDNTime[10][21];

    uint8   LMNID;
    uint8   LJNID;              //reject number
    uint8   LRNID;
    uint8   LDNID;
    uint8   nextcall;           
    uint8   hideIDflag;
    uint8   callwaitflag;
    uint8   lineselectflag;   //·ѡ־λ
    uint8   AutoAnswerFlag;
    uint8   MissedCallNum;
    uint8   LMNflag[10];  
    uint8   CFFlag;  // use the last 4 bits to mark CFNRc CFB CFNRy CFU 
    uint8   MForNameFlag[10]; 
    uint8   JForNameFlag[10];
    uint8   RForNameFlag[10];
    uint8   DForNameFlag[10];

    char    Mname[10][24];
    char    Jname[10][24];
    char    Rname[10][24];
    char    Dname[10][24];
    uint32     GPRSOUTCOUNTER;
    uint32     GPRSINCOUNTER;
} FlashDCTb;//usual used number and cug number table

extern FlashDCTb FlashDCTbData; 
typedef struct
{
    uint8 HostLock_flag;
    uint8 HostLock_Key[8];
    uint8 HostProtect_Items[5];
    uint8   SimLockFlag;
    uint8   imsi[8];
}FlashHostkey;
typedef enum
{
    NORMAL_ENV=0,
    OUTDOOR_ENV,
    MEETING_ENV,
    INCAR_ENV,
    MUTE_ENV,
    iconSceneMax 
}EnvironmentEnum;
typedef enum
{
    RING=0,
    VIBRA,
    VIBRARING,
    RINGANDVIBRA,
    ALERTMUTE 
}PromptEnum;

typedef enum
{
    SMSRING=0,       //ring
    SPECIALRING1,     //special ring strong more twice
    SPECIALRING2,
    SPECIALRING3,
    SPECIALRING4,
    SPECIALRING5,
    SMSVIBRA,        //vibra
    SMSRVIBRA,      //ring and vibrate
    SMSMUTE       //No ring and no vibrate
} SmsAlertType;


typedef struct
{
    PromptEnum   prompttype;
    uint8        ringtype;
    uint8        ringvolume;
    uint8        Autoanswerflag;
    uint8        Anykeyanswerflag;
    uint8        connecttone;
    PromptEnum   alarmprompt;  
    uint8        alarmtype;
    uint8        alarmvolume;
    uint8        speakervolume; //for adjusting speaker volume
    SmsAlertType  SMSTone;
    uint8         smsvolume;
    uint8         KeypadTone;
    uint8         MissedcallTone;
    uint8         UnreadSMSTone;
    //uint8         settings_status;
    uint8         KeypadVolume;    /* 2003/12/08 sunsj add */
    //2003.1.13 wyj add on&off ring
    uint8          OnRingtype; //λΪ 1
    uint8          OnVolume;
    uint8          OffRingtype;
    uint8          OffVolume;
    //2004.2.12 WYJ add Hall On&Off Ring
    uint8          HallOnRingtype; //λΪ 1
    uint8          HallOnVolume;
    uint8          HallOffRingtype;
    uint8          HallOffVolume; 
}EnvironmentStruct;
typedef struct
{
    EnvironmentEnum CurrentEnv;  //current enviorment
    EnvironmentStruct EnviroProfile[5];
}FlashEnvironment;
#define FLSAH_SMS_NUM    50
#define FlashSMS_Table          5
#define FlashSMS_table_len        10
typedef struct
{
    UBYTE   index;
    UBYTE   id;
} T_MMI_FLASH_SORT_INDEX;
typedef struct
{
    UBYTE   index;
    UBYTE   id;
    CHAR    addr[MFW_NUM_LEN];
    T_MFW_SMS_SCTP   time;
    T_MFW_SMS_STAT  state;
    BOOL    flag;
} T_MMI_FLASH_SMS_INDEX;

typedef struct
{
    UBYTE   id;
    CHAR    addr[MFW_NUM_LEN];
    T_MFW_SMS_SCTP   time;
    CHAR    sms_msg[MAX_MSG_LEN];
    USHORT  msg_len;
    T_MFW_SMS_STAT  state;
    SHORT    dcs;
    BOOL    flag;
}FlashSms;

typedef struct
{
    FlashSms  NVMSMS[FlashSMS_table_len];  
    //UBYTE	  total;
} FlashSMSdata;

#define ALL_NVM_LIST         200
#define ALL_SIM_LIST          256 
#define ALL_NUMBER_LIST      ALL_NVM_LIST+ALL_SIM_LIST
/* glowing: change the record times from 20 seconds to 30 seconds */
//#define VM_file                10
#define VM_file                6

#define PHB_name_len        13 //2004-04-05 Sunny modify.old value:21
#define PHB_number_len      21 //2004-04-13 Sunny modify.old value:21
#define PHB_numberExt_len   7
#define PHB_memo_len        22
#define PHB_PBTable         3
#define PHB_table_len       72
#define PE_SIZE             5
#define MAX_Grouping        10
#define MAX_ShortCutDial    9
#define MAX_COMSG_LEN       53
#define GroupingName_len    17//2003/12/01,talcon change 13 to 17
#define CheckFlag(i)         (((l_phb_index[i].flag & 0x40)==0x40)?TRUE:FALSE)
#define CheckDelFlag(i)      (((l_phb_index[i].flag & 0x80)==0x80)?TRUE:FALSE)
#define SetAddFlag(i)        ((l_phb_index[i].flag & 0x3F) | 0x40)
#define SetDelFlag(i)         ((l_phb_index[i].flag & 0x3F) | 0x80)
#define SetFirstNumFlag(i,j)  ((l_phb_index[i].flag & 0xCF) | ((j<<4) & 0x30))
#define CheckFirstNumFlag(i) ((l_phb_index[i].flag>>4) & 0x03)
#define SetGroupingFlag(i,j)  ((l_phb_index[i].flag & 0xF0) | (j & 0x0F))
#define CheckGroupingFlag(i) (l_phb_index[i].flag & 0x0F)
#if(MAIN_LCD_SIZE==4)
#define GetFree(i)            ((i>3)?3:i)    /* 2004/05/26 sunsj modify */
#elif(MAIN_LCD_SIZE==3)
#define GetFree(i)            ((i>3)?3:i)
#endif
typedef enum
{
    COPYINGALL,
    COPYINGSELECT,    
    COPYNONE
} T_EntryEvent;

typedef struct
{
    U8   name   [PHB_name_len+3];  
    U8   number [PHB_number_len+1];
    U8   office   [PHB_number_len+1];
    U8   home   [PHB_number_len+1];  
    U8   memo   [PHB_memo_len+3];
    U8   info;
} PhbkDetailItem;

typedef enum
{
    PhoneBook1=0,
    PhoneBook2=1,
    PhoneBook3=2,
    PhoneBook4=3,
    PhoneBook5=4,
    PhoneBook6=5,
    PhoneBook7=6,
    PhoneBookNULL
} T_MFW_PHB_TABLE;

typedef enum
{
    SIM_BOOK_SEL,
    NVM_BOOK_SEL
} T_MFW_PHB_SELECT;

typedef struct
{
    U8   name  [PHB_name_len+3];  
    U8   number[PHB_number_len/2+2];
    U8   office  [(PHB_number_len+PHB_numberExt_len)/2+1];
    U8   home  [PHB_number_len/2+2];  
    U8   memo [PHB_memo_len+3];
    U8   info;
} PhbkListItem;

typedef struct
{
    PhbkListItem      NVMBook[PHB_table_len];  
} FlashPBdata;

typedef struct
{
    U8    name   [PHB_name_len+3];
    U8    number [(PHB_number_len/2)+2];
} PhbkShortCutItem;

typedef struct
{
    char GroupingName[GroupingName_len];//
    U8  GroupingIcon;
    U8  GroupingRing;
} PhbkGroupingItem;


typedef struct
{
    PhbkShortCutItem ShortCutDial[MAX_ShortCutDial];//ݲ
    PhbkGroupingItem GroupingItem[MAX_Grouping];  
} FlashPBotherdata;

typedef struct
{
    unsigned char       name [PHB_name_len+3];
    T_MFW_PHB_SELECT  phonebook;
    int                 index;
    U16                number[3]; 
    U8                 flag;
} T_MFW_PHB_INDEX;

typedef struct //sort index table
{
    USHORT name;
    int      index;  
} T_MFW_PHB_SORT_INDEX;
typedef struct
{
    char vm_name[PHB_name_len];
    UINT8 minute;     /* minutes after the hour	- [0,59]       */
    UINT8 hour;       /* hours after the midnight	- [0,23]       */
    UINT8 day;        /* day of the month		- [1,31]       */
    UINT8 month;      /* months                       - [01,12]      */
    UINT8   year;       /*year                       -[00,99]*/
    BOOL  mode_12_hour;   /* TRUE->12 hour mode ; FALSE-> 24 hour mode   */
    BOOL  PM_flag;    /* if 12 hour flag = TRUE TRUE->PM ; FALSE->AM */  
    UINT8 length;     /*the time in second of this voice file*/
} VMTable;

typedef struct
{
    VMTable VM[VM_file];
} FlashVMdata;
//-----------------------------------------------------------------------------

//schedule data
#define SCHE_LEN  98
#define MEMO_LEN 100
#define SCHEDULE_NUMBER 70
#define STOPWRECORD_NUM 40
#define STOPWGROUP_NUM 5
typedef struct
{
    int date[2];
    uint8 wday;
    uint8 hour;
    uint8 minute;
    uint8 ringandf;   //ǷԼӵƵǶ
    uint8 type;//ǻ顢ջǱ
    uint8 text[SCHE_LEN];//¼
}FlashSchedule;//ճ̹

typedef struct
{
    uint8 index;
    int date[2];
    uint8 wday;
    uint8 hour;
    uint8 minute;
    uint8 number;
    uint8 ringandt;
}T_MFW_DetailSche_index;

typedef struct
{
    int date[2];
    uint8 wday;
    uint8 hour;
    uint8 minute;
    uint8 index;
}T_MFW_SCHE_INDEX;
//------------------------------------------------------------------------------
typedef enum
{
    AllLanguage,
    NoLanguage,
    ListLanguage
}CBLANG;
typedef struct
{
    UBYTE message[MAX_COMSG_LEN];   /* in ASCII*/
}CoMessage;

typedef struct
{
    FlashSchedule FfsSche[70];
}Flash_Sche;

//stopwatch data
typedef struct
{
    unsigned int record[STOPWRECORD_NUM];
    char name[14];
    uint8 type;
    uint8 group_number;
}FlashStopwatch;

typedef struct
{
    uint8 flag;
    char name[14];
    uint8 type;
    uint8 group_number;
}T_MFW_Stopw_INDEX;

typedef struct
{
    FlashStopwatch group[STOPWGROUP_NUM];  
}Flash_Stopw;

typedef struct
{
    uint8 text[MEMO_LEN];
    uint8 position;
}Flash_Memo;

typedef struct
{
    Flash_Memo  item[10];
}Flash_MData;

typedef struct 
{
    UINT8   second;     /* seconds after the minute	- [0,59]  */
    UINT8   minute;     /* minutes after the hour		- [0,59]  */
    UINT8   hour;           /* hours after the midnight	- [0,23]  */
    UINT8   day;            /* day of the month				- [1,31]  */
    UINT8   month;      /* months							- [01,12] */
    int     year;           /* years								- [00,99] */
    UINT8   wday;           /* days in a week					- [0,6] */
    int     alarm_type;   /*0->SCHEDULE_ALARM,1->ORDINARY_ALARM,2->AUTOPOWER*/
    UINT8   schedule_position; //if it is ordinary alarm 0->daily 1->weekly; if it is a schedule alarm,this parameter indicates the position in Flash
    BOOL    month_switch;//TRUE->monthly alarm or not;
    BOOL    year_switch;//TRUE->mannul alarm or not;
    BOOL    weekly_switch;//TRUE->weekly alarm or not;
    BOOL    daily_switch;//TRUE->daily alarm or not;
} T_ALARM_DATA;

#if 0 //TCS2112
typedef struct
{   uint8 IMEI[16]; 	/* in ASCII*/
    uint8 IMEI_bcd[8]; 	/*in BCD*/
	/*SPR 1725 removed date time and alarm data*/
	/*Call timers*/
	uint32 last_call_duration;
	uint32 incoming_calls_duration;
	uint32 outgoing_calls_duration;

	/*MSSET data*/

	uint8 output_volume;
	uint8 external_audio;
	uint8 voice_memo_position;
	uint8 PLMN_selection_mode;
	uint8 CLIR; //seem to only be used for supplementary services.
	uint8 CLIP;
	uint8 redial_mode;
	uint8 call_info_display;
	uint8 contrast;
	uint8 brightness;
	uint8 backlight_duration;
    uint8 recent_ldn_ref;
    uint8 recent_lrn_ref;
    uint8 recent_upn_ref;
    uint8 time_format;

 	/* Network Log              */
    uint8 net_log_status;                 /* status                   */
    uint8 plmn_name[20];                /* plmn name                */
    uint8 network_name [6];             /* plmn name numeric        */

    /*Setting status*/

	uint8 settings_status;

	uint8 voice_mail[22];

	/*mailbox number*/
	uint8 mbn_AlphId[10];
	uint8 mbn_len;
	uint8 mbn_numTp;
	uint8 mbn_Num[10];

	/*ringtones etc for MMisounds*/
	uint8 ringer;							// index of permanent active tune in soundlist and ringerItem
	uint8 vibrator;							// vibrator
	uint8 volumeSetting;					// values (0 = silent, 4= loud, 5 = increasing)
	uint8 keypadOn;							// on/off values
	uint8 AlarmOn;
	uint8 OrganiserAlert;
	uint8 CreditLow;
	uint8 SMSTone;
	uint8 SMSBroadcast;
	uint8 battLow;
	uint8 earpiece;
	uint8 language;
	uint8 Equalizer;

    /*Data for MmiSmsBroadcast*/


	//Predictive text Flags
	uint8 PredTextAvailable;
	uint8 PredTextSelected;

	//API - 01/10/02
	//Concatenate Flags 
	uint8 ConcatenateStatus;

	//API - 06/12/02
	//Idle Screen Background image
	uint8 IdleScreenBgd;
	uint8 MainMenuBgd;
	uint8 ProviderNetworkShow;

	//CPHS ALS info
	uint8 als_selLine;
  	uint8 als_statLine;

  	uint8 ccbs_status;  /* Marcus: CCBS: 13/11/2002 */

  	/* MC SPR 1392, call deflection flag*/
	uint8 call_deflection;


  	/* SPR#1352 - SH - TTY */
  	uint8 ttyAlwaysOn;

	/*API CQ10203 - Add the Flash define for Validity Period here*/
	uint8 vp_rel;
} FlashData;
#else
typedef struct
{
    /*current time*/
    uint8 current_hour;
    uint8 current_minute;
    /*current date*/
    uint8 current_day;
    uint8 current_month;
    uint16 current_year;
    /*alarm data*/
    uint8 alarm_hour;
    uint8 alarm_minute;
    uint8 alarm_day;
    uint8 alarm_month;
    uint16 alarm_year;

    uint8  timeZone;         //current timezone
    uint8  cityNumber;
    uint8  fullhralert;      //full hour alert
    uint8  dailyAlarm_hour;
    uint8  dailyAlarm_min;
    uint8  dailyAlarm_switch;
    uint8  weeklyAlarm_hour;
    uint8  weeklyAlarm_min;
    uint8  weeklyAlarm_switch;
    uint8  weeklyChineseString[50];
    uint8  weeklyEnglishString[50];

    /*Call timers*/
    uint32 last_call_duration;
    uint32 incoming_calls_duration;
    uint32 outgoing_calls_duration;

    /*MSSET data*/
    uint8 output_volume;
    uint8 voice_memo_position;
    uint8 PLMN_selection_mode;
    uint8 Band_restriction; //for band set
    uint8 redial_mode;
    uint8 time_format;
    uint8 call_minute_flag;

    /* Network Log*/
    uint8 net_log_status;              /* status                   */
    uint8 plmn_name[20];                /* plmn name                */
    uint8 network_name [6];             /* plmn name numeric        */

    /*Setting status*/

    uint8 settings_status;

    uint8 voice_mail[22];

    /*mailbox number*/
    uint8 mbn_AlphId[10];
    uint8 mbn_len;
    uint8 mbn_numTp;
    uint8 mbn_Num[10];

    //Predictive text Flags
    uint8 PredTextAvailable;
    uint8 PredTextSelected;

    //CPHS ALS info
    uint8 als_selLine;
    uint8 als_statLine;
	
    //uint8 onoroff;//Ƿػ0->deactive,1->active
    uint8 poweron_switch;//ǷԶ 0->deactive,1->active
    uint8 poweroff_switch;//ǷԶػ 0->deactive,1->active
    uint8 opentime[2];//ʱopentime[0]->hour,opentime[1]->minute
    uint8 closetime[2];//ػʱclosetime[0]->hour,closetime[1]->minute
    
    T_ALARM_DATA latest_alarm;   
    CBLANG   CBLanguage;     //CB  language option
    USHORT   CBLangIdAll;    //To find out which language is select
    UBYTE    CBdcs[MAXCB];      /* data coding schemes */
    USHORT  msg_id[MAXCB];   /* message identifier              */
    int CBONOFF;//control CB on off trigger
    int SRRONOFF;
    U16 shortcutmenu_buffer[15]; //for shortcut menu
    uint8 onoffanimation;
    uint8 language;
    int contrast_intensity;//Աȶǿ
    uint8       DictBookIndex;  //three member of dictionary
    uint8       WordEveryGroup;
    uint16      StartGroup;

//glowing,2004-06-11, for compatible with TCS2112
#if 0
   	uint8 call_deflection;
  	uint8 ccbs_status;  /* Marcus: CCBS: 13/11/2002 */

	uint8 IdleScreenBgd;
	uint8 MainMenuBgd;
	uint8 ProviderNetworkShow;

	uint8 vp_rel;
	uint8 ConcatenateStatus; //super long sms 
	
#endif
	
} FlashData;
#endif

typedef struct
{
    UBYTE WDTValue;
    UBYTE LowVoltageValue;
    UBYTE Mode3Value;
    UBYTE NoSimValue;
    UBYTE Mode1Value;
    UBYTE Mode5Value;
    UBYTE NoNetWorkValue;
    int WDTCounter;      //fieldtest WDTCounter
    int SoftWareResetCounter;
    int HardWareResetCounter;
    int Mode1Counter;        //fieldtest Mode1 counter
    int Mode3Counter;        //fieldtest Mode3 counter
    int Mode5Counter;        //fieldtest Mode5 counter
    int NoSimCounter;        //fieldtest no sim counter
    int NoNetworkCounter;    //fieldtest no net work counter
    char ResetReason[20];
}FieldTest;

typedef struct
{
    uint8 serialnumber[8];
}FlashConstData;

extern FlashData FFS_flashData;

extern FlashPBdata           FFS_PBData;
extern FlashPBotherdata      FFS_PBOtherData;
extern char                  PBTable[PHB_PBTable][15];
extern T_MFW_PHB_INDEX       l_phb_index[ALL_NUMBER_LIST];
extern int                   NVMTotal,SIMTotal,PHBKTotal;
extern U8                    SIMLoadingPhbk;
extern U8                    NVMLoadingPhbk;//update nvm list data
extern T_MFW_PHB_SORT_INDEX  l_phb_sort_index[ALL_NUMBER_LIST];
extern T_MFW_PHB_TABLE       CurrentTable;
extern T_EntryEvent          phonebookstatus;
extern int                   Copyidx;
extern FlashConstData        Ffs_const_data;
extern FlashVMdata           FFS_VMData;
extern char                  vm_name[VM_file][5];

extern int flash_Gamewrite(void);

extern FlashSetting FlashSettingData;
extern Flash_Sche FFS_ScheData;
extern Flash_Stopw FFS_StopwData;
extern Flash_MData FFS_MemoData;
extern T_MFW_DetailSche_index ScheDetailIndex[200];
extern T_MFW_SCHE_INDEX ScheIndex[200];
extern T_MFW_Stopw_INDEX StopwIndex[5];
extern FlashHostkey FlashHostkeyData; 
extern FlashEnvironment FlashEnvironmentData; 
extern ConfigDataCheck  ConfigDataCheckSum;


typedef enum
{
    DCTFileIdx  =0,
    VMFileIdx,//=1
    PHB1FileIdx,//=2
    PHB2FileIdx,//=3
    PHB3FileIdx,//=4
    PBOFileIdx,//=5
    MMIFileIdx,// 6
    SetFileIdx,//7
    HstKeyFileIdx,//8
    EnvirFileIdx,//9
    StpWatFileIdx,//a
    WapFileIdx,//b
    Sche1FileIdx,//c
    Sche2FileIdx,//d
    Sche3FileIdx,//e
    CheckFileIdx,//f
    SmsFileIdx,//10
    MemoFileIdx,//11
    GameFileIdx,//=12
    CommonSmsFileIdx//

}ffsfileidx;

typedef struct
{
    char *pdir;
    void    *pdata; /* data point*/
    int size;   /* file size*/
    int writeStatus;    /* cmd status,1 is waitting to write, 0 is idle*/
}TffsfileItem;

#define MAX_FILE_NUM	30

typedef struct
{
    TffsfileItem    ffsfile[MAX_FILE_NUM];
}TffsfileCmd;


//flash access routines
effs_t flash_write(void);
int flash_read(void);
    /* Marcus: Issue 1719: 11/02/2003:
     * Changed return type to int: zero (EFFS_OK) if successful,
     * presumably -ve for errors, as in FFS_ERRORS (else read less than asked
     * for, but that value is internal to the function)
     */
effs_t flash_update(void);

/* glowing,2004-06-11, import from TCS2112 */
//Generic flash access routines.
effs_t flash_data_write(const char* dir_name, const char* file_name, void* data_pointer, int data_size);
int flash_data_read(const char* dir_name, const char* file_name, void* data_pointer, int data_size);
     /* Marcus: Issue 1719: 11/02/2003:
      * Changed return type to int: data_size if successful,
      * presumably -ve for errors, as in FFS_ERRORS (else read less than asked for)
      */
/* glowing,2004-06-11, end of import */
	 
void FlashHostkeyInitialise(void);
void FlashEnviroInitialise(void);
effs_t flash_hostwrite();
effs_t flash_hostread();
effs_t flash_environmentread();
effs_t flash_environmentwrite();

/* for flash sms */
typedef enum
{
    FlahsSms1=0,
    FlahsSms2,
    FlahsSms3,
    FlahsSms4,
    FlahsSms5,
    FlashSmsNULL
} T_MFW_FS_TABLE;


extern char FlashSMSTable[FlashSMS_Table][15];
extern FlashSMSdata  FFS_SMSData;
extern T_MMI_FLASH_SMS_INDEX Flash_sms_messages[FLSAH_SMS_NUM]; /* store info about the SMS: index... */
extern  UBYTE     FlashSMStotal;
extern T_MFW_FS_TABLE       CurrentFlashSmsTable;
void FlashSmsInitialise(void);
effs_t flash_Smswrite(const char *filename);    
int  flash_Smsread(const char *filename);
void Get_FlashSms_data(void);

/* for common sms */
extern CoMessage FFS_CoMsg[CommonMsgNum];
void CommonSmsInitialise(void);
effs_t Common_Smswrite();
effs_t Common_Smsread();

void FlashSettingInitialise(void);
effs_t flash_settingwrite();
effs_t flash_settingread();
void FlashDataInitialise(void);

void     ConfigVMReset();
int       flash_VMwrite(const char *filename);
int       flash_VMread(const char *filename);
effs_t    flash_PBwrite(const char *filename);
int      flash_PBread(const char *filename);
effs_t    flash_PBOtherWrite(const char *filename);
effs_t    flash_PBOtherRead(const char *filename);
effs_t    flash_PBupdate(const char *filename);
effs_t    flash_PBmkdir(const char *pathname);
void     ConfigPhbkReset(void);
effs_t    flash_CheckStat(const char *name);
effs_t    flash_Opendir(const char *pathname);

USHORT GetShortNumber(const char * numstr);
void     CompressNum(const char * Num,unsigned char CompNum[]);
void     UnCompressNum(const char * CompNum,unsigned char Num[]);

effs_t Flash_ScheInitWrite(char * filename);
int Flash_ScheRead(char * filename);
void FlashScheDataInitialise(void); 

effs_t flash_Stopwrite();
effs_t flash_Stopwread();
void FlashStopwDataInitialise(void); 

effs_t flash_Memowrite();
effs_t flash_Memoread(); 
void FlashMemoDataInitialise(void); 

uint16 getConfigData_checksum(char *filepath);
uint16 getConfigData_size(char *filepath);
effs_t flash_ConfigDataChecksum_read(void);
effs_t flash_ConfigDataChecksum_write(void);

effs_t flash_FTwrite();
effs_t flash_FTread();


void ffs_Check();
uint32 FFS_Get_Free_Bytes();
uint32 FFS_Get_Used_Bytes();
uint32 FFS_Get_Lost_Bytes();



void ffsfile_init(void);
extern void FfsWriteOneEvent ();
extern void FfsWriteAllEvent ();
extern  void Forward_Ffsfile_init();

extern TffsfileCmd  ffsfileCmd;//ffs file cmd storage,hxl add 2002-11-27


#endif
