/*
+--------------------------------------------------------------------+
| PROJECT: GSM-MFW (?)                  $Workfile:: mfw_sima.h      $|
| $Author: root $Revision: 1.1.1.1 $|
| CREATED: 14.10.98                     $Modtime:: 6.10.99 12:21    $|
| STATE  : code                                                      |
+--------------------------------------------------------------------+

	PURPOSE :  Types definitions for MMI framework 
    .
*/

#ifndef DEF_MFW_SIMA_HEADER
#define DEF_MFW_SIMA_HEADER

/* Contents of the Elementary Files from SIM card */
typedef struct
{
  UBYTE display_condition;
  UBYTE service_provider [LONG_NAME];
} T_EF_SPN;


EXTERN void  sima_init       (void);
EXTERN void  rAT_PlusCFUNP   (T_SIM_MMI_INSERT_IND * mmi_insert_ind);
EXTERN UBYTE qAT_PlusCPINNO  (void);
EXTERN void  sim_read_sim    (USHORT data_id, UBYTE len, UBYTE max_length);
EXTERN void  sim_read_sim_cb (SHORT table_id);
EXTERN void  sim_write_sim   (USHORT data_id, UBYTE * data, UBYTE length);
EXTERN void  sim_write_sim_cb(SHORT table_id);


#endif
