#ifdef _MMS_ENABLE_
#ifndef _MMI_MMS_FFS_H_
#define _MMI_MMS_FFS_H_

#include "Ffs.h"
#include "Atbdata.h"

#if 0
#define	FFSFILE_MMSSETTINGS_PATH	       "/mmi/MMSsettings"		
#define MMS_SETTINGS_SUM                   5          //MMSܵ
#define MMS_SETTINGS_IP_ADDRESS_LEN        19
#define MMS_SETTINGS_IP_PORT_LEN            8
#define MMS_SETTINGS_APN_LEN               105
#define MMS_SETTINGS_USERNAME_LEN          25
#define MMS_SETTINGS_PASSWORD_LEN          25
#define MMS_SETTINGS_DIALNUMBER_LEN        25   
#define MMS_SETTINGS_GROUPNAME_LEN         60
#define MMSC_URL_LEN                       60

#else
#define	FFSFILE_MMSSETTINGS_PATH	       "/bmi/MMSsettings"		
#define MMS_SETTINGS_SUM                   5          //MMSܵ
#define MMS_SETTINGS_IP_ADDRESS_LEN        IPADDRESS_MAX_LEN
#define MMS_SETTINGS_IP_PORT_LEN            8
#define MMS_SETTINGS_APN_LEN               URL_MAX_LEN
#define MMS_SETTINGS_USERNAME_LEN          USERNAME_MAX_LEN
#define MMS_SETTINGS_PASSWORD_LEN          PASSWORD_MAX_LEN
#define MMS_SETTINGS_DIALNUMBER_LEN        NUMBER_MAX_LEN   
#define MMS_SETTINGS_GROUPNAME_LEN         60
#define MMSC_URL_LEN                       URL_MAX_LEN

#endif

typedef enum
{
    MMS_PARAM_OFF,
	MMS_PARAM_ON
}MMS_PARA_SETTING_STATE; 

typedef struct 
{
	MMS_PARA_SETTING_STATE stateSendReport;	
}T_MMS_SEND_SETTINGS;

typedef struct 
{
    MMS_PARA_SETTING_STATE stateAutoSave;
	MMS_PARA_SETTING_STATE stateAutoRecv;
}T_MMS_RECV_SETTINGS;

typedef enum
{
	ONLY_GPRS,
	ONLY_GSM
}T_MMS_TRANSPORT_MODE;

typedef struct 
{
	char IPAddress[MMS_SETTINGS_IP_ADDRESS_LEN + 1];
	char IPPort[MMS_SETTINGS_IP_PORT_LEN + 1];
	char APN[MMS_SETTINGS_APN_LEN + 1];
	char userName[MMS_SETTINGS_USERNAME_LEN + 1];
	char password[MMS_SETTINGS_PASSWORD_LEN + 1];     
}T_MMS_GPRS_SETTINGS;

typedef enum
{
	ISDN,
	ANALOGUE
}T_MMS_DATA_CALL_TYPE;

typedef struct 
{ 
	char IPAddress[MMS_SETTINGS_IP_ADDRESS_LEN + 1];
    char IPPort[MMS_SETTINGS_IP_PORT_LEN + 1];
//	T_MMS_DATA_CALL_TYPE dataCallType;  //deleted by xie 04-07-14
	char dialNumber[MMS_SETTINGS_DIALNUMBER_LEN + 1];
	char userName[MMS_SETTINGS_USERNAME_LEN + 1];
	char password[MMS_SETTINGS_PASSWORD_LEN + 1];     	
}T_MMS_GSM_SETTINGS;

typedef struct 
{
	char strName[MMS_SETTINGS_GROUPNAME_LEN + 1];
	char mmscURL[MMSC_URL_LEN + 1];
	
	T_MMS_SEND_SETTINGS   sendSettings;
    T_MMS_RECV_SETTINGS   recvSettings;

	T_MMS_GPRS_SETTINGS   gprsSettings; 
	T_MMS_GSM_SETTINGS    gsmSettings;
	T_MMS_TRANSPORT_MODE  transportMode;  
}T_MMS_PARA_SETTINGS;

typedef struct
{
   T_MMS_PARA_SETTINGS allSettings[MMS_SETTINGS_SUM];
   UINT    settingsSum;   
   UINT    curSettingsIndex;
}T_MMS_NET_SETTINGS;

extern T_MMS_NET_SETTINGS mmsSettings;
effs_t flash_MMSSettingswrite();
effs_t flash_MMSSettingsread();
void flash_MMSSettingsInitialise();

#endif 
#endif