#ifdef _MMS_ENABLE_

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)
    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"
#else
    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"
#endif

#include "p_sim.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_str.h"
#include "dspl.h"

#include "MmiMain.h"
#include "MmiDummy.h"
#include "MmiMmi.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiEditor.h"
#include "Mmitextinput.h"
#include "phb.h"  
#include "mmiBookshared.h" 
#include "mmiSmsMenu.h"
#include "mmismssend.h"
#include "mmismsidle.h"

//begin xie
#include "mmimms_cfg.h"
#include "mmiMMSNew.h"
#include "mmseditor.h"
#include "mmiMMSGlobalDef.h"
#include "mmiutilapi.h"
#include "player.h"
#include "mmsgloble.h"
#include "msglist.h"
#include "jpeg.h"
#include "CmsImage.h"

#include "mmimmsmenu.h"
#include "listicn.h"

#ifdef MMI_MMSTASK_ENABLED
#define MMS_COMPILE_FORAPP
#include "mmstask.h"
#endif
#include "CmsWbmp.h" //add by xie for wbmp file preview
#include "CmsDraw.h" 
//end xie


/*½ýϢ*/

#define MMS_Menu_New_Listmenu_Num  4

typedef struct _MMS_Frame_Data{
	char title[MMS_TITLE_NUM_LENGTH+1];
	char imageFileName[MMS_IMAGE_NUM_LENGTH+1];
	char audioFileName[MMS_RING_NUM_LENGTH+1];
	char text[MMS_CONTEXT_NUM_LENGTH+1];
}MMS_Frame_Data;
MMS_Frame_Data  frameData;

static unsigned int MMS_NEW_ITEMLEN_MAX[]={
	MMS_TITLE_NUM_LENGTH,
	MMS_IMAGE_NUM_LENGTH,
	MMS_RING_NUM_LENGTH,
	MMS_CONTEXT_NUM_LENGTH,
};

typedef enum 
{
	MMS_Menu_New_Edit_Title=0,
	MMS_Menu_New_List_Image,
	MMS_Menu_New_List_Ring,
	MMS_Menu_New_Edit_Text,	
} MMS_Menu_New_Edit_ID;

int iMenuItemIndex = MMS_Menu_New_Edit_Title; 

/*talcon delett it*/
//static MfwRect MMS_Menu_New_Area = {0,0,SCREEN_SIZE_X,LINE_HEIGHT*(MMS_Menu_New_Listmenu_Num+5)}; 
extern MfwRect menuListArea;
static MfwMnuAttr MMS_Menu_New_Attrib =
{
    0,
	&menuListArea,//&MMS_Menu_New_Area,
	MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
	-1,                                 /* use default font         */
	NULL,                               /* with these items         */
	0                                   /* number of items     */
};

typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	

    /* associated handlers */
	
    /* internal data */
    ListMenuData    list_menu_data;
	unsigned int iItemLen[MMS_Menu_New_Listmenu_Num];

} T_MMS_MENU_NEW;

static T_MFW_HND MMS_Menu_New_create (T_MFW_HND window);
static void      MMS_Menu_New_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter);
static void      MMS_Menu_New_listmenu_create (T_MMS_MENU_NEW *data);
static void      MMS_Menu_New_listmenu_cb (T_MFW_HND * win, ListMenuData * ListData);
static void      MMS_Menu_New_destroy (T_MFW_HND window);

/*ݱ༭*/
typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;
	MMS_Menu_New_Edit_ID edtID;
	
    T_MFW_HND       editor;
    T_EDITOR_DATA   editor_info; 
}T_MMS_MENU_NEW_EDITOR; 

static T_MFW_HND MMS_Menu_New_Edit_start  (MfwHnd parent_window,MMS_Menu_New_Edit_ID  edtID);
static T_MFW_HND MMS_Menu_New_Edit_create (T_MFW_HND win);
static void		 MMS_Menu_New_Edit_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter);
static void		 MMS_Menu_New_Edit_edit_cb(T_MFW_HND win, USHORT Identifier, SHORT reason);
static void      MMS_Menu_New_Edit_destroy (T_MFW_HND window);
static void      MMS_Menu_New_Edit_LoadEditDefault(T_EDITOR_DATA *editor_data);

/*ѡ˵Լѡ˵*/ 
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
    /* associated handlers */	
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu;
    /* internal data */
	T_MFW_HND       info_win; 
	
}T_MMS_NEW_LIST_RIGHT; 

static T_MFW_HND MMS_New_List_Right_start(MfwHnd parent_window , MfwMnuAttr *menuAttr);
static T_MFW_HND MMS_New_List_Right_create(T_MFW_HND parent_window);
static void MMS_New_List_Right_destroy(T_MFW_HND win);
static void MMS_New_List_Right_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int MMS_New_List_Right_kbd_cb(MfwEvt e, MfwKbd *k);
static int MMS_New_List_Right_mnu_cb ( MfwEvt e, MfwMnu *m );
static int MMS_New_List_Right_win_cb(MfwEvt e, MfwWin *w);

static int MMS_NEW_List_Right_PageDown     (MfwMnu* m, MfwMnuItem* i);
static int MMS_NEW_List_Right_AddPage(MfwMnu* m, MfwMnuItem* i);
static int MMS_NEW_List_Right_DeleteImage(MfwMnu* m, MfwMnuItem* i);
static int MMS_NEW_List_Right_DeleteMusic(MfwMnu* m, MfwMnuItem* i);
static int MMS_NEW_List_Right_DeletePage(MfwMnu* m, MfwMnuItem* i);
static int MMS_NEW_List_Right_PageUp	(MfwMnu* m, MfwMnuItem* i);
static int MMS_NEW_List_Right_Exit(MfwMnu* m, MfwMnuItem* i);
static int MMS_NEW_List_Right_PreView(MfwMnu* m, MfwMnuItem* i);
static int MMS_NEW_List_Right_Send(MfwMnu* m, MfwMnuItem* i);
static int MMS_NEW_List_Right_StoreMsg(MfwMnu* m, MfwMnuItem* i);

/*talcon delete it*/
//MfwRect MMS_NEW_EDIT_OPTItems_Area = {0,0,SCREEN_SIZE_X,LINE_HEIGHT*9};


static MfwMnuItem MMS_NEW_EDIT_OPTItems00[] =
{
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSPreview,   0, (MenuFunc)MMS_NEW_List_Right_PreView,   item_flag_none},		
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSSend,   0, (MenuFunc)MMS_NEW_List_Right_Send,   item_flag_none},		
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSAddpage,   0, (MenuFunc)MMS_NEW_List_Right_AddPage,   item_flag_none},		
    {(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSDeletepage,   0, (MenuFunc)MMS_NEW_List_Right_DeletePage,   item_flag_none},
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSPageUp,   0, (MenuFunc)MMS_NEW_List_Right_PageUp,   item_flag_none},		
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtMMSPageDown,0,(MenuFunc)MMS_NEW_List_Right_PageDown,item_flag_none},
	{(MfwIcnAttr*)&colist,0,0,(char *)TxtMMSStoreMsg,0,(MenuFunc)MMS_NEW_List_Right_StoreMsg,item_flag_none},
    {(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSExit,  0, (MenuFunc)MMS_NEW_List_Right_Exit,  item_flag_none}		
};

static MfwMnuItem MMS_NEW_EDIT_OPTItems10[] =
{
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSPreview,   0, (MenuFunc)MMS_NEW_List_Right_PreView,   item_flag_none},		
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSSend,   0, (MenuFunc)MMS_NEW_List_Right_Send,   item_flag_none},		
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSDeleteImage,   0, (MenuFunc)MMS_NEW_List_Right_DeleteImage,   item_flag_none},
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSAddpage,   0, (MenuFunc)MMS_NEW_List_Right_AddPage,   item_flag_none},		
    {(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSDeletepage,   0, (MenuFunc)MMS_NEW_List_Right_DeletePage,   item_flag_none},
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSPageUp,   0, (MenuFunc)MMS_NEW_List_Right_PageUp,   item_flag_none},		
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtMMSPageDown,0,(MenuFunc)MMS_NEW_List_Right_PageDown,item_flag_none},
	{(MfwIcnAttr*)&colist,0,0,(char *)TxtMMSStoreMsg,0,(MenuFunc)MMS_NEW_List_Right_StoreMsg,item_flag_none},
    {(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSExit,  0, (MenuFunc)MMS_NEW_List_Right_Exit,  item_flag_none}		
};

static MfwMnuItem MMS_NEW_EDIT_OPTItems01[] =
{
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSPreview,   0, (MenuFunc)MMS_NEW_List_Right_PreView,   item_flag_none},		
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSSend,   0, (MenuFunc)MMS_NEW_List_Right_Send,   item_flag_none},		
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSDeleteMusic,   0, (MenuFunc)MMS_NEW_List_Right_DeleteMusic,   item_flag_none},
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSAddpage,   0, (MenuFunc)MMS_NEW_List_Right_AddPage,   item_flag_none},		
    {(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSDeletepage,   0, (MenuFunc)MMS_NEW_List_Right_DeletePage,   item_flag_none},
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSPageUp,   0, (MenuFunc)MMS_NEW_List_Right_PageUp,   item_flag_none},		
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtMMSPageDown,0,(MenuFunc)MMS_NEW_List_Right_PageDown,item_flag_none},
	{(MfwIcnAttr*)&colist,0,0,(char *)TxtMMSStoreMsg,0,(MenuFunc)MMS_NEW_List_Right_StoreMsg,item_flag_none},
    {(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSExit,  0, (MenuFunc)MMS_NEW_List_Right_Exit,  item_flag_none}		
};

static MfwMnuItem MMS_NEW_EDIT_OPTItems11[] =
{
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSPreview,   0, (MenuFunc)MMS_NEW_List_Right_PreView,   item_flag_none},		
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSSend,   0, (MenuFunc)MMS_NEW_List_Right_Send,   item_flag_none},		
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSDeleteImage,   0, (MenuFunc)MMS_NEW_List_Right_DeleteImage,   item_flag_none},
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSDeleteMusic,   0, (MenuFunc)MMS_NEW_List_Right_DeleteMusic,   item_flag_none},	
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSAddpage,   0, (MenuFunc)MMS_NEW_List_Right_AddPage,   item_flag_none},		
    {(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSDeletepage,   0, (MenuFunc)MMS_NEW_List_Right_DeletePage,   item_flag_none},
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSPageUp,   0, (MenuFunc)MMS_NEW_List_Right_PageUp,   item_flag_none},		
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtMMSPageDown,0,(MenuFunc)MMS_NEW_List_Right_PageDown,item_flag_none},
	{(MfwIcnAttr*)&colist,0,0,(char *)TxtMMSStoreMsg,0,(MenuFunc)MMS_NEW_List_Right_StoreMsg,item_flag_none},
    {(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSExit,  0, (MenuFunc)MMS_NEW_List_Right_Exit,  item_flag_none}		
};

static MfwMnuAttr MMS_NEW_EDIT_OPTAttr00 =
{
    0,
	&menuListArea,//&MMS_NEW_EDIT_OPTItems_Area,
	MNU_LEFT | MNU_LIST | MNU_CUR_LINE, 
	-1,                                
	MMS_NEW_EDIT_OPTItems00,                    
	sizeof(MMS_NEW_EDIT_OPTItems00)/sizeof(MfwMnuItem) 
}; 

static MfwMnuAttr MMS_NEW_EDIT_OPTAttr01 =
{
    0,
	&menuListArea,//&MMS_NEW_EDIT_OPTItems_Area,
	MNU_LEFT | MNU_LIST | MNU_CUR_LINE, 
	-1,                                
	MMS_NEW_EDIT_OPTItems01,                    
	sizeof(MMS_NEW_EDIT_OPTItems01)/sizeof(MfwMnuItem) 
}; 

static MfwMnuAttr MMS_NEW_EDIT_OPTAttr10 =
{
    0,
	&menuListArea,//&MMS_NEW_EDIT_OPTItems_Area,
	MNU_LEFT | MNU_LIST | MNU_CUR_LINE, 
	-1,                                
	MMS_NEW_EDIT_OPTItems10,                    
	sizeof(MMS_NEW_EDIT_OPTItems10)/sizeof(MfwMnuItem) 
}; 

static MfwMnuAttr MMS_NEW_EDIT_OPTAttr11 =
{
    0,
	&menuListArea,//&MMS_NEW_EDIT_OPTItems_Area,
	MNU_LEFT | MNU_LIST | MNU_CUR_LINE, 
	-1,                                
	MMS_NEW_EDIT_OPTItems11,                    
	sizeof(MMS_NEW_EDIT_OPTItems11)/sizeof(MfwMnuItem) 
}; 

/*ͼƬб*/
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
	
    /* associated handlers */
	
    /* internal data */
    ListMenuData    list_menu_data;
	
	/*feng */
	int ListID;
} T_MMS_MENU_NEW_LIST;

typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
	/*20040609 feng*/
	T_MFW_HND       info_win; 
	int ListID;
} T_MMS_MENU_NEW_LIST_PIC;  

int iListMenuItemIndex=0;
int mediaFileNumber =0;

T_MFW_HND MMS_Menu_New_List_start(T_MFW_HND parent, int  edtID);
T_MFW_HND  MMS_Menu_New_List_create(MfwHnd parent_window);
void MMS_Menu_New_List_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter);
void MMS_Menu_New_List_listmenu_create(T_MMS_MENU_NEW_LIST *data);
void MMS_Menu_New_List_listmenu_cb (T_MFW_HND * win, ListMenuData * ListData);
void  MMS_Menu_New_List_destroy (T_MFW_HND window);

//MMS
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
    /* associated handlers */	
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
	
}T_MMS_IMAGE_PREVIEW;  

T_MFW_HND gHndMMSImagePreview = NULL;

static T_MFW_HND MMS_Image_Preview_start(MfwHnd parent_window );
static T_MFW_HND MMS_Image_Preview_create(T_MFW_HND parent_window);
static void MMS_Image_Preview_destroy(T_MFW_HND win);
static void MMS_Image_Preview_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int MMS_Image_Preview_kbd_cb(MfwEvt e, MfwKbd *k);
static int MMS_Image_Preview_win_cb(MfwEvt e, MfwWin *w);

//Ԥ
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
    /* associated handlers */	
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
	
}T_MMS_NEW_PREVIEW;  

static T_MFW_HND MMS_New_Preview_start(MfwHnd parent_window );
static T_MFW_HND MMS_New_Preview_create(T_MFW_HND parent_window);
static void MMS_New_Preview_destroy(T_MFW_HND win);
static void MMS_New_Preview_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int MMS_New_Preview_kbd_cb(MfwEvt e, MfwKbd *k);
static int MMS_New_Preview_win_cb(MfwEvt e, MfwWin *w);

void MMS_Menu_New_Pic_ShowAffirmWin (T_MFW_HND win,int picID);
static void MMS_Menu_New_Pic_cb(T_MFW_HND win,USHORT identifier, UBYTE reason);


//ʱô
#define RECEIVER_NUMBER_MAX  15
#define RECEIVER_LENGTH_MAX  30

typedef enum{
	NORECEIVER,
	EMAIL,
	TELEPHONE
}RECEIVER_TYPE;

typedef struct _RECEIVER_
{
    RECEIVER_TYPE type;
    char receiver[RECEIVER_LENGTH_MAX+1];
}RECEIVER;

RECEIVER recvLists[RECEIVER_NUMBER_MAX];
unsigned char   receiverIndex = 0;

/*talcon delete it*/
//static MfwRect MMS_Receiver_List_Area = {0,0,SCREEN_SIZE_X,LINE_HEIGHT*9}; 

static MfwMnuAttr MMS_Receiver_List_Attrib =
{
    0,
	&menuListArea,//&MMS_Receiver_List_Area,
	MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
	-1,                                 /* use default font         */
	NULL,                               /* with these items         */
	0                                   /* number of items     */
};

typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
	
    /* associated handlers */
	
    /* internal data */
    ListMenuData    list_menu_data;	
} T_MMS_RECEIVER_LIST;    

static T_MFW_HND MMS_Receiver_List_start(MfwHnd parent_window );
static T_MFW_HND MMS_Receiver_List_create (T_MFW_HND window);
static void      MMS_Receiver_List_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter);
static void      MMS_Receiver_List_listmenu_create (T_MMS_RECEIVER_LIST *data);
static void      MMS_Receiver_List_listmenu_cb (T_MFW_HND * win, ListMenuData * ListData);
static void      MMS_Receiver_List_destroy (T_MFW_HND window);

static void      MMS_Receiver_List_Refresh(MMS_FOLDER_TYPE folderType, Refresh_Action command);

INFO_DIALOG_DATA iddMMSSending = {NULL,NULL};

typedef struct _RECEIVER_LIST_WIN_INFO_
{
	T_MFW_HND  hndRecListWin;
	T_MFW_HND  hndRecList;
}RECEIVER_LIST_WIN_INFO;

RECEIVER_LIST_WIN_INFO gMMSRecvHndInfo={
	NULL,
    NULL
};
#if 0
int       MMS_Sending_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
void             MMS_Sending_End(void);
#endif

//бѡ
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;   
    T_MFW_HND       parent;	
    /* associated handlers */	
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu;
    /* internal data */
}T_MMS_RECEIVER_LIST_OPT; 

static T_MFW_HND MMS_Receiver_List_Opt_start(MfwHnd parent_window , MfwMnuAttr *menuAttr);
static T_MFW_HND MMS_Receiver_List_Opt_create(T_MFW_HND parent_window);
static void MMS_Receiver_List_Opt_destroy(T_MFW_HND win);
static void MMS_Receiver_List_Opt_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int MMS_Receiver_List_Opt_kbd_cb(MfwEvt e, MfwKbd *k);
static int MMS_Receiver_List_Opt_mnu_cb ( MfwEvt e, MfwMnu *m );
static int MMS_Receiver_List_Opt_win_cb(MfwEvt e, MfwWin *w);

static int MMS_Receiver_List_Opt_TelNumber(MfwMnu* m, MfwMnuItem* i);
static int MMS_Receiver_List_Opt_Email(MfwMnu* m, MfwMnuItem* i);

static int MMS_Receiver_List_Opt_Delete(MfwMnu* m, MfwMnuItem* i);		
static int MMS_Receiver_List_Opt_Edit(MfwMnu* m, MfwMnuItem* i);

/*talcon delete it*/
//MfwRect MMS_Receiver_List_OPTItems_Area = {0,0,SCREEN_SIZE_X,LINE_HEIGHT*9};
static MfwMnuItem MMS_Receiver_List_OPTItems[] =
{
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSTelNumber,   0, (MenuFunc)MMS_Receiver_List_Opt_TelNumber,   item_flag_none},		
	{(MfwIcnAttr*)&colist, 0,0, (char *)TxtMMSEmail,   0, (MenuFunc)MMS_Receiver_List_Opt_Email,   item_flag_none},		
};

static MfwMnuAttr MMS_Receiver_List_OPTAttr =
{
    0,
		&menuListArea,//&MMS_Receiver_List_OPTItems_Area,
		MNU_LEFT | MNU_LIST | MNU_CUR_LINE, 
		-1,                                
		MMS_Receiver_List_OPTItems,                    
		sizeof(MMS_Receiver_List_OPTItems)/sizeof(MfwMnuItem) 
}; 


static MfwMnuItem MMS_Receiver_List_OPTItems2[] =
{
	{(MfwIcnAttr*)&colist, 0, 0, (char*)TxtMMSDelete,        0, (MenuFunc)MMS_Receiver_List_Opt_Delete,   item_flag_none},		
	{(MfwIcnAttr*)&colist, 0, 0, (char *)TxtMMSEdit, 0, (MenuFunc)MMS_Receiver_List_Opt_Edit,   item_flag_none},		
};

static MfwMnuAttr MMS_Receiver_List_OPTAttr2 =
{
    0,
		&menuListArea,//&MMS_Receiver_List_OPTItems_Area,
		MNU_LEFT | MNU_LIST | MNU_CUR_LINE, 
		-1,                                
		MMS_Receiver_List_OPTItems2,                    
		sizeof(MMS_Receiver_List_OPTItems2)/sizeof(MfwMnuItem) 
}; 
//߱༭
typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;
	RECEIVER_TYPE   edtID;
	
    T_MFW_HND       editor;
    T_EDITOR_DATA   editor_info; 
}T_MMS_RECEIVER_EDITOR;     //ݱ༭ڲ 

static T_MFW_HND MMS_Receiver_Edit_start  (MfwHnd parent_window, RECEIVER_TYPE edtID);
static T_MFW_HND MMS_Receiver_Edit_create (T_MFW_HND win);
static void		 MMS_Receiver_Edit_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter);
static void		 MMS_Receiver_Edit_edit_cb(T_MFW_HND win, USHORT Identifier, SHORT reason);
static void      MMS_Receiver_Edit_destroy (T_MFW_HND window);
static void      MMS_Receiver_Edit_LoadEditDefault(T_EDITOR_DATA *editor_data);

/***************************************************************/
/*                  ýϢ                                 */
/***************************************************************/

int MMS_Menu_New(MfwMnu* m, MfwMnuItem* i)
{
/*
	char stringbu[30] = "xiexiaodong hello";
	char stringbu2[30];
	int ret;
	T_FFS_FD fp = MMS_fopen("/mms/xie.txt","w");
	MMS_TRACE_EVENT(("fp= %d",(int)fp));
	if(fp)
	{	
		ret = MMS_fwrite(stringbu, 1, 11,  fp);
		MMS_TRACE_EVENT(("fwrite %d bytes",ret));

		MMS_fclose(fp);
    	fp = MMS_fopen("/mms/xie.txt","r");
		ret = MMS_fread(stringbu2, 1, 5, fp);
		MMS_TRACE_EVENT(("fread %d bytes,the results is %s %d",ret ,stringbu2, (int)fp));
		MMS_fclose(fp);
	}

	MMS_deletefile("temp.txt", "/mms");
	MMS_deletefiles("/mms");*/
//	MMS_Test_Send_Message();   

//	FILE* fp= fopen("c:\mms\dmf.txt","w");

	T_MFW_HND   win = mfwParent(mfwHeader());
	P_MMS		mms = getMMS();	
	MMS_TRACE_FUNCTION("MMS_Menu_New"); 
	if(mms->editor==NULL)
	{	
		mms->editor = editor_on_initialize(EDITOR_INIT_NEW, NULL);
		if(mms->editor==NULL)
		{
			MMS_TRACE_EVENT(("MMS editor initialize error in MMS_Menu_New()"));
			return 0;
		}	
		manager_set_currentfolder(mms->manager->draftfolder);//½Ϣ󣬽ѰϢΪdraft folderеһMMSвûаѵǰfolderΪdraftfolder
	} 
	MMS_Refresh_FrameData(CLEAR);
	
	gCurMMSPos = MMS_NEW;
	MMS_Menu_New_start(win);	 
	return 1;   
}

T_MFW_HND MMS_Menu_New_start(T_MFW_HND parent_window)
{	
	T_MFW_HND      win;
	MMS_TRACE_FUNCTION("MMS_Menu_New_start"); 
	win = MMS_Menu_New_create(parent_window);	   	   
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, NULL);
    }
    return win;	
}

T_MFW_HND  MMS_Menu_New_create(T_MFW_HND window)
{
	T_MMS_MENU_NEW * data = (T_MMS_MENU_NEW *)ALLOC_MEMORY (sizeof (T_MMS_MENU_NEW));
    T_MFW_WIN  * win;
	
    MMS_TRACE_FUNCTION("MMS_Menu_New_create"); 
    data->win =win_create (window, 0, 0, NULL);
    if( data->win EQ NULL )
    {
        return NULL;
    }

	MMS_Set_MMSNew_WHnd(data->win);

    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Menu_New_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = window;
	
    winShow(data->win);
    return data->win;
}

void MMS_Menu_New_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter)
{
	T_MFW_WIN         * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_MENU_NEW    * data = (T_MMS_MENU_NEW *)win_data->user;
    T_MFW_HND         * parent=data->parent;
	MMS_TRACE_FUNCTION("MMS_Menu_New_dialog"); 
    switch( event )
    {
    case E_INIT:
        /* initialization of the dialog data */
        data->list_menu_data.ListPosition   = iMenuItemIndex+1;/* True cursor position in list menu. */
        data->list_menu_data.CursorPosition = iMenuItemIndex;/* Cursor position in list snapshot.  */
        data->list_menu_data.SnapshotSize   = MMS_Menu_New_Listmenu_Num;/* Number of list entries to view.    */
        data->list_menu_data.Font           = 0;
        data->list_menu_data.LeftSoftKey    = TxtSoftSelect;
        data->list_menu_data.RightSoftKey   = TxtSoftOptions;
        data->list_menu_data.KeyEvents      = KEY_ALL^KEY_CALL;//KEY_RIGHT | KEY_LEFT | KEY_OK | KEY_MNUUP | KEY_MNUDOWN | KEY_HUP;
        data->list_menu_data.Reason         = 0;
        data->list_menu_data.Strings        = TRUE; 
        data->list_menu_data.Attr           = &MMS_Menu_New_Attrib;
        data->list_menu_data.autoDestroy    = TRUE;

        MMS_Menu_New_listmenu_create(data);
        break;
		
    case E_RETURN: 
    case E_EXIT: 
    case E_BACK: 
		MMS_Menu_New_destroy(data->win);
        MMS_Menu_New_start(parent);
        break;
		
    case E_ABORT:   
		iMenuItemIndex = 0;
        MMS_Menu_New_destroy(data->win);
        SEND_EVENT (parent, E_BACK, 0, NULL); /* forward event to parent */
        break;
    default:
        return;
    }
	return;
}

/*calculate the string length merged by  str1 and str2*/
unsigned int MMS_String_Merge_Len(char *str1, char *str2)
{
	unsigned char *ss1=(unsigned char*)str1;
	unsigned char *ss2=(unsigned char*)str2;
	unsigned int len1=wstrlen((char*)ss1);
	unsigned int len2=wstrlen((char*)ss2);
	
	if (*ss1!=0x80&&*ss2!=0x80)
	{
		return len1+len2+1;
	} 
	else if (*ss1==0x80&&*ss2==0x80)
	{
	    return len1+len2+2;
	}
	else if (*ss1==0x80&&*ss2!=0x80)
	{
		return len1+2*len2+3;
	}
	else if (*ss1!=0x80&&*ss2==0x80)
	{
		return 2*len1+len2+3;
	}
}

void MMS_Menu_New_listmenu_create(T_MMS_MENU_NEW *data)
{
    int i;
	char *strItem = NULL;
	char *strItemEdit = NULL;
	P_MMS mms= getMMS();
	MMS_TRACE_FUNCTION("MMS_Menu_New_listmenu_create"); 
    /* allocate sufficient memory to hold the maximum list of menu items */
    data->list_menu_data.List = (MfwMnuItem *)ALLOC_MEMORY (MMS_Menu_New_Listmenu_Num * sizeof (MfwMnuItem));

    data->list_menu_data.ListMenuFlag=1;//for display the title
    data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtMMSNew);
    for( i=0; i < MMS_Menu_New_Listmenu_Num; i++ ) /* Fill Menu List */
    {
        data->list_menu_data.List[i].icon = (MfwIcnAttr*)&colist;
        data->list_menu_data.List[i].exta = 0;
        data->list_menu_data.List[i].edit = 0;
        data->list_menu_data.List[i].menu = 0;
        data->list_menu_data.List[i].func = 0; 
        data->list_menu_data.List[i].flagFunc = item_flag_none;

#if 0
//		data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( MMS_NEW_ITEMLEN_MAX[i] );
		if(i == 0)
		{
			data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( 2*MMS_NEW_ITEMLEN_MAX[i] + wstrlen(MmiRsrcGetText(TxtNewMMSTitle)) +3);
	    	wstrcpy(data->list_menu_data.List[i].str ,(char *) MmiRsrcGetText(TxtNewMMSTitle));
		}
		else if(i == 1)
		{
			data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( 2*MMS_NEW_ITEMLEN_MAX[i] + wstrlen(MmiRsrcGetText(TxtNewMMSPicture)) +3);
			wstrcpy(data->list_menu_data.List[i].str ,(char *) MmiRsrcGetText(TxtNewMMSPicture));
		}
		else if(i == 2)
		{
			data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( 2*MMS_NEW_ITEMLEN_MAX[i] + wstrlen(MmiRsrcGetText(TxtNewMMSMusic)) +3);
			wstrcpy(data->list_menu_data.List[i].str ,(char *) MmiRsrcGetText(TxtNewMMSMusic));
		}
		else if(i == 3)
		{
			data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( 2*MMS_NEW_ITEMLEN_MAX[i] + wstrlen(MmiRsrcGetText(TxtNewMMSText)) +3 );
			wstrcpy(data->list_menu_data.List[i].str ,(char *) MmiRsrcGetText(TxtNewMMSText));
		}
					
		switch(i)
		{
		case 0:
			strItem =  (char *)editor_get_mmstitle();
			if(strItem && strItem[0] != '\0')
				wstrcat(data->list_menu_data.List[i].str,strItem);			
			break;			
		case 1:
			strItem = (char *)editor_get_imagefilename();
			if( strItem && strItem[0] != '\0')
			{
				if(strstr(strItem,"/"))
				{
				strItem = strrchr(strItem,'/');
				if(strItem)
				{
					strItem +=1;
				wstrcat(data->list_menu_data.List[i].str, strItem);				
				}	
			}
				else
				{
                    wstrcat(data->list_menu_data.List[i].str, strItem);	
				}
			
			}
			break;			
		case 2:			
			strItem = (char *)editor_get_audiofilename();
			if( strItem && strItem[0] != '\0')
			{
				if(strstr(strItem,"/"))
				{
				strItem = strrchr(strItem,'/');
				if(strItem)
				{
					strItem +=1;
				wstrcat(data->list_menu_data.List[i].str, strItem);	
				}	
			}
				else
				{
                    wstrcat(data->list_menu_data.List[i].str, strItem);	
				}
			}
			break;			
		case 3:
			strItem = (char *)editor_get_textstring();
			if(strItem && strItem[0] != '\0')
				wstrcat(data->list_menu_data.List[i].str, strItem);					
			break;
		default:
			break;
		}
#else 
		if(i == 0)
		{
			strItem = MmiRsrcGetText(TxtNewMMSTitle);
			strItemEdit =  (char *)editor_get_mmstitle();
			if(strItemEdit && strItemEdit[0] != '\0')
			{
				data->iItemLen[i] = MMS_String_Merge_Len(strItem, strItemEdit);
				data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY (data->iItemLen[i]);
				wstrcpy(data->list_menu_data.List[i].str ,strItem);
				wstrcat(data->list_menu_data.List[i].str,strItemEdit);
			}
			else
			{ 
				data->iItemLen[i] = wstrlen(strItem)+2;
				data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY (data->iItemLen[i]);
				wstrcpy(data->list_menu_data.List[i].str ,strItem);
			}
		}
		else if(i == 1)
		{
			strItem = MmiRsrcGetText(TxtNewMMSPicture);
			strItemEdit = (char *)editor_get_imagefilename();
			if( strItemEdit && strItemEdit[0] != '\0')
			{
				if(strstr(strItemEdit,"/"))
				{
					strItemEdit = strrchr(strItemEdit,'/');	
					if(strItemEdit)
					{
						strItemEdit +=1;			
					}	
				}
				else if(strstr(strItemEdit,"\\"))
				{
					strItemEdit = strrchr(strItemEdit,'\\');
					if(strItemEdit)
					{
						strItemEdit +=1;			
					}	
				}
			}

			if(strItemEdit && strItemEdit[0] != '\0')
			{
                data->iItemLen[i] = MMS_String_Merge_Len(strItem, strItemEdit);
				data->list_menu_data.List[1].str= (char *) ALLOC_MEMORY ( data->iItemLen[i]);
				wstrcpy(data->list_menu_data.List[i].str ,strItem);
				wstrcat(data->list_menu_data.List[i].str,strItemEdit);
			}
			else
			{
                data->iItemLen[i] = wstrlen(strItem)+2;
				data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY (data->iItemLen[i]);
				wstrcpy(data->list_menu_data.List[i].str ,strItem);
			}
		}
		else if(i == 2)
		{
			strItem = MmiRsrcGetText(TxtNewMMSMusic);	
			strItemEdit = (char *)editor_get_audiofilename();
			if( strItemEdit && strItemEdit[0] != '\0')
			{
				if(strstr(strItemEdit,"/"))
				{
					strItemEdit = strrchr(strItemEdit,'/');
					if(strItemEdit)
					{
						strItemEdit +=1;			
					}	
				}
				else if(strstr(strItemEdit, "\\"))
				{
					strItemEdit = strrchr(strItemEdit,'\\');
					if(strItemEdit)
					{
						strItemEdit +=1;			
					}	
				}	
			}
			
			if(strItemEdit && strItemEdit[0] != '\0')
			{
                data->iItemLen[i] = MMS_String_Merge_Len(strItem, strItemEdit);
				data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( data->iItemLen[i] );
				wstrcpy(data->list_menu_data.List[i].str ,strItem);
				wstrcat(data->list_menu_data.List[i].str,strItemEdit);
			}
			else
			{
				data->iItemLen[i] = wstrlen(strItem)+2;
				data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY( data->iItemLen[i]);
				wstrcpy(data->list_menu_data.List[i].str ,strItem);
			}
		}
		else if(i == 3)
		{
			strItem = MmiRsrcGetText(TxtNewMMSText);
			strItemEdit =  (char *)editor_get_textstring();
			if(strItemEdit && strItemEdit[0] != '\0')
			{
                data->iItemLen[i] = MMS_String_Merge_Len(strItem, strItemEdit);
				data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY (data->iItemLen[i]);
				wstrcpy(data->list_menu_data.List[i].str ,strItem);
				wstrcat(data->list_menu_data.List[i].str,strItemEdit);
			}
			else
			{
				data->iItemLen[i] = wstrlen(strItem)+2;
				data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY (data->iItemLen[i]);
				wstrcpy(data->list_menu_data.List[i].str ,strItem);
			}
		}
#endif
	}
 	
    //actual number of entries in list menu
    data->list_menu_data.ListLength = MMS_Menu_New_Listmenu_Num; 
    data->list_menu_data.autoDestroy = TRUE;
    listDisplayListMenu(data->win, &data->list_menu_data, (ListCbFunc)MMS_Menu_New_listmenu_cb,0);

	//added by xie for displaying current slide and the total num of slide 
	{
		char title[10];
		unsigned char curSlide = (unsigned char)editor_get_slideindex();
		unsigned char slideNum = (unsigned char)editor_get_slidecount();	
		sprintf(title,"%d/%d",curSlide+1,slideNum);
		drawcolorclarity((SCREEN_SIZE_X- get_StringWidth(title))/2,SCREEN_SIZE_Y-dspl_GetFontHeight()-1,title, 0x000000);
	}
}

void MMS_Menu_New_listmenu_cb (T_MFW_HND * win, ListMenuData * ListData)
{
    T_MFW_WIN         * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_MENU_NEW    * data   = (T_MMS_MENU_NEW *)win_data->user;
	T_MFW_HND              * parent=data->parent;
	P_MMS mms = getMMS();
	pMMS_EDocument	edoc = NULL;
	pMMS_Slide	slide =  NULL;
	MMS_TRACE_FUNCTION("MMS_Menu_New_listmenu_cb"); 
	if(mms->editor)
	{
		edoc =  mms->editor->eDoc;
		if(edoc)
	    	slide = edoc->slide_cur;		
	}

    switch( ListData->Reason )
    {
	case LISTS_REASON_OK:
    case LISTS_REASON_SELECT:
        iMenuItemIndex = ListData->ListPosition;
		if(MMS_Menu_New_Edit_Title   == iMenuItemIndex)
		{
			char *strItem = (char*)editor_get_mmstitle();
			memset(frameData.title, 0, sizeof(frameData.title));
			if(strItem && strItem[0]!='\0')
				wstrcpy(frameData.title , strItem );
			MMS_Menu_New_Edit_start(win, iMenuItemIndex); 
		}
		else if(MMS_Menu_New_Edit_Text == iMenuItemIndex)
		{
			char *strItem = (char*)editor_get_textstring();
			memset(frameData.text, 0, sizeof(frameData.text));
			if(strItem && strItem[0] != '\0')
				wstrcpy(frameData.text, strItem);
			MMS_Menu_New_Edit_start(win, iMenuItemIndex); 
		}			
		else if(MMS_Menu_New_List_Image == iMenuItemIndex)
		{
			memset(frameData.imageFileName, 0, sizeof(frameData.imageFileName));
			MMS_Menu_New_List_start(win, iMenuItemIndex);
		}
		else 
		{
			memset(frameData.audioFileName, 0, sizeof(frameData.audioFileName));
			MMS_Menu_New_List_start(win, iMenuItemIndex);
		}
        break;
		
    case LISTS_REASON_BACK: /* back to previous menu */
		if(slide)
		{
			if(slide->image_flag && slide->audio_type)
				MMS_New_List_Right_start(win,&MMS_NEW_EDIT_OPTAttr11);
			else if(slide->image_flag)
                MMS_New_List_Right_start(win,&MMS_NEW_EDIT_OPTAttr10);
			else if(slide->audio_type)
		    	MMS_New_List_Right_start(win,&MMS_NEW_EDIT_OPTAttr01);
			else
		     	MMS_New_List_Right_start(win,&MMS_NEW_EDIT_OPTAttr00);
		}
		break;

	case LISTS_REASON_HANGUP:
		if(mms->editor)
		{
			editor_on_destroy();
			mms->editor = NULL;
		}
		/*
		if(mms->manager)
		{
			MMS_Codec_Destory();
			manager_on_destroy();
			mms->manager  = NULL;
		}*/
		iMenuItemIndex = 0;
		break;
		
    default:
        break;
    }
    return;
}

void  MMS_Menu_New_destroy (T_MFW_HND window)
{
	T_MFW_WIN          * win_data;
    T_MMS_MENU_NEW     * data;
    USHORT i;
		
	MMS_TRACE_FUNCTION("MMS_Menu_New_destroy"); 
    if( window )
    {
        win_data = ((T_MFW_HDR *)window)->data;
        data = (T_MMS_MENU_NEW *)win_data->user;
		
        if( data )
        {
            win_delete (data->win);
			MMS_Set_MMSNew_WHnd( NULL );
#if 0
            FREE_MEMORY( (void *)(data->list_menu_data.List[0].str), 2*MMS_NEW_ITEMLEN_MAX[0] + wstrlen(MmiRsrcGetText(TxtNewMMSTitle)) +3);
			FREE_MEMORY( (void *)(data->list_menu_data.List[1].str), 2*MMS_NEW_ITEMLEN_MAX[1] + wstrlen(MmiRsrcGetText(TxtNewMMSPicture)) +3);
			FREE_MEMORY( (void *)(data->list_menu_data.List[2].str), 2*MMS_NEW_ITEMLEN_MAX[2] + wstrlen(MmiRsrcGetText(TxtNewMMSMusic)) +3);
            FREE_MEMORY( (void *)(data->list_menu_data.List[3].str), 2*MMS_NEW_ITEMLEN_MAX[3] + wstrlen(MmiRsrcGetText(TxtNewMMSText)) +3);
#else
		    for( i = 0; i < MMS_Menu_New_Listmenu_Num; i++ )
                 FREE_MEMORY( (void *)(data->list_menu_data.List[i].str), data->iItemLen[i]);
#endif
            FREE_MEMORY ((void *)data->list_menu_data.List, MMS_Menu_New_Listmenu_Num* sizeof (MfwMnuItem)); 
            FREE_MEMORY ((void *)data, sizeof (T_MMS_MENU_NEW));
        }
        else
        {
            MMS_TRACE_EVENT (("MMS_Menu_New_destroy() called twice"));
        }
		
    }
}

/*********************************************************************/
/*                    ͼƬѡ񴰿                             */
/*********************************************************************/
T_MFW_HND MMS_Menu_New_List_start(T_MFW_HND parent, int  edtID)
{
	T_MFW_HND win;
    win = MMS_Menu_New_List_create(parent);
	MMS_TRACE_FUNCTION("MMS_Menu_New_List_start"); 
    if( win NEQ NULL )
    {
		SEND_EVENT (win, E_INIT, edtID, NULL);
    }
    return win;
}

T_MFW_HND  MMS_Menu_New_List_create(MfwHnd parent_window)
{
	T_MMS_MENU_NEW_LIST * data = (T_MMS_MENU_NEW_LIST *)ALLOC_MEMORY (sizeof (T_MMS_MENU_NEW_LIST));
    T_MFW_WIN  * win;
	MMS_TRACE_FUNCTION("MMS_Menu_New_List_create"); 
    data->win =win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        return NULL;
    }
	MMS_Set_MMSImageMusic_WHnd(data->win);//Added by xie 04-07-15
    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Menu_New_List_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
	
    winShow(data->win);
    return data->win;
}

void MMS_Menu_New_List_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter)
{
	extern MMS_U8	ECC_MidiPlay(MMS_S8 *filename, MMS_U8 loop);
	extern MMS_U8		ECC_MidiStop(MMS_S8 *filename);
	
	T_MFW_WIN         * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_MENU_NEW_LIST    * data = (T_MMS_MENU_NEW_LIST *)win_data->user;
    T_MFW_HND         * parent=data->parent;
	
	MMS_TRACE_FUNCTION("MMS_Menu_New_List_dialog"); 
    switch( event )
    {
    case E_INIT:
		/* initialization of the dialog data */
		data->list_menu_data.ListPosition   = iListMenuItemIndex+1;/* True cursor position in list menu. */
		data->list_menu_data.CursorPosition = iListMenuItemIndex;/* Cursor position in list snapshot.  */
		data->list_menu_data.Font           = 0;
		data->list_menu_data.LeftSoftKey    = (value == 1?TxtMMSPreview:TxtSoftSelect);
		data->list_menu_data.RightSoftKey   = TxtSoftBack;
		data->list_menu_data.KeyEvents      = KEY_RIGHT|KEY_LEFT |KEY_OK | KEY_MNUUP | KEY_MNUDOWN|KEY_HUP;
		data->list_menu_data.Reason         = 0;
		data->list_menu_data.Strings        = TRUE; 
		data->list_menu_data.Attr           = &MMS_Menu_New_Attrib;
		data->list_menu_data.autoDestroy    = TRUE;

		data->ListID=value;
	
		MMS_Menu_New_List_listmenu_create(data);
		if(2 == data->ListID)
		{
			char *pTemp = (char*)data->list_menu_data.List[iListMenuItemIndex].str;
			wstrcpy(frameData.audioFileName,MMS_MUSIC_FILEPATH);
			wstrcat(frameData.audioFileName,"/");
			wstrcat(frameData.audioFileName,pTemp);
			MMS_TRACE_EVENT(("the audioFilename is%s",frameData.audioFileName));
			rvf_delay(10);
			if( MMS_File_Type(pTemp,MMS_TYPE_MMF) || MMS_File_Type(pTemp,MMS_TYPE_MIDI))
			{
				ECC_MidiPlay(frameData.audioFileName,1);
			}
		}	
		break;

	case E_RETURN: 
    case E_EXIT: 
    case E_BACK:  
		MMS_Menu_New_List_destroy(data->win);
		SEND_EVENT (parent, event, 0, NULL); /* forward event to parent */
        break;

    default:
        return;
    }
}

void MMS_Menu_New_List_listmenu_create(T_MMS_MENU_NEW_LIST *data)
{ 
#ifdef  _INNOVATION_EMULATOR_
	WIN32_FIND_DATA FileData; 
	HANDLE hSearch; 
	BOOL fFinished = FALSE; 
	BOOL isDirectory;
	int nfiles = 0;
	int i = 0;
	T_MFW_HND         * parent=data->parent;

	char filename[256];	
	if(parent)
	GetCurrentDirectoryA(sizeof(filename),filename);
	
	if(data->ListID == 1)
    	strcat(filename,"\\filesystem\\mms\\imageFiles\\*.*");	
	else if(data->ListID == 2)
		strcat(filename,"\\filesystem\\mms\\musicFiles\\*.*");

	hSearch = FindFirstFileA(filename, &FileData); 
	if (hSearch == INVALID_HANDLE_VALUE) 
	{ 
		fFinished = TRUE;
	}
	
	while (!fFinished) 
	{
		if( (FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0x00)
		{
			if(FileData.cFileName[0] != 0)
			{
				nfiles ++;
			}
		}
		
		if (!FindNextFileA(hSearch, &FileData)) 
		{
			fFinished = TRUE; 
		}
	}	
	FindClose(hSearch );

	mediaFileNumber = nfiles;
	if(nfiles  ==  0)
	{
		T_DISPLAY_DATA display_info;		  
		dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		display_info.Time         = THREE_SECS;
		display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR|KEY_HUP;
		display_info.TextId2      = TxtMMSNoImage;
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_FAILURE;
		info_dialog (data->win, &display_info); 
		SEND_EVENT (data->win, E_BACK, 0, NULL); 
		return;
	}

    fFinished = FALSE;
	hSearch = FindFirstFileA(filename, &FileData); 
	if (hSearch == INVALID_HANDLE_VALUE) 
	{ 
		fFinished = TRUE;
	}
	data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtNewMMSPicture);
	data->list_menu_data.List = (MfwMnuItem *)ALLOC_MEMORY (nfiles * sizeof (MfwMnuItem));
	while (!fFinished) 
	{
		if( (FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0x00)
		{
			if(FileData.cFileName[0] != 0)
			{
				data->list_menu_data.List[i].icon = (MfwIcnAttr*)&colist;   ///textlistIcon;
				data->list_menu_data.List[i].exta = 0;
				data->list_menu_data.List[i].edit = 0;
				data->list_menu_data.List[i].menu = 0;
				data->list_menu_data.List[i].func = 0; 
				data->list_menu_data.List[i].flagFunc = item_flag_none;
				
				data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( MMS_IMAGE_NUM_LENGTH);
				wstrcpy(data->list_menu_data.List[i].str ,(char *)FileData.cFileName);
				i++;
			}
		}
		
		if (!FindNextFileA(hSearch, &FileData)) 
		{
			fFinished = TRUE; 
		}
	}
	FindClose(hSearch );	
	mediaFileNumber = nfiles;
	data->list_menu_data.SnapshotSize   = nfiles; 
	data->list_menu_data.ListLength = nfiles; 
	data->list_menu_data.autoDestroy = TRUE;
	listDisplayListMenu(data->win, &data->list_menu_data, (ListCbFunc)MMS_Menu_New_List_listmenu_cb,0);

#else
    int i = 0;
 	T_FFS_DIR sDir;
	MMS_S8 filename[64];
 	int iFileNum =0;
    T_MFW_HND         * parent=data->parent;
    MMS_TRACE_FUNCTION("MMS_Menu_New_List_listmenu_create"); 
	data->list_menu_data.ListMenuFlag=1;//for display the title
	if(data->ListID == 1)
	{ 
	  iFileNum = ffs_opendir(MMS_IMAGE_FILEPATH, &sDir);
	  
	  if((mediaFileNumber=iFileNum) <= 0)
          mediaFileNumber = 0;
	  
	  if(iFileNum  ==  0)
	  {
	    T_DISPLAY_DATA display_info;		  
		dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		display_info.Time         = THREE_SECS;
		display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR|KEY_HUP;
		display_info.TextId2      = TxtMMSNoImage;
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_FAILURE;
		info_dialog (data->win, &display_info); 
		SEND_EVENT (data->win, E_BACK, 0, NULL); 
		return;
	  }
	      
	  data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtNewMMSPicture);
	}
	else if(data->ListID == 2)
	{
	   iFileNum = ffs_opendir( MMS_MUSIC_FILEPATH, &sDir);

	   if((mediaFileNumber=iFileNum) <= 0)
          mediaFileNumber = 0;
	   
	   if(iFileNum  ==  0)
	   {
		   T_DISPLAY_DATA display_info;		  
		   dialog_info_init(&display_info);
		   display_info.RightSoftKey = TxtSoftBack;
		   display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		   display_info.Time         = THREE_SECS;
		   display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR|KEY_HUP;
		   display_info.TextId2      = TxtMMSNoMusic;
		   display_info.Identifier   = DIALOGS_REASON_NULL;
		   display_info.iconindex	  = REMIND_FAILURE;
		   info_dialog (data->win, &display_info); 
		   SEND_EVENT (data->win, E_BACK, 0, NULL); 
		   return;
	   }
	   data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtNewMMSMusic);	
    }

    data->list_menu_data.List = (MfwMnuItem *)ALLOC_MEMORY (iFileNum * sizeof (MfwMnuItem));
    while((ffs_readdir(&sDir, filename, sizeof(filename))) > 0 )
	{
         data->list_menu_data.List[i].icon = (MfwIcnAttr*)&colist;   ///textlistIcon;
         data->list_menu_data.List[i].exta = 0;
         data->list_menu_data.List[i].edit = 0;
         data->list_menu_data.List[i].menu = 0;
         data->list_menu_data.List[i].func = 0; 
         data->list_menu_data.List[i].flagFunc = item_flag_none;
 
 		data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( MMS_IMAGE_NUM_LENGTH);	
        wstrcpy(data->list_menu_data.List[i].str ,(char *) filename);
		i++;
 	}

	 data->list_menu_data.SnapshotSize   = iFileNum; /* Number of list entries to view. */
     data->list_menu_data.ListLength = iFileNum; 
     data->list_menu_data.autoDestroy = TRUE;
     listDisplayListMenu(data->win, &data->list_menu_data, (ListCbFunc)MMS_Menu_New_List_listmenu_cb,0);
#endif
}

void MMS_Menu_New_List_listmenu_cb (T_MFW_HND * win, ListMenuData * ListData)
{
/*
#ifdef  _INNOVATION_EMULATOR_
	T_MFW_WIN         * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_MENU_NEW_LIST    * data   = (T_MMS_MENU_NEW_LIST *)win_data->user;
    T_MFW_WIN         * parent= data->parent;
	switch( ListData->Reason )
	{
	case LISTS_REASON_OK:
	case LISTS_REASON_SELECT:
		iListMenuItemIndex=ListData->ListPosition;
		if(1==data->ListID) //ѡͼƬ
		{
			wstrcpy(frameData.imageFileName,"/mms/imagefiles/");
			wstrcat(frameData.imageFileName,(char*)data->list_menu_data.List[iListMenuItemIndex].str);
			MMS_TRACE_EVENT(("the imageFilename is%s",frameData.imageFileName));
			rvf_delay(10);
			MMS_strstr(frameData.imageFileName, ".jpg");
            MMS_strstr(frameData.imageFileName, ".JPG");
			MMS_strstr(frameData.imageFileName, ".GIG");
			MMS_strstr(frameData.imageFileName, ".gif");
			
			editor_image_new(frameData.imageFileName, MMS_TYPE_JPEG);//MMS_TYPE_GIF
			MMS_Menu_New_List_destroy(data->win);
			SEND_EVENT (parent, E_BACK, 0, NULL);
		}
		else if(2 == data->ListID)
		{
			wstrcpy(frameData.audioFileName,"/mms/audiofiles/");
			wstrcat(frameData.audioFileName,(char*)data->list_menu_data.List[iListMenuItemIndex].str);
			MMS_TRACE_EVENT(("the audioFilename is%s",frameData.audioFileName));
			rvf_delay(10);
			editor_audio_new(frameData.audioFileName, MMS_TYPE_MMF);
			MMS_Menu_New_List_destroy(data->win);
			SEND_EVENT (parent, E_BACK, 0, NULL);
		}		
		break;
		
	case LISTS_REASON_BACK: 
		MMS_Menu_New_List_destroy(data->win);
		SEND_EVENT (parent, E_BACK, 0, NULL);
		break;
		
	default:
		break;
	}
	return;

#else*/
    extern MMS_U8	ECC_MidiPlay(MMS_S8 *filename, MMS_U8 loop);
	extern MMS_U8		ECC_MidiStop(MMS_S8 *filename);

	int ret;
    T_MFW_WIN         * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_MENU_NEW_LIST    * data   = (T_MMS_MENU_NEW_LIST *)win_data->user;
    T_MFW_WIN         * parent= data->parent;
	P_MMS mms = getMMS(); 

	MMS_TRACE_FUNCTION("MMS_Menu_New_List_listmenu_cb"); 
	switch( ListData->Reason )
	{
	case LISTS_REASON_OK:
	case LISTS_REASON_SELECT:
		iListMenuItemIndex=ListData->ListPosition;
		if(1==data->ListID) //ѡͼƬ
		{

			char *pTemp = (char*)data->list_menu_data.List[iListMenuItemIndex].str;
			wstrcpy(frameData.imageFileName,MMS_IMAGE_FILEPATH);
			wstrcat(frameData.imageFileName,"/");
			wstrcat(frameData.imageFileName,pTemp);
			MMS_TRACE_EVENT(("the imageFilename is%s",pTemp));
			
#if 0		
			if( MMS_File_Type(pTemp,MMS_TYPE_JPEG) )
			{
				editor_content_del(2);
				editor_image_new(frameData.imageFileName, MMS_TYPE_JPEG);
			}
			else if( MMS_File_Type(pTemp,MMS_TYPE_WBMP) )
			{
				editor_content_del(2);
				editor_image_new(frameData.imageFileName, MMS_TYPE_WBMP);
			}
			else if( MMS_File_Type(pTemp,MMS_TYPE_GIF) )
			{
				editor_content_del(2);
				editor_image_new(frameData.imageFileName, MMS_TYPE_GIF);
			}

			MMS_Menu_New_List_destroy(data->win);
			SEND_EVENT (parent, E_BACK, 0, NULL);
#else
            MMS_Image_Preview_start(data->win) ;
#endif
		}
		else if(2 == data->ListID)
		{
			char *pTemp = (char*)data->list_menu_data.List[iListMenuItemIndex].str;
			wstrcpy(frameData.audioFileName,MMS_MUSIC_FILEPATH);
			wstrcat(frameData.audioFileName,"/");
			wstrcat(frameData.audioFileName,pTemp);
			MMS_TRACE_EVENT(("the audioFilename is%s",frameData.audioFileName));
			
			if( MMS_File_Type(pTemp,MMS_TYPE_MMF) )
			{
			   	ret = editor_audio_new(frameData.audioFileName, MMS_TYPE_MMF);	
			}
			else if( MMS_File_Type(pTemp,MMS_TYPE_MIDI) )
			{
                ret = editor_audio_new(frameData.audioFileName, MMS_TYPE_MIDI);
			}
#if 0
			MMS_Menu_New_List_destroy(data->win);
			SEND_EVENT (parent, E_BACK, 0, NULL);
            if(ret == -1)
			{
				info_screen(NULL, NULL, TxtMMSFileTooBig, NULL, REMIND_FAILURE);
			}
			else if(ret = 0)
			{
				info_screen(NULL,NULL,TxtMMSSystemError, NULL, REMIND_FAILURE);
			}
#else
			if(1 == ret)
			{
				MMS_Menu_New_List_destroy(data->win);
				SEND_EVENT (parent, E_BACK, 0, NULL);
			}
			else if(ret == -1)
			   info_mms_screen(win, MMS_SCREEN_ID_MUSIC_FILETOOBIG);
			else if (ret = 0)
			{
               
			}
#endif
		}		
		break;
    case LISTS_REASON_HANGUP:
		if(2 == data->ListID)    //add by xie 04-07-23
			ECC_MidiStop(frameData.audioFileName);
		if(mms->editor)
		{
			editor_on_destroy();
			mms->editor = NULL;
		}
		/*
		if(mms->manager)
		{
			MMS_Codec_Destory();
			manager_on_destroy();
			mms->manager = NULL;
		}*/
		if( returntoidle(0) )
			break;
		break;
		
	case LISTS_REASON_UP:
        iListMenuItemIndex=ListData->ListPosition;
		if(2 == data->ListID)
		{
			char *pTemp = (char*)data->list_menu_data.List[iListMenuItemIndex].str;
			wstrcpy(frameData.audioFileName,MMS_MUSIC_FILEPATH);
			wstrcat(frameData.audioFileName,"/");
			wstrcat(frameData.audioFileName,pTemp);
			MMS_TRACE_EVENT(("the audioFilename is%s",frameData.audioFileName));
			rvf_delay(10);
			if( MMS_File_Type(pTemp,MMS_TYPE_MMF) || MMS_File_Type(pTemp,MMS_TYPE_MIDI))
			{
			    ECC_MidiPlay(frameData.audioFileName,1);
			}
		}		
		break;

    case LISTS_REASON_DOWN:
		iListMenuItemIndex=ListData->ListPosition;
		if(2 == data->ListID)
		{
			char *pTemp = (char*)data->list_menu_data.List[iListMenuItemIndex].str;
			wstrcpy(frameData.audioFileName,MMS_MUSIC_FILEPATH);
			wstrcat(frameData.audioFileName,"/");
			wstrcat(frameData.audioFileName,pTemp);
			MMS_TRACE_EVENT(("the audioFilename is%s",frameData.audioFileName));
			rvf_delay(10);
			if( MMS_File_Type(pTemp,MMS_TYPE_MMF) || MMS_File_Type(pTemp,MMS_TYPE_MIDI))
			{
				ECC_MidiPlay(frameData.audioFileName,1);
			}
		}	
		break;
		
	case LISTS_REASON_BACK: 
		if(2 == data->ListID)   //add by xie 04-07-23
		    ECC_MidiStop(frameData.audioFileName);
		MMS_Menu_New_List_destroy(data->win);
		SEND_EVENT (parent, E_BACK, 0, NULL);
		break;
		
	default:
		break;
	}
	return;
//#endif    
}

int MMS_FileTooBig_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
	MMS_TRACE_EVENT(("MMS_FileTooBig_dialog_cb()"));
	
    switch( Reason )
    {
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:	
	case INFO_TIMEOUT:       
		if(MMS_SCREEN_ID_MUSIC_FILETOOBIG == Identifier)
		{
			T_MFW_HND    *win = MMS_Get_MMSImageMusic_WHnd();
				
			T_MFW_WIN         * win_data = ((T_MFW_HDR *)win)->data;
			T_MMS_MENU_NEW_LIST    * data   = (T_MMS_MENU_NEW_LIST *)win_data->user;
			T_MFW_WIN         * parent= data->parent;  
			
			MMS_Menu_New_List_destroy(data->win);
			SEND_EVENT (parent, E_BACK, 0, NULL);
		}  
		else if(MMS_SCREEN_ID_IMAGE_FILETOOBIG == Identifier)
		{
			T_MFW_WIN  * win_data = ((T_MFW_HDR *)gHndMMSImagePreview)->data;
			T_MMS_IMAGE_PREVIEW      * data = (T_MMS_IMAGE_PREVIEW *)win_data->user;
			T_MFW_HND  *parent  = data->parent;
			
			MMS_Image_Preview_destroy(data->win);
			SEND_EVENT (parent, E_BACK, 0, NULL);
		}
		break;
		
    default:
        return MFW_EVENT_REJECTED;
    }
}

void  MMS_Menu_New_List_destroy (T_MFW_HND window)
{
	T_MFW_WIN          * win_data;
    T_MMS_MENU_NEW_LIST     * data;
    USHORT i;
	MMS_TRACE_FUNCTION("MMS_Menu_New_List_destroy"); 	
    if( window )
    {
        win_data = ((T_MFW_HDR *)window)->data;
        data = (T_MMS_MENU_NEW_LIST *)win_data->user;
		
        if( data )
        {
            win_delete (data->win);
			data->win = NULL;
			MMS_Set_MMSImageMusic_WHnd(NULL);//Added by xie 04-07-15

            for( i = 0; i < mediaFileNumber; i++ )
                FREE_MEMORY( (void *)(data->list_menu_data.List[i].str), MMS_IMAGE_NUM_LENGTH);
            FREE_MEMORY ((void *)data->list_menu_data.List, mediaFileNumber* sizeof (MfwMnuItem)); 
            FREE_MEMORY ((void *)data, sizeof (T_MMS_MENU_NEW_LIST));
			iListMenuItemIndex = 0;
			mediaFileNumber = 0;
        }
        else
        {
            TRACE_EVENT ("MMS_Menu_New_List_destroy called twice");
        }
    }
}

/**********************************************************************/
/*                           ͼƬԤ                             */
/**********************************************************************/

void MMS_Menu_New_Pic_ShowAffirmWin (T_MFW_HND win,int picID)
{
	T_MFW_WIN              * win_data;
    T_MMS_MENU_NEW_LIST_PIC     * data;
	T_DISPLAY_DATA   display_info;
	MMS_TRACE_FUNCTION("MMS_Menu_New_Pic_ShowAffirmWin"); 	
    if(win)
    {
        win_data = ((T_MFW_HDR *)win)->data;
        data = (T_MMS_MENU_NEW_LIST_PIC *)win_data->user;
   		
		dialog_info_init(&display_info);//gdy add
		display_info.LeftSoftKey  = TxtAdd;
		display_info.RightSoftKey = TxtSoftBack;
	//	display_info.TextId2       = TxtCancelAffirm;//TxtCFCancelAffirm;
		display_info.TextId      = '\0';
		display_info.TextString   = '\0';
		display_info.TextString2   = '\0';
		display_info.Time         = FOREVER;
		display_info.iconindex=REMIND_WAP;  
		display_info.Callback     = (T_VOID_FUNC)MMS_Menu_New_Pic_cb;
		display_info.KeyEvents    = KEY_HUP | KEY_LEFT | KEY_RIGHT;

		data->info_win=info_dialog(data->win, &display_info);
	}

}       

static void MMS_Menu_New_Pic_cb(T_MFW_HND win,USHORT identifier, UBYTE reason)
{
	T_MFW_WIN              * win_data=((T_MFW_HDR *)win)->data;
    T_MMS_MENU_NEW_LIST_PIC     * data=(T_MMS_MENU_NEW_LIST_PIC *)win_data->user;
	T_MFW_HND              * parent=data->parent;
    MMS_TRACE_FUNCTION("MMS_Menu_New_Pic_cb"); 
	switch(reason)
	{
		case INFO_KCD_LEFT:
			win_delete (data->info_win);
			SEND_EVENT (win, E_BACK, 0, NULL);
			break;
		case INFO_KCD_RIGHT:
			win_delete (data->info_win);
			SEND_EVENT (win, E_ABORT, 0, NULL);
			break;
		default:
			break;
	}

} 

/**********************************************************************/
/*                       ʼд                       */
/**********************************************************************/
T_MFW_HND MMS_Menu_New_Edit_start(T_MFW_HND parent, int  edtID)
{
    T_MFW_HND win;
    win = MMS_Menu_New_Edit_create(parent);
    MMS_TRACE_FUNCTION("MMS_Menu_New_Edit_start"); 
    if( win NEQ NULL )
    {
		SEND_EVENT (win, E_INIT, edtID, NULL);
    }
    return win;
}


static T_MFW_HND MMS_Menu_New_Edit_create(MfwHnd parent_window)
{	
	T_MMS_MENU_NEW_EDITOR  * data = (T_MMS_MENU_NEW_EDITOR *)ALLOC_MEMORY (sizeof (T_MMS_MENU_NEW_EDITOR));
	T_MFW_WIN  * win;
	MMS_TRACE_FUNCTION("MMS_Menu_New_Edit_create");    	   
	data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
	if( data->win EQ NULL )
	{
	   return NULL;
	}
	   
	data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Menu_New_Edit_dialog;
	data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
	win->user                = (void *)data;
	data->parent             = parent_window;
	   
    winShow(data->win);
	return data->win;
}

static void MMS_Menu_New_Edit_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter)
{  
    T_MFW_WIN                  * win_data = ((T_MFW_HDR *) win)->data;
	T_MMS_MENU_NEW_EDITOR      * data = (T_MMS_MENU_NEW_EDITOR *)win_data->user;
    T_MFW_HDR                  * parent      =  data->parent;
    MMS_TRACE_FUNCTION("MMS_Menu_New_Edit_dialog");  
	switch(event)
	{
	case E_INIT:
		{			
			switch(value)
			{
			case MMS_Menu_New_Edit_Title:  //
				data->edtID = MMS_Menu_New_Edit_Title;
				MMS_Menu_New_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtNewMMSTitle,(char *)frameData.title,MMS_NEW_ITEMLEN_MAX[0],edtCurBar1);
				data->editor_info.mode                 = TEXTINPUT_MODE;     
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Menu_New_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = PINYIN_INPUT_MODE;  				
//				data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = text_input(win, &(data->editor_info));//text_input(win, &editor_data);
				break;
			
			case MMS_Menu_New_Edit_Text:   //ʼ
				data->edtID = MMS_Menu_New_Edit_Text;
				MMS_Menu_New_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtNewMMSText,(char *)frameData.text,MMS_NEW_ITEMLEN_MAX[3],edtCurBar1);
				data->editor_info.mode                 = TEXTINPUT_MODE;  
				//data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB )MMS_Menu_New_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = PINYIN_INPUT_MODE;  				
//				data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = text_input(win, &(data->editor_info));
				break;
			default:
				return;
			}
		}
		break;
		
	case E_ABORT:
	case E_EXIT: 
		MMS_Menu_New_Edit_destroy(data->win);
        SEND_EVENT (parent, event, 0, NULL); /* forward event to parent */
		break;
	default:
		return;
	}
	return;
}

static void MMS_Menu_New_Edit_edit_cb(T_MFW_HND win, USHORT Identifier, SHORT reason)
{
	T_MFW_WIN           * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_MENU_NEW_EDITOR  * data     = (T_MMS_MENU_NEW_EDITOR *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
    P_MMS mms = getMMS();
    MMS_TRACE_FUNCTION("MMS_Menu_New_Edit_edit_cb");  
	switch( reason )
    {
    case INFO_KCD_ALTERNATELEFT:
    case INFO_KCD_LEFT:
	    MMS_Menu_New_Edit_destroy(data->win);
	    SEND_EVENT (parent, E_EXIT, 0, NULL);
	    break;

    case INFO_KCD_RIGHT:
		SEND_EVENT (win, E_EXIT, 0, NULL);
//		SEND_EVENT (parent, E_EXIT, 0, NULL);
        break;
	case INFO_KCD_HUP:
		if(mms->editor)
		{
			editor_on_destroy();
			mms->editor = NULL;
		}
/*
        if(mms->manager)
		{
			MMS_Codec_Destory();
			manager_on_destroy();
			mms->manager = NULL;
		}*/
/*
		
		if(mms->player)
		{
			player_destrory();
			mms->player = NULL;
		}*/

		iMenuItemIndex = 0;
		iListMenuItemIndex =0;
		returntoidle(0);
		break;

    default:
        break;
    }
	return;
}

static void MMS_Menu_New_Edit_destroy(MfwHnd own_window)
{   
    T_MFW_WIN * win_data;
    T_MMS_MENU_NEW_EDITOR    * data = NULL; 
	P_MMS mms = getMMS();
    pMessage pMsg = NULL;
	MMS_TRACE_FUNCTION("MMS_Menu_New_Edit_destroy");  
    if( own_window )
    {
		win_data = ((T_MFW_HDR *)own_window)->data;
		if( win_data != NULL )
			data = (T_MMS_MENU_NEW_EDITOR *)win_data->user;
		
		if( data->edtID == MMS_Menu_New_Edit_Title )
		{
		   if(mms && mms->editor)
			   pMsg = editor_get_msg();
           msg_set_title(pMsg, (char*)(frameData.title) );
		}
		else if( data->edtID == MMS_Menu_New_Edit_Text)
		{
           editor_text_new( (char*)(frameData.text) );
		}
      		
		if (data)
		{
			if(data->editor != 0)
			{
				text_input_destroy(data->editor);
				data->editor = NULL;
			}		
			win_delete (data->win);
		    /*     
		     * MMS_FREE Memory
		     */
		    FREE_MEMORY ((void *)data, sizeof (T_MMS_MENU_NEW_EDITOR));
		}
	    else
		{
		    MMS_TRACE_EVENT((" "));
		}
	}   
}

static void MMS_Menu_New_Edit_LoadEditDefault(T_EDITOR_DATA *editor_data)
{	
	MMS_TRACE_FUNCTION("MMS_Menu_New_Edit_LoadEditDefault");  
	editor_attr_init(&editor_data->editor_attr, NULL, edtCurNone, 0, 0, 0);
	editor_data->hide				= FALSE;
	editor_data->min_enter			= 1;  
	editor_data->LeftSoftKey		= TxtSoftSelect;
	editor_data->RightSoftKey		= TxtSoftBack;
	editor_data->AlternateLeftSoftKey   = TxtNull;
	editor_data->TextId				= '\0';  
	editor_data->Identifier			=  0; 
	editor_data->TextString			= NULL;  
	editor_data->timeout			= FOREVER; 
	editor_data->mode                = ALPHA_MODE;
	editor_data->Callback			= NULL;
	editor_data->destroyEditor		= TRUE ; 
}


/**********************************************************************/
/*                          ʾ˵                        */
/**********************************************************************/

static T_MFW_HND MMS_New_List_Right_start(MfwHnd parent_window , MfwMnuAttr *menuAttr)
{
    T_MFW_HND win;	
	MMS_TRACE_FUNCTION("MMS_New_List_Right_start");  
    win = MMS_New_List_Right_create (parent_window);	
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, NULL, (void *)menuAttr);
    }
    return win;
}

static T_MFW_HND MMS_New_List_Right_create(T_MFW_HND parent_window)
{
	T_MMS_NEW_LIST_RIGHT      * data = (T_MMS_NEW_LIST_RIGHT *)ALLOC_MEMORY (sizeof (T_MMS_NEW_LIST_RIGHT));
    T_MFW_WIN  * win;
	MMS_TRACE_FUNCTION("MMS_New_List_Right_create");  
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)MMS_New_List_Right_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
  	
    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_New_List_Right_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    return data->win;
}

static void MMS_New_List_Right_destroy(T_MFW_HND win)
{
    T_MFW_WIN              * win_data;
    T_MMS_NEW_LIST_RIGHT     * data;

	
	MMS_TRACE_FUNCTION("MMS_New_List_Right_destroy");  
    if(win)
    {
        win_data = ((T_MFW_HDR *)win)->data;
        data = (T_MMS_NEW_LIST_RIGHT *)win_data->user;

        if( data )
        {
            win_delete (data->win);
			MMS_TRACE_EVENT(("before MMS_New_List_Right_destroy"));
            FREE_MEMORY ((void *)data, sizeof (T_MMS_NEW_LIST_RIGHT));
			MMS_TRACE_EVENT(("after MMS_New_List_Right_destroy "));
        }
        else
        {
            MMS_TRACE_EVENT((" "));
        }
    }
}

static void MMS_New_List_Right_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_NEW_LIST_RIGHT  * data     = (T_MMS_NEW_LIST_RIGHT *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
  
    char * title;
	MMS_TRACE_FUNCTION("MMS_New_List_Right_dialog");  
    switch( event )
    {
    case E_INIT:
        /* initialization of administrative data */       
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)MMS_New_List_Right_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)MMS_New_List_Right_kbd_cb);
        title = (char *) MmiRsrcGetText(TxtSoftOptions);  // get the editor title text

        data->menu = mnuListCreate(data->win,(MfwMnuAttr*)parameter, E_MNU_ESCAPE, (MfwCb)MMS_New_List_Right_mnu_cb,title);
        mnuLang(data->menu,mainMmiLng);
        /* put the (new) dialog window on top of the window stack */
        mnuUnhide(data->menu);
        winShow(win);
        break;
		
	case E_BACK:
		MMS_New_List_Right_destroy(data->win);
    	SEND_EVENT (parent, E_BACK, 0, NULL);
		break;

	case E_ABORT:
        MMS_New_List_Right_destroy(data->win);
		SEND_EVENT (parent, E_ABORT, 0, NULL);
		break;
		
    default:
        return;
    }
}

static int MMS_New_List_Right_kbd_cb(MfwEvt e, MfwKbd *k)
{
    T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT      * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user;
	P_MMS mms = getMMS();
    MMS_TRACE_FUNCTION("MMS_New_List_Right_kbd_cb");  
    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
			if(mms->editor)
			{
				editor_on_destroy();
				mms->editor = NULL;
			}
/*
			if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/
			iMenuItemIndex = 0;
            returntoidle(0);
            break;
        case KCD_RIGHT:
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
            mnuUp(data->menu);
            break;
        case KCD_MNUDOWN: /* highlight next entry */
            mnuDown(data->menu);
            break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:
            mnuSelect(data->menu);
            break;
        case KCD_HUP: /* back to previous menu */
			if(mms->editor)
			{
				editor_on_destroy();
				mms->editor = NULL;
			}
			/*
			if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/
			iMenuItemIndex = 0;
            if( returntoidle(0) )
               break;
			break;
        case KCD_RIGHT: /* back to previous menu */
            mnuEscape(data->menu);
            break;
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;//when change to MFW_EVENT_REJECTED,deleting string will lead to collapsed.
}


static int MMS_New_List_Right_mnu_cb ( MfwEvt e, MfwMnu *m )
{ 
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT      * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user;
	T_MFW_HND              * parent=data->parent;
	MMS_TRACE_FUNCTION("MMS_New_List_Right_mnu_cb");  
    switch( e )
    {
    case E_MNU_ESCAPE: /* back to previous menu */
        MMS_New_List_Right_destroy(data->win);
		SEND_EVENT (parent, E_BACK, 0, NULL);
        break;

    default: /* in mnuCreate() only E_MNU_ESCAPE has been enabled! */
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

static int MMS_New_List_Right_win_cb(MfwEvt e, MfwWin *w)
{
	MMS_TRACE_FUNCTION("MMS_New_List_Right_win_cb");  
    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        dspl_ClearAll();
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

static int MMS_NEW_List_Right_PageDown(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	T_MFW_WIN * win_data= ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT    * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user; 
	T_MFW_HND  *parent=data->parent;
	int ret;
	P_MMS  mms = getMMS();
	pMMS_Slide   pSlide = NULL;
	
	MMS_TRACE_FUNCTION("MMS_NEW_List_Right_PageDown");  
    if( mms->editor )
	{
		pSlide = mms->editor->eDoc->slide_cur->next;
		if( pSlide == NULL)
		{
			T_DISPLAY_DATA display_info;	
			
			dialog_info_init(&display_info);//gdy add
			display_info.RightSoftKey = TxtSoftBack;
			display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
			display_info.Time         = THREE_SECS;//zy 12/22/2002 change 3sec to 1sec
			display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
			display_info.TextId2      = TxtMMSErrorLast;
			//	display_info.Callback     = MMS_NEW_EDIT_OPTExit_callback;
			display_info.Identifier   = DIALOGS_REASON_NULL;
			display_info.iconindex	  = REMIND_FAILURE;
			data->info_win=info_dialog (win, &display_info); //Ի
			return MFW_EVENT_REJECTED;
		}
		else
		{
			ret = editor_slide_next();
			if(ret == 0)
			{
				MMS_TRACE_EVENT(("editor_slide_next() error in MMS_NEW_List_Right_PageDown()"));//
			}
			MMS_Refresh_FrameData(REFRESH);

			MMS_New_List_Right_destroy(data->win);
			iMenuItemIndex = 0;
			SEND_EVENT (parent, E_BACK, 0, NULL);
			return MFW_EVENT_CONSUMED;
		}
	}
	else
        return MFW_EVENT_REJECTED;
}

static int MMS_NEW_List_Right_PageUp(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	T_MFW_WIN * win_data= ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT    * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user; 
	T_MFW_HND  *parent=data->parent;
	int ret;
	P_MMS  mms = getMMS();
	pMMS_Slide   pSlide1,pSlide2;
	
	MMS_TRACE_FUNCTION("MMS_NEW_List_Right_PageUp");  
    if( mms->editor )
	{
		pSlide1 = mms->editor->eDoc->slide_cur;
		pSlide2 = mms->editor->eDoc->slide_root;
		if( pSlide1 == pSlide2 )
		{
			T_DISPLAY_DATA display_info;	
			
			dialog_info_init(&display_info);
			display_info.RightSoftKey = TxtSoftBack;
			display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
			display_info.Time         = THREE_SECS;
			display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
			display_info.TextId2      = TxtMMSErrorPre;
			display_info.Identifier   = DIALOGS_REASON_NULL;
			display_info.iconindex	  = REMIND_FAILURE;
			info_dialog (win, &display_info); //Ի
			return MFW_EVENT_REJECTED;
		}
		else
		{
			ret = editor_slide_last();
			MMS_Refresh_FrameData(REFRESH);
			
			if(ret == 0)
			{
				MMS_TRACE_EVENT(("editor_slide_last() error in MMS_NEW_List_Right_PageDown()"));//
			}
			MMS_New_List_Right_destroy(data->win);
			iMenuItemIndex = 0;
			SEND_EVENT (parent, E_BACK, 0, NULL);
			return MFW_EVENT_CONSUMED;
		}
	}
	else
		return MFW_EVENT_REJECTED;
}

static int MMS_NEW_List_Right_AddPage(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	T_MFW_WIN * win_data= ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT    * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user; 
	T_MFW_HND  *parent=data->parent;
	int ret;

	MMS_TRACE_FUNCTION("MMS_NEW_List_Right_AddPage");  
	if(FRAME_NUMBER_MAX == editor_get_slidecount())
	{
		T_DISPLAY_DATA display_info;	

    	dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		display_info.Time         = THREE_SECS;
		display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
		display_info.TextId2      = TxtMMSErrorLarge;
		//display_info.Callback     = MMS_NEW_EDIT_OPTExit_callback;
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_FAILURE;
		data->info_win=info_dialog (win, &display_info); //Ի
		return MFW_EVENT_REJECTED;
	}
	else
	{
		ret = editor_slide_add();
		if(ret == 0)
		{
			MMS_TRACE_EVENT(("editor_slide_add() error in MMS_NEW_List_Right_AddPage()"));
		}
        MMS_Refresh_FrameData(CLEAR);

		MMS_New_List_Right_destroy(data->win);
		iMenuItemIndex = 0;
		SEND_EVENT (parent, E_BACK, 0, NULL);
		return MFW_EVENT_CONSUMED;
	}
}

static int MMS_NEW_List_Right_DeletePage(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	T_MFW_WIN * win_data= ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT    * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user; 
	T_MFW_HND  *parent=data->parent;
	int ret; 
	P_MMS mms = getMMS();
	
	MMS_TRACE_FUNCTION("MMS_NEW_List_Right_DeletePage"); 
	if(0 == editor_get_slidecount())
	{
		T_DISPLAY_DATA display_info;	
    
		dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		display_info.LeftSoftKey  = TxtSoftConfirm;
		display_info.Time         = THREE_SECS;
		display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
		display_info.TextId2      = TxtMMSErrorZero;
		
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_FAILURE;
		data->info_win=info_dialog (win, &display_info); 
		return MFW_EVENT_REJECTED;
	}
	else
	{
		ret = editor_slide_del();
		if(ret == 0)
		{
			MMS_TRACE_EVENT(("editor_slide_del() error in MMS_NEW_List_Right_DeletePage()"));//
		}
		
        MMS_Refresh_FrameData(REFRESH);
		
		MMS_New_List_Right_destroy(data->win);
		if(0 == editor_get_slidecount())
		{
			iMenuItemIndex = 0;
			if(mms->editor)    //added by xie 04-07-16
			{
				editor_on_destroy();
				mms->editor = NULL;
			}
			SEND_EVENT (parent, E_ABORT, 0, NULL);  // ɾ֡˵½Ϣ
		}
		else
		{
			SEND_EVENT (parent, E_BACK, 0, NULL);    //˵༭Ϣ
		}
		return MFW_EVENT_CONSUMED;
	}
}


static int MMS_NEW_List_Right_DeleteImage(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	T_MFW_WIN * win_data= ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT    * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user; 
	T_MFW_HND  *parent=data->parent;
	P_MMS  mms = getMMS();

	MMS_TRACE_FUNCTION("MMS_NEW_List_Right_DeleteImage"); 
	if(mms->manager && mms->editor)
	    editor_content_del(2);
	MMS_Refresh_FrameData(REFRESH);	
	MMS_New_List_Right_destroy(data->win);
	SEND_EVENT (parent, E_BACK, 0, NULL);
	return MFW_EVENT_CONSUMED;	
}

static int MMS_NEW_List_Right_DeleteMusic(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	T_MFW_WIN * win_data= ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT    * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user; 
	T_MFW_HND  *parent=data->parent;
	P_MMS  mms = getMMS();
	
	MMS_TRACE_FUNCTION("MMS_NEW_List_Right_DeleteMusic"); 
	if(mms->manager && mms->editor)
		editor_content_del(3);
	MMS_Refresh_FrameData(REFRESH);	
	MMS_New_List_Right_destroy(data->win);
	SEND_EVENT (parent, E_BACK, 0, NULL);
	return MFW_EVENT_CONSUMED;	
}

static int MMS_NEW_List_Right_StoreMsg(MfwMnu* m, MfwMnuItem* i)
{
    int ret;
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT      * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user;
	T_MFW_HND  *parent=data->parent;
	P_MMS  mms = getMMS();
	MMS_TRACE_FUNCTION("MMS_NEW_List_Right_StoreMsg"); 
	ret = editor_save_message();//ɹ10
	MMS_TRACE_EVENT(("MMS_NEW_List_Right_StoreMsg step 1----%d",ret));
//	manager_on_store();
//	return 1;
	if(gCurMMSPos == MMS_SEND_FOLDER)
	{

		storemessagefolder(mms->manager->unsendfolder);

	}
	else if(gCurMMSPos == MMS_NEW || gCurMMSPos== MMS_RECV_FOLDER || gCurMMSPos == MMS_SENT_FOLDER || gCurMMSPos == MMS_DRAFT_FOLDER)
	{
        storemessagefolder(mms->manager->draftfolder);
	}
	
	if( ret == 0)
	{
	    MMS_TRACE_EVENT(("save message error in MMS_NEW_List_Right_StoreMsg"));
		return ret;
	}

	if(mms->editor != NULL)
	{
		ret = editor_on_destroy();//ɹ10
		MMS_TRACE_EVENT(("editor_on_destroy()----%d",ret));
		mms->editor=NULL;
	}

	MMS_TRACE_EVENT(("MMS_NEW_List_Right_StoreMsg step 2----%d",ret));
	
	MMS_New_List_Right_destroy(data->win);
	SEND_EVENT (parent, E_ABORT, 0, NULL);
	return MFW_EVENT_CONSUMED;
}

static int MMS_NEW_List_Right_PreView(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());

	mmsPlayerState =  PREVIEW;
	MMS_TRACE_FUNCTION("MMS_NEW_List_Right_PreView"); 
	
	 MMS_New_Preview_start(win);  
}

static int MMS_NEW_List_Right_Send(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_NEW_List_Right_Send"); 
	MMS_Receiver_List_Refresh(gCurMMSPos, REFRESH);
    MMS_Receiver_List_start( win );

/*

	T_MFW_HND    win  = mfwParent(mfw_header());
	T_MFW_WIN * win_data= ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT    * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user; 
	T_MFW_HND  *parent=data->parent;
	P_MMS  mms = getMMS();
	int ret;

	if('\0' == mms->manager->currentfolder->currentmessage&&
		 '\0' == &&
		 '\0' == &&
		 '\0' == )
	{
		MMS_SHOWDialog(win);
		return MFW_EVENT_REJECTED;
	}
	else
	{

		/ *ÿ⺯* /		
		MMS_SHOWSentDialog(win);		
		ret = editor_save_message();//ɹ10
		if( ret == 0)
		{
			MMS_TRACE_EVENT(("save message error in MMS_NEW_List_Right_Send()"));
		}		
		ret = editor_on_destroy();//ɹ10
		mms->editor=NULL;
        mms_test_send_message();
		return MFW_EVENT_CONSUMED;
	}*/


}

static int MMS_NEW_List_Right_Exit(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_LIST_RIGHT      * data = (T_MMS_NEW_LIST_RIGHT *)win_data->user;
	T_MFW_HND  *parent=data->parent;
    int ret;
	P_MMS mms = getMMS();
    MMS_TRACE_FUNCTION("MMS_NEW_List_Right_Exit"); 
	if(mms->editor)
	{
		ret = editor_on_destroy();//ɹ10
		MMS_TRACE_EVENT(("editor_on_destroy()----%d",ret));
		mms->editor=NULL;
	}
	
	MMS_New_List_Right_destroy(data->win);
	SEND_EVENT (parent, E_ABORT, 0, NULL);
	return MFW_EVENT_CONSUMED;
}

void MMS_Refresh_FrameData(Refresh_Action command)
{
    char *strItem = NULL;
	MMS_TRACE_FUNCTION("MMS_Refresh_FrameData"); 
	if(command == CLEAR)
	{
        memset(frameData.title, 0, sizeof(frameData.title));
		memset(frameData.imageFileName, 0, sizeof(frameData.imageFileName));
		memset(frameData.audioFileName, 0, sizeof(frameData.audioFileName));
		memset(frameData.text, 0, sizeof(frameData.text));
	}
	else if(command == REFRESH)
	{
		memset(frameData.title, 0, sizeof(frameData.title));
		memset(frameData.imageFileName, 0, sizeof(frameData.imageFileName));
		memset(frameData.audioFileName, 0, sizeof(frameData.audioFileName));
		memset(frameData.text, 0, sizeof(frameData.text));

		strItem = (char*)editor_get_mmstitle();
		if(strItem && strItem[0]!='\0')
		   wstrcpy(frameData.title , strItem );

	    strItem = (char*)editor_get_imagefilename();
		if(strItem && strItem[0] != '\0')
		  wstrcpy(frameData.imageFileName , strItem);

		strItem = (char*)editor_get_audiofilename();
		if(strItem && strItem[0] !='\0')
		   wstrcpy(frameData.audioFileName, strItem);
		
		strItem = (char*)editor_get_textstring();
		if(strItem && strItem[0] != '\0')
	    	wstrcpy(frameData.text, strItem);
	}
}

//Ԥ
static T_MFW_HND MMS_New_Preview_start(MfwHnd parent_window)
{
    T_MFW_HND win;	
	MMS_TRACE_FUNCTION("MMS_New_Preview_start"); 
    win = MMS_New_Preview_create (parent_window);	
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, NULL, NULL);
    }
    return win;
}

static T_MFW_HND MMS_New_Preview_create(T_MFW_HND parent_window)
{
   	T_MMS_NEW_PREVIEW      * data = (T_MMS_NEW_PREVIEW *)ALLOC_MEMORY (sizeof (T_MMS_NEW_PREVIEW));
    T_MFW_WIN  * win;

	PlayerInitRetVal playerVal;
	P_MMS mms = getMMS();
	MMS_TRACE_FUNCTION("MMS_New_Preview_create"); 
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)MMS_New_Preview_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
	
    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_New_Preview_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

	//ĳʼ
	if(mms->player == NULL)
	{
#ifdef MMI_MMSTASK_ENABLED
	mmsui_data->temp_win = info_mms_dialog(win);
	mmsui_data->current_win = win;
{
	T_MMI_MMS_PLAYERINITIALIZE_IND  parameter;
	parameter.event = PLAYER_INIT_PREVIEW;
	M_MMI_MMS_PLAYERINITIALIZE_IND(&parameter);
}
#else
		mms->player = player_initialize(PLAYER_INIT_PREVIEW, &playerVal);//PLAYER_INIT_PLAY 	ŵǰĵǰϢ
#endif
	mmsPlayerState = PREVIEW;
	}

#ifndef MMI_MMSTASK_ENABLED
	if(playerVal != Normal)
	{
		MMS_TRACE_EVENT(("player initialize failure in MMS_New_Preview_create"));		
	}
#endif


    return data->win;
}

static void MMS_New_Preview_destroy(T_MFW_HND win)
{
	T_MFW_WIN              * win_data;
    T_MMS_NEW_PREVIEW     * data;
	P_MMS mms = getMMS();
	
	MMS_TRACE_FUNCTION("MMS_New_Preview_destroy"); 
    if(win)
    {
        win_data = ((T_MFW_HDR *)win)->data;
        data = (T_MMS_NEW_PREVIEW *)win_data->user;
		
        if( data )
        {
			kbd_delete(data->kbd);   //added by xie 04-07-15
			kbd_delete(data->kbd_long);
			data->kbd = NULL;
			data->kbd_long = NULL;
			
            win_delete (data->win);
            FREE_MEMORY ((void *)data, sizeof (T_MMS_NEW_PREVIEW));

			if(mms->player)
			{
				player_on_stop();
				player_destrory( PLAYER_INIT_PREVIEW );
				mms->player = NULL;
			}
			return;
        }
        else
        {
            MMS_TRACE_EVENT((" "));
        }
    }
}

static void MMS_New_Preview_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_NEW_PREVIEW  * data     = (T_MMS_NEW_PREVIEW *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
	
    char * title;
	MMS_TRACE_FUNCTION("MMS_New_Preview_dialog"); 
    switch( event )
    {
    case E_INIT:
        /* initialization of administrative data */
		// data->parent_data = parent_data;        
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)MMS_New_Preview_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)MMS_New_Preview_kbd_cb);
        winShow(win);
        break;
    default:
        return;
    }
}

static int MMS_New_Preview_kbd_cb(MfwEvt e, MfwKbd *k)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_NEW_PREVIEW      * data = (T_MMS_NEW_PREVIEW *)win_data->user;
    T_MFW_HND  *parent  = data->parent; 
	P_MMS mms = getMMS();
	int ret;

	pMMS_Slide   pSlide = NULL;
	unsigned char curPage = 0;
	unsigned char pageNum = 0;
	unsigned char curSlide = 0;
	unsigned char slideNum = 0;
	int pageNumMod;
	if( mms->player && mms->player->eDocument)
	{
		pSlide = mms->player->eDocument->slide_cur;
	}
	
	if(pSlide)
	{
		curSlide = (unsigned char)player_get_slideindex();
		slideNum = (unsigned char)player_get_slidecount();
		curPage  = (unsigned char)pSlide->page_no;
		pageNum  = (unsigned char)(pSlide->pagelength/PLAYER_H);
		pageNumMod = pSlide->pagelength%PLAYER_H;
		if(pageNumMod > 0)
			pageNum = pageNum +1;
		else if(pageNumMod < 0)
			pageNum = pageNum -1;
	}
		
	MMS_TRACE_FUNCTION("MMS_New_Preview_kbd_cb"); 
    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
			if(mms->player)
			{
				switch(mmsPlayerState)
				{
				case PLAY:
					player_destrory(PLAYER_INIT_PLAY);
					mms->player = NULL;
					break;
				case PREVIEW:
					player_destrory(PLAYER_INIT_PREVIEW);
					mms->player = NULL;
					break;
				}
			}

			if(mms->editor)
			{
				editor_on_destroy();
				mms->editor = NULL;
			}	
/*
			if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/
			
			iMenuItemIndex = 0;
            returntoidle(0);
            break;
        case KCD_RIGHT: 
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
			if(pageNum > 1 && curPage > 0 && curPage <= pageNum-1)
			{
#ifdef MMI_MMSTASK_ENABLED
{
	T_MMI_MMS_PLAYERONPAGE_IND parameter;
	parameter.event = 0;
	mmsui_data->current_win = win  ;
	M_MMI_MMS_PLAYERONPAGE_IND(&parameter);
}
#else
				player_on_pageup();
#endif
				//				winShow( win );
				MMSDrawScrollBar(curPage, pageNum);
			}
            break;
        case KCD_MNUDOWN: /* highlight next entry */
			if(pageNum > 1 && curPage >= 0 && curPage < pageNum-1)
			{
#ifdef MMI_MMSTASK_ENABLED
{
	T_MMI_MMS_PLAYERONPAGE_IND parameter;
	parameter.event = 1;
	mmsui_data->current_win = win  ;
	M_MMI_MMS_PLAYERONPAGE_IND(&parameter);
}
#else
				player_on_pagedown();
#endif
				MMSDrawScrollBar(curPage+2, pageNum);
				//				winShow( win );
			}
            break;
		case KCD_MNURIGHT:
			if(slideNum >1 && curSlide >= 0 && curSlide < slideNum-1)
			{
				char title[10];
				displaySoftKeys(TxtEdit,TxtSoftBack);
				sprintf(title,"%d/%d",curSlide+2,slideNum);
				drawcolorclarity((SCREEN_SIZE_X- get_StringWidth(title))/2,SCREEN_SIZE_Y-dspl_GetFontHeight()-1,title, 0x000000);
				player_on_stop();
#ifdef MMI_MMSTASK_ENABLED
{
	T_MMI_MMS_PLAYERONPAGE_IND parameter;
	parameter.event = 2;
	mmsui_data->current_win = win  ;
	M_MMI_MMS_PLAYERONPAGE_IND(&parameter);
}
#else
				player_on_pagenext();
#endif
				
				pSlide = mms->player->eDocument->slide_cur;
				curPage  = (unsigned char)pSlide->page_no;
				pageNum  = (unsigned char)(pSlide->pagelength/PLAYER_H);
				pageNumMod = pSlide->pagelength%PLAYER_H;
				if(pageNumMod > 0)
					pageNum = pageNum +1;
				else if(pageNumMod < 0)
					pageNum = pageNum -1;

				MMSDrawScrollBar(curPage+1, pageNum);
				//				winShow( win );
			}
			break;
        case KCD_MNULEFT:
			if(slideNum >1 && curSlide > 0 && curSlide <= slideNum-1)
			{
				char title[10];
				displaySoftKeys(TxtEdit,TxtSoftBack);
				sprintf(title,"%d/%d",curSlide,slideNum);
				drawcolorclarity((SCREEN_SIZE_X- get_StringWidth(title))/2,SCREEN_SIZE_Y-dspl_GetFontHeight()-1,title, 0x000000);
				player_on_stop();
#ifdef MMI_MMSTASK_ENABLED
{
	T_MMI_MMS_PLAYERONPAGE_IND parameter;
	parameter.event = 3;
	mmsui_data->current_win = win  ;
	M_MMI_MMS_PLAYERONPAGE_IND(&parameter);
}
#else
				player_on_pagelast();
#endif

				pSlide = mms->player->eDocument->slide_cur;
				curPage  = (unsigned char)pSlide->page_no;
				pageNum  = (unsigned char)(pSlide->pagelength/PLAYER_H);
				pageNumMod = pSlide->pagelength%PLAYER_H;
				if(pageNumMod > 0)
					pageNum = pageNum +1;
				else if(pageNumMod < 0)
					pageNum = pageNum -1;
				
				MMSDrawScrollBar(curPage+1, pageNum);
				//				winShow( win );
			}
			break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:
			player_on_stop();  //add by xie 04-08-03
			MMS_New_Preview_destroy(data->win);
			SEND_EVENT (parent, E_BACK, 0, NULL);
            break;
        case KCD_HUP: /* back to previous menu */			
			if(mms->player)
			{
				switch(mmsPlayerState)
				{
				case PLAY:
					player_destrory(PLAYER_INIT_PLAY);
					mms->player = NULL;
					break;
				case PREVIEW:
					player_destrory(PLAYER_INIT_PREVIEW);
					mms->player = NULL;
					break;
				}
			}

			if(mms->editor)
			{
				editor_on_destroy();
				mms->editor = NULL;
			}
/*
			if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/
			
			iMenuItemIndex = 0;
            if( returntoidle(0) )
                break;
        case KCD_RIGHT: /* back to previous menu */
			MMS_New_Preview_destroy(data->win);
//			SEND_EVENT (parent, E_BACK, 0, NULL);//why success? by xie
            break;
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;
}

static int MMS_New_Preview_win_cb(MfwEvt e, MfwWin *w)
{
	P_MMS mms = getMMS();
	pMMS_Slide   pSlide;
	
	MMS_TRACE_FUNCTION("MMS_New_Preview_win_cb"); 
    if( mms->editor )
	{
		pSlide = mms->editor->eDoc->slide_cur;
		if(!pSlide )
		{
			return MFW_EVENT_REJECTED;
		}
	}

	switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
#ifdef MMI_MMSTASK_ENABLED 
		if(mms->player)
#endif
		{
			unsigned int oldcolor = dspl_SetBkgColor(0xffffff);
		    char title[10];
			unsigned char curSlide = (unsigned char)editor_get_slideindex();
			unsigned char slideNum = (unsigned char)editor_get_slidecount();
			unsigned char curPage = (unsigned char)pSlide->page_no;
			unsigned char pageNum = (unsigned char)(pSlide->pagelength/PLAYER_H);
			int pageNumMod = pSlide->pagelength%PLAYER_H;
			if(pageNumMod > 0)
				pageNum = pageNum +1;
			else if(pageNumMod < 0)
				pageNum = pageNum -1;

			dspl_ClearAll();
			
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
				menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
				menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
			
			dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(MmiRsrcGetText(TxtMMSPreview)))/2, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtMMSPreview), 0x0);    	  

			
			displaySoftKeys(TxtEdit,TxtSoftBack);			
			sprintf(title,"%d/%d",curSlide+1,slideNum);
			drawcolorclarity((SCREEN_SIZE_X- get_StringWidth(title))/2,SCREEN_SIZE_Y-dspl_GetFontHeight()-1,title, 0x000000);
			
			MMSDrawScrollBar(curPage+1, pageNum);
#ifdef MMI_MMSTASK_ENABLED
			{/*talcon added for mms task,2004.07.17*/
			T_MMI_MMS_PLAYERONDRAW_IND parameter;
			mmsui_data->current_win= ((T_MMS_NEW_PREVIEW*)w->user)->win;;
			M_MMI_MMS_PLAYERONDRAW_IND(  &parameter);
			}
#else
			player_on_draw();
#endif
			dspl_SetBkgColor(oldcolor);
		}
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

//б
static T_MFW_HND MMS_Receiver_List_start(MfwHnd parent_window )
{
	T_MFW_HND      win;
	MMS_TRACE_FUNCTION("MMS_Receiver_List_start"); 
	win = MMS_Receiver_List_create(parent_window);	   	   
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, NULL);
    }
    return win;	
}

static T_MFW_HND MMS_Receiver_List_create (T_MFW_HND window)
{
	T_MMS_RECEIVER_LIST * data = (T_MMS_RECEIVER_LIST *)ALLOC_MEMORY (sizeof (T_MMS_RECEIVER_LIST));
    T_MFW_WIN  * win;

	MMS_TRACE_FUNCTION("MMS_Receiver_List_create"); 	
    data->win =win_create (window, 0, 0, NULL);
    if( data->win EQ NULL )
    {
        return NULL;
    }

	MMS_Set_RecvList_WHnd( data->win ); 

    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Receiver_List_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = window;
	
    winShow(data->win);
    return data->win;
}

static void      MMS_Receiver_List_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter)
{
	T_MFW_WIN         * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_RECEIVER_LIST    * data = (T_MMS_RECEIVER_LIST *)win_data->user;
    T_MFW_HND         * parent=data->parent;
	MMS_TRACE_FUNCTION("MMS_Receiver_List_dialog"); 
    switch( event )
    {
    case E_INIT:
        /* initialization of the dialog data */
        data->list_menu_data.ListPosition   = receiverIndex+1;/* True cursor position in list menu. */
        data->list_menu_data.CursorPosition = receiverIndex+1;/* Cursor position in list snapshot.  */
        data->list_menu_data.SnapshotSize   = RECEIVER_NUMBER_MAX;/* Number of list entries to view.    */
        data->list_menu_data.Font           = 0;
        data->list_menu_data.LeftSoftKey    = TxtSoftSelect;
        data->list_menu_data.RightSoftKey   = TxtMMSSend;//TxtSoftBack,TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions	
        data->list_menu_data.KeyEvents      = KEY_ALL^KEY_CALL;
        data->list_menu_data.Reason         = 0;
        data->list_menu_data.Strings        = TRUE; 
        data->list_menu_data.Attr           = &MMS_Receiver_List_Attrib;
        data->list_menu_data.autoDestroy    = TRUE;

        MMS_Receiver_List_listmenu_create(data);
        break;
		
    case E_RETURN: 
    case E_EXIT: 
    case E_BACK:  
		MMS_Receiver_List_destroy(data->win);
        MMS_Receiver_List_start(parent);
        break;
		
    case E_ABORT:      
        MMS_Receiver_List_destroy(data->win);
        SEND_EVENT (parent, event, 0, NULL); /* forward event to parent */
        break;
    default:
        return;
    }
}

static void      MMS_Receiver_List_listmenu_create (T_MMS_RECEIVER_LIST *data)
{
	int i;
	char *strItem = NULL;
	P_MMS mms= getMMS();
	pMessage pMsg = editor_get_msg();
	T_FindName  searchPhdata;
    /* allocate sufficient memory to hold the maximum list of menu items */
    data->list_menu_data.List = (MfwMnuItem *)ALLOC_MEMORY (RECEIVER_NUMBER_MAX * sizeof (MfwMnuItem));
	
    data->list_menu_data.ListMenuFlag=1;//for display the title
    data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtMMSSend);
    MMS_TRACE_FUNCTION("MMS_Receiver_List_listmenu_create"); 
    for( i=0; i < RECEIVER_NUMBER_MAX; i++ ) /* Fill Menu List */
    {
		  
        data->list_menu_data.List[i].icon = (MfwIcnAttr*)&colist;
        data->list_menu_data.List[i].exta = 0;
        data->list_menu_data.List[i].edit = 0;
        data->list_menu_data.List[i].menu = 0;
        data->list_menu_data.List[i].func = 0; 
        data->list_menu_data.List[i].flagFunc = item_flag_none;
		
		data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( RECEIVER_LENGTH_MAX +1);	
		if((U8)(recvLists[i].receiver[0]) == '\0')
	        wstrcpy(data->list_menu_data.List[i].str , (char *) MmiRsrcGetText(TxtMMSEmpty));
		else
		{
#if 0
		    wstrcpy(data->list_menu_data.List[i].str ,recvLists[i].receiver);
#else
			if( FindNumber((char*)(recvLists[i].receiver), (T_FindName *)&searchPhdata) )
				wstrcpy(data->list_menu_data.List[i].str ,(char*)searchPhdata.name);
            else
                wstrcpy(data->list_menu_data.List[i].str ,recvLists[i].receiver);
#endif
		}
    }
	
    //actual number of entries in list menu
    data->list_menu_data.ListLength = RECEIVER_NUMBER_MAX; 
    data->list_menu_data.autoDestroy = TRUE;
    listDisplayListMenu(data->win, &data->list_menu_data, (ListCbFunc)MMS_Receiver_List_listmenu_cb,0);
}

static void      MMS_Receiver_List_listmenu_cb (T_MFW_HND * win, ListMenuData * ListData)
{
	T_MFW_WIN         * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_RECEIVER_LIST    * data   = (T_MMS_RECEIVER_LIST *)win_data->user;
	T_MFW_HND              * parent=data->parent;
	pMMI_MMS_EVENT temp;
	P_MMS mms = getMMS();
	pMessage pMsg = NULL;
	int i = 0;
	char *strRecvList;
	int len = 0 ;
	T_DISPLAY_DATA display_info;
    MMS_TRACE_FUNCTION("MMS_Receiver_List_listmenu_cb"); 
    switch( ListData->Reason )
    {
    case LISTS_REASON_OK:
    case LISTS_REASON_SELECT:
		receiverIndex = ListData->ListPosition;
		if(recvLists[receiverIndex].type == NORECEIVER)
           MMS_Receiver_List_Opt_start(win,&MMS_Receiver_List_OPTAttr);
		else
		   MMS_Receiver_List_Opt_start(win,&MMS_Receiver_List_OPTAttr2);
        break;
		
    case LISTS_REASON_BACK: /* send current message */
        if(mms->editor)
		{ 
			pMsg  = editor_get_msg();
		}
		strRecvList  = (char *)ALLOC_MEMORY(RECEIVER_NUMBER_MAX*RECEIVER_LENGTH_MAX);
		memset(strRecvList, 0, RECEIVER_NUMBER_MAX*RECEIVER_LENGTH_MAX);
		for( i=0; i < RECEIVER_NUMBER_MAX; i++ ) /* Fill Menu List */
		{	
#if 0
			if((U8)(data->list_menu_data.List[i].str[0]) != '\0' && (U8)(data->list_menu_data.List[i].str[0]) != 0x80)
			{
				strcpy(strRecvList, (char*)data->list_menu_data.List[i].str);
				strcat(strRecvList,";");
				if(i == 0)
				{
					strcpy(strRecvList , (char *) data->list_menu_data.List[i].str);
					strcat(strRecvList,";");
				}
				else 
				{
					strcat(strRecvList , (char *) data->list_menu_data.List[i].str);
					strcat(strRecvList,";");
				}
			}
#else 
			static BOOL isFirstReciverOccur = FALSE;
			if(recvLists[i].type != NORECEIVER)
			{
				if(isFirstReciverOccur == FALSE)
				{
					strcpy(strRecvList, (char*)recvLists[i].receiver);
					strcat(strRecvList, ";");
					isFirstReciverOccur = TRUE;
				}
				else
				{ 
					strcat(strRecvList, (char*)recvLists[i].receiver);
					strcat(strRecvList,";");
				}
			}			
#endif 
		}

        len = strlen(strRecvList);
        strRecvList[len-1] = '\0';

		if(strRecvList[0] != '\0')
		{
			msg_set_receiver(pMsg,strRecvList);
			//msg_set_cc()
			if(gCurMMSPos == MMS_SEND_FOLDER)
			{
				if(mms->editor)
				{
					editor_save_message();
				//	manager_on_store();
					storemessagefolder(mms->manager->unsendfolder);
					
					editor_on_destroy();
					mms->editor = NULL;
				}
				//			mms_test_send_message(); //deleted by xie 04-07-21
			}
			else if(gCurMMSPos == MMS_NEW || gCurMMSPos== MMS_RECV_FOLDER || gCurMMSPos == MMS_SENT_FOLDER || gCurMMSPos == MMS_DRAFT_FOLDER)
			{
				if(mms->editor)
				{
					editor_save_message();
			    	manager_on_store();
				//	storemessagefolder(mms->manager->draftfolder);
					
					editor_on_destroy();
					mms->editor = NULL;
					if(mms->manager && mms->manager->draftfolder && mms->manager->draftfolder->currentmessage)
					{ 
						
						pMessage pMsg = manager_on_pickout(mms->manager->draftfolder);
						pMsg->state = MMS_MSG_TYPE_UNSEND;
						//pMsg->sender = "13764345499";
						//manager_on_addmsg(mms->manager->receivefolder, pMsg);
						manager_on_addmsg(mms->manager->unsendfolder, pMsg);
					//	manager_on_store();
						storemessagefolder(mms->manager->draftfolder);
						storemessagefolder(mms->manager->unsendfolder);
					}
				}
				//			mms_test_send_message();   //deleted by xie 04-07-21
			}
			
	#if 0
			dialog_info_init(&display_info);
			display_info.LeftSoftKey    = TxtNull;
			display_info.RightSoftKey	= TxtCancel;	
			display_info.TextId         = TxtMMSSending;
			display_info.TextId2        = TxtMMSPleaseWaitting;
			display_info.Callback       = (T_VOID_FUNC)MMS_Sending_dialog_cb;
			display_info.Time           = FOREVER;
			display_info.KeyEvents      = KEY_RIGHT | KEY_HUP;
			display_info.iconindex=REMIND_WAITTING;
			
			iddMMSSending.hndParent  = data->win;
			iddMMSSending.hndInfo    = info_dialog(win,&display_info); 
#endif

#if 0
			listsDestroy(ListData->win); //add by xie 04-07-28
			MMS_Receiver_List_destroy(win);
			SEND_EVENT(parent, E_ABORT, 0 ,NULL);
#endif

			gMMSRecvHndInfo.hndRecListWin  = data->win;
			gMMSRecvHndInfo.hndRecList     = ListData->win;
			info_mms_screen(data->win,MMS_SCREEN_ID_SENDING);
//			listsDestroy(ListData->win);  
			MMS_TRACE_EVENT(("enter mms_test_send_message"));
			manager_set_currentfolder(mms->manager->unsendfolder); //add by xie 04-07-30
			mms_test_send_message(); 
			MMS_TRACE_EVENT(("out mms_test_send_message"));
			
		}
	    else
		{
			dialog_info_init(&display_info);
			display_info.LeftSoftKey    = TxtNull;
			display_info.RightSoftKey	= TxtNull;	
			display_info.TextId         = TxtMMSReceiverCanNotBeEmpty;
//			display_info.TextId2        = TxtMMSPleaseWaitting;
			display_info.Callback       = (T_VOID_FUNC)NULL;
			display_info.Time           = TWO_SECS;
			display_info.KeyEvents      = KEY_RIGHT | KEY_HUP |KEY_LEFT;
			display_info.iconindex      = REMIND_FAILURE;
			info_dialog(win,&display_info); 
		}

        FREE_MEMORY((U8*)strRecvList, RECEIVER_NUMBER_MAX*RECEIVER_LENGTH_MAX);
//		MMS_MMI_NewMMS_notification(temp);
/*
		if(mms->manager && mms->manager->currentfolder && mms->manager->currentfolder->currentmessage)
		{
			pMessage pMsg = manager_on_pickout(mms->manager->currentfolder);//mms->manager->currentfolder->currentmessage;
			manager_on_addmsg(mms->manager->unsendfolder, pMsg);

		}
*/
		break;
   
	case LISTS_REASON_HANGUP:
		if(mms->editor)
		{
			editor_on_destroy();
			mms->editor = NULL;
		}
		/*
		if(mms->manager)
		{
			MMS_Codec_Destory();
			manager_on_destroy();
			mms->manager  = NULL;
		}*/
		iMenuItemIndex = 0;
		receiverIndex =0;
		break;

    default:
        break;
    }
    return;
}

void      MMS_Receiver_List_destroy (T_MFW_HND window)
{
	T_MFW_WIN          * win_data;
    T_MMS_RECEIVER_LIST     * data;
    USHORT i;
	MMS_TRACE_FUNCTION("MMS_Receiver_List_destroy"); 
    if( window )
    {
        win_data = ((T_MFW_HDR *)window)->data;
        data = (T_MMS_RECEIVER_LIST *)win_data->user;
        if( data )
        {
            win_delete (data->win);
			MMS_Set_RecvList_WHnd( NULL ); 
            for( i = 0; i < RECEIVER_NUMBER_MAX; i++ )
                FREE_MEMORY( (void *)(data->list_menu_data.List[i].str), RECEIVER_LENGTH_MAX +1);
            FREE_MEMORY ((void *)data->list_menu_data.List, RECEIVER_NUMBER_MAX* sizeof (MfwMnuItem)); 
            FREE_MEMORY ((void *)data, sizeof (T_MMS_RECEIVER_LIST));
        }
        else
        {
            MMS_TRACE_EVENT (("MMS_Receiver_List_destroy() called twice"));
        }
		
    }

}

static char *MMS_strchr(const char *s, int c)
{
	do
	if (*s == c) return (char *)s;
	while (*s++);
	
	return NULL;
}


static void MMS_Receiver_List_Refresh(MMS_FOLDER_TYPE folderType, Refresh_Action command)
{
	int i = 0;
	P_MMS mms = getMMS();
	pMessage pMsg = NULL;
	char *pRecvStr = NULL;
	char *strFind=NULL,*strLastFind =NULL;

	MMS_TRACE_FUNCTION("MMS_Receiver_List_Refresh"); 
	for(i= 0; i < RECEIVER_NUMBER_MAX; i++)
	{
		recvLists[i].type = NORECEIVER;
		memset(recvLists[i].receiver, 0, RECEIVER_LENGTH_MAX);;
	}	
	
	if(mms->editor)
		pMsg = editor_get_msg();
	else
		return;

    pRecvStr = msg_get_receiver(pMsg);
	if(pRecvStr == NULL || (U8)pRecvStr[0] == 0X80)
		return;

	strFind = MMS_strchr(pRecvStr, ';');
	strLastFind = pRecvStr;
	for(i= 0; i < RECEIVER_NUMBER_MAX && strFind; i++)
	{
		strncpy(recvLists[i].receiver, strLastFind, (unsigned int)(strFind - strLastFind));

		if(strchr((const char*)(recvLists[i].receiver), '@'))
            recvLists[i].type = EMAIL;
		else 
			recvLists[i].type = TELEPHONE;

		strLastFind = strFind+1;
		strFind = MMS_strchr(strLastFind, ';');
	}
	strcpy(recvLists[i].receiver, strLastFind);	

	if(strchr(recvLists[i].receiver, '@'))
		recvLists[i].type = EMAIL;
	else 
		recvLists[i].type = TELEPHONE;

	//strFind = 
	/*
	if(command == CLEAR)
		{
			for(i= 0; i < RECEIVER_NUMBER_MAX; i++)
			{
				memset(recvLists[i].receiver, 0, RECEIVER_LENGTH_MAX);;
			}	
		}
		else if(command == REFRESH)
		{
			switch(folderType)
			{
			case MMS_NEW:
				for(i= 0; i < RECEIVER_NUMBER_MAX; i++)
				{
					
					memset(recvLists[i].receiver, 0, RECEIVER_LENGTH_MAX);
				}
				break;
	
			case MMS_RECV_FOLDER:
				for(i= 0; i < RECEIVER_NUMBER_MAX; i++)
				{
					manager_get_currentmsg();			
					wstrcpy(recvLists[i].receiver ,(char *) MmiRsrcGetText(TxtMMSEmpty));
				}
				break;	
				
			case MMS_SEND_FOLDER:
				for(i= 0; i < RECEIVER_NUMBER_MAX; i++)
				{
					wstrcpy(recvLists[i].receiver ,(char *) MmiRsrcGetText(TxtMMSEmpty));
				}
				break;
	
			case MMS_DRAFT_FOLDER:
				for(i= 0; i < RECEIVER_NUMBER_MAX; i++)
				{
					wstrcpy(recvLists[i].receiver ,(char *) MmiRsrcGetText(TxtMMSEmpty));
				}
				break;
			case MMS_SENT_FOLDER:
				for(i= 0; i < RECEIVER_NUMBER_MAX; i++)
				{
					wstrcpy(recvLists[i].receiver ,(char *) MmiRsrcGetText(TxtMMSEmpty));
				}
				break;
			}
	   	}*/
}
#if 0	
int MMS_Sending_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
	T_MFW_WIN         * win_data    = ((T_MFW_HDR *)win)->data;
    T_MMS_RECEIVER_LIST    * data   = (T_MMS_RECEIVER_LIST *)win_data->user;
	T_MFW_HND              * parent = data->parent;
	
    TRACE_FUNCTION ("SmsRead_dialog_cb()");
	
    switch( Reason )
    {
	case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
		iddMMSSending.hndInfo = NULL;
		iMenuItemIndex = 0;
		receiverIndex = 0;
		MMS_Receiver_List_destroy(win);
		iddMMSSending.hndParent = NULL;
		SEND_EVENT(parent, E_ABORT, 0 ,NULL);
        return MFW_EVENT_CONSUMED;
		
    default:
        return MFW_EVENT_REJECTED;
    }
}	

void   MMS_Sending_End(void)
{
	   T_MFW_HND    *parent = iddMMSSending.hndParent;

	   T_MFW_WIN         * winRecList         = ((T_MFW_HDR *)parent)->data;
	   T_MMS_RECEIVER_LIST    * dataRecList   = (T_MMS_RECEIVER_LIST *)winRecList->user;
       T_MFW_HND       * parentRecList  = dataRecList->parent;  
	   SEND_EVENT(iddMMSSending.hndInfo,DIALOG_DESTROY, NULL,NULL);
	   iddMMSSending.hndInfo = NULL;
	   iMenuItemIndex = 0;
	   receiverIndex = 0;
	   MMS_Receiver_List_destroy(dataRecList->win);
	   iddMMSSending.hndParent = NULL;
	   SEND_EVENT(parentRecList, E_ABORT, 0 ,NULL);      
}
#endif
//ѡ
static T_MFW_HND MMS_Receiver_List_Opt_start(MfwHnd parent_window , MfwMnuAttr *menuAttr)
{
    T_MFW_HND win;	
	
	MMS_TRACE_FUNCTION("MMS_Receiver_List_Opt_start"); 
    win = MMS_Receiver_List_Opt_create (parent_window);	
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, NULL, (void *)menuAttr);
    }
    return win;
}


static T_MFW_HND MMS_Receiver_List_Opt_create(T_MFW_HND parent_window)
{
	T_MMS_RECEIVER_LIST_OPT      * data = (T_MMS_RECEIVER_LIST_OPT *)ALLOC_MEMORY (sizeof (T_MMS_RECEIVER_LIST_OPT));
    T_MFW_WIN  * win;
	
	MMS_TRACE_FUNCTION("MMS_Receiver_List_Opt_create"); 
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)MMS_Receiver_List_Opt_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
	
    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Receiver_List_Opt_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
	
    return data->win;
}

static void MMS_Receiver_List_Opt_destroy(T_MFW_HND win)
{
	T_MFW_WIN              * win_data;
    T_MMS_RECEIVER_LIST_OPT     * data;
	
	MMS_TRACE_FUNCTION("MMS_Receiver_List_Opt_destroy"); 
    if(win)
    {
        win_data = ((T_MFW_HDR *)win)->data;
        data = (T_MMS_RECEIVER_LIST_OPT *)win_data->user;
		
        if( data )
        {
            win_delete (data->win);
            FREE_MEMORY ((void *)data, sizeof (T_MMS_RECEIVER_LIST_OPT));
        }
        else
        {
            MMS_TRACE_EVENT((" "));
        }
    }
}

static void MMS_Receiver_List_Opt_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_RECEIVER_LIST_OPT  * data     = (T_MMS_RECEIVER_LIST_OPT *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
	
    char * title;
	MMS_TRACE_FUNCTION("MMS_Receiver_List_Opt_dialog"); 
    switch( event )
    {
    case E_INIT:
        /* initialization of administrative data */
		// data->parent_data = parent_data;        
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)MMS_Receiver_List_Opt_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)MMS_Receiver_List_Opt_kbd_cb);
        title = (char *) MmiRsrcGetText(TxtSoftOptions);  // get the editor title text
		
        data->menu = mnuListCreate(data->win,(MfwMnuAttr*)parameter, E_MNU_ESCAPE, (MfwCb)MMS_Receiver_List_Opt_mnu_cb,title);
        mnuLang(data->menu,mainMmiLng);
        /* put the (new) dialog window on top of the window stack */
        mnuUnhide(data->menu);
        winShow(win);
        break;
		
	case E_ABORT:
	case E_EXIT: 
		MMS_Receiver_List_Opt_destroy(data->win);
        SEND_EVENT (parent, E_BACK, 0, NULL); 
		break;
		
    default:
        return;
    }
}

static int MMS_Receiver_List_Opt_kbd_cb(MfwEvt e, MfwKbd *k)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_RECEIVER_LIST_OPT      * data = (T_MMS_RECEIVER_LIST_OPT *)win_data->user;
	P_MMS  mms = getMMS();

	MMS_TRACE_FUNCTION("MMS_Receiver_List_Opt_kbd_cb"); 
    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
            if(mms->editor)
			{
				editor_on_destroy();
				mms->editor = NULL;
			}
/*
			if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/
			
			iMenuItemIndex = 0;
			iListMenuItemIndex =0;
            returntoidle(0);
            //mnuEscape(data->menu);
            break;
        case KCD_RIGHT: /* Power Down */
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
            mnuUp(data->menu);
            break;
        case KCD_MNUDOWN: /* highlight next entry */
            mnuDown(data->menu);
            break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:
            mnuSelect(data->menu);
            break;
        case KCD_HUP: /* back to previous menu */
			if(mms->editor)
			{
				editor_on_destroy();
				mms->editor = NULL;
			}
			/*
			if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/
			
			iMenuItemIndex = 0;
			iListMenuItemIndex =0;
            if( returntoidle(0) )
            break;
        case KCD_RIGHT: /* back to previous menu */
            mnuEscape(data->menu);
            break;
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;
}

static int MMS_Receiver_List_Opt_mnu_cb ( MfwEvt e, MfwMnu *m )
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_RECEIVER_LIST_OPT      * data = (T_MMS_RECEIVER_LIST_OPT *)win_data->user;
	T_MFW_HND              * parent=data->parent;
	MMS_TRACE_FUNCTION("MMS_Receiver_List_Opt_mnu_cb"); 
    switch( e )
    {
    case E_MNU_ESCAPE: /* back to previous menu */
        MMS_Receiver_List_Opt_destroy(data->win);
		SEND_EVENT (parent, E_BACK, 0, NULL);
        break;
		
    default: /* in mnuCreate() only E_MNU_ESCAPE has been enabled! */
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

static int MMS_Receiver_List_Opt_win_cb(MfwEvt e, MfwWin *w)
{
	MMS_TRACE_FUNCTION("MMS_Receiver_List_Opt_win_cb"); 
	switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        dspl_ClearAll();
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

static int MMS_Receiver_List_Opt_TelNumber(MfwMnu* m, MfwMnuItem* i)
{
   T_MFW_HND    win  = mfwParent(mfw_header());
   MMS_TRACE_FUNCTION("MMS_Receiver_List_Opt_TelNumber"); 
   MMS_Receiver_Edit_start(win, TELEPHONE);
}

static int MMS_Receiver_List_Opt_Email(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Receiver_List_Opt_Email"); 
	MMS_Receiver_Edit_start(win, EMAIL);
}

static int MMS_Receiver_List_Opt_Delete(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_RECEIVER_LIST_OPT      * data = (T_MMS_RECEIVER_LIST_OPT *)win_data->user;
	T_MFW_HND              * parent=data->parent;
	
    recvLists[receiverIndex].type = NORECEIVER;
	memset(recvLists[receiverIndex].receiver, 0, RECEIVER_LENGTH_MAX+1);
	MMS_Receiver_List_Opt_destroy(data->win);
	SEND_EVENT (parent, E_BACK, 0, NULL); 	
}

static int MMS_Receiver_List_Opt_Edit(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_RECEIVER_LIST_OPT      * data = (T_MMS_RECEIVER_LIST_OPT *)win_data->user;
	T_MFW_HND              * parent=data->parent;
	if(EMAIL == recvLists[receiverIndex].type )
	   MMS_Receiver_Edit_start(win, EMAIL);
	else if(TELEPHONE ==  recvLists[receiverIndex].type)
		MMS_Receiver_Edit_start(win, TELEPHONE);
}

//߱༭
static T_MFW_HND MMS_Receiver_Edit_start  (MfwHnd parent_window, RECEIVER_TYPE edtID)
{
    T_MFW_HND win;
    win = MMS_Receiver_Edit_create(parent_window);
	MMS_TRACE_FUNCTION("MMS_Receiver_Edit_start"); 
    if( win NEQ NULL )
    {
		SEND_EVENT (win, E_INIT, edtID, NULL);
    }
    return win;
}


static T_MFW_HND MMS_Receiver_Edit_create (T_MFW_HND parent_window)
{
	T_MMS_RECEIVER_EDITOR  * data = (T_MMS_RECEIVER_EDITOR *)ALLOC_MEMORY (sizeof (T_MMS_RECEIVER_EDITOR));
	T_MFW_WIN  * win;
	
	MMS_TRACE_FUNCTION("MMS_Receiver_Edit_create"); 
	data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
	if( data->win EQ NULL )
	{
		return NULL;
	}
	   
	data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Receiver_Edit_dialog;
	data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
	win->user                = (void *)data;
	data->parent             = parent_window;
	   
    winShow(data->win);
	return data->win;
}

static void	  MMS_Receiver_Edit_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter)
{
	T_MFW_WIN                  * win_data = ((T_MFW_HDR *) win)->data;
	T_MMS_RECEIVER_EDITOR      * data = (T_MMS_RECEIVER_EDITOR *)win_data->user;
    T_MFW_HDR                  * parent      =  data->parent;
    MMS_TRACE_FUNCTION("MMS_Receiver_Edit_dialog"); 
	switch(event)
	{
	case E_INIT:
		{			
			switch(value)
			{
			case TELEPHONE:  
				data->edtID = TELEPHONE;
				MMS_Receiver_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSTelNumber,(char *)recvLists[receiverIndex].receiver,RECEIVER_LENGTH_MAX,edtCurBar1);
//				recvLists[receiverIndex].type          = TELEPHONE;
				data->editor_info.mode                 = PHONENUMONLY_MODE;     
				data->editor_info.Identifier           = SMSSEND_ID_NBEDIT; 
				data->editor_info.min_enter            = 1; //very important
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
			    data->editor_info.AlternateLeftSoftKey = TxtSearchName;//TxtPhonebook;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Receiver_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
//				data->editor_info.InputMode            = SHUZI_INPUT_MODE;  				
				//data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = editor_start(win, &(data->editor_info));//text_input(win, &editor_data);
				break;
				
			case EMAIL:  
				data->edtID = EMAIL;
				MMS_Receiver_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSEmail,(char *)recvLists[receiverIndex].receiver,RECEIVER_LENGTH_MAX,edtCurBar1);
//				recvLists[receiverIndex].type          = EMAIL;
				data->editor_info.mode                 = TEXTINPUT_MODE;//PHONENUMONLY_MODE;  
				data->editor_info.Identifier           = SMSSEND_ID_NBEDIT ; //very important
				data->editor_info.min_enter            = 1; //very important
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
			//	data->editor_info.AlternateLeftSoftKey = TxtSearchName;//TxtPhonebook;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB )MMS_Receiver_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = LOWERCASE_INPUT_MODE;  
				
				//data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = text_input(win, &(data->editor_info));
				break;
			default:
				return;
			}
		}
		break;
		
	case E_ABORT:
	case E_EXIT: 
		MMS_Receiver_Edit_destroy(data->win);
        SEND_EVENT (parent, event, 0, NULL); /* forward event to parent */
		break;

    case SMS_PHBK_NUMBER:
        memcpy((char *)recvLists[receiverIndex].receiver, (char *)parameter, MINIMUM(RECEIVER_LENGTH_MAX, strlen((char *)parameter)+1));
		recvLists[receiverIndex].type  = TELEPHONE;  //Add by xie 04-08-02
		SetPhbkIN(0);
		MMS_Receiver_Edit_destroy(data->win);
        SEND_EVENT (parent, E_ABORT, 0, NULL);
        break;
		
	default:
		return;
	}
	return;
}

static BOOL isMMS_Valid_Email(char *strEmail)
{
	 if(!strEmail || strEmail[0] == '\0')
		 return FALSE;

     if(strEmail[0] == '\x80')
		 return FALSE;
	 else 
	 {
		 unsigned int i = 0,iCount1 = 0, iCount2 =0;	 
		 char *strFind1 = NULL,*strFind2 = NULL;
		 while(strEmail[i])
		 {
			 if(strEmail[i]>='0' && strEmail[i]<='9')
			 {   
				 i++;
				 continue;
			 }
			 else if(strEmail[i]>= 'a' && strEmail[i]<='z')
			 { 
				 i++;
				 continue;
			 }
			 else if(strEmail[i]>='A' && strEmail[i]<='Z')
			 {
				 i++;
				 continue;
			 }
			 else if(strEmail[i] == '@')
			 {
				 i++;
				 iCount1++;
				 continue;
			 }
			 else if(strEmail[i] == '.')
			 {
				 i++;
				 iCount2++;
				 continue;
			 }
			 else
				 return FALSE;

		 }
		 
		 if(iCount1 != 1 && iCount2 != 1)
			 return FALSE;
		 strFind1 = strchr(strEmail,'@');
		 strFind2 = strrchr(strEmail,'.');
		 if((strFind2 < strFind1) || (strFind2-strFind1) == 1|| ('\x0' == *(++strFind2) ) || (strFind1 == strEmail) )
			 return FALSE;
		 return TRUE;
	 }
}

static void MMS_Receiver_Edit_edit_cb(T_MFW_HND win, USHORT Identifier, SHORT reason)
{
	T_MFW_WIN           * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_RECEIVER_EDITOR  * data     = (T_MMS_RECEIVER_EDITOR *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
	P_MMS mms = getMMS();

	MMS_TRACE_FUNCTION("MMS_Receiver_Edit_edit_cb"); 
	switch( reason )
    {
    case INFO_KCD_ALTERNATELEFT:
		SetPhbkIN(1);
        bookPhonebookStart(win, PhbkFromSms);
		break;
		
    case INFO_KCD_LEFT:
		//add by xie for get valid tele number or email
        {
			char *pReceiver = recvLists[receiverIndex].receiver;
			if(EMAIL == data->edtID)
			{
                if(pReceiver[0]=='\0')
				{
                    recvLists[receiverIndex].type = NORECEIVER;
                    MMS_Receiver_Edit_destroy(data->win);
			    	SEND_EVENT (parent, E_EXIT, 0, NULL);
					break;
				}

				if( !isMMS_Valid_Email(pReceiver) )
				{
					T_DISPLAY_DATA display_info;
					dialog_info_init(&display_info);
					display_info.LeftSoftKey    = TxtNull;
					display_info.RightSoftKey	= TxtNull;	
					display_info.TextId         = TxtMMSInvalidInput;
					display_info.TextId2        = TxtMMSPleaseInputAgain;
					display_info.Callback       = (T_VOID_FUNC)NULL;
					display_info.Time           = ONE_SECS;
					display_info.KeyEvents      = KEY_RIGHT | KEY_HUP |KEY_LEFT;
					display_info.iconindex      = REMIND_FAILURE;
					info_dialog(win,&display_info); 
				}
				else
				{
					recvLists[receiverIndex].type = EMAIL;
					MMS_Receiver_Edit_destroy(data->win);
					SEND_EVENT (parent, E_EXIT, 0, NULL);
				}

			}
			else if(TELEPHONE == data->edtID)
			{
				if(pReceiver[0] == '\0')
                    recvLists[receiverIndex].type = NORECEIVER;
				else
					recvLists[receiverIndex].type = TELEPHONE;
				
				MMS_Receiver_Edit_destroy(data->win);
				SEND_EVENT (parent, E_EXIT, 0, NULL);
			}
        }	
		break;
		
    case INFO_KCD_RIGHT:
		recvLists[receiverIndex].type = NORECEIVER;
		SEND_EVENT (win, E_EXIT, 0, NULL);
		//SEND_EVENT (parent, E_EXIT, 0, NULL);
        break;
	case INFO_KCD_HUP:
		if(mms->editor)
		{
			editor_on_destroy();
			mms->editor = NULL;
		}
		/*
		if(mms->manager)
		{
			MMS_Codec_Destory();
			manager_on_destroy();
			mms->manager = NULL;
		}*/
		
		iMenuItemIndex = 0;
		iListMenuItemIndex =0;
		if(returntoidle(0) )
            break;
		break;
		
    default:
        MMS_TRACE_EVENT((" "));
        break;
    }
}

static void MMS_Receiver_Edit_destroy (T_MFW_HND window)
{
	T_MFW_WIN * win_data;
    T_MMS_RECEIVER_EDITOR    * data = NULL; 
    pMessage pMsg = editor_get_msg();
	MMS_TRACE_FUNCTION("MMS_Receiver_Edit_destroy"); 
    if( window )
    {
		win_data = ((T_MFW_HDR *)window)->data;
		if( win_data != NULL )
			data = (T_MMS_RECEIVER_EDITOR *)win_data->user;
		      		
		if (data)
		{
			if(data->editor != 0)
			{
				if(data->edtID == EMAIL)
				{
					text_input_destroy(data->editor);
					data->editor = 0;
				}
				else if(data->edtID == TELEPHONE)
				{
					editor_destroy(data->editor);
					data->editor = 0;
				}
			}		
			win_delete (data->win);
		    /*     
		     * MMS_FREE Memory
		     */
		    FREE_MEMORY ((void *)data, sizeof (T_MMS_RECEIVER_EDITOR));
		}
	    else
		{
		    MMS_TRACE_EVENT((" "));
		}
	}   
}

static void MMS_Receiver_Edit_LoadEditDefault(T_EDITOR_DATA *editor_data)
{
	MMS_TRACE_FUNCTION("MMS_Receiver_Edit_LoadEditDefault"); 
	editor_attr_init(&editor_data->editor_attr, NULL, edtCurNone, 0, 0, 0);
	editor_data->hide				= FALSE;
	editor_data->min_enter			= 0;  
	editor_data->LeftSoftKey		= TxtSoftSelect;
	editor_data->RightSoftKey		= TxtSoftBack;
	editor_data->AlternateLeftSoftKey   = TxtNull;
	editor_data->TextId				= '\0';  
	editor_data->Identifier			=  0; 
	editor_data->TextString			= NULL;  
	editor_data->timeout			= FOREVER; 
	editor_data->mode                = ALPHA_MODE;
	editor_data->Callback			= NULL;
	editor_data->destroyEditor		= TRUE ; 
}

//MMS
static T_MFW_HND MMS_Image_Preview_start(MfwHnd parent_window )
{
	T_MFW_HND win;	
	MMS_TRACE_FUNCTION("MMS_Image_Preview_start"); 
    win = MMS_Image_Preview_create (parent_window);	
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, NULL, NULL);
    }
    return win;
}

static T_MFW_HND MMS_Image_Preview_create(T_MFW_HND parent_window)
{
	T_MMS_IMAGE_PREVIEW      * data = (T_MMS_IMAGE_PREVIEW *)ALLOC_MEMORY (sizeof (T_MMS_IMAGE_PREVIEW));
    T_MFW_WIN  * win;
	MMS_TRACE_FUNCTION("MMS_Image_Preview_create"); 
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)MMS_Image_Preview_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
	
	gHndMMSImagePreview = data->win;  //add by xie 04-08-03
    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Image_Preview_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
	
    return data->win;
}

static void MMS_Image_Preview_destroy(T_MFW_HND win)
{
	T_MFW_WIN              * win_data;
    T_MMS_IMAGE_PREVIEW     * data;
	MMS_TRACE_FUNCTION("MMS_Image_Preview_destroy"); 
    if(win)
    {
        win_data = ((T_MFW_HDR *)win)->data;
        data = (T_MMS_IMAGE_PREVIEW *)win_data->user;
		
        if( data )
        {
            win_delete (data->win);
			gHndMMSImagePreview = NULL;
            FREE_MEMORY ((void *)data, sizeof (T_MMS_IMAGE_PREVIEW));
			return;
        }
        else
        {
            MMS_TRACE_EVENT((" "));
        }
    }
}

static void MMS_Image_Preview_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_IMAGE_PREVIEW  * data     = (T_MMS_IMAGE_PREVIEW *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
	
    char * title;
	MMS_TRACE_FUNCTION("MMS_Image_Preview_dialog"); 
    switch( event )
    {
    case E_INIT:     
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)MMS_Image_Preview_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)MMS_Image_Preview_kbd_cb);
        winShow(win);
        break;
    default:
        return;
    }
}

static int MMS_Image_Preview_kbd_cb(MfwEvt e, MfwKbd *k)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_IMAGE_PREVIEW      * data = (T_MMS_IMAGE_PREVIEW *)win_data->user;
    T_MFW_HND  *parent  = data->parent; 
	P_MMS mms = getMMS();
	int ret;
	MMS_TRACE_FUNCTION("MMS_Image_Preview_kbd_cb"); 
    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
			
			if(mms->editor)
			{
				editor_on_destroy();
				mms->editor = NULL;
			}
			/*
			if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/				
			iMenuItemIndex = 0;
            returntoidle(0);
            break;
        case KCD_RIGHT: 
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
            break;
        case KCD_MNUDOWN: /* highlight next entry */
            break;
		case KCD_MNURIGHT:
			break;
        case KCD_MNULEFT:
			break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:
			if( MMS_File_Type(frameData.imageFileName,MMS_TYPE_JPEG) )
			{
				editor_content_del(2);
				ret = editor_image_new(frameData.imageFileName, MMS_TYPE_JPEG);
			}
			else if( MMS_File_Type(frameData.imageFileName,MMS_TYPE_WBMP) )
			{
				editor_content_del(2);
				ret = editor_image_new(frameData.imageFileName, MMS_TYPE_WBMP);
			}
			else if( MMS_File_Type(frameData.imageFileName,MMS_TYPE_GIF) )
			{
				editor_content_del(2);
				ret = editor_image_new(frameData.imageFileName, MMS_TYPE_GIF);
			}
#if 0
			MMS_Image_Preview_destroy(data->win);
			SEND_EVENT (parent, E_BACK, 0, NULL);
#else 
			if(1 == ret)
			{
			MMS_Image_Preview_destroy(data->win);
			SEND_EVENT (parent, E_BACK, 0, NULL);
			}
			else if(ret == -1)
				info_mms_screen(win, MMS_SCREEN_ID_IMAGE_FILETOOBIG);
			else if (ret = 0)
			{
				
			}
#endif
            break;

        case KCD_HUP: /* back to previous menu */			
            break;
        case KCD_RIGHT: /* back to previous menu */
			MMS_Image_Preview_destroy(data->win);
			SEND_EVENT (parent, E_BACK, 0, NULL);//why success? by xie
            break;
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;
}

static int MMS_Image_Preview_win_cb(MfwEvt e, MfwWin * w)
{	
	MMS_TRACE_FUNCTION("MMS_Image_Preview_win_cb"); 
	switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
		{
			unsigned int oldcolor = dspl_SetBkgColor(0xffffff);
			char title[10];		
			U8 *pImage = NULL;
			//int w,  h, component;
			//UINT posx ,posy;
			dspl_ClearAll();
			
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
				menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
				menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(MmiRsrcGetText(TxtMMSPreview)))/2, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtMMSPreview), 0x0);    	  			

			MMS_TRACE_EVENT((frameData.imageFileName));
			if( MMS_File_Type(frameData.imageFileName,MMS_TYPE_JPEG) )
			{
				//int GetJPEGDimension(char *filename, int *w, int *h);
				//pImage = ReadJpegToData (frameData.imageFileName, &w, &h, &component, 18);
				//posx = (SCREEN_SIZE_X - w)/2;
				//posy = (SCREEN_SIZE_Y - h)/2;
				//MMSBitBlt(posx, posy, (UINT)w, (UINT)h, pImage);
#ifdef MMI_MMSTASK_ENABLED
				mmsui_data->current_win= ((T_MMS_IMAGE_PREVIEW*)w->user)->win;
				{
					T_MMI_MMS_DRAWAIBUM_IND  parameter;
					//mmsui_data->temp_win = info_mms_dialog(win); 
					
					parameter.type = MMS_TYPE_JPEG;
					strcpy(parameter.filename , frameData.imageFileName);
					M_MMI_MMS_DRAWAIBUM_IND(&parameter);
				}
#else
				 MMS_DrawJPEGAlbum(frameData.imageFileName);
#endif
	
			}
			else if( MMS_File_Type(frameData.imageFileName,MMS_TYPE_WBMP) )
			{
	
#ifdef MMI_MMSTASK_ENABLED
				mmsui_data->current_win= ((T_MMS_IMAGE_PREVIEW*)w->user)->win;;
				{
					T_MMI_MMS_DRAWAIBUM_IND  parameter;
					
					parameter.type = MMS_TYPE_WBMP;
					strcpy(parameter.filename , frameData.imageFileName);
					M_MMI_MMS_DRAWAIBUM_IND(&parameter);
				}
#else
				MMS_DrawWBMPAlbum(frameData.imageFileName);
#endif
			}
			else if( MMS_File_Type(frameData.imageFileName,MMS_TYPE_GIF) )
			{
#ifdef MMI_MMSTASK_ENABLED
				mmsui_data->current_win= ((T_MMS_IMAGE_PREVIEW*)w->user)->win;
				{
					T_MMI_MMS_DRAWAIBUM_IND  parameter;
					
					parameter.type = MMS_TYPE_GIF;
					strcpy(parameter.filename , frameData.imageFileName);
					M_MMI_MMS_DRAWAIBUM_IND(&parameter);
				}
#else
				MMS_DrawGIFAlbum(frameData.imageFileName);
#endif
//				MMS_S32 mms_draw_image(MMS_S8 *filename, MMS_U32 x, MMS_U32 y, MMS_U32 w, MMS_U32 h, MMS_S8 imagetype, pPlayer mmsplayer);
//				mms_draw_image(frameData.imageFileName, 0,TITLE_HEIGHT,50,50,MMS_TYPE_GIF,NULL);
			}
			      
			displaySoftKeys(TxtAdd,TxtSoftBack);			
//			sprintf(title,"%d/%d",curSlide+1,slideNum);
//			drawcolorclarity((SCREEN_SIZE_X- get_StringWidth(title))/2,SCREEN_SIZE_Y-dspl_GetFontHeight()-1,title, 0x000000);			
			dspl_SetBkgColor(oldcolor);
		}
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

int MMS_Sending_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
/*	T_MFW_WIN         * win_data    = ((T_MFW_HDR *)win)->data;
    T_MMS_RECEIVER_LIST    * data   = (T_MMS_RECEIVER_LIST *)win_data->user;
	T_MFW_HND              * parent = data->parent;
*/	
    MMS_TRACE_EVENT(("MMS_Sending_dialog_cb()"));
	
    switch( Reason )
    {
	case INFO_KCD_LEFT:
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:/*cancel mms*/
#if 0
		iddMMSSending.hndInfo = NULL;
		iMenuItemIndex = 0;
		receiverIndex = 0;
		MMS_Receiver_List_destroy(win);
		iddMMSSending.hndParent = NULL;
		SEND_EVENT(parent, E_ABORT, 0 ,NULL);
#endif
		MMS_Cancel();
		
		//MMS_Sending_End();
		MMS_DELAY(30);
        return MFW_EVENT_CONSUMED;

	case INFO_TIMEOUT:           //add by xie 04-08-02
		{
			T_MFW_HND    *parent = iddMMSSending.hndParent;
			
			T_MFW_WIN         * winRecList         = ((T_MFW_HDR *)parent)->data;
			T_MMS_RECEIVER_LIST    * dataRecList   = (T_MMS_RECEIVER_LIST *)winRecList->user;
			T_MFW_HND       * parentRecList  = dataRecList->parent;  
			iMenuItemIndex = 0;
			receiverIndex = 0;
			MMS_Receiver_List_destroy(dataRecList->win);
			iddMMSSending.hndParent = NULL;
			SEND_EVENT(parentRecList, E_ABORT, 0 ,NULL);   
		}
		break;

    default:
        return MFW_EVENT_REJECTED;
    }
}

int MMS_EndSending_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
	MMS_TRACE_EVENT(("MMS_Send_dialog_cb()"));
	
    switch( Reason )
    {
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:	
	case INFO_TIMEOUT:       
		{
			T_MFW_HND    *parent = gMMSRecvHndInfo.hndRecListWin;
			
			T_MFW_WIN         * winRecList         = ((T_MFW_HDR *)parent)->data;
			T_MMS_RECEIVER_LIST    * dataRecList   = (T_MMS_RECEIVER_LIST *)winRecList->user;
			T_MFW_HND       * parentRecList  = dataRecList->parent;  
			iMenuItemIndex = 0;
			receiverIndex = 0;
			listsDestroy(gMMSRecvHndInfo.hndRecList);
			gMMSRecvHndInfo.hndRecList = NULL;
			MMS_Receiver_List_destroy(dataRecList->win);
			gMMSRecvHndInfo.hndRecListWin = NULL;
			SEND_EVENT(parentRecList, E_ABORT, 0 ,NULL);   
		}
		break;
		
    default:
        return MFW_EVENT_REJECTED;
    }
}
/*
void   MMS_Sending_End(void)
{
	   T_MFW_HND    *parent = iddMMSSending.hndParent;
	   
	   T_MFW_WIN         * winRecList         = ((T_MFW_HDR *)parent)->data;
	   T_MMS_RECEIVER_LIST    * dataRecList   = (T_MMS_RECEIVER_LIST *)winRecList->user;
       T_MFW_HND       * parentRecList  = dataRecList->parent;  
	   SEND_EVENT(iddMMSSending.hndInfo,DIALOG_DESTROY, NULL,NULL);
	   iddMMSSending.hndInfo = NULL;
	   iMenuItemIndex = 0;
	   receiverIndex = 0;
	   MMS_Receiver_List_destroy(dataRecList->win);
	   iddMMSSending.hndParent = NULL;
	   SEND_EVENT(parentRecList, E_ABORT, 0 ,NULL);      
}
*/
#endif