#ifdef _MMS_ENABLE_
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#if defined (NEW_FRAME)
#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif


#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#include "mfw_sys.h"
#include "p_sim.h"

#include "vsi.h"

#include "mfw_mfw.h"
#include "mfw_win.h"

#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_cm.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_sat.h"
#include "mmiicons.h"

//#include "mfw_ffs.h"

#include "dspl.h"

#include "gdi.h" //ES!!
#ifdef WIN32
#include "MmiMain.h"
#endif
#include "Audio.h"  
#include "pcm.h"
#include "Mfw_cphs.h" 
#include "Mmiblklangdb.h"
#include "mmi3dframe.h"

//begin xie
#include "mmiMMSffs.h"
#include "mmimms_cfg.h"
//end xie

T_MMS_NET_SETTINGS mmsSettings;

static const T_MMS_NET_SETTINGS mmsSettingsDefault =
{
	{
		//Settings 1
		{
			"China Mobile",
			"http://mmsc.monternet.com",

			{MMS_PARAM_OFF},
			{MMS_PARAM_OFF,MMS_PARAM_OFF},
			
			{
				"10.0.0.172",
				"9201",
				"cmwap",
				"wap",
				"wap"
			},
			
			{
				"",
				"9201",
				//ISDN,  //deleted by xie 04-07-30
				
				"",
				"",
				""
			},
			ONLY_GPRS
		},

		//settings 2
		{
			"China Unicom",
			"http://",
			{MMS_PARAM_OFF},
			{MMS_PARAM_OFF,MMS_PARAM_OFF},
						
			{
			   "",
				"",
				"",
				"",
				""
			},
						
			{
				"",
				"9201",
				//ISDN,
				"",
				"",
				""
			},
			ONLY_GPRS
		},

		//settings 3			
		{
			"",
			"http://",

			{MMS_PARAM_OFF},
			{MMS_PARAM_OFF,MMS_PARAM_OFF},
									
			{
				"",
				"9201",
				"",
				"",
				""
			},
									
			{
				"",
				"",
			    //ISDN,
				"",
				"",
				""
			},
			ONLY_GPRS
		},

		//settings 4
		{
			"",
			"http://",

			{MMS_PARAM_OFF},
			{MMS_PARAM_OFF,MMS_PARAM_OFF},
												
			{
		    	"",
				"9201",
				"",
				"",
				""
			},
												
			{
				"",
				"",
				//ISDN,
				"",
				"",
				""
			},
		    ONLY_GPRS
		},

		//settings 5
		{
			"",
			"http://",

			{MMS_PARAM_OFF},
			{MMS_PARAM_OFF,MMS_PARAM_OFF},
					
			{
		    	"",
				"9201",
				"",
				"",
				""
			},
					
			{
				"",
				"",
				//ISDN,
				"",
				"",
				""
			},
			ONLY_GPRS
		}						
   },
   MMS_SETTINGS_SUM,
   0		
};

void flash_MMSSettingsInitialise(void)
{
	MMS_TRACE_FUNCTION("flash_MMSSettingsInitialise");
	mmsSettings = mmsSettingsDefault;
	//memset(&FFS_ScheData,0,sizeof(Flash_Sche));
}

effs_t flash_MMSSettingswrite()
{
	//	ffsfileCmd.ffsfile[MMSConfigFile].pdir=FFSFILE_MMSSETTINGS_PATH;
	//	ffsfileCmd.ffsfile[MMSConfigFile].pdata=&mmsSettings;
	//	ffsfileCmd.ffsfile[MMSConfigFile].size=sizeof(mmsSettings);
	//	ffsfileCmd.ffsfile[MMSConfigFile].writeStatus=1;
	//if time is stop
#ifdef _INNOVATION_EMULATOR_

#else
    T_FFS_RET error;
    MMS_TRACE_FUNCTION("flash_MMSSettingswrite");
	error = ffs_file_write(FFSFILE_MMSSETTINGS_PATH, &mmsSettings,sizeof(mmsSettings),FFS_O_TRUNC);
	if(EFFS_OK  == error)
	{
       return 1; 
	}
	else
	{
	   MMS_TRACE_EVENT(("flash_MMSSettingswrite ERROR"));
	   return 0;
	}
#endif
}

effs_t flash_MMSSettingsread()
{
#ifdef _INNOVATION_EMULATOR_

#else
	T_FFS_RET ret;
	MMS_TRACE_FUNCTION("flash_MMSSettingsread");
	ret = ffs_file_read(FFSFILE_MMSSETTINGS_PATH, &mmsSettings, sizeof(mmsSettings));
	if(ret < 0)
		MMS_TRACE_EVENT(("flash_MMSSettingsread error %d",ret));
	return ret;
#endif
}

#if 0
void flash_MMSSettingsInfo()
{
    T_MMS_NET_SETTINGS settings;
	T_FFS_RET ret;
	ret = ffs_file_read(FFSFILE_MMSSETTINGS_PATH,&settings,sizeof(settings));
	MMS_TRACE_EVENT(("flash_MMSSettingsInfo ret=%d",ret));
	MMS_TRACE_EVENT(("curSettingsIndex=%d",settings.curSettingsIndex));
//	MMS_TRACE_EVENT(("settings",settings.allSettings[curSettingesIndx].strName);
}
#endif

#endif