unit fileop;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Grids,  DirOutln,
  ShellCtrls, ComCtrls, FileCtrl, ImgList;

type
  TForm_fileop = class(TForm)
    BitBtn3: TBitBtn;
    Edit_PC: TEdit;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    SpeedButton_uploadfile: TSpeedButton;
    SpeedButton_downloadfile: TSpeedButton;
    ListView_file: TListView;
    StatusBar_fileop: TStatusBar;
    TreeView_dir: TTreeView;
    ImageList_fileop: TImageList;
    SpeedButton_Delfile: TSpeedButton;
    SpeedButton_uploaddir: TSpeedButton;
    SpeedButton_downloaddir: TSpeedButton;
    SpeedButton_deldir: TSpeedButton;
    procedure BitBtn3Click(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure TreeView_dirChange(Sender: TObject; Node: TTreeNode);
    procedure SpeedButton_downloadfileClick(Sender: TObject);
    procedure SpeedButton_uploadfileClick(Sender: TObject);
    procedure SpeedButton_DelfileClick(Sender: TObject);
    procedure ListView_fileColumnClick(Sender: TObject;
      Column: TListColumn);
    procedure SpeedButton_downloaddirClick(Sender: TObject);
    procedure SpeedButton_uploaddirClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton_deldirClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    FLastIndex_file:Integer;
  public
    { Public declarations }
  end;

var
  Form_fileop: TForm_fileop;

implementation

uses global, main, progressbar;
{$R *.dfm}

function transdigital(s:string):string;//ȥļСеǧֺ
var i:integer;
begin
  i:=pos(',',s);
  while i>0 do
  begin
    delete(s,i,1);
    i:=pos(',',s);
  end;
  result:=s;
end;

function CustSortAsc(Item1, Item2:TListItem;ColIndex: Integer): Integer; stdcall;
var
  Item1Str:string;
  Item2Str:string;
begin
  Result := 0;
  Item1Str :='';
  Item2Str :='';

  if ColIndex < 0 then Exit;

  if ColIndex = 0 then
  begin
    Item1Str := Item1.Caption;
    Item2Str := Item2.Caption;
  end
  else
  begin
    if ColIndex <= Item1.SubItems.Count then
      Item1Str := Item1.SubItems[ColIndex - 1];
    if ColIndex <= Item2.SubItems.Count then
      Item2Str := Item2.SubItems[ColIndex - 1];
    if ColIndex=1 then
    begin
      item1str:=format('%.10d',[strtoint64(transdigital(item1str))]);
      item2str:=format('%.10d',[strtoint64(transdigital(item2str))]);;
    end;
  end;
  Result := CompareText(Item1Str, Item2Str);

  // If one of the strings is empty, make the other string sort before it

  if (Result > 0) and (Item2Str = '') then Result := -1
  else if (Result < 0) and (Item1Str ='') then Result := 1;
end; {= CustSortAsc =}

function CustSortDesc(Item1, Item2: TListItem;ColIndex: Integer): Integer; stdcall;
begin
  Result := CustSortAsc(Item1, Item2, ColIndex);
  Result := Result*-1;
end; {= CustSortDesc =}

procedure TForm_fileop.BitBtn3Click(Sender: TObject);
begin
  close;
end;

procedure pc_callback_FILEGetInfo(p:pointer);
var tempname:string;
    showstr:string;
begin
  if PPC_Interface_Info(p).status<>ord(PC_Error_NoError) then
  begin
    case PPC_Interface_Info(p).status of
      ord(PC_Error_SerialNoResponse):
      begin
        Form_fileop.statusbar_fileop.Panels[0].Text:='ͨѶʱ,ܴй';//˵targetӦtimeoutfor exampleserial is invalid
        Serial_Close;
        Form_fileop.StatusBar_fileop.Panels[1].Text:='δ';
      end;
      ord(PC_Error_MMINotAllow):Form_fileop.statusbar_fileop.Panels[0].Text:='ֻδͬ״̬˵';//ֻpcͬ ҪȽ˵->pcͬ
      ord(PC_Error_MMINeedPause):Form_fileop.statusbar_fileop.Panels[0].Text:='е绰ͬͣ';
    end;
    status_FILE:=PC_FILE_status_init;
    form_progressbar.ProgressBar1.Position:=1;
    form_progressbar.Hide;
    form_progressbar.close;
    Form_fileop.TreeView_dir.ClearSelection;
    Form_fileop.TreeView_dir.FullCollapse;
    Form_fileop.ListView_file.clear;
    if PPC_Interface_Info(p).pdata_cmd<>nil then
      freemem(PPC_Interface_Info(p).pdata_cmd);
    if PPC_Interface_Info(p).pdata_dlbuff<>nil then
      freemem(PPC_Interface_Info(p).pdata_dlbuff);
    if p<>nil then
     freemem(p);
    exit;
  end;
  case status_FILE of
    PC_FILE_status_init:
    begin
      if PPC_Interface_Info(p).pdata_cmd<>nil then
        freemem(PPC_Interface_Info(p).pdata_cmd);
      if PPC_Interface_Info(p).pdata_dlbuff<>nil then
        freemem(PPC_Interface_Info(p).pdata_dlbuff);
      if p<>nil then
       freemem(p);
      exit;
    end;
    PC_FILE_status_getfileinfo: //Sim绰ֻ绰ĵ绰Ŀ󣬴
    begin
      dogetfileinfo(p);
      Form_fileop.TreeView_dir.Cursor:=crDefault;
      Form_fileop.StatusBar_fileop.Panels[0].Text:='ȡĿ¼Ϣɣ';
    end;
    PC_FILE_status_DLfile:
    begin
      dodownloadfile(p);
      showstr:='ļʣ '+inttostr(fileList.Count-1)+'';
      form_progressbar.Label_status.Caption:=showstr;
      form_progressbar.ProgressBar1.StepIt;
      Form_fileop.FileListBox1.Update;//ʵʱ±ļĿ¼
      Form_fileop.FileListBox1.Selected[Form_fileop.FileListBox1.count-1]:=true; //Ҫѡһfilelistboxеļǰļͼ겻ʾ
      if filelist.Items[0]<>nil then freemem(filelist.Items[0]);
      filelist.Delete(0);
      if filelist.Count>0 then
      begin
        getfile(@pc_callback_FILEGetInfo,strpas(PFileRec(filelist.items[0]).Pathname)+'/'+strpas(PFileRec(filelist.items[0]).filename));
        exit;
      end;
      Form_fileop.FileListBox1.Update;//ʵʱ±ļĿ¼
      Form_fileop.statusbar_fileop.Panels[0].Text:='ļɣ';
      Form_fileop.FileListBox1.ClearSelection;
      Form_fileop.TreeView_dirChange(nil,Form_fileop.TreeView_dir.Selected);
      exit;//ΪҪȥ»ȡgetfileinfo,ֱ˳ȥstatus_FILE:=PC_FILE_status_init;
      //ȴҪһļϢܹصȽ
    end;
    PC_FILE_status_ULfile:
    begin
      douploadfile(p);
      showstr:='ļʣ '+inttostr(fileList.Count-1)+'';
      Form_progressbar.Label_status.Caption:=showstr;
      form_progressbar.ProgressBar1.StepIt;

      if filelist.Items[0]<>nil then freemem(filelist.Items[0]);
      filelist.Delete(0);
      if filelist.Count>0 then
      begin
        putfile(@pc_callback_FILEGetInfo,strpas(PFileRec(filelist.items[0]).filename),strpas(PFileRec(filelist.items[0]).Pathname)+'/');
        exit;
      end;
      Form_fileop.statusbar_fileop.Panels[0].Text:='ļɣ';
      Form_fileop.TreeView_dirChange(nil,Form_fileop.TreeView_dir.Selected);
      exit;//ΪҪȥ»ȡgetfileinfo,ֱ˳ȥstatus_FILE:=PC_FILE_status_init;
       //ȴҪһļϢܹصȽ
   end;
    PC_FILE_status_Delfile:
    begin
      doDelfile(p);
      form_progressbar.ProgressBar1.StepIt;
      tempname:=strpas(PFileRec(filelist.items[0]).filename);
      if filelist.Items[0]<>nil then freemem(filelist.Items[0]);
      filelist.Delete(0);
      if filelist.Count>0 then
      begin
        showstr:='ɾļʣ '+inttostr(fileList.Count)+'';
        form_progressbar.Label_status.Caption:=showstr;
        Delfile(@pc_callback_FILEGetInfo,strpas(PFileRec(filelist.items[0]).Pathname)+'/'+strpas(PFileRec(filelist.items[0]).filename));
        exit;
      end;
      Form_fileop.statusbar_fileop.Panels[0].Text:='ɾɣ';
      Form_fileop.FileListBox1.ClearSelection;
      if tempname='' then//ʾɾĿ¼ҪѡһĿ¼
        Form_fileop.TreeView_dir.Selected:=Form_fileop.TreeView_dir.Selected.Parent
      else//ʾɾļԾѡĿ¼
        Form_fileop.TreeView_dirChange(nil,Form_fileop.TreeView_dir.Selected);
      exit;//ΪҪȥ»ȡgetfileinfo,ֱ˳ȥstatus_FILE:=PC_FILE_status_init;
      //ȴҪһļϢܹصȽ
    end;
  end;
  status_FILE:=PC_FILE_status_init;
  form_progressbar.ProgressBar1.Position:=1;
  form_progressbar.Hide;
  form_progressbar.close;
end;

procedure TForm_fileop.FileListBox1Click(Sender: TObject);
var
  sr: TSearchRec;
  FileAttrs: Integer;
begin
  edit_pc.Text:=FileListBox1.FileName;
  FileAttrs:=0;
  if fileexists(edit_pc.text) then
  begin
    if FindFirst(edit_pc.Text, FileAttrs, sr) = 0 then
      FileListBox1.Hint:=format('%.0n',[sr.Size*1.0])+'ֽ';
  end;
end;

procedure TForm_fileop.TreeView_dirChange(Sender: TObject;
  Node: TTreeNode);
var pathname:string;
    tempnode:TTreeNode;
begin
  tempnode:=node;
  if tempnode=nil then exit;
  TreeView_dir.Cursor:=crHourGlass;
  pathname:='';
  if tempnode.level>0 then
  begin
    repeat
      pathname:='/'+tempnode.Text+pathname;
      tempnode:=tempnode.Parent;
      tempnode.ImageIndex:=1;
    until tempnode.Level=0;
  end else
    pathname:='/';
  status_FILE:=PC_FILE_status_Getfileinfo;
  getfileInfo(@pc_callback_FILEGetInfo,pathname);
  FLastIndex_file :=-1;
end;

procedure TForm_fileop.SpeedButton_downloadfileClick(Sender: TObject);
var pathname:string;
    tempnode:TTreeNode;
    itemSelected:TListItem;
    tempFileRec:PFileRec;
    showstr:string;
begin
  while FileList.Count>0 do
  begin
    if filelist.Items[0]<>nil then freemem(filelist.Items[0]);
    filelist.Delete(0);
  end;

  tempnode:=TreeView_dir.Selected;
  if tempnode=nil then exit;
  pathname:='';
  if tempnode.level>0 then
  begin
    repeat
      pathname:='/'+tempnode.Text+pathname;
      tempnode:=tempnode.Parent;
      tempnode.ImageIndex:=1;
    until tempnode.Level=0;
  end;

  itemSelected:=ListView_file.Selected;
  while itemSelected<>nil do
  begin
    if FileExists(Form_fileop.FileListBox1.Directory+'\'+itemSelected.Caption) then
      if MessageDlg('صļ'''+itemSelected.Caption+'''PCѴڣǷҪǣ',mtConfirmation, [mbYes, mbNo], 0)=mrNo then
        break;
    getmem(tempFileRec,sizeof(TFileRec));
    strpcopy(tempFileRec.Pathname,pathname);
    strpcopy(tempFileRec.Filename,itemSelected.Caption);
    tempFileRec.Filesize:=strtoint64(transdigital(itemSelected.SubItems[0]));
    tempFileRec.ReadOnly:=itemSelected.SubItems[1]='';
    FileList.Add(tempFileRec);
    itemSelected:=ListView_file.GetNextItem(itemSelected, sdAll, [isSelected]);
  end;

  if FileList.Count>0 then
  begin
    Form_fileop.statusbar_fileop.Panels[0].Text:='ļ';
    status_FILE:=PC_FILE_status_DLfile;
    getfile(@pc_callback_FILEGetInfo,strpas(PFileRec(filelist.items[0]).Pathname)+'/'+strpas(PFileRec(filelist.items[0]).filename));
    showstr:='ļ '+inttostr(filelist.Count)+'';
    form_progressbar.Label_status.Caption:=showstr;
    form_progressbar.ProgressBar1.Max:=filelist.Count+1;
    form_progressbar.ProgressBar1.Min:=1;
    form_progressbar.ProgressBar1.Step:=1;
    form_progressbar.ProgressBar1.Position:=1;
    form_progressbar.Showmodal;
    //    SpeedButton_download.Enabled:=false;
  end;
end;

procedure TForm_fileop.SpeedButton_uploadfileClick(Sender: TObject);
var tempitem:TListItem;
    pathname,filename:string;
    tempnode:TTreeNode;
    tempFileRec:PFileRec;
    sr: TSearchRec;
    FileAttrs: Integer;
    i:integer;
    showstr:string;
begin
  while FileList.Count>0 do
  begin
    if filelist.Items[0]<>nil then freemem(filelist.Items[0]);
    filelist.Delete(0);
  end;

  tempnode:=TreeView_dir.Selected;
  if tempnode=nil then exit;
  pathname:='';
  if tempnode.level>0 then
  begin
    repeat
      pathname:='/'+tempnode.Text+pathname;
      tempnode:=tempnode.Parent;
      tempnode.ImageIndex:=1;
    until tempnode.Level=0;
  end;


  for i:=0 to FileListBox1.Items.Count-1 do
  begin
    if FileListBox1.Selected[i] then
    begin
      if FileExists(filelistbox1.Directory+'\'+filelistbox1.Items[i]) then
      begin
        tempitem:=ListView_file.FindCaption(0,filelistbox1.Items[i],false,true,true);
        if tempitem<>nil then
        begin
          if MessageDlg('صļ'''+tempitem.Caption+'''ֻѴڣǷ񸲸ǣ'
               ,mtConfirmation, [mbYes, mbNo], 0)=mrNo then continue;
          if tempitem.subitems[1]='' then
          begin
            showmessage('Ҫǵļֻģ޷!');
            continue;
          end;
        end;

        getmem(tempFileRec,sizeof(TFileRec));
        strpcopy(tempFileRec.Pathname,pathname);
        filename:=filelistbox1.Directory+'\'+filelistbox1.Items[i];
        strpcopy(tempFileRec.Filename,filename);
        FileAttrs:=0;
        if fileexists(filename) then
        begin
          if FindFirst(filename, FileAttrs, sr) = 0 then
            tempFileRec.Filesize:=sr.Size;
        end;
        tempFileRec.ReadOnly:=false;
        FileList.Add(tempFileRec);
      end;
    end;
  end;
  if FileList.Count>0 then
  begin
    Form_fileop.statusbar_fileop.Panels[0].Text:='ļ';
    status_FILE:=PC_FILE_status_ULfile;
    putfile(@pc_callback_FILEGetInfo,strpas(PFileRec(filelist.items[0]).filename),strpas(PFileRec(filelist.items[0]).Pathname)+'/');
    showstr:='ļ '+inttostr(filelist.Count)+'';
    form_progressbar.Label_status.Caption:=showstr;
    form_progressbar.ProgressBar1.Max:=filelist.Count+1;
    form_progressbar.ProgressBar1.Min:=1;
    form_progressbar.ProgressBar1.Step:=1;
    form_progressbar.ProgressBar1.Position:=1;
    form_progressbar.Showmodal;
  end;
end;

procedure TForm_fileop.SpeedButton_DelfileClick(Sender: TObject);
var pathname:string;
    tempnode:TTreeNode;
    itemSelected:TListItem;
    tempFileRec:PFileRec;
    showstr:string;
begin
  while FileList.Count>0 do
  begin
    if filelist.Items[0]<>nil then freemem(filelist.Items[0]);
    filelist.Delete(0);
  end;

  tempnode:=TreeView_dir.Selected;
  if tempnode=nil then exit;
  pathname:='';
  if tempnode.level>0 then
  begin
    repeat
      pathname:='/'+tempnode.Text+pathname;
      tempnode:=tempnode.Parent;
      tempnode.ImageIndex:=1;
    until tempnode.Level=0;
  end;
  if MessageDlg('ȷҪɾ',mtConfirmation, [mbYes, mbNo], 0)=mrNo then exit;

  itemSelected:=ListView_file.Selected;
  while itemSelected<>nil do
  begin
    getmem(tempFileRec,sizeof(TFileRec));
    strpcopy(tempFileRec.Pathname,pathname);
    strpcopy(tempFileRec.Filename,itemSelected.Caption);
    tempFileRec.Filesize:=strtoint64(transdigital(itemSelected.SubItems[0]));
    tempFileRec.ReadOnly:=itemSelected.SubItems[1]='';
    FileList.Add(tempFileRec);
    itemSelected:=ListView_file.GetNextItem(itemSelected, sdAll, [isSelected]);
  end;
  if FileList.Count>0 then
  begin
    Form_fileop.statusbar_fileop.Panels[0].Text:='ɾļ';
    status_FILE:=PC_FILE_status_DeLfile;
    Delfile(@pc_callback_FILEGetInfo,strpas(PFileRec(filelist.items[0]).Pathname)+'/'+strpas(PFileRec(filelist.items[0]).filename));
    showstr:='ɾļ '+inttostr(filelist.Count)+'';
    form_progressbar.Label_status.Caption:=showstr;
    form_progressbar.ProgressBar1.Max:=filelist.Count+1;
    form_progressbar.ProgressBar1.Min:=1;
    form_progressbar.ProgressBar1.Step:=1;
    form_progressbar.ProgressBar1.Position:=1;
    form_progressbar.Showmodal;
  end;
end;

procedure TForm_fileop.ListView_fileColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  if FLastIndex_file = Column.Index then
  begin
    ListView_file.CustomSort(@CustSortDesc, Column.Index);
    FLastIndex_file := -1;
  end  else
  begin
    ListView_file.CustomSort(@CustSortAsc, Column.Index);
    FLastIndex_file := Column.Index;
  end;
end;

procedure TForm_fileop.SpeedButton_downloaddirClick(Sender: TObject);
var pathname,directory:string;
    tempnode:TTreeNode;
    itemSelected:TListItem;
    tempFileRec:PFileRec;
    i:integer;
    showstr:string;
begin
  if TreeView_dir.Selected<>nil then
  begin
    while FileList.Count>0 do
    begin
      if filelist.Items[0]<>nil then freemem(filelist.Items[0]);
      filelist.Delete(0);
    end;
    tempnode:=TreeView_dir.Selected;
    if tempnode=nil then exit;
    directory:=tempnode.Text;
    pathname:='';
    if tempnode.level>0 then
    begin
      repeat
        pathname:='/'+tempnode.Text+pathname;
        tempnode:=tempnode.Parent;
        tempnode.ImageIndex:=1;
      until tempnode.Level=0;
    end;
    if not DirectoryExists(FileListBox1.Directory+'\'+directory) then
    begin
      if not CreateDir(FileListBox1.Directory+'\'+directory) then
      begin
        raise Exception.Create('޷PCϴĿ¼'''+FileListBox1.Directory+'\'+directory+'''');
        exit;
      end;
    end else
      if MessageDlg('صĿ¼'''+FileListBox1.Directory+'\'+directory+'''PCѴڣǷҪȫǣ',mtConfirmation, [mbYes, mbNo], 0)=mrNo then exit;
    FileListBox1.Directory:=FileListBox1.Directory+'\'+directory;
    FileListBox1.Update;

    for i:=0 to ListView_file.Items.Count-1 do
    begin
      itemSelected:=ListView_file.Items[i];
      getmem(tempFileRec,sizeof(TFileRec));
      strpcopy(tempFileRec.Pathname,pathname);
      strpcopy(tempFileRec.Filename,itemSelected.Caption);
      tempFileRec.Filesize:=strtoint64(transdigital(itemSelected.SubItems[0]));
      tempFileRec.ReadOnly:=itemSelected.SubItems[1]='';
      FileList.Add(tempFileRec);
    end;

    if FileList.Count>0 then
    begin
      Form_fileop.statusbar_fileop.Panels[0].Text:='ļ';
      status_FILE:=PC_FILE_status_DLfile;
      getfile(@pc_callback_FILEGetInfo,strpas(PFileRec(filelist.items[0]).Pathname)+'/'+strpas(PFileRec(filelist.items[0]).filename));
      showstr:='ļ '+inttostr(filelist.Count)+'';
      form_progressbar.Label_status.Caption:=showstr;
      form_progressbar.ProgressBar1.Max:=filelist.Count+1;
      form_progressbar.ProgressBar1.Min:=1;
      form_progressbar.ProgressBar1.Step:=1;
      form_progressbar.ProgressBar1.Position:=1;
      form_progressbar.Showmodal;
      //    SpeedButton_download.Enabled:=false;
    end;
  end;
end;

procedure TForm_fileop.SpeedButton_uploaddirClick(Sender: TObject);
var pathname,filename:string;
    tempnode,childnode:TTreeNode;
    i:integer;
    tempFileRec:PFileRec;
    sr: TSearchRec;
    FileAttrs: Integer;
    showstr:string;
begin
  DirectoryListBox1.OpenCurrent;
  if DirectoryExists(FileListBox1.Directory) then
  begin
    while FileList.Count>0 do
    begin
      if filelist.Items[0]<>nil then freemem(filelist.Items[0]);
      filelist.Delete(0);
    end;

    tempnode:=TreeView_dir.Selected;
    if tempnode=nil then exit;
    pathname:='';
    if tempnode.level>0 then
    begin
      repeat
        pathname:='/'+tempnode.Text+pathname;
        tempnode:=tempnode.Parent;
        tempnode.ImageIndex:=1;
      until tempnode.Level=0;
    end;

    if TreeView_dir.Selected.HasChildren then
    begin
      childnode:=TreeView_dir.Selected.getFirstChild;
      while childnode<>nil do
      begin
        if childnode.Text=ExtractFileName(FileListBox1.Directory) then
          if MessageDlg('صĿ¼'''+pathname+'/'+childnode.Text+'''ֻѴڣǷҪȫǣ',mtConfirmation, [mbYes, mbNo], 0)=mrNo then
            exit
          else
            break;
        childnode:=childnode.GetNextSibling;
      end;
    end;

    for i:=0 to FileListBox1.Count-1 do
    begin
      getmem(tempFileRec,sizeof(TFileRec));
      strpcopy(tempFileRec.Pathname,pathname+'/'+ExtractFileName(FileListBox1.Directory));
      filename:=FileListBox1.Directory+'\'+FileListBox1.items[i];
      strpcopy(tempFileRec.Filename,filename);
      FileAttrs:=0;
      if fileexists(filename) then
      begin
        if FindFirst(filename, FileAttrs, sr) = 0 then
          tempFileRec.Filesize:=sr.Size;
      end;
      tempFileRec.ReadOnly:=false;
      FileList.Add(tempFileRec);
    end;

    if FileList.Count>0 then
    begin
      Form_fileop.statusbar_fileop.Panels[0].Text:='ļ';
      status_FILE:=PC_FILE_status_ULfile;
      putfile(@pc_callback_FILEGetInfo,strpas(PFileRec(filelist.items[0]).filename),strpas(PFileRec(filelist.items[0]).Pathname)+'/');
      showstr:='ļ '+inttostr(filelist.Count)+'';
      form_progressbar.Label_status.Caption:=showstr;
      form_progressbar.ProgressBar1.Max:=filelist.Count+1;
      form_progressbar.ProgressBar1.Min:=1;
      form_progressbar.ProgressBar1.Step:=1;
      form_progressbar.ProgressBar1.Position:=1;
      form_progressbar.Showmodal;
    end;
  end;
end;

procedure TForm_fileop.FormActivate(Sender: TObject);
begin
  TreeView_dir.SetFocus;
end;

procedure TForm_fileop.SpeedButton_deldirClick(Sender: TObject);
var pathname:string;
    tempnode:TTreeNode;
    tempFileRec:PFileRec;
begin
  if TreeView_dir.Selected<>nil then
  begin
    while FileList.Count>0 do
    begin
      if filelist.Items[0]<>nil then freemem(filelist.Items[0]);
      filelist.Delete(0);
    end;

    tempnode:=TreeView_dir.Selected;
    if tempnode=nil then exit;
    pathname:='';
    tempnode.Expanded:=true;
    if tempnode.level>0 then
    begin
      repeat
        pathname:='/'+tempnode.Text+pathname;
        tempnode:=tempnode.Parent;
        tempnode.ImageIndex:=1;
      until tempnode.Level=0;
    end;

    if MessageDlg('ȷҪɾĿ¼',mtConfirmation, [mbYes, mbNo], 0)=mrNo then exit;
//ɾĿ¼µļ
//    Form_fileop.TreeView_dir.Selected:=Form_fileop.TreeView_dir.Selected.Parent;
    getmem(tempFileRec,sizeof(TFileRec));
    strpcopy(tempFileRec.Pathname,pathname);
    strpcopy(tempFileRec.Filename,'');
    tempFileRec.Filesize:=0;
    tempFileRec.ReadOnly:=false;
    FileList.Add(tempFileRec);
    if FileList.Count>0 then
    begin
      Form_fileop.statusbar_fileop.Panels[0].Text:='ɾĿ¼';
      status_FILE:=PC_FILE_status_DeLfile;
      Delfile(@pc_callback_FILEGetInfo,strpas(PFileRec(filelist.items[0]).Pathname)+'/'+strpas(PFileRec(filelist.items[0]).filename));
      form_progressbar.Label_status.Caption:='ɾĿ¼';
      form_progressbar.ProgressBar1.Max:=filelist.Count+1;
      form_progressbar.ProgressBar1.Min:=1;
      form_progressbar.ProgressBar1.Step:=1;
      form_progressbar.ProgressBar1.Position:=1;
      form_progressbar.Showmodal;
    end;
  end;
end;

procedure TForm_fileop.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//  TreeView_dir.Selected:=nil;
end;

end.
