#ifndef _PC_PROTOCOLDLL_
#define _PC_PROTOCOLDLL_


#define DllImport   __declspec( dllimport )
#define DllExport   __declspec( dllexport )


//defien falg for pc_interface
#define PC_IF_FLAGS_DATAUL  0x01
#define PC_IF_FLAGS_CMD       0x02
#define PC_IF_FLAGS_DATADL  0x10

typedef void  ( *PC_HANDLE_CALLBACK)(void *);
typedef struct
{
	unsigned int flag;
	BYTE *pdata_cmd;
	unsigned int  size_cmd;
	BYTE *pdata_ulbuff;
	unsigned int size_ulbuff;
	BYTE *pdata_dlbuff;
	unsigned int size_dlbuff;
	
	unsigned int status;//ֵ
	PC_HANDLE_CALLBACK callback;
}PC_Interface_Info;


DllExport int  Serial_Open(unsigned char* name,unsigned baudtrate);
DllExport int Serial_Close();

DllExport void pcsyn_protocol_init();
DllExport void pcsyn_protocol_close();

DllExport int pc_interface(PC_Interface_Info * info);
//DllExport int pc_interface(void * info);

#endif