/* 
+----------------------------------------------------------------------------- 
|  Project :  GSM-F&D (8411)
|  Modul   :  CNF_SMI
+----------------------------------------------------------------------------- 
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  Dynamic Configuration for SMI
+----------------------------------------------------------------------------- 
*/ 

#ifndef CNF_SMI_H
#define CNF_SMI_H

/*==== CONSTANTS ==================================================*/
/*
 * CONFIGURATION PARAMETER
 *
 * Description :  The constants define the commands for dynamic
 *                configuration proposals.
 */

#define  SMI_KEY_SEQUENCE    "KEY_SEQUENCE"
#define  SMI_START_SS        "START_SS"
#define  SMI_EXT_TEST_ENABLE "EXT_TEST_ENABLE"

#ifdef BT_ADAPTER
#define  SMI_BT_PRIM         "BT_PRIM"
#endif /* BT_ADAPTER */

/*==== TYPES ======================================================*/

/*==== EXPORT =====================================================*/

#endif
