#
#	Setting Directory for WAP Objects
#


TARID := wap$(NNF)$(NCOMPTRC)
OBJ :=  $(L23_OBJ_DIR)/wap

SRCBMI=$(CONDAT_DIR)/ms/src/bmi
SRCACI=$(CONDAT_DIR)/ms/src/aci
SRCMFW=$(CONDAT_DIR)/ms/src/mfw
SRCWAP=$(CONDAT_DIR)/ms/src/wapaus


#
# ---------------- create WAP ---------------------
#
WAPOBJ =  $(OBJ)/wap_pei.$(OBJ_TAIL)\
          $(OBJ)/wap_csf.$(OBJ_TAIL)\
          $(OBJ)/wap_frame.$(OBJ_TAIL)\
          $(OBJ)/wap_udpc.$(OBJ_TAIL)\
          $(OBJ)/wap_udpf.$(OBJ_TAIL)\
          $(OBJ)/wap_udpp.$(OBJ_TAIL)\
          $(OBJ)/wap_tim.$(OBJ_TAIL)\
          $(OBJ)/wap_mem.$(OBJ_TAIL)\
          $(OBJ)/wap_codec.$(OBJ_TAIL)\
          $(OBJ)/wap_wapmmi.$(OBJ_TAIL)\
          $(OBJ)/wap_mmi.$(OBJ_TAIL)\
          $(OBJ)/wap_gle.$(OBJ_TAIL)\
          $(OBJ)/wap_mmip.$(OBJ_TAIL)\
          $(OBJ)/wap_wlbif.$(OBJ_TAIL)\
          $(OBJ)/wap_mmis.$(OBJ_TAIL)\
          $(OBJ)/wap_wta.$(OBJ_TAIL)\
          $(OBJ)/wap_examples.$(OBJ_TAIL)

$(WAP_LIB) : $(OBJ) $(WAPOBJ)
	$(AR) r $(WAP_LIB) $(WAPOBJ)

$(OBJ):	
	mkdir $(subst /,$(SLASH),$(OBJ))

		
clean:
	$(REMOVE) $(subst /,$(SLASH),$(OBJ))

$(WAPOBJ): $(OBJ)/%.$(OBJ_TAIL) : $(SRCWAP)/%.c
	echo -D$(NCONFIG) >  cmd
	echo -D$(NTRACE) >> cmd
	echo -D$(NWARN) >> cmd
	echo -DTRGT_G23 >> cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo -DAUS_CONDAT_TYPE_PORTING >> cmd
	echo -DWAP_TASK >> cmd
	echo -DDTI2 >> cmd
	echo $(COPT) >> cmd
	echo $(COPT1) >> cmd
	echo $(COTAR) >> cmd
	echo $(FDOPT) >> cmd
	echo -I$(CONDAT_BASE_DIR)/com/include >> cmd
	echo -i$(GPF_DIR)/INC >> cmd
	echo -I$(ICDG) >> cmd
	echo -I$(ICOM0) >> cmd
	echo -I$(ICOM1) >> cmd
	echo -I$(ICOM2) >> cmd
	echo $(ZHQDRV0) >> cmd
	echo $(ZHQDRV1) >> cmd
	echo $(ZHQDRV2) >> cmd
	echo -i$(SRCWAP) >> cmd
	echo -i$(SRCBMI) >> cmd
	echo -i$(SRCACI) >> cmd
	echo -i$(SRCMFW) >> cmd
	echo -I$(IAUS) >> cmd
	echo -I$(IAUSC) >> cmd
	echo -I$(IGLE) >> cmd
	echo -I$(IAUSOPTMEM) >> cmd
	echo -fr$(OBJ) >> cmd
	$(CC_PRE) $^ -@cmd
	$(CC_INT) $(addsuffix .pp,$(basename $^))
	$(CC_COM) $(addsuffix .pp_,$(basename $^)) -@cmd



