/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	                                                      
 $Project code:	                                                           
 $Module:		
 $File:		  	WapCodec.h
 $Revision:		                                                      
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		                                                          
                                                                               
********************************************************************************
                                                                              
 Description:
 	Function prototypes for WAP codec.
    
                        
********************************************************************************

 $History: wap_codec.h
	
	20/05/2003 - SPR#1934 - SH - Synchronised latest with 1.7.0 version.
	   
 $End

*******************************************************************************/

#ifdef WAP_TASK
void	wap_coder(UBYTE event_id, void* parameter);
UBYTE*	wap_coder_pack_event(UBYTE event_id, void* parameter, USHORT *size);
void 	wap_coder_free_packed_event(UBYTE* event_store, USHORT size);
void	wap_coder_add_element(UBYTE event_id, USHORT size, UBYTE* parameter);
void 	wap_coder_clear_elements();
void	wap_coder_send_buffered_list();
UBYTE	wap_coder_check_send();
void 	wap_decoder(UBYTE event_id, void* parameter);
void	wap_decoder_unpack_event(UBYTE event_id, void* data);
void	wap_offset_table(UBYTE event_id, USHORT offset_table[][2], USHORT *struct_size);
#else
void	mmi_coder(UBYTE event_id, void* parameter);
UBYTE*	mmi_coder_pack_event(UBYTE event_id, void* parameter, USHORT *size);
void 	mmi_coder_free_packed_event(UBYTE* event_store, USHORT size);
void	mmi_decoder(UBYTE event_id, void* parameter);
void	mmi_decoder_unpack_event(UBYTE event_id, void* data);
void	mmi_offset_table(UBYTE event_id, USHORT offset_table[][2], USHORT *struct_size);
#endif
