/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:                                                   
 $Project code:	                                                           
 $Module:		
 $File:		    AUIWap.h
 $Revision:		                                                      
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		                                                          
                                                                               
********************************************************************************
                                                                              
 Description:
 	Some definitions and internal function prototypes for the WAP AUI.
    
                        
********************************************************************************

 $History: AUIWap.h

	15/05/2003 - SPR#1983 - SH - Updated to latest from 1.6.3 version.
	   
 $End

*******************************************************************************/

/* Window indicators
 *
 * These flags are used to specify which windows will be destroyed in WAP_destroy
 */

#define WAP_WIN 			0x0001
#define MENU_WIN 			0x0002
#define OPTIONS_WIN 		0x0004
#define LIST_WIN 			0x0008
#define EDIT_WIN 			0x0010
#define OPTIONSMENU_WIN   0x0020
#define BROWSER_WIN 		0x0040
/* SPR#1189 - SH - Added CONNECT_WIN, removed ALL_NOT_WAP */
#define CONNECT_WIN			0x0080
#define OTHER_MENU_WIN		0x0100	

#define ALL_WIN 			0xFF

void		AUI_error_dialog(T_WAP_VIEW *View, SHORT errorCode);
T_WAP_RES	AUI_wap_input_dialog_open(T_WAP_MMI_INPUT_DIALOG_REQ *Dialog, T_WAP_VIEW *View);
T_WAP_RES	AUI_wap_password_dialog_open(T_WAP_MMI_PASSWORD_DIALOG_REQ *Dialog,T_WAP_VIEW *View);
T_WAP_RES	AUI_wap_confirm_dialog_open(T_WAP_MMI_CONFIRM_DIALOG_REQ *Dialog, T_WAP_VIEW *View);
T_WAP_RES	AUI_wap_info_dialog_open(T_WAP_MMI_INFO_DIALOG_REQ *Dialog, T_WAP_VIEW *View);
T_WAP_RES	AUI_wap_options_menu_open(UBYTE contextType);
T_WAP_RES	AUI_wap_CustSoftKey_menu_open(UBYTE contextType);
U8*			AUI_wap_memory_alloc(USHORT size);
U8			AUI_wap_memory_free(U8* address,U16 size);
void 		AUI_wap_change_soft_key(T_WAP_VIEW *View, USHORT *Label, USHORT length, USHORT keyId);
char*		AUI_wap_string(USHORT stringID);
//void info_screen (T_MFW_HND win, USHORT TextId, USHORT TextId2, T_VOID_FUNC  Callback);

#ifdef MMS_WAP_ENABLED
/********talcon add for mms***************/
int AUI_mms_start();

void AUI_mms_new_view();

void AUI_mms_close();

void AUI_mms_status_notify(T_WAP_VIEW *View, USHORT status);
#endif

