/****************************************************************************
 *
 *		Copyright (C) 2002-2003	YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: masnddrv.h
 *
 *		Description	: Header of DVA module
 *
 *		Version		: 1.0.2 	2003.02.05
 *
 ****************************************************************************/

#ifndef __MASNDDVA_H__
#define __MASNDDVA_H__

#include "mamachdep.h"
#include "madefs.h"

SINT32 MaDva_Initialize(UINT32 dAl, UINT32 dFm, UINT32 dWt, UINT32 dStream, UINT32 dAlt);
SINT32 MaDva_End(void);
SINT32 MaDva_GetAlt3Slot(UINT32 dKey);
SINT32 MaDva_GetFmSlot(UINT32 dCh, UINT32 dKey, UINT32 dMode);
SINT32 MaDva_GetWtSlot(UINT32 dCh, UINT32 dKey, UINT32 dMode);
SINT32 MaDva_GetStreamSlot(UINT32 dCh, UINT32 dKey, UINT32 dStereo);
SINT32 MaDva_ReleaseSlot(UINT32 dCh, UINT32 dKey);
UINT32 MaDva_ReleaseFmOnSlot(UINT32 dCh);
UINT32 MaDva_ReleaseWtOnSlot(UINT32 dCh);
UINT32 MaDva_ReleaseFmAllSlot(UINT32 dCh);
UINT32 MaDva_ReleaseWtAllSlot(UINT32 dCh);
SINT32 MaDva_ReleaseStreamSlot(UINT32 dCh, UINT32 dKey);
UINT32 MaDva_ReleaseStreamAllSlot(UINT32 dCh);
UINT32 MaDva_GetStreamKey(UINT32 dSlot);

#endif /*__MASNDDVA_H__*/
