/****************************************************************************
 *
 *		Copyright (C) 2002-2003	YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: mammfcnv.h
 *
 *		Description	: SMAF Converter
 *
 *		Version		: 2.0.0 	2003.04.29
 *
 ****************************************************************************/

#ifndef _MAMMFCNV_H
#define _MAMMFCNV_H


#define	MMF_CONTENTS_CLASS_0			0x00
#define	MMF_CONTENTS_CLASS_1			0x20

#define	MMF_CONTENTS_TYPE_0				0x00
#define	MMF_CONTENTS_TYPE_1				0x10
#define	MMF_CONTENTS_TYPE_2				0x20
#define	MMF_CONTENTS_TYPE_3				0x30
#define	MMF_CONTENTS_TYPE_4				0x40
#define	MMF_CONTENTS_TYPE_5				0x50


SINT32	MaMmfCnv_Initialize	( void );
SINT32	MaMmfCnv_End		( void );
SINT32	MaMmfCnv_Load		(UINT8* pbFile, UINT32 dFSize, UINT32 dMode, SINT32 (*pFunc)(UINT8 bId), void* pvExt_args);
SINT32	MaMmfCnv_Unload		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaMmfCnv_Open		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaMmfCnv_Standby	(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaMmfCnv_Close		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaMmfCnv_Seek		(SINT32 sdFile_id, UINT32 dPos, void* pvExt_args);
SINT32	MaMmfCnv_Start		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaMmfCnv_Stop		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaMmfCnv_Control	(SINT32 sdFile_id, UINT32 dCtrl_num, void* pvPrm, void* pvExt_args);

#endif
