/******************************************************************************
 * Power Task (pwr)
 * Design and coding by Svend Kristian Lindholm, skl@ti.com
 *
 * PWR Message Processing
 *
 * $Id: lcc_handle_timers.h,v 1.1.1.1 2004/06/19 06:00:29 root Exp $
 *
 ******************************************************************************/
#ifndef __PWR_HANDLE_TIMERS_H_
#define __PWR_HANDLE_TIMERS_H_

#include "lcc.h"

T_RV_RET process_pwr_handle_T1_expiration    (T_PWR_REQ *request);
T_RV_RET process_pwr_handle_T2_expiration    (T_PWR_REQ *request);
T_RV_RET process_pwr_handle_T3_expiration    (T_PWR_REQ *request);
T_RV_RET process_pwr_handle_T4_expiration    (T_PWR_REQ *request);
T_RV_RET process_pwr_handle_mmi_info_expiration(T_PWR_REQ *request);

void pwr_check_timers(void);
T_RVM_RETURN pwr_create_timer(UINT32 *timer_begin);
T_RVM_RETURN pwr_start_timer(UINT32 *timer_begin);

#endif
