/****************************************************************************/
/*                                                                          */
/*	File Name:	lcd_messages_ti.h												*/
/*                                                                          */
/*	Purpose:	This file contains data structures and functions prototypes */
/*				used to send events to the LCD SWE.							*/
/*                                                                          */
/*  Version		0.1															*/
/*																			*/
/* 	Date       	Modification												*/
/*  ------------------------------------									*/
/*  29/09/2000	Create														*/
/*																			*/
/*	Author		Davide Carpegna												*/
/*																			*/
/* (C) Copyright 2000 by Texas Instruments Incorporated, All Rights Reserved*/
/****************************************************************************/
#ifndef __LCD_MESSAGES_TI_H_
#define __LCD_MESSAGES_TI_H_


#ifdef _WINDOWS
#define _LCD_TI_CONTROL_ 1
#else
#ifdef TEST
#include "mmi.cfg"
#endif
#endif


#ifdef __cplusplus
extern "C"
{
#endif


/*#ifdef _LCD_TI_CONTROL_

#define LCD_Reset			lcd_reset
#define LCD_Clear			lcd_clear
#define LCD_Init			lcd_init
#define LCD_WriteString		lcd_write_string
#define LCD_WriteCenter		lcd_write_center
#define LCD_ClearString		lcd_clear_string
#define LCD_ClearWord		lcd_clear_word
#define LCD_PutPixel		lcd_put_pixel
#define LCD_ClearPixel		lcd_clear_pixel
#define LCD_DrawLine		lcd_draw_line
#define LCD_ClearLine		lcd_clear_line
#define LCD_DrawRectangle	lcd_draw_rectangle
#define LCD_ClearRectangle	lcd_clear_rectangle
#define LCD_DrawIcon		lcd_draw_icon
#define LCD_RefreshBloc		lcd_refresh_bloc
#define LCD_PixBlt			lcd_pix_blt
#define LCD_Enable			lcd_enable
#define LCD_SetPower		lcd_set_power
#define LCD_Cursor			lcd_cursor

#else

#define LCD_Reset()
#define LCD_Clear()			
#define LCD_Init()			
#define LCD_WriteString(row, column, string, mode)		
#define LCD_WriteCenter(string)		
#define LCD_ClearString(row)		
#define LCD_ClearWord(row, column, length)		
#define LCD_PutPixel(x, y)
#define LCD_ClearPixel(x, y)		
#define LCD_DrawLine(x1, y1, x2, y2)	
#define LCD_ClearLine(x1, y1, x2, y2)		
#define LCD_DrawRectangle(x1, y1, x2, y2)	
#define LCD_ClearRectangle(x1, y1, x2, y2)	
#define LCD_DrawIcon(x,y,icon_id)		
#define LCD_RefreshBloc(table,x_dim,y_dim,x_pos,y_pos)		
#define LCD_PixBlt(x_pos,y_pos,x_dim,y_dim,table)			
#define LCD_Enable(x)			
#define LCD_SetPower()		
#define LCD_Cursor(y,x)			


#endif*/

#define LCD_Reset lcd_reset
#define LCD_Clear	LCD_Clear_ll 		
#define LCD_Init LCD_Init_ll			
#define LCD_WriteString	LCD_Write_String	
#define LCD_WriteCenter	LCD_Write_Center	

#ifdef __cplusplus
}
#endif


#endif /* __LCD_MESSAGES_TI_H_ */

