/*******************************************************************************
 *
 * power.h
 *
 *
 * (C) Texas Instruments 2001
 *
 ******************************************************************************/

#ifndef __POWER_H__
#define __POWER_H__

#include "rv_defined_swe.h"	   // for RVM_PWR_SWE


/* Prototypes */
void Power_ON_Button(void);
void Power_ON_Remote(void);
void Switch_ON(void);
void Power_IT_WakeUp(void);
void Power_OFF_Button(void);
void Power_OFF_Remote(void);
void Power_ON_Reset(void); //Glowing,2004-07-25, add


#ifdef RVM_PWR_SWE
  void PWR_Charger_Plug(void);
  void PWR_Charger_Unplug(void);
#endif /* #ifdef RVM_PWR_SWE */

#endif /* __POWER_H__ */
