/*******************************************************************************
 *
 *  pwr_messages_i.h
 *
 * Purpose: Contains internal definitions used by PWR SWE. 
 * Author   Candice Bazanegue (c-brille@ti.com)
 *
 *
 * (C) Texas Instruments 2001
 *
 ******************************************************************************/

#ifndef __PWR_MESSAGES_I_H__
#define __PWR_MESSAGES_I_H__

#include "rv_general.h"
#include "pwr_api.h"
#include "spi_api.h"



/* Events that can be sent by the power SWE API to the SPI task */
#define PWR_SPI_INFO_BATTERY_EVT    (1)



/* Prototypes */

/* Functions used to send messages to the SPI task */
T_RV_RET pwr_spi_battery_info(CALLBACK_FUNC CallBack);

#endif /* __PWR_MESSAGES_I_H__ */