exception End_iteration

type unicode_block =
  BASIC_LATIN1
| LATIN1_SUPPLEMENT
| LATIN_EXTENDED_A
| LATIN_EXTENDED_B
| IPA_EXTENSIONS
| SPACING_MODIFIER_LETTERS
| COMBINING_DIACRITICAL_MARKS
| GREEK
| CYRILLIC
| ARMENIAN
| HEBREW
| ARABIC
| SYRIAC
| THAANA
| DEVANAGARI
| BENGALI
| GURMUKHI
| GUJARATI
| ORIYA
| TAMIL
| TELUGU
| KANNADA
| MALAYALAM
| SINHALA
| THAI
| LAO
| TIBETAN
| MYANMAR
| GEORGIAN
| HANGUL_JAMO
| ETHIOPIC
| CHEROKEE
| UNIFIED_CANADIAN_ABORIGINAL
| OGHAM
| RUNIC
| KHMER
| MONGOLIAN
| LATIN_EXTENDED_ADDITIONAL
| GREEK_EXTENDED
| GENERAL_PUNCTUATION
| SUPER_SUB_SCRIPTS
| CURRENCY_SYMBOLS
| COMBINING_MARKS
| LETTERLIKE_SYMBOLS
| NUMBER_FORMS
| ARROWS
| MATHEMATICAL_OPERATORS
| MISC_TECHNICAL
| CONTROL_PICTURES
| OCR
| ENCLOSED_ALPHA
| BOX_DRAWING
| BLOCK_ELEMENTS
| GEOMETRIC_SHAPES
| MISC_SYMBOLS
| DINGBATS
| BRAILLE
| CJK_RADICAL_SUPPLEMENT
| KANGXI_RADICALS
| IDEOGRAPHIC_DESCRIPTION
| CJK_SYMBOLS
| HIRAGANA
| KATAKANA
| BOPOMOFO
| HANGUL_COMPATIBILITY
| KANBUN
| BOPOFOMO_EXTENDED
| ENCLOSED_CJK
| CJK_COMPATIBLITY
| CJK_UNIFIED_A
| CJK_UNIFIED
| YI_SYLLABLES
| YI_RADICALS
| HANGUL_SYLLABLES
| HIGH_SURROGATES
| LOW_SURROGATES
| PRIVATE_A
| CJK_COMPATIBILITY_IDEOGRAPHS
| ALPHABETIC_PRESENTATION
| ARABIC_PRESENTATION_A
| COMBINING_HALF_MARKS
| CJK_COMPATIBILITY_FORMS
| SMALL_FORM_VARIANTS
| ARABIC_PRESENTATION_B
| SPECIALS
| HALFWIDTH
| OLD_ITALIC
| GOTHIC
| DESERET
| BYZANTINE_MUSICAL
| MUSICAL_SYMBOLS
| MATH_ALPHANUM
| CJK_UNIFIED_B
| CJK_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT
| TAGS
| PRIVATE_B
| PRIVATE_C
| SPECIALS_B
| HIGH_PRIVATE_SURROGATES


type interval = int*int

val interval_of_unicode_block : unicode_block -> interval

val new_iterator : unicode_block list -> (unit -> int)
