/************* Revision Controle System Header *************
 *                  GSM Layer 1 software 
 * L1_VAREX.H
 *
 *        Filename l1_varex.h
 *        Version  1.24
 *        Date     03/27/03
 *
 ************* Revision Controle System Header *************/

#ifdef L1_ASYNC_C

#if (LONG_JUMP == 3) || (LONG_JUMP == 4)
 #pragma DATA_SECTION(l1s,".l1s_global")
 #pragma DATA_SECTION(l1s_dsp_com,".l1s_global")
 #pragma DATA_SECTION(l1a_l1s_com,".l1s_global")
 #pragma DATA_SECTION(l1s_tpu_com,".l1s_global")
 #pragma DATA_SECTION(l1_config,".l1s_global")
#endif

 T_L1S_GLOBAL   l1s;
 T_L1A_GLOBAL   l1a;

 T_L1A_L1S_COM  l1a_l1s_com;
 T_L1S_DSP_COM  l1s_dsp_com;
 T_L1S_TPU_COM  l1s_tpu_com;

 // variables for L1 configuration
 T_L1_CONFIG    l1_config;

#else
 extern T_L1S_GLOBAL   l1s;
 extern T_L1A_GLOBAL   l1a;

 extern T_L1A_L1S_COM  l1a_l1s_com;
 extern T_L1S_DSP_COM  l1s_dsp_com;
 extern T_L1S_TPU_COM  l1s_tpu_com;

 // variables for L1 configuration
 extern T_L1_CONFIG    l1_config;
#endif


extern const UWORD8 ramBootCode[]; // dummy DSP code for boot.
  

