#include "emu.h"

#include "aci_cmh.h"
#include "aci_ext_pers.h"
#include "aci_slock.h"

/*
  Unlocks the lock of the given type after verifying the given password.
  The ACI extension for password verifying (see 2.3.9.1) will be used to
  determine if the given password is correct or not.
  On a successful unlock the actual status of the lock will be returned.
  If an error occurred SIMLOCK_FAIL will be returned.
  (Uses the ACI extension "personalisation data access".)
  */

T_SIMLOCK_STATUS aci_slock_unlock ( T_SIMLOCK_TYPE type, char *passwd )
{

}


/*
  Locks the lock of the given type.  On a successful lock the actual
  status of the lock will be returned. If an error occurred SIMLOCK_FAIL
  will be returned. This method will use the ACI extension for password
  verifying (see 2.3.9.1) to determine if the given password is correct
  or not. (Uses the ACI extension "personalisation data access".)
  */
T_SIMLOCK_STATUS aci_slock_lock ( T_SIMLOCK_TYPE type, char *passwd )
{
	
}

/*
  Checks the lock status of the given lock type.  On a successful
  check the status will be returned. If an error occurred SIMLOCK_FAIL
  will be returned. (Uses the ACI extension "personalisation data access".)
  */
T_SIMLOCK_STATUS aci_slock_checklock ( T_SIMLOCK_TYPE type )
{

}

/*
  Checks for all kinds of personalisation locks. The given IMSI will be checked against the internal 
  personalisation data. Returns SIMLOCK_BLOCKED, if one lock was not matching the given IMSI.
  */
T_SIMLOCK_STATUS aci_slock_checkpersonalisation( void )
{

}
