export
AOBJ := $(AUSYSTEM_DIR)/obj/obj_aus

AUS_SRC_DIR=$(AUSYSTEM_DIR)/Gwc/source

AUS_OPT_MEM_SRC_DIR=$(AUSYSTEM_DIR)/Gwc/optional/memory

IAUS_OPT_MEM = $(AUSYSTEM_DIR)/Gwc/optional/memory

AUS_LIB_DIR=$(AUSYSTEM_DIR)/lib

#xmzhou AUS_LIB_REL_DIR=$(AUS_REL_DIR)/lib
AUS_LIB_REL_DIR=$(AUSYSTEM_DIR)/lib

AUS_LIB=$(AUS_LIB_DIR)/ausystem$(NNTRC).lib

AUS_REL_LIB = $(AUS_LIB_REL_DIR)/ausystem$(NNTRC).lib

AUSOPTMEMOBJ = $(AOBJ)/wip_mem.$(OBJ_TAIL)

#
# use internal memory allocator
#
AUS_WIP_MALLOC = 1

AUSOBJ1 =  $(AOBJ)/buffmgt.$(OBJ_TAIL) \
     $(AOBJ)/cache.$(OBJ_TAIL) \
     $(AOBJ)/capiclnt.$(OBJ_TAIL) \
     $(AOBJ)/capimem.$(OBJ_TAIL) \
     $(AOBJ)/capimmi.$(OBJ_TAIL) \
     $(AOBJ)/capiudp.$(OBJ_TAIL) \
     $(AOBJ)/capiwta.$(OBJ_TAIL) \
     $(AOBJ)/cmmnrsrc.$(OBJ_TAIL) \
     $(AOBJ)/ctypes.$(OBJ_TAIL) \
     $(AOBJ)/dbfunct.$(OBJ_TAIL) \
     $(AOBJ)/glbldecl.$(OBJ_TAIL) \
     $(AOBJ)/hdrutil.$(OBJ_TAIL) \
     $(AOBJ)/header.$(OBJ_TAIL) \
     $(AOBJ)/history.$(OBJ_TAIL) \
     $(AOBJ)/mk_cpu.$(OBJ_TAIL) \
     $(AOBJ)/mk_main.$(OBJ_TAIL) \
     $(AOBJ)/mk_outp.$(OBJ_TAIL) \
     $(AOBJ)/mk_queu.$(OBJ_TAIL) \
     $(AOBJ)/mk_sche.$(OBJ_TAIL) \
     $(AOBJ)/mk_user.$(OBJ_TAIL) \
     $(AOBJ)/ml_buf.$(OBJ_TAIL) \
     $(AOBJ)/ml_err.$(OBJ_TAIL) \
     $(AOBJ)/ml_mem.$(OBJ_TAIL) \
     $(AOBJ)/pdubuf.$(OBJ_TAIL) \
     $(AOBJ)/prov_dec.$(OBJ_TAIL) \
     $(AOBJ)/provif.$(OBJ_TAIL) \
     $(AOBJ)/sctpred.$(OBJ_TAIL) \
     $(AOBJ)/si_bpi.$(OBJ_TAIL) \
     $(AOBJ)/si_crpto.$(OBJ_TAIL) \
     $(AOBJ)/si_float.$(OBJ_TAIL) \
     $(AOBJ)/si_frame.$(OBJ_TAIL)

AUSOBJ2 =	 $(AOBJ)/si_fs.$(OBJ_TAIL)\
     $(AOBJ)/si_instr.$(OBJ_TAIL) \
     $(AOBJ)/si_int.$(OBJ_TAIL) \
     $(AOBJ)/si_libs.$(OBJ_TAIL) \
     $(AOBJ)/si_list.$(OBJ_TAIL) \
     $(AOBJ)/si_misc.$(OBJ_TAIL) \
     $(AOBJ)/si_ops.$(OBJ_TAIL) \
     $(AOBJ)/si_re.$(OBJ_TAIL) \
     $(AOBJ)/si_sdl.$(OBJ_TAIL) \
     $(AOBJ)/si_si.$(OBJ_TAIL) \
     $(AOBJ)/si_sq.$(OBJ_TAIL) \
     $(AOBJ)/si_var.$(OBJ_TAIL) \
     $(AOBJ)/si_varop.$(OBJ_TAIL) \
     $(AOBJ)/si_wtaia.$(OBJ_TAIL) \
     $(AOBJ)/sptp_tls.$(OBJ_TAIL) \
     $(AOBJ)/stackmgr.$(OBJ_TAIL) \
     $(AOBJ)/storage.$(OBJ_TAIL) \
     $(AOBJ)/trnscode.$(OBJ_TAIL) \
     $(AOBJ)/url.$(OBJ_TAIL) \
     $(AOBJ)/wae.$(OBJ_TAIL) \
     $(AOBJ)/wae_cmmn.$(OBJ_TAIL) \
     $(AOBJ)/wae_ua.$(OBJ_TAIL) \
     $(AOBJ)/wae_wsp.$(OBJ_TAIL) \
     $(AOBJ)/waectype.$(OBJ_TAIL) \
     $(AOBJ)/waedef.$(OBJ_TAIL) \
     $(AOBJ)/waepckg.$(OBJ_TAIL) \
     $(AOBJ)/wap.$(OBJ_TAIL) \
     $(AOBJ)/wapcvt.$(OBJ_TAIL) \
     $(AOBJ)/wbxmldec.$(OBJ_TAIL) \
     $(AOBJ)/wbxmlelm.$(OBJ_TAIL) \
     $(AOBJ)/wdp.$(OBJ_TAIL) \
     $(AOBJ)/wdp_udp.$(OBJ_TAIL) \
     $(AOBJ)/wdp_ul.$(OBJ_TAIL) \
     $(AOBJ)/wdppckg.$(OBJ_TAIL) \
     $(AOBJ)/wdpsuppt.$(OBJ_TAIL) \
     $(AOBJ)/wipdb.$(OBJ_TAIL) \
     $(AOBJ)/wiptimer.$(OBJ_TAIL) \
     $(AOBJ)/wml_mmi.$(OBJ_TAIL) \
     $(AOBJ)/wml_uafn.$(OBJ_TAIL) \
     $(AOBJ)/wmlelm.$(OBJ_TAIL) \
     $(AOBJ)/wmlevent.$(OBJ_TAIL) \
     $(AOBJ)/wmlif.$(OBJ_TAIL) \
     $(AOBJ)/wmlparse.$(OBJ_TAIL) \
     $(AOBJ)/wmltoken.$(OBJ_TAIL) \
     $(AOBJ)/wsp.$(OBJ_TAIL) \
     $(AOBJ)/wspclwdp.$(OBJ_TAIL) \
     $(AOBJ)/wspcmwtp.$(OBJ_TAIL) \
     $(AOBJ)/wspif.$(OBJ_TAIL) \
     $(AOBJ)/wspprocl.$(OBJ_TAIL) \
     $(AOBJ)/wspprocm.$(OBJ_TAIL) \
     $(AOBJ)/wtai_if.$(OBJ_TAIL) \
     $(AOBJ)/wtp_wdp.$(OBJ_TAIL) \
     $(AOBJ)/wtppckg.$(OBJ_TAIL) \
     $(AOBJ)/wtpprvdr.$(OBJ_TAIL) \
     $(AOBJ)/wtpsar.$(OBJ_TAIL) \
     $(AOBJ)/wtpsuppt.$(OBJ_TAIL) \
     $(AOBJ)/xml_conv.$(OBJ_TAIL) 
