/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

	GleElementType type; /* total size = 42 bytes */
	UINT16 chunkSize;
	struct GleElementNode *next;
	struct GleElementNode *prev;

	/*Virtual member functions*/
	BOOL (*RenderX)();
	VOID (*RenderY)();
	VOID (*Draw)();
	#ifdef SUPPORT_PEN_NAVIGATION
		BOOL (*Contains)();
	#endif
	#ifdef SUPPORT_KEY_NAVIGATION
		BOOL (*IsMarkable)();
	#endif
	VOID (*Destruct)();
	VOID (*Selected)();
