/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __GLEOPTION_H__
	#define __GLEOPTION_H__
	
	#include "tapigle.h"
	#include "engine.h"
	#include "gleelem.h"
	#include "gleview.h"
	
/*	typedef struct GleCloseOptionGroupNode 
		{
		#include "baseobj.h"
		} GleCloseOptionGroup;
	
	typedef struct GleOptionNode 
		{
		#include "baseobj.h"
		GleRectangleType bounds;
		UINT8		viewId; 
		BOOL		multipleSelected; 	
		BOOL		isInverted; 		
		UINT8		optionId;
		UINT16  	ascent;			
		VOID*		singleSelect;
		GLE_STRING	label;
		GLE_STRING	title;
		} GleOption;
		
	typedef struct GleOptionGroupNode 
		{
		#include "baseobj.h"
		GleRectangleType bounds;
		GLE_STRING	label;
		UINT16  	ascent;
		} GleOptionGroup;
*/	
	BOOL 	   GleCloseOptionGroupRenderX(GleCloseOptionGroup* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth);
	GleElement *GleCloseOptionGroupConstruct(VOID);
	VOID 	   GleOptionGroupDraw(GleViewType* viewP, const GleOptionGroup* self);
	BOOL 	   GleOptionGroupRenderX(GleOptionGroup* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID* viewP);
	VOID 	   GleOptionGroupDestruct(GleOptionGroup* self);
	GleElement *GleOptionGroupConstruct(const WCHAR *label);
	#ifdef SUPPORT_PEN_NAVIGATION
		BOOL 	   GleOptionContains(GleViewType* viewP, const GleOption *self, GlePointType point);
	#endif
/*	BOOL 	   GleOptionContains(const GleOption *self, GlePointType point);*/
	VOID 	   GleOptionDraw(GleViewType* viewP, const GleOption* self);
	#ifdef SUPPORT_KEY_NAVIGATION 
		BOOL 	   GleOptionIsMarkable(GleViewType* viewP, const GleOption* self);
	#endif
	BOOL 	   GleOptionRenderX(GleOption* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth);
	VOID	   GleOptionSelected(GleViewType* viewP, GleOption* self);
	VOID 	   GleOptionDestruct(GleOption* self);
	GleElement *GleOptionConstruct(UINT8 viewId, UINT8 optionId, const WCHAR *label, const WCHAR *title, BOOL isSelected);
	
#endif