/*
 * Copyright (C) Ericsson Mobile Communications AB, 2000.
 * Licensed to AU-System AB.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * Neither Ericsson Mobile Communications AB nor AU-System AB
 * assumes any responsibility or liability for any errors or inaccuracies in
 * this software, or any consequential, incidental or indirect damage arising
 * out of the use of the Generic WAP Client software.
 */

 /*---------------------Revision history------------------
 version         date         author          comment
 0.01           2002/9/17    ganchh          according with condat porting guid


 ------------------------------------------------------*/
 #if 0
 //--------condat porting guid with BMI 1.6.0 primary
 #if !defined TRGT_VXWORKS && !defined TRGT_SEOS
	/*  INT8    :   8 bit signed integer    */
	typedef signed char     INT8;
	/*  UINT8   :   8 bit unsigned integer  */
	typedef unsigned char   UINT8;
	/*  INT16   :   16 bit signed integer   */
		typedef signed short    INT16;
	/*  UINT16  :   16 bit unsigned integer */
#ifndef AUS_CONDAT_TYPE_PORTING	
	typedef unsigned short  UINT16;
#endif
#ifndef TBNG
	/*  INT32   :   32 bit signed integer   */
	typedef signed long     INT32;
	/*  UINT32  :   32 bit unsigned integer */
	#ifndef AUS_CONDAT_TYPE_PORTING	
		typedef unsigned long   UINT32;
	#endif
#endif
#endif

.

#if !defined TRGT_VXWORKS && !defined _WINDOWS_
	#ifdef TRGT_REX
		typedef char            BOOL;
	#elif defined TRGT_SDLM
		typedef UINT8			BOOL;
	#else
		#ifndef AUS_CONDAT_TYPE_PORTING 			
			typedef UINT8             BOOL;
		#endif
	#endif
#endif
.

#if !defined TRGT_SDLM
	#ifndef AUS_CONDAT_TYPE_PORTING		
		typedef unsigned char BYTE;
	#endif

#else
		typedef UINT8 BYTE;
#endif
.
#if !defined TRGT_SEOS
		#ifndef AUS_CONDAT_TYPE_PORTING		
			typedef char     CHAR;
		#endif
#elif defined TRGT_G23
		typedef INT8	 CHAR;		
#else
		typedef unsigned char     CHAR;
#endif
.
#ifndef TRGT_VXWORKS
	#ifdef TRGT_SDLM
		typedef UINT8        UCHAR;
	#else
		#ifndef AUS_CONDAT_TYPE_PORTING		
			typedef unsigned char   UCHAR;
		#endif
	#endif
#endif

.
#ifndef _WINDOWS_
	#ifdef TRGT_SDLM
		typedef UINT16        WCHAR;
	#elif defined TRGT_SEOS
		typedef unsigned int WCHAR;
   	#elif defined TRGT_G23
//JVJ		typedef int WCHAR;
		typedef unsigned short  WCHAR;
	#else
		typedef unsigned short  WCHAR;
	#endif
#endif
#endif
#ifndef TAPICMMN_H
#define TAPICMMN_H


#include "wiptrgt.h"


#if defined TRGT_VXWORKS			
	#include "types/vxTypesOld.h"
#endif

#if 0 //aus primary code
/*  Generic type definitions    */
#if !defined TRGT_VXWORKS && !defined TRGT_SEOS
	/*  INT8    :   8 bit signed integer    */
	typedef signed char     INT8;
	/*  UINT8   :   8 bit unsigned integer  */
	typedef unsigned char   UINT8;
	/*  INT16   :   16 bit signed integer   */
	typedef signed short    INT16;
	/*  UINT16  :   16 bit unsigned integer */
	typedef unsigned short  UINT16;
#ifndef TBNG
	/*  INT32   :   32 bit signed integer   */
	typedef signed long     INT32;
	/*  UINT32  :   32 bit unsigned integer */
	typedef unsigned long   UINT32;
#endif
#endif

#endif


//following definition is from condat porting guide 2002/9/17
 #if !defined TRGT_VXWORKS && !defined TRGT_SEOS
	/*  INT8    :   8 bit signed integer    */
#ifndef _FFS_H_
  //ganchh 2002/9/17
	typedef signed char     INT8;
	/*  UINT8   :   8 bit unsigned integer  */
	typedef unsigned char   UINT8;
	/*  INT16   :   16 bit signed integer   */
		typedef signed short    INT16;
	/*  UINT16  :   16 bit unsigned integer */
#endif
#ifndef AUS_CONDAT_TYPE_PORTING	
	typedef unsigned short  UINT16;
#endif
#ifndef TBNG
	/*  INT32   :   32 bit signed integer   */
#ifndef  GENERAL_H
	typedef signed long     INT32;
#endif
	/*  UINT32  :   32 bit unsigned integer */
	#ifndef AUS_CONDAT_TYPE_PORTING	
		typedef unsigned long   UINT32;
	    typedef unsigned long ULONG;  //added by ganchunhui 2002/9/25
	#endif
#endif
#endif
//end of condat porting guide change



#ifdef TRGT_SEOS
	/*  INT8    :   8 bit signed integer    */
	typedef signed char     INT8;
	/*  UINT8   :   8 bit unsigned integer  */
	typedef unsigned char   UINT8;
	/*  INT16   :   16 bit signed integer   */
	typedef signed int    INT16;
	/*  UINT16  :   16 bit unsigned integer */
	typedef unsigned int  UINT16;
	/*  INT32   :   32 bit signed integer   */
	typedef signed long     INT32;
	/*  UINT32  :   32 bit unsigned integer */
	typedef unsigned long   UINT32;
	typedef unsinged long  ULONG;   //added by ganchunhui 2002/9/25
#endif


/*  FLOAT32 :   32 bit real */
/*  If no real type exist for the host device, map to any integer. See also the static configuration variable HAS_REAL. */
#ifdef HAS_FLOAT
	typedef float           FLOAT32;
#else
	typedef INT32           FLOAT32;
#endif


#if 0  //aus primary code
/*  BOOL    :   1 bit integer   */
#if !defined TRGT_VXWORKS && !defined _WINDOWS_
	#ifdef TRGT_REX
		typedef char            BOOL;
	#elif defined TRGT_SDLM
		typedef UINT8			BOOL;
	#else
		typedef int             BOOL;
	#endif
#endif
#endif


//the following code is from condat wap porting guide bmi 1.6.0
#if !defined TRGT_VXWORKS && !defined _WINDOWS_
	#ifdef TRGT_REX
		typedef char            BOOL;
	#elif defined TRGT_SDLM
		typedef UINT8			BOOL;
	#else
		#ifndef AUS_CONDAT_TYPE_PORTING 			
			typedef UINT8             BOOL;
		#endif
	#endif
#endif
//end of condat porting


#if 0 //aus primary code
/*  BYTE    :   8 bit unsigned integer  */
#if !defined TRGT_SDLM
		typedef unsigned char BYTE;
#else
		typedef UINT8 BYTE;
#endif

#endif 

// from condat wap porting guide for BMI 1.6.0
#if !defined TRGT_SDLM
	#ifndef AUS_CONDAT_TYPE_PORTING		
		typedef unsigned char BYTE;
	#endif

#else
		typedef UINT8 BYTE;
#endif
//end of condat porting code


#if 0 //aus primary code
/*  CHAR    :   8 bit character  */
#if !defined TRGT_SEOS
		typedef char     CHAR;
#elif defined TRGT_G23
		typedef INT8	 CHAR;		
#else
		typedef unsigned char     CHAR;
#endif

#endif

//from condat wap porting guide bmi 1.6.0
#if !defined TRGT_SEOS
		#ifndef AUS_CONDAT_TYPE_PORTING		
			typedef char     CHAR;
		#endif
#elif defined TRGT_G23
		typedef INT8	 CHAR;		
#else
		typedef unsigned char     CHAR;
#endif
//end of condat porting guide


#if 0 //aus primary code
/*  UCHAR   :   8 bit unsigned character    */
#ifndef TRGT_VXWORKS
	#ifdef TRGT_SDLM
		typedef UINT8        UCHAR;
	#else
		typedef unsigned char   UCHAR;
	#endif
#endif

/*  WCHAR   :   16 bit unsigned character   */
#ifndef _WINDOWS_
	#ifdef TRGT_SDLM
		typedef UINT16        WCHAR;
	#elif defined TRGT_SEOS
		typedef unsigned int WCHAR;
   	#elif defined TRGT_G23
		typedef int WCHAR;
	#else
		typedef unsigned short  WCHAR;
	#endif
#endif

#endif


//from condat wap porting guide for BMI 1.6.0
#ifndef TRGT_VXWORKS
	#ifdef TRGT_SDLM
		typedef UINT8        UCHAR;
	#else
		#ifndef AUS_CONDAT_TYPE_PORTING		
			typedef unsigned char   UCHAR;
		#endif
	#endif
#endif

#ifndef _WINDOWS_
	#ifdef TRGT_SDLM
		typedef UINT16        WCHAR;
	#elif defined TRGT_SEOS
		typedef unsigned int WCHAR;
   	#elif defined TRGT_G23
//JVJ		typedef int WCHAR;
		typedef unsigned short  WCHAR;
	#else
		typedef unsigned short  WCHAR;
	#endif
#endif

//end of condat porting

/*  VOID    :   A special type indicating the absence of any value. */
#ifndef VOID
	#define VOID            void
#endif


/*  Constants   */
/*  NULL    :   Integer value 0 */
#ifndef NULL
	#define NULL    0
#endif

/*  TRUE    :   Integer value 1 */
#ifndef TRUE
	#define TRUE    1
#endif

/*  FALSE   :   Integer value 0 */
#ifndef FALSE
	#define FALSE   0
#endif


/*
device dependent constant that describes
the minimum alignment for memory addresses that
malloc returns. Ex:
struct
{
    char    *t; <- address 0x00000000
    char    *p; <- address 0x00000004
}
As the example illustrates takes the two variables in
the struct normally 8 bytes on a device with 32 bit
addresses. Some devices needs, however, further padding.
On a sparc processor must memory addresses be aligned
with 8 bytes. The struct would in that case take 16 bytes.
*/
#define MEM_ADDRESS_ALIGNMENT 4


#endif
