/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		display
 $File:		    font_bitmaps.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
	The book controller module provides the external
	interface to the phone book. It provides ALL external
	entry points to the phone book system.
                        
********************************************************************************

 $History: font_bitmaps.h

	25/10/00			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/



#define NUM_FONTS 257


typedef struct{

USHORT code;
UBYTE  format;
UBYTE  height;
UBYTE width;
UBYTE bitmap_size;
char* bitmap;
}t_font_bitmap;


extern const t_font_bitmap database[NUM_FONTS];

#ifndef EASY_TEXT_ENABLED
//#define EASY_TEXT_ENABLED
#endif

#ifndef CHINESE_MMI
  #define CHINESE_MMI
#endif

