//6.19 chenjun add a function DrawCpointLine()


#if defined (NEW_FRAME)
        #include "typedefs.h"
        #include "gdi.h"        
        #include "vsi.h"
        #include "custom.h"
        #include "gsm.h"
    #else

        #include "stddefs.h"
        #include "gdi.h"        
        #include "custom.h"
        #include "gsm.h"
    #endif


#include "GameDisplay.h"
#include "dspl.h"


 void DrawPoint(game_Point   param)
 {
 int oldcolor;
 oldcolor=dspl_SetFrgColor(param.color);
 dspl_DrawPoint(param.x, param.y);
 dspl_SetFrgColor(oldcolor);
}
 void DrawCircle(game_Circle  param)
 {
 int oldcolor;
 oldcolor=dspl_SetFrgColor(param.color);
 dspl_DrawCircle(param.x,param.y,param.radius);
 dspl_SetFrgColor(oldcolor);
 oldcolor=dspl_SetBkgColor(param.fillcolor);
 dspl_fill_Circle(param.x,param.y,param.radius);
 dspl_SetBkgColor(oldcolor);
 }
 void DrawRectagle(game_Rectangle  param)
 {
 int oldcolor;
 oldcolor=dspl_SetFrgColor(param.color);
 dspl_DrawRect(param.x1,param.y1,param.x2,param.y2);
 dspl_SetFrgColor(oldcolor);
 oldcolor=dspl_SetBkgColor(param.fillcolor);
 dspl_fill_rectangle(param.x1,param.y1,param.x2,param.y2);
 dspl_SetBkgColor(oldcolor);
 }
void DrawLine(game_Line  param)
{
int oldcolor;
 oldcolor=dspl_SetFrgColor(param.color);
 dspl_DrawLine(param.x1,param.y1,param.x2,param.y2);
 dspl_SetFrgColor(oldcolor);
}
void DrawCpointLine(CPoint point_start, CPoint point_end, USHORT ulinewidth, ULONG  ucolor)
{
 int oldcolor;
 int oldpensize;
 oldcolor=dspl_SetFrgColor(ucolor);
 oldpensize=dspl_set_pen_size(ulinewidth);
 dspl_DrawLine(point_start.x,point_start.y,point_end.x,point_end.y);
 dspl_SetFrgColor(oldcolor);
 dspl_set_pen_size(oldpensize);
}

#if 1
int GetGameColor(game_color g_color)
{
   int color;
   if(g_color>=MaxGameColor)
   	return 0x0;//chenjun :this should never happen,maybe we can return a color like red to avoid wrong
   switch(g_color)
  {
     case WHITE :return 0xffffff ; break;//ɫ white ffffff 
     case RED:return 0xff0000 ; break;// ɫ red ff0000 
    case GREEN:return 0x00ff00 ; break;// ɫ green 00ff00 
    case BLUE:return 0x0000ff ; break;// ɫ blue 0000ff 
    case MAGENTA:return 0xff00ff  ; break;// Һɫ magenta ff00ff 
    case CYAN:return 0x00ffff ; break;// ǳɫ cyan 00ffff 
    case YELLOW:return 0xffff00 ; break;// ɫ yellow ffff00 
    case BLACK:return 0x000000 ; break;// ɫ black 000000 
    case AQUAMARINE:return 0x70db93 ; break;// ɫ aquamarine 70db93 
    case BRONZE:return 0x8c7853 ; break;// ͭɫbronze 8c7853 
    case COPPER:return 0xb87333 ; break;// ͭɫ copper b87333 
    case FELDSPAR:return 0xd19275 ; break;// ʯɫ feldspar d19275 
    case GOLD:return 0xcd7f32 ; break;// ɫ gold cd7f32 
    case GRAY:return 0xc0c0c0 ; break;// ɫ gray c0c0c0 
    case KHAKI:return 0x9f9f9f; break;// ɫ khaki 9f9f9f 
    case MAROON:return 0x8e236b ; break;// ɫ maroon 8e236b 
    case ORANGE:return 0xff7f00 ; break;// ɫ orange ff7f00 
    case ORCHID:return 0xdb70db ; break;// ɫ orchid db70db 
    case PINK:return 0xbc8f8f ; break;// ۺɫ pink bc8f8f 
    case PLUM:return 0xeaadea; break;// ÷ɫ plum eaadea
    case QUARTZ:return 0xd9d9f3; break;// ʯӢɫ quartz d9d9f3 
    case SALMON:return 0x6f4242 ; break;// ɫ salmon 6f4242 
    case SCARLET:return 0x8c1717; break;// ʺɫ scarlet 8c1717 
    case SILVER:return 0xe6e8fa ; break;// ɫ silver e6e8fa 
    case THISTLE:return 0xd8bfd8; break;// ɫ thistle d8bfd8 
    case TURQUOISE:return 0xadeaea ; break;// ɫ turquoise adeaea 
    case VIOLET:return 0x4f2f4f ; break;// ɫ violet 4f2f4f 
    case WHEAT:return 0xd8d8bf ; break;// Сɫ wheat d8d8bf 
    case ALICEBLUE:return 0xf0f8ff; break;// ˹ aliceblue f0f8ff 
    case ANTIQUEWHITE:return 0xfaebd7 ; break;// Ű antiquewhite faebd7 
    case AZURE:return 0xf0ffff ; break;// ɫ azure f0ffff 
    case BEIGE:return 0xf5f5dc ; break;// ɫ beige f5f5dc 
    case BISQUE:return 0xffe4c4 ; break;// ɫ bisque ffe4c4 
    case BLANCHEDALMOND:return 0xffebcd ; break;//  blanchedalmond ffebcd 
    case BLUEVIOLET:return 0x8a2be2 ; break;// ɫ blueviolet 8a2be2 
    case BROWN:return 0xa52a2a ; break;// ɫ brown a52a2a 
    case BURLYWOOD:return 0xdeb887 ; break;// Ӳľͷ burlywood deb887 
    case CADETBLUE:return 0x5f9ea0 ; break;//  cadetblue 5f9ea0 
    case CHARTREUSE:return 0x7ff000 ; break;// ɫ chartreuse 7ff000 
    case CHOCOLATE:return 0xd2691e ; break;// Һɫ chocolate d2691e 
    case CORAL:return 0xff7f50 ; break;// ɺɫ coral ff7f50 
    case CORNFLOWERBLUE:return 0x6495ed ; break;//  cornflowerblue 6495ed 
    case CORNSILK:return 0xfff8dc ; break;//  cornsilk fff8dc 
    case CRIMSON:return 0xdc143c ; break;// ʺɫ crimson dc143c 
    case DARKBLUE:return 0x00008b ; break;// ɫ darkblue 00008b 
    case DARKCYAN:return 0x008b8b; break;// ɫ darkcyan 008b8b 
    case DARKGOLDENROD:return 0xffffff ; break;//  darkgoldenrod b8860b 
    case DARKGRAY:return 0xffffff ; break;// ɫ darkgray a9a9a9 
    case DARKGREEN:return 0x006400; break;// īɫ darkgreen 006400 
    case DARKKHAKI:return 0xbdb76b ; break;// ɫ darkkhaki bdb76b 
    case DARKMAGENTA:return 0x8b008b ; break;// Ϻɫ darkmagenta 8b008b 
    case DARKOLIVEGREEN:return 0x556b2f ; break;//  darkolivegreen 556b2f 
    case DARKORANGE:return 0xff8c00 ; break;// ɫ darkorange ff8c00 
    case DARKORCHID:return 0x9932cc ; break;//  darkorchid 9932cc 
    case DARKRED:return 0x8b0000 ; break;// ɫ darkred 8b0000 
    case DARKSALMON:return 0xe9967a ; break;// Ⱥɫ darksalmon e9967a 
    case DARKSEAGREEN:return 0x8fbc8f; break;// ɫ darkseagreen 8fbc8f 
    case DARKSLATEBLUE:return 0x483d8b; break;// ɫ darkslateblue 483d8b 
    case DARKSLATEGRAY:return 0x2f4f4f ; break;// ɫ darkslategray 2f4f4f 
    case DARKTURQUOISE:return 0x00ced1; break;//  darkturquoise 00ced1 
    case DARKVIOLET:return 0x9400d3 ; break;// ɫ darkviolet 9400d3 
    case DEEPPINK:return 0xff1493; break;// طۺtɫ deeppink ff1493 
    case DEEPSKYBLUE:return 0x00bfff ; break;//  deepskyblue 00bfff 
    case DIMGRAY:return 0x696969 ; break;// ɫ dimgray 696969 
    case DODGERBLUE:return 0x1e90ff; break;//  dodgerblue 1e90ff 
    case FIREBRICK:return 0xb22222 ; break;// ͻשɫ firebrick b22222 
    default :return 0x0;break;
  }
   
   		
}
#endif
