/* 
+------------------------------------------------------------------------------
|  File:       glob_defs.h
+------------------------------------------------------------------------------
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  Definitions for the fixed dimensions of frame.
+----------------------------------------------------------------------------- 
*/ 

#ifndef GLOB_DEFS_H
#define GLOB_DEFS_H

#define VSI_CALLER                   0,

#define GUARD_PATTERN        0xAFFEDEAD

#define RESOURCE_NAMELEN             8

#define MAX_POOL_GROUPS	             3	/* maximum number of partition groups */
#define MAX_POOLS_PER_GROUP	         6	/* maximum number of partition pools in one group */
#define MAX_MEMORY_POOLS	           1	/* maximum number of dynamic memory pools */ 

#endif
