#ifndef _MMI_QQ_WINDOW_H_
#define _MMI_QQ_WINDOW_H_

#include "mmiQQSwitch.h"

#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		QQ
 $File:		    MmiQQ.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    16/12/02                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
	This module provides the phone book search window functionality for the
	phone book module of the basic MMI
                        
********************************************************************************
 $History: MmiQQ.h

	16/12/02			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/
#define	MAX_QQSer_NUMBER		5	//hxl add for QQ 2002-12-17
#define	MAX_QQ_NUMBER		15
#define MAX_QQ_NAME			15
#define MAX_QQ_INFO			21	//qq info
#define DATETIME_LEN		18	//date time
#define NEXT_POS			5	//next item pos in pqqfile ,contract with the file top
#define MAX_QQ_DATA			50	//max QQ item in two file,qqfile and qqtempfile
#define	MenuLine			8
#define	MAX_QQFRI_NUMBER		20	//max qq friend 
#define  MAX_QQ_PW			20
#define	MAX_QQ_MEMO			30
#define	MAX_NETFRI_NUMBER	8
#define  MAX_QQ_PIC			10
#define	MAX_QQ_SEX			4
#define  MAX_QQ_AGE			6
# if 0
typedef enum
{
	Fri_list=1,
	Sys_info_list=1,
	Chat_info_list,
	Unread_info_list
}EDataListType;
#endif

typedef enum
{
	SEL_NONE=0,
	SEL_TELECOM,
	SEL_UNICOM
}QQ_SERVICE;

typedef enum
{
	QQ_INIT=0,
	QQ_LEFT,
	QQ_RIGHT,
	QQ_CLEAR,
	QQ_DESTROY
} tQQMessageEvents;

typedef enum
{
  EditNAME,
  EditNUMBER,
  EditMEMO,
  EditPW,
  EditOPTION ,
  BeforeSerOn,
  AfterService
} EDIT_QQ_MODE;

typedef enum
{
	sending=QQDummy,
	send_ok,
	send_fail,
	send_QQ_ok,
	send_QQ_fail,
	destroy_seltwowin,
	backto_listpa,
	destroy_one,
	only_info,
	ask_info,
	get_netfri_ok,
	get_netfri_fail,
	wait_net_fri,
	backto_viewWin,
	delAllSys_ask_info,
	delAllChat_ask_info
	
}T_QQCMD_STATUS;

typedef enum
{
	NOT_QQ=-3,
	NO_SPACE=-2,	//no space,please delete,or updtate the oldest one?
	ALLOC_FAIL=-1,
	Is_QQ=1,
	Is_Spec_QQ=2,//ring and del ,but it don't in qq info;
	Is_Left_Info=3,
	QQ_ALLOC_FAIL=4,
	Is_Invalid_QQ=5//don't ring,del it directly;or it is left qq will ring later
}RETURNINFO;

typedef enum
{
	Not_qqcmd=0,
	Service_off,
	Service_on,
	Recieve_off,
	Recieve_on,
	send_QQ,
	read_new_QQ,
	set_bind_QQ,
	ask_QQ_num,
	get_net_fri,
	see_fri_info,
	forward_QQ,
	reply_QQ,
	get_left_info,
	Find_QQ,
	Find_by_random
}T_QQCMD;

typedef struct _T_QQSEND_
{
	T_QQCMD	QQsendmsg;		//is QQsnedmsg >0  other sms msg:0
	MfwHnd	sendingwin;
	uint8	QQCheck;
	MfwHnd	sendingpawin;
	T_QQCMD	sendQQtype;		//is forward_QQ or reply_QQ
}T_QQSEND;

typedef struct
{
  unsigned char year[2];
  unsigned char month[2];
  unsigned char day[2];
  unsigned char hour[2];
  unsigned char minute[2];
  unsigned char second[2];
} TDateTime;

typedef enum{
	Blank=0x30,//0x30:
	Unread_sys,//0x31:δsys
	Readed_sys,//0x32:Ѷsys
	Unread_fri,//0x33:δfri
	Readed_fri,//0x34:Ѷfri
	Unread_Left,		// 0x35:δ
	Readed_Left,		// 0x36:Ѷ
	Sent,		//0x37:ѷ
	All_sys,//0x38
	All_chat,//0x39
	All_Unread,//0x3a
	All_left//0x3b
}TQQTYPE;

typedef struct
{
	TQQTYPE		type;     
	char		QQnumber[MAX_QQ_NUMBER+3 ];	//
	char		QQname[ MAX_QQ_NAME+3];		//ǳ
	char		len[4];//QQϢ,max 600
	char		*QQSms;			//QQϢָ
	unsigned char		QQpic;//ͷ
	TDateTime    dt;
	uint8		index;//
}TQQItem;

typedef struct T_QQ_data
{
	T_MFW_HND			win;
	T_MFW_HND			dynamicmenu_win;
	T_MFW_HND			menu_options_win;
	T_MFW_HND			QQselmenu;
	T_MFW_HND			editorNamewin;
	T_MFW_HND			editorNumberwin;
	T_MFW_HND			editorMemowin;
	T_MFW_HND			editorPWwin;
	T_MFW_HND			editorsmswin;
	
	char				edt_buf_name[MAX_QQ_NAME+3];
	char				edt_buf_number[MAX_QQ_NUMBER+3];
	MfwEdtAttr			edt_attr_number;
	char				edt_buf_password[MAX_QQ_PW+3];
	char				edt_buf_memo[MAX_QQ_MEMO+3];
	char				edt_buf_share[MAX_QQ_MEMO+3];
	char				edt_buf_sms[MAX_MSG_LEN_ARRAY-60+3];
	int					EditMODE;
	
	int					select_index;//sel index in menu list
} T_QQ;


/* Each window uses a standard message block containing references
   to the keyboards, editors, menues etc.
*/
typedef struct _tQQInputSpecifics_
{
    int 		text;
    MfwEdtAttr	*edt_attr_input;
    int         left_soft_key;
    int         right_soft_key;
	short		abc;
    void		(* callback)( T_MFW_HND win,uint8 reason );
} tQQInputSpecifics;

typedef struct _tQQStandard_
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       win;
	T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       edt;
    T_MFW_HND       tim;
    T_MFW_HND       menu;
	T_QQ			*QQ;
	tQQInputSpecifics properties;
 	T_EDITOR_DATA  editor_data;
} tQQStandard;

int FindQQ_ByQQ(MfwMnu* m, MfwMnuItem* i);
int FindQQ_ByNick(MfwMnu* m, MfwMnuItem* i);
int setQQRecieveOn(MfwMnu* m, MfwMnuItem* i);
int setQQRecieveOff(MfwMnu* m, MfwMnuItem* i);
int setQQServiceOn(MfwMnu* m, MfwMnuItem* i);
int setQQServiceOff(MfwMnu* m, MfwMnuItem* i);
int Get_NVM_Friend(MfwMnu *m, MfwMnuItem *item ) ;
int Get_NET_Friend(MfwMnu* m, MfwMnuItem* i);
int Add_New_friend(MfwMnu* m, MfwMnuItem* i);
int Get_System_info(MfwMnu* m, MfwMnuItem* i);
int Get_left_info(MfwMnu* m, MfwMnuItem* i);
int Get_chat_info(MfwMnu* m, MfwMnuItem* i);
int FindQQ_Random(MfwMnu* m, MfwMnuItem* i);
int Set_QQ_Bind(MfwMnu* m, MfwMnuItem* i);
int SendQQ_Start(MfwMnu* m, MfwMnuItem* i);
int Del_QQ_Fri(MfwMnu* m, MfwMnuItem* i);
int Del_QQ_Sms(MfwMnu* m, MfwMnuItem* i);
int See_QQ_Datas(MfwMnu* m, MfwMnuItem* i);
int ADD_TO_NVMFri(MfwMnu* m, MfwMnuItem* i);
int Del_ALL_QQ_Sms(MfwMnu* m, MfwMnuItem* i);
int Ask_QQ_number(MfwMnu* m, MfwMnuItem* i);
int Show_QQ_help(MfwMnu* m, MfwMnuItem* i);
int	Reply_QQ_Start(MfwMnu* m, MfwMnuItem* i);
int	Forward_QQ_Start(MfwMnu* m, MfwMnuItem* i);
int Cancel_QQ_Bind(MfwMnu* m, MfwMnuItem* i);
int Del_ALL_QQ_Fri(MfwMnu* m, MfwMnuItem* i);
int Del_ALL_SysQQ(MfwMnu* m, MfwMnuItem* i);
int Del_ALL_ChatQQ(MfwMnu * m, MfwMnuItem * i);

USHORT get_current_service( struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi );
USHORT In_Sms_Menu( struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi );
USHORT In_QQ_Menu( struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi );
USHORT In_SpeQQ_Menu( struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi );
void FreeListMemory();

extern T_QQSEND	QQsend;
extern int	QQReadNewSms;
extern uint8	nsms;//for check qq,2003-3-16


void SentQQ_CB(USHORT	status);
int	IsQQSms(char * smsNumber,char * smsInfo, void * t,int	 Iswrite);
int	check_new_sms(int	IsdelPreidx,uint8 delidx);
int	readQQfile(int havefile);
void	freeQQsmsMem(void);
int idle_display_QQ_status(int* noOfMsgs);
int Get_Unread_info(T_MFW_HND parent_win);
int View_left_info(void);

/*******************************************************************************
                               End of File
*******************************************************************************/
#endif
#endif
