#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "mfw_sys.h"
//#include "typedef.h"
//#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"
#include "p_sim.h"
#include "cus_aci.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_sat.h"
#include "dspl.h"
#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiBookShared.h"
//#include "bmieastapi.h"

//#include "mmiicnother.h"
#include "Gamedisplay.h"
#include "mmi3dframe.h"
#include "mmiblklangdb.h"
//#include "mmigameicons.h"
#include "mmigame.h"
#include "MmiRussia.h"
#include "mmidialogs.h"
#include "..\bmi\icons\GameRussiaIcn.h"
#include "..\bmi\icons\GameIcn.h"


#include "mmiutilapi.h"

typedef game_color TColor;
#define russiagame 101
#define RUSSIAHELPINIT 22

#define RUSSIA_REMAINCOLOR

//#define Russiaframe Russia_BkgAttr[0].icons

typedef enum 
{
 MoveLeft,
 MoveRight,
 MoveUp,
 MoveDown,
 MoveNone
}R_MoveAspect;

typedef enum 
{
 R_Init,
 R_Ready,
 R_Start,
 R_Stop
}GameState;

typedef enum
{
#ifndef GAME_SUBMENU
	Russia_Initstate,
#endif
	Russia_Gamestate,
	Russia_Exitstate,
	Russia_Overstate,
	Russia_Scorestate,
	Russia_Settingstate,
	Russia_Helpstate,
	Russia_Maxmode
}Russia_State;

Russia_State l_mode;
#if (MAIN_LCD_SIZE==3)

static int Current_Select;
#endif
#define RUSSIA_R_KEYCOUNT_MAX 3
typedef struct
{
    T_MMI_CONTROL   mmi_control;		// common control parameter
	T_MFW_HND  win;
	T_MFW_HND  kbd;
	T_MFW_HND  kbd_long;
	T_MFW_HND	menu;
	T_MFW_HND 	parent_win;
	T_MFW_HND  timer;   

    U8 russiaTimeflag;
	S32 R_Speed;		
	int R_Score,R_Level,R_Count;
	int	R_keycount;//δͷµİ,RUSSIA_R_KEYCOUNT_MAX
	
	/* talcon : add the following line */
	int	R_LineCount;									//total lines 
	
	UBYTE R_Preview,R_Nextview;
	UBYTE Prekeycode;//δͷµİϢused by timerµĿƶ
	/*2003,talcon add*/
	UBYTE R_NextviewColor;
    GameState CurState;   
    UBYTE R_Coordinate[LINEROW][LineNumber];
    UBYTE R_DummySiteAndStyle[4];
	//2003/10/17,talcon,ǰѡ״̬,ͣ
	U8 R_CurSlect,R_AnimType,R_AnimIndx;
} T_game_russia;

/*2003/11/24,talcon add */
typedef enum
{
	RussiaNone =0,
	RussiaDiamond1 ,
	RussiaDiamond2,
	RussiaDiamond3,
	RussiaDiamond4,
	RussiaDiamond5,
	RussiaDiamond6,
	RussiaDiamond7,
	RussiaDiamondEnd
};

typedef struct 
{
	int offsetX;
	int offsetY;
}T_RussiaStyle_Offset;

typedef struct 
{
	T_RussiaStyle_Offset offset[4];
	UBYTE				next;
}T_RussiaStyle_Data;

T_RussiaStyle_Data R_StyleData[]=
{
	//stytle 1
	{	
		{ { 0, 0 },{ -1, 0 },{ 0,-1 },{ -1,-1 } },
		1
	},
	//stytle 2
	{
		{ { 0, 0 },{ 1, 0 },{ -1,-1 },{ 0,-1 } },
		8
	},
	//stytle 3
	{	
		{ { 0, 0 },{ -1, 0 },{ 0,-1 },{ 1,-1 } },
		9
	},
	//stytle 4
	{
		{ { 0, 0 },{ -1, 0 },{ 0,-1 },{ 1, 0 } },
		10
	},
	//stytle 5
	{	
		{ { 0, 0 },{ -1, 0 },{ -1,1 },{ 1, 0 } },
		13
	},
	//stytle 6
	{	
		{ { 0, 0 },{ -1, 0 },{ 1, 0 },{ 1,1 } },
		16
	},
	//stytle 7
	{	
		{ { 0, 0 },{ 1, 0 },{ 2, 0 },{ 3, 0 } },
		19
	},
	//stytle 8
	{	
		{ { 0, 0 },{ -1, 0 },{ -1,1 },{ 0,-1 } },
		2
	},
	//stytle 9
	{	
		{ { 0, 0 },{ -1,-1 },{ -1, 0 },{ 0,1 } },
		3
	},
	//stytle 10
	{	
		{ { 0, 0 },{ 0,-1 },{ 0,1 },{ -1, 0 } },
		11
	},
	//stytle 11
	{	
		{ { 0, 0 },{ -1, 0 },{ 1, 0 },{ 0,1 } },
		12
	},
	//stytle 12
	{	
		{ { 0, 0 },{ 0,-1 },{ 1, 0 },{ 0,1 } },
		4
	},
	//stytle 13
	{	
		{ { 0, 0 },{ 0,-1 },{ 0,1 },{ 1,1 } },
		14
	},
	//stytle 14
	{
		{ { 0, 0 },{ -1, 0 },{ 1, 0 },{ 1,-1 } },
		15
	},
	
	//stytle 15
	{	
		{ { 0, 0 },{ -1,-1 },{ 0,-1 },{ 0,1 } },
		5
	},
	//stytle 16
	{	
		{ { 0, 0 },{ 0,-1 },{ 0,1 },{ 1,-1 } },
		17
	},
	//stytle 17
	{
		{ { 0, 0 },{ -1, 0 },{ 1, 0 },{ -1,-1 } },
		18
	},
	//stytle 18
	{
		{ { 0, 0 },{ -1,1 },{ 0,1 },{ 0,-1 } },
		6
	},
	//stytle 19
	{
		{ { 0, 0 },{ 0,1 },{ 0,2 },{ 0,3 } },
        7
	}
};
/*end talcon add */
UBYTE CheckShapeLegal(UBYTE Dummy_X,UBYTE Dummy_Y,T_RussiaStyle_Data *pData,T_game_russia *parameter);
UBYTE removeShape(T_game_russia *parameter);

extern INT8 g_norejectkeyflag;
extern ffsgamedata ffs_gamedata;

GameScore *Russia_Score=(GameScore *)&ffs_gamedata.Russia_ffsScore;



/*Russia Diamond uesed function */
void    Draw_PreviewShape(UBYTE style,UBYTE color);
void    Draw_PreviewDiamond(UBYTE diamondcolor,U16 xposition,U16 yposition);
void    DrawDiamond (UBYTE Offset_x,UBYTE Offset_y,UBYTE diamondcolor,T_game_russia *parameter);
void    Draw_Shape (UBYTE Offset_x,UBYTE Offset_y,UBYTE Style,UBYTE diamondcolor,Boolean InitSite,T_game_russia *parameter);
void    ChangeShape(UBYTE Dummy_X,UBYTE Dummy_Y,UBYTE Style,UBYTE diamondcolor,T_game_russia *parameter);
void    ClearRow(UBYTE Row,T_game_russia *parameter);
Boolean JudgeLine(UBYTE Row,UBYTE State,T_game_russia *parameter);
Boolean MoveRow(UBYTE Row,T_game_russia *parameter);
Boolean MoveShape(UBYTE Dummy_X,UBYTE Dummy_Y,UBYTE Style,UBYTE diamondcolor,R_MoveAspect Way,T_game_russia *parameter);
Boolean JudgeCoordinate(UBYTE Dummy_X,UBYTE Dummy_Y,UBYTE Style);

T_MFW_HND GameRussiaStart (MfwHnd parent);
T_MFW_HND GameRussiaCreate( MfwHnd parent );
void        GameRussiaDialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
int         GameRussia_win_cb (MfwEvt e, MfwWin *w);
int         GameRussia_kbd_cb (MfwEvt e, MfwKbd *k);
void        GameRussia_tim_cb(T_MFW_EVENT event,T_MFW_TIM * t);
void Dspl_Difficult(T_game_russia * data,UBYTE diffcult);
void Dspl_TotalLines(int lines);
void DrawText(U8 uX,U8 uY,U32 uColor,char *pszText);
void Russia_MnuItemIcnShow(T_game_russia * data);
void drawRussiaBkg();		
void drawRussiaBkgByZone(int posX,int posY,int nWidth,int nHeight);				  
void Dspl_Score(int score);

extern GLOBAL int get_StringWidth(char *string);

//˹鹦ģ麯
void DrawDiamond(UBYTE Offset_x,UBYTE Offset_y,UBYTE diamondcolor,T_game_russia *parameter)
{
	U16 xposition, yposition;
	U8 diaType = diamondcolor & 0x0f;

	if(Offset_x >=LINEROW || Offset_y >=LineNumber)return;
	//zgzTraceDataFunc("DrawDiamond diamondcolor", (U16)diamondcolor);
	xposition=BenchMark_X+Offset_x*DiamondWidth;
	yposition=BenchMark_Y+Offset_y*DiamondWidth;
	
	switch(diaType)
	{
	case RussiaNone:
		//dspl_BitBlt(xposition, yposition, FKSIZE, FKSIZE, 0, (void *)Russiaback, 0);
		dspl_BitBlt_ext(xposition, yposition,
			Offset_x*DiamondWidth,Offset_y*DiamondWidth, 
			FKSIZE, FKSIZE,
			DiamondWidth * LINEROW,DiamondWidth * LineNumber,
			0, (void *)GET_ICONATTR(ICON_RUSSIA_BKG,0)->icons, 0);
		break;
	case RussiaDiamond1:
	case RussiaDiamond2:
	case RussiaDiamond3:
	case RussiaDiamond4:
	case RussiaDiamond5:
	case RussiaDiamond6:
	case RussiaDiamond7:
		dspl_BitBlt(xposition, yposition, FKSIZE, FKSIZE, 0, 
			(void *)((char*)GET_ICONATTR(ICON_RUSSIA_DIAMONDS,0)->icons+FKSIZE * FKSIZE * 2 * (diaType - RussiaDiamond1)) , 0);
	  break;
	}

	parameter->R_Coordinate[Offset_x][Offset_y]=diamondcolor;
}//end Function:DrawDiamond

void Draw_Shape(UBYTE Offset_x,UBYTE Offset_y,
				UBYTE Style,UBYTE diamondcolor,
				Boolean InitSite,T_game_russia *parameter)
{

 U8 umode;

  umode=dspl_Enable(0);

 if (diamondcolor )
 {
    parameter->R_DummySiteAndStyle[0]=Offset_x;
    parameter->R_DummySiteAndStyle[1]=Offset_y;
    parameter->R_DummySiteAndStyle[2]=Style;
    parameter->R_DummySiteAndStyle[3]=diamondcolor;

 }

 /*2003/11/24,talcon modify*/
 if((int)Style>=1 && (int)Style<=19)
 {
	 T_RussiaStyle_Offset *pOffsetData = R_StyleData[Style-1].offset;
	 int i;
	for(i = 0; i< 4; i++)
	{
		DrawDiamond(Offset_x + pOffsetData->offsetX,Offset_y + pOffsetData->offsetY,
			diamondcolor,parameter);
		pOffsetData ++ ;
	}
 }

 /*end talcon modify*/
 dspl_Enable(umode);
}

/**************************************************
$History:
********2003/11/24,talcon add
************************************************/
void Draw_PreviewShape(UBYTE style,UBYTE color)
{
 UBYTE diamondtype,diamondcolor;
 U16 xposition,yposition;
 UBYTE StartBitX=86,StartBitY=27;

	
 xposition=PREVIEWXPOS;
	 yposition=PREVIEWYPOS;
	 diamondtype=style;
	 diamondcolor=color;
 
 //dspl_BitBlt(PREVIEWXPOS, PREVIEWYPOS, 30, 30, 0, (void *)Prebackgrd, 0);
	 drawRussiaBkgByZone(PREVIEWXPOS,PREVIEWYPOS,PREVIEWWIDTH,PREVIEWHEIGHT);
 /*2003/11/24,talcon modify*/
#if 1
	 if((int)style>=1 && (int)style<=19)
	 {
		 T_RussiaStyle_Offset *pOffsetData = R_StyleData[style-1].offset;
		 int i;
		 int left = 0,right = 0,top = 0,bottom = 0;
		 for(i = 0; i< 4; i++)
		 {
			 if(left > pOffsetData->offsetX)
				 left = pOffsetData->offsetX;
			 else if(right < pOffsetData->offsetX )
				 right = pOffsetData->offsetX ;
			 if(top > pOffsetData->offsetY)
				 top = pOffsetData->offsetY;
			 else if(bottom < pOffsetData->offsetY )
				 bottom = pOffsetData->offsetY ;
			 pOffsetData ++ ;
		 }
		 pOffsetData -=4;
		 xposition += (PREVIEWWIDTH - (right - left) * FKSIZE)/2 
			 + (pOffsetData->offsetX - left) * FKSIZE;
		 yposition += (PREVIEWHEIGHT - (bottom - top) * FKSIZE)/2
			 + ( pOffsetData->offsetY - top ) * FKSIZE;
 
		 for(i = 0; i< 4; i++)
		 {
			 Draw_PreviewDiamond(diamondcolor,xposition + pOffsetData->offsetX *FKSIZE,
				 yposition + pOffsetData->offsetY * FKSIZE);
			 pOffsetData ++ ;
		 }
	 }

#endif
	 /*end talcon modify*/
}

void Draw_PreviewDiamond(UBYTE diamondcolor,U16 xposition,U16 yposition)
{
	
	switch(diamondcolor)
	{
	case RussiaDiamond1:
	case RussiaDiamond2:
	case RussiaDiamond3:
	case RussiaDiamond4:
	case RussiaDiamond5:
	case RussiaDiamond6:
	case RussiaDiamond7:
		dspl_BitBlt(xposition, yposition, FKSIZE, FKSIZE, 0, 
			(void *)((char*)GET_ICONATTR(ICON_RUSSIA_DIAMONDS,0)->icons+FKSIZE * FKSIZE * 2 * (diamondcolor - RussiaDiamond1)) , 0);
		break;		
	default:break;   
		
	}
}

void ChangeShape(UBYTE Dummy_X,UBYTE Dummy_Y,UBYTE Style,UBYTE diamondcolor,T_game_russia *parameter)
{
	UBYTE newStyle;
	T_RussiaStyle_Data *pStyleData = 0;
	pStyleData = &R_StyleData[Style - 1];
	newStyle = pStyleData->next;
	if(newStyle == Style)
		return;
	pStyleData = &R_StyleData[newStyle - 1];
	if(CheckShapeLegal(Dummy_X,Dummy_Y,pStyleData,parameter) )
		return;
	//ɾɵͼ
	Draw_Shape(Dummy_X,Dummy_Y,Style,0,False,parameter);
	
	//µͼ
	Draw_Shape(Dummy_X,Dummy_Y,newStyle,diamondcolor,False,parameter);
	
}//end ChangeShape

void ClearRow(UBYTE Row,T_game_russia *parameter)
{
	int i;
	
	for (i=0;i<LINEROW;i++)
	{
		parameter->R_Coordinate[i][Row]=False;
		DrawDiamond(i,Row,RussiaNone,parameter);
	}
}//end ClearRow

Boolean JudgeLine(UBYTE Row,UBYTE State,T_game_russia *parameter)
{
	int i;
	
	if(State)//ûRussiaNoneTRue
	{
		for(i=0;i<LINEROW;i++)
		{
			if( parameter->R_Coordinate[i][Row] == RussiaNone )
				return False;
		}
		return (True);
	}
	else //ȫRussiaNoneFalse
	{
		for(i=0;i<LINEROW;i++)
		{
			if( parameter->R_Coordinate[i][Row] != RussiaNone )
				return True;
		}
		return(False);
	}
	return(True);
}//end JudgeLine

Boolean MoveRow(UBYTE Row,T_game_russia *parameter)
{
	int i,MoveLine;
	
	if(JudgeLine(Row,True,parameter))
	{
		ClearRow(Row,parameter);
		MoveLine=Row-1;
		
		while(MoveLine>=0)
		{
			if(JudgeLine(MoveLine,False,parameter))
			{
				for(i=0;i<LINEROW;i++)
				{
					parameter->R_Coordinate[i][MoveLine+1]=parameter->R_Coordinate[i][MoveLine];
					DrawDiamond(i,MoveLine+1,parameter->R_Coordinate[i][MoveLine+1],parameter);
				}
				ClearRow(MoveLine,parameter);
				MoveLine=MoveLine-1;
			}
			else 
				MoveLine=-1;
		}
		return(True);
	}
	else 
		return(False);
}//end MoveRow

Boolean MoveShape(UBYTE Dummy_X,UBYTE Dummy_Y,UBYTE Style,UBYTE diamondcolor,R_MoveAspect Way,T_game_russia *parameter)
{
	Boolean Result = True;
	
	/*2003/11/25,talcon modify it*/
	UBYTE newDummy_X = Dummy_X,newDummy_Y = Dummy_Y;
	UBYTE i;
	
	UBYTE uShapeLegal ;
	//memcpy(newOffsetData,pOldOffsetData ,sizeof(newOffsetData) );
	
	switch(Way)
	{
	case MoveLeft:
		newDummy_X --;
		break;
	case MoveRight:
		newDummy_X ++;
		break;
	case MoveDown:
		newDummy_Y ++;
		break;
	default:
		return False;
		break;
	}
	
	uShapeLegal = CheckShapeLegal(newDummy_X,newDummy_Y,&R_StyleData[Style -1],parameter);
	if(uShapeLegal)
	{
		if(Way ==MoveDown)
#ifdef RUSSIA_REMAINCOLOR
			Draw_Shape(Dummy_X,Dummy_Y,Style,diamondcolor | 0x80,False,parameter);
#else 
		     Draw_Shape(Dummy_X,Dummy_Y,Style,RussiaBlue,False,parameter);
#endif
		return False;
	}
	
	Draw_Shape(Dummy_X,Dummy_Y,Style,RussiaNone,False,parameter);
	Draw_Shape(newDummy_X,newDummy_Y,Style,diamondcolor,False,parameter);
	return Result;
}//end MoveShape

Boolean JudgeCoordinate(UBYTE Dummy_X,UBYTE Dummy_Y,UBYTE Style)
{
	Boolean Result;
	
	Result=False;
	/*2003/11/24,talcon modify*/
	if(Dummy_Y ==0)
		Result=True;
	
	return Result;
}//end JudgeCoordinate

void Draw_Initinterface(T_game_russia *data)
{
	U8 i,j;
	UINT uOldColor = 0;//2003/11/04,talcon add

	//dspl_BitBlt(0, 0, Screen_X, Screen_Y, 0, (void *)Russiaframe, 0);
	drawRussiaBkg();
	
	uOldColor = dspl_SetFrgColor(0x587868);
	dspl_DrawRect(Frame_X, Frame_Y, 
				  BenchMark_X + DiamondWidth * LINEROW +1, 
				  BenchMark_Y + DiamondWidth * LineNumber +1);
	dspl_SetFrgColor(0xb6b6b6);
	dspl_DrawLine(	BenchMark_X + DiamondWidth * LINEROW + 1,Frame_Y,
					BenchMark_X + DiamondWidth * LINEROW + 1, 
					BenchMark_Y + DiamondWidth * LineNumber+ 1);
	dspl_DrawLine(	Frame_X, BenchMark_Y + DiamondWidth * LineNumber + 1,
					BenchMark_X + DiamondWidth * LINEROW +1, 
					BenchMark_Y + DiamondWidth * LineNumber +1 );

	for (i = 0;i <= LineNumber-1; i++)
		for (j =0; j<=LINEROW-1;j++)
			 DrawDiamond(j,i,RussiaNone,data);

	dspl_SetFrgColor(uOldColor); //2003/11/04,talcon add
	           	
}//end Draw_Initinterface

//dwar russia background
void drawRussiaBkg()
{
#ifdef RUSSIA_BKG
	drawIconByIcnAttr((MfwIcnAttr*)Russia_BkgAttr,0);
#else
	U32 color = dspl_SetBkgColor(0x30a0f8);
	//dspl_ClearAll();
	dspl_Clear(0,0,128,160);
	dspl_SetBkgColor(color);
#endif
}//end drawRussiaBkg

void drawRussiaBkgByZone(int posX,int posY,int nWidth,int nHeight)
{
#ifdef RUSSIA_BKG
	dspl_BitBlt_ext(posX, posY,posX, posY,
		nWidth, nHeight,
		Screen_X, Screen_Y,0, (void *)Russiaframe, 0);
#else
	U32 color = dspl_SetBkgColor(0x30a0f8);
	dspl_Clear(posX,posY,posX + nWidth, posY + nHeight);
	dspl_SetBkgColor(color);
#endif
}
void Dspl_terris(T_game_russia *data)
{
	U8 i,j,umode;
	U32 oldcolor;
	char information[6];
	
	umode=dspl_Enable(0);
	//dspl_BitBlt(0, 0, Screen_X, Screen_Y, 0, (void *)Russiaframe, 0);
	drawRussiaBkg();
	
	oldcolor = dspl_SetFrgColor(0x587868);
	dspl_DrawRect(Frame_X, Frame_Y, 
		BenchMark_X + DiamondWidth * LINEROW, 
		BenchMark_Y + DiamondWidth * LineNumber);
	
	for (i = 0;i <= LineNumber-1; i++)
		for (j =0; j<=LINEROW-1;j++)
		{
			DrawDiamond(j,i,data->R_Coordinate[j][i],data);
		}
	       
	Print_Number((char *)information,6,(U32)data->R_Score);
	dspl_SetFrgColor(0xff);
	dspl_TextOut(CHARXPOS, CHARYPOS,DSPL_TXTATTR_TRANSPARENT, (char *)information);
	dspl_SetFrgColor(oldcolor); 
	
	Dspl_TotalLines(data->R_LineCount);
	/* 2004/06/17 yhf add */
	Dspl_Score(data->R_Score);
	Dspl_Difficult(data,data->R_Speed); 
	Draw_PreviewShape(data->R_Nextview,data->R_NextviewColor);	
	/* end yhf add */
	
	dspl_Enable(umode);
		
}//end Dspl_terris

void Dspl_Difficult(T_game_russia * data,UBYTE diffcult)
{
	char information[3];
    //dspl_BitBlt(DIFFCULTXPOS, DIFFCULTYPOS, RECTWIDTH, RECTHEGHT, 0, (void *)Rect1backgrd, 0);
	drawRussiaBkgByZone(DIFFCULTXPOS,DIFFCULTYPOS,RECTWIDTH,RECTHEGHT);

    Print_Number((char *)information,3,(U32)diffcult);
	set_font_type(UNI12X12_FONT);
    dspl_TextOut(DIFFCULTXPOS+10, DIFFCULTYPOS-1,DSPL_TXTATTR_TRANSPARENT, (char *)information);
    
	switch(diffcult)
   	{
   	case 0:
   	case 1:
   	case 2:
   	case 3:
   	case 4:
   	case 6:
   	case 9:
		timSetTime(data->timer,100);
		break;
   	case 5:
    case 8:
		timSetTime(data->timer,130);
		break;
   	case 7:
		timSetTime(data->timer,160);
		break;
   	default:break;
   	}
	
}//end Dspl_Difficult

void Dspl_TotalLines(int lines)
{
	char information[6];
    //dspl_BitBlt(DIFFCULTXPOS, DIFFCULTYPOS, RECTWIDTH, RECTHEGHT, 0, (void *)Rect1backgrd, 0);
    drawRussiaBkgByZone(LINESXPOS, LINESYPOS,60, RECTHEGHT);
	
    Print_Number((char *)information,6,(U32)lines);
	set_font_type(UNI12X12_FONT);
    dspl_TextOut(LINESXPOS+(Screen_X - LINESXPOS - strlen(information)*12)/2, LINESYPOS,DSPL_TXTATTR_TRANSPARENT, (char *)information);	
}

void Dspl_Score(int score)
{
	char information[8];
	Print_Number((char *)information,7,(U32)score);

	drawRussiaBkgByZone(CHARXPOS, CHARYPOS,40,12);

	set_font_type(UNI12X12_FONT);
	dspl_TextOut(CHARXPOS, CHARYPOS,DSPL_TXTATTR_TRANSPARENT, (char *)information);

}
void DrawText(U8 uX,U8 uY,U32 uColor,char *pszText)
{
	U32 oldcolor;
	
	if (!pszText)return;
    oldcolor = dspl_SetFrgColor(uColor);    
    dspl_TextOut(uX, uY,DSPL_TXTATTR_TRANSPARENT, pszText);
    dspl_SetFrgColor(oldcolor);	
}//end 
U8 Set_Rflect(U8 speed)
{
	
	switch(speed)
	{
   	case 0:
   	case 1:
   	case 2:
   	case 3:
   	case 4:
		return 7-speed;
   	case 6:
   	case 5:
		return 2;
   	case 9:   
    case 8:
   	case 7:
		return 1;
   	default:break;
	}
}//end Set_Rflect
void  Russia_Help(void)
{
	U32 oldcolor;
	
	oldcolor = dspl_SetBkgColor(0xF6F2CD);
	//2004/06/08 yhf modify
	dspl_fill_rectangle(0, 0, 128, 160);	
	//dspl_fill_rectangle(0, 0, 120, 160);
	dspl_DrawLine(0,0,0,160);
	dspl_SetBkgColor(oldcolor);
	
	//dspl_BitBlt(0,0,120,18,0,(void*)gameTitle,0);
	//draw3dbutton(0,0,119,20,(char *)gameexplain,0x80ff,1);
	
	/* 2004/06/19 yhf modify */
	dspl_TextOut(44, 1, DSPL_TXTATTR_TRANSPARENT,(char *)MmiRsrcGetText(TxtGameExplain));	
	dspl_TextOut(0, RUSSIAHELPINIT,DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtTerrisHelp1));
	dspl_TextOut(0, RUSSIAHELPINIT+37,DSPL_TXTATTR_TRANSPARENT, (char*)MmiRsrcGetText(TxtPublicHelp1));
	dspl_TextOut(0, RUSSIAHELPINIT+55,DSPL_TXTATTR_TRANSPARENT, (char*)MmiRsrcGetText(TxtPublicHelp2));
	dspl_TextOut(0, RUSSIAHELPINIT+73,DSPL_TXTATTR_TRANSPARENT, (char*)MmiRsrcGetText(TxtPublicHelp3));
	dspl_TextOut(0, RUSSIAHELPINIT+91,DSPL_TXTATTR_TRANSPARENT, (char*)MmiRsrcGetText(TxtPublicHelp4));
	/* end yhf modify */

}

void Russia_Mnushow()
{
/*
	static U8 bmpnum;

	if(bmpnum==1)
	{
		//dspl_BitBlt(0,0,120,78,0,(void*)russia_mnubmp1,0);
		//dspl_BitBlt(0,0,120,160,0,(void*)Russia_EntryBkg,0);
	}
	else
	{
		//dspl_BitBlt(0,0,120,78,0,(void*)russia_mnubmp1,0);
		//dspl_BitBlt(6,21,108,27,0,(void*)russia_mnubmp2,0);
		//dspl_BitBlt(0,0,120,160,0,(void*)Russia_EntryBkg,0);
	}

	bmpnum = 1 - bmpnum;
	*/
#if (MAIN_LCD_SIZE==3)
	int posX = 0, posY = 0;
	
	dspl_ClearAll();
	dspl_BitBlt(Russia_EntryBkg[0],Russia_EntryBkg[1],Russia_EntryBkg[2],Russia_EntryBkg[3],0,(void*)&Russia_EntryBkg[4],0);
	//	dspl_TextOut(28, 4, DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtGamestart));
	//	dspl_TextOut(28, 18, DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtGameselect));
	//	dspl_TextOut(28, 32, DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtGamehelp));
	//	dspl_TextOut(28, 46, DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtGameScore));
	
	posX = 50; 
	posY = 28 + 22 *Current_Select;
	dspl_BitBlt(posX, posY, 22, 18, 0, (void *)game_Menu_Finger, DSPL_BMPXOR);//shiheng 288 waiting//Ϸָͼ
	dspl_BitBlt(posX, posY, 22, 18, 0, (void *)game_Menu_Finger_mask, DSPL_BMPAND);
	dspl_BitBlt(posX, posY, 22, 18, 0, (void *)game_Menu_Finger, DSPL_BMPXOR);
#endif 
//dspl_BitBlt(0,77,120,82,0,(void*)game_mnubmp,0);
}

#ifndef GAME_SUBMENU
/*2003/10/18,talcon add*/
void Russia_MnuItemIcnShow(T_game_russia * data)
{
	int nBmpX,nBmpY;
	int nPosX,nPosY;
	int nInterval = 1;

	nBmpY = nBmpX = nPosX = 0;
	nPosY = 75 + 17 * data->R_CurSlect;
	if(data->R_AnimType == 0)
	{
		nBmpY = 0;
		nPosX = 0;		
		nBmpX = 25 - data->R_AnimIndx * 5;
		data->R_AnimIndx ++;
		if(nBmpX < 0)
		{
			nBmpX = 0;
			data->R_AnimType = 1;
			data->R_AnimIndx = 0;
		}
	}
	
#if(MAIN_LCD_SIZE==4)

	dspl_BitBlt_ext(nPosX,nPosY,
		nBmpX,nBmpY,
		25 - nBmpX, 15 - nBmpY ,
		25,15,
		0,
		(void*) game_MenuAnim,0);
#endif
}
#endif

int  GameRussiaEntry(MfwMnu* m, MfwMnuItem* i)
{

  T_MFW_HND win = mfw_parent(mfw_header());
    
  T_MFW_HND winCur  = GameRussiaStart(win);

#ifdef GAME_SUBMENU
  T_MFW_WIN     * win_data = ((T_MFW_HDR *)winCur)->data;
  T_game_russia   * data     = (T_game_russia*)win_data->user;

  if(winCur)
  {
	  //SEND_EVENT(winCur,Russia_Initstate,0,0);
	  switch(m->lCursor[m->level])
	  {
	  case 0:
		  l_mode=Russia_Gamestate;
		  data->CurState=R_Init;
		  winShow(data->win);
		  break;
	  case 1:
		  l_mode=Russia_Settingstate;
//		  Load_Keyset(russiagame);
		  winShow(data->win);
		  break;
	  case 2:
		  l_mode=Russia_Scorestate;
		  winShow(data->win);
		  break;
	  case 3:
		  l_mode=Russia_Helpstate;
		  winShow(data->win);
		  break;
		  break;
	  default:
		  break;
	  }
  }
#endif
  return MFW_EVENT_CONSUMED;
}

T_MFW_HND GameRussiaStart (MfwHnd parent)
{

  T_MFW_HND win = GameRussiaCreate(parent);

#ifndef GAME_SUBMENU
  if ( win != 0 )
	  SEND_EVENT(win,Russia_Initstate,0,0);
#endif

   g_norejectkeyflag=1;
  return win;
}

T_MFW_HND GameRussiaCreate( MfwHnd parent )
{
    T_MFW_WIN     * win;
    char * russiatitle;    
    T_game_russia *data=(T_game_russia *)ALLOC_MEMORY(sizeof(T_game_russia));

	TRACE_FUNCTION ("GameRussiaCreate()");
    if(data==NULL)
		return 0;
	
	/*2003/10/18,talcon add*/
	data->R_CurSlect = 0;
	data->R_AnimIndx = 0;
	data->R_AnimType = 0;
	/*end talcon */
    data->win=win_create(parent,0,E_WIN_VISIBLE,(T_MFW_CB)GameRussia_win_cb);
        
    if (data->win EQ 0) 
	{
		FREE_MEMORY ((void *)data, sizeof (T_game_russia));
		return 0;	 
	}

    g_game_win = data->win;
    data->mmi_control.dialog    = (T_DIALOG_FUNC)GameRussiaDialog;
    data->mmi_control.data     = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *) data;

    russiatitle=(char *) MmiRsrcGetText(TxtRussiagame);  // get the editor title text
    data->kbd      = kbd_create (data->win,KEY_ALL | KEY_MAKE,(T_MFW_CB)GameRussia_kbd_cb);
    data->russiaTimeflag =0;
    data->timer     = tim_create (data->win,timeout,(T_MFW_CB)GameRussia_tim_cb); //  timeout
    return data->win;
}

void GameRussiaDialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_game_russia    * data = (T_game_russia *)win_data->user;

    game_Rectangle   Rectangledata;
    char information[20];
    U32 oldcolor;
    TRACE_FUNCTION ("GameRussiaDialog()");

    switch (event)
	{   
#ifndef GAME_SUBMENU
	    case  Russia_Initstate:
               winShow(data->win); 
	    	  break;
#endif
	    default:     
			return;
	}
}

static int GameRussia_win_cb (MfwEvt e, MfwWin *w)
{
	T_game_russia * data = (T_game_russia*)w->user;
	U32 oldcolor;												
    char information[7];
    TRACE_FUNCTION ("GameRussia_win_cb()");
	MMI_TRACE_EVENT(("yhf--------------GameRussia_win_cb()"));

	/* 2004/06/03 yhf add */
	 if(winIsFocussed(data->win)==0)
		 winfocusout = 1; 
	 else 
	 	winfocusout=0;
	/* end yhf add */
	
	 switch (e)
    {
        case MfwWinVisible:   
        	switch(l_mode)
			{
#ifndef GAME_SUBMENU
			case Russia_Initstate:
				//2003/10/18,talcon add
				data->R_AnimIndx = data->R_AnimType = 0;
				timSetTime(data->timer,150);
				
				Russia_Mnushow();	
				//2003/10/18,talcon add
				Russia_MnuItemIcnShow(data);
				if(data->russiaTimeflag==0)
				{
					timStart(data->timer);
					data->russiaTimeflag=1;
				}
				break;
#endif
			case Russia_Gamestate:
				if(data->CurState==R_Init)
				{					
					Draw_Initinterface(data);
					data->R_Score=0;
					data->R_LineCount = 0; //talcon add
					data->R_Speed=0;

					data->R_Nextview=rand()%RUSSIASTYTLE+1;
					data->R_NextviewColor = rand()%RUSSIACOLOR + 1;
					//draw "Next"
					{
						set_font_type(UNI12X12_FONT);
						//dspl_TextOut(PREVIEWXPOS,PREVIEWYPOS-12,DSPL_TXTATTR_TRANSPARENT, (char*)MmiRsrcGetText(TxtGameNext));	
					}
					Draw_PreviewShape(data->R_Nextview,data->R_NextviewColor);             

					
					//draw "Speed"
					{
						set_font_type(UNI12X12_FONT);
						dspl_TextOut(DIFFCULTXPOS, DIFFCULTYPOS-12,DSPL_TXTATTR_TRANSPARENT, (char*)MmiRsrcGetText(TxtNull));	
					}
					Dspl_Difficult(data,data->R_Speed);    
					
					//draw "Srore"
					{
						char *txt = (char *)MmiRsrcGetText(TxtNull);
						int nStringWidth = get_StringWidth(txt);
						set_font_type(UNI12X12_FONT);
						dspl_TextOut(CHARXPOS - nStringWidth - 12, CHARYPOS,DSPL_TXTATTR_TRANSPARENT, txt);	
						set_font_type(UNI12X12_FONT);
						//dspl_TextOut(CHARXPOS - 12, CHARYPOS,DSPL_TXTATTR_TRANSPARENT, ":");	
					}

					Dspl_Score(data->R_Score);
					//draw "Lines"
					{
						set_font_type(UNI12X12_FONT);
						dspl_TextOut(LINESXPOS, LINESYPOS-12,DSPL_TXTATTR_TRANSPARENT, (char*)MmiRsrcGetText(TxtNull));	
					}
					Dspl_TotalLines(data->R_LineCount);
					data->CurState=R_Ready; 
				}
			/* 2004/06/03 yhf add */ 
				if(winfocusout==1)
				{
					data->Prekeycode = 0;
					Dspl_terris(data);
					
					if(data->CurState==R_Start)
					{
						timStart(data->timer);
						data->russiaTimeflag=1;
					}
				}
			/* end yhf add */	
				break;
			case Russia_Settingstate:
				dspl_ClearAll();
				//if(Key_Setshow((void *)&keysetting))
				Key_Setshow(0);
				
				break;
				
			case Russia_Exitstate:
				//   dspl_ClearAll(); /*2003/12/16, wangyan modify*/
				//Draw_Dialog((char *)MmiRsrcGetText(TxtExitGame));
				draw_icon_require();
#if(MAIN_LCD_SIZE==3)//jhxu720
				ALIGNED_PROMPT(CENTER_RIGHT, DIALOG_HALF_FIRSTSECOND, DSPL_TXTATTR_TRANSPARENT, TxtExitGame);				
#else
			    ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, TxtExitGame);
#endif
				dsplsoftkey(TxtGameGoon, TxtGameExit);
				break;
			case Russia_Overstate:
				//Russia_Scoreshow(data->R_Score);
				Game_Scoreshow(&ffs_gamedata.Russia_ffsScore,data->R_Score,0,1);
				break;
			case Russia_Scorestate:
				//Russia_Scoreshow(data->R_Score);
				Game_Scoreshow(&ffs_gamedata.Russia_ffsScore,-1,0,0);
				break;
			case Russia_Helpstate:
				dspl_ClearAll();
				Russia_Help();
				break;
			default:break;
			}
             break;
        default:          return 1;
    }
    return 1;
}

static int GameRussia_kbd_cb (MfwEvt e, MfwKbd *k)
{
	T_MFW_HND       win      = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_game_russia   * data     = (T_game_russia*)win_data->user;

    int i,j;
    char information[20];
    Boolean CanMove;
    UBYTE diamondcolor;
    U32 oldcolor;
		
     TRACE_EVENT ("GameRussia_kbd_cb()");
#ifndef GAME_SUBMENU
    if(l_mode==Russia_Initstate && (e&KEY_MAKE)) //ʼ״̬
    {
		switch(k->code)
		{
		case KCD_1:
		case KCD_2:
		case KCD_3:
		case KCD_4:
			if(data->R_CurSlect+1 != k->code)
			{
				data->R_CurSlect = k->code - 1;
				data->R_AnimIndx = data->R_AnimType = 0;
				timStart(data->timer);
			}
			//winShow(data->win);
			break;
		case KCD_MNUDOWN:
			data->R_CurSlect ++;
			if(data->R_CurSlect == 4)
			{
				data->R_CurSlect = 0;
			}
			data->R_AnimIndx = data->R_AnimType = 0;
			timStart(data->timer);
			break;
		case KCD_MNUUP:
			if(data->R_CurSlect)
			{
				data->R_CurSlect --;
			}
			else
			{
				data->R_CurSlect = 3;
			}
			data->R_AnimIndx = data->R_AnimType = 0;
			timStart(data->timer);
			break;
		case KCD_LEFT:
		case KCD_OK:
			switch(data->R_CurSlect)
			{
			case 0:
				l_mode=Russia_Gamestate;
				data->CurState=R_Init;
				winShow(data->win);
				break;
			case 2:
				l_mode=Russia_Settingstate;
				//							Load_Keyset(russiagame);
				winShow(data->win);
				break;
			case 1:
				l_mode=Russia_Scorestate;
				winShow(data->win);
				break;
			case 3:
				l_mode=Russia_Helpstate;
				winShow(data->win);
				break;
			}
			break;
			/*end add*/
			case KCD_RIGHT:
			case KCD_HUP:		  	   	  
				GameRussiaDestroy(data->win);
				break;
			default:break;
		}
#if (MAIN_LCD_SIZE==3)
		Current_Select=data->R_CurSlect;//shiheng add
#endif
		return MFW_EVENT_CONSUMED;
	}//end russia_initstates
#endif	
    if(l_mode==Russia_Exitstate && (e&KEY_MAKE)) //˳״̬
    {
		switch(k->code)
		{
		case KCD_LEFT:
			l_mode=Russia_Gamestate;
			Dspl_terris(data);
			if(data->CurState==R_Start)
			{
				timStart(data->timer);
				data->russiaTimeflag=1;
			}
			break;
		case KCD_RIGHT:
		case KCD_HUP:
			l_mode=Russia_Overstate;
			winShow(data->win);
			break;
		}        	    	
		
		
		return MFW_EVENT_CONSUMED;
    }//end russia_exitstates
   
    
   if(l_mode==Russia_Gamestate) //Ϸ״̬
   {
       if(!(e&KEY_MAKE))//ͷţR_keycount and Prekeycode Ϊ0
	   {
		   if (data->CurState==R_Start)   //r_start && key_long
		   {	     
			   if(	k->code==KCD_MNULEFT ||
				   k->code==KCD_MNURIGHT ||
				   k->code==KCD_MNUDOWN)
			   {
				   data->R_keycount=0;
				   data->Prekeycode=0;
			   }
		   }
	   } 
	   else if(e&KEY_MAKE)
	   {        
		   if (data->CurState==R_Start)  // key && r_start
		   {		
			   switch(k->code)
			   {
			   case KCD_MNULEFT:// 
				   data->R_keycount=0;
				   data->Prekeycode=1;
				   break;
			   case KCD_MNURIGHT:
				   data->R_keycount=0;
				   data->Prekeycode=2;
				   break;
			   case KCD_OK:
				   ChangeShape(data->R_DummySiteAndStyle[0],data->R_DummySiteAndStyle[1],
					   data->R_DummySiteAndStyle[2],data->R_DummySiteAndStyle[3],data);				
				   break;
			   case KCD_MNUDOWN :
				   data->Prekeycode=3;
				   break;
			   case KCD_CALL://pause
				   data->CurState=R_Stop;
				   timStop(data->timer);	     
				   data->russiaTimeflag=0;
				   break;
			   case KCD_HUP:
				   timStop(data->timer);	  
				   data->russiaTimeflag=0;
				   l_mode=Russia_Exitstate;
				   winShow(data->win);
				   break;
			   }	  
		   } 
		   else
		   {
			   if (k->code==KCD_CALL)  // kcd_call &&( r_ready || r_stop)
			   {                  
				   switch (data->CurState)
				   {
				   case R_Ready:
					   for (i = 0;i <= LineNumber-1; i++)
						   for (j =0; j<=LINEROW-1;j++)
							   data->R_Coordinate[j][i]=False;
					   data->R_Preview=data->R_Nextview;
					   diamondcolor = data->R_NextviewColor;
					   Draw_Shape(4,0,data->R_Preview,diamondcolor,True,data);
					   

					   data->R_Nextview=rand()%RUSSIASTYTLE+1;
					   data->R_NextviewColor= rand()%RUSSIACOLOR+1;
					   Draw_PreviewShape(data->R_Nextview,data->R_NextviewColor);
					   
                       Dspl_Score(data->R_Score);

					   data->Prekeycode=0;
					   
					   data->CurState=R_Start;
					   timStart(data->timer); 
					   data->russiaTimeflag=1;
					   break;
				   case R_Stop :
					   {
						   data->CurState=R_Start;
						   timStart(data->timer);
						   data->russiaTimeflag=1;
					   }             
					   break;
				   default      :break;
				   }
				   
			   }
			   else 
			   {
				   if(k->code== KCD_HUP)
				   {
					   timStop(data->timer);	
					   data->russiaTimeflag=0;
					   l_mode=Russia_Exitstate;
					   winShow(data->win);
				   }
				   
				   switch (k->code)    //  r_ready || r_stop
				   {
				   case KCD_MNUDOWN:
				   case KCD_MNULEFT:
					   if (data->R_Speed-1>=0) data->R_Speed=data->R_Speed-1;
					   else data->R_Speed=9-data->R_Speed;         
					   Dspl_Difficult(data,data->R_Speed);
					   break;
				   case KCD_MNUUP:
				   case KCD_MNURIGHT:
					   if (data->R_Speed+1<=9) data->R_Speed=data->R_Speed+1;
					   else data->R_Speed=0;
					   Dspl_Difficult(data,data->R_Speed);
					   break;
				   default: break;              	                     
				   }	          
			   }	
		   }
    }
   	}//end russia_gamestate
   
    if(l_mode==Russia_Settingstate&&(e&KEY_MAKE)) //Ϸ״̬
    	{
		 // if(Key_Setting_func(russiagame, &keysetting,k))
#ifdef GAME_SUBMENU
		switch(k->code)
		{
		case KCD_RIGHT:
		case KCD_HUP:
		 	GameRussiaDestroy(data->win);
			break;
		}
		  
#else
			l_mode=Russia_Initstate;
#endif
		 	winShow(data->win);
        }
        
    if(l_mode==Russia_Helpstate && (e&KEY_MAKE)) //Ϸ״̬
    	{
        if(k->code==KCD_RIGHT || k->code==KCD_HUP)
        	{
			/*2004/06/01 yhf modify*/
			switch(k->code)
				{
				case KCD_RIGHT:
				case KCD_HUP:
#ifdef GAME_SUBMENU
				GameRussiaDestroy(data->win);
#else
        		l_mode=Russia_Initstate;
        		winShow(data->win);
#endif
				break;
				}
			/* end yhf modify */
        	}
        }
    
    if(l_mode==Russia_Scorestate && (e&KEY_MAKE)) //ʾ״̬
    {
    	 switch(k->code)
         {
		 case KCD_LEFT:
			 Game_RestScore(Russia_Score);
			 winShow(data->win);
			 break;
		 case KCD_RIGHT:
		 case KCD_HUP:
#ifdef GAME_SUBMENU
			 GameRussiaDestroy(data->win);
#else
			 l_mode=Russia_Initstate;
			 winShow(data->win);
#endif
			 break;
		 }
    }
    
    if(l_mode==Russia_Overstate && (e&KEY_MAKE))
    {
       switch(k->code)
       {
	   case KCD_LEFT:
		   l_mode=Russia_Gamestate;
		   data->CurState=R_Init;
		   winShow(data->win);
		   break;
	   case KCD_RIGHT:
	   case KCD_HUP:
#ifdef GAME_SUBMENU
		   GameRussiaDestroy(data->win);
#else
		   l_mode=Russia_Initstate;
		   timSetTime(data->timer,timeout);
		   winShow(data->win);
#endif
		   
		   break;
	   }
    }
    return MFW_EVENT_CONSUMED;
}

void GameRussia_tim_cb(T_MFW_EVENT event,T_MFW_TIM * t)
{
	T_MFW_HND       win      = mfw_parent (mfw_header());
	T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;    
	T_game_russia   * data     = (T_game_russia*)win_data->user;
	
	char information[20];
	int i;
	UBYTE diamondcolor,levelIcs_i;
	static UBYTE timelevel;
	U32 oldcolor;
	
	timelevel++;
	timStop(data->timer);
	data->russiaTimeflag=0;
    
	/* 2004/06/03 yhf add */
	if(winIsFocussed(data->win)==0)
		winfocusout = 1; 
	else 
		winfocusout=0;
	/* end yhf add */
	
	TRACE_EVENT("bmtimerfunc");
	
	if(winfocusout==0 && l_mode==Russia_Gamestate) //2004/06/03 yhf modify
	{
		if(data->CurState==R_Start )
		{
			switch(data->Prekeycode)
			{
			case 1:
				data->R_keycount++;
				if(data->R_keycount!=RUSSIA_R_KEYCOUNT_MAX)
					MoveShape(data->R_DummySiteAndStyle[0],data->R_DummySiteAndStyle[1],
					data->R_DummySiteAndStyle[2],data->R_DummySiteAndStyle[3],MoveLeft,data);
				else
					data->R_keycount = 0;
				break;
			case 2:
				data->R_keycount++;
				if(data->R_keycount!=RUSSIA_R_KEYCOUNT_MAX)
					MoveShape(data->R_DummySiteAndStyle[0],data->R_DummySiteAndStyle[1],
					data->R_DummySiteAndStyle[2],data->R_DummySiteAndStyle[3],MoveRight,data);
				else
					data->R_keycount = 0;
				break;
			case 3:
				MoveShape(data->R_DummySiteAndStyle[0],data->R_DummySiteAndStyle[1],
					data->R_DummySiteAndStyle[2],data->R_DummySiteAndStyle[3],MoveDown,data);
				break;
			default:break;	
			}
		}//end if(data->CurState==R_Start )
		
		if(timelevel>=Set_Rflect(data->R_Speed))
		{
			timelevel=0;
			if (MoveShape(data->R_DummySiteAndStyle[0],data->R_DummySiteAndStyle[1],
                data->R_DummySiteAndStyle[2],data->R_DummySiteAndStyle[3],MoveDown,data))  
			{ 
				timStart(data->timer);  
				data->russiaTimeflag=1;
			}
			else
			{    
				/*2003/12/04,talcon modufy*/
				removeShape(data);

				//÷
				levelIcs_i=data->R_Score/10000;
				if(data->R_Count==1)
					data->R_Score=data->R_Score+100;
				else if(data->R_Count==2)
					data->R_Score=data->R_Score+300;
				else if(data->R_Count==3)
					data->R_Score=data->R_Score+700;
				else if(data->R_Count==4)
					data->R_Score=data->R_Score+1500;
				data->R_LineCount += data->R_Count;
				
				if(levelIcs_i+1==data->R_Score/10000)  
				{
					if(data->R_Speed<10)
						data->R_Speed++;
					Dspl_Difficult(data,data->R_Speed);
				}
				
				//ǰĵ÷ַinformation
				if(data->R_Count)
				{
					Dspl_Score(data->R_Score);
					Dspl_TotalLines(data->R_LineCount);
				}
				
				if (JudgeCoordinate(data->R_DummySiteAndStyle[0],data->R_DummySiteAndStyle[1],
					data->R_DummySiteAndStyle[2])==False)
				{   
					
					data->R_Preview=data->R_Nextview;
					diamondcolor = data->R_NextviewColor;
					Draw_Shape(4,0,data->R_Preview,diamondcolor,True,data);
					
					//data->R_Preview=data->R_Nextview;
					//srand((unsigned)time(NULL));//talcon
					data->R_Nextview=rand()%RUSSIASTYTLE+1;
					data->R_NextviewColor= rand()%RUSSIACOLOR+1;
					//Draw_PreviewShape(data->R_Preview,FALSE,FrameColor,FillColor,Backdrop);      
					Draw_PreviewShape(data->R_Nextview,data->R_NextviewColor);
				
					timStart(data->timer); 
					data->russiaTimeflag=1;
				}
				else  //Ϸ
				{
					for (i=0;i<=LineNumber-1;i++)
						ClearRow(i,data);
					
					data->CurState=R_Init;
					
					Dspl_Score(data->R_Score);
					
					l_mode=Russia_Overstate;
					winShow(data->win);
				}
	 }
	}
	else
	{
		timStart(data->timer);   
		data->russiaTimeflag=1;
	}
	}//end russia_gamestate

	if(l_mode==Russia_Settingstate)
	{
		keysetting.keySetstatus=1;
		dspl_ClearAll();
		//Key_Setshow((Key_Setting *)&keysetting);           
		Key_Setshow(0);
	}
#ifndef GAME_SUBMENU
	if(l_mode==Russia_Initstate && winfocusout==0)
	{
		Russia_Mnushow();
		Russia_MnuItemIcnShow(data);
		if(data->russiaTimeflag==0 && data->R_AnimType == 0)
		{
			timStart(data->timer); 
			data->russiaTimeflag=1;
		}
	}
#endif
}//end function:GameRussia_tim_cb
  
void GameRussiaDestroy (T_MFW_HND own_window)
{
  T_MFW_WIN     * win;
  T_game_russia   * data;

  TRACE_EVENT("GameRussiaDestroy");

  if (own_window)
  {
    win  = ((T_MFW_HDR *)own_window)->data;
    data = (T_game_russia *)win->user;

    if (data)
    {
      win_delete (data->win);
    }
   
	FREE_MEMORY ((void *)data, sizeof (T_game_russia));

    flash_Gamewrite();
    g_game_win = 0;
    g_norejectkeyflag=0;
	//2004/06/01 yhf remove
    //set_backlight_on();   
  }
}

/*************************************************************************
$Description: ָshapeλúϷ
$Arguments:
 @return:
	0x01: left
	0x02: right
	0x04: top
	0x08: bottom
	0x10: Ѿڷ
$History:
*******2003/11/24,talcon create
***************************************************************************/
UBYTE CheckShapeLegal(UBYTE Dummy_X,UBYTE Dummy_Y,T_RussiaStyle_Data *pData,T_game_russia *parameter)
{
	UBYTE Result = 0;                             
	UBYTE i;
	int offsetX,offsetY;

	for(i = 0; i<4;i++)
	{
		offsetX = Dummy_X + pData->offset[i].offsetX;
		offsetY = Dummy_Y + pData->offset[i].offsetY;
		if(offsetX <0 )
			Result |= 0x01;
		else if(offsetX >= LINEROW)
			Result |= 0x02;

		if(offsetY < 0)
			Result |= 0x04;
		else if(offsetY >=LineNumber )
			Result |= 0x08;
#ifndef RUSSIA_REMAINCOLOR
		if(parameter->R_Coordinate[offsetX][offsetY] != RussiaBlue)
#else
		if(parameter->R_Coordinate[offsetX][offsetY]&0x80 )
#endif
		{
			Result |= 0x10;
		}
	}
	return Result;
}
/*************************************************************************
$Description: 
$Arguments:
 @return:the number of lines removed
$History:
*******2003/11/24,talcon create
***************************************************************************/
UBYTE removeShape(T_game_russia *parameter)
{
	int nMinY =0,nMaxY=0;
	T_RussiaStyle_Data *pData= 0;
	int i  ;
	if(parameter->R_DummySiteAndStyle[2] > RUSSIASTYTLE || parameter->R_DummySiteAndStyle[2] == 0)
		return	0;
	parameter->R_Count = 0 ;
	pData = &R_StyleData[parameter->R_DummySiteAndStyle[2] -1];
	for(i = 0; i <4 ; i++)
	{
		if(nMinY > pData->offset[i].offsetY)
			nMinY = pData->offset[i].offsetY;
		else if(nMaxY < pData->offset[i].offsetY)
			nMaxY = pData->offset[i].offsetY;
	}
	for(i = nMinY;i<=nMaxY;i++)
	{
		if (MoveRow(parameter->R_DummySiteAndStyle[1]+i,parameter))
			++(parameter->R_Count);
	}
	return parameter->R_Count;
}





















