/********************************************************************************
 $History: Mmienvironment.c

  $12/07/02      Original BMI version.
  $author:  xsf (Mobile Innovation)
 $End

*******************************************************************************/
/*******************************************************************************
  modify hostory:mmienvironment.c
    12/07/02  version 0.001 Original BMI version.
    29/08/02  version 0.002 xsf modified for ajusting melody volume                            

*******************************************************************************/

/*******************************************************************************

                                Include Files

*******************************************************************************/

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h> 
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_kbd.h"
#include "mfw_tim.h"
#include "mfw_lng.h"
#include "mfw_win.h"
#include "mfw_icn.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_edt.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_sms.h"

#include "dspl.h"


#include "p_mmi.h"
#include "aci_cmh.h"
#include "mfw_mme.h"

#include "MmiMmi.h"

#include "MmiIcons.h"
#include "MmiPins.h"
#include "MmiMain.h"
#include "MmiDialogs.h"
#include "MmiIdle.h"
#include "MmiStart.h"
#include "MmiCall.h"
#include "MmiSimToolkit.h"
#include "gdi.h"
#include "Audio.h"
#include "MmiLists.h"
#include "MmiSounds.h"
#include "MmiResources.h"
#include "MmiTimeDate.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "MmiTimers.h"
#include "rv_general.h"
#include "Audio_api.h"
#include "Mmisounds.h"
#include "Mmiicons.h"

#include "mmiQQSwitch.h" //hxl add for check qq func

//#define TDTRACE 1
#include "mmiutilapi.h"

// 2004.3.18 WYJ add
#define RI_INIT		100		
#define RI_DESTROY	101
#define RI_SELECT	102		//call in ring select
#define AL_SELECT	103		//alarm
#define SM_SELECT	104		//sms
#define PO_SELECT	105		//power on
#define PF_SELECT	106		//power off
#define HO_SELECT	107		//hall on
#define HF_SELECT	108		//hall off
#define GP_SELECT	109		//group 

/* 2004/05/18 sunsj modify */
#if ( MAIN_LCD_SIZE==2 )
/* ring select pictures */
extern const unsigned char musicPlay0[];
extern const unsigned char musicPlay1_a[];
extern const unsigned char musicPlay1_b[] ;
extern const unsigned char musicPlay2_a[] ;
extern const unsigned char musicPlay2_b[] ;
extern const unsigned char musicPlay3[] ;
extern const unsigned char musicPlay4[] ;
extern const unsigned char musicPlay5_a[] ;
extern const unsigned char musicPlay5_b[] ;
#endif


static void envconfirm_dialog(void);

static MfwHnd    l_timPlay;            /* timer one second handle to begain play melody */
// 2004.4.1 wyj call no win
extern MfwHnd    hRingVibStartTimer;   /* timeout for vibrator then start of melody */
static UINT8     l_playing = INCALLPLAY; //xsf 2002.08.14
static MfwHnd	 LedStartTimer;		/* 2004/03/18 sunsj add */

int		isKeyRing = 0;						//־ 1-ֹwyj
int     isOnOffMenuRing = 0;				//־ 1-ֹwyj

UINT8    Gu8_Envio_num  = 0;           //enter which enviroment flag
UINT8    melody_status  = MELODY_IDLE;
UINT8    tone_status    = TONE_IDLE;
UINT8    vibra_status   = VIBRA_IDLE;

//2003.1.13 WYJ add Ƿ񿪻˵
static UINT8	isOnRing = 0;

extern  char  currentringstr[20];  //xsf extern from mmisounds.c 2002.09.06
extern  char  oldringstr[20];      //xsf add 2002.09.06
extern T_call call_data;
extern UINT32 driverFlag;          //wms added 02/12/28
extern BOOL   call_win_flag;

#define SHOW_CONFIRM           3
#define ACTIVATE_CONFIRM       4	// mute activated
#define DEACTIVATE_CONFIRM     5
#define PLAYTONE               2  //xsf change (0xFF) to 2 2002.09.16
#define INFO_TEXT_X            10
#define INFO_TEXT_Y            10 //xsf  add  2002.08.27

#define ModeIdle        0x001     /*in Idle Screen           */
#define ModeCall        0x002     /*in during a call         */
#define ModeIncomCall   0x004     /*in Incoming call         */
#define ModeRingmnu     0x008   
#define ModeVoicememo   0x010     /*in Dialling state        */
#define ModeSms         0x020     /*in SMS                   */
#define ModeAlarm       0x040     /*in Alarm                 */


typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        confirm_win;        // MFW win handler      
    UBYTE            local_status;
} T_Envconfirm;

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        parent_win;
    T_MFW_HND        volume_kbd_win;
    T_MFW_HND        kbd_handle;
    //T_MFW_HND	   tim_out_handle;
    UBYTE            volume_status;
	int				 curVol;				//2004.3.24 WYJ current ring in volume adjuest
} T_ringvolume_kbd;

// 2004.2.17 WYJ add
typedef struct
{
	T_MMI_CONTROL	mmi_control;
	T_MFW_HND		parent_win;
	T_MFW_HND		ring_win;
	MfwHnd			ring_kbd;
	MfwHnd			ring_tim;
	uint8			*ringtype;		
	uint8			*ringvolume;	
	SHORT			eventType;		
	int				index;			//index of ring
	int				ringOffset;		//off set of ring
	int				ringsum;		//sum of ring
	int				txtOffset;		//display string index;
} T_ring;


T_Envconfirm envconfirm;
int CurrentMode = ModeIdle;   //add 2002.12.30
int stopvib2playmelody( MfwEvt e, MfwTim *tc );
void  volume_destroy  (T_MFW_HND own_window);
static int LedLightEvent( MfwEvt e, MfwTim *tc );

//glowing,2003-12-15, enable or disable play keytone flag
// that define in mmisounds.c
extern int gPlayKeytoneFlag;

//2004.2.12 WYJ Hall on/off menu flag
int	gIsHallOnSet;

/* 2004/06/30 sunsj modify */
#ifdef SEVEN_COLORS_LED
extern MfwHnd ServiceLedTimer;
#endif

/* flag functiong for menu */
USHORT Stopplaying( struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi )
{
    //if(melody_status==MELODY_BUSY)
    //{
        //StopMelody2(oldringstr);
   //     StopPlayingMelody2( );   2004.1.6 WYJ
    //}

    //if(tone_status==TONE_BUSY)   2004.1.6 WYJ
    //    StopTone();
	static int	oldindex = 0; 

	//2004.2.9 WYJ 
	static	int aCursor = 0;

	//ֻڲ˵лʱ
	if(m->lCursor[m->level] != aCursor)
	{
		MC_StopVibra(); // 2004.4.16 WYJ

		aCursor = m->lCursor[m->level];

		if(isKeyRing && !((int)mi->str>=TxtSmsRing1 && (int)mi->str<=TxtSmsRing5) )
		{
			StopPlayingMelody2( );
			isKeyRing = 0;
		}
	}

	/*   2004.1.6 WYJ
    if((((int)mi->str==TxtRingmode)||((int)mi->str==TxtRingandVib)  //add for KCD_LEFT 2003.01.14
        ||((int)mi->str==TxtVibramode) ||((int)mi->str==TxtVibraRing)||((int)mi->str==TxtMute))
       && (( m->lCursor[m->level] == 0)||( m->lCursor[m->level] == 3)))
        driverFlag|=0x04;
    else if((((int)mi->str==TxtSmsRing) ||((int)mi->str==TxtSpecialRing)
             ||((int)mi->str==TxtSmsVibra)||((int)mi->str==TxtSmsRVibra)||((int)mi->str==TxtSmsMute))
            && (( m->lCursor[m->level] == 0))) //||( m->lCursor[m->level] == 1))) 
        driverFlag|=0x04;
    else if(((int)mi->str>=TxtSmsRing1) && ((int)mi->str<=TxtSmsRing5))
        driverFlag|=0x04;
    else if(((int)mi->str==TxtKeypadToneRing) || ((int)mi->str==TxtKeypadToneSpecialRing))	// 2003/12/08 sunsj 
        driverFlag|=0x04;
    else
        driverFlag&=0xFFFFFFFB;
	*/

	//2004.1.6 WYJ ޸Ķѡʽ
	if (gPlayKeytoneFlag == 0)
		gPlayKeytoneFlag = 1;

    if((((int)mi->str==TxtRingmode) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].prompttype==RING))
       ||(((int)mi->str==TxtVibramode) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].prompttype==VIBRA))
       ||(((int)mi->str==TxtVibraRing) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].prompttype==VIBRARING))
       ||(((int)mi->str==TxtRingandVib) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].prompttype==RINGANDVIBRA))
       ||(((int)mi->str==TxtMute) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].prompttype==ALERTMUTE))
       //for SMS prompt 
       ||(((int)mi->str==TxtSmsRing) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone==SMSRING))

       ||(((int)mi->str==TxtSpecialRing) && ((FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone>=SPECIALRING1)
                                             && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone<=SPECIALRING1+SMS_SUM-1)))

       ||(((int)mi->str==TxtSmsVibra) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone==SMSVIBRA))
       ||(((int)mi->str==TxtSmsRVibra) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone==SMSRVIBRA))
       ||(((int)mi->str==TxtSmsMute) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone==SMSMUTE))
       ||(((int)mi->str==TxtKeypadToneRing) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadTone==1))
       ||(((int)mi->str==TxtKeypadToneSpecialRing) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadTone==2))
       )		/* 2003/12/08 sunsj */

        return FLAGFUNC_TRUE_ICON;
    else
        return FLAGFUNC_FALSE_ICON;

}

/*******************************************************************************

 $Function:    	envconfirms

 $Description:	mute confirm dialog_CB

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void envconfirms (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN    * win_data = ((T_MFW_HDR *) win)->data;
    T_Envconfirm      * data     = (T_Envconfirm *)win_data->user;

    TRACE_FUNCTION("envconfirms()");

    switch(event)
    {
    case SHOW_CONFIRM:
        envconfirm_dialog();
        break;

    }
}

/*******************************************************************************

 $Function:    	envconfirm_win_cb

 $Description:	mute confirm

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int envconfirm_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    /*
     * Top Window has no output
     */
    return 1;
}

/*******************************************************************************

 $Function:    	envconfirm_create

 $Description:	mute confirm

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND envconfirm_create (T_MFW_HND parent_window)
{
    T_Envconfirm * data = &envconfirm;
    T_MFW_WIN   * win;

    TRACE_FUNCTION ("envconfirm_create()");

    data->confirm_win = win_create (parent_window, 0, 0, (T_MFW_CB)envconfirm_win_cb);

    if(data->confirm_win EQ 0)
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog = (T_DIALOG_FUNC)envconfirms;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->confirm_win)->data;
    win->user                = (void *) data;


    winShow(data->confirm_win);
    /*
     * return window handle
     */
    return data->confirm_win;
}

/*******************************************************************************

 $Function:    	envconfirm_destroy

 $Description:	mute confirm

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void envconfirm_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN   * win;
    T_Envconfirm * data;

    TRACE_FUNCTION ("envconfirm_destroy()");

    if(own_window)
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_Envconfirm *)win->user;

        if(data)
        {
            /*
             * Delete WIN handler
             */
            win_delete (data->confirm_win);
            data->confirm_win = 0;
        }
    }
}

/*******************************************************************************

 $Function:    	envconfirm_Init

 $Description:	call by scenemode_mute

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND envconfirm_Init (T_MFW_HND parent_window)
{
    return(envconfirm_create (parent_window));
}
/*******************************************************************************

 $Function:    	envconfirm_Exit

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void envconfirm_Exit (T_MFW_HND own_window)
{
    T_MFW_WIN   * win_data = ((T_MFW_HDR *)own_window)->data;
    T_Envconfirm * data     = (T_Envconfirm *)win_data->user;

    envconfirm_destroy (data->confirm_win);
}


/*******************************************************************************

 $Function:    	envconfirm_dialog_cb

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void envconfirm_dialog_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    TRACE_FUNCTION ("envconfirm_dialog_cb()");

    switch(reason)
    {
    case INFO_TIMEOUT:
        /* no break; */
    case INFO_KCD_HUP:
        /* no break; */
    case INFO_KCD_RIGHT:
        /* no break; */
    case INFO_KCD_CLEAR:
    case INFO_KCD_LEFT:   //xsf add 2003.02.13
        envconfirm_Exit(win);
        break;
    default :
        break;
    }
}

/*******************************************************************************

 $Function:    	confirm_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void envconfirm_dialog(void)
{
    T_DISPLAY_DATA display_info;

    TRACE_FUNCTION ("envconfirm_dialog()");
    dialog_info_init(&display_info);

    display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT | KEY_LEFT;
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.TextId   = 0;
    display_info.Time       = TWO_SECS;
    display_info.iconindex=REMIND_COMPLETE;

    if(envconfirm.local_status EQ ACTIVATE_CONFIRM)
    {
        display_info.TextId2   = TxtActivated;
    }
    else if(envconfirm.local_status EQ DEACTIVATE_CONFIRM)
    {
        display_info.TextId2    = TxtDeActivated;
    }

    display_info.Callback     = (T_VOID_FUNC)envconfirm_dialog_cb;
    /*
     * Call Info Screen
     */
    info_dialog (envconfirm.confirm_win, &display_info);

}
/* handler of menu menuScene */
int scenemode_normal (MfwMnu *m, MfwMnuItem *i)
{
    //TRACE_EVENT("NORMAL MODE");
    Gu8_Envio_num=NORMAL_ENV;
    return 0;
}  
/* handler of menu menuScene */
int scenemode_out(MfwMnu *m, MfwMnuItem *i)
{
    //TRACE_EVENT("OUT MODE");
    Gu8_Envio_num=OUTDOOR_ENV;
    return 0;
}  
/* handler of menu menuScene */
int scenemode_meeting(MfwMnu *m, MfwMnuItem *i)
{

    //TRACE_EVENT("MEETING MODE");
    Gu8_Envio_num=MEETING_ENV;
    return 0;
}  
/* handler of menu menuScene */
int scenemode_incar(MfwMnu *m, MfwMnuItem *i)
//USHORT scenemode_incar (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    //TRACE_EVENT("INCAR MODE");
    Gu8_Envio_num=INCAR_ENV;
    return 0;
}  

/* handler of menu menuScene */
void scenemode_mute(void)
//USHORT scenemode_mute (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    envconfirm_Init(win);

    if(FlashEnvironmentData.CurrentEnv== MUTE_ENV)
        envconfirm.local_status = ACTIVATE_CONFIRM;
    else
    {
        envconfirm.local_status = ACTIVATE_CONFIRM;
        FlashEnvironmentData.CurrentEnv= MUTE_ENV;
        flash_environmentwrite();
    }
    SEND_EVENT (envconfirm.confirm_win, SHOW_CONFIRM, 0, 0);

}  
/*  */
int SetEnvironmentmode( MfwMnu *m, MfwMnuItem *i )
{
    //T_MFW_HND win = mfw_parent(mfw_header()); 
    //envconfirm_Init(win);
    if(FlashEnvironmentData.CurrentEnv!= Gu8_Envio_num)
    //envconfirm.local_status = ACTIVATE_CONFIRM;
    //else
    {
        //envconfirm.local_status = ACTIVATE_CONFIRM;
        FlashEnvironmentData.CurrentEnv= Gu8_Envio_num;
        flash_environmentwrite();
    }
    //SEND_EVENT (envconfirm.confirm_win, SHOW_CONFIRM, 0, 0);
    mnuUpdate(m);    //xsf add 2002.11.07
    return 0;
}

//SetRingmode
// -----------------------------------------------------------------------
// Function		:SetRingmode
// Description	: incoming call ring mode activate
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 2004.1.6 WYJ 
// ------------------------------------------------------------------------
//
void  SetRingmode(MfwMnu* m, MfwMnuItem* i)
{
	StopPlayingMelody2();
    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].prompttype=RING;
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.08.16
    //StartMelody(0);  //xsf add 2002.08.12
    StartPlayByReason(MENUSETPLAY,0);   //xsf add 2002.09.06
    isKeyRing = 1;
}//SetRingmode

/* alarm ring activate  */
void  SetAlarmRingmode(MfwMnu* m, MfwMnuItem* i)
{

    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmprompt=RING;
    flash_environmentwrite();
    mnuUpdate(m);    //add 2002.09.24
    //StartPlayByReason(MENUALARMPLAY,0);  
    if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmvolume < 1)
        FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmvolume = 3;

	SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmvolume); 
    if(melody_status==MELODY_IDLE) //&& (tone_status == TONE_IDLE))	
    {
     	StartPlayingMelody2( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmtype, 0);
    }
	isKeyRing = 1; 
}//SetAlarmRingmode

// -----------------------------------------------------------------------
// Function		:SetRingAndVib
// Description	: incoming call ring & Vibra  activate
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 2004.1.6 WYJ 
// ------------------------------------------------------------------------
//

void SetRingAndVib(MfwMnu* m, MfwMnuItem* i)
{
	StopPlayingMelody2();
    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].prompttype=RINGANDVIBRA;
    flash_environmentwrite();
    mnuUpdate(m);   
    //StartMelody(0);  //xsf add 2002.08.12
    StartPlayByReason(MENUSETPLAY,0);  
    StartVibrator();
    l_playing=SMSPLAYVIB;
	//TIMCREATE_SETFLLAG( hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
    timStart( hRingVibStartTimer );
	isKeyRing = 1;
}


// -----------------------------------------------------------------------
// Function		:SetVibramode
// Description	: incoming call Vibra mode activate
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//

void SetVibramode(MfwMnu* m, MfwMnuItem* i)
{

    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].prompttype=VIBRA;
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.08.16
    StartVibrator(); 
    l_playing=SMSPLAYVIB;
	//TIMCREATE_SETFLLAG  (hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
     timStart( hRingVibStartTimer );

}//SetVibramode

/* alarm vibra activate */
void SetAlarmVibramode(MfwMnu* m, MfwMnuItem* i)
{

    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmprompt=VIBRA;
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.09.24
    StartVibrator();
    l_playing=SMSPLAYVIB;
   //TIMCREATE_SETFLLAG( hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
    timStart( hRingVibStartTimer );

}//SetAlarmVibramode

/*******************************************************************************

 $Function:     stopvib2playmelody

 $Description:  stop vibrator then play melody , this event handler
        is invoked when the hRingVibStartTimer event completes

 $Returns:    MFW_EVENT_CONSUMED always

 $Arguments:  e, event, tc timer context

*******************************************************************************/

int stopvib2playmelody( MfwEvt e, MfwTim *tc )
{
    //CurrentMode = CurrentMode & (~ModeSms);  2004.3.30 wyj MI18800000128 
    if(vibra_status == VIBRA_BUSY)
        StopVibrator();
    else if((vibra_status == VIBRA_IDLE)&&(l_playing==INCALLVIBRA))
        StartVibrator();
    else if((vibra_status == VIBRA_IDLE)&&(l_playing==INCALLPLAY)) //xsf add for vibra 12s(old is 4s) first then ring 2003.04.09
    {
        StartVibrator();
        l_playing=INCALLVIBRING;
        timStart(hRingVibStartTimer);
        return MFW_EVENT_CONSUMED;
    }
    // stop running timer
    if(hRingVibStartTimer != NULL)
        timStop(hRingVibStartTimer);

    //if((melody_status == MELODY_BUSY) && ( l_playing==SMSPLAYMELODY))  //XSF add 2002.10.15
        //StopMelody2(MelodyTablestr[3]);
	if( l_playing==SMSPLAYMELODY) //glowing, 2003-12-15
		StopPlayingMelody2( ); //glowing: use the new api
    if((melody_status == MELODY_IDLE) 
       &&(( l_playing==INCALLVIBRING)||( l_playing==SMSPLAY)||( l_playing==SMSPLAYVIB)||( l_playing==INCALLVIBRAR)))
    {
        if(l_playing==INCALLVIBRING)  //xsf add for vibra 12s(old is 4s) first then ring 2003.04.09
        {
            timStop(hRingVibStartTimer);	// 2004.4.1 wyj call no win
			
			SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].ringvolume);
            StartPlayingMelody2(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].ringtype, 0); //glowing: use the new api

        }
        else if(l_playing==SMSPLAY)
        {
            //StartMelody2(MelodyTablestr[3],0);
   			SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].smsvolume);
            StartPlayingMelody2( SMS_MELODY_NORMAL, 1); //glowing: use the new api
            l_playing=SMSPLAYMELODY;
            //CurrentMode = CurrentMode | ModeSms;  2004.3.30 wyj MI18800000128  
            //timStart( hRingVibStartTimer ); 2004.1.6 WYJ
        }
        else if(l_playing==INCALLVIBRAR)   //xsf add for incall first vibra then ring 2003.02.13 
        {
            StartPlayByReason(MENUSETPLAY,0); 
            timStop(hRingVibStartTimer);	// 2004.4.1 wyj call no win
        }
        else
            timStop(hRingVibStartTimer);	// 2004.4.1 wyj call no win

    }
    //else if(l_playing==SMSVIBRA)
    else if((l_playing==INCALLVIBRA)||(l_playing==INCALLPLAY))
        timStart(hRingVibStartTimer);
    else
        timStop(hRingVibStartTimer);		// 2004.4.1 wyj call no win

    return MFW_EVENT_CONSUMED;
}

// -----------------------------------------------------------------------
// Function		:SetRingVibra
// Description	: incoming call ring after Vibra  activate
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 2004.1.6 WYJ 
// ------------------------------------------------------------------------
//

void SetRingVibra(MfwMnu* m, MfwMnuItem* i)
{
	StopPlayingMelody2();
	FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].prompttype=VIBRARING;
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.08.16
    StartVibrator();
    //SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringvolume);
    l_playing=INCALLVIBRAR;  //xsf add 2003.02.13
//TIMCREATE_SETFLLAG(    hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
    timStart( hRingVibStartTimer );
	isKeyRing = 1;

}//SetRingVibra
// -----------------------------------------------------------------------
// Function		:SetMuteMode
// Description	: incoming call Mute  activate
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//


void SetMuteMode(MfwMnu* m, MfwMnuItem* i)
{

    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].prompttype = ALERTMUTE;
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.08.16
}//SetMuteMode

// -----------------------------------------------------------------------
// Function		:SetSmsRingmode
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified:      xsf 2003.02.28
// ------------------------------------------------------------------------
//
void SetSmsRing(MfwMnu* m, MfwMnuItem* i)
{

    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone = SMSRING;
    flash_environmentwrite();
	mnuUpdate(m);    
    if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume< 1)
        FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume = 3;

	SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume); 
    StartTonebypara(2);  //xsf change it from 1 to 2 temporarily 09.16 
   isKeyRing = 1;
}//SetSmsRingmode
// -----------------------------------------------------------------------
// Function		:SetSpecialRing
// Description	: Sms special ring select(will not be called)
// Input		: 
// Output		: 
// Notes		: 
// Last Modified:   2003.03.13
// ------------------------------------------------------------------------
//
void SetSpecialRing(MfwMnu* m, MfwMnuItem* i)
{
    uint8 smsringIndex=0;

	StopPlayingMelody2();

    if(((int)i->str)==TxtSmsRing1)
    {
        FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone = SPECIALRING1;
    }
    else if(((int)i->str)==TxtSmsRing2)
    {
        FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone = SPECIALRING2;
    }
    else if(((int)i->str)==TxtSmsRing3)
    {
        FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone = SPECIALRING3;
    }
    else if(((int)i->str)==TxtSmsRing4)
    {
        FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone = SPECIALRING4;
    }
    else if(((int)i->str)==TxtSmsRing5)
    {
        FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone = SPECIALRING5;
    }
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.08.16
    //add for set alarmvolume 2002.09.05
    if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume<1)
        FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume = 3;

    SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume); // FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume);
    smsringIndex=(uint8)(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone-SPECIALRING1);
    if((smsringIndex>=0) && (smsringIndex<5))
		StartPlayingMelody2( smsringIndex + FIRST_SMS_MELODY,1 ); //glowing: use the new api
        //StartMelody2(SmsMelodyTablestr[smsringIndex],0);  //add 2002.08.12  

}//SetSpecialRing

// -----------------------------------------------------------------------
// Function		:SetSmsVibra
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
void SetSmsVibra(MfwMnu* m, MfwMnuItem* i)   

{
    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone = SMSVIBRA;
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.08.16
    StartVibrator();
    l_playing=SMSPLAYVIB;
//TIMCREATE_SETFLLAG(    hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
    timStart( hRingVibStartTimer );
}//SetSmsVibra

// -----------------------------------------------------------------------
// Function		:SetSmsRVibra
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified:    xsf 2003.02.28
// ------------------------------------------------------------------------
//
void SetSmsRVibra(MfwMnu* m, MfwMnuItem* i)
{
    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone = SMSRVIBRA;
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.08.16
    StartVibrator();
    if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume<1)
        FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume = 3;

    SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume); // FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume);
    l_playing=SMSPLAY;
//TIMCREATE_SETFLLAG(    hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
    timStart( hRingVibStartTimer );
	isKeyRing = 1;
    // StartTone();
    //PlayVibAndRing(1,(SMSRING+CustToneBegin),ALConfig.EnviroProfile[Gu8_Envio_num].Volume[RINGER]*63/10,1);

}//SetSmsRVibra

// -----------------------------------------------------------------------
// Function		:SetSmsMute
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
void SetSmsMute(MfwMnu* m, MfwMnuItem* i)
{

    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone = SMSMUTE;
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.08.16
}

// -----------------------------------------------------------------------
// Function		:SetModeAutoanswer
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
static int SetModeAutoanswer(void)
{

    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].Autoanswerflag=! FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].Autoanswerflag;
    flash_environmentwrite();
    return 0;
}

// -----------------------------------------------------------------------
// Function		:SetModeEasyanswer
// Description	: any key answer
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//



void SetModeEasyanswer(MfwMnu* m, MfwMnuItem* i)
{
//    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].Anykeyanswerflag=! FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].Anykeyanswerflag;
  FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].Anykeyanswerflag=!FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].Anykeyanswerflag;/*2004/5/17, wangyan add*/
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.09.16

}

// -----------------------------------------------------------------------
// Function		:SetModeConnectTone
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
void SetModeConnectTonewer(MfwMnu* m, MfwMnuItem* i)
{
//    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].connecttone=! FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].connecttone;
	   FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].connecttone=! FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].connecttone;/*2004/5/17, wangyan add*/
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.09.16
    if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].connecttone)
        StartSpecialTone(1);  //xsf add 2002.09.16 //wms modified the function
}
// 2004.4.9 wyj modify
#if 0
// -----------------------------------------------------------------------
// Function		:SetKeypadTone
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
void SetKeypadTone(MfwMnu* m, MfwMnuItem* i)
{

    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadTone=! FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadTone;
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.09.16
    if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadTone)
        StartKeyBeep(0);  //xsf add 2002.08.05
    else
        StopKeyBeep();

}

void SetMissedcallTone(MfwMnu* m, MfwMnuItem* i)
{

    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].MissedcallTone=! FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].MissedcallTone;
    flash_environmentwrite();
    mnuUpdate(m);    //add 2002.09.16
    if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].MissedcallTone)
    {
        SetMVol_DownLinkPGA(4);
        //StartTonebypara(3);  //add 2002.09.16
        StartStdTone(3);
    }
}

void SetUnreadsmsTone(MfwMnu* m, MfwMnuItem* i)
{

    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].UnreadSMSTone=! FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].UnreadSMSTone;
    flash_environmentwrite();
    mnuUpdate(m);    //xsf add 2002.09.17
    if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].UnreadSMSTone)
    {
        SetMVol_DownLinkPGA(4); // FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume);
        StartTonebypara(2);  //xsf add 2002.09.16
    }
}
#endif 
// -----------------------------------------------------------------------
// Function		:Stopplayingdevice
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
void Stopplayingdevice( void )
{
    //if(melody_status==MELODY_BUSY)
    //{
        //StopMelody2(oldringstr);
        StopPlayingMelody2( ); //glowing: use the yamaha api
        //SetEarMode();
    //}

    if(tone_status==TONE_BUSY)
        StopTone();

    MC_StopVibra();		// 2004.4.16 WYJ 

    if(driverFlag&0x04)  //xsf add 2003.01.14
        driverFlag&=0xFFFFFFFB;
}

// -----------------------------------------------------------------------
// Function		:StopPlayByReasonId
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
void StopPlayByReasonId(AUDIO_REASON reasonid)
{
    //if(melody_status==MELODY_BUSY)
        //StopMelody2(oldringstr);
        StopPlayingMelody2( ); //glowing: use the new api

    if(tone_status==TONE_BUSY)
        StopTone();

	MC_StopVibra();						// 2004.4.16 WYJ add
	
    switch(reasonid)
    {
    case INCALL:
        CurrentMode = CurrentMode & (~ModeIncomCall);
        CurrentMode = CurrentMode & (~ModeCall);    
        CurrentMode = CurrentMode & (~ModeSms); 
        break;

    case INCALLPLAY:
		CurrentMode = CurrentMode & (~ModeIncomCall);
        CurrentMode = CurrentMode & (~ModeCall);   
        CurrentMode = CurrentMode & (~ModeSms);
        break;

    case ALARMPLAY:
        CurrentMode = CurrentMode & (~ModeAlarm);       
        CurrentMode = CurrentMode & (~ModeSms);     
        break;
    case MENURINGPLAY:   
        CurrentMode = CurrentMode & (~ModeRingmnu);     
        break;
    case SMSPLAY:
        CurrentMode = CurrentMode & (~ModeSms);     
        break;
    case VOICEMEMO:
        CurrentMode = CurrentMode & (~ModeVoicememo);       
        break;
    default:
        break;

    }
	/* 2004/03/23 sunsj modify for stop led */
	//glowing,2004-05-22, replace Green_Off as LEDOff()
	//	Green_Off();
    	LEDOff();
	timStop(LedStartTimer);
#ifdef SEVEN_COLORS_LED
        if(ServiceLedTimer)
        {
            timStart(ServiceLedTimer);
        }
#endif
}
// -----------------------------------------------------------------------
// Function		:StartPlayByReason
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
void StartPlayByReason(AUDIO_REASON reasonid, BOOLEANS index)
{
    int smsringIndex1=0;  //xsf add 2003.03.13
    U8 keytone_type;
	U8 keytone_volume;

    switch(FlashEnvironmentData.CurrentEnv)
    {
    //龰ģʽ
    case NORMAL_ENV:
    case OUTDOOR_ENV:
    case MEETING_ENV:
    case INCAR_ENV:
        switch(reasonid)
        {
        case INCALL:
            StopPlayByReasonId(INCALLPLAY);
            CurrentMode = CurrentMode | ModeCall;       
            //xsf remarked it 2003.03.04SetASpk_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume);
            break;
        case INCALLPLAYGROUP:        // incoming call to play device
        	if(index & 0x80)				//2004.12.18 WYJ add
        		index = FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].ringtype;
        case INCALLPLAY:

            if(CurrentMode & ModeCall)   //in call
                return;
            CurrentMode = CurrentMode & (~ModeAlarm);   
            CurrentMode = CurrentMode & (~ModeRingmnu);  
            CurrentMode = CurrentMode | ModeIncomCall;   
            //if((index != 0) ||(index == 0 && tone_status == TONE_IDLE) )
            StopPlayByReasonId(SMSPLAY);

            SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].ringvolume);
			if(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].prompttype == RING)
            //&& (melody_status==MELODY_IDLE))
            {
                 StartPlayingMelody2( index, 0 ); //glowing: use the new api
            }
            else if((FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].prompttype == VIBRA)
                    &&(vibra_status!=VIBRA_BUSY))
            {
                l_playing=INCALLVIBRA;
                StartVibrator();
//TIMCREATE_SETFLLAG(                hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
                timStart( hRingVibStartTimer );
            }
            else if(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].prompttype == VIBRARING)
            {
                if(vibra_status!=VIBRA_BUSY)
                    StartVibrator();
           //TIMCREATE_SETFLLAG(     hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
                timStart( hRingVibStartTimer );
                l_playing=INCALLPLAY;
            }
            else if(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].prompttype == RINGANDVIBRA)
            {
                StartPlayingMelody2(index,0); //glowing: use the new api
            
                if(vibra_status!=VIBRA_BUSY)
                {
                    StartVibrator();   
                    l_playing=INCALLVIBRA;
               //TIMCREATE_SETFLLAG(     hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
                    timStart( hRingVibStartTimer );
                }
            }
			
		//MMI_TRACE_EVENT(("<<<<talcon,StartPlayByReason,hRingVibStartTimer:%p",hRingVibStartTimer));
		//MMI_TRACE_EVENT(("<<<<talcon,StartPlayByReason,mfwRoot:%p(%p,%p,%p)",mfwRoot,mfwRoot->next,mfwRoot->type,mfwRoot->data));
            break;
        case SMSPLAY:            // short message to play device
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall) ||call_win_flag)  //xsf add call_win_flag 03.04.07
                return;
            //StopPlayByReasonId(SMSPLAY);
            //CurrentMode = CurrentMode | ModeSms;   //2004.3.30 WYJ fix MI18800000128
            smsringIndex1 = FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].SMSTone;
            SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].smsvolume);

			if((smsringIndex1 == SMSRING) && (tone_status!=TONE_BUSY))

                StartTonebypara(PLAYTONE);
            else if((smsringIndex1>= SPECIALRING1) && (smsringIndex1 <= SPECIALRING1+SMS_SUM-1))
            //&& (melody_status==MELODY_IDLE))
            {
                //StartMelody2(SmsMelodyTablestr[(uint8)smsringIndex1-SPECIALRING1],0);  
                StartPlayingMelody2( SMS_MELODY_NORMAL + (uint8)smsringIndex1, 1);  //glowing: use the yamaha api
            }
            else if((smsringIndex1 == SMSVIBRA) && (vibra_status!=VIBRA_BUSY))
            {
                //CurrentMode = CurrentMode | ModeSms;   
                StartVibrator(); 
                l_playing=SMSPLAYVIB;
              //TIMCREATE_SETFLLAG(  hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
                timStart( hRingVibStartTimer );
            }
            else if(smsringIndex1 == SMSRVIBRA)
            {
                //CurrentMode = CurrentMode | ModeSms;   
                if(vibra_status!=VIBRA_BUSY)
                    StartVibrator();
         //TIMCREATE_SETFLLAG(       hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
                timStart( hRingVibStartTimer );
                l_playing=SMSPLAY; 
            }

            break; 
        case ALARMPLAY:       // alarm to play device 
            if(CurrentMode & ModeIncomCall)
                return;

            if(CurrentMode & ModeCall)
            {
                //StartSpecialTone(4);
                return;
            }
            StopPlayByReasonId(SMSPLAY);
            SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].alarmvolume);
            CurrentMode = CurrentMode | ModeAlarm;  
            if(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].alarmprompt == RING)
            //&& (melody_status==MELODY_IDLE))	 
            {
				StartPlayingMelody2(  FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].alarmtype, 0); //glowing: use the yamaha api 2004.4.2 WYJ fix MI18800000155
            }
            else if((FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].alarmprompt == VIBRA)
                    &&(vibra_status!=VIBRA_BUSY))
            {
                StartVibrator(); 
                l_playing=INCALLVIBRA;
               //TIMCREATE_SETFLLAG( hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
                timStart( hRingVibStartTimer );
            }
            break;

        case MENURINGPLAY:     // play device while adjusting ring volume or SetRingmode()/SetRingAndVib() in menu
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall)||(CurrentMode & ModeSms))
                return;
            //StopPlayByReasonId(MENURINGPLAY);
            CurrentMode = CurrentMode | ModeRingmnu;      
            SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringvolume);
            //if(melody_status==MELODY_IDLE) //&& (tone_status == TONE_IDLE))	
            {
                StartPlayingMelody2( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringtype,0);  //glowing: use the yamaha api
            }
            break;
        case MENUALARMPLAY:   // play device while adjusting alarm volume or SetAlarmRingmode() in menu
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall)||(CurrentMode & ModeSms))
                return;
            //StopPlayByReasonId(MENURINGPLAY);
            //CurrentMode = CurrentMode | ModeRingmnu;  
            SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmvolume);
            if(melody_status==MELODY_IDLE) //&& (tone_status == TONE_IDLE))	
            {
                StartPlayingMelody2( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmtype,0);  //glowing: use the yamaha api
            }
            break;
        case MENUIDLEPLAY:       //play device while adjusting ring volume in idle window
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall)||(CurrentMode & ModeSms))
                return;
            //StopPlayByReasonId(MENURINGPLAY);
            CurrentMode = CurrentMode | ModeRingmnu;      

            SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].ringvolume);
            if(melody_status==MELODY_IDLE)// && (tone_status == TONE_IDLE))	
            {
                 StartPlayingMelody2( FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].ringtype,0);  //glowing: use the yamaha api
            }

            break;
        case MENUSETPLAY:       //play device while adjusting ring volume in idle window
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall)||(CurrentMode & ModeSms))
                return;
            //StopPlayByReasonId(MENURINGPLAY);
            if(melody_status==MELODY_IDLE)
            {
                if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringvolume<1)
                    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringvolume = 3;

                SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringvolume); //FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringvolume);
                StartPlayingMelody2( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringtype,0);  //glowing: use the yamaha api
            }
            break;
        case KEYPADTONE:      //key beep when keypadTone is opened
            /*       
            if((CurrentMode & ModeAlarm)||(CurrentMode & ModeSms))
                return;
            if(((CurrentMode & ModeIncomCall)||(CurrentMode & ModeCall)) && call_win_flag)
                //if(driverFlag & 0x00000001 == 0x00000001)
                return;

            StartKeyBeep(index); 
            break;
            */
            //2004.1.30 WYJ disable sound in main menu
			if(gPlayKeytoneFlag==2 && FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadTone==2)
				return;
			
            //glowing, 2003-12-15, disable Play keytone
            if( gPlayKeytoneFlag == 0 )
				return;
			
            if((CurrentMode & ModeAlarm)||(CurrentMode & ModeSms))
                return;
            if(((CurrentMode & ModeIncomCall)||(CurrentMode & ModeCall)) && call_win_flag)
                //if(driverFlag & 0x00000001 == 0x00000001)
                return;

	        //CurrentMode = CurrentMode & (~ModeMainMenu );

			
            keytone_volume= FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadVolume;
			if( keytone_volume == 0 || FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadTone==0)
				return;
            SetMVol_DownLinkPGA(keytone_volume);

            keytone_type= FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadTone;
					
			
            //if( keytone_type == 0 )
	        //    StartKeyBeep(index); 
            //else
                StartKeyVoice(keytone_type,index);  //glowing: use the yamaha api
                
            break; 

        case NEEDCHARGE:      //need to charge tone (big tone)
            if(CurrentMode & ModeCall)
            {
                //StartSpecialTone(2);  //need to charge tone (small tone)
                return;
            }
            else if(CurrentMode & ModeIncomCall)  //xsf add 2003.04.15
            {
                //StartSpecialTone(3);
                return;
            }
            else if(call_win_flag)
            {
                //StartSpecialTone(2);  //need to charge tone (small tone)
                return;
            }

			//if(FlashEnvironmentData.CurrentEnv == MEETING_ENV) //xsf add 2003.04.17
            //{
            //    StartVibrator(); 
            //    l_playing=SMSPLAYVIB;
              //TIMCREATE_SETFLLAG(  hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
            //    timStart( hRingVibStartTimer );
            //}
            //else
            SetMVol_DownLinkPGA(3);
            StartPlayingMelody2(NEEDCHARGE_WARNING, 1);
            break;
		//2004.4.9 wyj 
		#if 0
        case MISSEDCALL:     //missed call/calls tone every 5 minutes
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall)||(CurrentMode & ModeSms))
                return;
            if(FlashEnvironmentData.CurrentEnv == MEETING_ENV) //xsf add 2003.04.17
            {
                StartVibrator(); 
                l_playing=SMSPLAYVIB;
            //TIMCREATE_SETFLLAG(    hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
                timStart( hRingVibStartTimer );
            }
            else
            {
                SetMVol_DownLinkPGA(4);
                //StartTonebypara(3); 
                StartStdTone(3);
            }
            break;
        case UNREADSMS:     //unread new sms tone every 5 minutes
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall)||(CurrentMode & ModeSms))
                return;
            if(FlashEnvironmentData.CurrentEnv == MEETING_ENV) //xsf add 2003.04.17
            {
                StartVibrator(); 
                l_playing=SMSPLAYVIB;
            //TIMCREATE_SETFLLAG(    hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
                timStart( hRingVibStartTimer );
            }
            else
            {
                SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].smsvolume);
                StartTonebypara(2); 
            }
            break;
		#endif
        case CONNECTTONE:   //call connect tone
            if(CurrentMode & ModeCall)
                return;
			SetMVol_DownLinkPGA(2);
            StartPlayingMelody2(CONNENT_TONE, 1);
            break;
			
        case FULLHRALERT:    //full hour alert
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall))
                return;
			// 2004.4.2 WYJ fix MI18800000168
            SetMVol_DownLinkPGA(2);
			StartPlayingMelody2(FULLHOUR_TONE, 1);	
            break;
			
        case VOICEMEMO:    //voice dial/memo
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall))
                return;
            StopPlayByReasonId(SMSPLAY);
            CurrentMode = CurrentMode |ModeVoicememo;   
            break;

		case MAINMENUVOICE:
            if((CurrentMode & ModeAlarm)||(CurrentMode & ModeSms))
                return;
            if(((CurrentMode & ModeIncomCall)||(CurrentMode & ModeCall)) && call_win_flag)
                //if(driverFlag & 0x00000001 == 0x00000001)
                return;

            keytone_volume= FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadVolume;
			if( keytone_volume == 0 )
				return;
            SetMVol_DownLinkPGA(keytone_volume);

            keytone_type= FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadTone;

			if( keytone_type == 0 )
	            StartPlayingMelody2( KEYTONE_SINGLE, 0 ); //glowing: use the yamaha api
	        else
	            StartPlayingMelody2( KEYTONE_VOICE0 + index, 0); //glowing: use the yamaha api
				
            break; 
		case POWERONPLAY:
			if(!(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].OnRingtype & 0x80))
			{
				SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].OnVolume);
				StartPlayingMelody2(FIRST_HALL_MELODY + FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].OnRingtype, 1);
			}
            break; 

		case POWEROFFPLAY:
    		if( !(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].OffRingtype & 0x80) )
    		{
        		SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].OffVolume);
        		StartPlayingMelody2(FIRST_HALL_MELODY + FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].OffRingtype, 1);
    		}
            break; 
			
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
        case QQPLAY:  //xsf add for QQ received 2003.03.18
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall)||(CurrentMode & ModeSms))
                return;
            if(FlashEnvironmentData.CurrentEnv == MEETING_ENV) //xsf add 2003.04.17
            {
                StartVibrator(); 
                l_playing=SMSPLAYVIB;
       //TIMCREATE_SETFLLAG(         hRingVibStartTimer = timCreate( 0, TIM4SECOND, (MfwCb)stopvib2playmelody);)// 2004.4.1 wyj call no win
                timStart( hRingVibStartTimer );
            }
            else
                StartSpecialTone(6);
            break;
#endif
		case HALLON:					// 2004.4.9 WYJ add
			if( !(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].HallOnRingtype & 0x80))
			{
				SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].HallOnVolume);
				StartPlayingMelody2(FIRST_HALL_MELODY + FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].HallOnRingtype, 1);
			}
			break;
			
		case HALLOFF:
			if(!(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].HallOffRingtype & 0x80))
			{
				SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].HallOffVolume);
				StartPlayingMelody2(FIRST_HALL_MELODY + FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].HallOffRingtype, 1);
			}
			break;
			
		case MAINMENU_VOICE:
			if( FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadTone != 0)
			{
				SetMVol_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadVolume);
				StartPlayingMelody2( FIRST_MAINMENU_VOICE + index, 1 );
			}
			break;
	
        default:
            break;
        }

		/* 2004/06/14 sunsj modify for LED controller */
		switch(reasonid)
		{
		case INCALLPLAY:
		case INCALLPLAYGROUP:
		case ALARMPLAY:
			LEDStart(1);
			break;
		case SMSPLAY:
			LEDStart(0);
			break;
		default:
			break;
		}
		MMI_TRACE_EVENT(("<<<<talcon--2,StartPlayByReason,LedStartTimer:%p",LedStartTimer));
		MMI_TRACE_EVENT(("<<<<talcon--2,StartPlayByReason,mfwRoot:%p(%p,%p,%p)",mfwRoot,mfwRoot->next,mfwRoot->type,mfwRoot->data));
        break;

	case MUTE_ENV: //ģʽ
        switch(reasonid)
        {
        case INCALL: 
            StopPlayByReasonId(INCALLPLAY);
            CurrentMode = CurrentMode | ModeCall;   
            SetASpk_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume);
            break;
        case INCALLPLAYGROUP:             // 1
        case INCALLPLAY:

            if(CurrentMode & ModeCall)   //in call
                return;
            CurrentMode = CurrentMode & (~ModeAlarm);   
            CurrentMode = CurrentMode & (~ModeRingmnu);  
            CurrentMode = CurrentMode | ModeIncomCall;          
            StopPlayByReasonId(SMSPLAY);

            break;
        case SMSPLAY:            // 2
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall))
                return;
            StopPlayByReasonId(SMSPLAY);

            break; 
        case ALARMPLAY:       // 3
            if(CurrentMode & ModeIncomCall)
                return;
            if(CurrentMode & ModeCall)
            {
                //StartSpecialTone(4);
                return;
            }
            StopPlayByReasonId(SMSPLAY);
            CurrentMode = CurrentMode | ModeAlarm;         
            break;

        case MENURINGPLAY:     // 4
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall)||(CurrentMode & ModeSms))
                return;
            StopPlayByReasonId(MENURINGPLAY);
            CurrentMode = CurrentMode | ModeRingmnu;  
            break;

        case MENUALARMPLAY:   //5
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall)||(CurrentMode & ModeSms))
                return;
            StopPlayByReasonId(MENURINGPLAY);
            CurrentMode = CurrentMode | ModeRingmnu;        
            break;

        case MENUIDLEPLAY:       //6
            if((CurrentMode & ModeIncomCall) ||(CurrentMode & ModeAlarm)||(CurrentMode & ModeCall)||(CurrentMode & ModeSms))
                return;
            StopPlayByReasonId(MENURINGPLAY);
            CurrentMode = CurrentMode | ModeRingmnu;           
            break;

        case KEYPADTONE:           
        case NEEDCHARGE:           
        case MISSEDCALL:       
        case UNREADSMS:            
        case CONNECTTONE:      
        default:
            break;
        }
        break;
    default:
        break;

    }
}


/********************************************************************************/
/*                                                                              */
/*Function Name: environment_check                                              */
/*Purpose:      environment_check   flag funtiong for menu                      */
/*Prarmeter:   struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *m i */
/*return   :     USHORT                                                         */
/*                                                                              */
/*Author   :     xsf                                                            */
/*Date     :    Aug.13th,2002  2004.1.6 WYJ                                                  */
/********************************************************************************/
USHORT environment_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    //if(melody_status==MELODY_BUSY)
        //StopMelody2(oldringstr);
    //    StopPlayingMelody2(); //glowing: use the new api
    //else if(tone_status==TONE_BUSY)
    //if(tone_status==TONE_BUSY)
        //StopTone();

    //if(vibra_status==VIBRA_BUSY)
    //    StopVibrator();

    //if(hRingVibStartTimer != NULL)
    //    timDelete(hRingVibStartTimer);

	static	int aCursor = 0;
	
	//ֻڲ˵лʱ 2004.2.9 WYJ
	if(m->lCursor[m->level] != aCursor)
	{
		MC_StopVibra();						// 2004.4.16 WYJ add

        aCursor = m->lCursor[m->level];

		if(isKeyRing && !((int)mi->str>=TxtSmsRing1 && (int)mi->str<=TxtSmsRing5) )
		{
			StopPlayingMelody2( );
			isKeyRing = 0;
		}
	}

    if(((int)mi->str==TxtMissedCallTone || (int)mi->str==TxtUnreadSMSTone) && ( m->lCursor[m->level] >= 6)) //add 2003.01.06
        driverFlag|=0x04;
    else   //xsf add for KCD_LEFT 2003.01.14
        driverFlag&=0xFFFFFFFB;
	
//    if(((int)mi->str==TxtAnyKeyAnswer) && ( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].Anykeyanswerflag))
if(((int)mi->str==TxtAnyKeyAnswer) && ( FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].Anykeyanswerflag))/*2004/5/17, wangyan add*/
        return FLAGFUNC_TRUE_ICON;
 //   else if(((int)mi->str==TxtAnswerTone) && ( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].connecttone))
	else if(((int)mi->str==TxtAnswerTone) && ( FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].connecttone))/*2004/5/17, wangyan add*/
        return FLAGFUNC_TRUE_ICON;
    else if(((int)mi->str==TxtMissedCallTone) && ( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].MissedcallTone))
        return FLAGFUNC_TRUE_ICON;
    else if(((int)mi->str==TxtKeypadTones) && ( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadTone))
        return FLAGFUNC_TRUE_ICON;
    else if(((int)mi->str==TxtUnreadSMSTone) && ( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].UnreadSMSTone))
        return FLAGFUNC_TRUE_ICON;
    else if(((int)mi->str==TxtSmsVibra) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmprompt==VIBRA))
        return FLAGFUNC_TRUE_ICON;
    //else if(((int)mi->str==TxtRingPrompt) && (FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmprompt==RING))
    //      return FLAGFUNC_TRUE_ICON; 
    //else if(((int)mi->str==TxtStart) && (FlashEnvironmentData.CurrentEnv== Gu8_Envio_num))
    else if(((int)mi->str==TxtActivate) && (FlashEnvironmentData.CurrentEnv== Gu8_Envio_num))  //wuyj

        return FLAGFUNC_TRUE_ICON;
    else

        return FLAGFUNC_FALSE_ICON;

}


/* 2003/12/08 sunsj add */
void SetKeypadToneRing(MfwMnu* m, MfwMnuItem* i)
{
    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadTone= 1;
	if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadVolume < 1)
		FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadVolume = 3;
    flash_environmentwrite();
    mnuUpdate(m);    
    //SetMVol_DownLinkPGA(4);
    //StartTonebypara(2);
}

/* 2003/12/08 sunsj add */
void SetKeypadToneSpcial(MfwMnu* m, MfwMnuItem* i)
{
    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadTone = 2;
	if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadVolume < 1)
		FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadVolume = 3;
    flash_environmentwrite();
    mnuUpdate(m);    
    //SetMVol_DownLinkPGA(4);
    //StartTonebypara(2);
}

/* 2004.1.4 WYJ add key sound mute option */
void setKeypadMute(MfwMnu* m, MfwMnuItem* i)
{
    FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadTone = 0;
	flash_environmentwrite();
	mnuUpdate(m); 
}

USHORT checkKeypadMute( struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi )
{
	if ( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadTone==0 )
		return FLAGFUNC_TRUE_ICON;
    else
        return FLAGFUNC_FALSE_ICON;
}


//	2004.5.10 WYJ add
void SetOnMenu(MfwMnu* m, MfwMnuItem* i)
{
	isOnRing = 1;
}

void SetOffMenu(MfwMnu* m, MfwMnuItem* i)
{
	isOnRing = 0;
}
//	end of 2004.5.10 WYJ add


//-----------------------2004.1.13 WYJ------------------------- 
/*******************************************************/
/*Function Name: SetOnRingMute                   
/*Purpose:       Off ring mute                 
/*Prarmeter:                                         
/*return   :                                       
/*Author   :     WYJ                                   
/*Date     :     2004.1.15                        
/*******************************************************/
void SetOnRingMute(MfwMnu* m, MfwMnuItem* i)
{
	isOnRing = 1;
	FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OnRingtype |= 0x80;
	mnuUpdate (m);
	flash_environmentwrite();
}

/*******************************************************/
/*Function Name: SetOffRingMute                   
/*Purpose:       Off ring mute                 
/*Prarmeter:                                         
/*return   :                                       
/*Author   :     WYJ                                   
/*Date     :     2004.1.15                        
/*******************************************************/
void SetOffRingMute(MfwMnu* m, MfwMnuItem* i)
{
	isOnRing = 0;
	FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OffRingtype |= 0x80;
	mnuUpdate (m);
	flash_environmentwrite();
}

/*******************************************************/
/*Function Name: OnOff_check                   
/*Purpose:       flag check function for on/off menu                 
/*Prarmeter:                                         
/*return   :                                       
/*Author   :     WYJ                                   
/*Date     :     2004.1.15                        
/*******************************************************/
USHORT OnOff_check( struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi )
{
	if(gPlayKeytoneFlag == 0)
		gPlayKeytoneFlag = 1;
	
	if(isOnRing == 1)			// 2004.5.10 WYJ modify
	{
		if(((int)mi->str==TxtSpecialRing) &&(!(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OnRingtype & 0x80)))
			return FLAGFUNC_TRUE_ICON;
		else if (((int)mi->str==TxtSmsMute) &&(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OnRingtype & 0x80))
			return FLAGFUNC_TRUE_ICON;
		else
			return FLAGFUNC_FALSE_ICON;
	}
	else if(isOnRing == 0)		//ػ 2004.5.10 WYJ modify
	{
		if(((int)mi->str==TxtSpecialRing) &&(!(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OffRingtype&0x80)))
			return FLAGFUNC_TRUE_ICON;
		else if (((int)mi->str==TxtSmsMute) &&(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OffRingtype & 0x80))
			return FLAGFUNC_TRUE_ICON;
		else
			return FLAGFUNC_FALSE_ICON;	
	}
	else
	{
		return FLAGFUNC_FALSE_ICON;	
	}
}

/*******************************************************/
/*Function Name: SetHallOnMenu                   
/*Purpose:       select HallOn menu, modify flag                
/*Prarmeter:                                         
/*return   :                                       
/*Author   :     WYJ                                   
/*Date     :     2004.2.12                        
/*******************************************************/
void SetHallOnMenu(MfwMnu* m, MfwMnuItem* i)
{
	gIsHallOnSet = 1;
}

/*******************************************************/
/*Function Name: SetHallOffMenu                   
/*Purpose:       select HallOn menu, modify flag                
/*Prarmeter:                                         
/*return   :                                       
/*Author   :     WYJ                                   
/*Date     :     2004.2.12                        
/*******************************************************/
void SetHallOffMenu(MfwMnu* m, MfwMnuItem* i)
{
	gIsHallOnSet = 0;
}

/*******************************************************/
/*Function Name: SetHallOnOffRingMute                   
/*Purpose:       set HallOnOff mute                
/*Prarmeter:                                         
/*return   :                                       
/*Author   :     WYJ                                   
/*Date     :     2004.2.12                        
/*******************************************************/
void SetHallOnOffRingMute(MfwMnu* m, MfwMnuItem* i)
{
	if(gIsHallOnSet)
		FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOnRingtype |= 0x80;
	else
		FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOffRingtype |= 0x80;
	mnuUpdate (m);
	flash_environmentwrite();
}

/*******************************************************/
/*Function Name: HallOnOff_check                   
/*Purpose:       flag check function for hallset menu                
/*Prarmeter:                                         
/*return   :                                       
/*Author   :     WYJ                                   
/*Date     :     2004.2.12                        
/*******************************************************/
USHORT HallOnOff_check( struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi )
{
	if(gPlayKeytoneFlag == 0)
		gPlayKeytoneFlag = 1;
	
	
	if(gIsHallOnSet)						//
	{
		if(((int)mi->str==TxtSpecialRing) &&(!(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOnRingtype & 0x80)))
			return FLAGFUNC_TRUE_ICON;
		else if (((int)mi->str==TxtSmsMute) &&(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOnRingtype & 0x80))
			return FLAGFUNC_TRUE_ICON;
		else
			return FLAGFUNC_FALSE_ICON;
	}
	else 									//ػ
	{
		if(((int)mi->str==TxtSpecialRing) &&(!(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOffRingtype&0x80)))
			return FLAGFUNC_TRUE_ICON;
		else if (((int)mi->str==TxtSmsMute) &&(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOffRingtype & 0x80))
			return FLAGFUNC_TRUE_ICON;
		else
			return FLAGFUNC_FALSE_ICON;	
	}
}


/* ring select windows functions*/
static T_MFW_HND	ring_create (T_MFW_HND  parent_win);
static void			ring_destroy  (T_MFW_HND  own_window);
void				ring_dialog_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int			ring_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static int			ring_kbd_cb (T_MFW_EVENT event, T_MFW_KBD * keyboard);
static T_MFW_CB		ring_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc);

/* phonebook group index */
extern int	ringSelect;

//picture shift counter 
static int	ringcount = 0;
//group select ring volume
static U8  dumvol = 2;


/*
 *	2004.3.18 WYJ  
 */
int callSelect(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND	parent_win	= mfw_parent(mfw_header());
	T_MFW_HND	win			= ring_create(parent_win);
  
	if (win NEQ NULL)
	{
		SEND_EVENT (win, RI_INIT, RI_SELECT, 0);
	}
	return 1;
}

/*
 *	2004.3.18 WYJ  
 */
int alarmSelect(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND	parent_win	= mfw_parent(mfw_header());
	T_MFW_HND	win			= ring_create(parent_win);
	
	if (win NEQ NULL)
	{
		SEND_EVENT (win, RI_INIT, AL_SELECT, 0);
	}
	return 1;
}

/*
 *	2004.3.18 WYJ  
 */
int smsSelect(MfwMnu* m, MfwMnuItem* i)
{	
	T_MFW_HND	parent_win	= mfw_parent(mfw_header());
	T_MFW_HND	win			= ring_create(parent_win);

	if (win NEQ NULL)
	{
		SEND_EVENT (win, RI_INIT, SM_SELECT, 0);
	}
	return 1;
}

/*
 *	2004.3.18 WYJ  
 */
int powerOnSelect(MfwMnu* m, MfwMnuItem* i)
{	
	T_MFW_HND	parent_win	= mfw_parent(mfw_header());
	T_MFW_HND	win			= ring_create(parent_win);

	if (win NEQ NULL)
	{
		SEND_EVENT (win, RI_INIT, PO_SELECT, 0);
	}
	return 1;
}

/*
 *	2004.3.18 WYJ  
 */
int powerOffSelect(MfwMnu* m, MfwMnuItem* i)
{	
	T_MFW_HND	parent_win	= mfw_parent(mfw_header());
	T_MFW_HND	win			= ring_create(parent_win);

	if (win NEQ NULL)
	{
		SEND_EVENT (win, RI_INIT, PF_SELECT, 0);
	}
	return 1;
}

/*
 *	2004.3.18 WYJ  
 */
int hallOnOffSelect(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND	parent_win	= mfw_parent(mfw_header());
	T_MFW_HND	win			= ring_create(parent_win);
	
	if (win NEQ NULL)
	{
		isOnOffMenuRing = 1;
		if(gIsHallOnSet)
			SEND_EVENT (win, RI_INIT, HO_SELECT, 0);
		else
			SEND_EVENT (win, RI_INIT, HF_SELECT, 0);
	}
	return 1;
}

/*
 *	2004.3.18 WYJ  
 */
int groupSelect(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND	parent_win	= mfw_parent(mfw_header());
	T_MFW_HND	win			= ring_create(parent_win);
	
	if (win NEQ NULL)
	{
		SEND_EVENT (win, RI_INIT, GP_SELECT, 0);
	}
	return 1;
}

/*
 *	2004..18 WYJ  
 */
static T_MFW_HND ring_create (T_MFW_HND  parent_win)
{
	T_MFW_WIN   *win_data;
	T_ring		*data = (T_ring *)ALLOC_MEMORY (sizeof (T_ring));
	
	/* window create */
	data->ring_win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)ring_win_cb);
	
	if (data->ring_win EQ 0)
		return 0;
	
	/* Create window handler */
	data->mmi_control.dialog   = (T_DIALOG_FUNC)ring_dialog_cb;
	data->mmi_control.data     = data;
	data->parent_win           = parent_win;
	win_data                   = ((T_MFW_HDR *)data->ring_win)->data;
	win_data->user             = (void *)data;
	
	/* return window handle	*/
	return data->ring_win;
}

/*
 *	2004.3.18 WYJ  
 */
static void ring_destroy  (T_MFW_HND  own_window)
{
	T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
	T_ring		  * data   = (T_ring *)win->user;
	
	if (own_window == NULL)
		return;
	
	StopPlayingMelody2();

	if (data)
	{
		kbd_delete (data->ring_kbd);
		tim_delete (data->ring_tim);

		win_delete (data->ring_win);

		FREE_MEMORY ((void *)data, sizeof (T_ring));
	}
	
	// enble key tone 
	gPlayKeytoneFlag = 1;
}

/*
 *	2004.3.18 WYJ  
 */
void ring_dialog_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN   * win_data     = ((T_MFW_HDR *)win)->data;
	T_ring		* data         = (T_ring *)win_data->user;

	switch (event)
	{
    case RI_INIT:
		dumvol = 2;
		data->ring_kbd = kbd_create (win, KEY_ALL, (T_MFW_CB)ring_kbd_cb);
		data->ring_tim = tim_create (win, 800, (T_MFW_CB)ring_tim_cb);
		tim_start(data->ring_tim);
		
		data->eventType = value;

		if(value==RI_SELECT || value==AL_SELECT || value==GP_SELECT)
		{
			data->ringsum		= RING_SUM;
			data->ringOffset	= 0;
			data->txtOffset		= Txtmelody1;
		}
		else if(value == SM_SELECT)
		{
			data->ringsum		= SMS_SUM;
			data->ringOffset	= FIRST_SMS_MELODY;
			data->txtOffset		= TxtSmsRing1;
		}
		else
		{
			data->ringsum		= HALL_TONE_SUM;	
			data->ringOffset	= FIRST_HALL_MELODY;
			data->txtOffset		= TxtSmsRing1;
		}
		
		switch(value)
		{
		case RI_SELECT:
			data->ringtype		= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringtype;
			data->ringvolume	= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringvolume;
			data->index 		= FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringtype;
			break;

		case AL_SELECT:
			data->ringtype		= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmtype;
			data->ringvolume	= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmvolume;
			data->index 		= FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmtype;
			break;
		
		case GP_SELECT:
			data->ringtype		= &FFS_PBOtherData.GroupingItem[RingSelect].GroupingRing;
			data->ringvolume	= &dumvol;
			data->index 		= FFS_PBOtherData.GroupingItem[RingSelect].GroupingRing & 0x7f;
			break;

		case SM_SELECT:
			data->ringtype		= (uint8 *)(&FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone);
			data->ringvolume	= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume;
			
			if(*(data->ringtype) >= SPECIALRING1 && *(data->ringtype) <= SPECIALRING1+SMS_SUM-1)
				data->index = *(data->ringtype) - 1;
			else
				data->index = 0;
			break;

		case PO_SELECT:
			data->ringtype		= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OnRingtype;
			data->ringvolume	= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OnVolume;
			data->index			= FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OnRingtype & 0x7f;
			break;
		
		case PF_SELECT:
			data->ringtype		= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OffRingtype;
			data->ringvolume	= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OffVolume;
			data->index			= FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OffRingtype & 0x7f;
			break;
		
		case HO_SELECT:
			data->ringtype		= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOnRingtype;
			data->ringvolume	= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOnVolume;
			data->index			= FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOnRingtype & 0x7f;
			break;
		
		case HF_SELECT:
			data->ringtype		= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOffRingtype;
			data->ringvolume	= &FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOffVolume;
			data->index			= FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOffRingtype & 0x7f;
			break;
		}
		
		//disable key tone
		gPlayKeytoneFlag = 0;

		/* play first melody */
		if(*(data->ringvolume) < 1)
			*(data->ringvolume) = 3;
			
		SetMVol_DownLinkPGA(*(data->ringvolume));
		StartPlayingMelody2(data->index + data->ringOffset, 1);

		ringcount = 0;
		win_show (win);
		break;
	
    case RI_DESTROY:
		ring_destroy(win);
		break;
	}
}


/*
 *	2004.3.18 WYJ  
 */
static int ring_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_ring * data = (T_ring *)win->user;
	
    if (data EQ 0)
		return 1;
	
    switch (event)
	{
	case E_WIN_VISIBLE:
		if (win->flags & E_WIN_VISIBLE)
		{
			dspl_ClearAll();
			draw_special_background();
#if (MAIN_LCD_SIZE==3)//jhxu 720
			/* title display */
            DRAW_ICON(ICON_MENUUP);
			
			// name display
			ALIGNED_PROMPT(CENTER, 0, DSPL_TXTATTR_TRANSPARENT, data->txtOffset + data->index);
			
			switch(ringcount)
			{
			case 0:
				//	dspl_BitBlt(20, 18, 71, 95, 0, (void *)musicPlay0, 0);
				DRAW_ICON_SEL(ICON_MUSIC_PLAY,0);
				break;
				
			case 1:
				//	dspl_BitBlt(41, 18, 46, 95, 0, (void *)musicPlay1, 0);
				DRAW_ICON_SEL(ICON_MUSIC_PLAY,1);
				break;
				
			case 2:
				//	dspl_BitBlt(34, 18, 81, 95, 0, (void *)musicPlay2, 0);
				DRAW_ICON_SEL(ICON_MUSIC_PLAY,2);
				break;
				
			case 3:
				//dspl_BitBlt(31, 18, 72, 95, 0, (void *)musicPlay3, 0);
				DRAW_ICON_SEL(ICON_MUSIC_PLAY,3);
				break;
				
			case 4:
				//	dspl_BitBlt(34, 18, 57, 95, 0, (void *)musicPlay4, 0);
				DRAW_ICON_SEL(ICON_MUSIC_PLAY,4);
				break;
				
			case 5:
				//	dspl_BitBlt(36, 18, 55, 95, 0, (void *)musicPlay5, 0);
				DRAW_ICON_SEL(ICON_MUSIC_PLAY,5);
				break;
			}
#elif ( MAIN_LCD_SIZE==4 )
			ALIGNED_PROMPT(CENTER, 0, DSPL_TXTATTR_TRANSPARENT, data->txtOffset + data->index);
			DRAW_ICON_SEL(ICON_RING_IMAGE, 0);
			//dspl_BitBlt(38, 64, 52, 63, 0, (void *)gImage_ring1, 0);
			
			if(ringcount)
			{
				DRAW_ICON_SEL(ICON_RING_IMAGE, 1);
				DRAW_ICON_SEL(ICON_RING_IMAGE, 2);
				//dspl_BitBlt(38, 86, 22, 26, 0, (void *)gImage_ring2l, 0);
				//dspl_BitBlt(67, 86, 23, 31, 0, (void *)gImage_ring2r, 0);
			}
			
			//dspl_colorTextOut(19, 42, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->txtOffset + data->index), 0xffffff);
#elif ( MAIN_LCD_SIZE==2 )
			/* title display */
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
				menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
				menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);

			// name display
			ALIGNED_PROMPT(CENTER, 0, DSPL_TXTATTR_TRANSPARENT, data->txtOffset + data->index);
	
			switch(ringcount)
			{
			case 0:
				dspl_BitBlt(29, 18, 50, 41, 0, (void *)musicPlay0, 0);
				break;

			case 1:
				dspl_BitBlt(13, 17, 35, 39, 0, (void *)musicPlay1_a, 0);
				dspl_BitBlt(60, 19, 27, 33, 0, (void *)musicPlay1_b, 0);
				break;

			case 2:
				dspl_BitBlt(15, 22, 27, 33, 0, (void *)musicPlay2_a, 0);
				dspl_BitBlt(54, 15, 27, 34, 0, (void *)musicPlay2_b, 0);
				break;

			case 3:
				dspl_BitBlt(24, 17, 60, 45, 0, (void *)musicPlay3, 0);
				break;

			case 4:
				dspl_BitBlt(27, 17, 51, 43, 0, (void *)musicPlay4, 0);
				break;

			case 5:
				dspl_BitBlt(17, 21, 36, 40, 0, (void *)musicPlay5_a, 0);
				dspl_BitBlt(59, 18, 29, 34, 0, (void *)musicPlay5_b, 0);
				break;
			}
#endif
			displaySoftKeys(TxtSoftOK,TxtSoftBack);
			break;
		}
	default:
		return 0;
		}
    return 1;
	}
	
/*
 *	2004.3.18 WYJ
 */
static int ring_kbd_cb (T_MFW_EVENT event, T_MFW_KBD * keyboard)
{
	T_MFW_HND       win			= mfw_parent (mfw_header());
	T_MFW_WIN		* win_data	= ((T_MFW_HDR *)win)->data;
	T_ring			* data		= (T_ring *)win_data->user;
	T_DISPLAY_DATA	display_info;
	
	switch (keyboard->code)
	{
	case KCD_F4:
	case KCD_HUP:							//escape
    case KCD_RIGHT:
		SEND_EVENT (win, RI_DESTROY,0, 0);
		break;

   case KCD_LEFT:							//confirm
	    *(data->ringtype) = data->index;

		if (data->eventType == SM_SELECT)	//2004.3.29 WYJ MI18800000111 sms ring begins with index 1 
			*(data->ringtype) += 1;

		if(data->eventType == GP_SELECT)
			flash_PBOtherWrite("PBOption");
		else
			flash_environmentwrite();

		dialog_info_init(&display_info);   
		display_info.TextId2      = TxtDone;  
		display_info.Time         = THREE_SECS;
		display_info.Callback     = 0;
		display_info.iconindex    =REMIND_COMPLETE;
		/*
		* Call Info Screen
		*/
		info_dialog (win, &display_info);
		SEND_EVENT (win, RI_DESTROY,0, 0);
		break;
		
	case KCD_MNULEFT:						//back
		data->index = (data->index-1+data->ringsum) % (data->ringsum);
		winShow(win);
		SetMVol_DownLinkPGA(*(data->ringvolume));
		StartPlayingMelody2(data->index + data->ringOffset, 1);
		break;

	case KCD_MNURIGHT:						//forward
		data->index = (data->index+1) % (data->ringsum);
		winShow(win);
		SetMVol_DownLinkPGA(*(data->ringvolume));
		StartPlayingMelody2(data->index + data->ringOffset, 1);
		break;

    default:
		break; 
	}

	return MFW_EVENT_CONSUMED;
}

/*
 *	2004.3.18 WYJ  
 *	ring select animation timer
 */
static T_MFW_CB ring_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
	T_MFW_HND	win			= mfw_parent (mfw_header());
	T_MFW_WIN	* win_data	= ((T_MFW_HDR *)win)->data;
	T_ring		* data		= (T_ring *)win_data->user;

#if (MAIN_LCD_SIZE==3)//jhxu720
	ringcount = (ringcount+1) % 6;
#elif ( MAIN_LCD_SIZE==4 )
	//picture shift counter
	ringcount = (ringcount+1) % 2;
#elif ( MAIN_LCD_SIZE==2 )
	//picture shift counter
	ringcount = (ringcount+1) % 6;
#endif

	//timer restart
	tim_start(data->ring_tim);
	
	//show ring select window
	winShow(win);
	
	return 0;
}

/*
 *	2004.3.18 WYJ
 */
USHORT group_check( struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi )
	{
    if(((int)mi->str==TxtGroupSelect) && !(FFS_PBOtherData.GroupingItem[RingSelect].GroupingRing & 0x80))
        return FLAGFUNC_TRUE_ICON;
	else if (((int)mi->str==TxtGroupMute) && (FFS_PBOtherData.GroupingItem[RingSelect].GroupingRing & 0x80))
			return FLAGFUNC_TRUE_ICON;
		else
			return FLAGFUNC_FALSE_ICON;
	}

/*
 *	2004.3.18 WYJ
 */
int SetGroupMute(MfwMnu* m, MfwMnuItem* i)
{
	FFS_PBOtherData.GroupingItem[RingSelect].GroupingRing |= 0x80;
	mnuUpdate(m); 
	flash_PBOtherWrite("PBOption");
	return 1;
}

/* 2004/03/18 sunsj add led controller */
static int LedLightEvent( MfwEvt e, MfwTim *tc )
{
	timStop(LedStartTimer);
	/* 2004/06/09 sunsj modify */
	LEDStart(0);
	timStart(LedStartTimer);
}


/*
 *	2004.3.24 WYJ modify volume adjust 
 */
void volume_adjust_play(int type, int volume)
{
	if(type == SPEAKERVOLUME || type == CALLEARVOLUME || type == IDLEVOLUME)
	{
		SetASpk_DownLinkPGA(volume);
	}
	else
	{
		SetMVol_DownLinkPGA(volume);
		
        if(type == RINGVOLUME)
        {
            StartPlayingMelody2( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringtype,0);   // xsf add 2002.09.04
        }
        else if(type == ALARMVOLUME)
        {
            StartPlayingMelody2( FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmtype,0);  // xsf add 2002.09.04
        }
        else if(type == SMSVOLUME)  //xsf add 2003.01.28
        {
        	 //2004.3.29 WYJ fix MI18800000117
        	 if(FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone >= SMSVIBRA)
			 	StartPlayingMelody2( SMS_MELODY_NORMAL, 1 );
             else
			 	StartPlayingMelody2( SMS_MELODY_NORMAL+ FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].SMSTone, 1 );
        }
       	else if(type == KEYTONEVOLUME)	/* 2003/12/08 sunsj */
        {
			StartPlayingMelody2( KEYTONE_SINGLE, 1);		//2004.1.6 WYJ
		}
		else if(type == ONTONEVOLUME)	//2004.1.14 WYJ ADD 
		{
			StartPlayingMelody2((FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OnRingtype&0x7f)+FIRST_HALL_MELODY, 1);		
		}
		else if(type == OFFTONEVOLUME)	//2004.1.14 WYJ ADD 
        {
			StartPlayingMelody2((FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OffRingtype&0x7f)+FIRST_HALL_MELODY, 1);		
		}
		else if(type == HALLONOFFVOLUME) //2004.2.1 WYJ Add
		{
			if(gIsHallOnSet)
			{
				StartPlayingMelody2((FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOnRingtype&0x7f)+FIRST_HALL_MELODY, 1);		
			}
			else
			{
				StartPlayingMelody2((FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOffRingtype&0x7f)+FIRST_HALL_MELODY, 1);		
			}
		}
	}
}

/*******************************************************************************

 $Function:	volume_destroy 
 $Description:	Destroy the volume  dialog.
 $Returns:		void
 $Arguments:	window
 
*******************************************************************************/
void  volume_destroy  (T_MFW_HND own_window)
{
    T_ringvolume_kbd * data ;
    T_MFW_WIN * win;
    driverFlag&=0xFFFFFFFE;//wms set back the last bit flag to 0 02/12/28

	// 2004.3.29 WYJ add enable key tone
	gPlayKeytoneFlag = 1;

    if(own_window)
    {
        TRACE_EVENT("volume_destroy");
        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_ringvolume_kbd *)win->user;

        if(data)
        {
            if(call_data.win_adjustvolume&&call_data.win)
            {
                call_data.win_adjustvolume=0;
                /*zy 2003-04-01 if in call destroy adjustvolume win in call_data.win_adjustvolume 
              it's impossible destroy nomorl adjust win.
                */
            }
            /* Delete WIN Handler and children handler*/
            // pin_edit_windows = 0;
            win_delete (data->volume_kbd_win);
            FREE_MEMORY((void *)data,(sizeof(T_ringvolume_kbd)));;
        }
    }
}

/*******************************************************************************

 $Function:	volume_kbd_cb 
 $Description:	Callback function for keyboard
 $Returns:		Status int
 $Arguments:	window handle event, keyborad control block
 
*******************************************************************************/
static int volume_kbd_cb (T_MFW_EVENT event,T_MFW_KBD *  kc)
{
 T_MFW_HND			win			= mfw_parent(mfw_header());
 T_MFW_WIN			*win_data	= ((T_MFW_HDR *)win)->data;
 T_ringvolume_kbd	*volume_data = (T_ringvolume_kbd *)win_data->user;

    TRACE_FUNCTION("zhqdebug: Mmienvironment.c:volume_kbd_cb");
	
    switch(kc->code)
    {
    case KCD_F4:
        if(volume_data->volume_status == CALLEARVOLUME)
        {
            if(!HallStatus()&&call_data.win&&IsHandsetPlugin())
            {
                flash_environmentwrite();
                //	VolumeIconDel();zy 2003-04-01needn't destroy these icons just init them at iconinit and destroy at last
                volume_destroy(volume_data->volume_kbd_win);              
            }
            else if(!HallStatus()&&call_data.win)
            {
                flash_environmentwrite();
                //	VolumeIconDel();zy 2003-04-01needn't destroy these icons just init them at iconinit and destroy at last
                volume_destroy(volume_data->volume_kbd_win);
                SEND_EVENT(call_data.win, CALL_DESTROY_ALL, 0, 0);
            }
        }
        else if(!HallStatus())
        {
            StopPlayByReasonId(MENURINGPLAY);
            flash_environmentwrite();
            // VolumeIconDel();zy 2003-04-01needn't destroy these icons just init them at iconinit and destroy at last
            volume_destroy(volume_data->volume_kbd_win);
        }
        break;          
    case KCD_HUP:
    case KCD_RIGHT:
        volume_destroy(volume_data->volume_kbd_win);
		StopPlayingMelody2();
		break;

	case KCD_OK:
    case KCD_LEFT:   
      	if(volume_data->volume_status == RINGVOLUME)
        {
            FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringvolume = volume_data->curVol;
        }
        else if(volume_data->volume_status == ALARMVOLUME)
        {
            FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmvolume = volume_data->curVol;
        }
        else if(volume_data->volume_status == SPEAKERVOLUME)
        {
            FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].speakervolume = volume_data->curVol;
			SetASpk_DownLinkPGA(volume_data->curVol);
        }
        else if(volume_data->volume_status == CALLEARVOLUME)
        {
            FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume = volume_data->curVol;
            SetASpk_DownLinkPGA( volume_data->curVol);
        }
        else if(volume_data->volume_status == IDLEVOLUME) //xsf replaced ringvolume with speakervolume 03.04.29
        {
            FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume = volume_data->curVol;
			SetASpk_DownLinkPGA(volume_data->curVol);
        }
        else if(volume_data->volume_status == SMSVOLUME)  //xsf add 2003.01.28
        {
            FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume = volume_data->curVol;
        }
       	else if(volume_data->volume_status == KEYTONEVOLUME)	/* 2003/12/08 sunsj */
        {
            FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadVolume = volume_data->curVol;
		}
		else if(volume_data->volume_status == ONTONEVOLUME)	//2004.1.14 WYJ ADD 
		{
            FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OnVolume = volume_data->curVol;
		}
		else if(volume_data->volume_status == OFFTONEVOLUME)	//2004.1.14 WYJ ADD 
        {
            FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OffVolume = volume_data->curVol;
		}
		else if(volume_data->volume_status == HALLONOFFVOLUME) //2004.2.1 WYJ Add
		{
			if(gIsHallOnSet)
			{
				FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOnVolume = volume_data->curVol;
			}
			else
			{
				FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOffVolume = volume_data->curVol;
			}
		}
		flash_environmentwrite();
        volume_destroy(volume_data->volume_kbd_win);
		StopPlayingMelody2();
        break;

    case KCD_VOLUP:
    case KCD_MNUUP:
    case KCD_MNURIGHT:
        TRACE_EVENT("zhq debug: kcd_volUp");
        TRACE_EVENT_P1("zhq debug: volume_data->volume_status = %d", volume_data->volume_status);

        if(volume_data->curVol < 6)
            volume_data->curVol += 1;
        else
            volume_data->curVol = 6;

		volume_adjust_play(volume_data->volume_status, volume_data->curVol);
		
        iconsShowVolume(volume_data->curVol);
		
        break;
	case KCD_F3:
    case KCD_VOLDOWN:
    case KCD_MNUDOWN:
    case KCD_MNULEFT:
	    TRACE_EVENT_P1("zhq debug: volume_data->volume_status = %d", volume_data->volume_status);

        if(volume_data->curVol > 0)
            volume_data->curVol -= 1;
        else
            volume_data->curVol = 0;
		
		volume_adjust_play(volume_data->volume_status, volume_data->curVol);

		iconsShowVolume(volume_data->curVol);
        break;
		
	case KCD_ABC:
		break;

    default:							// anykey quit in call win
        if(volume_data->volume_status == CALLEARVOLUME)
        {
            flash_environmentwrite();
            //	VolumeIconDel();zy 2003-04-01needn't destroy these icons just init them at iconinit and destroy at last
            volume_destroy(volume_data->volume_kbd_win);              
        }
        //timer = FALSE;
        break;  
    }
    //if (timer)
    //	tim_start(volume_data->tim_out_handle);/* start timer for entering */
    return MFW_EVENT_CONSUMED;
}




/*******************************************************************************

 $Function:	volume_win_cb
 $Description:	Callback function for volume windows
 $Returns:		Status int
 $Arguments:	window handle event, window
 
*******************************************************************************/
static int volume_win_cb (T_MFW_EVENT event,T_MFW_WIN * win)
{
    T_ringvolume_kbd 	*volume_data = (T_ringvolume_kbd *)win->user;
    T_MFW_WIN 			*win_volume =((T_MFW_HDR *)volume_data->parent_win)->data;
    int 				TxtId;
	
    if(event EQ MfwWinVisible)
    {
        dspl_ClearAll();
#if (MAIN_LCD_SIZE==3)//jhxu720
	DRAW_ICON(ICON_MENUUP);
#elif ( MAIN_LCD_SIZE==4 )
	draw_special_background();
#else ( MAIN_LCD_SIZE==2 )
        dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                     menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
#endif

		if(volume_data->volume_status == RINGVOLUME)
        {
            TxtId = TxtRingVolume;  
        }
        else if(volume_data->volume_status == ALARMVOLUME)
        {
            TxtId = TxtAlarmVolume;  
        }
        else if(volume_data->volume_status == SPEAKERVOLUME)
        {
            TxtId = TxtSpeakerVolume;  
        }
        else if(volume_data->volume_status ==CALLEARVOLUME)
        {
            TxtId = TxtSpeakerVolume;  
        }
        //press VOLUP/VOLDOWN in idle window  xsf add 2002.09.05
        else if(volume_data->volume_status == IDLEVOLUME) //xsf replaced ringvolume with speakervolume 03.04.29
        {
            TxtId = TxtSpeakerVolume;  //xsf replaced TxtRingVolume with TxtSpeakerVolume 03.04.29
        }
        else if(volume_data->volume_status == SMSVOLUME)  //xsf add 2003.01.28
        {
            TxtId = TxtSmsVolume;  
        }
		else if(volume_data->volume_status == KEYTONEVOLUME )	/* 2003/12/08 sunsj */
		{
            TxtId = TxtKeypadToneVolume;
		}
		else if(volume_data->volume_status == ONTONEVOLUME )	//2004.1.14 WYJ
		{
            TxtId = TxtOnVolume;
		}
		else if(volume_data->volume_status == OFFTONEVOLUME )	//2004.1.14 WYJ
		{
            TxtId = TxtOffVolume;
		}
		else if(volume_data->volume_status == HALLONOFFVOLUME )
		{
			TxtId = TxtHallOnVolume;
		}

		ALIGNED_PROMPT(CENTER, 0, DSPL_TXTATTR_TRANSPARENT, TxtId);
        iconsShowVolume(volume_data->curVol);
        displaySoftKeys(TxtSoftConfirm, TxtSoftBack);
#if(MAIN_LCD_SZIE==3)
		draw_softkeybar_leftright_arrow();//jhxu720
#endif
        return 1;
    }
    return 0;
}

static void adjustvolume(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
T_MFW_WIN   		*win_data	= ( (T_MFW_HDR *) win )->data;
T_ringvolume_kbd	*data 		= (T_ringvolume_kbd *) win_data->user; 


	//2004.3.29 WYJ disable key tone
	gPlayKeytoneFlag = 0;
	

	switch(event)
    {
    case RINGVOLUME:
        data->curVol = FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].ringvolume;
		break;		
    case ALARMVOLUME:
        data->curVol = FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].alarmvolume;
		break;
    case SPEAKERVOLUME:
        data->curVol = FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].speakervolume;
		break;
    case CALLEARVOLUME:
        data->curVol = FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume;
		break;
    //press VOLUP/VOLDOWN in idle window  xsf add 2002.09.05
    case IDLEVOLUME: //xsf replaced ringvolume with speakervolume 03.04.29
        data->curVol = FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume;
		break;
    case SMSVOLUME:
        data->curVol = FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].smsvolume;
		break;
    case KEYTONEVOLUME:	/* 2003/12/08 sunsj */
        data->curVol = FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].KeypadVolume;
		break;
	case ONTONEVOLUME:	//2004.1.14 WYJ ADD 
        data->curVol = FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OnVolume;
		break;
	case OFFTONEVOLUME:	//2004.1.14 WYJ ADD 
        data->curVol = FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].OffVolume;
		break;
	case HALLONOFFVOLUME:	//2004.2.12 WYJ ADD 
		if(gIsHallOnSet)
			data->curVol = FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOnVolume;
		else
			data->curVol = FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].HallOffVolume;
		break;

	/*zy 2003-04-01 when need destroy in call win*/
    case CALLVOLDESTROY:
        //	VolumeIconDel();
        volume_destroy(win);
        break;
        /*end of zy 2003-04-01 when need destroy in call win*/   
    default:
        break;
    }
    winShow(win);
}


/*******************************************************************************

 $Function:    	adjustvolume_create

 $Description:	Creation of an instance for the adjustvolume dialog 

                Type of dialog : SINGLE_DYNAMIC
 $Returns:		Window

 $Arguments:	Parent window
 
*******************************************************************************/
T_MFW_HND adjustvolume_create (T_MFW_HND parent_window)
{
T_MFW_WIN     		*win;
T_ringvolume_kbd 	*data = (T_ringvolume_kbd*)ALLOC_MEMORY (sizeof (T_ringvolume_kbd));

    data->volume_kbd_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)volume_win_cb);

    if(data->volume_kbd_win EQ 0)
        return 0;
    //  VolumeIconInit();zy 2003-04-01 these icons have been init at the iconinit
    /*Create window handler*/

    driverFlag|=0x00000001;//the last bit for judge adjustvolume is set to 1 wms added 02/12/28
    data->mmi_control.dialog    = (T_DIALOG_FUNC)adjustvolume;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                 = ((T_MFW_HDR *)data->volume_kbd_win)->data;
    win->user           = (void *) data;

    /*
     * Create any other handler
     */
    //data->tim_out_handle = tim_create(data->volume_kbd_win,TIMERESULT,(T_MFW_CB)volume_tim_out_cb);
    data->kbd_handle = kbd_create(data->volume_kbd_win,KEY_ALL|KEY_F4,(T_MFW_CB)volume_kbd_cb);
    /*
     * return window handle
     */
    /* 
    winShow( data->volume_kbd_win);
    */
    return data->volume_kbd_win;

}

/*******************************************************/
/*                                                     */
/*Function Name: AdjustRingerVolume                    */
/*Purpose:       Adjust Ringer Volume in menu                */
/*Prarmeter:     void                                    */
/*return   :     void                                  */
/*                                                     */
/*Author   :     xsf                                   */
/*Date     :    Aug.25th,2002                          */
/*******************************************************/
int AdjustRingerVolume (MfwMnu *m, MfwMnuItem *i)
{
T_MFW_HND 			idle_win = idle_get_window();
T_MFW_HND 			win = adjustvolume_create(idle_win);
T_MFW_WIN 			*win_data = ((T_MFW_HDR *)win)->data;
T_ringvolume_kbd 	*volume_data = (T_ringvolume_kbd *)win_data->user;
int 				event;
	
	if(((int)i->str)==TxtRingVolume)
    {
        volume_data->volume_status = RINGVOLUME;
    }
    else if(((int)i->str)==TxtAlarmVolume)
    {
        volume_data->volume_status = ALARMVOLUME;
    }
    else if(((int)i->str)==TxtSpeakerVolume)
    {
        volume_data->volume_status = SPEAKERVOLUME;
    }
    else if(((int)i->str)==TxtSmsVolume)
    {
        volume_data->volume_status = SMSVOLUME;
    }
    else if(((int)i->str)==TxtKeypadToneVolume)	/* 2003/12/08 sunsj add */
    {
		volume_data->volume_status = KEYTONEVOLUME;
    }
	else if(((int)i->str) == TxtOnVolume)	//2004.1.14 WYJ ADD 
	{
		volume_data->volume_status = ONTONEVOLUME;
	}
	else if(((int)i->str) == TxtOffVolume)	//2004.1.14 WYJ ADD 
	{
		volume_data->volume_status = OFFTONEVOLUME;
	}
	else if(((int)i->str) == TxtHallOnVolume)//2004.2.12 WYJ Add
	{
		volume_data->volume_status = HALLONOFFVOLUME;
	}

   	SEND_EVENT(volume_data->volume_kbd_win, volume_data->volume_status, 0, volume_data);
	
    return MFW_EVENT_CONSUMED;
}


//press VOLUP/VOLDOWN in idle window  xsf add 2002.09.05
void AdjustRingerVolumeIdle (void)
{
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = adjustvolume_create(idle_win);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_ringvolume_kbd * volume_data = (T_ringvolume_kbd *)win_data->user;
	
    //VolumeIconInit();
    //press VOLUP/VOLDOWN in idle window  xsf add 2002.09.05
    volume_data->volume_status = IDLEVOLUME; 
    SEND_EVENT(volume_data->volume_kbd_win,IDLEVOLUME,0,volume_data); 
	
}
void AdjustEarVolumeCall (void)
{
    T_MFW_HND win = adjustvolume_create(call_data.win);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_ringvolume_kbd * volume_data = (T_ringvolume_kbd *)win_data->user;
    /*zy 2003-04-01 start adjust win in call win*/
    if(call_data.win)
    {
        call_data.win_adjustvolume=win;
    }
    //VolumeIconInit();
    //press VOLUP/VOLDOWN in idle window  xsf add 2002.09.05
    volume_data->volume_status = CALLEARVOLUME;
    SEND_EVENT(volume_data->volume_kbd_win,CALLEARVOLUME,0,volume_data);    
}
/*
 *	end of 2004.3.24 WYJ modify volume adjust 
 */

// 2004.4.16 WYJ add 
void MC_StopVibra(void)
{
	if(vibra_status==VIBRA_BUSY)
			StopVibrator();

	if(hRingVibStartTimer != NULL)
        timStop(hRingVibStartTimer);		
}



