
/********************************************************************************/
/* File Name            : TdDisplay.c                                     		*/
/* File Description     : ʱڵĽʾģ					          	*/
/* Author Name      	: Wu Yajun	                                            */
/* Date	            	:														*/    
/* Copyright       		: mobile innovation	                                    */
/* History:  Date:                                                              */ 
/*           Author:                                                            */
/*           Modify:                                                            */ 
/********************************************************************************/
#include "typedefs.h"
#include "dspl.h"

#include "TdDisplay.h"
#include "..\bmi\mmiiconresource.h"
#define TD_FOR_TEST 1

#if(MAIN_LCD_SIZE==3)

/*  */
const TD_Rect	BG_rect		  = {10+EX, 42, 100, 78};		//λ
const TD_Attri	BG_attr		  = {0xf8f562, 0x92782d, 0x104 };//
const Color		BG_color2	  =	0xbeba32;					//߿ɫ
/* ôڳ */
const TD_Rect	DS_input_rect = {25+EX, 19, 80, 15};		//λ
const TD_Attri	DS_input_attr = {0xe0e0e0, 0x004c98, 0x102};//

const TD_Rect	DS_hint_rect  = {25+EX, 48, 64, 14};		//ʾλ
const TD_Attri	DS_hint_attr  = {0xc7eceb, 0xc7eceb, 0x200};//ʾ

const TD_Line	DS_index_l	  = {27+EX, 32, 34+EX, 32};		//λ
const Color		DS_index_c	  = 0x0000ff;					//ɫ

/* ʱôڳ */
const TD_Rect	TS_input_rect  = {25+EX, 19, 76, 15};		 //λ
const TD_Attri	TS_input_attr1 = {0xe0e0e0, 0x004c98, 0x102};//(ѡ)
const TD_Attri	TS_input_attr2 = {0xDBFFFF, 0xCDAAC5, 0x002};//(δѡ)

const TD_Line	TS_index_l	   = {32+EX, 32, 38+EX, 32};	//λ
const Color		TS_index_c	   = 0x0000ff;					//ɫ

const TD_Rect	TS_tm_rect	   = {25+EX, 48, 67, 14};		 //ʱģʽѡλ
const TD_Attri	TS_tm_attr     = {0xc7eceb, 0xc7eceb, 0x100};//ʱģʽѡ(δѡ)
const TD_Attri	TS_tm_attr1    = {0x5ac7ff, 0x5ac7ff, 0x100};//ʱģʽѡ(ѡ)

const TD_Rect	TS_AP_rect     = {42+EX, 64, 22, 12};		 //AM/PMѡλ
const TD_Attri	TS_AP_attr	   = {0x5ac7ff, 0x5ac7ff, 0x100};//AM/PMѡ

/* ôڳ */
const TD_Rect	AL_input_rect  = {26+EX, 19, 46, 16};		//λ//shiheng 288 modidy
const TD_Attri	AL_input_attr1 = {0xe0e0e0, 0x004c98, 0x102};//(ѡ)
const TD_Attri	AL_input_attr2 = {0xDBFFFF, 0xCDAAC5, 0x002};//(δѡ)

const TD_Line	AL_index_l	   = {31+EX, 33, 37+EX, 33};	//λ//shiheng 288 modify
const Color		AL_index_c	   = 0x0000ff;					//ɫ

const TD_Rect	AL_hint_rect   = {24+EX, 48, 66, 14};		 //ʱģʽʾλ
const TD_Attri	AL_hint_attr   = {0xc7eceb, 0xc7eceb, 0x200};//ʱģʽʾ

const TD_Rect	AL_AP_rect     = {40+EX, 33, 22, 12};		 //AM/PMѡλ
const TD_Attri	AL_AP_attr	   = {0x5ac7ff, 0x5ac7ff, 0x100};//AM/PMѡ

/* ʱó */
const TD_Rect	TM_input_rect  = {24+EX, 19, 70, 16};		//λ
const TD_Attri	TM_input_attr  = {0xe0e0e0, 0x004c98, 0x102};//

const TD_Line	TM_index_l	   = {28+EX, 32, 34+EX, 32};	//λ
const Color		TM_index_c	   = 0x0000ff;					//ɫ

/* Զػ */
const TD_Rect	AU_input_rect  = {31+EX, 17, 40, 13};		//λ
const TD_Attri	AU_input_attr1 = {0xe0e0e0, 0x004c98, 0x102};//(ѡ)
const TD_Attri	AU_input_attr2 = {0xDBFFFF, 0xCDAAC5, 0x002};//(δѡ)

const TD_Line	AU_index_l	   = {37+EX, 29, 41+EX, 29};	//λ
const Color		AU_index_c	   = 0x0000ff;					//ɫ

const TD_Rect	AU_SW_rect   = {39+EX,35, 24, 12};			//ؿλ
const TD_Attri	AU_SW_attr   = {0x5ac7ff, 0x5ac7ff, 0x100};//ؿ

const TD_Rect	AU_AP_rect   = {40+EX, 50, 22, 12};		//AM/PMѡλ
const TD_Attri	AU_AP_attr   = {0x5ac7ff, 0x5ac7ff, 0x100}; //AM/PMѡ

/* ճ̱ */
const TD_Rect	SC_week_rect = {0, 31, 127, 14};			//ڿλ
const TD_Attri	SC_week_attr = {0xc7eceb, 0xc7eceb, 0x200}; //ڿ

const TD_Rect	SC_Lunar_rect = {0, 125, 127, 16};			//ũλ
const TD_Attri	SC_Lunar_attr = {0xf8f562, 0xf8f562, 0x200};//ũ

const TD_Rect   SC_BS_rect = {0, 17, 127, 13};				//
const TD_Attri  SC_BS_attr = {0xc7eceb, 0xc7eceb, 0x200};	//

#elif(MAIN_LCD_SIZE==4)

/*  */
const TD_Rect	BG_rect		  = {10+EX, 40, 100, 85};		//λ
const TD_Attri	BG_attr		  = {0xf8f562, 0x92782d, 0x104 };//
const Color		BG_color2	  =	0xbeba32;					//߿ɫ
/* 2004/05/20 yhf modify */
/* ôڳ */
const TD_Rect	DS_input_rect = {16+EX, 56, 88, 18};		//λ
const TD_Attri	DS_input_attr = {0xe0e0e0, 0x004c98, 0x102};//

const TD_Rect	DS_hint_rect  = {27+EX, 92, 66, 13};		//ʾλ
const TD_Attri	DS_hint_attr  = {0xc7eceb, 0xc7eceb, 0x200};//ʾ

const TD_Line	DS_index_l	  = {20+EX, 72, 28+EX, 72};		//λ
const Color		DS_index_c	  = 0x0000ff;					//ɫ

/* ʱôڳ */
const TD_Rect	TS_input_rect  = {24+EX, 56, 72, 18};		 //λ
const TD_Attri	TS_input_attr1 = {0xe0e0e0, 0x004c98, 0x102};//(ѡ)
const TD_Attri	TS_input_attr2 = {0xDBFFFF, 0xCDAAC5, 0x002};//(δѡ)

const TD_Line	TS_index_l	   = {28+EX, 72, 36+EX, 72};	//λ
const Color		TS_index_c	   = 0x0000ff;					//ɫ

const TD_Rect	TS_tm_rect	   = {30+EX, 82, 60, 13};		 //ʱģʽѡλ
const TD_Attri	TS_tm_attr     = {0xc7eceb, 0xc7eceb, 0x100};//ʱģʽѡ(δѡ)
const TD_Attri	TS_tm_attr1    = {0x5ac7ff, 0x5ac7ff, 0x100};//ʱģʽѡ(ѡ)

const TD_Rect	TS_AP_rect     = {49+EX, 103, 22, 12};		 //AM/PMѡλ
const TD_Attri	TS_AP_attr	   = {0x5ac7ff, 0x5ac7ff, 0x100};//AM/PMѡ

/* 2004/05/19yhf modify */
/* ôڳ */
const TD_Rect	AL_input_rect  = {35+EX, 56, 50, 18};		//λ
const TD_Attri	AL_input_attr1 = {0xe0e0e0, 0x004c98, 0x102};//(ѡ)
const TD_Attri	AL_input_attr2 = {0xDBFFFF, 0xCDAAC5, 0x002};//(δѡ)

const TD_Line	AL_index_l	   = {40+EX, 72, 48+EX, 72};	//λ
const Color		AL_index_c	   = 0x0000ff;					//ɫ

const TD_Rect	AL_hint_rect   = {28+EX, 102, 64, 13};		 //ʱģʽʾλ
const TD_Attri	AL_hint_attr   = {0xc7eceb, 0xc7eceb, 0x200};//ʱģʽʾ

const TD_Rect	AL_AP_rect     = {49+EX, 82, 22, 12};		 //AM/PMѡλ
const TD_Attri	AL_AP_attr	   = {0x5ac7ff, 0x5ac7ff, 0x100};//AM/PMѡ
/***end yhf modify***/


const TD_Rect	TM_input_rect  = {21+EX, 64, 80, 18};		//λ /* 2004/05/18 yhf modify */
//const TD_Rect	TM_input_rect  = {24+EX, 29, 54, 13};		//λ
const TD_Attri	TM_input_attr  = {0xe0e0e0, 0x004c98, 0x102};//

const TD_Line	TM_index_l	   = {28+EX, 80, 36+EX, 80};	//λ
//const TD_Line	TM_index_l	   = {28+EX, 41, 32+EX, 41};	//λ  /* 2004/05/18 yhf modify */
const Color		TM_index_c	   = 0x0000ff;					//ɫ

/* 2004/05/20 yhf modify */
/* Զػ */
const TD_Rect	AU_input_rect  = {35+EX, 56, 50, 18};		//λ
const TD_Attri	AU_input_attr1 = {0xe0e0e0, 0x004c98, 0x102};//(ѡ)
const TD_Attri	AU_input_attr2 = {0xDBFFFF, 0xCDAAC5, 0x002};//(δѡ)

const TD_Line	AU_index_l	   = {40+EX, 72, 48+EX, 72};	//λ
const Color		AU_index_c	   = 0x0000ff;					//ɫ

const TD_Rect	AU_SW_rect   = {38+EX, 82, 44, 17};			//ؿλ
const TD_Attri	AU_SW_attr   = {0x5ac7ff, 0x5ac7ff, 0x100};//ؿ

const TD_Rect	AU_AP_rect   = {49+EX, 103, 22, 12};		//AM/PMѡλ
const TD_Attri	AU_AP_attr   = {0x5ac7ff, 0x5ac7ff, 0x100}; //AM/PMѡ
/***end yhf modify***/

/* ճ̱ */
const TD_Rect	SC_week_rect = {0, 31, 127, 14};			//ڿλ
const TD_Attri	SC_week_attr = {0xc7eceb, 0xc7eceb, 0x200}; //ڿ

const TD_Rect	SC_Lunar_rect = {0, 125, 127, 16};			//ũλ
const TD_Attri	SC_Lunar_attr = {0xf8f562, 0xf8f562, 0x200};//ũ

const TD_Rect   SC_BS_rect = {0, 17, 127, 13};				//
const TD_Attri  SC_BS_attr = {0xc7eceb, 0xc7eceb, 0x200};	//
#endif
/* ģڲ */ 
static	void	drawtype1(TD_Rect r, TD_Attri a);
static	void	drawtype2(TD_Rect r, TD_Attri a);
static	void	drawtype3(TD_Rect r, TD_Attri a);

static	void	TD_drawRectangle0(TD_Rect r, Color color);
static	void	TD_drawRectangle1(TD_Rect r, Color color);
static	void	TD_drawRectangle2(TD_Rect r, Color color);

/*  */
void TD_drawLine(TD_Line l, Color color)
{
int oldcolor;

	oldcolor = dspl_SetFrgColor(color);
	dspl_DrawLine(l.x1, l.y1, l.x2, l.y2);
	dspl_SetFrgColor(oldcolor);
}

/* ο */
void TD_drawSolidRectangle(TD_Rect r, TD_Attri a)
{
	dspl_Clear(r.x, r.y, r.x+r.width, r.y+r.height);
	
	/* ɫ */
	switch(a.type & 0xff00)
	{
	case 0x0000:
		TD_drawRectangle0(r, a.fillcolor);	//䣨ɫ
		break;
	case 0x0100:							//޽Ч
		TD_drawRectangle1(r, a.fillcolor);
		break;
	case 0x0200:							//нЧ
		TD_drawRectangle2(r, a.fillcolor);
		break;
	}
	
	/* ߿ */
	switch(a.type & 0xff)
	{
	case 1:									//
		drawtype1(r, a);
		break;
	case 2:									//
		drawtype2(r, a);
		break;
	case 3:									//Ӱ
		drawtype3(r, a);
		break;
	}
}
/* 䣨ɫ */
static	void	TD_drawRectangle0(TD_Rect r, Color color)
{
int oldcolor;

	oldcolor = dspl_SetFrgColor(0xffffff);
	dspl_DrawRect(r.x, r.y, r.x+r.width, r.y+r.height);
	dspl_SetFrgColor(oldcolor);
}	

/* ʵľ */
static void TD_drawRectangle1(TD_Rect r, Color color)
{
int oldcolor;
	
	oldcolor = dspl_SetBkgColor(color);
	dspl_fill_rectangle(r.x, r.y, r.x+r.width, r.y+r.height);
	dspl_SetBkgColor(oldcolor);

	oldcolor = dspl_SetFrgColor(color);
	dspl_DrawRect(r.x, r.y, r.x+r.width, r.y+r.height);
	dspl_SetFrgColor(oldcolor);
}

/* ʵľΣɫ䣩 */
static void TD_drawRectangle2(TD_Rect r, Color color)
{
int oldcolor;
int i;
TD_Line		l;

	oldcolor = dspl_SetFrgColor(color);
	dspl_DrawRect(r.x, r.y, r.x+r.width, r.y+r.height);
	dspl_SetFrgColor(oldcolor);

	oldcolor = dspl_SetBkgColor(color);

	l.x1 = r.x;	
	l.y1 = r.y; 
	l.x2 = r.x + r.width;
	l.y2 = r.y;
	
	for(i=0; i<r.height; i++)
	{
		color -= 0x030303;
		l.y1++;
		l.y2++;
		TD_drawLine(l,  color);
	}

	dspl_SetBkgColor(oldcolor);
}

/* ߿  */
static	void	drawtype1(TD_Rect r, TD_Attri a)
{
TD_Line	l;
	/*  */
	l.x1	= r.x + 1;
	l.y1	= r.y - 1;
	l.x2	= r.x + r.width  - 1;
	l.y2	= r.y - 1;
	TD_drawLine(l, a.framecolor);
	/*  */
	l.x1	= r.x + r.width  + 1;
	l.y1	= r.y + 1;
	l.x2	= r.x + r.width  + 1;
	l.y2	= r.y + r.height - 1;
	TD_drawLine(l, a.framecolor);
	/*  */
	l.x1	= r.x + 1;
	l.y1	= r.y + r.height + 1;
	l.x2	= r.x + r.width  - 1;
	l.y2	= r.y + r.height + 1;
	TD_drawLine(l, a.framecolor);
	/*  */
	l.x1	= r.x - 1;
	l.y1	= r.y + 1;
	l.x2	= r.x - 1;
	l.y2	= r.y + r.height - 1;
	TD_drawLine(l, a.framecolor);
}

/* ο */
static	void	drawtype2(TD_Rect r, TD_Attri a)
{
TD_Line		l;
	/*  */
	l.x1	= r.x - 1;
	l.y1	= r.y - 1;
	l.x2	= r.x + r.width  ;
	l.y2	= r.y - 1;
	/*  */
	TD_drawLine(l, a.framecolor);
	l.x1	= r.x + r.width  + 1;
	l.y1	= r.y - 1;
	l.x2	= r.x + r.width  + 1;
	l.y2	= r.y + r.height + 1;
	TD_drawLine(l, a.framecolor);
	/*  */
	l.x1	= r.x - 1;
	l.y1	= r.y + r.height + 1;
	l.x2	= r.x + r.width  + 1;
	l.y2	= r.y + r.height + 1;
	TD_drawLine(l, a.framecolor);
	/*  */
	l.x1	= r.x - 1;
	l.y1	= r.y - 1;
	l.x2	= r.x - 1;
	l.y2	= r.y + r.height + 1;
	TD_drawLine(l, a.framecolor);
}

/* Ӱ;ο */
static	void	drawtype3(TD_Rect r, TD_Attri a)
{
TD_Line		l;
	/*  */
	l.x1	= r.x + r.width  + 1;
	l.y1	= r.y + 1;
	l.x2	= r.x + r.width  + 1;
	l.y2	= r.y + r.height;
	TD_drawLine(l, a.framecolor);
	/*  */
	l.x1	= r.x + 1;
	l.y1	= r.y + r.height + 1;
	l.x2	= r.x + r.width  ;
	l.y2	= r.y + r.height + 1;
	TD_drawLine(l, a.framecolor);
}

/* ͼƬ */
void TD_drawPic(TD_Pic pic)
{
	dspl_BitBlt(pic.x, pic.y, pic.width, pic.height, 0, pic.p, 0);
}

extern const unsigned char icnMnuListBkg[];

/*  */
void TD_drawBkg(TD_Rect r, TD_Attri a)
{
#if(MAIN_LCD_SIZE==4)
	/* 2004/05/18 yhf modify */
	TD_Line l;
	
	TD_drawRectangle1(r, a.fillcolor);
	/*  */
	l.x1	= r.x - 1;
	l.y1	= r.y - 1;
	l.x2	= r.x + r.width  ;
	l.y2	= r.y - 1;
	TD_drawLine(l, 0xdfa726);
	/*  */
	l.x1	= r.x - 1;
	l.y1	= r.y - 1;
	l.x2	= r.x - 1;
	l.y2	= r.y + r.height + 1;
	TD_drawLine(l, 0xdfa726);
	/*  */
	l.x1	= r.x + r.width  + 1;
	l.y1	= r.y ;
	l.x2	= r.x + r.width  + 1;
	l.y2	= r.y + r.height;
	TD_drawLine(l, BG_color2);
	l.x1	= r.x + r.width  + 2;
	l.y1	= r.y + 1;
	l.x2	= r.x + r.width  + 2;
	l.y2	= r.y + r.height + 1;
	TD_drawLine(l, a.framecolor);
	/*  */
	l.x1	= r.x ;
	l.y1	= r.y + r.height + 1;
	l.x2	= r.x + r.width  + 1;
	l.y2	= r.y + r.height + 1;
	TD_drawLine(l, BG_color2);
	l.x1	= r.x + 1;
	l.y1	= r.y + r.height + 2;
	l.x2	= r.x + r.width  + 1;
	l.y2	= r.y + r.height + 2;
	TD_drawLine(l, a.framecolor);
#elif (MAIN_LCD_SIZE==3)
	DRAW_ICON(ICON_MENULISTBKGICONS);
#endif

}
