
/********************************************************************************/
/* File Name            : TdDisplay.h                                     		*/
/* File Description     : ʱڵĽʾģ					          	*/
/* Author Name      	: Wu Yajun	                                            */
/* Date	            	:														*/    
/* Copyright       		: mobile innovation	                                    */
/* History:  Date:                                                              */ 
/*           Author:                                                            */
/*           Modify:                                                            */ 
/********************************************************************************/

#ifndef _TDDISPLAY_H
#define _TDDISPLAY_H

/*  */
#define		EX		0	//4 - 128*160		0  120*160		


/* ṹ嶨 */
typedef	int Color;

typedef struct 
{
	unsigned char	x;							
	unsigned char	y;								
}TD_Point;									//

typedef struct
{
	unsigned char	x1;							
	unsigned char	y1;
	unsigned char	x2;							
	unsigned char	y2;								
	int				type;					//
}TD_Line;

typedef struct
{
	unsigned char	x;								
	unsigned char	y;
	unsigned char	width;
	unsigned char	height;
}TD_Rect;									//

typedef struct
{
	unsigned char	x;								
	unsigned char	y;		
	int				width;
	int				height;
	char		   *p;	
}TD_Pic;									//ͼƬ

typedef struct
{
	Color	fillcolor;
	Color	framecolor;
	int		type;
}TD_Attri;									//

/* ȫֱ */

/*  */
extern const TD_Pic		BG_pic;
extern const TD_Rect	BG_rect;
extern const TD_Attri	BG_attr;
extern const Color		BG_color2;
  
/* ӿں */
void TD_drawLine(TD_Line l, Color color);			//
void TD_drawSolidRectangle(TD_Rect r, TD_Attri a);	//ο 
void TD_drawPic(TD_Pic pic);						//ͼƬ
void TD_drawBkg(TD_Rect r, TD_Attri a);				//

#endif
