#BMI compilation parameters.

# EazyText compilation. 1 -> Compile. 0 -> Don't compile.
# Hard-wire ETXT off until supported, then set via .inf file.
#ifndef ETXT
#ETXT = 0
#endif
# Chinese compilation. . 1 -> Compile. 0 -> Don't compile.
# Hard-wire CHIMMI off until supported, then set via .inf file.
#ifndef CHIMMI
#CHIMMI = 0
#endif

# Game compilation. . 1 -> Compile. 0 -> Don't compile.
# Now set via .inf file
ifndef GAME
GAME = 1
endif

# Melody generator compilation. . 1 -> Compile. 0 -> Don't compile.
# Hard-wire MELGEN off until supported, then set via .inf file.
#ifndef MELGEN
export MELGEN = 0
#endif
# HOMEZONE compilation.  1 -> Compile. 0 -> Don't compile.
# Now set via .inf file
#ifndef HZONE
#HZONE = 1
#endif
# GPRS compilation. 1 -> Compile. 0 -> Don't compile.
# Should we be setting this here at all ????? Set via .inf file ?????
#ifndef GPRS
#GPRS = 1
#endif
# Internal phonebook compilation. 1 -> Compile. 0 -> Don't compile.
# Hard-wire INTPB on, no .inf file setting.
ifndef INTPB
INTPB = 1
endif

ifeq ($(WAP),1)
	export AUS_REL_DIR = $(CONDAT_BASE_DIR)/../ausystem
	# $AUSYSTEM_DIR is being set by /g23m/makefile, if $WAP==1
	export GLE_DIR = $(AUS_REL_DIR)/GLE
endif
ifeq ($(ETXT),1)
	export ZI_DIR = $(CONDAT_BASE_DIR)/../zi
endif


ifeq ($(SRVC),1)
	ifeq ($(MMI),2)
	# dbachran, 2003-06-11: isn't this variable obsolete by now?
	CMDADD:=_fd# To be added to the cmd name file in order to set the proper libraries to the external memory.
	endif
endif


ifeq ($(WAP),1)
	ifeq ($(MMI),2)
	# dbachran, 2003-06-11: isn't this variable obsolete by now?
	CMDADD:=_wap# To be added to the cmd name file in order to set the proper libraries to the external memory.
	endif
endif

ifeq ($(WAP),1)
	# NOTE: Use $AUSYSTEM_DIR (absolute path, set by /g23m/makefile) here
	# since these variables are used for includes from source dirs below,
	# so no relativ path allowed.
	export IAUS    = $(AUSYSTEM_DIR)/Gwc/include
	export IAUSC	= $(AUSYSTEM_DIR)/Gwc/source
	export IGLE    = $(AUSYSTEM_DIR)/GLE/include
	export IAUSOPTMEM =  $(AUSYSTEM_DIR)/Gwc/optional/memory
endif


ifeq ($(ETXT),1)
include $(ZI_DIR)/zi_env.mak
endif


ifeq ($(ETXT),1)
CONDAT_LIBS += $(ZI_LIB) $(ZI_C_LIB)
endif

ifeq ($(WAP),1)
include $(AUS_REL_DIR)/ausystem_env.mak
include $(GLE_DIR)/gle_env.mak
endif

ifeq ($(WAP),1)  # Libraries for wap versions

CONDAT_LIBS += $(AUS_REL_LIB) $(GLE_REL_LIB)

endif






