/******************************************************************************

 $Project name:	Basic MMI                                                      
 $File:		    mmiSnake.h
 $Author:		talcon  hu                                                        
 $Date:		    2003-12-18                                                      
 $Description: implement file of Game:snake 
                
 $History: 

*******************************************************************************/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "mfw_sys.h"
//#include "typedef.h"
//#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"
#include "p_sim.h"
#include "cus_aci.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_sat.h"
#include "dspl.h"
#include "MmiMmi.h"
//#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
//#include "MmiMenu.h"
#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiBookShared.h"
//#include "bmieastapi.h"


#include "Gamedisplay.h"
#include "mmi3dframe.h"
#include "mmiblklangdb.h"
//#include "mmigameicons.h"
#include "mmigame.h"

#include "mmiSnake.h"
#include "mmidialogs.h"
#include "..\bmi\icons\GameSnakeIcn.h"
#include "..\bmi\icons\GameIcn.h"

#if (MAIN_LCD_SIZE==3)
/*2004/5/26, wy add begin*///shiheng porting
#define MAXLEN_GAMEHELP 300
char snakeHelp_Buffer[MAXLEN_GAMEHELP];	
/*2004/5/26, wy add end */
#endif

#define SNAKE_STAGE				4 
#define SNAKE_SPEED				10

/*define Snake's movement*/ 
typedef enum 
{
	MoveNone,
	MoveLeft,
	MoveRight,
	MoveUp,
	MoveDown
}Snake_Move;
typedef enum
{
	Snake_Diamond_None,//none
	Snake_Diamond_Food1,//food
	Snake_Diamond_Food2,
	Snake_Diamond_Food3,
	Snake_Diamond_Food4,
	Snake_Diamond_Food5,
	Snake_Diamond_Food6,
	Snake_Diamond_Snake,//Sanke self
	Snake_Diamond_Wall
}Snake_DiamondState;
/* define state of game*/
typedef enum 
{
	Snake_Init,
	Snake_Ready,//game ready
	Snake_Running,
	Snake_Pause,
	Snake_Over,//game over
	Snake_Exit,
	Snake_Select,//Game Select Stage
	Snake_KeyInfo,
	Snake_Help,
	Snake_Rank
}Snake_GameState;

typedef struct 
{
	U8   state;/*
	 * 0:none
	 * 1:food
	 * 2:snake

	 */
	U8   nextX;
	U8   nextY;
	U8	 previousX;
	U8	 previousY;
}Snake_DiamondData;
/*define data of snake*/ 
typedef struct
{
    T_MMI_CONTROL   mmi_control;		// common control parameter
	T_MFW_HND  win;

	T_MFW_HND  kbd;
	T_MFW_HND  kbd_long;
	T_MFW_HND  edt;
	T_MFW_HND	menu;
	T_MFW_HND 	parent_win;
	MfwEdtAttr edt_attr;
	T_MFW_HND  timer;   
	
	Snake_DiamondData	Diamonddata[GameSnake_Width][GameSnake_Height];//
	//position of snake's head 
	U8    headX;
	U8    headY;
	//position of snake's tail 
	U8    tailX;
	U8    tailY;
	
	U8   uMove;
	U8	 uGameState;
	U8	 uGameStateOld;	

	U8   foodadd;//foodҪӵĳ
	U8	  stage;
	U8   speed;
	U32 score;
	char gameselect[5];

	//ǰѡ״̬,ͣ
	U8 R_CurSlect,R_AnimType,R_AnimIndx;
} Snake_Data;

static Snake_Data snakedata;
const U16    snakeTimeout[]=
{
	600,//speed 0
	550,//speed 1
	500,//speed 2
	450,//speed 3
	400,//speed 4
	350,//speed 5
	300,//speed 6
	250,//speed 7
	200,//speed 8
	150,//speed 9
	250//animation	
};

const U16	snakeScorePerFood[SNAKE_STAGE] =
{
	10, 20, 30, 50
};

const int snakeScore[SNAKE_STAGE][SNAKE_SPEED]=
{
	{50, 100, 150, 250, 350, 600, 750, 900, 1100, 1500},
	{100, 200, 300, 500, 700, 1200, 1500, 1800, 2200, 3000},
	{150, 300, 450, 750, 1050, 1800, 2250, 2700, 3300, 4500},
	{250, 500, 750, 1250, 1750, 3000, 3750, 4500, 5500, 7500}
};
#define SIZESTAGEDATA 63
const char snakeStageData[]=
{
//size(1 byte),snake info(0xff β),data
//stage 1
0x46,0x0a,0x08,0x0a,0x09,0xff,0xff, /*data*/0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//stage 2
0x46,0x0a,0x08,0x0a,0x09,0xff,0xff, /*data*/0x80,0x00,0x0c,0x00,0x00,0x60,0x00,0x03,0x00,0x00,0x18,0x00,0x00,0xc0,0x00,0x06,0x00,0x00,0x30,0x00,0x01,0x80,0x00,0x0c,0x00,0x00,0x60,0x00,0x03,0x00,0x00,0x18,0x00,0x00,0xc0,0x00,0x06,0x00,0x00,0x30,0x00,0x01,0x80,0x00,0x0c,0x00,0x00,0x60,0x00,0x03,0x00,0x00,0x18,0x00,0x00,0xc0,0x00,0x06,0x00,0x00,0x30,0x00,0x01,
//stage 3
0x46,0x0a,0x08,0x0a,0x09,0xff, 0xff,/*data*/0xcc,0xc6,0x64,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x08,0x00,0x00,0xc0,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x0c,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x08,0x00,0x00,0xc0,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x0c,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x08,0x00,0x00,0xc0,0x00,0x04,0x00,0x00,0x19,0x98,0xcc,
//stage 4
0x46,0x0a,0x08,0x0a,0x09,0xff,0xff, /*data*/0x00,0x00,0x00,0xff,0xfe,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x00,0xc0,0x00,0x06,0x00,0x00,0x30,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x40,0x00,0x42,0x00,0x02,0x10,0x00,0x16,0x80,0x00,0x84,0x00,0x04,0x20,0x00,0x21,0x00,0x01,0x00,0x00,0x08,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
};
extern ffsgamedata ffs_gamedata;
//private function
static int GameSnake_win_cb (MfwEvt e, MfwWin *w);
void GameSnakeDestroy (T_MFW_HND own_window);
static int GameSnake_kbd_cb (MfwEvt e, MfwKbd *k);
static int GameSnake_timer_cb(MfwEvt e, MfwTim *t);
//void Snake_MnuShow();
#if (MAIN_LCD_SIZE==3)
void Snake_MnuShow();
#endif
T_MFW_HND GameSnakeCreate( MfwHnd parent );
extern MfwHnd GetIncomingCallWin();

void clearDiamond(U8 posX,U8 posY);
void drawDiamond(U8 posX,U8 posY);
U8 moveSnake(Snake_Data *data);
U8 gernateFood(U8 isDraw);
//void snake_help();
/************operation function**********************************************/

void readSnakeMap()
{
	int i,j;
	int pos = 7;
	char chr = 0;

	int nStage = snakedata.stage ;
	char *pMapData = (char*)snakeStageData;
	char *pMapData1; 	

	while(nStage)
	{
		pMapData +=(int)*pMapData;
		nStage -- ;
	}
	pMapData1 = pMapData+1;
	pMapData += (int)*pMapData - SIZESTAGEDATA;
		
	for(j = 0; j< GameSnake_Height;j++)
	{
		for(i = 0;i<GameSnake_Width; i++)
		{
			chr = 0x01 <<pos;
			if(*pMapData & chr)
				snakedata.Diamonddata[i][j].state = Snake_Diamond_Wall;
			else
				snakedata.Diamonddata[i][j].state = Snake_Diamond_None;
			if(pos)
				pos --;
			else
			{
				pMapData ++;
				pos = 7;
			}
			snakedata.Diamonddata[i][j].nextX = 0xff;
			snakedata.Diamonddata[i][j].nextY = 0xff;
			snakedata.Diamonddata[i][j].previousX = 0xff;
			snakedata.Diamonddata[i][j].previousY = 0xff;
		}
	}//for(j = 0; j< GameSnake_Height;j++)
	
	//read snake self
	pMapData = pMapData1;
	while(*pMapData != (char)0xff)
	{
		i = *pMapData;
		j = *(pMapData+1);
		if(pMapData == pMapData1)
		{
			snakedata.headX = i;
			snakedata.headY=  j;
			snakedata.Diamonddata[i][j].previousX = 0xff;
			snakedata.Diamonddata[i][j].previousY = 0xff;
		}
		else
		{
			snakedata.Diamonddata[i][j].previousX = *(pMapData-2);
			snakedata.Diamonddata[i][j].previousY = *(pMapData-1);
		}
		pMapData += 2;
		snakedata.Diamonddata[i][j].nextX = *pMapData;
		snakedata.Diamonddata[i][j].nextY = *(pMapData+1);
		snakedata.Diamonddata[i][j].state = Snake_Diamond_Snake;
	}
	snakedata.tailX = i;
	snakedata.tailY=  j;

}
void setSnakeGameState(U8	 uGameState)
{
	if(snakedata.uGameState != uGameState)
	{
		snakedata.uGameStateOld =snakedata.uGameState ;
		snakedata.uGameState = uGameState;
	}
}
void domoveSnake()
{
	U8 moveflag ;
	timStop(snakedata.timer);
	moveflag =moveSnake(&snakedata);
	if(moveflag >= Snake_Diamond_Snake)//game over
	{		
		flash_Gamewrite();
		setSnakeGameState(Snake_Rank);
		winShow(snakedata.win);
		return;
	}
	if(moveflag == 1)//eat food
	{
		snakedata.score += snakeScorePerFood[snakedata.stage];
		if(snakedata.speed < 9)
		{
			if(snakedata.score >= snakeScore[snakedata.stage][snakedata.speed])
			{
				snakedata.speed ++;
				timSetTime(snakedata.timer,snakeTimeout[snakedata.speed]);
				//draw speed
				drawGameNumber(85,GameSnake_Diamond *GameSnake_Height,snakedata.speed);
			}
		}
		//draw score
		drawGameNumber(20,GameSnake_Diamond *GameSnake_Height,snakedata.score);
		gernateFood(1);
	}
	timStart(snakedata.timer);
}
/********************************************************
$argument:
	@return:
		0: success
		1: none
		2 :food
		0x10: wall
		0x20: self
******************************************************************/
U8 moveSnake(Snake_Data *data)
{	
	U8 uRet = 0;
	U8 newX = data->headX;
	U8 newY = data->headY;
	U8 oldtailX = data->tailX;
	U8 oldtailY = data->tailY;
	switch(data->uMove)
	{
	case MoveLeft:
		newX --;
		break;
	case MoveRight:
		newX ++;
		break;
	case MoveUp:
		newY --;
		break;
	case MoveDown:
		newY ++;
		break;
	default:
		return 1;//none
	}
	if(newX == 0xff)
		newX = GameSnake_Width - 1;
	else if(newX == GameSnake_Width)
		newX = 0;
	else if(newY == 0xff)
		newY = GameSnake_Height - 1;
	else if(newY == GameSnake_Height)
		newY = 0;
	uRet = data->Diamonddata[newX][newY].state;
	if(uRet >= Snake_Diamond_Snake)
		return uRet;	
	
	data->Diamonddata[newX][newY].nextX = data->headX;
	data->Diamonddata[newX][newY].nextY = data->headY;
	
	data->Diamonddata[data->headX][data->headY].previousX = newX;
	data->Diamonddata[data->headX][data->headY].previousY = newY;
	
	data->headX = newX;
	data->headY = newY;
	if(data->Diamonddata[data->headX][data->headY].state >= Snake_Diamond_Food1 &&
		data->Diamonddata[data->headX][data->headY].state <= Snake_Diamond_Food6)//food
	{
		uRet  = 1;
		/*2004/04/27,talcon add*/
		clearDiamond(data->headX,data->headY);
	}
	data->Diamonddata[data->headX][data->headY].state = Snake_Diamond_Snake;
	
	if(data->foodadd == 0)
	{
		//get new tail position
		newX = data->Diamonddata[data->tailX][data->tailY].previousX;
		newY = data->Diamonddata[data->tailX][data->tailY].previousY;
		//change previois of tail to tail
		data->Diamonddata[newX][newY].nextX = 0xff;
		data->Diamonddata[newX][newY].nextY = 0xff;
		//reomve old tail
		data->Diamonddata[data->tailX][data->tailY].state = Snake_Diamond_None;
		data->Diamonddata[data->tailX][data->tailY].previousX = 0xff;
		data->Diamonddata[data->tailX][data->tailY].previousY = 0xff;
		//set tail
		data->tailX = newX;
		data->tailY = newY;
		/*2004/04/27,talcon add*/
		clearDiamond(data->tailX,data->tailY);
		
		drawDiamond(data->tailX,data->tailY);
		drawDiamond(oldtailX,oldtailY);
	}
	else
	{
		data->foodadd = 0;
	}
	
	
	drawDiamond(data->headX,data->headY);
	/*2004/04/27,talcon add*/
	clearDiamond(data->Diamonddata[data->headX][data->headY].nextX,data->Diamonddata[data->headX][data->headY].nextY);
	
	drawDiamond(data->Diamonddata[data->headX][data->headY].nextX,data->Diamonddata[data->headX][data->headY].nextY);
	
	if(uRet == Snake_Diamond_Food1)
		data->foodadd = 1;
	return uRet;
}
/******************************************************
$Description:gernate food
$Argument:
	@isDraw: 0 don't draw food
			 1 draw food	
	@return:0 fail
			1 success	
*********************************************************/
U8 gernateFood(U8 isDraw)
{
	int i = 0;
	int size = GameSnake_Width*GameSnake_Height;
	Snake_DiamondData *pDiamondData = (Snake_DiamondData*)snakedata.Diamonddata;

	int nFood = rand()%(size);

	i  = nFood;
	while((pDiamondData+i)->state != 0)
	{
		if(i == size -1)
			i = 0;
		else
			i ++;
		if(i == nFood)
			return 0;
	}
	(pDiamondData+i)->state = Snake_Diamond_Food1 + rand() % GET_ICONATTR_NUM(ICON_SNAKE_FOOD);

	//dspl food
	if(isDraw)
	{	
		U8 foodX = i/GameSnake_Height;
		U8 foodY = i%GameSnake_Height;
		drawDiamond(foodX,foodY);	
	
	}
	return 1;
}

/*2004/04/27,talcon add*/
void clearDiamond(U8 posX,U8 posY)
{
	dspl_BitBlt_ext(GameSnake_ZonePosX+posX*GameSnake_Diamond,
			GameSnake_ZonePosY+posY*GameSnake_Diamond,
			posX%GameSnake_BkgDiamond*GameSnake_Diamond,
			posY%GameSnake_BkgDiamond*GameSnake_Diamond,
			GameSnake_Diamond,
			GameSnake_Diamond,
			GameSnake_Diamond*GameSnake_BkgDiamond,
			GameSnake_Diamond*GameSnake_BkgDiamond,
			0,
			(void *)GET_ICONATTR(ICON_SNAKE_BKG,0)->icons,//(void *)snake_BkgDiamond, 
			0);
}

void drawDiamond(U8 posX,U8 posY)
{
	Snake_DiamondData *data = (Snake_DiamondData*)&snakedata.Diamonddata[posX][posY];
	void *icon = 0;
	void *iconmask = 0;
	if(posX>=GameSnake_Width || posY>=GameSnake_Height)
	{
		return;
	}
	switch(data->state)
	{
	case Snake_Diamond_None://none
		dspl_BitBlt_ext(GameSnake_ZonePosX+posX*GameSnake_Diamond,
						GameSnake_ZonePosY+posY*GameSnake_Diamond,
						posX%GameSnake_BkgDiamond*GameSnake_Diamond,
						posY%GameSnake_BkgDiamond*GameSnake_Diamond,
						GameSnake_Diamond,
						GameSnake_Diamond,
						GameSnake_Diamond*GameSnake_BkgDiamond,
						GameSnake_Diamond*GameSnake_BkgDiamond,
						0,
						(void *)GET_ICONATTR(ICON_SNAKE_BKG,0)->icons,//(void *)snake_BkgDiamond, 
						0);
		break;
	case Snake_Diamond_Food1:
	case Snake_Diamond_Food2:
	case Snake_Diamond_Food3:
	case Snake_Diamond_Food4:
	case Snake_Diamond_Food5:
	case Snake_Diamond_Food6:
		icon = (void*) (GET_ICONATTR(ICON_SNAKE_FOOD,0)->icons + (data->state - Snake_Diamond_Food1)*GameSnake_Diamond*GameSnake_Diamond*2);
		iconmask = (void*) (GET_ICONATTR(ICON_SNAKE_FOODMASK,0)->icons + (data->state - Snake_Diamond_Food1)*GameSnake_Diamond*GameSnake_Diamond*2); 
		break;
	case Snake_Diamond_Wall:
		icon = (void*) GET_ICONATTR(ICON_SNAKE_WALL,0)->icons;
		break;
	case Snake_Diamond_Snake:
		if(data->previousX == 0xff || data->previousY == 0xff)//is head
		{
			//up
			if(posX == data->nextX && posY == data->nextY  - 1)
			{
				icon = (void*)GET_ICONATTR(ICON_SNAKE_BODY,0)->icons;
				iconmask = (void*)GET_ICONATTR(ICON_SNAKE_BODYMASK,0)->icons;
			}
			else if(posX == data->nextX && posY == data->nextY + 1)//down
			{
				icon = (void*)GET_ICONATTR(ICON_SNAKE_BODY,1)->icons;
				iconmask = (void*)GET_ICONATTR(ICON_SNAKE_BODYMASK,1)->icons;
			}
			else if(posX == data->nextX - 1 && posY == data->nextY )//right
			{
				icon = (void*)GET_ICONATTR(ICON_SNAKE_BODY,2)->icons;
				iconmask = (void*)GET_ICONATTR(ICON_SNAKE_BODYMASK,2)->icons;
			}
			else if(posX == data->nextX + 1 && posY == data->nextY )//left
			{
				icon = (void*)GET_ICONATTR(ICON_SNAKE_BODY,3)->icons;
				iconmask = (void*)GET_ICONATTR(ICON_SNAKE_BODYMASK,3)->icons;
			}
		}
		else if(data->nextX == 0xff || data->nextY == 0xff)//tail
		{
			if(posX == data->previousX && posY == data->previousY -1)//up	
			{
				icon = (void*)GET_ICONATTR(ICON_SNAKE_BODY,6)->icons;
				iconmask = (void*)GET_ICONATTR(ICON_SNAKE_BODYMASK,6)->icons;
			}
			else if(posX == data->previousX && posY == data->previousY +1)//down
			{
				icon = (void*)GET_ICONATTR(ICON_SNAKE_BODY,5)->icons;
				iconmask = (void*)GET_ICONATTR(ICON_SNAKE_BODYMASK,5)->icons;
			}
			else if(posX == data->previousX - 1 && posY == data->previousY )//left
			{
				icon = (void*)GET_ICONATTR(ICON_SNAKE_BODY,8)->icons;
				iconmask = (void*)GET_ICONATTR(ICON_SNAKE_BODYMASK,8)->icons;
			}
			else if(posX == data->previousX + 1 && posY== data->previousY )//right
			{
				icon = (void*)GET_ICONATTR(ICON_SNAKE_BODY,7)->icons;
				iconmask = (void*)GET_ICONATTR(ICON_SNAKE_BODYMASK,7)->icons;
			}
		}
		else
		{
			icon = (void*)GET_ICONATTR(ICON_SNAKE_BODY,4)->icons;
			iconmask = (void*)GET_ICONATTR(ICON_SNAKE_BODYMASK,4)->icons;
		}
	
		break;
	default:
		break;
	}
	if(icon)
	{
		posX = GameSnake_ZonePosX+posX*GameSnake_Diamond;
		posY = GameSnake_ZonePosY+posY*GameSnake_Diamond;
		if(iconmask)
		{
			dspl_BitBlt(posX,posY,
				GameSnake_Diamond,GameSnake_Diamond,
				0, (void *)icon, DSPL_BMPXOR);
			dspl_BitBlt(posX,posY,
				GameSnake_Diamond,GameSnake_Diamond,
				0, (void *)iconmask, DSPL_BMPAND);
			dspl_BitBlt(posX,posY,
				GameSnake_Diamond,GameSnake_Diamond,
				0, (void *)icon, DSPL_BMPXOR);
		}
		else
		{
			dspl_BitBlt(posX,posY,
				GameSnake_Diamond,GameSnake_Diamond,
				0, (void *)icon, 0);
		}
	}
}

void redrawAll()
{
	int i;
	int j;
	U32 oldColor;

	dspl_ClearAll();

	dspl_DrawRect(GameSnake_ZonePosX - 1,GameSnake_ZonePosY,
				GameSnake_ZonePosX - 1 + GameSnake_Width*GameSnake_Diamond+1,
				GameSnake_ZonePosY + GameSnake_Height*GameSnake_Diamond - 1);

	//draw bkg	
	for(i = 0; i< GameSnake_Height; i += GameSnake_BkgDiamond)
	{
		for(j = 0; j< GameSnake_Width;j += GameSnake_BkgDiamond )
		{
			DRAW_ICON_ATTRIBUTE(ICON_SNAKE_BKG, GameSnake_ZonePosX + j * GameSnake_Diamond, GameSnake_ZonePosY + i * GameSnake_Diamond, 0, ICON_LOCATION);			
			/*dspl_BitBlt(GameSnake_ZonePosX + j * GameSnake_Diamond,
				GameSnake_ZonePosY + i * GameSnake_Diamond,
				GameSnake_BkgDiamond*GameSnake_Diamond,
				GameSnake_BkgDiamond*GameSnake_Diamond,
				0,
				(void *)GetIconAttr(ICON_SNAKE_BKG,0)->icons,//(void *)snake_BkgDiamond, 
				0);	*/		
		}
	}
	
	for(i = 0;i<GameSnake_Width; i++)
	{
		for(j = 0; j<GameSnake_Height ;j++)
		{
			if(snakedata.Diamonddata[i][j].state != Snake_Diamond_None)
			{
				drawDiamond(i,j);
			}			
		}
	}

	//oldColor = dspl_SetBkgColor(0xBDBF9B);
	//dspl_fill_rectangle(0, GameSnake_Height * GameSnake_Diamond -1 , SCREEN_WIDTH , SCREEN_HIGH);
	//dspl_SetBkgColor(oldColor);
	//draw speed
	//2004/07/01 yhf modify
	drawGameNumber(85, GameSnake_Diamond *GameSnake_Height, snakedata.speed);
	//draw score
	drawGameNumber(20, GameSnake_Diamond *GameSnake_Height, snakedata.score);		
}

void SnakeData_Init()
{
	readSnakeMap();

	gernateFood(0);

	snakedata.speed = 0;
	snakedata.score = 0;
	snakedata.uMove = MoveUp;

	flash_Gameread();
}

/********************win function****************************/
static int GameSnake_win_cb (MfwEvt e, MfwWin *w)
{
	U8 uMode;
#if (MAIN_LCD_SIZE==3)
	Snake_Data* data = (Snake_Data *)w->user;//shiheng porting
	
#endif
    switch ( e )
    {
    case MfwWinVisible:
		uMode = dspl_Enable(0);
		switch(snakedata.uGameState)
		{
#if (MAIN_LCD_SIZE==3)
		case  Snake_Init:
			Snake_MnuShow();
			//snake_MnuItemIcnShow(&snakedata);
			//timStart(snakedata.timer);
			break;
#endif
		case Snake_Ready:
			SnakeData_Init();
			//timStart(snakedata.timer);
			redrawAll();
			break;
#if(MAIN_LCD_SIZE==3)
		case Snake_Help:
			dspl_ClearAll();
			//			snake_help();/*2004/5/26, wy modify*///shiheng porting
			game_display_help(data->edt);
			break;			
#endif
		case Snake_Running:
			redrawAll();
			break;
		case Snake_Exit:
			//dspl_ClearAll();
			//Draw_Dialog((char *)MmiRsrcGetText(TxtExitGame));
			draw_icon_require();
#if(MAIN_LCD_SIZE==3)//jhxu720
			ALIGNED_PROMPT(CENTER_RIGHT, DIALOG_HALF_FIRSTSECOND, DSPL_TXTATTR_TRANSPARENT, TxtExitGame);				
#else
			ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, TxtExitGame);
#endif			
			dsplsoftkey(TxtGameGoon, TxtGameExit);
			break;
		case Snake_Rank://score 
			if(Snake_Init == snakedata.uGameStateOld)
				Game_Scoreshow(&ffs_gamedata.Snake_ffsScore,-1,0,0);
			else
				Game_Scoreshow(&ffs_gamedata.Snake_ffsScore,snakedata.score,0,1);
			break;
		case Snake_KeyInfo:
			dspl_ClearAll();
			Key_Setshow(2);
			break;
		case Snake_Select:
			dspl_ClearAll();
			Game_StageSelect(SNAKE_STAGE,snakedata.stage+1,(char *)snakedata.gameselect);
			break;
		default:
			break;
		}
		dspl_Enable(uMode);
        break;
		case MfwWinFocussed: /* input focus / selected   */
		case MfwWinDelete:   /* window will be deleted   */
		default:
			return MFW_EVENT_REJECTED;
    }
	
    return MFW_EVENT_CONSUMED;
}

void GameSnakeDestroy (T_MFW_HND own_window)
{
	flash_Gamewrite();
	win_delete (snakedata.win);
}
static int GameSnake_kbd_cb (MfwEvt e, MfwKbd *k)
{
	int len = 0;
	U8 uflags = 0;
#if (MAIN_LCD_SIZE==3)
	T_MFW_HND       win  = mfw_parent (mfw_header());//shiheng porting
	char *text;//shiheng porting
	
#endif
	Snake_Data *data = (Snake_Data*)&snakedata;

	if(!(e & KEY_MAKE))
		return MFW_EVENT_CONSUMED;
	//Game Running
	if(data->uGameState == Snake_Running)	
	{
		switch ( k->code )
		{          
		case KCD_MNUUP:
			if(data->uMove!=MoveDown)
			{
				uflags = 1;
				data->uMove = MoveUp;
			}
			break;
		case KCD_MNUDOWN: 
			if(data->uMove!=MoveUp)
			{
				uflags = 1;
				data->uMove = MoveDown;
			}
			break;
		case KCD_MNULEFT:
			if(data->uMove!=MoveRight)
			{
				uflags = 1;
				data->uMove = MoveLeft;
			}
			break;
		case KCD_MNURIGHT:
			if(data->uMove!=MoveLeft)
			{
				uflags = 1;
				data->uMove = MoveRight;
			}
			break;
		case KCD_CALL://Pause
			setSnakeGameState( Snake_Pause);
			timStop(data->timer);
			break;	
		case KCD_RIGHT:
		case KCD_HUP:
			setSnakeGameState(Snake_Exit);
			winShow(data->win);
			break;
		case KCD_LEFT:
		case KCD_OK:   
			break;
		default:
			break;
		}
		if(uflags)
			domoveSnake();
	//	return MFW_EVENT_CONSUMED;
	}
	//Game Init
	else if(data->uGameState == Snake_Init)
	{
		switch ( k->code )
		{          
		case KCD_1:
		case KCD_2:
		case KCD_3:
		case KCD_4:
			if(data->R_CurSlect+1 != k->code)
			{
				data->R_CurSlect = k->code - 1;
				uflags  = 1;
			}
			break;
		case KCD_MNUUP:
			if(data->R_CurSlect)
			{
				data->R_CurSlect --;
			}
			else
			{
				data->R_CurSlect = 3;
			}
			uflags  = 1;
			break;
		case KCD_MNUDOWN: 
			data->R_CurSlect ++;
			if(data->R_CurSlect == 4)
			{
				data->R_CurSlect = 0;
			}
			uflags  = 1;
			break;
		case KCD_LEFT:
		case KCD_OK:
			switch(data->R_CurSlect)
			{
			case 0:
				setSnakeGameState(Snake_Ready);
				break;
			case 1:
				setSnakeGameState(Snake_Select);
				break;
			case 2:
				setSnakeGameState(Snake_Help);
#if (MAIN_LCD_SIZE==3)
				/*2004/5/26, wy modify begin*/	//shiheng porting   
				game_editor_init(&data->edt_attr);	
				data->edt = edtCreate(win, &data->edt_attr, 0, 0);
				
				text=(char *)MmiRsrcGetText(TxtSnakeHelp);
				memset(snakeHelp_Buffer, 0, sizeof(snakeHelp_Buffer));
				memcpy(snakeHelp_Buffer, text, wstrlen(text));
				
				edtSetText(data->edt, snakeHelp_Buffer );
				/*2004/5/26, wy modify end*/				
#endif
				break;
			case 3:
				setSnakeGameState(Snake_Rank);
				break;
			}
			uflags = 2;
			break;
		case KCD_RIGHT:
		case KCD_HUP:		  	   	  
			GameSnakeDestroy(data->win);  
			break;
		default:
			break;
		}
		if(uflags  == 1)
		{
			data->R_AnimIndx = data->R_AnimType = 0;
			winShow(data->win);
			timStart(data->timer);
		}
		else if(uflags == 2)
		{
			data->R_AnimIndx = data->R_AnimType = 0;
			winShow(data->win);
		}
		//return MFW_EVENT_CONSUMED;
	}
	//Game Ready
	else if(data->uGameState == Snake_Ready)
	{
		switch ( k->code )
		{
		case KCD_CALL:
			setSnakeGameState(Snake_Running);
			timSetTime(data->timer,snakeTimeout[data->speed]);
			timStart(data->timer);
			break;
		case KCD_RIGHT:
		case KCD_HUP:
			setSnakeGameState(Snake_Init);
			winShow(data->win);
			break;
		}
		#ifdef GAME_SUBMENU
		if(snakedata.uGameState == Snake_Init)
		{
			GameSnakeDestroy(data->win);
		}
		#endif	
	//	return MFW_EVENT_CONSUMED;
	}//end Game Ready
	
	//Select Game level
	else if(data->uGameState == Snake_Select)
	{
		switch(k->code)
		{
		case KCD_LEFT:
			if(snakedata.gameselect[0])
			{
				snakedata.stage = atoi(snakedata.gameselect);		
				snakedata.stage--;
				memset(snakedata.gameselect,0,sizeof(snakedata.gameselect)); 
			}
			setSnakeGameState(Snake_Ready);
			winShow(data->win);
			break;
		case KCD_RIGHT:
			if(snakedata.gameselect[0] == 0)
			{
			#ifdef GAME_SUBMENU
				GameSnakeDestroy(data->win);
				//return MFW_EVENT_CONSUMED;
			#else
				setSnakeGameState(Snake_Init);
				winShow(data->win);			
			#endif
			}
			else
			{
				snakedata.gameselect[strlen(snakedata.gameselect)-1] = 0;
			}
			winShow(data->win);
			break;
		case KCD_HUP:
			#ifdef GAME_SUBMENU
				GameSnakeDestroy(data->win);
			//return MFW_EVENT_CONSUMED;
			#else
			setSnakeGameState(Snake_Init);
			memset(snakedata.gameselect,0,sizeof(snakedata.gameselect)); 
			winShow(data->win);
			#endif
			break;		
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
			len = strlen(snakedata.gameselect);
			snakedata.gameselect[len] = '0' + k->code;
			if(atoi(snakedata.gameselect) > SNAKE_STAGE)
			{
				snakedata.gameselect[len] = 0;
			}
			winShow(data->win);
			break;
		}		
	}
	//Select Game level end 

	//Key info
	else if(data->uGameState == Snake_KeyInfo)
	{
		switch(k->code)
		{		
		case KCD_RIGHT:
		case KCD_HUP:			
		#ifdef GAME_SUBMENU
			GameSnakeDestroy(data->win);
		#else
			setSnakeGameState(Snake_Init);
			winShow(data->win);
		#endif
			break;	
		}
	}
	//Key info end
#if (MAIN_LCD_SIZE==3)
	//Game help
	else if(data->uGameState == Snake_Help)
	{
		switch(k->code)
		{
		case KCD_MNUUP:
			edtSymbol(snakedata.edt, ecUp);
			break;
		case KCD_MNUDOWN:
			edtSymbol(snakedata.edt, ecDown);
			break;
		case KCD_LEFT:
		case KCD_RIGHT:
		case KCD_HUP:
			edtDelete(snakedata.edt);
			setSnakeGameState(Snake_Init);
			winShow(data->win);
			break;			
		}
	}
	//Game help end 
#endif
	//Game Pause
	else if(data->uGameState == Snake_Pause)
	{
		switch ( k->code )
		{
		case KCD_CALL:
			setSnakeGameState(Snake_Running);
			timStart(data->timer);
			break;
		case KCD_RIGHT:
		case KCD_HUP:
			setSnakeGameState(Snake_Exit);
			winShow(data->win);
			break;
		}
	//	return MFW_EVENT_CONSUMED;
	}
	//Game Exit
	else if(data->uGameState ==Snake_Exit)
	{
		switch ( k->code )
		{
		case KCD_LEFT:
			setSnakeGameState(Snake_Running);
			winShow(data->win);
			timStart(data->timer);
			break;
		case KCD_RIGHT:
			setSnakeGameState(Snake_Init);
			winShow(data->win);
			break;
		}
#ifdef GAME_SUBMENU
		if(snakedata.uGameState == Snake_Init)
			GameSnakeDestroy(data->win);
#endif
		
		//return MFW_EVENT_CONSUMED;
	}
	//Game Rand
	else if(data->uGameState ==Snake_Rank)
	{
		switch ( k->code )
		{
		case KCD_LEFT:
			if(data->uGameStateOld == Snake_Init)
			{
				Game_resetScore(&ffs_gamedata.Snake_ffsScore);
				flash_Gamewrite();
				//2004/06/10 yhf remove
				//setSnakeGameState(data->uGameStateOld);
			}
			else
			{
				setSnakeGameState(Snake_Ready);
			}
			
			winShow(data->win);
		
			break;
		case KCD_HUP:
		case KCD_RIGHT:
		#ifdef GAME_SUBMENU
			GameSnakeDestroy(data->win);
		#else
			setSnakeGameState(Snake_Init);
			winShow(data->win);
		#endif
			break;
		}
		//return MFW_EVENT_CONSUMED;
	}
	//talcon add 2004/05/15
	if(data->uGameState == Snake_Running)	
	{
		timStop(gtVibator);
	}
	return MFW_EVENT_CONSUMED;
}//end function:GameSnake_kbd_cb

static int GameSnake_timer_cb(MfwEvt e, MfwTim *t)
{
    MfwHnd     win  = mfwParent (mfwHeader());

	if(!winIsFocussed(snakedata.win))
	{
		timStart(snakedata.timer);
		return;
	}

	switch(snakedata.uGameState)
	{
	case  Snake_Init:
		//snake_MnuItemIcnShow(&snakedata);	
		break;
	/*case Snake_Ready:
		SnakeData_Init();
		redrawAll();*/
	case Snake_Running:
		domoveSnake();
		break;
	default:
		break;
	}
    return 0;
	
}

T_MFW_HND GameSnakeCreate( MfwHnd parent )
{
	T_MFW_WIN     * win;

    Snake_Data *data=&snakedata;
	//memset(data,0,sizeof(Snake_Data) );
	
    data->win=win_create(parent,0,E_WIN_VISIBLE,(T_MFW_CB)GameSnake_win_cb);
	
    if (data->win EQ 0) 
	{
		return 0;	 
	}

    data->mmi_control.dialog    = (T_DIALOG_FUNC)NULL;
    data->mmi_control.data     = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *) data;

    data->kbd      = kbd_create (data->win,KEY_ALL | KEY_MAKE,(T_MFW_CB)GameSnake_kbd_cb);
    data->timer     = tim_create (data->win,snakeTimeout[10],(T_MFW_CB)GameSnake_timer_cb); //  timeout

	winShow(data->win);
    return data->win;
}

int  GameSnakeEntry(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND win = mfw_parent(mfw_header());
    
	T_MFW_HND winCur;
	snakedata.uGameState = Snake_Init;
	winCur = GameSnakeCreate(win);
#ifdef GAME_SUBMENU
	if(winCur)
	{
		switch(m->lCursor[m->level])
		{
		case 0:
			setSnakeGameState(Snake_Ready);
			winShow(winCur);
			break;
		case 1://slect game
			setSnakeGameState(Snake_Select);
			winShow(winCur);
			break;
		case 2://key info.
			setSnakeGameState(Snake_KeyInfo);
			winShow(winCur);
			break;
		case 3://score
			setSnakeGameState(Snake_Rank);
			winShow(winCur);
			break;
		default:
			break;
		}
	}
#endif
	return MFW_EVENT_CONSUMED;
}

/********************************************************************************************
	$Function:		snake_help
	$Description:
	$Author:
	$Date:
********************************************************************************************/

void snake_help()
{
	game_editor_init(&snakedata.edt_attr);
	/* 2004/06/08 sunsj modify */
	//snakedata.edt = game_display_help(&snakedata.edt_attr);
}
#if (MAIN_LCD_SIZE==3)
void Snake_MnuShow()
{
	int posX = 0, posY = 0;
	
	dspl_ClearAll();
	dspl_BitBlt(snake_EntryBkg[0],snake_EntryBkg[1],snake_EntryBkg[2],snake_EntryBkg[3],0,(void*)&snake_EntryBkg[4],0);
	//	dspl_TextOut(28, 4, DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtGamestart));
	//	dspl_TextOut(28, 18, DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtGameselect));
	//	dspl_TextOut(28, 32, DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtGamehelp));
	//	dspl_TextOut(28, 46, DSPL_TXTATTR_WHITE_EDGE,MmiRsrcGetText(TxtGameScore));
	
	posX = 50; 
	posY = 28 + 22 * snakedata.R_CurSlect;
	dspl_BitBlt(posX, posY, 22, 18, 0, (void *)game_Menu_Finger, DSPL_BMPXOR);//shiheng 288 waiting//Ϸָͼ
	dspl_BitBlt(posX, posY, 22, 18, 0, (void *)game_Menu_Finger_mask, DSPL_BMPAND);
	dspl_BitBlt(posX, posY, 22, 18, 0, (void *)game_Menu_Finger, DSPL_BMPXOR);
}
#endif




















