#ifndef _MMI_GPRS_H_
#define _MMI_GPRS_H_

#undef TEST_MMIGPRS	/* SH - GPRS testing, gives extra menu functions */
	
enum
{
	GPRS_OFF = 0,				// GPRS is not attached
	GPRS_SEARCHING,
	GPRS_ATTACHED				// GPRS is attached
};

void mmiGprsInit(void);
void mmiGprsExit(void);
int mmiGprsStatus(void);
T_MFW_HND mmiPleaseWaitWindow(T_MFW_HND parent_win, USHORT TextId1, USHORT TextId2,USHORT displayflag);
void mmiPleaseWaitWindowCb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
void mmiGprsShowCounter(T_MFW_HND win, USHORT identifier);
char * mmiGprsUpdateCounter(T_MFW_HND win, USHORT identifier);
void mmiGprsShowCounterCb(T_MFW_HND win, USHORT identifier, USHORT reason);

int GPRSMfwCb(T_MFW_EVENT event, void* para);
int GPRSAttach(MfwMnu* m, MfwMnuItem* i);
int GPRSDetach(MfwMnu* m, MfwMnuItem* i);

int GPRSIncomingDataCount(MfwMnu* m, MfwMnuItem* i);
int GPRSOutgoingDataCount(MfwMnu* m, MfwMnuItem* i);
int GPRSselectSms(MfwMnu* menu, MfwMnuItem* item);
int GPRSselectSms_set(MfwMnu* menu, MfwMnuItem* item);

/* SH - GPRS testing - exta menu options */
#ifdef TEST_MMIGPRS
int GPRSContextDefine(MfwMnu* m, MfwMnuItem* i);
int GPRSActivate(MfwMnu* m, MfwMnuItem* i);
int GPRSDeactivate(MfwMnu* m, MfwMnuItem* i);
int GPRSsetQos(MfwMnu* m, MfwMnuItem* i);
int GPRSsetMinQos(MfwMnu* m, MfwMnuItem* i);
int showTotalIncDataCount(MfwMnu* m, MfwMnuItem* i);
int showTotalOutDataCount(MfwMnu* m, MfwMnuItem* i);
int resetIncDataCount(MfwMnu* m, MfwMnuItem* i);
int resetOutDataCount(MfwMnu* m, MfwMnuItem* i);
int showCounter(MfwMnu* m, MfwMnuItem* i);
int dontShowCounter(MfwMnu* m, MfwMnuItem* i);
int csdConnection(MfwMnu* m, MfwMnuItem* i);
int setClassBConnection(MfwMnu* m, MfwMnuItem* i);
int setClasCConnection(MfwMnu* m, MfwMnuItem* i);
int showIPAddress(MfwMnu* m, MfwMnuItem* i);
int GPRSCompressionStatus(MfwMnu* m, MfwMnuItem* i);
int GPRSCompressionOn(MfwMnu* m, MfwMnuItem* i);
int GPRSCompressionOff(MfwMnu* m, MfwMnuItem* i);
int setClassCVoice(MfwMnu* m, MfwMnuItem* i);	
int setClassCData(MfwMnu* m, MfwMnuItem* i);
void SaveGprsCounter(void);
#endif

#endif
