/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         $Workfile::   Mmihost.c     $|
| $Author: jhxu $Revision: 1.7 $|
| CREATED: 15.05.02                     $Modtime::                   |
| STATE  : code                                                      |
+--------------------------------------------------------------------+

   MODULE  : 
   PURPOSE : 
   EXPORT  : 
   TO DO   :



********************************************************************************
 $History: Mmihost.c
    Date .................. Modification ......................................
    25/05/02		xsf created	Original Mobile Innovation BMI version.	
    
    16/08/02      version 0.101 xsf  modified for list menu icons of hostkey protect options
    19/08/02      version 0.102 xusufang modified 
       29/08/02   version 0.103  xsf modified 
     18/09/02    version 0.104 xsf modified for hostkey protect PRO_DELALLPBK etc.
 $End

*******************************************************************************/


/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"

#include "p_sim.h"


#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_cm.h"
#include "mfw_icn.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_ss.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"
#include "mfw_tim.h"
#include "mfw_mnu.h"
#include "mfw_sms.h"

#include "dspl.h"


#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

// #include "MmiLang.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiMenu.h"
#include "MmiSoftkeys.h"
#include "MmiIdle.h"
#include "mmiCall.h"
#include "MmiNetwork.h"
#include "MmiSounds.h"
#include "MmiSettings.h"
//#include "MmiServices.h"
#include "MmiIcons.h"
#include "MmiDialogs.h"
#include "MmiEditor.h"
#include "MmiPins.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"

#include "Mmieditor.h"
#include "MmiBookUtils.h"   
#include "Mmibookshared.h"     //02.05.28
#include "Mmihost.h"
#include "Mfw_ffs.h"
#include "Psa_sim.h"
#include "Mmibooksearchwindow.h"  //xsf 11.08
#include "Mmismsmenu.h"   //xsf add 11.27 for PRO_MSGBOX
#include "Mmitoolkit_timer.h"  //xsf add for display drawSolidRectangle() 12.28
#include "Gamedisplay.h"

#define CLEAR_PIN_EDIT_AREA dspl_Clear(0,30,LCD_X,LCD_Y);

void hostkey_loadEditDefault (T_EDITOR_DATA * editor_data);
static void hostkey_editor_cb (T_MFW_HND win, USHORT Identifier, SHORT reason);
int hostkey_change (struct MfwMnuTag * m, struct MfwMnuItemTag * i);
void hostkey_messages(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int hostkey_mess_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
void hostkey_mess_destroy  (T_MFW_HND own_window);
T_MFW_HND hostkey_mess_create (T_MFW_HND parent_window);
static void hostkey_call_mess(T_MFW_HND win, USHORT event);
static void hostkey_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int hostkey_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
void hostkey_destroy  (T_MFW_HND own_window);
T_MFW_HND hostkey_create (T_MFW_HND parent_window);
void hostkey_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reasons);
void setting_hostkey_init (T_MFW_HND parent_window);
T_MFW_HND setting_hostkey_create (T_MFW_HND parent_window);
void hostkey_mess_destroy  (T_MFW_HND own_window);
static int setting_hostkey_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
void setting_hostkey_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static void sett_hostkey_edit(T_MFW_HND win, USHORT event);
T_MFW_HND set_hostkey_edt_create (T_MFW_HND parent_window);
void set_hostkey_edt_destroy  (T_MFW_HND own_window);
static int set_hostkey_edt_win_cb (T_MFW_EVENT event,T_MFW_WIN * win);
static void set_hostkey_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int set_hostkey_kbd_cb (T_MFW_EVENT event,T_MFW_KBD *  kc);
static int set_hostkey_edt_kbd_long_cb (T_MFW_EVENT event,T_MFW_KBD *  kc);
static void check_set_hostkey (T_MFW_HND win,void * edt_hostkey);
static void clear_edit_array (void * parameter);
int JudgeHostKey(char* L_Key);
void hostconfirms(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
void hostconfirm_dialog_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void hostconfirm_dialog(void);
static int hostconfirm_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
void hostconfirm_destroy (T_MFW_HND own_window);
T_MFW_HND hostconfirm_create (T_MFW_HND parent_window);
void hostconfirm_Exit (T_MFW_HND own_window);
T_MFW_HND hostconfirm_Init (T_MFW_HND parent_window);
T_MFW_HND hostkey_menu_start(MfwMnuAttr* menuAttr,T_VOID_FUNC func_cb);
void hostkey_menu (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int hostkey_menu_win_cb (MfwEvt e, MfwWin *w);
static int hostkey_menu_kbd_cb (MfwEvt e, MfwKbd *k);
static int hostkey_menu_kbd_long_cb (MfwEvt e, MfwKbd *k);
static int hostkey_menu_mnu_cb (MfwEvt e, MfwMnu *m);
void hostkey_menu_end_cb(T_MFW_HND win);

void ReadSimIMSI(void) ;

/* defines */
#define MAX_DIG        30
#define MAX_HOST		9		/* maximum number of digits */
#define TIMER_OUT      30000    //time for entering
#define MAX_PIN     8
#define MIN_PIN     4

// the coordinate of the TxtId 
#define INFO_TEXT_X     6
#define INFO_TEXT_Y     14		/* 2004/03/25 sunsj modify */
#define STAR            0x2a
#define HASH            0x23
#define SHOW_CONFIRM           3
#define ACTIVATE_CONFIRM       4
#define DEACTIVATE_CONFIRM     5

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        confirm_win;        // MFW win handler      
    UBYTE            local_status;
} T_hostconfirm;

T_hostconfirm hostconfirm;


typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        parent_win;
    T_MFW_HND        hostkey_win;
    //T_MFW_HND        win_menu;       //menu
    USHORT           display_id1;
    USHORT           display_id2;         
    UBYTE            hostkey[MAX_PIN+1];      /* number string host key        */
    UBYTE            new_hostkey[MAX_PIN+1];  /* store new hostkey            */
    UBYTE            old_hostkey[MAX_PIN+1];  /* store old hostkey            */
    HOST_CASE        hostkey_case;            /* editor state             */
    char              edtbuf[MAX_DIG];  
    UBYTE            protect_opt;   //xsf  add for hostkey protect options
} T_hostkey;

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        parent_win;
    T_MFW_HND        hostkey_mess_win;
    USHORT           display_id1;
    USHORT           display_id2;
    HOST_CASE        hostkey_case;
}T_hostkey_mess;

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        parent_win;
    T_MFW_HND        hostkey_edt_win;
    T_MFW_HND        kbd_handle;
    T_MFW_HND        kbd_long_handle;
    T_MFW_HND        editor_handle;
    T_MFW_HND        tim_out_handle;
    UBYTE            hostkey[MAX_PIN+1];      /* number string host key        */
    UBYTE            new_hostkey[MAX_PIN+1];  /* store new host key            */
    UBYTE            old_hostkey[MAX_PIN+1];  /* store old host key            */
    UBYTE            editor_index;
    HOST_CASE         hostkey_case_edit;
    char edtbuf[MAX_DIG];
    MfwEdtAttr edithostkeyAttr;
    char  hostkey_dspl[MAX_PIN+1];
}T_hostkey_edt;

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       win;
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu;
    T_VOID_FUNC     func_cb;
    /*
     * internal data
     */
} T_hostkey_menu;


static T_MFW_HND hostkey_windows;
static T_MFW_HND hostkey_edit_windows;
static T_MFW_HND hostkey_mess_windows;
static T_MFW_HND set_hostkey_windows;
//xsf 2002.07.17
static UBYTE    l_data[MAX_SIM_CMD];
char SimLock1=0;
char ProOnLock=0;//hostkey protect switchon flag
extern UBYTE animation_complete;
static T_MFW_HND pro_options_win;  //xsf 11.08

/*******************************************************************************

 $Function:     hostkey_menu_check

 $Description:   If the inputed hostkey is not correct hostkey menu
           will not appear in the menulist

 $Returns:

 $Arguments:

*******************************************************************************/
//USHORT hostkey_menu_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
int hostkey_menu_check(struct MfwMnuTag * m, struct MfwMnuItemTag * i)
{

    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = hostkey_create(idle_win);

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user;

    TRACE_EVENT("Mmihost.c:hostkey_menu_check()");
    if( FlashHostkeyData.HostLock_flag )
        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK_MENU,0,hostkey_data);
    else   //xsf changed for can't change hostkey protect options without hostkey_open 2002/10/16
    {
        hostkey_destroy(hostkey_data->hostkey_win);// finish main pin dialog
        hostconfirm_Init(idle_win);  
        hostconfirm.local_status = ACTIVATE_CONFIRM;
        SEND_EVENT (hostconfirm.confirm_win, SHOW_CONFIRM, 0, 0);
    }
    //else
    //SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_MENU_END,0,hostkey_data);

    return 1;
}



/*******************************************************************************

 $Function:    	hostkey_init 

 $Description:	This is the start-up time initialisation routine.
                call from init routine in the idle
 
 $Returns:		None

 $Arguments:	parent window
 
*******************************************************************************/
void hostkey_init (T_MFW_HND parent_window)
{

    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = hostkey_create(idle_win);

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user;

    TRACE_EVENT("Mmihost.c:hostkey_init()");
    //2002.07.16  
    //if(CheckPassWord(PRO_ON))
    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK,0,hostkey_data);
    //else
    //SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_OK_END,0,hostkey_data);


    //  hostkey_create (parent_window);
}


/*******************************************************************************

 $Function:    	hostkey_create

 $Description:	Creation of an instance for the HOSTKEY dialog 

                Type of dialog : SINGLE_DYNAMIC
 $Returns:		Window

 $Arguments:	Parent window
 
*******************************************************************************/
T_MFW_HND hostkey_create (T_MFW_HND parent_window)
{

    T_MFW_WIN     * win;
    T_hostkey * data = (T_hostkey*)ALLOC_MEMORY (sizeof (T_hostkey));

    data->hostkey_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)hostkey_win_cb);

    hostkey_windows = data->hostkey_win;
    hostkey_edit_windows = NULL;
    hostkey_mess_windows = NULL;

    TRACE_EVENT("Mmihost.c:hostkey_create");

    if( data->hostkey_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)hostkey_main;/* dialog main function    */
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->hostkey_win)->data;
    win->user                   = (void *) data;

    /*
     * return window handle
     */
    mfwSetSignallingMethod(1);//mfw focus handling
    winShow(data->hostkey_win);


    return data->hostkey_win;
}

/*******************************************************************************

 $Function:    	hostkey_destroy

 $Description:	Destroy the hostkey dialog.
 $Returns:		None

 $Arguments:	window
 
*******************************************************************************/
void hostkey_destroy  (T_MFW_HND own_window)
{

    T_hostkey *      data;
    T_MFW_WIN *   win;

    TRACE_EVENT("Mmihost.c:hostkey_destroy");

    if( own_window )
    {
        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_hostkey *)win->user;

        if( data )
        {
            /*
            * Delete WIN Handler
            */

            if( hostkey_edit_windows )
            {
                TRACE_EVENT("hostkey_destroy():hostkey_edit_windows");
                set_hostkey_edt_destroy(hostkey_edit_windows);
            }
            else
            {
                win_delete (data->hostkey_win);
                hostkey_windows = 0;
                FREE_MEMORY((void *)data,(sizeof(T_hostkey)));
            }

        }
    }
}


/*******************************************************************************

 $Function:    	hostkey_win_cb

 $Description:	Callback function for windows
 $Returns:		Status int
 $Arguments:	window handler event, window
 
*******************************************************************************/
static int hostkey_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{ 
    //char debug[50];
    //sprintf(debug, "hostkey_win_cb: %d", event);

    //TRACE_EVENT(debug);

    if( event EQ MfwWinVisible )
    {
        /*
         * Top Window has no output
         */
        //     TRACE_EVENT("dsplClearAll 1"); 
        dspl_ClearAll();
        return 1;
    }
    return 0;
}


/*******************************************************************************

 $Function:    	hostkey_main

 $Description:	HOSTKEY MAIN Dialog Handling function
 $Returns:		void
 $Arguments:	window, window handler event, value, parameters
 
*******************************************************************************/
static void hostkey_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user;//hostkey main data
    T_hostkey_mess * mess_data = (T_hostkey_mess *) parameter;//hostkey message data
    T_hostkey_edt * edt_data = (T_hostkey_edt *) parameter;//hostkey editor data
    T_MFW_HND idle_win = idle_get_window();  //xsf add 2002.08.19
    int sms_type;
    char debug[20];

    T_EDITOR_DATA   editor_data;

    //sprintf(debug,"Mmihost.c:hostkey_main: %d", event);
    //TRACE_EVENT(debug);

    switch( event )
    {
    case HOSTKEY_FAIL:
    case HOSTKEY_OK:
    case HOSTKEY_ASK_FAIL:
    case HOSTKEY_ASK_OK:
    case HOSTKEY_CHANGE_FAIL:
    case HOSTKEY_CHANGE_OK:
    case HOSTKEY_MENU_OK:
    case HOSTKEY_MENU_FAIL:           
        //xsf add 2002.08.22 2 lines
    case HOSTKEY_ONOFF_OK:
    case HOSTKEY_ONOFF_FAIL:                 
        hostkey_call_mess(win,event);
        break; 
    case HOSTKEY_ASK:
        if( hostkey_data->protect_opt == PRO_SIMLOCK )
            hostkey_data->display_id2 = TxtSimReplaced;
        hostkey_data->display_id1 = TxtEnterHostKey;
        hostkey_data->hostkey_case = HOSTKEY_ASK;
        sett_hostkey_edit(win,HOSTKEY_ASK);
        break;

    case HOSTKEY_ASK_MENU:
        //TRACE_EVENT("hostkey_main():HOSTKEY_ASK_MENU");
        hostkey_data->display_id1 = TxtEnterHostKey;
        hostkey_data->hostkey_case = HOSTKEY_ASK_MENU;
        sett_hostkey_edit(win,HOSTKEY_ASK_MENU);
        break;
    case HOSTKEY_ASK_ONOFF:
        //TRACE_EVENT("hostkey_main():HOSTKEY_ASK_ONOFF");
        hostkey_data->display_id1 = TxtEnterHostKey;
        hostkey_data->hostkey_case = HOSTKEY_ASK_ONOFF;
        sett_hostkey_edit(win,HOSTKEY_ASK_ONOFF);
        break;
    case HOSTKEY_SWITCHON:      //xsf add 2002.08.29
        //TRACE_EVENT("hostkey_main():HOSTKEY_SWITCHON");
        hostkey_data->display_id1 = TxtEnterHostKey;
        hostkey_data->hostkey_case = HOSTKEY_SWITCHON;
        sett_hostkey_edit(win,HOSTKEY_SWITCHON);
        break;
    case HOSTKEY_OK_END:
        //TRACE_EVENT("xsfxsf hostkey_main():HOSTKEY_OK_END");
        if( hostkey_data->protect_opt == PRO_DELALLPHB )
        {
            /*hostconfirm_Init(idle_win);
            hostconfirm.local_status = PRO_DELALLPHB;
            SEND_EVENT (hostconfirm.confirm_win, PRO_DELALLPHB, 0, 0);*/
            bookDeleteAllNVMRecord(pro_options_win);  //xsf 11.08
        }
        else if( hostkey_data->protect_opt == PRO_RESETALL )
        {
            hostconfirm_Init(idle_win);
            hostconfirm.local_status = PRO_RESETALL;
            SEND_EVENT (hostconfirm.confirm_win, PRO_RESETALL, 0, 0);
        }
        else if( hostkey_data->protect_opt == PRO_MSGBOX )
        {
            sms_type = 1;
            // Here we have to pass the type of sms to delete (SMS or SMS-CB)
            M_DEL_ALL_start(pro_options_win, (void *)&sms_type);
        }
        else
        {
            TRACE_EVENT("xsfxsf hostkey_main():showwelcome()");
            showwelcome(idle_get_window());
            //Pin1OKOrNoPin1();  //xsf add 2002.10.09
            //network_start_full_service ();
            hostkey_data->protect_opt = PRO_ON;  //xsf add 2003.04.10
            ReadSimIMSI();
        }       
        hostkey_destroy(hostkey_data->hostkey_win);// finish main hostkey dialog
        break;
    case HOSTKEY_CHANGE_END:

        hostkey_destroy(hostkey_data->hostkey_win);// finish main hostkey dialog
        //TRACE_EVENT("hostkey_destroy 2");

        break; 
    case HOSTKEY_MENU_END:
        hostkey_destroy(hostkey_data->hostkey_win);// finish main hostkey dialog
        //TRACE_EVENT("HOSTKEY_MENU_END 2");
        bookPhonebookStart(idle_win,PhbkHostkeyList);
        //hostkey_menu_start((T_MFW_MNU_ATTR *)&menuHostKey,(T_VOID_FUNC)hostkey_menu_end_cb);
        break;
        //xsf add for on/off 2002.08.22
    case HOSTKEY_ONOFF_END:

        //TRACE_EVENT("HOSTKEY_ONOFF_END 2");
        hostkey_destroy(hostkey_data->hostkey_win);// finish main hostkey dialog
        //bookPhonebookStart(idle_win,PhbkHostkeyOnOffList);  //xsf add for hostkey on/off menu 2002.08.23

        break;
    case SETT_HOSTKEY_ABORT:
        //TRACE_EVENT("clear softkey 10");		  
        dspl_ClearAll();
        hostkey_destroy(hostkey_data->hostkey_win);// destroy hostkey settings dialog
        break;
    }

}


/*******************************************************************************

 $Function:    	hostkey_call_mess 
 $Description:	help function for message dialog
 $Returns:		void
 $Arguments:	window, window handler event
 
*******************************************************************************/
static void hostkey_call_mess(T_MFW_HND win, USHORT event)
{

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user; // hostkey main data

    T_MFW_HND hostkey_mess_win;
    TRACE_EVENT("Mmihost.c: hostkey_call_mess");

    hostkey_mess_win = hostkey_mess_create(hostkey_data->hostkey_win);
    if( hostkey_mess_win )
    {
        SEND_EVENT(hostkey_mess_win,event,0,hostkey_data);
    }
}

/*******************************************************************************

 $Function:    	hostkey_mess_create 
 $Description:	Creation of an instance  for the HOSTKEY Message dialog.
                Type of dialog : SINGLE_DYNAMIC
 $Returns:		window
 $Arguments:	parent win
 
*******************************************************************************/
T_MFW_HND hostkey_mess_create (T_MFW_HND parent_window)
{
    T_hostkey_mess * data = (T_hostkey_mess *)ALLOC_MEMORY (sizeof (T_hostkey_mess));

    T_MFW_WIN     * win;

    data->hostkey_mess_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)hostkey_mess_win_cb);

    TRACE_EVENT("Mmihost.c:hostkey_mess_create");

    if( data->hostkey_mess_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    hostkey_mess_windows = data->hostkey_mess_win;
    data->mmi_control.dialog    = (T_DIALOG_FUNC)hostkey_messages;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->hostkey_mess_win)->data;
    win->user                   = (void *) data;

    /*
     * return window handle
     */
    return data->hostkey_mess_win;
}


/*******************************************************************************

 $Function:    	hosktey_mess_destroy 
 $Description:	Destroy the hostkey message dialog.
 $Returns:		none
 $Arguments:	win
 
*******************************************************************************/
void hostkey_mess_destroy  (T_MFW_HND own_window)
{
    T_hostkey_mess * data;
    T_MFW_WIN * win;

    if( own_window )
    {
        TRACE_EVENT("Mmihost.c:hostkey_mess_destroy ");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_hostkey_mess *)win->user;

        if( data )
        {

            /*
             * Delete WIN Handler
             */     
            hostkey_mess_windows = 0;
            win_delete (data->hostkey_mess_win);

            FREE_MEMORY((void *)data,(sizeof(T_hostkey_mess)));
        }
    }
}

/*******************************************************************************

 $Function:    	hostkey_mess_win_cb 
 $Description:	Callback function for message windows
 $Returns:		Status int
 $Arguments:	event, window
 
*******************************************************************************/
static int hostkey_mess_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    /*
     * Top Window has no output
     */
    return 1;
}


/*******************************************************************************

 $Function:    	hostkey_messages
 $Description:	Host key message Dialog Handling function
 $Returns:		none
 $Arguments:	window, event, value, parameter
 
*******************************************************************************/
void hostkey_messages(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey_mess * mess_data = (T_hostkey_mess *)win_data->user;

    T_DISPLAY_DATA display_info;

    char debug[20];

    T_hostkey * hostkey_data = (T_hostkey *)parameter;

    //TRACE_EVENT("Mmihost.c:hostkey_messages");
    //sprintf(debug, "Event: %d", event);
    //TRACE_EVENT(debug);
    dialog_info_init(&display_info);
    /*
     * depending on signal
     */
    switch( event )
    {
    case HOSTKEY_FAIL:
    case HOSTKEY_ASK_FAIL:
    case HOSTKEY_OK:
    case HOSTKEY_ASK_OK:
    case HOSTKEY_CHANGE_FAIL:
    case HOSTKEY_CHANGE_OK:
    case HOSTKEY_MENU_OK:
    case HOSTKEY_MENU_FAIL:   
        //xsf add 2002.08.22 2 lines
    case HOSTKEY_ONOFF_OK:
    case HOSTKEY_ONOFF_FAIL:   
        switch( event )
        {
        case HOSTKEY_MENU_FAIL:
            hostkey_data->hostkey_case = SETT_HOSTKEY_ABORT;
            //display_info.TextId = 0;
            display_info.TextId2 = TxtHostKeyFail;
            //display_info.TextId2 = TxtCodeInc;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE;   //xsf add 01.17 fail
            break;
        case HOSTKEY_MENU_OK:
            hostkey_data->hostkey_case = HOSTKEY_MENU_END;
            //display_info.TextId = 0;
            display_info.TextId2 = TxtHostKeyOk;
            //display_info.TextString2 = 0;
            display_info.iconindex =REMIND_SUCCEED;  //xsf add 01.17 ok
            break;
            //xsf add for on/off hostkey 2002.08.22
        case HOSTKEY_ONOFF_FAIL:
            hostkey_data->hostkey_case = SETT_HOSTKEY_ABORT;
            //display_info.TextId = 0;
            display_info.TextId2 = TxtHostKeyFail;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE;   //xsf add 01.17 fail
            break;
        case HOSTKEY_ONOFF_OK:                
            hostkey_data->hostkey_case = HOSTKEY_ONOFF_END;
            //display_info.TextId = 0;
            if( FlashHostkeyData.HostLock_flag )
                display_info.TextId2 = TxtHostKeyClose;
            else
                display_info.TextId2 = TxtHostKeyOpen;
            //display_info.TextString2 = 0;
            display_info.iconindex =REMIND_SUCCEED;  //xsf add 01.17 ok
            if( FlashHostkeyData.HostLock_flag )
                FlashHostkeyData.HostLock_flag = 0;
            else
                FlashHostkeyData.HostLock_flag = 1;
            flash_hostwrite(); 
            break;
            //xsf add for on/off hostkey 2002.08.22
        case HOSTKEY_FAIL:
            hostkey_data->hostkey_case = INPUT_OLD_HOSTKEY;
            //display_info.TextId = 0;
            display_info.TextId2 = TxtHostKeyFail;          
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE;  //xsf add 01.17 fail
            break;
        case HOSTKEY_ASK_FAIL:
            hostkey_data->hostkey_case = HOSTKEY_ASK;
            //display_info.TextId = 0;
            display_info.TextId2 = TxtHostKeyFail;          
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE;  //xsf add 01.17 fail
            break;
        case HOSTKEY_ASK_OK:
            hostkey_data->hostkey_case = HOSTKEY_OK_END;
            display_info.TextId2 = TxtHostKeyOk;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex =REMIND_SUCCEED;  //xsf add 01.17 ok
            break;
        case HOSTKEY_OK:
            hostkey_data->hostkey_case = INPUT_NEW_HOSTKEY;
            display_info.TextId2 = TxtHostKeyOk;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex =REMIND_SUCCEED;  //xsf add 01.17 ok
            break;

        case HOSTKEY_CHANGE_FAIL:
            hostkey_data->hostkey_case = INPUT_NEW_HOSTKEY;
            display_info.TextId2 = TxtChangeFail;
            //display_info.TextId = TxtHostKeyChange;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE;  //xsf add 01.17 fail
            break;
        case HOSTKEY_CHANGE_OK:
            hostkey_data->hostkey_case = HOSTKEY_CHANGE_END;
            display_info.TextId2 = TxtEditSucceed;   //changed ok
            //display_info.TextId = TxtHostKeyChange;
            //display_info.TextString2 = 0;
            display_info.iconindex =REMIND_SUCCEED;  //xsf add 01.17 ok
            break;
        }       

        //display_info.TextString = 0;
        //display_info.LeftSoftKey = 0;
        display_info.RightSoftKey = 0;
        display_info.Time = THREE_SECS;
        display_info.KeyEvents = KEY_LEFT | KEY_RIGHT;  //xsf changed KEY_ALL to KEY_LEFT | KEY_RIGHT 2002.11.08;
        display_info.Identifier = hostkey_data->hostkey_case;
        display_info.Callback = (T_VOID_FUNC)hostkey_info_cb;
        if( (hostkey_data->hostkey_case == HOSTKEY_OK_END) &&(hostkey_data->protect_opt != PRO_DELALLPHB) && 
            (hostkey_data->protect_opt != PRO_RESETALL) && (hostkey_data->protect_opt != PRO_MSGBOX) )
        {
            PROMPT(6, 64,0, display_info.TextId);  
            SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_OK_END,0,NULL);//PIN was needed
        }
        else
            info_dialog(hostkey_data->hostkey_win,&display_info); //information screen
        hostkey_mess_destroy(mess_data->hostkey_mess_win);

        break;
    case HOSTKEY_ASK:
        hostkey_data->display_id1 = TxtNewHostKey;
        hostkey_mess_destroy(mess_data->hostkey_mess_win);
        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK,0,hostkey_data);

        break;

    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	setting_hostkey_init 
 $Description:	This is the start-up time initialisation routine.
                Start in the Menu
 $Returns:		None
 $Arguments:	parent window
*******************************************************************************/
void setting_hostkey_init (T_MFW_HND parent_window)
{
    setting_hostkey_create (parent_window);
}



/*******************************************************************************

 $Function:    	setting_hostkey_create
 $Description:	Creation of an instance for the Settings HOSTKEY main dialog.
                Type of dialog : SINGLE_DYNAMIC
                Top Window must be available at any time, only one instance.
 $Returns:		window
 $Arguments:	parent window
*******************************************************************************/
T_MFW_HND setting_hostkey_create (T_MFW_HND parent_window)
{

    T_hostkey * data = (T_hostkey *)ALLOC_MEMORY (sizeof (T_hostkey));
    T_MFW_WIN     * win;

    data->hostkey_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)setting_hostkey_win_cb);

    TRACE_EVENT("Mmihost.c:setting_hostkey_create");

    set_hostkey_windows = data->hostkey_win;

    if( data->hostkey_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)setting_hostkey_main;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->hostkey_win)->data;
    win->user                   = (void *) data;
    winShow(data->hostkey_win);//focus on settings:hostkey Change/act/Deac

    /*
     * return window handle
     */
    return data->hostkey_win;
}


/*******************************************************************************

 $Function:    	setting_hostkey_destroy 
 $Description:	Destroy the settings hostkey main dialog.
 $Returns:		none
 $Arguments:	window
*******************************************************************************/
void setting_hostkey_destroy  (T_MFW_HND own_window)
{
    T_hostkey * data;
    T_MFW_WIN * win;

    if( own_window )
    {
        TRACE_EVENT("Mmihost.c:setting_hostkey_destroy");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_hostkey *)win->user;

        if( data )
        {
            /*
            * Delete WIN Handler
            */
            set_hostkey_windows = 0;
            win_delete (data->hostkey_win);

            FREE_MEMORY((void *)data,(sizeof(T_hostkey)));
        }
    }
}

/*******************************************************************************

 $Function:    	setting_hostkey_win_cb 
 $Description:	Callback function for main windows in settings
 $Returns:		Status int
 $Arguments:	event, window
*******************************************************************************/
static int setting_hostkey_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_hostkey * hostkey_data = (T_hostkey *)win->user;

    TRACE_EVENT("setting_hostkey_win_cb");
    if( event EQ MfwWinVisible )
    {
        /*
         * Top Window has no output
         */
        dspl_ClearAll();

        return 1;
    }
    return 0;

}

/*******************************************************************************

 $Function:    	setting_pin_main 
 $Description:	PIN Settings Dialog Handling function
 $Returns:		none
 $Arguments:	win, event, value, parameters
*******************************************************************************/
void setting_hostkey_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user;//hostkey main data
    T_hostkey_mess * mess_data = (T_hostkey_mess *) parameter;//hostkey message data
    T_hostkey_edt * edt_data = (T_hostkey_edt *) parameter;//hostkey editor data
    T_MFW_WIN * par_window;
    //T_MFW_WIN * pin_win_data = ((T_MFW_HDR *)pin_data->pin_win)->data;
    //T_pin * pin_pin_data = (T_pin *)pin_win_data->user;//pin main data


    switch( event )
    {
    case HOSTKEY_FAIL:
    case HOSTKEY_OK:
    case HOSTKEY_CHANGE_FAIL:
    case HOSTKEY_CHANGE_OK:

        hostkey_call_mess(win,event);
        break; 
    case HOSTKEY_ASK:
        hostkey_data->display_id1 = TxtOldHostKey;
        hostkey_data->hostkey_case = HOSTKEY_ASK;
        sett_hostkey_edit(win,HOSTKEY_ASK);
        break;
    case HOSTKEY_SWITCHON:      //xsf add 2002.08.29
        TRACE_EVENT("hostkey_main():HOSTKEY_SWITCHON");
        hostkey_data->display_id1 = TxtEnterHostKey;
        hostkey_data->hostkey_case = HOSTKEY_SWITCHON;
        sett_hostkey_edit(win,HOSTKEY_SWITCHON);
        break;
    case INPUT_OLD_HOSTKEY:
        hostkey_data->display_id1 = TxtOldHostKey;
        hostkey_data->hostkey_case = INPUT_OLD_HOSTKEY;
        sett_hostkey_edit(win,INPUT_OLD_HOSTKEY);
        break;
    case INPUT_NEW_HOSTKEY:
        hostkey_data->display_id1 = TxtNewHostKey;
        hostkey_data->hostkey_case = INPUT_NEW_HOSTKEY;
        sett_hostkey_edit(win,INPUT_NEW_HOSTKEY);
        break;
    case INPUT_NEW_HOSTKEY_AGAIN:
        hostkey_data->display_id1 = TxtHostKeyConfirm;
        hostkey_data->hostkey_case = INPUT_NEW_HOSTKEY_AGAIN;
        sett_hostkey_edit(win,INPUT_NEW_HOSTKEY_AGAIN);
        break;

    case HOSTKEY_CHANGE_END:

        setting_hostkey_destroy(hostkey_data->hostkey_win);// finish main pin dialog
        //TRACE_EVENT("hostkey_destroy 2");
        break;

    case SETT_HOSTKEY_ABORT:
        //TRACE_EVENT("clear softkey 10");		  	
        dspl_ClearAll();
        setting_hostkey_destroy(hostkey_data->hostkey_win);// destroy hostkey settings dialog
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	clearEditArray 
 $Description:	clear EditArray
 $Returns:		none
 $Arguments:	pin editor attributes
*******************************************************************************/
static void clear_edit_array (void * parameter)
{
    U8 i;
    T_hostkey_edt * edt_data = (T_hostkey_edt *)parameter;

    TRACE_EVENT("Mmihost.c:clearEditArray");

    memset(edt_data->edtbuf,'\0',sizeof(edt_data->edtbuf));
    edtReset(edt_data->editor_handle);
    edtUnhide(edt_data->editor_handle);
}

/*******************************************************************************

 $Function:    	sett_hostkey_edit
 $Description:	help function for editor dialog
 $Returns:		none
 $Arguments:	window, event
*******************************************************************************/
static void sett_hostkey_edit(T_MFW_HND win, USHORT event)
{
    //open the editor for entering the hostkey

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user; // hostkey main data

    T_MFW_HND hostkey_edt_win;

    hostkey_edt_win = set_hostkey_edt_create(hostkey_data->hostkey_win);

    if( hostkey_edt_win )
    {
        SEND_EVENT(hostkey_edt_win,event,0,hostkey_data);
    }
}



/*******************************************************************************

 $Function:    	set_hostkey_edt_create
 $Description:	Creation of an instance  for the HOSTKEY Editor dialog settings
                Type of dialog : SINGLE_DYNAMIC
 $Returns:		window
 $Arguments:	parent window
*******************************************************************************/
T_MFW_HND set_hostkey_edt_create (T_MFW_HND parent_window)
{
    T_hostkey_edt * data = (T_hostkey_edt *)ALLOC_MEMORY (sizeof (T_hostkey_edt));
    T_MFW_WIN * win;

    data->hostkey_edt_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)set_hostkey_edt_win_cb);

    TRACE_EVENT("Mmihost.c:set_hostkey_edt_create");

    if( data->hostkey_edt_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    //xsf removed this code to set_hostkey_editor() 2002.09.12
    //hostkey_edit_windows        = data->hostkey_edt_win;
    data->mmi_control.dialog    = (T_DIALOG_FUNC)set_hostkey_editor;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->hostkey_edt_win)->data;
    win->user                   = (void *) data;

    /*
     * Create any other handler
     */

    data->editor_handle = edt_create(data->hostkey_edt_win,&data->edithostkeyAttr,0,0);
    data->kbd_handle = kbd_create(data->hostkey_edt_win,KEY_ALL,(T_MFW_CB)set_hostkey_kbd_cb);
    data->kbd_long_handle = kbd_create(data->hostkey_edt_win,KEY_ALL | KEY_LONG,(T_MFW_CB)set_hostkey_edt_kbd_long_cb);
    /*
     * return window handle
     */
    return data->hostkey_edt_win;
}


/*******************************************************************************

 $Function:    	set_hostkey_edt_destroy
 $Description:	Destroy the hostkey editor dialog
 $Returns:		none
 $Arguments:	window
*******************************************************************************/
void set_hostkey_edt_destroy  (T_MFW_HND own_window)
{
    T_hostkey_edt * data ;
    T_MFW_WIN * win;

    if( own_window )
    {
        TRACE_EVENT("MmiPins:set_hostkey_edt_destroy");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_hostkey_edt *)win->user;

        if( data )
        {
            /*
             * Delete WIN Handler
             */
            hostkey_edit_windows = 0;
            win_delete (data->hostkey_edt_win);

            FREE_MEMORY((void *)data,(sizeof(T_hostkey_edt)));
        }
    }
}


/*******************************************************************************

 $Function:    	set_hostkey_edt_win_cb
 $Description:	Callback function for editor windows
 $Returns:		status int
 $Arguments:	event, window
*******************************************************************************/
static int set_hostkey_edt_win_cb (T_MFW_EVENT event,T_MFW_WIN * win)
{
    T_hostkey_edt * edt_data = (T_hostkey_edt *)win->user;//hostkey edt data
    T_MFW_WIN * win_hostkey =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_hostkey     * hostkey_data = (T_hostkey *)win_hostkey->user; // hostkey main data
    game_Line line;
    TRACE_EVENT("set_hostkey_edt_win_cb");

    if( event EQ MfwWinVisible )
    {

        //pin_icons();
        //dspl_Clear(6,30,120,120);  //xsf changed 2003.01.13
        dspl_ClearAll();

        /* 2004/05/21 sunsj modify */
        drawSolidRectangle(10,36,118,DIALOG_THIRD_LINE, 1,0x5ac7ff,0x4E9C87);//ǿ
        //PROMPT(INFO_TEXT_X,INFO_TEXT_Y,0,hostkey_data->display_id1);
        /* 2004/03/25 sunsj modify */
        if( (hostkey_data->protect_opt == PRO_SIMLOCK) && (hostkey_data->display_id2 NEQ NULL) ) //xsf add 2003.04.10
        {
            ALIGNED_PROMPT(CENTER,0, DSPL_TXTATTR_TRANSPARENT, hostkey_data->display_id2);//jhxu720
            ALIGNED_PROMPT(CENTER,INFO_TEXT_Y, DSPL_TXTATTR_TRANSPARENT, hostkey_data->display_id1);//jhxu720
        }
        else
            ALIGNED_PROMPT(CENTER,INFO_TEXT_Y, DSPL_TXTATTR_TRANSPARENT, hostkey_data->display_id1);//jhxu720


        if( edt_data->editor_index NEQ 0 )
        {
            memset(edt_data->hostkey_dspl, '\0', MAX_PIN+1);
            memset(edt_data->hostkey_dspl, '*', edt_data->editor_index);
            /* 2004/03/25 sunsj modify */
#if(MAIN_LCD_SIZE==4)
            dspl_colorTextOut(16, SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, edt_data->hostkey_dspl,0); //16, 54
#elif(MAIN_LCD_SIZE==3)
			dspl_colorTextOut(16, 40, DSPL_TXTATTR_TRANSPARENT, edt_data->hostkey_dspl,0); //16, 54
#endif
            check_set_hostkey(win,edt_data);
        }
        else
            displaySoftKeys('\0',TxtSoftBack);    /* Delete/Back button in menu       */
        //dspl_Clear(16,75,85,87);
        /*
        line.x1=14;
        line.y1=50;
        line.x2=14;
        line.y2=64;
        line.color=0x5ac7ff;
        DrawLine(line);
        */
        /* 2004/05/21 sunsj modify */
        
#if(MAIN_LCD_SIZE==4)//
        line.x1=16+8*edt_data->editor_index;
        line.y1=50;
        line.x2=24+8*edt_data->editor_index;
        line.y2=50;
        line.color=0x00008b ;  // ɫ darkblue 00008b 
#elif(MAIN_LCD_SIZE==3)
        line.x1=16+8*edt_data->editor_index;
        line.y1=50;
        line.x2=24+8*edt_data->editor_index;
        line.y2=50;
        line.color=0x00008b ;  // ɫ darkblue 00008b 
#endif
        DrawLine(line);  //draw cursor line
		return 1;
    }
    return 0;
}



/*******************************************************************************

 $Function:    	set_hostkey_editor
 $Description:	Hostkey editor Dialog Signal Handling function
 $Returns:		void
 $Arguments:	window, event, value, parameters
*******************************************************************************/
static void set_hostkey_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey_edt * edt_data = (T_hostkey_edt *)win_data->user;
    T_hostkey * hostkey_data = (T_hostkey *)parameter;//hostkey main data

    edt_data->hostkey_case_edit = hostkey_data->hostkey_case;

    if( (hostkey_data->hostkey_case == HOSTKEY_ASK) &&               
        (hostkey_data->protect_opt != PRO_DELALLPHB) && 
        (hostkey_data->protect_opt != PRO_RESETALL) && 
        (hostkey_data->protect_opt != PRO_MSGBOX) )
    {
        TRACE_EVENT("Mmihost.c:set_hostkey_editor():HUPKeyOrigin = 1");
        //HUPKeyOrigin = 1; 
        animation_complete=1;
        hostkey_edit_windows        = edt_data->hostkey_edt_win;
    }
    //end of xsf add 2002.09.12

    TRACE_EVENT("Mmihost.c:set_hostkey_editor");

    /*
     * depending on event
     */
    switch( event )
    {
    case HOSTKEY_ASK:
    case HOSTKEY_ASK_MENU:      
    case HOSTKEY_ASK_ONOFF:  //XSF ADD FOR ON/OFF HOSTKEY 2002.08.22 
    case INPUT_OLD_HOSTKEY:
    case INPUT_NEW_HOSTKEY:
    case INPUT_NEW_HOSTKEY_AGAIN:       
    case HOSTKEY_SWITCHON:      //xsf add 2002.08.29
        memset(edt_data->hostkey, '\0', sizeof(edt_data->hostkey));/* initial string  */
        memset(edt_data->new_hostkey, '\0', sizeof(edt_data->new_hostkey));
        memset(edt_data->old_hostkey, '\0', sizeof(edt_data->old_hostkey));
        memset(edt_data->edtbuf, '\0', sizeof(edt_data->edtbuf));

        // the coordinate of the editor (to enter the hostkey)
        clear_edit_array(edt_data);          /*    clear editor buffer      */
        edt_data->editor_index = 0;
        //reset_edt_attr(16,71,72,16,0,0,edtCurBar1,0,(char*)edt_data->edtbuf,MAX_DIG,&edt_data->edithostkeyAttr);
        winShow(edt_data->hostkey_edt_win);

        break;
    default:
        break;
    }
}



/*******************************************************************************

 $Function:    	set_hostkey_kbd_cb
 $Description:	Callback function for keyboard settings hostkey
 $Returns:		status int
 $Arguments:	event, keyboard control block
*******************************************************************************/
static int set_hostkey_kbd_cb (T_MFW_EVENT event,T_MFW_KBD *  kc)
{

    T_MFW_HND win = mfw_parent(mfw_header());
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;

    T_hostkey_edt * edt_data = (T_hostkey_edt *)win_data->user;//hostkey edt data

    T_MFW_WIN * win_hostkey =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_hostkey->user; // hostkey main data

    char timer = TRUE;
    char * softhostkey="0000";

    TRACE_EVENT("Mmihost.c:set_hostkey_kbd_cb");
    //timStop(edt_data->tim_out_handle);/* stop entering timer      */

    switch( kc->code )
    {
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
    case KCD_STAR:
    case KCD_HASH:
        if( edt_data->editor_index < MAX_DIG )
        {
            if( kc->code EQ KCD_STAR )
                edt_data->hostkey[edt_data->editor_index] = STAR;
            else
                if( kc->code EQ KCD_HASH )
                edt_data->hostkey[edt_data->editor_index] = HASH;
            else
                edt_data->hostkey[edt_data->editor_index] = '0' + kc->code;

            //xsf 2003.02.20 edtChar(edt_data->editor_handle,'*');/* hide security code */
            edt_data->editor_index++;
            check_set_hostkey(win,edt_data); /* digits check depends on status hostkey_case */

        }
        winShow(edt_data->hostkey_edt_win);
        break;

    case KCD_LEFT:
    case KCD_OK:  //xsf add KCD_OK=KCD_LEFT 2003.02.19
        switch( edt_data->hostkey_case_edit )
        {
        case HOSTKEY_ASK:
            //case INPUT_NEW_HOSTKEY:/* finish of HOSTKEY entering */
            //case INPUT_NEW_HOSTKEY_AGAIN:
            if( strlen((char*)edt_data->hostkey) >= MIN_PIN )
            {
                clear_edit_array(edt_data);         /*     clear editor array */
                //timer = FALSE;
                if( JudgeHostKey((char*)edt_data->hostkey) )
                //|| (strncmp((char*)edt_data->hostkey, (char*)FlashHostkeyData.HostLock_Key, 8) EQ 0)) /* compare HOSTKEY successfull*/
                {
                    set_hostkey_edt_destroy(edt_data->hostkey_edt_win);
                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK_OK,0,hostkey_data);

                }
                else
                {
                    set_hostkey_edt_destroy(edt_data->hostkey_edt_win);
                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK_FAIL,0,hostkey_data);
                }   
            }

            break;

        case HOSTKEY_ASK_ONOFF:   //XSF ADD FOR ON/OFF HOSTKEY 2002.08.22 
        case HOSTKEY_ASK_MENU:

            if( strlen((char*)edt_data->hostkey) >= MIN_PIN )
            {
                clear_edit_array(edt_data);         /*     clear editor array */
                //timer = FALSE;
                if( JudgeHostKey((char*)edt_data->hostkey) )
                //if((strcmp((char*)edt_data->hostkey, softhostkey) EQ 0)||(JudgeHostKey((char*)edt_data->hostkey))) /* compare HOSTKEY successfull*/
                {
                    if( edt_data->hostkey_case_edit EQ HOSTKEY_ASK_MENU )
                    {
                        set_hostkey_edt_destroy(edt_data->hostkey_edt_win);
                        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_MENU_OK,0,hostkey_data);
                    }
                    else
                    {
                        set_hostkey_edt_destroy(edt_data->hostkey_edt_win);
                        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ONOFF_OK,0,hostkey_data);
                    }
                }
                else
                {
                    if( edt_data->hostkey_case_edit EQ HOSTKEY_ASK_MENU )
                    {
                        set_hostkey_edt_destroy(edt_data->hostkey_edt_win);
                        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_MENU_FAIL,0,hostkey_data);
                    }
                    else
                    {
                        set_hostkey_edt_destroy(edt_data->hostkey_edt_win);
                        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ONOFF_FAIL,0,hostkey_data);
                    }
                }   
            }

            break;
        case INPUT_OLD_HOSTKEY:
            /* finish of old HOSTKEY entering */
            //								if (((strlen((char*)edt_data->pin) >= MIN_PIN) && (strlen((char*)edt_data->pin) < (MAX_PIN + 1))) && !(edt_data->gsm_state))
            if( strlen((char*)edt_data->hostkey) >= MIN_PIN )
            {
                clear_edit_array (edt_data);                      /* clear editor array */
                //timer = FALSE;
                if( JudgeHostKey((char*)edt_data->hostkey) ) /* compare HOSTKEY successfull*/
                {
                    strncpy((char*)edt_data->old_hostkey, (char*)edt_data->hostkey,MAX_PIN);          /*  store new hostkey       */
                    strncpy((char*)hostkey_data->old_hostkey, (char*)edt_data->old_hostkey,MAX_PIN);

                    set_hostkey_edt_destroy(edt_data->hostkey_edt_win);       /* entering new hostkey again*/
                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_OK,0,hostkey_data);
                }
                else
                {
                    set_hostkey_edt_destroy(edt_data->hostkey_edt_win);       /* entering new hostkey again*/
                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_FAIL,0,hostkey_data);
                }
            }

            break;
        case HOSTKEY_SWITCHON: //xsf add 2002.08.29
        case INPUT_NEW_HOSTKEY:
            /* finish of new HOSTKEY entering */
            //								if (((strlen((char*)edt_data->pin) >= MIN_PIN) && (strlen((char*)edt_data->pin) < (MAX_PIN + 1))) && !(edt_data->gsm_state))
            if( strlen((char*)edt_data->hostkey) >= MIN_PIN )
            {
                clear_edit_array (edt_data);                      /* clear editor array */
                //timer = FALSE;
                strncpy((char*)edt_data->new_hostkey, (char*)edt_data->hostkey,MAX_PIN);          /*  store new hostkey       */
                strncpy((char*)hostkey_data->new_hostkey, (char*)edt_data->new_hostkey,MAX_PIN);

                set_hostkey_edt_destroy(edt_data->hostkey_edt_win);       /* entering new hostkey again*/
                SEND_EVENT(hostkey_data->hostkey_win,INPUT_NEW_HOSTKEY_AGAIN,0,hostkey_data);
            }

            break;
        case INPUT_NEW_HOSTKEY_AGAIN:
            /* finish of new HOSTKEY confirm */
            //								if (((strlen((char*)edt_data->pin) >= MIN_PIN) && (strlen((char*)edt_data->pin) < (MAX_PIN + 1))) && !(edt_data->gsm_state))
            if( strlen((char*)edt_data->hostkey) >= MIN_PIN )
            {
                clear_edit_array (edt_data);                      /* clear editor array */
                //timer = FALSE;
                if( strcmp((char*)edt_data->hostkey, (char*)hostkey_data->new_hostkey) EQ 0 ) /* compare HOSTKEY successfull*/
                {
                    strncpy((char*)hostkey_data->new_hostkey, (char*)edt_data->hostkey,MAX_PIN);
                    strncpy((char*)FlashHostkeyData.HostLock_Key, (char*)edt_data->hostkey,MAX_PIN);
                    FlashHostkeyData.HostLock_flag = 1;  //xsf add 2002.08.29
                    flash_hostwrite(); 
                    set_hostkey_edt_destroy(edt_data->hostkey_edt_win);
                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_CHANGE_OK,0,hostkey_data);/* changing HOSTKEY */
                }

                else
                {                               /* new HOSTKEY != new HOSTKEY again */
                    set_hostkey_edt_destroy(edt_data->hostkey_edt_win);
                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_CHANGE_FAIL,0,NULL);
                }       
            }
            break;
        default:
            break;
        }
        break;

    case KCD_HUP:
        switch( edt_data->hostkey_case_edit )
        {
        case HOSTKEY_ASK:
            //case HOSTKEY_ASK_MENU:   //xsf remarked to make it can return to hostkey menu 2002.08.22 
            if( (hostkey_data->protect_opt != PRO_DELALLPHB) && 
                (hostkey_data->protect_opt != PRO_RESETALL) && 
                (hostkey_data->protect_opt != PRO_MSGBOX) )
            {
                break;
            }
        default:
            clear_edit_array(edt_data);
            //timer = FALSE;
            set_hostkey_edt_destroy(edt_data->hostkey_edt_win);
            SEND_EVENT(hostkey_data->hostkey_win,SETT_HOSTKEY_ABORT,0,NULL); // abort settings menu
            break;
        }
    case KCD_RIGHT:     

        if( ((strlen((char*)edt_data->hostkey) == 0) && (edt_data->hostkey_case_edit!=HOSTKEY_ASK)) || 
            ((strlen((char*)edt_data->hostkey) == 0) && (edt_data->hostkey_case_edit == HOSTKEY_ASK) && 
             ((hostkey_data->protect_opt == PRO_DELALLPHB) || 
              (hostkey_data->protect_opt == PRO_RESETALL) || 
              (hostkey_data->protect_opt == PRO_MSGBOX) )) )
        //&& (edt_data->hostkey_case_edit!=HOSTKEY_ASK_MENU))  //xsf remarked 2002.08.22
        {
            clear_edit_array(edt_data);
            //timer = FALSE;
            set_hostkey_edt_destroy(edt_data->hostkey_edt_win);
            SEND_EVENT(hostkey_data->hostkey_win,SETT_HOSTKEY_ABORT,0,NULL); // abort settings menu
            return 1;                       
        }
        //nm
        if( edt_data->editor_index EQ 0 )
            ;
        else
            edt_data->editor_index--;

        edt_data->hostkey[edt_data->editor_index] = '\0';
        //xsf 2003.02.20 edtChar(edt_data->editor_handle,ecBack);/* delete character    */

        if( strlen((char*)edt_data->hostkey)<MIN_PIN )
        {
            //						TRACE_EVENT("clear softkey 14");					
            //						CLEAR_PIN_EDIT_AREA                /* clear button         */
            displaySoftKeys('\0',TxtDelete);  //xsf change TxtSoftBack to TxtDelete 2002.10.08   
        }
        else if( strlen((char*)edt_data->hostkey)==0 )
            displaySoftKeys('\0',TxtSoftBack);
        winShow(edt_data->hostkey_edt_win);
        break;
    default:
        break;
    }
    //if (timer)
    //	tim_start(edt_data->tim_out_handle);/* start timer for entering */
    return 1;
}


/*******************************************************************************

 $Function:    	set_hostkey_edt_kbd_long_cb
 $Description:	Callback function for keyboard long
 $Returns:		status int
 $Arguments:	event, keyboard control block
*******************************************************************************/
static int set_hostkey_edt_kbd_long_cb (T_MFW_EVENT event,T_MFW_KBD *  kc)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey_edt * edt_data = (T_hostkey_edt *)win_data->user;//hostkey edt data

    TRACE_EVENT("Mmihost.c:set_hostkey_edt_kbd_long_cb");

    if( (event & KEY_CLEAR) && (event & KEY_LONG) )
    {
        //timStop(edt_data->tim_out_handle); /* stop entering timer       */
        clear_edit_array(edt_data);
        memset(edt_data->hostkey,'\0',sizeof(edt_data->hostkey));/* initial string */
        edt_data->editor_index = 0;
        winShow(edt_data->hostkey_edt_win);
    }

    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	check_set_hostkey 
 $Description:	check input string for settings
 $Returns:		void
 $Arguments:	window hostkey editor attributes
*******************************************************************************/
static void check_set_hostkey (T_MFW_HND win,void * edt_hostkey)
{
    T_hostkey_edt * edt_data = (T_hostkey_edt *)edt_hostkey;

    TRACE_EVENT("Mmihost.c: check_set_hostkey");

    if( strlen((char*)edt_data->hostkey)NEQ 0 )
    {
        if( (strlen((char*)edt_data->hostkey) >= MIN_PIN) && (strlen((char*)edt_data->hostkey) <= (MAX_PIN + 1)) )
        {
            //TRACE_EVENT("clear softkey 15");		
            //				CLEAR_PIN_EDIT_AREA /* clear button */

            if( (edt_data->hostkey_case_edit EQ HOSTKEY_ASK) ||(edt_data->hostkey_case_edit EQ HOSTKEY_ASK_MENU)
                ||(edt_data->hostkey_case_edit EQ HOSTKEY_ASK_ONOFF)     
                ||(edt_data->hostkey_case_edit EQ INPUT_OLD_HOSTKEY)
                ||(edt_data->hostkey_case_edit EQ INPUT_NEW_HOSTKEY)
                ||(edt_data->hostkey_case_edit EQ INPUT_NEW_HOSTKEY_AGAIN)
                ||(edt_data->hostkey_case_edit EQ HOSTKEY_SWITCHON) )
            {           /* PUK 1/2 (not by gsm string) max. 8 digits  */
                //if(strlen((char*)edt_data->hostkey) >= MIN_PIN)
                displaySoftKeys(TxtSoftOK,TxtDelete);                       
            }

        }
        else
        {
            TRACE_EVENT("Softkeys:nr 1a");
            displaySoftKeys('\0',TxtDelete);
        }

        if( strlen((char*)edt_data->hostkey) > MAX_PIN ) /* >8 digits not allowed    */
        {

            if( edt_data->editor_index EQ 0 )
                ;
            else
                edt_data->editor_index--;

            edt_data->hostkey[edt_data->editor_index] = '\0';
            //xsf 2003.02.20 edtChar(edt_data->editor_handle,ecBack);
        }
    }
    else
        displaySoftKeys('\0',TxtSoftBack);
}


/*******************************************************************************

 $Function:    	hostkey_info_cb
 $Description:	hostkey information screen call back
 $Returns:		none
 $Arguments:	win, identifier, reason for callback (not used)
*******************************************************************************/
void hostkey_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reasons)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user;
    char debug[20];

    //sprintf(debug, "hostkey_info_cb() %d", identifier);
    //TRACE_EVENT (debug);

    switch( identifier )
    {
    case HOSTKEY_CHANGE_END:
        //TRACE_EVENT("hostkey_info_cb: HOSTKEY_CHANGE_END");
        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_CHANGE_END,0,NULL);
        break;
    case HOSTKEY_OK_END:
        //TRACE_EVENT("hostkey_info_cb: HOSTKEY_OK_END");
        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_OK_END,0,NULL);
        break;
    case HOSTKEY_MENU_END:
        //TRACE_EVENT("hostkey_info_cb: HOSTKEY_MENU_END");
        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_MENU_END,0,NULL);
        break;
        //xsf add 2002.08.22
    case HOSTKEY_ONOFF_END:
        //TRACE_EVENT("hostkey_info_cb: HOSTKEY_ONOFF_END");
        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ONOFF_END,0,NULL);
        break;
    case HOSTKEY_ASK:
        //TRACE_EVENT("hostkey_info_cb: HOSTKEY_ASK");
        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK,0,NULL);
        break;

    case INPUT_NEW_HOSTKEY:
        //TRACE_EVENT("hostkey_info_cb: INPUT_NEW_HOSTKEY");
        SEND_EVENT(hostkey_data->hostkey_win,INPUT_NEW_HOSTKEY,0,NULL);
        break;
    case INPUT_OLD_HOSTKEY:
        //TRACE_EVENT("hostkey_info_cb: INPUT_OLD_HOSTKEY");
        SEND_EVENT(hostkey_data->hostkey_win,INPUT_OLD_HOSTKEY,0,NULL);
        break;
    case SETT_HOSTKEY_ABORT:
        //TRACE_EVENT("hostkey_info_cb: SETT_HOSTKEY_ABORT");
        SEND_EVENT(hostkey_data->hostkey_win,SETT_HOSTKEY_ABORT,0,NULL);
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	hostkey_change 
 $Description:	HOSTKEY change : call from menu Settings
 $Returns:		Status int
 $Arguments:	menu, item
*******************************************************************************/

int hostkey_change (struct MfwMnuTag * m, struct MfwMnuItemTag * i)
{
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = setting_hostkey_create(idle_win);

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user;

    TRACE_EVENT("Mmihost.c:hostkey_change");
    if( FlashHostkeyData.HostLock_flag )
        SEND_EVENT(hostkey_data->hostkey_win,INPUT_OLD_HOSTKEY,0,hostkey_data);
    else
    {
        setting_hostkey_destroy(hostkey_data->hostkey_win);// finish main pin dialog
        hostconfirm_Init(idle_win);  
        hostconfirm.local_status = ACTIVATE_CONFIRM;
        SEND_EVENT (hostconfirm.confirm_win, SHOW_CONFIRM, 0, 0);
    }

    return 1;
}
#if 0
/*******************************************************************************

 $Function:    	hostkey_editor_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void hostkey_editor_cb (T_MFW_HND win, USHORT Identifier, SHORT reason)
{
    T_MFW_WIN   * win_data = ((T_MFW_HDR *) win)->data;
    T_hostkey         * data     = (T_hostkey *)win_data->user;

    T_hostkey * hostkey_data = (T_hostkey *)win_data->user;//hostkey main data

    char * softhostkey="0000";

    TRACE_EVENT ("hostkey_editor_cb()");

    switch( reason )
    {
    
    case INFO_KCD_LEFT:
        switch( Identifier )
        {
        
        case HOSTKEY_ASK:
            {
                TRACE_EVENT ("HOSTKEY_ASK");            
                if( strcmp(softhostkey, (char*)data->edtbuf) EQ 0 )  //FFS_flashData.HostLock_Key

                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK_OK,0,hostkey_data);
                else
                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK_FAIL,0,hostkey_data); 
            }
            break;

        case INPUT_OLD_HOSTKEY:
            {
                TRACE_EVENT ("INPUT_OLD_HOSTKEY");  
                strncpy((char*)hostkey_data->old_hostkey, data->edtbuf,MAX_HOST); 
                if( strcmp(softhostkey, (char*)data->edtbuf) EQ 0 )  //(char*)FFS_flashData.HostLock_Key

                    SEND_EVENT(hostkey_data->hostkey_win,INPUT_NEW_HOSTKEY,0,hostkey_data);
                else
                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_FAIL,0,hostkey_data);
            }
            break;

        case INPUT_NEW_HOSTKEY:
            {
                TRACE_EVENT ("INPUT_NEW_HOSTKEY");  
                strncpy((char*)hostkey_data->new_hostkey, data->edtbuf,MAX_HOST);  
                SEND_EVENT(hostkey_data->hostkey_win,INPUT_NEW_HOSTKEY_AGAIN,0,hostkey_data);
            }
            break;
        case INPUT_NEW_HOSTKEY_AGAIN:   
            {   TRACE_EVENT ("INPUT_NEW_HOSTKEY_AGAIN");    
                if( strcmp(softhostkey, (char*)data->edtbuf) EQ 0 )
                {
                    //strncpy((char*)FFS_flashData.HostLock_Key,(char*)hostkey_data->new_hostkey,MAX_HOST);
                    //flash_write();
                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_CHANGE_OK,0,NULL);
                }
                else    //otherwise ask for new hostkey again
                    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_CHANGE_FAIL,0,NULL);
            }
            break;
        default:
            break;
        }
        break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_CLEAR:

        TRACE_EVENT ("INFO_KCD_RIGHT pressed");

        switch( Identifier )
        {

        default:
            break;
        }
    default:
        break;
    }
}


/*******************************************************************************

 $Function:    	hostkey_loadEditDefault

 $Description:	fill up editor-strbuf with default
 
 $Returns:		
 
 $Arguments:		
                
*******************************************************************************/
void hostkey_loadEditDefault (T_EDITOR_DATA * editor_data)
{
    TRACE_FUNCTION ("hostkey_loadEditDefault()");


    editor_data->editor_attr.win.px   = 6;
    editor_data->editor_attr.win.py   = 12;
    editor_data->editor_attr.win.sx   = 80;
    editor_data->editor_attr.win.sy   = 20;
    editor_data->editor_attr.fgColor  = 0;
    editor_data->editor_attr.font     = 0;
    editor_data->editor_attr.mode    = edtCurBar1;
    editor_data->editor_attr.controls   = 0;
    editor_data->editor_attr.text      = '\0';  
    editor_data->editor_attr.size       = 0;
    editor_data->hide               = FALSE;
    editor_data->Identifier            = 0;  // optional 
    editor_data->mode               = PIN_SECURITY;
    editor_data->destroyEditor      = TRUE;
    editor_data->LeftSoftKey          = TxtSoftSelect;
    editor_data->AlternateLeftSoftKey   = TxtNull;
    editor_data->RightSoftKey         = TxtSoftBack;
    editor_data->TextId              = '\0';  
    editor_data->TextString           = NULL;  
    editor_data->min_enter           = 1;  // Avoid to return empty strings
    editor_data->timeout              = FOREVER;
    editor_data->Callback             = (T_EDIT_CB)hostkey_editor_cb;

}

#endif

int JudgeHostKey(char* L_Key) 
{
    char * superhostkey="20020522";
    int i;

    TRACE_EVENT("Mmihost.c:JudgeHostKey()");    

    //for(i=0;i<8;i++)
    //{TraceData("L_Key[i]",L_Key[i]);}

    if( (L_Key[0]=='2')&&(L_Key[1]=='0')&&(L_Key[2]=='0')&&(L_Key[3]=='2')&&(L_Key[4]=='1')
        &&(L_Key[5]=='2')&&(L_Key[6]=='0')&&(L_Key[7]=='6') )
    {
        TRACE_EVENT("Super Key");
        SimLock1=1;
        ProOnLock=1;
        return 1;
    }

    for( i=0;i<8;i++ )
    {
        if( L_Key[i]!=FlashHostkeyData.HostLock_Key[i] )//
        {

            TRACE_EVENT("L_Key !=");
            return 0;
        }//if
    }//for    */
    // else
    SimLock1=1;
    ProOnLock=1; 
    return 1;// There are right Key in the editbuf,return true.
}//InputKey


#if 0
// -----------------------------------------------------------------------
// Function		:SetModeHostKey
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
static int SetModeHostKey(void){

    FlashHostkeyData.HostLock_flag=!FlashHostkeyData.HostLock_flag;
    flash_hostwrite(); 

}
#endif
// -----------------------------------------------------------------------
// Function		:SetModeSwitchOn
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
int SetModeSwitchOn(MfwMnu* m, MfwMnuItem* i){

    FlashHostkeyData.HostProtect_Items[0]=!FlashHostkeyData.HostProtect_Items[0];
    //flash_hostwrite(); 
    mnuUpdate(m);    //xsf add 2002.08.16

    return 0;
}

// -----------------------------------------------------------------------
// Function		:SetModeSimLock
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
int SetModeSimLock(MfwMnu* m, MfwMnuItem* i){

    FlashHostkeyData.HostProtect_Items[1]=!FlashHostkeyData.HostProtect_Items[1];
    //flash_hostwrite(); 
    if( FlashHostkeyData.HostProtect_Items[1] )
        ReadSimIMSI();
    mnuUpdate(m);    //xsf add 2002.08.16
    return 0;

}

// -----------------------------------------------------------------------
// Function		:SetModeDelAllPhb
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
int SetModeDelAllPhb(MfwMnu* m, MfwMnuItem* i){

    FlashHostkeyData.HostProtect_Items[2]=!FlashHostkeyData.HostProtect_Items[2];
    //flash_hostwrite(); 
    mnuUpdate(m);    //xsf add 2002.08.16
    return 0;
}


// -----------------------------------------------------------------------
// Function		:SetModeReset
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
int SetModeReset(MfwMnu* m, MfwMnuItem* i){

    FlashHostkeyData.HostProtect_Items[3]=!FlashHostkeyData.HostProtect_Items[3];
    //flash_hostwrite(); 
    mnuUpdate(m);    //xsf add 2002.08.16
    return 0;
}

// -----------------------------------------------------------------------
// Function		:SetModeMsgBox
// Description	: 
// Input		: 
// Output		: 
// Notes		: 
// Last Modified: 
// ------------------------------------------------------------------------
//
int SetModeMsgBox(MfwMnu* m, MfwMnuItem* i){

    FlashHostkeyData.HostProtect_Items[4]=!FlashHostkeyData.HostProtect_Items[4];
    //flash_hostwrite(); 
    mnuUpdate(m);    //xsf add 2002.08.16
    return 0;
}

int  CheckPassWord(ProtectItem Items){
    if( FlashHostkeyData.HostLock_flag&&FlashHostkeyData.HostProtect_Items[Items] )
        return 1;

    else
        return 0; 
}
/*******************************************************************************

 $Function:    	HostkeyProtectOpts

 $Description:  for hostkey protect items to check if on,if it's on then be asked to input
 hostkey

 $Returns:		

 $Arguments:	items, maybe PRO_ON,PRO_SIMLOCK, PRO_DELALLPHB, PRO_RESETALL,
 PRO_MSGBOX
 $date:         //xsf created 2002.08.30 
*******************************************************************************/

void HostkeyProtectOpts (T_MFW_HND parent_window, ProtectItem Items )
{

    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = hostkey_create(idle_win);

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user;     
    TRACE_EVENT("Mmihost.c:HostkeyProtectOpts()");

    hostkey_data->protect_opt = Items;
    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK,0,hostkey_data);
    //else
    //SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_OK_END,0,hostkey_data);


    //  hostkey_create (parent_window);
}
/*******************************************************************************

 $Function:    	CheckHostkey

 $Description:  for hostkey protect items to check if on

 $Returns:		

 $Arguments:	items, maybe PRO_ON,PRO_SIMLOCK, PRO_DELALLPHB, PRO_RESETALL,
 PRO_MSGBOX
 
*******************************************************************************/
int CheckHostkey(ProtectItem Items){
    TRACE_EVENT("CheckHostkey()_XSF");
    if( FlashHostkeyData.HostLock_flag&&FlashHostkeyData.HostProtect_Items[Items] )
        //return 1;
        HostkeyProtectOpts(0,Items);    //xsf 2002.08.25
    else
        return 0;
    return 1; 
}

void CheckHostkey2(T_MFW_HND     win, ProtectItem Items){  //xsf 11.08
    int sms_type;
    pro_options_win = win;
    if( FlashHostkeyData.HostLock_flag&&FlashHostkeyData.HostProtect_Items[Items] )
        HostkeyProtectOpts(win,Items);    //xsf 2002.08.25
    else
    {
        switch( Items )
        {
        case PRO_DELALLPHB:
            bookDeleteAllNVMRecord(win);  
            break;
        case PRO_RESETALL:

            break;
        case PRO_MSGBOX:
            sms_type = 1;
            // Here we have to pass the type of sms to delete (SMS or SMS-CB)
            M_DEL_ALL_start(win, (void *)&sms_type);
            break;
        default:
            break;
        } 
    }
}
/*******************************************************************************

 $Function:    	settingHostKeyOn

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
//USHORT settingHostKeyOnOff (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
int settingHostKeyOnOff(struct MfwMnuTag * m, struct MfwMnuItemTag * i)
{
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = hostkey_create(idle_win);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user;

    TRACE_EVENT("Mmihost.c:settingHostKeyOnOff()");

    //if (FlashHostkeyData.HostLock_flag)
    SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK_ONOFF,0,hostkey_data);
    //else
    //SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ONOFF_END,0,hostkey_data);

    return 1;
}


int settingHostKeyOn(MfwMnu* m, MfwMnuItem* i)
{    
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = setting_hostkey_create(idle_win);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_hostkey * hostkey_data = (T_hostkey *)win_data->user;

    if( FlashHostkeyData.HostLock_flag )
        setting_hostkey_destroy(hostkey_data->hostkey_win);// finish main hostkey dialog
    else
        SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_SWITCHON,0,hostkey_data);
    /*FlashHostkeyData.HostLock_flag = 1;
   flash_hostwrite(); 
   mnuUpdate(m);   */ //xsf add 2002.08.22

    return 0;
}
/*******************************************************************************

 $Function:    	settingHostKeyOff

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingHostKeyOff(MfwMnu* m, MfwMnuItem* i)
{
    FlashHostkeyData.HostLock_flag = 0;
    flash_hostwrite(); 
    mnuUpdate(m);    //xsf add 2002.08.22

    return 0;
}

T_MFW_HND hostconfirm_Init (T_MFW_HND parent_window)
{
    return(hostconfirm_create (parent_window));
}
/*******************************************************************************

 $Function:    	confirm_Exit

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void hostconfirm_Exit (T_MFW_HND own_window)
{

    T_MFW_WIN   * win_data = ((T_MFW_HDR *)own_window)->data;
    T_hostconfirm * data     = (T_hostconfirm *)win_data->user;

    hostconfirm_destroy (data->confirm_win);
}

/*******************************************************************************

 $Function:    	confirm_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND hostconfirm_create (T_MFW_HND parent_window)
{
    T_hostconfirm * data = &hostconfirm;
    T_MFW_WIN   * win;

    TRACE_FUNCTION ("confirm_create()");

    data->confirm_win = win_create (parent_window, 0, 0, (T_MFW_CB)hostconfirm_win_cb);

    if( data->confirm_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog = (T_DIALOG_FUNC)hostconfirms;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->confirm_win)->data;
    win->user                = (void *) data;


    winShow(data->confirm_win);
    /*
     * return window handle
     */
    return data->confirm_win;
}

/*******************************************************************************

 $Function:    	confirm_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void hostconfirm_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN   * win;
    T_hostconfirm * data;

    TRACE_FUNCTION ("confirm_destroy()");

    if( own_window )
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_hostconfirm *)win->user;

        if( data )
        {

            /*
             * Delete WIN handler
             */
            win_delete (data->confirm_win);
            data->confirm_win = 0;
        }
    }
}
/*******************************************************************************

 $Function:    	confirm_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int hostconfirm_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    /*
     * Top Window has no output
     */
    return 1;
}


/*******************************************************************************

 $Function:    	confirm_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void hostconfirm_dialog(void)
{
    T_DISPLAY_DATA display_info;

    TRACE_FUNCTION ("confirm_dialog()");

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT | KEY_LEFT;
    display_info.RightSoftKey = '\0';
    display_info.Time       = TWO_SECS;  //xsf 2002.09.04 THREE_SECS;


    if( hostconfirm.local_status EQ ACTIVATE_CONFIRM )
    {
        display_info.TextId2   = TxtHostKeyNotOn;
        display_info.iconindex  =REMIND_NORECORD;
    }
    // else if (hostconfirm.local_status EQ DEACTIVATE_CONFIRM)
    //{
    //  display_info.TextId    = TxtDeActivated;
    //}
    else if( hostconfirm.local_status EQ PRO_RESETALL )
    {
        display_info.TextId2      = TxtFactoryReset;  //TxtPressOk;
        display_info.TextId     = TxtPressOk;
        display_info.Time        = TEN_SECS;
        display_info.LeftSoftKey  = TxtSoftOK;
        display_info.RightSoftKey  = TxtSoftBack;
        display_info.iconindex  =REMIND_REQUIRE;
    }
    else if( hostconfirm.local_status EQ PRO_DELALLPHB )
    {
        display_info.TextId      = TxtPressOk;
        display_info.TextId2     = TxtClearAll;
        display_info.Time       = TEN_SECS;
        display_info.LeftSoftKey  = TxtSoftOK;
        display_info.RightSoftKey = TxtSoftBack;
    }
    else if( hostconfirm.local_status EQ PRO_DELALLPHBSUCC )
    {
        display_info.TextId2      = TxtDelSucceed;
        display_info.Time       = TWO_SECS;
        display_info.RightSoftKey = TxtSoftBack;
    }
    else if( hostconfirm.local_status EQ PRO_CONFIRM )  //xsf add 2003.03.06
    {
        display_info.TextId2      = TxtSave;
        display_info.iconindex  =REMIND_SUCCEED;
    }
    else if( hostconfirm.local_status EQ PRO_NOTICE )  //xsf add for noticing user to select pro_options with kcd_ok 2003.04.16
    {
        display_info.TextId2      = TxtHostkeySelect;
        display_info.iconindex  =REMIND_NORECORD;
    }
    display_info.Callback     = (T_VOID_FUNC)hostconfirm_dialog_cb;
    /*
     * Call Info Screen
     */
    info_dialog (hostconfirm.confirm_win, &display_info);

}
/*******************************************************************************

 $Function:    	confirm_dialog_cb

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void hostconfirm_dialog_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    char            getpath[20],filepath[6]="/bmi/";	/* 2004/06/14 sunsj modify */
    char            temp[50];
    int              i;

    TRACE_FUNCTION ("confirm_dialog_cb()");

    switch( reason )
    {
    case INFO_KCD_LEFT: 
        //begin of xsf add 2002.08.30 
        if( hostconfirm.local_status EQ PRO_RESETALL )
        {
            setUserSettingsDefault();   //zy change use self function 04/08/02
            hostconfirm_Exit(win);
        }
        else if( hostconfirm.local_status EQ PRO_DELALLPHB )
        {
            for( i=0;i<PHB_PBTable;i++ )
            {
                memset(getpath,0,sizeof(getpath));
                memcpy(getpath,filepath,sizeof(filepath));                          
                strcat(getpath,PBTable[i]);
                //sprintf(temp,"CheckValue:%d",flash_CheckStat(filepath));
                //TRACE_EVENT(temp);                          
                ConfigPhbkReset();
                flash_PBwrite(PBTable[i]);                       
            }

            for( i=0;i<ALL_NVM_LIST;i++ )
                l_phb_index[i].flag=SetDelFlag(i);                                                                                        
            NVMTotal=0;
            PHBKTotal=SIMTotal+NVMTotal;

            Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
            hostconfirm.local_status = PRO_DELALLPHBSUCC;
            SEND_EVENT (hostconfirm.confirm_win, PRO_DELALLPHB, 0, 0);
        }
        else
            hostconfirm_Exit(win);

        break;    
        //end of xsf add 2002.08.30 
    case INFO_TIMEOUT:
    case INFO_KCD_HUP:
        /* no break; */
    case INFO_KCD_RIGHT:
        /* no break; */
    case INFO_KCD_CLEAR:
        hostconfirm_Exit(win);
        break;
    }
}

/*******************************************************************************

 $Function:    	confirm

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void hostconfirms (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN    * win_data = ((T_MFW_HDR *) win)->data;
    T_hostconfirm      * data     = (T_hostconfirm *)win_data->user;

    TRACE_FUNCTION("confirm()");

    switch( event )
    {
    case SHOW_CONFIRM:
    case PRO_CONFIRM:
    case PRO_DELALLPHB:
    case PRO_NOTICE:   //xsf add for noticing user to select pro_options with kcd_ok 2003.04.16
        hostconfirm_dialog();
        break;
    default:
        break;
    }

}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : SIM                |
| STATE   : code                        ROUTINE : checkImsi_cb       |
+--------------------------------------------------------------------+

  PURPOSE : local exit function
            Call back function for JudgeSim

*/

void CheckImsi_cb(SHORT table_id){
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win;
    T_MFW_WIN * win_data;
    T_hostkey * hostkey_data;

    int z;
    switch( simShrdPrm.atb[table_id].reqDataFld )
    {
    case 0x6f07:  // Service provide name 
        for( z=0;z<=7;z++ )
        {
            if( FlashHostkeyData.imsi[z]!=simShrdPrm.imsi.field[z] )
            {
                win=hostkey_create(idle_win);   
                //begin of xsf add 2003.04.10
                win_data = ((T_MFW_HDR *)win)->data;
                hostkey_data = (T_hostkey *)win_data->user;
                hostkey_data->protect_opt = PRO_SIMLOCK;
                SEND_EVENT(hostkey_data->hostkey_win,HOSTKEY_ASK,0,hostkey_data);
                //end of xsf add 2003.04.10
                break;
            }
        }
        if( z==8 )
        {
            showwelcome(idle_get_window());  //xsf add 2002.09.12
            //Pin1OKOrNoPin1();  //xsf add 2002.10.09
            //network_start_full_service ();
            SimLock1=1;
        }
        break;
    default:
        break;
    }//switch

}//CheckImsi_cb

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : BMI_SIM            |
| STATE   : code                        ROUTINE : JUDGE SIM RIGHT    |
+--------------------------------------------------------------------+

  PURPOSE : Get imsi from sim after it just power on

  */
void JudgeSim(void){

    SHORT table_id;
    table_id = psaSIM_atbNewEntry();

    if( table_id NEQ NO_ENTRY )
    {
        TRACE_EVENT("Filling up table");
        simShrdPrm.atb[table_id].ntryUsdFlg = TRUE;
        simShrdPrm.atb[table_id].accType    = ACT_RD_DAT;
        simShrdPrm.atb[table_id].reqDataFld = 0x6f07;
        simShrdPrm.atb[table_id].dataOff    = 0;
        simShrdPrm.atb[table_id].dataLen    = 1;
        simShrdPrm.atb[table_id].exchData   = l_data;
        simShrdPrm.atb[table_id].rplyCB     = CheckImsi_cb;//Call back function when it get the imsi from sim

        simShrdPrm.aId = table_id;

        //glowing,2005-05-25, add _M188_ for compatible with M288B( rita project)	    
#ifdef _M188_
        if( psaSIM(SIM_CMD_ACC_SIM) < 0 )
        {
            TRACE_EVENT("FATAL ERROR");            
        }
#else
        if( psaSIM_AccessSIMData( ) < 0 )
        {
            TRACE_EVENT("FATAL ERROR");
        }
#endif

    }//if noentry
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : SIM           |
| STATE   : code                        ROUTINE : Exit               |
+--------------------------------------------------------------------+

  PURPOSE : local exit function
            Call back function for ReadSimImsi

*/

void IMSIRead_cb(SHORT table_id) 
{  
    TRACE_EVENT ("Mmihost.c:IMSIRead_cb()");  
    simShrdPrm.atb[table_id].ntryUsdFlg = FALSE;

    switch( simShrdPrm.atb[table_id].reqDataFld )
    {
    case 0x6f07:                // IMSI
        memcpy(FlashHostkeyData.imsi,simShrdPrm.imsi.field,8);//Store the imsi
        FlashHostkeyData.SimLockFlag=1;
        SimLock1=1;
        flash_hostwrite(); 
        break;
    default:
        break;
    }
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : SIM                |
| STATE   : code                        ROUTINE : ReadSimIMSI        |
+--------------------------------------------------------------------+

  PURPOSE : local exit function
            For EnableLockSim

*/
void ReadSimIMSI(void) {
    SHORT table_id;

    TRACE_EVENT("Mmihost.c:ReadSimIMSI()");

    table_id = psaSIM_atbNewEntry();

    if( table_id NEQ NO_ENTRY )
    {
        TRACE_EVENT("Filling up table");
        simShrdPrm.atb[table_id].ntryUsdFlg = TRUE;
        simShrdPrm.atb[table_id].accType    = ACT_RD_DAT;
        simShrdPrm.atb[table_id].reqDataFld = 0x6f07;//IMSI
        simShrdPrm.atb[table_id].dataOff    = 0;
        simShrdPrm.atb[table_id].dataLen    = 1;
        simShrdPrm.atb[table_id].exchData   = l_data;
        simShrdPrm.atb[table_id].rplyCB     = IMSIRead_cb;//Call back function when it get the imsi from sim

        simShrdPrm.aId = table_id;

        //glowing,2005-05-25, add _M188_ for compatible with M288B( rita project)	    
#ifdef _M188_
        if( psaSIM(SIM_CMD_ACC_SIM) < 0 )
        {
            TRACE_EVENT("FATAL ERROR");            
        }
#else
        if( psaSIM_AccessSIMData( ) < 0 )
        {
            TRACE_EVENT("FATAL ERROR");
        }
#endif
    }
}


/******************************************************/
/*                                                    */
/*Function Name: HostkeyOptions_check                       */
/*Purpose:      HostkeyOptions items check                      */
/*Prarmeter:   struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi */
/*return   :     USHORT                                 */
/*                                                    */
/*Author   :     xsf                               */
/*Date     :    Aug.16th,2002                             */
/******************************************************/
USHORT HostkeyOptions_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{

    if( ((int)mi->str==TxtHostSwitchOn) && ( FlashHostkeyData.HostProtect_Items[0]) )
        return FLAGFUNC_TRUE_ICON;
    else if( ((int)mi->str==TxtHostKeySet) && (FlashHostkeyData.HostLock_flag ) )
        return FLAGFUNC_TRUE_ICON;
    //xsf add 2002.08.22
    //if((strcmp(mi->str,(char *)TxtHostKeySet)==0) && (FlashHostkeyData.HostLock_flag ))
    // return FLAGFUNC_TRUE_ICON; 
    else if( ((int)mi->str==TxtOn) && (FlashHostkeyData.HostLock_flag ) )
        return FLAGFUNC_TRUE_ICON;
    else if( ((int)mi->str==TxtOff) && (FlashHostkeyData.HostLock_flag == 0) )
        return FLAGFUNC_TRUE_ICON;

    else if( ((int)mi->str == TxtHostSimLock) && (FlashHostkeyData.HostProtect_Items[1]) )
        return FLAGFUNC_TRUE_ICON;

    else if( ((int)mi->str == TxtHostDelPbkall) && (FlashHostkeyData.HostProtect_Items[2]) )
        return FLAGFUNC_TRUE_ICON;

    else if( ((int)mi->str == TxtHostReset) && (FlashHostkeyData.HostProtect_Items[3]) )
        return FLAGFUNC_TRUE_ICON;

    else if( ((int)mi->str == TxtHostMsgbox) && (FlashHostkeyData.HostProtect_Items[4]) )
        return FLAGFUNC_TRUE_ICON;
    else
        return FLAGFUNC_FALSE_ICON;


}

/*******************************************************************************

 $Function:	hostkeyASKIsFocussed
 $Description:	check hostkey windows focussed
 $Returns:		Status int
 $Arguments:	none
*******************************************************************************/

int hostkeyASKIsFocussed(void)
{
    int status;

    if( winIsFocussed(hostkey_edit_windows) )
        status = FOCUSSED_PINS;
    else
        status = NOT_FOCUSSED_PINS;

    return status;
}

/*******************************************************************************

 $Function:	hostkey_exit 

 $Description:	power down in hostkey screen
 $Returns:		None

 $Arguments:	None
 
*******************************************************************************/
void hostkey_exit (void)
{
    if( hostkey_mess_windows )
        hostkey_mess_destroy(hostkey_mess_windows);
    if( hostkey_edit_windows )
        set_hostkey_edt_destroy(hostkey_edit_windows);
    if( hostkey_windows )
    {
        TRACE_EVENT("xsf:hostkey_destroy");
        hostkey_destroy (hostkey_windows);

    }
}

/*******************************************************************************

 $Function:     HostkeyProtectOpts_confirm

 $Description:   confirm and save the selection of hostkey protect options 

 $Returns:

 $Arguments:   //xsf add 2003.03.06

*******************************************************************************/
void HostkeyProtectOpts_confirm(void)
{       
    T_MFW_HND idle_win = idle_get_window();

    TRACE_EVENT("Mmihost.c:HostkeyProtectOpts_confirm()"); 
    hostconfirm_Init(idle_win);  
    hostconfirm.local_status = PRO_CONFIRM;
    SEND_EVENT (hostconfirm.confirm_win, PRO_CONFIRM, 0, 0);

}
/*******************************************************************************

 $Function:     HostkeyProtectOpts_notice

 $Description:  notice user to select hostkey protect options with KCD_OK 

 $Returns:

 $Arguments:    xsf add 2003.04.16

*******************************************************************************/
void HostkeyProtectOpts_notice(void)
{       
    T_MFW_HND idle_win = idle_get_window();

    TRACE_EVENT("Mmihost.c:HostkeyProtectOpts_notice()"); 
    hostconfirm_Init(idle_win);  
    hostconfirm.local_status = PRO_NOTICE;
    SEND_EVENT (hostconfirm.confirm_win, PRO_NOTICE, 0, 0);

}


