




#ifndef _DEF_BMI_CHINESEAPI_H_
#define _DEF_BMI_CHINESEAPI_H_


/*
 * clrobert comment. 
 * This struct is used to implement chinese input method.
 */
typedef struct 
{    
	char             ConditionStr[10];
	unsigned short   ConditionHz[10];
	unsigned short   PromptBuf[40];
	int              InTheTime;
	int              SatisfyNum;
	int              MAX_Satisfy;
	int              PageNum;
	int              Index;
	int              CurCode;
	char             OtherMightChar[4];
	char             ProgramCode[9];
}chinese_Data,*pchinese_Data;


unsigned int wordstrlen(const unsigned short *ws);
unsigned short *wordstrcat(unsigned short *ws1, const unsigned short *ws2);

int OtherCharIsOnlyOne(chinese_Data *pChineseData);


void SetTheConditionStr(chinese_Data * pChineseData,int keyCode);

void SetThePromptBuf(chinese_Data *pChineseData);                                  

#endif

