/******************************************************************************

 $Project name:	Basic MMI                                                      
 $File:		    tdouterIdle.h
 $Author:		talcon  hu                                                        
 $Date:		    2003-12-12                                                      
 $Description:ʵinclude file
                
 $History: 

*******************************************************************************/
#ifndef _TDOUTERIDLE_H_
#define _TDOUTERIDLE_H_

#define  OUTERSCREEN_SIZE_X		96

//define event
#define OUTERIDLEEVENT_NONE			0x00
#define OUTERIDLEEVENT_TIME			0x01
#define OUTERIDLEEVENT_SIGNAL		0x02//globalMme
#define OUTERIDLEEVENT_BATTERY		0x04//globalMme
#define OUTERIDLEEVENT_OFFBATTERY   0x08 
#define OUTERIDLEEVENT_REFRESH		0x10//2004/03/11 Sunny add
	
//define state
#if 0
	#define OUTERIDLESTATE_NONE		0x00
	#define OUTERIDLESTATE_NORMAL	0x01
	#define OUTERIDLESTATE_LCDOFF	0x02
	#define OUTERIDLESTATE_SMS		0x04
	#define OUTERIDLESTATE_CALL		0x08
	#define OUTERIDLESTATE_MISSCALL	0x10
	#define OUTERIDLESTATE_CHARGE	0x20
	#define OUTERIDLESTATE_ALERT	 0x40
	#define OUTERIDLESTATE_MISSALERT 0x80
	#define OUTERIDLESTATE_INCOMING  0x100   //2004-03-21 Sunny add
	#define OUTERIDLESTATE_LOWVOLTAGE 0x200  //2004-04-01 Sunny add	
	#define OUTERIDLESTATE_LOWVOLTAGESWITCHOFF 0x400//2004-04-01 Sunny add
	#define OUTERIDLESTATE_REFRESH	  0X800  //2004-04-05 Sunny add
	#define OUTERIDLESTATE_LCDON	0x10000  //highest priority
#else
	#define OUTERIDLESTATE_NONE					0x00
	#define OUTERIDLESTATE_NORMAL				0x01
	#define OUTERIDLESTATE_LCDOFF				0x02
	#define OUTERIDLESTATE_LCDON				0x04	
	#define OUTERIDLESTATE_CALL					0x08
	#define OUTERIDLESTATE_MISSCALL				0x10
	#define OUTERIDLESTATE_CHARGE				0x20	
	#define OUTERIDLESTATE_MISSALERT			0x80	
	#define OUTERIDLESTATE_REFRESH				0X100 
	#define OUTERIDLESTATE_LOWVOLTAGE			0x200  
	#define OUTERIDLESTATE_LOWVOLTAGESWITCHOFF	0x400
	#define OUTERIDLESTATE_ALERT				0x800
	#define OUTERIDLESTATE_SMS					0x1000
	#define OUTERIDLESTATE_INCOMING				0x2000
#endif

//define charge state
#define OUTERIDLECHARGE_NONE	0x00
#define OUTERIDLECHARGE_NORMAL  0x01
#define OUTERIDLECHARGE_OFF		0x02

typedef struct 
{
	MfwHnd outeridletimer;//animationtimer
	//MfwHnd chargetimer;//timer 2004-03-20 Sunny remove
	MfwHnd refreshtimer;//outer screen refresh timer.
	int    nAnimTimes;//animationĴ,if <0,is forever
	U32    nIdleState;//״̬,OUTERIDLESTATE_XXX
	U32	   nIdleCurState;//ǰ״̬,OUTERIDLESTATE_XXX
	//
	MfwIcnAttr* curIcnAttr;//animationicon
	MfwIcnAttr* curIcnAttr_mask;
	U8 nIdxAnim;//animationindex
	U8 nTotalAnim;
	U8  nChargeState;//OUTERIDLECHARGE_XXX
	U8  nChargeCurIcn;
	U8  nChargeOffset;
	U8  nOldChargePicNum;
	//U8  n
}T_outerIdle;

//#define OUTERIDLE_FOR_FTA
#ifdef OUTERIDLE_FOR_FTA
#define outerIdleInit()
#define outerIdleExit()
#define setOuterState(a,b)
#define outeridleExec(a,b)
#define setChargeState(a,b)
#else
void outerIdleInit();
void outerIdleExit();
void setOuterState(U32 flags,UBYTE mask,char *par);
void outeridleExec (int reason,void* para);
void setChargeState(U8 flags,void *para);
#endif
#endif