/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Settings
 $File:		    MmiSettings.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    
********************************************************************************
 $History: MmiSetting.c

 data:  22/07/02  

 Description:zy Mobile Innovation make the Active and Deactive confirm window has icons
       
 $End

*******************************************************************************/
/********************************************************************************
 $History: MmiSetting.c
 data                  Description
 01/08/02             zy Mobile Innovation make the language choice funtion
 04/08/02	          zy Mobile Innovation change the total structure 
 28/08/02      wufei modified


 $End

*******************************************************************************/

/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"

#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_cm.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_cphs.h"
#include "mfw_sat.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiSounds.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiSettings.h"
#include "MmiVoiceMemo.h"
#include "mfw_ffs.h"
#include "MmiTimers.h"
#include "Mmieditor.h"
#include "mmiusersymbolinput.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mmihost.h"   //xsf add 2002.08.30 for hostkey protect options
#include "mmitextinput.h"		/* 2003/12/04 sunsj */
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */

#define CLEAR_BOTTOM_ZONE dspl_Clear( KEY_AREA );
T_MFW_SMS_INFO SmsConfigData;
//extern UINT8    Gu8_Envio_num;//enter which enviroment flag  /*2004/5/14, wangyan remove*/
extern MfwHnd ledblink;//zy 2003-02-12

static int winEvent (MfwEvt e, MfwWin *w);

void confirm (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
void confirm_dialog_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void confirm_dialog(void);
static int confirm_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
void confirm_destroy (T_MFW_HND own_window);
T_MFW_HND confirm_create (T_MFW_HND parent_window);
void confirm_Exit (T_MFW_HND own_window);
T_MFW_HND confirm_Init (T_MFW_HND parent_window);
void setUserSettings2Default (void);
/*................zy add functions 04/08/02......................................................*/
static void NameAddNameCB( T_MFW_HND win, USHORT Identifier, SHORT reason );
static int NameInputKbdLongCB( MfwEvt e, MfwKbd *k );
static int NameInputKbdCB( MfwEvt e, MfwKbd *k );
static int NameInputWindowCB( MfwEvt e, MfwWin *w );
static void NameInputDestroy( MfwHnd window );
static void NameInputDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter );
static T_MFW_HND NameInputCreate( MfwHnd parent );
/*.....................end of zy change.................................................................*/

static void (*show) (void);

static MfwHnd win;                      /* our window               */
static MmiState nextState;              /* next state when finished */
static DisplayData DisplayInfo;
static int curIntensity;//zy add 04/08/02 backlight intensity
static U32 curKey;//zy add 04/08/02
static int BG;//zy add 04/08/02


#define SHOW_CONFIRM           3
#define ACTIVATE_CONFIRM       4
#define DEACTIVATE_CONFIRM     5
#define FACTORY_RESET          6
#define MAX_INTENSITY 6//zy add 04/08/02 max backlight intensity
#define MAX_SPLIT_FILE_NUM   8    //chenjun ,max split files num of user defined picture,2002-12-29 

//#ifdef FIELD_TEST_MODE_ENABLED 
#if 0
extern unsigned char gucEarPhoneSupport;
#endif

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        confirm_win;        /* MFW win handler      */
    UBYTE            local_status;
} T_confirm;
/*............zy add 08/04/02 for backlight listmenu.....................*/
typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        background_win;                 /* MFW win handler      */
    T_MFW_HND        parent;
    T_MFW_HND        Background_handler;         /* MFW sms handler      */
    unsigned char      local_status;
    ListMenuData     * menu_list_data;
} T_BACKGROUND_INFO;
/*2003/12/15,talcon add*/
typedef struct 
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        win;
    T_MFW_HND           kbd;
    MfwHnd           AnimTimer; 
    UBYTE            idxbkganim;
    UBYTE            nBKGSel;   
}T_BKGSel;
T_confirm confirm_data;
/*2003/12/15,talcon add*/
T_BKGSel  BKGSel_data;
T_BKGSel  OuterBKGSel_data; /* 2004/04/10 sunsj add */

static MfwMnuAttr background_menuAttrib =
{
    0,
    &melody_menuArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};
/*................end of zy change......................................*/
/*
 * Settings menu subs:
 */




#define ON  	0
#define OFF		1
#define CLEAR	2

typedef struct 
{
    UBYTE setting;
    UBYTE status;
} T_settings;
/*....................zy add for edit greetingword.04/08/02.................*/
typedef struct 
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       kbd;
    T_MFW_HND       edt;
    T_MFW_HND       parent_win;
    T_VOID_FUNC     Callback;
    char             edt_buf_name[PHB_MAX_LEN];
    MfwEdtAttr      attr;
    T_EDITOR_DATA  properties;
} T_editBGname;

typedef enum
{
    NAMEINPUT_INIT,
    NAMEINPUT_LEFT,
    NAMEINPUT_RIGHT,
    NAMEINPUT_CLEAR,
    NAMEINPUT_DESTROY
} tNameMessageEvents;
typedef enum
{
    BACKLIGHT_REASON=0,
    CONTRAST_REASON
} IntensityReasons;
/*......................end of zy change....................................*/
typedef enum 
{
    ENGLISH = 0,
    GERMAN,
    AUTOREDIAL,
    AUTOANSWER,
    ANYKEYANSWER,
    CALLTIMERS,
    KEYPAD_CLICK,
    KEYPAD_DTMF,
    KEYPAD_SILENT,
    VOICE_MEMO,
    // later melody & volume as well
    // voicememo buffer + record_position
    MAX
}T_FACTORY_RESET_LIST;
/*..........zy cahnge for rename greetingword04/08/02....................*/
typedef enum
{
    RENAMEGREETINGWORD=0,
}T_RENAMEENTRY;

T_RENAMEENTRY RenameEntry;
/*.......................end of zy change...........................*/
//DEFAULT-SETTING-TABLE 
//IF YOU WANT TO MODIFY THE "DEFAULT_SETTINGS"-TABLE
//JUST CHANGE ONLY THE STATUS (ON, OFF, CLEAR)

T_settings DEFAULT_SETTINGS[] = 
{ 
    {ENGLISH,       ON},        //select the Language:English as a default
    {GERMAN,        OFF},   
    {AUTOREDIAL,    OFF},       
    {AUTOANSWER,    OFF},       
    {ANYKEYANSWER,  OFF},       
    {CALLTIMERS,    CLEAR},     
    {KEYPAD_CLICK,  ON},        //only one of the Keypads are eligible
    {KEYPAD_DTMF,   OFF},       
    {KEYPAD_SILENT, OFF},       
    {VOICE_MEMO,    CLEAR},     
    {MAX,           0xFF}     
};

typedef enum
{
    E_INIT = 0x0801,
    E_BACK,
    E_ABORT,
    E_EXIT,
    E_RETURN,
    E_OK
} e_M_events;
typedef struct
{
    /* administrative data */

    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         win;
    T_MFW_HND         parent_win;
    T_MFW_HND           kbd;
    IntensityReasons    reason;
    int                 intensity;
} t_Intnsity;
typedef struct 
{
    UINT8 splitNum;    //ļ
    UINT8 splitW;   //ֿ,just one, all the split file has the same width
    UINT8 splitH[2];   //ָ߶,each split file may has it's own height
    char splitName[MAX_SPLIT_FILE_NUM][25];     //ļ
}TSplitPicInfo;//ADDED by chenjun 2002-12-28
static int curVolume;                   /* current volume           */
//chenjun add the following lines for user defined pixture 2002-12-29

#define SPLIT_SIZE  3840    //7680   //120*32=120*128*2/8=120*160*2/5


unsigned char UserBmpBuffer[SPLIT_SIZE+1];  //chenjun 2003-01-23 changed from malloc to static 
const char picIndex[]="/bmi/pic1index"; /* 2004/06/14 sunsj modify */
TSplitPicInfo SplitInfo;
/*******************************************************************************

 $Function:    	SmsValidityPeriod

 $Description:	Store the validity period information, selected by the user.
            
 
 $Returns:		Execution status
 
 $Arguments:	m - menu handler
                i - Menu item selected
 
*******************************************************************************/
int SmsValidityPeriod(MfwMnu* m, MfwMnuItem* i)
{
    int index;
    T_DISPLAY_DATA DisplayInfo;

    T_MFW_HND win  = mfwParent(mfw_header());

    TRACE_EVENT(">>>> SmsValidityPeriod()");

    index= m->lCursor[m->level];
    // Use Index to store the selected validity period in NVM.

    // Display confirmation screen.
    dialog_info_init(&DisplayInfo);//gdy add
    DisplayInfo.TextId= TxtSmsValidityPeriodSet;
    DisplayInfo.Time =ONE_SECS;
    DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_CLEAR;
    DisplayInfo.TextId2      = 0;
    DisplayInfo.TextString    = '\0';
    DisplayInfo.TextString2   = '\0';
    DisplayInfo.LeftSoftKey   = TxtNull;
    DisplayInfo.RightSoftKey = TxtCancel;
    DisplayInfo.Callback     = NULL;

    info_dialog(win,&DisplayInfo);

    return 1;
}

/******************************************************/
/*                                                    */
/*Function Name: CBLanguage_check                       */
/*Purpose:      CBLanguage_check items check                      */
/*Prarmeter:   struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi */
/*return   :     USHORT                                 */
/*                                                    */
/*Author   :     windy                              */
/*Date     :    Aug.16th,2002                             */
/******************************************************/
USHORT SRRONOFF_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    if( FFS_flashData.SRRONOFF==1 )
        return FLAGFUNC_TRUE_ICON;
    else if( FFS_flashData.SRRONOFF==0 )
        return FLAGFUNC_FALSE_ICON;
#if 0
    T_MFW_SMS_INFO  sms_parameter;
    SmsSend_get_config_data(&sms_parameter);
    switch( sms_parameter.srr )
    {
    case SMS_NOT_REQUESTED_SRR:
        return FLAGFUNC_FALSE_ICON;

    case SMS_REQUESTED_SRR:
        return FLAGFUNC_TRUE_ICON;

    }
#endif
}
/* Marcus: Issue 1170: 30/09/2002: Start */
/*******************************************************************************

 $Function:    	SmsStatusReportRequest

 $Description:	Activate/Deactivate SRR, selected by the user.
            
 $Returns:		Execution status
 
 $Arguments:	m - menu handler
                i - Menu item selected
 
*******************************************************************************/
int SmsStatusReportRequest(MfwMnu* m, MfwMnuItem* i)
{
    int index = m->lCursor[m->level];
    T_DISPLAY_DATA DisplayInfo;
    T_MFW_SMS_INFO sms_info;
    T_MFW_HND win  = mfwParent(mfw_header());

    TRACE_FUNCTION(">>>> SmsStatusReportRequest()");

    dialog_info_init(&DisplayInfo);//gdy add
    if( sms_parameter(&sms_info, TRUE) == MFW_SMS_OK )
    {
        if( FFS_flashData.SRRONOFF==1 )
        {
            sms_info.srr = SMS_NOT_REQUESTED_SRR;
            sms_parameter(&sms_info, FALSE);
            //		call infoscreen("Deactivated"); 
            DisplayInfo.RightSoftKey = 0;
            DisplayInfo.Time         = ONE_SECS;//zy 12/22/2002 change 3sec to 1sec
            DisplayInfo.KeyEvents    = KEY_CLEAR|KEY_RIGHT|KEY_LEFT;
            DisplayInfo.TextId2      = TxtDeActivated;
            DisplayInfo.Identifier   = DIALOGS_REASON_NULL;
            DisplayInfo.iconindex   =REMIND_COMPLETE;
            info_dialog (win, &DisplayInfo); 
            //info_screen(win, TxtDeActivated,TxtNull, NULL);//(T_VOID_FUNC)SmsCB_dialog_cb); 
            //statusCBCH(TRUE);
            FFS_flashData.SRRONOFF=0;
            flash_write();
        }
        else if( FFS_flashData.SRRONOFF==0 )
        {
            sms_info.srr = SMS_REQUESTED_SRR;
            sms_parameter(&sms_info, FALSE);
            //call infoscreen("Activated"); 
            DisplayInfo.RightSoftKey = 0;
            DisplayInfo.Time         = ONE_SECS;//zy 12/22/2002 change 3sec to 1sec
            DisplayInfo.KeyEvents    =  KEY_CLEAR|KEY_RIGHT|KEY_LEFT;
            DisplayInfo.TextId2      = TxtActivated;
            DisplayInfo.Identifier   = DIALOGS_REASON_NULL;
            DisplayInfo.iconindex   =REMIND_COMPLETE;
            info_dialog (win, &DisplayInfo); 
            //info_screen(win, TxtActivated,TxtNull,NULL);//(T_VOID_FUNC)SmsCB_dialog_cb); 
            //statusCBCH(FALSE);
            FFS_flashData.SRRONOFF=1;
            flash_write();
        }

    }
#if 0 
    if( sms_parameter(&sms_info, TRUE) == MFW_SMS_OK )
    {
        if( index == 0 )
        {
            sms_info.srr = SMS_NOT_REQUESTED_SRR;
            FFS_flashData.SRRONOFF=0;
        }
        else
        {
            sms_info.srr = SMS_REQUESTED_SRR;
            FFS_flashData.SRRONOFF=1;
        }
        if( sms_parameter(&sms_info, FALSE) == MFW_SMS_OK )
        {
            // Display confirmation screen.
            DisplayInfo.TextId=     TxtSRR;
            DisplayInfo.Time =      THREE_SECS;
            DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_CLEAR;

            if( index == 0 )
                DisplayInfo.TextId2      = TxtOff;
            else
                DisplayInfo.TextId2      = TxtOn;

            DisplayInfo.TextString    = '\0';
            DisplayInfo.TextString2   = '\0';
            DisplayInfo.LeftSoftKey   = TxtNull;
            DisplayInfo.RightSoftKey = TxtCancel;
            DisplayInfo.Callback     = NULL;
            DisplayInfo.iconindex   =REMIND_COMPLETE;
            info_dialog(win,&DisplayInfo);
        }
        flash_write();
    }
#endif
    return 1;
}
/* Marcus: Issue 1170: 30/09/2002: End */


//-----------------------------WUFEI Add----------------------------------------------
int settingsVoiceCall(MfwMnu* m, MfwMnuItem* i) 
{
    T_MFW_HND win = mfw_parent(mfw_header());

    confirm_Init(win);

    //cm_set_redial(CM_REDIAL_AUTO);

    FlashDCTbData.nextcall=voice_call_CallSet;
    flash_DCTbwrite();//wufei add 0827
    sAT_PlusCCWA(CMD_SRC_LCL,CCWA_MOD_Enable,CLASS_Vce);//0916 wufei
    sAT_PlusCCWA(CMD_SRC_LCL,CCWA_MOD_Disable,CLASS_Dat);//0916 wufei
    sAT_PlusCCWA(CMD_SRC_LCL,CCWA_MOD_Disable,CLASS_Fax);//0916 wufei
    confirm_data.local_status = ACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 1;
}

int settingsDataCall(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    confirm_Init(win);

    //cm_set_redial(CM_REDIAL_AUTO);
    FlashDCTbData.nextcall=data_call_CallSet;
    flash_DCTbwrite();//wufei add 0827
    sAT_PlusCCWA(CMD_SRC_LCL,CCWA_MOD_Disable,CLASS_Vce);//0916 wufei
    sAT_PlusCCWA(CMD_SRC_LCL,CCWA_MOD_Enable,CLASS_Dat);//0916 wufei
    sAT_PlusCCWA(CMD_SRC_LCL,CCWA_MOD_Disable,CLASS_Fax);//0916 wufei

    confirm_data.local_status = ACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 1;
}

int settingsFaxCall(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    confirm_Init(win);

    //cm_set_redial(CM_REDIAL_AUTO);

    FlashDCTbData.nextcall=fax_call_CallSet;
    flash_DCTbwrite();//wufei add 0827
    sAT_PlusCCWA(CMD_SRC_LCL,CCWA_MOD_Disable,CLASS_Vce);//0916 wufei
    sAT_PlusCCWA(CMD_SRC_LCL,CCWA_MOD_Disable,CLASS_Dat);//0916 wufei
    sAT_PlusCCWA(CMD_SRC_LCL,CCWA_MOD_Enable,CLASS_Fax);//0916 wufei
    confirm_data.local_status = ACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 1;
}

USHORT nextcall_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi) //wufei add 0827
{




    if( ((FlashDCTbData.nextcall==0)&&(((int)mi->str)==TxtVoice))||
        ((FlashDCTbData.nextcall==1)&&(((int)mi->str)==TxtData))||
        ((FlashDCTbData.nextcall==2)&&(((int)mi->str)==TxtFax)) )

        return FLAGFUNC_TRUE_ICON;

    else

        return FLAGFUNC_FALSE_ICON;


}


//-----------------------------end of wufei Add----------------------------------


/*******************************************************************************

 $Function:    	settingsVoiceMail

 $Description:	menu entry function

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsVoiceMail(MfwMnu* m, MfwMnuItem* i)

{

    cphs_get_mailbox ();


    return 0;
}

/*******************************************************************************

 $Function:    	settingsVoiceMail

 $Description:	menu entry function

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsScNumber(MfwMnu* m, MfwMnuItem* i)
{
    //  T_MFW Status;

    //  TRACE_FUNCTION ("settingScNumber()");


    //JVJE    Status = (T_MFW)settingsSetUpScEdit();

    return 0;
}
/*******************************************************************************

 $Function:    	settingsInit

 $Description:	init settings handling

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void settingsInit (void)
{

    TRACE_FUNCTION ("settingsInit()");

    nextState = 0;

    win = winCreate(0,0,MfwWinVisible,(MfwCb)winEvent);
    winShow(win);
}

/*******************************************************************************

 $Function:    	settingsExit

 $Description:	exit settings handling

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void settingsExit (void)
{
    TRACE_FUNCTION ("settingsExit()");

    nextState = 0;
    winDelete(win); win = 0;
}


/*******************************************************************************

 $Function:    	winEvent

 $Description:	window event handler

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int winEvent (MfwEvt e, MfwWin *w)
{
    TRACE_FUNCTION ("MmiSettings :: winEvent()");

    switch( e )
    {
    case MfwWinVisible:
        if( w->flags & MfwWinVisible )
            show();
        break;
    default:
        return 0;
    }

    return 1;
}
/*******************************************************************************

 $Function:    	settingsAutoRedialOn

 $Description:	auto redial switch on

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsAutoRedialOn(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win = mfw_parent(mfw_header());

    confirm_Init(win);

    cm_set_redial(CM_REDIAL_AUTO);


    confirm_data.local_status = ACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    //flash_write() in Mfw_cm.c (FFS_flashData.redial_mode =redial_mode;) hu binhao 2002-11-28
    return 0;
}
/*******************************************************************************

 $Function:    	settingsAutoRedialOff

 $Description:	auto redial switch off

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsAutoRedialOff(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    confirm_Init(win);

    cm_set_redial(CM_REDIAL_OFF);

    confirm_data.local_status = DEACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);

    //flash_write() in Mfw_cm.c (FFS_flashData.redial_mode =redial_mode;) hu binhao 2002-11-28

    return 0;
}

/******************************wufei add 0827*************************************************

 $Function:    	settingsAutoRedialOff

 $Description:	auto redial switch on/off

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
USHORT autoredial_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{




    if( ((FFS_flashData.redial_mode==CM_REDIAL_AUTO)&&(((int)mi->str)==TxtOn))||
        ((FFS_flashData.redial_mode==CM_REDIAL_OFF)&&(((int)mi->str)==TxtOff)) )

        return FLAGFUNC_TRUE_ICON;

    else

        return FLAGFUNC_FALSE_ICON;


}

//---------------------------wufei add------------------------------------------

/*****************************wufei add****************************************

 $Function:    	settingsCallMinuteFlagOn

 $Description:	Call minute hints on

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsCallMinuteFlagOn(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win = mfw_parent(mfw_header());
    confirm_Init(win);
    FFS_flashData.call_minute_flag=TRUE;
    flash_write();
    confirm_data.local_status = ACTIVATE_CONFIRM;
    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);

    return 0;
}
/*******************************wufei add****************************************

 $Function:    	settingsCallMinuteFlagOff
 $Description:	call minute flag switch off

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsCallMinuteFlagOff(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    confirm_Init(win);
    FFS_flashData.call_minute_flag=FALSE;
    flash_write();
    confirm_data.local_status = DEACTIVATE_CONFIRM;
    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);

    return 0;
}

/*******************************wufei add 0827****************************************

 $Function:    	minutehint_check
 $Description:	call minute flag switch on/off

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
USHORT minutehint_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{



    if( ((FFS_flashData.call_minute_flag)&&(((int)mi->str)==TxtActivate))||
        ((!FFS_flashData.call_minute_flag)&&(((int)mi->str)==TxtDeactivate)) )

        return FLAGFUNC_TRUE_ICON;

    else

        return FLAGFUNC_FALSE_ICON;


}
/*******************************wufei add****************************************

 $Function:    	settingsMinuteFlagCheck
 $Description:	check call minute flag 

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsMinuteFlagCheck(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    confirm_Init(win);
    if( FFS_flashData.call_minute_flag )
    {
        confirm_data.local_status = ACTIVATE_CONFIRM;
    }
    else
    {
        confirm_data.local_status = DEACTIVATE_CONFIRM;
    }
    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 0;
}
//-----------------------end of wufei add---------------------------------------

/*******************************************************************************

 $Function:    	settingsSilentModeOn

 $Description:    Activate the silent Mode

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsSilentModeOn(void)
{
    TRACE_EVENT(">> settingsSilentModeOn()");
    FFS_flashData.settings_status |= SettingsSilentMode;
    flash_settingwrite();//zy change save to flashsettingdata 04/08/02
    setSilentModeVolume();
    iconsSetState(iconIdSilRin);
    //idleEvent(IdleActiveKeyPadLocked);
    return 0;
}
/*******************************************************************************

 $Function:    	settingsSilentModeOff

 $Description:	Deactivate the silent Mode

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsSilentModeOff(void)
{
    TRACE_EVENT(">> settingsSilentModeOff()");
    FFS_flashData.settings_status &= ~SettingsSilentMode;
    flash_settingwrite();//zy change save to flashsettingdata 04/08/02
    restoreSilentModeVolume();
    iconsDeleteState(iconIdSilRin);
    return 0;
}

/*******************************************************************************

 $Function:    	settingsKeyPadLockOn

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsKeyPadLockOn(void)
{
    /*FFS_flashData.settings_status |= SettingsKeyPadLockOn;
    iconsSetState(iconIdKeyplock);
    idleEvent(IdleActiveKeyPadLocked);*/
    return 0;
}
/*******************************************************************************

 $Function:    	settingsKeyPadLockOff

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsKeyPadLockOff(void)
{
    /*FFS_flashData.settings_status &= ~SettingsKeyPadLockOn;
    iconsDeleteState(iconIdKeyplock);*/

    return 0;
}
/*******************************************************************************

 $Function:    	settingsAutoAnswerOn

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsAutoAnswerOn(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    confirm_Init(win);

    // xsf 2002.07.05 FFS_flashData.settings_status |= SettingsAutoAnswerOn;
    FlashDCTbData.AutoAnswerFlag= 1;

    flash_DCTbwrite();
    confirm_data.local_status = ACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);

    return 0;
}
/*******************************************************************************

 $Function:    	settingsAutoAnswerOff

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsAutoAnswerOff(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    confirm_Init(win);

    // xsf 2002.07.05 FFS_flashData.settings_status &= ~SettingsAutoAnswerOn;
    FlashDCTbData.AutoAnswerFlag= 0;

    flash_DCTbwrite();
    confirm_data.local_status = DEACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);



    return 0;
}

/******************************wufei add 0916*************************************************

 $Function:    	settingsAutoRedialOff

 $Description:	auto redial switch on/off

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
USHORT autoanswer_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{ 

    if( ((FlashDCTbData.AutoAnswerFlag==1)&&(((int)mi->str)==TxtOn))||
        ((FlashDCTbData.AutoAnswerFlag==0)&&(((int)mi->str)==TxtOff)) )

        return FLAGFUNC_TRUE_ICON;

    else

        return FLAGFUNC_FALSE_ICON;


}

/*******************************************************************************

 $Function:    	settingsAnyKeyAnswerOn

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsAnyKeyAnswerOn(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    confirm_Init(win);

    // xsf 2002.07.05 FFS_flashData.settings_status |= SettingsAnyKeyAnswerOn;
    //   FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].Anykeyanswerflag= 1;
    FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].Anykeyanswerflag= 1;/*2004/5/14, wangyan add*/


    flash_environmentwrite();
    confirm_data.local_status = ACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 0;
}
/*******************************************************************************

 $Function:    	settingsAnyKeyAnswerOff

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingsAnyKeyAnswerOff(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win = mfw_parent(mfw_header());

    confirm_Init(win);

    // xsf 2002.07.05 FFS_flashData.settings_status &= ~SettingsAnyKeyAnswerOn;
    //   FlashEnvironmentData.EnviroProfile[Gu8_Envio_num].Anykeyanswerflag= 0;
    FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].Anykeyanswerflag= 0;/*2004/5/14, wangyan add*/

    flash_environmentwrite();
    confirm_data.local_status = DEACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);

    return 0;
}

/*2003/12/15,talocn comment*/
#if 0
/*******************************************************************************

$Function:    	settingBGOnA

$Description:	

$Returns:		

$Arguments:	

*******************************************************************************/
int settingBGOn(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    TRACE_EVENT("SEttingBGon");

    confirm_Init(win);

    //	FFS_flashData.settings_status |= SettingBGOn;
    switch( (int)i->str )
    {
    case TxtA:
        FlashSettingData.BGI=1;
        break;
    case TxtB:
        FlashSettingData.BGI=2;
        break;
    case TxtUserdefine1:
        FlashSettingData.BGI=3;
        break;
    case TxtUserdefine2:
        FlashSettingData.BGI=4;
        break;
    case TxtUserdefine3:
        FlashSettingData.BGI=5;
        break;
    case TxtUserdefine4:
        FlashSettingData.BGI=6;
        break;
    case TxtUserdefine5:
        FlashSettingData.BGI=7;
        break;
    case TxtUserDefinedPic:   //chenjun 2002-12-29 add for user defined pic, PCSync             
        if( flash_CheckStat(picIndex)<0 )
            FlashSettingData.BGI=0;
        else
            FlashSettingData.BGI=8;    //chenjun no user defined pic ,set idle back to no picture
        break; 
    default:
        break;
    }
    flash_settingwrite();
    confirm_data.local_status = ACTIVATE_CONFIRM;
    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 0;
}
#endif
/*******************************************************************************

 $Function:    	settingBGOff

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingBGOff(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win = mfw_parent(mfw_header());

    confirm_Init(win);
    FlashSettingData.BGI=0;
    flash_settingwrite();
    confirm_data.local_status = DEACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);

    return 0; 
}







/*******************************************************************************

 $Function:    	settingGreetingWordOn

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingGreetingWordOn(MfwMnu* m, MfwMnuItem* i)
{   T_MFW_HND parent  = mfwParent(mfwHeader());

    confirm_Init(win);
    FlashSettingData.GreetingWordIsOn=1;
    flash_settingwrite();
    //FFS_flashData.settings_status &= ~SettingGreetingWord;
    confirm_data.local_status = ACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);



    return 0; 
}

/*******************************************************************************

 $Function:    	settingGreetingWordOff

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingGreetingWordOff(MfwMnu* m, MfwMnuItem* i)
{  T_MFW_HND win = mfw_parent(mfw_header());

    confirm_Init(win);
    FlashSettingData.GreetingWordIsOn=0;
    flash_settingwrite();
    //FFS_flashData.settings_status &= ~SettingGreetingWord;
    confirm_data.local_status = DEACTIVATE_CONFIRM;

    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);

    return 0; 
}

/*******************************************************************************

 $Function:    	editGreetingWord

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int editGreetingWord(MfwMnu* m, MfwMnuItem* i)
{   T_MFW_HND parent  = mfwParent(mfwHeader());

    win = NameInputCreate(parent) ;
    if( win NEQ NULL )
    {
        SEND_EVENT( win, NAMEINPUT_INIT, 0, 0 );
        TRACE_EVENT("NameInputCreate ok"); 
    }


    return 0; 
}

void updateSoftkey()
{
    UINT32 oldColor;
    UINT32 oldFontColor;
    oldColor=dspl_GetBkgColor();
    dspl_SetBkgColor(GetPreDefinedColor(ColorMenuBG));
    dspl_Clear(0, 144, 120, 16);//zy
    dspl_SetBkgColor(GetPreDefinedColor(ColorSoftKeyBG));
    oldFontColor=dspl_GetFrgColor();
    dspl_SetFrgColor(GetPreDefinedColor(ColorSoftKeyFont));
    displaySoftKeys( '\0', '\0');
    displaySoftKeys( TxtSoftSelect, TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_updown_arrow();//jhxu720
#endif
    dspl_SetBkgColor(oldColor);
    dspl_SetFrgColor(oldFontColor);
}


int settingAnimation(MfwMnu * m, MfwMnuItem * i)
{ 
    T_MFW_HND win = mfw_parent(mfw_header());
    switch( (int)i->str )
    {
    case TxtCloseAnim:
        FFS_flashData.onoffanimation=0;
        break;
    case TxtMobileInnovation:
        FFS_flashData.onoffanimation=1;
        break;
    case TxtFlower:
        FFS_flashData.onoffanimation=2;
        break;
    case TxtSkyrocket:
        FFS_flashData.onoffanimation=3;
        break;

    default:
        break;
    }
    flash_write();
    confirm_Init(win);
    /* 2004/07/06 sunsj modify for comfirm word */
	if( (int)i->str == TxtCloseAnim )
	{
		confirm_data.local_status = DEACTIVATE_CONFIRM;
	}
	else
	{
		confirm_data.local_status = ACTIVATE_CONFIRM;
	}
    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 0;

}
int Hallconnect(MfwMnu * m, MfwMnuItem * i)//zy for call connect when hall action 10/22
{ 
    T_MFW_HND win = mfw_parent(mfw_header());
    switch( (int)i->str )
    {
    case TxtActivate:
        FlashSettingData.hallonconnect=1;
        break;
    case TxtDeactivate:
        FlashSettingData.hallonconnect=0;
        break;
    default:
        break;
    }
    flash_settingwrite();
    confirm_Init(win);
    if( FlashSettingData.hallonconnect )
        confirm_data.local_status = ACTIVATE_CONFIRM;
    else
        confirm_data.local_status =  DEACTIVATE_CONFIRM;
    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 0;

}

int LedSetting(MfwMnu * m, MfwMnuItem * i)//zy for led control 2003/02/12
{ 
    T_MFW_HND win = mfw_parent(mfw_header());
    switch( (int)i->str )
    {
    case TxtActivate:
        FlashSettingData.ledon=1;
        timStart(ledblink);
        break;
    case TxtDeactivate:
        FlashSettingData.ledon=0;
        /* 2004/03/15 sunsj remove */
        //Red_Off();
        Green_Off();
        break;
    default:
        break;
    }
    flash_settingwrite();
    confirm_Init(win);
    if( FlashSettingData.ledon )
        confirm_data.local_status = ACTIVATE_CONFIRM;
    else
        confirm_data.local_status =  DEACTIVATE_CONFIRM;
    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 0;

}


#if 0
/*******************************************************************************

 $Function:    	settingMobileInnovation
 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingMobileInnovation(MfwMnu* m, MfwMnuItem* i)
{


    return 0; 
}

/*******************************************************************************

 $Function:    	settingFlower
 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingFlower(MfwMnu* m, MfwMnuItem* i)
{


    return 0; 
}
/*******************************************************************************

 $Function:    	settingSkyrocket
 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingSkyrocket(MfwMnu* m, MfwMnuItem* i)
{


    return 0; 
}
#endif
/*******************************************************************************

 $Function:    	settingSavingMode
 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingSavingMode(MfwMnu* m, MfwMnuItem* i)
{


    return 0; 
}
/*******************************************************************************

 $Function:    	settingNormalMode
 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int settingNormalMode(MfwMnu* m, MfwMnuItem* i)
{



    return 0; 
}

/*******************************************************************************

 $Function:    	ViewBmpAlbum
 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int ViewBmpAlbum(MfwMnu* m, MfwMnuItem* i)
{


    return 0; 
}
/*******************************************************************************

 $Function:    	GreetingWordOff
 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int GreetingWordOff(MfwMnu* m, MfwMnuItem* i)
{


    return 0; 
}







/*******************************************************************************

 $Function:		NameInputCreate

 $Description:	Create the input window and asociate it's handlers
 
 $Returns:		handle of new window, or NULL if failure

 $Arguments:	parent, handle of the parent window
 
*******************************************************************************/

static T_MFW_HND NameInputCreate( T_MFW_HND parent_window )
{
    T_MFW_WIN       *win;
    T_editBGname    *data;

    TRACE_EVENT("NameInputCreate()");


    data = (T_editBGname  *) ALLOC_MEMORY( sizeof(T_editBGname ) ) ;

    /* Create the window if we can
    */

    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) NameInputWindowCB );
    if( data->win EQ NULL )
        return NULL;
    data->parent_win=parent_window;


    /* Okay, we have created the control block and the window, so
       we now need to configure the dialog and data pointers
    */
    data->mmi_control.dialog    = (T_DIALOG_FUNC) NameInputDialog;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;

    /* create keyboards and menus for our window
    */
    //	data->kbd		= kbdCreate( data->win, KEY_ALL,            (MfwCb) NameInputKbdCB );



    return data->win;
}

/*******************************************************************************

 $Function:		NameInputDialog

 $Description:	Dialog function for the input window
 
 $Returns:		None

 $Arguments:	win, window handle
                event, event to be handled
                value, not used
                parameter, not used
 $History: 2004/07/01 sunsj modify for greeting word length
*******************************************************************************/

static void NameInputDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    T_editBGname    *data       = (T_editBGname*) win_data->user;
    T_EDITOR_DATA editor_data;
    TRACE_EVENT("NAMEInputDialog()");

    /* Handle the input event, ew only deal with initialise and
       destroy of the window in here
    */
    switch( event )
    {
    case NAMEINPUT_INIT:
        {  TRACE_EVENT("NAMEInput_INIT");
            memset( data->edt_buf_name,  '\0', 15 );
            /* 2003/12/22 sunsj initialize editor buffer */
            memcpy( data->edt_buf_name, FlashSettingData.greeting_word, 15 );

            /*zy	    bookSetEditAttributes( 20,50 , 80, 80, 0, 0, edtCurBar1, 0, 
                    (char *)data->edt_buf_name, PHB_MAX_LEN, &data->attr );
                        /* Initialise the input window
                        */
            /*zy			data->properties.abc			= TRUE;
                        data->properties.text			= TxtEnterName;
                        data->properties.left_soft_key	= TxtSoftOK;
                        data->properties.right_soft_key      = TxtDelete;
                        data->properties.callback		= NameAddNameCB;
                        data->properties.edt_attr_input	= &data->attr;
                         data->edt						= edtCreate( data->win, data->properties.edt_attr_input, 0, 0 );
            zy*/
            editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtGreetingWord,(char *)data->edt_buf_name,15,edtCurBar1);
            editor_data.min_enter            = 1;             
            editor_data.LeftSoftKey          = TxtSoftOK;     /* 2004/04/16 sunsj modify */
            editor_data.AlternateLeftSoftKey = TxtNull;
            editor_data.RightSoftKey         = TxtDelete;
            editor_data.Callback             =(T_EDIT_CB) NameAddNameCB;
            editor_data.destroyEditor        = TRUE;
            editor_data.mode                 = TEXTINPUT_MODE;      /* 2003/12/04 sunsj modify */
            editor_data.hide                 = FALSE;
            editor_data.Identifier           =  0; 
            editor_data.TextString           = NULL;  
            editor_data.timeout              = FOREVER;  // Avoid to return empty strings
            editor_data.TextId               = '\0'; 
            editor_data.edtInPbk             =0;//zy 2003-04-08
            editor_data.InputMode            = PINYIN_INPUT_MODE;   /* 2003/12/04 sunsj set default input mode */
            /* 2003/12/04 sunsj modify for new editor mode */
            if( editor_data.mode == TEXTINPUT_MODE )
            {
                data->edt = text_input(data->win, &editor_data);
            }
            else
            {
                data->edt = editor_start(data->win,&editor_data);  /* start the editor */
            }

        }
        break;

    case NAMEINPUT_DESTROY:
        {
            /* destroy the input window
            */
            NameInputDestroy(data-> win );
        }
        break;
    default:
        break;
    }
}
/*******************************************************************************

 $Function:		NameInputDestroy

 $Description:	Destroy Input Window
 
 $Returns:		None

 $Arguments:	Handle of window to be destroyed
 
*******************************************************************************/

static void NameInputDestroy( MfwHnd window )
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    T_editBGname *data = (T_editBGname *) win->user;

    TRACE_EVENT("NameInputDestroy()");

    if( data )
    {
        editDeactivate();

        winDelete ( data->win );
        FREE_MEMORY( (void *) data, sizeof( T_editBGname ) );

    }
}


/*******************************************************************************

 $Function:		NameInputWindowCB

 $Description:	Window event handler
 
 $Returns:		MFW_CONSUMED for the visible event, MFW_PASSED otherwise

 $Arguments:	e, event, w, window handle
 
*******************************************************************************/

static int NameInputWindowCB( MfwEvt e, MfwWin *w )
{
    T_editBGname *data = (T_editBGname *) w->user;

    TRACE_EVENT("NameInputWindowCB()");

    /* Handle the visible event, otherwise return MFW_EVENT_PASSED
    */
    switch( e )
    {
    case MfwWinVisible:

        break;

    default:
        break;
        /* unabel to handle event, pass handling of event back up tree
        */
        return MFW_EVENT_PASSED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:		NameInputKbdCB

 $Description:	Input window keyboard handler
 
 $Returns:		MFW_EVENT_CONSUMED always, this will pass LEFT, RIGHT and CLEAR
                events back to the calling window using the installed callback
                method

 $Arguments:	e, event, k, key handle
 
*******************************************************************************/

/*static int NameInputKbdCB( MfwEvt e, MfwKbd *k )
{   T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    T_editBGname	*data		= (T_editBGname *) win_data->user;

     TRACE_EVENT("NameInputKbdCB()");
    /* make sure the active editor is ours
    */
/*    if ( activeEditor() != data->edt )
        editActivate( data->edt, data->properties.abc );

    /* Handle the key press
    */
/*    switch (k->code)
    {
        case KCD_MNUUP:
        {
            /* move right
            */
/*			edtChar( data->edt, ecRight );
        }
        break;

        case KCD_MNUDOWN:
        {
            /* move left
            */
/*		    edtChar( data->edt, ecLeft );
        }
        break;

        case KCD_LEFT:
        {
            /* select the entry using the parent window callback
            */
/*		    data->properties.callback( win, NAMEINPUT_LEFT );
           
        }
        break;

        case KCD_HUP:
        {
            /* get edit control block
            */
//            MfwEdt *edt = ( (MfwHdr *) data->edt )->data;

/* if current buffer is empty then we clear the editor, otherwise
   we step back in the buffer
*/
// MC -- hang up will now exit the editor
// if ( edt->attr->text[0] )
//    edtChar( data->edt, ecBack );
//else
//               data->properties.callback( win, NAMEINPUT_CLEAR );
//		}
/*		break;

        case KCD_RIGHT:
        {
            MfwEdt *edt = ( (MfwHdr *) data->edt )->data;
            /* select the entry using the parent windows callback
            */
//If we have any data input, delete the char before cursor
/*		if ( edt->attr->text[0] )
            edtChar( data->edt, ecBack );
        else	
        {
            data->properties.callback( win, NAMEINPUT_RIGHT );
            displaySoftKeys_edition (TxtNull, TxtNull ,TxtNull);

        }
         
    }
    break;

    case KCD_HASH:
    {
        /* deal with hash key 
        */
/*	        edtChar( data->edt, '#' );
        }
        break;

        case KCD_STAR:
        {
            /* deal with star key
            */
/*		    edtChar( data->edt, '*' );
        }
        break;

        default:
        {
            /* default handling for the key being pressed
            */
/*		    editEventKey( e, k );
        }
        break;
    }

    /* always consume the event
    */
/*    return MFW_EVENT_CONSUMED;
}
*/

/*******************************************************************************

 $Function:     bookAddNameCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

static void NameAddNameCB( T_MFW_HND win, USHORT Identifier, SHORT reason )
{
    char A[4];
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    T_editBGname *data       = (T_editBGname *) win_data->user;
    TRACE_EVENT("NameAddNameCB");
    switch( reason )
    {
    case INFO_KCD_ALTERNATELEFT:
    case INFO_KCD_LEFT:
        {
            wstrncpy( FlashSettingData.greeting_word, data->edt_buf_name,PHB_MAX_LEN );
            TRACE_EVENT((char * )FlashSettingData.greeting_word);
            TRACE_EVENT((char * )data->edt_buf_name);
            FlashSettingData.GreetingWordIsOn=1;
            flash_settingwrite();
            confirm_Init(data->parent_win);
            confirm_data.local_status = ACTIVATE_CONFIRM;
            SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
            SEND_EVENT( win, NAMEINPUT_DESTROY, 0, 0 );
        }
        break;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        SEND_EVENT( win, NAMEINPUT_DESTROY, 0, 0 );
        break;
    default:
        break;
    }
}


/*******************************************************************************
 $Function:    	factoryReset

 $Description:	Reset all the user-settings, 
                At first it show up a confirmation screen 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int factoryReset(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win = mfw_parent(mfw_header());
    if( !CheckHostkey(PRO_RESETALL ) )    //xsf 2002.08.30
    {
        confirm_Init(win);
        confirm_data.local_status = FACTORY_RESET;
        SEND_EVENT (confirm_data.confirm_win, FACTORY_RESET, 0, 0);
        return 0;
    }

    return 0;
}


/******************************************************/
/*                                                    */
/*Function Name: setUserSettingsDefault                       */
/*Purpose:      The user confirm to delete the user-settings.    */
/*Prarmeter:     none                                    */
/*return   :     none                                   */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/
void setUserSettingsDefault (void)
{
    flash_PBmkdir("/bmi");  /* 2004/06/14 sunsj modify */
    ffs_remove(FFSFILE_GAME_PATH);
    ConfigGameInit();
    flash_Gamewrite();
    ffs_remove(FFSFILE_WAP_PATH);
    FlashWapInitialise();
    flash_wap_write();
    ffs_remove(FFSFILE_DCTB_PATH);
    FlashDCTbInitialise();
    flash_DCTbwrite();
    ffs_remove(FFSFILE_SETTING_PATH);
    FlashSettingInitialise();
    flash_settingwrite();
    ffs_remove(FFSFILE_ENVIR_PATH);
    FlashEnviroInitialise(); // xsf add 2 lines for Environment reset 2002.10.15
    flash_environmentwrite(); 

}

/*******************************************************************************

 $Function:    	setUserSettings2Default

 $Description:	The user confirm to delete the user-settings. 

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void setUserSettings2Default (void)
{
    char buf[30];

#if 0

    if( DEFAULT_SETTINGS[ENGLISH].status EQ ON )
    {
        // set the language :ENGLISH
        MmiRsrcSetEnglish();
    }


    if( DEFAULT_SETTINGS[GERMAN].status EQ ON )
    {
        // set the language :GERMAN
        MmiRsrcSetGerman();
    }


    if( DEFAULT_SETTINGS[AUTOREDIAL].status EQ ON )
    {
        // set the Auto-redial
        cm_set_redial(CM_REDIAL_AUTO);  
    }
    else
    {
        cm_set_redial(CM_REDIAL_OFF);
    }


    if( DEFAULT_SETTINGS[AUTOANSWER].status EQ ON )
    {
        // set the Autoanswer
        FFS_flashData.settings_status |= SettingsAutoAnswerOn;
    }
    else
    {
        //switch off the Autoanswer
        FFS_flashData.settings_status &= ~SettingsAutoAnswerOn;
    }


    if( DEFAULT_SETTINGS[ANYKEYANSWER].status EQ ON )
    {
        // set the Anykeyanswer
        FFS_flashData.settings_status |= SettingsAnyKeyAnswerOn;
    }
    else
    {
        //switch off the Anykeyanswer
        FFS_flashData.settings_status &= ~SettingsAnyKeyAnswerOn;
    }

    if( DEFAULT_SETTINGS[CALLTIMERS].status EQ CLEAR )
    {
        //reset here the call timers
        //incoming, outgoing & last calls
    }


    if( DEFAULT_SETTINGS[KEYPAD_CLICK].status EQ ON )
    {
        // set the Keypad click

        if( FFS_flashData.settings_status & SettingsKeypadDTMF )
        {
            FFS_flashData.settings_status &= ~SettingsKeypadDTMF;
        }

        FFS_flashData.settings_status |= SettingsKeypadClick;
    }


    if( DEFAULT_SETTINGS[KEYPAD_DTMF].status EQ ON )
    {
        // set the Keypad DTMF

        if( FFS_flashData.settings_status & SettingsKeypadClick )
        {
            FFS_flashData.settings_status &= ~SettingsKeypadClick;
        }

        FFS_flashData.settings_status |= SettingsKeypadDTMF;
    }


    if( DEFAULT_SETTINGS[KEYPAD_SILENT].status EQ ON )
    {
        // set the Keypad silence

        if( FFS_flashData.settings_status & SettingsKeypadClick )
        {
            FFS_flashData.settings_status &= ~SettingsKeypadClick;
        }
        else if( FFS_flashData.settings_status & SettingsKeypadDTMF )
        {
            FFS_flashData.settings_status &= ~SettingsKeypadDTMF;
        }

    }

    sprintf (buf, " FFS_flashData.settings_status %d", FFS_flashData.settings_status);
    TRACE_EVENT (buf);


    if( DEFAULT_SETTINGS[VOICE_MEMO].status EQ CLEAR )
    {
        // clear the voice memo
        FFS_flashData.voice_memo_position = 0;

    }
    //reset the call timers
    setLastCallDuration(0, INVALID);
    resetIncomingCallsDuration();
    resetOutgoingCallsDuration();
    //set clock format to twenty-four hour
    setClockFormat(TWENTYFOUR_HOUR);



    // PCM
    // here should also update the user-data-settings !!
    // in PCM
    flash_write();
#endif

}

/*******************************************************************************

 $Function:    	confirm_Init

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND confirm_Init (T_MFW_HND parent_window)
{
    return(confirm_create (parent_window));
}
/*******************************************************************************

 $Function:    	confirm_Exit

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void confirm_Exit (T_MFW_HND own_window)
{

    T_MFW_WIN   * win_data = ((T_MFW_HDR *)own_window)->data;
    T_confirm * data     = (T_confirm *)win_data->user;

    confirm_destroy (data->confirm_win);
}

/*******************************************************************************

 $Function:    	confirm_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND confirm_create (T_MFW_HND parent_window)
{
    T_confirm * data = &confirm_data;
    T_MFW_WIN   * win;

    TRACE_FUNCTION ("confirm_create()");

    data->confirm_win = win_create (parent_window, 0, 0, (T_MFW_CB)confirm_win_cb);

    if( data->confirm_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog = (T_DIALOG_FUNC)confirm;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->confirm_win)->data;
    win->user                = (void *) data;


    winShow(data->confirm_win);
    /*
     * return window handle
     */
    return data->confirm_win;
}

/*******************************************************************************

 $Function:    	confirm_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void confirm_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN   * win;
    T_confirm * data;

    TRACE_FUNCTION ("confirm_destroy()");

    if( own_window )
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_confirm *)win->user;

        if( data )
        {

            /*
             * Delete WIN handler
             */
            win_delete (data->confirm_win);
            data->confirm_win = 0;
        }
    }
}
/*******************************************************************************

 $Function:    	confirm_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int confirm_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    /*
     * Top Window has no output
     */
    return 1;
}


/*******************************************************************************

 $Function:    	confirm_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void confirm_dialog(void)
{
    T_DISPLAY_DATA display_info;

    TRACE_FUNCTION ("confirm_dialog()");

    dialog_info_init(&display_info);//gdy add
    display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT | KEY_LEFT|KEY_HUP;
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.TextId   = 0;
    display_info.Time       = FOREVER;


    /*************************zy change for show dialog with icon*********************/
    if( confirm_data.local_status EQ ACTIVATE_CONFIRM )
    {
        display_info.iconindex=REMIND_COMPLETE; //hu binhao 2003-1-14
        display_info.TextId2   = TxtActivated;
        display_info.Callback     = (T_VOID_FUNC)confirm_dialog_cb;
        // bookShowInformation( confirm_data.confirm_win, display_info.TextId, &Confirm, 0, display_info.Callback);

    }
    else if( confirm_data.local_status EQ DEACTIVATE_CONFIRM )
    {
        display_info.iconindex=REMIND_COMPLETE; //hu binhao 2003-1-14

        display_info.TextId2    = TxtDeActivated;
        display_info.Callback     = (T_VOID_FUNC)confirm_dialog_cb;
        // bookShowInformation( confirm_data.confirm_win, display_info.TextId, &Confirm, 0, display_info.Callback);
    }
    else if( confirm_data.local_status EQ FACTORY_RESET )
    {
        display_info.TextId      = TxtPressOk;
        display_info.TextId2     = TxtFactoryReset;
        display_info.Time       = TEN_SECS;
        display_info.LeftSoftKey  = TxtSoftOK;
        display_info.RightSoftKey = TxtSoftBack;
        display_info.iconindex    =REMIND_REQUIRE;
        display_info.Callback     = (T_VOID_FUNC)confirm_dialog_cb;
        //  info_dialog (confirm_data.confirm_win, &display_info);
    }
    info_dialog (confirm_data.confirm_win, &display_info);
    /*************************end of zy change for show dialog with icon*********************/


}
/*******************************************************************************

 $Function:    	confirm_dialog_cb

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void confirm_dialog_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    TRACE_FUNCTION ("confirm_dialog_cb()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        // user confirm to reset all the user settings !
        if( confirm_data.local_status EQ FACTORY_RESET )
            setUserSettingsDefault();    //zy change use self function 04/08/02
        confirm_Exit(win);
        break;

        /* no break; */
    case INFO_KCD_HUP:
        /* no break; */
    case INFO_KCD_RIGHT:
        /* no break; */
    case INFO_KCD_CLEAR:
    case INFO_TIMEOUT:   //zy move here 2003-02-24
        confirm_Exit(win);
        break;
    }
}

/*******************************************************************************

 $Function:    	confirm

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void confirm (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN    * win_data = ((T_MFW_HDR *) win)->data;
    T_confirm      * data     = (T_confirm *)win_data->user;

    TRACE_FUNCTION("confirm()");

    switch( event )
    {
    case SHOW_CONFIRM:
        confirm_dialog();
        break;
    case FACTORY_RESET:
        confirm_dialog();
        break;

    }

}

/******************************************************/
/*                                                    */
/*Function Name: IntensityShow                           */
/*Purpose:      IntensityShow                             */
/*Prarmeter:    none                                     */
/*return   :     none                                    */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/
static void IntensityShow (void)
{
    dspl_TextOut(20,12,DSPL_TXTATTR_NORMAL,"INTENSITY");
    dspl_DrawRect(10,22,70,22+5);
    dspl_DrawFillRect(10,22,10+curIntensity*6,22+5);
}

/* 2004/05/25 sunsj modify */
/******************************************************/
/*                                                    */
/*Function Name: intensityEventWin                          */
/*Purpose:      intensityEventWin                           */
/*Prarmeter:   MfwEvt e, MfwWin *w                      */
/*return   :     int                                    */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/
static int intensityEventWin (MfwEvt e, MfwWin *w)
{   
    t_Intnsity  * data = (t_Intnsity *) w->user;
    uint8       nTextLen;
    int         i;
#if(MAIN_LCD_SIZE==4)
    switch( e )
    {
    case E_WIN_VISIBLE:
        if( w->flags & MfwWinVisible )
            dspl_ClearAll();
        draw_special_background();

        displaySoftKeys(TxtSoftOK, TxtSoftBack);//2004/05/31 yhf modify		
        ALIGNED_PROMPT(CENTER,2,DSPL_TXTATTR_TRANSPARENT,TxtAdjustContrast);
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_CONTRAST, 0);
        curIntensity = FFS_flashData.contrast_intensity;
        DRAW_ICON_SEL(ICON_CONTRAST, 1);
        for( i = 0; i < curIntensity; i++ )
        {
            DRAW_ICON_ATTRIBUTE(ICON_CONTRAST, 28+12*i, 105, 2, ICON_LOCATION);
        }
    default:
        return 0;
    }
#elif(MAIN_LCD_SIZE==3)
switch( e )
    {
    case E_WIN_VISIBLE:
        if( w->flags & MfwWinVisible )
            dspl_ClearAll();
		
        nTextLen=wstrBitlen(MmiRsrcGetText(TxtAdjustContrast));
            DRAW_ICON(ICON_MENUUP);
        drawcolorclarity((120-nTextLen*8)/2, 0, MmiRsrcGetText(TxtAdjustContrast), 0x0);

		/* background */
		DRAW_ICON_SEL(ICON_CONTRAST,1);
		
		/* icon */
		DRAW_ICON_SEL(ICON_CONTRAST,0);//ԱȶͼƬǰͷСicon//jhxu 288 modify
		
		/* intensity */
		for(i=0; i <= (data->intensity)-1; i++)//jhxu 288 modify intensity)-1
		{
			//dspl_BitBlt(constrctIcons[i].area.px, constrctIcons[i].area.py+30, constrctIcons[i].area.sx, constrctIcons[i].area.sy, 
			//			0, (void *)constrctIcons[i].icons, 0);//shiheng 288 modify
			DRAW_ICON_SEL(ICON_CONTRAST_ICONS,i);
			
		
		}
		
        displaySoftKeys(TxtSoftOK, TxtSoftBack);
		draw_softkeybar_leftright_arrow();//jhxu 288 add
    default:
        return 0;
    }
#endif
    return 1;
}

/******************************************************/
/*                                                    */
/*Function Name:  IntensityExit                            */
/*Purpose:      IntensityExit                               */
/*Prarmeter:   MfwHnd window                            */
/*return   :     none                                    */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/

static void IntensityExit (MfwHnd window)
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    t_Intnsity*data = (t_Intnsity* ) win->user;
    //VolumeIconDel();zy 2003-04-08 don't show intensity icons
    winDelete(data->win);
    data->win = 0;
}
/******************************************************/
/*                                                    */
/*Function Name:  IntensityEventKbd                        */
/*Purpose:      IntensityEventKbd                          */
/*Prarmeter:   MfwEvt e, MfwKbd *kc                      */
/*return   :   int                                       */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/

static int IntensityEventKbd (MfwEvt e, MfwKbd *k)
{   T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    t_Intnsity         *data       = (t_Intnsity *) win_data->user;
    int i = 0;
    //   curKey = e;

    switch( k->code )
    {
    case KCD_MNULEFT:

        if( curIntensity > 0 )
            curIntensity--;
        break;
    case KCD_MNURIGHT:
        if( curIntensity < MAX_INTENSITY )
            curIntensity++;
        break;
        /* 2004/03/30 sunsj modify */
        //case KCD_LEFT: WYJ MI18800000399
        //case KCD_RIGHT://talcon delete
    case KCD_LEFT:
        /*2004/05/22,talcon add*/
        switch( data->reason )
        {
        case BACKLIGHT_REASON:
            FlashSettingData.backlight_intensity=curIntensity;
            break;
        case CONTRAST_REASON:
            FFS_flashData.contrast_intensity=curIntensity;
            break; 
        default:
            break;     
        }
        flash_settingwrite();
        flash_write();
    case KCD_RIGHT:
    case KCD_HUP:
        IntensityExit(data->win);

        /*2004/05/22,talcon add*/
        switch( data->reason )
        {
        case BACKLIGHT_REASON:
            break;
        case CONTRAST_REASON:
            ContrastAdjust(FFS_flashData.contrast_intensity);
            break; 
        default:
            break;     
        }

        return 1;
        break;
    default:
        break;
    }
    switch( data->reason )
    {
    case BACKLIGHT_REASON:
        //FlashSettingData.backlight_intensity=curIntensity;/*2004/05/22,talcon delete*/
        break;
    case CONTRAST_REASON:
        //FFS_flashData.contrast_intensity=curIntensity;/*2004/05/22,talcon delete*/
        ContrastAdjust(curIntensity);
        /* 2004/05/25 sunsj add */
#if ( MAIN_LCD_SIZE==4 )
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_CONTRAST, 1);
        for( i = 0; i < curIntensity; i++ )
        {
            DRAW_ICON_ATTRIBUTE(ICON_CONTRAST, 28+12*i, 105, 2, ICON_LOCATION);
        }
#endif
        break; 
    default:
        break;     
    }

    /*2004/05/22,talcon delete*/
    // flash_settingwrite();
    //flash_write();

    data->intensity = curIntensity;
#if(MAIN_LCD_SIZE==3)
    winShow(win);
#endif
    return 1;
}


/******************************************************/
/*                                                    */
/*Function Name: Intensity_create                           */
/*Purpose:      creates the  Intensity window                */
/*Prarmeter:     MfwHnd parent_window                     */
/*return   :     T_MFW_HND                              */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/
static T_MFW_HND Intensity_create(MfwHnd parent_window, IntensityReasons Reason)
{
    t_Intnsity* data = (t_Intnsity*)ALLOC_MEMORY (sizeof (t_Intnsity));
    T_MFW_WIN  * win;
    data->reason=Reason;
    // VolumeIconInit();zy 2003-04-01 these icons init at the iconsinit
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)intensityEventWin);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window

    // curIntensity = FlashSettingData.backlight_intensity;
    switch( data->reason )
    {
    case BACKLIGHT_REASON:
        curIntensity= FlashSettingData.backlight_intensity;
        break;
    case CONTRAST_REASON:
        curIntensity= FFS_flashData.contrast_intensity;
        break; 
    default:
        break;     
    }
    data->intensity = curIntensity;

    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    data->kbd       = kbdCreate( data->win, KEY_ALL, (MfwCb) IntensityEventKbd );
    if( data->win NEQ NULL )
        winShow(data->win);
    return data->win;
}

/******************************************************/
/*                                                    */
/*Function Name: settingBacklightIntensity                    */
/*Purpose:      settingBacklightIntensity                     */
/*Prarmeter:    MfwMnu* m, MfwMnuItem* i                */
/*return   :     int                                     */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/
int settingBacklightIntensity(MfwMnu* m, MfwMnuItem* i)
{  
    T_MFW_HND parent = mfw_parent(mfw_header());
    Intensity_create(parent,BACKLIGHT_REASON) ;
    return 0; 
}


/******************************************************/
/*                                                    */
/*Function Name: settingBacklightContrast                    */
/*Purpose:      settingBacklightContrast                     */
/*Prarmeter:    MfwMnu* m, MfwMnuItem* i                */
/*return   :     int                                     */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/
int settingBacklightContrast(MfwMnu* m, MfwMnuItem* i)
{    
    T_MFW_HND parent = mfw_parent(mfw_header());
    Intensity_create(parent,CONTRAST_REASON) ;
    return 0; 
}

/******************************************************/
/*                                                    */
/*Function Name: GetPreDefinedColor                        */
/*Purpose:      GetPreDefinedColor                        */
/*Prarmeter:    PREDEFINED_COLOR color                   */
/*return   :     UINT32                                 */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/
UINT32 GetPreDefinedColor(PREDEFINED_COLOR color)
{
    if( color<0 || color >= ColorMax )
        return 0;
    return ColorSetArray[FlashSettingData.theme][color];
}
/******************************************************/
/*                                                    */
/*Function Name: Language_check                       */
/*Purpose:      Language_check                      */
/*Prarmeter:   struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi */
/*return   :     USHORT                                 */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/
USHORT Language_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{


    TRACE_EVENT("language_check");
    /*if( ((FFS_flashData.language==CHINESE_LANGUAGE)&&(mi->str==MmiRsrcGetText(TxtChinese)))||
        ((FFS_flashData.language==ENGLISH_LANGUAGE)&&(mi->str==MmiRsrcGetText(TxtEnglish)))
      )*/
    switch( (int)mi->str )
    {
    case TxtChinese: 
        if( FFS_flashData.language==0 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtEnglish:
        if( FFS_flashData.language==1 )
            return FLAGFUNC_TRUE_ICON;
        break;  
    default:
        break;
    }
    return FLAGFUNC_FALSE_ICON;  
}
/******************************************************/
/*                                                    */
/*Function Name:  SetSituation_check                      */
/*Purpose:       SetSituation_check                      */
/*Prarmeter:   struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi */
/*return   :     USHORT                                 */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/

USHORT SetSituation_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    switch( (int)mi->str )
    {
    case TxtBackgroud:
        if( FlashSettingData.BGI )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtGreetingWord:
        if( FlashSettingData.GreetingWordIsOn )
            return FLAGFUNC_TRUE_ICON;
        break;
    case  TxtHallOnConnect:
        if( FlashSettingData.hallonconnect )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtLedSetting:
        if( FlashSettingData.ledon )
            return FLAGFUNC_TRUE_ICON;
        break;    
    default:
        break;
    }
    return FLAGFUNC_FALSE_ICON;     
}
/******************************************************/
/*                                                    */
/*Function Name:  OnAnimation_check                      */
/*Purpose:       OnAnimation_check                     */
/*Prarmeter:   struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi */
/*return   :     USHORT                                 */
/*                                                    */
/*Author   :     zhou yue                               */
/*Date     :    Aug.4st,2002                             */
/******************************************************/

USHORT OnAnimation_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    switch( (int)mi->str )
    {
    case TxtCloseAnim:
        if( FFS_flashData.onoffanimation==0 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtMobileInnovation:
        if( FFS_flashData.onoffanimation==1 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtFlower:
        if( FFS_flashData.onoffanimation==2 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtSkyrocket:
        if( FFS_flashData.onoffanimation==3 )
            return FLAGFUNC_TRUE_ICON;
        break;

    default:
        break;
    }
    return FLAGFUNC_FALSE_ICON;     
}

#if 0/*2003/1201,talcon comment it*/
USHORT Theme_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    switch( (int)mi->str )
    {
    case TxtBlue:
        if( FlashSettingData.theme==0 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtPink:
        if( FlashSettingData.theme==1 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtJazz:
        if( FlashSettingData.theme==2 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtPopular:
        if( FlashSettingData.theme==3 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtBlackWhite:
        if( FlashSettingData.theme==4 )
            return FLAGFUNC_TRUE_ICON;
        break;
    default:
        break;
    }
    return FLAGFUNC_FALSE_ICON;    


}
#endif
USHORT Hallconnect_check(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)//zy 10/22
{
    switch( (int)mi->str )
    {
    case TxtActivate:
        if( FlashSettingData.hallonconnect==1 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtDeactivate:
        if( FlashSettingData.hallonconnect==0 )
            return FLAGFUNC_TRUE_ICON;
        break;
    default:
        break;
    }
    return FLAGFUNC_FALSE_ICON;    
}
USHORT LED_check(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)//zy 2003-02-12
{
    switch( (int)mi->str )
    {
    case TxtActivate:
        if( FlashSettingData.ledon==1 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtDeactivate:
        if( FlashSettingData.ledon==0 )
            return FLAGFUNC_TRUE_ICON;
        break;
    default:
        break;
    }
    return FLAGFUNC_FALSE_ICON;    
}

USHORT GprsAttachMode_check(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    if( (FlashSettingData.gprsattachmode!=0)&&(FlashSettingData.gprsattachmode!=1) )
    {
        FlashSettingData.gprsattachmode==0;
        flash_settingwrite();
    }
    switch( (int)mi->str )
    {
    case TxtGPRSAuto:/*zy 2003-03-04*/
        if( FlashSettingData.gprsattachmode==1 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtGPRSNeed:/*zy 2003-03-04*/
        if( FlashSettingData.gprsattachmode==0 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtAttachMode:/*zy 2003-03-04*/
        if( FlashSettingData.gprsattachmode==0 )
            return FLAGFUNC_FALSE_ICON;
        else
            return FLAGFUNC_TRUE_ICON;
        break;
    default:
        break;
    }
    return FLAGFUNC_FALSE_ICON;    
}


int GPRSAttachMode(MfwMnu* m, MfwMnuItem* i)
{
    switch( (int)i->str )
    {
    case TxtGPRSAuto:/*zy 2003-03-04*/
        FlashSettingData.gprsattachmode=1;
        break;
    case TxtGPRSNeed:/*zy 2003-03-04*/
        FlashSettingData.gprsattachmode=0;
        break;
    default:
        break;
    }
    confirm_Init(win);
    flash_settingwrite();
    confirm_data.local_status = ACTIVATE_CONFIRM;
    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 0;
}

/************************begin added by ganchunhui*/
//#ifdef FIELD_TEST_MODE_ENABLED 
#if 0
int settingsEarPhoneSetFlagOn(MfwMnu* m, MfwMnuItem* i)
{
    gucEarPhoneSupport=1;
    return 0;
}
int settingsEarPhoneSetFlagOff(MfwMnu* m, MfwMnuItem* i)
{
    gucEarPhoneSupport=0;
    return 0;
}

USHORT EarPhoneMode_CheckActive (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    if( gucEarPhoneSupport )
        return FLAGFUNC_TRUE_ICON;
    else
        return FLAGFUNC_FALSE_ICON;
}
USHORT EarPhoneMode_CheckDeActive (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    if( gucEarPhoneSupport )
        return FLAGFUNC_FALSE_ICON;
    else
        return FLAGFUNC_TRUE_ICON;
}

#endif

/************************end added by gan chunhui*/
void dspl_BitBltUser(BOOL bIdle)  //chenjun,2002-12-28
{
    unsigned char *p=(unsigned char*) UserBmpBuffer;  
    char *filename=NULL;
    int i;
    int AddedH=18;  
    int dsplW=0;
    int dsplH=0;
    int readSize=0;
    int res;

    //extern const unsigned char NoRecordBit[];/*2004/1/15, wangyan modify*/
    //extern const unsigned char backgroundBit[];

    //  TRACE_EVENT("chenjun:into dspl_BitBltUser");

    if( flash_CheckStat(picIndex)<0 )   //file not exist
    {
        if( !bIdle )//in mode of select background pic, if nouser  pic, nedd tips 
        {
            //chenjun ,here may add a info dialog,let user know that there is not any user defined pic,2003-01-11
            //  here use a simple method to avoid create and destroy a new win
            // dspl_Clear(0,16,120,144);
            draw_popup_background();
            dspl_TextOut((SCREEN_SIZE_X-get_StringWidth((char *) MmiRsrcGetText(TxtNoUserPic)))/2,TOP_POSITION,0,(char*)MmiRsrcGetText(TxtNoUserPic));
            //            dspl_BitBlt(9,41,102,72,0,(void*)backgroundBit,0); /*2004/1/15, wangyan modify*/
            //         dspl_BitBlt(45, 58, 36, 27, 0, (void *)NoRecordBit,0);
            //          dspl_TextOut((120-8*wstrBitlen(MmiRsrcGetText(TxtNoUserPic)))/2+4,92,0,(char*)MmiRsrcGetText(TxtNoUserPic));
            return;
        }
        else
        {
            return;  //chenjun:in main idle ,no tips needed
        }
    }
    res=ffs_fread(picIndex,(void*)&SplitInfo,sizeof(SplitInfo));
    if( res<=EFFS_OK )   //chenjun: ffs_fread error, read flash file failed,return
    {
        return;
    }
    //   AddedH=(128-AddedH)/2;  //cj, center the picture
    // if(ffs_fread("/mmi/picindex",(void*)&SplitInfo,sizeof(SplitInfo))<0)
    //	 return FALSE;//chenjun ,ffs read wrong ,should show tips 
    for( i=0;i<(SplitInfo.splitNum)&&(i<MAX_SPLIT_FILE_NUM);i++ )
    {
        dsplH+=(i==(SplitInfo.splitNum-1))? (int)SplitInfo.splitH[1] :(int)SplitInfo.splitH[0];
    }//chenjun: vertically center the picture;
    if( dsplH<124 )
        AddedH+=(124-dsplH)/2;

    for( i=0;i<(SplitInfo.splitNum)&&(i<MAX_SPLIT_FILE_NUM);i++ )
    {
        memset(UserBmpBuffer, '\0' , (SPLIT_SIZE+1));
        dsplW=(int)SplitInfo.splitW;
        dsplH=(i==(SplitInfo.splitNum-1))? (int)SplitInfo.splitH[1] :(int)SplitInfo.splitH[0];
        readSize=dsplW*dsplH*2;
        if( readSize> SPLIT_SIZE )
            readSize=SPLIT_SIZE;  //chenjun ,this may not appear,if we change the MAX_SPLIT_FILE_NUM to 
        //a value small than 8, we should larger the SPLIT_SIZE too
        /*
         p=(unsigned char*)malloc(readSize*sizeof(unsigned char));
         if(p==NULL)
           {
           return ;
           }
         */
        //if(dsplW>120||dsplH>128||readSize>SPLIT_SIZE)
        //	return FALSE;//chenjun ,overflow
        filename=SplitInfo.splitName[i];
        //chenjun, if open split pix files wrong, show tips
        res=ffs_fread(filename,(void*)p,readSize);
        if( res<=EFFS_OK )   //chenjun: ffs_fread error, read flash file failed,return
        {
            return;
        }
        //	  if(ffs_fread(filename,(void*)p,readSize)<0)
        //  	return FALSE;//chenjun ,ffs read wrong ,should show tips 
        if( (AddedH+dsplH)>142 )//chenjun 0410 ,144->142
            dsplH=142-AddedH;//chenjun 0410 ,144->142
        dspl_BitBlt((120-dsplW)/2,AddedH,dsplW,dsplH,0 ,(void*)p,0);
        /*
           if(p!=NULL)
              free(p);
        */   
        AddedH+=dsplH;

    }
    return ; 

    /*  
       ffs_fread("/mmi/pic1st1",(void*)p,7680);
       dspl_BitBlt (0,16,120,32,0,(void *)userBmp, 0);
       ffs_fread("/mmi/pic1st2",(void*)p,7680);
       dspl_BitBlt (0,48,120,32,0,(void *)userBmp, 0);
       ffs_fread("/mmi/pic1st3",(void*)p,7680);
       dspl_BitBlt (0,80,120,32,0,(void *)userBmp, 0);
       ffs_fread("/mmi/pic1st4",(void*)p,7680);
       dspl_BitBlt (0,112,120,32,0,(void *)userBmp, 0);
    */
}

USHORT SetUserDefinedPic(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)//chenjun,2002-12-29
{   
    dspl_Clear(0,18,120,142);
    dspl_BitBltUser(0);      
    return 0;
}

/**********************************select background bitmap********
***2003/12/15,talcon add
**********************************************************************/

static int BKGSel_win_cb (MfwEvt e, MfwWin *w)
{
    switch( e )
    {
    case MfwWinVisible:
        timStop(BKGSel_data.AnimTimer);
        {
            UBYTE  uMode;
            UBYTE idxbkganimOld = BKGSel_data.idxbkganim;
            uMode = dspl_Enable(0);
            dspl_ClearAll();
            dspl_IdleBackBmpAnim(BKGSel_data.nBKGSel, &BKGSel_data.idxbkganim);
            displaySoftKeys( TxtSoftSelect, TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
			draw_softkeybar_updown_arrow();//jhxu720
#endif
            dspl_Enable(uMode);
            if( idxbkganimOld !=BKGSel_data.idxbkganim )
                timStart(BKGSel_data.AnimTimer);
        }

        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }

    return MFW_EVENT_CONSUMED;

}//

void BKGSelDestroy (T_MFW_HND own_window)
{
    T_BKGSel *data=&BKGSel_data;
    win_delete (data->win);
}

/* 2004/06 sunsj modify for icon manage */
static int BKGSel_kbd_cb (MfwEvt e, MfwKbd *k)
{
    if( !(e & KEY_MAKE) )
        return MFW_EVENT_CONSUMED;
    switch( k->code )
    {
    case KCD_MNUUP:
    case KCD_MNULEFT:
        if( flash_CheckStat(picIndex)>=0 )
        {
            if( BKGSel_data.nBKGSel>=DYNAMICWALLPAPER_NUM + STATICWALLPAPER_NUM+1 )
                BKGSel_data.nBKGSel = 1;//zy add no background bmp
            else
                BKGSel_data.nBKGSel++;
        }
        else
        {
            if( BKGSel_data.nBKGSel>=DYNAMICWALLPAPER_NUM + STATICWALLPAPER_NUM )
                BKGSel_data.nBKGSel = 1;//zy add no background bmp
            else
                BKGSel_data.nBKGSel++;
        }       
        winShow(BKGSel_data.win);
        break;

    case KCD_MNUDOWN:   
    case KCD_MNURIGHT:
        if( flash_CheckStat(picIndex)>=0 )
        {
            if( BKGSel_data.nBKGSel<=1 )
                BKGSel_data.nBKGSel = DYNAMICWALLPAPER_NUM + STATICWALLPAPER_NUM + 1;
            else
                BKGSel_data.nBKGSel--;
        }
        else
        {
            if( BKGSel_data.nBKGSel<=1 )
                BKGSel_data.nBKGSel = DYNAMICWALLPAPER_NUM + STATICWALLPAPER_NUM;
            else
                BKGSel_data.nBKGSel--;
        }       

        winShow(BKGSel_data.win);
        break;
    case KCD_RIGHT:                 
    case KCD_HUP:   
        BKGSelDestroy(BKGSel_data.win);
        break;
    case KCD_LEFT:
    case KCD_OK:   
        confirm_Init(win);
        FlashSettingData.BGI = BKGSel_data.nBKGSel;
        flash_settingwrite();
        confirm_data.local_status = ACTIVATE_CONFIRM;
        SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
        //BKGSelDestroy(BKGSel_data.win);
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}
static int BKGSel_timer_cb(MfwEvt e, MfwTim *t)
{
    MfwHnd     win  = mfwParent (mfwHeader());

    timStop(BKGSel_data.AnimTimer);
    if( winIsFocussed(BKGSel_data.win) )
    {
        winShow(BKGSel_data.win);
    }

    return 0;

}

T_MFW_HND BKGSelCreate( MfwHnd parent )
{
    T_MFW_WIN     * win;

    T_BKGSel *data=&BKGSel_data;
    memset(data,0,sizeof(T_BKGSel) );

    data->nBKGSel = FlashSettingData.BGI;
    if( data->nBKGSel == 0 )
        data->nBKGSel  = 1;
    data->win=win_create(parent,0,E_WIN_VISIBLE,(T_MFW_CB)BKGSel_win_cb);

    if( data->win EQ 0 )
    {
        return 0;    
    }

    data->mmi_control.dialog    = (T_DIALOG_FUNC)NULL;
    data->mmi_control.data     = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *) data;

    data->kbd      = kbd_create (data->win,KEY_ALL | KEY_MAKE,(T_MFW_CB)BKGSel_kbd_cb);
    data->AnimTimer     = tim_create (data->win,idleanim_timeout,(T_MFW_CB)BKGSel_timer_cb); //  timeout

    winShow(BKGSel_data.win);
    return data->win;
}


int  BKGSelEntry(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win = mfw_parent(mfw_header());

    T_MFW_HND winCur  = BKGSelCreate(win);

    return MFW_EVENT_CONSUMED;
}

/* 2004/04/10 sunsj add start */
static int OuterBKGSel_win_cb (MfwEvt e, MfwWin *w)
{
    switch( e )
    {
    case MfwWinVisible:
        {
            UBYTE  uMode;
            UBYTE idxbkganimOld = OuterBKGSel_data.idxbkganim;
            uMode = dspl_Enable(0);
            dspl_ClearAll();
            /* 2004/04/22 sunsj modify */
            //drawIconByIcnAttr((MfwIcnAttr* )OTBkgIcns+OuterBKGSel_data.nBKGSel, NULL);
            //pdspl_BitBlt(3, 1, 96, 64, 0, OTBkgIcns[OuterBKGSel_data.nBKGSel].icons, 0);
            displaySoftKeys( TxtSoftSelect, TxtSoftBack);
            dspl_Enable(uMode);
        }
        break;
    case MfwWinFocussed:
    case MfwWinDelete:
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

void OuterBKGSelDestroy (T_MFW_HND own_window)
{
    T_BKGSel *data = &OuterBKGSel_data;
    win_delete (data->win);
}

static int OuterBKGSel_kbd_cb (MfwEvt e, MfwKbd *k)
{
    if( !(e & KEY_MAKE) )
    {
        return MFW_EVENT_CONSUMED;
    }
    switch( k->code )
    {
    case KCD_MNUUP:
    case KCD_MNULEFT:
        if( flash_CheckStat(picIndex)>=0 )
        {
            if( OuterBKGSel_data.nBKGSel == 3 )
            {
                OuterBKGSel_data.nBKGSel = 0;
            }
            else
            {
                OuterBKGSel_data.nBKGSel++;
            }
        }
        else
        {
            if( OuterBKGSel_data.nBKGSel == 3 )
            {
                OuterBKGSel_data.nBKGSel = 0;
            }
            else
            {
                OuterBKGSel_data.nBKGSel++;
            }
        }       
        winShow(OuterBKGSel_data.win);
        break;

    case KCD_MNUDOWN:   
    case KCD_MNURIGHT:
        if( flash_CheckStat(picIndex)>=0 )
        {
            if( OuterBKGSel_data.nBKGSel == 0 )
            {
                OuterBKGSel_data.nBKGSel = 3;
            }
            else
            {
                OuterBKGSel_data.nBKGSel--;
            }
        }
        else
        {
            if( OuterBKGSel_data.nBKGSel == 0 )
            {
                OuterBKGSel_data.nBKGSel = 3;
            }
            else
            {
                OuterBKGSel_data.nBKGSel--;
            }
        }       

        winShow(OuterBKGSel_data.win);
        break;
    case KCD_RIGHT:                 
    case KCD_HUP:   
        OuterBKGSelDestroy(OuterBKGSel_data.win);
        break;
    case KCD_LEFT:
    case KCD_OK:   
        confirm_Init(win);
        FlashSettingData.OutBGI = OuterBKGSel_data.nBKGSel;
        flash_settingwrite();
        confirm_data.local_status = ACTIVATE_CONFIRM;
        SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
        drawOuterIdle();
        OuterBKGSelDestroy(OuterBKGSel_data.win);
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}

T_MFW_HND OuterBKGSelCreate( MfwHnd parent )
{
    T_MFW_WIN     * win;
    T_BKGSel *data = &OuterBKGSel_data;

    memset(data,0,sizeof(T_BKGSel) );

    data->nBKGSel = FlashSettingData.OutBGI;
    if( data->nBKGSel == 0 )
        data->nBKGSel  = 1;
    data->win = win_create(parent,0,E_WIN_VISIBLE,(T_MFW_CB)OuterBKGSel_win_cb);

    if( data->win EQ 0 )
    {
        return 0;    
    }

    data->mmi_control.dialog    = (T_DIALOG_FUNC)NULL;
    data->mmi_control.data     = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *) data;

    data->kbd      = kbd_create (data->win,KEY_ALL | KEY_MAKE,(T_MFW_CB)OuterBKGSel_kbd_cb);

    winShow(OuterBKGSel_data.win);
    return data->win;
}

int OuterBKGSelEntry(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    T_MFW_HND winCur  = OuterBKGSelCreate(win);

    return MFW_EVENT_CONSUMED;
}
/* 2004/04/10 sunsj add end */

#if 0
/* 2004/03/18 sunsj add */
void LEDStart()
{
    Green_Off();
    Green_On();
}

void LEDOff()
{
    Green_Off();
}

#endif

#ifdef SEVEN_COLORS_LED
extern MfwHnd ServiceLedTimer;
#endif
/* 2004/04/10 sunsj add */
int settingLED(MfwMnu * m, MfwMnuItem * i)
{ 
    T_MFW_HND win = mfw_parent(mfw_header());
    switch( (int)i->str )
    {
    case TxtOn:
        FlashSettingData.LedSwitch = 1;
        break;
    case TxtOff:
        FlashSettingData.LedSwitch = 0;
        break;

    default:
        break;
    }
    /* 2004/04/22 sunsj modify */
    flash_settingwrite();
    confirm_Init(win);
    // 2004.5.19 WYJ MI18800000380
    if( FlashSettingData.LedSwitch == 1 )
        confirm_data.local_status = ACTIVATE_CONFIRM;
    else
        confirm_data.local_status = DEACTIVATE_CONFIRM;
    /* 2004/06/10 sunsj modify */
#ifdef SEVEN_COLORS_LED
    if( FlashSettingData.LedSwitch == 1 )
    {
        timStart(ServiceLedTimer);
    }
#endif
    SEND_EVENT (confirm_data.confirm_win, SHOW_CONFIRM, 0, 0);
    return 0;

}

USHORT LEDSwitchOn_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    switch( (int)mi->str )
    {
    case TxtOn:
        if( FlashSettingData.LedSwitch == 1 )
            return FLAGFUNC_TRUE_ICON;
        break;
    case TxtOff:
        if( FlashSettingData.LedSwitch == 0 )
            return FLAGFUNC_TRUE_ICON;
        break;

    default:
        break;
    }
    return FLAGFUNC_FALSE_ICON;     
}