//01/08/02 zy Mobile Innovation add language check fuction for listIcon menu
#ifndef _DEF_MMI_SETTINGS_H_
#define _DEF_MMI_SETTINGS_H_

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Settings
 $File:		    MmiSettings.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
                        
********************************************************************************
/********************************************************************************
 $History: MmiSetting.h
 data                  Description
 04/08/02	          zy Mobile Innovation change the total structure 
 28/08/02      wufei modified


 $End

*******************************************************************************/


/*******************************************************************************
                                                                              
                                Required Include Files
                                                                              
*******************************************************************************/

							          
/* PROTOTYPES               */

T_MFW settingsRecReportControl(UBYTE ReportStatus);
/************************************
 *      color management function zy add Mobile Innovation 04/08/02
 *************************************/

typedef enum {
	ColorMenuTitle=0,
	ColorMenuTitleFont,//ColorTwo,
	ColorMenuBG,//ColorThree,
	ColorMenuItemFont,
	ColorMenuItemSel,
	ColorMenuItemSelFont,
	ColorSoftKeyBG,
	ColorSoftKeyFont,
	ColorMax
} PREDEFINED_COLOR;
#define COLORSET_NUM 5
#define voice_call_CallSet 0//WUFEI 0827
#define data_call_CallSet 1//WUFEI 0827
#define fax_call_CallSet 2 //WUFEI 0827
/************************************
 *      color management function
 *************************************/
 const static UINT32 ColorSetArray[COLORSET_NUM][ColorMax] =
 {
	{0x00ff00,0x000000,0xffffff,0xff00ff,0xffff00,0x7800c4,0x00ff00,0x000000},
	{0x0085ff,0xffffff,0x00ffd9,0xb85200,0xffffff,0xb85200,0xf266fd,0x000000},
	{0x9b00db,0xfff400,0xffffff,0xff6600,0x00b259,0xffffff,0x9b00db,0xfff400,},
	{0x0000ff,0xffffff,0xffffff,0xff0000,0xffd700,0xff0000,0x0000ff,0xffffff},
	{0x1e1d1d,0xffffff,0xffffff,0x1e1d1d,0xca0000,0xffffff,0x1e1d1d,0xffffff}
};
/*................................ end of zy change...............................................................*/
int settingsSilentModeOff	(void);
int settingsSilentModeOn	(void);
int settingsKeyPadLockOn	(void);
int settingsKeyPadLockOff	(void);
int settingsAutoRedialOn	(MfwMnu* m, MfwMnuItem* i);
int settingsAutoRedialOff	(MfwMnu* m, MfwMnuItem* i);
int settingsAutoAnswerOn	(MfwMnu* m, MfwMnuItem* i);
int settingsAutoAnswerOff	(MfwMnu* m, MfwMnuItem* i);
int settingsAnyKeyAnswerOn	(MfwMnu* m, MfwMnuItem* i);
int settingsAnyKeyAnswerOff	(MfwMnu* m, MfwMnuItem* i);
int BackgroundSel( MfwMnu *m, MfwMnuItem *i );//zy add begin 04/08/02
//int settingBGOn (MfwMnu* m, MfwMnuItem* i);
int settingBGOff (MfwMnu* m, MfwMnuItem* i);//end of zy change 
int factoryReset			(MfwMnu* m, MfwMnuItem* i);
int settingsVoiceMail		(MfwMnu* m, MfwMnuItem* i);
int settingsScNumber		(MfwMnu* m, MfwMnuItem* i);
int SmsValidityPeriod          (MfwMnu* m, MfwMnuItem* i);
int SmsStatusReportRequest(MfwMnu* m, MfwMnuItem* i); /* Marcus: Issue 1170: 30/09/2002 */

int settingBacklightIntensity( MfwMnu* m, MfwMnuItem* i);//zy add 04/08/02
int settingBacklightContrast(MfwMnu* m, MfwMnuItem* i);//zy add 04/08/23
int settingGreetingWordOn( MfwMnu* m, MfwMnuItem* i);
int settingGreetingWordOff( MfwMnu* m, MfwMnuItem* i);
int editGreetingWord(MfwMnu* m, MfwMnuItem* i);
#if 0
int settingBlue( MfwMnu* m, MfwMnuItem* i);
int settingPink( MfwMnu* m, MfwMnuItem* i);
int settingJazz( MfwMnu* m, MfwMnuItem* i);
int settingPopular( MfwMnu* m, MfwMnuItem* i);
int settingBlackWhite( MfwMnu* m, MfwMnuItem* i);
#endif
int settingTheme(MfwMnu * m, MfwMnuItem * i);
#if 0
int settingMobileInnovation( MfwMnu* m, MfwMnuItem* i);
int settingFlower( MfwMnu* m, MfwMnuItem* i);
int settingSkyrocket( MfwMnu* m, MfwMnuItem* i);
#endif
int settingAnimation(MfwMnu * m, MfwMnuItem * i);
int settingSavingMode( MfwMnu* m, MfwMnuItem* i);
int settingNormalMode( MfwMnu* m, MfwMnuItem* i);
int ViewBmpAlbum( MfwMnu* m, MfwMnuItem* i);
int GreetingWordOff( MfwMnu* m, MfwMnuItem* i);//end of zy change 04/08/02
int Hallconnect(MfwMnu * m, MfwMnuItem * i);
int LedSetting(MfwMnu * m, MfwMnuItem * i);
void settingsInit (void);
void settingsExit (void);
USHORT Language_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);//zy add for check laguage menu should show what icon
UINT32 GetPreDefinedColor(PREDEFINED_COLOR color);//zy add 04/08/02
int settingsVoiceCall	(MfwMnu* m, MfwMnuItem* i); //WUFEI APPEND
int settingsDataCall  (MfwMnu* m, MfwMnuItem* i); //WUFEI APPEND
int settingsFaxCall  (MfwMnu* m, MfwMnuItem* i); //WUFEI APPEND
int settingsCallMinuteFlagOn(MfwMnu* m, MfwMnuItem* i);//WUFEI APPEND
int settingsCallMinuteFlagOff(MfwMnu* m, MfwMnuItem* i);//WUFEI APPEND
int settingsMinuteFlagCheck(MfwMnu* m, MfwMnuItem* i);//WUFEI APPEND
USHORT autoredial_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);//wufei 0827
USHORT nextcall_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi); //wufei add 0827
USHORT minutehint_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);//wufei 0827
void setUserSettingsDefault (void);   //xsf add 2002.08.30
USHORT autoanswer_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);//wufei 0912
USHORT SetSituation_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);//zy 1011
USHORT OnAnimation_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);//zy 1013
//USHORT Theme_check(struct MfwMnuTag * m, struct MfwMnuAttrTag * ma, struct MfwMnuItemTag * mi);//zy 1016
USHORT Hallconnect_check(struct MfwMnuTag * m, struct MfwMnuAttrTag * ma, struct MfwMnuItemTag * mi);//zy 1018
USHORT LED_check(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);//zy 2003-02-11
int GPRSAttachMode(MfwMnu* m, MfwMnuItem* i);
USHORT GprsAttachMode_check(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
USHORT SetUserDefinedPic(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);//chenjun,2002-12-29
USHORT SRRONOFF_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);

/************************begin added by ganchunhui*/
//#ifdef FIELD_TEST_MODE_ENABLED 
#if 0
int settingsEarPhoneSetFlagOn(MfwMnu* m, MfwMnuItem* i);
int settingsEarPhoneSetFlagOff(MfwMnu* m, MfwMnuItem* i);
USHORT EarPhoneMode_CheckActive (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
USHORT EarPhoneMode_CheckDeActive (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);

#endif

/************************end added by gan chunhui*/

/*2003/12/15,talcon add*/
int  BKGSelEntry(MfwMnu* m, MfwMnuItem* i);

#if 0
/* 2004/03/18 sunsj add */
void LEDStart();
void LEDOff();
#endif

/* 2004/04/10 sunsj add */
int settingLED(MfwMnu * m, MfwMnuItem * i);
USHORT LEDSwitchOn_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
int OuterBKGSelEntry(MfwMnu* m, MfwMnuItem* i);

#endif

