/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	eg730                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		shortcut menu
 $File:		    mmishortcutmnu.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		zhangxp                                                         
 $Date:		    09/14/02                                                      
                                                                               
********************************************************************************

                                                                              
 Description
    

********************************************************************************/
/*******************************************************************************
History
Date                          Modified
09/14/02                                                                              
*******************************************************************************/

/*******************************************************************************
                                                                              
                                Include files
                                                                              
*******************************************************************************/


#ifndef _DEF_MMI_SHORTCUTMNU_H_
#define _DEF_MMI_SHORTCUTMNU_H_


typedef enum
{
    MNU_INIT,
    MNU_EXIT,
    FUNCSELECT_INIT,
    FUNCSELECT_EXIT       
}T_shortcutmnu_event;

typedef enum
{
    SceneEntry,
    SmsSendEntry,
    SmsReadEntry,
    AlarmEntry,
    StopwatchEntry,
    FunctionSelectEntry
}T_menuIdentifiers;


typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent;
    T_MFW_HND       win;
    T_MFW_HND		menu_options_win;
    T_MFW_HND       kbd;
    T_MFW_HND       menu; 
    U16             scmenu[15];                
    ListMenuData    *menu_list_data;
    uint8           Listmnu_pos;  //xsf add to record the position of quick function before exeuting it 12.30  
} T_SHORTCUTMNU_INFO;


T_MFW_HND ShortCutMnu_Start(T_MFW_HND parent);
void ShortCutMnu_destroy(MfwHnd own_window);
T_MFW_HND FunctionMenuStart( MfwHnd parent, MfwMnuAttr *menuAttr,SHORT reason );
void FunctionMenuDestroy( MfwHnd window );


int QuickFunctionSelected(struct MfwMnuTag *m,struct MfwMnuItemTag *mi);
/*int FunctionSceneSelected(struct MfwMnuTag *m,struct MfwMnuItemTag *mi);
int FunctionSendSmsSelected(struct MfwMnuTag *m,struct MfwMnuItemTag *mi);
int FunctionReadSmsSelected(struct MfwMnuTag * m, struct MfwMnuItemTag * mi);
int FunctionMemorySelected(struct MfwMnuTag *m,struct MfwMnuItemTag *mi);
int FunctionIncomingCallsSelected(struct MfwMnuTag *m,struct MfwMnuItemTag *mi);
int FunctionOutgoingCallsSelected(struct MfwMnuTag *m,struct MfwMnuItemTag *mi);
int FunctionMissedCallsSelected(struct MfwMnuTag *m,struct MfwMnuItemTag *mi);
int FunctionRejectCallsSelected(struct MfwMnuTag *m,struct MfwMnuItemTag *mi);
int FunctionAlarmSelected(struct MfwMnuTag *m,struct MfwMnuItemTag *mi);
int FunctionTimerSelected(struct MfwMnuTag * m, struct MfwMnuItemTag * mi);
int FunctionStopwatchSelected(struct MfwMnuTag * m, struct MfwMnuItemTag * mi);
int FunctionScheduleSelected(struct MfwMnuTag * m, struct MfwMnuItemTag * mi);*/
USHORT FunctionMenu_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);
int DeleteAllSelect(MfwMnu* m, MfwMnuItem* i);

#endif

