#ifndef _MMI_SOUNDS_DEFS_H_
#define _MMI_SOUNDS_DEFS_H_ 

// 2004.4.9 WYJ modify
#ifdef MMI_WAP_ENABLED
#define ME 1
#else
#define ME 0
#endif

//glowing, 2003-12-11, define the melody id in music list
//2004.1.9 WYJ modify
#ifdef CAMERA_ENABLED
#define MELODY_SUM				(59+ME)
#else
#define MELODY_SUM				(57+ME)
#endif
#define FIRST_RING_MELODY 		0
#define LAST_RING_MELODY		19
#define SMS_MELODY_NORMAL		20
#define FIRST_SMS_MELODY		21
#define LAST_SMS_MELODY			25

#define KEYTONE_SINGLE			26
#define KEYTONE_VOICE0			27
#define KEYTONE_VOICE1			28
#define KEYTONE_VOICE2			29
#define KEYTONE_VOICE3			30
#define KEYTONE_VOICE4			31
#define KEYTONE_VOICE5			32
#define KEYTONE_VOICE6			33
#define KEYTONE_VOICE7			34
#define KEYTONE_VOICE8			35
#define KEYTONE_VOICE9			36
#define KEYTONE_VOICE_STAR		37
#define KEYTONE_VOICE_HASH		38

#define POWERON_MELODY			39
#define POWEROFF_MELODY			40

#define FIRST_MAINMENU_VOICE	41
#define LAST_MAINMENU_VOICE		(47+ME)

#define	NEEDCHARGE_WARNING		(48+ME)
#define	FULLHOUR_TONE			(49+ME)
#define	SPECIAL_MELODY			(50+ME)
#define CONNENT_TONE			(51+ME)

#define FIRST_HALL_MELODY		(52+ME)
#define LAST_HALL_MELODY		(56+ME)

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
#define FIRST_CAM_MELODY        (57+ME)
#endif


//glowing, 2003-12-11, end of add

#define RING_SUM				20
#define SMS_SUM					5
#define HALL_TONE_SUM			5		// 2004.4.9 WYJ add


//begin of xsf add 2002.08.13 for start or stop melody/tone/vibrator
typedef enum
{  
   INCALLPLAY,
   INCALLPLAYGROUP,    //xsf add for group melody 2002.09.19
   INCALL,       //xsf add for in call mode 12.30
   SMSPLAY,
   ALARMPLAY,
   MENURINGPLAY,     // to adjust melody volume of ringer in menu
   MENUALARMPLAY,    // to adjust melody volume of alarm in menu
   MENUIDLEPLAY,   //for press VOLUP/VOLDOWN in idle window to adjust melody volume
   MENUSETPLAY,
   KEYPADTONE,
   NEEDCHARGE,
   MISSEDCALL,
   UNREADSMS,
   CONNECTTONE,
   FULLHRALERT,   // full hour alert
   VOICEMEMO,
   MAINMENUVOICE, //glowing: 2003-12-11, for playing main menu voice
   POWERONPLAY,
   POWEROFFPLAY,
   #ifdef QQFUNC//hxl add for qq func switch,2003-3-24
   QQPLAY,
   #endif
   INCALLVIBRA,
   SMSPLAYVIB,
   INCALLVIBRAR,   //xsf add 2003.02.13
   MELODY_BUSY,
   MELODY_IDLE,
   MELODY_STOPPING,   //xsf add to record now status is stop playing meldoy 2003.02.27
   TONE_BUSY,
   TONE_IDLE,
   TONE_FORBID,
   VIBRA_BUSY,
   VIBRA_IDLE,
   VIBRA_FORBID,
   INCALLVIBRING,  //xsf add for vibra 12s(old is 4s) first then ring 2003.04.09
   SMSPLAYMELODY,       //xsf add for play sms melody 3secs 10.16
   HALLON,								// 2004.4.9 WYJ
   HALLOFF,								// 2004.4.9 WYJ
   MAINMENU_VOICE,						// 2004.4.9 WYJ
}AUDIO_REASON; 

typedef unsigned char   BOOLEANS;



#endif




