#ifndef _DEF_MMI_TIMERS_H_
#define _DEF_MMI_TIMERS_H_
/*******************************************************************************

					CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MMI
 $File:		    MmiTimers.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This handles the storage of call times.
                        
********************************************************************************
 $History: MmiTimers.h


	   
 $End

*******************************************************************************/
#include "MmiBookShared.h"

//typedef enum
//{
/***************wufei Mobile Innovation add the different information dialog flag*******************/
	#define LAST_CALL        (11)
	#define	OUTGOING_CALLS (12)
	#define INCOMING_CALLS  (13)
	#define ALL_CALLS_DURATION (14)//WUFEI APPEND
/*******************************************************************************/

//} timer_types;

typedef enum
{
	INVALID,
	OUTGOING,
	INCOMING
} directions;

typedef struct _tTimerData_
{
    /* administrative data */

    T_MMI_CONTROL   	mmi_control;
    T_MFW_HND       	win;
    T_MFW_HND       	parent_win;
	
    /* associated handlers */

    T_MFW_HND       	kbd;
    T_MFW_HND       	kbd_long;
    T_MFW_HND       	menu;
	T_MFW_HND       	menu_tim;
	UBYTE     			status_of_timer; /* use for the keypadlock */
    /* internal data */
	UBYTE 				timer_type;
    char                 text[25];       //hu binhao 2003-4-21  
    
} tTimerData;


void setLastCallDuration(long call_time, UBYTE call_direction);
/*int timerLastCall(MfwMnu* m, MfwMnuItem* i);
int timerIncomingCalls(MfwMnu* m, MfwMnuItem* i);
int timerOutgoingCalls(MfwMnu* m, MfwMnuItem* i);*/
int timerstatistics(MfwMnu* m, MfwMnuItem* i);  /* 2003/10/22, wangyan, modify call time statistics menu*/
int timerReset(); //WUFEI Append

#endif
