/*
+-----------------------------------------------------------------------+
|                       Restricted Rights Legend                                                                   |
| Copyright(c) 1999-2000 by Synchronization, Inc.                                                      |
| This file is the property of the Synchronization Inc. and it is                                        |
| protected by United States Copyright laws, Internationals laws and                             |
| treaties. It is there by forbidden for any unauthorized use,                                         |
| duplication, distribution or disclosure by any commercial industry                                |
| (public or private), private individual, or by any Government agency                           |
| without a explicit written consent of release from Synchronization.                               |
|....................................................................   |
| PROJECT: Eg730                       $Workfile::   mmiusersymbolinput.h     $               |
| Original Author::zhu guangzhao  $Revision: 1.1.1.1 $                                   |
| CREATED: 04  Jul  2002             $Modtime::     $|
+-----------------------------------------------------------------------+

   PURPOSE  : handle the eastcom's symbol input
   TO DO    :
   
*/

#ifndef _mmiusersymbolinput_H_
#define  _mmiusersymbolinput_H_
//Note: the follow six modes must be the ORDER!!!
/* 2003/12/04 sunsj i use new define in here */
#if 0
#define PARADISE_MODE  				10     //Paradise input mode
#define STROKE_MODE					11		/* 2003/10/26 sunsj add for stroke mode */
#define UPPERCASE_MODE				12    // such as A,B,C...
#define LOWERCASE_MODE				13    // such as a,b,c...
#define SHUZI_MODE				    14	 //digit input mode, such as 1,2,3... 

#define ONLYREAD_MODE				15
#define PHONENUMONLY_MODE			16    //  Not like SHUZI_MODE, it can not convert to other mode 
#define IPADDRESS_MODE				17
#endif
#define TEXTINPUT_MODE				10		//text editor
#define SHUZI_MODE					11		//number editor
#define ONLYREAD_MODE				12
#define PHONENUMONLY_MODE			13
#define IPADDRESS_MODE				14

char findprechar(void);
char findnextchar(void);
void ec_editActivate (MfwHnd e,int AlphaMode);  // ec means Mobile Innovation
void ec_editDeactivate (void);
int ec_editEventKey (MfwEvt e, MfwKbd *k);
MfwHnd getactiveEditor(void);

void set_ecinput_mode(int mode);
int  get_ecinput_mode(void);
void switch_ecinput_mode(void);
#endif

