/********************************************************************************
 $History: Suoha_algri.c
    Date .................. Modification ......................................
    08/14/2002    version 1.1.0 zhangzg 
    08/22/2002    version 1.1.2 zhangzg change the table of possibility
 $End

*******************************************************************************/

#if defined (NEW_FRAME)

   #include "typedefs.h"
   #include "vsi.h"
   #include "pei.h"
   #include "custom.h"
   #include "gsm.h"

#else  /* NEW_FRAME */

   #include "stddefs.h"
   #include "custom.h"
   #include "gsm.h"
   #include "vsi.h"

#endif /* NEW_FRAME */

#include "mfw_sys.h"
//#include "stddefs.h"
#include "p_sim.h"
#include "cus_aci.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_sat.h"
#include "dspl.h"
#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiBookShared.h"
//#include "Mmigame.h"

#include "suoha_algri.h"

//GW 14/09/01 Disable game when not required.
#ifdef MMIGAME

//
EXTERN UBYTE focus_opp;
/****************************************************************************

                       varibles definition


*****************************************************************************/
/*ЩԪеĸλ8֮ΪƵĴС
ʮλе1234ֱӦƬݻҡҡ*/
static unsigned short cards[28] = {10, 20, 30, 40,
   11, 21, 31, 41,
   12, 22, 32, 42,
   13, 23, 33, 43, 
   14, 24, 34, 44,
   15, 25, 35, 45,
   16, 26, 36, 46};
/* 鱣Ÿʱʾж(ע˳ע)
   ĸʷֲPoss32ʾ֪ƣ2µĸʱopp1ʾ1*/
static unsigned char Poss32_opp1[11][5] = {10,30,60,100,0,
   20,50,30,100,0,
   0,30,70,100,0,
   20,40,40,100,0,
   70,20,10,70,30,
   10,50,40,100,0,
   30,60,10,100,0,
   60,30,10,90,10,
   80,20,0,60,40,
   30,40,30,100,0,
   30,40,30,100,0
};
static unsigned char Poss43_opp1[25][5] = {0,30,70,100,0,
   0,60,40,100,0,//1
   0,40,60,100,0,//2
   0,20,80,100,0,//3
   0,60,40,100,0,//4
   90,10,0,10,90,//5
   0,40,60,100,0,//6
   0,60,40,100,0,//7
   0,30,70,100,0,//8
   90,10,0,0,100,//9
   90,10,0,0,100,//10
   10,50,40,100,0,//11
   20,50,30,100,0,//12
   0,40,60,100,0,//13
   100,0,0,0,100,//14
   100,0,0,0,100,//15
   20,60,20,100,0,//16
   90,10,0,90,10,//17
   10,50,40,100,0,//18
   30,50,20,100,0,//19
   100,0,0,0,100,//20
   90,10,0,50,50,//21
   100,0,0,100,0,//22
   30,50,20,100,0,//23
   70,20,10,100,0//24
};
//this is a common array for opp1,opp2,opp3!!
static unsigned char Poss54[26][5] = {0,20,80,100,0,//0
   0,20,80,100,0,//1
   0,30,70,100,0,//2
   0,30,70,100,0,//3
   0,70,30,100,0,//4
   0,30,70,100,0,//5
   0,40,60,100,0,//6
   10,60,30,100,0,//7
   0,30,70,100,0,//8
   0,40,60,100,0,//9
   10,60,30,100,0,//10
   0,30,70,100,0,//11
   10,50,40,100,0,//12
   20,60,20,100,0,//13
   0,30,70,100,0,//14
   20,60,20,100,0,//15
   0,30,70,100,0,//16
   20,60,40,100,0,//17
   20,60,40,100,0,//18
   30,60,20,100,0,//19
   0,30,70,100,0,//20
   90,10,0,0,100,//21
   20,60,20,100,0,//22
   0,30,70,100,0,//23
   20,50,30,100,0,//24
   30,50,20,100,0//25
};
static unsigned char Poss32_opp2[11][5]={
   10,    30,     60,      100,      0,
   20,    30,     50,      100,      0,
   0,     10,     90,      100,      0,

   20,    30,     50,      100,      0,
   40,    50,     10,      100,      0,
   10,    30,     60,      100,      0,
   10,    70,     20,      100,      0,

   20,    70,     10,      90,   10,
   60,    40,     0,       90,       10,
   10,    60,     30,      100,      0, 
   20,    50,     30,      100,      0

};

static unsigned char Poss43_opp2[25][5]={
   0,     30,     70,    100,         0,
   0,     30,     70,    100,         0,
   0,     10,     90,    100,         0,
   0,     10,     90,    100,         0,

   0,     40,     60,    100,         0,
   80,    20,     0,     60,          40,
   0,     60,     40,    100,        0,
   0,     60,     40,    100,         0,
   0,     30,     70,    100,        0,

   30,    70,     0,     80,           20,
   80,    20,     0,     20,           80,
   10,    50,     40,    100,         0,
   20,    50,     30,    100,         0,
   0,     40,     60,    100,         0,

   40,    60,      0,    80,            20,
   100,   0,      0,     20,            80,
   20,    40,     40,    100,          0,
   40,    60,     0,     90,            10,
   10,    40,     50,    100,       0,
   10,    50,     40,    100,       0,

   100,    0,      0    ,20,        80,
   40,     60,     0   , 90,        10,
   100,    0  ,    0  ,  80,        20,
   30,     50  ,   20,   100,       0,
   30,     60   , 10,    100,       0  
};


static unsigned char Poss32_opp3[11][5]={
   10   , 50,     40  ,    100,     0,
   40  ,  50 ,    10 ,     100,     0,
   0     ,50  ,   50,      100   ,  0,

   40   , 40  ,   20   ,   100,     0,
   70  ,  30   ,  0   ,   70  ,  30,
   50 ,   50    , 0  ,    100 ,  0,
   60,    40     ,0 ,     80  ,  20,

   60,    30,     10,      70,      30,
   80,    20,     0,       40,      60,
   30,    50,     20,      100,     0,
   40,    50,     10,      100,     0
};
static unsigned char Poss43_opp3[25][5]={
   0,     50   ,  50,    100      , 0,
   0 ,    60  ,   40 ,   100     ,  0,
   0  ,   40 ,    60  ,  100    ,   0,
   0   ,  50,     50   , 100       ,0,

   0    , 60,     40    ,100, 0,
   90  ,  10 ,    0    , 10  ,     90,
   0  ,   50  ,   50  ,  100  ,  0,
   30,    60   ,  10 ,   100  ,  0,
   0,     40    , 60,    100  ,  0,

   90    ,10,     0     ,10 ,       90,
   90   , 10 ,    0     ,10  ,      90,
   10  ,  60  ,   30    ,100,    0,
   30 ,   50   ,  20    ,100,    0,
   0 ,    50    , 50    ,100,    0,

   100   ,0,      0     ,80,        20    ,
   100   ,0 ,     0    , 0,         100,
   30   , 60 ,    10  ,  100,    0,
   90  ,  10  ,   0  ,   90,     0,
   40 ,   50   ,  10,    100,    0,
   60,    40    , 0,    100,     0,

   100,    0     , 0,    0 ,     100,
   90  ,   10   ,  0 ,   90   ,      10,
   100 ,   0   ,   0  ,  100,    0,
   40   ,  50 ,    10  , 100,    0,
   70    , 20,    10    ,100,    0
};

/* c_Cardsеƣp_Cardsе*/
unsigned short        c_Cards[5] = {0, 0, 0, 0, 0};
unsigned short        p_Cards[5] = {0, 0, 0, 0, 0};

//int c_Two, c_Three, c_Four, c_Five;
//int p_Two, p_Three, p_Four, p_Five;
//int p_CStake,c_CStake;//the current stake the player and computer chip in

unsigned long           desk_Stake;//4ܹĳ;
unsigned long           p_Stake, c_Stake;//4ֱΪֺͻʣĳ
unsigned long           p_M = PIM; //4 ĳ
unsigned long           c_M = CIM; //4 ĳ
unsigned long           p_PreviousM;//4 ǰһеĳ
unsigned long           c_PreviousM;//4 ǰһеĳ

unsigned long           p_CurrStake=0, c_CurrStake=0, desk_CurrStake=0; //4 ǰµע
unsigned short          curr_CardTh=0;//4 ҺͻǰƵΪ5
unsigned short          turnPlayerorComputer=0; //4ֵ˭ע

CardType   SetDifficult;
extern unsigned long casenum;
/* //4ÿ
CardType      p1_Ct, c1_Ct,
              p2_Ct, c2_Ct,
            p3_Ct, c3_Ct,  //4 curr_CardTh=3ʱֺҵ
            p4_Ct, c4_Ct,
            p5_Ct, c5_Ct;
            */
/****************************************************************************************

                            function definition


*****************************************************************************************/
void          ShuffleCards();
void          SendCards();
unsigned short         FirstNum(unsigned short onecard);  //һƵĴС
unsigned short         SecondNum(unsigned short onecard); //һƵĻɫ
CardType      Status_Two(unsigned short* whoCards);
CardType      Status_Three(CardType twoStatus, unsigned short* whoCards);
CardType      Status_Four(CardType threeStatus, unsigned short* whoCards);
CardType      Status_Five(CardType fourStatus, unsigned short* whoCards);
//CardType GetLiangDui(int* whoCards);
//CardType GetDuiZi(int* whoCards);
CardType      ClassifyShanPai(unsigned short* whoCards);  //"ɢ"ɢָκžͬ˻Ϊͬ˳ӡɢƵ

unsigned long           Two_Greater(CardType c_CT, unsigned short turnwho);
unsigned long           Three_Greater(CardType c_CT, CardType p_CT, unsigned short turnwho);
unsigned long           Three_Greater_Opp1(CardType c_CT, CardType p_CT, unsigned short turnwho, unsigned long pMoney); //zhangzg 08/23/2002
unsigned long           Four_Greater_Opp1(CardType c_CT, CardType p_CT, unsigned short turnwho, unsigned long pMoney);//zhangzg 08/23/2002
unsigned long           Four_Greater(CardType c_CT, CardType p_CT, unsigned short turnwho);
unsigned long           Five_Greater(CardType c_CT, CardType p_CT, unsigned short turnwho);
unsigned short           CompareTwo(unsigned short card1, unsigned short card2);
CardType      CompareCards(CardType p_CardType, CardType c_CardType);
/////////////////////////////////////////////////
unsigned short         Produce3Poss(unsigned char a1, unsigned char a2, unsigned char a3);
unsigned short         Produce2Poss(unsigned char a1, unsigned char a2);
unsigned long           ClassifyStake(unsigned short cardsnum, unsigned short classnum);
unsigned long           ClassifyFollorQuit(unsigned short cardnum, unsigned short classnum);
CardType Stake_Two(unsigned short *whoCards);
CardType Stake_Three(CardType twoStatus, unsigned short *whoCards);
CardType Stake_Four(CardType threeStatus, unsigned short *whoCards);
void Set_Suohadifficulty();
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
void ShuffleCards()
{
   int   b; UBYTE a[100]; USHORT  i, j, k, c;
   srand( (unsigned)rvf_get_tick_count() );

   for ( i = 0;   i < 100; i++ )
   {
      b = rand();
      a[i] = b-(b/28)*28;
   }

   for (i = 0; i<99; i++)
   {
      c = cards[a[i]];
      cards[a[i]] = cards[a[i+1]];
      cards[a[i+1]] = c;
   }
//shuffle	
   b = rand();    
   for (i=0; i<(b%50); i++)
   {
      for (j=0; j<=a[i]; j++)
      {
         c = cards[0];        
         for (k = 1; k<=27; k++)
         {
            cards[k-1] = cards[k];
         }
         cards[27] = c;
      }
   }
}

void SendCards()
{
   int i, j, k;
   j = k = 0;

   for (i = 0; i<10; i++)
   {
      if ((i-(i/2)*2)==0)
      {
         p_Cards[j] = cards[i];
         j++;
      } else
      {
         c_Cards[k] = cards[i];
         k++;
      }
   }
/*  //add for test
   switch(casenum)
      {
      case 0: 
            p_Cards[0]=11;
         p_Cards[1]=20;
         p_Cards[2]=10;
         p_Cards[3]=35;
         p_Cards[4]=25;
         c_Cards[0]=10;
         c_Cards[1]=32;
         c_Cards[2]=22;
         c_Cards[3]=12;
         c_Cards[4]=14;
         
         break;
      case 1:
         p_Cards[0]=10;
         p_Cards[1]=11;
         p_Cards[2]=12;
         p_Cards[3]=34;
         p_Cards[4]=14;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=23;
         c_Cards[3]=24;
         c_Cards[4]=25;
         break;
      case 2:
         p_Cards[0]=10;
         p_Cards[1]=11;
         p_Cards[2]=33;
         p_Cards[3]=13;
         p_Cards[4]=14;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=23;
         c_Cards[3]=42;
         c_Cards[4]=25;
         break;
      case 3:
         p_Cards[0]=10;
         p_Cards[1]=11;
         p_Cards[2]=33;
         p_Cards[3]=13;
         p_Cards[4]=14;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=35;
         c_Cards[3]=45;
         c_Cards[4]=25;
         break;
      case 4:
         p_Cards[0]=10;
         p_Cards[1]=11;
         p_Cards[2]=33;
         p_Cards[3]=13;
         p_Cards[4]=14;
         c_Cards[0]=21;
         c_Cards[1]=15;
         c_Cards[2]=35;
         c_Cards[3]=45;
         c_Cards[4]=25;
         break;
      case 5:
         p_Cards[0]=10;
         p_Cards[1]=11;
         p_Cards[2]=14;
         p_Cards[3]=34;
         p_Cards[4]=15;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=35;
         c_Cards[3]=45;
         c_Cards[4]=25;
         break;
      case 6:
         p_Cards[0]=10;
         p_Cards[1]=11;
         p_Cards[2]=14;
         p_Cards[3]=34;
         p_Cards[4]=15;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=32;
         c_Cards[3]=42;
         c_Cards[4]=12;
         break;
      case 7:
         p_Cards[0]=10;
         p_Cards[1]=24;
         p_Cards[2]=14;
         p_Cards[3]=34;
         p_Cards[4]=15;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=33;
         c_Cards[3]=44;
         c_Cards[4]=11;
         break;
      case 8:
         p_Cards[0]=10;
         p_Cards[1]=24;
         p_Cards[2]=14;
         p_Cards[3]=34;
         p_Cards[4]=15;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=33;
         c_Cards[3]=44;
         c_Cards[4]=13;
         break;
      case 9:
         p_Cards[0]=10;
         p_Cards[1]=24;
         p_Cards[2]=14;
         p_Cards[3]=34;
         p_Cards[4]=15;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=33;
         c_Cards[3]=43;
         c_Cards[4]=13;
         break;
      case 10:
         p_Cards[0]=10;
         p_Cards[1]=24;
         p_Cards[2]=14;
         p_Cards[3]=34;
         p_Cards[4]=15;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=32;
         c_Cards[3]=42;
         c_Cards[4]=12;
         break;
      case 11:
         p_Cards[0]=10;
         p_Cards[1]=24;
         p_Cards[2]=14;
         p_Cards[3]=34;
         p_Cards[4]=44;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=32;
         c_Cards[3]=42;
         c_Cards[4]=12;
         break;
      case 12:
         p_Cards[0]=10;
         p_Cards[1]=24;
         p_Cards[2]=14;
         p_Cards[3]=34;
         p_Cards[4]=44;
         c_Cards[0]=21;
         c_Cards[1]=22;
         c_Cards[2]=15;
         c_Cards[3]=45;
         c_Cards[4]=11;
         break;
      case 13:
         p_Cards[0]=10;
         p_Cards[1]=24;
         p_Cards[2]=14;
         p_Cards[3]=34;
         p_Cards[4]=44;
         c_Cards[0]=21;
         c_Cards[1]=25;
         c_Cards[2]=15;
         c_Cards[3]=45;
         c_Cards[4]=11;
         break;
      case 14:
         p_Cards[0]=10;
         p_Cards[1]=24;
         p_Cards[2]=14;
         p_Cards[3]=34;
         p_Cards[4]=44;
         c_Cards[0]=21;
         c_Cards[1]=25;
         c_Cards[2]=15;
         c_Cards[3]=45;
         c_Cards[4]=35;
         break;
      case 15:
         c_Cards[0]=10;
         c_Cards[1]=11;
         c_Cards[2]=12;
         c_Cards[3]=13;
         c_Cards[4]=14;
         p_Cards[0]=21;
         p_Cards[1]=25;
         p_Cards[2]=15;
         p_Cards[3]=45;
         p_Cards[4]=35;
         break;
      case 16:
         p_Cards[0]=10;
         p_Cards[1]=11;
         p_Cards[2]=12;
         p_Cards[3]=13;
         p_Cards[4]=14;
         c_Cards[0]=21;
         c_Cards[1]=25;
         c_Cards[2]=15;
         c_Cards[3]=45;
         c_Cards[4]=35;
         break;
        default:break;
      }*/
   Set_Suohadifficulty();

}

//4 ƵĴС
unsigned short FirstNum(unsigned short onecard)
{
   return onecard-(onecard/10)*10;
}

//4 ƵĻɫ
unsigned short SecondNum(unsigned short onecard)
{
   return onecard/10;
}

/*********************************************************************************************************
    This module is used to get all kinds of card types under the conditions of two, three, four,or five cards
    Input two cards,three cards, four cards and five cards, and their previous card type
    Output their card type
    Notice: to get n cards of card type, you must input n-1 cards of card type!
**********************************************************************************************************/
CardType Status_Two(unsigned short *whoCards)
{
   CardType pc_Ct;



   if (FirstNum(whoCards[0])==FirstNum(whoCards[1]))
   {
      if (SecondNum(whoCards[0])<SecondNum(whoCards[1]))
         pc_Ct.bigcard = whoCards[1];
      else
         pc_Ct.bigcard = whoCards[0];
      pc_Ct.cardType = TWO_DUIZI;
      return pc_Ct;
   } else
   {
      if (FirstNum(whoCards[0])<FirstNum(whoCards[1]))
         pc_Ct.bigcard = whoCards[1];
      else
         pc_Ct.bigcard = whoCards[0];
      pc_Ct.cardType = TWO_SHANPAI;
      return pc_Ct;
   }
}
//the argument of twoStatus must be return from the funtion of Status_Two
CardType Status_Three(CardType twoStatus, unsigned short *whoCards)
{

   CardType pc_Ct;
   pc_Ct.bigcard =0;
   pc_Ct.cardType =0;
   pc_Ct.smallcard =0;


   switch (twoStatus.cardType)
   {
   case TWO_DUIZI:
      if (FirstNum(whoCards[2])==FirstNum(whoCards[0]))
      {
         pc_Ct.bigcard = whoCards[0];
         pc_Ct.cardType = THREE_SHANTIAO;
         return pc_Ct;
      } else
      {
         pc_Ct.bigcard = twoStatus.bigcard;
         pc_Ct.smallcard=whoCards[0];  //tangyan 1227
         pc_Ct.cardType = THREE_DUIZI;
         return pc_Ct;
      }
      break;
   case TWO_SHANPAI:
      if (FirstNum(whoCards[2])==FirstNum(whoCards[0]) )
      {
         if (SecondNum(whoCards[0])<SecondNum(whoCards[2]))
            pc_Ct.bigcard = whoCards[2];
         else
            pc_Ct.bigcard = whoCards[0];
         pc_Ct.cardType = THREE_DUIZI;
         return pc_Ct;
      } else if (FirstNum(whoCards[2])==FirstNum(whoCards[1]))
      {
         if (SecondNum(whoCards[1])<SecondNum(whoCards[2]))
            pc_Ct.bigcard = whoCards[2];
         else
            pc_Ct.bigcard = whoCards[1];
         pc_Ct.cardType = THREE_DUIZI;
         return pc_Ct;
      } else
      {
         if (FirstNum(twoStatus.bigcard)<FirstNum(whoCards[2]))
            pc_Ct.bigcard = whoCards[2];
         else
            pc_Ct.bigcard = twoStatus.bigcard;
         pc_Ct.cardType = THREE_SHANPAI;
         return pc_Ct;
      }
      break;
   }
   return pc_Ct;
}
//the argument of threeStatus must be return from the funtion of Status_Three
CardType Status_Four(CardType threeStatus, unsigned short *whoCards)
{


   int i, samenum=0, tempcard;
   CardType pc_Ct;
   pc_Ct.bigcard =0;
   pc_Ct.cardType =0;
   pc_Ct.smallcard =0;

   switch (threeStatus.cardType)
   {
   case THREE_SHANTIAO:
      if (FirstNum(whoCards[3])==FirstNum(whoCards[0]))
      {
         pc_Ct.bigcard = whoCards[3];
         pc_Ct.cardType = FOUR_TIEZI;
         return pc_Ct;
      } else
      {
         pc_Ct.bigcard = threeStatus.bigcard;
         pc_Ct.cardType = FOUR_SHANTIAO;
         return pc_Ct;
      }
      break;
   case THREE_DUIZI:
      for (i=0; i<=2; i++)
      {
         if (FirstNum(whoCards[3])==FirstNum(whoCards[i]))
         {
            tempcard = whoCards[i]; 
            samenum++;
         }
      }
      if (samenum==2) //the last card is the same as one card of duizi
      {
         pc_Ct.bigcard = whoCards[3];
         pc_Ct.cardType = FOUR_SHANTIAO;
         return pc_Ct;
      } else if (samenum==1)// total four cards become liangdui
      {
         if (FirstNum(whoCards[3])<FirstNum(threeStatus.bigcard))
         {
            pc_Ct.bigcard = threeStatus.bigcard;
            pc_Ct.smallcard = whoCards[3];
         } else
         {
            if (SecondNum(whoCards[3])>SecondNum(tempcard))
               pc_Ct.bigcard =whoCards[3];
            else
               pc_Ct.bigcard = tempcard;
            pc_Ct.smallcard = threeStatus.bigcard;
         }
         pc_Ct.cardType = FOUR_LIANGDUI;
         return pc_Ct;
      } else
      {
         pc_Ct.bigcard = threeStatus.bigcard;
         pc_Ct.cardType = FOUR_DUIZI;
         return pc_Ct;
      }
      break;
   case THREE_SHANPAI:
      for (i=0; i<=2; i++)
      {
         if (FirstNum(whoCards[3])==FirstNum(whoCards[i]))
         {
            if (SecondNum(whoCards[3])<SecondNum(whoCards[i]))
               pc_Ct.bigcard = whoCards[i];
            else
               pc_Ct.bigcard = whoCards[3];
            samenum++;
         }
      }
      if (samenum==1)
      {
         pc_Ct.cardType = FOUR_DUIZI;
         return pc_Ct;
      } else
      {
         if (FirstNum(threeStatus.bigcard)<FirstNum(whoCards[3]))
            pc_Ct.bigcard = whoCards[3];
         else
            pc_Ct.bigcard = threeStatus.bigcard;
         pc_Ct.cardType = FOUR_SHANPAI;
         return pc_Ct;
      }
      break;

   }
   return pc_Ct;
}

//the argument of fourStatus must be return from the funtion of Status_Four
CardType Status_Five(CardType fourStatus, unsigned short* whoCards)
{
   int i, diff=0, samenum=0, same = 0;
   CardType CT_shanpaiclass, pc_Ct;
   pc_Ct.bigcard =0;
   pc_Ct.cardType =0;
   pc_Ct.smallcard =0;

   switch (fourStatus.cardType)
   {
   case FOUR_TIEZI:
      pc_Ct.cardType = TIEZI;
      pc_Ct.bigcard = whoCards[0];
      return pc_Ct;
      break;
   case FOUR_SHANTIAO:
      for (i=0; i<=3; i++)
      {
         if (FirstNum(whoCards[4])==FirstNum(whoCards[i]))
            samenum++;
         else
            diff = whoCards[i];
      }
      if (samenum==3)
      {
         pc_Ct.cardType = TIEZI;
         pc_Ct.bigcard = whoCards[4];
         return pc_Ct;
      } else if (samenum==1)
      {
         pc_Ct.cardType = HULU;
         pc_Ct.bigcard = diff;
         return pc_Ct;
      } else
      {
         pc_Ct.cardType = SHANTIAO;
         pc_Ct.bigcard = fourStatus.bigcard;
         return pc_Ct;
      }
      break;

   case FOUR_LIANGDUI:
      for (i=0; i<=3; i++)
      {
         if (FirstNum(whoCards[4])==FirstNum(whoCards[i]))
            samenum++;
      }
      if (samenum==2)
      {
         pc_Ct.cardType = HULU;
         pc_Ct.bigcard = whoCards[4];
         return pc_Ct;
      } else
      {
         pc_Ct.cardType = LIANGDUI;
         pc_Ct.bigcard = fourStatus.bigcard;
         pc_Ct.smallcard = fourStatus.smallcard;
         return pc_Ct;
      }
      break;
   case FOUR_DUIZI:
      for (i=0; i<=3; i++)
      {
         if (FirstNum(whoCards[4])==FirstNum(whoCards[i]))
         {
            samenum++;        
            same = whoCards[i];
         }
      }
      if (samenum==2)
      {
         pc_Ct.cardType = SHANTIAO;
         pc_Ct.bigcard = whoCards[4];
         return pc_Ct;
      } else if (samenum==1)
      {
         if (FirstNum(whoCards[4])<FirstNum(fourStatus.bigcard))
         {
            pc_Ct.bigcard = fourStatus.bigcard;
            pc_Ct.smallcard = whoCards[4];
         } else
         {
            if (SecondNum(same)<SecondNum(whoCards[4]))
               pc_Ct.bigcard = whoCards[4];
            else
               pc_Ct.bigcard = same;
            pc_Ct.smallcard = fourStatus.bigcard;
         }
         pc_Ct.cardType = LIANGDUI;
         return pc_Ct;
      } else
      {
         pc_Ct.bigcard = fourStatus.bigcard;
         pc_Ct.cardType = DUIZI;
         return pc_Ct;
      }
      break;
   case FOUR_SHANPAI:
      for (i=0; i<=3; i++)
      {
         if (FirstNum(whoCards[4])==FirstNum(whoCards[i]))
         {
            samenum++;        
            same = whoCards[i];
         }
      }
      if (samenum==1)
      {
         if (SecondNum(same)<SecondNum(whoCards[4]))
            pc_Ct.bigcard = whoCards[4];
         else
            pc_Ct.bigcard = same;
         pc_Ct.cardType = DUIZI;
         return pc_Ct;
      } else
      {
         CT_shanpaiclass = ClassifyShanPai(whoCards);
         pc_Ct.cardType = CT_shanpaiclass.cardType;
         pc_Ct.bigcard = CT_shanpaiclass.bigcard;
         return pc_Ct;
      }
      break;
   }
   return pc_Ct;
}

CardType ClassifyShanPai( unsigned short* whoCards)
{
   int bigCard=0;
   int smallCard=0;
   int i=0;
   BOOL colorsame;
   CardType pc_shanpai;
//get the greatest and smallest cards of five cards
   if (FirstNum(whoCards[0])<FirstNum(whoCards[1]))
   {
      smallCard = whoCards[0];
      bigCard = whoCards[1];
   } else
   {
      smallCard = whoCards[1];
      bigCard = whoCards[0];
   }
   for (i=2; i<=4; i++)
   {
      if (FirstNum(whoCards[i])>FirstNum(bigCard))
         bigCard = whoCards[i];
      if (FirstNum(whoCards[i])<FirstNum(smallCard))
         smallCard = whoCards[i];
   }
//are colors of five cards the same?
   if ((SecondNum(whoCards[0])==SecondNum(whoCards[1])) &&
       (SecondNum(whoCards[0])==SecondNum(whoCards[2])) &&
       (SecondNum(whoCards[0])==SecondNum(whoCards[3])) &&
       (SecondNum(whoCards[0])==SecondNum(whoCards[4])) )
      colorsame = true;
   else
      colorsame = FALSE;
//decide whether the cards form TONGHUASUN or SUNZI
   if (((FirstNum(bigCard)==4)||(FirstNum(smallCard)==2)||
        ((FirstNum(bigCard)==5)&&(FirstNum(smallCard)==1)))&&colorsame)
   {
      pc_shanpai.bigcard = bigCard;
      pc_shanpai.cardType = TONGHUASUN;
      return pc_shanpai;
   } else
      if (((FirstNum(bigCard)==4)||(FirstNum(smallCard)==2)||
           ((FirstNum(bigCard)==5)&&(FirstNum(smallCard)==1)))&&!colorsame)
   {
      pc_shanpai.bigcard = bigCard;
      pc_shanpai.cardType = SUNZI;
      return pc_shanpai;
   } else if (colorsame)
   {
      pc_shanpai.bigcard = bigCard;
      pc_shanpai.cardType = TONGHUA;
      return pc_shanpai;
   } else
   {
      pc_shanpai.bigcard = bigCard;
      pc_shanpai.cardType = SHANPAI;
      return pc_shanpai;
   }

}

///////////////////////////////////////////////////////////////////////////////
//According the card types classified by above module, the computer will take an action.
//This module will guide the compute how to do? There are some conditions,such as 
//two, three, four, five cards to discuss.
//the action of computer is returned!
//////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
/*******************************************************************************************************
    
   This module is used to decide to how to act when the computer is chipping in or following or quiting
    Input the card types of the player and computer, and who is being turned
    output the actions of the computer

********************************************************************************************************/
//4 жƵʱԺҵĴСȻ¶ٵע
unsigned long Two_Greater(CardType c_CT, unsigned short turnwho)
{
   int randnum, possible, actionnum;
   switch (c_CT.cardType)
   {
   case TWO_DUIZI:
      if (turnwho==COMPUTER)
      {
         if (c_M>=100)
         {
//				srand((unsigned)rvf_get_tick_count());
            randnum = rand();
            possible = randnum-(randnum/100)*100;
            if (possible>70)
               return TWOCARDS50;  //the possibility of computer chips $50 in is 30% 
            else
               return TWOCARDS100;
         } else if (c_M>=50)
            return TWOCARDS50;
         else if (c_M>=10)
            return TWOCARDS10;
         else
            return NOMONEY;
      } else
         return TWOCARDSFOLL;
      break;
   case TWO_SHANPAI:
      if (turnwho==COMPUTER)
      {
         if ((FirstNum(c_CT.bigcard)>FirstNum(p_Cards[1])) ||
             ((FirstNum(c_CT.bigcard)==FirstNum(p_Cards[1])) &&
              (SecondNum(c_CT.bigcard)>SecondNum(p_Cards[1]))))
            actionnum = Produce3Poss(30,40,30);
         else
            actionnum = Produce3Poss(40,40,20);
         return ClassifyStake(2, actionnum);   //2 means the action is taken after sending the second cards 
      } else
      {
         return TWOCARDSFOLL;
      }
      break;
   }
   return 0;
}

unsigned long Three_Greater(CardType c_CT, CardType p_CT, unsigned short turnwho)
{
   int bigger=0, actionnum;
   unsigned char Poss32[11][5];
   if (focus_opp==1)
      strcpy((char *)& Poss32, (char *)& Poss32_opp1);
   else if (focus_opp==2)
      strcpy((char *)& Poss32, (char *)& Poss32_opp2);
   else
      strcpy((char *)& Poss32, (char *)& Poss32_opp3);


   switch (c_CT.cardType)
   {
   case THREE_SHANTIAO:
      switch (p_CT.cardType)
      {
      case TWO_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[0][0],Poss32[0][1],Poss32[0][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               return THREECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[1][0],Poss32[1][1],Poss32[1][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               return THREECARDSFOLL;
            }
         }
         break;
      case TWO_SHANPAI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss32[2][0],Poss32[2][1],Poss32[2][2]);
            return ClassifyStake(3, actionnum);
         } else
         {
            return THREECARDSFOLL;
         }
         break;
      }
      break;
   case THREE_DUIZI:
      switch (p_CT.cardType)
      {
      case TWO_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[3][0],Poss32[3][1],Poss32[3][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               return THREECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[4][0],Poss32[4][1],Poss32[4][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss32[4][3],Poss32[4][4]);
               return ClassifyFollorQuit(3,actionnum);
            }
         }
         break;
      case TWO_SHANPAI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[5][0],Poss32[5][1],Poss32[5][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               return THREECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[6][0],Poss32[6][1],Poss32[6][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               return THREECARDSFOLL; //zhangzg 08/22/2002
//					actionnum = Produce2Poss(Poss32[6][3],Poss32[6][4]);
//					return ClassifyFollorQuit(3,actionnum);
            }
         }
         break;
      }
      break;
   case THREE_SHANPAI:
      switch (p_CT.cardType)
      {
      case TWO_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[7][0],Poss32[7][1],Poss32[7][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss32[7][3],Poss32[7][4]);
               return ClassifyFollorQuit(3,actionnum);
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[8][0],Poss32[8][1],Poss32[8][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss32[8][3],Poss32[8][4]);
               return ClassifyFollorQuit(3,actionnum);
            }
         }
         break;
      case TWO_SHANPAI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[9][0],Poss32[9][1],Poss32[9][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               return THREECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[10][0],Poss32[10][1],Poss32[10][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               return THREECARDSFOLL;
            }
         }
         break;
      }
      break;
   }
   return 0;
}
//follow or quit are the same with three_greater when player put stake. But it is different when computer firstly put stake
unsigned long Three_Greater_Opp1(CardType c_CT, CardType p_CT, unsigned short turnwho, unsigned long pMoney) //zhangzg 08/23/2002
{
   int bigger=0, actionnum;
   unsigned char Poss32[11][5];
//	if(focus_opp==1)
   strcpy((char *)& Poss32, (char *)& Poss32_opp1);
   //else if(focus_opp==2)
   //strcpy((char *)& Poss32, (char *)& Poss32_opp2);
//	else
   //	strcpy((char *)& Poss32, (char *)& Poss32_opp3);


   switch (c_CT.cardType)
   {
   case THREE_SHANTIAO:
      switch (p_CT.cardType)
      {
      case TWO_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[0][0],Poss32[0][1],Poss32[0][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss32[0][0],Poss32[0][1],Poss32[0][2]);                
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1); //return more stake!
               else
                  return THREECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[1][0],Poss32[1][1],Poss32[1][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss32[1][0],Poss32[1][1],Poss32[1][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1); //return more stake!
               else
                  return THREECARDSFOLL;
            }
         }
         break;
      case TWO_SHANPAI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss32[2][0],Poss32[2][1],Poss32[2][2]);
            return ClassifyStake(3, actionnum);
         } else
         {
            actionnum = Produce3Poss(Poss32[2][0],Poss32[2][1],Poss32[2][2]);
            if (c_M>(pMoney*(actionnum+1)))
               return pMoney*(actionnum+1); //return more stake!
            else
               return THREECARDSFOLL;
         }
         break;
      }
      break;
   case THREE_DUIZI:
      switch (p_CT.cardType)
      {
      case TWO_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[3][0],Poss32[3][1],Poss32[3][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss32[3][0],Poss32[3][1],Poss32[3][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1); //return more stake!
               else
                  return THREECARDSFOLL;               
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[4][0],Poss32[4][1],Poss32[4][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss32[4][3],Poss32[4][4]);
               return ClassifyFollorQuit(3,actionnum);
            }
         }
         break;
      case TWO_SHANPAI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[5][0],Poss32[5][1],Poss32[5][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss32[5][0],Poss32[5][1],Poss32[5][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1); //return more stake!
               else
                  return THREECARDSFOLL;               
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[6][0],Poss32[6][1],Poss32[6][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               return THREECARDSFOLL; //zhangzg 08/22/2002
//					actionnum = Produce2Poss(Poss32[6][3],Poss32[6][4]);
//					return ClassifyFollorQuit(3,actionnum);
            }
         }
         break;
      }
      break;
   case THREE_SHANPAI:
      switch (p_CT.cardType)
      {
      case TWO_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[7][0],Poss32[7][1],Poss32[7][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss32[7][3],Poss32[7][4]);
               return ClassifyFollorQuit(3,actionnum);
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[8][0],Poss32[8][1],Poss32[8][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss32[8][3],Poss32[8][4]);
               return ClassifyFollorQuit(3,actionnum);
            }
         }
         break;
      case TWO_SHANPAI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[9][0],Poss32[9][1],Poss32[9][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               return THREECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss32[10][0],Poss32[10][1],Poss32[10][2]);
               return ClassifyStake(3,actionnum);
            } else
            {
               return THREECARDSFOLL;
            }
         }
         break;
      }
      break;
   }
   return 0;
}
unsigned long Four_Greater(CardType c_CT, CardType p_CT, unsigned short turnwho)
{
   int bigger=0, actionnum;
   unsigned char Poss43[25][5];
   if (focus_opp==1)
      strcpy((char *)& Poss43, (char *)& Poss43_opp1);
   else if (focus_opp==2)
      strcpy((char *)& Poss43, (char *)& Poss43_opp2);
   else
      strcpy((char *)& Poss43, (char *)& Poss43_opp3);

   switch (c_CT.cardType)
   {
   case FOUR_TIEZI:
      switch (p_CT.cardType)
      {
      case THREE_SHANTIAO:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[0][0],Poss43[0][1],Poss43[0][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[1][0],Poss43[1][1],Poss43[1][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         }
         break;
      case THREE_DUIZI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss43[2][0],Poss43[2][1],Poss43[2][2]);
            return ClassifyStake(4, actionnum);
         } else
         {
            return FOURCARDSFOLL;
         }
         break;
      case THREE_SHANPAI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss43[3][0],Poss43[3][1],Poss43[3][2]);
            return ClassifyStake(4, actionnum);
         } else
         {
            return FOURCARDSFOLL;
         }
         break;
      }
      break;
   case FOUR_SHANTIAO:
      switch (p_CT.cardType)
      {
      case THREE_SHANTIAO:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[4][0],Poss43[4][1],Poss43[4][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[5][0],Poss43[5][1],Poss43[5][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[5][3],Poss43[5][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         }
         break;
      case THREE_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[6][0],Poss43[6][1],Poss43[6][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[7][0],Poss43[7][1],Poss43[7][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         }
         break;
      case THREE_SHANPAI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss43[8][0],Poss43[8][1],Poss43[8][2]);
            return ClassifyStake(4, actionnum);
         } else
         {
            return FOURCARDSFOLL;
         }
         break;
      }
      break;
   case FOUR_LIANGDUI:
      switch (p_CT.cardType)
      {
      case THREE_SHANTIAO:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[9][0],Poss43[9][1],Poss43[9][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[9][3],Poss43[9][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[10][0],Poss43[10][1],Poss43[10][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[10][3],Poss43[10][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         }
         break;
      case THREE_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[11][0],Poss43[11][1],Poss43[11][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[12][0],Poss43[12][1],Poss43[12][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         }
         break;
      case THREE_SHANPAI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss43[13][0],Poss43[13][1],Poss43[13][2]);
            return ClassifyStake(4, actionnum);
         } else
         {
            return FOURCARDSFOLL;
         }
         break;
      }
      break;
   case FOUR_DUIZI:
      switch (p_CT.cardType)
      {
      case THREE_SHANTIAO:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[14][0],Poss43[14][1],Poss43[14][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[14][3],Poss43[14][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[15][0],Poss43[15][1],Poss43[15][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSQUIT;
            }
         }
         break;
      case THREE_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[16][0],Poss43[16][1],Poss43[16][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[17][0],Poss43[17][1],Poss43[17][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[17][3],Poss43[17][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         }
         break;
      case THREE_SHANPAI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[18][0],Poss43[18][1],Poss43[18][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[19][0],Poss43[19][1],Poss43[19][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         }
         break;
      }
      break;
   case FOUR_SHANPAI:
      switch (p_CT.cardType)
      {
      case THREE_SHANTIAO:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss43[20][0],Poss43[20][1],Poss43[20][2]);
            return ClassifyStake(4, actionnum);
         } else
         {
            return FOURCARDSQUIT;
         }
         break;
      case THREE_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[21][0],Poss43[21][1],Poss43[21][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[21][3],Poss43[21][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[22][0],Poss43[22][1],Poss43[22][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSQUIT;
            }
         }
         break;
      case THREE_SHANPAI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[23][0],Poss43[23][1],Poss43[23][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[24][0],Poss43[24][1],Poss43[24][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         }
         break;
      }
      break;
   }
   return 0;
}
unsigned long Four_Greater_Opp1(CardType c_CT, CardType p_CT, unsigned short turnwho, unsigned long pMoney)//zhangzg 08/23/2002
{
   int bigger=0, actionnum;
   unsigned char Poss43[25][5];
//	if(focus_opp==1)
   strcpy((char *)& Poss43, (char *)& Poss43_opp1);
//	else if(focus_opp==2)
   //	strcpy((char *)& Poss43, (char *)& Poss43_opp2);
//	else
   //	strcpy((char *)& Poss43, (char *)& Poss43_opp3);

   switch (c_CT.cardType)
   {
   case FOUR_TIEZI:
      switch (p_CT.cardType)
      {
      case THREE_SHANTIAO:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[0][0],Poss43[0][1],Poss43[0][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss43[0][0],Poss43[0][1],Poss43[0][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1);
               else
                  return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[1][0],Poss43[1][1],Poss43[1][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss43[1][0],Poss43[1][1],Poss43[1][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1);
               else
                  return FOURCARDSFOLL;
            }
         }
         break;
      case THREE_DUIZI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss43[2][0],Poss43[2][1],Poss43[2][2]);
            return ClassifyStake(4, actionnum);
         } else
         {
            actionnum = Produce3Poss(Poss43[2][0],Poss43[2][1],Poss43[2][2]);
            if (c_M>(pMoney*(actionnum+1)))
               return pMoney*(actionnum+1);
            else
               return FOURCARDSFOLL;
         }
         break;
      case THREE_SHANPAI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss43[3][0],Poss43[3][1],Poss43[3][2]);
            return ClassifyStake(4, actionnum);
         } else
         {
            actionnum = Produce3Poss(Poss43[3][0],Poss43[3][1],Poss43[3][2]);
            if (c_M>(pMoney*(actionnum+1)))
               return pMoney*(actionnum+1);
            else
               return FOURCARDSFOLL;
         }
         break;
      }
      break;
   case FOUR_SHANTIAO:
      switch (p_CT.cardType)
      {
      case THREE_SHANTIAO:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[4][0],Poss43[4][1],Poss43[4][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss43[4][0],Poss43[4][1],Poss43[4][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1);
               else
                  return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[5][0],Poss43[5][1],Poss43[5][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[5][3],Poss43[5][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         }
         break;
      case THREE_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[6][0],Poss43[6][1],Poss43[6][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss43[6][0],Poss43[6][1],Poss43[6][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1);
               else
                  return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[7][0],Poss43[7][1],Poss43[7][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss43[7][0],Poss43[7][1],Poss43[7][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1);
               else
                  return FOURCARDSFOLL;
            }
         }
         break;
      case THREE_SHANPAI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss43[8][0],Poss43[8][1],Poss43[8][2]);
            return ClassifyStake(4, actionnum);
         } else
         {
            actionnum = Produce3Poss(Poss43[8][0],Poss43[8][1],Poss43[8][2]);
            if (c_M>(pMoney*(actionnum+1)))
               return pMoney*(actionnum+1);
            else
               return FOURCARDSFOLL;
         }
         break;
      }
      break;
   case FOUR_LIANGDUI:
      switch (p_CT.cardType)
      {
      case THREE_SHANTIAO:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[9][0],Poss43[9][1],Poss43[9][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[9][3],Poss43[9][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[10][0],Poss43[10][1],Poss43[10][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[10][3],Poss43[10][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         }
         break;
      case THREE_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[11][0],Poss43[11][1],Poss43[11][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss43[11][0],Poss43[11][1],Poss43[11][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1);
               else
                  return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[12][0],Poss43[12][1],Poss43[12][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss43[12][0],Poss43[12][1],Poss43[12][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1);
               else
                  return FOURCARDSFOLL;
            }
         }
         break;
      case THREE_SHANPAI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss43[13][0],Poss43[13][1],Poss43[13][2]);
            return ClassifyStake(4, actionnum);
         } else
         {
            actionnum = Produce3Poss(Poss43[13][0],Poss43[13][1],Poss43[13][2]);
            if (c_M>(pMoney*(actionnum+1)))
               return pMoney*(actionnum+1);
            else
               return FOURCARDSFOLL;
         }
         break;
      }
      break;
   case FOUR_DUIZI:
      switch (p_CT.cardType)
      {
      case THREE_SHANTIAO:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[14][0],Poss43[14][1],Poss43[14][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[14][3],Poss43[14][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[15][0],Poss43[15][1],Poss43[15][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSQUIT;
            }
         }
         break;
      case THREE_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[16][0],Poss43[16][1],Poss43[16][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss43[16][0],Poss43[16][1],Poss43[16][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1);
               else
                  return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[17][0],Poss43[17][1],Poss43[17][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[17][3],Poss43[17][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         }
         break;
      case THREE_SHANPAI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[18][0],Poss43[18][1],Poss43[18][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss43[18][0],Poss43[18][1],Poss43[18][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1);
               else
                  return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[19][0],Poss43[19][1],Poss43[19][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce3Poss(Poss43[19][0],Poss43[19][1],Poss43[19][2]);
               if (c_M>(pMoney*(actionnum+1)))
                  return pMoney*(actionnum+1);
               else
                  return FOURCARDSFOLL;
            }
         }
         break;
      }
      break;
   case FOUR_SHANPAI:
      switch (p_CT.cardType)
      {
      case THREE_SHANTIAO:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss43[20][0],Poss43[20][1],Poss43[20][2]);
            return ClassifyStake(4, actionnum);
         } else
         {
            return FOURCARDSQUIT;
         }
         break;
      case THREE_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[21][0],Poss43[21][1],Poss43[21][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               actionnum = Produce2Poss(Poss43[21][3],Poss43[21][4]);
               return ClassifyFollorQuit(4,actionnum);
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[22][0],Poss43[22][1],Poss43[22][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSQUIT;
            }
         }
         break;
      case THREE_SHANPAI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[23][0],Poss43[23][1],Poss43[23][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss43[24][0],Poss43[24][1],Poss43[24][2]);
               return ClassifyStake(4,actionnum);
            } else
            {
               return FOURCARDSFOLL;
            }
         }
         break;
      }
      break;
   }
   return 0;
}
unsigned long Five_Greater(CardType c_CT, CardType p_CT, unsigned short turnwho)
{
   int bigger=0, actionnum;

   switch (c_CT.cardType)
   {
   case TONGHUASUN:
      if (turnwho==COMPUTER)
      {
         actionnum = Produce3Poss(Poss54[0][0],Poss54[0][1],Poss54[0][2]);
         return ClassifyStake(5,actionnum);
      } else
      {
         return FOURCARDSFOLL;
      }
      break;
   case TIEZI:
      switch (p_CT.cardType)
      {
      case FOUR_TIEZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[1][0],Poss54[1][1],Poss54[1][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               return FIVECARDS10;
            } else
            {
               return FIVECARDSQUIT;
            }
         }
         break;
      default:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[2][0],Poss54[2][1],Poss54[2][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      }
      break;
   case HULU:
      switch (p_CT.cardType)
      {
      case FOUR_TIEZI:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_SHANTIAO:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[3][0],Poss54[3][1],Poss54[3][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[4][0],Poss54[4][1],Poss54[4][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         }
         break;
      default:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[5][0],Poss54[5][1],Poss54[5][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      }
      break;
   case TONGHUA:
      switch (p_CT.cardType)
      {
      case FOUR_TIEZI:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_SHANTIAO:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[6][0],Poss54[6][1],Poss54[6][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      case FOUR_LIANGDUI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[7][0],Poss54[7][1],Poss54[7][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      default:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[8][0],Poss54[8][1],Poss54[8][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      }
      break;
   case SUNZI:
      switch (p_CT.cardType)
      {
      case FOUR_TIEZI:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_SHANTIAO:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[9][0],Poss54[9][1],Poss54[9][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      case FOUR_LIANGDUI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[10][0],Poss54[10][1],Poss54[10][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      default:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[11][0],Poss54[11][1],Poss54[11][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      }
      break;
   case SHANTIAO:
      switch (p_CT.cardType)
      {
      case FOUR_TIEZI:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_SHANTIAO:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[12][0],Poss54[12][1],Poss54[12][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               return FIVECARDS10;
            } else
            {
               return FIVECARDSQUIT;
            }
         }
         break;
      case FOUR_LIANGDUI:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[13][0],Poss54[13][1],Poss54[13][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      case FOUR_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[14][0],Poss54[14][1],Poss54[14][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[15][0],Poss54[15][1],Poss54[15][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         }
         break;
      default:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[16][0],Poss54[16][1],Poss54[16][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      }
      break;
   case LIANGDUI:
      switch (p_CT.cardType)
      {
      case FOUR_TIEZI:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_SHANTIAO:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_LIANGDUI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[17][0],Poss54[17][1],Poss54[17][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               return FIVECARDS10;
            } else
            {
               return FIVECARDSQUIT;
            }
         }
         break;
      case FOUR_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[18][0],Poss54[18][1],Poss54[18][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[19][0],Poss54[19][1],Poss54[19][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         }
         break;
      default:
         if (turnwho==COMPUTER)
         {
            actionnum = Produce3Poss(Poss54[20][0],Poss54[20][1],Poss54[20][2]);
            return ClassifyStake(5,actionnum);
         } else
         {
            return FIVECARDSFOLL;
         }
         break;
      }
      break;
   case DUIZI:
      switch (p_CT.cardType)
      {
      case FOUR_TIEZI:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_SHANTIAO:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_LIANGDUI:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_DUIZI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[21][0],Poss54[21][1],Poss54[21][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[22][0],Poss54[22][1],Poss54[22][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSQUIT;
            }
         }
         break;
      case FOUR_SHANPAI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[23][0],Poss54[23][1],Poss54[23][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[24][0],Poss54[24][1],Poss54[24][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         }
         break;
      default:
         break;
      }
      break;
   case SHANPAI:
      switch (p_CT.cardType)
      {
      case FOUR_TIEZI:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_SHANTIAO:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_LIANGDUI:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_DUIZI:
         if (turnwho==COMPUTER)
         {
            return FIVECARDS10;
         } else
         {
            return FIVECARDSQUIT;
         }
         break;
      case FOUR_SHANPAI:
         bigger = CompareTwo(c_CT.bigcard, p_CT.bigcard);
         if (c_CT.bigcard==bigger)
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               actionnum = Produce3Poss(Poss54[25][0],Poss54[25][1],Poss54[25][2]);
               return ClassifyStake(5,actionnum);
            } else
            {
               return FIVECARDSFOLL;
            }
         } else
         {//corresponds to a composite of both card types
            if (turnwho==COMPUTER)
            {
               return FIVECARDS10;
            } else
            {
               return FIVECARDSQUIT;
            }
         }
         break;
      default:
         break;
      }
      break;
   }
   return 0;
}



/************************************************************************************************



**************************************************************************************************/
//return the greater card of both card1 and card2
unsigned short CompareTwo(unsigned short card1, unsigned short card2)
{
   if (FirstNum(card1)>FirstNum(card2))
      return card1;
   else if ((FirstNum(card1)==FirstNum(card2)) && (SecondNum(card1)>SecondNum(card2)))
      return card1;
   else
      return card2;
}

//compare the cards of computer and player, when sending 5rd card. The purpose of function is to decide who will win
//4 ȱȽƵͣȻڱȽϴһƵĴСȻȽСһƵĴС
//4 ȻȽϴƵĻɫ
CardType CompareCards(CardType p_CardType, CardType c_CardType)
{
   if (p_CardType.cardType>c_CardType.cardType)
   {
      return p_CardType;
   } else if (p_CardType.cardType==c_CardType.cardType)
   {
      if (FirstNum(p_CardType.bigcard)>FirstNum(c_CardType.bigcard))
      {
         return p_CardType;
      } else if (FirstNum(p_CardType.bigcard)==FirstNum(c_CardType.bigcard))
      {
         if (p_CardType.cardType == LIANGDUI) //4˵ڷ1224Ե
         {
            if (FirstNum(p_CardType.smallcard)>FirstNum(c_CardType.smallcard))
            {
               return p_CardType;
            } else if (FirstNum(p_CardType.smallcard)==FirstNum(c_CardType.smallcard))
            {
               if (SecondNum(p_CardType.bigcard)>SecondNum(c_CardType.bigcard))
               {
                  return p_CardType;
               } else
               {
                  return c_CardType;
               }
            } else
            {
               return c_CardType;
            }
         } else
         {
            if (SecondNum(p_CardType.bigcard)>SecondNum(c_CardType.bigcard))
            {
               return p_CardType;
            } else
            {
               return c_CardType;
            }
         }
      } else
      {
         return c_CardType;
      }
   } else
   {
      return c_CardType;
   }
}

/*****************************************************************************************


****************************************************************************************/
unsigned short Produce3Poss(unsigned char a1, unsigned char a2, unsigned char a3)//decide to how much stakes to chip in
{
   int randnum;
//    srand((unsigned)rvf_get_tick_count());
   randnum = rand();
   randnum = randnum-(randnum/100)*100;
   if (randnum<a1)
      return 1;
   else if ((randnum>=a1) && (randnum<(a1+a2)))
      return 2;
   else
      return 3;
}

unsigned short Produce2Poss(unsigned char a1, unsigned char a2) //decide to follow or quit
{
   int randnum;
//    srand((unsigned)rvf_get_tick_count());
   randnum = rand();
   randnum = randnum-(randnum/100)*100;
   if (randnum<a1)
      return 1;
   else
      return 2;
}

/********************************************************************************************************



*********************************************************************************************************/
//There are total three kinds of stakes according to classnum
//4 ӦͬƣԼĿܵĸʣעĴС
unsigned long ClassifyStake(unsigned short cardsnum, unsigned short classnum)
{
   switch (cardsnum)
   {
   case 2:
      if (classnum==1)
         return TWOCARDS10;
      else if (classnum==2)
         return TWOCARDS50;
      else
         return TWOCARDS100;
      break;
   case 3:
      if (classnum==1)
         return THREECARDS10;
      else if (classnum==2)
         return THREECARDS200;
      else
         return THREECARDS300;
      break;
   case 4:
      if (classnum==1)
         return FOURCARDS10;
      else if (classnum==2)
         return FOURCARDS300;
      else
         return FOURCARDS500;    
      break;
   case 5:
      if (classnum==1)
         return FIVECARDS10;
      else if (classnum==2)
         return FIVECARDS500;
      else
         return FIVECARDS1000;
      break;
   }
   return 0;
}

//
unsigned long ClassifyFollorQuit(unsigned short cardsnum, unsigned short classnum)
{
   switch (cardsnum)
   {
   case 2:
      if (classnum==1)
         return TWOCARDSFOLL;
      else
         return TWOCARDSQUIT;
      break;
   case 3:
      if (classnum==1)
         return THREECARDSFOLL;
      else
         return THREECARDSQUIT;
      break;
   case 4:
      if (classnum==1)
         return FOURCARDSFOLL;
      else
         return FOURCARDSQUIT;
      break;
   case 5:
      if (classnum==1)
         return FIVECARDSFOLL;
      else
         return FIVECARDSQUIT;
      break;
   }
   return 0;
}

/*****************************ж˭ע*************************************/
unsigned short Cp_Stake()
{

   CardType temp_CardType, c_CardType, p_CardType;
   unsigned short whichcard=0;

   switch (curr_CardTh)
   {
   case 2:  //4 ϵ
      whichcard=CompareTwo(p_Cards[1], c_Cards[1]);
      break;
   case 3:
      c_CardType = Stake_Two(&c_Cards[1]);
      p_CardType = Stake_Two(&p_Cards[1]);
      temp_CardType = CompareCards(p_CardType, c_CardType); 

      if (temp_CardType.cardType==p_CardType.cardType &&
          temp_CardType.bigcard==p_CardType.bigcard)
         whichcard=p_Cards[2];
      else
         whichcard=c_Cards[2];
      break;
   case 4:
      c_CardType = Stake_Two(&c_Cards[1]);
      c_CardType = Stake_Three(c_CardType,&c_Cards[1]);

      p_CardType = Stake_Two(&p_Cards[1]);
      p_CardType = Stake_Three(p_CardType,&p_Cards[1]);

      temp_CardType = CompareCards(p_CardType, c_CardType);

      if (temp_CardType.cardType==p_CardType.cardType &&
          temp_CardType.bigcard==p_CardType.bigcard)
         whichcard=p_Cards[3];
      else
         whichcard=c_Cards[3];
      break;
   case 5:
      c_CardType = Stake_Two(&c_Cards[1]);   
      c_CardType = Stake_Three(c_CardType,&c_Cards[1]);
      c_CardType = Stake_Four(c_CardType,&c_Cards[1]);
      p_CardType = Stake_Two(&p_Cards[1]);
      p_CardType = Stake_Three(p_CardType,&p_Cards[1]);
      p_CardType = Stake_Four(p_CardType,&p_Cards[1]);

      temp_CardType = CompareCards(p_CardType, c_CardType);

      if (temp_CardType.cardType==p_CardType.cardType &&
          temp_CardType.bigcard==p_CardType.bigcard)
         whichcard=p_Cards[4];
      else
         whichcard=c_Cards[4];
      break;
   default:break;
   }
   return whichcard;

}

CardType Stake_Two(unsigned short *whoCards)
{
   CardType pc_Ct;



   if (FirstNum(whoCards[0])==FirstNum(whoCards[1]))
   {
      if (SecondNum(whoCards[0])<SecondNum(whoCards[1]))
         pc_Ct.bigcard = whoCards[1];
      else
         pc_Ct.bigcard = whoCards[0];
      pc_Ct.cardType = TWO_DUIZI;
      return pc_Ct;
   } else
   {
      pc_Ct.bigcard = whoCards[1];
      pc_Ct.cardType = TWO_SHANPAI;
      return pc_Ct;
   }
}

CardType Stake_Three(CardType twoStatus, unsigned short *whoCards)
{

   CardType pc_Ct;
   pc_Ct.bigcard =0;
   pc_Ct.cardType =0;
   pc_Ct.smallcard =0;


   switch (twoStatus.cardType)
   {
   case TWO_DUIZI:
      if (FirstNum(whoCards[2])==FirstNum(whoCards[0]))
      {
         pc_Ct.bigcard = whoCards[0];
         pc_Ct.cardType = THREE_SHANTIAO;
         return pc_Ct;
      } else
      {
         pc_Ct.bigcard = twoStatus.bigcard;
         pc_Ct.cardType = THREE_DUIZI;
         return pc_Ct;
      }
      break;
   case TWO_SHANPAI:
      if (FirstNum(whoCards[2])==FirstNum(whoCards[0]) )
      {
         if (SecondNum(whoCards[0])<SecondNum(whoCards[2]))
            pc_Ct.bigcard = whoCards[2];
         else
            pc_Ct.bigcard = whoCards[0];
         pc_Ct.cardType = THREE_DUIZI;
         return pc_Ct;
      } else if (FirstNum(whoCards[2])==FirstNum(whoCards[1]))
      {
         if (SecondNum(whoCards[1])<SecondNum(whoCards[2]))
            pc_Ct.bigcard = whoCards[2];
         else
            pc_Ct.bigcard = whoCards[1];
         pc_Ct.cardType = THREE_DUIZI;
         return pc_Ct;
      } else
      {

         pc_Ct.bigcard = whoCards[2];
         pc_Ct.cardType = THREE_SHANPAI;
      }
      break;
   }
   return pc_Ct;
}

CardType Stake_Four(CardType threeStatus, unsigned short *whoCards)
{


   int i, samenum=0, tempcard;
   CardType pc_Ct;
   pc_Ct.bigcard =0;
   pc_Ct.cardType =0;
   pc_Ct.smallcard =0;

   switch (threeStatus.cardType)
   {
   case THREE_SHANTIAO:
      if (FirstNum(whoCards[3])==FirstNum(whoCards[0]))
      {
         pc_Ct.bigcard = whoCards[3];
         pc_Ct.cardType = FOUR_TIEZI;
         return pc_Ct;
      } else
      {
         pc_Ct.bigcard = threeStatus.bigcard;
         pc_Ct.cardType = FOUR_SHANTIAO;
         return pc_Ct;
      }
      break;
   case THREE_DUIZI:
      for (i=0; i<=2; i++)
      {
         if (FirstNum(whoCards[3])==FirstNum(whoCards[i]))
         {
            tempcard = whoCards[i]; 
            samenum++;
         }
      }
      if (samenum==2) //the last card is the same as one card of duizi
      {
         pc_Ct.bigcard = whoCards[3];
         pc_Ct.cardType = FOUR_SHANTIAO;
         return pc_Ct;
      } else if (samenum==1)// total four cards become liangdui
      {
         if (FirstNum(whoCards[3])<FirstNum(threeStatus.bigcard))
         {
            pc_Ct.bigcard = threeStatus.bigcard;
            pc_Ct.smallcard = whoCards[3];
         } else
         {
            if (SecondNum(whoCards[3])>SecondNum(tempcard))
               pc_Ct.bigcard =whoCards[3];
            else
               pc_Ct.bigcard = tempcard;
            pc_Ct.smallcard = threeStatus.bigcard;
         }
         pc_Ct.cardType = FOUR_LIANGDUI;
         return pc_Ct;
      } else
      {
         pc_Ct.bigcard = threeStatus.bigcard;
         pc_Ct.cardType = FOUR_DUIZI;
         return pc_Ct;
      }
      break;
   case THREE_SHANPAI:
      for (i=0; i<=2; i++)
      {
         if (FirstNum(whoCards[3])==FirstNum(whoCards[i]))
         {
            if (SecondNum(whoCards[3])<SecondNum(whoCards[i]))
               pc_Ct.bigcard = whoCards[i];
            else
               pc_Ct.bigcard = whoCards[3];
            samenum++;
         }
      }
      if (samenum==1)
      {
         pc_Ct.cardType = FOUR_DUIZI;
         return pc_Ct;
      } else
      {

         pc_Ct.bigcard = whoCards[3];
         pc_Ct.cardType = FOUR_SHANPAI;
         return pc_Ct;
      }
      break;

   }
   return pc_Ct;
}

UINT8  Cp_Card()
{
   CardType temp_CardType, c_CardType, p_CardType;

   c_CardType = Status_Two(c_Cards);
   c_CardType = Status_Three(c_CardType,c_Cards);
   c_CardType = Status_Four(c_CardType,c_Cards);
   c_CardType = Status_Five(c_CardType,c_Cards);

   p_CardType = Status_Two(p_Cards);
   p_CardType = Status_Three(p_CardType,p_Cards);
   p_CardType = Status_Four(p_CardType,p_Cards);
   p_CardType = Status_Five(p_CardType,p_Cards);


   temp_CardType = CompareCards(p_CardType, c_CardType); 

   if (temp_CardType.cardType==c_CardType.cardType &&
       temp_CardType.bigcard==c_CardType.bigcard)
   {
      memcpy(&SetDifficult,&c_CardType,sizeof(CardType));
      return 1;
   } else
      return 0;  
}

void Swape_Card()
{
   UINT8 tempcard,i,equalnum=0;


   switch (SetDifficult.cardType)
   {
   case SHANPAI:
      for (i=0;i<5;i++)
      {
         if (c_Cards[i]==SetDifficult.bigcard)
         {
            tempcard=c_Cards[0];
            c_Cards[0]=c_Cards[i];
            c_Cards[i]=tempcard;
         }
      }
      break;
   case DUIZI:
   case LIANGDUI:
      for (i=0;i<5;i++)
      {
         if (FirstNum(c_Cards[i])==FirstNum(SetDifficult.bigcard))
         {
            if (c_Cards[i]==SetDifficult.bigcard)
            {
               tempcard=c_Cards[0];
               c_Cards[0]=c_Cards[i];
               c_Cards[i]=tempcard;
            } else
            {
               tempcard=c_Cards[2];
               c_Cards[2]=c_Cards[i];
               c_Cards[i]=tempcard;
            }
         }
      }
      break;
   case SHANTIAO: 
   case HULU:
      for (i=0;i<5;i++)
      {
         if (FirstNum(c_Cards[i])==FirstNum(SetDifficult.bigcard))
         {
            if (c_Cards[i]==SetDifficult.bigcard)
            {
               tempcard=c_Cards[0];
               c_Cards[0]=c_Cards[i];
               c_Cards[i]=tempcard;
            } else
            {
               //4 ȵƺ͵3ƽ
               tempcard=c_Cards[2];
               c_Cards[2]=c_Cards[i];
               c_Cards[i]=tempcard;
            }
         } else
         {
            //4 Ѳȵƻ
            tempcard=c_Cards[4];
            c_Cards[4]=c_Cards[i];
            c_Cards[i]=tempcard;

         }
      }
      break;
   default:
      break;
   }
}

void Set_Suohadifficulty()
{
   if (focus_opp==1)
   {
      if (Cp_Card())
         Swape_Card();
      else
         c_Cards[0]=cards[10];
   }
   if (focus_opp==2)
   {
      if ((rand()/2)&&Cp_Card())
         Swape_Card();
   }

}



#endif
