/*=====================================================================
Copyright (c) 2001-2002 MobileSoft Corporation

  All Rights Reserved.
  
    $Logfile: mevent.h
	
	  $Revision:
	  
		$vision:       1.00
		
		  $Date:         08/10/2002
		  
			$Author:       hulf
			
			  $Declare: 
			  This document contains information proprietary to MobileSoft  
			  Technology (Nanjing),  Corp.    Transmittal, receipt, or possession 
			  of this document does not express, license, or imply any rights to 
			  use, sell, design, or manufacture from this information. No reproduction, 
			  publication, or disclosure of this information, in whole or in part, 
			  shall be made without prior written authorization from an officer of 
			  MobileSoft Technology (NanJing), Corp.
			  
				Abstract:
				
				  Modified By:
				  
					Environment: 
					
					  Revision History:
					  
=====================================================================*/




#ifndef _MANAGER_H_
#define _MANAGER_H_



#include "mmsgloble.h"

#if __cplusplus 
extern "C" {
#endif

/* manager api */
pManager	manager_on_initialize();
MMS_S32		manager_on_destroy( );
MMS_S32		manager_on_store( );

MMS_S32		manager_get_allsize();
MMS_S32		manager_get_messagenum();

pMessage	manager_get_currentmsg(pFolder folder);
pManager	manager_get_manager();
pFolder		manager_get_currentfolder();
MMS_S32		manager_set_currentfolder(pFolder folder);


/* manager setting api */
MMS_S32		manager_get_wapaddress(MMS_S8 *wapgw);
MMS_S32		manager_set_wapaddress(MMS_S8 *wapgw);
MMS_S32		manager_get_mmscaddress(MMS_S8 *mmsc);
MMS_S32		manager_set_mmscaddress(MMS_S8 *mmsc);
MMS_S32		manager_get_autorecv(MMS_S8 *recv);
MMS_S32		manager_set_autorecv(MMS_S8 recv);
MMS_S32		manager_get_autosave(MMS_S8 *save);
MMS_S32		manager_set_autosave(MMS_S8 save);
MMS_S32		manager_get_report(MMS_S8 *report);
MMS_S32		manager_set_report(MMS_S8 report);

//added by JeffreyYao, նŵҪ
MMS_S32		manager_set_currentmessage(pFolder folder, MMS_U8 index);

#if __cplusplus 
}
#endif
#endif /* _MANAGER_H_ */







