


#ifndef _MSGLIST_H_
#define _MSGLIST_H_



#include "mmsgloble.h"

#if __cplusplus 
extern "C" {
#endif

pFolder		newfolder();
MMS_S32		freefolder(pFolder folder);

MMS_S32		readmessagefolder(pFolder folder);
MMS_S32		storemessagefolder(pFolder folder);


/* manager message list api */
MMS_S32		manager_on_addmsg(pFolder folder, pMessage msg);
MMS_S32		manager_on_addmms(pFolder folder, MMSHANDLE mms, MMS_U8 msgtype);
MMS_S32		manager_on_delete(pFolder folder);
MMS_S32		manager_on_deleteall(pFolder folder);
pMessage	manager_on_pickout(pFolder folder);
pMessage	manager_on_copy(pMessage pMsg);

MMS_S32		manager_on_focusup(pFolder folder);
MMS_S32		manager_on_focusdown(pFolder folder);

//added by JeffreyYao, 2-11-2004
MMS_S32		manager_specified_replacemms(pFolder folder, MMSHANDLE mmsdoc, MMS_U8 msgtype, pMessage pPosMsg);


/* message api */

pMessage	newmessage();
MMS_S32		freemessage(pMessage tlist);

MMS_S8		*msg_get_receiver(pMessage pMsg);
MMS_S32		msg_set_receiver(pMessage pMsg, MMS_S8 *recvs);

MMS_S8		*msg_get_title(pMessage pMsg);
MMS_S32		msg_set_title(pMessage pMsg, MMS_S8 *title);

MMS_S8		*msg_get_cc(pMessage pMsg);
MMS_S32		msg_set_cc(pMessage pMsg, MMS_S8 *cc);

MMS_S8		*msg_get_bcc(pMessage pMsg);
MMS_S32		msg_set_bcc(pMessage pMsg, MMS_S8 *bcc);

MMS_S32		msg_get_date(pMessage pMsg, MMS_S8 date[24]);
MMS_S32		msg_set_date(pMessage pMsg, MMS_S8 date[24]);

MMS_S32		msg_get_size(pMessage pMsg, MMS_S32 *size);
MMS_S32		msg_set_size(pMessage pMsg, MMS_S32 size);

MMS_S32		msg_get_type(pMessage pMsg, MMS_U8 *type);
MMS_S32		msg_set_type(pMessage pMsg, MMS_U8 type);


#if __cplusplus 
}
#endif

#endif