
/*=====================================================================

  Copyright (c) 2001-2002 MobileSoft Corporation
  
    All Rights Reserved.
	
	  $Logfile: player.h
	  
		$Revision:
		
		  $vision:       1.00
		  
			$Date:         07/21/2002
			
			  $Author:       hulf
			  
				$Declare: 
				This document contains information proprietary to MobileSoft  
				Technology (Nanjing),  Corp.    Transmittal, receipt, or possession 
				of this document does not express, license, or imply any rights to 
				use, sell, design, or manufacture from this information. No reproduction, 
				publication, or disclosure of this information, in whole or in part, 
				shall be made without prior written authorization from an officer of 
				MobileSoft Technology (NanJing), Corp.
				Abstract:
				Modified By:
				Environment: 
				Revision History:
=====================================================================*/



#ifndef _USEREVENT_H_
#define _USEREVENT_H_

#include "mms_codec.h"




#define		PLAYER_DRAWSLIDE_TIMERVALUE		300


#define		PLAYER_INIT_PLAY		0x01	
#define		PLAYER_INIT_PREVIEW		0x02

typedef enum
{
	FileOpenFailed = -1,
	OtherErrs = 0,
	Normal = 1
}PlayerInitRetVal;

#if __cplusplus 
extern "C" {
#endif

//pPlayer		player_initialize(MMS_S32 event);
//pPlayer		player_initialize(MMS_S32 event, MMS_S8* retval);
pPlayer		player_initialize(MMS_S32 event, PlayerInitRetVal *retval);

//playertype, 0: preview;  1: play from .mms file
//JeffreyYao, 2-4-2004
MMS_S32		player_destrory(MMS_S32 event);

MMS_S32		player_on_draw();
MMS_S32		player_on_replay();
MMS_S32		player_on_stop();
MMS_S32		player_on_pageup();
MMS_S32		player_on_pagedown();
MMS_S32		player_on_timer(MMS_S32 timerid);

MMS_S32		player_openpreview();
MMS_S32		player_inputfile();
MMS_S32		player_on_test();


pPlayer		player_get_player();

//added by JeffreyYao, 2-9-2004
MMS_S32	player_on_pagenext();
MMS_S32	player_on_pagelast();

//added by JeffreyYao for MobileInnovation, 6-23-2004
MMS_S32		player_get_slideindex();
MMS_S32		player_get_slidecount();

#if __cplusplus 
}
#endif



#endif /* _USEREVENT_H_ */
