#ifdef _MMS_ENABLE_

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)
#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"
#else
#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"
#endif

#include "p_sim.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_smsi.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"


#include "dspl.h"
#include "MmiMain.h"
#include "MmiDummy.h"
#include "MmiMmi.h"

#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiEditor.h"

//begin xie
#include "mmimms_cfg.h"
#include "mmibookshared.h"
#include "mmiMMSffs.h"  //add by xie 04-07-08
#include "manager.h"
#include "mmsgloble.h"
#include "mmiicnOther.h"
#include "mmiMMSGlobalDef.h"
#include "MmiSmsIdle.h"
#include "mmiMMSFolders.h"
#include "mmimms_cfg.h"  //#include "Mmiutilapi.h"  //modified by xie 04-07-12 
#include "mmseditor.h"
#include "mmiMMSNew.h"
#include "player.h"
#include "msglist.h"
#include "mmiutilapi.h"
//end xie
#include "mmimmsmenu.h"

#ifdef MMI_MMSTASK_ENABLED
#define MMS_COMPILE_FORAPP
#include "mmstask.h"
#endif

//Ϣб
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    MMS_FOLDER_TYPE winID;
    T_MFW_HND       parent;	
	
    /* associated handlers */
	
    /* internal data */
    ListMenuData    list_menu_data;
	unsigned int msgNum;
} T_MMS_MENU_FOLDERS;

static int iMsgListIndex = 0;

/*talcon delete it*/
//static MfwRect MMS_Menu_Folder_Area = {0,0,SCREEN_SIZE_X,LINE_HEIGHT*9}; 
extern MfwRect menuListArea;
static MfwMnuAttr MMS_Menu_Folder_Attrib =
{
    0,
    &menuListArea,//&MMS_Menu_Folder_Area,
	MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
	-1,                                 /* use default font         */
	NULL,                               /* with these items         */
	0                                   /* number of items     */
};

static void       MMS_Menu_Folder_listmenu_create(T_MMS_MENU_FOLDERS *data);
static void       MMS_Menu_Folder_listmenu_cb    (T_MFW_HND * win, ListMenuData * ListData);
static void       MMS_Menu_Folder_destroy        (T_MFW_HND window);
static void       MMS_Menu_Folder_dialog         (T_MFW_HND win, USHORT event, USHORT value, void * parameter);
static T_MFW_HND  MMS_Menu_Folder_create         (T_MFW_HND window , MMS_FOLDER_TYPE folderType);
static T_MFW_HND  MMS_Menu_Folder_start          (T_MFW_HND window , MMS_FOLDER_TYPE folderType);
static int        MMS_Menu_Folders               (MMS_FOLDER_TYPE folderType);

//
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
	MMS_FOLDER_TYPE winID;
    /* associated handlers */	
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
	
}T_MMS_FOLDERS_PLAYER;  

static T_MFW_HND MMS_Folders_Play_start(MfwHnd parent_window , MMS_FOLDER_TYPE folderType);
static T_MFW_HND MMS_Folders_Play_create(T_MFW_HND parent_window, MMS_FOLDER_TYPE folderType);
static void MMS_Folders_Play_destroy(T_MFW_HND win);
static void MMS_Folders_Play_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int MMS_Folders_Play_kbd_cb(MfwEvt e, MfwKbd *k);
static int MMS_Folders_Play_win_cb(MfwEvt e, MfwWin *w);

//ѡ
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
	MMS_FOLDER_TYPE winID;
    T_MFW_HND       parent;	
    /* associated handlers */	
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu;
    /* internal data */
    T_MMS_FOLDERS_PLAYER          *parent_data;
}T_MMS_FOLDER_OPT;

static int MMS_Folder_Opt_win_cb(MfwEvt e, MfwWin *w);
static int MMS_Folder_Opt_mnu_cb ( MfwEvt e, MfwMnu *m );
static int MMS_Folder_Opt_kbd_cb(MfwEvt e, MfwKbd *k);
static void MMS_Folder_Opt_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static void MMS_Folder_Opt_destroy(T_MFW_HND win);
static T_MFW_HND MMS_Folder_Opt_create(T_MFW_HND parent_window);
static T_MFW_HND MMS_Folder_Opt_start(MfwHnd parent_window , MfwMnuAttr *menuAttr);

INFO_DIALOG_DATA iddMMSRetrieving ={NULL,NULL};
//int MMS_Retrieving_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);

//MMSýб
static int g_codememalloc = 0;
#define MMS_new(ptr, size)  		MI_ALLOC(ptr, size,g_codememalloc)
#define MMS_free(ptr,size)      	MI_FREE(ptr, g_codememalloc)

typedef enum 
{
	MUSIC,
	IMAGE
}MMS_MEDIA_TYPE;

#define MMS_FILENAME_LEN		64
char mmsMediaFileName[MMS_FILENAME_LEN+1];
char originMediaFileName[MMS_FILENAME_LEN+1];

typedef struct
{    
	T_MMI_CONTROL   mmi_control;
	T_MFW_HND       win;
	MMS_MEDIA_TYPE   winID;
	T_MFW_HND       parent;
	
	T_MFW_HND       editor;
	T_EDITOR_DATA   editor_info;   
}T_MMS_MEDIALIST_EDITOR;

static void MMS_MediaList_Edit_LoadEditDefault(T_EDITOR_DATA *editor_data);
static void MMS_MediaList_Edit_destroy(MfwHnd own_window);
static void MMS_MediaList_Edit_edit_cb(T_MFW_HND win, USHORT Identifier, SHORT reason);
static void MMS_MediaList_Edit_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter);
static T_MFW_HND MMS_MediaList_Edit_create(MfwHnd parent_window,MMS_MEDIA_TYPE winID);
static T_MFW_HND MMS_MediaList_Edit_start(T_MFW_HND parent, MMS_MEDIA_TYPE winID);

//ϸ
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
    /* associated handlers */	
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    /* internal data */
}T_MMS_FOLDER_DETAIL;

static int MMS_Folder_Detail_win_cb(MfwEvt e, MfwWin *w);
static int MMS_Folder_Detail_kbd_cb(MfwEvt e, MfwKbd *k);
static void MMS_Folder_Detail_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static void MMS_Folder_Detail_destroy(T_MFW_HND win);
static T_MFW_HND MMS_Folder_Detail_create(T_MFW_HND parent_window);
static T_MFW_HND MMS_Folder_Detail_start(MfwHnd parent_window );

int MMS_Menu_Send_Folder(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
	T_DISPLAY_DATA display_info;
    P_MMS	mms = getMMS();
    
	MMS_TRACE_FUNCTION("MMS_Menu_Send_Folder");
	
	if(mms->manager && mms->manager->unsendfolder && mms->manager->unsendfolder->messagenumber <= 0)
	{
		dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		display_info.Time         = TWO_SECS;
		display_info.KeyEvents    = KEY_RIGHT;
		display_info.TextId2      = TxtMMSSendFolderEmpty;
		display_info.Callback     = (T_VOID_FUNC)NULL;
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_COMPLETE;
		info_dialog (win, &display_info); 
		return 0;
	}
	else
	{
		gCurMMSPos = MMS_SEND_FOLDER;
	    MMS_Menu_Folders(MMS_SEND_FOLDER);
		return 1;
	}
}

void MMS_Entry_Recv_Folder_In_Idle(T_MFW_HND parentWin)
{
	T_DISPLAY_DATA display_info;
    P_MMS	mms = getMMS();
	
	MMS_TRACE_FUNCTION("MMS_Entry_Recv_Folder_In_Idle");
	
	if(mms->manager && mms->manager->receivefolder && mms->manager->receivefolder->messagenumber <= 0)
	{
		dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		display_info.Time         = TWO_SECS;
		display_info.KeyEvents    = KEY_RIGHT;
		display_info.TextId2      = TxtMMSRecvFolderEmpty;
		display_info.Callback     = (T_VOID_FUNC)NULL;
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_COMPLETE;
		info_dialog (parentWin, &display_info); 
		return ;
	}
	else
	{
		gCurMMSPos = MMS_RECV_FOLDER;
		iMsgListIndex = 0;
		MMS_Menu_Folder_start(parentWin, MMS_RECV_FOLDER);
		return ;
	}
}

int MMS_Menu_Recv_Folder(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
	T_DISPLAY_DATA display_info;
    P_MMS	mms = getMMS();
	
	MMS_TRACE_FUNCTION("MMS_Menu_Recv_Folder");
	
	if(mms->manager && mms->manager->receivefolder && mms->manager->receivefolder->messagenumber <= 0)
	{
		dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		display_info.Time         = TWO_SECS;
		display_info.KeyEvents    = KEY_RIGHT;
		display_info.TextId2      = TxtMMSRecvFolderEmpty;
		display_info.Callback     = (T_VOID_FUNC)NULL;
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_COMPLETE;
		info_dialog (win, &display_info); 
		return 0;
	}
	else
	{
		gCurMMSPos = MMS_RECV_FOLDER;
	    MMS_Menu_Folders(MMS_RECV_FOLDER);
		return 1;
	}
}

int MMS_Menu_Draft_Folder(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
	T_DISPLAY_DATA display_info;
    P_MMS	mms = getMMS();
	
	MMS_TRACE_FUNCTION("MMS_Menu_Draft_Folder");
	if(mms->manager && mms->manager->draftfolder && mms->manager->draftfolder->messagenumber <= 0)
	{
		dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		display_info.Time         = TWO_SECS;
		display_info.KeyEvents    = KEY_RIGHT;
		display_info.TextId2      = TxtMMSDraftFolderEmpty;
		display_info.Callback     = (T_VOID_FUNC)NULL;
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_COMPLETE;
		info_dialog (win, &display_info); 
		return 0;
	}
	else
	{
		gCurMMSPos = MMS_DRAFT_FOLDER;
        MMS_Menu_Folders(MMS_DRAFT_FOLDER);
		return 1;
	}
}

int MMS_Menu_Sent_Folder(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
	T_DISPLAY_DATA display_info;
    P_MMS	mms = getMMS();
	MMS_TRACE_FUNCTION("MMS_Menu_Sent_Folder");
	if(mms->manager && mms->manager->sendfolder && mms->manager->sendfolder->messagenumber <= 0)
	{
		dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		display_info.Time         = TWO_SECS;
		display_info.KeyEvents    = KEY_RIGHT;
		display_info.TextId2      = TxtMMSSentFolderEmpty;
		display_info.Callback     = (T_VOID_FUNC)NULL;
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_COMPLETE;
		info_dialog (win, &display_info); 
		return 0;
	}
	else
	{
		gCurMMSPos = MMS_SENT_FOLDER;
	    MMS_Menu_Folders(MMS_SENT_FOLDER);
    	return 1;
	}
}

static int MMS_Menu_Folders(MMS_FOLDER_TYPE folderType)
{
	T_MFW_HND      win = mfwParent(mfwHeader());
	
	MMS_TRACE_EVENT(("MMS_Menu_Folders( %d )", folderType));
	switch(folderType)
	{
	case MMS_SEND_FOLDER:
		iMsgListIndex = 0;
		MMS_Menu_Folder_start(win, MMS_SEND_FOLDER);
		break;
	case MMS_RECV_FOLDER:
		iMsgListIndex = 0;
		MMS_Menu_Folder_start(win, MMS_RECV_FOLDER);
		break;
	case MMS_DRAFT_FOLDER:
		iMsgListIndex = 0;
		MMS_Menu_Folder_start(win, MMS_DRAFT_FOLDER);
		break;
	case MMS_SENT_FOLDER:
		iMsgListIndex = 0;
		MMS_Menu_Folder_start(win, MMS_SENT_FOLDER);
		break;		
	default:
        return 0;
	}
	return 1;
}

static T_MFW_HND  MMS_Menu_Folder_start(T_MFW_HND window , MMS_FOLDER_TYPE folderType)
{
	T_MFW_HND win;
	
	MMS_TRACE_FUNCTION("MMS_Menu_Folder_start");
    win = MMS_Menu_Folder_create(window , folderType);
	
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, folderType , NULL);
    }
    return win;	
}

static T_MFW_HND  MMS_Menu_Folder_create(T_MFW_HND window , MMS_FOLDER_TYPE folderType)
{
	T_MMS_MENU_FOLDERS * data = (T_MMS_MENU_FOLDERS *)ALLOC_MEMORY (sizeof (T_MMS_MENU_FOLDERS));
    T_MFW_WIN  * win;
	
    data->win =win_create (window, 0, 0, NULL);
    if( data->win EQ NULL )
    {
        return NULL;
    }
	
	MMS_Set_MsgList_WHnd(data->win);

    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Menu_Folder_dialog;
    data->mmi_control.data   = data;
	data->winID              = folderType;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = window;
	
    winShow(data->win);
    return data->win;
}

static void MMS_Menu_Folder_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter)
{
	T_MFW_WIN           * win_data = ((T_MFW_HDR     *) win)->data;
    T_MMS_MENU_FOLDERS  * data     = (T_MMS_MENU_FOLDERS *)win_data->user;
    T_MFW_HND           * parent   = data->parent;
	P_MMS	mms = getMMS();
	T_DISPLAY_DATA display_info;
	
	MMS_TRACE_FUNCTION("MMS_Menu_Folder_dialog");
	MMS_TRACE_EVENT(( " foldertype:%d", value));
	switch( event )
	{
	case E_INIT:
		if(value == MMS_SEND_FOLDER)
		    manager_set_currentfolder(mms->manager->unsendfolder);
		else if(value == MMS_RECV_FOLDER)
            manager_set_currentfolder(mms->manager->receivefolder);
		else if(value == MMS_DRAFT_FOLDER)
			manager_set_currentfolder(mms->manager->draftfolder);
		else if(value == MMS_SENT_FOLDER)
			manager_set_currentfolder(mms->manager->sendfolder);
		else 
			return;

		if(mms->manager && mms->manager->currentfolder && mms->manager->currentfolder->messagenumber > 0)
		    MMS_Menu_Folder_listmenu_create(data);
		break;
		
	case E_RETURN: 
	case E_EXIT: 
	case E_BACK:  
		if(mms->manager && mms->manager->currentfolder)
		{
			if(mms->manager->currentfolder->messagenumber > 0)
			{
				 MMS_Menu_Folder_destroy(data->win);
			     MMS_Menu_Folder_start(parent , gCurMMSPos);
				 return;
			}
			else
			{
#if 0
				switch(gCurMMSPos)
				{
				case MMS_SEND_FOLDER:
					dialog_info_init(&display_info);
					display_info.RightSoftKey = TxtSoftBack;
					//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
					display_info.Time         = TWO_SECS;
					display_info.KeyEvents    = KEY_RIGHT;
					display_info.TextId2      = TxtMMSSendFolderEmpty;
					display_info.Callback     = (T_VOID_FUNC)NULL;
					display_info.Identifier   = DIALOGS_REASON_NULL;
					display_info.iconindex	  = REMIND_COMPLETE;
					info_dialog (win, &display_info); 
					break;
				case MMS_RECV_FOLDER:
					dialog_info_init(&display_info);
					display_info.RightSoftKey = TxtSoftBack;
					//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
					display_info.Time         = TWO_SECS;
					display_info.KeyEvents    = KEY_RIGHT;
					display_info.TextId2      = TxtMMSRecvFolderEmpty;
					display_info.Callback     = (T_VOID_FUNC)NULL;
					display_info.Identifier   = DIALOGS_REASON_NULL;
					display_info.iconindex	  = REMIND_COMPLETE;
					info_dialog (win, &display_info); 
					break;
				case MMS_DRAFT_FOLDER:
					dialog_info_init(&display_info);
					display_info.RightSoftKey = TxtSoftBack;
					//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
					display_info.Time         = TWO_SECS;
					display_info.KeyEvents    = KEY_RIGHT;
					display_info.TextId2      = TxtMMSDraftFolderEmpty;
					display_info.Callback     = (T_VOID_FUNC)NULL;
					display_info.Identifier   = DIALOGS_REASON_NULL;
					display_info.iconindex	  = REMIND_COMPLETE;
					info_dialog (win, &display_info); 
					break;
				case MMS_SENT_FOLDER:
					dialog_info_init(&display_info);
					display_info.RightSoftKey = TxtSoftBack;
					//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
					display_info.Time         = TWO_SECS;
					display_info.KeyEvents    = KEY_RIGHT;
					display_info.TextId2      = TxtMMSSentFolderEmpty;
					display_info.Callback     = (T_VOID_FUNC)NULL;
					display_info.Identifier   = DIALOGS_REASON_NULL;
					display_info.iconindex	  = REMIND_COMPLETE;
					info_dialog (win, &display_info); 
					break;
				default:
					break;
				}
#endif
				MMS_Menu_Folder_destroy(data->win);
				switch(gCurMMSPos)
				{
				case MMS_SEND_FOLDER:
					dialog_info_init(&display_info);
					display_info.RightSoftKey = TxtSoftBack;
					//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
					display_info.Time         = TWO_SECS;
					display_info.KeyEvents    = KEY_RIGHT;
					display_info.TextId2      = TxtMMSSendFolderEmpty;
					display_info.Callback     = (T_VOID_FUNC)NULL;
					display_info.Identifier   = DIALOGS_REASON_NULL;
					display_info.iconindex	  = REMIND_COMPLETE;
					info_dialog (parent, &display_info); 
					break;
				case MMS_RECV_FOLDER:
					dialog_info_init(&display_info);
					display_info.RightSoftKey = TxtSoftBack;
					//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
					display_info.Time         = TWO_SECS;
					display_info.KeyEvents    = KEY_RIGHT;
					display_info.TextId2      = TxtMMSRecvFolderEmpty;
					display_info.Callback     = (T_VOID_FUNC)NULL;
					display_info.Identifier   = DIALOGS_REASON_NULL;
					display_info.iconindex	  = REMIND_COMPLETE;
					info_dialog (parent, &display_info); 
					break;
				case MMS_DRAFT_FOLDER:
					dialog_info_init(&display_info);
					display_info.RightSoftKey = TxtSoftBack;
					//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
					display_info.Time         = TWO_SECS;
					display_info.KeyEvents    = KEY_RIGHT;
					display_info.TextId2      = TxtMMSDraftFolderEmpty;
					display_info.Callback     = (T_VOID_FUNC)NULL;
					display_info.Identifier   = DIALOGS_REASON_NULL;
					display_info.iconindex	  = REMIND_FAILURE;
					info_dialog (parent, &display_info); 
					break;
				case MMS_SENT_FOLDER:
					dialog_info_init(&display_info);
					display_info.RightSoftKey = TxtSoftBack;
					//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
					display_info.Time         = TWO_SECS;
					display_info.KeyEvents    = KEY_RIGHT;
					display_info.TextId2      = TxtMMSSentFolderEmpty;
					display_info.Callback     = (T_VOID_FUNC)NULL;
					display_info.Identifier   = DIALOGS_REASON_NULL;
					display_info.iconindex	  = REMIND_COMPLETE;
					info_dialog (parent, &display_info); 
					break;
				default:
					break;
				}
//				SEND_EVENT (parent, event, 0, NULL);				
			}
		}
		break;
		
	case E_ABORT:      
		MMS_Menu_Folder_destroy(data->win);
		SEND_EVENT (parent, event, 0, NULL); /* forward event to parent */
		break;
	default:
		return;
	};
	return;
}

static void MMS_Menu_Folder_listmenu_create(T_MMS_MENU_FOLDERS *data)
{
	int i=0;
	pMessage	msglist;
	P_MMS	mms = getMMS();
	
	MMS_TRACE_FUNCTION("MMS_Menu_Folder_listmenu_create");
	switch( data->winID )
	{
	case MMS_SEND_FOLDER:
		data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtMMSSendFolder);
		break;
	case MMS_RECV_FOLDER:
		data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtMMSRecvFolder);	
		break;
	case MMS_DRAFT_FOLDER:
		data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtMMSDraftFolder);
		break;
	case MMS_SENT_FOLDER:
		data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtMMSSentFolder);
		break;
	}
    
	MMS_TRACE_EVENT(("MMS_Menu_Folder_listmenu_create()"));
	MMS_TRACE_EVENT(("the message number in current folder is:%d",mms->manager->currentfolder->messagenumber));
	
	
	data->list_menu_data.ListPosition   = iMsgListIndex+1;
	data->list_menu_data.CursorPosition = iMsgListIndex+1;
	data->list_menu_data.SnapshotSize   = mms->manager->currentfolder->messagenumber;
	data->list_menu_data.Font           = 0;
	data->list_menu_data.LeftSoftKey    = TxtSoftSelect;
	data->list_menu_data.RightSoftKey   = TxtSoftBack;
	data->list_menu_data.KeyEvents      = KEY_ALL^KEY_CALL;//KEY_RIGHT|KEY_LEFT | KEY_MNUUP | KEY_MNUDOWN;
	data->list_menu_data.Reason         = 0;
	data->list_menu_data.Strings        = TRUE; 
	data->list_menu_data.Attr           = &MMS_Menu_Folder_Attrib;
	data->list_menu_data.autoDestroy    = TRUE;
	
	data->list_menu_data.List = (MfwMnuItem *)ALLOC_MEMORY ((mms->manager->currentfolder->messagenumber) * sizeof (MfwMnuItem));		
	data->list_menu_data.ListMenuFlag=1;
	data->list_menu_data.ListLength = mms->manager->currentfolder->messagenumber; 
	data->list_menu_data.autoDestroy = TRUE;
	
	for(msglist=mms->manager->currentfolder->root; msglist; msglist=msglist->next)
	{
		data->list_menu_data.List[i].icon =&textlistIcon;
		data->list_menu_data.List[i].exta = 0;
		data->list_menu_data.List[i].edit = 0;
		data->list_menu_data.List[i].menu = 0;
		data->list_menu_data.List[i].func = 0; 
		data->list_menu_data.List[i].flagFunc = item_flag_none;
		
		if(msglist->title && msglist->title[0] != '\0')
		{
			data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( MMS_TITLE_NUM_LENGTH);
			wstrcpy(data->list_menu_data.List[i].str ,(char *) (msglist->title));
		}
		
		else
		{				
			data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY (MMS_TITLE_NUM_LENGTH);
			data->list_menu_data.List[i].str[0] = '\0';
		}
		i++;
	}
	data->msgNum = i;
	//manager_set_currentmessage(mms->manager->currentfolder, 1);
	listDisplayListMenu(data->win, &data->list_menu_data, (ListCbFunc)MMS_Menu_Folder_listmenu_cb,0);
	
}

static void MMS_Menu_Folder_listmenu_cb (T_MFW_HND * win, ListMenuData * ListData)
{
      T_MFW_WIN         * win_data = ((T_MFW_HDR *)win)->data;
      T_MMS_MENU_FOLDERS    * data   = (T_MMS_MENU_FOLDERS *)win_data->user;
	  P_MMS mms = getMMS();
	  pMessage  curMsg  = NULL;
  	  pMessage	msglist = NULL;

	MMS_TRACE_FUNCTION("MMS_Menu_Folder_listmenu_cb");
	
      switch( ListData->Reason )
      {
	  case LISTS_REASON_OK:
      case LISTS_REASON_SELECT:
//		iMsgListIndex = data->list_menu_data.CursorPosition;
        iMsgListIndex = ListData->CursorPosition;
		if(iMsgListIndex <= (mms->manager->currentfolder->messagenumber -1))
		{
#ifdef MMI_MMSTASK_ENABLED/*talcon added for mms task,2004.07.19*/
			{
			mmsui_data->temp_win = info_mms_dialog(win); 
			mmsui_data->current_win = win;
			mmsui_data->folderType = data->winID;
			}
			{
			T_MMI_MMS_MSETCMSG_IND parameter;
			parameter.pFolder = mms->manager->currentfolder;
			parameter.index =  iMsgListIndex + 1;
			MMS_TRACE_EVENT(("0x%08x,0x%08x,%d", mms->manager, mms->manager->currentfolder,parameter.index));
			MMS_TRACE_EVENT(("type:%d,n:%d,unsel:%d,prote:%d,size:%d,0x%08x,0x%08x",mms->manager->currentfolder->type,mms->manager->currentfolder->messagenumber,mms->manager->currentfolder->unsettlednumber,mms->manager->currentfolder->protectednumber,mms->manager->currentfolder->size,mms->manager->currentfolder->currentmessage,mms->manager->currentfolder->root));
			M_MMI_MMS_MSETCMSG_IND(  &parameter);
			}
#else
		    manager_set_currentmessage(mms->manager->currentfolder, iMsgListIndex + 1);
		    curMsg = mms->manager->currentfolder->currentmessage;
#endif
			}
#ifndef MMI_MMSTASK_ENABLED
        if(curMsg && curMsg->state != MMS_MSG_TYPE_UNNOTI)
		{
		    MMS_Folders_Play_start(data->win , data->winID);
		}
		else
			MMS_Folder_Detail_start(data->win);
#endif
        break;
  		
      case LISTS_REASON_BACK: 
        MMS_Menu_Folder_destroy(data->win);
        break;
  		
	  case LISTS_REASON_UP:
		for(msglist=mms->manager->currentfolder->root; msglist->next; msglist=msglist->next)
		 {
			  if(msglist->next == mms->manager->currentfolder->currentmessage)
			  {
				  mms->manager->currentfolder->currentmessage = msglist;
			  }
		}				  
		break;

      case LISTS_REASON_DOWN:
		if(mms->manager->currentfolder->currentmessage->next)
		{
			mms->manager->currentfolder->currentmessage = mms->manager->currentfolder->currentmessage->next;
		}			  
		break;

	  case LISTS_REASON_HANGUP:
         /*if(mms->manager)
		 {
			 manager_on_destroy();
			 mms->manager = NULL;
		 }*/
         break;
      default:
        break;
      }
      return; 
}

static void  MMS_Menu_Folder_destroy (T_MFW_HND window)
{

	T_MFW_WIN              * win_data;
	T_MMS_MENU_FOLDERS     * data;
	USHORT i;
//	pMessage	pMsg;
//	P_MMS		mms = getMMS();	
	MMS_TRACE_FUNCTION("MMS_Menu_Folder_destroy");
		
	if( window )
	{
	    win_data = ((T_MFW_HDR *)window)->data;
	    data     = (T_MMS_MENU_FOLDERS *)win_data->user;
			
	    if( data )
	    {	 
		     win_delete (data->win);
			 MMS_Set_MsgList_WHnd(NULL);
//	         for( i = 0; i < mms->manager->currentfolder->messagenumber; i++ )
			 for(i=0; i < data->msgNum; i++)
	             FREE_MEMORY( (void *)(data->list_menu_data.List[i].str), MMS_TITLE_NUM_LENGTH);
	         FREE_MEMORY ((void *)data->list_menu_data.List, data->msgNum* sizeof (MfwMnuItem)); 
	         FREE_MEMORY ((void *)data, sizeof (T_MMS_MENU_FOLDERS));
	    }
	    else
	    {
	         ;
	    }
	}
}

//MMSŽ
static T_MFW_HND MMS_Folders_Play_start(MfwHnd parent_window, MMS_FOLDER_TYPE folderType)
{
    T_MFW_HND win;	
	MMS_TRACE_FUNCTION("MMS_Folders_Play_start");
    win = MMS_Folders_Play_create (parent_window, folderType);	
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, NULL, NULL);
    }
    return win;
}

static T_MFW_HND MMS_Folders_Play_create(T_MFW_HND parent_window, MMS_FOLDER_TYPE folderType)
{
   	T_MMS_FOLDERS_PLAYER      * data = (T_MMS_FOLDERS_PLAYER *)ALLOC_MEMORY (sizeof (T_MMS_FOLDERS_PLAYER));
    T_MFW_WIN  * win;
	PlayerInitRetVal playerVal;
	P_MMS mms = getMMS();
	MMS_TRACE_FUNCTION("MMS_Folders_Play_create");
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)MMS_Folders_Play_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
	
	data->winID = folderType;
    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Folders_Play_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
	
	//ĳʼ
	if(mms->player == NULL)
	{
#ifdef MMI_MMSTASK_ENABLED
	mmsui_data->temp_win = info_mms_dialog(win);
	mmsui_data->current_win = win;
{
	T_MMI_MMS_PLAYERINITIALIZE_IND  parameter;
	parameter.event = PLAYER_INIT_PLAY;
	MMSTASK_DELAY(10);
	M_MMI_MMS_PLAYERINITIALIZE_IND(&parameter);
	MMSTASK_DELAY(10);
}
#else
		mms->player = player_initialize(PLAYER_INIT_PLAY, &playerVal);//PLAYER_INIT_PREVIEW	༭ʱֱԤ
		if(playerVal != Normal)
		{
			MMS_TRACE_EVENT(("player initialize error in MMS_Folders_Play_create"));
		}
#endif
		mmsPlayerState = PLAY;
	}
    return data->win;
}

static void MMS_Folders_Play_destroy(T_MFW_HND win)
{
	T_MFW_WIN              * win_data;
    T_MMS_FOLDERS_PLAYER     * data;
	P_MMS mms = getMMS();
	
	MMS_TRACE_FUNCTION("MMS_Folders_Play_destroy");
    if(win)
    {
        win_data = ((T_MFW_HDR *)win)->data;
        data = (T_MMS_FOLDERS_PLAYER *)win_data->user;
		
        if( data )
        {
            win_delete (data->win);
            FREE_MEMORY ((void *)data, sizeof (T_MMS_FOLDERS_PLAYER));

			if(mms->player)
			{
				player_on_stop();
				player_destrory( PLAYER_INIT_PLAY);
				mms->player = NULL;
				mmsPlayerState = STOP;
			}
			return;
        }
        else
        {
            MMS_TRACE_EVENT((" "));
        }
    }
}

static void MMS_Folders_Play_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_FOLDERS_PLAYER  * data     = (T_MMS_FOLDERS_PLAYER *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
	
    char * title;
	MMS_TRACE_FUNCTION("MMS_Folders_Play_dialog");
    switch( event )
    {
    case E_INIT:
        /* initialization of administrative data */      
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)MMS_Folders_Play_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)MMS_Folders_Play_kbd_cb);
        winShow(win);
        break;

	case E_RETURN: 
    case E_EXIT: 
    case E_BACK: 
//		winShow(win);//deleted by xie 04-07-13
		break;	
		
    case E_ABORT:  
		MMS_Folders_Play_destroy(data->win);
		SEND_EVENT (parent, E_BACK, 0, NULL);
		break;
		
    default:
       break;
    }
	return;
}

static int MMS_Folders_Play_kbd_cb(MfwEvt e, MfwKbd *k)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDERS_PLAYER      * data = (T_MMS_FOLDERS_PLAYER *)win_data->user;
    T_MFW_HND parentHnd;
	P_MMS mms = getMMS();
	pMMS_Slide   pSlide = NULL;
	unsigned char curPage = 0;
	unsigned char pageNum = 0;
	unsigned char curSlide = 0;
	unsigned char slideNum = 0;
        int pageNumMod;

MMS_TRACE_FUNCTION("MMS_Folders_Play_kbd_cb");

#ifdef MMI_MMSTASK_ENABLED
	{
		extern BYTE get_mmstask_proc();
		if( get_mmstask_proc() )
		{
			MMS_TRACE_EVENT(("mms task in proc"));
			return MFW_EVENT_REJECTED;
		}
	}
#endif
	if( mms->player && mms->player->eDocument)
	{
		pSlide = mms->player->eDocument->slide_cur;
	}

	if(pSlide)
	{
		curSlide = (unsigned char)player_get_slideindex();
		slideNum = (unsigned char)player_get_slidecount();
		curPage  = (unsigned char)pSlide->page_no;
		pageNum  = (unsigned char)(pSlide->pagelength/PLAYER_H);
		pageNumMod = pSlide->pagelength%PLAYER_H;
		if(pageNumMod > 0)
			pageNum = pageNum +1;
		else if(pageNumMod < 0)
			pageNum = pageNum -1;
	}

	MMS_TRACE_FUNCTION("MMS_Folders_Play_kbd_cb");
    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
	
			if(mms->player)
			{
				player_on_stop();
				player_destrory(PLAYER_INIT_PLAY);
				mms->player = NULL;
				mmsPlayerState = STOP;
			}
/*
			if(mms->manager)
			{
			    MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}
			*/
			iMsgListIndex = 0;
            returntoidle(0);
            //mnuEscape(data->menu);
            break;
        case KCD_RIGHT: /* Power Down */
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
			if(pageNum > 1 && curPage > 0 && curPage <= pageNum-1)
			{
#ifdef MMI_MMSTASK_ENABLED
				{
					T_MMI_MMS_PLAYERONPAGE_IND parameter;
					parameter.event = 0;
					mmsui_data->current_win = win  ;
					M_MMI_MMS_PLAYERONPAGE_IND(&parameter);
				}
#else
				player_on_pageup();
#endif
				//				winShow( win );
				MMSDrawScrollBar(curPage, pageNum);
			}
            break;
        case KCD_MNUDOWN: /* highlight next entry */
			if(pageNum > 1 && curPage >= 0 && curPage < pageNum-1)
			{
#ifdef MMI_MMSTASK_ENABLED
				{
					T_MMI_MMS_PLAYERONPAGE_IND parameter;
					parameter.event = 1;
					mmsui_data->current_win = win  ;
					M_MMI_MMS_PLAYERONPAGE_IND(&parameter);
				}
#else
              		 player_on_pagedown();
#endif
				MMSDrawScrollBar(curPage+2, pageNum);
				//				winShow( win );
			}
            break;
		case KCD_MNURIGHT:
			if(slideNum >1 && curSlide >= 0 && curSlide < slideNum-1)
			{
				char title[10];
				displaySoftKeys(TxtSoftOptions,TxtSoftBack);
				sprintf(title,"%d/%d",curSlide+2,slideNum);
				drawcolorclarity((SCREEN_SIZE_X- get_StringWidth(title))/2,SCREEN_SIZE_Y-dspl_GetFontHeight()-1,title, 0x000000);
				player_on_stop();
#ifdef MMI_MMSTASK_ENABLED
				{
					T_MMI_MMS_PLAYERONPAGE_IND parameter;
					parameter.event = 2;
					mmsui_data->current_win = win  ;
					M_MMI_MMS_PLAYERONPAGE_IND(&parameter);
				}
#else
				player_on_pagenext();
#endif
				
				pSlide = mms->player->eDocument->slide_cur;
				curPage  = (unsigned char)pSlide->page_no;
				pageNum  = (unsigned char)(pSlide->pagelength/PLAYER_H);
				pageNumMod = pSlide->pagelength%PLAYER_H;
				if(pageNumMod > 0)
					pageNum = pageNum +1;
				else if(pageNumMod < 0)
					pageNum = pageNum -1;
				
				MMSDrawScrollBar(curPage+1, pageNum);
				//				winShow( win );
			}
			break;
        case KCD_MNULEFT:
			if(slideNum >1 && curSlide > 0 && curSlide <= slideNum-1)
			{
				char title[10];
				displaySoftKeys(TxtSoftOptions,TxtSoftBack);
				sprintf(title,"%d/%d",curSlide,slideNum);
				drawcolorclarity((SCREEN_SIZE_X- get_StringWidth(title))/2,SCREEN_SIZE_Y-dspl_GetFontHeight()-1,title, 0x000000);
				player_on_stop();
#ifdef MMI_MMSTASK_ENABLED
				{
					T_MMI_MMS_PLAYERONPAGE_IND parameter;
					parameter.event = 3;
					mmsui_data->current_win = win  ;
					M_MMI_MMS_PLAYERONPAGE_IND(&parameter);
				}
#else
				player_on_pagelast();
#endif
				
				pSlide = mms->player->eDocument->slide_cur;
				curPage  = (unsigned char)pSlide->page_no;
				pageNum  = (unsigned char)(pSlide->pagelength/PLAYER_H);
				pageNumMod = pSlide->pagelength%PLAYER_H;
				if(pageNumMod > 0)
					pageNum = pageNum +1;
				else if(pageNumMod < 0)
					pageNum = pageNum -1;
				
				MMSDrawScrollBar(curPage+1, pageNum);
				//				winShow( win );
			}
			break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:
			switch( data->winID )
			{
			case MMS_SEND_FOLDER:
				if(mms->player)
				  player_on_stop();
				MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSSendFolderOptionMenuAttributes());  
				break;
			case MMS_RECV_FOLDER:
				if(mms->player)
					player_on_stop();
				MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSRecvFolderOptionMenuAttributes());  

                                #if 0
				/*talcon ad,2004.07.13*/
				if(mms->manager && mms->manager->currentfolder )
				{
					pMessage pMsg = NULL;
					pMsg = mms->manager->currentfolder->currentmessage;
					MMS_TRACE_EVENT(("MMS_Folders_Play_kbd_cb: pMsg->state -%d",pMsg->state));
					if(pMsg->state == MMS_MSG_TYPE_UNNOTI)
						MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSRetrieveMsgOptionMenuAttributes());  
					else
				MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSRecvFolderOptionMenuAttributes());  
				}
                                #endif 

				break;
			case MMS_DRAFT_FOLDER:
				if(mms->player)
					player_on_stop();
				MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSDraftFolderOptionMenuAttributes());  
				break;
			case MMS_SENT_FOLDER:
				if(mms->player)
					player_on_stop();
				MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSSentFolderOptionMenuAttributes());  
				break;
			}
            break;
        case KCD_HUP: /* back to previous menu */
			/*if(mms->manager)
			{
				manager_on_destroy();
				mms->manager = NULL;
				MMS_Codec_Destory();
			}*/
			
			if(mms->player)
			{
				player_destrory(PLAYER_INIT_PLAY);
				mms->player = NULL;
				mmsPlayerState = STOP;
			}
			iMsgListIndex = 0;
            returntoidle(0);
            break;
        case KCD_RIGHT: /* back to previous menu */
			parentHnd = data->parent;
			MMS_Folders_Play_destroy(data->win);
            SEND_EVENT (parentHnd, E_BACK, 0, NULL);
//			SEND_EVENT (data->parent, E_BACK, 0, NULL);
            break;
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;
}

static int MMS_Folders_Play_win_cb(MfwEvt e, MfwWin *w)
{
	P_MMS mms = getMMS();
	pMMS_Slide   pSlide;
	MMS_TRACE_FUNCTION("MMS_Folders_Play_win_cb");
    if( mms->player )
	{
		pSlide = mms->player->eDocument->slide_cur;
		if(!pSlide )
		{
			return MFW_EVENT_REJECTED;
		}
	}

	switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
#ifdef MMI_MMSTASK_ENABLED 
		if(mms->player)
#endif
		{
			unsigned int oldcolor = dspl_SetBkgColor(0xffffff);
			char title[10];
			unsigned char curSlide = (unsigned char)player_get_slideindex();
			unsigned char slideNum = (unsigned char)player_get_slidecount();
			unsigned char curPage = (unsigned char)pSlide->page_no;
			unsigned char pageNum = (unsigned char)(pSlide->pagelength/PLAYER_H);
			int pageNumMod = pSlide->pagelength%PLAYER_H;
			if(pageNumMod > 0)
				pageNum = pageNum +1;
			else if(pageNumMod < 0)
				pageNum = pageNum -1;
			
			dspl_ClearAll();          
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
				menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
				menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
			
			dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(MmiRsrcGetText(TxtMMSPlay)))/2, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtMMSPlay), 0x0);    	  

			
			displaySoftKeys(TxtSoftOptions,TxtSoftBack);			
			sprintf(title,"%d/%d",curSlide+1,slideNum);
			drawcolorclarity((SCREEN_SIZE_X- get_StringWidth(title))/2,SCREEN_SIZE_Y-dspl_GetFontHeight()-1,title, 0x000000);
			
			MMSDrawScrollBar(curPage+1, pageNum);
#ifdef MMI_MMSTASK_ENABLED
			{/*talcon added for mms task,2004.07.17*/
			T_MMI_MMS_PLAYERONDRAW_IND parameter;
			mmsui_data->current_win= ((T_MMS_FOLDERS_PLAYER*)w->user)->win;
			M_MMI_MMS_PLAYERONDRAW_IND(  &parameter);
			}
#else
			player_on_draw();
#endif
			dspl_SetBkgColor(oldcolor);
		}
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}



//˵ѡ
T_MFW_HND MMS_Folder_Opt_start(MfwHnd parent_window , MfwMnuAttr *menuAttr)
{
    T_MFW_HND win;	

MMS_TRACE_FUNCTION("MMS_Folder_Opt_start");
    win = MMS_Folder_Opt_create (parent_window);	
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, NULL, (void *)menuAttr);
    }
    return win;
}

T_MFW_HND MMS_Folder_Opt_create(T_MFW_HND parent_window)
{
	T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)ALLOC_MEMORY (sizeof (T_MMS_FOLDER_OPT));
    T_MFW_WIN  * win;

	T_MFW_WIN    * parentWin   =  ((T_MFW_HDR *)parent_window)->data;
    T_MMS_FOLDERS_PLAYER  * parent_data =  (T_MMS_FOLDERS_PLAYER *)parentWin->user;
	MMS_TRACE_FUNCTION("MMS_Folder_Opt_create");
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)MMS_Folder_Opt_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    /* 
	* connect the dialog data to the MFW-window
	*/
	
    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Folder_Opt_dialog;
    data->mmi_control.data   = data;
	data->winID              = parent_data->winID;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    return data->win;
}

static void MMS_Folder_Opt_destroy(T_MFW_HND win)
{
    T_MFW_WIN            * win_data;
    T_MMS_FOLDER_OPT     * data;
MMS_TRACE_FUNCTION("MMS_Folder_Opt_destroy");
    if(win)
    {
        win_data = ((T_MFW_HDR *)win)->data;
        data = (T_MMS_FOLDER_OPT *)win_data->user;

        if( data )
        {
            win_delete (data->win);
            FREE_MEMORY ((void *)data, sizeof (T_MMS_FOLDER_OPT));
        }
        else
        {
            ;
        }
    }
}

static void MMS_Folder_Opt_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_FOLDER_OPT  * data     = (T_MMS_FOLDER_OPT *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;
    T_MMS_FOLDERS_PLAYER  * parent_data =  (T_MMS_FOLDERS_PLAYER *)win_data2->user;
//	MMS_FOLDER_TYPE parentWinId =parent_data->winID;

    char * title;
	MMS_TRACE_FUNCTION("MMS_Folder_Opt_dialog");
    switch( event )
    {
    case E_INIT:
        /* initialization of administrative data */
        data->parent_data = parent_data;        
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)MMS_Folder_Opt_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)MMS_Folder_Opt_kbd_cb);
        title = (char *) MmiRsrcGetText(TxtSoftOptions);  // get the editor title text

        data->menu = mnuListCreate(data->win,(MfwMnuAttr*)parameter, E_MNU_ESCAPE, (MfwCb)MMS_Folder_Opt_mnu_cb,title);
        mnuLang(data->menu,mainMmiLng);
        /* put the (new) dialog window on top of the window stack */
        mnuUnhide(data->menu);
        winShow(win);
        break;

	case E_RETURN: 
		MMS_Folder_Opt_destroy(data->win);
		switch( data->winID)
		{
		case MMS_SEND_FOLDER:
			MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSSendFolderOptionMenuAttributes());  
			break;
		case MMS_RECV_FOLDER:
			{
				P_MMS mms = getMMS();
				pMessage pMsg = NULL;
				if(mms->manager && mms->manager->currentfolder )
				{
					pMsg = mms->manager->currentfolder->currentmessage;
					MMS_TRACE_EVENT(("MMS_Folder_Opt_dialog: pMsg->state -%d",pMsg->state));
					if(pMsg->state == MMS_MSG_TYPE_UNNOTI)
						MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSRetrieveMsgOptionMenuAttributes());  
					else
			            MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSRecvFolderOptionMenuAttributes());  
				}
			}
			break;
		case MMS_DRAFT_FOLDER:
			MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSDraftFolderOptionMenuAttributes());  
			break;
		case MMS_SENT_FOLDER:
			MMS_Folder_Opt_start(win, (MfwMnuAttr *)MMSSentFolderOptionMenuAttributes());  
			break;
		}
		break;
		
    case E_EXIT: 
    case E_BACK:  
		MMS_Folder_Opt_destroy(data->win);//add by xie
		SEND_EVENT (parent, event, 0, NULL);
		break;
		
    case E_ABORT:      
        MMS_Folder_Opt_destroy(data->win);
        SEND_EVENT (parent, E_BACK, 0, NULL); /* forward event to parent */
		break;

    default:
        return;
    }
}

static int MMS_Folder_Opt_kbd_cb(MfwEvt e, MfwKbd *k)
{
    T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	P_MMS mms = getMMS();
	MMS_TRACE_FUNCTION("MMS_Folder_Opt_kbd_cb");
    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
			/*if(mms->manager)
			{
				manager_on_destroy();
				mms->manager = NULL;
				MMS_Codec_Destory();
			}*/
		
			if(mms->player)
			{
				player_destrory(PLAYER_INIT_PLAY);
				mms->player = NULL;
				mmsPlayerState = STOP;
			}
            iMsgListIndex = 0;
            returntoidle(0);
            //mnuEscape(data->menu);
            break;
        case KCD_RIGHT: /* Power Down */
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
            mnuUp(data->menu);
            break;
        case KCD_MNUDOWN: /* highlight next entry */
            mnuDown(data->menu);
            break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:
            mnuSelect(data->menu);
            break;
        case KCD_HUP: /* back to previous menu */
			/*if(mms->manager)
			{
				manager_on_destroy();
				mms->manager = NULL;
				MMS_Codec_Destory();
			}*/

			if(mms->player)
			{
				player_destrory(PLAYER_INIT_PLAY);
				mms->player = NULL;
				mmsPlayerState = STOP;
			}
			iMsgListIndex =0;
            returntoidle(0);
            break;
        case KCD_RIGHT: /* back to previous menu */
            mnuEscape(data->menu);
            break;
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;//when change to MFW_EVENT_REJECTED,deleting string will lead to collapsed.
}

static int MMS_Folder_Opt_mnu_cb ( MfwEvt e, MfwMnu *m )
{ 
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent      =  data->parent;
MMS_TRACE_FUNCTION("MMS_Folder_Opt_mnu_cb");
    switch( e )
    {
    case E_MNU_ESCAPE: /* back to previous menu */
        MMS_Folder_Opt_destroy(data->win);
		SEND_EVENT (parent, E_BACK, 0, NULL);
        break;
    default: /* in mnuCreate() only E_MNU_ESCAPE has been enabled! */
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

static int MMS_Folder_Opt_win_cb(MfwEvt e, MfwWin *w)
{
MMS_TRACE_FUNCTION("MMS_Folder_Opt_win_cb");
    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        dspl_ClearAll();
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

int MMS_Folder_Opt_Retrieve (MfwMnu* m, MfwMnuItem* i)
{
	pMMI_MMS_EVENT temp;
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent      =  data->parent;
	T_DISPLAY_DATA display_info;

	 pMessage pCurrentMsg;
	 
    MMS_TRACE_FUNCTION("MMS_Folder_Opt_Retrieve");

	pCurrentMsg = manager_get_currentmsg(manager_get_currentfolder());

	/*dialog_info_init(&display_info);
	display_info.LeftSoftKey    = TxtNull;
	display_info.RightSoftKey	= TxtCancel;	
	display_info.TextId         = TxtMMSRetrieving;
	display_info.TextId2        = TxtMMSPleaseWaitting;
	display_info.Callback       = (T_VOID_FUNC)MMS_Retrieving_dialog_cb;
	display_info.Time           = FOREVER;
	display_info.KeyEvents      = KEY_RIGHT | KEY_HUP;
	display_info.iconindex      = REMIND_WAITTING;
	
	iddMMSRetrieving.hndParent  = data->win;
	iddMMSRetrieving.hndInfo    = info_dialog(win,&display_info); 
	*/
	MMS_Folder_Opt_destroy(win);
	if(iMsgListIndex >= 1)
		iMsgListIndex = iMsgListIndex -1;
	SEND_EVENT(parent, E_ABORT, 0 , NULL);
	info_mms_screen(0,MMS_SCREEN_ID_RETRIEVE);
	//mms_test_recv_message();
/*talcon added 2004.07.15*/
#ifdef MMS_WAP_ENABLED
	{
		extern void MMS_Force_Recv(char* filename);
		MMS_Force_Recv(pCurrentMsg->filename);
	}
#endif
	
//    MMS_MMI_NewMMS_notification(temp);
#if 0
	MMS_Folder_Opt_destroy(win);
	if(iMsgListIndex >= 1)
		iMsgListIndex = iMsgListIndex -1;
	SEND_EVENT(parent, E_ABORT, 0 , NULL);
#endif
}

#if 0
int MMS_Retrieving_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
	T_MFW_WIN         * win_data    = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT    * data   = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HND              * parent = data->parent;
	
    TRACE_FUNCTION ("SmsRead_dialog_cb()");
	
    switch( Reason )
    {
	case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
		iddMMSRetrieving.hndInfo = NULL;
		MMS_Folder_Opt_destroy(win);
		if(iMsgListIndex >= 1)
			iMsgListIndex = iMsgListIndex -1;
		iddMMSRetrieving.hndParent = NULL;
		SEND_EVENT(parent, E_ABORT, 0 , NULL);
        return MFW_EVENT_CONSUMED;
		
    default:
        return MFW_EVENT_REJECTED;
    }
}	

void   MMS_Retrieving_End(void)
{
	   T_MFW_HND    *parent = iddMMSRetrieving.hndParent;
	   
	   T_MFW_WIN         * winFolderOpt         = ((T_MFW_HDR *)parent)->data;
	   T_MMS_FOLDER_OPT    * dataFolderOpt   = (T_MMS_FOLDER_OPT *)winFolderOpt->user;
       T_MFW_HND       * parentFolderOpt  = dataFolderOpt->parent;  
	   SEND_EVENT(iddMMSRetrieving.hndInfo,DIALOG_DESTROY, NULL,NULL);
	   iddMMSRetrieving.hndInfo = NULL;
	   MMS_Folder_Opt_destroy(dataFolderOpt->win);
	   if(iMsgListIndex >= 1)
		   iMsgListIndex = iMsgListIndex -1;
	   iddMMSRetrieving.hndParent = NULL;
	   SEND_EVENT(parentFolderOpt, E_ABORT, 0 , NULL);   
}
#endif
int MMS_Folder_Opt_Delete          (MfwMnu* m, MfwMnuItem* i)
{   
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent      =  data->parent;
	P_MMS	mms = getMMS();
    MMS_TRACE_FUNCTION("MMS_Folder_Opt_Delete");
	if(mms->manager->currentfolder)
	{
		player_on_stop();   //add by xie 04-08-05 
        manager_on_delete( mms->manager->currentfolder );
		//manager_on_store(); //added by xie for disposing the file deleted
		storemessagefolder(mms->manager->currentfolder);
		MMS_Folder_Opt_destroy(win);
		if(iMsgListIndex >= 1)
		  iMsgListIndex = iMsgListIndex -1;
		SEND_EVENT(parent, E_ABORT, 0 , NULL);
	}   
}

int MMS_Folder_Opt_Replay          (MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent      =  data->parent;

	MMS_TRACE_FUNCTION("MMS_Folder_Opt_Replay");
	/*
	P_MMS	mms = getMMS();
	pMessage	pMsg;
	pMsg = mms->manager->currentfolder->currentmessage;
	editor_on_initialize(EDITOR_INIT_REPLY, pMsg);*/
	player_on_stop();                 //modified by xie 04-07-22
        player_on_replay();
	MMS_Folder_Opt_destroy(win);
}

int MMS_Folder_Opt_Send            (MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win      = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT  * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent =  data->parent;
	T_MFW_WIN  * parent_data = ((T_MFW_HDR *)parent)->data;
    T_MMS_FOLDERS_PLAYER  * data2 = (T_MMS_FOLDERS_PLAYER *)parent_data->user;
    T_MFW_HDR    * folderListHnd = data2->parent;
    
	P_MMS	mms = getMMS();
	pMessage	pMsg;
	
	MMS_TRACE_FUNCTION("MMS_Folder_Opt_Send");
	
	/*talcon added 2004.07.20*/
	winUnMask(parent,MfwWinVisible);
	
	MMS_Folder_Opt_destroy(win);
	MMS_Folders_Play_destroy(parent);

	if(mms->editor==NULL)
	{		
		if(mms->manager && mms->manager->currentfolder && mms->manager->currentfolder->currentmessage)
		{
			pMsg = mms->manager->currentfolder->currentmessage;
#ifdef MMI_MMSTASK_ENABLED
			{
			mmsui_data->temp_win = info_mms_dialog(win); //information screen
			mmsui_data->current_win = folderListHnd;
			}
			{
			T_MMI_MMS_EDTONINIT_IND parameter;
			parameter.event = EDITOR_INIT_EDIT;
			parameter.pMsg=  pMsg;
			M_MMI_MMS_EDTONINIT_IND(  &parameter);
			}
			return;
#else
			mms->editor = editor_on_initialize(EDITOR_INIT_EDIT, pMsg);
			if(mms->editor == NULL)
			{
				MMS_TRACE_EVENT(("editor initialize error in MMS_Folder_Opt_Send"));
			}
#endif
		}
	}

/*  pMsg = editor_get_msg();
	manager_set_currentfolder(mms->manager->draftfolder);
	if(pMsg->receiver && (mms->editor->eDoc->slide_root->text_flag || mms->editor->eDoc->slide_root->audio_type || mms->editor->eDoc->slide_root->image_flag))
	{
		;
	}
	gCurMMSPos   =  data->winID;*/

    MMS_Refresh_FrameData( REFRESH );	
    MMS_Menu_New_start(folderListHnd); 
}

int MMS_Folder_Opt_Reply       (MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win      = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT  * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent =  data->parent;
	T_MFW_WIN  * parent_data = ((T_MFW_HDR *)parent)->data;
    T_MMS_FOLDERS_PLAYER  * data2 = (T_MMS_FOLDERS_PLAYER *)parent_data->user;
    T_MFW_HDR    * folderListHnd = data2->parent;
    
	P_MMS	mms = getMMS();
	pMessage	pMsg;

MMS_TRACE_FUNCTION("MMS_Folder_Opt_Reply");
/*talcon added 2004.07.20*/
	winUnMask(parent,MfwWinVisible);

	MMS_Folder_Opt_destroy(win);
	MMS_Folders_Play_destroy(parent);

	if(mms->editor==NULL)
	{		
		if(mms->manager && mms->manager->currentfolder && mms->manager->currentfolder->currentmessage)
		{
			pMsg = mms->manager->currentfolder->currentmessage;
#ifdef MMI_MMSTASK_ENABLED
			{
			mmsui_data->temp_win = info_mms_dialog(win); 
			mmsui_data->current_win = folderListHnd;
			}
			{
			T_MMI_MMS_EDTONINIT_IND parameter;
			parameter.event = EDITOR_INIT_REPLY;
			parameter.pMsg=  pMsg;
			M_MMI_MMS_EDTONINIT_IND(  &parameter);
			}
			return;
#else
			mms->editor = editor_on_initialize(EDITOR_INIT_REPLY, pMsg);
			if(mms->editor == NULL)
			{
				MMS_TRACE_EVENT(("editor initialize error in MMS_Folder_Opt_Send"));
			}
#endif
		}
	}
	
/*  pMsg = editor_get_msg();
	manager_set_currentfolder(mms->manager->draftfolder);
	if(pMsg->receiver && (mms->editor->eDoc->slide_root->text_flag || mms->editor->eDoc->slide_root->audio_type || mms->editor->eDoc->slide_root->image_flag))
	{
		;
	}
	gCurMMSPos   =  data->winID;*/

    MMS_Refresh_FrameData( REFRESH );	
    MMS_Menu_New_start(folderListHnd);        
}

int MMS_Folder_Opt_Farward        (MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win      = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT  * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent =  data->parent;
	T_MFW_WIN  * parent_data = ((T_MFW_HDR *)parent)->data;
    T_MMS_FOLDERS_PLAYER  * data2 = (T_MMS_FOLDERS_PLAYER *)parent_data->user;
    T_MFW_HDR    * folderListHnd = data2->parent;
    
	P_MMS	mms = getMMS();
	pMessage	pMsg;

    MMS_TRACE_FUNCTION("MMS_Folder_Opt_Farward");

	/*talcon added 2004.07.20*/
	winUnMask(parent,MfwWinVisible);
	
	MMS_Folder_Opt_destroy(win);
	MMS_Folders_Play_destroy(parent);

	if(mms->editor==NULL)
	{		
		if(mms->manager && mms->manager->currentfolder && mms->manager->currentfolder->currentmessage)
		{
			pMsg = mms->manager->currentfolder->currentmessage;
#ifdef MMI_MMSTASK_ENABLED
			{
			mmsui_data->temp_win = info_mms_dialog(win); 
			mmsui_data->current_win = folderListHnd;
			}
			{
			T_MMI_MMS_EDTONINIT_IND parameter;
			parameter.event = EDITOR_INIT_FARWARD;
			parameter.pMsg=  pMsg;
			M_MMI_MMS_EDTONINIT_IND(  &parameter);
			}
			return;
#else
			mms->editor = editor_on_initialize(EDITOR_INIT_FARWARD, pMsg);
			if(mms->editor == NULL)
			{
				MMS_TRACE_EVENT(("editor initialize error in MMS_Folder_Opt_Send"));
			}
#endif
		}
	}

/*  pMsg = editor_get_msg();
	manager_set_currentfolder(mms->manager->draftfolder);
	if(pMsg->receiver && (mms->editor->eDoc->slide_root->text_flag || mms->editor->eDoc->slide_root->audio_type || mms->editor->eDoc->slide_root->image_flag))
	{
		;
	}
	gCurMMSPos   =  data->winID;*/

    MMS_Refresh_FrameData( REFRESH );	
    MMS_Menu_New_start(folderListHnd);  
}

int MMS_Folder_Opt_Callback        (MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent      =  data->parent;
	
	P_MMS mms = getMMS();
	pMessage pMsg = NULL;
	char *strSender = NULL;

	MMS_TRACE_FUNCTION("MMS_Folder_Opt_Callback");
	
	if(mms->manager)
	{ 
		pMsg = mms->manager->currentfolder->currentmessage;
		if(pMsg)
        {
             strSender = pMsg->sender;
			 if(strSender && (unsigned char)strSender[0] != '\0')
			 {
				//callNumber((UBYTE*)strSender);
				 MMS_Folder_Opt_destroy(win);
				 SEND_EVENT(parent, E_ABORT, 0 , NULL);
				 callNumber((UBYTE*)strSender);
			 }
			 else
			 {
				 T_DISPLAY_DATA display_info;
                 dialog_info_init(&display_info);
				 display_info.RightSoftKey = TxtSoftBack;
				 //display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
				 display_info.Time         = TWO_SECS;
				 display_info.KeyEvents    = KEY_RIGHT;
				 display_info.TextId2      = TxtMMSSenderIsEmpty;
				 display_info.Callback     = (T_VOID_FUNC)NULL;
				 display_info.Identifier   = DIALOGS_REASON_NULL;
				 display_info.iconindex	  = REMIND_COMPLETE;
				 info_dialog (win, &display_info); 
			 }
		}
	}
}

int MMS_Folder_Opt_CutAddress      (MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent      =  data->parent;
	P_MMS mms = getMMS();

	pMessage pMsg = NULL;
	char *strSender = NULL;

	MMS_TRACE_FUNCTION("MMS_Folder_Opt_CutAddress");
	
	if(mms->manager)
	{ 
		pMsg = mms->manager->currentfolder->currentmessage;
		if(pMsg)
        {
			strSender = pMsg->sender;
			if(strSender && (unsigned char)strSender[0] != '\0')
			{
				if( bookPhoneBookLoading()==BOOK_SUCCESS )
				{
					T_MFW_HND phbk_win;
					phbk_win = bookPhonebookStart(win,PhbkNameEnterSms);
					SEND_EVENT( phbk_win, PHBK_SEND_NUMBER, 0,(char*)strSender);
				}
				else
				{
					//Ժ
				}  
			}
			else
			{
				T_DISPLAY_DATA display_info;
				dialog_info_init(&display_info);
				display_info.RightSoftKey = TxtSoftBack;
				//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
				display_info.Time         = TWO_SECS;
				display_info.KeyEvents    = KEY_RIGHT;
				display_info.TextId2      = TxtMMSSenderIsEmpty;
				display_info.Callback     = (T_VOID_FUNC)NULL;
				display_info.Identifier   = DIALOGS_REASON_NULL;
				display_info.iconindex	  = REMIND_COMPLETE;
				info_dialog (win, &display_info); 
			}
		}
	}
	return 1;
}

int MMS_Folder_Opt_Details         (MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent      =  data->parent;
     
	 MMS_TRACE_FUNCTION("MMS_Folder_Opt_Details");
	 
	MMS_Folder_Detail_start(data->win); 
}

int MMS_Folder_Opt_MoveToSentFolder(MfwMnu* m, MfwMnuItem* i)
{

	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent      =  data->parent;
	P_MMS	mms = getMMS();
    pMessage pMsg = NULL;
	
	MMS_TRACE_FUNCTION("MMS_Folder_Opt_MoveToSentFolder");
	
	if(mms->manager && mms->manager->currentfolder && mms->manager->currentfolder->currentmessage)
	{
		pMsg = manager_on_pickout(mms->manager->currentfolder);//mms->manager->currentfolder->currentmessage;
//		pMsg->state = MMS_MSG_TYPE_SEND;
		manager_on_addmsg(mms->manager->receivefolder, pMsg);
//		manager_on_delete( mms->manager->currentfolder);
		MMS_Folder_Opt_destroy(win);
		SEND_EVENT(parent, E_ABORT, 0 , NULL);
	}

}


int MMS_Folder_PictureList         (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent      =  data->parent;
	P_MMS mms =  getMMS(); 

	MMS_TRACE_FUNCTION("MMS_Folder_PictureList");

    if(!mms->player)
		return 0;
	player_on_stop();

	if(mms->player->eDocument->slide_cur->image_flag)
	{
		wstrcpy(originMediaFileName, mms->player->eDocument->slide_cur->content_cur->filename); 
		wstrcpy(mmsMediaFileName, mms->player->eDocument->slide_cur->content_cur->filename); 
		MMS_MediaList_Edit_start(win,IMAGE);
	}
	else
	{					
		T_DISPLAY_DATA display_info;
		dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		display_info.Time         = ONE_SECS;
		display_info.KeyEvents    = KEY_RIGHT;
		display_info.TextId2      = TxtMMSNoImageInCurSlide;
		display_info.Callback     = (T_VOID_FUNC)NULL;
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_COMPLETE;
		info_dialog (data->win, &display_info); 
	}
	//	mms->player->slide->image_flag;
	//	mms->player->slide->content_cur->type;
    //	mms->player->slide->content_cur->filename;
}

int MMS_Folder_MusicList           (MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_OPT      * data = (T_MMS_FOLDER_OPT *)win_data->user;
	T_MFW_HDR    * parent      =  data->parent;
	P_MMS mms =  getMMS(); 
	
	MMS_TRACE_FUNCTION("MMS_Folder_MusicList");
	
    if(!mms->player)
		return 0;
	player_on_stop();
 
	if(mms->player->eDocument->slide_cur->audio_type)
	{
		wstrcpy(originMediaFileName, mms->player->eDocument->slide_cur->audiofile); 
	    wstrcpy(mmsMediaFileName, mms->player->eDocument->slide_cur->audiofile); 
		MMS_MediaList_Edit_start(win,MUSIC);
	}
	else
	{
		T_DISPLAY_DATA display_info;
		dialog_info_init(&display_info);
		display_info.RightSoftKey = TxtSoftBack;
		//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
		display_info.Time         = ONE_SECS;
		display_info.KeyEvents    = KEY_RIGHT;
		display_info.TextId2      = TxtMMSNoMusicInCurSlide;
		display_info.Callback     = (T_VOID_FUNC)NULL;
		display_info.Identifier   = DIALOGS_REASON_NULL;
		display_info.iconindex	  = REMIND_COMPLETE;
		info_dialog (data->win, &display_info); 
	}
}

//MMSýб
T_MFW_HND MMS_MediaList_Edit_start(T_MFW_HND parent, MMS_MEDIA_TYPE  winID)
{
    T_MFW_HND win;
    win = MMS_MediaList_Edit_create(parent,winID);
	MMS_TRACE_FUNCTION("MMS_MediaList_Edit_start");
    if( win NEQ NULL )
    {
		SEND_EVENT (win, E_INIT, NULL, NULL);
    }
    return win;
}

T_MFW_HND MMS_MediaList_Edit_create(MfwHnd parent_window, MMS_MEDIA_TYPE  winID)
{	
	T_MMS_MEDIALIST_EDITOR  * data = (T_MMS_MEDIALIST_EDITOR *)ALLOC_MEMORY (sizeof (T_MMS_MEDIALIST_EDITOR));
	T_MFW_WIN  * win;
	MMS_TRACE_FUNCTION("MMS_MediaList_Edit_create");   	   
	data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
	if( data->win EQ NULL )
	{
	   return NULL;
	}

	data->winID              = winID;
	data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_MediaList_Edit_dialog;
	data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
	win->user                = (void *)data;
	data->parent             = parent_window;
	   
    winShow(data->win);
	return data->win;
}

void MMS_MediaList_Edit_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter)
{  
    T_MFW_WIN                  * win_data = ((T_MFW_HDR *) win)->data;
	T_MMS_MEDIALIST_EDITOR      * data = (T_MMS_MEDIALIST_EDITOR *)win_data->user;
    T_MFW_HDR                  * parent      =  data->parent;
    MMS_TRACE_FUNCTION("MMS_MediaList_Edit_dialog");  
	switch(event)
	{
	case E_INIT:
		{			
			switch(data->winID)
			{
			case IMAGE:
				MMS_MediaList_Edit_LoadEditDefault(&(data->editor_info));
            	editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSPicture,(char *)mmsMediaFileName,MMS_FILENAME_LEN	,edtCurBar1);
				data->editor_info.mode                 = SHUZI_MODE; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtMMSSave;	
				data->editor_info.edtInPbk             = 0;
				//data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_MediaList_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
//				data->editor_info.InputMode            = PINYIN_INPUT_MODE;  
				
				//ata->editor_info.editor_attr.e_size   = 163;
				data->editor                           = editor_start(win, &(data->editor_info));
				break;
			case MUSIC:
				MMS_MediaList_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSMusic,(char *)mmsMediaFileName,MMS_FILENAME_LEN,edtCurBar1);
				data->editor_info.mode                 = SHUZI_MODE; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtMMSSave;	
				data->editor_info.edtInPbk             = 0;
				//data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_MediaList_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
//				data->editor_info.InputMode            = PINYIN_INPUT_MODE;  
				
				//ata->editor_info.editor_attr.e_size   = 163;
				data->editor                           = editor_start(win, &(data->editor_info));
				break;
			default:
				return;             
			}
		}
		break;
		
	case E_ABORT:
	case E_EXIT: 
		MMS_MediaList_Edit_destroy(data->win);
        SEND_EVENT (parent, event, 0, NULL); /* forward event to parent */
		break;
	default:
		return;
	}
	return;
}

/*
#define PICTURE_TOTLESIZE		100000
#define MELODY_TOTLESIZE		100000
#define PICTURE_MAXNUMBER		20
#define MELODY_MAXNUMBER		5
#define FILE_NAME_LENGTH		33

typedef struct 
{
UINT8   index;			
char    filename[10];	
char    displayname[FILE_NAME_LENGTH];
UINT	filesize;
UINT8   flag;			
} T_PIC_INFO;

FFSFILE_PICTURE_PATH = "/picture"  ʵļĴλ
"/bmi/pictureinfo";   "/picture"µͼļϢ
T_PIC_INFO Pictureinfodata[PICTURE_MAXNUMBER];
void PictureDirData_Write();


typedef struct 
{
    UINT8   index;		
    char    filename[10];	
	char    displayname[FILE_NAME_LENGTH];
	UINT	filesize;
    UINT8   flag;			
} T_MEL_INFO;
FFSFILE_MELODY_PATH  = "/melody"   ʵļĴλ
"/bmi/melodyinfo";     /melodyļϢ
T_PIC_INFO Melofyinfodata[MELODY_MAXNUMBER];
void MelodyDirData_Write();
 */

void MMS_MediaList_Edit_edit_cb(T_MFW_HND win, USHORT Identifier, SHORT reason)
{
	T_MFW_WIN           * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_MEDIALIST_EDITOR  * data     = (T_MMS_MEDIALIST_EDITOR *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
	char sourceFullName[128];
	char destFullName[128];
	T_FFS_STAT stat;
	P_MMS mms = getMMS();
#ifdef _INNOVATION_EMULATOR_
	WIN32_FIND_DATA FileData; 
#endif

	//0--normal 1--the file already exsit 2--no enough flash space
	unsigned char fileState = 0; 
	unsigned int  iFilesTotalSize = 0;
	unsigned int  iSourceFileSize = 0;
	char j = -1;
	unsigned char i;

    MMS_TRACE_FUNCTION("MMS_MediaList_Edit_edit_cb");  
	switch( reason )
    {
    case INFO_KCD_ALTERNATELEFT:
    case INFO_KCD_LEFT:
		switch(data->winID)
		{
		case MUSIC:	
#if 1
#ifdef _INNOVATION_EMULATOR_
			GetCurrentDirectoryA(sizeof(sourceFullName),sourceFullName);
			wstrcat(sourceFullName,"\\filesystem");
			wstrcat(sourceFullName,"/mms/temp/");
            wstrcat(sourceFullName, originMediaFileName);
			
			GetCurrentDirectoryA(sizeof(destFullName),destFullName);
			wstrcat(destFullName,"\\filesystem");
			wstrcat(destFullName,"/mms/musicfiles/");
            wstrcat(destFullName, mmsMediaFileName);
#else
			wstrcpy(sourceFullName,"/mms/temp/");
            wstrcat(sourceFullName, originMediaFileName);
			
			wstrcpy(destFullName,"/mms/musicfiles/");
            wstrcat(destFullName, mmsMediaFileName);
#endif

#else
			for(i=0;i< PICTURE_MAXNUMBER; i++)
			{
				if('\0' == Pictureinfodata[i].filename[0])
				{
					j=(char)i;
					continue;
				}
                iFilesTotalSize+ = Pictureinfodata[i].filesize;
			}
			
#ifdef _INNOVATION_EMULATOR_
			GetCurrentDirectoryA(sizeof(sourceFullName),sourceFullName);
			wstrcat(sourceFullName,"\\filesystem");
			wstrcat(sourceFullName,"/mms/temp/");
            wstrcat(sourceFullName, originMediaFileName);
#else
			wstrcpy(sourceFullName,"/mms/temp/");
            wstrcat(sourceFullName, originMediaFileName);
#endif
			iSourceFileSize = MMS_fstat(sourceFullName);
			if(j==-1 || (PICTURE_TOTLESIZE - iFilesTotalSize) < iSourceFileSize)
			{
				fileState = 2;
			}
			
			if(fileState != 2)
			{
				for(i=0 ; i< PICTURE_MAXNUMBER ;i++)
				{
					if(!(wstrcmp(mmsMediaFileName,Pictureinfodata[i].displayname)))
					{
						fileState = 1;
						break;
					}
				}
			}
#endif
			break;

		case IMAGE:
#if 1

#ifdef _INNOVATION_EMULATOR_
			GetCurrentDirectoryA(sizeof(sourceFullName),sourceFullName);
			wstrcat(sourceFullName,"\\filesystem");
			wstrcat(sourceFullName,"/mms/temp/");
            wstrcat(sourceFullName, originMediaFileName);
			
			GetCurrentDirectoryA(sizeof(destFullName),destFullName);
			wstrcat(destFullName,"\\filesystem");
			wstrcat(destFullName,"/mms/imagefiles/");
            wstrcat(destFullName, mmsMediaFileName);
#else
			wstrcpy(sourceFullName,"/mms/temp/");
            wstrcat(sourceFullName, originMediaFileName);

			wstrcpy(destFullName,"/mms/imagefiles/");
            wstrcat(destFullName, mmsMediaFileName);
#endif

#else
			for(i=0;i< MELODY_MAXNUMBER; i++)
			{
				if('\0' == Melofyinfodata[i].filename[0])
				{
					j=(char)i;
					continue;
				}
                iFilesTotalSize+ = Melofyinfodata[i].filesize;
			}
			
#ifdef _INNOVATION_EMULATOR_
			GetCurrentDirectoryA(sizeof(sourceFullName),sourceFullName);
			wstrcat(sourceFullName,"\\filesystem");
			wstrcat(sourceFullName,"/mms/temp/");
            wstrcat(sourceFullName, originMediaFileName);
#else
			wstrcpy(sourceFullName,"/mms/temp/");
            wstrcat(sourceFullName, originMediaFileName);
#endif
			iSourceFileSize = MMS_fstat(sourceFullName);
			if(j==-1 || (MELODY_TOTLESIZE - iFilesTotalSize) < iSourceFileSize)
			{
				fileState = 2;
			}
			
			if(fileState != 2)
			{
				for(i=0 ; i< PICTURE_MAXNUMBER ;i++)
				{
					if(!(wstrcmp(mmsMediaFileName,Melofyinfodata[i].displayname)))
					{
						fileState = 1;
						break;
					}
				}
			}

#endif
			break;
		default:
			break;
		}

#if 1

#ifdef _INNOVATION_EMULATOR_
		if(INVALID_HANDLE_VALUE != FindFirstFileA(destFullName, &FileData))	
#else 
		if(EFFS_OK  == ffs_stat(destFullName, &stat))
#endif 
		{
			T_DISPLAY_DATA display_info;
//			MMS_MediaList_Edit_destroy(data->win);
			dialog_info_init(&display_info);
			display_info.RightSoftKey = TxtSoftBack;
			//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
			display_info.Time         = ONE_SECS;
			display_info.KeyEvents    = KEY_RIGHT;
			display_info.TextId2      = TxtMMSAlreadyExist;
			display_info.Callback     = (T_VOID_FUNC)NULL;
			display_info.Identifier   = DIALOGS_REASON_NULL;
			display_info.iconindex	  = REMIND_COMPLETE;
			info_dialog (data->win, &display_info); 
			break;
		}
		else
		{
#ifdef _INNOVATION_EMULATOR_
			FILE *fp1,*fp2;
			int fSize;
			char *buf=NULL;
			fp1 = fopen(sourceFullName, "r+b");
			if(fp1)
			{
				fseek(fp1, 0, SEEK_END);
				fSize = ftell(fp1);
				MMS_new(buf,fSize);
				fseek(fp1,0,SEEK_SET);
				fread(buf, 1, fSize, fp1);
				fclose(fp1);
			}

			fp2 = fopen(destFullName,  "w+b");
			if(fp2)
				fwrite(buf, 1, fSize, fp2);
			fclose(fp2);
			MMS_free(buf,fSize);
			MMS_MediaList_Edit_destroy(data->win);
			SEND_EVENT(parent, E_BACK, NULL, NULL);	
			
#else 
			T_FFS_FD fd;
			T_FFS_SIZE fRet;
			char *buf;
			ffs_stat(sourceFullName, &stat);
			MMS_new(buf,stat.size);
			fd = ffs_open(sourceFullName, FFS_O_RDONLY);
			if(fd)
				fRet = ffs_read(fd,buf,stat.size);
			ffs_close(fd);
			MMS_TRACE_EVENT(("stat.size=%d, fd=%d, buf=%d, fRet= %d",stat.size, fd, &buf,fRet));
			fRet = ffs_file_write(destFullName, buf, fRet,FFS_O_CREATE);
			MMS_TRACE_EVENT(("fRet= %d",fRet));
			rvf_delay(30);
			MMS_free(buf,stat.size);
			MMS_MediaList_Edit_destroy(data->win);
			SEND_EVENT(parent, E_BACK, NULL, NULL);	
#endif 
	}

#else
		if(0==fileSate)
		{			
#ifdef _INNOVATION_EMULATOR_
			FILE *fp1,*fp2;
			int fSize;
			char *buf=NULL;
			char flashFileName[64];
			char *temp = NULL;
			GetCurrentDirectoryA(sizeof(destFullName),destFullName);
			strcat(destFullName,"\\filesystem");
            
			switch(data->winID)
			{
			case MUSIC:
				wstrcpy(Melofyinfodata[j].displayname,mmsMediaFileName);
				strcat(destFullName,FFSFILE_MELODY_PATH);
				strcat(destFullName, "/");
				break;
				
			case IMAGE:
				wstrcpy(Pictureinfodata[j].displayname,mmsMediaFileName);
                strcat(destFullName,FFSFILE_PICTURE_PATH);
				strcat(destFullName, "/");
				break;
			}

            sprintf(flashFileName,"%d",j);
			temp = (char*)strchr(sourceFullName,'.');
			if(temp)
			{
				strcat(flashFileName, temp);		
			}
			strcat(destFullName, flashFileName);

			fp1 = fopen(sourceFullName, "r+b");
			if(fp1)
			{
				fseek(fp1, 0, SEEK_END);
				fSize = ftell(fp1);
				switch(data->winID)
				{
				case MUSIC:
					Melofyinfodata[j].filesize = fSize;
					break;
					
				case IMAGE:
					Pictureinfodata[j].filesize = fSize;
					break;
				}
				MMS_new(buf,fSize);
				fseek(fp1,0,SEEK_SET);
				fread(buf, 1, fSize, fp1);
				fclose(fp1);
			}
			
			fp2 = fopen(destFullName,  "w+b");
			if(fp2)
				fwrite(buf, 1, fSize, fp2);
			fclose(fp2);
			MMS_free(buf,fSize);
			MMS_MediaList_Edit_destroy(data->win);
			SEND_EVENT(parent, E_BACK, NULL, NULL);	
			
#else 
			T_FFS_FD fd;
			T_FFS_SIZE fRet;
			char *buf;

			ffs_stat(sourceFullName, &stat);
			switch(data->winID)
			{
			case MUSIC:
				Melofyinfodata[j].filesize = stat.size;
				wstrcpy(Melofyinfodata[j].displayname,mmsMediaFileName);
				strcat(destFullName,FFSFILE_MELODY_PATH);
				strcat(destFullName, "/");
				break;
				
			case IMAGE:
				Pictureinfodata[j].filesize = stat.size;
				wstrcpy(Pictureinfodata[j].displayname,mmsMediaFileName);
                strcat(destFullName,FFSFILE_PICTURE_PATH);
				strcat(destFullName, "/");
				break;
			}
			
			sprintf(flashFileName,"%d",j);
			temp = (char*)strchr(sourceFullName,'.');
			if(temp)
			{
				strcat(flashFileName, temp);		
			}
            strcat(destFullName, flashFileName);

			MMS_new(buf,stat.size);
			fd = ffs_open(sourceFullName, FFS_O_RDONLY);
			if(fd)
				fRet = ffs_read(fd,buf,stat.size);
			ffs_close(fd);
			MMS_TRACE_EVENT(("stat.size=%d, fd=%d, buf=%d, fRet= %d",stat.size, fd, &buf,fRet));
			fRet = ffs_file_write(destFullName, buf, fRet,FFS_O_CREATE);
			MMS_TRACE_EVENT(("fRet= %d",fRet));
			rvf_delay(30);
			MMS_free(buf,stat.size);
			MMS_MediaList_Edit_destroy(data->win);
			SEND_EVENT(parent, E_BACK, NULL, NULL);	
#endif 
		}
		else if(2== fileState)
		{
			T_DISPLAY_DATA display_info;
			//			MMS_MediaList_Edit_destroy(data->win);
			dialog_info_init(&display_info);
			display_info.RightSoftKey = TxtSoftBack;
			//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
			display_info.Time         = ONE_SECS;
			display_info.KeyEvents    = KEY_RIGHT;
			display_info.TextId2      = TxtMMSNoEnoughFlashSpace;
			display_info.Callback     = (T_VOID_FUNC)NULL;
			display_info.Identifier   = DIALOGS_REASON_NULL;
			display_info.iconindex	  = REMIND_COMPLETE;
			info_dialog (data->win, &display_info); 
			break;
		}
		else if(1==fileState)
		{
			T_DISPLAY_DATA display_info;
			//			MMS_MediaList_Edit_destroy(data->win);
			dialog_info_init(&display_info);
			display_info.RightSoftKey = TxtSoftBack;
			//display_info.LeftSoftKey  = TxtSoftConfirm;//TxtSoftSelect,TxtSoftConfirm,TxtSoftOptions
			display_info.Time         = ONE_SECS;
			display_info.KeyEvents    = KEY_RIGHT;
			display_info.TextId2      = TxtMMAlreadyExist;
			display_info.Callback     = (T_VOID_FUNC)NULL;
			display_info.Identifier   = DIALOGS_REASON_NULL;
			display_info.iconindex	  = REMIND_COMPLETE;
			info_dialog (data->win, &display_info); 
			break;
		}
#endif
        break;

    case INFO_KCD_RIGHT:
		MMS_MediaList_Edit_destroy(data->win);
//		SEND_EVENT (win, E_BACK, 0, NULL);
//		SEND_EVENT (parent, E_EXIT, 0, NULL);
        break;

	case INFO_KCD_HUP:
#if 0
		{
			P_MMS mms = getMMS();
			if(mms->player)
				player_destrory(PLAYER_INIT_PLAY);

			if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}
		}
		if( returntoidle(0) )
			break;
#endif
		MMS_MediaList_Edit_destroy(data->win);
		break;
		
    default:
        TRACE_EVENT("Err: Default");
        break;
    }
}

void MMS_MediaList_Edit_destroy(MfwHnd own_window)
{   
    T_MFW_WIN * win_data;
    T_MMS_MEDIALIST_EDITOR    * data = NULL; 
	MMS_TRACE_FUNCTION("MMS_MediaList_Edit_destroy"); 
    if( own_window )
    {
		win_data = ((T_MFW_HDR *)own_window)->data;
		if( win_data != NULL )
			data = (T_MMS_MEDIALIST_EDITOR *)win_data->user;
		
		if (data)
		{
		    editor_destroy(data->editor);
		    data->editor = 0;
		    win_delete (data->win);
		    FREE_MEMORY ((void *)data, sizeof (T_MMS_MEDIALIST_EDITOR));
		}
	    else
		{
		    TRACE_EVENT (" ");
		}
	}
    
}

void MMS_MediaList_Edit_LoadEditDefault(T_EDITOR_DATA *editor_data)
{	
	editor_attr_init(&editor_data->editor_attr, NULL, edtCurNone, 0, 0, 0);
	editor_data->hide				= FALSE;
	editor_data->min_enter			= 1;  
	editor_data->LeftSoftKey		= TxtSoftSelect;
	editor_data->RightSoftKey		= TxtSoftBack;
	editor_data->AlternateLeftSoftKey   = TxtNull;
	editor_data->TextId				= '\0';  
	editor_data->Identifier			=  0; 
	editor_data->TextString			= NULL;  
	editor_data->timeout			= FOREVER; 
	editor_data->mode                = ALPHA_MODE;
	editor_data->Callback			= NULL;
	editor_data->destroyEditor		= TRUE ; 
}

//ϸϢ
static T_MFW_HND MMS_Folder_Detail_start(MfwHnd parent_window)
{
	T_MFW_HND win;	
	MMS_TRACE_FUNCTION("MMS_Folder_Detail_start");
    win = MMS_Folder_Detail_create (parent_window);	
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT,0, NULL);
    }
    return win;
}

static T_MFW_HND MMS_Folder_Detail_create(T_MFW_HND parent_window)
{
	
	T_MMS_FOLDER_DETAIL      * data = (T_MMS_FOLDER_DETAIL *)ALLOC_MEMORY (sizeof (T_MMS_FOLDER_DETAIL));
    T_MFW_WIN  * win;
	
	MMS_TRACE_FUNCTION("MMS_Folder_Detail_create");
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)MMS_Folder_Detail_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    /* 
	* connect the dialog data to the MFW-window
	*/
	
    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Folder_Detail_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    return data->win;
}

static void MMS_Folder_Detail_destroy(T_MFW_HND win)
{
	T_MFW_WIN            * win_data;
    T_MMS_FOLDER_DETAIL     * data;
	
	MMS_TRACE_FUNCTION("MMS_Folder_Detail_destroy");
    if(win)
    {
        win_data = ((T_MFW_HDR *)win)->data;
        data = (T_MMS_FOLDER_DETAIL *)win_data->user;
		
        if( data )
        {
            win_delete (data->win);
            FREE_MEMORY ((void *)data, sizeof (T_MMS_FOLDER_DETAIL));
        }
        else
        {
            ;
        }
    }
}

static void MMS_Folder_Detail_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_FOLDER_DETAIL  * data     = (T_MMS_FOLDER_DETAIL *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
	
    char * title;
	MMS_TRACE_FUNCTION("MMS_Folder_Detail_dialog");
    switch( event )
    {
    case E_INIT:
        /* initialization of administrative data */       
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)MMS_Folder_Detail_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)MMS_Folder_Detail_kbd_cb);
        winShow(win);
        break;
		
	case E_RETURN: 
    case E_EXIT: 
    case E_BACK:  
//		MMS_Folder_Detail_destroy(data->win);//add by xie
//		SEND_EVENT (parent, event, 0, NULL);
		break;
		
    case E_ABORT:      
        MMS_Folder_Detail_destroy(data->win);
        SEND_EVENT (parent, E_BACK, 0, NULL); /* forward event to parent */
		break;

    default:
        return;
    }
}

static int MMS_Folder_Detail_kbd_cb(MfwEvt e, MfwKbd *k)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_FOLDER_DETAIL      * data = (T_MMS_FOLDER_DETAIL *)win_data->user;
	T_MFW_HND    parent =data->parent;
	P_MMS mms = getMMS();
    MMS_TRACE_FUNCTION("MMS_Folder_Detail_kbd_cb");
    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
			/*if(mms->manager)
			{
				manager_on_destroy();
				mms->manager = NULL;
				MMS_Codec_Destory();
			}*/
			
			if(mms->player)
			{
				player_destrory(PLAYER_INIT_PLAY);
				mms->player = NULL;
				mmsPlayerState = STOP;
			}

			iMsgListIndex = 0;
            returntoidle(0);
            //mnuEscape(data->menu);
            break;

#if 0
		case KCD_LEFT:
            MMS_Folder_Opt_start(win,(MfwMnuAttr *)MMSRetrieveMsgOptionMenuAttributes());
		    break;
#endif

        case KCD_RIGHT: /* Power Down */
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
		/*	if(mms->manager)
			{
				manager_on_destroy();
				mms->manager = NULL;
				MMS_Codec_Destory();
			}
			*/
			
			if(mms->player)
			{
				player_destrory(PLAYER_INIT_PLAY);
				mms->player = NULL;
				mmsPlayerState = STOP;
			}
			iMsgListIndex = 0;
            returntoidle(0);
            break;
        case KCD_LEFT:
            MMS_Folder_Opt_start(win,(MfwMnuAttr *)MMSRetrieveMsgOptionMenuAttributes());
			break;

        case KCD_RIGHT: /* back to previous menu */
			MMS_Folder_Detail_destroy( win );
			SEND_EVENT (parent, E_RETURN, 0, NULL);
            break;
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;
}

static int MMS_Folder_Detail_win_cb(MfwEvt e, MfwWin *w)
{
	P_MMS mms = getMMS();
	pMessage curMsg;
	char *pRec = NULL;
	char strData[24] ;
	int  size =-1;
	char strTemp[20];

	MMS_TRACE_FUNCTION("MMS_Folder_Detail_win_cb");
	memset(strTemp, 0, sizeof(strTemp));

	if(mms->manager && mms->manager->currentfolder)
	{
		curMsg = manager_get_currentmsg(mms->manager->currentfolder);
		if(!curMsg)
          return 0;
	}

	switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        dspl_ClearAll();
		//draw title
		dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
			menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
			menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);


		dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(MmiRsrcGetText(TxtMMSDetails)))/2, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtMMSDetails), 0x0);    	  
		
		dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(MmiRsrcGetText(TxtMMSDetailDate)))/2, FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtMMSDetailDate), 0x0); 			
		msg_get_date(curMsg, strData);
		dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(strData))/2, SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, strData, 0x0);   
		//dspl_colorTextOut((SCREEN_SIZE_X - wstrlen(strData)), SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, (char*)strData, 0x0); 
		
		if(gCurMMSPos == 	MMS_RECV_FOLDER)
		{
			char *pSender = NULL;
			dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(MmiRsrcGetText(TxtMMSDetailFrom)))/2, THIRD_LINE, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtMMSDetailFrom), 0x0);    	  	
			pSender = (char*)curMsg->sender;
			if(pSender)
				dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(pSender))/2, FOURTH_LINE, DSPL_TXTATTR_TRANSPARENT, (char*)pSender, 0x0);    	  
		}
		else
		{
			dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(MmiRsrcGetText(TxtMMSDetailTo)))/2, THIRD_LINE, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtMMSDetailTo), 0x0);    	  	
			pRec = (char*)msg_get_receiver(curMsg);
			if(pRec)
				dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(pRec))/2, FOURTH_LINE, DSPL_TXTATTR_TRANSPARENT, (char*)pRec, 0x0);    	  
		}
		
		dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(MmiRsrcGetText(TxtMMSDetailSize)))/2, FIFTH_LINE, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtMMSDetailSize), 0x0);    	  	
		msg_get_size(curMsg, &size);
		if(size >= 0)
		{
			sprintf(strTemp,"%dByte",size);
			dspl_colorTextOut((SCREEN_SIZE_X-get_StringWidth(strTemp))/2, SIXTH_LINE, DSPL_TXTATTR_TRANSPARENT, (char*)strTemp, 0x0);    	
		}
		
		if(curMsg->state == MMS_MSG_TYPE_UNNOTI)
		{
			displaySoftKeys(TxtSoftOptions,TxtSoftBack);
		}
		else
           displaySoftKeys(NULL,TxtSoftBack);
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}



/************for mms task cnf*****************/
#ifdef MMI_MMSTASK_ENABLED/*talcon added for mms task,2004.07.19*/

/***************************************
$Description:
	player_on_draw_done done in mms task
***************************************/
void player_on_draw_done()
{
	P_MMS mms = getMMS();
  	pMessage  curMsg  = NULL;
	 
	MMS_TRACE_FUNCTION("player_on_draw_done");
}	

/***************************************
$Description:
	manager_set_currentmessage done in mms task
***************************************/
void mms_set_currentmsg_done()
{
	P_MMS mms = getMMS();
  	pMessage  curMsg  = NULL;
	 
	MMS_TRACE_FUNCTION("mms_set_currentmsg_done");
	
	SEND_EVENT(mmsui_data->temp_win, DIALOG_DESTROY, NULL, NULL);

	curMsg = mms->manager->currentfolder->currentmessage;
	if(curMsg  ==0)
	{
		MMS_TRACE_FUNCTION(("curMsg is null!"));
	}

	MMSTASK_DELAY(30);
        if(curMsg && curMsg->state != MMS_MSG_TYPE_UNNOTI)
		    MMS_Folders_Play_start(mmsui_data->current_win , mmsui_data->folderType);
		else
			MMS_Folder_Detail_start(mmsui_data->current_win);
}	

/***************************************
$Description:
	editor_on_initialize_done done in mms task
***************************************/
void editor_on_initialize_done(void *pData)
{
	P_MMS mms = getMMS();
	 
	MMS_TRACE_FUNCTION("editor_on_initialize_done_done");
	SEND_EVENT(mmsui_data->temp_win, DIALOG_DESTROY, NULL, NULL);
	
	mms->editor = pData;
	if(mms->editor == NULL)
	{
		MMS_TRACE_EVENT(("editor initialize error in MMS_Folder_Opt_Send"));
		return;
	}

    MMS_Refresh_FrameData( REFRESH );	
    MMS_Menu_New_start(mmsui_data->current_win);  
}	

/***************************************
$Description:
	player_on_page_done done in mms task
***************************************/
void player_on_page_done(void *pData)
{
	P_MMS mms = getMMS();
	 
	MMS_TRACE_FUNCTION("player_on_page_done");
}

/***************************************
$Description:
	player_initialize_done done in mms task
***************************************/
void player_initialize_done(void *pPlayer, int retval)
{
	P_MMS mms = getMMS();
	 
	MMS_TRACE_FUNCTION("player_initialize_done");

	mms->player = pPlayer;
	if(retval != Normal)
	{
		MMS_TRACE_EVENT(("player initialize failure in MMS_New_Preview_create"));		
	}
	
	SEND_EVENT(mmsui_data->temp_win, DIALOG_DESTROY, NULL, NULL);
}

/***************************************
$Description:
	MMS_DrawXXXAlbum done in mms task
***************************************/
void MMS_DrawXXXAlbum_done()
{
	MMS_TRACE_FUNCTION("MMS_DrawXXXAlbum_done");
}	


#endif

#endif
