#ifdef _MMS_ENABLE_

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)
#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"
#else
#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"
#endif

#include "p_sim.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_str.h"
#include "dspl.h"

#include "MmiMain.h"
#include "MmiDummy.h"
#include "MmiMmi.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiEditor.h"
#include "Mmitextinput.h"
#include "phb.h"  
#include "mmiBookshared.h" 
#include "mmiSmsMenu.h"
#include "mmismssend.h"
#include "mmismsidle.h"

//begin xie 
#include "mmiMMSffs.h"   //add by xie 04-07-08
#include "mmimms_cfg.h"
#include "ffs.h"
#include "mmseditor.h"
#include "mmscfg.h"
#include "manager.h"
#include "mmiMMSGlobalDef.h"
#include "mmimms_cfg.h"  //#include "Mmiutilapi.h"  //modified by xie 04-07-12 
//end xie
#include "atbdata.h"

BOOL gIsMMSInitialized = FALSE;
BOOL gIsNewMMSIncoming = FALSE;
#if 1
static unsigned int gNewMMSNum;  //the sum of new mms,add by xie 04-07-29
void MMS_Increase_NewMMS_Sum()
{
	gNewMMSNum++;
	return;
}
void MMS_Decrease_NewMMS_Sum()
{
	gNewMMSNum--;
	return;
}
void MMS_Set_NewMMS_Sum(unsigned int uiSum)
{
     gNewMMSNum = uiSum;
	 return;
}
#endif
void MMS_Fresh_NewMMS_Sum(void)
{
	MMS_FILE fp;	
	fp = MMS_fopen("/mms/rmfu.txt", "r+b");
	if(fp)
	{
		MMS_fread(&gNewMMSNum,sizeof(gNewMMSNum),1,fp);
		MMS_fclose(fp);
	}
}

unsigned int MMS_Get_NewMMS_Sum()
{
#if 0
	unsigned int uiNewMMSNum;
	MMS_FILE fp;
	fp = MMS_fopen("/mms/rmfu.txt", "r+b");
	if(fp)
	{
		MMS_fread(&uiNewMMSNum,sizeof(uiNewMMSNum),1,fp);
		MMS_fclose(fp);
	}
    return uiNewMMSNum;
#endif	
    return gNewMMSNum;
}

void MMS_Initialize_In_Idle()
{
#if 0
	P_MMS mms = getMMS();	
	if(!(mms->manager))
	{
		mms->manager = (pManager)manager_on_initialize();
		MMS_Codec_Init(APP_PATH);
	}
#else
	MI_manager_on_initialize(MANAGER_MASK_MMSMNU);
#endif
}

void MMS_Destroy_In_Idle()
{
#if 0
    P_MMS mms = getMMS();
	if(mms->manager)
	{
		MMS_Codec_Destory();
		manager_on_destroy();
	}
#else
	MI_manager_on_destroy(MANAGER_MASK_MMSMNU);
#endif
}

MMS_PLAYER_STATE mmsPlayerState = STOP;
MMS_FOLDER_TYPE gCurMMSPos = MMS_NEW;//MMS_Floders_ID is renamed with gCurMMSPos

static T_MFW_HND   gMMSNewHnd = NULL;
static T_MFW_HND   gMMSMsgListHnd = NULL;
static T_MFW_HND   gRecvListHnd = NULL;
void MMS_Set_MMSNew_WHnd(T_MFW_HND win)
{ 
    gMMSNewHnd = win;
}
T_MFW_HND MMS_Get_MMSNew_WHnd(void )
{
    return gMMSNewHnd;
}
void MMS_Set_MsgList_WHnd(T_MFW_HND win)
{ 
    gMMSMsgListHnd = win;
}
T_MFW_HND MMS_Get_MsgList_WHnd(void )
{
    return gMMSMsgListHnd;
}
void MMS_Set_RecvList_WHnd(T_MFW_HND win)
{ 
    gRecvListHnd = win;
}
T_MFW_HND MMS_Get_RecvList_WHnd(void )
{
    return gRecvListHnd;
}

//MMS༭
T_MFW_HND  gMMSImageMusicHnd;
void MMS_Set_MMSImageMusic_WHnd(T_MFW_HND win)
{ 
    gMMSImageMusicHnd = win;
}
T_MFW_HND MMS_Get_MMSImageMusic_WHnd(void )
{
    return gMMSImageMusicHnd;
}

static	MMS	gMms ={NULL,NULL,NULL};
P_MMS	getMMS()
{
	return &gMms;
}

static char *MMS_to_Lowercase(const char *strIn,char *strOut)
{
	int i=0;
    if(strIn == NULL || strOut == NULL)
		return NULL;
	strcpy(strOut, strIn);
	while(strOut[i])
	{
		if( strOut[i] >= 'A' && strOut[i]<='Z')
			strOut[i] = strOut[i] +'a' - 'A';
		i++;
	}
	return strOut;
}

BOOL MMS_File_Type(const char *filename, int fileType)
{
	char lowerCaseFileName[128];
	char *ret=NULL;
	if(filename == NULL)
		return 0;
	
	MMS_to_Lowercase(filename, lowerCaseFileName);
	switch(fileType)
	{
	case MMS_TYPE_GIF:	
		ret = strstr(lowerCaseFileName, ".gif");
		if(ret)
			return 1;
		break;
		
	case MMS_TYPE_JPEG:
		ret = strstr(lowerCaseFileName, ".jpg");
		if(ret)
			return 1;
		ret = strstr(lowerCaseFileName, ".jpeg");
		if(ret)
			return 1;
		break;
		
	case MMS_TYPE_WBMP:
		ret = strstr(lowerCaseFileName, ".wbmp");
		if(ret)
			return 1;
		break;

	case MMS_TYPE_MMF:
		ret = strstr(lowerCaseFileName, ".mmf");
		if(ret)
			return 1;
		break;
		
	case MMS_TYPE_MIDI:
		ret = strstr(lowerCaseFileName, ".midi");
		if(ret)
			return 1;
		break;
		
	case MMS_TYPE_TEXT:
	case MMS_TYPE_WAV:
	case MMS_TYPE_AMR:
	case MMS_TYPE_MP3:
	case MMS_TYPE_BMP:
	case MMS_TYPE_IMY:
	case MMS_TYPE_PNG:
	default:
		return 0;
	}
	return 0;
}

UINT8 mmi_mms_chkDir(const char* dir)
{
	T_FFS_RET error;
    T_FFS_STAT stat;
	
    if((error = ffs_stat(dir, &stat)) != EFFS_OK)
    {
		MMS_TRACE_EVENT(("mmi_mms_chkDir(): directory %s not exist!!!", dir));
		if((error = ffs_mkdir(dir)) == EFFS_OK)
		{
			MMS_TRACE_EVENT(("mmi_mms_chkDir(): create directory %s ok!!!", dir));     
		    return 1;
		}
		else
		{
			MMS_TRACE_EVENT(("mmi_mms_chkDir(): create directory %s error = %d!!!", dir, error));
			return 0;
		}    
    }
	
    return 1;
}

/* check if a FFS file exists, if not, make it */
UINT8 mmi_mms_chkFile(const char* name, void* data, int size)
{
	T_FFS_RET error;
    T_FFS_STAT stat;
	
	if((error = ffs_stat(name, &stat)) != EFFS_OK)
	{
		MMS_TRACE_EVENT(("mmi_mms_chkFile(): file %s not exist!!!", name));
		/* write a default file */
		error = ffs_fwrite(name, data, size);
		if(error == EFFS_OK)
		{
			MMS_TRACE_EVENT(("mmi_mms_chkFile(): write default %s ok!!!", name)); 
			return 1;
		}
		else
		{
			MMS_TRACE_EVENT(("mmi_mms_chkFile(): write default %s error = %d!!!", name, error)); 
			return 0;
		}
	}
	
	return 1;
}


UINT8 mmi_mms_chkSettingsFile(void)
{
	T_FFS_RET error;
    T_FFS_STAT stat;

	if((error = ffs_stat(FFSFILE_MMSSETTINGS_PATH, &stat)) != EFFS_OK)
	{
		MMS_TRACE_EVENT(("mmi_mms_chkSettingsFile(): file %s not exist!!!", FFSFILE_MMSSETTINGS_PATH));
		/* write a default file */
		flash_MMSSettingsInitialise();
		error = ffs_fwrite(FFSFILE_MMSSETTINGS_PATH, &mmsSettings, sizeof(mmsSettings));
		if(error == EFFS_OK)
		{
			MMS_TRACE_EVENT(("mmi_mms_chkSettingsFile(): write default %s ok!!!", FFSFILE_MMSSETTINGS_PATH)); 
			return 1;
		}
		else
		{
			MMS_TRACE_EVENT((""));
			MMS_TRACE_EVENT(("XIE"));
			MMS_TRACE_EVENT(("mmi_mms_chkSettingsFile(): write default %s error = %d!!!", FFSFILE_MMSSETTINGS_PATH, error)); 
			return 0;
		}
	}
    else
	{
	    flash_MMSSettingsread();  
		return 1;
	}
}

#if 1
enum
{
	MSG_HDR_TYPE_UNKNOWN = 0,
	MSG_HDR_TYPE_BCC,
	MSG_HDR_TYPE_CC,
	MSG_HDR_TYPE_FILENAME,
	MSG_HDR_TYPE_RECEIVER,
	MSG_HDR_TYPE_SENDER,
	MSG_HDR_TYPE_TITLE,
	MSG_HDR_TYPE_DATE,
	MSG_HDR_TYPE_STATE,
	MSG_HDR_TYPE_MSGSIZE
};

MMS_S32 MMS_GetFolder_MsgSum(char *pTxtPath,unsigned char folderType)
{
	MMS_S32 msgSum = 0 ;
    MMS_FILE fp;
	MMS_S8 pathname[64];
	
	MMS_S8 *file_content_buffer = NULL;
	MMS_S32 file_len = 0;
	MMS_S32 file_pos = 0;
	MMS_S8 flag_continue = 1;
	MMS_S8 *ptr_buf = NULL;
	MMS_S32 count = 0;
		
	if(pTxtPath == NULL)
	{
		return -1;
	}
	MMS_memset(pathname, 0, 64);
	MMS_strcpy(pathname, pTxtPath);
	switch (folderType)
	{
	case MMS_FOLDER_TYPE_RECV:
		MMS_strcat(pathname, "rmf.txt");
		break;
	case MMS_FOLDER_TYPE_SEND:
		MMS_strcat(pathname, "smf.txt");
		break;
	case MMS_FOLDER_TYPE_DRAFT:
		MMS_strcat(pathname, "dmf.txt");
		break;
	case MMS_FOLDER_TYPE_UNSEND:
		MMS_strcat(pathname, "usmf.txt");
		break;
	default:
		return -1;
	}
	
	fp = MMS_fopen(pathname, "r");
	
	file_len = MMS_fstat(pathname);
	if(file_len <= 0)
	{
		MMS_fclose(fp);
		return -1;
	}
	
	file_content_buffer = (MMS_S8*)ALLOC_MEMORY(sizeof(MMS_S8)*(file_len + 256));
	MMS_fread(file_content_buffer, file_len,1, fp);
	MMS_fclose(fp);
	
	file_pos = 0;
	while(1)
	{
		if(file_pos >= file_len)
		{
			break;
		}
		
		flag_continue = 1;
		while(flag_continue)
		{
			MMS_S8 msg_hdr_type = MSG_HDR_TYPE_UNKNOWN;
			MMS_U8 msg_hdr_type_len = 0;
			
			if(file_pos >= file_len)
			{
				MMS_TRACE_EVENT(("file_pos error!"));
				FREE_MEMORY((U8*)file_content_buffer,(U16)(sizeof(MMS_S8)*(file_len + 256)));
				return FALSE; 				
			}
			
			msg_hdr_type = (MMS_S8)*(file_content_buffer + file_pos);
			msg_hdr_type_len = (MMS_U8)*(file_content_buffer + file_pos + 1);
			ptr_buf = file_content_buffer + file_pos + 2;
			file_pos += (msg_hdr_type_len + 2);
			
			if(file_pos > file_len)
			{
				MMS_TRACE_EVENT(("file_len error , data may be corrupted!"));
				FREE_MEMORY((U8*)file_content_buffer,(U16)(sizeof(MMS_S8)*(file_len + 256)));
				return -1;
			}
			
			switch(msg_hdr_type)
			{
			case MSG_HDR_TYPE_BCC:
			case MSG_HDR_TYPE_CC:
			case MSG_HDR_TYPE_RECEIVER:
			case MSG_HDR_TYPE_SENDER:			
			case MSG_HDR_TYPE_TITLE:
			case MSG_HDR_TYPE_STATE:
				MMS_TRACE_EVENT(("case MSG_HDR_TYPE_FILENAME:%",msg_hdr_type));
				break;
			case MSG_HDR_TYPE_DATE:
				flag_continue = 0;
				MMS_TRACE_EVENT(("case MSG_HDR_TYPE_FILENAME:%",msg_hdr_type));
				break;				
			case MSG_HDR_TYPE_FILENAME:
				MMS_TRACE_EVENT(("case MSG_HDR_TYPE_FILENAME:%",msg_hdr_type));
				if(msg_hdr_type_len == 0)
				{
	               MMS_TRACE_EVENT(("WARNING:  No MSG_HDR_TYPE_FILENAME content"));
				}
				break;
				
			case MSG_HDR_TYPE_MSGSIZE:
				MMS_TRACE_EVENT(("case MSG_HDR_TYPE_FILENAME:%",msg_hdr_type));
				if(msg_hdr_type_len != 4)
				{
					MMS_TRACE_EVENT(("msg_hdr_type_len \!= 4"));
					FREE_MEMORY((U8*)file_content_buffer,(U16)(sizeof(MMS_S8)*(file_len + 256)));
					return -1; 
				}
				break;			
				
			default:
			case MSG_HDR_TYPE_UNKNOWN:
				FREE_MEMORY((U8*)file_content_buffer,(U16)(sizeof(MMS_S8)*(file_len + 256)));
				return FALSE; 				
			}		
		}
		msgSum++;
	}
		
	FREE_MEMORY((U8*)file_content_buffer,(U16)(sizeof(MMS_S8)*(file_len + 256)));
	return msgSum;
}

MMS_S32 MMS_Get_Msg_Sum()
{
#ifdef  _INNOVATION_EMULATOR_
	MMS_S8 fullname[128];
	MMS_S8 path[128];
	WIN32_FIND_DATA FileData; 
	HANDLE hSearch; 
	BOOL fFinished = FALSE; 
	BOOL isDirectory;
	int nfiles = 0;
	
	GetCurrentDirectoryA(sizeof(path),path);
	strcat(path,"\\filesystem");
	strcat(path, "/mms/message/");
	strcpy(fullname, path, strlen(path));
	strcat(fullname, "*.*");
	
	hSearch = FindFirstFileA(fullname, &FileData); 
	if (hSearch == INVALID_HANDLE_VALUE) 
	{ 
		return -1;
	} 
	
	while (!fFinished) 
	{
		if( (FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0x00)
		{
			if(FileData.cFileName[0] != 0)
			{	
				if(FileData.cFileName[0]>='0' && FileData.cFileName[0]<='9')
			    	nfiles ++;
			}
		}
		
		if (!FindNextFileA(hSearch, &FileData)) 
		{
			fFinished = TRUE; 
		}
	}	
	FindClose(hSearch );
	return nfiles;
	
#else
	T_FFS_DIR  sDir;
	MMS_S32 iSum = 0;
	MMS_S32 iRet = 0;
	MMS_S8 filename[32];
	if((iRet = ffs_opendir("/mms/message", &sDir)) >= 0)
	{
		memset(filename, 0, sizeof(filename));
		while((iRet = ffs_readdir(&sDir, filename, sizeof(filename))) > 0 )
		{
			MMS_TRACE_EVENT(("MMS_Get_Msg_Sum():file names: %s", filename));
            if(filename[0]>='0' && filename[0]<='9')
				iSum++;
		}			
	}
	else
	{
		iSum = -1;
		MMS_TRACE_EVENT(("Open /mms/message error"));
	}
	return iSum;
#endif
}

BOOL MMS_Check_MsgSum()
{
	MMS_S32 iSum = 0;
	MMS_S32 iSum2;
	MMS_S32 iRet;
	T_FFS_DIR  sDir;

	if(	MMS_fstat("/mms/dmf.txt") > 0)
	{
        iRet = MMS_GetFolder_MsgSum("/mms/",MMS_FOLDER_TYPE_DRAFT);
		if(iRet > 0)
			iSum += iRet;
	}

	if( MMS_fstat("/mms/smf.txt") > 0)
	{
		iRet = MMS_GetFolder_MsgSum("/mms/",MMS_FOLDER_TYPE_SEND);
		if(iRet > 0)
			iSum += iRet;
	}
	
	if(MMS_fstat("/mms/rmf.txt") > 0)
	{
		iRet = MMS_GetFolder_MsgSum("/mms/",MMS_FOLDER_TYPE_RECV);
		if(iRet > 0)
			iSum += iRet;
	}

	if(MMS_fstat("/mms/usmf.txt") > 0)
	{
		iRet = MMS_GetFolder_MsgSum("/mms/",MMS_FOLDER_TYPE_UNSEND);
		if(iRet > 0)
			iSum += iRet;
	}
	
	iSum2 = MMS_Get_Msg_Sum();	
	if(iSum2 == iSum)
		return TRUE;
	else 
		return FALSE;
}

typedef struct tagMMS_FILE_LIST MMS_FILE_LIST;
typedef  MMS_FILE_LIST *pMMS_FILE_LIST;
struct tagMMS_FILE_LIST
{
	char *pFileName;
	unsigned char lenth;
	pMMS_FILE_LIST pNext;
};
pMMS_FILE_LIST mmsFileList=NULL;
pMMS_FILE_LIST curMMSFileListNode = NULL;

BOOL MMS_Read_FolderMsg(unsigned char folderType)
{
	MMS_FILE fp;
	MMS_S8 pathname[64];
	
	MMS_S8 *file_content_buffer = NULL;
	MMS_S32 file_len = 0;
	MMS_S32 file_pos = 0;
	MMS_S8 flag_continue = 1;
	MMS_S8 *ptr_buf = NULL;
	MMS_S32 count = 0;
		
	MMS_memset(pathname, 0, 64);
	MMS_strcpy(pathname, "/mms/");
	switch (folderType)
	{
	case MMS_FOLDER_TYPE_RECV:
		MMS_strcat(pathname, "rmf.txt");
		break;
	case MMS_FOLDER_TYPE_SEND:
		MMS_strcat(pathname, "smf.txt");
		break;
	case MMS_FOLDER_TYPE_DRAFT:
		MMS_strcat(pathname, "dmf.txt");
		break;
	case MMS_FOLDER_TYPE_UNSEND:
		MMS_strcat(pathname, "usmf.txt");
		break;
	default:
		return FALSE;
	}
	
	file_len = MMS_fstat(pathname);
	if(file_len == 0)
	{
		return TRUE;
	}
	else if(file_len < 0)
	{
		return FALSE;
	}

	fp = MMS_fopen(pathname, "r");
	if((int)fp <= 0)
	{
		MMS_TRACE_EVENT(("MMS_fopen failed"));
		return FALSE;
	}
	

	file_content_buffer = (MMS_S8*)ALLOC_MEMORY(sizeof(MMS_S8)*(file_len + 256));
	MMS_fread(file_content_buffer, file_len,1, fp);
	MMS_fclose(fp);
		
	file_pos = 0;
	while(1)
	{
		if(file_pos >= file_len)
		{
			break;
		}
		
		flag_continue = 1;
		while(flag_continue)
		{
			MMS_S8 msg_hdr_type = MSG_HDR_TYPE_UNKNOWN;
			MMS_U8 msg_hdr_type_len = 0;
			
			if(file_pos >= file_len)
			{
				MMS_TRACE_EVENT(("file_pos error!"));
				FREE_MEMORY((U8*)file_content_buffer,(U16)(sizeof(MMS_S8)*(file_len + 256)));
				return FALSE; 				
			}
			
			msg_hdr_type = (MMS_S8)*(file_content_buffer + file_pos);
			msg_hdr_type_len = (MMS_U8)*(file_content_buffer + file_pos + 1);
			ptr_buf = file_content_buffer + file_pos + 2;
			file_pos += (msg_hdr_type_len + 2);
			
			if(file_pos > file_len)
			{
				MMS_TRACE_EVENT(("file_len error , data may be corrupted!"));
				FREE_MEMORY((U8*)file_content_buffer, (U16)(sizeof(MMS_S8)*(file_len + 256)));
				return FALSE;
			}
			
			switch(msg_hdr_type)
			{
			case MSG_HDR_TYPE_BCC:
			case MSG_HDR_TYPE_CC:
			case MSG_HDR_TYPE_RECEIVER:
			case MSG_HDR_TYPE_SENDER:			
			case MSG_HDR_TYPE_TITLE:
			case MSG_HDR_TYPE_STATE:
			case MSG_HDR_TYPE_MSGSIZE: 	
				MMS_TRACE_EVENT(("case MSG_HDR_TYPE_FILENAME:%",msg_hdr_type));
				break;
			case MSG_HDR_TYPE_DATE:
				flag_continue = 0;
				MMS_TRACE_EVENT(("case MSG_HDR_TYPE_FILENAME:%",msg_hdr_type));
				break;				
			case MSG_HDR_TYPE_FILENAME:
				MMS_TRACE_EVENT(("case MSG_HDR_TYPE_FILENAME:%",msg_hdr_type));
				if(msg_hdr_type_len != 0)
				{
					if(!curMMSFileListNode)
					{
						 curMMSFileListNode = (pMMS_FILE_LIST)ALLOC_MEMORY(sizeof(MMS_FILE_LIST));
					     curMMSFileListNode->pFileName = (MMS_S8 *)ALLOC_MEMORY(msg_hdr_type_len+1+2);
						 MMS_memset(curMMSFileListNode->pFileName, 0, msg_hdr_type_len+1+2);
						 MMS_memcpy(curMMSFileListNode->pFileName, ptr_buf, msg_hdr_type_len);
						 curMMSFileListNode->lenth = msg_hdr_type_len+1+2;
						 curMMSFileListNode->pNext = NULL;
						 mmsFileList = curMMSFileListNode;
					}
					else
					{
						pMMS_FILE_LIST tempFileListNode = NULL;
						tempFileListNode = (pMMS_FILE_LIST)ALLOC_MEMORY(sizeof(MMS_FILE_LIST));
						tempFileListNode->pFileName = (MMS_S8 *)ALLOC_MEMORY(msg_hdr_type_len+1+2);
						MMS_memset(tempFileListNode->pFileName, 0, msg_hdr_type_len+1+2);
						MMS_memcpy(tempFileListNode->pFileName, ptr_buf, msg_hdr_type_len);
						tempFileListNode->lenth = msg_hdr_type_len+1+2;
						tempFileListNode->pNext = NULL;
						curMMSFileListNode->pNext = tempFileListNode;
					    curMMSFileListNode = tempFileListNode;
					}		
					MMS_TRACE_EVENT((curMMSFileListNode->pFileName));
				}else
				{
					MMS_TRACE_EVENT(("WARNING:  No MSG_HDR_TYPE_FILENAME content"));
				}
				break;		
				
			default:
			case MSG_HDR_TYPE_UNKNOWN:
				FREE_MEMORY((U8*)file_content_buffer, (U16)(sizeof(MMS_S8)*(file_len + 256)));
				return FALSE; 				
			}		
		}		
	}
		
	FREE_MEMORY((U8*)file_content_buffer,(U16)(sizeof(MMS_S8)*(file_len + 256)));
	return TRUE;
}

void MMS_Delete_Msg_List()
{
    if(mmsFileList)
	{
		pMMS_FILE_LIST pTempNode = NULL;
		do 
		{
			pTempNode = mmsFileList; 
			FREE_MEMORY((U8*)pTempNode->pFileName, (U16)pTempNode->lenth);
			FREE_MEMORY((U8*)pTempNode, (U16)sizeof(MMS_FILE_LIST));
			mmsFileList = mmsFileList->pNext;
		} while(mmsFileList);
		curMMSFileListNode = NULL;
		mmsFileList =  NULL;
	}
}

void MMS_Create_Msg_List()
{
    if(FALSE == MMS_Read_FolderMsg(MMS_FOLDER_TYPE_RECV))
	{
		MMS_Delete_Msg_List();
		return ;
	}

	if(FALSE == MMS_Read_FolderMsg(MMS_FOLDER_TYPE_SEND))
	{
       MMS_Delete_Msg_List();
	   return;
	}

	if(FALSE == MMS_Read_FolderMsg(MMS_FOLDER_TYPE_DRAFT))
	{
        MMS_Delete_Msg_List();
		return;
	}
	
	if(FALSE == MMS_Read_FolderMsg(MMS_FOLDER_TYPE_UNSEND))
	{
		MMS_Delete_Msg_List();
		return;
	}
}

BOOL isInMMSMsgList(char *strFileName)
{
	if(mmsFileList && strFileName)
	{
		pMMS_FILE_LIST pTempNode = mmsFileList;
		do 
		{
			if(0 == strcmp(pTempNode->pFileName,strFileName))
				return TRUE;
			else
				pTempNode = pTempNode->pNext;
		} while(pTempNode);
		return FALSE;
	}
	return FALSE;
}

#endif
//Return 1 if suc, 0 for fail
BOOL MMS_Check_Files(void)
{
    T_FFS_RET error;
    T_FFS_STAT stat;
	
	if(!mmi_mms_chkDir(MMS_PATH)) return 0;
	if(!mmi_mms_chkDir(MMS_TEMP_PATH)) return 0;
    if(!mmi_mms_chkDir(MMS_MESSAGE_PATH)) return 0;
	if(!mmi_mms_chkDir(MMS_IMAGE_FILEPATH)) return 0;
	if(!mmi_mms_chkDir(MMS_MUSIC_FILEPATH)) return 0;
    
	if(!mmi_mms_chkSettingsFile()) return 0;
	if(!mmi_mms_chkFile("/mms/dmf.txt" , NULL, 0)) return 0;
	if(!mmi_mms_chkFile("/mms/dmfu.txt", NULL, 0)) return 0; 
	if(!mmi_mms_chkFile("/mms/mset.txt", NULL, 0)) return 0;
	if(!mmi_mms_chkFile("/mms/rmf.txt",  NULL, 0)) return 0;
	if(!mmi_mms_chkFile("/mms/rmfu.txt", NULL, 0)) return 0;
	if(!mmi_mms_chkFile("/mms/smf.txt",  NULL, 0)) return 0; 
	if(!mmi_mms_chkFile("/mms/smfu.txt", NULL, 0)) return 0;
	
	if(!mmi_mms_chkFile("/mms/usmf.txt", NULL, 0)) return 0;
	if(!mmi_mms_chkFile("/mms/usmfu.txt",NULL, 0)) return 0;
	
	MMS_TRACE_EVENT(("MMS_Check_Files():check all MMS config ok!!!")); 
	return 1;
}

void MMS_Initialize()
{
	BOOL ret;
	int funRet;
	
#if 1
	MMS_FILE fp;	
	fp = MMS_fopen("/mms/rmfu.txt", "r+b");
	if(fp)
	{
		MMS_fread(&gNewMMSNum,sizeof(gNewMMSNum),1,fp);
		MMS_fclose(fp);
	}
#endif

//delete filess remained in temp directory
	{
        char tempPath[64];
		strcpy(tempPath, MMS_TEMP_PATH);
		strcat(tempPath, "/");
		MMS_deletefiles(tempPath);	 
	}
//delete .mms files which do not ocuur in .txt
//MMS_S32 MMS_fstat(MMS_S8 *filename)

#if 1
	{
		if(FALSE == MMS_Check_MsgSum())
		{
			MMS_Create_Msg_List();
#ifdef _INNOVATION_EMULATOR_
			{
				MMS_S8 fullname[128];
				MMS_S8 path[128];
				int len;
				WIN32_FIND_DATA FileData; 
				HANDLE hSearch; 
				BOOL fFinished = FALSE; 
				BOOL isDirectory;
				int nfiles = 0;
				int i = 0;
        
				GetCurrentDirectoryA(sizeof(path),path);
				strcat(path,"\\filesystem");
				strcat(path, "/mms/message/");
				strcpy(fullname, path, strlen(path));
				strcat(fullname, "*.*");
				
				hSearch = FindFirstFileA(fullname, &FileData); 
				if (hSearch == INVALID_HANDLE_VALUE) 
	{
					return;
				} 

				while (!fFinished) 
				{
					if( (FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0x00)
					{
						if(FileData.cFileName[0] != 0)
						{	
							if(FileData.cFileName[0]>='0' && FileData.cFileName[0]<='9')
							{
								if( FALSE == isInMMSMsgList(FileData.cFileName) )
								{
									strcpy(fullname, path, strlen(path));
									strcat(fullname, FileData.cFileName);
									remove(fullname);
	}
							}
						}
					}
					
					if (!FindNextFileA(hSearch, &FileData)) 
	{
						fFinished = TRUE; 
					}
				}	
				FindClose(hSearch );

	}
#else
	{
				T_FFS_DIR  sDir;
			    MMS_S32 iRet = 0;
		     	MMS_S8 filename[32];
			    MMS_S8 fullname[64];

				if((iRet = ffs_opendir("/mms/message", &sDir)) >= 0)
				{
					memset(filename, 0, sizeof(filename));
					while((iRet = ffs_readdir(&sDir, filename, sizeof(filename))) > 0 )
					{
						if(filename[0]>='0' && filename[0]<='9')
						{
							if( FALSE == isInMMSMsgList(filename) )
							{
								strcpy(fullname, "/mms/message/");
								strcat(fullname, filename);
								ffs_remove(fullname);
							}
	}
	
					}			
				}
			}
#endif
			MMS_Delete_Msg_List();
		}
	}
#endif
	
    if( ret = MMS_Check_Files())
	{
		//funRet = MMS_Net_Init(APP_PATH);
/*talcon hu*/	
		funRet = MMS_Net_Init("/mms/message/");	
	}
    else
	{
        MMS_TRACE_EVENT(("MMS_Initialize() failure!"));
	}
}

void MMS_Exit()
{
	P_MMS		mms = getMMS(); 
	if(mms->player)
	{
		player_destrory();
		mms->player = NULL;
	}
	if(mms->editor)
	{
		editor_on_destroy();
		mms->editor = NULL;
	}	
	if(mms->manager)
	{
		MMS_Codec_Destory();
		manager_on_destroy();
		mms->manager = NULL;
	}
	MMS_Net_Destroy();
}

void MMS_Test_Send_Message()
{
	   int ret;
       pMessage	pMsg;
	   P_MMS  mms = getMMS();	
	   
	   MMS_TRACE_EVENT(("         "));
	   MMS_TRACE_EVENT(("         "));
	   MMS_TRACE_EVENT(("         "));
	   MMS_TRACE_EVENT(("entry to MMS_Test_Send_Message()"));
	   
	   if(mms->editor==NULL)
	   {	
		   MMS_TRACE_EVENT(("before editor_on_initialize, mms->editor =%d" , (uint32)mms->editor));
		   mms->editor = editor_on_initialize(EDITOR_INIT_NEW, NULL);
		   MMS_TRACE_EVENT(("after editor_on_initialize, mms->editor =%d" , (uint32)mms->editor));
		   if(mms->editor==NULL)
		   {
			   MMS_TRACE_EVENT(("mms->editor==NULL,please check editor_on_initialize()!!!!"));
			   return ;
		   }			
	   }
	   
	   //	   MMS_TRACE_EVENT(("before editor_get_msg() pMsg = %d",(uint32)pMsg));
	   pMsg = editor_get_msg();
	   //	   MMS_TRACE_EVENT(("after editor_get_msg()  pMsg =%d",(uint32)pMsg));
	   MMS_TRACE_EVENT(("mms->manager->draftfolder=%d",(uint32)mms->manager->draftfolder));
	   ret = manager_set_currentfolder(mms->manager->draftfolder);
	   
	   MMS_TRACE_EVENT(("manager_set_currentfolder()----%d",ret));
	   msg_set_cc(pMsg, "13182810857");
	   msg_set_bcc(pMsg, "13182810857");
	   msg_set_title(pMsg, "Hello!!");
	   ret = editor_text_new("hello world!! mobileinnovation");
	   MMS_TRACE_EVENT(("editor_text_new()----%d",ret));
	   //editor_image_new("d:\\mms\\mmsdata\\temp\\m1.jpg",1);
	   //editor_audio_new("d:\\mms\\mmsdata\\temp\\m1.mid",1);
	   
	   ret = editor_save_message();//ɹ10
	   //	   MMS_TRACE_EVENT(("editor_save_message()----%d",ret));
	   ret = manager_on_store();//ɹ10
	   MMS_TRACE_EVENT(("manager_on_store()----%d",ret));
	   //storemessagefolder(mms->manager->currentfolder);
	   if(mms->editor!=NULL)
	   {
		   ret = editor_on_destroy();//ɹ10
		   MMS_TRACE_EVENT(("editor_on_destroy()----%d",ret));
		   mms->editor=NULL;
	   }
	   
	   /*	   MMS_TRACE_EVENT(("         "));
	   MMS_TRACE_EVENT(("         "));
	   MMS_TRACE_EVENT(("before exec mms_test_send_message()"));
	   mms_test_send_message();
	   MMS_TRACE_EVENT(("after exec mms_test_send_message()"));
	   MMS_TRACE_EVENT(("         "));
	   MMS_TRACE_EVENT(("         "));*/
	   MMS_TRACE_EVENT(("exit MMS_Test_Send_Message()"));
	   return;	
}



void MMS_Check_New_Stat()
{
	
}

void MMS_idle_display()
{
	
}
/*************************************
$Description:
@mask: 0x01: mms menu
	    0x10: mms agent  
talcon create 2004.07.23
*******************************************/

#ifdef MMI_MMSTASK_ENABLED
T_MMSUI_DATA *mmsui_data = 0;     //modified by xie 04-07-30
#endif

static unsigned int manage_ref = 0;
#ifdef MMI_MMSTASK_ENABLED
#endif
void  MI_manager_on_initialize(unsigned int mask)
{
	MMS_TRACE_EVENT(("MI_manager_on_initialize"));
	if(manage_ref ==0)
	{
		P_MMS  mms = getMMS();
		if(!mms->manager)
		{
			MMS_TRACE_EVENT(("MI enter manager_on_initialize"));
			mms->manager = (pManager)manager_on_initialize();
			MMS_Codec_Init(APP_PATH);

#ifdef MMI_MMSTASK_ENABLED
			if(mmsui_data ==0)
				mmsui_data =(T_MMSUI_DATA *)malloc (sizeof (T_MMSUI_DATA)); 
#endif
			

			{/*set mms setting*/
				extern T_MMS_NET_SETTINGS mmsSettings;
				if(mmsSettings.curSettingsIndex >= mmsSettings.settingsSum)
					mmsSettings.curSettingsIndex = 0;	
				manager_set_autorecv(mmsSettings.allSettings[mmsSettings.curSettingsIndex].recvSettings.stateAutoRecv);
				manager_set_autosave(mmsSettings.allSettings[mmsSettings.curSettingsIndex].recvSettings.stateAutoSave);
				manager_set_report(mmsSettings.allSettings[mmsSettings.curSettingsIndex].sendSettings.stateSendReport);
				manager_set_mmscaddress((MMS_S8 *)mmsSettings.allSettings[mmsSettings.curSettingsIndex].mmscURL);
			}

		}
	}
	manage_ref |= mask;
}

/*************************************
talcon create 2004.07.23
*******************************************/
void  MI_manager_on_destroy(unsigned int mask)
{
	MMS_TRACE_EVENT(("MI_manager_on_destroy"));
	MMS_TRACE_EVENT(("%d", manage_ref));
	if(manage_ref ==0)
	{
		return ;
	}
	manage_ref &= ~mask;
	
	if(manage_ref == 0)
	{
		P_MMS  mms = getMMS();
		if(mms->manager)
		{
#ifdef MMI_MMSTASK_ENABLED
			if(mmsui_data)
			{
				free((void *) mmsui_data); 
				mmsui_data = 0;
			}
#endif
			MMS_Codec_Destory();
			manager_on_destroy();
			mms->manager = NULL;
		}
    	}
}

/*************************************
talcon create 2004.07.20
*******************************************/
T_MFW_HND info_mms_dialog (T_MFW_HND parent_win )
{
	T_DISPLAY_DATA display_info;
	dialog_info_init(&display_info);
	MMS_TRACE_EVENT(("info_mms_dialog"));
	display_info.RightSoftKey	= TxtNull;	
	display_info.TextId2        = TxtPleaseWait;
	display_info.Callback       = NULL;//(T_VOID_FUNC)AUI_please_wait_cb;
	display_info.Time           = FOREVER;
	display_info.KeyEvents=0;
	display_info.iconindex=REMIND_WAITTING;

	return  info_dialog(parent_win,&display_info); 
}

extern int MMS_FileTooBig_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
extern int MMS_Sending_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
extern int MMS_EndSending_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
T_MFW_HND info_mms_screen(T_MFW_HND parent_win, BYTE id )
{
	static T_MFW_HND mmsscr_parentwin = 0;
	static T_MFW_HND mmsscr_win = 0;
	
	static BYTE idold;
	T_DISPLAY_DATA display_info;
	MMS_TRACE_EVENT(("info_mms_screen"));
	
	dialog_info_init(&display_info);
	
	switch(id)
	{
	case MMS_SCREEN_ID_NORMAL:
		display_info.RightSoftKey	= TxtNull;	
		display_info.TextId2        = TxtPleaseWait;
		display_info.Callback       = NULL;
		display_info.Time           = FOREVER;
		display_info.KeyEvents=0;
		display_info.iconindex=REMIND_WAITTING;
		break;
 
	case MMS_SCREEN_ID_SENDING:
		display_info.LeftSoftKey    = TxtNull;
		display_info.RightSoftKey	= TxtCancel;	
		display_info.TextId         = TxtMMSSending;
		display_info.TextId2        = TxtMMSPleaseWaitting;
		display_info.Callback       = (T_VOID_FUNC)MMS_Sending_dialog_cb;
		display_info.Time           = FOREVER;
		display_info.KeyEvents      = KEY_RIGHT | KEY_HUP;
		display_info.iconindex=REMIND_WAITTING;
		break;
	case MMS_SCREEN_ID_SENDSUCCESS:
		SEND_EVENT(mmsscr_win, DIALOG_DESTROY, 0, 0);
	//	MMS_Sending_End();
		display_info.LeftSoftKey    = TxtSoftOK;
		display_info.RightSoftKey	= TxtSoftBack;
		display_info.TextId         = TxtMMS;
		display_info.TextId2        = TxtMMSSendSuccess;
		display_info.Callback       = (T_VOID_FUNC)MMS_EndSending_dialog_cb;//NULL;
		display_info.Time           = TWO_SECS;
		display_info.KeyEvents      = KEY_LEFT | KEY_RIGHT;
		display_info.iconindex=REMIND_SUCCEED;
		break;
	case MMS_SCREEN_ID_SENDFAILED:
		SEND_EVENT(mmsscr_win, DIALOG_DESTROY, 0, 0);
	//	MMS_Sending_End();
		display_info.LeftSoftKey    = TxtSoftOK;
		display_info.RightSoftKey	= TxtSoftBack;
		display_info.TextId         = TxtMMS;
		display_info.TextId2        = TxtMMSSendFailed;
		display_info.Callback       = (T_VOID_FUNC)MMS_EndSending_dialog_cb;//NULL;
		display_info.Time           = TWO_SECS;
		display_info.KeyEvents      = KEY_LEFT | KEY_RIGHT | KEY_HUP;
		display_info.iconindex=REMIND_SUCCEED;
		break;
	case MMS_SCREEN_ID_SENDCANCLED:
		SEND_EVENT(mmsscr_win, DIALOG_DESTROY, 0, 0);
	//	MMS_Sending_End();
		display_info.LeftSoftKey    = TxtSoftOK;
		display_info.RightSoftKey	= TxtSoftBack;
		display_info.TextId         = TxtMMS;
		display_info.TextId2        = TxtMMSSendCancelled;
		display_info.Callback       = (T_VOID_FUNC)MMS_EndSending_dialog_cb;//NULL;
		display_info.Time           = TWO_SECS;  //moidified by xie 04-08-02
		display_info.KeyEvents      = KEY_LEFT | KEY_RIGHT | KEY_HUP;
		display_info.iconindex=REMIND_SUCCEED;
		break;
	case MMS_SCREEN_ID_AUTORECVFAILED:
		SEND_EVENT(mmsscr_win, DIALOG_DESTROY, 0, 0);
		display_info.LeftSoftKey    = TxtSoftOK;
		display_info.RightSoftKey	= TxtSoftBack;
		display_info.TextId         = TxtMMS;
		display_info.TextId2        = TxtMMSRecvFailed;
		display_info.Callback       = NULL;
		display_info.Time           = FOREVER;
		display_info.KeyEvents      = KEY_LEFT | KEY_RIGHT;
		display_info.iconindex=REMIND_SUCCEED;
		break;
	case MMS_SCREEN_ID_RETRIEVE:
		display_info.LeftSoftKey    = TxtNull;
		display_info.RightSoftKey	= TxtCancel;	
		display_info.TextId         = TxtMMSRetrieving;
		display_info.TextId2        = NULL;//TxtMMSPleaseWaitting;
		display_info.Callback       = (T_VOID_FUNC)MMS_Sending_dialog_cb;
		display_info.Time           = FOREVER;
		display_info.KeyEvents      = KEY_RIGHT | KEY_HUP;
		display_info.iconindex=REMIND_WAITTING;;
		break;
	case MMS_SCREEN_ID_RETRIEVESUCCESS:
		SEND_EVENT(mmsscr_win, DIALOG_DESTROY, 0, 0);
		display_info.LeftSoftKey    = TxtSoftOK;
		display_info.RightSoftKey	= TxtSoftBack;
		display_info.TextId         = TxtMMS;
		display_info.TextId2        = TxtMMSRecvSuccess;
		display_info.Callback       = NULL;
		display_info.Time           = FOREVER;
		display_info.KeyEvents      = KEY_LEFT | KEY_RIGHT;
		display_info.iconindex=REMIND_SUCCEED;
		break;
	case MMS_SCREEN_ID_RETRIEVEFAILED:
		SEND_EVENT(mmsscr_win, DIALOG_DESTROY, 0, 0);
		display_info.LeftSoftKey    = TxtSoftOK;
		display_info.RightSoftKey	= TxtSoftBack;
		display_info.TextId         = TxtMMS;
		display_info.TextId2        = TxtMMSRecvFailed;
		display_info.Callback       = NULL;
		display_info.Time           = FOREVER;
		display_info.KeyEvents      = KEY_LEFT | KEY_RIGHT;
		display_info.iconindex=REMIND_SUCCEED;
		break;
	case MMS_SCREEN_ID_RETRIEVECANCLED:
		SEND_EVENT(mmsscr_win, DIALOG_DESTROY, 0, 0);
		display_info.LeftSoftKey    = TxtSoftOK;
		display_info.RightSoftKey	= TxtSoftBack;
		display_info.TextId         = TxtMMS;
		display_info.TextId2        = TxtMMSRecvCancelled;
		display_info.Callback       = NULL;
		display_info.Time           = FOREVER;
		display_info.KeyEvents      = KEY_LEFT | KEY_RIGHT;
		display_info.iconindex=REMIND_SUCCEED;
		break;
	case MMS_SCREEN_ID_BAD_PDU:
		SEND_EVENT(mmsscr_win, DIALOG_DESTROY, 0, 0);
		display_info.LeftSoftKey    = TxtSoftOK;
		display_info.RightSoftKey	= TxtSoftBack;
		display_info.TextId         = TxtMMS;
		display_info.TextId2        = TxtMMSDataError;
		display_info.Callback       = NULL;
		display_info.Time           = FOREVER;
		display_info.KeyEvents      = KEY_LEFT | KEY_RIGHT;
		display_info.iconindex=REMIND_SUCCEED;
		break;
	case MMS_SCREEN_ID_IMAGE_FILETOOBIG:
    case MMS_SCREEN_ID_MUSIC_FILETOOBIG:
		display_info.LeftSoftKey    = TxtNull;
		display_info.RightSoftKey	= TxtSoftBack;
		display_info.TextId         = TxtMMSFileTooBig;
		display_info.TextId2        = TxtNull;
		display_info.Identifier     = id;
		display_info.Callback       = (T_VOID_FUNC)MMS_FileTooBig_dialog_cb;
		display_info.Time           = TWO_SECS;
		display_info.KeyEvents      = KEY_RIGHT | KEY_HUP;
		display_info.iconindex = REMIND_FAILURE;
		break;

	case MMS_SCREEN_ID_NULL:
		SEND_EVENT(mmsscr_win, DIALOG_DESTROY, 0, 0);
	default:
		break;
	}

	if(idold == MMS_SCREEN_ID_SENDING)
	{	
		
	}
	idold = id;
	if(parent_win)
		mmsscr_parentwin = parent_win;
	mmsscr_win = info_dialog(parent_win,&display_info); 
	return  mmsscr_win;
}
#endif