#ifdef _MMS_ENABLE_

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)
#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"
#else
#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"
#endif

#include "p_sim.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_str.h"
#include "dspl.h"

#include "MmiMain.h"
#include "MmiDummy.h"
#include "MmiMmi.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiEditor.h"
#include "Mmitextinput.h"
#include "phb.h"  
#include "mmiBookshared.h" 
#include "mmiSmsMenu.h"
#include "mmismssend.h"
#include "mmismsidle.h"
#include "listicn.h"
//begin xie
#include "mmiMMSffs.h"   //add by xie 04-07-08
#include "mmimms_cfg.h"
#include "manager.h"
#include "mmiMMSSetting.h"
#include "mmiMMSGlobalDef.h"
#include "mmimms_cfg.h"  //modified by xie 04-07-12 
//end xie

/*
                        MMS_PARA_SETTING_STATE  stateAutoRecv   = MMS_PARAM_OFF,
                                                stateAutoSave   = MMS_PARAM_OFF,
                                                stateSendReport = MMS_PARAM_OFF;*/
//õĲ˵
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
    /* associated handlers */	
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu;
}T_MMS_SETTINGS_MENU; 

static T_MFW_HND MMS_SettingsMenu_start(MfwHnd parent_window , MfwMnuAttr *menuAttr);
static T_MFW_HND MMS_SettingsMenu_create(T_MFW_HND parent_window);
static void      MMS_SettingsMenu_destroy(T_MFW_HND win);
static void      MMS_SettingsMenu_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int       MMS_SettingsMenu_kbd_cb(MfwEvt e, MfwKbd *k);
static int       MMS_SettingsMenu_mnu_cb ( MfwEvt e, MfwMnu *m );
static int       MMS_SettingsMenu_win_cb(MfwEvt e, MfwWin *w);

//б
typedef enum
{
  CUR_SETTINGS = 0,
  ALL_SETTINGS
}SETTINGS_MENU_ID;

/*talcon delete it*/
//static MfwRect MMS_All_Settings_List_Area = {0,0,SCREEN_SIZE_X,LINE_HEIGHT*9}; 
extern MfwRect menuListArea;
static MfwMnuAttr MMS_All_Settings_List_Attrib =
{
    0,
	&menuListArea,//&MMS_All_Settings_List_Area,
	//MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
	MNU_LEFT | MNU_OVERLAPPED | MNU_CUR_LINE,
	-1,                                 /* use default font         */
	NULL,                               /* with these items         */
	0                                   /* number of items     */
};

int iSettingsItemIndex = 0;

typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
	unsigned int menuID;
    /* associated handlers */
	
    /* internal data */
    ListMenuData    list_menu_data;
	
} T_MMS_ALL_SETTINGS_LIST;

static T_MFW_HND MMS_All_Settings_List_start (T_MFW_HND window, SETTINGS_MENU_ID menuID);
static T_MFW_HND MMS_All_Settings_List_create (T_MFW_HND window, SETTINGS_MENU_ID menuID);
static void      MMS_All_Settings_List_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter);
static void      MMS_All_Settings_List_listmenu_create (T_MMS_ALL_SETTINGS_LIST *data);
static void      MMS_All_Settings_List_listmenu_cb (T_MFW_HND * win, ListMenuData * ListData);
static void      MMS_All_Settings_List_destroy (T_MFW_HND window);

static T_MFW_HND   gMMSCurSetListHnd = NULL;
static T_MFW_HND   gMMSAllSetListHnd = NULL;
void MMS_Set_CurSetList_WHnd(T_MFW_HND win)
{ 
    gMMSCurSetListHnd = win;
}
T_MFW_HND MMS_Get_CurSetList_WHnd(void )
{
    return gMMSCurSetListHnd;
}
void MMS_Set_AllSetList_WHnd(T_MFW_HND win)
{ 
    gMMSAllSetListHnd = win;
}
T_MFW_HND MMS_Get_AllSetList_WHnd(void )
{
    return gMMSAllSetListHnd;
}
//ǰò˵Ӧ
static int MMS_Setting_Group1 (MfwMnu* m, MfwMnuItem* i);  
static int MMS_Setting_Group2 (MfwMnu* m, MfwMnuItem* i);
static int  MMS_Setting_Group3 (MfwMnu* m, MfwMnuItem* i);
static int MMS_Setting_Group4 (MfwMnu* m, MfwMnuItem* i);
static int MMS_Setting_Group5 (MfwMnu* m, MfwMnuItem* i);

//õѡ˵
typedef struct
{
    /* administrative data */	
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;	
    /* associated handlers */	
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu;
}T_MMS_SETTINGS_OPT; 

static T_MFW_HND MMS_Settings_Opt_start(MfwHnd parent_window , MfwMnuAttr *menuAttr);
static T_MFW_HND MMS_Settings_Opt_create(T_MFW_HND parent_window);
static void      MMS_Settings_Opt_destroy(T_MFW_HND win);
static void      MMS_Settings_Opt_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int       MMS_Settings_Opt_kbd_cb(MfwEvt e, MfwKbd *k);
static int       MMS_Settings_Opt_mnu_cb ( MfwEvt e, MfwMnu *m );
static int       MMS_Settings_Opt_win_cb(MfwEvt e, MfwWin *w);


//б༭
typedef enum
{
	MMS_SETTINGS_GROUP_NAME,
	MMS_MMSC_URL,

	MMS_GSM_IP_ADDRESS,
	MMS_GSM_IP_PORT,
	MMS_GSM_DIAL_NUMBER,
	MMS_GSM_LOGIN_ID,
	MMS_GSM_PASSWORD,

	MMS_GPRS_IP_ADDRESS,
	MMS_GPRS_IP_PORT,
	MMS_GPRS_APN,
	MMS_GPRS_LOGIN_ID,
	MMS_GPRS_PASSWORD
}T_MMS_EDITOR_ID;

typedef struct
{    
	T_MMI_CONTROL   mmi_control;
	T_MFW_HND       win;
	unsigned int    winID;
	T_MFW_HND       parent;
	
	T_MFW_HND       editor;
	T_EDITOR_DATA   editor_info;   
}T_MMS_SETTINGS_EDITOR;

static void MMS_Settings_Edit_LoadEditDefault(T_EDITOR_DATA *editor_data);
static void MMS_Settings_Edit_destroy(MfwHnd own_window);
static void MMS_Settings_Edit_edit_cb(T_MFW_HND win, USHORT Identifier, SHORT reason);
static void MMS_Settings_Edit_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter);
static T_MFW_HND MMS_Settings_Edit_create(MfwHnd parent_window);  
static T_MFW_HND MMS_Settings_Edit_start(T_MFW_HND parent, unsigned int  winID);

#if 0
static T_MFW_HND   gMMSSettingEditsHnd = NULL;
void MMS_Set_MMSSettingEdits_WHnd(T_MFW_HND win)
{ 
    gMMSSettingEditsHnd = win;
}

T_MFW_HND MMS_Get_MMSSettingEdits_WHnd(void )
{
    return gMMSSettingEditsHnd;
}
#endif

//õĲ˵
int MMS_SettingsMenu(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_SettingsMenu");
	MMS_SettingsMenu_start(win, (MfwMnuAttr *)MMSSettingsMenuAttributes());
}

T_MFW_HND MMS_SettingsMenu_start(MfwHnd parent_window , MfwMnuAttr *menuAttr)
{
	T_MFW_HND win;	
	MMS_TRACE_FUNCTION("MMS_SettingsMenu_start");
    win = MMS_SettingsMenu_create (parent_window);	
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, NULL, (void *)menuAttr);
    }
    return win;
}

T_MFW_HND MMS_SettingsMenu_create(T_MFW_HND parent_window)
{
	T_MMS_SETTINGS_MENU      * data = (T_MMS_SETTINGS_MENU *)ALLOC_MEMORY (sizeof (T_MMS_SETTINGS_MENU));
    T_MFW_WIN  * win;
	
	MMS_TRACE_FUNCTION("MMS_SettingsMenu_create");
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)MMS_SettingsMenu_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
	
    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_SettingsMenu_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
	
    return data->win;
}

void      MMS_SettingsMenu_destroy(T_MFW_HND win)
{
	T_MFW_WIN              * win_data;
    T_MMS_SETTINGS_MENU     * data;
	P_MMS mms = getMMS();
	MMS_TRACE_FUNCTION("MMS_SettingsMenu_destroy");
    if(win)
    {
        win_data = ((T_MFW_HDR *)win)->data;
        data = (T_MMS_SETTINGS_MENU *)win_data->user;
		
        if( data )
        {
            win_delete (data->win);
			data->win = NULL;
            FREE_MEMORY ((void *)data, sizeof (T_MMS_SETTINGS_MENU));
        }
        else
        {
            MMS_TRACE_EVENT((" "));
        }
    }
}

void      MMS_SettingsMenu_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	
	T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_SETTINGS_MENU  * data     = (T_MMS_SETTINGS_MENU *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
	
    char * title;
	MMS_TRACE_FUNCTION("MMS_SettingsMenu_dialog");
    switch( event )
    {
    case E_INIT:
        /* initialization of administrative data */     
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)MMS_SettingsMenu_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)MMS_SettingsMenu_kbd_cb);
        title = (char *) MmiRsrcGetText(TxtMMSSettings); 
		
        data->menu = mnuListCreate(data->win,(MfwMnuAttr*)parameter, E_MNU_ESCAPE, (MfwCb)MMS_SettingsMenu_mnu_cb,title);
        mnuLang(data->menu,mainMmiLng);
        /* put the (new) dialog window on top of the window stack */
        mnuUnhide(data->menu);
        winShow(win);
        break;
		
	case E_RETURN: 
    case E_EXIT: 
    case E_BACK:
		//MMS_MainMenu_destroy(data->win);
		//MMS_MainMenu_start(parent, (MfwMnuAttr*)MMSMainMenuAttributes());
		//SEND_EVENT (parent, E_BACK, 0, NULL); 
		break;
	case E_ABORT:
		MMS_SettingsMenu_destroy(data->win);
        SEND_EVENT (parent, event, 0, NULL); 
		break;
    default:
        return;
    }
}

int       MMS_SettingsMenu_kbd_cb(MfwEvt e, MfwKbd *k)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_SETTINGS_MENU      * data = (T_MMS_SETTINGS_MENU *)win_data->user;
	P_MMS  mms = getMMS();
	MMS_TRACE_FUNCTION("MMS_SettingsMenu_kbd_cb");
    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
			/*if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/
			
            returntoidle(0);
            break;
        case KCD_RIGHT: 
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
            mnuUp(data->menu);
            break;
        case KCD_MNUDOWN: /* highlight next entry */
            mnuDown(data->menu);
            break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:
            mnuSelect(data->menu);
            break;
        case KCD_HUP: /* back to previous menu */
			/*if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/
			
            if( returntoidle(0) )
                break;
			break;
        case KCD_RIGHT: /* back to previous menu */
            mnuEscape(data->menu);
            break;
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;
}

int       MMS_SettingsMenu_mnu_cb ( MfwEvt e, MfwMnu *m )
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_SETTINGS_MENU      * data = (T_MMS_SETTINGS_MENU *)win_data->user;
	T_MFW_HND              * parent=data->parent;
	MMS_TRACE_FUNCTION("MMS_SettingsMenu_mnu_cb");
    switch( e )
    {
    case E_MNU_ESCAPE: /* back to previous menu */
        MMS_SettingsMenu_destroy(data->win);	
        //SEND_EVENT (parent, E_BACK, 0, NULL); //delete by xie 04-07-13
        break;
		
    default: /* in mnuCreate() only E_MNU_ESCAPE has been enabled! */
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

int       MMS_SettingsMenu_win_cb(MfwEvt e, MfwWin *w)
{
	MMS_TRACE_FUNCTION("MMS_SettingsMenu_win_cb");
	switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        dspl_ClearAll();
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

//б
int MMS_Cur_Settings_List(MfwMnu* m, MfwMnuItem* i)
{
   T_MFW_HND    win  = mfwParent(mfw_header());
   MMS_TRACE_FUNCTION("MMS_Cur_Settings_List");
   MMS_All_Settings_List_start(win,CUR_SETTINGS); 
}

int MMS_All_Settings_List(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_All_Settings_List");
	MMS_All_Settings_List_start(win,ALL_SETTINGS); 
}

T_MFW_HND MMS_All_Settings_List_start (T_MFW_HND parent , SETTINGS_MENU_ID menuID)
{
	T_MFW_HND win;
    win = MMS_All_Settings_List_create(parent, menuID);
	MMS_TRACE_FUNCTION("MMS_All_Settings_List_start");
    if( win NEQ NULL )
    {
		SEND_EVENT (win, E_INIT, menuID, NULL);
    }
    return win;
}

T_MFW_HND MMS_All_Settings_List_create (T_MFW_HND parent_window, SETTINGS_MENU_ID menuID)
{
	T_MMS_ALL_SETTINGS_LIST * data = (T_MMS_ALL_SETTINGS_LIST *)ALLOC_MEMORY (sizeof (T_MMS_ALL_SETTINGS_LIST));
    T_MFW_WIN  * win;
	MMS_TRACE_FUNCTION("MMS_All_Settings_List_create");
    data->win =win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        return NULL;
    }
	
	if(menuID == CUR_SETTINGS)
	{
        MMS_Set_CurSetList_WHnd(data->win);
	}
	else if(menuID == ALL_SETTINGS)
	{
        MMS_Set_AllSetList_WHnd(data->win);
	}

    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_All_Settings_List_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
	
    winShow(data->win);
    return data->win;
}

void      MMS_All_Settings_List_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter)
{
	T_MFW_WIN         * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_ALL_SETTINGS_LIST    * data = (T_MMS_ALL_SETTINGS_LIST *)win_data->user;
    T_MFW_HND         * parent=data->parent;
	MMS_TRACE_FUNCTION("MMS_All_Settings_List_dialog");
    switch( event )
    {
    case E_INIT:
		/* initialization of the dialog data */
		data->list_menu_data.ListPosition   = iSettingsItemIndex+1;/* True cursor position in list menu. */
		data->list_menu_data.CursorPosition = iSettingsItemIndex;/* Cursor position in list snapshot.  */
		data->list_menu_data.Font           = 0;
		data->list_menu_data.LeftSoftKey    = TxtSoftSelect;
		data->list_menu_data.RightSoftKey   = TxtSoftBack;
		data->list_menu_data.KeyEvents      = KEY_RIGHT|KEY_LEFT |KEY_OK | KEY_MNUUP | KEY_MNUDOWN|KEY_HUP;
		data->list_menu_data.Reason         = 0;
		data->list_menu_data.Strings        = TRUE; 
		data->list_menu_data.Attr           = &MMS_All_Settings_List_Attrib;
		data->list_menu_data.autoDestroy    = TRUE;

		data->menuID = value;
		
		MMS_All_Settings_List_listmenu_create(data);
		break;
		
	case E_RETURN: 
    case E_EXIT: 
    case E_BACK:  
		MMS_All_Settings_List_destroy(data->win);
		SEND_EVENT (parent, event, 0, NULL); /* forward event to parent */
        break;		
    default:
        return;
    }
}

void      MMS_All_Settings_List_listmenu_create (T_MMS_ALL_SETTINGS_LIST *data)
{
	int i = 0;
    T_MFW_HND         * parent=data->parent;
    MMS_TRACE_FUNCTION("MMS_All_Settings_List_listmenu_create");
	data->list_menu_data.ListMenuFlag=1;//for display the title
	if(data->menuID == CUR_SETTINGS)
	{ 	
		data->list_menu_data.autoDestroy = TRUE;
		data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtMMSCurSettings);
		data->list_menu_data.List = (MfwMnuItem *)ALLOC_MEMORY (MMS_SETTINGS_SUM * sizeof (MfwMnuItem));
		for(i = 0; i < MMS_SETTINGS_SUM; i++)
		{
			data->list_menu_data.List[i].icon = (MfwIcnAttr*)&situationIcon;   ///textlistIcon;
			data->list_menu_data.List[i].exta = 0;
			data->list_menu_data.List[i].edit = 0;
			data->list_menu_data.List[i].menu = 0;
			if(i == 0)
			   data->list_menu_data.List[i].func = MMS_Setting_Group1; 
			else if(i == 1)
               data->list_menu_data.List[i].func = MMS_Setting_Group2; 
			else if(i == 2)
			   data->list_menu_data.List[i].func = MMS_Setting_Group3; 
			else if(i == 3)
			   data->list_menu_data.List[i].func = MMS_Setting_Group4; 
			else if(i == 4)
			   data->list_menu_data.List[i].func = MMS_Setting_Group5; 
			
			data->list_menu_data.List[i].flagFunc = MMS_Setting_flagFunc;	
			data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( MMS_SETTINGS_GROUPNAME_LEN +1);	
			
			if( mmsSettings.allSettings[i].strName[0] == 0x00)
			{
				char tempName[4];
				sprintf(tempName,"%d",i+1);
				wstrcpy(data->list_menu_data.List[i].str,(char *) MmiRsrcGetText(TxtMMSAllSettings));
                wstrcat(data->list_menu_data.List[i].str,tempName);
			}
			else
				wstrcpy(data->list_menu_data.List[i].str ,(char *) mmsSettings.allSettings[i].strName);	
		}
	}
	else if(data->menuID == ALL_SETTINGS)
	{
		data->list_menu_data.autoDestroy = TRUE;
		data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtMMSAllSettings);	
		data->list_menu_data.List = (MfwMnuItem *)ALLOC_MEMORY (MMS_SETTINGS_SUM * sizeof (MfwMnuItem));
		for(i = 0; i < MMS_SETTINGS_SUM; i++)
		{
			data->list_menu_data.List[i].icon = (MfwIcnAttr*)&colist;   ///textlistIcon;
			data->list_menu_data.List[i].exta = 0;
			data->list_menu_data.List[i].edit = 0;
			data->list_menu_data.List[i].menu = 0;
			data->list_menu_data.List[i].func = 0; 
			data->list_menu_data.List[i].flagFunc = item_flag_none;	
			data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY ( MMS_SETTINGS_GROUPNAME_LEN +1);	
			if( mmsSettings.allSettings[i].strName[0] == 0x00)
			{
				char tempName[4];
				sprintf(tempName,"%d",i+1);
				wstrcpy(data->list_menu_data.List[i].str,(char *) MmiRsrcGetText(TxtMMSAllSettings));
                wstrcat(data->list_menu_data.List[i].str,tempName);
			}
			else
			   wstrcpy(data->list_menu_data.List[i].str ,(char *) mmsSettings.allSettings[i].strName);
		}
    }
	
	data->list_menu_data.SnapshotSize   = MMS_SETTINGS_SUM; /* Number of list entries to view. */
	data->list_menu_data.ListLength = MMS_SETTINGS_SUM; 
	listDisplayListMenu(data->win, &data->list_menu_data, (ListCbFunc)MMS_All_Settings_List_listmenu_cb,0);
}

void      MMS_All_Settings_List_listmenu_cb (T_MFW_HND * win, ListMenuData * ListData)
{
#if 0
	extern void flash_MMSSettingsInfo();	
#endif 
	T_MFW_WIN         * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_ALL_SETTINGS_LIST    * data   = (T_MMS_ALL_SETTINGS_LIST *)win_data->user;
    T_MFW_WIN         * parent= data->parent;
	P_MMS mms = getMMS();
    MMS_TRACE_FUNCTION("MMS_All_Settings_List_listmenu_cb");
	switch( ListData->Reason )
	{
	case LISTS_REASON_OK:
	case LISTS_REASON_SELECT:
		iSettingsItemIndex=ListData->ListPosition;
		if(CUR_SETTINGS == data->menuID) 
		{
#if 0
			mmsSettings.curSettingsIndex = iSettingsItemIndex;
			flash_MMSSettingswrite();
			flash_MMSSettingsInfo();
#endif
		}
		else if(ALL_SETTINGS == data->menuID)
		{
			MMS_Settings_Opt_start(data->win , (MfwMnuAttr *)MMSAllSettingsMenuAttributes());  
		}		
		break;
		
	case LISTS_REASON_BACK: 
		MMS_All_Settings_List_destroy(data->win);
		SEND_EVENT (parent, E_BACK, 0, NULL);
		break;
		
	case LISTS_REASON_HANGUP:
	/*	if(mms->manager)
		{
			MMS_Codec_Destory();
			manager_on_destroy();
			mms->manager  = NULL;
		}*/
		
		if( returntoidle(0) )
			break;
		break;
		
	default:
		break;
	}
	return;
}

static void      MMS_All_Settings_List_destroy (T_MFW_HND window)
{
	T_MFW_WIN          * win_data;
    T_MMS_ALL_SETTINGS_LIST     * data;
    USHORT i;
	MMS_TRACE_FUNCTION("MMS_All_Settings_List_destroy");
    if( window )
    {
        win_data = ((T_MFW_HDR *)window)->data;
        data = (T_MMS_ALL_SETTINGS_LIST *)win_data->user;
		
        if( data )
        {
			if(data->menuID == CUR_SETTINGS)
			{
				MMS_Set_CurSetList_WHnd(NULL);
			}
			else if(data->menuID == ALL_SETTINGS)
			{
				MMS_Set_AllSetList_WHnd(NULL);
			}

            win_delete (data->win);
			data->win =  NULL;
            for( i = 0; i < MMS_SETTINGS_SUM; i++ )
                FREE_MEMORY( (void *)(data->list_menu_data.List[i].str), MMS_SETTINGS_GROUPNAME_LEN +1);
            FREE_MEMORY ((void *)data->list_menu_data.List, MMS_SETTINGS_SUM* sizeof (MfwMnuItem)); 
            FREE_MEMORY ((void *)data, sizeof (T_MMS_ALL_SETTINGS_LIST));
			iSettingsItemIndex = 0;
        }
        else
        {
            TRACE_EVENT ("MMS_All_Settings_destroy called twice");
        }
    }
}

//õѡ˵
static T_MFW_HND MMS_Settings_Opt_start(MfwHnd parent_window , MfwMnuAttr *menuAttr)
{
	T_MFW_HND win;	
	MMS_TRACE_FUNCTION("MMS_Settings_Opt_start");
    win = MMS_Settings_Opt_create (parent_window);	
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, NULL, (void *)menuAttr);
    }
    return win;
}

static T_MFW_HND MMS_Settings_Opt_create(T_MFW_HND parent_window)
{
	T_MMS_SETTINGS_OPT      * data = (T_MMS_SETTINGS_OPT *)ALLOC_MEMORY (sizeof (T_MMS_SETTINGS_OPT));
    T_MFW_WIN  * win;
	MMS_TRACE_FUNCTION("MMS_Settings_Opt_create");
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)MMS_Settings_Opt_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
	
    data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Settings_Opt_dialog;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
	
    return data->win;
}

static void      MMS_Settings_Opt_destroy(T_MFW_HND win)
{
	T_MFW_WIN              * win_data;
    T_MMS_SETTINGS_OPT     * data;
	P_MMS mms = getMMS();
	MMS_TRACE_FUNCTION("MMS_Settings_Opt_destroy");
    if(win)
    {
        win_data = ((T_MFW_HDR *)win)->data;
        data = (T_MMS_SETTINGS_OPT *)win_data->user;
		
        if( data )
        {
			if(data->kbd)
			{
				kbd_delete(data->kbd);
				data->kbd = NULL;
			}

			if(data->kbd_long)
			{
				kbd_delete(data->kbd_long);
				data->kbd_long = NULL;
			}

			if(data->menu)
			{
				mnuDelete(data->menu);
				data->menu = NULL;
			}
            win_delete (data->win);
			data->win = NULL;
            FREE_MEMORY ((void *)data, sizeof (T_MMS_SETTINGS_OPT));
        }
        else
        {
            MMS_TRACE_EVENT((" "));
        }
    }
}

static void      MMS_Settings_Opt_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_SETTINGS_OPT  * data     = (T_MMS_SETTINGS_OPT *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
	
    char * title;
	MMS_TRACE_FUNCTION("MMS_Settings_Opt_dialog");
    switch( event )
    {
    case E_INIT:
        /* initialization of administrative data */     
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)MMS_Settings_Opt_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)MMS_Settings_Opt_kbd_cb);
        title = (char *) MmiRsrcGetText(TxtMMSAllSettings); 
		
        data->menu = mnuListCreate(data->win,(MfwMnuAttr*)parameter, E_MNU_ESCAPE, (MfwCb)MMS_Settings_Opt_mnu_cb,title);
        mnuLang(data->menu,mainMmiLng);
        /* put the (new) dialog window on top of the window stack */
        mnuUnhide(data->menu);
        winShow(win);
        break;
		
	case E_RETURN: 
    case E_EXIT: 
    case E_BACK:
		//SEND_EVENT (parent, E_BACK, 0, NULL); 
		break;
	case E_ABORT:
		MMS_Settings_Opt_destroy(data->win);
        SEND_EVENT (parent, event, 0, NULL); 
		break;
    default:
        return;
    }
}

static int       MMS_Settings_Opt_kbd_cb(MfwEvt e, MfwKbd *k)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_SETTINGS_OPT      * data = (T_MMS_SETTINGS_OPT *)win_data->user;
	P_MMS  mms = getMMS();
	MMS_TRACE_FUNCTION("MMS_Settings_Opt_kbd_cb");
    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
	/*		if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;			
			}*/
			
            returntoidle(0);
            break;
        case KCD_RIGHT: 
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
            mnuUp(data->menu);
            break;
        case KCD_MNUDOWN: /* highlight next entry */
            mnuDown(data->menu);
            break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:
            mnuSelect(data->menu);
            break;
        case KCD_HUP: /* back to previous menu */
		/*	if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/
			
            if( returntoidle(0) )
                break;
			break;
        case KCD_RIGHT: /* back to previous menu */
            mnuEscape(data->menu);
            break;
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;
}

static int       MMS_Settings_Opt_mnu_cb ( MfwEvt e, MfwMnu *m )
{
	T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_MMS_SETTINGS_OPT      * data = (T_MMS_SETTINGS_OPT *)win_data->user;
	T_MFW_HND              * parent=data->parent;
	MMS_TRACE_FUNCTION("MMS_Settings_Opt_mnu_cb");
    switch( e )
    {
    case E_MNU_ESCAPE: /* back to previous menu */
        MMS_Settings_Opt_destroy(data->win);	
		SEND_EVENT (parent, E_BACK, 0, NULL);
        break;
		
    default: /* in mnuCreate() only E_MNU_ESCAPE has been enabled! */
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

static int       MMS_Settings_Opt_win_cb(MfwEvt e, MfwWin *w)
{
	MMS_TRACE_FUNCTION("MMS_Settings_Opt_win_cb");
	switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        dspl_ClearAll();
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

//еı༭                     
T_MFW_HND MMS_Settings_Edit_start(T_MFW_HND parent, unsigned int  winID)
{
    T_MFW_HND win;
    win = MMS_Settings_Edit_create(parent);
	MMS_TRACE_FUNCTION("MMS_Settings_Edit_start");
    if( win NEQ NULL )
    {
		SEND_EVENT (win, E_INIT, winID, NULL);
    }
    return win;
}

T_MFW_HND MMS_Settings_Edit_create(MfwHnd parent_window)
{	
	T_MMS_SETTINGS_EDITOR  * data = (T_MMS_SETTINGS_EDITOR *)ALLOC_MEMORY (sizeof (T_MMS_SETTINGS_EDITOR));
	T_MFW_WIN  * win;
	MMS_TRACE_FUNCTION("MMS_Settings_Edit_create");   	   
	data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
	if( data->win EQ NULL )
	{
	   return NULL;
	}
	
//	MMS_Set_MMSSettingEdits_WHnd(data->win);//add by xie 04-07-14

	data->mmi_control.dialog = (T_DIALOG_FUNC)MMS_Settings_Edit_dialog;
	data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
	win->user                = (void *)data;
	data->parent             = parent_window;
	   
    winShow(data->win);
	return data->win;
}

void MMS_Settings_Edit_dialog (T_MFW_HND win, USHORT event, USHORT value, void * parameter)
{  
    T_MFW_WIN                  * win_data = ((T_MFW_HDR *) win)->data;
	T_MMS_SETTINGS_EDITOR      * data = (T_MMS_SETTINGS_EDITOR *)win_data->user;
    T_MFW_HDR                  * parent      =  data->parent;
    MMS_TRACE_FUNCTION("MMS_Settings_Edit_dialog");  
	switch(event)
	{
	case E_INIT:
		{			
			switch(value)
			{
			case MMS_SETTINGS_GROUP_NAME:
				data->winID = MMS_SETTINGS_GROUP_NAME;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSEditGroupName,(char *)mmsSettings.allSettings[iSettingsItemIndex].strName, MMS_SETTINGS_GROUPNAME_LEN ,edtCurBar1);
				data->editor_info.mode                 = TEXTINPUT_MODE;//SHUZI_MODE;     
				//data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = PINYIN_INPUT_MODE;  				
				//data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = text_input(win, &(data->editor_info));//text_input(win, &editor_data);
				break;
			case MMS_MMSC_URL:
				data->winID = MMS_MMSC_URL;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSMMSCURL,(char *)mmsSettings.allSettings[iSettingsItemIndex].mmscURL, MMSC_URL_LEN ,edtCurBar1);
				data->editor_info.mode                 = TEXTINPUT_MODE;//SHUZI_MODE;     
				//data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = LOWERCASE_INPUT_MODE;  				
//				data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = text_input(win, &(data->editor_info));//text_input(win, &editor_data);
				break;
			case MMS_GSM_IP_ADDRESS:
				data->winID = MMS_GSM_IP_ADDRESS;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSIPAddress,(char *)mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.IPAddress,MMS_SETTINGS_IP_ADDRESS_LEN,edtCurBar1);
				data->editor_info.mode                 = TEXTINPUT_MODE;//TEXTINPUT_MODE;     
				//data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = SHUZI_INPUT_MODE;  				
//				data->editor_info.editor_attr.e_size   = 163;
			    data->editor                           = text_input(win, &(data->editor_info));//text_input(win, &editor_data);
				break;
			case MMS_GSM_IP_PORT:
				data->winID = MMS_GSM_IP_PORT;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSIPPort,(char *)mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.IPPort,MMS_SETTINGS_IP_PORT_LEN,edtCurBar1);				
				data->editor_info.mode                 = SHUZI_MODE;//TEXTINPUT_MODE;     
				//data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = PINYIN_INPUT_MODE;  				
//				data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = editor_start(win, &(data->editor_info));//text_input(win, &editor_data);
				break;
			case MMS_GSM_DIAL_NUMBER:
				data->winID = MMS_GSM_DIAL_NUMBER;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSDiaNumber,(char *)mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.dialNumber,MMS_SETTINGS_DIALNUMBER_LEN,edtCurBar1);
				data->editor_info.mode                 = SHUZI_MODE;  
				//			data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//			data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = PINYIN_INPUT_MODE;  
				
//				data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = editor_start(win, &(data->editor_info));
				break;        
			case MMS_GSM_LOGIN_ID:
                data->winID = MMS_GSM_LOGIN_ID;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSLoginID,(char *)mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.userName,MMS_SETTINGS_USERNAME_LEN,edtCurBar1);
				data->editor_info.mode                 = TEXTINPUT_MODE; 
				//data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
//				data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = LOWERCASE_INPUT_MODE;  
				
//				data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = text_input(win, &(data->editor_info));
				break;
			case MMS_GSM_PASSWORD:
				data->winID = MMS_GSM_PASSWORD;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSPassword,(char *)mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.password,MMS_SETTINGS_PASSWORD_LEN,edtCurBar1);
				data->editor_info.mode                 = SHUZI_MODE; 
				//data->editor_info.Identifier         = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				data->editor_info.hide	= TRUE;
				//				data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = PINYIN_INPUT_MODE;  
				
				//data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = editor_start(win, &(data->editor_info));
			    break;
			case MMS_GPRS_IP_ADDRESS:
				data->winID = MMS_GPRS_IP_ADDRESS;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSIPAddress,(char *)mmsSettings.allSettings[iSettingsItemIndex].gprsSettings.IPAddress,MMS_SETTINGS_IP_ADDRESS_LEN,edtCurBar1);
				data->editor_info.mode                 = TEXTINPUT_MODE; 
				//data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//				data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = SHUZI_INPUT_MODE;  
				
				//				data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = text_input(win, &(data->editor_info));
				break;
			case MMS_GPRS_IP_PORT:
				data->winID = MMS_GPRS_IP_PORT;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSIPPort,(char *)mmsSettings.allSettings[iSettingsItemIndex].gprsSettings.IPPort,MMS_SETTINGS_IP_PORT_LEN,edtCurBar1);
				data->editor_info.mode                 = SHUZI_MODE; 
				//data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//				data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = PINYIN_INPUT_MODE;  
				
				//				data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = editor_start(win, &(data->editor_info));
				break;
			case MMS_GPRS_APN:
				data->winID = MMS_GPRS_APN;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSAPN,(char *)mmsSettings.allSettings[iSettingsItemIndex].gprsSettings.APN,MMS_SETTINGS_APN_LEN,edtCurBar1);
				data->editor_info.mode                 = TEXTINPUT_MODE; 
				//data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//				data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = LOWERCASE_INPUT_MODE;  
				
				//				data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = text_input(win, &(data->editor_info));
				break;
			case MMS_GPRS_LOGIN_ID:
				data->winID = MMS_GPRS_LOGIN_ID;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSLoginID,(char *)mmsSettings.allSettings[iSettingsItemIndex].gprsSettings.userName,MMS_SETTINGS_USERNAME_LEN,edtCurBar1);
				data->editor_info.mode                 = TEXTINPUT_MODE; 
				//data->editor_info.Identifier           = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				//data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = LOWERCASE_INPUT_MODE;  
				
				//data->editor_info.editor_attr.e_size   = 163;
				data->editor                           = text_input(win, &(data->editor_info));
				break;
			case MMS_GPRS_PASSWORD:
				data->winID = MMS_GPRS_PASSWORD;
				MMS_Settings_Edit_LoadEditDefault(&(data->editor_info));
				editor_attr_init_fullscr(&(data->editor_info.editor_attr),1,TxtMMSPassword,(char *)mmsSettings.allSettings[iSettingsItemIndex].gprsSettings.password,MMS_SETTINGS_PASSWORD_LEN,edtCurBar1);
				data->editor_info.mode                 = SHUZI_MODE; 
				//data->editor_info.Identifier         = SMSSEND_ID_TEXTEDIT ; 
				data->editor_info.min_enter            = 0; 
				data->editor_info.LeftSoftKey          = TxtConfirm;	
				data->editor_info.edtInPbk             = 0;
				data->editor_info.hide                 = TRUE;
				//data->editor_info.AlternateLeftSoftKey = TxtSoftOptions;
				data->editor_info.RightSoftKey         = TxtDelete;
				data->editor_info.Callback             = (T_EDIT_CB)MMS_Settings_Edit_edit_cb;
				data->editor_info.destroyEditor        = FALSE;
				data->editor_info.InputMode            = SHUZI_INPUT_MODE;  
				
				//data->editor_info.editor_attr.e_size = 163;
				data->editor                           = editor_start(win, &(data->editor_info));
				break;
			default:
				return;             
}
		}
		break;
		
	case E_ABORT:
	case E_EXIT: 
		MMS_Settings_Edit_destroy(data->win);
        SEND_EVENT (parent, event, 0, NULL); /* forward event to parent */
		break;
	default:
		return;
	}
	return;
}

void MMS_Settings_Edit_edit_cb(T_MFW_HND win, USHORT Identifier, SHORT reason)
{
	T_MFW_WIN           * win_data = ((T_MFW_HDR *) win)->data;
    T_MMS_SETTINGS_EDITOR  * data     = (T_MMS_SETTINGS_EDITOR *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
    MMS_TRACE_FUNCTION("MMS_Settings_Edit_edit_cb");  
	switch( reason )
    {
    case INFO_KCD_ALTERNATELEFT:
    case INFO_KCD_LEFT:
		switch(data->winID)
		{
		case MMS_SETTINGS_GROUP_NAME:
			break;
			
		case MMS_MMSC_URL:
			{
                manager_set_mmscaddress((MMS_S8 *)mmsSettings.allSettings[iSettingsItemIndex].mmscURL);
			}	
			break;
			
		case MMS_GSM_IP_ADDRESS:
			{
				
			}

		case MMS_GSM_IP_PORT:
			{

			}

		case MMS_GSM_DIAL_NUMBER:
			{

			}
		case MMS_GSM_LOGIN_ID:
			{

			}

		case MMS_GSM_PASSWORD:
			{

			}
			
		case MMS_GPRS_IP_ADDRESS:
			{
//				manager_set_wapaddress(MMS_S8 *wapgw)
			}

		case MMS_GPRS_IP_PORT:
			{
//              MMS_Open("10.0.0.172", 9201, MMSRecvCallBack);
			}

		case MMS_GPRS_APN:
			{

			}

		case MMS_GPRS_LOGIN_ID:
			{

			}
			
		case MMS_GPRS_PASSWORD:
			{

			}
		}
		flash_MMSSettingswrite();
	    MMS_Settings_Edit_destroy(data->win);
//		SEND_EVENT (parent, E_BACK, 0, NULL);
//	    SEND_EVENT (parent, E_EXIT, 0, NULL);
        break;

    case INFO_KCD_RIGHT:
		MMS_Settings_Edit_destroy(data->win);
//		SEND_EVENT (win, E_BACK, 0, NULL);
//		SEND_EVENT (parent, E_EXIT, 0, NULL);
        break;

	case INFO_KCD_HUP:
		{
			/*P_MMS mms = getMMS();
			if(mms->manager)
			{
				MMS_Codec_Destory();
				manager_on_destroy();
				mms->manager = NULL;
			}*/
		}
		flash_MMSSettingswrite();
		if( returntoidle(0) )
			break;
		break;
		
    default:
        TRACE_EVENT("Err: Default");
        break;
    }
}

void MMS_Settings_Edit_destroy(MfwHnd own_window)
{   
    T_MFW_WIN * win_data;
    T_MMS_SETTINGS_EDITOR    * data = NULL; 
	MMS_TRACE_FUNCTION("MMS_Settings_Edit_destroy"); 
    if( own_window )
    {
		win_data = ((T_MFW_HDR *)own_window)->data;
		if( win_data != NULL )
			data = (T_MMS_SETTINGS_EDITOR *)win_data->user;
		
		if (data)
		{
		    //text_input_destroy must correspond with text_input and editor_destroy with editor_start
			if(
				data->winID == MMS_GSM_IP_PORT     || 
				data->winID == MMS_GSM_DIAL_NUMBER || 
				data->winID == MMS_GPRS_IP_PORT    ||
				data->winID == MMS_GSM_PASSWORD    || 
				data->winID == MMS_GPRS_PASSWORD
			  )  
			{
		       if(data->editor != 0)
			   {
				   editor_destroy(data->editor);
				   data->editor = 0;
			   }
			}
			else
			{
				if(data->editor!=0)
				{
				   text_input_destroy(data->editor);
				   data->editor = 0;
				}
			}

		    win_delete (data->win);

//			MMS_Set_MMSSettingEdits_WHnd(NULL);//add by xie 04-07-14
		    /*     
		     * Free Memory
		     */
		    FREE_MEMORY ((void *)data, sizeof (T_MMS_SETTINGS_EDITOR));
		}
	    else
		{
		    TRACE_EVENT (" ");
		}
	}
    
}

void MMS_Settings_Edit_LoadEditDefault(T_EDITOR_DATA *editor_data)
{	
	editor_attr_init(&editor_data->editor_attr, NULL, edtCurNone, 0, 0, 0);
	editor_data->hide				= FALSE;
	editor_data->min_enter			= 1;  
	editor_data->LeftSoftKey		= TxtSoftSelect;
	editor_data->RightSoftKey		= TxtSoftBack;
	editor_data->AlternateLeftSoftKey   = TxtNull;
	editor_data->TextId				= '\0';  
	editor_data->Identifier			=  0; 
	editor_data->TextString			= NULL;  
	editor_data->timeout			= FOREVER; 
	editor_data->mode                = ALPHA_MODE;
	editor_data->Callback			= NULL;
	editor_data->destroyEditor		= TRUE ; 
}



int MMS_Setting_SendReport_On(MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_SendReport_On"); 
	if(mmsSettings.allSettings[iSettingsItemIndex].sendSettings.stateSendReport == MMS_PARAM_OFF)
	{
      mmsSettings.allSettings[iSettingsItemIndex].sendSettings.stateSendReport = MMS_PARAM_ON;
	  flash_MMSSettingswrite();
	  manager_set_report(MMS_PARAM_ON);
	}
	else
	  return 0;		
//  stateSendReport = MMS_PARAM_ON;
	mnuUpdate(m);   
	return 1;
}

int MMS_Setting_SendReport_Off(MfwMnu* m, MfwMnuItem* i)
{
    MMS_TRACE_FUNCTION("MMS_Setting_SendReport_Off"); 
	if(mmsSettings.allSettings[iSettingsItemIndex].sendSettings.stateSendReport == MMS_PARAM_ON)
	{
		mmsSettings.allSettings[iSettingsItemIndex].sendSettings.stateSendReport = MMS_PARAM_OFF;
		flash_MMSSettingswrite();
		manager_set_report(MMS_PARAM_OFF);
	}
	else
		return 0;	
//	stateSendReport = MMS_PARAM_OFF;
	mnuUpdate(m); 
	return 1;
}
int MMS_Setting_AutoSave_On(MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_AutoSave_On"); 
	if(mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoSave == MMS_PARAM_OFF)
	{
		mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoSave = MMS_PARAM_ON;
		flash_MMSSettingswrite();
		manager_set_autosave(MMS_PARAM_ON);
	}
	else
		return 0;
//	stateAutoSave   = MMS_PARAM_ON;
    mnuUpdate(m);
	return 1;
}

int MMS_Setting_AutoSave_Off(MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_AutoSave_Off"); 
	if(mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoSave == MMS_PARAM_ON)
	{
		mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoSave = MMS_PARAM_OFF;
        flash_MMSSettingswrite();
		manager_set_autosave(MMS_PARAM_OFF);
	}
	else
		return 0;
//  stateAutoSave   =MMS_PARAM_OFF;
	mnuUpdate(m); 
	return 1;
}

int MMS_Setting_AutoRecv_On(MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_AutoRecv_On"); 
	if(mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoRecv == MMS_PARAM_OFF)
	{
		mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoRecv = MMS_PARAM_ON;
		flash_MMSSettingswrite();
		manager_set_autorecv(MMS_PARAM_ON);
	}
	else
		return 0;
//	stateAutoRecv   = MMS_PARAM_ON;
	mnuUpdate(m); 
	return 1;
}

int MMS_Setting_AutoRecv_Off(MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_AutoRecv_Off"); 
    if(mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoRecv == MMS_PARAM_ON)
	{
		mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoRecv = MMS_PARAM_OFF;
		flash_MMSSettingswrite();
		manager_set_autorecv(MMS_PARAM_OFF);
	}
	else
		return 0;;
//	stateAutoRecv   = MMS_PARAM_OFF;
	mnuUpdate(m); 
	return 1;
}

USHORT MMS_Setting_flagFunc( struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi )
{
	MMS_TRACE_FUNCTION("MMS_Setting_flagFunc");
	if(
	    ( ((int)mi->str==TxtMMSAutoSaveOn ) && (mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoSave == MMS_PARAM_ON ) ) ||
	    ( ((int)mi->str==TxtMMSAutoSaveOff) && (mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoSave == MMS_PARAM_OFF) ) ||
			  
		( ((int)mi->str==TxtMMSAutoRecvOn ) && (mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoRecv == MMS_PARAM_ON ) ) ||
		( ((int)mi->str==TxtMMSAutoRecvOff) && (mmsSettings.allSettings[iSettingsItemIndex].recvSettings.stateAutoRecv == MMS_PARAM_OFF) ) ||
			  
		( ((int)mi->str==TxtMMSSendReportOn ) && (mmsSettings.allSettings[iSettingsItemIndex].sendSettings.stateSendReport == MMS_PARAM_ON ) ) ||
		( ((int)mi->str==TxtMMSSendReportOff) && (mmsSettings.allSettings[iSettingsItemIndex].sendSettings.stateSendReport == MMS_PARAM_OFF) ) ||

		( ((int)mi->str==TxtMMSOnlyGPRS ) && (mmsSettings.allSettings[iSettingsItemIndex].transportMode == ONLY_GPRS ) ) ||
		( ((int)mi->str==TxtMMSOnlyGSM)   && (mmsSettings.allSettings[iSettingsItemIndex].transportMode == ONLY_GSM) )   ||

//		( ((int)mi->str==TxtMMSISDN    ) && (mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.dataCallType == ISDN ) ) ||//deleted by xie 04-07-14
//		( ((int)mi->str==TxtMMSAnologue)   && (mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.dataCallType == ANALOGUE) ) ||
		
		( (mi->func == (MenuFunc)MMS_Setting_Group1 ) && (mmsSettings.curSettingsIndex == 0 ) ) ||
		( (mi->func == (MenuFunc)MMS_Setting_Group2 ) && (mmsSettings.curSettingsIndex == 1 ) ) ||
		( (mi->func == (MenuFunc)MMS_Setting_Group3 ) && (mmsSettings.curSettingsIndex == 2 ) ) ||
		( (mi->func == (MenuFunc)MMS_Setting_Group4 ) && (mmsSettings.curSettingsIndex == 3 ) ) ||
		( (mi->func == (MenuFunc)MMS_Setting_Group5 ) && (mmsSettings.curSettingsIndex == 4 ) ) 
	) 
	    return FLAGFUNC_TRUE_ICON;
	else 
	    return FLAGFUNC_FALSE_ICON;

}

int MMS_Setting_GSM_IPAddress(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_GSM_IPAddress");
	MMS_Settings_Edit_start(win, MMS_GSM_IP_ADDRESS);
}

int MMS_Setting_GSM_IPPort(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_GSM_IPPort");
    MMS_Settings_Edit_start(win, MMS_GSM_IP_PORT);
}

#if 0  //deleted by xie 04-07-14
int MMS_Setting_GSM_ISDN(MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_GSM_ISDN");
	if(mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.dataCallType == ANALOGUE)
	{
		mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.dataCallType = ISDN;
		flash_MMSSettingswrite();
	}
	else
		return 0;
	mnuUpdate(m);
	return 1;
}

int MMS_Setting_GSM_Anologue(MfwMnu* m, MfwMnuItem* i)
{
    MMS_TRACE_FUNCTION("MMS_Setting_GSM_Anologue");
	if(mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.dataCallType == ISDN)
	{
		mmsSettings.allSettings[iSettingsItemIndex].gsmSettings.dataCallType = ANALOGUE;
		flash_MMSSettingswrite();
	}
	else
		return 0;
	mnuUpdate(m);
	return 1;
}
#endif

int MMS_Setting_GSM_Dial_Number(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_GSM_Dial_Number");
	MMS_Settings_Edit_start(win, MMS_GSM_DIAL_NUMBER);
}

int MMS_Setting_GSM_Login_ID(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_GSM_Login_ID");
	MMS_Settings_Edit_start(win, MMS_GSM_LOGIN_ID);
}

int MMS_Setting_GSM_Password(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_GSM_Password");
	MMS_Settings_Edit_start(win, MMS_GSM_PASSWORD);
}

int MMS_Setting_GPRS_IPAddress(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_GPRS_IPAddress");
	MMS_Settings_Edit_start(win, MMS_GPRS_IP_ADDRESS);
}

int MMS_Setting_GPRS_IPPort(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_GPRS_IPPort");
	MMS_Settings_Edit_start(win, MMS_GPRS_IP_PORT);
}

int MMS_Setting_GPRS_APN(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());	
	MMS_TRACE_FUNCTION("MMS_Setting_GPRS_APN");
    MMS_Settings_Edit_start(win, MMS_GPRS_APN);
}

int MMS_Setting_GPRS_Login_ID(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_GPRS_Login_ID"); 
	MMS_Settings_Edit_start(win, MMS_GPRS_LOGIN_ID);
}

int MMS_Setting_GPRS_Password(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_GPRS_Password"); 
	MMS_Settings_Edit_start(win, MMS_GPRS_PASSWORD);
}

int MMS_Setting_Only_GPRS(MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_Only_GPRS"); 
	if(mmsSettings.allSettings[iSettingsItemIndex].transportMode == ONLY_GSM)
	{
		mmsSettings.allSettings[iSettingsItemIndex].transportMode = ONLY_GPRS;
		flash_MMSSettingswrite();
	}
	else
		return 0;
	mnuUpdate(m);
	return 1;
}

int MMS_Setting_Only_GSM(MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_Only_GSM"); 
	if(mmsSettings.allSettings[iSettingsItemIndex].transportMode == ONLY_GPRS)
	{
		mmsSettings.allSettings[iSettingsItemIndex].transportMode = ONLY_GSM;
		flash_MMSSettingswrite();
	}
	else
		return 0;
	mnuUpdate(m);
	return 1;
}

int MMS_Setting_MMSCURL(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_MMSCURL"); 
	MMS_Settings_Edit_start(win, MMS_MMSC_URL);
}

int MMS_Setting_Group_Name(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	MMS_TRACE_FUNCTION("MMS_Setting_Group_Name"); 
	MMS_Settings_Edit_start(win, MMS_SETTINGS_GROUP_NAME);
}

//ǰò˵Ӧ
int MMS_Setting_Group1 (MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_Group1"); 	
	if(mmsSettings.curSettingsIndex != 0)
	{
		mmsSettings.curSettingsIndex = 0;
		flash_MMSSettingswrite();
	}
	else
		return 0;
	mnuUpdate(m);
	return 1;  
}

int MMS_Setting_Group2 (MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_Group2"); 
	if(mmsSettings.curSettingsIndex != 1)
	{
		mmsSettings.curSettingsIndex = 1;
		flash_MMSSettingswrite();
	}
	else
		return 0;
	mnuUpdate(m);
	return 1;  
}

int MMS_Setting_Group3 (MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_Group3"); 
	if(mmsSettings.curSettingsIndex != 2)
	{
		mmsSettings.curSettingsIndex = 2;
		flash_MMSSettingswrite();
	}
	else
		return 0;
	mnuUpdate(m);
	return 1;  
}

int MMS_Setting_Group4 (MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_Group4"); 
	if(mmsSettings.curSettingsIndex != 3)
	{
		mmsSettings.curSettingsIndex = 3;
		flash_MMSSettingswrite();
	}
	else
		return 0;
	mnuUpdate(m);
	return 1;  
}

int MMS_Setting_Group5 (MfwMnu* m, MfwMnuItem* i)
{
	MMS_TRACE_FUNCTION("MMS_Setting_Group5"); 
	if(mmsSettings.curSettingsIndex != 4)
	{
		mmsSettings.curSettingsIndex = 4;
		flash_MMSSettingswrite();
	}
	else
		return 0;
	mnuUpdate(m);
	return 1;  
}

#endif