unit callrecord;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TForm_CallRecord = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label3: TLabel;
    Edit_sort: TEdit;
    Edit_time: TEdit;
    Edit_phNo: TEdit;
    Label2: TLabel;
    Edit_Name: TEdit;
    Label4: TLabel;
    GroupBox_phblocation: TGroupBox;
    RadioButton_CR_SAVE: TRadioButton;
    RadioButton_CR_Del: TRadioButton;
    RadioButton_CR_sendsms: TRadioButton;
    Timer_cr: TTimer;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer_crTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_CallRecord: TForm_CallRecord;

implementation

uses main;

{$R *.dfm}

procedure TForm_CallRecord.FormActivate(Sender: TObject);
begin
  RadioButton_CR_SAVE.Checked:=true;
  RadioButton_CR_SAVE.Checked:=false;
  if form_main.ListView_CallRecord_main.Selected<>nil then
  begin
    edit_sort.Text:=form_main.ListView_CallRecord_main.Selected.SubItems[1];
    edit_time.Text:=form_main.ListView_CallRecord_main.Selected.SubItems[2];
    edit_phNo.Text:=form_main.ListView_CallRecord_main.Selected.SubItems[3];
    edit_Name.Text:=form_main.ListView_CallRecord_main.Selected.SubItems[4];
  end else
  begin
    edit_sort.Text:='';
    edit_time.Text:='';
    edit_phNo.Text:='';
    edit_Name.Text:='';
  end;
  Timer_CR.Enabled:=true;
end;

procedure TForm_CallRecord.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Timer_CR.Enabled:=false;
  OKBtn.Enabled:=false;
end;

procedure TForm_CallRecord.Timer_crTimer(Sender: TObject);
begin
  if (trim(Edit_phNo.text)<>'')and
   (RadioButton_CR_SAVE.Checked or RadioButton_CR_Del.Checked or RadioButton_CR_sendsms.Checked) then
  begin
    OKBtn.Enabled:=true
  end else
    OKBtn.Enabled:=false;
end;

end.
