unit global;

interface

uses Messages,classes,sysutils,Windows,mmsystem,ComCtrls,Dialogs;

const                                                                     
//public
    MFW_STRING_LEN=	   161;
    MFW_TAG_LEN=         21;
    MFW_SUBADR_LEN=      21;
    MAX_LEN=             21;
    MAX_CURRENCY=         5;

//绰
    PHB_name_len =        13;
    PHB_number_len =      21;
    PHB_numberExt_len =   7;
    PHB_memo_len   =      22;
    PHB_MaxUnicode = 11;
    PHB_MaxASC = 22;

//SMS const
    MAX_SCTP_DIGITS=  2;
    MAX_MSG_LEN=  573; //Max size for a SMS
    MFW_NUM_LEN=    41;
    MAX_MESSAGES =  50;
    SMS_MaxUnicode = 70;
    SMS_MaxASC = 160;

//Call record const
    CR_name_length=24;
    
    SIZE_BUFFER=32000;

//    PHB_TYPE_NVM= $01; //ֻ绰
//    PHB_TYPE_SIM= $02; //SIM绰
//    PHB_TYPE_PC= $00; //SIM绰

    CR_TYPE_LMN= 	$01; //δӵ绰
    CR_TYPE_LRN= 	$04; //ѽӵ绰
    CR_TYPE_LDN=	$08; //Ѳ绰

    PC_AppCID1_File=$11;	//file operate
    PC_AppCID1_PHB=$12;             //Phone Book
    PC_AppCID1_SMS=$13;             // SMS
    PC_AppCID1_CR=$14;             //ͨ¼
    PC_AppCID1_MAX=$15;

   	PC_AppCID2_Read=$11;  //read
    PC_AppCID2_Write=$12;		  //write,modify,add
    PC_AppCID2_Delete=$13;         //delete
    PC_AppCID2_Copy=$14;         //copy info
    PC_AppCID2_Info=$15;              //base Infomation
    PC_AppCID2_MAX=$16;

    PC_IF_FLAGS_DATAUL  =  $01;
    PC_IF_FLAGS_CMD  =     $02;
    PC_IF_FLAGS_DATADL  =  $10;

    PC_FILE_status_init = $01;
    PC_FILE_status_getfileinfo = $02;
    PC_FILE_status_DLfile = $03;
    PC_FILE_status_ULfile = $04;
    PC_FILE_status_Delfile=$05;

    PC_PHB_status_init = $01;
    PC_PHB_status_getPHBcount = $02;
    PC_PHB_status_getPHBList = $03;
    PC_PHB_status_AddPHB = $04;
    PC_PHB_status_DelPHB=$05;
    PC_PHB_status_EditPHB=$06;
    PC_SMS_status_CopyPHB=$07;

    PC_SMS_status_init = $01;
    PC_SMS_status_getSMScount = $02;
    PC_SMS_status_getFlashSMSList = $03;
    PC_SMS_status_getSIMSMSList = $04;
    PC_SMS_status_DelSMS=$05;
    PC_SMS_status_SendSMS=$06;
    PC_SMS_status_SaveSendSMS=$07;
    PC_SMS_status_SaveSMS=$08;
    PC_SMS_status_CopySMS=$09;

    PC_CR_status_init = $01;
    PC_CR_status_getCRcount = $02;
    PC_CR_status_getCRLMNList = $03;
    PC_CR_status_getCRLRNList = $04;
    PC_CR_status_getCRLDNList = $05;
    PC_CR_status_DelCR=$06;

    g_ascii_gsm_table :array[0..255] of byte= (
      $20,$20,$20,$20,$20,$20,$20,$20, //000-007
      $20,$20,  10,$20,$20,  13,$20,$20, //008-015
      $20,$20,$20,$20,$20,$20,$20,$20, //016-023
      $20,$20,$20,$20,$20,$20,$20,$20, //024-031
      32,  33,  34,  35,   2,  37,  38,  39, //032-039
      40,  41,  42,  43,  44,  45,  46,  47, //040-047
      48,  49,  50,  51,  52,  53,  54,  55, //048-055
      56,  57,  58,  59,  60,  61,  62,  63, //056-063
      0,  65,  66,  67,  68,  69,  70,  71, //064-071
      72,  73,  74,  75,  76,  77,  78,  79, //072-079
      80,  81,  82,  83,  84,  85,  86,  87, //080-087
      88,  89,  90,$20,$20,$20,$20,$20, //088-095
      $20,  97,  98,  99, 100, 101, 102, 103, //096-103
      104, 105, 106, 107, 108, 109, 110, 111, //104-111
      112, 113, 114, 115, 116, 117, 118, 119, //112-119
      120, 121, 122,$20,$20,$20,$20,$20, //120-127
      9, 126,   5,$20, 123, 127,  15,$20, //128-135
      $20,$20,   4,$20,$20,   7,  91,  14, //136-143
      31,  29,  28,$20, 124,   8,$20,   6, //144-151
      $20,  92,  94,$20,   1,   3,$20,$20, //152-159
      $20,$20,$20,$20, 125,  93,$20,$20, //160-167
      96,  17,$20,$20,$20,  64,$20,$20, //168-175
      $20,$20,$20,$20,$20,$20,$20,$20, //176-183
      $20,$20,$20,$20,$20,$20,$20,$20, //184-191
      $20,$20,$20,$20,$20,$20,$20,$20, //192-199
      $20,$20,$20,$20,$20,$20,$20,$20, //200-207
      $20,$20,$20,$20,$20,$20,$20,$20, //208-215
      $20,$20,$20,$20,$20,$20,$20,$20, //216-223
      $20,  30,  19,  22,  24,$20,$20,$20, //224-231
      18,  25,  21,$20,$20,$20,$20,  20,  //232-239
      26,$20,$20,$20,$20,$20,$20,$20, //240-247
      $20,$20,$20,$20,$20,$20,$20,$20//248-255
     );

    g_gsm_ascii_table :array[0..127] of byte= (
        64, 156,  36, 157, 138, 130, 151, 141,  //6456
        149, 128,  10, $20 , 32,  13, 143, 134,
        $20, 169, 232, 226, 239, 234, 227, $20,
        228, 233, 240, $20, 146, 145, 225, 144,
         32,  33,  34,  35, $20,  37,  38,  39,
         40,  41,  42,  43,  44,  45,  46,  47,
         48,  49,  50,  51,  52,  53,  54,  55,
         56,  57,  58,  59,  60,  61,  62,  63,
        173,  65,  66,  67,  68,  69,  70,  71,
         72,  73,  74,  75,  76,  77,  78,  79,
         80,  81,  82,  83,  84,  85,  86,  87,
         88,  89,  90, 142, 153, 165, 154, $20,
        168,  97,  98,  99, 100, 101, 102, 103,
        104, 105, 106, 107, 108, 109, 110, 111,
        112, 113, 114, 115, 116, 117, 118, 119,
        120, 121, 122, 132, 148, 164, 129, 133
    );


type
  PC_Error= (
              PC_Error_NoError = $00,
              PC_Error_CheckSum, //checksumerror
              PC_Error_InvalidPktSize = $03,//invalid packed size
              PC_Error_InvalidDataSize ,
              PC_Error_NoConnect,//NO connect
              PC_Error_ConnectExisted,// a connect existed
              PC_Error_InvalidFrameType,
              PC_Error_InvalidFrameid,
              PC_Error_FrameIsReRX = $20, //frame Ǳط
              PC_Error_WaitData,//    첽Ĳdataõ
              PC_Error_SerialNoResponse = $81,//˵targetӦtimeoutfor exampleserial is invalid
              App_Error_DefaultError = $82,//Ĭʧ
              App_Error_ReadError ,//˵ȡʧ
              App_Error_WriteError ,//˵дʧ
              App_Error_DeleteError ,//˵ɾʧ
              App_Error_CopyError ,//˵ʧ
              App_Error_InfoError ,//˵ȡϢʧ
              App_Error_SendError,  //ͶϢʧ
              App_Error_StoreError, //洢Ϣʧ
            	PC_Error_MMINotAllow = $90,//ֻpcͬ ҪȽ˵->pcͬ
            	PC_Error_MMINeedPause,//е绰Ҫͣ
             	PC_Error_MemoryAlloc,//ڴʧܣܲ
              App_Error_ModifyError //˵ĵ绰ʧ
            );


  TViewState_PHB= (ALL_PHB,V_PHB,S_PHB,P_PHB);//е绰һʾֻSIMPC
  TViewState_SMS= (ALL_SMS,V_SMS,S_SMS,P_SMS);//жϢһʾֻSIMPC
  TViewState_CR = (ALL_CR,M_CR,R_CR,D_CR);//¼һʾֻʾδӡֻʾѽӡֻʾѲ
  T_MFW_PHB_SELECT=(SIM_BOOK_SEL,NVM_BOOK_SEL,ALL_BOOK_SEL);//绰
  TEditState_SMS= (ReadSMS,ReSMS,ForwardSMS,ModifySMS,NewSMS);//Ϣ༭״̬

  T_PCSYN_SMS_STAT=(
                    PCSYN_SMS_UNKNOWN,
                    PCSYN_SMS_UNREAD,       (* received unread message *)
                    PCSYN_SMS_READ,         (* received read message   *)
                    PCSYN_SMS_STOR_UNSENT,  (* stored unsent messgae   *)
                    PCSYN_SMS_STOR_SENT,    (* stored sent message     *)
                    PCSYN_SMS_ALL,
                    PCSYN_SMS_NotVOICE,
                    PCSYN_SMS_FLASH,        (*FLASH SMS*)
                    PCSYN_SMS_FLASH_MO,     (*ֻ䷢*)
                    PCSYN_SMS_FLASH_MT,     (*ֻռ*)
                    PCSYN_SMS_MO,           (* SIM MO SMS message *)
                    PCSYN_SMS_MT,           (* SIM MT SMS message *)
                    PCSYN_SMS_INVALID,      (*SPR1830*)
                    PCSYN_SMS_VOICE        (* voice mail message *)
                  );

{
  T_PCSYN_SMS_STAT=(
                    PCSYN_SMS_NotVOICE,
                    PCSYN_SMS_FLASH,        (*FLASH SMS*)
                    PCSYN_SMS_FLASH_MO,     (*ֻ䷢*)
                    PCSYN_SMS_FLASH_MT,     (*ֻռ*)
                    PCSYN_SMS_MO,           (* SIM MO SMS message *)
                    PCSYN_SMS_MT,           (* SIM MT SMS message *)
                    PCSYN_SMS_INVALID,      (*SPR1830*)
                    PCSYN_SMS_VOICE,        (* voice mail message *)
                    PCSYN_SMS_UNKNOWN,
                    PCSYN_SMS_UNREAD,       (* received unread message *)
                    PCSYN_SMS_READ,         (* received read message   *)
                    PCSYN_SMS_STOR_UNSENT,  (* stored unsent messgae   *)
                    PCSYN_SMS_STOR_SENT,    (* stored sent message     *)
                    PCSYN_SMS_ALL
                  );
}
  T_MFW_SMS_MO_TYPE=(
                      MFW_SMS_SUBMIT,
                      MFW_SMS_REPLY,
                      MFW_SMS_SUBMIT_SENT,
                      MFW_SMS_REPLY_SENT
                    );


  T_ACI_SMS_READ=(SMS_READ_NotPresent=-1,SMS_READ_Normal,SMS_READ_Preview,SMS_READ_StatusChange);

  FFS_OBJECT_TYPE=(OT_FILE=1,OT_DIR=2,OT_LINK=3,OT_SEGMENT=4);
  FFS_OBJECT_FLAGS=(OF_READONLY= 1 shl 4);

  TCharSet=set of char;

  PPC_Interface_Info=^TPC_Interface_Info;
  TPC_Interface_Info=record
    flag:DWord;
    pdata_cmd:PChar;
    size_cmd:DWord;
    pdata_ulbuff:PChar;
    size_ulbuff:DWord;
    pdata_dlbuff:PChar;
    size_dlbuff:DWord;
    status:DWord;//ֵ
    callback:pointer;
  end;

  PPC_App_Cmd_File=^TPC_App_Cmd_File;
  TPC_App_Cmd_File=record
    cid1:byte;
    cid2:byte;
    filename:array[0..49] of char;
  end;

  PDELRec=^TDelRec;
  TDelRec=record
    ctype:short;
    index:short;
  end;

//****phonebook***//
  PPC_App_Cmd_PHB=^TPC_App_Cmd_PHB;
  TPC_App_Cmd_PHB=record
    cid1:byte;
    cid2:byte;
    ctype:byte;//  PHB_TYPE_SIM, PHB_TYPE_NVM
    index:byte;//绰
  end;

  PPC_PHB_Count=^TPC_PHB_Count;
  TPC_PHB_Count=record
    NVMTotal:word;
    SIMTotal:word;
	  MaxNVM:word;
	  MaxSIM:word;
  end;

  PPhbkDetailItem=^TPhbkDetailItem;  // 108 bytes
  TPhbkDetailItem=record
    name:array[0..PHB_name_len+3-1] of char;//16 bytes
    number:array[0..PHB_number_len+1-1] of char;  //22 bytes
    office:array[0..PHB_number_len+1-1] of char;  //22 bytes
    home:array[0..PHB_number_len+1-1] of char;  //22 bytes
    memo:array[0..PHB_memo_len+3-1] of char;// 25 bytes
    info:char;   //1 byte
  end;

  PPC_PHB_Content=^TPC_PHB_Content; //112 bytes绰¼ݽṹ
  TPC_PHB_Content=record
    phonebook:integer;
    id:integer;
    phkitem:TPhbkDetailItem;
  end;

  PPhoneBook=^TPhoneBook; //ڴдŵĵ绰¼ṹ
  TPhoneBook=record
    Location:array[0..3] of char;   //4bytes
    SN:array[0..3] of char;        //3bytes
    name:array[0..PHB_name_len+3-1] of char;//16 bytes
    number:array[0..PHB_number_len+1-1] of char;  //22 bytes
    office:array[0..PHB_number_len+1-1] of char;  //22 bytes
    home:array[0..PHB_number_len+1-1] of char;  //22 bytes
    memo:array[0..PHB_memo_len+3-1] of char; //25 bytes
    group:byte;                               //1 byte
    data:TPC_PHB_Content;
    serialNo:Longint; //PCݣʾݿе
  end;

//******SMS****//
  PPC_App_Cmd_SMS=^TPC_App_Cmd_SMS;
  TPC_App_Cmd_SMS=record
    cid1:byte;
    cid2:byte;
    ctype:byte;//
    index:byte;//
  end;

  PPC_SMS_Count=^TPC_PHB_Count;
  TPC_SMS_Count=record
	  FlashMOtotal:byte;
	  FlashMTtotal:byte;
	  SIMMOTotal:byte;
	  SIMMTTotal:byte;
    MaxFlashNum:short;
    MaxSIMNum:short;
  end;

  PT_MFW_SMS_SCTP=^T_MFW_SMS_SCTP;
  T_MFW_SMS_SCTP=record
    year:array[0..MAX_SCTP_DIGITS-1] of byte;
    month:array[0..MAX_SCTP_DIGITS-1] of byte;
    day:array[0..MAX_SCTP_DIGITS-1] of byte;
    hour:array[0..MAX_SCTP_DIGITS-1]  of byte;
    minute:array[0..MAX_SCTP_DIGITS-1] of byte;
    second:array[0..MAX_SCTP_DIGITS-1] of byte;
    timezone:short;
  end;

{
  PFlashSms=^TFlashSms;
  TFlashSms=record
    id:byte;
    addr:array[0..MFW_NUM_LEN-1] of char;
    dummy1:array[0..1]of char;
    time:T_MFW_SMS_SCTP;
    dummy2:array[0..1]of char;
    sms_msg:array[0..MAX_MSG_LEN-1] of char;
    dummy3:char;
    msg_len:Word  ;
    state:T_PCSYN_SMS_STAT;
    dummy4:array[0..2] of char;
    dcs:short;
    flag: boolean;
    dummy5:char;
  end;
}
  PPC_SMS_Content=^TPC_SMS_Content;
  TPC_SMS_Content=record
    name:array[0..15] of char;
    id:byte;
    addr:array[0..39] of char;
    dummy1:array[0..2] of char;
    time:T_MFW_SMS_SCTP;
    dummy2:array[0..1] of char;
    dcs:short;
    state:T_PCSYN_SMS_STAT;
    flag: boolean;
    msg_len:Word;
    sms_msg:array[0..MAX_MSG_LEN-1] of char;
  end;

{  PPC_SMS_Content=^TPC_SMS_Content; //572 bytesż¼ݽṹ
  TPC_SMS_Content=record
    name:array[0..PHB_name_len+3-1] of char;
    flashsmsitem:TFlashSms;
  end;
}
  PShortMessage=^TShortMessage;//shortmessagelistеĵԪṹ
  TShortMessage=record
    Location:array[0..3] of char;   //4bytes
    SN:array[0..3] of char;        //3bytes
    Sort:array[0..9] of char;  //
    number:array[0..MFW_NUM_LEN-1] of char;  //41 bytes
    name:array[0..PHB_name_len+3-1] of char;//16 bytes
    datetime:array[0..20] of char; //21 bytes
    sms_msg:array[0..MAX_MSG_LEN-1] of char;//573
    data:TPC_SMS_Content;
    serialNo:Longint; //PCݣʾݿе
  end;

//*******CR*******/
  PPC_App_Cmd_CR=^TPC_App_Cmd_CR;
  TPC_App_Cmd_CR=record
    cid1:byte;
    cid2:byte;
    ctype:byte;// CR_TYPE_LMN, CR_TYPE_LRN, CR_TYPE_LDN
    index:byte;//0ͨ¼
  end;

//call record dl buffer
//when CID2 = PC_AppCID2_Info
  PPC_CR_Count=^TPC_CR_Count;
  TPC_CR_Count=record
    LMNID:byte;
    LRNID:byte;
    LDNID:byte;
  end;

  PPC_CR_Content=^TPC_CR_Content;
  TPC_CR_Content=record
    number:array[0..23] of char;//24 bytes
    name:array[0..CR_name_length-1] of char;//24 bytes
    time:array[0..20] of char;//21 bytes
  end;

  PCallRecord=^TCallRecord;
  TCallRecord=record
    Location:array[0..3] of char;
    SN:array[0..3] of char;
    CRType:array[0..7] of char;
    datetime:array[0..20] of char;
    PhoneNo:array[0..23] of char;
    Name:array[0..CR_name_length-1] of char;
    serialNo:integer;
  end;

//**************file type***************//
  P_FFS_STAT=^T_FFS_STAT;
  T_FFS_STAT=record
    ftype:Byte; //FFS_OBJECT_TYPE=(OT_FILE=1,OT_DIR=2,OT_LINK=3,OT_SEGMENT=4);
    flags:Byte; //FFS_OBJECT_FLAGS=(OF_READONLY= 1 shl 4);
    inode:short;
    size:integer; //size of data space occupied by object
  end;

  PFileHead=^TFileHead;
  TFileHead=record
    stat:T_FFS_STAT;
    fnsize:integer;
  end;

  PFileRec=^TFileRec;
  TFileRec=Record
    Pathname:array[0..511] of char;
    Filename:array[0..255] of char;
    Filesize:integer;
    ReadOnly:boolean;
  end;

  function Serial_Open(name:PChar;baudtrate:DWORD):integer; stdcall;external 'pcsyn_prtcdll.dll';
  function Serial_Close:Integer; stdcall;external 'pcsyn_prtcdll.dll';
  function pc_interface(p:PPC_Interface_Info):integer; stdcall;external 'pcsyn_prtcdll.dll';
  procedure pcsyn_protocol_init; stdcall;external 'pcsyn_prtcdll.dll';
  procedure pcsyn_protocol_close; stdcall;external 'pcsyn_prtcdll.dll';

  //
  procedure UnicodetoASC(Sour:array of char;var Dest:array of char);
  procedure UnCompressNum(CompNum:PChar;var Num:array of char);
  function  ASCtoUnicode(Sour:array of char;var Dest:array of char):Word;//תunicodeַ
  procedure UnicodetoASC2(Sour:array of char;var Dest:array of char;strsize:integer);
  procedure GSMtoASC2(Sour:array of char;var Dest:array of char;strsize:integer);
  procedure ASC2toGSM(Sour:array of char;var Dest:array of char;strsize:integer);
  function infotogroup(info:char):byte;
  function grouptoinfo(gp:byte):char;

  //PhoneBook
  procedure GetPHBCount(cbfunc:Pointer);
  function doPHBCount(p:pointer):DWord;
  procedure getPHBcontent(ctype:T_MFW_PHB_SELECT;cindex:byte;cbfunc:Pointer);
  function doPHBList(p:pointer):DWord;
  procedure delPHB(cbfunc:Pointer);
  function doDelPHB(p:pointer):DWord;
  procedure putPhbRecord(ctype:T_MFW_PHB_SELECT;cindex:byte;ulrecn:PPhbkDetailItem;cbfunc:Pointer);
  function doputPhbRecord(p:pointer):DWord;

  //shortmessage
  procedure getSMSCount(cbfunc:Pointer);//ֻøֶϢ
  function doSMSCount(p:pointer):DWord;
  procedure getSMScontent(ctype:T_PCSYN_SMS_STAT;cindex:byte;cbfunc:Pointer);
  function doSMSFlashList(p:pointer):DWord;
  function doSMSSIMList(p:pointer):DWord;
  procedure delSMS(ctype:byte;cindex:byte;cbfunc:Pointer);
  function doDelSMS(p:pointer):DWord;
  procedure ChangeTime(var text:array of char;rctp:PT_MFW_SMS_SCTP);
  procedure UnChangeTime(var rctp:T_MFW_SMS_SCTP;text:array of char);
  function putSMSRecord(stype:byte;rptype:byte;ulrecn:PPC_SMS_Content;cbfunc:Pointer):DWord;
  function doputSMSRecord(p:pointer):DWord;
  procedure CopySMS(ctype:byte;cindex:byte;ulrecn:PPC_SMS_Content;cbfunc:Pointer);
  function doCopySMS(p:pointer):DWord;

  //CallRecord
  procedure GetCRCount(cbfunc:Pointer);
  procedure doCRCount(p:pointer);
  procedure getCRcontent(ctype:byte;cindex:byte;cbfunc:Pointer);
  procedure doCRList(p:pointer;ctype:byte);
  procedure delCR(cbfunc:Pointer);
  function doDelCR(p:pointer):DWord;

  //ļ
  procedure getfileInfo(cbfunc:Pointer;filename:string);
  function dogetfileinfo(p:pointer):DWord;  //صļ
  procedure getfile(cbfunc:Pointer;filename:string);
  function dodownloadfile(p:pointer):Dword;
  procedure putfile(cbfunc:Pointer;sourfile:string;Destpath:string);
  function douploadfile(p:pointer):DWord;
  procedure DELfile(cbfunc:Pointer;filename:string);
  function doDelFILE(p:pointer):DWord;

var
  NumberSet:TCharSet=['0'..'9','p','#','*','+',#8,#3,#22,#24,#26];//#8=backspace,copy,paste,cut
  Comhandle:THandle;
//PhoneBook
  status_PHB:integer; //PHBʲô״̬
  Count_PHB_PC:word; //绰绰¼
  Count_PHB_SIM:word; //SIM绰绰¼
  Count_PHB_NVM:word; //ֻ绰绰¼
//  CurPHB_type:byte;  //ǰյĵ绰
  CurPHB_index:word;  //ǰյ绰¼
//  CurPHBTable:byte;      //ǰ򿪵ĵ绰index
  Max_PHB_PC:word; //
  Max_PHB_SIM:word;//Դsimĵ绰¼
  Max_PHB_NVM:word;//Դflashĵ绰¼
  PhoneBookList:TList;
  DelPHBList:TList; //±ɾĶ¼
  CurInsPHB_Index:short;  //ǰĵ绰

//ShortMessage
  status_SMS:integer; //Ϣʲô״̬
  Count_SMS_PC:byte; //pcϢ
  Count_SMS_Flash:byte; //flashϢ
  Count_SMS_SIM:byte;  //SIMĶϢ
  Count_SMS_Flash_MO:byte; //flashзϢ
  Count_SMS_Flash_MT:byte; //flashռϢ
  Count_SMS_SIM_MO:byte; //simϢ
  Count_SMS_SIM_MT:byte; //simϢռ
//  CurPHB_type:byte;  //ǰյĵ绰
  CurSMS_index:short;  //ǰնϢ
  CurSMSTable:byte;      //ǰ򿪵ĶϢļindex
  MaxCount_SMS_PC:integer;
  MaxCount_SMS_FLash:integer;
  MaxCount_SMS_SIM:integer;
  ShortMessageList:TList;
  DelSMSList:TList; //±ɾĶ¼
  servicecenter:string;
  EditState_SMS:TEditState_SMS;
  CurInsSMS_Index:byte;  //ǰĶϢ

//CallRecord
  status_CR:integer; //CRʲô״̬
  Count_CR_LMN:byte; //CRδӵ绰
  Count_CR_LRN:byte; //CRѽӵ绰
  Count_CR_LDN:byte; //CRѲ绰
//  CurCR_type:byte;  //ǰյ
  CurCR_index:byte;  //ǰյ¼
  CallRecordList:TList;
  DelCRList:TList; //±ɾĶ¼

//ļ
  status_FILE:integer; //Ϣʲô״̬
  FileList:TList; //µļ¼


implementation

uses main,fileop;

//ļ
procedure getfileInfo(cbfunc:Pointer;filename:string);
var  tempinfo:pPC_Interface_Info;
     tempcmd_file:pPC_App_Cmd_file;
     tempbuffer_rx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_file,sizeof(TPC_App_Cmd_file));
  getmem(tempbuffer_rx,SIZE_BUFFER);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_file^,sizeof(TPC_App_Cmd_file),#0);
 	fillchar(tempbuffer_rx^,SIZE_BUFFER,#0);

	tempcmd_file.cid1:= PC_AppCID1_File;
	tempcmd_file.cid2:= PC_AppCID2_info;
  strpcopy(tempcmd_file.filename,filename);

	tempinfo.flag := PC_IF_FLAGS_DATADL;
	tempinfo.pdata_cmd:=Pchar(tempcmd_file);
	tempinfo.size_cmd:=(strlen(tempcmd_file.filename)+2+3)and(not	$03);//ֽڶ

	tempinfo.pdata_dlbuff := tempbuffer_rx;
	tempinfo.size_dlbuff := SIZE_BUFFER;
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

function dogetfileinfo(p:pointer):DWord;  //صļ
var tempPC_Interface_Info:pPC_Interface_Info;
    buff:array[0..SIZE_BUFFER-1] of char;
    tempchar:pchar;
    filehead:PFileHead;
    dlsize:integer;
    namebuf:array[0..255] of char;
    rootnode,tempnode:TTreeNode;
    tempitem:TListItem;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  Form_fileop.ListView_file.Clear;
  rootnode:=Form_fileop.TreeView_dir.Selected;
  if rootnode<>nil then
  begin
    rootnode.DeleteChildren;
  end;

  if tempPC_Interface_Info.size_dlbuff>0 then
  begin
    fillchar(buff,sizeof(buff),#0);
    move(tempPC_Interface_Info.pdata_dlbuff^,buff[0],tempPC_Interface_Info.size_dlbuff);

    dlsize:=tempPC_Interface_Info.size_dlbuff;
    if rootnode<>nil then
    begin
//      Form_fileop.ListView_file.Clear;
      rootnode.DeleteChildren;
      while dlsize>0 do
      begin
        tempchar:=pchar(tempPC_Interface_Info.pdata_dlbuff+(tempPC_Interface_Info.size_dlbuff-dlsize));
        filehead:=PFileHead(tempchar);
        inc(tempchar,sizeof(TFileHead));
        fillchar(namebuf,sizeof(namebuf),#0);
        move(tempchar^,namebuf[0],filehead.fnsize);
        case filehead.stat.ftype of
        ord(OT_DIR):
          begin
            tempnode:=Form_fileop.TreeView_dir.Items.AddChild(rootnode,namebuf);
            tempnode.ImageIndex:=0;
            tempnode.SelectedIndex:=1;
          end;
        ord(OT_FILE):
          begin
            tempitem:=Form_fileop.ListView_file.Items.Add;
            tempitem.Caption:=namebuf;
            tempitem.SubItems.Add(format('%.0n',[filehead.stat.size*1.0]));
            if filehead.stat.flags=ord(OF_READONLY) then
              tempitem.SubItems.Add('')
            else
              tempitem.SubItems.Add('');
//              Form_fileop.ListView_file.Repaint;
//            Form_fileop.ListView_file.Width:=Form_fileop.ListView_file.Width-1;
//            Form_fileop.ListView_file.Width:=Form_fileop.ListView_file.Width+1;
          end;
        end;
        dlsize:=dlsize-filehead.fnsize-sizeof(TFileHead);
      end;
      rootnode.Expanded:=true;
    end;
  end;

  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_dlbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_dlbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

//ļ
procedure getfile(cbfunc:Pointer;filename:string);
var  tempinfo:pPC_Interface_Info;
     tempcmd_file:pPC_App_Cmd_file;
     tempbuffer_rx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_file,sizeof(TPC_App_Cmd_file));
  getmem(tempbuffer_rx,SIZE_BUFFER);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_file^,sizeof(TPC_App_Cmd_file),#0);
 	fillchar(tempbuffer_rx^,SIZE_BUFFER,#0);

	tempcmd_file.cid1:= PC_AppCID1_File;
	tempcmd_file.cid2:= PC_AppCID2_Read;
  strpcopy(tempcmd_file.filename,filename);

	tempinfo.flag := PC_IF_FLAGS_DATADL;
	tempinfo.pdata_cmd:=Pchar(tempcmd_file);
	tempinfo.size_cmd:=(strlen(tempcmd_file.filename)+2+3)and(not	$03);//ֽڶ

	tempinfo.pdata_dlbuff := tempbuffer_rx;
	tempinfo.size_dlbuff := SIZE_BUFFER;
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

function dodownloadfile(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
    FileHandle:Thandle;
//    n:string;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  if tempPC_Interface_Info.size_dlbuff>0 then
  begin
//    n:=strpas(PFileRec(filelist.items[0]).filename);
    FileHandle:=filecreate(Form_fileop.FileListBox1.Directory+'\'+strpas(PFileRec(filelist.items[0]).filename));
    if FileHandle>0 then
    begin
      filewrite(FileHandle,tempPC_Interface_Info.pdata_dlbuff^,tempPC_Interface_Info.size_dlbuff);
      FileClose(FileHandle);
    end;
  end;
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_dlbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_dlbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

procedure putfile(cbfunc:Pointer;sourfile:string;Destpath:string);
var  tempinfo:pPC_Interface_Info;
     tempcmd_file:pPC_App_Cmd_file;
     tempbuffer_rx:PChar;
     FileHandle:integer;
     readbufsize:integer;
     filelen:integer;
begin
  FileHandle:=FileOpen(sourfile,fmOpenRead);
  if FileHandle<0 then
  begin
    showmessage('޷򿪴ļ');
    exit;
  end;

  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_file,sizeof(TPC_App_Cmd_file));
  getmem(tempbuffer_rx,SIZE_BUFFER);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_file^,sizeof(TPC_App_Cmd_file),#0);
 	fillchar(tempbuffer_rx^,SIZE_BUFFER,#0);

	tempcmd_file.cid1:= PC_AppCID1_File;
	tempcmd_file.cid2:= PC_AppCID2_Write;
  strpcopy(tempcmd_file.filename,Destpath+extractFileName(sourfile));


  readbufsize:=FileRead(filehandle,tempbuffer_rx^,SIZE_BUFFER);
  FileClose(Filehandle);
	tempinfo.flag := PC_IF_FLAGS_DATAUL;
	tempinfo.pdata_cmd:=Pchar(tempcmd_file);
  filelen:=(strlen(tempcmd_file.filename)+2+3)and(not	$03);//ֽڶ
	tempinfo.size_cmd:=(strlen(tempcmd_file.filename)+2+3)and(not	$03);//ֽڶ

	tempinfo.pdata_ulbuff := tempbuffer_rx;
	tempinfo.size_ulbuff := readbufsize;
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

function douploadfile(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_ulbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_ulbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

procedure Delfile(cbfunc:Pointer;filename:string);
var  tempinfo:pPC_Interface_Info;
     tempcmd_file:pPC_App_Cmd_file;
//     tempbuffer_rx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_file,sizeof(TPC_App_Cmd_file));

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_file^,sizeof(TPC_App_Cmd_file),#0);

	tempcmd_file.cid1:= PC_AppCID1_File;
	tempcmd_file.cid2:= PC_AppCID2_Delete;
  strpcopy(tempcmd_file.filename,filename);

	tempinfo.flag := PC_IF_FLAGS_DATADL;
	tempinfo.pdata_cmd:=Pchar(tempcmd_file);
	tempinfo.size_cmd:=(strlen(tempcmd_file.filename)+2+3)and(not	$03);//ֽڶ

	tempinfo.callback := cbfunc;
	pc_interface(tempinfo);
end;

function doDelFILE(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

//**************Phonebook***************//
function  ASCtoUnicode(Sour:array of char;var Dest:array of char):Word;//תunicodeַ
var objlen:Dword;
    c:char;
    i,loop:integer;
    isdoublebyte:boolean;
begin
  isdoublebyte:=false;
  for i:=0 to high(sour)-low(sour) do
  begin
    //жǷ˫ֽڵַеֽȫת˫ֽڵunicode
    if StrByteType(sour,i)<>mbSingleByte	 then
    begin
      isdoublebyte:=true;
      break;
    end;
  end;
  if isdoublebyte then
  begin
    objlen:=MultiByteToWideChar(CP_ACP,0,Sour,-1,nil,0);
    result:=(MultiByteToWideChar(CP_ACP,0,Sour,-1,PWideChar(@Dest[LOW(Dest)+1]),objlen)-1)*2+1; //תunicodeֽڣ1Ϊdest[0]$80
    Dest[LOW(Dest)]:=char($80);
    loop:=LOW(Dest)+1;//һַ
    //ַĳ˫еֽڶҪ
    //ַĳǵһֽڲҪ
    while loop<=((HIGH(Dest)-LOW(Dest)) div 2 *2) do//  η䳤Ϊ16ȥͷ$80Ӧֻʣ15ֽڣֻ114λõֽ
    begin  //ע,ߵֽڻֻunicodeַwordҪиߵֽڵĻ
      c:=Dest[loop];
      Dest[loop]:= Dest[loop+1];
      inc(loop);
      Dest[loop]:=c;
      inc(loop);
    end;
  end else
  begin
    ASC2toGSM(Sour,Dest,strlen(sour));
    result:=strlen(Dest);
  end;
end;

procedure UnicodetoASC(Sour:array of char;var Dest:array of char);
var objlen:Dword;
    c:char;
    loop:integer;
begin
  if Sour[LOW(Sour)]=char($80) then//һֽ$80ôunicodeĸʽֽڱʾһַ
  begin
    loop:=LOW(Sour)+1;//һַ
    //ַĳ˫еֽڶҪ
    //ַĳǵһֽڲҪ
    while loop<=((HIGH(Sour)-LOW(Sour)) div 2 *2) do//  η䳤Ϊ16ȥͷ$80Ӧֻʣ15ֽڣֻ114λõֽ
    begin  //ע,ߵֽڻֻunicodeַwordҪиߵֽڵĻ
      c:=Sour[loop];
      Sour[loop]:= Sour[loop+1];
      inc(loop);
      Sour[loop]:=c;
      inc(loop);
    end;
    objlen:=WideCharToMultiByte(CP_ACP,0, PWideChar(@Sour[LOW(Sour)+1]),-1,Nil,0,nil,nil);
    WideCharToMultiByte(CP_ACP, 0, PWideChar(@Sour[LOW(Sour)+1]), -1, Dest, objlen, nil, nil);
  end else
  begin
    strcopy(Dest,Sour);
  end;
end;

procedure UnicodetoASC2(Sour:array of char;var Dest:array of char;strsize:integer);
var objlen:Dword;
    c:char;
    loop:integer;
    i:integer;
begin
  loop:=LOW(Sour);
  //ַĳ˫еֽڶҪ
  //ַĳǵһֽڲҪ
  for i:=0 to (strsize div 2-1) do
  begin  //ע,ߵֽڻֻunicodeַwordҪиߵֽڵĻ
    c:=Sour[loop];
    Sour[loop]:= Sour[loop+1];
    inc(loop);
    Sour[loop]:=c;
    inc(loop);
  end;
  sour[strsize]:=#0;
  objlen:=WideCharToMultiByte(CP_ACP,0, PWideChar(@Sour[LOW(Sour)]),-1,Nil,0,nil,nil);
  WideCharToMultiByte(CP_ACP, 0, PWideChar(@Sour[LOW(Sour)]), -1, Dest, objlen, nil, nil);
end;

procedure GSMtoASC2(Sour:array of char;var Dest:array of char;strsize:integer);
var i:integer;
    ch:byte;
begin
  for i:=0 to strsize-1 do
  begin
  //    Dest[i]:=char(g_ascii_gsm_table[byte(g_gsm_ascii_table[byte(Sour[i]) and $7F])]);
    ch:=g_gsm_ascii_table[byte(Sour[i]) and $7F];
    if ch>127 then
      Dest[i]:=char(g_ascii_gsm_table[ch])
    else
      Dest[i]:=char(ch);
  end;
end;

procedure ASC2toGSM(Sour:array of char;var Dest:array of char;strsize:integer);
var i:integer;
    ch:byte;
begin
  for i:=0 to strsize-1 do
  begin
  //    Dest[i]:=char(g_ascii_gsm_table[byte(g_gsm_ascii_table[byte(Sour[i]) and $7F])]);

    ch:=g_gsm_ascii_table[byte(Sour[i])];
    if (ch=$20) then
    begin
       ch:=g_ascii_gsm_table[byte(Sour[i])];
       Dest[i]:=char(ch);
    end else
      if (ch>127) then
        Dest[i]:=char(g_ascii_gsm_table[ch and $7F])
      else
        Dest[i]:=char(ch);
  end;
end;

function infotogroup(info:char):byte;
var tempchar:byte;
begin
  tempchar:=ord(info) and $0F;
  if (tempchar)=$0F then
    result:=0
  else
    result:=tempchar+1;
end;

function grouptoinfo(gp:byte):char;
begin
  if gp=0 then result:=chr($5F)
  else result:=chr($50 or ((gp-1) and $0F));
end;

procedure UnCompressNum(CompNum:PChar;var Num:array of char);
var j,ExitFlag:integer;
    GetByte:byte;
begin
  j:=0;
  ExitFlag:=0;
  while ExitFlag=0 do
  begin
//4λ
    GetByte:=(byte(CompNum^) shr 4) and $0F;
    if (GetByte<>$00) then
    begin
      if GetByte=2 then
        Num[j]:=#35 //ʾ'#'
      else
        if GetByte=3 then
          Num[j]:=#42 //ʾ'*'
        else
          if GetByte=4 then
            Num[j]:=#112 //ʾ'p'
          else
            Num[j]:=char(GetByte+48-6);//Ҫȥ6
      inc(j);
    end else
    begin
      Num[j]:=#0;
      ExitFlag:=1;
    end;
//4λ
    if ExitFlag<>1 then
    begin
      GetByte:=byte(CompNum^) and $0F;
      if (GetByte<>$00) then
      begin
        if GetByte=2 then
          Num[j]:=#35      //ʾ'#'
        else
          if GetByte=3 then
            Num[j]:=#42    //ʾ'*'
          else
             if GetByte=4 then
               Num[j]:=#112  //ʾ'p'
             else
               Num[j]:=char(GetByte+48-6);//Ҫȥ6
         inc(j);
      end else
      begin
        Num[j]:=#0;
        ExitFlag:=1;
      end;
      inc(CompNum);
    end;
  end;
end;

//ͻȡPhoneBook
procedure getPHBCount(cbfunc:Pointer);//ֻøֵ绰
var  tempinfo:pPC_Interface_Info;
     tempcmd_phb:pPC_App_Cmd_PHB;
     tempbuffer_rx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_phb,sizeof(TPC_App_Cmd_PHB));
  getmem(tempbuffer_rx,SIZE_BUFFER);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_phb^,sizeof(TPC_App_Cmd_PHB),#0);
 	fillchar(tempbuffer_rx^,SIZE_BUFFER,#0);

	tempcmd_phb.cid1:= PC_AppCID1_PHB;
	tempcmd_phb.cid2:= PC_AppCID2_Info;

	tempinfo.flag := PC_IF_FLAGS_DATADL;
	tempinfo.pdata_cmd:=Pchar(tempcmd_phb);
	tempinfo.size_cmd:= sizeof(TPC_App_Cmd_PHB);

	tempinfo.pdata_dlbuff := tempbuffer_rx;
	tempinfo.size_dlbuff := SIZE_BUFFER;
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

//صдPhoneBook
function doPHBCount(p:pointer):DWord;  //صص绰¼
var tempPC_Interface_Info:pPC_Interface_Info;
//    buff:array[0..SIZE_BUFFER-1] of char;
    PC_PHB_count:TPC_PHB_Count;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  if tempPC_Interface_Info.size_dlbuff>0 then
  begin
//    fillchar(buff,sizeof(buff),#0);
//    move(tempPC_Interface_Info.pdata_dlbuff^,buff[0],tempPC_Interface_Info.size_dlbuff);
    move(tempPC_Interface_Info.pdata_dlbuff^,PC_PHB_count,sizeof(TPC_PHB_Count));
    Count_PHB_NVM:=PC_PHB_count.NVMTotal;
    Count_PHB_SIM:=PC_PHB_count.SIMTotal;
  	Max_PHB_NVM:=PC_PHB_count.MaxNVM;
    Max_PHB_SIM:=PC_PHB_count.MaxSIM;
  end else
  begin
    Count_PHB_SIM:=0;
    Count_PHB_NVM:=0;
  	Max_PHB_NVM:=0;
    Max_PHB_SIM:=0;
  end;

  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_dlbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_dlbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

//ͻȡphbݵ
procedure getPHBcontent(ctype:T_MFW_PHB_SELECT;cindex:byte;cbfunc:Pointer);
var  tempinfo:pPC_Interface_Info;
     tempcmd_phb:pPC_App_Cmd_PHB;
     tempbuffer_rx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_phb,sizeof(TPC_App_Cmd_PHB));
  getmem(tempbuffer_rx,SIZE_BUFFER);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_phb^,sizeof(TPC_App_Cmd_PHB),#0);
 	fillchar(tempbuffer_rx^,SIZE_BUFFER,#0);

	tempcmd_phb.cid1:= PC_AppCID1_PHB;
	tempcmd_phb.cid2:= PC_AppCID2_Read;
  tempcmd_phb.ctype:= ord(ctype);   //
 	tempcmd_phb.index:= cindex;//CurPHB_index;   //ϵڼ¼

	tempinfo.flag:= PC_IF_FLAGS_DATADL;
	tempinfo.pdata_cmd:= PChar(tempcmd_phb);
	tempinfo.size_cmd:= sizeof(TPC_App_Cmd_PHB);

	tempinfo.pdata_dlbuff := tempbuffer_rx;
	tempinfo.size_dlbuff := SIZE_BUFFER;

	tempinfo.callback :=cbfunc ;

	pc_interface(tempinfo);
end;

//صдphonebookݵ
function doPHBList(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
//    buff:array[0..SIZE_BUFFER-1] of char;
    pc_phb : TPC_phb_Content;
    tempPHB:PPhoneBook;
    objname:array[0..PHB_name_len+3-1] of char;
    objmemo:array[0..PHB_memo_len+3-1] of char;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  if tempPC_Interface_Info.size_dlbuff>0 then
  begin
//    fillchar(buff,sizeof(buff),#0);
//    move(tempPC_Interface_Info.pdata_dlbuff^,buff[0],tempPC_Interface_Info.size_dlbuff);
    fillchar(pc_phb,sizeof(TPC_phb_Content),#0);
    move(tempPC_Interface_Info.pdata_dlbuff^,pc_phb,sizeof(TPC_PHB_Content));
    getmem(tempPHB,sizeof(TPhoneBook));
    fillchar(tempPHB^,sizeof(TPhoneBook),#0);
    move(pc_phb,tempPHB.data,sizeof(TPC_PHB_Content));

    UnicodetoASC(pc_phb.phkitem.name,objname); //unicodeתΪasc
    strpcopy(tempPHB.Name,objname);
    strcopy(tempPHB.number,pc_phb.phkitem.number);//벻ýѹѾǿɶ
    case pc_phb.phonebook of
    ord(NVM_BOOK_SEL):
      begin
        tempPHB.Location:='ֻ';
        strpcopy(tempPHB.SN,format('%.3d',[pc_phb.id])); //ֻidŴ0ʼʾӦô000ʼ
        strpcopy(tempPHB.office,pc_phb.phkitem.office);
        strpcopy(tempPHB.home,pc_phb.phkitem.home);
        UnicodetoASC(pc_phb.phkitem.memo,objmemo); //unicodeתΪasc
        strpcopy(tempPHB.memo,objmemo);
        tempPHB.group:=infotogroup(pc_phb.phkitem.info); //ֻڵ绰Ϊ1-10
      end;
    ord(SIM_BOOK_SEL):
      begin
        tempPHB.Location:='SIM';
        strpcopy(tempPHB.SN,format('%.3d',[pc_phb.id]));  //simidŴ1ʼ
        tempPHB.group:=0;//SIMڵ绰Ϊ0
      end;
    end;
    tempPHB.serialNo:=pc_phb.id; //ǷҪɾļ¼
    phonebookList.Add(tempPHB);
  end;
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_dlbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_dlbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

procedure delPHB(cbfunc:Pointer);
var  tempinfo:pPC_Interface_Info;
     tempcmd_phb:pPC_App_Cmd_PHB;
     tempbuffer_tx:PChar;
     i:integer;
     tempchar:PDelRec;
//     cchar:array[0..100] of char;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_phb,sizeof(TPC_App_Cmd_phb));
  getmem(tempbuffer_tx,sizeof(TDelRec)*delphblist.Count);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_phb^,sizeof(TPC_App_Cmd_PHB),#0);
 	fillchar(tempbuffer_tx^,sizeof(TDelRec)*delphblist.Count,#0);
  //ɾļ¼ţһ¼ռ2ֽ,˳ulbuff

	tempinfo.flag:= PC_IF_FLAGS_DATAUL;
	tempinfo.pdata_cmd:= PChar(tempcmd_PHB);
	tempinfo.size_cmd:= sizeof(TPC_App_Cmd_PHB);

	tempcmd_phb.cid1:= PC_AppCID1_PHB;
	tempcmd_phb.cid2:= PC_AppCID2_Delete;
  tempcmd_phb.ctype:=0;    //Ҫһɾcmdֵ
 	tempcmd_phb.index:=0;

  tempchar:=PDelRec(tempbuffer_tx);
  for i:=0 to delphblist.Count-1 do
  begin
    tempchar.ctype:=PDelRec(delphblist[i]).ctype;
    tempchar.index:=PDelRec(delphblist[i]).index;
    inc(tempchar,1);
  end;
//  fillchar(cchar,sizeof(cchar),#0);
//  move(tempbuffer_tx^,cchar[0],sizeof(Word)*(dellist.Count+1));
	tempinfo.pdata_ulbuff := tempbuffer_tx;
	tempinfo.size_ulbuff := sizeof(TDelRec)*delphblist.Count;
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

function doDelPHB(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_ulbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_ulbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

procedure putPhbRecord(ctype:T_MFW_PHB_SELECT;cindex:byte;ulrecn:PPhbkDetailItem;cbfunc:Pointer);
var  tempinfo:pPC_Interface_Info;
     tempcmd_phb:pPC_App_Cmd_phb;
     tempbuffer_tx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_phb,sizeof(TPC_App_Cmd_PHB));
  getmem(tempbuffer_tx,sizeof(TPC_PHB_Content));

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_phb^,sizeof(TPC_App_Cmd_PHB),#0);
 	fillchar(tempbuffer_tx^,sizeof(TPC_PHB_Content),#0);

	tempcmd_phb.cid1:= PC_AppCID1_PHB;
	tempcmd_phb.cid2:= PC_AppCID2_Write;
  tempcmd_phb.ctype:= ORD(ctype);   //
 	tempcmd_phb.index:= cindex;   //ϵڼ¼

  PPC_PHB_Content(tempbuffer_tx).phonebook:=tempcmd_phb.ctype;
  move(ulrecn^,PPC_PHB_Content(tempbuffer_tx).phkitem,sizeof(TPhbkDetailItem));

	tempinfo.flag := PC_IF_FLAGS_DATAUL;
	tempinfo.pdata_cmd:=Pchar(tempcmd_phb);
	tempinfo.size_cmd:=sizeof(TPC_App_Cmd_PHB);

	tempinfo.pdata_ulbuff := tempbuffer_tx;
	tempinfo.size_ulbuff := sizeof(TPC_PHB_Content);
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

function doputPHBRecord(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_ulbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_ulbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

//*************ShortMessage******************//
//ͻȡPhoneBook
procedure getSMSCount(cbfunc:Pointer);//ֻøֶϢ
var  tempinfo:pPC_Interface_Info;
     tempcmd_SMS:pPC_App_Cmd_SMS;
     tempbuffer_rx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_SMS,sizeof(TPC_App_Cmd_SMS));
  getmem(tempbuffer_rx,SIZE_BUFFER);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_SMS^,sizeof(TPC_App_Cmd_SMS),#0);
 	fillchar(tempbuffer_rx^,SIZE_BUFFER,#0);

	tempcmd_SMS.cid1:= PC_AppCID1_SMS;
	tempcmd_SMS.cid2:= PC_AppCID2_Info;

	tempinfo.flag := PC_IF_FLAGS_DATADL;
	tempinfo.pdata_cmd:=Pchar(tempcmd_SMS);
	tempinfo.size_cmd:= sizeof(TPC_App_Cmd_SMS);

	tempinfo.pdata_dlbuff := tempbuffer_rx;
	tempinfo.size_dlbuff := SIZE_BUFFER;
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

//صдShortMessage
function doSMSCount(p:pointer):DWord;  //ص¼
var tempPC_Interface_Info:pPC_Interface_Info;
    //buff:array[0..SIZE_BUFFER-1] of char;
    PC_SMS_count:TPC_SMS_Count;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  if tempPC_Interface_Info.size_dlbuff>0 then
  begin
//    fillchar(buff,sizeof(buff),#0);
//    move(tempPC_Interface_Info.pdata_dlbuff^,buff[0],tempPC_Interface_Info.size_dlbuff);

    move(tempPC_Interface_Info.pdata_dlbuff^,PC_SMS_count,sizeof(TPC_SMS_Count));
    Count_SMS_Flash_MO:=PC_SMS_count.FlashMOtotal;
    Count_SMS_Flash_MT:=PC_SMS_count.FlashMTtotal;
    Count_SMS_Flash:= Count_SMS_Flash_MO+Count_SMS_Flash_MT;
    Count_SMS_SIM_MO:=PC_SMS_count.SIMMOTotal; //simϢ
    Count_SMS_SIM_MT:=PC_SMS_count.SIMMTTotal; //simϢռ
    Count_SMS_SIM:=Count_SMS_SIM_MO+Count_SMS_SIM_MT;
//    servicecenter:=strpas(PC_SMS_count.p0);
    MaxCount_SMS_FLash:=PC_SMS_count.MaxFlashNum;
    MaxCount_SMS_SIM:=PC_SMS_count.MaxSIMNum;
(*    form_main.statusbar1.Panels[0].Text:='p1='+inttostr(PC_PHB_count.p1)+','+inttostr(PC_PHB_count.p2)+','
                            +inttostr(PC_PHB_count.p3)+','+inttostr(PC_PHB_count.p4)+','+inttostr(PC_PHB_count.p5)
                            +','+inttostr(PC_PHB_count.p6)+','+inttostr(PC_PHB_count.p7)
                            +','+inttostr(PC_PHB_count.p8);  *)
  end else
  begin
    Count_SMS_Flash:=0;
    Count_SMS_SIM:=0;
    MaxCount_SMS_FLash:=0;
    MaxCount_SMS_SIM:=0;
  end;

  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_dlbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_dlbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

//ͻȡSMSݵ
procedure getSMScontent(ctype:T_PCSYN_SMS_STAT;cindex:byte;cbfunc:Pointer);
var  tempinfo:pPC_Interface_Info;
     tempcmd_sms:pPC_App_Cmd_SMS;
     tempbuffer_rx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_sms,sizeof(TPC_App_Cmd_SMS));
  getmem(tempbuffer_rx,SIZE_BUFFER);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_sms^,sizeof(TPC_App_Cmd_SMS),#0);
 	fillchar(tempbuffer_rx^,SIZE_BUFFER,#0);

	tempcmd_sms.cid1:= PC_AppCID1_SMS;
	tempcmd_sms.cid2:= PC_AppCID2_Read;
  tempcmd_sms.ctype:= ord(ctype);   //
 	tempcmd_sms.index:= cindex;//CurSMS_index;   //ϵڼ¼

	tempinfo.flag:= PC_IF_FLAGS_DATADL;
	tempinfo.pdata_cmd:= PChar(tempcmd_sms);
	tempinfo.size_cmd:= sizeof(TPC_App_Cmd_SMS);

	tempinfo.pdata_dlbuff := tempbuffer_rx;
	tempinfo.size_dlbuff := SIZE_BUFFER;

	tempinfo.callback :=cbfunc ;

	pc_interface(tempinfo);
end;

function doSMSFlashList(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
//    buff:array[0..SIZE_BUFFER-1] of char;
    pc_SMS : TPC_SMS_Content;
    tempSMS:PShortMessage;
    objname:array[0..PHB_name_len+3-1] of char;
    objmsg:array[0..MAX_MSG_LEN-1] of char;
    smsdatetime:string;
    objtime:array[0..sizeof(T_MFW_SMS_SCTP)+6] of char;
    i,oldcount:integer;
    str1,str2:string;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  if tempPC_Interface_Info.size_dlbuff>0 then
  begin
//    fillchar(buff,sizeof(buff),#0);
//    move(tempPC_Interface_Info.pdata_dlbuff^,buff[0],tempPC_Interface_Info.size_dlbuff);
    fillchar(pc_SMS,sizeof(TPC_SMS_Content),#0);
    move(tempPC_Interface_Info.pdata_dlbuff^,pc_SMS,tempPC_Interface_Info.size_dlbuff);
    getmem(tempSMS,sizeof(TShortMessage));
    fillchar(tempSMS^,sizeof(TShortMessage),#0);
    move(pc_SMS,tempSMS.data,sizeof(TPC_SMS_Content));
    tempSMS.Location:='ֻ';
    strpcopy(tempSMS.SN,format('%.3d',[pc_SMS.id]));
//SNŵsimflashͶϢֻеΨһţflashֵģsimֵܲ
//صĹУflashǰʱݼģsimǰidֵ
    tempSMS.serialNo:=pc_SMS.id;
//serialNoֻжPC,ŵPCÿ¼ݿеserialNo
//ҵserialNo=-1ʱʾ¼ʧЧconfigsmslist󣬾ͻɾ
    case pc_SMS.state of
      PCSYN_SMS_STOR_UNSENT:tempSMS.Sort:='STO UNSENT';
      PCSYN_SMS_STOR_SENT:tempSMS.Sort:='STO SENT';
      PCSYN_SMS_MT:tempSMS.Sort:='SMS MT';
    end;

    strcopy(tempSMS.number,pc_SMS.addr);
    UnicodetoASC(pc_SMS.name,objname); //unicodeתΪasc
    strpcopy(tempSMS.name,objname);

    if ord(pc_SMS.time.month[1])<>0 then//·ݱʾ
    begin
      ChangeTime(objtime,@pc_SMS.time);
      smsdatetime:=objtime+'+'+format('%.2d',[pc_SMS.time.timezone]);
      strpcopy(tempSMS.datetime,smsdatetime);
    end;
    fillchar(objmsg,sizeof(objmsg),#0);
    if (pc_SMS.dcs=$08)or(pc_SMS.dcs=$18) then
      UnicodetoASC2(pc_SMS.sms_msg,objmsg,pc_SMS.msg_len) //unicodeתΪasc
    else
      GSMtoASC2(pc_SMS.sms_msg,objmsg,pc_SMS.msg_len);
    move(objmsg[0],tempsms.sms_msg[0],pc_SMS.msg_len);
//յĶϢǰʱ˳ȷȺģҪĳΪidΪ˳shortmessagelist
    oldcount:=ShortMessageList.count;
    for i:=Count_SMS_PC to ShortMessageList.count-1 do
    begin
      if PShortMessage(ShortMessageList.Items[i]).Location<>'ֻ' then
      begin ShortMessageList.Insert(i,tempsms); break; end;
      str1:=PShortMessage(ShortMessageList.Items[i]).SN;
      str2:=tempSMS.SN;
      if CompareText(str2,str1)>0 then continue;
      ShortMessageList.Insert(i,tempsms);
      break;
    end;
    if ShortMessageList.count=oldcount then//idģôͰ¼
      ShortMessageList.Add(tempSMS);
  end;
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_dlbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_dlbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

function doSMSSIMList(p:pointer):Dword;
var tempPC_Interface_Info:pPC_Interface_Info;
//    buff:array[0..SIZE_BUFFER-1] of char;
    pc_SMS : TPC_SMS_Content;
    tempSMS:PShortMessage;
    objname:array[0..PHB_name_len+3-1] of char;
    objmsg:array[0..MAX_MSG_LEN-1] of char;
    smsdatetime:string;
    objtime:array[0..sizeof(T_MFW_SMS_SCTP)+6] of char;
    oldcount,i:integer;
    str1,str2:string;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  if tempPC_Interface_Info.size_dlbuff>0 then
  begin
//    fillchar(buff,sizeof(buff),#0);
//    move(tempPC_Interface_Info.pdata_dlbuff^,buff[0],tempPC_Interface_Info.size_dlbuff);
    fillchar(pc_SMS,sizeof(TPC_SMS_Content),#0);
    move(tempPC_Interface_Info.pdata_dlbuff^,pc_SMS,tempPC_Interface_Info.size_dlbuff);
    getmem(tempSMS,sizeof(TShortMessage));
    fillchar(tempSMS^,sizeof(TShortMessage),#0);

    move(pc_SMS,tempSMS.data,sizeof(TPC_SMS_Content)); //յTPC_SMS_ContentҲŵShortMessageListȥ
    tempSMS.Location:='SIM';

    strpcopy(tempSMS.SN,format('%.3d',[pc_SMS.id]));
//SNŵsimflashͶϢֻеΨһţflashֵģsimֵܲ
//صĹУflashǰʱݼģsimǰidֵ
    tempSMS.serialNo:=pc_SMS.id;
//serialNoֻжPC,ŵPCÿ¼ݿеserialNo
//ҵserialNo=-1ʱʾ¼ʧЧconfigsmslist󣬾ͻɾ

    case pc_SMS.state of
      PCSYN_SMS_UNKNOWN:  tempSMS.Sort:='UNKNOWN';
      PCSYN_SMS_UNREAD: tempSMS.Sort:='REC UNREAD';
      PCSYN_SMS_READ: tempSMS.Sort:='REC READ';
      PCSYN_SMS_STOR_UNSENT:  tempSMS.Sort:='STO UNSENT';
      PCSYN_SMS_STOR_SENT:    tempSMS.Sort:='STO SENT';
      PCSYN_SMS_ALL:  tempSMS.Sort:='SMS_ALL';
      PCSYN_SMS_FLASH:  tempSMS.Sort:='SMS_FLASH';
      PCSYN_SMS_FLASH_MO: tempSMS.Sort:='FLASH MO';
      PCSYN_SMS_FLASH_MT: tempSMS.Sort:='FLASH MT';
      PCSYN_SMS_MO: tempSMS.Sort:='SIM MO';           //* MO SMS message          */
      PCSYN_SMS_MT: tempSMS.Sort:='SIM MT';           //* MT SMS message          */
    end;

    strcopy(tempSMS.number,pc_SMS.addr);
    UnicodetoASC(pc_SMS.name,objname); //unicodeתΪasc
    strpcopy(tempSMS.name,objname);

    if ord(pc_SMS.time.month[1])<>0 then//·ݲΪ0˵
    begin
      ChangeTime(objtime,@pc_SMS.time);
      smsdatetime:=objtime+'+'+format('%.2d',[pc_SMS.time.timezone]);
      strpcopy(tempSMS.datetime,smsdatetime);
    end;
    fillchar(objmsg,sizeof(objmsg),#0);
    if (pc_SMS.dcs=$08)or(pc_SMS.dcs=$18) then
      UnicodetoASC2(pc_SMS.sms_msg,objmsg,pc_SMS.msg_len) //unicodeתΪasc
    else
      GSMtoASC2(pc_SMS.sms_msg,objmsg,pc_SMS.msg_len);
    move(objmsg[0],tempsms.sms_msg[0],pc_SMS.msg_len);
//յĶϢǰʱ˳ȷȺģҪĳΪidΪ˳shortmessagelist
    oldcount:=ShortMessageList.count;
    for i:=Count_SMS_PC+Count_SMS_Flash to ShortMessageList.count-1 do
    begin
      str1:=PShortMessage(ShortMessageList.Items[i]).SN;
      str2:=tempSMS.SN;
      if CompareText(str2,str1)>0 then continue;
      ShortMessageList.Insert(i,tempsms);
      break;
    end;
    if ShortMessageList.count=oldcount then//idģôͰ¼
      ShortMessageList.Add(tempSMS);
  end;
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_dlbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_dlbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

procedure delSMS(ctype:byte;cindex:byte;cbfunc:Pointer);
var  tempinfo:pPC_Interface_Info;
     tempcmd_SMS:pPC_App_Cmd_SMS;
//     tempbuffer_tx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_sms,sizeof(TPC_App_Cmd_sms));

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_sms^,sizeof(TPC_App_Cmd_SMS),#0);
  //һֽڴҪɾ¼ȥҪɾļ¼ţһ¼ռ2ֽ


	tempcmd_sms.cid1:= PC_AppCID1_sms;
	tempcmd_sms.cid2:= PC_AppCID2_Delete;
  tempcmd_sms.ctype:=ctype;
 	tempcmd_sms.index:=cindex;

	tempinfo.flag:= PC_IF_FLAGS_DATADL;
	tempinfo.pdata_cmd:= PChar(tempcmd_sms);
	tempinfo.size_cmd:= sizeof(TPC_App_Cmd_sms);

	tempinfo.callback := cbfunc;
	pc_interface(tempinfo);
end;


function doDelSMS(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

procedure ChangeTime(var text:array of char;rctp:PT_MFW_SMS_SCTP);
begin
  text[0]:=chr(ord(rctp.year[0])+ord('0'));
  text[1]:=chr(ord(rctp.year[1])+ord('0'));
  text[2]:='/';
  text[3]:=chr(ord(rctp.month[0])+ord('0'));
  text[4]:=chr(ord(rctp.month[1])+ord('0'));
  text[5]:='/';
  text[6]:=chr(ord(rctp.day[0])+ord('0'));
  text[7]:=chr(ord(rctp.day[1])+ord('0'));
  text[8]:=' ';
  text[9]:=chr(ord(rctp.hour[0])+ord('0'));
  text[10]:=chr(ord(rctp.hour[1])+ord('0'));
  text[11]:=':';
  text[12]:=chr(ord(rctp.minute[0])+ord('0'));
  text[13]:=chr(ord(rctp.minute[1])+ord('0'));
  text[14]:=':';
  text[15]:=chr(ord(rctp.second[0])+ord('0'));
  text[16]:=chr(ord(rctp.second[1])+ord('0'));

  text[17]:=#0;
end;

procedure UnChangeTime(var rctp:T_MFW_SMS_SCTP;text:array of char);
var tz:array[0..3] of char;
    ts:string;
begin
  rctp.year[0]:=ord(text[0])-ord('0');
  rctp.year[1]:=ord(text[1])-ord('0');
  rctp.month[0]:=ord(text[3])-ord('0');
  rctp.month[1]:=ord(text[4])-ord('0');
  rctp.day[0]:=ord(text[6])-ord('0');
  rctp.day[1]:=ord(text[7])-ord('0');
  rctp.hour[0]:=ord(text[9])-ord('0');
  rctp.hour[1]:=ord(text[10])-ord('0');
  rctp.minute[0]:=ord(text[12])-ord('0');
  rctp.minute[1]:=ord(text[13])-ord('0');
  rctp.second[0]:=ord(text[15])-ord('0');
  rctp.second[1]:=ord(text[16])-ord('0');
  move(text[18],tz[0],2);
  ts:=tz;
  rctp.timezone:=(ord(text[18])-ord('0'))*10+ord(text[19])-ord('0');
end;

function putSMSRecord(stype:byte;rptype:byte;ulrecn:PPC_SMS_Content;cbfunc:Pointer):DWord; 
var  tempinfo:pPC_Interface_Info;
     tempcmd_sms:pPC_App_Cmd_Sms;
     tempbuffer_tx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_sms,sizeof(TPC_App_Cmd_SMS));
  getmem(tempbuffer_tx,sizeof(TPC_SMS_Content));

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_sms^,sizeof(TPC_App_Cmd_SMS),#0);
 	fillchar(tempbuffer_tx^,sizeof(TPC_sms_Content),#0);

	tempcmd_sms.cid1:= PC_AppCID1_sms;
	tempcmd_sms.cid2:= PC_AppCID2_Write;
 	tempcmd_sms.index:= rptype;  //ϵڼ¼
  tempcmd_sms.ctype:= stype;  //

  move(ulrecn^,tempbuffer_tx^,sizeof(TPC_SMS_Content));

	tempinfo.flag := PC_IF_FLAGS_DATAUL;
	tempinfo.pdata_cmd:=Pchar(tempcmd_sms);
	tempinfo.size_cmd:=sizeof(TPC_App_Cmd_sms);

	tempinfo.pdata_ulbuff := tempbuffer_tx;
	tempinfo.size_ulbuff :=sizeof(TPC_SMS_Content);
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

function doputSMSRecord(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_ulbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_ulbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

procedure CopySMS(ctype:byte;cindex:byte;ulrecn:PPC_SMS_Content;cbfunc:Pointer);
var  tempinfo:pPC_Interface_Info;
     tempcmd_sms:pPC_App_Cmd_Sms;
     tempbuffer_tx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_sms,sizeof(TPC_App_Cmd_SMS));
  getmem(tempbuffer_tx,sizeof(TPC_SMS_Content));

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_sms^,sizeof(TPC_App_Cmd_SMS),#0);
 	fillchar(tempbuffer_tx^,sizeof(TPC_sms_Content),#0);

	tempcmd_sms.cid1:= PC_AppCID1_SMS;
	tempcmd_sms.cid2:= PC_AppCID2_Copy;
 	tempcmd_sms.index:= cindex;  //ϵڼ¼
  tempcmd_sms.ctype:= ctype;  //

//  PPC_sms_Content(tempbuffer_tx).name:=tempcmd_sms.ctype;
  move(ulrecn^,tempbuffer_tx^,sizeof(TPC_SMS_Content));

	tempinfo.flag := PC_IF_FLAGS_DATAUL;
	tempinfo.pdata_cmd:=Pchar(tempcmd_sms);
	tempinfo.size_cmd:=sizeof(TPC_App_Cmd_sms);

	tempinfo.pdata_ulbuff := tempbuffer_tx;
	tempinfo.size_ulbuff := sizeof(TPC_SMS_Content);
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

function doCopySMS(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  result:=tempPC_Interface_Info.status;
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_ulbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_ulbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

//**********************short message end*********************//

//*************CallRecord******************//
//ͻȡcallrecord
procedure getCRCount(cbfunc:Pointer);//ֻø¼
var  tempinfo:pPC_Interface_Info;
     tempcmd_cr:pPC_App_Cmd_CR;
     tempbuffer_rx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_cr,sizeof(TPC_App_Cmd_CR));
  getmem(tempbuffer_rx,SIZE_BUFFER);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_cr^,sizeof(TPC_App_Cmd_CR),#0);
 	fillchar(tempbuffer_rx^,SIZE_BUFFER,#0);

	tempcmd_cr.cid1:= PC_AppCID1_CR;
	tempcmd_cr.cid2:= PC_AppCID2_Info;

	tempinfo.flag := PC_IF_FLAGS_DATADL;
	tempinfo.pdata_cmd:=Pchar(tempcmd_cr);
	tempinfo.size_cmd:= sizeof(TPC_App_Cmd_CR);

	tempinfo.pdata_dlbuff := tempbuffer_rx;
	tempinfo.size_dlbuff := SIZE_BUFFER;
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

//صдCR
procedure doCRCount(p:pointer);  //ص¼
var tempPC_Interface_Info:pPC_Interface_Info;
    //buff:array[0..SIZE_BUFFER-1] of char;
    PC_CR_count:TPC_CR_Count;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  if tempPC_Interface_Info.size_dlbuff>0 then
  begin
//    fillchar(buff,sizeof(buff),#0);
//    move(tempPC_Interface_Info.pdata_dlbuff^,buff[0],tempPC_Interface_Info.size_dlbuff);
    move(tempPC_Interface_Info.pdata_dlbuff^,PC_CR_count,sizeof(TPC_CR_Count));
    Count_CR_LMN:=PC_CR_count.LMNID; //δӵ绰
    Count_CR_LRN:=PC_CR_count.LRNID; //ѽӵ绰
    Count_CR_LDN:=PC_CR_count.LDNID; //Ѳ绰
  end else
  begin
    Count_CR_LMN:=0; //δӵ绰
    Count_CR_LRN:=0; //ѽӵ绰
    Count_CR_LDN:=0; //Ѳ绰
  end;


  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_dlbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_dlbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

//ͻȡCRݵ
procedure getCRcontent(ctype:byte;cindex:byte;cbfunc:Pointer);
var  tempinfo:pPC_Interface_Info;
     tempcmd_cr:pPC_App_Cmd_CR;
     tempbuffer_rx:PChar;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_cr,sizeof(TPC_App_Cmd_CR));
  getmem(tempbuffer_rx,SIZE_BUFFER);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_cr^,sizeof(TPC_App_Cmd_CR),#0);
 	fillchar(tempbuffer_rx^,SIZE_BUFFER,#0);

	tempcmd_cr.cid1:= PC_AppCID1_CR;
	tempcmd_cr.cid2:= PC_AppCID2_Read;
  tempcmd_cr.ctype:= ctype;   //
 	tempcmd_cr.index:= cindex;// CurCR_index;   //ϵڼ¼

	tempinfo.flag:= PC_IF_FLAGS_DATADL;
	tempinfo.pdata_cmd:= PChar(tempcmd_cr);
	tempinfo.size_cmd:= sizeof(TPC_App_Cmd_CR);

	tempinfo.pdata_dlbuff := tempbuffer_rx;
	tempinfo.size_dlbuff := SIZE_BUFFER;

	tempinfo.callback :=cbfunc ;

	pc_interface(tempinfo);
end;
//صдCRݵ
procedure doCRList(p:pointer;ctype:byte);
var tempPC_Interface_Info:pPC_Interface_Info;
//    buff:array[0..SIZE_BUFFER-1] of char;
    pc_cr : TPC_CR_Content;
    tempCR:PCallRecord;
    objname:array[0..23] of char;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  if tempPC_Interface_Info.size_dlbuff>0 then
  begin
//    fillchar(buff,sizeof(buff),#0);
//    move(tempPC_Interface_Info.pdata_dlbuff^,buff[0],tempPC_Interface_Info.size_dlbuff);
    move(tempPC_Interface_Info.pdata_dlbuff^,pc_cr,sizeof(TPC_CR_Content));

    getmem(tempCR,sizeof(TCallRecord));
    tempCR.Location:='ֻ';
    strpcopy(tempCR.SN,format('%.2d',[CurCR_index+1]));
    case ctype of
    CR_TYPE_LMN: tempCR.CRType:='δӵ绰';
    CR_TYPE_LRN: tempCR.CRType:='ѽӵ绰';
    CR_TYPE_LDN: tempCR.CRType:='Ѳ绰';
    end;
    strpcopy(tempCR.datetime,pc_cr.time);
    strpcopy(tempCR.PhoneNo,pc_cr.number);
    UnicodetoASC(pc_cr.name,objname); //unicodeתΪasc
    strpcopy(tempCR.Name,objname);
    tempCR.serialNo:=0; //ǷҪɾļ¼
    CallRecordList.Add(tempCR);
  end;
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_dlbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_dlbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

procedure delCR(cbfunc:Pointer);
var  tempinfo:pPC_Interface_Info;
     tempcmd_cr:pPC_App_Cmd_CR;
     tempbuffer_tx:PChar;
     i:integer;
     tempchar:PDelRec;
//     cchar:array[0..100] of char;
begin
  getmem(tempinfo,sizeof(TPC_Interface_Info));
  getmem(tempcmd_cr,sizeof(TPC_App_Cmd_CR));
  getmem(tempbuffer_tx,sizeof(TDelRec)*delCRlist.Count);

 	fillchar(tempinfo^,sizeof(TPC_Interface_Info),#0);
 	fillchar(tempcmd_cr^,sizeof(TPC_App_Cmd_CR),#0);
 	fillchar(tempbuffer_tx^,sizeof(TDelRec)*delCRlist.Count,#0);
  //ɾļ¼ţһ¼ռ2ֽ,˳ulbuff

	tempinfo.flag:= PC_IF_FLAGS_DATAUL;
	tempinfo.pdata_cmd:= PChar(tempcmd_cr);
	tempinfo.size_cmd:= sizeof(TPC_App_Cmd_CR);

	tempcmd_cr.cid1:= PC_AppCID1_CR;
	tempcmd_cr.cid2:= PC_AppCID2_Delete;
  tempcmd_cr.ctype:=0;    //Ҫһɾcmdֵ
 	tempcmd_cr.index:=0;

  tempchar:=PDelRec(tempbuffer_tx);
  for i:=0 to delCRlist.Count-1 do
  begin
    tempchar.ctype:=PDelRec(delCRlist[i]).ctype;
    tempchar.index:=PDelRec(delCRlist[i]).index;
    inc(tempchar,1);
  end;
//  fillchar(cchar,sizeof(cchar),#0);
//  move(tempbuffer_tx^,cchar[0],sizeof(TDelRec)*(delCRlist.Count));
	tempinfo.pdata_ulbuff := tempbuffer_tx;
	tempinfo.size_ulbuff := sizeof(TDelRec)*delCRlist.Count;
	tempinfo.callback := cbfunc;

	pc_interface(tempinfo);
end;

function doDelCR(p:pointer):DWord;
var tempPC_Interface_Info:pPC_Interface_Info;
begin
  tempPC_Interface_Info:=pPC_Interface_Info(p);
  if tempPC_Interface_Info.pdata_cmd<>nil then
    freemem(tempPC_Interface_Info.pdata_cmd);
  if tempPC_Interface_Info.pdata_ulbuff<>nil then
    freemem(tempPC_Interface_Info.pdata_ulbuff);
  if tempPC_Interface_Info<>nil then
    freemem(tempPC_Interface_Info);
end;

end.
