/*
+-----------------------------------------------------------------------------
|  File     : pcsyn_hisrp.c
+-----------------------------------------------------------------------------
|  Purpose  : This Modul defines the functions for processing
|             of incomming primitives for pcsyn task
+-----------------------------------------------------------------------------
*/
 
#define ENTITY_PCSYN

/*==== INCLUDES ===================================================*/
#if defined (NEW_FRAME)

#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include "typedefs.h"
#include "pcm.h"
#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "vsi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "pei.h"
#include "tok.h"

#else

#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include "stddefs.h"
#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "vsi.h"
#include "pei.h"
#include "tok.h"

#endif

#include "pcsyn.h"
#include "pcsyn_protocol.h"

#define TRACE_EVENT(f) PCSYN_TRACE_EVENT((f));

GLOBAL const void   psa_HISR_PCSYN_IND (
                                  T_HISR_PCSYN_IND *hisr_pcsyn_ind
                                )
{
	  PACCESS(hisr_pcsyn_ind);

	  TRACE_EVENT("psa_HISR_PCSYN_IND()");

	   pc_writebystatus (handle_inbuffer(hisr_pcsyn_ind->sdu.buf,hisr_pcsyn_ind->sdu.l_buf/8) );
	  
	  PFREE(hisr_pcsyn_ind);

}


