/* 
+----------------------------------------------------------------------------- 
|  Project :  MMI-Framework (8417)
|  Modul   :  SMI_LCD
+----------------------------------------------------------------------------- 
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  screen driver interface (TI1 VERSION)
+----------------------------------------------------------------------------- 
*/ 

#ifndef SMI_LCD_H
#define SMI_LCD_H

#define U8  unsigned char

void scrInit (void);
void scrExit (void);
void scrSize (int *x, int *y);
void scrClear (void);
void scrClearRect (int px, int py, int sx, int sy);
void scrText (int x, int y, char *txt);
void scrLine (int px, int py, int sx, int sy);
void scrRect (int px, int py, int sx, int sy);
int scrFntSelect (int font);
int scrFntHeight (void);
int scrFntGetFit (char *tp, int lineWidth);
int scrFntGetLen (char *tp, int nChars);
int scrBmpDraw (int px, int py, int sx, int sy,
                    int ix, char *bm, int mode);
void scrCurType (int type);
void scrCursor (int x, int y);

#endif

