/*
+-------------------------------------------------------------------+
| PROJECT: GSM-WAP (8444)             $Workfile::   wap_tim.c      $|
| $Author: chenlang $$Revision: 1.2 $|
| CREATED: March 16, 2000             $Modtime::   Jun 20 2000 02:3$|
+-------------------------------------------------------------------+
 
   MODULE  : WAP_TIM
 
   PURPOSE : This Modul defines the timer handling functions
             for the component AUS WAP Browser of the mobile station
 
   $Log: wap_tim.c,v $
   Revision 1.2  2004/08/13 03:34:15  chenlang
   no message

 * 
 */

#ifndef WAP_TIM_C
#define WAP_TIM_C
#endif

#define ENTITY_WAP

/*==== INCLUDES ===================================================*/
#if defined (NEW_FRAME)

#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include "typedefs.h"
#include "pcm.h"
#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "vsi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "cnf_wap.h"
#include "mon_wap.h"
#include "pei.h"
#include "tok.h"
#include "dti.h"      /* functionality of the dti library */

#else

#include <string.h>
#include "stddefs.h"
#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "cnf_wap.h"
#include "mon_wap.h"
#include "vsi.h"
#include "pei.h"
#include "tok.h"

#endif

#include "wap.h"

/*==== EXPORT =====================================================*/

/*==== PRIVAT =====================================================*/

/*==== VARIABLES ==================================================*/

/*==== FUNCTIONS ==================================================*/

