/****************************************************************************
 *
 *		Copyright (C) 2003	YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: mahvsw.h
 *
 *		Description	: MA HV Sequence Wrapper
 *
 *		Version		: 2.0.0 	2003.07.11
 *
 ****************************************************************************/

#ifndef __MAHVSW_H__
#define __MAHVSW_H__

#include "mamachdep.h"

SINT32	MaSound_Initialize		( void );
SINT32	MaSound_Create			( UINT8 srm_id );
SINT32	MaSound_Load			( SINT32 func_id, UINT8 * file_ptr, UINT32 file_size, UINT8 mode, SINT32 (* func)(UINT8 id), void * ext_args );
SINT32	MaSound_Open			( SINT32 func_id, SINT32 file_id, UINT16 open_mode, void * ext_args );
SINT32	MaSound_Control			( SINT32 func_id, SINT32 file_id, UINT8 ctrl_num, void * prm, void * ext_args );
SINT32	MaSound_Standby			( SINT32 func_id, SINT32 file_id, void * ext_args );
SINT32	MaSound_Seek			( SINT32 func_id, SINT32 file_id, UINT32 pos, UINT8 flag, void * ext_args );
SINT32	MaSound_Start			( SINT32 func_id, SINT32 file_id, UINT16 play_mode, void * ext_args );
SINT32	MaSound_Pause			( SINT32 func_id, SINT32 file_id, void * ext_args );
SINT32	MaSound_Restart			( SINT32 func_id, SINT32 file_id, void * ext_args );
SINT32	MaSound_Stop			( SINT32 func_id, SINT32 file_id, void * ext_args );
SINT32	MaSound_Close			( SINT32 func_id, SINT32 file_id, void * ext_args );
SINT32	MaSound_Unload			( SINT32 func_id, SINT32 file_id, void * ext_args );
SINT32	MaSound_Delete			( SINT32 func_id );
SINT32	MaSound_Terminate		( void );
SINT32	MaSound_DeviceControl	( UINT8 p1, UINT8 p2, UINT8 p3, UINT8 p4 );

#endif /*__MAHVSW_H__*/
