/****************************************************************************
 *
 *		Copyright (C) 2002-2003	YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: mamidcnv.h
 *
 *		Description	: Header of SMF/GML Stream Converter Module.
 *
 *		Version		: 1.1.0 	2003.05.15
 *
 ****************************************************************************/
#ifndef	_MAMIDCNV_H_
#define	_MAMIDCNV_H_

#include "mamachdep.h"
#include "masnddrv.h"		/*	MA-X Sound Driver		*/
#include "maresmgr.h"		/*	MA-X Resource Manager	*/
#include "madebug.h"

/*==============================================================================*/
/* prototype functions                                                          */
/*==============================================================================*/

SINT32	MaMidCnv_Initialize	(void);
SINT32	MaMidCnv_End		(void);
SINT32	MaMidCnv_Load		(UINT8* pbFile, UINT32 dFileSize, UINT32 dMode, SINT32 (*pfnFunc)(UINT8 bID), void* pvExtArgs);
SINT32	MaMidCnv_Unload		(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaMidCnv_Open		(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaMidCnv_Close		(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaMidCnv_Standby	(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaMidCnv_Seek		(SINT32 sdFileID, UINT32 dPos, void* pvExtArgs);
SINT32	MaMidCnv_Start		(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaMidCnv_Stop		(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaMidCnv_Control	(SINT32 sdFileID, UINT32 dCtrlNum, void* pvPrm, void* pvExtArgs);

#endif	/*	_MAMIDCNV_H_	*/

