/****************************************************************************
 *
 *		Copyright (C) 2002-2003	YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: masoundlib.h
 *
 *		Description	: MA Sound Player LIB
 *
 *		Version		: 1.0.0 	2002.02.28
 *
 ****************************************************************************/

#ifndef __MASOUNDLIB_H__
#define __MASOUNDLIB_H__

#if defined(__cplusplus)
extern "C" {
#endif

unsigned short	malib_MakeCRC(unsigned long dSize, unsigned char* pbData);
unsigned long	malib_Decode_7bitData(unsigned char* pb7bit, unsigned long d7Size, unsigned char* pb8bit, unsigned long d8Size);
long			malib_smafphrase_checker(unsigned char* pbData, unsigned long dSize, void* pvInfo);
long			malib_smafaudio_checker(unsigned char* pbData, unsigned long dSize, unsigned char bMode, void* pvInfo);
long			malib_hvscript_checker(unsigned char* pbData, unsigned long dSize);


#if defined(__cplusplus)
}
#endif

#endif /*__MASOUNDLIB_H__*/
