/****************************************************************************
 *
 *		Copyright (C) 2002-2003	YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: mawavcnv.h
 *
 *		Description	: Header of WAV Stream Converter Module.
 *
 *		Version		: 1.1.0 	2003.04.09
 *
 ****************************************************************************/
#ifndef	_MAWAVCNV_H_
#define	_MAWAVCNV_H_

/*==============================================================================
//	prototype functions
//============================================================================*/

SINT32	MaWavCnv_Initialize	( void );
SINT32	MaWavCnv_End		( void );
SINT32	MaWavCnv_Load		(UINT8* pbFile, UINT32 dFSize, UINT32 dMode, SINT32	(*pFunc)(UINT8 bId), void* pvExt_args);
SINT32	MaWavCnv_Unload		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaWavCnv_Open		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaWavCnv_Standby	(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaWavCnv_Close		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaWavCnv_Seek		(SINT32 sdFile_id, UINT32 dPos, void* pvExt_args);
SINT32	MaWavCnv_Start		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaWavCnv_Pause		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaWavCnv_Restart	(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaWavCnv_Stop		(SINT32 sdFile_id, void* pvExt_args);
SINT32	MaWavCnv_Control	(SINT32 sdFile_id, UINT32 dCtrl_num, void* pvPrm, void* pvExt_args);

#endif	/*	_MAWAVCNV_H_	*/

