#include "sys_types.h"

#define VOLCTL_VOLUME_0dB	0x02
#define VOLCTL_VOLUME_n6dB	0x06
#define VOLCTL_VOLUME_n12dB	0x00
#define VOLCTL_VOLUME_n18dB	0x04
#define VOLCTL_VOLUME_n24dB	0x03
#define VOLCTL_VOLUME_MUTE	0x05


#define VDLPG_AMPLIFIER_n6dB	0x0000   // -6dB
#define VDLPG_AMPLIFIER_n4dB 	0x0002   // -3dB
#define VDLPG_AMPLIFIER_n2dB 	0x0004   // -2dB
#define VDLPG_AMPLIFIER_0dB 	0x0006   //  0dB
#define VDLPG_AMPLIFIER_2dB	0x0008	 //  2dB
#define VDLPG_AMPLIFIER_4dB	0x000A   //  4dB
#define VDLPG_AMPLIFIER_6dB	0x000C   //  6dB

//glowing,2004-06-17,import from M188
typedef enum
{
	MAINBOARD_188=0,
	MAINBOARD_288,
	MAINBOARD_288B,
	MAINBOARD_288C,
	MAINBOARD_288S,
	MAINBOARD_388,
	MAINBOARD_588
} tMAINBOARD_TYPE;


extern void SetVDLVolume( UINT16 amp );
unsigned short IsHandsetKey(void);
void QueryPcsyncHandsetStatus(void);
unsigned short IsPcsyncRemove(void);


