#ifndef _DEF_CAMERA_H_
#define _DEF_CAMERA_H_

typedef unsigned char CAMU8;
typedef unsigned short CAMU16;
typedef unsigned int CAMU32;

typedef enum tag_LcdPort
{
	MAINLCD_PORT,
	SUBLCD_PORT
}LCDPORT;

typedef enum tag_S1D13716_Powersaving_Mode
{
	POWER_ON,
	POWER_OFF
}S1D13716_POWERSAVING_MODE;

typedef enum tag_S1D13716_CameraAction
{
	BYPSS_MODE ,
	CAMERA_MODE 
}S1D13716_CAMERAACTION;

typedef enum tag_S1D13716_LcdType
{
	MAINLCD,
	SUBLCD
}S1D13716_LCDTYPE;


typedef struct tagCamConfig
{
	CAMU8 m_nCurAction;
	
	CAMU8 m_nCurLCD;

}CAMCONFIG;


#endif
