#
# PWR makefile for ABC
#

# TISH031204 shirely modify for lcc compilation
# PWR_CFLAGS   := -g -pw2 -mn -x -mt -mw -o $(CFLAGSDRIVERS) $(CFLAGSPWR) -D_RVF=1 -DTRACE_WANTED=1 -DUSE_PWL_AS_MODULATOR -DTEST_PWR_MMI_INTERFACE=0 -DUSE_Q401_CHG_CIRCUIT=1 -DUSE_Q402_CHG_CIRCUIT=0
PWR_CFLAGS   := -g -pw2 -mn -x -mt -mw -o $(CFLAGSPWR) -D_RVF=1 -DTRACE_WANTED=1 -DUSE_PWL_AS_MODULATOR -DTEST_PWR_MMI_INTERFACE=0 -DUSE_Q401_CHG_CIRCUIT=1 -DUSE_Q402_CHG_CIRCUIT=0 -DLCC_ALWAYS_MMI_INFO=1
#flags USE_Q401_CHG_CIRCUIT & USE_Q402_CHG_CIRCUIT (xor!!) must match the actual jumper (DS, customer) setting of the board
#CHGTYPE = _q401
#ifeq ($(USE_Q401_CHG_CIRCUIT),1)
#    CHGTYPE = _q401
#endif
#ifeq ($(USE_Q402_CHG_CIRCUIT),1)
#    CHGTYPE = _q402
#endif
export CHGTYPE

#LIB_PWR	    := $(OUT_LIB_DIR)/pwr$(NBRD)$(NCHP)$(NANALOG).lib
LIB_PWR	    := $(OUT_LIB_DIR)/pwr$(NBRD)$(NCHP)$(NANALOG)$(CHGTYPE).lib

CFG_LIBS += $(LIB_PWR)
#TISH040206 mars to release customer to avoid LCC source compile
ifdef LCC_SOURCE
SRC_PWR := $(DRIVERS_DIR)/Common/lcc/lcc_task.c \
           $(DRIVERS_DIR)/Common/lcc/lcc_handle_message.c \
           $(DRIVERS_DIR)/Common/lcc/lcc_env.c \
           $(DRIVERS_DIR)/Common/lcc/lcc_api.c \
           $(DRIVERS_DIR)/Common/lcc/lcc_trace.c \
           $(DRIVERS_DIR)/Common/lcc/lcc_modulate.c
endif
OBJ_PWR    := $(SRC_PWR:.c=.obj)

CFG_OBJS += $(OBJ_PWR)
CFG_DEPS += $(OBJ_PWR:.obj=.d)

all : $(LIB_PWR)

$(LIB_PWR) : $(OBJ_PWR)
	-rm $@
	ar470 r $@ $^

$(OBJ_PWR): %.obj: %.c
	cl470 $(PWR_CFLAGS) -fr$(@D) $<

c:
	rm $(OBJ_PWR) $(LIB_PWR)
