/*******************************************************************************
 *
 * rvt_env_i.h
 *
 * This file should be included by rvt_env.c ONLY!!!
 * It includes definitions of global variables used for trace.
 *
 * (C) Texas Instruments, all rights reserved
 *
 * Version number	: 0.11
 *
 * History			: 0.1  (7/4/2000) - Created
 *       			: 0.11 (6/13/2002) - Remove useless dependency.
 *
 * Date             : 6/13/2002
 *
 * Author           : Cristian Livadiotti, c-livadiotti@ti.com
 *
 ******************************************************************************/

#ifndef __RVT_ENV_I_H__
#define __RVT_ENV_I_H__

/*
** Environment global variables
*/

extern T_RVF_ADDR_ID	rvt_addr_id;
extern T_RVF_MB_ID		rvt_mb_id;


/*
** Trace Module State
*/
extern T_RVT_STATE		rvt_module_state;


#endif